/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/



































#include "../P2VectorElementwiseFullStokesP1ViscosityIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseFullStokesP1ViscosityIcosahedralShellMap::apply_P2VectorElementwiseFullStokesP1ViscosityIcosahedralShellMap_macro_3D( real_t * RESTRICT  _data_dst_edge_0, real_t * RESTRICT  _data_dst_edge_1, real_t * RESTRICT  _data_dst_edge_2, real_t * RESTRICT  _data_dst_vertex_0, real_t * RESTRICT  _data_dst_vertex_1, real_t * RESTRICT  _data_dst_vertex_2, real_t * RESTRICT  _data_mu, real_t * RESTRICT  _data_src_edge_0, real_t * RESTRICT  _data_src_edge_1, real_t * RESTRICT  _data_src_edge_2, real_t * RESTRICT  _data_src_vertex_0, real_t * RESTRICT  _data_src_vertex_1, real_t * RESTRICT  _data_src_vertex_2, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {-0.1333333333333333, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983};
   
       const real_t _data_q_p_0 [] = {0.25, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666666};
   
       const real_t _data_q_p_1 [] = {0.25, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666666};
   
       const real_t _data_q_p_2 [] = {0.25, 0.5, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
       const real_t tmp_qloop_1 = -rayVertex_0;
       const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
       const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
       const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
       const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
       const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
       const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
       const real_t tmp_qloop_8 = -rayVertex_1;
       const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
       const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
       const real_t tmp_qloop_12 = -rayVertex_2;
       const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
       const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
       const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
       const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
       const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
       const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
       const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
       const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
       const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_39 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
       const real_t tmp_qloop_40 = tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_45 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
       const real_t tmp_qloop_46 = -tmp_qloop_21*tmp_qloop_45;
       const real_t tmp_qloop_53 = -tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_68 = tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_72 = tmp_qloop_21*tmp_qloop_45;
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {0.25, 0.25, 0.25, 0.25, 0.16666666666666674, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666671, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666671, 0.5, 0.16666666666666666, 0.16666666666666666, 0.50000000000000011, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_UP [] = {0.0, ((real_t)(abs_det_jac_affine_WHITE_UP)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(abs_det_jac_affine_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(abs_det_jac_affine_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(abs_det_jac_affine_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_12 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_13 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_14 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_15 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_16 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_17 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_18 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_19 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_20 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_21 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_22 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_23 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_24 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_25 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_26 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_27 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_28 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_29 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_WHITE_UP[4*q],_data_phi_0_0_WHITE_UP[4*q],_data_phi_0_0_WHITE_UP[4*q],_data_phi_0_0_WHITE_UP[4*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_WHITE_UP[4*q + 1],_data_phi_0_0_WHITE_UP[4*q + 1],_data_phi_0_0_WHITE_UP[4*q + 1],_data_phi_0_0_WHITE_UP[4*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_WHITE_UP[4*q + 2],_data_phi_0_0_WHITE_UP[4*q + 2],_data_phi_0_0_WHITE_UP[4*q + 2],_data_phi_0_0_WHITE_UP[4*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_WHITE_UP[4*q + 3],_data_phi_0_0_WHITE_UP[4*q + 3],_data_phi_0_0_WHITE_UP[4*q + 3],_data_phi_0_0_WHITE_UP[4*q + 3]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_436 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_453 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_468 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_483 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_498 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_513 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_528 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_543 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_558 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_573 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q]));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9]));
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_444 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_459 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_474 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_489 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_504 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_519 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_534 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_549 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_564 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_579 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q]));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8]));
                   const __m256d tmp_qloop_257 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_342 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_449 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_464 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_479 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_494 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_509 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_524 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_539 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_554 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_569 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_134 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_236 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_437 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_454 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_469 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_484 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_499 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_514 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_529 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_544 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_559 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_574 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_445 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_460 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_475 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_490 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_505 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_520 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_535 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_550 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_565 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_580 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_343 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_432 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_450 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_465 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_480 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_495 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_510 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_525 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_540 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_555 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_570 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_126 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_124,tmp_qloop_125),tmp_qloop_126);
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_125,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_126,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_134),tmp_qloop_135);
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_134,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_135,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_187 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_213 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_226 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_237 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_239 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_265 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_280 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_291 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(tmp_qloop_120,tmp_qloop_291);
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_438 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_455 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_470 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_485 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_500 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_515 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_530 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_545 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_560 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_575 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_585 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_589 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_585);
                   const __m256d tmp_qloop_596 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_599 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_596);
                   const __m256d tmp_qloop_605 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_608 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_605);
                   const __m256d tmp_qloop_614 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_617 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_614);
                   const __m256d tmp_qloop_623 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_626 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_623);
                   const __m256d tmp_qloop_632 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_635 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_632);
                   const __m256d tmp_qloop_641 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_644 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_641);
                   const __m256d tmp_qloop_650 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_653 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_650);
                   const __m256d tmp_qloop_659 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_662 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_659);
                   const __m256d tmp_qloop_667 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_277,tmp_qloop_278),tmp_qloop_279);
                   const __m256d tmp_qloop_674 = _mm256_mul_pd(tmp_qloop_291,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(1.0,1.0,1.0,1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_121),tmp_qloop_122),tmp_qloop_123);
                   const __m256d tmp_qloop_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_139,tmp_qloop_140);
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_145),tmp_qloop_146);
                   const __m256d tmp_qloop_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_144,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_145,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_146,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_178 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_191 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_204 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_217 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_230 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_243 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_255 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_269 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_289 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_286,tmp_qloop_287),tmp_qloop_288);
                   const __m256d tmp_qloop_290 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_283,tmp_qloop_284),tmp_qloop_285),tmp_qloop_289);
                   const __m256d tmp_qloop_299 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_312 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_313 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_326 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_327 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_340 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_341 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_354 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_355 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_368 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_369 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_382 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_383 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_396 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_410 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_424 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_434 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_280);
                   const __m256d tmp_qloop_440 = _mm256_add_pd(tmp_qloop_127,tmp_qloop_289);
                   const __m256d tmp_qloop_441 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_440),tmp_qloop_141),tmp_qloop_292);
                   const __m256d tmp_qloop_446 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_461 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_476 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_491 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_506 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_521 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_536 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_551 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_566 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_581 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_586 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_593 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_586),tmp_qloop_589);
                   const __m256d tmp_qloop_594 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_593);
                   const __m256d tmp_qloop_597 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_602 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_597),tmp_qloop_599);
                   const __m256d tmp_qloop_603 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_602);
                   const __m256d tmp_qloop_606 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_611 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_606),tmp_qloop_608);
                   const __m256d tmp_qloop_612 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_611);
                   const __m256d tmp_qloop_615 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_620 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_615),tmp_qloop_617);
                   const __m256d tmp_qloop_621 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_620);
                   const __m256d tmp_qloop_624 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_629 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_624),tmp_qloop_626);
                   const __m256d tmp_qloop_630 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_629);
                   const __m256d tmp_qloop_633 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_638 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_633),tmp_qloop_635);
                   const __m256d tmp_qloop_639 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_638);
                   const __m256d tmp_qloop_642 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_647 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_642),tmp_qloop_644);
                   const __m256d tmp_qloop_648 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_647);
                   const __m256d tmp_qloop_651 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_656 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_651),tmp_qloop_653);
                   const __m256d tmp_qloop_657 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_656);
                   const __m256d tmp_qloop_660 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_665 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_660),tmp_qloop_662);
                   const __m256d tmp_qloop_666 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_665);
                   const __m256d tmp_qloop_670 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_671 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_672 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_283),tmp_qloop_284),tmp_qloop_285);
                   const __m256d tmp_qloop_678 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_670),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_672)),tmp_qloop_674);
                   const __m256d tmp_qloop_690 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_691 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_694 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_690),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_691));
                   const __m256d tmp_qloop_695 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_694);
                   const __m256d tmp_qloop_697 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_698 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_700 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_697),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_698));
                   const __m256d tmp_qloop_701 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_700);
                   const __m256d tmp_qloop_703 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_704 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_706 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_703),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_704));
                   const __m256d tmp_qloop_707 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_706);
                   const __m256d tmp_qloop_709 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_710 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_712 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_709),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_710));
                   const __m256d tmp_qloop_713 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_712);
                   const __m256d tmp_qloop_715 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_716 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_718 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_715),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_716));
                   const __m256d tmp_qloop_719 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_718);
                   const __m256d tmp_qloop_721 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_722 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_724 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_721),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_722));
                   const __m256d tmp_qloop_725 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_724);
                   const __m256d tmp_qloop_727 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_728 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_730 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_727),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_728));
                   const __m256d tmp_qloop_731 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_730);
                   const __m256d tmp_qloop_733 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_734 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_736 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_733),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_734));
                   const __m256d tmp_qloop_737 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_736);
                   const __m256d tmp_qloop_739 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_740 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_742 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_739),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_740));
                   const __m256d tmp_qloop_743 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_742);
                   const __m256d tmp_qloop_744 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_667);
                   const __m256d tmp_qloop_749 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_440,_mm256_add_pd(tmp_qloop_128,tmp_qloop_671)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_141),tmp_qloop_674);
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_117));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_130),tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_142,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q]));
                   const __m256d tmp_qloop_151 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_148,tmp_qloop_149),tmp_qloop_150);
                   const __m256d tmp_qloop_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,_mm256_add_pd(tmp_qloop_147,tmp_qloop_151)),tmp_qloop_141),tmp_qloop_143);
                   const __m256d tmp_qloop_160 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_169 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_199 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_208 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_212 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_221 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_225 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_234 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_246 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_251 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_260 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_264 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_273 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_281 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_280);
                   const __m256d tmp_qloop_282 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_296 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_293,tmp_qloop_294),tmp_qloop_295);
                   const __m256d tmp_qloop_297 = _mm256_add_pd(tmp_qloop_136,tmp_qloop_296);
                   const __m256d tmp_qloop_298 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_297),tmp_qloop_143),tmp_qloop_292);
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_303 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_304 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_299),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_303));
                   const __m256d tmp_qloop_308 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_317 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_318 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_313),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_317));
                   const __m256d tmp_qloop_322 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_331 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_332 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_327),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_331));
                   const __m256d tmp_qloop_336 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_345 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_346 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_341),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_345));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_359 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_360 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_355),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_359));
                   const __m256d tmp_qloop_364 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_373 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_374 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_369),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_373));
                   const __m256d tmp_qloop_378 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_387 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_388 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_383),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_387));
                   const __m256d tmp_qloop_392 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_401 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_402 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_397),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_401));
                   const __m256d tmp_qloop_406 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_416 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_411),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_415));
                   const __m256d tmp_qloop_420 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_429 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_430 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_425),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_429));
                   const __m256d tmp_qloop_433 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1]));
                   const __m256d tmp_qloop_435 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_439 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_442 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_443 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_442);
                   const __m256d tmp_qloop_447 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_448 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_447),tmp_qloop_443);
                   const __m256d tmp_qloop_451 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2]));
                   const __m256d tmp_qloop_452 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_457 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_458 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_457);
                   const __m256d tmp_qloop_462 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_463 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_462),tmp_qloop_458);
                   const __m256d tmp_qloop_466 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3]));
                   const __m256d tmp_qloop_467 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_472 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_473 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_472);
                   const __m256d tmp_qloop_477 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_478 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_477),tmp_qloop_473);
                   const __m256d tmp_qloop_481 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4]));
                   const __m256d tmp_qloop_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_486 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_487 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_488 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_487);
                   const __m256d tmp_qloop_492 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_493 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_492),tmp_qloop_488);
                   const __m256d tmp_qloop_496 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5]));
                   const __m256d tmp_qloop_497 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_501 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_502 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_503 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_502);
                   const __m256d tmp_qloop_507 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_508 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_507),tmp_qloop_503);
                   const __m256d tmp_qloop_511 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6]));
                   const __m256d tmp_qloop_512 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_516 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_517 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_518 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_517);
                   const __m256d tmp_qloop_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_523 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_522),tmp_qloop_518);
                   const __m256d tmp_qloop_526 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7]));
                   const __m256d tmp_qloop_527 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_531 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_532 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_533 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_532);
                   const __m256d tmp_qloop_537 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_538 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_537),tmp_qloop_533);
                   const __m256d tmp_qloop_541 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8]));
                   const __m256d tmp_qloop_542 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_546 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_547 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_548 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_547);
                   const __m256d tmp_qloop_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_553 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_552),tmp_qloop_548);
                   const __m256d tmp_qloop_556 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9]));
                   const __m256d tmp_qloop_557 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_561 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_562 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_563 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_562);
                   const __m256d tmp_qloop_567 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d tmp_qloop_568 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_567),tmp_qloop_563);
                   const __m256d tmp_qloop_571 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10]));
                   const __m256d tmp_qloop_572 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_576 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_573),tmp_qloop_574),tmp_qloop_575);
                   const __m256d tmp_qloop_577 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_578 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_577);
                   const __m256d tmp_qloop_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_579),tmp_qloop_580),tmp_qloop_581);
                   const __m256d tmp_qloop_583 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_582),tmp_qloop_578);
                   const __m256d tmp_qloop_584 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_157),tmp_qloop_158),tmp_qloop_159));
                   const __m256d tmp_qloop_587 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_588 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_304);
                   const __m256d tmp_qloop_590 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_587),tmp_qloop_589);
                   const __m256d tmp_qloop_591 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_590);
                   const __m256d tmp_qloop_592 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_448);
                   const __m256d tmp_qloop_595 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172));
                   const __m256d tmp_qloop_598 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_600 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_598),tmp_qloop_599);
                   const __m256d tmp_qloop_601 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_600);
                   const __m256d tmp_qloop_604 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_183),tmp_qloop_184),tmp_qloop_185));
                   const __m256d tmp_qloop_607 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_609 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_607),tmp_qloop_608);
                   const __m256d tmp_qloop_610 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_609);
                   const __m256d tmp_qloop_613 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_196),tmp_qloop_197),tmp_qloop_198));
                   const __m256d tmp_qloop_616 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_618 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_616),tmp_qloop_617);
                   const __m256d tmp_qloop_619 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_618);
                   const __m256d tmp_qloop_622 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211));
                   const __m256d tmp_qloop_625 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_627 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_625),tmp_qloop_626);
                   const __m256d tmp_qloop_628 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_627);
                   const __m256d tmp_qloop_631 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_222),tmp_qloop_223),tmp_qloop_224));
                   const __m256d tmp_qloop_634 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_636 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_634),tmp_qloop_635);
                   const __m256d tmp_qloop_637 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_636);
                   const __m256d tmp_qloop_640 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_235),tmp_qloop_236),tmp_qloop_237));
                   const __m256d tmp_qloop_643 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_645 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_643),tmp_qloop_644);
                   const __m256d tmp_qloop_646 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_645);
                   const __m256d tmp_qloop_649 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250));
                   const __m256d tmp_qloop_652 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_654 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_652),tmp_qloop_653);
                   const __m256d tmp_qloop_655 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_654);
                   const __m256d tmp_qloop_658 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263));
                   const __m256d tmp_qloop_661 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_663 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_661),tmp_qloop_662);
                   const __m256d tmp_qloop_664 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_663);
                   const __m256d tmp_qloop_668 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_667);
                   const __m256d tmp_qloop_669 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_274,tmp_qloop_275),tmp_qloop_276),tmp_qloop_668));
                   const __m256d tmp_qloop_673 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_675 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_676 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_677 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_676),tmp_qloop_143),tmp_qloop_674);
                   const __m256d tmp_qloop_679 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_676),tmp_qloop_443);
                   const __m256d tmp_qloop_680 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_676),tmp_qloop_458);
                   const __m256d tmp_qloop_681 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_676),tmp_qloop_473);
                   const __m256d tmp_qloop_682 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_676),tmp_qloop_488);
                   const __m256d tmp_qloop_683 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_676),tmp_qloop_503);
                   const __m256d tmp_qloop_684 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_676),tmp_qloop_518);
                   const __m256d tmp_qloop_685 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_676),tmp_qloop_533);
                   const __m256d tmp_qloop_686 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_676),tmp_qloop_548);
                   const __m256d tmp_qloop_687 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_676),tmp_qloop_563);
                   const __m256d tmp_qloop_688 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_676),tmp_qloop_578);
                   const __m256d tmp_qloop_689 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_305,tmp_qloop_306),tmp_qloop_307),tmp_qloop_668));
                   const __m256d tmp_qloop_692 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_693 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_679);
                   const __m256d tmp_qloop_696 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_319,tmp_qloop_320),tmp_qloop_321),tmp_qloop_668));
                   const __m256d tmp_qloop_699 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_702 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_333,tmp_qloop_334),tmp_qloop_335),tmp_qloop_668));
                   const __m256d tmp_qloop_705 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_708 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_347,tmp_qloop_348),tmp_qloop_349),tmp_qloop_668));
                   const __m256d tmp_qloop_711 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_714 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_361,tmp_qloop_362),tmp_qloop_363),tmp_qloop_668));
                   const __m256d tmp_qloop_717 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_720 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_375,tmp_qloop_376),tmp_qloop_377),tmp_qloop_668));
                   const __m256d tmp_qloop_723 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_726 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_389,tmp_qloop_390),tmp_qloop_391),tmp_qloop_668));
                   const __m256d tmp_qloop_729 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_732 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_403,tmp_qloop_404),tmp_qloop_405),tmp_qloop_668));
                   const __m256d tmp_qloop_735 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_738 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_417,tmp_qloop_418),tmp_qloop_419),tmp_qloop_668));
                   const __m256d tmp_qloop_741 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_745 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_431,tmp_qloop_432),tmp_qloop_433),tmp_qloop_744));
                   const __m256d tmp_qloop_746 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_747 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_748 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_750 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_449,tmp_qloop_450),tmp_qloop_451),tmp_qloop_744));
                   const __m256d tmp_qloop_751 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_752 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_753 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_754 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_464,tmp_qloop_465),tmp_qloop_466),tmp_qloop_744));
                   const __m256d tmp_qloop_755 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_756 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_757 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_758 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_479,tmp_qloop_480),tmp_qloop_481),tmp_qloop_744));
                   const __m256d tmp_qloop_759 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_760 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_761 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_762 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_494,tmp_qloop_495),tmp_qloop_496),tmp_qloop_744));
                   const __m256d tmp_qloop_763 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_764 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_765 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_766 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_509,tmp_qloop_510),tmp_qloop_511),tmp_qloop_744));
                   const __m256d tmp_qloop_767 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_768 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_769 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_770 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_524,tmp_qloop_525),tmp_qloop_526),tmp_qloop_744));
                   const __m256d tmp_qloop_771 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_772 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_773 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_774 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_539,tmp_qloop_540),tmp_qloop_541),tmp_qloop_744));
                   const __m256d tmp_qloop_775 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_776 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_777 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_778 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_554,tmp_qloop_555),tmp_qloop_556),tmp_qloop_744));
                   const __m256d tmp_qloop_779 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_780 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_781 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(tmp_qloop_129,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_121,tmp_qloop_122),tmp_qloop_123),tmp_qloop_127))),_mm256_mul_pd(tmp_qloop_138,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132),tmp_qloop_136))),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_161),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_165)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_169)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_160),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_178)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_182)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_187),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_191)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_195)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_186),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_200),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_204)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_208)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_213),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_217)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_221)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_212),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_226),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_230)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_234)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_225),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_239),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_243)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_247)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_238),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_252),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_256)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_260)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_251),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_265),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_269)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_273)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_264),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_290),tmp_qloop_298),tmp_qloop_304)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_312),tmp_qloop_298),tmp_qloop_318)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_308),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_326),tmp_qloop_298),tmp_qloop_332)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_322),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_340),tmp_qloop_298),tmp_qloop_346)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_336),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_354),tmp_qloop_298),tmp_qloop_360)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_350),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_368),tmp_qloop_298),tmp_qloop_374)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_364),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_382),tmp_qloop_298),tmp_qloop_388)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_378),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_396),tmp_qloop_298),tmp_qloop_402)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_392),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_410),tmp_qloop_298),tmp_qloop_416)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_406),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_424),tmp_qloop_298),tmp_qloop_430)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_420),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_439),tmp_qloop_441),tmp_qloop_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_435),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_456),tmp_qloop_441),tmp_qloop_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_452),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_471),tmp_qloop_441),tmp_qloop_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_467),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_486),tmp_qloop_441),tmp_qloop_493)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_482),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_501),tmp_qloop_441),tmp_qloop_508)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_497),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_516),tmp_qloop_441),tmp_qloop_523)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_512),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_531),tmp_qloop_441),tmp_qloop_538)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_527),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_546),tmp_qloop_441),tmp_qloop_553)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_542),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_561),tmp_qloop_441),tmp_qloop_568)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_557),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_576),tmp_qloop_441),tmp_qloop_583)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_572),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_165,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_169,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_586),tmp_qloop_588),tmp_qloop_590)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_586),tmp_qloop_318),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_586),tmp_qloop_332),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_586),tmp_qloop_346),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_586),tmp_qloop_360),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_586),tmp_qloop_374),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_586),tmp_qloop_388),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_586),tmp_qloop_402),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_586),tmp_qloop_416),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_586),tmp_qloop_430),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_587),tmp_qloop_592),tmp_qloop_593)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_587),tmp_qloop_463),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_587),tmp_qloop_478),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_587),tmp_qloop_493),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_587),tmp_qloop_508),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_587),tmp_qloop_523),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_587),tmp_qloop_538),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_587),tmp_qloop_553),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_587),tmp_qloop_568),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_587),tmp_qloop_583),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_597),tmp_qloop_588),tmp_qloop_600)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_597),tmp_qloop_318),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_597),tmp_qloop_332),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_597),tmp_qloop_346),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_597),tmp_qloop_360),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_597),tmp_qloop_374),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_597),tmp_qloop_388),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_597),tmp_qloop_402),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_597),tmp_qloop_416),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_597),tmp_qloop_430),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_598),tmp_qloop_592),tmp_qloop_602)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_598),tmp_qloop_463),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_598),tmp_qloop_478),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_598),tmp_qloop_493),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_598),tmp_qloop_508),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_598),tmp_qloop_523),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_598),tmp_qloop_538),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_598),tmp_qloop_553),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_598),tmp_qloop_568),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_598),tmp_qloop_583),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_606),tmp_qloop_588),tmp_qloop_609)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_606),tmp_qloop_318),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_606),tmp_qloop_332),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_606),tmp_qloop_346),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_606),tmp_qloop_360),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_606),tmp_qloop_374),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_606),tmp_qloop_388),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_606),tmp_qloop_402),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_606),tmp_qloop_416),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_606),tmp_qloop_430),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_607),tmp_qloop_592),tmp_qloop_611)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_607),tmp_qloop_463),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_607),tmp_qloop_478),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_607),tmp_qloop_493),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_607),tmp_qloop_508),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_607),tmp_qloop_523),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_607),tmp_qloop_538),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_607),tmp_qloop_553),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_607),tmp_qloop_568),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_607),tmp_qloop_583),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_615),tmp_qloop_588),tmp_qloop_618)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_615),tmp_qloop_318),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_615),tmp_qloop_332),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_615),tmp_qloop_346),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_615),tmp_qloop_360),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_615),tmp_qloop_374),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_615),tmp_qloop_388),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_615),tmp_qloop_402),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_615),tmp_qloop_416),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_615),tmp_qloop_430),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_616),tmp_qloop_592),tmp_qloop_620)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_616),tmp_qloop_463),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_616),tmp_qloop_478),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_616),tmp_qloop_493),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_616),tmp_qloop_508),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_616),tmp_qloop_523),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_616),tmp_qloop_538),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_616),tmp_qloop_553),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_616),tmp_qloop_568),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_616),tmp_qloop_583),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_624),tmp_qloop_588),tmp_qloop_627)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_624),tmp_qloop_318),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_624),tmp_qloop_332),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_624),tmp_qloop_346),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_624),tmp_qloop_360),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_624),tmp_qloop_374),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_624),tmp_qloop_388),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_624),tmp_qloop_402),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_624),tmp_qloop_416),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_624),tmp_qloop_430),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_625),tmp_qloop_592),tmp_qloop_629)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_625),tmp_qloop_463),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_625),tmp_qloop_478),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_625),tmp_qloop_493),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_625),tmp_qloop_508),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_625),tmp_qloop_523),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_625),tmp_qloop_538),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_625),tmp_qloop_553),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_625),tmp_qloop_568),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_625),tmp_qloop_583),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_633),tmp_qloop_588),tmp_qloop_636)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_633),tmp_qloop_318),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_633),tmp_qloop_332),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_633),tmp_qloop_346),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_633),tmp_qloop_360),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_633),tmp_qloop_374),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_633),tmp_qloop_388),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_633),tmp_qloop_402),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_633),tmp_qloop_416),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_633),tmp_qloop_430),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_634),tmp_qloop_592),tmp_qloop_638)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_634),tmp_qloop_463),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_634),tmp_qloop_478),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_634),tmp_qloop_493),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_634),tmp_qloop_508),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_634),tmp_qloop_523),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_634),tmp_qloop_538),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_634),tmp_qloop_553),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_634),tmp_qloop_568),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_634),tmp_qloop_583),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_642),tmp_qloop_588),tmp_qloop_645)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_642),tmp_qloop_318),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_642),tmp_qloop_332),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_642),tmp_qloop_346),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_642),tmp_qloop_360),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_642),tmp_qloop_374),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_642),tmp_qloop_388),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_642),tmp_qloop_402),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_642),tmp_qloop_416),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_642),tmp_qloop_430),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_643),tmp_qloop_592),tmp_qloop_647)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_643),tmp_qloop_463),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_643),tmp_qloop_478),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_643),tmp_qloop_493),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_643),tmp_qloop_508),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_643),tmp_qloop_523),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_643),tmp_qloop_538),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_643),tmp_qloop_553),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_643),tmp_qloop_568),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_643),tmp_qloop_583),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_651),tmp_qloop_588),tmp_qloop_654)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_651),tmp_qloop_318),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_651),tmp_qloop_332),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_651),tmp_qloop_346),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_651),tmp_qloop_360),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_651),tmp_qloop_374),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_651),tmp_qloop_388),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_651),tmp_qloop_402),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_651),tmp_qloop_416),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_651),tmp_qloop_430),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_652),tmp_qloop_592),tmp_qloop_656)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_652),tmp_qloop_463),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_652),tmp_qloop_478),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_652),tmp_qloop_493),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_652),tmp_qloop_508),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_652),tmp_qloop_523),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_652),tmp_qloop_538),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_652),tmp_qloop_553),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_652),tmp_qloop_568),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_652),tmp_qloop_583),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_659),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_660)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_661)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_660),tmp_qloop_588),tmp_qloop_663)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_660),tmp_qloop_318),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_660),tmp_qloop_332),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_660),tmp_qloop_346),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_660),tmp_qloop_360),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_660),tmp_qloop_374),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_660),tmp_qloop_388),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_660),tmp_qloop_402),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_660),tmp_qloop_416),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_660),tmp_qloop_430),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_661),tmp_qloop_592),tmp_qloop_665)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_661),tmp_qloop_463),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_661),tmp_qloop_478),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_661),tmp_qloop_493),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_661),tmp_qloop_508),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_661),tmp_qloop_523),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_661),tmp_qloop_538),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_661),tmp_qloop_553),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_661),tmp_qloop_568),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_661),tmp_qloop_583),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_299,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_303,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_673),tmp_qloop_678),tmp_qloop_679)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_673),tmp_qloop_678),tmp_qloop_680)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_673),tmp_qloop_678),tmp_qloop_681)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_673),tmp_qloop_678),tmp_qloop_682)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_673),tmp_qloop_678),tmp_qloop_683)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_673),tmp_qloop_678),tmp_qloop_684)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_673),tmp_qloop_678),tmp_qloop_685)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_673),tmp_qloop_678),tmp_qloop_686)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_673),tmp_qloop_678),tmp_qloop_687)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_673),tmp_qloop_678),tmp_qloop_688)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_692),tmp_qloop_693),tmp_qloop_694)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_692),tmp_qloop_680),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_692),tmp_qloop_681),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_692),tmp_qloop_682),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_692),tmp_qloop_683),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_692),tmp_qloop_684),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_692),tmp_qloop_685),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_692),tmp_qloop_686),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_692),tmp_qloop_687),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_692),tmp_qloop_688),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_699),tmp_qloop_693),tmp_qloop_700)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_699),tmp_qloop_680),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_699),tmp_qloop_681),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_699),tmp_qloop_682),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_699),tmp_qloop_683),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_699),tmp_qloop_684),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_699),tmp_qloop_685),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_699),tmp_qloop_686),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_699),tmp_qloop_687),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_699),tmp_qloop_688),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_705),tmp_qloop_693),tmp_qloop_706)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_705),tmp_qloop_680),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_705),tmp_qloop_681),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_705),tmp_qloop_682),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_705),tmp_qloop_683),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_705),tmp_qloop_684),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_705),tmp_qloop_685),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_705),tmp_qloop_686),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_705),tmp_qloop_687),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_705),tmp_qloop_688),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_711),tmp_qloop_693),tmp_qloop_712)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_711),tmp_qloop_680),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_711),tmp_qloop_681),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_711),tmp_qloop_682),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_711),tmp_qloop_683),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_711),tmp_qloop_684),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_711),tmp_qloop_685),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_711),tmp_qloop_686),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_711),tmp_qloop_687),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_711),tmp_qloop_688),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_717),tmp_qloop_693),tmp_qloop_718)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_717),tmp_qloop_680),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_717),tmp_qloop_681),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_717),tmp_qloop_682),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_717),tmp_qloop_683),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_717),tmp_qloop_684),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_717),tmp_qloop_685),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_717),tmp_qloop_686),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_717),tmp_qloop_687),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_717),tmp_qloop_688),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_723),tmp_qloop_693),tmp_qloop_724)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_723),tmp_qloop_680),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_723),tmp_qloop_681),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_723),tmp_qloop_682),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_723),tmp_qloop_683),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_723),tmp_qloop_684),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_723),tmp_qloop_685),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_723),tmp_qloop_686),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_723),tmp_qloop_687),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_723),tmp_qloop_688),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_729),tmp_qloop_693),tmp_qloop_730)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_729),tmp_qloop_680),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_729),tmp_qloop_681),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_729),tmp_qloop_682),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_729),tmp_qloop_683),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_729),tmp_qloop_684),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_729),tmp_qloop_685),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_729),tmp_qloop_686),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_729),tmp_qloop_687),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_729),tmp_qloop_688),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_735),tmp_qloop_693),tmp_qloop_736)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_735),tmp_qloop_680),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_735),tmp_qloop_681),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_735),tmp_qloop_682),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_735),tmp_qloop_683),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_735),tmp_qloop_684),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_735),tmp_qloop_685),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_735),tmp_qloop_686),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_735),tmp_qloop_687),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_735),tmp_qloop_688),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_740),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_739)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_741)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_741),tmp_qloop_693),tmp_qloop_742)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_741),tmp_qloop_680),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_741),tmp_qloop_681),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_741),tmp_qloop_682),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_741),tmp_qloop_683),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_741),tmp_qloop_684),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_741),tmp_qloop_685),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_741),tmp_qloop_686),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_741),tmp_qloop_687),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_741),tmp_qloop_688),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_442,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_447,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_577,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(1.0,1.0,1.0,1.0)))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_576,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_573,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_574,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_575,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_675)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_582,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_579,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_580,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_581,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_153)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_572),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_569,tmp_qloop_570),tmp_qloop_571),tmp_qloop_744)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_0_12 = _mm256_add_pd(q_acc_0_12,q_tmp_0_12);
                   q_acc_0_13 = _mm256_add_pd(q_acc_0_13,q_tmp_0_13);
                   q_acc_0_14 = _mm256_add_pd(q_acc_0_14,q_tmp_0_14);
                   q_acc_0_15 = _mm256_add_pd(q_acc_0_15,q_tmp_0_15);
                   q_acc_0_16 = _mm256_add_pd(q_acc_0_16,q_tmp_0_16);
                   q_acc_0_17 = _mm256_add_pd(q_acc_0_17,q_tmp_0_17);
                   q_acc_0_18 = _mm256_add_pd(q_acc_0_18,q_tmp_0_18);
                   q_acc_0_19 = _mm256_add_pd(q_acc_0_19,q_tmp_0_19);
                   q_acc_0_20 = _mm256_add_pd(q_acc_0_20,q_tmp_0_20);
                   q_acc_0_21 = _mm256_add_pd(q_acc_0_21,q_tmp_0_21);
                   q_acc_0_22 = _mm256_add_pd(q_acc_0_22,q_tmp_0_22);
                   q_acc_0_23 = _mm256_add_pd(q_acc_0_23,q_tmp_0_23);
                   q_acc_0_24 = _mm256_add_pd(q_acc_0_24,q_tmp_0_24);
                   q_acc_0_25 = _mm256_add_pd(q_acc_0_25,q_tmp_0_25);
                   q_acc_0_26 = _mm256_add_pd(q_acc_0_26,q_tmp_0_26);
                   q_acc_0_27 = _mm256_add_pd(q_acc_0_27,q_tmp_0_27);
                   q_acc_0_28 = _mm256_add_pd(q_acc_0_28,q_tmp_0_28);
                   q_acc_0_29 = _mm256_add_pd(q_acc_0_29,q_tmp_0_29);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_1_12 = _mm256_add_pd(q_acc_1_12,q_tmp_1_12);
                   q_acc_1_13 = _mm256_add_pd(q_acc_1_13,q_tmp_1_13);
                   q_acc_1_14 = _mm256_add_pd(q_acc_1_14,q_tmp_1_14);
                   q_acc_1_15 = _mm256_add_pd(q_acc_1_15,q_tmp_1_15);
                   q_acc_1_16 = _mm256_add_pd(q_acc_1_16,q_tmp_1_16);
                   q_acc_1_17 = _mm256_add_pd(q_acc_1_17,q_tmp_1_17);
                   q_acc_1_18 = _mm256_add_pd(q_acc_1_18,q_tmp_1_18);
                   q_acc_1_19 = _mm256_add_pd(q_acc_1_19,q_tmp_1_19);
                   q_acc_1_20 = _mm256_add_pd(q_acc_1_20,q_tmp_1_20);
                   q_acc_1_21 = _mm256_add_pd(q_acc_1_21,q_tmp_1_21);
                   q_acc_1_22 = _mm256_add_pd(q_acc_1_22,q_tmp_1_22);
                   q_acc_1_23 = _mm256_add_pd(q_acc_1_23,q_tmp_1_23);
                   q_acc_1_24 = _mm256_add_pd(q_acc_1_24,q_tmp_1_24);
                   q_acc_1_25 = _mm256_add_pd(q_acc_1_25,q_tmp_1_25);
                   q_acc_1_26 = _mm256_add_pd(q_acc_1_26,q_tmp_1_26);
                   q_acc_1_27 = _mm256_add_pd(q_acc_1_27,q_tmp_1_27);
                   q_acc_1_28 = _mm256_add_pd(q_acc_1_28,q_tmp_1_28);
                   q_acc_1_29 = _mm256_add_pd(q_acc_1_29,q_tmp_1_29);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_2_12 = _mm256_add_pd(q_acc_2_12,q_tmp_2_12);
                   q_acc_2_13 = _mm256_add_pd(q_acc_2_13,q_tmp_2_13);
                   q_acc_2_14 = _mm256_add_pd(q_acc_2_14,q_tmp_2_14);
                   q_acc_2_15 = _mm256_add_pd(q_acc_2_15,q_tmp_2_15);
                   q_acc_2_16 = _mm256_add_pd(q_acc_2_16,q_tmp_2_16);
                   q_acc_2_17 = _mm256_add_pd(q_acc_2_17,q_tmp_2_17);
                   q_acc_2_18 = _mm256_add_pd(q_acc_2_18,q_tmp_2_18);
                   q_acc_2_19 = _mm256_add_pd(q_acc_2_19,q_tmp_2_19);
                   q_acc_2_20 = _mm256_add_pd(q_acc_2_20,q_tmp_2_20);
                   q_acc_2_21 = _mm256_add_pd(q_acc_2_21,q_tmp_2_21);
                   q_acc_2_22 = _mm256_add_pd(q_acc_2_22,q_tmp_2_22);
                   q_acc_2_23 = _mm256_add_pd(q_acc_2_23,q_tmp_2_23);
                   q_acc_2_24 = _mm256_add_pd(q_acc_2_24,q_tmp_2_24);
                   q_acc_2_25 = _mm256_add_pd(q_acc_2_25,q_tmp_2_25);
                   q_acc_2_26 = _mm256_add_pd(q_acc_2_26,q_tmp_2_26);
                   q_acc_2_27 = _mm256_add_pd(q_acc_2_27,q_tmp_2_27);
                   q_acc_2_28 = _mm256_add_pd(q_acc_2_28,q_tmp_2_28);
                   q_acc_2_29 = _mm256_add_pd(q_acc_2_29,q_tmp_2_29);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_3_12 = _mm256_add_pd(q_acc_3_12,q_tmp_3_12);
                   q_acc_3_13 = _mm256_add_pd(q_acc_3_13,q_tmp_3_13);
                   q_acc_3_14 = _mm256_add_pd(q_acc_3_14,q_tmp_3_14);
                   q_acc_3_15 = _mm256_add_pd(q_acc_3_15,q_tmp_3_15);
                   q_acc_3_16 = _mm256_add_pd(q_acc_3_16,q_tmp_3_16);
                   q_acc_3_17 = _mm256_add_pd(q_acc_3_17,q_tmp_3_17);
                   q_acc_3_18 = _mm256_add_pd(q_acc_3_18,q_tmp_3_18);
                   q_acc_3_19 = _mm256_add_pd(q_acc_3_19,q_tmp_3_19);
                   q_acc_3_20 = _mm256_add_pd(q_acc_3_20,q_tmp_3_20);
                   q_acc_3_21 = _mm256_add_pd(q_acc_3_21,q_tmp_3_21);
                   q_acc_3_22 = _mm256_add_pd(q_acc_3_22,q_tmp_3_22);
                   q_acc_3_23 = _mm256_add_pd(q_acc_3_23,q_tmp_3_23);
                   q_acc_3_24 = _mm256_add_pd(q_acc_3_24,q_tmp_3_24);
                   q_acc_3_25 = _mm256_add_pd(q_acc_3_25,q_tmp_3_25);
                   q_acc_3_26 = _mm256_add_pd(q_acc_3_26,q_tmp_3_26);
                   q_acc_3_27 = _mm256_add_pd(q_acc_3_27,q_tmp_3_27);
                   q_acc_3_28 = _mm256_add_pd(q_acc_3_28,q_tmp_3_28);
                   q_acc_3_29 = _mm256_add_pd(q_acc_3_29,q_tmp_3_29);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_4_12 = _mm256_add_pd(q_acc_4_12,q_tmp_4_12);
                   q_acc_4_13 = _mm256_add_pd(q_acc_4_13,q_tmp_4_13);
                   q_acc_4_14 = _mm256_add_pd(q_acc_4_14,q_tmp_4_14);
                   q_acc_4_15 = _mm256_add_pd(q_acc_4_15,q_tmp_4_15);
                   q_acc_4_16 = _mm256_add_pd(q_acc_4_16,q_tmp_4_16);
                   q_acc_4_17 = _mm256_add_pd(q_acc_4_17,q_tmp_4_17);
                   q_acc_4_18 = _mm256_add_pd(q_acc_4_18,q_tmp_4_18);
                   q_acc_4_19 = _mm256_add_pd(q_acc_4_19,q_tmp_4_19);
                   q_acc_4_20 = _mm256_add_pd(q_acc_4_20,q_tmp_4_20);
                   q_acc_4_21 = _mm256_add_pd(q_acc_4_21,q_tmp_4_21);
                   q_acc_4_22 = _mm256_add_pd(q_acc_4_22,q_tmp_4_22);
                   q_acc_4_23 = _mm256_add_pd(q_acc_4_23,q_tmp_4_23);
                   q_acc_4_24 = _mm256_add_pd(q_acc_4_24,q_tmp_4_24);
                   q_acc_4_25 = _mm256_add_pd(q_acc_4_25,q_tmp_4_25);
                   q_acc_4_26 = _mm256_add_pd(q_acc_4_26,q_tmp_4_26);
                   q_acc_4_27 = _mm256_add_pd(q_acc_4_27,q_tmp_4_27);
                   q_acc_4_28 = _mm256_add_pd(q_acc_4_28,q_tmp_4_28);
                   q_acc_4_29 = _mm256_add_pd(q_acc_4_29,q_tmp_4_29);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_5_12 = _mm256_add_pd(q_acc_5_12,q_tmp_5_12);
                   q_acc_5_13 = _mm256_add_pd(q_acc_5_13,q_tmp_5_13);
                   q_acc_5_14 = _mm256_add_pd(q_acc_5_14,q_tmp_5_14);
                   q_acc_5_15 = _mm256_add_pd(q_acc_5_15,q_tmp_5_15);
                   q_acc_5_16 = _mm256_add_pd(q_acc_5_16,q_tmp_5_16);
                   q_acc_5_17 = _mm256_add_pd(q_acc_5_17,q_tmp_5_17);
                   q_acc_5_18 = _mm256_add_pd(q_acc_5_18,q_tmp_5_18);
                   q_acc_5_19 = _mm256_add_pd(q_acc_5_19,q_tmp_5_19);
                   q_acc_5_20 = _mm256_add_pd(q_acc_5_20,q_tmp_5_20);
                   q_acc_5_21 = _mm256_add_pd(q_acc_5_21,q_tmp_5_21);
                   q_acc_5_22 = _mm256_add_pd(q_acc_5_22,q_tmp_5_22);
                   q_acc_5_23 = _mm256_add_pd(q_acc_5_23,q_tmp_5_23);
                   q_acc_5_24 = _mm256_add_pd(q_acc_5_24,q_tmp_5_24);
                   q_acc_5_25 = _mm256_add_pd(q_acc_5_25,q_tmp_5_25);
                   q_acc_5_26 = _mm256_add_pd(q_acc_5_26,q_tmp_5_26);
                   q_acc_5_27 = _mm256_add_pd(q_acc_5_27,q_tmp_5_27);
                   q_acc_5_28 = _mm256_add_pd(q_acc_5_28,q_tmp_5_28);
                   q_acc_5_29 = _mm256_add_pd(q_acc_5_29,q_tmp_5_29);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_6_12 = _mm256_add_pd(q_acc_6_12,q_tmp_6_12);
                   q_acc_6_13 = _mm256_add_pd(q_acc_6_13,q_tmp_6_13);
                   q_acc_6_14 = _mm256_add_pd(q_acc_6_14,q_tmp_6_14);
                   q_acc_6_15 = _mm256_add_pd(q_acc_6_15,q_tmp_6_15);
                   q_acc_6_16 = _mm256_add_pd(q_acc_6_16,q_tmp_6_16);
                   q_acc_6_17 = _mm256_add_pd(q_acc_6_17,q_tmp_6_17);
                   q_acc_6_18 = _mm256_add_pd(q_acc_6_18,q_tmp_6_18);
                   q_acc_6_19 = _mm256_add_pd(q_acc_6_19,q_tmp_6_19);
                   q_acc_6_20 = _mm256_add_pd(q_acc_6_20,q_tmp_6_20);
                   q_acc_6_21 = _mm256_add_pd(q_acc_6_21,q_tmp_6_21);
                   q_acc_6_22 = _mm256_add_pd(q_acc_6_22,q_tmp_6_22);
                   q_acc_6_23 = _mm256_add_pd(q_acc_6_23,q_tmp_6_23);
                   q_acc_6_24 = _mm256_add_pd(q_acc_6_24,q_tmp_6_24);
                   q_acc_6_25 = _mm256_add_pd(q_acc_6_25,q_tmp_6_25);
                   q_acc_6_26 = _mm256_add_pd(q_acc_6_26,q_tmp_6_26);
                   q_acc_6_27 = _mm256_add_pd(q_acc_6_27,q_tmp_6_27);
                   q_acc_6_28 = _mm256_add_pd(q_acc_6_28,q_tmp_6_28);
                   q_acc_6_29 = _mm256_add_pd(q_acc_6_29,q_tmp_6_29);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_7_12 = _mm256_add_pd(q_acc_7_12,q_tmp_7_12);
                   q_acc_7_13 = _mm256_add_pd(q_acc_7_13,q_tmp_7_13);
                   q_acc_7_14 = _mm256_add_pd(q_acc_7_14,q_tmp_7_14);
                   q_acc_7_15 = _mm256_add_pd(q_acc_7_15,q_tmp_7_15);
                   q_acc_7_16 = _mm256_add_pd(q_acc_7_16,q_tmp_7_16);
                   q_acc_7_17 = _mm256_add_pd(q_acc_7_17,q_tmp_7_17);
                   q_acc_7_18 = _mm256_add_pd(q_acc_7_18,q_tmp_7_18);
                   q_acc_7_19 = _mm256_add_pd(q_acc_7_19,q_tmp_7_19);
                   q_acc_7_20 = _mm256_add_pd(q_acc_7_20,q_tmp_7_20);
                   q_acc_7_21 = _mm256_add_pd(q_acc_7_21,q_tmp_7_21);
                   q_acc_7_22 = _mm256_add_pd(q_acc_7_22,q_tmp_7_22);
                   q_acc_7_23 = _mm256_add_pd(q_acc_7_23,q_tmp_7_23);
                   q_acc_7_24 = _mm256_add_pd(q_acc_7_24,q_tmp_7_24);
                   q_acc_7_25 = _mm256_add_pd(q_acc_7_25,q_tmp_7_25);
                   q_acc_7_26 = _mm256_add_pd(q_acc_7_26,q_tmp_7_26);
                   q_acc_7_27 = _mm256_add_pd(q_acc_7_27,q_tmp_7_27);
                   q_acc_7_28 = _mm256_add_pd(q_acc_7_28,q_tmp_7_28);
                   q_acc_7_29 = _mm256_add_pd(q_acc_7_29,q_tmp_7_29);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_8_12 = _mm256_add_pd(q_acc_8_12,q_tmp_8_12);
                   q_acc_8_13 = _mm256_add_pd(q_acc_8_13,q_tmp_8_13);
                   q_acc_8_14 = _mm256_add_pd(q_acc_8_14,q_tmp_8_14);
                   q_acc_8_15 = _mm256_add_pd(q_acc_8_15,q_tmp_8_15);
                   q_acc_8_16 = _mm256_add_pd(q_acc_8_16,q_tmp_8_16);
                   q_acc_8_17 = _mm256_add_pd(q_acc_8_17,q_tmp_8_17);
                   q_acc_8_18 = _mm256_add_pd(q_acc_8_18,q_tmp_8_18);
                   q_acc_8_19 = _mm256_add_pd(q_acc_8_19,q_tmp_8_19);
                   q_acc_8_20 = _mm256_add_pd(q_acc_8_20,q_tmp_8_20);
                   q_acc_8_21 = _mm256_add_pd(q_acc_8_21,q_tmp_8_21);
                   q_acc_8_22 = _mm256_add_pd(q_acc_8_22,q_tmp_8_22);
                   q_acc_8_23 = _mm256_add_pd(q_acc_8_23,q_tmp_8_23);
                   q_acc_8_24 = _mm256_add_pd(q_acc_8_24,q_tmp_8_24);
                   q_acc_8_25 = _mm256_add_pd(q_acc_8_25,q_tmp_8_25);
                   q_acc_8_26 = _mm256_add_pd(q_acc_8_26,q_tmp_8_26);
                   q_acc_8_27 = _mm256_add_pd(q_acc_8_27,q_tmp_8_27);
                   q_acc_8_28 = _mm256_add_pd(q_acc_8_28,q_tmp_8_28);
                   q_acc_8_29 = _mm256_add_pd(q_acc_8_29,q_tmp_8_29);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_9_12 = _mm256_add_pd(q_acc_9_12,q_tmp_9_12);
                   q_acc_9_13 = _mm256_add_pd(q_acc_9_13,q_tmp_9_13);
                   q_acc_9_14 = _mm256_add_pd(q_acc_9_14,q_tmp_9_14);
                   q_acc_9_15 = _mm256_add_pd(q_acc_9_15,q_tmp_9_15);
                   q_acc_9_16 = _mm256_add_pd(q_acc_9_16,q_tmp_9_16);
                   q_acc_9_17 = _mm256_add_pd(q_acc_9_17,q_tmp_9_17);
                   q_acc_9_18 = _mm256_add_pd(q_acc_9_18,q_tmp_9_18);
                   q_acc_9_19 = _mm256_add_pd(q_acc_9_19,q_tmp_9_19);
                   q_acc_9_20 = _mm256_add_pd(q_acc_9_20,q_tmp_9_20);
                   q_acc_9_21 = _mm256_add_pd(q_acc_9_21,q_tmp_9_21);
                   q_acc_9_22 = _mm256_add_pd(q_acc_9_22,q_tmp_9_22);
                   q_acc_9_23 = _mm256_add_pd(q_acc_9_23,q_tmp_9_23);
                   q_acc_9_24 = _mm256_add_pd(q_acc_9_24,q_tmp_9_24);
                   q_acc_9_25 = _mm256_add_pd(q_acc_9_25,q_tmp_9_25);
                   q_acc_9_26 = _mm256_add_pd(q_acc_9_26,q_tmp_9_26);
                   q_acc_9_27 = _mm256_add_pd(q_acc_9_27,q_tmp_9_27);
                   q_acc_9_28 = _mm256_add_pd(q_acc_9_28,q_tmp_9_28);
                   q_acc_9_29 = _mm256_add_pd(q_acc_9_29,q_tmp_9_29);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_10_12 = _mm256_add_pd(q_acc_10_12,q_tmp_10_12);
                   q_acc_10_13 = _mm256_add_pd(q_acc_10_13,q_tmp_10_13);
                   q_acc_10_14 = _mm256_add_pd(q_acc_10_14,q_tmp_10_14);
                   q_acc_10_15 = _mm256_add_pd(q_acc_10_15,q_tmp_10_15);
                   q_acc_10_16 = _mm256_add_pd(q_acc_10_16,q_tmp_10_16);
                   q_acc_10_17 = _mm256_add_pd(q_acc_10_17,q_tmp_10_17);
                   q_acc_10_18 = _mm256_add_pd(q_acc_10_18,q_tmp_10_18);
                   q_acc_10_19 = _mm256_add_pd(q_acc_10_19,q_tmp_10_19);
                   q_acc_10_20 = _mm256_add_pd(q_acc_10_20,q_tmp_10_20);
                   q_acc_10_21 = _mm256_add_pd(q_acc_10_21,q_tmp_10_21);
                   q_acc_10_22 = _mm256_add_pd(q_acc_10_22,q_tmp_10_22);
                   q_acc_10_23 = _mm256_add_pd(q_acc_10_23,q_tmp_10_23);
                   q_acc_10_24 = _mm256_add_pd(q_acc_10_24,q_tmp_10_24);
                   q_acc_10_25 = _mm256_add_pd(q_acc_10_25,q_tmp_10_25);
                   q_acc_10_26 = _mm256_add_pd(q_acc_10_26,q_tmp_10_26);
                   q_acc_10_27 = _mm256_add_pd(q_acc_10_27,q_tmp_10_27);
                   q_acc_10_28 = _mm256_add_pd(q_acc_10_28,q_tmp_10_28);
                   q_acc_10_29 = _mm256_add_pd(q_acc_10_29,q_tmp_10_29);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_11_12 = _mm256_add_pd(q_acc_11_12,q_tmp_11_12);
                   q_acc_11_13 = _mm256_add_pd(q_acc_11_13,q_tmp_11_13);
                   q_acc_11_14 = _mm256_add_pd(q_acc_11_14,q_tmp_11_14);
                   q_acc_11_15 = _mm256_add_pd(q_acc_11_15,q_tmp_11_15);
                   q_acc_11_16 = _mm256_add_pd(q_acc_11_16,q_tmp_11_16);
                   q_acc_11_17 = _mm256_add_pd(q_acc_11_17,q_tmp_11_17);
                   q_acc_11_18 = _mm256_add_pd(q_acc_11_18,q_tmp_11_18);
                   q_acc_11_19 = _mm256_add_pd(q_acc_11_19,q_tmp_11_19);
                   q_acc_11_20 = _mm256_add_pd(q_acc_11_20,q_tmp_11_20);
                   q_acc_11_21 = _mm256_add_pd(q_acc_11_21,q_tmp_11_21);
                   q_acc_11_22 = _mm256_add_pd(q_acc_11_22,q_tmp_11_22);
                   q_acc_11_23 = _mm256_add_pd(q_acc_11_23,q_tmp_11_23);
                   q_acc_11_24 = _mm256_add_pd(q_acc_11_24,q_tmp_11_24);
                   q_acc_11_25 = _mm256_add_pd(q_acc_11_25,q_tmp_11_25);
                   q_acc_11_26 = _mm256_add_pd(q_acc_11_26,q_tmp_11_26);
                   q_acc_11_27 = _mm256_add_pd(q_acc_11_27,q_tmp_11_27);
                   q_acc_11_28 = _mm256_add_pd(q_acc_11_28,q_tmp_11_28);
                   q_acc_11_29 = _mm256_add_pd(q_acc_11_29,q_tmp_11_29);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_12_13 = _mm256_add_pd(q_acc_12_13,q_tmp_12_13);
                   q_acc_12_14 = _mm256_add_pd(q_acc_12_14,q_tmp_12_14);
                   q_acc_12_15 = _mm256_add_pd(q_acc_12_15,q_tmp_12_15);
                   q_acc_12_16 = _mm256_add_pd(q_acc_12_16,q_tmp_12_16);
                   q_acc_12_17 = _mm256_add_pd(q_acc_12_17,q_tmp_12_17);
                   q_acc_12_18 = _mm256_add_pd(q_acc_12_18,q_tmp_12_18);
                   q_acc_12_19 = _mm256_add_pd(q_acc_12_19,q_tmp_12_19);
                   q_acc_12_20 = _mm256_add_pd(q_acc_12_20,q_tmp_12_20);
                   q_acc_12_21 = _mm256_add_pd(q_acc_12_21,q_tmp_12_21);
                   q_acc_12_22 = _mm256_add_pd(q_acc_12_22,q_tmp_12_22);
                   q_acc_12_23 = _mm256_add_pd(q_acc_12_23,q_tmp_12_23);
                   q_acc_12_24 = _mm256_add_pd(q_acc_12_24,q_tmp_12_24);
                   q_acc_12_25 = _mm256_add_pd(q_acc_12_25,q_tmp_12_25);
                   q_acc_12_26 = _mm256_add_pd(q_acc_12_26,q_tmp_12_26);
                   q_acc_12_27 = _mm256_add_pd(q_acc_12_27,q_tmp_12_27);
                   q_acc_12_28 = _mm256_add_pd(q_acc_12_28,q_tmp_12_28);
                   q_acc_12_29 = _mm256_add_pd(q_acc_12_29,q_tmp_12_29);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_13_14 = _mm256_add_pd(q_acc_13_14,q_tmp_13_14);
                   q_acc_13_15 = _mm256_add_pd(q_acc_13_15,q_tmp_13_15);
                   q_acc_13_16 = _mm256_add_pd(q_acc_13_16,q_tmp_13_16);
                   q_acc_13_17 = _mm256_add_pd(q_acc_13_17,q_tmp_13_17);
                   q_acc_13_18 = _mm256_add_pd(q_acc_13_18,q_tmp_13_18);
                   q_acc_13_19 = _mm256_add_pd(q_acc_13_19,q_tmp_13_19);
                   q_acc_13_20 = _mm256_add_pd(q_acc_13_20,q_tmp_13_20);
                   q_acc_13_21 = _mm256_add_pd(q_acc_13_21,q_tmp_13_21);
                   q_acc_13_22 = _mm256_add_pd(q_acc_13_22,q_tmp_13_22);
                   q_acc_13_23 = _mm256_add_pd(q_acc_13_23,q_tmp_13_23);
                   q_acc_13_24 = _mm256_add_pd(q_acc_13_24,q_tmp_13_24);
                   q_acc_13_25 = _mm256_add_pd(q_acc_13_25,q_tmp_13_25);
                   q_acc_13_26 = _mm256_add_pd(q_acc_13_26,q_tmp_13_26);
                   q_acc_13_27 = _mm256_add_pd(q_acc_13_27,q_tmp_13_27);
                   q_acc_13_28 = _mm256_add_pd(q_acc_13_28,q_tmp_13_28);
                   q_acc_13_29 = _mm256_add_pd(q_acc_13_29,q_tmp_13_29);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_14_15 = _mm256_add_pd(q_acc_14_15,q_tmp_14_15);
                   q_acc_14_16 = _mm256_add_pd(q_acc_14_16,q_tmp_14_16);
                   q_acc_14_17 = _mm256_add_pd(q_acc_14_17,q_tmp_14_17);
                   q_acc_14_18 = _mm256_add_pd(q_acc_14_18,q_tmp_14_18);
                   q_acc_14_19 = _mm256_add_pd(q_acc_14_19,q_tmp_14_19);
                   q_acc_14_20 = _mm256_add_pd(q_acc_14_20,q_tmp_14_20);
                   q_acc_14_21 = _mm256_add_pd(q_acc_14_21,q_tmp_14_21);
                   q_acc_14_22 = _mm256_add_pd(q_acc_14_22,q_tmp_14_22);
                   q_acc_14_23 = _mm256_add_pd(q_acc_14_23,q_tmp_14_23);
                   q_acc_14_24 = _mm256_add_pd(q_acc_14_24,q_tmp_14_24);
                   q_acc_14_25 = _mm256_add_pd(q_acc_14_25,q_tmp_14_25);
                   q_acc_14_26 = _mm256_add_pd(q_acc_14_26,q_tmp_14_26);
                   q_acc_14_27 = _mm256_add_pd(q_acc_14_27,q_tmp_14_27);
                   q_acc_14_28 = _mm256_add_pd(q_acc_14_28,q_tmp_14_28);
                   q_acc_14_29 = _mm256_add_pd(q_acc_14_29,q_tmp_14_29);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_15_16 = _mm256_add_pd(q_acc_15_16,q_tmp_15_16);
                   q_acc_15_17 = _mm256_add_pd(q_acc_15_17,q_tmp_15_17);
                   q_acc_15_18 = _mm256_add_pd(q_acc_15_18,q_tmp_15_18);
                   q_acc_15_19 = _mm256_add_pd(q_acc_15_19,q_tmp_15_19);
                   q_acc_15_20 = _mm256_add_pd(q_acc_15_20,q_tmp_15_20);
                   q_acc_15_21 = _mm256_add_pd(q_acc_15_21,q_tmp_15_21);
                   q_acc_15_22 = _mm256_add_pd(q_acc_15_22,q_tmp_15_22);
                   q_acc_15_23 = _mm256_add_pd(q_acc_15_23,q_tmp_15_23);
                   q_acc_15_24 = _mm256_add_pd(q_acc_15_24,q_tmp_15_24);
                   q_acc_15_25 = _mm256_add_pd(q_acc_15_25,q_tmp_15_25);
                   q_acc_15_26 = _mm256_add_pd(q_acc_15_26,q_tmp_15_26);
                   q_acc_15_27 = _mm256_add_pd(q_acc_15_27,q_tmp_15_27);
                   q_acc_15_28 = _mm256_add_pd(q_acc_15_28,q_tmp_15_28);
                   q_acc_15_29 = _mm256_add_pd(q_acc_15_29,q_tmp_15_29);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_16_17 = _mm256_add_pd(q_acc_16_17,q_tmp_16_17);
                   q_acc_16_18 = _mm256_add_pd(q_acc_16_18,q_tmp_16_18);
                   q_acc_16_19 = _mm256_add_pd(q_acc_16_19,q_tmp_16_19);
                   q_acc_16_20 = _mm256_add_pd(q_acc_16_20,q_tmp_16_20);
                   q_acc_16_21 = _mm256_add_pd(q_acc_16_21,q_tmp_16_21);
                   q_acc_16_22 = _mm256_add_pd(q_acc_16_22,q_tmp_16_22);
                   q_acc_16_23 = _mm256_add_pd(q_acc_16_23,q_tmp_16_23);
                   q_acc_16_24 = _mm256_add_pd(q_acc_16_24,q_tmp_16_24);
                   q_acc_16_25 = _mm256_add_pd(q_acc_16_25,q_tmp_16_25);
                   q_acc_16_26 = _mm256_add_pd(q_acc_16_26,q_tmp_16_26);
                   q_acc_16_27 = _mm256_add_pd(q_acc_16_27,q_tmp_16_27);
                   q_acc_16_28 = _mm256_add_pd(q_acc_16_28,q_tmp_16_28);
                   q_acc_16_29 = _mm256_add_pd(q_acc_16_29,q_tmp_16_29);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_17_18 = _mm256_add_pd(q_acc_17_18,q_tmp_17_18);
                   q_acc_17_19 = _mm256_add_pd(q_acc_17_19,q_tmp_17_19);
                   q_acc_17_20 = _mm256_add_pd(q_acc_17_20,q_tmp_17_20);
                   q_acc_17_21 = _mm256_add_pd(q_acc_17_21,q_tmp_17_21);
                   q_acc_17_22 = _mm256_add_pd(q_acc_17_22,q_tmp_17_22);
                   q_acc_17_23 = _mm256_add_pd(q_acc_17_23,q_tmp_17_23);
                   q_acc_17_24 = _mm256_add_pd(q_acc_17_24,q_tmp_17_24);
                   q_acc_17_25 = _mm256_add_pd(q_acc_17_25,q_tmp_17_25);
                   q_acc_17_26 = _mm256_add_pd(q_acc_17_26,q_tmp_17_26);
                   q_acc_17_27 = _mm256_add_pd(q_acc_17_27,q_tmp_17_27);
                   q_acc_17_28 = _mm256_add_pd(q_acc_17_28,q_tmp_17_28);
                   q_acc_17_29 = _mm256_add_pd(q_acc_17_29,q_tmp_17_29);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_18_19 = _mm256_add_pd(q_acc_18_19,q_tmp_18_19);
                   q_acc_18_20 = _mm256_add_pd(q_acc_18_20,q_tmp_18_20);
                   q_acc_18_21 = _mm256_add_pd(q_acc_18_21,q_tmp_18_21);
                   q_acc_18_22 = _mm256_add_pd(q_acc_18_22,q_tmp_18_22);
                   q_acc_18_23 = _mm256_add_pd(q_acc_18_23,q_tmp_18_23);
                   q_acc_18_24 = _mm256_add_pd(q_acc_18_24,q_tmp_18_24);
                   q_acc_18_25 = _mm256_add_pd(q_acc_18_25,q_tmp_18_25);
                   q_acc_18_26 = _mm256_add_pd(q_acc_18_26,q_tmp_18_26);
                   q_acc_18_27 = _mm256_add_pd(q_acc_18_27,q_tmp_18_27);
                   q_acc_18_28 = _mm256_add_pd(q_acc_18_28,q_tmp_18_28);
                   q_acc_18_29 = _mm256_add_pd(q_acc_18_29,q_tmp_18_29);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_19_20 = _mm256_add_pd(q_acc_19_20,q_tmp_19_20);
                   q_acc_19_21 = _mm256_add_pd(q_acc_19_21,q_tmp_19_21);
                   q_acc_19_22 = _mm256_add_pd(q_acc_19_22,q_tmp_19_22);
                   q_acc_19_23 = _mm256_add_pd(q_acc_19_23,q_tmp_19_23);
                   q_acc_19_24 = _mm256_add_pd(q_acc_19_24,q_tmp_19_24);
                   q_acc_19_25 = _mm256_add_pd(q_acc_19_25,q_tmp_19_25);
                   q_acc_19_26 = _mm256_add_pd(q_acc_19_26,q_tmp_19_26);
                   q_acc_19_27 = _mm256_add_pd(q_acc_19_27,q_tmp_19_27);
                   q_acc_19_28 = _mm256_add_pd(q_acc_19_28,q_tmp_19_28);
                   q_acc_19_29 = _mm256_add_pd(q_acc_19_29,q_tmp_19_29);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_20_21 = _mm256_add_pd(q_acc_20_21,q_tmp_20_21);
                   q_acc_20_22 = _mm256_add_pd(q_acc_20_22,q_tmp_20_22);
                   q_acc_20_23 = _mm256_add_pd(q_acc_20_23,q_tmp_20_23);
                   q_acc_20_24 = _mm256_add_pd(q_acc_20_24,q_tmp_20_24);
                   q_acc_20_25 = _mm256_add_pd(q_acc_20_25,q_tmp_20_25);
                   q_acc_20_26 = _mm256_add_pd(q_acc_20_26,q_tmp_20_26);
                   q_acc_20_27 = _mm256_add_pd(q_acc_20_27,q_tmp_20_27);
                   q_acc_20_28 = _mm256_add_pd(q_acc_20_28,q_tmp_20_28);
                   q_acc_20_29 = _mm256_add_pd(q_acc_20_29,q_tmp_20_29);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_21_22 = _mm256_add_pd(q_acc_21_22,q_tmp_21_22);
                   q_acc_21_23 = _mm256_add_pd(q_acc_21_23,q_tmp_21_23);
                   q_acc_21_24 = _mm256_add_pd(q_acc_21_24,q_tmp_21_24);
                   q_acc_21_25 = _mm256_add_pd(q_acc_21_25,q_tmp_21_25);
                   q_acc_21_26 = _mm256_add_pd(q_acc_21_26,q_tmp_21_26);
                   q_acc_21_27 = _mm256_add_pd(q_acc_21_27,q_tmp_21_27);
                   q_acc_21_28 = _mm256_add_pd(q_acc_21_28,q_tmp_21_28);
                   q_acc_21_29 = _mm256_add_pd(q_acc_21_29,q_tmp_21_29);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_22_23 = _mm256_add_pd(q_acc_22_23,q_tmp_22_23);
                   q_acc_22_24 = _mm256_add_pd(q_acc_22_24,q_tmp_22_24);
                   q_acc_22_25 = _mm256_add_pd(q_acc_22_25,q_tmp_22_25);
                   q_acc_22_26 = _mm256_add_pd(q_acc_22_26,q_tmp_22_26);
                   q_acc_22_27 = _mm256_add_pd(q_acc_22_27,q_tmp_22_27);
                   q_acc_22_28 = _mm256_add_pd(q_acc_22_28,q_tmp_22_28);
                   q_acc_22_29 = _mm256_add_pd(q_acc_22_29,q_tmp_22_29);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_23_24 = _mm256_add_pd(q_acc_23_24,q_tmp_23_24);
                   q_acc_23_25 = _mm256_add_pd(q_acc_23_25,q_tmp_23_25);
                   q_acc_23_26 = _mm256_add_pd(q_acc_23_26,q_tmp_23_26);
                   q_acc_23_27 = _mm256_add_pd(q_acc_23_27,q_tmp_23_27);
                   q_acc_23_28 = _mm256_add_pd(q_acc_23_28,q_tmp_23_28);
                   q_acc_23_29 = _mm256_add_pd(q_acc_23_29,q_tmp_23_29);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_24_25 = _mm256_add_pd(q_acc_24_25,q_tmp_24_25);
                   q_acc_24_26 = _mm256_add_pd(q_acc_24_26,q_tmp_24_26);
                   q_acc_24_27 = _mm256_add_pd(q_acc_24_27,q_tmp_24_27);
                   q_acc_24_28 = _mm256_add_pd(q_acc_24_28,q_tmp_24_28);
                   q_acc_24_29 = _mm256_add_pd(q_acc_24_29,q_tmp_24_29);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_25_26 = _mm256_add_pd(q_acc_25_26,q_tmp_25_26);
                   q_acc_25_27 = _mm256_add_pd(q_acc_25_27,q_tmp_25_27);
                   q_acc_25_28 = _mm256_add_pd(q_acc_25_28,q_tmp_25_28);
                   q_acc_25_29 = _mm256_add_pd(q_acc_25_29,q_tmp_25_29);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_26_27 = _mm256_add_pd(q_acc_26_27,q_tmp_26_27);
                   q_acc_26_28 = _mm256_add_pd(q_acc_26_28,q_tmp_26_28);
                   q_acc_26_29 = _mm256_add_pd(q_acc_26_29,q_tmp_26_29);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_27_28 = _mm256_add_pd(q_acc_27_28,q_tmp_27_28);
                   q_acc_27_29 = _mm256_add_pd(q_acc_27_29,q_tmp_27_29);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_28_29 = _mm256_add_pd(q_acc_28_29,q_tmp_28_29);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_12,src_dof_12)),_mm256_mul_pd(q_acc_0_13,src_dof_13)),_mm256_mul_pd(q_acc_0_14,src_dof_14)),_mm256_mul_pd(q_acc_0_15,src_dof_15)),_mm256_mul_pd(q_acc_0_16,src_dof_16)),_mm256_mul_pd(q_acc_0_17,src_dof_17)),_mm256_mul_pd(q_acc_0_18,src_dof_18)),_mm256_mul_pd(q_acc_0_19,src_dof_19)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_20,src_dof_20)),_mm256_mul_pd(q_acc_0_21,src_dof_21)),_mm256_mul_pd(q_acc_0_22,src_dof_22)),_mm256_mul_pd(q_acc_0_23,src_dof_23)),_mm256_mul_pd(q_acc_0_24,src_dof_24)),_mm256_mul_pd(q_acc_0_25,src_dof_25)),_mm256_mul_pd(q_acc_0_26,src_dof_26)),_mm256_mul_pd(q_acc_0_27,src_dof_27)),_mm256_mul_pd(q_acc_0_28,src_dof_28)),_mm256_mul_pd(q_acc_0_29,src_dof_29)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_12,src_dof_12)),_mm256_mul_pd(q_acc_1_13,src_dof_13)),_mm256_mul_pd(q_acc_1_14,src_dof_14)),_mm256_mul_pd(q_acc_1_15,src_dof_15)),_mm256_mul_pd(q_acc_1_16,src_dof_16)),_mm256_mul_pd(q_acc_1_17,src_dof_17)),_mm256_mul_pd(q_acc_1_18,src_dof_18)),_mm256_mul_pd(q_acc_1_19,src_dof_19)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_20,src_dof_20)),_mm256_mul_pd(q_acc_1_21,src_dof_21)),_mm256_mul_pd(q_acc_1_22,src_dof_22)),_mm256_mul_pd(q_acc_1_23,src_dof_23)),_mm256_mul_pd(q_acc_1_24,src_dof_24)),_mm256_mul_pd(q_acc_1_25,src_dof_25)),_mm256_mul_pd(q_acc_1_26,src_dof_26)),_mm256_mul_pd(q_acc_1_27,src_dof_27)),_mm256_mul_pd(q_acc_1_28,src_dof_28)),_mm256_mul_pd(q_acc_1_29,src_dof_29)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_12,src_dof_12)),_mm256_mul_pd(q_acc_2_13,src_dof_13)),_mm256_mul_pd(q_acc_2_14,src_dof_14)),_mm256_mul_pd(q_acc_2_15,src_dof_15)),_mm256_mul_pd(q_acc_2_16,src_dof_16)),_mm256_mul_pd(q_acc_2_17,src_dof_17)),_mm256_mul_pd(q_acc_2_18,src_dof_18)),_mm256_mul_pd(q_acc_2_19,src_dof_19)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_20,src_dof_20)),_mm256_mul_pd(q_acc_2_21,src_dof_21)),_mm256_mul_pd(q_acc_2_22,src_dof_22)),_mm256_mul_pd(q_acc_2_23,src_dof_23)),_mm256_mul_pd(q_acc_2_24,src_dof_24)),_mm256_mul_pd(q_acc_2_25,src_dof_25)),_mm256_mul_pd(q_acc_2_26,src_dof_26)),_mm256_mul_pd(q_acc_2_27,src_dof_27)),_mm256_mul_pd(q_acc_2_28,src_dof_28)),_mm256_mul_pd(q_acc_2_29,src_dof_29)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_12,src_dof_12)),_mm256_mul_pd(q_acc_3_13,src_dof_13)),_mm256_mul_pd(q_acc_3_14,src_dof_14)),_mm256_mul_pd(q_acc_3_15,src_dof_15)),_mm256_mul_pd(q_acc_3_16,src_dof_16)),_mm256_mul_pd(q_acc_3_17,src_dof_17)),_mm256_mul_pd(q_acc_3_18,src_dof_18)),_mm256_mul_pd(q_acc_3_19,src_dof_19)),_mm256_mul_pd(q_acc_3_20,src_dof_20)),_mm256_mul_pd(q_acc_3_21,src_dof_21)),_mm256_mul_pd(q_acc_3_22,src_dof_22)),_mm256_mul_pd(q_acc_3_23,src_dof_23)),_mm256_mul_pd(q_acc_3_24,src_dof_24)),_mm256_mul_pd(q_acc_3_25,src_dof_25)),_mm256_mul_pd(q_acc_3_26,src_dof_26)),_mm256_mul_pd(q_acc_3_27,src_dof_27)),_mm256_mul_pd(q_acc_3_28,src_dof_28)),_mm256_mul_pd(q_acc_3_29,src_dof_29)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_12,src_dof_12)),_mm256_mul_pd(q_acc_4_13,src_dof_13)),_mm256_mul_pd(q_acc_4_14,src_dof_14)),_mm256_mul_pd(q_acc_4_15,src_dof_15)),_mm256_mul_pd(q_acc_4_16,src_dof_16)),_mm256_mul_pd(q_acc_4_17,src_dof_17)),_mm256_mul_pd(q_acc_4_18,src_dof_18)),_mm256_mul_pd(q_acc_4_19,src_dof_19)),_mm256_mul_pd(q_acc_4_20,src_dof_20)),_mm256_mul_pd(q_acc_4_21,src_dof_21)),_mm256_mul_pd(q_acc_4_22,src_dof_22)),_mm256_mul_pd(q_acc_4_23,src_dof_23)),_mm256_mul_pd(q_acc_4_24,src_dof_24)),_mm256_mul_pd(q_acc_4_25,src_dof_25)),_mm256_mul_pd(q_acc_4_26,src_dof_26)),_mm256_mul_pd(q_acc_4_27,src_dof_27)),_mm256_mul_pd(q_acc_4_28,src_dof_28)),_mm256_mul_pd(q_acc_4_29,src_dof_29)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_12,src_dof_12)),_mm256_mul_pd(q_acc_5_13,src_dof_13)),_mm256_mul_pd(q_acc_5_14,src_dof_14)),_mm256_mul_pd(q_acc_5_15,src_dof_15)),_mm256_mul_pd(q_acc_5_16,src_dof_16)),_mm256_mul_pd(q_acc_5_17,src_dof_17)),_mm256_mul_pd(q_acc_5_18,src_dof_18)),_mm256_mul_pd(q_acc_5_19,src_dof_19)),_mm256_mul_pd(q_acc_5_20,src_dof_20)),_mm256_mul_pd(q_acc_5_21,src_dof_21)),_mm256_mul_pd(q_acc_5_22,src_dof_22)),_mm256_mul_pd(q_acc_5_23,src_dof_23)),_mm256_mul_pd(q_acc_5_24,src_dof_24)),_mm256_mul_pd(q_acc_5_25,src_dof_25)),_mm256_mul_pd(q_acc_5_26,src_dof_26)),_mm256_mul_pd(q_acc_5_27,src_dof_27)),_mm256_mul_pd(q_acc_5_28,src_dof_28)),_mm256_mul_pd(q_acc_5_29,src_dof_29)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_12,src_dof_12)),_mm256_mul_pd(q_acc_6_13,src_dof_13)),_mm256_mul_pd(q_acc_6_14,src_dof_14)),_mm256_mul_pd(q_acc_6_15,src_dof_15)),_mm256_mul_pd(q_acc_6_16,src_dof_16)),_mm256_mul_pd(q_acc_6_17,src_dof_17)),_mm256_mul_pd(q_acc_6_18,src_dof_18)),_mm256_mul_pd(q_acc_6_19,src_dof_19)),_mm256_mul_pd(q_acc_6_20,src_dof_20)),_mm256_mul_pd(q_acc_6_21,src_dof_21)),_mm256_mul_pd(q_acc_6_22,src_dof_22)),_mm256_mul_pd(q_acc_6_23,src_dof_23)),_mm256_mul_pd(q_acc_6_24,src_dof_24)),_mm256_mul_pd(q_acc_6_25,src_dof_25)),_mm256_mul_pd(q_acc_6_26,src_dof_26)),_mm256_mul_pd(q_acc_6_27,src_dof_27)),_mm256_mul_pd(q_acc_6_28,src_dof_28)),_mm256_mul_pd(q_acc_6_29,src_dof_29)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_12,src_dof_12)),_mm256_mul_pd(q_acc_7_13,src_dof_13)),_mm256_mul_pd(q_acc_7_14,src_dof_14)),_mm256_mul_pd(q_acc_7_15,src_dof_15)),_mm256_mul_pd(q_acc_7_16,src_dof_16)),_mm256_mul_pd(q_acc_7_17,src_dof_17)),_mm256_mul_pd(q_acc_7_18,src_dof_18)),_mm256_mul_pd(q_acc_7_19,src_dof_19)),_mm256_mul_pd(q_acc_7_20,src_dof_20)),_mm256_mul_pd(q_acc_7_21,src_dof_21)),_mm256_mul_pd(q_acc_7_22,src_dof_22)),_mm256_mul_pd(q_acc_7_23,src_dof_23)),_mm256_mul_pd(q_acc_7_24,src_dof_24)),_mm256_mul_pd(q_acc_7_25,src_dof_25)),_mm256_mul_pd(q_acc_7_26,src_dof_26)),_mm256_mul_pd(q_acc_7_27,src_dof_27)),_mm256_mul_pd(q_acc_7_28,src_dof_28)),_mm256_mul_pd(q_acc_7_29,src_dof_29)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_12,src_dof_12)),_mm256_mul_pd(q_acc_8_13,src_dof_13)),_mm256_mul_pd(q_acc_8_14,src_dof_14)),_mm256_mul_pd(q_acc_8_15,src_dof_15)),_mm256_mul_pd(q_acc_8_16,src_dof_16)),_mm256_mul_pd(q_acc_8_17,src_dof_17)),_mm256_mul_pd(q_acc_8_18,src_dof_18)),_mm256_mul_pd(q_acc_8_19,src_dof_19)),_mm256_mul_pd(q_acc_8_20,src_dof_20)),_mm256_mul_pd(q_acc_8_21,src_dof_21)),_mm256_mul_pd(q_acc_8_22,src_dof_22)),_mm256_mul_pd(q_acc_8_23,src_dof_23)),_mm256_mul_pd(q_acc_8_24,src_dof_24)),_mm256_mul_pd(q_acc_8_25,src_dof_25)),_mm256_mul_pd(q_acc_8_26,src_dof_26)),_mm256_mul_pd(q_acc_8_27,src_dof_27)),_mm256_mul_pd(q_acc_8_28,src_dof_28)),_mm256_mul_pd(q_acc_8_29,src_dof_29)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_12,src_dof_12)),_mm256_mul_pd(q_acc_9_13,src_dof_13)),_mm256_mul_pd(q_acc_9_14,src_dof_14)),_mm256_mul_pd(q_acc_9_15,src_dof_15)),_mm256_mul_pd(q_acc_9_16,src_dof_16)),_mm256_mul_pd(q_acc_9_17,src_dof_17)),_mm256_mul_pd(q_acc_9_18,src_dof_18)),_mm256_mul_pd(q_acc_9_19,src_dof_19)),_mm256_mul_pd(q_acc_9_20,src_dof_20)),_mm256_mul_pd(q_acc_9_21,src_dof_21)),_mm256_mul_pd(q_acc_9_22,src_dof_22)),_mm256_mul_pd(q_acc_9_23,src_dof_23)),_mm256_mul_pd(q_acc_9_24,src_dof_24)),_mm256_mul_pd(q_acc_9_25,src_dof_25)),_mm256_mul_pd(q_acc_9_26,src_dof_26)),_mm256_mul_pd(q_acc_9_27,src_dof_27)),_mm256_mul_pd(q_acc_9_28,src_dof_28)),_mm256_mul_pd(q_acc_9_29,src_dof_29)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_10_12,src_dof_12)),_mm256_mul_pd(q_acc_10_13,src_dof_13)),_mm256_mul_pd(q_acc_10_14,src_dof_14)),_mm256_mul_pd(q_acc_10_15,src_dof_15)),_mm256_mul_pd(q_acc_10_16,src_dof_16)),_mm256_mul_pd(q_acc_10_17,src_dof_17)),_mm256_mul_pd(q_acc_10_18,src_dof_18)),_mm256_mul_pd(q_acc_10_19,src_dof_19)),_mm256_mul_pd(q_acc_10_20,src_dof_20)),_mm256_mul_pd(q_acc_10_21,src_dof_21)),_mm256_mul_pd(q_acc_10_22,src_dof_22)),_mm256_mul_pd(q_acc_10_23,src_dof_23)),_mm256_mul_pd(q_acc_10_24,src_dof_24)),_mm256_mul_pd(q_acc_10_25,src_dof_25)),_mm256_mul_pd(q_acc_10_26,src_dof_26)),_mm256_mul_pd(q_acc_10_27,src_dof_27)),_mm256_mul_pd(q_acc_10_28,src_dof_28)),_mm256_mul_pd(q_acc_10_29,src_dof_29)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_11_12,src_dof_12)),_mm256_mul_pd(q_acc_11_13,src_dof_13)),_mm256_mul_pd(q_acc_11_14,src_dof_14)),_mm256_mul_pd(q_acc_11_15,src_dof_15)),_mm256_mul_pd(q_acc_11_16,src_dof_16)),_mm256_mul_pd(q_acc_11_17,src_dof_17)),_mm256_mul_pd(q_acc_11_18,src_dof_18)),_mm256_mul_pd(q_acc_11_19,src_dof_19)),_mm256_mul_pd(q_acc_11_20,src_dof_20)),_mm256_mul_pd(q_acc_11_21,src_dof_21)),_mm256_mul_pd(q_acc_11_22,src_dof_22)),_mm256_mul_pd(q_acc_11_23,src_dof_23)),_mm256_mul_pd(q_acc_11_24,src_dof_24)),_mm256_mul_pd(q_acc_11_25,src_dof_25)),_mm256_mul_pd(q_acc_11_26,src_dof_26)),_mm256_mul_pd(q_acc_11_27,src_dof_27)),_mm256_mul_pd(q_acc_11_28,src_dof_28)),_mm256_mul_pd(q_acc_11_29,src_dof_29)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                const __m256d elMatVec_12 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_12,src_dof_0),_mm256_mul_pd(q_acc_10_12,src_dof_10)),_mm256_mul_pd(q_acc_11_12,src_dof_11)),_mm256_mul_pd(q_acc_12_12,src_dof_12)),_mm256_mul_pd(q_acc_12_13,src_dof_13)),_mm256_mul_pd(q_acc_12_14,src_dof_14)),_mm256_mul_pd(q_acc_12_15,src_dof_15)),_mm256_mul_pd(q_acc_12_16,src_dof_16)),_mm256_mul_pd(q_acc_12_17,src_dof_17)),_mm256_mul_pd(q_acc_12_18,src_dof_18)),_mm256_mul_pd(q_acc_12_19,src_dof_19)),_mm256_mul_pd(q_acc_12_20,src_dof_20)),_mm256_mul_pd(q_acc_12_21,src_dof_21)),_mm256_mul_pd(q_acc_12_22,src_dof_22)),_mm256_mul_pd(q_acc_12_23,src_dof_23)),_mm256_mul_pd(q_acc_12_24,src_dof_24)),_mm256_mul_pd(q_acc_12_25,src_dof_25)),_mm256_mul_pd(q_acc_12_26,src_dof_26)),_mm256_mul_pd(q_acc_12_27,src_dof_27)),_mm256_mul_pd(q_acc_12_28,src_dof_28)),_mm256_mul_pd(q_acc_12_29,src_dof_29)),_mm256_mul_pd(q_acc_1_12,src_dof_1)),_mm256_mul_pd(q_acc_2_12,src_dof_2)),_mm256_mul_pd(q_acc_3_12,src_dof_3)),_mm256_mul_pd(q_acc_4_12,src_dof_4)),_mm256_mul_pd(q_acc_5_12,src_dof_5)),_mm256_mul_pd(q_acc_6_12,src_dof_6)),_mm256_mul_pd(q_acc_7_12,src_dof_7)),_mm256_mul_pd(q_acc_8_12,src_dof_8)),_mm256_mul_pd(q_acc_9_12,src_dof_9));
                const __m256d elMatVec_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_13,src_dof_0),_mm256_mul_pd(q_acc_10_13,src_dof_10)),_mm256_mul_pd(q_acc_11_13,src_dof_11)),_mm256_mul_pd(q_acc_12_13,src_dof_12)),_mm256_mul_pd(q_acc_13_13,src_dof_13)),_mm256_mul_pd(q_acc_13_14,src_dof_14)),_mm256_mul_pd(q_acc_13_15,src_dof_15)),_mm256_mul_pd(q_acc_13_16,src_dof_16)),_mm256_mul_pd(q_acc_13_17,src_dof_17)),_mm256_mul_pd(q_acc_13_18,src_dof_18)),_mm256_mul_pd(q_acc_13_19,src_dof_19)),_mm256_mul_pd(q_acc_13_20,src_dof_20)),_mm256_mul_pd(q_acc_13_21,src_dof_21)),_mm256_mul_pd(q_acc_13_22,src_dof_22)),_mm256_mul_pd(q_acc_13_23,src_dof_23)),_mm256_mul_pd(q_acc_13_24,src_dof_24)),_mm256_mul_pd(q_acc_13_25,src_dof_25)),_mm256_mul_pd(q_acc_13_26,src_dof_26)),_mm256_mul_pd(q_acc_13_27,src_dof_27)),_mm256_mul_pd(q_acc_13_28,src_dof_28)),_mm256_mul_pd(q_acc_13_29,src_dof_29)),_mm256_mul_pd(q_acc_1_13,src_dof_1)),_mm256_mul_pd(q_acc_2_13,src_dof_2)),_mm256_mul_pd(q_acc_3_13,src_dof_3)),_mm256_mul_pd(q_acc_4_13,src_dof_4)),_mm256_mul_pd(q_acc_5_13,src_dof_5)),_mm256_mul_pd(q_acc_6_13,src_dof_6)),_mm256_mul_pd(q_acc_7_13,src_dof_7)),_mm256_mul_pd(q_acc_8_13,src_dof_8)),_mm256_mul_pd(q_acc_9_13,src_dof_9));
                const __m256d elMatVec_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_14,src_dof_0),_mm256_mul_pd(q_acc_10_14,src_dof_10)),_mm256_mul_pd(q_acc_11_14,src_dof_11)),_mm256_mul_pd(q_acc_12_14,src_dof_12)),_mm256_mul_pd(q_acc_13_14,src_dof_13)),_mm256_mul_pd(q_acc_14_14,src_dof_14)),_mm256_mul_pd(q_acc_14_15,src_dof_15)),_mm256_mul_pd(q_acc_14_16,src_dof_16)),_mm256_mul_pd(q_acc_14_17,src_dof_17)),_mm256_mul_pd(q_acc_14_18,src_dof_18)),_mm256_mul_pd(q_acc_14_19,src_dof_19)),_mm256_mul_pd(q_acc_14_20,src_dof_20)),_mm256_mul_pd(q_acc_14_21,src_dof_21)),_mm256_mul_pd(q_acc_14_22,src_dof_22)),_mm256_mul_pd(q_acc_14_23,src_dof_23)),_mm256_mul_pd(q_acc_14_24,src_dof_24)),_mm256_mul_pd(q_acc_14_25,src_dof_25)),_mm256_mul_pd(q_acc_14_26,src_dof_26)),_mm256_mul_pd(q_acc_14_27,src_dof_27)),_mm256_mul_pd(q_acc_14_28,src_dof_28)),_mm256_mul_pd(q_acc_14_29,src_dof_29)),_mm256_mul_pd(q_acc_1_14,src_dof_1)),_mm256_mul_pd(q_acc_2_14,src_dof_2)),_mm256_mul_pd(q_acc_3_14,src_dof_3)),_mm256_mul_pd(q_acc_4_14,src_dof_4)),_mm256_mul_pd(q_acc_5_14,src_dof_5)),_mm256_mul_pd(q_acc_6_14,src_dof_6)),_mm256_mul_pd(q_acc_7_14,src_dof_7)),_mm256_mul_pd(q_acc_8_14,src_dof_8)),_mm256_mul_pd(q_acc_9_14,src_dof_9));
                const __m256d elMatVec_15 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_15,src_dof_0),_mm256_mul_pd(q_acc_10_15,src_dof_10)),_mm256_mul_pd(q_acc_11_15,src_dof_11)),_mm256_mul_pd(q_acc_12_15,src_dof_12)),_mm256_mul_pd(q_acc_13_15,src_dof_13)),_mm256_mul_pd(q_acc_14_15,src_dof_14)),_mm256_mul_pd(q_acc_15_15,src_dof_15)),_mm256_mul_pd(q_acc_15_16,src_dof_16)),_mm256_mul_pd(q_acc_15_17,src_dof_17)),_mm256_mul_pd(q_acc_15_18,src_dof_18)),_mm256_mul_pd(q_acc_15_19,src_dof_19)),_mm256_mul_pd(q_acc_15_20,src_dof_20)),_mm256_mul_pd(q_acc_15_21,src_dof_21)),_mm256_mul_pd(q_acc_15_22,src_dof_22)),_mm256_mul_pd(q_acc_15_23,src_dof_23)),_mm256_mul_pd(q_acc_15_24,src_dof_24)),_mm256_mul_pd(q_acc_15_25,src_dof_25)),_mm256_mul_pd(q_acc_15_26,src_dof_26)),_mm256_mul_pd(q_acc_15_27,src_dof_27)),_mm256_mul_pd(q_acc_15_28,src_dof_28)),_mm256_mul_pd(q_acc_15_29,src_dof_29)),_mm256_mul_pd(q_acc_1_15,src_dof_1)),_mm256_mul_pd(q_acc_2_15,src_dof_2)),_mm256_mul_pd(q_acc_3_15,src_dof_3)),_mm256_mul_pd(q_acc_4_15,src_dof_4)),_mm256_mul_pd(q_acc_5_15,src_dof_5)),_mm256_mul_pd(q_acc_6_15,src_dof_6)),_mm256_mul_pd(q_acc_7_15,src_dof_7)),_mm256_mul_pd(q_acc_8_15,src_dof_8)),_mm256_mul_pd(q_acc_9_15,src_dof_9));
                const __m256d elMatVec_16 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_16,src_dof_0),_mm256_mul_pd(q_acc_10_16,src_dof_10)),_mm256_mul_pd(q_acc_11_16,src_dof_11)),_mm256_mul_pd(q_acc_12_16,src_dof_12)),_mm256_mul_pd(q_acc_13_16,src_dof_13)),_mm256_mul_pd(q_acc_14_16,src_dof_14)),_mm256_mul_pd(q_acc_15_16,src_dof_15)),_mm256_mul_pd(q_acc_16_16,src_dof_16)),_mm256_mul_pd(q_acc_16_17,src_dof_17)),_mm256_mul_pd(q_acc_16_18,src_dof_18)),_mm256_mul_pd(q_acc_16_19,src_dof_19)),_mm256_mul_pd(q_acc_16_20,src_dof_20)),_mm256_mul_pd(q_acc_16_21,src_dof_21)),_mm256_mul_pd(q_acc_16_22,src_dof_22)),_mm256_mul_pd(q_acc_16_23,src_dof_23)),_mm256_mul_pd(q_acc_16_24,src_dof_24)),_mm256_mul_pd(q_acc_16_25,src_dof_25)),_mm256_mul_pd(q_acc_16_26,src_dof_26)),_mm256_mul_pd(q_acc_16_27,src_dof_27)),_mm256_mul_pd(q_acc_16_28,src_dof_28)),_mm256_mul_pd(q_acc_16_29,src_dof_29)),_mm256_mul_pd(q_acc_1_16,src_dof_1)),_mm256_mul_pd(q_acc_2_16,src_dof_2)),_mm256_mul_pd(q_acc_3_16,src_dof_3)),_mm256_mul_pd(q_acc_4_16,src_dof_4)),_mm256_mul_pd(q_acc_5_16,src_dof_5)),_mm256_mul_pd(q_acc_6_16,src_dof_6)),_mm256_mul_pd(q_acc_7_16,src_dof_7)),_mm256_mul_pd(q_acc_8_16,src_dof_8)),_mm256_mul_pd(q_acc_9_16,src_dof_9));
                const __m256d elMatVec_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_17,src_dof_0),_mm256_mul_pd(q_acc_10_17,src_dof_10)),_mm256_mul_pd(q_acc_11_17,src_dof_11)),_mm256_mul_pd(q_acc_12_17,src_dof_12)),_mm256_mul_pd(q_acc_13_17,src_dof_13)),_mm256_mul_pd(q_acc_14_17,src_dof_14)),_mm256_mul_pd(q_acc_15_17,src_dof_15)),_mm256_mul_pd(q_acc_16_17,src_dof_16)),_mm256_mul_pd(q_acc_17_17,src_dof_17)),_mm256_mul_pd(q_acc_17_18,src_dof_18)),_mm256_mul_pd(q_acc_17_19,src_dof_19)),_mm256_mul_pd(q_acc_17_20,src_dof_20)),_mm256_mul_pd(q_acc_17_21,src_dof_21)),_mm256_mul_pd(q_acc_17_22,src_dof_22)),_mm256_mul_pd(q_acc_17_23,src_dof_23)),_mm256_mul_pd(q_acc_17_24,src_dof_24)),_mm256_mul_pd(q_acc_17_25,src_dof_25)),_mm256_mul_pd(q_acc_17_26,src_dof_26)),_mm256_mul_pd(q_acc_17_27,src_dof_27)),_mm256_mul_pd(q_acc_17_28,src_dof_28)),_mm256_mul_pd(q_acc_17_29,src_dof_29)),_mm256_mul_pd(q_acc_1_17,src_dof_1)),_mm256_mul_pd(q_acc_2_17,src_dof_2)),_mm256_mul_pd(q_acc_3_17,src_dof_3)),_mm256_mul_pd(q_acc_4_17,src_dof_4)),_mm256_mul_pd(q_acc_5_17,src_dof_5)),_mm256_mul_pd(q_acc_6_17,src_dof_6)),_mm256_mul_pd(q_acc_7_17,src_dof_7)),_mm256_mul_pd(q_acc_8_17,src_dof_8)),_mm256_mul_pd(q_acc_9_17,src_dof_9));
                const __m256d elMatVec_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_18,src_dof_0),_mm256_mul_pd(q_acc_10_18,src_dof_10)),_mm256_mul_pd(q_acc_11_18,src_dof_11)),_mm256_mul_pd(q_acc_12_18,src_dof_12)),_mm256_mul_pd(q_acc_13_18,src_dof_13)),_mm256_mul_pd(q_acc_14_18,src_dof_14)),_mm256_mul_pd(q_acc_15_18,src_dof_15)),_mm256_mul_pd(q_acc_16_18,src_dof_16)),_mm256_mul_pd(q_acc_17_18,src_dof_17)),_mm256_mul_pd(q_acc_18_18,src_dof_18)),_mm256_mul_pd(q_acc_18_19,src_dof_19)),_mm256_mul_pd(q_acc_18_20,src_dof_20)),_mm256_mul_pd(q_acc_18_21,src_dof_21)),_mm256_mul_pd(q_acc_18_22,src_dof_22)),_mm256_mul_pd(q_acc_18_23,src_dof_23)),_mm256_mul_pd(q_acc_18_24,src_dof_24)),_mm256_mul_pd(q_acc_18_25,src_dof_25)),_mm256_mul_pd(q_acc_18_26,src_dof_26)),_mm256_mul_pd(q_acc_18_27,src_dof_27)),_mm256_mul_pd(q_acc_18_28,src_dof_28)),_mm256_mul_pd(q_acc_18_29,src_dof_29)),_mm256_mul_pd(q_acc_1_18,src_dof_1)),_mm256_mul_pd(q_acc_2_18,src_dof_2)),_mm256_mul_pd(q_acc_3_18,src_dof_3)),_mm256_mul_pd(q_acc_4_18,src_dof_4)),_mm256_mul_pd(q_acc_5_18,src_dof_5)),_mm256_mul_pd(q_acc_6_18,src_dof_6)),_mm256_mul_pd(q_acc_7_18,src_dof_7)),_mm256_mul_pd(q_acc_8_18,src_dof_8)),_mm256_mul_pd(q_acc_9_18,src_dof_9));
                const __m256d elMatVec_19 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_19,src_dof_0),_mm256_mul_pd(q_acc_10_19,src_dof_10)),_mm256_mul_pd(q_acc_11_19,src_dof_11)),_mm256_mul_pd(q_acc_12_19,src_dof_12)),_mm256_mul_pd(q_acc_13_19,src_dof_13)),_mm256_mul_pd(q_acc_14_19,src_dof_14)),_mm256_mul_pd(q_acc_15_19,src_dof_15)),_mm256_mul_pd(q_acc_16_19,src_dof_16)),_mm256_mul_pd(q_acc_17_19,src_dof_17)),_mm256_mul_pd(q_acc_18_19,src_dof_18)),_mm256_mul_pd(q_acc_19_19,src_dof_19)),_mm256_mul_pd(q_acc_19_20,src_dof_20)),_mm256_mul_pd(q_acc_19_21,src_dof_21)),_mm256_mul_pd(q_acc_19_22,src_dof_22)),_mm256_mul_pd(q_acc_19_23,src_dof_23)),_mm256_mul_pd(q_acc_19_24,src_dof_24)),_mm256_mul_pd(q_acc_19_25,src_dof_25)),_mm256_mul_pd(q_acc_19_26,src_dof_26)),_mm256_mul_pd(q_acc_19_27,src_dof_27)),_mm256_mul_pd(q_acc_19_28,src_dof_28)),_mm256_mul_pd(q_acc_19_29,src_dof_29)),_mm256_mul_pd(q_acc_1_19,src_dof_1)),_mm256_mul_pd(q_acc_2_19,src_dof_2)),_mm256_mul_pd(q_acc_3_19,src_dof_3)),_mm256_mul_pd(q_acc_4_19,src_dof_4)),_mm256_mul_pd(q_acc_5_19,src_dof_5)),_mm256_mul_pd(q_acc_6_19,src_dof_6)),_mm256_mul_pd(q_acc_7_19,src_dof_7)),_mm256_mul_pd(q_acc_8_19,src_dof_8)),_mm256_mul_pd(q_acc_9_19,src_dof_9));
                const __m256d elMatVec_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_20,src_dof_0),_mm256_mul_pd(q_acc_10_20,src_dof_10)),_mm256_mul_pd(q_acc_11_20,src_dof_11)),_mm256_mul_pd(q_acc_12_20,src_dof_12)),_mm256_mul_pd(q_acc_13_20,src_dof_13)),_mm256_mul_pd(q_acc_14_20,src_dof_14)),_mm256_mul_pd(q_acc_15_20,src_dof_15)),_mm256_mul_pd(q_acc_16_20,src_dof_16)),_mm256_mul_pd(q_acc_17_20,src_dof_17)),_mm256_mul_pd(q_acc_18_20,src_dof_18)),_mm256_mul_pd(q_acc_19_20,src_dof_19)),_mm256_mul_pd(q_acc_1_20,src_dof_1)),_mm256_mul_pd(q_acc_20_20,src_dof_20)),_mm256_mul_pd(q_acc_20_21,src_dof_21)),_mm256_mul_pd(q_acc_20_22,src_dof_22)),_mm256_mul_pd(q_acc_20_23,src_dof_23)),_mm256_mul_pd(q_acc_20_24,src_dof_24)),_mm256_mul_pd(q_acc_20_25,src_dof_25)),_mm256_mul_pd(q_acc_20_26,src_dof_26)),_mm256_mul_pd(q_acc_20_27,src_dof_27)),_mm256_mul_pd(q_acc_20_28,src_dof_28)),_mm256_mul_pd(q_acc_20_29,src_dof_29)),_mm256_mul_pd(q_acc_2_20,src_dof_2)),_mm256_mul_pd(q_acc_3_20,src_dof_3)),_mm256_mul_pd(q_acc_4_20,src_dof_4)),_mm256_mul_pd(q_acc_5_20,src_dof_5)),_mm256_mul_pd(q_acc_6_20,src_dof_6)),_mm256_mul_pd(q_acc_7_20,src_dof_7)),_mm256_mul_pd(q_acc_8_20,src_dof_8)),_mm256_mul_pd(q_acc_9_20,src_dof_9));
                const __m256d elMatVec_21 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_21,src_dof_0),_mm256_mul_pd(q_acc_10_21,src_dof_10)),_mm256_mul_pd(q_acc_11_21,src_dof_11)),_mm256_mul_pd(q_acc_12_21,src_dof_12)),_mm256_mul_pd(q_acc_13_21,src_dof_13)),_mm256_mul_pd(q_acc_14_21,src_dof_14)),_mm256_mul_pd(q_acc_15_21,src_dof_15)),_mm256_mul_pd(q_acc_16_21,src_dof_16)),_mm256_mul_pd(q_acc_17_21,src_dof_17)),_mm256_mul_pd(q_acc_18_21,src_dof_18)),_mm256_mul_pd(q_acc_19_21,src_dof_19)),_mm256_mul_pd(q_acc_1_21,src_dof_1)),_mm256_mul_pd(q_acc_20_21,src_dof_20)),_mm256_mul_pd(q_acc_21_21,src_dof_21)),_mm256_mul_pd(q_acc_21_22,src_dof_22)),_mm256_mul_pd(q_acc_21_23,src_dof_23)),_mm256_mul_pd(q_acc_21_24,src_dof_24)),_mm256_mul_pd(q_acc_21_25,src_dof_25)),_mm256_mul_pd(q_acc_21_26,src_dof_26)),_mm256_mul_pd(q_acc_21_27,src_dof_27)),_mm256_mul_pd(q_acc_21_28,src_dof_28)),_mm256_mul_pd(q_acc_21_29,src_dof_29)),_mm256_mul_pd(q_acc_2_21,src_dof_2)),_mm256_mul_pd(q_acc_3_21,src_dof_3)),_mm256_mul_pd(q_acc_4_21,src_dof_4)),_mm256_mul_pd(q_acc_5_21,src_dof_5)),_mm256_mul_pd(q_acc_6_21,src_dof_6)),_mm256_mul_pd(q_acc_7_21,src_dof_7)),_mm256_mul_pd(q_acc_8_21,src_dof_8)),_mm256_mul_pd(q_acc_9_21,src_dof_9));
                const __m256d elMatVec_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_22,src_dof_0),_mm256_mul_pd(q_acc_10_22,src_dof_10)),_mm256_mul_pd(q_acc_11_22,src_dof_11)),_mm256_mul_pd(q_acc_12_22,src_dof_12)),_mm256_mul_pd(q_acc_13_22,src_dof_13)),_mm256_mul_pd(q_acc_14_22,src_dof_14)),_mm256_mul_pd(q_acc_15_22,src_dof_15)),_mm256_mul_pd(q_acc_16_22,src_dof_16)),_mm256_mul_pd(q_acc_17_22,src_dof_17)),_mm256_mul_pd(q_acc_18_22,src_dof_18)),_mm256_mul_pd(q_acc_19_22,src_dof_19)),_mm256_mul_pd(q_acc_1_22,src_dof_1)),_mm256_mul_pd(q_acc_20_22,src_dof_20)),_mm256_mul_pd(q_acc_21_22,src_dof_21)),_mm256_mul_pd(q_acc_22_22,src_dof_22)),_mm256_mul_pd(q_acc_22_23,src_dof_23)),_mm256_mul_pd(q_acc_22_24,src_dof_24)),_mm256_mul_pd(q_acc_22_25,src_dof_25)),_mm256_mul_pd(q_acc_22_26,src_dof_26)),_mm256_mul_pd(q_acc_22_27,src_dof_27)),_mm256_mul_pd(q_acc_22_28,src_dof_28)),_mm256_mul_pd(q_acc_22_29,src_dof_29)),_mm256_mul_pd(q_acc_2_22,src_dof_2)),_mm256_mul_pd(q_acc_3_22,src_dof_3)),_mm256_mul_pd(q_acc_4_22,src_dof_4)),_mm256_mul_pd(q_acc_5_22,src_dof_5)),_mm256_mul_pd(q_acc_6_22,src_dof_6)),_mm256_mul_pd(q_acc_7_22,src_dof_7)),_mm256_mul_pd(q_acc_8_22,src_dof_8)),_mm256_mul_pd(q_acc_9_22,src_dof_9));
                const __m256d elMatVec_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_23,src_dof_0),_mm256_mul_pd(q_acc_10_23,src_dof_10)),_mm256_mul_pd(q_acc_11_23,src_dof_11)),_mm256_mul_pd(q_acc_12_23,src_dof_12)),_mm256_mul_pd(q_acc_13_23,src_dof_13)),_mm256_mul_pd(q_acc_14_23,src_dof_14)),_mm256_mul_pd(q_acc_15_23,src_dof_15)),_mm256_mul_pd(q_acc_16_23,src_dof_16)),_mm256_mul_pd(q_acc_17_23,src_dof_17)),_mm256_mul_pd(q_acc_18_23,src_dof_18)),_mm256_mul_pd(q_acc_19_23,src_dof_19)),_mm256_mul_pd(q_acc_1_23,src_dof_1)),_mm256_mul_pd(q_acc_20_23,src_dof_20)),_mm256_mul_pd(q_acc_21_23,src_dof_21)),_mm256_mul_pd(q_acc_22_23,src_dof_22)),_mm256_mul_pd(q_acc_23_23,src_dof_23)),_mm256_mul_pd(q_acc_23_24,src_dof_24)),_mm256_mul_pd(q_acc_23_25,src_dof_25)),_mm256_mul_pd(q_acc_23_26,src_dof_26)),_mm256_mul_pd(q_acc_23_27,src_dof_27)),_mm256_mul_pd(q_acc_23_28,src_dof_28)),_mm256_mul_pd(q_acc_23_29,src_dof_29)),_mm256_mul_pd(q_acc_2_23,src_dof_2)),_mm256_mul_pd(q_acc_3_23,src_dof_3)),_mm256_mul_pd(q_acc_4_23,src_dof_4)),_mm256_mul_pd(q_acc_5_23,src_dof_5)),_mm256_mul_pd(q_acc_6_23,src_dof_6)),_mm256_mul_pd(q_acc_7_23,src_dof_7)),_mm256_mul_pd(q_acc_8_23,src_dof_8)),_mm256_mul_pd(q_acc_9_23,src_dof_9));
                const __m256d elMatVec_24 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_24,src_dof_0),_mm256_mul_pd(q_acc_10_24,src_dof_10)),_mm256_mul_pd(q_acc_11_24,src_dof_11)),_mm256_mul_pd(q_acc_12_24,src_dof_12)),_mm256_mul_pd(q_acc_13_24,src_dof_13)),_mm256_mul_pd(q_acc_14_24,src_dof_14)),_mm256_mul_pd(q_acc_15_24,src_dof_15)),_mm256_mul_pd(q_acc_16_24,src_dof_16)),_mm256_mul_pd(q_acc_17_24,src_dof_17)),_mm256_mul_pd(q_acc_18_24,src_dof_18)),_mm256_mul_pd(q_acc_19_24,src_dof_19)),_mm256_mul_pd(q_acc_1_24,src_dof_1)),_mm256_mul_pd(q_acc_20_24,src_dof_20)),_mm256_mul_pd(q_acc_21_24,src_dof_21)),_mm256_mul_pd(q_acc_22_24,src_dof_22)),_mm256_mul_pd(q_acc_23_24,src_dof_23)),_mm256_mul_pd(q_acc_24_24,src_dof_24)),_mm256_mul_pd(q_acc_24_25,src_dof_25)),_mm256_mul_pd(q_acc_24_26,src_dof_26)),_mm256_mul_pd(q_acc_24_27,src_dof_27)),_mm256_mul_pd(q_acc_24_28,src_dof_28)),_mm256_mul_pd(q_acc_24_29,src_dof_29)),_mm256_mul_pd(q_acc_2_24,src_dof_2)),_mm256_mul_pd(q_acc_3_24,src_dof_3)),_mm256_mul_pd(q_acc_4_24,src_dof_4)),_mm256_mul_pd(q_acc_5_24,src_dof_5)),_mm256_mul_pd(q_acc_6_24,src_dof_6)),_mm256_mul_pd(q_acc_7_24,src_dof_7)),_mm256_mul_pd(q_acc_8_24,src_dof_8)),_mm256_mul_pd(q_acc_9_24,src_dof_9));
                const __m256d elMatVec_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_25,src_dof_0),_mm256_mul_pd(q_acc_10_25,src_dof_10)),_mm256_mul_pd(q_acc_11_25,src_dof_11)),_mm256_mul_pd(q_acc_12_25,src_dof_12)),_mm256_mul_pd(q_acc_13_25,src_dof_13)),_mm256_mul_pd(q_acc_14_25,src_dof_14)),_mm256_mul_pd(q_acc_15_25,src_dof_15)),_mm256_mul_pd(q_acc_16_25,src_dof_16)),_mm256_mul_pd(q_acc_17_25,src_dof_17)),_mm256_mul_pd(q_acc_18_25,src_dof_18)),_mm256_mul_pd(q_acc_19_25,src_dof_19)),_mm256_mul_pd(q_acc_1_25,src_dof_1)),_mm256_mul_pd(q_acc_20_25,src_dof_20)),_mm256_mul_pd(q_acc_21_25,src_dof_21)),_mm256_mul_pd(q_acc_22_25,src_dof_22)),_mm256_mul_pd(q_acc_23_25,src_dof_23)),_mm256_mul_pd(q_acc_24_25,src_dof_24)),_mm256_mul_pd(q_acc_25_25,src_dof_25)),_mm256_mul_pd(q_acc_25_26,src_dof_26)),_mm256_mul_pd(q_acc_25_27,src_dof_27)),_mm256_mul_pd(q_acc_25_28,src_dof_28)),_mm256_mul_pd(q_acc_25_29,src_dof_29)),_mm256_mul_pd(q_acc_2_25,src_dof_2)),_mm256_mul_pd(q_acc_3_25,src_dof_3)),_mm256_mul_pd(q_acc_4_25,src_dof_4)),_mm256_mul_pd(q_acc_5_25,src_dof_5)),_mm256_mul_pd(q_acc_6_25,src_dof_6)),_mm256_mul_pd(q_acc_7_25,src_dof_7)),_mm256_mul_pd(q_acc_8_25,src_dof_8)),_mm256_mul_pd(q_acc_9_25,src_dof_9));
                const __m256d elMatVec_26 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_26,src_dof_0),_mm256_mul_pd(q_acc_10_26,src_dof_10)),_mm256_mul_pd(q_acc_11_26,src_dof_11)),_mm256_mul_pd(q_acc_12_26,src_dof_12)),_mm256_mul_pd(q_acc_13_26,src_dof_13)),_mm256_mul_pd(q_acc_14_26,src_dof_14)),_mm256_mul_pd(q_acc_15_26,src_dof_15)),_mm256_mul_pd(q_acc_16_26,src_dof_16)),_mm256_mul_pd(q_acc_17_26,src_dof_17)),_mm256_mul_pd(q_acc_18_26,src_dof_18)),_mm256_mul_pd(q_acc_19_26,src_dof_19)),_mm256_mul_pd(q_acc_1_26,src_dof_1)),_mm256_mul_pd(q_acc_20_26,src_dof_20)),_mm256_mul_pd(q_acc_21_26,src_dof_21)),_mm256_mul_pd(q_acc_22_26,src_dof_22)),_mm256_mul_pd(q_acc_23_26,src_dof_23)),_mm256_mul_pd(q_acc_24_26,src_dof_24)),_mm256_mul_pd(q_acc_25_26,src_dof_25)),_mm256_mul_pd(q_acc_26_26,src_dof_26)),_mm256_mul_pd(q_acc_26_27,src_dof_27)),_mm256_mul_pd(q_acc_26_28,src_dof_28)),_mm256_mul_pd(q_acc_26_29,src_dof_29)),_mm256_mul_pd(q_acc_2_26,src_dof_2)),_mm256_mul_pd(q_acc_3_26,src_dof_3)),_mm256_mul_pd(q_acc_4_26,src_dof_4)),_mm256_mul_pd(q_acc_5_26,src_dof_5)),_mm256_mul_pd(q_acc_6_26,src_dof_6)),_mm256_mul_pd(q_acc_7_26,src_dof_7)),_mm256_mul_pd(q_acc_8_26,src_dof_8)),_mm256_mul_pd(q_acc_9_26,src_dof_9));
                const __m256d elMatVec_27 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_27,src_dof_0),_mm256_mul_pd(q_acc_10_27,src_dof_10)),_mm256_mul_pd(q_acc_11_27,src_dof_11)),_mm256_mul_pd(q_acc_12_27,src_dof_12)),_mm256_mul_pd(q_acc_13_27,src_dof_13)),_mm256_mul_pd(q_acc_14_27,src_dof_14)),_mm256_mul_pd(q_acc_15_27,src_dof_15)),_mm256_mul_pd(q_acc_16_27,src_dof_16)),_mm256_mul_pd(q_acc_17_27,src_dof_17)),_mm256_mul_pd(q_acc_18_27,src_dof_18)),_mm256_mul_pd(q_acc_19_27,src_dof_19)),_mm256_mul_pd(q_acc_1_27,src_dof_1)),_mm256_mul_pd(q_acc_20_27,src_dof_20)),_mm256_mul_pd(q_acc_21_27,src_dof_21)),_mm256_mul_pd(q_acc_22_27,src_dof_22)),_mm256_mul_pd(q_acc_23_27,src_dof_23)),_mm256_mul_pd(q_acc_24_27,src_dof_24)),_mm256_mul_pd(q_acc_25_27,src_dof_25)),_mm256_mul_pd(q_acc_26_27,src_dof_26)),_mm256_mul_pd(q_acc_27_27,src_dof_27)),_mm256_mul_pd(q_acc_27_28,src_dof_28)),_mm256_mul_pd(q_acc_27_29,src_dof_29)),_mm256_mul_pd(q_acc_2_27,src_dof_2)),_mm256_mul_pd(q_acc_3_27,src_dof_3)),_mm256_mul_pd(q_acc_4_27,src_dof_4)),_mm256_mul_pd(q_acc_5_27,src_dof_5)),_mm256_mul_pd(q_acc_6_27,src_dof_6)),_mm256_mul_pd(q_acc_7_27,src_dof_7)),_mm256_mul_pd(q_acc_8_27,src_dof_8)),_mm256_mul_pd(q_acc_9_27,src_dof_9));
                const __m256d elMatVec_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_28,src_dof_0),_mm256_mul_pd(q_acc_10_28,src_dof_10)),_mm256_mul_pd(q_acc_11_28,src_dof_11)),_mm256_mul_pd(q_acc_12_28,src_dof_12)),_mm256_mul_pd(q_acc_13_28,src_dof_13)),_mm256_mul_pd(q_acc_14_28,src_dof_14)),_mm256_mul_pd(q_acc_15_28,src_dof_15)),_mm256_mul_pd(q_acc_16_28,src_dof_16)),_mm256_mul_pd(q_acc_17_28,src_dof_17)),_mm256_mul_pd(q_acc_18_28,src_dof_18)),_mm256_mul_pd(q_acc_19_28,src_dof_19)),_mm256_mul_pd(q_acc_1_28,src_dof_1)),_mm256_mul_pd(q_acc_20_28,src_dof_20)),_mm256_mul_pd(q_acc_21_28,src_dof_21)),_mm256_mul_pd(q_acc_22_28,src_dof_22)),_mm256_mul_pd(q_acc_23_28,src_dof_23)),_mm256_mul_pd(q_acc_24_28,src_dof_24)),_mm256_mul_pd(q_acc_25_28,src_dof_25)),_mm256_mul_pd(q_acc_26_28,src_dof_26)),_mm256_mul_pd(q_acc_27_28,src_dof_27)),_mm256_mul_pd(q_acc_28_28,src_dof_28)),_mm256_mul_pd(q_acc_28_29,src_dof_29)),_mm256_mul_pd(q_acc_2_28,src_dof_2)),_mm256_mul_pd(q_acc_3_28,src_dof_3)),_mm256_mul_pd(q_acc_4_28,src_dof_4)),_mm256_mul_pd(q_acc_5_28,src_dof_5)),_mm256_mul_pd(q_acc_6_28,src_dof_6)),_mm256_mul_pd(q_acc_7_28,src_dof_7)),_mm256_mul_pd(q_acc_8_28,src_dof_8)),_mm256_mul_pd(q_acc_9_28,src_dof_9));
                const __m256d elMatVec_29 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_29,src_dof_0),_mm256_mul_pd(q_acc_10_29,src_dof_10)),_mm256_mul_pd(q_acc_11_29,src_dof_11)),_mm256_mul_pd(q_acc_12_29,src_dof_12)),_mm256_mul_pd(q_acc_13_29,src_dof_13)),_mm256_mul_pd(q_acc_14_29,src_dof_14)),_mm256_mul_pd(q_acc_15_29,src_dof_15)),_mm256_mul_pd(q_acc_16_29,src_dof_16)),_mm256_mul_pd(q_acc_17_29,src_dof_17)),_mm256_mul_pd(q_acc_18_29,src_dof_18)),_mm256_mul_pd(q_acc_19_29,src_dof_19)),_mm256_mul_pd(q_acc_1_29,src_dof_1)),_mm256_mul_pd(q_acc_20_29,src_dof_20)),_mm256_mul_pd(q_acc_21_29,src_dof_21)),_mm256_mul_pd(q_acc_22_29,src_dof_22)),_mm256_mul_pd(q_acc_23_29,src_dof_23)),_mm256_mul_pd(q_acc_24_29,src_dof_24)),_mm256_mul_pd(q_acc_25_29,src_dof_25)),_mm256_mul_pd(q_acc_26_29,src_dof_26)),_mm256_mul_pd(q_acc_27_29,src_dof_27)),_mm256_mul_pd(q_acc_28_29,src_dof_28)),_mm256_mul_pd(q_acc_29_29,src_dof_29)),_mm256_mul_pd(q_acc_2_29,src_dof_2)),_mm256_mul_pd(q_acc_3_29,src_dof_3)),_mm256_mul_pd(q_acc_4_29,src_dof_4)),_mm256_mul_pd(q_acc_5_29,src_dof_5)),_mm256_mul_pd(q_acc_6_29,src_dof_6)),_mm256_mul_pd(q_acc_7_29,src_dof_7)),_mm256_mul_pd(q_acc_8_29,src_dof_8)),_mm256_mul_pd(q_acc_9_29,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_12,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_13,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_14,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_15,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_16,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_17,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_18,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_19,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_20,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_21,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_22,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_23,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_24,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_25,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_26,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_27,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_28,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_29,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_0_12 = 0.0;
                real_t q_acc_0_13 = 0.0;
                real_t q_acc_0_14 = 0.0;
                real_t q_acc_0_15 = 0.0;
                real_t q_acc_0_16 = 0.0;
                real_t q_acc_0_17 = 0.0;
                real_t q_acc_0_18 = 0.0;
                real_t q_acc_0_19 = 0.0;
                real_t q_acc_0_20 = 0.0;
                real_t q_acc_0_21 = 0.0;
                real_t q_acc_0_22 = 0.0;
                real_t q_acc_0_23 = 0.0;
                real_t q_acc_0_24 = 0.0;
                real_t q_acc_0_25 = 0.0;
                real_t q_acc_0_26 = 0.0;
                real_t q_acc_0_27 = 0.0;
                real_t q_acc_0_28 = 0.0;
                real_t q_acc_0_29 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_1_12 = 0.0;
                real_t q_acc_1_13 = 0.0;
                real_t q_acc_1_14 = 0.0;
                real_t q_acc_1_15 = 0.0;
                real_t q_acc_1_16 = 0.0;
                real_t q_acc_1_17 = 0.0;
                real_t q_acc_1_18 = 0.0;
                real_t q_acc_1_19 = 0.0;
                real_t q_acc_1_20 = 0.0;
                real_t q_acc_1_21 = 0.0;
                real_t q_acc_1_22 = 0.0;
                real_t q_acc_1_23 = 0.0;
                real_t q_acc_1_24 = 0.0;
                real_t q_acc_1_25 = 0.0;
                real_t q_acc_1_26 = 0.0;
                real_t q_acc_1_27 = 0.0;
                real_t q_acc_1_28 = 0.0;
                real_t q_acc_1_29 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_2_12 = 0.0;
                real_t q_acc_2_13 = 0.0;
                real_t q_acc_2_14 = 0.0;
                real_t q_acc_2_15 = 0.0;
                real_t q_acc_2_16 = 0.0;
                real_t q_acc_2_17 = 0.0;
                real_t q_acc_2_18 = 0.0;
                real_t q_acc_2_19 = 0.0;
                real_t q_acc_2_20 = 0.0;
                real_t q_acc_2_21 = 0.0;
                real_t q_acc_2_22 = 0.0;
                real_t q_acc_2_23 = 0.0;
                real_t q_acc_2_24 = 0.0;
                real_t q_acc_2_25 = 0.0;
                real_t q_acc_2_26 = 0.0;
                real_t q_acc_2_27 = 0.0;
                real_t q_acc_2_28 = 0.0;
                real_t q_acc_2_29 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_3_12 = 0.0;
                real_t q_acc_3_13 = 0.0;
                real_t q_acc_3_14 = 0.0;
                real_t q_acc_3_15 = 0.0;
                real_t q_acc_3_16 = 0.0;
                real_t q_acc_3_17 = 0.0;
                real_t q_acc_3_18 = 0.0;
                real_t q_acc_3_19 = 0.0;
                real_t q_acc_3_20 = 0.0;
                real_t q_acc_3_21 = 0.0;
                real_t q_acc_3_22 = 0.0;
                real_t q_acc_3_23 = 0.0;
                real_t q_acc_3_24 = 0.0;
                real_t q_acc_3_25 = 0.0;
                real_t q_acc_3_26 = 0.0;
                real_t q_acc_3_27 = 0.0;
                real_t q_acc_3_28 = 0.0;
                real_t q_acc_3_29 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_4_12 = 0.0;
                real_t q_acc_4_13 = 0.0;
                real_t q_acc_4_14 = 0.0;
                real_t q_acc_4_15 = 0.0;
                real_t q_acc_4_16 = 0.0;
                real_t q_acc_4_17 = 0.0;
                real_t q_acc_4_18 = 0.0;
                real_t q_acc_4_19 = 0.0;
                real_t q_acc_4_20 = 0.0;
                real_t q_acc_4_21 = 0.0;
                real_t q_acc_4_22 = 0.0;
                real_t q_acc_4_23 = 0.0;
                real_t q_acc_4_24 = 0.0;
                real_t q_acc_4_25 = 0.0;
                real_t q_acc_4_26 = 0.0;
                real_t q_acc_4_27 = 0.0;
                real_t q_acc_4_28 = 0.0;
                real_t q_acc_4_29 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_5_12 = 0.0;
                real_t q_acc_5_13 = 0.0;
                real_t q_acc_5_14 = 0.0;
                real_t q_acc_5_15 = 0.0;
                real_t q_acc_5_16 = 0.0;
                real_t q_acc_5_17 = 0.0;
                real_t q_acc_5_18 = 0.0;
                real_t q_acc_5_19 = 0.0;
                real_t q_acc_5_20 = 0.0;
                real_t q_acc_5_21 = 0.0;
                real_t q_acc_5_22 = 0.0;
                real_t q_acc_5_23 = 0.0;
                real_t q_acc_5_24 = 0.0;
                real_t q_acc_5_25 = 0.0;
                real_t q_acc_5_26 = 0.0;
                real_t q_acc_5_27 = 0.0;
                real_t q_acc_5_28 = 0.0;
                real_t q_acc_5_29 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_6_12 = 0.0;
                real_t q_acc_6_13 = 0.0;
                real_t q_acc_6_14 = 0.0;
                real_t q_acc_6_15 = 0.0;
                real_t q_acc_6_16 = 0.0;
                real_t q_acc_6_17 = 0.0;
                real_t q_acc_6_18 = 0.0;
                real_t q_acc_6_19 = 0.0;
                real_t q_acc_6_20 = 0.0;
                real_t q_acc_6_21 = 0.0;
                real_t q_acc_6_22 = 0.0;
                real_t q_acc_6_23 = 0.0;
                real_t q_acc_6_24 = 0.0;
                real_t q_acc_6_25 = 0.0;
                real_t q_acc_6_26 = 0.0;
                real_t q_acc_6_27 = 0.0;
                real_t q_acc_6_28 = 0.0;
                real_t q_acc_6_29 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_7_12 = 0.0;
                real_t q_acc_7_13 = 0.0;
                real_t q_acc_7_14 = 0.0;
                real_t q_acc_7_15 = 0.0;
                real_t q_acc_7_16 = 0.0;
                real_t q_acc_7_17 = 0.0;
                real_t q_acc_7_18 = 0.0;
                real_t q_acc_7_19 = 0.0;
                real_t q_acc_7_20 = 0.0;
                real_t q_acc_7_21 = 0.0;
                real_t q_acc_7_22 = 0.0;
                real_t q_acc_7_23 = 0.0;
                real_t q_acc_7_24 = 0.0;
                real_t q_acc_7_25 = 0.0;
                real_t q_acc_7_26 = 0.0;
                real_t q_acc_7_27 = 0.0;
                real_t q_acc_7_28 = 0.0;
                real_t q_acc_7_29 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_8_12 = 0.0;
                real_t q_acc_8_13 = 0.0;
                real_t q_acc_8_14 = 0.0;
                real_t q_acc_8_15 = 0.0;
                real_t q_acc_8_16 = 0.0;
                real_t q_acc_8_17 = 0.0;
                real_t q_acc_8_18 = 0.0;
                real_t q_acc_8_19 = 0.0;
                real_t q_acc_8_20 = 0.0;
                real_t q_acc_8_21 = 0.0;
                real_t q_acc_8_22 = 0.0;
                real_t q_acc_8_23 = 0.0;
                real_t q_acc_8_24 = 0.0;
                real_t q_acc_8_25 = 0.0;
                real_t q_acc_8_26 = 0.0;
                real_t q_acc_8_27 = 0.0;
                real_t q_acc_8_28 = 0.0;
                real_t q_acc_8_29 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_9_12 = 0.0;
                real_t q_acc_9_13 = 0.0;
                real_t q_acc_9_14 = 0.0;
                real_t q_acc_9_15 = 0.0;
                real_t q_acc_9_16 = 0.0;
                real_t q_acc_9_17 = 0.0;
                real_t q_acc_9_18 = 0.0;
                real_t q_acc_9_19 = 0.0;
                real_t q_acc_9_20 = 0.0;
                real_t q_acc_9_21 = 0.0;
                real_t q_acc_9_22 = 0.0;
                real_t q_acc_9_23 = 0.0;
                real_t q_acc_9_24 = 0.0;
                real_t q_acc_9_25 = 0.0;
                real_t q_acc_9_26 = 0.0;
                real_t q_acc_9_27 = 0.0;
                real_t q_acc_9_28 = 0.0;
                real_t q_acc_9_29 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_10_12 = 0.0;
                real_t q_acc_10_13 = 0.0;
                real_t q_acc_10_14 = 0.0;
                real_t q_acc_10_15 = 0.0;
                real_t q_acc_10_16 = 0.0;
                real_t q_acc_10_17 = 0.0;
                real_t q_acc_10_18 = 0.0;
                real_t q_acc_10_19 = 0.0;
                real_t q_acc_10_20 = 0.0;
                real_t q_acc_10_21 = 0.0;
                real_t q_acc_10_22 = 0.0;
                real_t q_acc_10_23 = 0.0;
                real_t q_acc_10_24 = 0.0;
                real_t q_acc_10_25 = 0.0;
                real_t q_acc_10_26 = 0.0;
                real_t q_acc_10_27 = 0.0;
                real_t q_acc_10_28 = 0.0;
                real_t q_acc_10_29 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_11_12 = 0.0;
                real_t q_acc_11_13 = 0.0;
                real_t q_acc_11_14 = 0.0;
                real_t q_acc_11_15 = 0.0;
                real_t q_acc_11_16 = 0.0;
                real_t q_acc_11_17 = 0.0;
                real_t q_acc_11_18 = 0.0;
                real_t q_acc_11_19 = 0.0;
                real_t q_acc_11_20 = 0.0;
                real_t q_acc_11_21 = 0.0;
                real_t q_acc_11_22 = 0.0;
                real_t q_acc_11_23 = 0.0;
                real_t q_acc_11_24 = 0.0;
                real_t q_acc_11_25 = 0.0;
                real_t q_acc_11_26 = 0.0;
                real_t q_acc_11_27 = 0.0;
                real_t q_acc_11_28 = 0.0;
                real_t q_acc_11_29 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_12_13 = 0.0;
                real_t q_acc_12_14 = 0.0;
                real_t q_acc_12_15 = 0.0;
                real_t q_acc_12_16 = 0.0;
                real_t q_acc_12_17 = 0.0;
                real_t q_acc_12_18 = 0.0;
                real_t q_acc_12_19 = 0.0;
                real_t q_acc_12_20 = 0.0;
                real_t q_acc_12_21 = 0.0;
                real_t q_acc_12_22 = 0.0;
                real_t q_acc_12_23 = 0.0;
                real_t q_acc_12_24 = 0.0;
                real_t q_acc_12_25 = 0.0;
                real_t q_acc_12_26 = 0.0;
                real_t q_acc_12_27 = 0.0;
                real_t q_acc_12_28 = 0.0;
                real_t q_acc_12_29 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_13_14 = 0.0;
                real_t q_acc_13_15 = 0.0;
                real_t q_acc_13_16 = 0.0;
                real_t q_acc_13_17 = 0.0;
                real_t q_acc_13_18 = 0.0;
                real_t q_acc_13_19 = 0.0;
                real_t q_acc_13_20 = 0.0;
                real_t q_acc_13_21 = 0.0;
                real_t q_acc_13_22 = 0.0;
                real_t q_acc_13_23 = 0.0;
                real_t q_acc_13_24 = 0.0;
                real_t q_acc_13_25 = 0.0;
                real_t q_acc_13_26 = 0.0;
                real_t q_acc_13_27 = 0.0;
                real_t q_acc_13_28 = 0.0;
                real_t q_acc_13_29 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_14_15 = 0.0;
                real_t q_acc_14_16 = 0.0;
                real_t q_acc_14_17 = 0.0;
                real_t q_acc_14_18 = 0.0;
                real_t q_acc_14_19 = 0.0;
                real_t q_acc_14_20 = 0.0;
                real_t q_acc_14_21 = 0.0;
                real_t q_acc_14_22 = 0.0;
                real_t q_acc_14_23 = 0.0;
                real_t q_acc_14_24 = 0.0;
                real_t q_acc_14_25 = 0.0;
                real_t q_acc_14_26 = 0.0;
                real_t q_acc_14_27 = 0.0;
                real_t q_acc_14_28 = 0.0;
                real_t q_acc_14_29 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_15_16 = 0.0;
                real_t q_acc_15_17 = 0.0;
                real_t q_acc_15_18 = 0.0;
                real_t q_acc_15_19 = 0.0;
                real_t q_acc_15_20 = 0.0;
                real_t q_acc_15_21 = 0.0;
                real_t q_acc_15_22 = 0.0;
                real_t q_acc_15_23 = 0.0;
                real_t q_acc_15_24 = 0.0;
                real_t q_acc_15_25 = 0.0;
                real_t q_acc_15_26 = 0.0;
                real_t q_acc_15_27 = 0.0;
                real_t q_acc_15_28 = 0.0;
                real_t q_acc_15_29 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_16_17 = 0.0;
                real_t q_acc_16_18 = 0.0;
                real_t q_acc_16_19 = 0.0;
                real_t q_acc_16_20 = 0.0;
                real_t q_acc_16_21 = 0.0;
                real_t q_acc_16_22 = 0.0;
                real_t q_acc_16_23 = 0.0;
                real_t q_acc_16_24 = 0.0;
                real_t q_acc_16_25 = 0.0;
                real_t q_acc_16_26 = 0.0;
                real_t q_acc_16_27 = 0.0;
                real_t q_acc_16_28 = 0.0;
                real_t q_acc_16_29 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_17_18 = 0.0;
                real_t q_acc_17_19 = 0.0;
                real_t q_acc_17_20 = 0.0;
                real_t q_acc_17_21 = 0.0;
                real_t q_acc_17_22 = 0.0;
                real_t q_acc_17_23 = 0.0;
                real_t q_acc_17_24 = 0.0;
                real_t q_acc_17_25 = 0.0;
                real_t q_acc_17_26 = 0.0;
                real_t q_acc_17_27 = 0.0;
                real_t q_acc_17_28 = 0.0;
                real_t q_acc_17_29 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_18_19 = 0.0;
                real_t q_acc_18_20 = 0.0;
                real_t q_acc_18_21 = 0.0;
                real_t q_acc_18_22 = 0.0;
                real_t q_acc_18_23 = 0.0;
                real_t q_acc_18_24 = 0.0;
                real_t q_acc_18_25 = 0.0;
                real_t q_acc_18_26 = 0.0;
                real_t q_acc_18_27 = 0.0;
                real_t q_acc_18_28 = 0.0;
                real_t q_acc_18_29 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_19_20 = 0.0;
                real_t q_acc_19_21 = 0.0;
                real_t q_acc_19_22 = 0.0;
                real_t q_acc_19_23 = 0.0;
                real_t q_acc_19_24 = 0.0;
                real_t q_acc_19_25 = 0.0;
                real_t q_acc_19_26 = 0.0;
                real_t q_acc_19_27 = 0.0;
                real_t q_acc_19_28 = 0.0;
                real_t q_acc_19_29 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_20_21 = 0.0;
                real_t q_acc_20_22 = 0.0;
                real_t q_acc_20_23 = 0.0;
                real_t q_acc_20_24 = 0.0;
                real_t q_acc_20_25 = 0.0;
                real_t q_acc_20_26 = 0.0;
                real_t q_acc_20_27 = 0.0;
                real_t q_acc_20_28 = 0.0;
                real_t q_acc_20_29 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_21_22 = 0.0;
                real_t q_acc_21_23 = 0.0;
                real_t q_acc_21_24 = 0.0;
                real_t q_acc_21_25 = 0.0;
                real_t q_acc_21_26 = 0.0;
                real_t q_acc_21_27 = 0.0;
                real_t q_acc_21_28 = 0.0;
                real_t q_acc_21_29 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_22_23 = 0.0;
                real_t q_acc_22_24 = 0.0;
                real_t q_acc_22_25 = 0.0;
                real_t q_acc_22_26 = 0.0;
                real_t q_acc_22_27 = 0.0;
                real_t q_acc_22_28 = 0.0;
                real_t q_acc_22_29 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_23_24 = 0.0;
                real_t q_acc_23_25 = 0.0;
                real_t q_acc_23_26 = 0.0;
                real_t q_acc_23_27 = 0.0;
                real_t q_acc_23_28 = 0.0;
                real_t q_acc_23_29 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_24_25 = 0.0;
                real_t q_acc_24_26 = 0.0;
                real_t q_acc_24_27 = 0.0;
                real_t q_acc_24_28 = 0.0;
                real_t q_acc_24_29 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_25_26 = 0.0;
                real_t q_acc_25_27 = 0.0;
                real_t q_acc_25_28 = 0.0;
                real_t q_acc_25_29 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_26_27 = 0.0;
                real_t q_acc_26_28 = 0.0;
                real_t q_acc_26_29 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_27_28 = 0.0;
                real_t q_acc_27_29 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_28_29 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_156 = (mu_dof_0*_data_phi_0_0_WHITE_UP[4*q] + mu_dof_1*_data_phi_0_0_WHITE_UP[4*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_UP[4*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_UP[4*q + 3])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_133 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_157 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4];
                   const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6];
                   const real_t tmp_qloop_222 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7];
                   const real_t tmp_qloop_235 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10];
                   const real_t tmp_qloop_277 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11];
                   const real_t tmp_qloop_283 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_323 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_337 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_365 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_379 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_407 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_421 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_436 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_453 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_468 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_483 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_498 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_513 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_528 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_543 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_558 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_573 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_121 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q];
                   const real_t tmp_qloop_144 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_162 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4];
                   const real_t tmp_qloop_201 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5];
                   const real_t tmp_qloop_214 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8];
                   const real_t tmp_qloop_253 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9];
                   const real_t tmp_qloop_266 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10];
                   const real_t tmp_qloop_274 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_286 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11];
                   const real_t tmp_qloop_305 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_319 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_361 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_389 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_403 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_444 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_459 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_474 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_489 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_504 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_519 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_534 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_549 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_564 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_579 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q];
                   const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 2];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 3];
                   const real_t tmp_qloop_192 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 4];
                   const real_t tmp_qloop_205 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 5];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 6];
                   const real_t tmp_qloop_231 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 7];
                   const real_t tmp_qloop_244 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 8];
                   const real_t tmp_qloop_257 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 9];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 10];
                   const real_t tmp_qloop_293 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[12*q + 11];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_314 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_328 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_342 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_356 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_370 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_398 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_412 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_431 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_449 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_464 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_479 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_494 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_509 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_524 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_539 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_554 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_569 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_125 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_158 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_184 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_223 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_236 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_278 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_284 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_324 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_338 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_366 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_380 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_408 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_422 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_437 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_454 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_469 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_484 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_499 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_514 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_529 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_544 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_559 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_574 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_145 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_163 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_176 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_202 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_215 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_254 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_267 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_275 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_287 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_306 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_320 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_362 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_390 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_404 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_445 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_460 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_475 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_490 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_505 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_520 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_535 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_550 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_565 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_580 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_193 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_206 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_232 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_245 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_258 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_294 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_315 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_329 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_343 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_357 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_371 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_399 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_413 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_432 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_450 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_465 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_480 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_495 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_510 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_525 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_540 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_555 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_570 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_120 = tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0;
                   const real_t tmp_qloop_126 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_127 = tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_126;
                   const real_t tmp_qloop_128 = tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_126*0.5;
                   const real_t tmp_qloop_135 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_136 = tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135;
                   const real_t tmp_qloop_137 = tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5;
                   const real_t tmp_qloop_159 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_161 = tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0;
                   const real_t tmp_qloop_172 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_174 = tmp_qloop_170*2.0 + tmp_qloop_171*2.0 + tmp_qloop_172*2.0;
                   const real_t tmp_qloop_185 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_187 = tmp_qloop_183*2.0 + tmp_qloop_184*2.0 + tmp_qloop_185*2.0;
                   const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_200 = tmp_qloop_196*2.0 + tmp_qloop_197*2.0 + tmp_qloop_198*2.0;
                   const real_t tmp_qloop_211 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_213 = tmp_qloop_209*2.0 + tmp_qloop_210*2.0 + tmp_qloop_211*2.0;
                   const real_t tmp_qloop_224 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_226 = tmp_qloop_222*2.0 + tmp_qloop_223*2.0 + tmp_qloop_224*2.0;
                   const real_t tmp_qloop_237 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_239 = tmp_qloop_235*2.0 + tmp_qloop_236*2.0 + tmp_qloop_237*2.0;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_252 = tmp_qloop_248*2.0 + tmp_qloop_249*2.0 + tmp_qloop_250*2.0;
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_265 = tmp_qloop_261*2.0 + tmp_qloop_262*2.0 + tmp_qloop_263*2.0;
                   const real_t tmp_qloop_279 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_280 = tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663 + tmp_qloop_279*0.66666666666666663;
                   const real_t tmp_qloop_285 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_291 = tmp_qloop_277*2.0 + tmp_qloop_278*2.0 + tmp_qloop_279*2.0;
                   const real_t tmp_qloop_292 = tmp_qloop_120*tmp_qloop_291;
                   const real_t tmp_qloop_311 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_325 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_339 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_367 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_381 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_409 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_438 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_455 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_470 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_485 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_500 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_515 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_530 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_545 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_560 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_575 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_585 = tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0;
                   const real_t tmp_qloop_589 = tmp_qloop_291*tmp_qloop_585;
                   const real_t tmp_qloop_596 = tmp_qloop_170*1.0 + tmp_qloop_171*1.0 + tmp_qloop_172*1.0;
                   const real_t tmp_qloop_599 = tmp_qloop_291*tmp_qloop_596;
                   const real_t tmp_qloop_605 = tmp_qloop_183*1.0 + tmp_qloop_184*1.0 + tmp_qloop_185*1.0;
                   const real_t tmp_qloop_608 = tmp_qloop_291*tmp_qloop_605;
                   const real_t tmp_qloop_614 = tmp_qloop_196*1.0 + tmp_qloop_197*1.0 + tmp_qloop_198*1.0;
                   const real_t tmp_qloop_617 = tmp_qloop_291*tmp_qloop_614;
                   const real_t tmp_qloop_623 = tmp_qloop_209*1.0 + tmp_qloop_210*1.0 + tmp_qloop_211*1.0;
                   const real_t tmp_qloop_626 = tmp_qloop_291*tmp_qloop_623;
                   const real_t tmp_qloop_632 = tmp_qloop_222*1.0 + tmp_qloop_223*1.0 + tmp_qloop_224*1.0;
                   const real_t tmp_qloop_635 = tmp_qloop_291*tmp_qloop_632;
                   const real_t tmp_qloop_641 = tmp_qloop_235*1.0 + tmp_qloop_236*1.0 + tmp_qloop_237*1.0;
                   const real_t tmp_qloop_644 = tmp_qloop_291*tmp_qloop_641;
                   const real_t tmp_qloop_650 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                   const real_t tmp_qloop_653 = tmp_qloop_291*tmp_qloop_650;
                   const real_t tmp_qloop_659 = tmp_qloop_261*1.0 + tmp_qloop_262*1.0 + tmp_qloop_263*1.0;
                   const real_t tmp_qloop_662 = tmp_qloop_291*tmp_qloop_659;
                   const real_t tmp_qloop_667 = tmp_qloop_277 + tmp_qloop_278 + tmp_qloop_279;
                   const real_t tmp_qloop_674 = tmp_qloop_291*(tmp_qloop_277*1.0 + tmp_qloop_278*1.0 + tmp_qloop_279*1.0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_116 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_123 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_129 = tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_128*2.0;
                   const real_t tmp_qloop_139 = tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0;
                   const real_t tmp_qloop_140 = tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0;
                   const real_t tmp_qloop_141 = tmp_qloop_139*tmp_qloop_140;
                   const real_t tmp_qloop_146 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_147 = tmp_qloop_144 + tmp_qloop_145 + tmp_qloop_146;
                   const real_t tmp_qloop_152 = tmp_qloop_144*0.5 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5;
                   const real_t tmp_qloop_164 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_165 = tmp_qloop_127 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_177 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_178 = tmp_qloop_127 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_191 = tmp_qloop_127 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_203 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_204 = tmp_qloop_127 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_216 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_217 = tmp_qloop_127 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_229 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_230 = tmp_qloop_127 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_243 = tmp_qloop_127 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_255 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_256 = tmp_qloop_127 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_268 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_269 = tmp_qloop_127 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_276 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_288 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_289 = tmp_qloop_286 + tmp_qloop_287 + tmp_qloop_288;
                   const real_t tmp_qloop_290 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_289;
                   const real_t tmp_qloop_299 = tmp_qloop_274*2.0 + tmp_qloop_275*2.0 + tmp_qloop_276*2.0;
                   const real_t tmp_qloop_307 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_312 = tmp_qloop_289 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311;
                   const real_t tmp_qloop_313 = tmp_qloop_305*2.0 + tmp_qloop_306*2.0 + tmp_qloop_307*2.0;
                   const real_t tmp_qloop_321 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_326 = tmp_qloop_289 + tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325;
                   const real_t tmp_qloop_327 = tmp_qloop_319*2.0 + tmp_qloop_320*2.0 + tmp_qloop_321*2.0;
                   const real_t tmp_qloop_335 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_340 = tmp_qloop_289 + tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339;
                   const real_t tmp_qloop_341 = tmp_qloop_333*2.0 + tmp_qloop_334*2.0 + tmp_qloop_335*2.0;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_354 = tmp_qloop_289 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353;
                   const real_t tmp_qloop_355 = tmp_qloop_347*2.0 + tmp_qloop_348*2.0 + tmp_qloop_349*2.0;
                   const real_t tmp_qloop_363 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_368 = tmp_qloop_289 + tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367;
                   const real_t tmp_qloop_369 = tmp_qloop_361*2.0 + tmp_qloop_362*2.0 + tmp_qloop_363*2.0;
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_382 = tmp_qloop_289 + tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381;
                   const real_t tmp_qloop_383 = tmp_qloop_375*2.0 + tmp_qloop_376*2.0 + tmp_qloop_377*2.0;
                   const real_t tmp_qloop_391 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_396 = tmp_qloop_289 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395;
                   const real_t tmp_qloop_397 = tmp_qloop_389*2.0 + tmp_qloop_390*2.0 + tmp_qloop_391*2.0;
                   const real_t tmp_qloop_405 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_410 = tmp_qloop_289 + tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409;
                   const real_t tmp_qloop_411 = tmp_qloop_403*2.0 + tmp_qloop_404*2.0 + tmp_qloop_405*2.0;
                   const real_t tmp_qloop_419 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_424 = tmp_qloop_289 + tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423;
                   const real_t tmp_qloop_425 = tmp_qloop_417*2.0 + tmp_qloop_418*2.0 + tmp_qloop_419*2.0;
                   const real_t tmp_qloop_434 = tmp_qloop_113 + tmp_qloop_280;
                   const real_t tmp_qloop_440 = tmp_qloop_127 + tmp_qloop_289;
                   const real_t tmp_qloop_441 = tmp_qloop_129*tmp_qloop_440 + tmp_qloop_141 + tmp_qloop_292;
                   const real_t tmp_qloop_446 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_461 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_476 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_491 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_506 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_521 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_536 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_551 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_566 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_581 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_586 = tmp_qloop_128*2.0 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_593 = tmp_qloop_440*tmp_qloop_586 + tmp_qloop_589;
                   const real_t tmp_qloop_594 = tmp_qloop_141 + tmp_qloop_593;
                   const real_t tmp_qloop_597 = tmp_qloop_128*2.0 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_602 = tmp_qloop_440*tmp_qloop_597 + tmp_qloop_599;
                   const real_t tmp_qloop_603 = tmp_qloop_141 + tmp_qloop_602;
                   const real_t tmp_qloop_606 = tmp_qloop_128*2.0 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_611 = tmp_qloop_440*tmp_qloop_606 + tmp_qloop_608;
                   const real_t tmp_qloop_612 = tmp_qloop_141 + tmp_qloop_611;
                   const real_t tmp_qloop_615 = tmp_qloop_128*2.0 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_620 = tmp_qloop_440*tmp_qloop_615 + tmp_qloop_617;
                   const real_t tmp_qloop_621 = tmp_qloop_141 + tmp_qloop_620;
                   const real_t tmp_qloop_624 = tmp_qloop_128*2.0 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_629 = tmp_qloop_440*tmp_qloop_624 + tmp_qloop_626;
                   const real_t tmp_qloop_630 = tmp_qloop_141 + tmp_qloop_629;
                   const real_t tmp_qloop_633 = tmp_qloop_128*2.0 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_638 = tmp_qloop_440*tmp_qloop_633 + tmp_qloop_635;
                   const real_t tmp_qloop_639 = tmp_qloop_141 + tmp_qloop_638;
                   const real_t tmp_qloop_642 = tmp_qloop_128*2.0 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_647 = tmp_qloop_440*tmp_qloop_642 + tmp_qloop_644;
                   const real_t tmp_qloop_648 = tmp_qloop_141 + tmp_qloop_647;
                   const real_t tmp_qloop_651 = tmp_qloop_128*2.0 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_656 = tmp_qloop_440*tmp_qloop_651 + tmp_qloop_653;
                   const real_t tmp_qloop_657 = tmp_qloop_141 + tmp_qloop_656;
                   const real_t tmp_qloop_660 = tmp_qloop_128*2.0 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_665 = tmp_qloop_440*tmp_qloop_660 + tmp_qloop_662;
                   const real_t tmp_qloop_666 = tmp_qloop_141 + tmp_qloop_665;
                   const real_t tmp_qloop_670 = tmp_qloop_274*1.0 + tmp_qloop_275*1.0 + tmp_qloop_276*1.0;
                   const real_t tmp_qloop_671 = tmp_qloop_286*0.5 + tmp_qloop_287*0.5 + tmp_qloop_288*0.5;
                   const real_t tmp_qloop_672 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_678 = tmp_qloop_140*tmp_qloop_670 + tmp_qloop_440*tmp_qloop_672 + tmp_qloop_674;
                   const real_t tmp_qloop_690 = tmp_qloop_305*1.0 + tmp_qloop_306*1.0 + tmp_qloop_307*1.0;
                   const real_t tmp_qloop_691 = tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_694 = tmp_qloop_140*tmp_qloop_690 + tmp_qloop_440*tmp_qloop_691;
                   const real_t tmp_qloop_695 = tmp_qloop_674 + tmp_qloop_694;
                   const real_t tmp_qloop_697 = tmp_qloop_319*1.0 + tmp_qloop_320*1.0 + tmp_qloop_321*1.0;
                   const real_t tmp_qloop_698 = tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_700 = tmp_qloop_140*tmp_qloop_697 + tmp_qloop_440*tmp_qloop_698;
                   const real_t tmp_qloop_701 = tmp_qloop_674 + tmp_qloop_700;
                   const real_t tmp_qloop_703 = tmp_qloop_333*1.0 + tmp_qloop_334*1.0 + tmp_qloop_335*1.0;
                   const real_t tmp_qloop_704 = tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_706 = tmp_qloop_140*tmp_qloop_703 + tmp_qloop_440*tmp_qloop_704;
                   const real_t tmp_qloop_707 = tmp_qloop_674 + tmp_qloop_706;
                   const real_t tmp_qloop_709 = tmp_qloop_347*1.0 + tmp_qloop_348*1.0 + tmp_qloop_349*1.0;
                   const real_t tmp_qloop_710 = tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_712 = tmp_qloop_140*tmp_qloop_709 + tmp_qloop_440*tmp_qloop_710;
                   const real_t tmp_qloop_713 = tmp_qloop_674 + tmp_qloop_712;
                   const real_t tmp_qloop_715 = tmp_qloop_361*1.0 + tmp_qloop_362*1.0 + tmp_qloop_363*1.0;
                   const real_t tmp_qloop_716 = tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_718 = tmp_qloop_140*tmp_qloop_715 + tmp_qloop_440*tmp_qloop_716;
                   const real_t tmp_qloop_719 = tmp_qloop_674 + tmp_qloop_718;
                   const real_t tmp_qloop_721 = tmp_qloop_375*1.0 + tmp_qloop_376*1.0 + tmp_qloop_377*1.0;
                   const real_t tmp_qloop_722 = tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_724 = tmp_qloop_140*tmp_qloop_721 + tmp_qloop_440*tmp_qloop_722;
                   const real_t tmp_qloop_725 = tmp_qloop_674 + tmp_qloop_724;
                   const real_t tmp_qloop_727 = tmp_qloop_389*1.0 + tmp_qloop_390*1.0 + tmp_qloop_391*1.0;
                   const real_t tmp_qloop_728 = tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_730 = tmp_qloop_140*tmp_qloop_727 + tmp_qloop_440*tmp_qloop_728;
                   const real_t tmp_qloop_731 = tmp_qloop_674 + tmp_qloop_730;
                   const real_t tmp_qloop_733 = tmp_qloop_403*1.0 + tmp_qloop_404*1.0 + tmp_qloop_405*1.0;
                   const real_t tmp_qloop_734 = tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_736 = tmp_qloop_140*tmp_qloop_733 + tmp_qloop_440*tmp_qloop_734;
                   const real_t tmp_qloop_737 = tmp_qloop_674 + tmp_qloop_736;
                   const real_t tmp_qloop_739 = tmp_qloop_417*1.0 + tmp_qloop_418*1.0 + tmp_qloop_419*1.0;
                   const real_t tmp_qloop_740 = tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_742 = tmp_qloop_140*tmp_qloop_739 + tmp_qloop_440*tmp_qloop_740;
                   const real_t tmp_qloop_743 = tmp_qloop_674 + tmp_qloop_742;
                   const real_t tmp_qloop_744 = tmp_qloop_116 + tmp_qloop_667;
                   const real_t tmp_qloop_749 = tmp_qloop_141 + tmp_qloop_440*(tmp_qloop_128 + tmp_qloop_671)*2.0 + tmp_qloop_674;
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_119 = tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_117);
                   const real_t tmp_qloop_132 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q];
                   const real_t tmp_qloop_138 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_137*2.0;
                   const real_t tmp_qloop_142 = tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0;
                   const real_t tmp_qloop_143 = tmp_qloop_142*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q];
                   const real_t tmp_qloop_151 = tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150;
                   const real_t tmp_qloop_153 = tmp_qloop_148*0.5 + tmp_qloop_149*0.5 + tmp_qloop_150*0.5;
                   const real_t tmp_qloop_154 = tmp_qloop_152*2.0 + tmp_qloop_153*2.0;
                   const real_t tmp_qloop_155 = tmp_qloop_141 + tmp_qloop_143 + tmp_qloop_154*(tmp_qloop_147 + tmp_qloop_151);
                   const real_t tmp_qloop_160 = tmp_qloop_114 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663;
                   const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_169 = tmp_qloop_136 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_173 = tmp_qloop_114 + tmp_qloop_170*0.66666666666666663 + tmp_qloop_171*0.66666666666666663 + tmp_qloop_172*0.66666666666666663;
                   const real_t tmp_qloop_181 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_182 = tmp_qloop_136 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_186 = tmp_qloop_114 + tmp_qloop_183*0.66666666666666663 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663;
                   const real_t tmp_qloop_194 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_195 = tmp_qloop_136 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_199 = tmp_qloop_114 + tmp_qloop_196*0.66666666666666663 + tmp_qloop_197*0.66666666666666663 + tmp_qloop_198*0.66666666666666663;
                   const real_t tmp_qloop_207 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_208 = tmp_qloop_136 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_212 = tmp_qloop_114 + tmp_qloop_209*0.66666666666666663 + tmp_qloop_210*0.66666666666666663 + tmp_qloop_211*0.66666666666666663;
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_221 = tmp_qloop_136 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_225 = tmp_qloop_114 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663 + tmp_qloop_224*0.66666666666666663;
                   const real_t tmp_qloop_233 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_234 = tmp_qloop_136 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_238 = tmp_qloop_114 + tmp_qloop_235*0.66666666666666663 + tmp_qloop_236*0.66666666666666663 + tmp_qloop_237*0.66666666666666663;
                   const real_t tmp_qloop_246 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_247 = tmp_qloop_136 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_251 = tmp_qloop_114 + tmp_qloop_248*0.66666666666666663 + tmp_qloop_249*0.66666666666666663 + tmp_qloop_250*0.66666666666666663;
                   const real_t tmp_qloop_259 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_260 = tmp_qloop_136 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_264 = tmp_qloop_114 + tmp_qloop_261*0.66666666666666663 + tmp_qloop_262*0.66666666666666663 + tmp_qloop_263*0.66666666666666663;
                   const real_t tmp_qloop_272 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_273 = tmp_qloop_136 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_281 = tmp_qloop_109 + tmp_qloop_280;
                   const real_t tmp_qloop_282 = tmp_qloop_274*0.66666666666666663 + tmp_qloop_275*0.66666666666666663 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_281;
                   const real_t tmp_qloop_295 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_296 = tmp_qloop_293 + tmp_qloop_294 + tmp_qloop_295;
                   const real_t tmp_qloop_297 = tmp_qloop_136 + tmp_qloop_296;
                   const real_t tmp_qloop_298 = tmp_qloop_138*tmp_qloop_297 + tmp_qloop_143 + tmp_qloop_292;
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_303 = tmp_qloop_147 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_304 = tmp_qloop_139*tmp_qloop_299 + tmp_qloop_154*tmp_qloop_303;
                   const real_t tmp_qloop_308 = tmp_qloop_281 + tmp_qloop_305*0.66666666666666663 + tmp_qloop_306*0.66666666666666663 + tmp_qloop_307*0.66666666666666663;
                   const real_t tmp_qloop_316 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_317 = tmp_qloop_147 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_318 = tmp_qloop_139*tmp_qloop_313 + tmp_qloop_154*tmp_qloop_317;
                   const real_t tmp_qloop_322 = tmp_qloop_281 + tmp_qloop_319*0.66666666666666663 + tmp_qloop_320*0.66666666666666663 + tmp_qloop_321*0.66666666666666663;
                   const real_t tmp_qloop_330 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_331 = tmp_qloop_147 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_332 = tmp_qloop_139*tmp_qloop_327 + tmp_qloop_154*tmp_qloop_331;
                   const real_t tmp_qloop_336 = tmp_qloop_281 + tmp_qloop_333*0.66666666666666663 + tmp_qloop_334*0.66666666666666663 + tmp_qloop_335*0.66666666666666663;
                   const real_t tmp_qloop_344 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_345 = tmp_qloop_147 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_346 = tmp_qloop_139*tmp_qloop_341 + tmp_qloop_154*tmp_qloop_345;
                   const real_t tmp_qloop_350 = tmp_qloop_281 + tmp_qloop_347*0.66666666666666663 + tmp_qloop_348*0.66666666666666663 + tmp_qloop_349*0.66666666666666663;
                   const real_t tmp_qloop_358 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_359 = tmp_qloop_147 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_360 = tmp_qloop_139*tmp_qloop_355 + tmp_qloop_154*tmp_qloop_359;
                   const real_t tmp_qloop_364 = tmp_qloop_281 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663 + tmp_qloop_363*0.66666666666666663;
                   const real_t tmp_qloop_372 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_373 = tmp_qloop_147 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_374 = tmp_qloop_139*tmp_qloop_369 + tmp_qloop_154*tmp_qloop_373;
                   const real_t tmp_qloop_378 = tmp_qloop_281 + tmp_qloop_375*0.66666666666666663 + tmp_qloop_376*0.66666666666666663 + tmp_qloop_377*0.66666666666666663;
                   const real_t tmp_qloop_386 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_387 = tmp_qloop_147 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_388 = tmp_qloop_139*tmp_qloop_383 + tmp_qloop_154*tmp_qloop_387;
                   const real_t tmp_qloop_392 = tmp_qloop_281 + tmp_qloop_389*0.66666666666666663 + tmp_qloop_390*0.66666666666666663 + tmp_qloop_391*0.66666666666666663;
                   const real_t tmp_qloop_400 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_401 = tmp_qloop_147 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_402 = tmp_qloop_139*tmp_qloop_397 + tmp_qloop_154*tmp_qloop_401;
                   const real_t tmp_qloop_406 = tmp_qloop_281 + tmp_qloop_403*0.66666666666666663 + tmp_qloop_404*0.66666666666666663 + tmp_qloop_405*0.66666666666666663;
                   const real_t tmp_qloop_414 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_415 = tmp_qloop_147 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_416 = tmp_qloop_139*tmp_qloop_411 + tmp_qloop_154*tmp_qloop_415;
                   const real_t tmp_qloop_420 = tmp_qloop_281 + tmp_qloop_417*0.66666666666666663 + tmp_qloop_418*0.66666666666666663 + tmp_qloop_419*0.66666666666666663;
                   const real_t tmp_qloop_428 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_429 = tmp_qloop_147 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_430 = tmp_qloop_139*tmp_qloop_425 + tmp_qloop_154*tmp_qloop_429;
                   const real_t tmp_qloop_433 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 1];
                   const real_t tmp_qloop_435 = tmp_qloop_431*0.66666666666666663 + tmp_qloop_432*0.66666666666666663 + tmp_qloop_433*0.66666666666666663 + tmp_qloop_434;
                   const real_t tmp_qloop_439 = tmp_qloop_296 + tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438;
                   const real_t tmp_qloop_442 = tmp_qloop_431*2.0 + tmp_qloop_432*2.0 + tmp_qloop_433*2.0;
                   const real_t tmp_qloop_443 = tmp_qloop_142*tmp_qloop_442;
                   const real_t tmp_qloop_447 = tmp_qloop_151 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_448 = tmp_qloop_154*tmp_qloop_447 + tmp_qloop_443;
                   const real_t tmp_qloop_451 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 2];
                   const real_t tmp_qloop_452 = tmp_qloop_434 + tmp_qloop_449*0.66666666666666663 + tmp_qloop_450*0.66666666666666663 + tmp_qloop_451*0.66666666666666663;
                   const real_t tmp_qloop_456 = tmp_qloop_296 + tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455;
                   const real_t tmp_qloop_457 = tmp_qloop_449*2.0 + tmp_qloop_450*2.0 + tmp_qloop_451*2.0;
                   const real_t tmp_qloop_458 = tmp_qloop_142*tmp_qloop_457;
                   const real_t tmp_qloop_462 = tmp_qloop_151 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_463 = tmp_qloop_154*tmp_qloop_462 + tmp_qloop_458;
                   const real_t tmp_qloop_466 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 3];
                   const real_t tmp_qloop_467 = tmp_qloop_434 + tmp_qloop_464*0.66666666666666663 + tmp_qloop_465*0.66666666666666663 + tmp_qloop_466*0.66666666666666663;
                   const real_t tmp_qloop_471 = tmp_qloop_296 + tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470;
                   const real_t tmp_qloop_472 = tmp_qloop_464*2.0 + tmp_qloop_465*2.0 + tmp_qloop_466*2.0;
                   const real_t tmp_qloop_473 = tmp_qloop_142*tmp_qloop_472;
                   const real_t tmp_qloop_477 = tmp_qloop_151 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_478 = tmp_qloop_154*tmp_qloop_477 + tmp_qloop_473;
                   const real_t tmp_qloop_481 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 4];
                   const real_t tmp_qloop_482 = tmp_qloop_434 + tmp_qloop_479*0.66666666666666663 + tmp_qloop_480*0.66666666666666663 + tmp_qloop_481*0.66666666666666663;
                   const real_t tmp_qloop_486 = tmp_qloop_296 + tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485;
                   const real_t tmp_qloop_487 = tmp_qloop_479*2.0 + tmp_qloop_480*2.0 + tmp_qloop_481*2.0;
                   const real_t tmp_qloop_488 = tmp_qloop_142*tmp_qloop_487;
                   const real_t tmp_qloop_492 = tmp_qloop_151 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_493 = tmp_qloop_154*tmp_qloop_492 + tmp_qloop_488;
                   const real_t tmp_qloop_496 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 5];
                   const real_t tmp_qloop_497 = tmp_qloop_434 + tmp_qloop_494*0.66666666666666663 + tmp_qloop_495*0.66666666666666663 + tmp_qloop_496*0.66666666666666663;
                   const real_t tmp_qloop_501 = tmp_qloop_296 + tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500;
                   const real_t tmp_qloop_502 = tmp_qloop_494*2.0 + tmp_qloop_495*2.0 + tmp_qloop_496*2.0;
                   const real_t tmp_qloop_503 = tmp_qloop_142*tmp_qloop_502;
                   const real_t tmp_qloop_507 = tmp_qloop_151 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_508 = tmp_qloop_154*tmp_qloop_507 + tmp_qloop_503;
                   const real_t tmp_qloop_511 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 6];
                   const real_t tmp_qloop_512 = tmp_qloop_434 + tmp_qloop_509*0.66666666666666663 + tmp_qloop_510*0.66666666666666663 + tmp_qloop_511*0.66666666666666663;
                   const real_t tmp_qloop_516 = tmp_qloop_296 + tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515;
                   const real_t tmp_qloop_517 = tmp_qloop_509*2.0 + tmp_qloop_510*2.0 + tmp_qloop_511*2.0;
                   const real_t tmp_qloop_518 = tmp_qloop_142*tmp_qloop_517;
                   const real_t tmp_qloop_522 = tmp_qloop_151 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_523 = tmp_qloop_154*tmp_qloop_522 + tmp_qloop_518;
                   const real_t tmp_qloop_526 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 7];
                   const real_t tmp_qloop_527 = tmp_qloop_434 + tmp_qloop_524*0.66666666666666663 + tmp_qloop_525*0.66666666666666663 + tmp_qloop_526*0.66666666666666663;
                   const real_t tmp_qloop_531 = tmp_qloop_296 + tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530;
                   const real_t tmp_qloop_532 = tmp_qloop_524*2.0 + tmp_qloop_525*2.0 + tmp_qloop_526*2.0;
                   const real_t tmp_qloop_533 = tmp_qloop_142*tmp_qloop_532;
                   const real_t tmp_qloop_537 = tmp_qloop_151 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_538 = tmp_qloop_154*tmp_qloop_537 + tmp_qloop_533;
                   const real_t tmp_qloop_541 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 8];
                   const real_t tmp_qloop_542 = tmp_qloop_434 + tmp_qloop_539*0.66666666666666663 + tmp_qloop_540*0.66666666666666663 + tmp_qloop_541*0.66666666666666663;
                   const real_t tmp_qloop_546 = tmp_qloop_296 + tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545;
                   const real_t tmp_qloop_547 = tmp_qloop_539*2.0 + tmp_qloop_540*2.0 + tmp_qloop_541*2.0;
                   const real_t tmp_qloop_548 = tmp_qloop_142*tmp_qloop_547;
                   const real_t tmp_qloop_552 = tmp_qloop_151 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_553 = tmp_qloop_154*tmp_qloop_552 + tmp_qloop_548;
                   const real_t tmp_qloop_556 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 9];
                   const real_t tmp_qloop_557 = tmp_qloop_434 + tmp_qloop_554*0.66666666666666663 + tmp_qloop_555*0.66666666666666663 + tmp_qloop_556*0.66666666666666663;
                   const real_t tmp_qloop_561 = tmp_qloop_296 + tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560;
                   const real_t tmp_qloop_562 = tmp_qloop_554*2.0 + tmp_qloop_555*2.0 + tmp_qloop_556*2.0;
                   const real_t tmp_qloop_563 = tmp_qloop_142*tmp_qloop_562;
                   const real_t tmp_qloop_567 = tmp_qloop_151 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t tmp_qloop_568 = tmp_qloop_154*tmp_qloop_567 + tmp_qloop_563;
                   const real_t tmp_qloop_571 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[11*q + 10];
                   const real_t tmp_qloop_572 = tmp_qloop_434 + tmp_qloop_569*0.66666666666666663 + tmp_qloop_570*0.66666666666666663 + tmp_qloop_571*0.66666666666666663;
                   const real_t tmp_qloop_576 = tmp_qloop_296 + tmp_qloop_573 + tmp_qloop_574 + tmp_qloop_575;
                   const real_t tmp_qloop_577 = tmp_qloop_569*2.0 + tmp_qloop_570*2.0 + tmp_qloop_571*2.0;
                   const real_t tmp_qloop_578 = tmp_qloop_142*tmp_qloop_577;
                   const real_t tmp_qloop_582 = tmp_qloop_151 + tmp_qloop_579 + tmp_qloop_580 + tmp_qloop_581;
                   const real_t tmp_qloop_583 = tmp_qloop_154*tmp_qloop_582 + tmp_qloop_578;
                   const real_t tmp_qloop_584 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159);
                   const real_t tmp_qloop_587 = tmp_qloop_137*2.0 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_588 = tmp_qloop_143 + tmp_qloop_304;
                   const real_t tmp_qloop_590 = tmp_qloop_297*tmp_qloop_587 + tmp_qloop_589;
                   const real_t tmp_qloop_591 = tmp_qloop_143 + tmp_qloop_590;
                   const real_t tmp_qloop_592 = tmp_qloop_141 + tmp_qloop_448;
                   const real_t tmp_qloop_595 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172);
                   const real_t tmp_qloop_598 = tmp_qloop_137*2.0 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_600 = tmp_qloop_297*tmp_qloop_598 + tmp_qloop_599;
                   const real_t tmp_qloop_601 = tmp_qloop_143 + tmp_qloop_600;
                   const real_t tmp_qloop_604 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_183 + tmp_qloop_184 + tmp_qloop_185);
                   const real_t tmp_qloop_607 = tmp_qloop_137*2.0 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_609 = tmp_qloop_297*tmp_qloop_607 + tmp_qloop_608;
                   const real_t tmp_qloop_610 = tmp_qloop_143 + tmp_qloop_609;
                   const real_t tmp_qloop_613 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198);
                   const real_t tmp_qloop_616 = tmp_qloop_137*2.0 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_618 = tmp_qloop_297*tmp_qloop_616 + tmp_qloop_617;
                   const real_t tmp_qloop_619 = tmp_qloop_143 + tmp_qloop_618;
                   const real_t tmp_qloop_622 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211);
                   const real_t tmp_qloop_625 = tmp_qloop_137*2.0 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_627 = tmp_qloop_297*tmp_qloop_625 + tmp_qloop_626;
                   const real_t tmp_qloop_628 = tmp_qloop_143 + tmp_qloop_627;
                   const real_t tmp_qloop_631 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_222 + tmp_qloop_223 + tmp_qloop_224);
                   const real_t tmp_qloop_634 = tmp_qloop_137*2.0 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_636 = tmp_qloop_297*tmp_qloop_634 + tmp_qloop_635;
                   const real_t tmp_qloop_637 = tmp_qloop_143 + tmp_qloop_636;
                   const real_t tmp_qloop_640 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_235 + tmp_qloop_236 + tmp_qloop_237);
                   const real_t tmp_qloop_643 = tmp_qloop_137*2.0 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_645 = tmp_qloop_297*tmp_qloop_643 + tmp_qloop_644;
                   const real_t tmp_qloop_646 = tmp_qloop_143 + tmp_qloop_645;
                   const real_t tmp_qloop_649 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250);
                   const real_t tmp_qloop_652 = tmp_qloop_137*2.0 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_654 = tmp_qloop_297*tmp_qloop_652 + tmp_qloop_653;
                   const real_t tmp_qloop_655 = tmp_qloop_143 + tmp_qloop_654;
                   const real_t tmp_qloop_658 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263);
                   const real_t tmp_qloop_661 = tmp_qloop_137*2.0 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_663 = tmp_qloop_297*tmp_qloop_661 + tmp_qloop_662;
                   const real_t tmp_qloop_664 = tmp_qloop_143 + tmp_qloop_663;
                   const real_t tmp_qloop_668 = tmp_qloop_115 + tmp_qloop_667;
                   const real_t tmp_qloop_669 = tmp_qloop_118*(tmp_qloop_274 + tmp_qloop_275 + tmp_qloop_276 + tmp_qloop_668);
                   const real_t tmp_qloop_673 = tmp_qloop_152*2.0 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_675 = tmp_qloop_293*0.5 + tmp_qloop_294*0.5 + tmp_qloop_295*0.5;
                   const real_t tmp_qloop_676 = tmp_qloop_137*2.0 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_677 = tmp_qloop_143 + tmp_qloop_297*tmp_qloop_676 + tmp_qloop_674;
                   const real_t tmp_qloop_679 = tmp_qloop_439*tmp_qloop_676 + tmp_qloop_443;
                   const real_t tmp_qloop_680 = tmp_qloop_456*tmp_qloop_676 + tmp_qloop_458;
                   const real_t tmp_qloop_681 = tmp_qloop_471*tmp_qloop_676 + tmp_qloop_473;
                   const real_t tmp_qloop_682 = tmp_qloop_486*tmp_qloop_676 + tmp_qloop_488;
                   const real_t tmp_qloop_683 = tmp_qloop_501*tmp_qloop_676 + tmp_qloop_503;
                   const real_t tmp_qloop_684 = tmp_qloop_516*tmp_qloop_676 + tmp_qloop_518;
                   const real_t tmp_qloop_685 = tmp_qloop_531*tmp_qloop_676 + tmp_qloop_533;
                   const real_t tmp_qloop_686 = tmp_qloop_546*tmp_qloop_676 + tmp_qloop_548;
                   const real_t tmp_qloop_687 = tmp_qloop_561*tmp_qloop_676 + tmp_qloop_563;
                   const real_t tmp_qloop_688 = tmp_qloop_576*tmp_qloop_676 + tmp_qloop_578;
                   const real_t tmp_qloop_689 = tmp_qloop_118*(tmp_qloop_305 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_668);
                   const real_t tmp_qloop_692 = tmp_qloop_152*2.0 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_693 = tmp_qloop_674 + tmp_qloop_679;
                   const real_t tmp_qloop_696 = tmp_qloop_118*(tmp_qloop_319 + tmp_qloop_320 + tmp_qloop_321 + tmp_qloop_668);
                   const real_t tmp_qloop_699 = tmp_qloop_152*2.0 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_702 = tmp_qloop_118*(tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335 + tmp_qloop_668);
                   const real_t tmp_qloop_705 = tmp_qloop_152*2.0 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_708 = tmp_qloop_118*(tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349 + tmp_qloop_668);
                   const real_t tmp_qloop_711 = tmp_qloop_152*2.0 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_714 = tmp_qloop_118*(tmp_qloop_361 + tmp_qloop_362 + tmp_qloop_363 + tmp_qloop_668);
                   const real_t tmp_qloop_717 = tmp_qloop_152*2.0 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_720 = tmp_qloop_118*(tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377 + tmp_qloop_668);
                   const real_t tmp_qloop_723 = tmp_qloop_152*2.0 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_726 = tmp_qloop_118*(tmp_qloop_389 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_668);
                   const real_t tmp_qloop_729 = tmp_qloop_152*2.0 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_732 = tmp_qloop_118*(tmp_qloop_403 + tmp_qloop_404 + tmp_qloop_405 + tmp_qloop_668);
                   const real_t tmp_qloop_735 = tmp_qloop_152*2.0 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_738 = tmp_qloop_118*(tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419 + tmp_qloop_668);
                   const real_t tmp_qloop_741 = tmp_qloop_152*2.0 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_745 = tmp_qloop_118*(tmp_qloop_431 + tmp_qloop_432 + tmp_qloop_433 + tmp_qloop_744);
                   const real_t tmp_qloop_746 = tmp_qloop_431*1.0 + tmp_qloop_432*1.0 + tmp_qloop_433*1.0;
                   const real_t tmp_qloop_747 = tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_748 = tmp_qloop_153*2.0 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_750 = tmp_qloop_118*(tmp_qloop_449 + tmp_qloop_450 + tmp_qloop_451 + tmp_qloop_744);
                   const real_t tmp_qloop_751 = tmp_qloop_449*1.0 + tmp_qloop_450*1.0 + tmp_qloop_451*1.0;
                   const real_t tmp_qloop_752 = tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_753 = tmp_qloop_153*2.0 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_754 = tmp_qloop_118*(tmp_qloop_464 + tmp_qloop_465 + tmp_qloop_466 + tmp_qloop_744);
                   const real_t tmp_qloop_755 = tmp_qloop_464*1.0 + tmp_qloop_465*1.0 + tmp_qloop_466*1.0;
                   const real_t tmp_qloop_756 = tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_757 = tmp_qloop_153*2.0 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_758 = tmp_qloop_118*(tmp_qloop_479 + tmp_qloop_480 + tmp_qloop_481 + tmp_qloop_744);
                   const real_t tmp_qloop_759 = tmp_qloop_479*1.0 + tmp_qloop_480*1.0 + tmp_qloop_481*1.0;
                   const real_t tmp_qloop_760 = tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_761 = tmp_qloop_153*2.0 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_762 = tmp_qloop_118*(tmp_qloop_494 + tmp_qloop_495 + tmp_qloop_496 + tmp_qloop_744);
                   const real_t tmp_qloop_763 = tmp_qloop_494*1.0 + tmp_qloop_495*1.0 + tmp_qloop_496*1.0;
                   const real_t tmp_qloop_764 = tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_765 = tmp_qloop_153*2.0 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_766 = tmp_qloop_118*(tmp_qloop_509 + tmp_qloop_510 + tmp_qloop_511 + tmp_qloop_744);
                   const real_t tmp_qloop_767 = tmp_qloop_509*1.0 + tmp_qloop_510*1.0 + tmp_qloop_511*1.0;
                   const real_t tmp_qloop_768 = tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_769 = tmp_qloop_153*2.0 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_770 = tmp_qloop_118*(tmp_qloop_524 + tmp_qloop_525 + tmp_qloop_526 + tmp_qloop_744);
                   const real_t tmp_qloop_771 = tmp_qloop_524*1.0 + tmp_qloop_525*1.0 + tmp_qloop_526*1.0;
                   const real_t tmp_qloop_772 = tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_773 = tmp_qloop_153*2.0 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_774 = tmp_qloop_118*(tmp_qloop_539 + tmp_qloop_540 + tmp_qloop_541 + tmp_qloop_744);
                   const real_t tmp_qloop_775 = tmp_qloop_539*1.0 + tmp_qloop_540*1.0 + tmp_qloop_541*1.0;
                   const real_t tmp_qloop_776 = tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_777 = tmp_qloop_153*2.0 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_778 = tmp_qloop_118*(tmp_qloop_554 + tmp_qloop_555 + tmp_qloop_556 + tmp_qloop_744);
                   const real_t tmp_qloop_779 = tmp_qloop_554*1.0 + tmp_qloop_555*1.0 + tmp_qloop_556*1.0;
                   const real_t tmp_qloop_780 = tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_781 = tmp_qloop_153*2.0 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + tmp_qloop_129*(tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_127) + tmp_qloop_138*(tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_136) + tmp_qloop_155) - tmp_qloop_119*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_114));
                   const real_t q_tmp_0_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_161 + tmp_qloop_129*tmp_qloop_165 + tmp_qloop_138*tmp_qloop_169 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_160);
                   const real_t q_tmp_0_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_174 + tmp_qloop_129*tmp_qloop_178 + tmp_qloop_138*tmp_qloop_182 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_173);
                   const real_t q_tmp_0_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_187 + tmp_qloop_129*tmp_qloop_191 + tmp_qloop_138*tmp_qloop_195 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_186);
                   const real_t q_tmp_0_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_200 + tmp_qloop_129*tmp_qloop_204 + tmp_qloop_138*tmp_qloop_208 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_199);
                   const real_t q_tmp_0_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_213 + tmp_qloop_129*tmp_qloop_217 + tmp_qloop_138*tmp_qloop_221 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_212);
                   const real_t q_tmp_0_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_226 + tmp_qloop_129*tmp_qloop_230 + tmp_qloop_138*tmp_qloop_234 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_225);
                   const real_t q_tmp_0_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_239 + tmp_qloop_129*tmp_qloop_243 + tmp_qloop_138*tmp_qloop_247 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_238);
                   const real_t q_tmp_0_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_252 + tmp_qloop_129*tmp_qloop_256 + tmp_qloop_138*tmp_qloop_260 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_251);
                   const real_t q_tmp_0_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_265 + tmp_qloop_129*tmp_qloop_269 + tmp_qloop_138*tmp_qloop_273 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_264);
                   const real_t q_tmp_0_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_290 + tmp_qloop_298 + tmp_qloop_304) - tmp_qloop_119*tmp_qloop_282);
                   const real_t q_tmp_0_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_312 + tmp_qloop_298 + tmp_qloop_318) - tmp_qloop_119*tmp_qloop_308);
                   const real_t q_tmp_0_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_326 + tmp_qloop_298 + tmp_qloop_332) - tmp_qloop_119*tmp_qloop_322);
                   const real_t q_tmp_0_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_340 + tmp_qloop_298 + tmp_qloop_346) - tmp_qloop_119*tmp_qloop_336);
                   const real_t q_tmp_0_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_354 + tmp_qloop_298 + tmp_qloop_360) - tmp_qloop_119*tmp_qloop_350);
                   const real_t q_tmp_0_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_368 + tmp_qloop_298 + tmp_qloop_374) - tmp_qloop_119*tmp_qloop_364);
                   const real_t q_tmp_0_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_382 + tmp_qloop_298 + tmp_qloop_388) - tmp_qloop_119*tmp_qloop_378);
                   const real_t q_tmp_0_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_396 + tmp_qloop_298 + tmp_qloop_402) - tmp_qloop_119*tmp_qloop_392);
                   const real_t q_tmp_0_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_410 + tmp_qloop_298 + tmp_qloop_416) - tmp_qloop_119*tmp_qloop_406);
                   const real_t q_tmp_0_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_424 + tmp_qloop_298 + tmp_qloop_430) - tmp_qloop_119*tmp_qloop_420);
                   const real_t q_tmp_0_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_439 + tmp_qloop_441 + tmp_qloop_448) - tmp_qloop_119*tmp_qloop_435);
                   const real_t q_tmp_0_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_456 + tmp_qloop_441 + tmp_qloop_463) - tmp_qloop_119*tmp_qloop_452);
                   const real_t q_tmp_0_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_471 + tmp_qloop_441 + tmp_qloop_478) - tmp_qloop_119*tmp_qloop_467);
                   const real_t q_tmp_0_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_486 + tmp_qloop_441 + tmp_qloop_493) - tmp_qloop_119*tmp_qloop_482);
                   const real_t q_tmp_0_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_501 + tmp_qloop_441 + tmp_qloop_508) - tmp_qloop_119*tmp_qloop_497);
                   const real_t q_tmp_0_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_516 + tmp_qloop_441 + tmp_qloop_523) - tmp_qloop_119*tmp_qloop_512);
                   const real_t q_tmp_0_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_531 + tmp_qloop_441 + tmp_qloop_538) - tmp_qloop_119*tmp_qloop_527);
                   const real_t q_tmp_0_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_546 + tmp_qloop_441 + tmp_qloop_553) - tmp_qloop_119*tmp_qloop_542);
                   const real_t q_tmp_0_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_561 + tmp_qloop_441 + tmp_qloop_568) - tmp_qloop_119*tmp_qloop_557);
                   const real_t q_tmp_0_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_576 + tmp_qloop_441 + tmp_qloop_583) - tmp_qloop_119*tmp_qloop_572);
                   const real_t q_tmp_1_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_161*tmp_qloop_585 + tmp_qloop_165*tmp_qloop_586 + tmp_qloop_169*tmp_qloop_587) - tmp_qloop_160*tmp_qloop_584);
                   const real_t q_tmp_1_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_585 + tmp_qloop_178*tmp_qloop_586 + tmp_qloop_182*tmp_qloop_587) - tmp_qloop_173*tmp_qloop_584);
                   const real_t q_tmp_1_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_585 + tmp_qloop_191*tmp_qloop_586 + tmp_qloop_195*tmp_qloop_587) - tmp_qloop_186*tmp_qloop_584);
                   const real_t q_tmp_1_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_585 + tmp_qloop_204*tmp_qloop_586 + tmp_qloop_208*tmp_qloop_587) - tmp_qloop_199*tmp_qloop_584);
                   const real_t q_tmp_1_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_585 + tmp_qloop_217*tmp_qloop_586 + tmp_qloop_221*tmp_qloop_587) - tmp_qloop_212*tmp_qloop_584);
                   const real_t q_tmp_1_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_585 + tmp_qloop_230*tmp_qloop_586 + tmp_qloop_234*tmp_qloop_587) - tmp_qloop_225*tmp_qloop_584);
                   const real_t q_tmp_1_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_585 + tmp_qloop_243*tmp_qloop_586 + tmp_qloop_247*tmp_qloop_587) - tmp_qloop_238*tmp_qloop_584);
                   const real_t q_tmp_1_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_585 + tmp_qloop_256*tmp_qloop_586 + tmp_qloop_260*tmp_qloop_587) - tmp_qloop_251*tmp_qloop_584);
                   const real_t q_tmp_1_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_585 + tmp_qloop_269*tmp_qloop_586 + tmp_qloop_273*tmp_qloop_587) - tmp_qloop_264*tmp_qloop_584);
                   const real_t q_tmp_1_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_586 + tmp_qloop_588 + tmp_qloop_590) - tmp_qloop_282*tmp_qloop_584);
                   const real_t q_tmp_1_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_586 + tmp_qloop_318 + tmp_qloop_591) - tmp_qloop_308*tmp_qloop_584);
                   const real_t q_tmp_1_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_586 + tmp_qloop_332 + tmp_qloop_591) - tmp_qloop_322*tmp_qloop_584);
                   const real_t q_tmp_1_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_586 + tmp_qloop_346 + tmp_qloop_591) - tmp_qloop_336*tmp_qloop_584);
                   const real_t q_tmp_1_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_586 + tmp_qloop_360 + tmp_qloop_591) - tmp_qloop_350*tmp_qloop_584);
                   const real_t q_tmp_1_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_586 + tmp_qloop_374 + tmp_qloop_591) - tmp_qloop_364*tmp_qloop_584);
                   const real_t q_tmp_1_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_586 + tmp_qloop_388 + tmp_qloop_591) - tmp_qloop_378*tmp_qloop_584);
                   const real_t q_tmp_1_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_586 + tmp_qloop_402 + tmp_qloop_591) - tmp_qloop_392*tmp_qloop_584);
                   const real_t q_tmp_1_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_586 + tmp_qloop_416 + tmp_qloop_591) - tmp_qloop_406*tmp_qloop_584);
                   const real_t q_tmp_1_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_586 + tmp_qloop_430 + tmp_qloop_591) - tmp_qloop_420*tmp_qloop_584);
                   const real_t q_tmp_1_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_587 + tmp_qloop_592 + tmp_qloop_593) - tmp_qloop_435*tmp_qloop_584);
                   const real_t q_tmp_1_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_587 + tmp_qloop_463 + tmp_qloop_594) - tmp_qloop_452*tmp_qloop_584);
                   const real_t q_tmp_1_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_587 + tmp_qloop_478 + tmp_qloop_594) - tmp_qloop_467*tmp_qloop_584);
                   const real_t q_tmp_1_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_587 + tmp_qloop_493 + tmp_qloop_594) - tmp_qloop_482*tmp_qloop_584);
                   const real_t q_tmp_1_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_587 + tmp_qloop_508 + tmp_qloop_594) - tmp_qloop_497*tmp_qloop_584);
                   const real_t q_tmp_1_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_587 + tmp_qloop_523 + tmp_qloop_594) - tmp_qloop_512*tmp_qloop_584);
                   const real_t q_tmp_1_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_587 + tmp_qloop_538 + tmp_qloop_594) - tmp_qloop_527*tmp_qloop_584);
                   const real_t q_tmp_1_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_587 + tmp_qloop_553 + tmp_qloop_594) - tmp_qloop_542*tmp_qloop_584);
                   const real_t q_tmp_1_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_587 + tmp_qloop_568 + tmp_qloop_594) - tmp_qloop_557*tmp_qloop_584);
                   const real_t q_tmp_1_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_587 + tmp_qloop_583 + tmp_qloop_594) - tmp_qloop_572*tmp_qloop_584);
                   const real_t q_tmp_2_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_596 + tmp_qloop_178*tmp_qloop_597 + tmp_qloop_182*tmp_qloop_598) - tmp_qloop_173*tmp_qloop_595);
                   const real_t q_tmp_2_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_596 + tmp_qloop_191*tmp_qloop_597 + tmp_qloop_195*tmp_qloop_598) - tmp_qloop_186*tmp_qloop_595);
                   const real_t q_tmp_2_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_596 + tmp_qloop_204*tmp_qloop_597 + tmp_qloop_208*tmp_qloop_598) - tmp_qloop_199*tmp_qloop_595);
                   const real_t q_tmp_2_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_596 + tmp_qloop_217*tmp_qloop_597 + tmp_qloop_221*tmp_qloop_598) - tmp_qloop_212*tmp_qloop_595);
                   const real_t q_tmp_2_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_596 + tmp_qloop_230*tmp_qloop_597 + tmp_qloop_234*tmp_qloop_598) - tmp_qloop_225*tmp_qloop_595);
                   const real_t q_tmp_2_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_596 + tmp_qloop_243*tmp_qloop_597 + tmp_qloop_247*tmp_qloop_598) - tmp_qloop_238*tmp_qloop_595);
                   const real_t q_tmp_2_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_596 + tmp_qloop_256*tmp_qloop_597 + tmp_qloop_260*tmp_qloop_598) - tmp_qloop_251*tmp_qloop_595);
                   const real_t q_tmp_2_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_596 + tmp_qloop_269*tmp_qloop_597 + tmp_qloop_273*tmp_qloop_598) - tmp_qloop_264*tmp_qloop_595);
                   const real_t q_tmp_2_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_597 + tmp_qloop_588 + tmp_qloop_600) - tmp_qloop_282*tmp_qloop_595);
                   const real_t q_tmp_2_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_597 + tmp_qloop_318 + tmp_qloop_601) - tmp_qloop_308*tmp_qloop_595);
                   const real_t q_tmp_2_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_597 + tmp_qloop_332 + tmp_qloop_601) - tmp_qloop_322*tmp_qloop_595);
                   const real_t q_tmp_2_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_597 + tmp_qloop_346 + tmp_qloop_601) - tmp_qloop_336*tmp_qloop_595);
                   const real_t q_tmp_2_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_597 + tmp_qloop_360 + tmp_qloop_601) - tmp_qloop_350*tmp_qloop_595);
                   const real_t q_tmp_2_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_597 + tmp_qloop_374 + tmp_qloop_601) - tmp_qloop_364*tmp_qloop_595);
                   const real_t q_tmp_2_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_597 + tmp_qloop_388 + tmp_qloop_601) - tmp_qloop_378*tmp_qloop_595);
                   const real_t q_tmp_2_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_597 + tmp_qloop_402 + tmp_qloop_601) - tmp_qloop_392*tmp_qloop_595);
                   const real_t q_tmp_2_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_597 + tmp_qloop_416 + tmp_qloop_601) - tmp_qloop_406*tmp_qloop_595);
                   const real_t q_tmp_2_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_597 + tmp_qloop_430 + tmp_qloop_601) - tmp_qloop_420*tmp_qloop_595);
                   const real_t q_tmp_2_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_598 + tmp_qloop_592 + tmp_qloop_602) - tmp_qloop_435*tmp_qloop_595);
                   const real_t q_tmp_2_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_598 + tmp_qloop_463 + tmp_qloop_603) - tmp_qloop_452*tmp_qloop_595);
                   const real_t q_tmp_2_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_598 + tmp_qloop_478 + tmp_qloop_603) - tmp_qloop_467*tmp_qloop_595);
                   const real_t q_tmp_2_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_598 + tmp_qloop_493 + tmp_qloop_603) - tmp_qloop_482*tmp_qloop_595);
                   const real_t q_tmp_2_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_598 + tmp_qloop_508 + tmp_qloop_603) - tmp_qloop_497*tmp_qloop_595);
                   const real_t q_tmp_2_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_598 + tmp_qloop_523 + tmp_qloop_603) - tmp_qloop_512*tmp_qloop_595);
                   const real_t q_tmp_2_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_598 + tmp_qloop_538 + tmp_qloop_603) - tmp_qloop_527*tmp_qloop_595);
                   const real_t q_tmp_2_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_598 + tmp_qloop_553 + tmp_qloop_603) - tmp_qloop_542*tmp_qloop_595);
                   const real_t q_tmp_2_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_598 + tmp_qloop_568 + tmp_qloop_603) - tmp_qloop_557*tmp_qloop_595);
                   const real_t q_tmp_2_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_598 + tmp_qloop_583 + tmp_qloop_603) - tmp_qloop_572*tmp_qloop_595);
                   const real_t q_tmp_3_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_605 + tmp_qloop_191*tmp_qloop_606 + tmp_qloop_195*tmp_qloop_607) - tmp_qloop_186*tmp_qloop_604);
                   const real_t q_tmp_3_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_605 + tmp_qloop_204*tmp_qloop_606 + tmp_qloop_208*tmp_qloop_607) - tmp_qloop_199*tmp_qloop_604);
                   const real_t q_tmp_3_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_605 + tmp_qloop_217*tmp_qloop_606 + tmp_qloop_221*tmp_qloop_607) - tmp_qloop_212*tmp_qloop_604);
                   const real_t q_tmp_3_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_605 + tmp_qloop_230*tmp_qloop_606 + tmp_qloop_234*tmp_qloop_607) - tmp_qloop_225*tmp_qloop_604);
                   const real_t q_tmp_3_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_605 + tmp_qloop_243*tmp_qloop_606 + tmp_qloop_247*tmp_qloop_607) - tmp_qloop_238*tmp_qloop_604);
                   const real_t q_tmp_3_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_605 + tmp_qloop_256*tmp_qloop_606 + tmp_qloop_260*tmp_qloop_607) - tmp_qloop_251*tmp_qloop_604);
                   const real_t q_tmp_3_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_605 + tmp_qloop_269*tmp_qloop_606 + tmp_qloop_273*tmp_qloop_607) - tmp_qloop_264*tmp_qloop_604);
                   const real_t q_tmp_3_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_606 + tmp_qloop_588 + tmp_qloop_609) - tmp_qloop_282*tmp_qloop_604);
                   const real_t q_tmp_3_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_606 + tmp_qloop_318 + tmp_qloop_610) - tmp_qloop_308*tmp_qloop_604);
                   const real_t q_tmp_3_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_606 + tmp_qloop_332 + tmp_qloop_610) - tmp_qloop_322*tmp_qloop_604);
                   const real_t q_tmp_3_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_606 + tmp_qloop_346 + tmp_qloop_610) - tmp_qloop_336*tmp_qloop_604);
                   const real_t q_tmp_3_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_606 + tmp_qloop_360 + tmp_qloop_610) - tmp_qloop_350*tmp_qloop_604);
                   const real_t q_tmp_3_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_606 + tmp_qloop_374 + tmp_qloop_610) - tmp_qloop_364*tmp_qloop_604);
                   const real_t q_tmp_3_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_606 + tmp_qloop_388 + tmp_qloop_610) - tmp_qloop_378*tmp_qloop_604);
                   const real_t q_tmp_3_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_606 + tmp_qloop_402 + tmp_qloop_610) - tmp_qloop_392*tmp_qloop_604);
                   const real_t q_tmp_3_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_606 + tmp_qloop_416 + tmp_qloop_610) - tmp_qloop_406*tmp_qloop_604);
                   const real_t q_tmp_3_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_606 + tmp_qloop_430 + tmp_qloop_610) - tmp_qloop_420*tmp_qloop_604);
                   const real_t q_tmp_3_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_607 + tmp_qloop_592 + tmp_qloop_611) - tmp_qloop_435*tmp_qloop_604);
                   const real_t q_tmp_3_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_607 + tmp_qloop_463 + tmp_qloop_612) - tmp_qloop_452*tmp_qloop_604);
                   const real_t q_tmp_3_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_607 + tmp_qloop_478 + tmp_qloop_612) - tmp_qloop_467*tmp_qloop_604);
                   const real_t q_tmp_3_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_607 + tmp_qloop_493 + tmp_qloop_612) - tmp_qloop_482*tmp_qloop_604);
                   const real_t q_tmp_3_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_607 + tmp_qloop_508 + tmp_qloop_612) - tmp_qloop_497*tmp_qloop_604);
                   const real_t q_tmp_3_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_607 + tmp_qloop_523 + tmp_qloop_612) - tmp_qloop_512*tmp_qloop_604);
                   const real_t q_tmp_3_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_607 + tmp_qloop_538 + tmp_qloop_612) - tmp_qloop_527*tmp_qloop_604);
                   const real_t q_tmp_3_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_607 + tmp_qloop_553 + tmp_qloop_612) - tmp_qloop_542*tmp_qloop_604);
                   const real_t q_tmp_3_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_607 + tmp_qloop_568 + tmp_qloop_612) - tmp_qloop_557*tmp_qloop_604);
                   const real_t q_tmp_3_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_607 + tmp_qloop_583 + tmp_qloop_612) - tmp_qloop_572*tmp_qloop_604);
                   const real_t q_tmp_4_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_614 + tmp_qloop_204*tmp_qloop_615 + tmp_qloop_208*tmp_qloop_616) - tmp_qloop_199*tmp_qloop_613);
                   const real_t q_tmp_4_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_614 + tmp_qloop_217*tmp_qloop_615 + tmp_qloop_221*tmp_qloop_616) - tmp_qloop_212*tmp_qloop_613);
                   const real_t q_tmp_4_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_614 + tmp_qloop_230*tmp_qloop_615 + tmp_qloop_234*tmp_qloop_616) - tmp_qloop_225*tmp_qloop_613);
                   const real_t q_tmp_4_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_614 + tmp_qloop_243*tmp_qloop_615 + tmp_qloop_247*tmp_qloop_616) - tmp_qloop_238*tmp_qloop_613);
                   const real_t q_tmp_4_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_614 + tmp_qloop_256*tmp_qloop_615 + tmp_qloop_260*tmp_qloop_616) - tmp_qloop_251*tmp_qloop_613);
                   const real_t q_tmp_4_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_614 + tmp_qloop_269*tmp_qloop_615 + tmp_qloop_273*tmp_qloop_616) - tmp_qloop_264*tmp_qloop_613);
                   const real_t q_tmp_4_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_615 + tmp_qloop_588 + tmp_qloop_618) - tmp_qloop_282*tmp_qloop_613);
                   const real_t q_tmp_4_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_615 + tmp_qloop_318 + tmp_qloop_619) - tmp_qloop_308*tmp_qloop_613);
                   const real_t q_tmp_4_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_615 + tmp_qloop_332 + tmp_qloop_619) - tmp_qloop_322*tmp_qloop_613);
                   const real_t q_tmp_4_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_615 + tmp_qloop_346 + tmp_qloop_619) - tmp_qloop_336*tmp_qloop_613);
                   const real_t q_tmp_4_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_615 + tmp_qloop_360 + tmp_qloop_619) - tmp_qloop_350*tmp_qloop_613);
                   const real_t q_tmp_4_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_615 + tmp_qloop_374 + tmp_qloop_619) - tmp_qloop_364*tmp_qloop_613);
                   const real_t q_tmp_4_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_615 + tmp_qloop_388 + tmp_qloop_619) - tmp_qloop_378*tmp_qloop_613);
                   const real_t q_tmp_4_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_615 + tmp_qloop_402 + tmp_qloop_619) - tmp_qloop_392*tmp_qloop_613);
                   const real_t q_tmp_4_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_615 + tmp_qloop_416 + tmp_qloop_619) - tmp_qloop_406*tmp_qloop_613);
                   const real_t q_tmp_4_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_615 + tmp_qloop_430 + tmp_qloop_619) - tmp_qloop_420*tmp_qloop_613);
                   const real_t q_tmp_4_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_616 + tmp_qloop_592 + tmp_qloop_620) - tmp_qloop_435*tmp_qloop_613);
                   const real_t q_tmp_4_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_616 + tmp_qloop_463 + tmp_qloop_621) - tmp_qloop_452*tmp_qloop_613);
                   const real_t q_tmp_4_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_616 + tmp_qloop_478 + tmp_qloop_621) - tmp_qloop_467*tmp_qloop_613);
                   const real_t q_tmp_4_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_616 + tmp_qloop_493 + tmp_qloop_621) - tmp_qloop_482*tmp_qloop_613);
                   const real_t q_tmp_4_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_616 + tmp_qloop_508 + tmp_qloop_621) - tmp_qloop_497*tmp_qloop_613);
                   const real_t q_tmp_4_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_616 + tmp_qloop_523 + tmp_qloop_621) - tmp_qloop_512*tmp_qloop_613);
                   const real_t q_tmp_4_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_616 + tmp_qloop_538 + tmp_qloop_621) - tmp_qloop_527*tmp_qloop_613);
                   const real_t q_tmp_4_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_616 + tmp_qloop_553 + tmp_qloop_621) - tmp_qloop_542*tmp_qloop_613);
                   const real_t q_tmp_4_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_616 + tmp_qloop_568 + tmp_qloop_621) - tmp_qloop_557*tmp_qloop_613);
                   const real_t q_tmp_4_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_616 + tmp_qloop_583 + tmp_qloop_621) - tmp_qloop_572*tmp_qloop_613);
                   const real_t q_tmp_5_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_623 + tmp_qloop_217*tmp_qloop_624 + tmp_qloop_221*tmp_qloop_625) - tmp_qloop_212*tmp_qloop_622);
                   const real_t q_tmp_5_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_623 + tmp_qloop_230*tmp_qloop_624 + tmp_qloop_234*tmp_qloop_625) - tmp_qloop_225*tmp_qloop_622);
                   const real_t q_tmp_5_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_623 + tmp_qloop_243*tmp_qloop_624 + tmp_qloop_247*tmp_qloop_625) - tmp_qloop_238*tmp_qloop_622);
                   const real_t q_tmp_5_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_623 + tmp_qloop_256*tmp_qloop_624 + tmp_qloop_260*tmp_qloop_625) - tmp_qloop_251*tmp_qloop_622);
                   const real_t q_tmp_5_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_623 + tmp_qloop_269*tmp_qloop_624 + tmp_qloop_273*tmp_qloop_625) - tmp_qloop_264*tmp_qloop_622);
                   const real_t q_tmp_5_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_624 + tmp_qloop_588 + tmp_qloop_627) - tmp_qloop_282*tmp_qloop_622);
                   const real_t q_tmp_5_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_624 + tmp_qloop_318 + tmp_qloop_628) - tmp_qloop_308*tmp_qloop_622);
                   const real_t q_tmp_5_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_624 + tmp_qloop_332 + tmp_qloop_628) - tmp_qloop_322*tmp_qloop_622);
                   const real_t q_tmp_5_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_624 + tmp_qloop_346 + tmp_qloop_628) - tmp_qloop_336*tmp_qloop_622);
                   const real_t q_tmp_5_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_624 + tmp_qloop_360 + tmp_qloop_628) - tmp_qloop_350*tmp_qloop_622);
                   const real_t q_tmp_5_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_624 + tmp_qloop_374 + tmp_qloop_628) - tmp_qloop_364*tmp_qloop_622);
                   const real_t q_tmp_5_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_624 + tmp_qloop_388 + tmp_qloop_628) - tmp_qloop_378*tmp_qloop_622);
                   const real_t q_tmp_5_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_624 + tmp_qloop_402 + tmp_qloop_628) - tmp_qloop_392*tmp_qloop_622);
                   const real_t q_tmp_5_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_624 + tmp_qloop_416 + tmp_qloop_628) - tmp_qloop_406*tmp_qloop_622);
                   const real_t q_tmp_5_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_624 + tmp_qloop_430 + tmp_qloop_628) - tmp_qloop_420*tmp_qloop_622);
                   const real_t q_tmp_5_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_625 + tmp_qloop_592 + tmp_qloop_629) - tmp_qloop_435*tmp_qloop_622);
                   const real_t q_tmp_5_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_625 + tmp_qloop_463 + tmp_qloop_630) - tmp_qloop_452*tmp_qloop_622);
                   const real_t q_tmp_5_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_625 + tmp_qloop_478 + tmp_qloop_630) - tmp_qloop_467*tmp_qloop_622);
                   const real_t q_tmp_5_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_625 + tmp_qloop_493 + tmp_qloop_630) - tmp_qloop_482*tmp_qloop_622);
                   const real_t q_tmp_5_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_625 + tmp_qloop_508 + tmp_qloop_630) - tmp_qloop_497*tmp_qloop_622);
                   const real_t q_tmp_5_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_625 + tmp_qloop_523 + tmp_qloop_630) - tmp_qloop_512*tmp_qloop_622);
                   const real_t q_tmp_5_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_625 + tmp_qloop_538 + tmp_qloop_630) - tmp_qloop_527*tmp_qloop_622);
                   const real_t q_tmp_5_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_625 + tmp_qloop_553 + tmp_qloop_630) - tmp_qloop_542*tmp_qloop_622);
                   const real_t q_tmp_5_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_625 + tmp_qloop_568 + tmp_qloop_630) - tmp_qloop_557*tmp_qloop_622);
                   const real_t q_tmp_5_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_625 + tmp_qloop_583 + tmp_qloop_630) - tmp_qloop_572*tmp_qloop_622);
                   const real_t q_tmp_6_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_632 + tmp_qloop_230*tmp_qloop_633 + tmp_qloop_234*tmp_qloop_634) - tmp_qloop_225*tmp_qloop_631);
                   const real_t q_tmp_6_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_632 + tmp_qloop_243*tmp_qloop_633 + tmp_qloop_247*tmp_qloop_634) - tmp_qloop_238*tmp_qloop_631);
                   const real_t q_tmp_6_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_632 + tmp_qloop_256*tmp_qloop_633 + tmp_qloop_260*tmp_qloop_634) - tmp_qloop_251*tmp_qloop_631);
                   const real_t q_tmp_6_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_632 + tmp_qloop_269*tmp_qloop_633 + tmp_qloop_273*tmp_qloop_634) - tmp_qloop_264*tmp_qloop_631);
                   const real_t q_tmp_6_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_633 + tmp_qloop_588 + tmp_qloop_636) - tmp_qloop_282*tmp_qloop_631);
                   const real_t q_tmp_6_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_633 + tmp_qloop_318 + tmp_qloop_637) - tmp_qloop_308*tmp_qloop_631);
                   const real_t q_tmp_6_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_633 + tmp_qloop_332 + tmp_qloop_637) - tmp_qloop_322*tmp_qloop_631);
                   const real_t q_tmp_6_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_633 + tmp_qloop_346 + tmp_qloop_637) - tmp_qloop_336*tmp_qloop_631);
                   const real_t q_tmp_6_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_633 + tmp_qloop_360 + tmp_qloop_637) - tmp_qloop_350*tmp_qloop_631);
                   const real_t q_tmp_6_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_633 + tmp_qloop_374 + tmp_qloop_637) - tmp_qloop_364*tmp_qloop_631);
                   const real_t q_tmp_6_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_633 + tmp_qloop_388 + tmp_qloop_637) - tmp_qloop_378*tmp_qloop_631);
                   const real_t q_tmp_6_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_633 + tmp_qloop_402 + tmp_qloop_637) - tmp_qloop_392*tmp_qloop_631);
                   const real_t q_tmp_6_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_633 + tmp_qloop_416 + tmp_qloop_637) - tmp_qloop_406*tmp_qloop_631);
                   const real_t q_tmp_6_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_633 + tmp_qloop_430 + tmp_qloop_637) - tmp_qloop_420*tmp_qloop_631);
                   const real_t q_tmp_6_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_634 + tmp_qloop_592 + tmp_qloop_638) - tmp_qloop_435*tmp_qloop_631);
                   const real_t q_tmp_6_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_634 + tmp_qloop_463 + tmp_qloop_639) - tmp_qloop_452*tmp_qloop_631);
                   const real_t q_tmp_6_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_634 + tmp_qloop_478 + tmp_qloop_639) - tmp_qloop_467*tmp_qloop_631);
                   const real_t q_tmp_6_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_634 + tmp_qloop_493 + tmp_qloop_639) - tmp_qloop_482*tmp_qloop_631);
                   const real_t q_tmp_6_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_634 + tmp_qloop_508 + tmp_qloop_639) - tmp_qloop_497*tmp_qloop_631);
                   const real_t q_tmp_6_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_634 + tmp_qloop_523 + tmp_qloop_639) - tmp_qloop_512*tmp_qloop_631);
                   const real_t q_tmp_6_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_634 + tmp_qloop_538 + tmp_qloop_639) - tmp_qloop_527*tmp_qloop_631);
                   const real_t q_tmp_6_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_634 + tmp_qloop_553 + tmp_qloop_639) - tmp_qloop_542*tmp_qloop_631);
                   const real_t q_tmp_6_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_634 + tmp_qloop_568 + tmp_qloop_639) - tmp_qloop_557*tmp_qloop_631);
                   const real_t q_tmp_6_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_634 + tmp_qloop_583 + tmp_qloop_639) - tmp_qloop_572*tmp_qloop_631);
                   const real_t q_tmp_7_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_641 + tmp_qloop_243*tmp_qloop_642 + tmp_qloop_247*tmp_qloop_643) - tmp_qloop_238*tmp_qloop_640);
                   const real_t q_tmp_7_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_641 + tmp_qloop_256*tmp_qloop_642 + tmp_qloop_260*tmp_qloop_643) - tmp_qloop_251*tmp_qloop_640);
                   const real_t q_tmp_7_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_641 + tmp_qloop_269*tmp_qloop_642 + tmp_qloop_273*tmp_qloop_643) - tmp_qloop_264*tmp_qloop_640);
                   const real_t q_tmp_7_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_642 + tmp_qloop_588 + tmp_qloop_645) - tmp_qloop_282*tmp_qloop_640);
                   const real_t q_tmp_7_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_642 + tmp_qloop_318 + tmp_qloop_646) - tmp_qloop_308*tmp_qloop_640);
                   const real_t q_tmp_7_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_642 + tmp_qloop_332 + tmp_qloop_646) - tmp_qloop_322*tmp_qloop_640);
                   const real_t q_tmp_7_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_642 + tmp_qloop_346 + tmp_qloop_646) - tmp_qloop_336*tmp_qloop_640);
                   const real_t q_tmp_7_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_642 + tmp_qloop_360 + tmp_qloop_646) - tmp_qloop_350*tmp_qloop_640);
                   const real_t q_tmp_7_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_642 + tmp_qloop_374 + tmp_qloop_646) - tmp_qloop_364*tmp_qloop_640);
                   const real_t q_tmp_7_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_642 + tmp_qloop_388 + tmp_qloop_646) - tmp_qloop_378*tmp_qloop_640);
                   const real_t q_tmp_7_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_642 + tmp_qloop_402 + tmp_qloop_646) - tmp_qloop_392*tmp_qloop_640);
                   const real_t q_tmp_7_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_642 + tmp_qloop_416 + tmp_qloop_646) - tmp_qloop_406*tmp_qloop_640);
                   const real_t q_tmp_7_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_642 + tmp_qloop_430 + tmp_qloop_646) - tmp_qloop_420*tmp_qloop_640);
                   const real_t q_tmp_7_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_643 + tmp_qloop_592 + tmp_qloop_647) - tmp_qloop_435*tmp_qloop_640);
                   const real_t q_tmp_7_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_643 + tmp_qloop_463 + tmp_qloop_648) - tmp_qloop_452*tmp_qloop_640);
                   const real_t q_tmp_7_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_643 + tmp_qloop_478 + tmp_qloop_648) - tmp_qloop_467*tmp_qloop_640);
                   const real_t q_tmp_7_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_643 + tmp_qloop_493 + tmp_qloop_648) - tmp_qloop_482*tmp_qloop_640);
                   const real_t q_tmp_7_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_643 + tmp_qloop_508 + tmp_qloop_648) - tmp_qloop_497*tmp_qloop_640);
                   const real_t q_tmp_7_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_643 + tmp_qloop_523 + tmp_qloop_648) - tmp_qloop_512*tmp_qloop_640);
                   const real_t q_tmp_7_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_643 + tmp_qloop_538 + tmp_qloop_648) - tmp_qloop_527*tmp_qloop_640);
                   const real_t q_tmp_7_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_643 + tmp_qloop_553 + tmp_qloop_648) - tmp_qloop_542*tmp_qloop_640);
                   const real_t q_tmp_7_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_643 + tmp_qloop_568 + tmp_qloop_648) - tmp_qloop_557*tmp_qloop_640);
                   const real_t q_tmp_7_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_643 + tmp_qloop_583 + tmp_qloop_648) - tmp_qloop_572*tmp_qloop_640);
                   const real_t q_tmp_8_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_650 + tmp_qloop_256*tmp_qloop_651 + tmp_qloop_260*tmp_qloop_652) - tmp_qloop_251*tmp_qloop_649);
                   const real_t q_tmp_8_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_650 + tmp_qloop_269*tmp_qloop_651 + tmp_qloop_273*tmp_qloop_652) - tmp_qloop_264*tmp_qloop_649);
                   const real_t q_tmp_8_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_651 + tmp_qloop_588 + tmp_qloop_654) - tmp_qloop_282*tmp_qloop_649);
                   const real_t q_tmp_8_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_651 + tmp_qloop_318 + tmp_qloop_655) - tmp_qloop_308*tmp_qloop_649);
                   const real_t q_tmp_8_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_651 + tmp_qloop_332 + tmp_qloop_655) - tmp_qloop_322*tmp_qloop_649);
                   const real_t q_tmp_8_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_651 + tmp_qloop_346 + tmp_qloop_655) - tmp_qloop_336*tmp_qloop_649);
                   const real_t q_tmp_8_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_651 + tmp_qloop_360 + tmp_qloop_655) - tmp_qloop_350*tmp_qloop_649);
                   const real_t q_tmp_8_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_651 + tmp_qloop_374 + tmp_qloop_655) - tmp_qloop_364*tmp_qloop_649);
                   const real_t q_tmp_8_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_651 + tmp_qloop_388 + tmp_qloop_655) - tmp_qloop_378*tmp_qloop_649);
                   const real_t q_tmp_8_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_651 + tmp_qloop_402 + tmp_qloop_655) - tmp_qloop_392*tmp_qloop_649);
                   const real_t q_tmp_8_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_651 + tmp_qloop_416 + tmp_qloop_655) - tmp_qloop_406*tmp_qloop_649);
                   const real_t q_tmp_8_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_651 + tmp_qloop_430 + tmp_qloop_655) - tmp_qloop_420*tmp_qloop_649);
                   const real_t q_tmp_8_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_652 + tmp_qloop_592 + tmp_qloop_656) - tmp_qloop_435*tmp_qloop_649);
                   const real_t q_tmp_8_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_652 + tmp_qloop_463 + tmp_qloop_657) - tmp_qloop_452*tmp_qloop_649);
                   const real_t q_tmp_8_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_652 + tmp_qloop_478 + tmp_qloop_657) - tmp_qloop_467*tmp_qloop_649);
                   const real_t q_tmp_8_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_652 + tmp_qloop_493 + tmp_qloop_657) - tmp_qloop_482*tmp_qloop_649);
                   const real_t q_tmp_8_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_652 + tmp_qloop_508 + tmp_qloop_657) - tmp_qloop_497*tmp_qloop_649);
                   const real_t q_tmp_8_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_652 + tmp_qloop_523 + tmp_qloop_657) - tmp_qloop_512*tmp_qloop_649);
                   const real_t q_tmp_8_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_652 + tmp_qloop_538 + tmp_qloop_657) - tmp_qloop_527*tmp_qloop_649);
                   const real_t q_tmp_8_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_652 + tmp_qloop_553 + tmp_qloop_657) - tmp_qloop_542*tmp_qloop_649);
                   const real_t q_tmp_8_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_652 + tmp_qloop_568 + tmp_qloop_657) - tmp_qloop_557*tmp_qloop_649);
                   const real_t q_tmp_8_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_652 + tmp_qloop_583 + tmp_qloop_657) - tmp_qloop_572*tmp_qloop_649);
                   const real_t q_tmp_9_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_659 + tmp_qloop_269*tmp_qloop_660 + tmp_qloop_273*tmp_qloop_661) - tmp_qloop_264*tmp_qloop_658);
                   const real_t q_tmp_9_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_660 + tmp_qloop_588 + tmp_qloop_663) - tmp_qloop_282*tmp_qloop_658);
                   const real_t q_tmp_9_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_660 + tmp_qloop_318 + tmp_qloop_664) - tmp_qloop_308*tmp_qloop_658);
                   const real_t q_tmp_9_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_660 + tmp_qloop_332 + tmp_qloop_664) - tmp_qloop_322*tmp_qloop_658);
                   const real_t q_tmp_9_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_660 + tmp_qloop_346 + tmp_qloop_664) - tmp_qloop_336*tmp_qloop_658);
                   const real_t q_tmp_9_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_660 + tmp_qloop_360 + tmp_qloop_664) - tmp_qloop_350*tmp_qloop_658);
                   const real_t q_tmp_9_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_660 + tmp_qloop_374 + tmp_qloop_664) - tmp_qloop_364*tmp_qloop_658);
                   const real_t q_tmp_9_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_660 + tmp_qloop_388 + tmp_qloop_664) - tmp_qloop_378*tmp_qloop_658);
                   const real_t q_tmp_9_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_660 + tmp_qloop_402 + tmp_qloop_664) - tmp_qloop_392*tmp_qloop_658);
                   const real_t q_tmp_9_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_660 + tmp_qloop_416 + tmp_qloop_664) - tmp_qloop_406*tmp_qloop_658);
                   const real_t q_tmp_9_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_660 + tmp_qloop_430 + tmp_qloop_664) - tmp_qloop_420*tmp_qloop_658);
                   const real_t q_tmp_9_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_661 + tmp_qloop_592 + tmp_qloop_665) - tmp_qloop_435*tmp_qloop_658);
                   const real_t q_tmp_9_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_661 + tmp_qloop_463 + tmp_qloop_666) - tmp_qloop_452*tmp_qloop_658);
                   const real_t q_tmp_9_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_661 + tmp_qloop_478 + tmp_qloop_666) - tmp_qloop_467*tmp_qloop_658);
                   const real_t q_tmp_9_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_661 + tmp_qloop_493 + tmp_qloop_666) - tmp_qloop_482*tmp_qloop_658);
                   const real_t q_tmp_9_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_661 + tmp_qloop_508 + tmp_qloop_666) - tmp_qloop_497*tmp_qloop_658);
                   const real_t q_tmp_9_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_661 + tmp_qloop_523 + tmp_qloop_666) - tmp_qloop_512*tmp_qloop_658);
                   const real_t q_tmp_9_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_661 + tmp_qloop_538 + tmp_qloop_666) - tmp_qloop_527*tmp_qloop_658);
                   const real_t q_tmp_9_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_661 + tmp_qloop_553 + tmp_qloop_666) - tmp_qloop_542*tmp_qloop_658);
                   const real_t q_tmp_9_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_661 + tmp_qloop_568 + tmp_qloop_666) - tmp_qloop_557*tmp_qloop_658);
                   const real_t q_tmp_9_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_661 + tmp_qloop_583 + tmp_qloop_666) - tmp_qloop_572*tmp_qloop_658);
                   const real_t q_tmp_10_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_672 + tmp_qloop_299*tmp_qloop_670 + tmp_qloop_303*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_282*tmp_qloop_669);
                   const real_t q_tmp_10_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_672 + tmp_qloop_313*tmp_qloop_670 + tmp_qloop_317*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_669);
                   const real_t q_tmp_10_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_672 + tmp_qloop_327*tmp_qloop_670 + tmp_qloop_331*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_669);
                   const real_t q_tmp_10_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_672 + tmp_qloop_341*tmp_qloop_670 + tmp_qloop_345*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_669);
                   const real_t q_tmp_10_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_672 + tmp_qloop_355*tmp_qloop_670 + tmp_qloop_359*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_669);
                   const real_t q_tmp_10_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_672 + tmp_qloop_369*tmp_qloop_670 + tmp_qloop_373*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_669);
                   const real_t q_tmp_10_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_672 + tmp_qloop_383*tmp_qloop_670 + tmp_qloop_387*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_669);
                   const real_t q_tmp_10_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_672 + tmp_qloop_397*tmp_qloop_670 + tmp_qloop_401*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_669);
                   const real_t q_tmp_10_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_672 + tmp_qloop_411*tmp_qloop_670 + tmp_qloop_415*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_669);
                   const real_t q_tmp_10_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_672 + tmp_qloop_425*tmp_qloop_670 + tmp_qloop_429*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_669);
                   const real_t q_tmp_10_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_679) - tmp_qloop_435*tmp_qloop_669);
                   const real_t q_tmp_10_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_680) - tmp_qloop_452*tmp_qloop_669);
                   const real_t q_tmp_10_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_681) - tmp_qloop_467*tmp_qloop_669);
                   const real_t q_tmp_10_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_682) - tmp_qloop_482*tmp_qloop_669);
                   const real_t q_tmp_10_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_683) - tmp_qloop_497*tmp_qloop_669);
                   const real_t q_tmp_10_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_684) - tmp_qloop_512*tmp_qloop_669);
                   const real_t q_tmp_10_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_685) - tmp_qloop_527*tmp_qloop_669);
                   const real_t q_tmp_10_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_686) - tmp_qloop_542*tmp_qloop_669);
                   const real_t q_tmp_10_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_687) - tmp_qloop_557*tmp_qloop_669);
                   const real_t q_tmp_10_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_688) - tmp_qloop_572*tmp_qloop_669);
                   const real_t q_tmp_11_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_691 + tmp_qloop_313*tmp_qloop_690 + tmp_qloop_317*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_689);
                   const real_t q_tmp_11_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_691 + tmp_qloop_327*tmp_qloop_690 + tmp_qloop_331*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_689);
                   const real_t q_tmp_11_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_691 + tmp_qloop_341*tmp_qloop_690 + tmp_qloop_345*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_689);
                   const real_t q_tmp_11_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_691 + tmp_qloop_355*tmp_qloop_690 + tmp_qloop_359*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_689);
                   const real_t q_tmp_11_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_691 + tmp_qloop_369*tmp_qloop_690 + tmp_qloop_373*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_689);
                   const real_t q_tmp_11_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_691 + tmp_qloop_383*tmp_qloop_690 + tmp_qloop_387*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_689);
                   const real_t q_tmp_11_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_691 + tmp_qloop_397*tmp_qloop_690 + tmp_qloop_401*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_689);
                   const real_t q_tmp_11_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_691 + tmp_qloop_411*tmp_qloop_690 + tmp_qloop_415*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_689);
                   const real_t q_tmp_11_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_691 + tmp_qloop_425*tmp_qloop_690 + tmp_qloop_429*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_689);
                   const real_t q_tmp_11_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_692 + tmp_qloop_693 + tmp_qloop_694) - tmp_qloop_435*tmp_qloop_689);
                   const real_t q_tmp_11_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_692 + tmp_qloop_680 + tmp_qloop_695) - tmp_qloop_452*tmp_qloop_689);
                   const real_t q_tmp_11_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_692 + tmp_qloop_681 + tmp_qloop_695) - tmp_qloop_467*tmp_qloop_689);
                   const real_t q_tmp_11_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_692 + tmp_qloop_682 + tmp_qloop_695) - tmp_qloop_482*tmp_qloop_689);
                   const real_t q_tmp_11_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_692 + tmp_qloop_683 + tmp_qloop_695) - tmp_qloop_497*tmp_qloop_689);
                   const real_t q_tmp_11_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_692 + tmp_qloop_684 + tmp_qloop_695) - tmp_qloop_512*tmp_qloop_689);
                   const real_t q_tmp_11_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_692 + tmp_qloop_685 + tmp_qloop_695) - tmp_qloop_527*tmp_qloop_689);
                   const real_t q_tmp_11_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_692 + tmp_qloop_686 + tmp_qloop_695) - tmp_qloop_542*tmp_qloop_689);
                   const real_t q_tmp_11_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_692 + tmp_qloop_687 + tmp_qloop_695) - tmp_qloop_557*tmp_qloop_689);
                   const real_t q_tmp_11_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_692 + tmp_qloop_688 + tmp_qloop_695) - tmp_qloop_572*tmp_qloop_689);
                   const real_t q_tmp_12_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_698 + tmp_qloop_327*tmp_qloop_697 + tmp_qloop_331*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_696);
                   const real_t q_tmp_12_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_698 + tmp_qloop_341*tmp_qloop_697 + tmp_qloop_345*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_696);
                   const real_t q_tmp_12_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_698 + tmp_qloop_355*tmp_qloop_697 + tmp_qloop_359*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_696);
                   const real_t q_tmp_12_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_698 + tmp_qloop_369*tmp_qloop_697 + tmp_qloop_373*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_696);
                   const real_t q_tmp_12_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_698 + tmp_qloop_383*tmp_qloop_697 + tmp_qloop_387*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_696);
                   const real_t q_tmp_12_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_698 + tmp_qloop_397*tmp_qloop_697 + tmp_qloop_401*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_696);
                   const real_t q_tmp_12_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_698 + tmp_qloop_411*tmp_qloop_697 + tmp_qloop_415*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_696);
                   const real_t q_tmp_12_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_698 + tmp_qloop_425*tmp_qloop_697 + tmp_qloop_429*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_696);
                   const real_t q_tmp_12_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_699 + tmp_qloop_693 + tmp_qloop_700) - tmp_qloop_435*tmp_qloop_696);
                   const real_t q_tmp_12_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_699 + tmp_qloop_680 + tmp_qloop_701) - tmp_qloop_452*tmp_qloop_696);
                   const real_t q_tmp_12_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_699 + tmp_qloop_681 + tmp_qloop_701) - tmp_qloop_467*tmp_qloop_696);
                   const real_t q_tmp_12_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_699 + tmp_qloop_682 + tmp_qloop_701) - tmp_qloop_482*tmp_qloop_696);
                   const real_t q_tmp_12_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_699 + tmp_qloop_683 + tmp_qloop_701) - tmp_qloop_497*tmp_qloop_696);
                   const real_t q_tmp_12_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_699 + tmp_qloop_684 + tmp_qloop_701) - tmp_qloop_512*tmp_qloop_696);
                   const real_t q_tmp_12_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_699 + tmp_qloop_685 + tmp_qloop_701) - tmp_qloop_527*tmp_qloop_696);
                   const real_t q_tmp_12_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_699 + tmp_qloop_686 + tmp_qloop_701) - tmp_qloop_542*tmp_qloop_696);
                   const real_t q_tmp_12_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_699 + tmp_qloop_687 + tmp_qloop_701) - tmp_qloop_557*tmp_qloop_696);
                   const real_t q_tmp_12_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_699 + tmp_qloop_688 + tmp_qloop_701) - tmp_qloop_572*tmp_qloop_696);
                   const real_t q_tmp_13_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_704 + tmp_qloop_341*tmp_qloop_703 + tmp_qloop_345*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_702);
                   const real_t q_tmp_13_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_704 + tmp_qloop_355*tmp_qloop_703 + tmp_qloop_359*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_702);
                   const real_t q_tmp_13_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_704 + tmp_qloop_369*tmp_qloop_703 + tmp_qloop_373*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_702);
                   const real_t q_tmp_13_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_704 + tmp_qloop_383*tmp_qloop_703 + tmp_qloop_387*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_702);
                   const real_t q_tmp_13_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_704 + tmp_qloop_397*tmp_qloop_703 + tmp_qloop_401*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_702);
                   const real_t q_tmp_13_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_704 + tmp_qloop_411*tmp_qloop_703 + tmp_qloop_415*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_702);
                   const real_t q_tmp_13_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_704 + tmp_qloop_425*tmp_qloop_703 + tmp_qloop_429*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_702);
                   const real_t q_tmp_13_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_705 + tmp_qloop_693 + tmp_qloop_706) - tmp_qloop_435*tmp_qloop_702);
                   const real_t q_tmp_13_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_705 + tmp_qloop_680 + tmp_qloop_707) - tmp_qloop_452*tmp_qloop_702);
                   const real_t q_tmp_13_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_705 + tmp_qloop_681 + tmp_qloop_707) - tmp_qloop_467*tmp_qloop_702);
                   const real_t q_tmp_13_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_705 + tmp_qloop_682 + tmp_qloop_707) - tmp_qloop_482*tmp_qloop_702);
                   const real_t q_tmp_13_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_705 + tmp_qloop_683 + tmp_qloop_707) - tmp_qloop_497*tmp_qloop_702);
                   const real_t q_tmp_13_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_705 + tmp_qloop_684 + tmp_qloop_707) - tmp_qloop_512*tmp_qloop_702);
                   const real_t q_tmp_13_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_705 + tmp_qloop_685 + tmp_qloop_707) - tmp_qloop_527*tmp_qloop_702);
                   const real_t q_tmp_13_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_705 + tmp_qloop_686 + tmp_qloop_707) - tmp_qloop_542*tmp_qloop_702);
                   const real_t q_tmp_13_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_705 + tmp_qloop_687 + tmp_qloop_707) - tmp_qloop_557*tmp_qloop_702);
                   const real_t q_tmp_13_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_705 + tmp_qloop_688 + tmp_qloop_707) - tmp_qloop_572*tmp_qloop_702);
                   const real_t q_tmp_14_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_710 + tmp_qloop_355*tmp_qloop_709 + tmp_qloop_359*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_708);
                   const real_t q_tmp_14_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_710 + tmp_qloop_369*tmp_qloop_709 + tmp_qloop_373*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_708);
                   const real_t q_tmp_14_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_710 + tmp_qloop_383*tmp_qloop_709 + tmp_qloop_387*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_708);
                   const real_t q_tmp_14_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_710 + tmp_qloop_397*tmp_qloop_709 + tmp_qloop_401*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_708);
                   const real_t q_tmp_14_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_710 + tmp_qloop_411*tmp_qloop_709 + tmp_qloop_415*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_708);
                   const real_t q_tmp_14_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_710 + tmp_qloop_425*tmp_qloop_709 + tmp_qloop_429*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_708);
                   const real_t q_tmp_14_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_711 + tmp_qloop_693 + tmp_qloop_712) - tmp_qloop_435*tmp_qloop_708);
                   const real_t q_tmp_14_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_711 + tmp_qloop_680 + tmp_qloop_713) - tmp_qloop_452*tmp_qloop_708);
                   const real_t q_tmp_14_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_711 + tmp_qloop_681 + tmp_qloop_713) - tmp_qloop_467*tmp_qloop_708);
                   const real_t q_tmp_14_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_711 + tmp_qloop_682 + tmp_qloop_713) - tmp_qloop_482*tmp_qloop_708);
                   const real_t q_tmp_14_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_711 + tmp_qloop_683 + tmp_qloop_713) - tmp_qloop_497*tmp_qloop_708);
                   const real_t q_tmp_14_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_711 + tmp_qloop_684 + tmp_qloop_713) - tmp_qloop_512*tmp_qloop_708);
                   const real_t q_tmp_14_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_711 + tmp_qloop_685 + tmp_qloop_713) - tmp_qloop_527*tmp_qloop_708);
                   const real_t q_tmp_14_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_711 + tmp_qloop_686 + tmp_qloop_713) - tmp_qloop_542*tmp_qloop_708);
                   const real_t q_tmp_14_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_711 + tmp_qloop_687 + tmp_qloop_713) - tmp_qloop_557*tmp_qloop_708);
                   const real_t q_tmp_14_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_711 + tmp_qloop_688 + tmp_qloop_713) - tmp_qloop_572*tmp_qloop_708);
                   const real_t q_tmp_15_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_716 + tmp_qloop_369*tmp_qloop_715 + tmp_qloop_373*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_714);
                   const real_t q_tmp_15_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_716 + tmp_qloop_383*tmp_qloop_715 + tmp_qloop_387*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_714);
                   const real_t q_tmp_15_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_716 + tmp_qloop_397*tmp_qloop_715 + tmp_qloop_401*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_714);
                   const real_t q_tmp_15_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_716 + tmp_qloop_411*tmp_qloop_715 + tmp_qloop_415*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_714);
                   const real_t q_tmp_15_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_716 + tmp_qloop_425*tmp_qloop_715 + tmp_qloop_429*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_714);
                   const real_t q_tmp_15_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_717 + tmp_qloop_693 + tmp_qloop_718) - tmp_qloop_435*tmp_qloop_714);
                   const real_t q_tmp_15_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_717 + tmp_qloop_680 + tmp_qloop_719) - tmp_qloop_452*tmp_qloop_714);
                   const real_t q_tmp_15_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_717 + tmp_qloop_681 + tmp_qloop_719) - tmp_qloop_467*tmp_qloop_714);
                   const real_t q_tmp_15_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_717 + tmp_qloop_682 + tmp_qloop_719) - tmp_qloop_482*tmp_qloop_714);
                   const real_t q_tmp_15_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_717 + tmp_qloop_683 + tmp_qloop_719) - tmp_qloop_497*tmp_qloop_714);
                   const real_t q_tmp_15_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_717 + tmp_qloop_684 + tmp_qloop_719) - tmp_qloop_512*tmp_qloop_714);
                   const real_t q_tmp_15_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_717 + tmp_qloop_685 + tmp_qloop_719) - tmp_qloop_527*tmp_qloop_714);
                   const real_t q_tmp_15_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_717 + tmp_qloop_686 + tmp_qloop_719) - tmp_qloop_542*tmp_qloop_714);
                   const real_t q_tmp_15_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_717 + tmp_qloop_687 + tmp_qloop_719) - tmp_qloop_557*tmp_qloop_714);
                   const real_t q_tmp_15_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_717 + tmp_qloop_688 + tmp_qloop_719) - tmp_qloop_572*tmp_qloop_714);
                   const real_t q_tmp_16_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_722 + tmp_qloop_383*tmp_qloop_721 + tmp_qloop_387*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_720);
                   const real_t q_tmp_16_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_722 + tmp_qloop_397*tmp_qloop_721 + tmp_qloop_401*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_720);
                   const real_t q_tmp_16_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_722 + tmp_qloop_411*tmp_qloop_721 + tmp_qloop_415*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_720);
                   const real_t q_tmp_16_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_722 + tmp_qloop_425*tmp_qloop_721 + tmp_qloop_429*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_720);
                   const real_t q_tmp_16_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_723 + tmp_qloop_693 + tmp_qloop_724) - tmp_qloop_435*tmp_qloop_720);
                   const real_t q_tmp_16_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_723 + tmp_qloop_680 + tmp_qloop_725) - tmp_qloop_452*tmp_qloop_720);
                   const real_t q_tmp_16_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_723 + tmp_qloop_681 + tmp_qloop_725) - tmp_qloop_467*tmp_qloop_720);
                   const real_t q_tmp_16_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_723 + tmp_qloop_682 + tmp_qloop_725) - tmp_qloop_482*tmp_qloop_720);
                   const real_t q_tmp_16_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_723 + tmp_qloop_683 + tmp_qloop_725) - tmp_qloop_497*tmp_qloop_720);
                   const real_t q_tmp_16_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_723 + tmp_qloop_684 + tmp_qloop_725) - tmp_qloop_512*tmp_qloop_720);
                   const real_t q_tmp_16_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_723 + tmp_qloop_685 + tmp_qloop_725) - tmp_qloop_527*tmp_qloop_720);
                   const real_t q_tmp_16_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_723 + tmp_qloop_686 + tmp_qloop_725) - tmp_qloop_542*tmp_qloop_720);
                   const real_t q_tmp_16_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_723 + tmp_qloop_687 + tmp_qloop_725) - tmp_qloop_557*tmp_qloop_720);
                   const real_t q_tmp_16_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_723 + tmp_qloop_688 + tmp_qloop_725) - tmp_qloop_572*tmp_qloop_720);
                   const real_t q_tmp_17_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_728 + tmp_qloop_397*tmp_qloop_727 + tmp_qloop_401*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_726);
                   const real_t q_tmp_17_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_728 + tmp_qloop_411*tmp_qloop_727 + tmp_qloop_415*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_726);
                   const real_t q_tmp_17_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_728 + tmp_qloop_425*tmp_qloop_727 + tmp_qloop_429*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_726);
                   const real_t q_tmp_17_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_729 + tmp_qloop_693 + tmp_qloop_730) - tmp_qloop_435*tmp_qloop_726);
                   const real_t q_tmp_17_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_729 + tmp_qloop_680 + tmp_qloop_731) - tmp_qloop_452*tmp_qloop_726);
                   const real_t q_tmp_17_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_729 + tmp_qloop_681 + tmp_qloop_731) - tmp_qloop_467*tmp_qloop_726);
                   const real_t q_tmp_17_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_729 + tmp_qloop_682 + tmp_qloop_731) - tmp_qloop_482*tmp_qloop_726);
                   const real_t q_tmp_17_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_729 + tmp_qloop_683 + tmp_qloop_731) - tmp_qloop_497*tmp_qloop_726);
                   const real_t q_tmp_17_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_729 + tmp_qloop_684 + tmp_qloop_731) - tmp_qloop_512*tmp_qloop_726);
                   const real_t q_tmp_17_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_729 + tmp_qloop_685 + tmp_qloop_731) - tmp_qloop_527*tmp_qloop_726);
                   const real_t q_tmp_17_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_729 + tmp_qloop_686 + tmp_qloop_731) - tmp_qloop_542*tmp_qloop_726);
                   const real_t q_tmp_17_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_729 + tmp_qloop_687 + tmp_qloop_731) - tmp_qloop_557*tmp_qloop_726);
                   const real_t q_tmp_17_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_729 + tmp_qloop_688 + tmp_qloop_731) - tmp_qloop_572*tmp_qloop_726);
                   const real_t q_tmp_18_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_734 + tmp_qloop_411*tmp_qloop_733 + tmp_qloop_415*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_732);
                   const real_t q_tmp_18_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_734 + tmp_qloop_425*tmp_qloop_733 + tmp_qloop_429*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_732);
                   const real_t q_tmp_18_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_735 + tmp_qloop_693 + tmp_qloop_736) - tmp_qloop_435*tmp_qloop_732);
                   const real_t q_tmp_18_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_735 + tmp_qloop_680 + tmp_qloop_737) - tmp_qloop_452*tmp_qloop_732);
                   const real_t q_tmp_18_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_735 + tmp_qloop_681 + tmp_qloop_737) - tmp_qloop_467*tmp_qloop_732);
                   const real_t q_tmp_18_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_735 + tmp_qloop_682 + tmp_qloop_737) - tmp_qloop_482*tmp_qloop_732);
                   const real_t q_tmp_18_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_735 + tmp_qloop_683 + tmp_qloop_737) - tmp_qloop_497*tmp_qloop_732);
                   const real_t q_tmp_18_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_735 + tmp_qloop_684 + tmp_qloop_737) - tmp_qloop_512*tmp_qloop_732);
                   const real_t q_tmp_18_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_735 + tmp_qloop_685 + tmp_qloop_737) - tmp_qloop_527*tmp_qloop_732);
                   const real_t q_tmp_18_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_735 + tmp_qloop_686 + tmp_qloop_737) - tmp_qloop_542*tmp_qloop_732);
                   const real_t q_tmp_18_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_735 + tmp_qloop_687 + tmp_qloop_737) - tmp_qloop_557*tmp_qloop_732);
                   const real_t q_tmp_18_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_735 + tmp_qloop_688 + tmp_qloop_737) - tmp_qloop_572*tmp_qloop_732);
                   const real_t q_tmp_19_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_740 + tmp_qloop_425*tmp_qloop_739 + tmp_qloop_429*tmp_qloop_741 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_738);
                   const real_t q_tmp_19_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_741 + tmp_qloop_693 + tmp_qloop_742) - tmp_qloop_435*tmp_qloop_738);
                   const real_t q_tmp_19_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_741 + tmp_qloop_680 + tmp_qloop_743) - tmp_qloop_452*tmp_qloop_738);
                   const real_t q_tmp_19_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_741 + tmp_qloop_681 + tmp_qloop_743) - tmp_qloop_467*tmp_qloop_738);
                   const real_t q_tmp_19_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_741 + tmp_qloop_682 + tmp_qloop_743) - tmp_qloop_482*tmp_qloop_738);
                   const real_t q_tmp_19_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_741 + tmp_qloop_683 + tmp_qloop_743) - tmp_qloop_497*tmp_qloop_738);
                   const real_t q_tmp_19_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_741 + tmp_qloop_684 + tmp_qloop_743) - tmp_qloop_512*tmp_qloop_738);
                   const real_t q_tmp_19_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_741 + tmp_qloop_685 + tmp_qloop_743) - tmp_qloop_527*tmp_qloop_738);
                   const real_t q_tmp_19_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_741 + tmp_qloop_686 + tmp_qloop_743) - tmp_qloop_542*tmp_qloop_738);
                   const real_t q_tmp_19_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_741 + tmp_qloop_687 + tmp_qloop_743) - tmp_qloop_557*tmp_qloop_738);
                   const real_t q_tmp_19_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_741 + tmp_qloop_688 + tmp_qloop_743) - tmp_qloop_572*tmp_qloop_738);
                   const real_t q_tmp_20_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_747 + tmp_qloop_442*tmp_qloop_746 + tmp_qloop_447*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_435*tmp_qloop_745);
                   const real_t q_tmp_20_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_747 + tmp_qloop_457*tmp_qloop_746 + tmp_qloop_462*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_745);
                   const real_t q_tmp_20_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_747 + tmp_qloop_472*tmp_qloop_746 + tmp_qloop_477*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_745);
                   const real_t q_tmp_20_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_747 + tmp_qloop_487*tmp_qloop_746 + tmp_qloop_492*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_745);
                   const real_t q_tmp_20_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_747 + tmp_qloop_502*tmp_qloop_746 + tmp_qloop_507*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_745);
                   const real_t q_tmp_20_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_747 + tmp_qloop_517*tmp_qloop_746 + tmp_qloop_522*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_745);
                   const real_t q_tmp_20_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_747 + tmp_qloop_532*tmp_qloop_746 + tmp_qloop_537*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_745);
                   const real_t q_tmp_20_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_747 + tmp_qloop_547*tmp_qloop_746 + tmp_qloop_552*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_745);
                   const real_t q_tmp_20_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_747 + tmp_qloop_562*tmp_qloop_746 + tmp_qloop_567*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_745);
                   const real_t q_tmp_20_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_747 + tmp_qloop_577*tmp_qloop_746 + tmp_qloop_582*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_745);
                   const real_t q_tmp_21_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_752 + tmp_qloop_457*tmp_qloop_751 + tmp_qloop_462*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_750);
                   const real_t q_tmp_21_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_752 + tmp_qloop_472*tmp_qloop_751 + tmp_qloop_477*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_750);
                   const real_t q_tmp_21_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_752 + tmp_qloop_487*tmp_qloop_751 + tmp_qloop_492*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_750);
                   const real_t q_tmp_21_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_752 + tmp_qloop_502*tmp_qloop_751 + tmp_qloop_507*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_750);
                   const real_t q_tmp_21_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_752 + tmp_qloop_517*tmp_qloop_751 + tmp_qloop_522*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_750);
                   const real_t q_tmp_21_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_752 + tmp_qloop_532*tmp_qloop_751 + tmp_qloop_537*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_750);
                   const real_t q_tmp_21_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_752 + tmp_qloop_547*tmp_qloop_751 + tmp_qloop_552*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_750);
                   const real_t q_tmp_21_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_752 + tmp_qloop_562*tmp_qloop_751 + tmp_qloop_567*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_750);
                   const real_t q_tmp_21_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_752 + tmp_qloop_577*tmp_qloop_751 + tmp_qloop_582*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_750);
                   const real_t q_tmp_22_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_756 + tmp_qloop_472*tmp_qloop_755 + tmp_qloop_477*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_754);
                   const real_t q_tmp_22_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_756 + tmp_qloop_487*tmp_qloop_755 + tmp_qloop_492*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_754);
                   const real_t q_tmp_22_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_756 + tmp_qloop_502*tmp_qloop_755 + tmp_qloop_507*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_754);
                   const real_t q_tmp_22_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_756 + tmp_qloop_517*tmp_qloop_755 + tmp_qloop_522*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_754);
                   const real_t q_tmp_22_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_756 + tmp_qloop_532*tmp_qloop_755 + tmp_qloop_537*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_754);
                   const real_t q_tmp_22_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_756 + tmp_qloop_547*tmp_qloop_755 + tmp_qloop_552*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_754);
                   const real_t q_tmp_22_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_756 + tmp_qloop_562*tmp_qloop_755 + tmp_qloop_567*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_754);
                   const real_t q_tmp_22_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_756 + tmp_qloop_577*tmp_qloop_755 + tmp_qloop_582*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_754);
                   const real_t q_tmp_23_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_760 + tmp_qloop_487*tmp_qloop_759 + tmp_qloop_492*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_758);
                   const real_t q_tmp_23_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_760 + tmp_qloop_502*tmp_qloop_759 + tmp_qloop_507*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_758);
                   const real_t q_tmp_23_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_760 + tmp_qloop_517*tmp_qloop_759 + tmp_qloop_522*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_758);
                   const real_t q_tmp_23_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_760 + tmp_qloop_532*tmp_qloop_759 + tmp_qloop_537*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_758);
                   const real_t q_tmp_23_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_760 + tmp_qloop_547*tmp_qloop_759 + tmp_qloop_552*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_758);
                   const real_t q_tmp_23_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_760 + tmp_qloop_562*tmp_qloop_759 + tmp_qloop_567*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_758);
                   const real_t q_tmp_23_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_760 + tmp_qloop_577*tmp_qloop_759 + tmp_qloop_582*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_758);
                   const real_t q_tmp_24_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_764 + tmp_qloop_502*tmp_qloop_763 + tmp_qloop_507*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_762);
                   const real_t q_tmp_24_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_764 + tmp_qloop_517*tmp_qloop_763 + tmp_qloop_522*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_762);
                   const real_t q_tmp_24_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_764 + tmp_qloop_532*tmp_qloop_763 + tmp_qloop_537*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_762);
                   const real_t q_tmp_24_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_764 + tmp_qloop_547*tmp_qloop_763 + tmp_qloop_552*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_762);
                   const real_t q_tmp_24_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_764 + tmp_qloop_562*tmp_qloop_763 + tmp_qloop_567*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_762);
                   const real_t q_tmp_24_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_764 + tmp_qloop_577*tmp_qloop_763 + tmp_qloop_582*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_762);
                   const real_t q_tmp_25_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_768 + tmp_qloop_517*tmp_qloop_767 + tmp_qloop_522*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_766);
                   const real_t q_tmp_25_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_768 + tmp_qloop_532*tmp_qloop_767 + tmp_qloop_537*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_766);
                   const real_t q_tmp_25_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_768 + tmp_qloop_547*tmp_qloop_767 + tmp_qloop_552*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_766);
                   const real_t q_tmp_25_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_768 + tmp_qloop_562*tmp_qloop_767 + tmp_qloop_567*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_766);
                   const real_t q_tmp_25_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_768 + tmp_qloop_577*tmp_qloop_767 + tmp_qloop_582*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_766);
                   const real_t q_tmp_26_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_772 + tmp_qloop_532*tmp_qloop_771 + tmp_qloop_537*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_770);
                   const real_t q_tmp_26_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_772 + tmp_qloop_547*tmp_qloop_771 + tmp_qloop_552*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_770);
                   const real_t q_tmp_26_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_772 + tmp_qloop_562*tmp_qloop_771 + tmp_qloop_567*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_770);
                   const real_t q_tmp_26_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_772 + tmp_qloop_577*tmp_qloop_771 + tmp_qloop_582*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_770);
                   const real_t q_tmp_27_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_776 + tmp_qloop_547*tmp_qloop_775 + tmp_qloop_552*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_774);
                   const real_t q_tmp_27_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_776 + tmp_qloop_562*tmp_qloop_775 + tmp_qloop_567*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_774);
                   const real_t q_tmp_27_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_776 + tmp_qloop_577*tmp_qloop_775 + tmp_qloop_582*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_774);
                   const real_t q_tmp_28_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_780 + tmp_qloop_562*tmp_qloop_779 + tmp_qloop_567*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_778);
                   const real_t q_tmp_28_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_780 + tmp_qloop_577*tmp_qloop_779 + tmp_qloop_582*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_778);
                   const real_t q_tmp_29_29 = tmp_qloop_156*(-tmp_qloop_118*tmp_qloop_572*(tmp_qloop_569 + tmp_qloop_570 + tmp_qloop_571 + tmp_qloop_744) + tmp_qloop_118*(tmp_qloop_576*(tmp_qloop_573*0.5 + tmp_qloop_574*0.5 + tmp_qloop_575*0.5 + tmp_qloop_675)*2.0 + tmp_qloop_577*(tmp_qloop_569*1.0 + tmp_qloop_570*1.0 + tmp_qloop_571*1.0) + tmp_qloop_582*(tmp_qloop_153 + tmp_qloop_579*0.5 + tmp_qloop_580*0.5 + tmp_qloop_581*0.5)*2.0 + tmp_qloop_749));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                   q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                   q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                   q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                   q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                   q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                   q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                   q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                   q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                   q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                   q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                   q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                   q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                   q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                   q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                   q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                   q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                   q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                   q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                   q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                   q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                   q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                   q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                   q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                   q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                   q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                   q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                   q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                   q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                   q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                   q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                   q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                   q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                   q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                   q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                   q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                   q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                   q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                   q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                   q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                   q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                   q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                   q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                   q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                   q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                   q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                   q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                   q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                   q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                   q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                   q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                   q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                   q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                   q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                   q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                   q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                   q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                   q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                   q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                   q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                   q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                   q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                   q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                   q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                   q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                   q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                   q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                   q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                   q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                   q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                   q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                   q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                   q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                   q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                   q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                   q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                   q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                   q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                   q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                   q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                   q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                   q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                   q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                   q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                   q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                   q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                   q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                   q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                   q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                   q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                   q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                   q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                   q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                   q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                   q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                   q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                   q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                   q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                   q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                   q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                   q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                   q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                   q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                   q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                   q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                   q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                   q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                   q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                   q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                   q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                   q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                   q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                   q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                   q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                   q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                   q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                   q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                   q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                   q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                   q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                   q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                   q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                   q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                   q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                   q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                   q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                   q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                   q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                   q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                   q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                   q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                   q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                   q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                   q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                   q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                   q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                   q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                   q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                   q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                   q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                   q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                   q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                   q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                   q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                   q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                   q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                   q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                   q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                   q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                   q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                   q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                   q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                   q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                   q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                   q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                   q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                   q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                   q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                   q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                   q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                   q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                   q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                   q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                   q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                   q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                   q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                   q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                   q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                   q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                   q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                   q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                   q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                   q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                   q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                   q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                   q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                   q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                   q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                   q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                   q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                   q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                   q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                   q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                   q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                   q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                   q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                   q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                   q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                   q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                   q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                   q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                   q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                   q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                   q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                   q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                   q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                   q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                   q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                   q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                   q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                   q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                   q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                   q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                   q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                   q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                   q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                   q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                   q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                   q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                   q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                   q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                   q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                   q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                   q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                   q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                   q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                   q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                   q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                   q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                   q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                   q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                   q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                   q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                   q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                   q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                   q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                   q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                   q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                   q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                   q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                   q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                   q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                   q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                   q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                   q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                   q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                   q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                   q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                   q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                   q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                   q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                   q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                   q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                   q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                   q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                   q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                   q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                   q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                   q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                   q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                   q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                   q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                   q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                   q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                   q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                   q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                   q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                   q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                   q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                   q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                   q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                   q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                   q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                   q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                   q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                   q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                   q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                   q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                   q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                   q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                   q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                   q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                   q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                   q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                   q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                   q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                   q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                   q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                   q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                   q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                   q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                   q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                   q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                   q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                   q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                   q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                   q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                   q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                   q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                   q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                   q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                   q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                   q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                   q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                   q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                   q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                   q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                   q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                   q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                   q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                   q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                   q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                   q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                   q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                   q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                   q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                   q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                   q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                   q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                   q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                   q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                   q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                   q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                   q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                   q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                   q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                   q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                   q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                   q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                   q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                   q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                   q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                   q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                   q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                   q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                   q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                   q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                   q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                   q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                   q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                   q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                   q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                   q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                   q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                   q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                   q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                   q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                   q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                   q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                   q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                   q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
                const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
                const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
                const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
                const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
                const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
                const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
                const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
                const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
                const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
                const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
                const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
                const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
                const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
                const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
                const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
                const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
                const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_17 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_27 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {0.25, 0.25, 0.25, 0.25, 0.16666666666666674, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666671, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666671, 0.5, 0.16666666666666666, 0.16666666666666666, 0.50000000000000011, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(abs_det_jac_affine_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(abs_det_jac_affine_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(abs_det_jac_affine_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_12 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_13 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_14 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_15 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d src_dof_16 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_17 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_18 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_19 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_20 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_21 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_22 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_23 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_24 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_25 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d src_dof_26 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_27 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_28 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_29 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[4*q],_data_phi_0_0_WHITE_DOWN[4*q],_data_phi_0_0_WHITE_DOWN[4*q],_data_phi_0_0_WHITE_DOWN[4*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[4*q + 1],_data_phi_0_0_WHITE_DOWN[4*q + 1],_data_phi_0_0_WHITE_DOWN[4*q + 1],_data_phi_0_0_WHITE_DOWN[4*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[4*q + 2],_data_phi_0_0_WHITE_DOWN[4*q + 2],_data_phi_0_0_WHITE_DOWN[4*q + 2],_data_phi_0_0_WHITE_DOWN[4*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_WHITE_DOWN[4*q + 3],_data_phi_0_0_WHITE_DOWN[4*q + 3],_data_phi_0_0_WHITE_DOWN[4*q + 3],_data_phi_0_0_WHITE_DOWN[4*q + 3]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_436 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_453 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_468 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_483 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_498 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_513 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_528 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_543 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_558 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_573 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q]));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_444 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_459 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_474 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_489 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_504 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_519 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_534 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_549 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_564 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_579 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q]));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_257 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_342 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_449 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_464 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_479 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_494 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_509 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_524 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_539 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_554 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_569 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_134 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_236 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_437 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_454 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_469 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_484 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_499 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_514 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_529 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_544 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_559 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_574 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_445 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_460 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_475 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_490 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_505 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_520 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_535 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_550 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_565 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_580 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_343 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_432 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_450 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_465 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_480 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_495 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_510 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_525 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_540 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_555 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_570 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_126 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_124,tmp_qloop_125),tmp_qloop_126);
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_125,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_126,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_134),tmp_qloop_135);
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_134,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_135,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_187 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_213 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_226 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_237 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_239 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_265 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_280 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_291 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(tmp_qloop_120,tmp_qloop_291);
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_438 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_455 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_470 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_485 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_500 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_515 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_530 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_545 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_560 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_575 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_585 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_589 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_585);
                   const __m256d tmp_qloop_596 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_599 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_596);
                   const __m256d tmp_qloop_605 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_608 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_605);
                   const __m256d tmp_qloop_614 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_617 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_614);
                   const __m256d tmp_qloop_623 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_626 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_623);
                   const __m256d tmp_qloop_632 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_635 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_632);
                   const __m256d tmp_qloop_641 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_644 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_641);
                   const __m256d tmp_qloop_650 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_653 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_650);
                   const __m256d tmp_qloop_659 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_662 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_659);
                   const __m256d tmp_qloop_667 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_277,tmp_qloop_278),tmp_qloop_279);
                   const __m256d tmp_qloop_674 = _mm256_mul_pd(tmp_qloop_291,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(1.0,1.0,1.0,1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_121),tmp_qloop_122),tmp_qloop_123);
                   const __m256d tmp_qloop_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_139,tmp_qloop_140);
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_145),tmp_qloop_146);
                   const __m256d tmp_qloop_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_144,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_145,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_146,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_178 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_191 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_204 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_217 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_230 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_243 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_255 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_269 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_289 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_286,tmp_qloop_287),tmp_qloop_288);
                   const __m256d tmp_qloop_290 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_283,tmp_qloop_284),tmp_qloop_285),tmp_qloop_289);
                   const __m256d tmp_qloop_299 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_312 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_313 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_326 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_327 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_340 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_341 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_354 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_355 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_368 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_369 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_382 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_383 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_396 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_410 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_424 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_434 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_280);
                   const __m256d tmp_qloop_440 = _mm256_add_pd(tmp_qloop_127,tmp_qloop_289);
                   const __m256d tmp_qloop_441 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_440),tmp_qloop_141),tmp_qloop_292);
                   const __m256d tmp_qloop_446 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_461 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_476 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_491 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_506 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_521 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_536 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_551 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_566 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_581 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_586 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_593 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_586),tmp_qloop_589);
                   const __m256d tmp_qloop_594 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_593);
                   const __m256d tmp_qloop_597 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_602 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_597),tmp_qloop_599);
                   const __m256d tmp_qloop_603 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_602);
                   const __m256d tmp_qloop_606 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_611 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_606),tmp_qloop_608);
                   const __m256d tmp_qloop_612 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_611);
                   const __m256d tmp_qloop_615 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_620 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_615),tmp_qloop_617);
                   const __m256d tmp_qloop_621 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_620);
                   const __m256d tmp_qloop_624 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_629 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_624),tmp_qloop_626);
                   const __m256d tmp_qloop_630 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_629);
                   const __m256d tmp_qloop_633 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_638 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_633),tmp_qloop_635);
                   const __m256d tmp_qloop_639 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_638);
                   const __m256d tmp_qloop_642 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_647 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_642),tmp_qloop_644);
                   const __m256d tmp_qloop_648 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_647);
                   const __m256d tmp_qloop_651 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_656 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_651),tmp_qloop_653);
                   const __m256d tmp_qloop_657 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_656);
                   const __m256d tmp_qloop_660 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_665 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_660),tmp_qloop_662);
                   const __m256d tmp_qloop_666 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_665);
                   const __m256d tmp_qloop_670 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_671 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_672 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_283),tmp_qloop_284),tmp_qloop_285);
                   const __m256d tmp_qloop_678 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_670),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_672)),tmp_qloop_674);
                   const __m256d tmp_qloop_690 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_691 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_694 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_690),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_691));
                   const __m256d tmp_qloop_695 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_694);
                   const __m256d tmp_qloop_697 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_698 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_700 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_697),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_698));
                   const __m256d tmp_qloop_701 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_700);
                   const __m256d tmp_qloop_703 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_704 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_706 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_703),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_704));
                   const __m256d tmp_qloop_707 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_706);
                   const __m256d tmp_qloop_709 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_710 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_712 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_709),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_710));
                   const __m256d tmp_qloop_713 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_712);
                   const __m256d tmp_qloop_715 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_716 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_718 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_715),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_716));
                   const __m256d tmp_qloop_719 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_718);
                   const __m256d tmp_qloop_721 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_722 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_724 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_721),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_722));
                   const __m256d tmp_qloop_725 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_724);
                   const __m256d tmp_qloop_727 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_728 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_730 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_727),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_728));
                   const __m256d tmp_qloop_731 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_730);
                   const __m256d tmp_qloop_733 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_734 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_736 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_733),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_734));
                   const __m256d tmp_qloop_737 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_736);
                   const __m256d tmp_qloop_739 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_740 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_742 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_739),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_740));
                   const __m256d tmp_qloop_743 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_742);
                   const __m256d tmp_qloop_744 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_667);
                   const __m256d tmp_qloop_749 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_440,_mm256_add_pd(tmp_qloop_128,tmp_qloop_671)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_141),tmp_qloop_674);
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_117));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_130),tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_142,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q]));
                   const __m256d tmp_qloop_151 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_148,tmp_qloop_149),tmp_qloop_150);
                   const __m256d tmp_qloop_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,_mm256_add_pd(tmp_qloop_147,tmp_qloop_151)),tmp_qloop_141),tmp_qloop_143);
                   const __m256d tmp_qloop_160 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_169 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_199 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_208 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_212 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_221 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_225 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_234 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_246 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_251 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_260 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_264 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_273 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_281 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_280);
                   const __m256d tmp_qloop_282 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_296 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_293,tmp_qloop_294),tmp_qloop_295);
                   const __m256d tmp_qloop_297 = _mm256_add_pd(tmp_qloop_136,tmp_qloop_296);
                   const __m256d tmp_qloop_298 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_297),tmp_qloop_143),tmp_qloop_292);
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_303 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_304 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_299),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_303));
                   const __m256d tmp_qloop_308 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_317 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_318 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_313),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_317));
                   const __m256d tmp_qloop_322 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_331 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_332 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_327),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_331));
                   const __m256d tmp_qloop_336 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_345 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_346 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_341),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_345));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_359 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_360 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_355),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_359));
                   const __m256d tmp_qloop_364 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_373 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_374 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_369),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_373));
                   const __m256d tmp_qloop_378 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_387 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_388 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_383),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_387));
                   const __m256d tmp_qloop_392 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_401 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_402 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_397),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_401));
                   const __m256d tmp_qloop_406 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_416 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_411),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_415));
                   const __m256d tmp_qloop_420 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_429 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_430 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_425),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_429));
                   const __m256d tmp_qloop_433 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_435 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_439 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_442 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_443 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_442);
                   const __m256d tmp_qloop_447 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_448 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_447),tmp_qloop_443);
                   const __m256d tmp_qloop_451 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_452 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_457 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_458 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_457);
                   const __m256d tmp_qloop_462 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_463 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_462),tmp_qloop_458);
                   const __m256d tmp_qloop_466 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_467 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_472 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_473 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_472);
                   const __m256d tmp_qloop_477 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_478 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_477),tmp_qloop_473);
                   const __m256d tmp_qloop_481 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_486 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_487 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_488 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_487);
                   const __m256d tmp_qloop_492 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_493 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_492),tmp_qloop_488);
                   const __m256d tmp_qloop_496 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_497 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_501 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_502 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_503 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_502);
                   const __m256d tmp_qloop_507 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_508 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_507),tmp_qloop_503);
                   const __m256d tmp_qloop_511 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_512 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_516 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_517 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_518 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_517);
                   const __m256d tmp_qloop_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_523 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_522),tmp_qloop_518);
                   const __m256d tmp_qloop_526 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_527 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_531 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_532 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_533 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_532);
                   const __m256d tmp_qloop_537 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_538 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_537),tmp_qloop_533);
                   const __m256d tmp_qloop_541 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_542 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_546 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_547 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_548 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_547);
                   const __m256d tmp_qloop_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_553 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_552),tmp_qloop_548);
                   const __m256d tmp_qloop_556 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_557 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_561 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_562 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_563 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_562);
                   const __m256d tmp_qloop_567 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d tmp_qloop_568 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_567),tmp_qloop_563);
                   const __m256d tmp_qloop_571 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_572 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_576 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_573),tmp_qloop_574),tmp_qloop_575);
                   const __m256d tmp_qloop_577 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_578 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_577);
                   const __m256d tmp_qloop_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_579),tmp_qloop_580),tmp_qloop_581);
                   const __m256d tmp_qloop_583 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_582),tmp_qloop_578);
                   const __m256d tmp_qloop_584 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_157),tmp_qloop_158),tmp_qloop_159));
                   const __m256d tmp_qloop_587 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_588 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_304);
                   const __m256d tmp_qloop_590 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_587),tmp_qloop_589);
                   const __m256d tmp_qloop_591 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_590);
                   const __m256d tmp_qloop_592 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_448);
                   const __m256d tmp_qloop_595 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172));
                   const __m256d tmp_qloop_598 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_600 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_598),tmp_qloop_599);
                   const __m256d tmp_qloop_601 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_600);
                   const __m256d tmp_qloop_604 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_183),tmp_qloop_184),tmp_qloop_185));
                   const __m256d tmp_qloop_607 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_609 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_607),tmp_qloop_608);
                   const __m256d tmp_qloop_610 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_609);
                   const __m256d tmp_qloop_613 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_196),tmp_qloop_197),tmp_qloop_198));
                   const __m256d tmp_qloop_616 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_618 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_616),tmp_qloop_617);
                   const __m256d tmp_qloop_619 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_618);
                   const __m256d tmp_qloop_622 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211));
                   const __m256d tmp_qloop_625 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_627 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_625),tmp_qloop_626);
                   const __m256d tmp_qloop_628 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_627);
                   const __m256d tmp_qloop_631 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_222),tmp_qloop_223),tmp_qloop_224));
                   const __m256d tmp_qloop_634 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_636 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_634),tmp_qloop_635);
                   const __m256d tmp_qloop_637 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_636);
                   const __m256d tmp_qloop_640 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_235),tmp_qloop_236),tmp_qloop_237));
                   const __m256d tmp_qloop_643 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_645 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_643),tmp_qloop_644);
                   const __m256d tmp_qloop_646 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_645);
                   const __m256d tmp_qloop_649 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250));
                   const __m256d tmp_qloop_652 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_654 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_652),tmp_qloop_653);
                   const __m256d tmp_qloop_655 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_654);
                   const __m256d tmp_qloop_658 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263));
                   const __m256d tmp_qloop_661 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_663 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_661),tmp_qloop_662);
                   const __m256d tmp_qloop_664 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_663);
                   const __m256d tmp_qloop_668 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_667);
                   const __m256d tmp_qloop_669 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_274,tmp_qloop_275),tmp_qloop_276),tmp_qloop_668));
                   const __m256d tmp_qloop_673 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_675 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_676 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_677 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_676),tmp_qloop_143),tmp_qloop_674);
                   const __m256d tmp_qloop_679 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_676),tmp_qloop_443);
                   const __m256d tmp_qloop_680 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_676),tmp_qloop_458);
                   const __m256d tmp_qloop_681 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_676),tmp_qloop_473);
                   const __m256d tmp_qloop_682 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_676),tmp_qloop_488);
                   const __m256d tmp_qloop_683 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_676),tmp_qloop_503);
                   const __m256d tmp_qloop_684 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_676),tmp_qloop_518);
                   const __m256d tmp_qloop_685 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_676),tmp_qloop_533);
                   const __m256d tmp_qloop_686 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_676),tmp_qloop_548);
                   const __m256d tmp_qloop_687 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_676),tmp_qloop_563);
                   const __m256d tmp_qloop_688 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_676),tmp_qloop_578);
                   const __m256d tmp_qloop_689 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_305,tmp_qloop_306),tmp_qloop_307),tmp_qloop_668));
                   const __m256d tmp_qloop_692 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_693 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_679);
                   const __m256d tmp_qloop_696 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_319,tmp_qloop_320),tmp_qloop_321),tmp_qloop_668));
                   const __m256d tmp_qloop_699 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_702 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_333,tmp_qloop_334),tmp_qloop_335),tmp_qloop_668));
                   const __m256d tmp_qloop_705 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_708 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_347,tmp_qloop_348),tmp_qloop_349),tmp_qloop_668));
                   const __m256d tmp_qloop_711 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_714 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_361,tmp_qloop_362),tmp_qloop_363),tmp_qloop_668));
                   const __m256d tmp_qloop_717 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_720 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_375,tmp_qloop_376),tmp_qloop_377),tmp_qloop_668));
                   const __m256d tmp_qloop_723 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_726 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_389,tmp_qloop_390),tmp_qloop_391),tmp_qloop_668));
                   const __m256d tmp_qloop_729 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_732 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_403,tmp_qloop_404),tmp_qloop_405),tmp_qloop_668));
                   const __m256d tmp_qloop_735 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_738 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_417,tmp_qloop_418),tmp_qloop_419),tmp_qloop_668));
                   const __m256d tmp_qloop_741 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_745 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_431,tmp_qloop_432),tmp_qloop_433),tmp_qloop_744));
                   const __m256d tmp_qloop_746 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_747 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_748 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_750 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_449,tmp_qloop_450),tmp_qloop_451),tmp_qloop_744));
                   const __m256d tmp_qloop_751 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_752 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_753 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_754 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_464,tmp_qloop_465),tmp_qloop_466),tmp_qloop_744));
                   const __m256d tmp_qloop_755 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_756 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_757 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_758 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_479,tmp_qloop_480),tmp_qloop_481),tmp_qloop_744));
                   const __m256d tmp_qloop_759 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_760 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_761 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_762 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_494,tmp_qloop_495),tmp_qloop_496),tmp_qloop_744));
                   const __m256d tmp_qloop_763 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_764 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_765 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_766 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_509,tmp_qloop_510),tmp_qloop_511),tmp_qloop_744));
                   const __m256d tmp_qloop_767 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_768 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_769 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_770 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_524,tmp_qloop_525),tmp_qloop_526),tmp_qloop_744));
                   const __m256d tmp_qloop_771 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_772 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_773 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_774 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_539,tmp_qloop_540),tmp_qloop_541),tmp_qloop_744));
                   const __m256d tmp_qloop_775 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_776 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_777 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_778 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_554,tmp_qloop_555),tmp_qloop_556),tmp_qloop_744));
                   const __m256d tmp_qloop_779 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_780 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_781 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(tmp_qloop_129,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_121,tmp_qloop_122),tmp_qloop_123),tmp_qloop_127))),_mm256_mul_pd(tmp_qloop_138,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132),tmp_qloop_136))),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_161),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_165)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_169)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_160),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_178)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_182)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_187),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_191)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_195)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_186),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_200),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_204)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_208)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_213),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_217)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_221)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_212),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_226),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_230)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_234)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_225),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_239),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_243)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_247)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_238),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_252),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_256)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_260)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_251),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_265),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_269)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_273)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_264),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_290),tmp_qloop_298),tmp_qloop_304)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_312),tmp_qloop_298),tmp_qloop_318)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_308),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_326),tmp_qloop_298),tmp_qloop_332)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_322),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_340),tmp_qloop_298),tmp_qloop_346)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_336),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_354),tmp_qloop_298),tmp_qloop_360)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_350),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_368),tmp_qloop_298),tmp_qloop_374)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_364),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_382),tmp_qloop_298),tmp_qloop_388)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_378),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_396),tmp_qloop_298),tmp_qloop_402)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_392),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_410),tmp_qloop_298),tmp_qloop_416)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_406),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_424),tmp_qloop_298),tmp_qloop_430)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_420),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_439),tmp_qloop_441),tmp_qloop_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_435),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_456),tmp_qloop_441),tmp_qloop_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_452),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_471),tmp_qloop_441),tmp_qloop_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_467),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_486),tmp_qloop_441),tmp_qloop_493)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_482),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_501),tmp_qloop_441),tmp_qloop_508)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_497),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_516),tmp_qloop_441),tmp_qloop_523)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_512),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_531),tmp_qloop_441),tmp_qloop_538)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_527),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_546),tmp_qloop_441),tmp_qloop_553)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_542),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_561),tmp_qloop_441),tmp_qloop_568)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_557),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_576),tmp_qloop_441),tmp_qloop_583)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_572),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_165,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_169,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_586),tmp_qloop_588),tmp_qloop_590)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_586),tmp_qloop_318),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_586),tmp_qloop_332),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_586),tmp_qloop_346),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_586),tmp_qloop_360),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_586),tmp_qloop_374),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_586),tmp_qloop_388),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_586),tmp_qloop_402),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_586),tmp_qloop_416),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_586),tmp_qloop_430),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_587),tmp_qloop_592),tmp_qloop_593)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_587),tmp_qloop_463),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_587),tmp_qloop_478),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_587),tmp_qloop_493),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_587),tmp_qloop_508),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_587),tmp_qloop_523),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_587),tmp_qloop_538),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_587),tmp_qloop_553),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_587),tmp_qloop_568),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_587),tmp_qloop_583),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_597),tmp_qloop_588),tmp_qloop_600)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_597),tmp_qloop_318),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_597),tmp_qloop_332),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_597),tmp_qloop_346),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_597),tmp_qloop_360),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_597),tmp_qloop_374),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_597),tmp_qloop_388),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_597),tmp_qloop_402),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_597),tmp_qloop_416),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_597),tmp_qloop_430),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_598),tmp_qloop_592),tmp_qloop_602)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_598),tmp_qloop_463),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_598),tmp_qloop_478),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_598),tmp_qloop_493),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_598),tmp_qloop_508),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_598),tmp_qloop_523),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_598),tmp_qloop_538),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_598),tmp_qloop_553),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_598),tmp_qloop_568),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_598),tmp_qloop_583),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_606),tmp_qloop_588),tmp_qloop_609)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_606),tmp_qloop_318),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_606),tmp_qloop_332),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_606),tmp_qloop_346),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_606),tmp_qloop_360),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_606),tmp_qloop_374),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_606),tmp_qloop_388),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_606),tmp_qloop_402),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_606),tmp_qloop_416),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_606),tmp_qloop_430),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_607),tmp_qloop_592),tmp_qloop_611)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_607),tmp_qloop_463),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_607),tmp_qloop_478),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_607),tmp_qloop_493),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_607),tmp_qloop_508),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_607),tmp_qloop_523),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_607),tmp_qloop_538),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_607),tmp_qloop_553),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_607),tmp_qloop_568),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_607),tmp_qloop_583),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_615),tmp_qloop_588),tmp_qloop_618)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_615),tmp_qloop_318),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_615),tmp_qloop_332),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_615),tmp_qloop_346),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_615),tmp_qloop_360),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_615),tmp_qloop_374),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_615),tmp_qloop_388),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_615),tmp_qloop_402),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_615),tmp_qloop_416),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_615),tmp_qloop_430),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_616),tmp_qloop_592),tmp_qloop_620)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_616),tmp_qloop_463),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_616),tmp_qloop_478),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_616),tmp_qloop_493),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_616),tmp_qloop_508),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_616),tmp_qloop_523),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_616),tmp_qloop_538),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_616),tmp_qloop_553),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_616),tmp_qloop_568),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_616),tmp_qloop_583),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_624),tmp_qloop_588),tmp_qloop_627)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_624),tmp_qloop_318),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_624),tmp_qloop_332),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_624),tmp_qloop_346),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_624),tmp_qloop_360),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_624),tmp_qloop_374),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_624),tmp_qloop_388),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_624),tmp_qloop_402),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_624),tmp_qloop_416),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_624),tmp_qloop_430),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_625),tmp_qloop_592),tmp_qloop_629)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_625),tmp_qloop_463),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_625),tmp_qloop_478),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_625),tmp_qloop_493),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_625),tmp_qloop_508),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_625),tmp_qloop_523),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_625),tmp_qloop_538),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_625),tmp_qloop_553),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_625),tmp_qloop_568),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_625),tmp_qloop_583),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_633),tmp_qloop_588),tmp_qloop_636)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_633),tmp_qloop_318),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_633),tmp_qloop_332),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_633),tmp_qloop_346),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_633),tmp_qloop_360),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_633),tmp_qloop_374),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_633),tmp_qloop_388),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_633),tmp_qloop_402),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_633),tmp_qloop_416),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_633),tmp_qloop_430),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_634),tmp_qloop_592),tmp_qloop_638)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_634),tmp_qloop_463),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_634),tmp_qloop_478),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_634),tmp_qloop_493),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_634),tmp_qloop_508),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_634),tmp_qloop_523),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_634),tmp_qloop_538),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_634),tmp_qloop_553),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_634),tmp_qloop_568),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_634),tmp_qloop_583),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_642),tmp_qloop_588),tmp_qloop_645)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_642),tmp_qloop_318),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_642),tmp_qloop_332),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_642),tmp_qloop_346),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_642),tmp_qloop_360),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_642),tmp_qloop_374),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_642),tmp_qloop_388),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_642),tmp_qloop_402),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_642),tmp_qloop_416),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_642),tmp_qloop_430),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_643),tmp_qloop_592),tmp_qloop_647)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_643),tmp_qloop_463),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_643),tmp_qloop_478),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_643),tmp_qloop_493),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_643),tmp_qloop_508),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_643),tmp_qloop_523),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_643),tmp_qloop_538),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_643),tmp_qloop_553),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_643),tmp_qloop_568),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_643),tmp_qloop_583),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_651),tmp_qloop_588),tmp_qloop_654)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_651),tmp_qloop_318),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_651),tmp_qloop_332),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_651),tmp_qloop_346),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_651),tmp_qloop_360),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_651),tmp_qloop_374),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_651),tmp_qloop_388),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_651),tmp_qloop_402),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_651),tmp_qloop_416),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_651),tmp_qloop_430),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_652),tmp_qloop_592),tmp_qloop_656)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_652),tmp_qloop_463),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_652),tmp_qloop_478),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_652),tmp_qloop_493),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_652),tmp_qloop_508),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_652),tmp_qloop_523),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_652),tmp_qloop_538),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_652),tmp_qloop_553),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_652),tmp_qloop_568),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_652),tmp_qloop_583),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_659),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_660)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_661)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_660),tmp_qloop_588),tmp_qloop_663)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_660),tmp_qloop_318),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_660),tmp_qloop_332),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_660),tmp_qloop_346),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_660),tmp_qloop_360),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_660),tmp_qloop_374),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_660),tmp_qloop_388),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_660),tmp_qloop_402),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_660),tmp_qloop_416),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_660),tmp_qloop_430),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_661),tmp_qloop_592),tmp_qloop_665)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_661),tmp_qloop_463),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_661),tmp_qloop_478),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_661),tmp_qloop_493),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_661),tmp_qloop_508),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_661),tmp_qloop_523),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_661),tmp_qloop_538),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_661),tmp_qloop_553),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_661),tmp_qloop_568),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_661),tmp_qloop_583),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_299,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_303,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_673),tmp_qloop_678),tmp_qloop_679)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_673),tmp_qloop_678),tmp_qloop_680)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_673),tmp_qloop_678),tmp_qloop_681)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_673),tmp_qloop_678),tmp_qloop_682)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_673),tmp_qloop_678),tmp_qloop_683)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_673),tmp_qloop_678),tmp_qloop_684)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_673),tmp_qloop_678),tmp_qloop_685)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_673),tmp_qloop_678),tmp_qloop_686)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_673),tmp_qloop_678),tmp_qloop_687)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_673),tmp_qloop_678),tmp_qloop_688)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_692),tmp_qloop_693),tmp_qloop_694)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_692),tmp_qloop_680),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_692),tmp_qloop_681),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_692),tmp_qloop_682),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_692),tmp_qloop_683),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_692),tmp_qloop_684),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_692),tmp_qloop_685),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_692),tmp_qloop_686),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_692),tmp_qloop_687),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_692),tmp_qloop_688),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_699),tmp_qloop_693),tmp_qloop_700)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_699),tmp_qloop_680),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_699),tmp_qloop_681),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_699),tmp_qloop_682),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_699),tmp_qloop_683),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_699),tmp_qloop_684),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_699),tmp_qloop_685),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_699),tmp_qloop_686),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_699),tmp_qloop_687),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_699),tmp_qloop_688),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_705),tmp_qloop_693),tmp_qloop_706)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_705),tmp_qloop_680),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_705),tmp_qloop_681),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_705),tmp_qloop_682),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_705),tmp_qloop_683),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_705),tmp_qloop_684),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_705),tmp_qloop_685),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_705),tmp_qloop_686),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_705),tmp_qloop_687),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_705),tmp_qloop_688),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_711),tmp_qloop_693),tmp_qloop_712)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_711),tmp_qloop_680),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_711),tmp_qloop_681),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_711),tmp_qloop_682),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_711),tmp_qloop_683),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_711),tmp_qloop_684),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_711),tmp_qloop_685),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_711),tmp_qloop_686),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_711),tmp_qloop_687),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_711),tmp_qloop_688),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_717),tmp_qloop_693),tmp_qloop_718)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_717),tmp_qloop_680),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_717),tmp_qloop_681),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_717),tmp_qloop_682),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_717),tmp_qloop_683),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_717),tmp_qloop_684),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_717),tmp_qloop_685),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_717),tmp_qloop_686),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_717),tmp_qloop_687),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_717),tmp_qloop_688),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_723),tmp_qloop_693),tmp_qloop_724)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_723),tmp_qloop_680),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_723),tmp_qloop_681),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_723),tmp_qloop_682),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_723),tmp_qloop_683),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_723),tmp_qloop_684),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_723),tmp_qloop_685),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_723),tmp_qloop_686),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_723),tmp_qloop_687),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_723),tmp_qloop_688),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_729),tmp_qloop_693),tmp_qloop_730)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_729),tmp_qloop_680),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_729),tmp_qloop_681),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_729),tmp_qloop_682),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_729),tmp_qloop_683),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_729),tmp_qloop_684),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_729),tmp_qloop_685),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_729),tmp_qloop_686),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_729),tmp_qloop_687),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_729),tmp_qloop_688),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_735),tmp_qloop_693),tmp_qloop_736)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_735),tmp_qloop_680),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_735),tmp_qloop_681),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_735),tmp_qloop_682),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_735),tmp_qloop_683),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_735),tmp_qloop_684),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_735),tmp_qloop_685),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_735),tmp_qloop_686),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_735),tmp_qloop_687),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_735),tmp_qloop_688),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_740),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_739)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_741)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_741),tmp_qloop_693),tmp_qloop_742)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_741),tmp_qloop_680),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_741),tmp_qloop_681),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_741),tmp_qloop_682),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_741),tmp_qloop_683),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_741),tmp_qloop_684),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_741),tmp_qloop_685),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_741),tmp_qloop_686),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_741),tmp_qloop_687),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_741),tmp_qloop_688),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_442,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_447,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_577,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(1.0,1.0,1.0,1.0)))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_576,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_573,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_574,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_575,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_675)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_582,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_579,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_580,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_581,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_153)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_572),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_569,tmp_qloop_570),tmp_qloop_571),tmp_qloop_744)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_0_12 = _mm256_add_pd(q_acc_0_12,q_tmp_0_12);
                   q_acc_0_13 = _mm256_add_pd(q_acc_0_13,q_tmp_0_13);
                   q_acc_0_14 = _mm256_add_pd(q_acc_0_14,q_tmp_0_14);
                   q_acc_0_15 = _mm256_add_pd(q_acc_0_15,q_tmp_0_15);
                   q_acc_0_16 = _mm256_add_pd(q_acc_0_16,q_tmp_0_16);
                   q_acc_0_17 = _mm256_add_pd(q_acc_0_17,q_tmp_0_17);
                   q_acc_0_18 = _mm256_add_pd(q_acc_0_18,q_tmp_0_18);
                   q_acc_0_19 = _mm256_add_pd(q_acc_0_19,q_tmp_0_19);
                   q_acc_0_20 = _mm256_add_pd(q_acc_0_20,q_tmp_0_20);
                   q_acc_0_21 = _mm256_add_pd(q_acc_0_21,q_tmp_0_21);
                   q_acc_0_22 = _mm256_add_pd(q_acc_0_22,q_tmp_0_22);
                   q_acc_0_23 = _mm256_add_pd(q_acc_0_23,q_tmp_0_23);
                   q_acc_0_24 = _mm256_add_pd(q_acc_0_24,q_tmp_0_24);
                   q_acc_0_25 = _mm256_add_pd(q_acc_0_25,q_tmp_0_25);
                   q_acc_0_26 = _mm256_add_pd(q_acc_0_26,q_tmp_0_26);
                   q_acc_0_27 = _mm256_add_pd(q_acc_0_27,q_tmp_0_27);
                   q_acc_0_28 = _mm256_add_pd(q_acc_0_28,q_tmp_0_28);
                   q_acc_0_29 = _mm256_add_pd(q_acc_0_29,q_tmp_0_29);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_1_12 = _mm256_add_pd(q_acc_1_12,q_tmp_1_12);
                   q_acc_1_13 = _mm256_add_pd(q_acc_1_13,q_tmp_1_13);
                   q_acc_1_14 = _mm256_add_pd(q_acc_1_14,q_tmp_1_14);
                   q_acc_1_15 = _mm256_add_pd(q_acc_1_15,q_tmp_1_15);
                   q_acc_1_16 = _mm256_add_pd(q_acc_1_16,q_tmp_1_16);
                   q_acc_1_17 = _mm256_add_pd(q_acc_1_17,q_tmp_1_17);
                   q_acc_1_18 = _mm256_add_pd(q_acc_1_18,q_tmp_1_18);
                   q_acc_1_19 = _mm256_add_pd(q_acc_1_19,q_tmp_1_19);
                   q_acc_1_20 = _mm256_add_pd(q_acc_1_20,q_tmp_1_20);
                   q_acc_1_21 = _mm256_add_pd(q_acc_1_21,q_tmp_1_21);
                   q_acc_1_22 = _mm256_add_pd(q_acc_1_22,q_tmp_1_22);
                   q_acc_1_23 = _mm256_add_pd(q_acc_1_23,q_tmp_1_23);
                   q_acc_1_24 = _mm256_add_pd(q_acc_1_24,q_tmp_1_24);
                   q_acc_1_25 = _mm256_add_pd(q_acc_1_25,q_tmp_1_25);
                   q_acc_1_26 = _mm256_add_pd(q_acc_1_26,q_tmp_1_26);
                   q_acc_1_27 = _mm256_add_pd(q_acc_1_27,q_tmp_1_27);
                   q_acc_1_28 = _mm256_add_pd(q_acc_1_28,q_tmp_1_28);
                   q_acc_1_29 = _mm256_add_pd(q_acc_1_29,q_tmp_1_29);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_2_12 = _mm256_add_pd(q_acc_2_12,q_tmp_2_12);
                   q_acc_2_13 = _mm256_add_pd(q_acc_2_13,q_tmp_2_13);
                   q_acc_2_14 = _mm256_add_pd(q_acc_2_14,q_tmp_2_14);
                   q_acc_2_15 = _mm256_add_pd(q_acc_2_15,q_tmp_2_15);
                   q_acc_2_16 = _mm256_add_pd(q_acc_2_16,q_tmp_2_16);
                   q_acc_2_17 = _mm256_add_pd(q_acc_2_17,q_tmp_2_17);
                   q_acc_2_18 = _mm256_add_pd(q_acc_2_18,q_tmp_2_18);
                   q_acc_2_19 = _mm256_add_pd(q_acc_2_19,q_tmp_2_19);
                   q_acc_2_20 = _mm256_add_pd(q_acc_2_20,q_tmp_2_20);
                   q_acc_2_21 = _mm256_add_pd(q_acc_2_21,q_tmp_2_21);
                   q_acc_2_22 = _mm256_add_pd(q_acc_2_22,q_tmp_2_22);
                   q_acc_2_23 = _mm256_add_pd(q_acc_2_23,q_tmp_2_23);
                   q_acc_2_24 = _mm256_add_pd(q_acc_2_24,q_tmp_2_24);
                   q_acc_2_25 = _mm256_add_pd(q_acc_2_25,q_tmp_2_25);
                   q_acc_2_26 = _mm256_add_pd(q_acc_2_26,q_tmp_2_26);
                   q_acc_2_27 = _mm256_add_pd(q_acc_2_27,q_tmp_2_27);
                   q_acc_2_28 = _mm256_add_pd(q_acc_2_28,q_tmp_2_28);
                   q_acc_2_29 = _mm256_add_pd(q_acc_2_29,q_tmp_2_29);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_3_12 = _mm256_add_pd(q_acc_3_12,q_tmp_3_12);
                   q_acc_3_13 = _mm256_add_pd(q_acc_3_13,q_tmp_3_13);
                   q_acc_3_14 = _mm256_add_pd(q_acc_3_14,q_tmp_3_14);
                   q_acc_3_15 = _mm256_add_pd(q_acc_3_15,q_tmp_3_15);
                   q_acc_3_16 = _mm256_add_pd(q_acc_3_16,q_tmp_3_16);
                   q_acc_3_17 = _mm256_add_pd(q_acc_3_17,q_tmp_3_17);
                   q_acc_3_18 = _mm256_add_pd(q_acc_3_18,q_tmp_3_18);
                   q_acc_3_19 = _mm256_add_pd(q_acc_3_19,q_tmp_3_19);
                   q_acc_3_20 = _mm256_add_pd(q_acc_3_20,q_tmp_3_20);
                   q_acc_3_21 = _mm256_add_pd(q_acc_3_21,q_tmp_3_21);
                   q_acc_3_22 = _mm256_add_pd(q_acc_3_22,q_tmp_3_22);
                   q_acc_3_23 = _mm256_add_pd(q_acc_3_23,q_tmp_3_23);
                   q_acc_3_24 = _mm256_add_pd(q_acc_3_24,q_tmp_3_24);
                   q_acc_3_25 = _mm256_add_pd(q_acc_3_25,q_tmp_3_25);
                   q_acc_3_26 = _mm256_add_pd(q_acc_3_26,q_tmp_3_26);
                   q_acc_3_27 = _mm256_add_pd(q_acc_3_27,q_tmp_3_27);
                   q_acc_3_28 = _mm256_add_pd(q_acc_3_28,q_tmp_3_28);
                   q_acc_3_29 = _mm256_add_pd(q_acc_3_29,q_tmp_3_29);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_4_12 = _mm256_add_pd(q_acc_4_12,q_tmp_4_12);
                   q_acc_4_13 = _mm256_add_pd(q_acc_4_13,q_tmp_4_13);
                   q_acc_4_14 = _mm256_add_pd(q_acc_4_14,q_tmp_4_14);
                   q_acc_4_15 = _mm256_add_pd(q_acc_4_15,q_tmp_4_15);
                   q_acc_4_16 = _mm256_add_pd(q_acc_4_16,q_tmp_4_16);
                   q_acc_4_17 = _mm256_add_pd(q_acc_4_17,q_tmp_4_17);
                   q_acc_4_18 = _mm256_add_pd(q_acc_4_18,q_tmp_4_18);
                   q_acc_4_19 = _mm256_add_pd(q_acc_4_19,q_tmp_4_19);
                   q_acc_4_20 = _mm256_add_pd(q_acc_4_20,q_tmp_4_20);
                   q_acc_4_21 = _mm256_add_pd(q_acc_4_21,q_tmp_4_21);
                   q_acc_4_22 = _mm256_add_pd(q_acc_4_22,q_tmp_4_22);
                   q_acc_4_23 = _mm256_add_pd(q_acc_4_23,q_tmp_4_23);
                   q_acc_4_24 = _mm256_add_pd(q_acc_4_24,q_tmp_4_24);
                   q_acc_4_25 = _mm256_add_pd(q_acc_4_25,q_tmp_4_25);
                   q_acc_4_26 = _mm256_add_pd(q_acc_4_26,q_tmp_4_26);
                   q_acc_4_27 = _mm256_add_pd(q_acc_4_27,q_tmp_4_27);
                   q_acc_4_28 = _mm256_add_pd(q_acc_4_28,q_tmp_4_28);
                   q_acc_4_29 = _mm256_add_pd(q_acc_4_29,q_tmp_4_29);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_5_12 = _mm256_add_pd(q_acc_5_12,q_tmp_5_12);
                   q_acc_5_13 = _mm256_add_pd(q_acc_5_13,q_tmp_5_13);
                   q_acc_5_14 = _mm256_add_pd(q_acc_5_14,q_tmp_5_14);
                   q_acc_5_15 = _mm256_add_pd(q_acc_5_15,q_tmp_5_15);
                   q_acc_5_16 = _mm256_add_pd(q_acc_5_16,q_tmp_5_16);
                   q_acc_5_17 = _mm256_add_pd(q_acc_5_17,q_tmp_5_17);
                   q_acc_5_18 = _mm256_add_pd(q_acc_5_18,q_tmp_5_18);
                   q_acc_5_19 = _mm256_add_pd(q_acc_5_19,q_tmp_5_19);
                   q_acc_5_20 = _mm256_add_pd(q_acc_5_20,q_tmp_5_20);
                   q_acc_5_21 = _mm256_add_pd(q_acc_5_21,q_tmp_5_21);
                   q_acc_5_22 = _mm256_add_pd(q_acc_5_22,q_tmp_5_22);
                   q_acc_5_23 = _mm256_add_pd(q_acc_5_23,q_tmp_5_23);
                   q_acc_5_24 = _mm256_add_pd(q_acc_5_24,q_tmp_5_24);
                   q_acc_5_25 = _mm256_add_pd(q_acc_5_25,q_tmp_5_25);
                   q_acc_5_26 = _mm256_add_pd(q_acc_5_26,q_tmp_5_26);
                   q_acc_5_27 = _mm256_add_pd(q_acc_5_27,q_tmp_5_27);
                   q_acc_5_28 = _mm256_add_pd(q_acc_5_28,q_tmp_5_28);
                   q_acc_5_29 = _mm256_add_pd(q_acc_5_29,q_tmp_5_29);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_6_12 = _mm256_add_pd(q_acc_6_12,q_tmp_6_12);
                   q_acc_6_13 = _mm256_add_pd(q_acc_6_13,q_tmp_6_13);
                   q_acc_6_14 = _mm256_add_pd(q_acc_6_14,q_tmp_6_14);
                   q_acc_6_15 = _mm256_add_pd(q_acc_6_15,q_tmp_6_15);
                   q_acc_6_16 = _mm256_add_pd(q_acc_6_16,q_tmp_6_16);
                   q_acc_6_17 = _mm256_add_pd(q_acc_6_17,q_tmp_6_17);
                   q_acc_6_18 = _mm256_add_pd(q_acc_6_18,q_tmp_6_18);
                   q_acc_6_19 = _mm256_add_pd(q_acc_6_19,q_tmp_6_19);
                   q_acc_6_20 = _mm256_add_pd(q_acc_6_20,q_tmp_6_20);
                   q_acc_6_21 = _mm256_add_pd(q_acc_6_21,q_tmp_6_21);
                   q_acc_6_22 = _mm256_add_pd(q_acc_6_22,q_tmp_6_22);
                   q_acc_6_23 = _mm256_add_pd(q_acc_6_23,q_tmp_6_23);
                   q_acc_6_24 = _mm256_add_pd(q_acc_6_24,q_tmp_6_24);
                   q_acc_6_25 = _mm256_add_pd(q_acc_6_25,q_tmp_6_25);
                   q_acc_6_26 = _mm256_add_pd(q_acc_6_26,q_tmp_6_26);
                   q_acc_6_27 = _mm256_add_pd(q_acc_6_27,q_tmp_6_27);
                   q_acc_6_28 = _mm256_add_pd(q_acc_6_28,q_tmp_6_28);
                   q_acc_6_29 = _mm256_add_pd(q_acc_6_29,q_tmp_6_29);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_7_12 = _mm256_add_pd(q_acc_7_12,q_tmp_7_12);
                   q_acc_7_13 = _mm256_add_pd(q_acc_7_13,q_tmp_7_13);
                   q_acc_7_14 = _mm256_add_pd(q_acc_7_14,q_tmp_7_14);
                   q_acc_7_15 = _mm256_add_pd(q_acc_7_15,q_tmp_7_15);
                   q_acc_7_16 = _mm256_add_pd(q_acc_7_16,q_tmp_7_16);
                   q_acc_7_17 = _mm256_add_pd(q_acc_7_17,q_tmp_7_17);
                   q_acc_7_18 = _mm256_add_pd(q_acc_7_18,q_tmp_7_18);
                   q_acc_7_19 = _mm256_add_pd(q_acc_7_19,q_tmp_7_19);
                   q_acc_7_20 = _mm256_add_pd(q_acc_7_20,q_tmp_7_20);
                   q_acc_7_21 = _mm256_add_pd(q_acc_7_21,q_tmp_7_21);
                   q_acc_7_22 = _mm256_add_pd(q_acc_7_22,q_tmp_7_22);
                   q_acc_7_23 = _mm256_add_pd(q_acc_7_23,q_tmp_7_23);
                   q_acc_7_24 = _mm256_add_pd(q_acc_7_24,q_tmp_7_24);
                   q_acc_7_25 = _mm256_add_pd(q_acc_7_25,q_tmp_7_25);
                   q_acc_7_26 = _mm256_add_pd(q_acc_7_26,q_tmp_7_26);
                   q_acc_7_27 = _mm256_add_pd(q_acc_7_27,q_tmp_7_27);
                   q_acc_7_28 = _mm256_add_pd(q_acc_7_28,q_tmp_7_28);
                   q_acc_7_29 = _mm256_add_pd(q_acc_7_29,q_tmp_7_29);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_8_12 = _mm256_add_pd(q_acc_8_12,q_tmp_8_12);
                   q_acc_8_13 = _mm256_add_pd(q_acc_8_13,q_tmp_8_13);
                   q_acc_8_14 = _mm256_add_pd(q_acc_8_14,q_tmp_8_14);
                   q_acc_8_15 = _mm256_add_pd(q_acc_8_15,q_tmp_8_15);
                   q_acc_8_16 = _mm256_add_pd(q_acc_8_16,q_tmp_8_16);
                   q_acc_8_17 = _mm256_add_pd(q_acc_8_17,q_tmp_8_17);
                   q_acc_8_18 = _mm256_add_pd(q_acc_8_18,q_tmp_8_18);
                   q_acc_8_19 = _mm256_add_pd(q_acc_8_19,q_tmp_8_19);
                   q_acc_8_20 = _mm256_add_pd(q_acc_8_20,q_tmp_8_20);
                   q_acc_8_21 = _mm256_add_pd(q_acc_8_21,q_tmp_8_21);
                   q_acc_8_22 = _mm256_add_pd(q_acc_8_22,q_tmp_8_22);
                   q_acc_8_23 = _mm256_add_pd(q_acc_8_23,q_tmp_8_23);
                   q_acc_8_24 = _mm256_add_pd(q_acc_8_24,q_tmp_8_24);
                   q_acc_8_25 = _mm256_add_pd(q_acc_8_25,q_tmp_8_25);
                   q_acc_8_26 = _mm256_add_pd(q_acc_8_26,q_tmp_8_26);
                   q_acc_8_27 = _mm256_add_pd(q_acc_8_27,q_tmp_8_27);
                   q_acc_8_28 = _mm256_add_pd(q_acc_8_28,q_tmp_8_28);
                   q_acc_8_29 = _mm256_add_pd(q_acc_8_29,q_tmp_8_29);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_9_12 = _mm256_add_pd(q_acc_9_12,q_tmp_9_12);
                   q_acc_9_13 = _mm256_add_pd(q_acc_9_13,q_tmp_9_13);
                   q_acc_9_14 = _mm256_add_pd(q_acc_9_14,q_tmp_9_14);
                   q_acc_9_15 = _mm256_add_pd(q_acc_9_15,q_tmp_9_15);
                   q_acc_9_16 = _mm256_add_pd(q_acc_9_16,q_tmp_9_16);
                   q_acc_9_17 = _mm256_add_pd(q_acc_9_17,q_tmp_9_17);
                   q_acc_9_18 = _mm256_add_pd(q_acc_9_18,q_tmp_9_18);
                   q_acc_9_19 = _mm256_add_pd(q_acc_9_19,q_tmp_9_19);
                   q_acc_9_20 = _mm256_add_pd(q_acc_9_20,q_tmp_9_20);
                   q_acc_9_21 = _mm256_add_pd(q_acc_9_21,q_tmp_9_21);
                   q_acc_9_22 = _mm256_add_pd(q_acc_9_22,q_tmp_9_22);
                   q_acc_9_23 = _mm256_add_pd(q_acc_9_23,q_tmp_9_23);
                   q_acc_9_24 = _mm256_add_pd(q_acc_9_24,q_tmp_9_24);
                   q_acc_9_25 = _mm256_add_pd(q_acc_9_25,q_tmp_9_25);
                   q_acc_9_26 = _mm256_add_pd(q_acc_9_26,q_tmp_9_26);
                   q_acc_9_27 = _mm256_add_pd(q_acc_9_27,q_tmp_9_27);
                   q_acc_9_28 = _mm256_add_pd(q_acc_9_28,q_tmp_9_28);
                   q_acc_9_29 = _mm256_add_pd(q_acc_9_29,q_tmp_9_29);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_10_12 = _mm256_add_pd(q_acc_10_12,q_tmp_10_12);
                   q_acc_10_13 = _mm256_add_pd(q_acc_10_13,q_tmp_10_13);
                   q_acc_10_14 = _mm256_add_pd(q_acc_10_14,q_tmp_10_14);
                   q_acc_10_15 = _mm256_add_pd(q_acc_10_15,q_tmp_10_15);
                   q_acc_10_16 = _mm256_add_pd(q_acc_10_16,q_tmp_10_16);
                   q_acc_10_17 = _mm256_add_pd(q_acc_10_17,q_tmp_10_17);
                   q_acc_10_18 = _mm256_add_pd(q_acc_10_18,q_tmp_10_18);
                   q_acc_10_19 = _mm256_add_pd(q_acc_10_19,q_tmp_10_19);
                   q_acc_10_20 = _mm256_add_pd(q_acc_10_20,q_tmp_10_20);
                   q_acc_10_21 = _mm256_add_pd(q_acc_10_21,q_tmp_10_21);
                   q_acc_10_22 = _mm256_add_pd(q_acc_10_22,q_tmp_10_22);
                   q_acc_10_23 = _mm256_add_pd(q_acc_10_23,q_tmp_10_23);
                   q_acc_10_24 = _mm256_add_pd(q_acc_10_24,q_tmp_10_24);
                   q_acc_10_25 = _mm256_add_pd(q_acc_10_25,q_tmp_10_25);
                   q_acc_10_26 = _mm256_add_pd(q_acc_10_26,q_tmp_10_26);
                   q_acc_10_27 = _mm256_add_pd(q_acc_10_27,q_tmp_10_27);
                   q_acc_10_28 = _mm256_add_pd(q_acc_10_28,q_tmp_10_28);
                   q_acc_10_29 = _mm256_add_pd(q_acc_10_29,q_tmp_10_29);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_11_12 = _mm256_add_pd(q_acc_11_12,q_tmp_11_12);
                   q_acc_11_13 = _mm256_add_pd(q_acc_11_13,q_tmp_11_13);
                   q_acc_11_14 = _mm256_add_pd(q_acc_11_14,q_tmp_11_14);
                   q_acc_11_15 = _mm256_add_pd(q_acc_11_15,q_tmp_11_15);
                   q_acc_11_16 = _mm256_add_pd(q_acc_11_16,q_tmp_11_16);
                   q_acc_11_17 = _mm256_add_pd(q_acc_11_17,q_tmp_11_17);
                   q_acc_11_18 = _mm256_add_pd(q_acc_11_18,q_tmp_11_18);
                   q_acc_11_19 = _mm256_add_pd(q_acc_11_19,q_tmp_11_19);
                   q_acc_11_20 = _mm256_add_pd(q_acc_11_20,q_tmp_11_20);
                   q_acc_11_21 = _mm256_add_pd(q_acc_11_21,q_tmp_11_21);
                   q_acc_11_22 = _mm256_add_pd(q_acc_11_22,q_tmp_11_22);
                   q_acc_11_23 = _mm256_add_pd(q_acc_11_23,q_tmp_11_23);
                   q_acc_11_24 = _mm256_add_pd(q_acc_11_24,q_tmp_11_24);
                   q_acc_11_25 = _mm256_add_pd(q_acc_11_25,q_tmp_11_25);
                   q_acc_11_26 = _mm256_add_pd(q_acc_11_26,q_tmp_11_26);
                   q_acc_11_27 = _mm256_add_pd(q_acc_11_27,q_tmp_11_27);
                   q_acc_11_28 = _mm256_add_pd(q_acc_11_28,q_tmp_11_28);
                   q_acc_11_29 = _mm256_add_pd(q_acc_11_29,q_tmp_11_29);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_12_13 = _mm256_add_pd(q_acc_12_13,q_tmp_12_13);
                   q_acc_12_14 = _mm256_add_pd(q_acc_12_14,q_tmp_12_14);
                   q_acc_12_15 = _mm256_add_pd(q_acc_12_15,q_tmp_12_15);
                   q_acc_12_16 = _mm256_add_pd(q_acc_12_16,q_tmp_12_16);
                   q_acc_12_17 = _mm256_add_pd(q_acc_12_17,q_tmp_12_17);
                   q_acc_12_18 = _mm256_add_pd(q_acc_12_18,q_tmp_12_18);
                   q_acc_12_19 = _mm256_add_pd(q_acc_12_19,q_tmp_12_19);
                   q_acc_12_20 = _mm256_add_pd(q_acc_12_20,q_tmp_12_20);
                   q_acc_12_21 = _mm256_add_pd(q_acc_12_21,q_tmp_12_21);
                   q_acc_12_22 = _mm256_add_pd(q_acc_12_22,q_tmp_12_22);
                   q_acc_12_23 = _mm256_add_pd(q_acc_12_23,q_tmp_12_23);
                   q_acc_12_24 = _mm256_add_pd(q_acc_12_24,q_tmp_12_24);
                   q_acc_12_25 = _mm256_add_pd(q_acc_12_25,q_tmp_12_25);
                   q_acc_12_26 = _mm256_add_pd(q_acc_12_26,q_tmp_12_26);
                   q_acc_12_27 = _mm256_add_pd(q_acc_12_27,q_tmp_12_27);
                   q_acc_12_28 = _mm256_add_pd(q_acc_12_28,q_tmp_12_28);
                   q_acc_12_29 = _mm256_add_pd(q_acc_12_29,q_tmp_12_29);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_13_14 = _mm256_add_pd(q_acc_13_14,q_tmp_13_14);
                   q_acc_13_15 = _mm256_add_pd(q_acc_13_15,q_tmp_13_15);
                   q_acc_13_16 = _mm256_add_pd(q_acc_13_16,q_tmp_13_16);
                   q_acc_13_17 = _mm256_add_pd(q_acc_13_17,q_tmp_13_17);
                   q_acc_13_18 = _mm256_add_pd(q_acc_13_18,q_tmp_13_18);
                   q_acc_13_19 = _mm256_add_pd(q_acc_13_19,q_tmp_13_19);
                   q_acc_13_20 = _mm256_add_pd(q_acc_13_20,q_tmp_13_20);
                   q_acc_13_21 = _mm256_add_pd(q_acc_13_21,q_tmp_13_21);
                   q_acc_13_22 = _mm256_add_pd(q_acc_13_22,q_tmp_13_22);
                   q_acc_13_23 = _mm256_add_pd(q_acc_13_23,q_tmp_13_23);
                   q_acc_13_24 = _mm256_add_pd(q_acc_13_24,q_tmp_13_24);
                   q_acc_13_25 = _mm256_add_pd(q_acc_13_25,q_tmp_13_25);
                   q_acc_13_26 = _mm256_add_pd(q_acc_13_26,q_tmp_13_26);
                   q_acc_13_27 = _mm256_add_pd(q_acc_13_27,q_tmp_13_27);
                   q_acc_13_28 = _mm256_add_pd(q_acc_13_28,q_tmp_13_28);
                   q_acc_13_29 = _mm256_add_pd(q_acc_13_29,q_tmp_13_29);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_14_15 = _mm256_add_pd(q_acc_14_15,q_tmp_14_15);
                   q_acc_14_16 = _mm256_add_pd(q_acc_14_16,q_tmp_14_16);
                   q_acc_14_17 = _mm256_add_pd(q_acc_14_17,q_tmp_14_17);
                   q_acc_14_18 = _mm256_add_pd(q_acc_14_18,q_tmp_14_18);
                   q_acc_14_19 = _mm256_add_pd(q_acc_14_19,q_tmp_14_19);
                   q_acc_14_20 = _mm256_add_pd(q_acc_14_20,q_tmp_14_20);
                   q_acc_14_21 = _mm256_add_pd(q_acc_14_21,q_tmp_14_21);
                   q_acc_14_22 = _mm256_add_pd(q_acc_14_22,q_tmp_14_22);
                   q_acc_14_23 = _mm256_add_pd(q_acc_14_23,q_tmp_14_23);
                   q_acc_14_24 = _mm256_add_pd(q_acc_14_24,q_tmp_14_24);
                   q_acc_14_25 = _mm256_add_pd(q_acc_14_25,q_tmp_14_25);
                   q_acc_14_26 = _mm256_add_pd(q_acc_14_26,q_tmp_14_26);
                   q_acc_14_27 = _mm256_add_pd(q_acc_14_27,q_tmp_14_27);
                   q_acc_14_28 = _mm256_add_pd(q_acc_14_28,q_tmp_14_28);
                   q_acc_14_29 = _mm256_add_pd(q_acc_14_29,q_tmp_14_29);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_15_16 = _mm256_add_pd(q_acc_15_16,q_tmp_15_16);
                   q_acc_15_17 = _mm256_add_pd(q_acc_15_17,q_tmp_15_17);
                   q_acc_15_18 = _mm256_add_pd(q_acc_15_18,q_tmp_15_18);
                   q_acc_15_19 = _mm256_add_pd(q_acc_15_19,q_tmp_15_19);
                   q_acc_15_20 = _mm256_add_pd(q_acc_15_20,q_tmp_15_20);
                   q_acc_15_21 = _mm256_add_pd(q_acc_15_21,q_tmp_15_21);
                   q_acc_15_22 = _mm256_add_pd(q_acc_15_22,q_tmp_15_22);
                   q_acc_15_23 = _mm256_add_pd(q_acc_15_23,q_tmp_15_23);
                   q_acc_15_24 = _mm256_add_pd(q_acc_15_24,q_tmp_15_24);
                   q_acc_15_25 = _mm256_add_pd(q_acc_15_25,q_tmp_15_25);
                   q_acc_15_26 = _mm256_add_pd(q_acc_15_26,q_tmp_15_26);
                   q_acc_15_27 = _mm256_add_pd(q_acc_15_27,q_tmp_15_27);
                   q_acc_15_28 = _mm256_add_pd(q_acc_15_28,q_tmp_15_28);
                   q_acc_15_29 = _mm256_add_pd(q_acc_15_29,q_tmp_15_29);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_16_17 = _mm256_add_pd(q_acc_16_17,q_tmp_16_17);
                   q_acc_16_18 = _mm256_add_pd(q_acc_16_18,q_tmp_16_18);
                   q_acc_16_19 = _mm256_add_pd(q_acc_16_19,q_tmp_16_19);
                   q_acc_16_20 = _mm256_add_pd(q_acc_16_20,q_tmp_16_20);
                   q_acc_16_21 = _mm256_add_pd(q_acc_16_21,q_tmp_16_21);
                   q_acc_16_22 = _mm256_add_pd(q_acc_16_22,q_tmp_16_22);
                   q_acc_16_23 = _mm256_add_pd(q_acc_16_23,q_tmp_16_23);
                   q_acc_16_24 = _mm256_add_pd(q_acc_16_24,q_tmp_16_24);
                   q_acc_16_25 = _mm256_add_pd(q_acc_16_25,q_tmp_16_25);
                   q_acc_16_26 = _mm256_add_pd(q_acc_16_26,q_tmp_16_26);
                   q_acc_16_27 = _mm256_add_pd(q_acc_16_27,q_tmp_16_27);
                   q_acc_16_28 = _mm256_add_pd(q_acc_16_28,q_tmp_16_28);
                   q_acc_16_29 = _mm256_add_pd(q_acc_16_29,q_tmp_16_29);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_17_18 = _mm256_add_pd(q_acc_17_18,q_tmp_17_18);
                   q_acc_17_19 = _mm256_add_pd(q_acc_17_19,q_tmp_17_19);
                   q_acc_17_20 = _mm256_add_pd(q_acc_17_20,q_tmp_17_20);
                   q_acc_17_21 = _mm256_add_pd(q_acc_17_21,q_tmp_17_21);
                   q_acc_17_22 = _mm256_add_pd(q_acc_17_22,q_tmp_17_22);
                   q_acc_17_23 = _mm256_add_pd(q_acc_17_23,q_tmp_17_23);
                   q_acc_17_24 = _mm256_add_pd(q_acc_17_24,q_tmp_17_24);
                   q_acc_17_25 = _mm256_add_pd(q_acc_17_25,q_tmp_17_25);
                   q_acc_17_26 = _mm256_add_pd(q_acc_17_26,q_tmp_17_26);
                   q_acc_17_27 = _mm256_add_pd(q_acc_17_27,q_tmp_17_27);
                   q_acc_17_28 = _mm256_add_pd(q_acc_17_28,q_tmp_17_28);
                   q_acc_17_29 = _mm256_add_pd(q_acc_17_29,q_tmp_17_29);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_18_19 = _mm256_add_pd(q_acc_18_19,q_tmp_18_19);
                   q_acc_18_20 = _mm256_add_pd(q_acc_18_20,q_tmp_18_20);
                   q_acc_18_21 = _mm256_add_pd(q_acc_18_21,q_tmp_18_21);
                   q_acc_18_22 = _mm256_add_pd(q_acc_18_22,q_tmp_18_22);
                   q_acc_18_23 = _mm256_add_pd(q_acc_18_23,q_tmp_18_23);
                   q_acc_18_24 = _mm256_add_pd(q_acc_18_24,q_tmp_18_24);
                   q_acc_18_25 = _mm256_add_pd(q_acc_18_25,q_tmp_18_25);
                   q_acc_18_26 = _mm256_add_pd(q_acc_18_26,q_tmp_18_26);
                   q_acc_18_27 = _mm256_add_pd(q_acc_18_27,q_tmp_18_27);
                   q_acc_18_28 = _mm256_add_pd(q_acc_18_28,q_tmp_18_28);
                   q_acc_18_29 = _mm256_add_pd(q_acc_18_29,q_tmp_18_29);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_19_20 = _mm256_add_pd(q_acc_19_20,q_tmp_19_20);
                   q_acc_19_21 = _mm256_add_pd(q_acc_19_21,q_tmp_19_21);
                   q_acc_19_22 = _mm256_add_pd(q_acc_19_22,q_tmp_19_22);
                   q_acc_19_23 = _mm256_add_pd(q_acc_19_23,q_tmp_19_23);
                   q_acc_19_24 = _mm256_add_pd(q_acc_19_24,q_tmp_19_24);
                   q_acc_19_25 = _mm256_add_pd(q_acc_19_25,q_tmp_19_25);
                   q_acc_19_26 = _mm256_add_pd(q_acc_19_26,q_tmp_19_26);
                   q_acc_19_27 = _mm256_add_pd(q_acc_19_27,q_tmp_19_27);
                   q_acc_19_28 = _mm256_add_pd(q_acc_19_28,q_tmp_19_28);
                   q_acc_19_29 = _mm256_add_pd(q_acc_19_29,q_tmp_19_29);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_20_21 = _mm256_add_pd(q_acc_20_21,q_tmp_20_21);
                   q_acc_20_22 = _mm256_add_pd(q_acc_20_22,q_tmp_20_22);
                   q_acc_20_23 = _mm256_add_pd(q_acc_20_23,q_tmp_20_23);
                   q_acc_20_24 = _mm256_add_pd(q_acc_20_24,q_tmp_20_24);
                   q_acc_20_25 = _mm256_add_pd(q_acc_20_25,q_tmp_20_25);
                   q_acc_20_26 = _mm256_add_pd(q_acc_20_26,q_tmp_20_26);
                   q_acc_20_27 = _mm256_add_pd(q_acc_20_27,q_tmp_20_27);
                   q_acc_20_28 = _mm256_add_pd(q_acc_20_28,q_tmp_20_28);
                   q_acc_20_29 = _mm256_add_pd(q_acc_20_29,q_tmp_20_29);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_21_22 = _mm256_add_pd(q_acc_21_22,q_tmp_21_22);
                   q_acc_21_23 = _mm256_add_pd(q_acc_21_23,q_tmp_21_23);
                   q_acc_21_24 = _mm256_add_pd(q_acc_21_24,q_tmp_21_24);
                   q_acc_21_25 = _mm256_add_pd(q_acc_21_25,q_tmp_21_25);
                   q_acc_21_26 = _mm256_add_pd(q_acc_21_26,q_tmp_21_26);
                   q_acc_21_27 = _mm256_add_pd(q_acc_21_27,q_tmp_21_27);
                   q_acc_21_28 = _mm256_add_pd(q_acc_21_28,q_tmp_21_28);
                   q_acc_21_29 = _mm256_add_pd(q_acc_21_29,q_tmp_21_29);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_22_23 = _mm256_add_pd(q_acc_22_23,q_tmp_22_23);
                   q_acc_22_24 = _mm256_add_pd(q_acc_22_24,q_tmp_22_24);
                   q_acc_22_25 = _mm256_add_pd(q_acc_22_25,q_tmp_22_25);
                   q_acc_22_26 = _mm256_add_pd(q_acc_22_26,q_tmp_22_26);
                   q_acc_22_27 = _mm256_add_pd(q_acc_22_27,q_tmp_22_27);
                   q_acc_22_28 = _mm256_add_pd(q_acc_22_28,q_tmp_22_28);
                   q_acc_22_29 = _mm256_add_pd(q_acc_22_29,q_tmp_22_29);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_23_24 = _mm256_add_pd(q_acc_23_24,q_tmp_23_24);
                   q_acc_23_25 = _mm256_add_pd(q_acc_23_25,q_tmp_23_25);
                   q_acc_23_26 = _mm256_add_pd(q_acc_23_26,q_tmp_23_26);
                   q_acc_23_27 = _mm256_add_pd(q_acc_23_27,q_tmp_23_27);
                   q_acc_23_28 = _mm256_add_pd(q_acc_23_28,q_tmp_23_28);
                   q_acc_23_29 = _mm256_add_pd(q_acc_23_29,q_tmp_23_29);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_24_25 = _mm256_add_pd(q_acc_24_25,q_tmp_24_25);
                   q_acc_24_26 = _mm256_add_pd(q_acc_24_26,q_tmp_24_26);
                   q_acc_24_27 = _mm256_add_pd(q_acc_24_27,q_tmp_24_27);
                   q_acc_24_28 = _mm256_add_pd(q_acc_24_28,q_tmp_24_28);
                   q_acc_24_29 = _mm256_add_pd(q_acc_24_29,q_tmp_24_29);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_25_26 = _mm256_add_pd(q_acc_25_26,q_tmp_25_26);
                   q_acc_25_27 = _mm256_add_pd(q_acc_25_27,q_tmp_25_27);
                   q_acc_25_28 = _mm256_add_pd(q_acc_25_28,q_tmp_25_28);
                   q_acc_25_29 = _mm256_add_pd(q_acc_25_29,q_tmp_25_29);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_26_27 = _mm256_add_pd(q_acc_26_27,q_tmp_26_27);
                   q_acc_26_28 = _mm256_add_pd(q_acc_26_28,q_tmp_26_28);
                   q_acc_26_29 = _mm256_add_pd(q_acc_26_29,q_tmp_26_29);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_27_28 = _mm256_add_pd(q_acc_27_28,q_tmp_27_28);
                   q_acc_27_29 = _mm256_add_pd(q_acc_27_29,q_tmp_27_29);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_28_29 = _mm256_add_pd(q_acc_28_29,q_tmp_28_29);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_12,src_dof_12)),_mm256_mul_pd(q_acc_0_13,src_dof_13)),_mm256_mul_pd(q_acc_0_14,src_dof_14)),_mm256_mul_pd(q_acc_0_15,src_dof_15)),_mm256_mul_pd(q_acc_0_16,src_dof_16)),_mm256_mul_pd(q_acc_0_17,src_dof_17)),_mm256_mul_pd(q_acc_0_18,src_dof_18)),_mm256_mul_pd(q_acc_0_19,src_dof_19)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_20,src_dof_20)),_mm256_mul_pd(q_acc_0_21,src_dof_21)),_mm256_mul_pd(q_acc_0_22,src_dof_22)),_mm256_mul_pd(q_acc_0_23,src_dof_23)),_mm256_mul_pd(q_acc_0_24,src_dof_24)),_mm256_mul_pd(q_acc_0_25,src_dof_25)),_mm256_mul_pd(q_acc_0_26,src_dof_26)),_mm256_mul_pd(q_acc_0_27,src_dof_27)),_mm256_mul_pd(q_acc_0_28,src_dof_28)),_mm256_mul_pd(q_acc_0_29,src_dof_29)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_12,src_dof_12)),_mm256_mul_pd(q_acc_1_13,src_dof_13)),_mm256_mul_pd(q_acc_1_14,src_dof_14)),_mm256_mul_pd(q_acc_1_15,src_dof_15)),_mm256_mul_pd(q_acc_1_16,src_dof_16)),_mm256_mul_pd(q_acc_1_17,src_dof_17)),_mm256_mul_pd(q_acc_1_18,src_dof_18)),_mm256_mul_pd(q_acc_1_19,src_dof_19)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_20,src_dof_20)),_mm256_mul_pd(q_acc_1_21,src_dof_21)),_mm256_mul_pd(q_acc_1_22,src_dof_22)),_mm256_mul_pd(q_acc_1_23,src_dof_23)),_mm256_mul_pd(q_acc_1_24,src_dof_24)),_mm256_mul_pd(q_acc_1_25,src_dof_25)),_mm256_mul_pd(q_acc_1_26,src_dof_26)),_mm256_mul_pd(q_acc_1_27,src_dof_27)),_mm256_mul_pd(q_acc_1_28,src_dof_28)),_mm256_mul_pd(q_acc_1_29,src_dof_29)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_12,src_dof_12)),_mm256_mul_pd(q_acc_2_13,src_dof_13)),_mm256_mul_pd(q_acc_2_14,src_dof_14)),_mm256_mul_pd(q_acc_2_15,src_dof_15)),_mm256_mul_pd(q_acc_2_16,src_dof_16)),_mm256_mul_pd(q_acc_2_17,src_dof_17)),_mm256_mul_pd(q_acc_2_18,src_dof_18)),_mm256_mul_pd(q_acc_2_19,src_dof_19)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_20,src_dof_20)),_mm256_mul_pd(q_acc_2_21,src_dof_21)),_mm256_mul_pd(q_acc_2_22,src_dof_22)),_mm256_mul_pd(q_acc_2_23,src_dof_23)),_mm256_mul_pd(q_acc_2_24,src_dof_24)),_mm256_mul_pd(q_acc_2_25,src_dof_25)),_mm256_mul_pd(q_acc_2_26,src_dof_26)),_mm256_mul_pd(q_acc_2_27,src_dof_27)),_mm256_mul_pd(q_acc_2_28,src_dof_28)),_mm256_mul_pd(q_acc_2_29,src_dof_29)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_12,src_dof_12)),_mm256_mul_pd(q_acc_3_13,src_dof_13)),_mm256_mul_pd(q_acc_3_14,src_dof_14)),_mm256_mul_pd(q_acc_3_15,src_dof_15)),_mm256_mul_pd(q_acc_3_16,src_dof_16)),_mm256_mul_pd(q_acc_3_17,src_dof_17)),_mm256_mul_pd(q_acc_3_18,src_dof_18)),_mm256_mul_pd(q_acc_3_19,src_dof_19)),_mm256_mul_pd(q_acc_3_20,src_dof_20)),_mm256_mul_pd(q_acc_3_21,src_dof_21)),_mm256_mul_pd(q_acc_3_22,src_dof_22)),_mm256_mul_pd(q_acc_3_23,src_dof_23)),_mm256_mul_pd(q_acc_3_24,src_dof_24)),_mm256_mul_pd(q_acc_3_25,src_dof_25)),_mm256_mul_pd(q_acc_3_26,src_dof_26)),_mm256_mul_pd(q_acc_3_27,src_dof_27)),_mm256_mul_pd(q_acc_3_28,src_dof_28)),_mm256_mul_pd(q_acc_3_29,src_dof_29)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_12,src_dof_12)),_mm256_mul_pd(q_acc_4_13,src_dof_13)),_mm256_mul_pd(q_acc_4_14,src_dof_14)),_mm256_mul_pd(q_acc_4_15,src_dof_15)),_mm256_mul_pd(q_acc_4_16,src_dof_16)),_mm256_mul_pd(q_acc_4_17,src_dof_17)),_mm256_mul_pd(q_acc_4_18,src_dof_18)),_mm256_mul_pd(q_acc_4_19,src_dof_19)),_mm256_mul_pd(q_acc_4_20,src_dof_20)),_mm256_mul_pd(q_acc_4_21,src_dof_21)),_mm256_mul_pd(q_acc_4_22,src_dof_22)),_mm256_mul_pd(q_acc_4_23,src_dof_23)),_mm256_mul_pd(q_acc_4_24,src_dof_24)),_mm256_mul_pd(q_acc_4_25,src_dof_25)),_mm256_mul_pd(q_acc_4_26,src_dof_26)),_mm256_mul_pd(q_acc_4_27,src_dof_27)),_mm256_mul_pd(q_acc_4_28,src_dof_28)),_mm256_mul_pd(q_acc_4_29,src_dof_29)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_12,src_dof_12)),_mm256_mul_pd(q_acc_5_13,src_dof_13)),_mm256_mul_pd(q_acc_5_14,src_dof_14)),_mm256_mul_pd(q_acc_5_15,src_dof_15)),_mm256_mul_pd(q_acc_5_16,src_dof_16)),_mm256_mul_pd(q_acc_5_17,src_dof_17)),_mm256_mul_pd(q_acc_5_18,src_dof_18)),_mm256_mul_pd(q_acc_5_19,src_dof_19)),_mm256_mul_pd(q_acc_5_20,src_dof_20)),_mm256_mul_pd(q_acc_5_21,src_dof_21)),_mm256_mul_pd(q_acc_5_22,src_dof_22)),_mm256_mul_pd(q_acc_5_23,src_dof_23)),_mm256_mul_pd(q_acc_5_24,src_dof_24)),_mm256_mul_pd(q_acc_5_25,src_dof_25)),_mm256_mul_pd(q_acc_5_26,src_dof_26)),_mm256_mul_pd(q_acc_5_27,src_dof_27)),_mm256_mul_pd(q_acc_5_28,src_dof_28)),_mm256_mul_pd(q_acc_5_29,src_dof_29)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_12,src_dof_12)),_mm256_mul_pd(q_acc_6_13,src_dof_13)),_mm256_mul_pd(q_acc_6_14,src_dof_14)),_mm256_mul_pd(q_acc_6_15,src_dof_15)),_mm256_mul_pd(q_acc_6_16,src_dof_16)),_mm256_mul_pd(q_acc_6_17,src_dof_17)),_mm256_mul_pd(q_acc_6_18,src_dof_18)),_mm256_mul_pd(q_acc_6_19,src_dof_19)),_mm256_mul_pd(q_acc_6_20,src_dof_20)),_mm256_mul_pd(q_acc_6_21,src_dof_21)),_mm256_mul_pd(q_acc_6_22,src_dof_22)),_mm256_mul_pd(q_acc_6_23,src_dof_23)),_mm256_mul_pd(q_acc_6_24,src_dof_24)),_mm256_mul_pd(q_acc_6_25,src_dof_25)),_mm256_mul_pd(q_acc_6_26,src_dof_26)),_mm256_mul_pd(q_acc_6_27,src_dof_27)),_mm256_mul_pd(q_acc_6_28,src_dof_28)),_mm256_mul_pd(q_acc_6_29,src_dof_29)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_12,src_dof_12)),_mm256_mul_pd(q_acc_7_13,src_dof_13)),_mm256_mul_pd(q_acc_7_14,src_dof_14)),_mm256_mul_pd(q_acc_7_15,src_dof_15)),_mm256_mul_pd(q_acc_7_16,src_dof_16)),_mm256_mul_pd(q_acc_7_17,src_dof_17)),_mm256_mul_pd(q_acc_7_18,src_dof_18)),_mm256_mul_pd(q_acc_7_19,src_dof_19)),_mm256_mul_pd(q_acc_7_20,src_dof_20)),_mm256_mul_pd(q_acc_7_21,src_dof_21)),_mm256_mul_pd(q_acc_7_22,src_dof_22)),_mm256_mul_pd(q_acc_7_23,src_dof_23)),_mm256_mul_pd(q_acc_7_24,src_dof_24)),_mm256_mul_pd(q_acc_7_25,src_dof_25)),_mm256_mul_pd(q_acc_7_26,src_dof_26)),_mm256_mul_pd(q_acc_7_27,src_dof_27)),_mm256_mul_pd(q_acc_7_28,src_dof_28)),_mm256_mul_pd(q_acc_7_29,src_dof_29)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_12,src_dof_12)),_mm256_mul_pd(q_acc_8_13,src_dof_13)),_mm256_mul_pd(q_acc_8_14,src_dof_14)),_mm256_mul_pd(q_acc_8_15,src_dof_15)),_mm256_mul_pd(q_acc_8_16,src_dof_16)),_mm256_mul_pd(q_acc_8_17,src_dof_17)),_mm256_mul_pd(q_acc_8_18,src_dof_18)),_mm256_mul_pd(q_acc_8_19,src_dof_19)),_mm256_mul_pd(q_acc_8_20,src_dof_20)),_mm256_mul_pd(q_acc_8_21,src_dof_21)),_mm256_mul_pd(q_acc_8_22,src_dof_22)),_mm256_mul_pd(q_acc_8_23,src_dof_23)),_mm256_mul_pd(q_acc_8_24,src_dof_24)),_mm256_mul_pd(q_acc_8_25,src_dof_25)),_mm256_mul_pd(q_acc_8_26,src_dof_26)),_mm256_mul_pd(q_acc_8_27,src_dof_27)),_mm256_mul_pd(q_acc_8_28,src_dof_28)),_mm256_mul_pd(q_acc_8_29,src_dof_29)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_12,src_dof_12)),_mm256_mul_pd(q_acc_9_13,src_dof_13)),_mm256_mul_pd(q_acc_9_14,src_dof_14)),_mm256_mul_pd(q_acc_9_15,src_dof_15)),_mm256_mul_pd(q_acc_9_16,src_dof_16)),_mm256_mul_pd(q_acc_9_17,src_dof_17)),_mm256_mul_pd(q_acc_9_18,src_dof_18)),_mm256_mul_pd(q_acc_9_19,src_dof_19)),_mm256_mul_pd(q_acc_9_20,src_dof_20)),_mm256_mul_pd(q_acc_9_21,src_dof_21)),_mm256_mul_pd(q_acc_9_22,src_dof_22)),_mm256_mul_pd(q_acc_9_23,src_dof_23)),_mm256_mul_pd(q_acc_9_24,src_dof_24)),_mm256_mul_pd(q_acc_9_25,src_dof_25)),_mm256_mul_pd(q_acc_9_26,src_dof_26)),_mm256_mul_pd(q_acc_9_27,src_dof_27)),_mm256_mul_pd(q_acc_9_28,src_dof_28)),_mm256_mul_pd(q_acc_9_29,src_dof_29)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_10_12,src_dof_12)),_mm256_mul_pd(q_acc_10_13,src_dof_13)),_mm256_mul_pd(q_acc_10_14,src_dof_14)),_mm256_mul_pd(q_acc_10_15,src_dof_15)),_mm256_mul_pd(q_acc_10_16,src_dof_16)),_mm256_mul_pd(q_acc_10_17,src_dof_17)),_mm256_mul_pd(q_acc_10_18,src_dof_18)),_mm256_mul_pd(q_acc_10_19,src_dof_19)),_mm256_mul_pd(q_acc_10_20,src_dof_20)),_mm256_mul_pd(q_acc_10_21,src_dof_21)),_mm256_mul_pd(q_acc_10_22,src_dof_22)),_mm256_mul_pd(q_acc_10_23,src_dof_23)),_mm256_mul_pd(q_acc_10_24,src_dof_24)),_mm256_mul_pd(q_acc_10_25,src_dof_25)),_mm256_mul_pd(q_acc_10_26,src_dof_26)),_mm256_mul_pd(q_acc_10_27,src_dof_27)),_mm256_mul_pd(q_acc_10_28,src_dof_28)),_mm256_mul_pd(q_acc_10_29,src_dof_29)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_11_12,src_dof_12)),_mm256_mul_pd(q_acc_11_13,src_dof_13)),_mm256_mul_pd(q_acc_11_14,src_dof_14)),_mm256_mul_pd(q_acc_11_15,src_dof_15)),_mm256_mul_pd(q_acc_11_16,src_dof_16)),_mm256_mul_pd(q_acc_11_17,src_dof_17)),_mm256_mul_pd(q_acc_11_18,src_dof_18)),_mm256_mul_pd(q_acc_11_19,src_dof_19)),_mm256_mul_pd(q_acc_11_20,src_dof_20)),_mm256_mul_pd(q_acc_11_21,src_dof_21)),_mm256_mul_pd(q_acc_11_22,src_dof_22)),_mm256_mul_pd(q_acc_11_23,src_dof_23)),_mm256_mul_pd(q_acc_11_24,src_dof_24)),_mm256_mul_pd(q_acc_11_25,src_dof_25)),_mm256_mul_pd(q_acc_11_26,src_dof_26)),_mm256_mul_pd(q_acc_11_27,src_dof_27)),_mm256_mul_pd(q_acc_11_28,src_dof_28)),_mm256_mul_pd(q_acc_11_29,src_dof_29)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                const __m256d elMatVec_12 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_12,src_dof_0),_mm256_mul_pd(q_acc_10_12,src_dof_10)),_mm256_mul_pd(q_acc_11_12,src_dof_11)),_mm256_mul_pd(q_acc_12_12,src_dof_12)),_mm256_mul_pd(q_acc_12_13,src_dof_13)),_mm256_mul_pd(q_acc_12_14,src_dof_14)),_mm256_mul_pd(q_acc_12_15,src_dof_15)),_mm256_mul_pd(q_acc_12_16,src_dof_16)),_mm256_mul_pd(q_acc_12_17,src_dof_17)),_mm256_mul_pd(q_acc_12_18,src_dof_18)),_mm256_mul_pd(q_acc_12_19,src_dof_19)),_mm256_mul_pd(q_acc_12_20,src_dof_20)),_mm256_mul_pd(q_acc_12_21,src_dof_21)),_mm256_mul_pd(q_acc_12_22,src_dof_22)),_mm256_mul_pd(q_acc_12_23,src_dof_23)),_mm256_mul_pd(q_acc_12_24,src_dof_24)),_mm256_mul_pd(q_acc_12_25,src_dof_25)),_mm256_mul_pd(q_acc_12_26,src_dof_26)),_mm256_mul_pd(q_acc_12_27,src_dof_27)),_mm256_mul_pd(q_acc_12_28,src_dof_28)),_mm256_mul_pd(q_acc_12_29,src_dof_29)),_mm256_mul_pd(q_acc_1_12,src_dof_1)),_mm256_mul_pd(q_acc_2_12,src_dof_2)),_mm256_mul_pd(q_acc_3_12,src_dof_3)),_mm256_mul_pd(q_acc_4_12,src_dof_4)),_mm256_mul_pd(q_acc_5_12,src_dof_5)),_mm256_mul_pd(q_acc_6_12,src_dof_6)),_mm256_mul_pd(q_acc_7_12,src_dof_7)),_mm256_mul_pd(q_acc_8_12,src_dof_8)),_mm256_mul_pd(q_acc_9_12,src_dof_9));
                const __m256d elMatVec_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_13,src_dof_0),_mm256_mul_pd(q_acc_10_13,src_dof_10)),_mm256_mul_pd(q_acc_11_13,src_dof_11)),_mm256_mul_pd(q_acc_12_13,src_dof_12)),_mm256_mul_pd(q_acc_13_13,src_dof_13)),_mm256_mul_pd(q_acc_13_14,src_dof_14)),_mm256_mul_pd(q_acc_13_15,src_dof_15)),_mm256_mul_pd(q_acc_13_16,src_dof_16)),_mm256_mul_pd(q_acc_13_17,src_dof_17)),_mm256_mul_pd(q_acc_13_18,src_dof_18)),_mm256_mul_pd(q_acc_13_19,src_dof_19)),_mm256_mul_pd(q_acc_13_20,src_dof_20)),_mm256_mul_pd(q_acc_13_21,src_dof_21)),_mm256_mul_pd(q_acc_13_22,src_dof_22)),_mm256_mul_pd(q_acc_13_23,src_dof_23)),_mm256_mul_pd(q_acc_13_24,src_dof_24)),_mm256_mul_pd(q_acc_13_25,src_dof_25)),_mm256_mul_pd(q_acc_13_26,src_dof_26)),_mm256_mul_pd(q_acc_13_27,src_dof_27)),_mm256_mul_pd(q_acc_13_28,src_dof_28)),_mm256_mul_pd(q_acc_13_29,src_dof_29)),_mm256_mul_pd(q_acc_1_13,src_dof_1)),_mm256_mul_pd(q_acc_2_13,src_dof_2)),_mm256_mul_pd(q_acc_3_13,src_dof_3)),_mm256_mul_pd(q_acc_4_13,src_dof_4)),_mm256_mul_pd(q_acc_5_13,src_dof_5)),_mm256_mul_pd(q_acc_6_13,src_dof_6)),_mm256_mul_pd(q_acc_7_13,src_dof_7)),_mm256_mul_pd(q_acc_8_13,src_dof_8)),_mm256_mul_pd(q_acc_9_13,src_dof_9));
                const __m256d elMatVec_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_14,src_dof_0),_mm256_mul_pd(q_acc_10_14,src_dof_10)),_mm256_mul_pd(q_acc_11_14,src_dof_11)),_mm256_mul_pd(q_acc_12_14,src_dof_12)),_mm256_mul_pd(q_acc_13_14,src_dof_13)),_mm256_mul_pd(q_acc_14_14,src_dof_14)),_mm256_mul_pd(q_acc_14_15,src_dof_15)),_mm256_mul_pd(q_acc_14_16,src_dof_16)),_mm256_mul_pd(q_acc_14_17,src_dof_17)),_mm256_mul_pd(q_acc_14_18,src_dof_18)),_mm256_mul_pd(q_acc_14_19,src_dof_19)),_mm256_mul_pd(q_acc_14_20,src_dof_20)),_mm256_mul_pd(q_acc_14_21,src_dof_21)),_mm256_mul_pd(q_acc_14_22,src_dof_22)),_mm256_mul_pd(q_acc_14_23,src_dof_23)),_mm256_mul_pd(q_acc_14_24,src_dof_24)),_mm256_mul_pd(q_acc_14_25,src_dof_25)),_mm256_mul_pd(q_acc_14_26,src_dof_26)),_mm256_mul_pd(q_acc_14_27,src_dof_27)),_mm256_mul_pd(q_acc_14_28,src_dof_28)),_mm256_mul_pd(q_acc_14_29,src_dof_29)),_mm256_mul_pd(q_acc_1_14,src_dof_1)),_mm256_mul_pd(q_acc_2_14,src_dof_2)),_mm256_mul_pd(q_acc_3_14,src_dof_3)),_mm256_mul_pd(q_acc_4_14,src_dof_4)),_mm256_mul_pd(q_acc_5_14,src_dof_5)),_mm256_mul_pd(q_acc_6_14,src_dof_6)),_mm256_mul_pd(q_acc_7_14,src_dof_7)),_mm256_mul_pd(q_acc_8_14,src_dof_8)),_mm256_mul_pd(q_acc_9_14,src_dof_9));
                const __m256d elMatVec_15 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_15,src_dof_0),_mm256_mul_pd(q_acc_10_15,src_dof_10)),_mm256_mul_pd(q_acc_11_15,src_dof_11)),_mm256_mul_pd(q_acc_12_15,src_dof_12)),_mm256_mul_pd(q_acc_13_15,src_dof_13)),_mm256_mul_pd(q_acc_14_15,src_dof_14)),_mm256_mul_pd(q_acc_15_15,src_dof_15)),_mm256_mul_pd(q_acc_15_16,src_dof_16)),_mm256_mul_pd(q_acc_15_17,src_dof_17)),_mm256_mul_pd(q_acc_15_18,src_dof_18)),_mm256_mul_pd(q_acc_15_19,src_dof_19)),_mm256_mul_pd(q_acc_15_20,src_dof_20)),_mm256_mul_pd(q_acc_15_21,src_dof_21)),_mm256_mul_pd(q_acc_15_22,src_dof_22)),_mm256_mul_pd(q_acc_15_23,src_dof_23)),_mm256_mul_pd(q_acc_15_24,src_dof_24)),_mm256_mul_pd(q_acc_15_25,src_dof_25)),_mm256_mul_pd(q_acc_15_26,src_dof_26)),_mm256_mul_pd(q_acc_15_27,src_dof_27)),_mm256_mul_pd(q_acc_15_28,src_dof_28)),_mm256_mul_pd(q_acc_15_29,src_dof_29)),_mm256_mul_pd(q_acc_1_15,src_dof_1)),_mm256_mul_pd(q_acc_2_15,src_dof_2)),_mm256_mul_pd(q_acc_3_15,src_dof_3)),_mm256_mul_pd(q_acc_4_15,src_dof_4)),_mm256_mul_pd(q_acc_5_15,src_dof_5)),_mm256_mul_pd(q_acc_6_15,src_dof_6)),_mm256_mul_pd(q_acc_7_15,src_dof_7)),_mm256_mul_pd(q_acc_8_15,src_dof_8)),_mm256_mul_pd(q_acc_9_15,src_dof_9));
                const __m256d elMatVec_16 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_16,src_dof_0),_mm256_mul_pd(q_acc_10_16,src_dof_10)),_mm256_mul_pd(q_acc_11_16,src_dof_11)),_mm256_mul_pd(q_acc_12_16,src_dof_12)),_mm256_mul_pd(q_acc_13_16,src_dof_13)),_mm256_mul_pd(q_acc_14_16,src_dof_14)),_mm256_mul_pd(q_acc_15_16,src_dof_15)),_mm256_mul_pd(q_acc_16_16,src_dof_16)),_mm256_mul_pd(q_acc_16_17,src_dof_17)),_mm256_mul_pd(q_acc_16_18,src_dof_18)),_mm256_mul_pd(q_acc_16_19,src_dof_19)),_mm256_mul_pd(q_acc_16_20,src_dof_20)),_mm256_mul_pd(q_acc_16_21,src_dof_21)),_mm256_mul_pd(q_acc_16_22,src_dof_22)),_mm256_mul_pd(q_acc_16_23,src_dof_23)),_mm256_mul_pd(q_acc_16_24,src_dof_24)),_mm256_mul_pd(q_acc_16_25,src_dof_25)),_mm256_mul_pd(q_acc_16_26,src_dof_26)),_mm256_mul_pd(q_acc_16_27,src_dof_27)),_mm256_mul_pd(q_acc_16_28,src_dof_28)),_mm256_mul_pd(q_acc_16_29,src_dof_29)),_mm256_mul_pd(q_acc_1_16,src_dof_1)),_mm256_mul_pd(q_acc_2_16,src_dof_2)),_mm256_mul_pd(q_acc_3_16,src_dof_3)),_mm256_mul_pd(q_acc_4_16,src_dof_4)),_mm256_mul_pd(q_acc_5_16,src_dof_5)),_mm256_mul_pd(q_acc_6_16,src_dof_6)),_mm256_mul_pd(q_acc_7_16,src_dof_7)),_mm256_mul_pd(q_acc_8_16,src_dof_8)),_mm256_mul_pd(q_acc_9_16,src_dof_9));
                const __m256d elMatVec_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_17,src_dof_0),_mm256_mul_pd(q_acc_10_17,src_dof_10)),_mm256_mul_pd(q_acc_11_17,src_dof_11)),_mm256_mul_pd(q_acc_12_17,src_dof_12)),_mm256_mul_pd(q_acc_13_17,src_dof_13)),_mm256_mul_pd(q_acc_14_17,src_dof_14)),_mm256_mul_pd(q_acc_15_17,src_dof_15)),_mm256_mul_pd(q_acc_16_17,src_dof_16)),_mm256_mul_pd(q_acc_17_17,src_dof_17)),_mm256_mul_pd(q_acc_17_18,src_dof_18)),_mm256_mul_pd(q_acc_17_19,src_dof_19)),_mm256_mul_pd(q_acc_17_20,src_dof_20)),_mm256_mul_pd(q_acc_17_21,src_dof_21)),_mm256_mul_pd(q_acc_17_22,src_dof_22)),_mm256_mul_pd(q_acc_17_23,src_dof_23)),_mm256_mul_pd(q_acc_17_24,src_dof_24)),_mm256_mul_pd(q_acc_17_25,src_dof_25)),_mm256_mul_pd(q_acc_17_26,src_dof_26)),_mm256_mul_pd(q_acc_17_27,src_dof_27)),_mm256_mul_pd(q_acc_17_28,src_dof_28)),_mm256_mul_pd(q_acc_17_29,src_dof_29)),_mm256_mul_pd(q_acc_1_17,src_dof_1)),_mm256_mul_pd(q_acc_2_17,src_dof_2)),_mm256_mul_pd(q_acc_3_17,src_dof_3)),_mm256_mul_pd(q_acc_4_17,src_dof_4)),_mm256_mul_pd(q_acc_5_17,src_dof_5)),_mm256_mul_pd(q_acc_6_17,src_dof_6)),_mm256_mul_pd(q_acc_7_17,src_dof_7)),_mm256_mul_pd(q_acc_8_17,src_dof_8)),_mm256_mul_pd(q_acc_9_17,src_dof_9));
                const __m256d elMatVec_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_18,src_dof_0),_mm256_mul_pd(q_acc_10_18,src_dof_10)),_mm256_mul_pd(q_acc_11_18,src_dof_11)),_mm256_mul_pd(q_acc_12_18,src_dof_12)),_mm256_mul_pd(q_acc_13_18,src_dof_13)),_mm256_mul_pd(q_acc_14_18,src_dof_14)),_mm256_mul_pd(q_acc_15_18,src_dof_15)),_mm256_mul_pd(q_acc_16_18,src_dof_16)),_mm256_mul_pd(q_acc_17_18,src_dof_17)),_mm256_mul_pd(q_acc_18_18,src_dof_18)),_mm256_mul_pd(q_acc_18_19,src_dof_19)),_mm256_mul_pd(q_acc_18_20,src_dof_20)),_mm256_mul_pd(q_acc_18_21,src_dof_21)),_mm256_mul_pd(q_acc_18_22,src_dof_22)),_mm256_mul_pd(q_acc_18_23,src_dof_23)),_mm256_mul_pd(q_acc_18_24,src_dof_24)),_mm256_mul_pd(q_acc_18_25,src_dof_25)),_mm256_mul_pd(q_acc_18_26,src_dof_26)),_mm256_mul_pd(q_acc_18_27,src_dof_27)),_mm256_mul_pd(q_acc_18_28,src_dof_28)),_mm256_mul_pd(q_acc_18_29,src_dof_29)),_mm256_mul_pd(q_acc_1_18,src_dof_1)),_mm256_mul_pd(q_acc_2_18,src_dof_2)),_mm256_mul_pd(q_acc_3_18,src_dof_3)),_mm256_mul_pd(q_acc_4_18,src_dof_4)),_mm256_mul_pd(q_acc_5_18,src_dof_5)),_mm256_mul_pd(q_acc_6_18,src_dof_6)),_mm256_mul_pd(q_acc_7_18,src_dof_7)),_mm256_mul_pd(q_acc_8_18,src_dof_8)),_mm256_mul_pd(q_acc_9_18,src_dof_9));
                const __m256d elMatVec_19 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_19,src_dof_0),_mm256_mul_pd(q_acc_10_19,src_dof_10)),_mm256_mul_pd(q_acc_11_19,src_dof_11)),_mm256_mul_pd(q_acc_12_19,src_dof_12)),_mm256_mul_pd(q_acc_13_19,src_dof_13)),_mm256_mul_pd(q_acc_14_19,src_dof_14)),_mm256_mul_pd(q_acc_15_19,src_dof_15)),_mm256_mul_pd(q_acc_16_19,src_dof_16)),_mm256_mul_pd(q_acc_17_19,src_dof_17)),_mm256_mul_pd(q_acc_18_19,src_dof_18)),_mm256_mul_pd(q_acc_19_19,src_dof_19)),_mm256_mul_pd(q_acc_19_20,src_dof_20)),_mm256_mul_pd(q_acc_19_21,src_dof_21)),_mm256_mul_pd(q_acc_19_22,src_dof_22)),_mm256_mul_pd(q_acc_19_23,src_dof_23)),_mm256_mul_pd(q_acc_19_24,src_dof_24)),_mm256_mul_pd(q_acc_19_25,src_dof_25)),_mm256_mul_pd(q_acc_19_26,src_dof_26)),_mm256_mul_pd(q_acc_19_27,src_dof_27)),_mm256_mul_pd(q_acc_19_28,src_dof_28)),_mm256_mul_pd(q_acc_19_29,src_dof_29)),_mm256_mul_pd(q_acc_1_19,src_dof_1)),_mm256_mul_pd(q_acc_2_19,src_dof_2)),_mm256_mul_pd(q_acc_3_19,src_dof_3)),_mm256_mul_pd(q_acc_4_19,src_dof_4)),_mm256_mul_pd(q_acc_5_19,src_dof_5)),_mm256_mul_pd(q_acc_6_19,src_dof_6)),_mm256_mul_pd(q_acc_7_19,src_dof_7)),_mm256_mul_pd(q_acc_8_19,src_dof_8)),_mm256_mul_pd(q_acc_9_19,src_dof_9));
                const __m256d elMatVec_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_20,src_dof_0),_mm256_mul_pd(q_acc_10_20,src_dof_10)),_mm256_mul_pd(q_acc_11_20,src_dof_11)),_mm256_mul_pd(q_acc_12_20,src_dof_12)),_mm256_mul_pd(q_acc_13_20,src_dof_13)),_mm256_mul_pd(q_acc_14_20,src_dof_14)),_mm256_mul_pd(q_acc_15_20,src_dof_15)),_mm256_mul_pd(q_acc_16_20,src_dof_16)),_mm256_mul_pd(q_acc_17_20,src_dof_17)),_mm256_mul_pd(q_acc_18_20,src_dof_18)),_mm256_mul_pd(q_acc_19_20,src_dof_19)),_mm256_mul_pd(q_acc_1_20,src_dof_1)),_mm256_mul_pd(q_acc_20_20,src_dof_20)),_mm256_mul_pd(q_acc_20_21,src_dof_21)),_mm256_mul_pd(q_acc_20_22,src_dof_22)),_mm256_mul_pd(q_acc_20_23,src_dof_23)),_mm256_mul_pd(q_acc_20_24,src_dof_24)),_mm256_mul_pd(q_acc_20_25,src_dof_25)),_mm256_mul_pd(q_acc_20_26,src_dof_26)),_mm256_mul_pd(q_acc_20_27,src_dof_27)),_mm256_mul_pd(q_acc_20_28,src_dof_28)),_mm256_mul_pd(q_acc_20_29,src_dof_29)),_mm256_mul_pd(q_acc_2_20,src_dof_2)),_mm256_mul_pd(q_acc_3_20,src_dof_3)),_mm256_mul_pd(q_acc_4_20,src_dof_4)),_mm256_mul_pd(q_acc_5_20,src_dof_5)),_mm256_mul_pd(q_acc_6_20,src_dof_6)),_mm256_mul_pd(q_acc_7_20,src_dof_7)),_mm256_mul_pd(q_acc_8_20,src_dof_8)),_mm256_mul_pd(q_acc_9_20,src_dof_9));
                const __m256d elMatVec_21 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_21,src_dof_0),_mm256_mul_pd(q_acc_10_21,src_dof_10)),_mm256_mul_pd(q_acc_11_21,src_dof_11)),_mm256_mul_pd(q_acc_12_21,src_dof_12)),_mm256_mul_pd(q_acc_13_21,src_dof_13)),_mm256_mul_pd(q_acc_14_21,src_dof_14)),_mm256_mul_pd(q_acc_15_21,src_dof_15)),_mm256_mul_pd(q_acc_16_21,src_dof_16)),_mm256_mul_pd(q_acc_17_21,src_dof_17)),_mm256_mul_pd(q_acc_18_21,src_dof_18)),_mm256_mul_pd(q_acc_19_21,src_dof_19)),_mm256_mul_pd(q_acc_1_21,src_dof_1)),_mm256_mul_pd(q_acc_20_21,src_dof_20)),_mm256_mul_pd(q_acc_21_21,src_dof_21)),_mm256_mul_pd(q_acc_21_22,src_dof_22)),_mm256_mul_pd(q_acc_21_23,src_dof_23)),_mm256_mul_pd(q_acc_21_24,src_dof_24)),_mm256_mul_pd(q_acc_21_25,src_dof_25)),_mm256_mul_pd(q_acc_21_26,src_dof_26)),_mm256_mul_pd(q_acc_21_27,src_dof_27)),_mm256_mul_pd(q_acc_21_28,src_dof_28)),_mm256_mul_pd(q_acc_21_29,src_dof_29)),_mm256_mul_pd(q_acc_2_21,src_dof_2)),_mm256_mul_pd(q_acc_3_21,src_dof_3)),_mm256_mul_pd(q_acc_4_21,src_dof_4)),_mm256_mul_pd(q_acc_5_21,src_dof_5)),_mm256_mul_pd(q_acc_6_21,src_dof_6)),_mm256_mul_pd(q_acc_7_21,src_dof_7)),_mm256_mul_pd(q_acc_8_21,src_dof_8)),_mm256_mul_pd(q_acc_9_21,src_dof_9));
                const __m256d elMatVec_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_22,src_dof_0),_mm256_mul_pd(q_acc_10_22,src_dof_10)),_mm256_mul_pd(q_acc_11_22,src_dof_11)),_mm256_mul_pd(q_acc_12_22,src_dof_12)),_mm256_mul_pd(q_acc_13_22,src_dof_13)),_mm256_mul_pd(q_acc_14_22,src_dof_14)),_mm256_mul_pd(q_acc_15_22,src_dof_15)),_mm256_mul_pd(q_acc_16_22,src_dof_16)),_mm256_mul_pd(q_acc_17_22,src_dof_17)),_mm256_mul_pd(q_acc_18_22,src_dof_18)),_mm256_mul_pd(q_acc_19_22,src_dof_19)),_mm256_mul_pd(q_acc_1_22,src_dof_1)),_mm256_mul_pd(q_acc_20_22,src_dof_20)),_mm256_mul_pd(q_acc_21_22,src_dof_21)),_mm256_mul_pd(q_acc_22_22,src_dof_22)),_mm256_mul_pd(q_acc_22_23,src_dof_23)),_mm256_mul_pd(q_acc_22_24,src_dof_24)),_mm256_mul_pd(q_acc_22_25,src_dof_25)),_mm256_mul_pd(q_acc_22_26,src_dof_26)),_mm256_mul_pd(q_acc_22_27,src_dof_27)),_mm256_mul_pd(q_acc_22_28,src_dof_28)),_mm256_mul_pd(q_acc_22_29,src_dof_29)),_mm256_mul_pd(q_acc_2_22,src_dof_2)),_mm256_mul_pd(q_acc_3_22,src_dof_3)),_mm256_mul_pd(q_acc_4_22,src_dof_4)),_mm256_mul_pd(q_acc_5_22,src_dof_5)),_mm256_mul_pd(q_acc_6_22,src_dof_6)),_mm256_mul_pd(q_acc_7_22,src_dof_7)),_mm256_mul_pd(q_acc_8_22,src_dof_8)),_mm256_mul_pd(q_acc_9_22,src_dof_9));
                const __m256d elMatVec_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_23,src_dof_0),_mm256_mul_pd(q_acc_10_23,src_dof_10)),_mm256_mul_pd(q_acc_11_23,src_dof_11)),_mm256_mul_pd(q_acc_12_23,src_dof_12)),_mm256_mul_pd(q_acc_13_23,src_dof_13)),_mm256_mul_pd(q_acc_14_23,src_dof_14)),_mm256_mul_pd(q_acc_15_23,src_dof_15)),_mm256_mul_pd(q_acc_16_23,src_dof_16)),_mm256_mul_pd(q_acc_17_23,src_dof_17)),_mm256_mul_pd(q_acc_18_23,src_dof_18)),_mm256_mul_pd(q_acc_19_23,src_dof_19)),_mm256_mul_pd(q_acc_1_23,src_dof_1)),_mm256_mul_pd(q_acc_20_23,src_dof_20)),_mm256_mul_pd(q_acc_21_23,src_dof_21)),_mm256_mul_pd(q_acc_22_23,src_dof_22)),_mm256_mul_pd(q_acc_23_23,src_dof_23)),_mm256_mul_pd(q_acc_23_24,src_dof_24)),_mm256_mul_pd(q_acc_23_25,src_dof_25)),_mm256_mul_pd(q_acc_23_26,src_dof_26)),_mm256_mul_pd(q_acc_23_27,src_dof_27)),_mm256_mul_pd(q_acc_23_28,src_dof_28)),_mm256_mul_pd(q_acc_23_29,src_dof_29)),_mm256_mul_pd(q_acc_2_23,src_dof_2)),_mm256_mul_pd(q_acc_3_23,src_dof_3)),_mm256_mul_pd(q_acc_4_23,src_dof_4)),_mm256_mul_pd(q_acc_5_23,src_dof_5)),_mm256_mul_pd(q_acc_6_23,src_dof_6)),_mm256_mul_pd(q_acc_7_23,src_dof_7)),_mm256_mul_pd(q_acc_8_23,src_dof_8)),_mm256_mul_pd(q_acc_9_23,src_dof_9));
                const __m256d elMatVec_24 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_24,src_dof_0),_mm256_mul_pd(q_acc_10_24,src_dof_10)),_mm256_mul_pd(q_acc_11_24,src_dof_11)),_mm256_mul_pd(q_acc_12_24,src_dof_12)),_mm256_mul_pd(q_acc_13_24,src_dof_13)),_mm256_mul_pd(q_acc_14_24,src_dof_14)),_mm256_mul_pd(q_acc_15_24,src_dof_15)),_mm256_mul_pd(q_acc_16_24,src_dof_16)),_mm256_mul_pd(q_acc_17_24,src_dof_17)),_mm256_mul_pd(q_acc_18_24,src_dof_18)),_mm256_mul_pd(q_acc_19_24,src_dof_19)),_mm256_mul_pd(q_acc_1_24,src_dof_1)),_mm256_mul_pd(q_acc_20_24,src_dof_20)),_mm256_mul_pd(q_acc_21_24,src_dof_21)),_mm256_mul_pd(q_acc_22_24,src_dof_22)),_mm256_mul_pd(q_acc_23_24,src_dof_23)),_mm256_mul_pd(q_acc_24_24,src_dof_24)),_mm256_mul_pd(q_acc_24_25,src_dof_25)),_mm256_mul_pd(q_acc_24_26,src_dof_26)),_mm256_mul_pd(q_acc_24_27,src_dof_27)),_mm256_mul_pd(q_acc_24_28,src_dof_28)),_mm256_mul_pd(q_acc_24_29,src_dof_29)),_mm256_mul_pd(q_acc_2_24,src_dof_2)),_mm256_mul_pd(q_acc_3_24,src_dof_3)),_mm256_mul_pd(q_acc_4_24,src_dof_4)),_mm256_mul_pd(q_acc_5_24,src_dof_5)),_mm256_mul_pd(q_acc_6_24,src_dof_6)),_mm256_mul_pd(q_acc_7_24,src_dof_7)),_mm256_mul_pd(q_acc_8_24,src_dof_8)),_mm256_mul_pd(q_acc_9_24,src_dof_9));
                const __m256d elMatVec_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_25,src_dof_0),_mm256_mul_pd(q_acc_10_25,src_dof_10)),_mm256_mul_pd(q_acc_11_25,src_dof_11)),_mm256_mul_pd(q_acc_12_25,src_dof_12)),_mm256_mul_pd(q_acc_13_25,src_dof_13)),_mm256_mul_pd(q_acc_14_25,src_dof_14)),_mm256_mul_pd(q_acc_15_25,src_dof_15)),_mm256_mul_pd(q_acc_16_25,src_dof_16)),_mm256_mul_pd(q_acc_17_25,src_dof_17)),_mm256_mul_pd(q_acc_18_25,src_dof_18)),_mm256_mul_pd(q_acc_19_25,src_dof_19)),_mm256_mul_pd(q_acc_1_25,src_dof_1)),_mm256_mul_pd(q_acc_20_25,src_dof_20)),_mm256_mul_pd(q_acc_21_25,src_dof_21)),_mm256_mul_pd(q_acc_22_25,src_dof_22)),_mm256_mul_pd(q_acc_23_25,src_dof_23)),_mm256_mul_pd(q_acc_24_25,src_dof_24)),_mm256_mul_pd(q_acc_25_25,src_dof_25)),_mm256_mul_pd(q_acc_25_26,src_dof_26)),_mm256_mul_pd(q_acc_25_27,src_dof_27)),_mm256_mul_pd(q_acc_25_28,src_dof_28)),_mm256_mul_pd(q_acc_25_29,src_dof_29)),_mm256_mul_pd(q_acc_2_25,src_dof_2)),_mm256_mul_pd(q_acc_3_25,src_dof_3)),_mm256_mul_pd(q_acc_4_25,src_dof_4)),_mm256_mul_pd(q_acc_5_25,src_dof_5)),_mm256_mul_pd(q_acc_6_25,src_dof_6)),_mm256_mul_pd(q_acc_7_25,src_dof_7)),_mm256_mul_pd(q_acc_8_25,src_dof_8)),_mm256_mul_pd(q_acc_9_25,src_dof_9));
                const __m256d elMatVec_26 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_26,src_dof_0),_mm256_mul_pd(q_acc_10_26,src_dof_10)),_mm256_mul_pd(q_acc_11_26,src_dof_11)),_mm256_mul_pd(q_acc_12_26,src_dof_12)),_mm256_mul_pd(q_acc_13_26,src_dof_13)),_mm256_mul_pd(q_acc_14_26,src_dof_14)),_mm256_mul_pd(q_acc_15_26,src_dof_15)),_mm256_mul_pd(q_acc_16_26,src_dof_16)),_mm256_mul_pd(q_acc_17_26,src_dof_17)),_mm256_mul_pd(q_acc_18_26,src_dof_18)),_mm256_mul_pd(q_acc_19_26,src_dof_19)),_mm256_mul_pd(q_acc_1_26,src_dof_1)),_mm256_mul_pd(q_acc_20_26,src_dof_20)),_mm256_mul_pd(q_acc_21_26,src_dof_21)),_mm256_mul_pd(q_acc_22_26,src_dof_22)),_mm256_mul_pd(q_acc_23_26,src_dof_23)),_mm256_mul_pd(q_acc_24_26,src_dof_24)),_mm256_mul_pd(q_acc_25_26,src_dof_25)),_mm256_mul_pd(q_acc_26_26,src_dof_26)),_mm256_mul_pd(q_acc_26_27,src_dof_27)),_mm256_mul_pd(q_acc_26_28,src_dof_28)),_mm256_mul_pd(q_acc_26_29,src_dof_29)),_mm256_mul_pd(q_acc_2_26,src_dof_2)),_mm256_mul_pd(q_acc_3_26,src_dof_3)),_mm256_mul_pd(q_acc_4_26,src_dof_4)),_mm256_mul_pd(q_acc_5_26,src_dof_5)),_mm256_mul_pd(q_acc_6_26,src_dof_6)),_mm256_mul_pd(q_acc_7_26,src_dof_7)),_mm256_mul_pd(q_acc_8_26,src_dof_8)),_mm256_mul_pd(q_acc_9_26,src_dof_9));
                const __m256d elMatVec_27 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_27,src_dof_0),_mm256_mul_pd(q_acc_10_27,src_dof_10)),_mm256_mul_pd(q_acc_11_27,src_dof_11)),_mm256_mul_pd(q_acc_12_27,src_dof_12)),_mm256_mul_pd(q_acc_13_27,src_dof_13)),_mm256_mul_pd(q_acc_14_27,src_dof_14)),_mm256_mul_pd(q_acc_15_27,src_dof_15)),_mm256_mul_pd(q_acc_16_27,src_dof_16)),_mm256_mul_pd(q_acc_17_27,src_dof_17)),_mm256_mul_pd(q_acc_18_27,src_dof_18)),_mm256_mul_pd(q_acc_19_27,src_dof_19)),_mm256_mul_pd(q_acc_1_27,src_dof_1)),_mm256_mul_pd(q_acc_20_27,src_dof_20)),_mm256_mul_pd(q_acc_21_27,src_dof_21)),_mm256_mul_pd(q_acc_22_27,src_dof_22)),_mm256_mul_pd(q_acc_23_27,src_dof_23)),_mm256_mul_pd(q_acc_24_27,src_dof_24)),_mm256_mul_pd(q_acc_25_27,src_dof_25)),_mm256_mul_pd(q_acc_26_27,src_dof_26)),_mm256_mul_pd(q_acc_27_27,src_dof_27)),_mm256_mul_pd(q_acc_27_28,src_dof_28)),_mm256_mul_pd(q_acc_27_29,src_dof_29)),_mm256_mul_pd(q_acc_2_27,src_dof_2)),_mm256_mul_pd(q_acc_3_27,src_dof_3)),_mm256_mul_pd(q_acc_4_27,src_dof_4)),_mm256_mul_pd(q_acc_5_27,src_dof_5)),_mm256_mul_pd(q_acc_6_27,src_dof_6)),_mm256_mul_pd(q_acc_7_27,src_dof_7)),_mm256_mul_pd(q_acc_8_27,src_dof_8)),_mm256_mul_pd(q_acc_9_27,src_dof_9));
                const __m256d elMatVec_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_28,src_dof_0),_mm256_mul_pd(q_acc_10_28,src_dof_10)),_mm256_mul_pd(q_acc_11_28,src_dof_11)),_mm256_mul_pd(q_acc_12_28,src_dof_12)),_mm256_mul_pd(q_acc_13_28,src_dof_13)),_mm256_mul_pd(q_acc_14_28,src_dof_14)),_mm256_mul_pd(q_acc_15_28,src_dof_15)),_mm256_mul_pd(q_acc_16_28,src_dof_16)),_mm256_mul_pd(q_acc_17_28,src_dof_17)),_mm256_mul_pd(q_acc_18_28,src_dof_18)),_mm256_mul_pd(q_acc_19_28,src_dof_19)),_mm256_mul_pd(q_acc_1_28,src_dof_1)),_mm256_mul_pd(q_acc_20_28,src_dof_20)),_mm256_mul_pd(q_acc_21_28,src_dof_21)),_mm256_mul_pd(q_acc_22_28,src_dof_22)),_mm256_mul_pd(q_acc_23_28,src_dof_23)),_mm256_mul_pd(q_acc_24_28,src_dof_24)),_mm256_mul_pd(q_acc_25_28,src_dof_25)),_mm256_mul_pd(q_acc_26_28,src_dof_26)),_mm256_mul_pd(q_acc_27_28,src_dof_27)),_mm256_mul_pd(q_acc_28_28,src_dof_28)),_mm256_mul_pd(q_acc_28_29,src_dof_29)),_mm256_mul_pd(q_acc_2_28,src_dof_2)),_mm256_mul_pd(q_acc_3_28,src_dof_3)),_mm256_mul_pd(q_acc_4_28,src_dof_4)),_mm256_mul_pd(q_acc_5_28,src_dof_5)),_mm256_mul_pd(q_acc_6_28,src_dof_6)),_mm256_mul_pd(q_acc_7_28,src_dof_7)),_mm256_mul_pd(q_acc_8_28,src_dof_8)),_mm256_mul_pd(q_acc_9_28,src_dof_9));
                const __m256d elMatVec_29 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_29,src_dof_0),_mm256_mul_pd(q_acc_10_29,src_dof_10)),_mm256_mul_pd(q_acc_11_29,src_dof_11)),_mm256_mul_pd(q_acc_12_29,src_dof_12)),_mm256_mul_pd(q_acc_13_29,src_dof_13)),_mm256_mul_pd(q_acc_14_29,src_dof_14)),_mm256_mul_pd(q_acc_15_29,src_dof_15)),_mm256_mul_pd(q_acc_16_29,src_dof_16)),_mm256_mul_pd(q_acc_17_29,src_dof_17)),_mm256_mul_pd(q_acc_18_29,src_dof_18)),_mm256_mul_pd(q_acc_19_29,src_dof_19)),_mm256_mul_pd(q_acc_1_29,src_dof_1)),_mm256_mul_pd(q_acc_20_29,src_dof_20)),_mm256_mul_pd(q_acc_21_29,src_dof_21)),_mm256_mul_pd(q_acc_22_29,src_dof_22)),_mm256_mul_pd(q_acc_23_29,src_dof_23)),_mm256_mul_pd(q_acc_24_29,src_dof_24)),_mm256_mul_pd(q_acc_25_29,src_dof_25)),_mm256_mul_pd(q_acc_26_29,src_dof_26)),_mm256_mul_pd(q_acc_27_29,src_dof_27)),_mm256_mul_pd(q_acc_28_29,src_dof_28)),_mm256_mul_pd(q_acc_29_29,src_dof_29)),_mm256_mul_pd(q_acc_2_29,src_dof_2)),_mm256_mul_pd(q_acc_3_29,src_dof_3)),_mm256_mul_pd(q_acc_4_29,src_dof_4)),_mm256_mul_pd(q_acc_5_29,src_dof_5)),_mm256_mul_pd(q_acc_6_29,src_dof_6)),_mm256_mul_pd(q_acc_7_29,src_dof_7)),_mm256_mul_pd(q_acc_8_29,src_dof_8)),_mm256_mul_pd(q_acc_9_29,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_12,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_13,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_14,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatVec_15,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_16,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_17,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_18,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_19,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_20,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_21,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_22,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_23,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_24,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatVec_25,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_26,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_27,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_28,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_29,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_14 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_18 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_24 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_28 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t mu_dof_0 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_0_12 = 0.0;
                real_t q_acc_0_13 = 0.0;
                real_t q_acc_0_14 = 0.0;
                real_t q_acc_0_15 = 0.0;
                real_t q_acc_0_16 = 0.0;
                real_t q_acc_0_17 = 0.0;
                real_t q_acc_0_18 = 0.0;
                real_t q_acc_0_19 = 0.0;
                real_t q_acc_0_20 = 0.0;
                real_t q_acc_0_21 = 0.0;
                real_t q_acc_0_22 = 0.0;
                real_t q_acc_0_23 = 0.0;
                real_t q_acc_0_24 = 0.0;
                real_t q_acc_0_25 = 0.0;
                real_t q_acc_0_26 = 0.0;
                real_t q_acc_0_27 = 0.0;
                real_t q_acc_0_28 = 0.0;
                real_t q_acc_0_29 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_1_12 = 0.0;
                real_t q_acc_1_13 = 0.0;
                real_t q_acc_1_14 = 0.0;
                real_t q_acc_1_15 = 0.0;
                real_t q_acc_1_16 = 0.0;
                real_t q_acc_1_17 = 0.0;
                real_t q_acc_1_18 = 0.0;
                real_t q_acc_1_19 = 0.0;
                real_t q_acc_1_20 = 0.0;
                real_t q_acc_1_21 = 0.0;
                real_t q_acc_1_22 = 0.0;
                real_t q_acc_1_23 = 0.0;
                real_t q_acc_1_24 = 0.0;
                real_t q_acc_1_25 = 0.0;
                real_t q_acc_1_26 = 0.0;
                real_t q_acc_1_27 = 0.0;
                real_t q_acc_1_28 = 0.0;
                real_t q_acc_1_29 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_2_12 = 0.0;
                real_t q_acc_2_13 = 0.0;
                real_t q_acc_2_14 = 0.0;
                real_t q_acc_2_15 = 0.0;
                real_t q_acc_2_16 = 0.0;
                real_t q_acc_2_17 = 0.0;
                real_t q_acc_2_18 = 0.0;
                real_t q_acc_2_19 = 0.0;
                real_t q_acc_2_20 = 0.0;
                real_t q_acc_2_21 = 0.0;
                real_t q_acc_2_22 = 0.0;
                real_t q_acc_2_23 = 0.0;
                real_t q_acc_2_24 = 0.0;
                real_t q_acc_2_25 = 0.0;
                real_t q_acc_2_26 = 0.0;
                real_t q_acc_2_27 = 0.0;
                real_t q_acc_2_28 = 0.0;
                real_t q_acc_2_29 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_3_12 = 0.0;
                real_t q_acc_3_13 = 0.0;
                real_t q_acc_3_14 = 0.0;
                real_t q_acc_3_15 = 0.0;
                real_t q_acc_3_16 = 0.0;
                real_t q_acc_3_17 = 0.0;
                real_t q_acc_3_18 = 0.0;
                real_t q_acc_3_19 = 0.0;
                real_t q_acc_3_20 = 0.0;
                real_t q_acc_3_21 = 0.0;
                real_t q_acc_3_22 = 0.0;
                real_t q_acc_3_23 = 0.0;
                real_t q_acc_3_24 = 0.0;
                real_t q_acc_3_25 = 0.0;
                real_t q_acc_3_26 = 0.0;
                real_t q_acc_3_27 = 0.0;
                real_t q_acc_3_28 = 0.0;
                real_t q_acc_3_29 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_4_12 = 0.0;
                real_t q_acc_4_13 = 0.0;
                real_t q_acc_4_14 = 0.0;
                real_t q_acc_4_15 = 0.0;
                real_t q_acc_4_16 = 0.0;
                real_t q_acc_4_17 = 0.0;
                real_t q_acc_4_18 = 0.0;
                real_t q_acc_4_19 = 0.0;
                real_t q_acc_4_20 = 0.0;
                real_t q_acc_4_21 = 0.0;
                real_t q_acc_4_22 = 0.0;
                real_t q_acc_4_23 = 0.0;
                real_t q_acc_4_24 = 0.0;
                real_t q_acc_4_25 = 0.0;
                real_t q_acc_4_26 = 0.0;
                real_t q_acc_4_27 = 0.0;
                real_t q_acc_4_28 = 0.0;
                real_t q_acc_4_29 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_5_12 = 0.0;
                real_t q_acc_5_13 = 0.0;
                real_t q_acc_5_14 = 0.0;
                real_t q_acc_5_15 = 0.0;
                real_t q_acc_5_16 = 0.0;
                real_t q_acc_5_17 = 0.0;
                real_t q_acc_5_18 = 0.0;
                real_t q_acc_5_19 = 0.0;
                real_t q_acc_5_20 = 0.0;
                real_t q_acc_5_21 = 0.0;
                real_t q_acc_5_22 = 0.0;
                real_t q_acc_5_23 = 0.0;
                real_t q_acc_5_24 = 0.0;
                real_t q_acc_5_25 = 0.0;
                real_t q_acc_5_26 = 0.0;
                real_t q_acc_5_27 = 0.0;
                real_t q_acc_5_28 = 0.0;
                real_t q_acc_5_29 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_6_12 = 0.0;
                real_t q_acc_6_13 = 0.0;
                real_t q_acc_6_14 = 0.0;
                real_t q_acc_6_15 = 0.0;
                real_t q_acc_6_16 = 0.0;
                real_t q_acc_6_17 = 0.0;
                real_t q_acc_6_18 = 0.0;
                real_t q_acc_6_19 = 0.0;
                real_t q_acc_6_20 = 0.0;
                real_t q_acc_6_21 = 0.0;
                real_t q_acc_6_22 = 0.0;
                real_t q_acc_6_23 = 0.0;
                real_t q_acc_6_24 = 0.0;
                real_t q_acc_6_25 = 0.0;
                real_t q_acc_6_26 = 0.0;
                real_t q_acc_6_27 = 0.0;
                real_t q_acc_6_28 = 0.0;
                real_t q_acc_6_29 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_7_12 = 0.0;
                real_t q_acc_7_13 = 0.0;
                real_t q_acc_7_14 = 0.0;
                real_t q_acc_7_15 = 0.0;
                real_t q_acc_7_16 = 0.0;
                real_t q_acc_7_17 = 0.0;
                real_t q_acc_7_18 = 0.0;
                real_t q_acc_7_19 = 0.0;
                real_t q_acc_7_20 = 0.0;
                real_t q_acc_7_21 = 0.0;
                real_t q_acc_7_22 = 0.0;
                real_t q_acc_7_23 = 0.0;
                real_t q_acc_7_24 = 0.0;
                real_t q_acc_7_25 = 0.0;
                real_t q_acc_7_26 = 0.0;
                real_t q_acc_7_27 = 0.0;
                real_t q_acc_7_28 = 0.0;
                real_t q_acc_7_29 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_8_12 = 0.0;
                real_t q_acc_8_13 = 0.0;
                real_t q_acc_8_14 = 0.0;
                real_t q_acc_8_15 = 0.0;
                real_t q_acc_8_16 = 0.0;
                real_t q_acc_8_17 = 0.0;
                real_t q_acc_8_18 = 0.0;
                real_t q_acc_8_19 = 0.0;
                real_t q_acc_8_20 = 0.0;
                real_t q_acc_8_21 = 0.0;
                real_t q_acc_8_22 = 0.0;
                real_t q_acc_8_23 = 0.0;
                real_t q_acc_8_24 = 0.0;
                real_t q_acc_8_25 = 0.0;
                real_t q_acc_8_26 = 0.0;
                real_t q_acc_8_27 = 0.0;
                real_t q_acc_8_28 = 0.0;
                real_t q_acc_8_29 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_9_12 = 0.0;
                real_t q_acc_9_13 = 0.0;
                real_t q_acc_9_14 = 0.0;
                real_t q_acc_9_15 = 0.0;
                real_t q_acc_9_16 = 0.0;
                real_t q_acc_9_17 = 0.0;
                real_t q_acc_9_18 = 0.0;
                real_t q_acc_9_19 = 0.0;
                real_t q_acc_9_20 = 0.0;
                real_t q_acc_9_21 = 0.0;
                real_t q_acc_9_22 = 0.0;
                real_t q_acc_9_23 = 0.0;
                real_t q_acc_9_24 = 0.0;
                real_t q_acc_9_25 = 0.0;
                real_t q_acc_9_26 = 0.0;
                real_t q_acc_9_27 = 0.0;
                real_t q_acc_9_28 = 0.0;
                real_t q_acc_9_29 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_10_12 = 0.0;
                real_t q_acc_10_13 = 0.0;
                real_t q_acc_10_14 = 0.0;
                real_t q_acc_10_15 = 0.0;
                real_t q_acc_10_16 = 0.0;
                real_t q_acc_10_17 = 0.0;
                real_t q_acc_10_18 = 0.0;
                real_t q_acc_10_19 = 0.0;
                real_t q_acc_10_20 = 0.0;
                real_t q_acc_10_21 = 0.0;
                real_t q_acc_10_22 = 0.0;
                real_t q_acc_10_23 = 0.0;
                real_t q_acc_10_24 = 0.0;
                real_t q_acc_10_25 = 0.0;
                real_t q_acc_10_26 = 0.0;
                real_t q_acc_10_27 = 0.0;
                real_t q_acc_10_28 = 0.0;
                real_t q_acc_10_29 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_11_12 = 0.0;
                real_t q_acc_11_13 = 0.0;
                real_t q_acc_11_14 = 0.0;
                real_t q_acc_11_15 = 0.0;
                real_t q_acc_11_16 = 0.0;
                real_t q_acc_11_17 = 0.0;
                real_t q_acc_11_18 = 0.0;
                real_t q_acc_11_19 = 0.0;
                real_t q_acc_11_20 = 0.0;
                real_t q_acc_11_21 = 0.0;
                real_t q_acc_11_22 = 0.0;
                real_t q_acc_11_23 = 0.0;
                real_t q_acc_11_24 = 0.0;
                real_t q_acc_11_25 = 0.0;
                real_t q_acc_11_26 = 0.0;
                real_t q_acc_11_27 = 0.0;
                real_t q_acc_11_28 = 0.0;
                real_t q_acc_11_29 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_12_13 = 0.0;
                real_t q_acc_12_14 = 0.0;
                real_t q_acc_12_15 = 0.0;
                real_t q_acc_12_16 = 0.0;
                real_t q_acc_12_17 = 0.0;
                real_t q_acc_12_18 = 0.0;
                real_t q_acc_12_19 = 0.0;
                real_t q_acc_12_20 = 0.0;
                real_t q_acc_12_21 = 0.0;
                real_t q_acc_12_22 = 0.0;
                real_t q_acc_12_23 = 0.0;
                real_t q_acc_12_24 = 0.0;
                real_t q_acc_12_25 = 0.0;
                real_t q_acc_12_26 = 0.0;
                real_t q_acc_12_27 = 0.0;
                real_t q_acc_12_28 = 0.0;
                real_t q_acc_12_29 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_13_14 = 0.0;
                real_t q_acc_13_15 = 0.0;
                real_t q_acc_13_16 = 0.0;
                real_t q_acc_13_17 = 0.0;
                real_t q_acc_13_18 = 0.0;
                real_t q_acc_13_19 = 0.0;
                real_t q_acc_13_20 = 0.0;
                real_t q_acc_13_21 = 0.0;
                real_t q_acc_13_22 = 0.0;
                real_t q_acc_13_23 = 0.0;
                real_t q_acc_13_24 = 0.0;
                real_t q_acc_13_25 = 0.0;
                real_t q_acc_13_26 = 0.0;
                real_t q_acc_13_27 = 0.0;
                real_t q_acc_13_28 = 0.0;
                real_t q_acc_13_29 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_14_15 = 0.0;
                real_t q_acc_14_16 = 0.0;
                real_t q_acc_14_17 = 0.0;
                real_t q_acc_14_18 = 0.0;
                real_t q_acc_14_19 = 0.0;
                real_t q_acc_14_20 = 0.0;
                real_t q_acc_14_21 = 0.0;
                real_t q_acc_14_22 = 0.0;
                real_t q_acc_14_23 = 0.0;
                real_t q_acc_14_24 = 0.0;
                real_t q_acc_14_25 = 0.0;
                real_t q_acc_14_26 = 0.0;
                real_t q_acc_14_27 = 0.0;
                real_t q_acc_14_28 = 0.0;
                real_t q_acc_14_29 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_15_16 = 0.0;
                real_t q_acc_15_17 = 0.0;
                real_t q_acc_15_18 = 0.0;
                real_t q_acc_15_19 = 0.0;
                real_t q_acc_15_20 = 0.0;
                real_t q_acc_15_21 = 0.0;
                real_t q_acc_15_22 = 0.0;
                real_t q_acc_15_23 = 0.0;
                real_t q_acc_15_24 = 0.0;
                real_t q_acc_15_25 = 0.0;
                real_t q_acc_15_26 = 0.0;
                real_t q_acc_15_27 = 0.0;
                real_t q_acc_15_28 = 0.0;
                real_t q_acc_15_29 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_16_17 = 0.0;
                real_t q_acc_16_18 = 0.0;
                real_t q_acc_16_19 = 0.0;
                real_t q_acc_16_20 = 0.0;
                real_t q_acc_16_21 = 0.0;
                real_t q_acc_16_22 = 0.0;
                real_t q_acc_16_23 = 0.0;
                real_t q_acc_16_24 = 0.0;
                real_t q_acc_16_25 = 0.0;
                real_t q_acc_16_26 = 0.0;
                real_t q_acc_16_27 = 0.0;
                real_t q_acc_16_28 = 0.0;
                real_t q_acc_16_29 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_17_18 = 0.0;
                real_t q_acc_17_19 = 0.0;
                real_t q_acc_17_20 = 0.0;
                real_t q_acc_17_21 = 0.0;
                real_t q_acc_17_22 = 0.0;
                real_t q_acc_17_23 = 0.0;
                real_t q_acc_17_24 = 0.0;
                real_t q_acc_17_25 = 0.0;
                real_t q_acc_17_26 = 0.0;
                real_t q_acc_17_27 = 0.0;
                real_t q_acc_17_28 = 0.0;
                real_t q_acc_17_29 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_18_19 = 0.0;
                real_t q_acc_18_20 = 0.0;
                real_t q_acc_18_21 = 0.0;
                real_t q_acc_18_22 = 0.0;
                real_t q_acc_18_23 = 0.0;
                real_t q_acc_18_24 = 0.0;
                real_t q_acc_18_25 = 0.0;
                real_t q_acc_18_26 = 0.0;
                real_t q_acc_18_27 = 0.0;
                real_t q_acc_18_28 = 0.0;
                real_t q_acc_18_29 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_19_20 = 0.0;
                real_t q_acc_19_21 = 0.0;
                real_t q_acc_19_22 = 0.0;
                real_t q_acc_19_23 = 0.0;
                real_t q_acc_19_24 = 0.0;
                real_t q_acc_19_25 = 0.0;
                real_t q_acc_19_26 = 0.0;
                real_t q_acc_19_27 = 0.0;
                real_t q_acc_19_28 = 0.0;
                real_t q_acc_19_29 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_20_21 = 0.0;
                real_t q_acc_20_22 = 0.0;
                real_t q_acc_20_23 = 0.0;
                real_t q_acc_20_24 = 0.0;
                real_t q_acc_20_25 = 0.0;
                real_t q_acc_20_26 = 0.0;
                real_t q_acc_20_27 = 0.0;
                real_t q_acc_20_28 = 0.0;
                real_t q_acc_20_29 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_21_22 = 0.0;
                real_t q_acc_21_23 = 0.0;
                real_t q_acc_21_24 = 0.0;
                real_t q_acc_21_25 = 0.0;
                real_t q_acc_21_26 = 0.0;
                real_t q_acc_21_27 = 0.0;
                real_t q_acc_21_28 = 0.0;
                real_t q_acc_21_29 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_22_23 = 0.0;
                real_t q_acc_22_24 = 0.0;
                real_t q_acc_22_25 = 0.0;
                real_t q_acc_22_26 = 0.0;
                real_t q_acc_22_27 = 0.0;
                real_t q_acc_22_28 = 0.0;
                real_t q_acc_22_29 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_23_24 = 0.0;
                real_t q_acc_23_25 = 0.0;
                real_t q_acc_23_26 = 0.0;
                real_t q_acc_23_27 = 0.0;
                real_t q_acc_23_28 = 0.0;
                real_t q_acc_23_29 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_24_25 = 0.0;
                real_t q_acc_24_26 = 0.0;
                real_t q_acc_24_27 = 0.0;
                real_t q_acc_24_28 = 0.0;
                real_t q_acc_24_29 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_25_26 = 0.0;
                real_t q_acc_25_27 = 0.0;
                real_t q_acc_25_28 = 0.0;
                real_t q_acc_25_29 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_26_27 = 0.0;
                real_t q_acc_26_28 = 0.0;
                real_t q_acc_26_29 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_27_28 = 0.0;
                real_t q_acc_27_29 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_28_29 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_156 = (mu_dof_0*_data_phi_0_0_WHITE_DOWN[4*q] + mu_dof_1*_data_phi_0_0_WHITE_DOWN[4*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_DOWN[4*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_DOWN[4*q + 3])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_133 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_157 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4];
                   const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6];
                   const real_t tmp_qloop_222 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7];
                   const real_t tmp_qloop_235 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10];
                   const real_t tmp_qloop_277 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11];
                   const real_t tmp_qloop_283 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_323 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_337 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_365 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_379 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_407 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_421 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_436 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_453 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_468 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_483 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_498 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_513 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_528 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_543 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_558 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_573 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_121 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q];
                   const real_t tmp_qloop_144 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_162 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4];
                   const real_t tmp_qloop_201 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5];
                   const real_t tmp_qloop_214 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8];
                   const real_t tmp_qloop_253 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9];
                   const real_t tmp_qloop_266 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10];
                   const real_t tmp_qloop_274 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_286 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11];
                   const real_t tmp_qloop_305 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_319 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_361 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_389 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_403 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_444 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_459 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_474 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_489 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_504 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_519 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_534 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_549 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_564 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_579 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q];
                   const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 2];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 3];
                   const real_t tmp_qloop_192 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 4];
                   const real_t tmp_qloop_205 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 5];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 6];
                   const real_t tmp_qloop_231 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 7];
                   const real_t tmp_qloop_244 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 8];
                   const real_t tmp_qloop_257 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 9];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 10];
                   const real_t tmp_qloop_293 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[12*q + 11];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_314 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_328 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_342 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_356 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_370 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_398 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_412 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_431 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_449 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_464 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_479 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_494 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_509 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_524 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_539 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_554 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_569 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_125 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_158 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_184 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_223 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_236 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_278 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_284 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_324 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_338 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_366 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_380 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_408 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_422 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_437 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_454 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_469 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_484 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_499 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_514 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_529 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_544 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_559 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_574 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_145 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_163 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_176 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_202 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_215 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_254 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_267 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_275 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_287 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_306 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_320 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_362 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_390 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_404 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_445 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_460 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_475 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_490 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_505 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_520 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_535 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_550 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_565 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_580 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_193 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_206 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_232 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_245 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_258 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_294 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_315 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_329 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_343 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_357 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_371 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_399 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_413 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_432 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_450 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_465 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_480 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_495 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_510 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_525 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_540 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_555 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_570 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_120 = tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0;
                   const real_t tmp_qloop_126 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_127 = tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_126;
                   const real_t tmp_qloop_128 = tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_126*0.5;
                   const real_t tmp_qloop_135 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_136 = tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135;
                   const real_t tmp_qloop_137 = tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5;
                   const real_t tmp_qloop_159 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_161 = tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0;
                   const real_t tmp_qloop_172 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_174 = tmp_qloop_170*2.0 + tmp_qloop_171*2.0 + tmp_qloop_172*2.0;
                   const real_t tmp_qloop_185 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_187 = tmp_qloop_183*2.0 + tmp_qloop_184*2.0 + tmp_qloop_185*2.0;
                   const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_200 = tmp_qloop_196*2.0 + tmp_qloop_197*2.0 + tmp_qloop_198*2.0;
                   const real_t tmp_qloop_211 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_213 = tmp_qloop_209*2.0 + tmp_qloop_210*2.0 + tmp_qloop_211*2.0;
                   const real_t tmp_qloop_224 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_226 = tmp_qloop_222*2.0 + tmp_qloop_223*2.0 + tmp_qloop_224*2.0;
                   const real_t tmp_qloop_237 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_239 = tmp_qloop_235*2.0 + tmp_qloop_236*2.0 + tmp_qloop_237*2.0;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_252 = tmp_qloop_248*2.0 + tmp_qloop_249*2.0 + tmp_qloop_250*2.0;
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_265 = tmp_qloop_261*2.0 + tmp_qloop_262*2.0 + tmp_qloop_263*2.0;
                   const real_t tmp_qloop_279 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_280 = tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663 + tmp_qloop_279*0.66666666666666663;
                   const real_t tmp_qloop_285 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_291 = tmp_qloop_277*2.0 + tmp_qloop_278*2.0 + tmp_qloop_279*2.0;
                   const real_t tmp_qloop_292 = tmp_qloop_120*tmp_qloop_291;
                   const real_t tmp_qloop_311 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_325 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_339 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_367 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_381 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_409 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_438 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_455 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_470 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_485 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_500 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_515 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_530 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_545 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_560 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_575 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_585 = tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0;
                   const real_t tmp_qloop_589 = tmp_qloop_291*tmp_qloop_585;
                   const real_t tmp_qloop_596 = tmp_qloop_170*1.0 + tmp_qloop_171*1.0 + tmp_qloop_172*1.0;
                   const real_t tmp_qloop_599 = tmp_qloop_291*tmp_qloop_596;
                   const real_t tmp_qloop_605 = tmp_qloop_183*1.0 + tmp_qloop_184*1.0 + tmp_qloop_185*1.0;
                   const real_t tmp_qloop_608 = tmp_qloop_291*tmp_qloop_605;
                   const real_t tmp_qloop_614 = tmp_qloop_196*1.0 + tmp_qloop_197*1.0 + tmp_qloop_198*1.0;
                   const real_t tmp_qloop_617 = tmp_qloop_291*tmp_qloop_614;
                   const real_t tmp_qloop_623 = tmp_qloop_209*1.0 + tmp_qloop_210*1.0 + tmp_qloop_211*1.0;
                   const real_t tmp_qloop_626 = tmp_qloop_291*tmp_qloop_623;
                   const real_t tmp_qloop_632 = tmp_qloop_222*1.0 + tmp_qloop_223*1.0 + tmp_qloop_224*1.0;
                   const real_t tmp_qloop_635 = tmp_qloop_291*tmp_qloop_632;
                   const real_t tmp_qloop_641 = tmp_qloop_235*1.0 + tmp_qloop_236*1.0 + tmp_qloop_237*1.0;
                   const real_t tmp_qloop_644 = tmp_qloop_291*tmp_qloop_641;
                   const real_t tmp_qloop_650 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                   const real_t tmp_qloop_653 = tmp_qloop_291*tmp_qloop_650;
                   const real_t tmp_qloop_659 = tmp_qloop_261*1.0 + tmp_qloop_262*1.0 + tmp_qloop_263*1.0;
                   const real_t tmp_qloop_662 = tmp_qloop_291*tmp_qloop_659;
                   const real_t tmp_qloop_667 = tmp_qloop_277 + tmp_qloop_278 + tmp_qloop_279;
                   const real_t tmp_qloop_674 = tmp_qloop_291*(tmp_qloop_277*1.0 + tmp_qloop_278*1.0 + tmp_qloop_279*1.0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_116 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_123 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_129 = tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_128*2.0;
                   const real_t tmp_qloop_139 = tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0;
                   const real_t tmp_qloop_140 = tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0;
                   const real_t tmp_qloop_141 = tmp_qloop_139*tmp_qloop_140;
                   const real_t tmp_qloop_146 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_147 = tmp_qloop_144 + tmp_qloop_145 + tmp_qloop_146;
                   const real_t tmp_qloop_152 = tmp_qloop_144*0.5 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5;
                   const real_t tmp_qloop_164 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_165 = tmp_qloop_127 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_177 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_178 = tmp_qloop_127 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_191 = tmp_qloop_127 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_203 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_204 = tmp_qloop_127 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_216 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_217 = tmp_qloop_127 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_229 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_230 = tmp_qloop_127 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_243 = tmp_qloop_127 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_255 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_256 = tmp_qloop_127 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_268 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_269 = tmp_qloop_127 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_276 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_288 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_289 = tmp_qloop_286 + tmp_qloop_287 + tmp_qloop_288;
                   const real_t tmp_qloop_290 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_289;
                   const real_t tmp_qloop_299 = tmp_qloop_274*2.0 + tmp_qloop_275*2.0 + tmp_qloop_276*2.0;
                   const real_t tmp_qloop_307 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_312 = tmp_qloop_289 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311;
                   const real_t tmp_qloop_313 = tmp_qloop_305*2.0 + tmp_qloop_306*2.0 + tmp_qloop_307*2.0;
                   const real_t tmp_qloop_321 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_326 = tmp_qloop_289 + tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325;
                   const real_t tmp_qloop_327 = tmp_qloop_319*2.0 + tmp_qloop_320*2.0 + tmp_qloop_321*2.0;
                   const real_t tmp_qloop_335 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_340 = tmp_qloop_289 + tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339;
                   const real_t tmp_qloop_341 = tmp_qloop_333*2.0 + tmp_qloop_334*2.0 + tmp_qloop_335*2.0;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_354 = tmp_qloop_289 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353;
                   const real_t tmp_qloop_355 = tmp_qloop_347*2.0 + tmp_qloop_348*2.0 + tmp_qloop_349*2.0;
                   const real_t tmp_qloop_363 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_368 = tmp_qloop_289 + tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367;
                   const real_t tmp_qloop_369 = tmp_qloop_361*2.0 + tmp_qloop_362*2.0 + tmp_qloop_363*2.0;
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_382 = tmp_qloop_289 + tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381;
                   const real_t tmp_qloop_383 = tmp_qloop_375*2.0 + tmp_qloop_376*2.0 + tmp_qloop_377*2.0;
                   const real_t tmp_qloop_391 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_396 = tmp_qloop_289 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395;
                   const real_t tmp_qloop_397 = tmp_qloop_389*2.0 + tmp_qloop_390*2.0 + tmp_qloop_391*2.0;
                   const real_t tmp_qloop_405 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_410 = tmp_qloop_289 + tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409;
                   const real_t tmp_qloop_411 = tmp_qloop_403*2.0 + tmp_qloop_404*2.0 + tmp_qloop_405*2.0;
                   const real_t tmp_qloop_419 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_424 = tmp_qloop_289 + tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423;
                   const real_t tmp_qloop_425 = tmp_qloop_417*2.0 + tmp_qloop_418*2.0 + tmp_qloop_419*2.0;
                   const real_t tmp_qloop_434 = tmp_qloop_113 + tmp_qloop_280;
                   const real_t tmp_qloop_440 = tmp_qloop_127 + tmp_qloop_289;
                   const real_t tmp_qloop_441 = tmp_qloop_129*tmp_qloop_440 + tmp_qloop_141 + tmp_qloop_292;
                   const real_t tmp_qloop_446 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_461 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_476 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_491 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_506 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_521 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_536 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_551 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_566 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_581 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_586 = tmp_qloop_128*2.0 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_593 = tmp_qloop_440*tmp_qloop_586 + tmp_qloop_589;
                   const real_t tmp_qloop_594 = tmp_qloop_141 + tmp_qloop_593;
                   const real_t tmp_qloop_597 = tmp_qloop_128*2.0 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_602 = tmp_qloop_440*tmp_qloop_597 + tmp_qloop_599;
                   const real_t tmp_qloop_603 = tmp_qloop_141 + tmp_qloop_602;
                   const real_t tmp_qloop_606 = tmp_qloop_128*2.0 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_611 = tmp_qloop_440*tmp_qloop_606 + tmp_qloop_608;
                   const real_t tmp_qloop_612 = tmp_qloop_141 + tmp_qloop_611;
                   const real_t tmp_qloop_615 = tmp_qloop_128*2.0 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_620 = tmp_qloop_440*tmp_qloop_615 + tmp_qloop_617;
                   const real_t tmp_qloop_621 = tmp_qloop_141 + tmp_qloop_620;
                   const real_t tmp_qloop_624 = tmp_qloop_128*2.0 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_629 = tmp_qloop_440*tmp_qloop_624 + tmp_qloop_626;
                   const real_t tmp_qloop_630 = tmp_qloop_141 + tmp_qloop_629;
                   const real_t tmp_qloop_633 = tmp_qloop_128*2.0 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_638 = tmp_qloop_440*tmp_qloop_633 + tmp_qloop_635;
                   const real_t tmp_qloop_639 = tmp_qloop_141 + tmp_qloop_638;
                   const real_t tmp_qloop_642 = tmp_qloop_128*2.0 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_647 = tmp_qloop_440*tmp_qloop_642 + tmp_qloop_644;
                   const real_t tmp_qloop_648 = tmp_qloop_141 + tmp_qloop_647;
                   const real_t tmp_qloop_651 = tmp_qloop_128*2.0 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_656 = tmp_qloop_440*tmp_qloop_651 + tmp_qloop_653;
                   const real_t tmp_qloop_657 = tmp_qloop_141 + tmp_qloop_656;
                   const real_t tmp_qloop_660 = tmp_qloop_128*2.0 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_665 = tmp_qloop_440*tmp_qloop_660 + tmp_qloop_662;
                   const real_t tmp_qloop_666 = tmp_qloop_141 + tmp_qloop_665;
                   const real_t tmp_qloop_670 = tmp_qloop_274*1.0 + tmp_qloop_275*1.0 + tmp_qloop_276*1.0;
                   const real_t tmp_qloop_671 = tmp_qloop_286*0.5 + tmp_qloop_287*0.5 + tmp_qloop_288*0.5;
                   const real_t tmp_qloop_672 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_678 = tmp_qloop_140*tmp_qloop_670 + tmp_qloop_440*tmp_qloop_672 + tmp_qloop_674;
                   const real_t tmp_qloop_690 = tmp_qloop_305*1.0 + tmp_qloop_306*1.0 + tmp_qloop_307*1.0;
                   const real_t tmp_qloop_691 = tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_694 = tmp_qloop_140*tmp_qloop_690 + tmp_qloop_440*tmp_qloop_691;
                   const real_t tmp_qloop_695 = tmp_qloop_674 + tmp_qloop_694;
                   const real_t tmp_qloop_697 = tmp_qloop_319*1.0 + tmp_qloop_320*1.0 + tmp_qloop_321*1.0;
                   const real_t tmp_qloop_698 = tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_700 = tmp_qloop_140*tmp_qloop_697 + tmp_qloop_440*tmp_qloop_698;
                   const real_t tmp_qloop_701 = tmp_qloop_674 + tmp_qloop_700;
                   const real_t tmp_qloop_703 = tmp_qloop_333*1.0 + tmp_qloop_334*1.0 + tmp_qloop_335*1.0;
                   const real_t tmp_qloop_704 = tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_706 = tmp_qloop_140*tmp_qloop_703 + tmp_qloop_440*tmp_qloop_704;
                   const real_t tmp_qloop_707 = tmp_qloop_674 + tmp_qloop_706;
                   const real_t tmp_qloop_709 = tmp_qloop_347*1.0 + tmp_qloop_348*1.0 + tmp_qloop_349*1.0;
                   const real_t tmp_qloop_710 = tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_712 = tmp_qloop_140*tmp_qloop_709 + tmp_qloop_440*tmp_qloop_710;
                   const real_t tmp_qloop_713 = tmp_qloop_674 + tmp_qloop_712;
                   const real_t tmp_qloop_715 = tmp_qloop_361*1.0 + tmp_qloop_362*1.0 + tmp_qloop_363*1.0;
                   const real_t tmp_qloop_716 = tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_718 = tmp_qloop_140*tmp_qloop_715 + tmp_qloop_440*tmp_qloop_716;
                   const real_t tmp_qloop_719 = tmp_qloop_674 + tmp_qloop_718;
                   const real_t tmp_qloop_721 = tmp_qloop_375*1.0 + tmp_qloop_376*1.0 + tmp_qloop_377*1.0;
                   const real_t tmp_qloop_722 = tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_724 = tmp_qloop_140*tmp_qloop_721 + tmp_qloop_440*tmp_qloop_722;
                   const real_t tmp_qloop_725 = tmp_qloop_674 + tmp_qloop_724;
                   const real_t tmp_qloop_727 = tmp_qloop_389*1.0 + tmp_qloop_390*1.0 + tmp_qloop_391*1.0;
                   const real_t tmp_qloop_728 = tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_730 = tmp_qloop_140*tmp_qloop_727 + tmp_qloop_440*tmp_qloop_728;
                   const real_t tmp_qloop_731 = tmp_qloop_674 + tmp_qloop_730;
                   const real_t tmp_qloop_733 = tmp_qloop_403*1.0 + tmp_qloop_404*1.0 + tmp_qloop_405*1.0;
                   const real_t tmp_qloop_734 = tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_736 = tmp_qloop_140*tmp_qloop_733 + tmp_qloop_440*tmp_qloop_734;
                   const real_t tmp_qloop_737 = tmp_qloop_674 + tmp_qloop_736;
                   const real_t tmp_qloop_739 = tmp_qloop_417*1.0 + tmp_qloop_418*1.0 + tmp_qloop_419*1.0;
                   const real_t tmp_qloop_740 = tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_742 = tmp_qloop_140*tmp_qloop_739 + tmp_qloop_440*tmp_qloop_740;
                   const real_t tmp_qloop_743 = tmp_qloop_674 + tmp_qloop_742;
                   const real_t tmp_qloop_744 = tmp_qloop_116 + tmp_qloop_667;
                   const real_t tmp_qloop_749 = tmp_qloop_141 + tmp_qloop_440*(tmp_qloop_128 + tmp_qloop_671)*2.0 + tmp_qloop_674;
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_119 = tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_117);
                   const real_t tmp_qloop_132 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_138 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_137*2.0;
                   const real_t tmp_qloop_142 = tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0;
                   const real_t tmp_qloop_143 = tmp_qloop_142*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q];
                   const real_t tmp_qloop_151 = tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150;
                   const real_t tmp_qloop_153 = tmp_qloop_148*0.5 + tmp_qloop_149*0.5 + tmp_qloop_150*0.5;
                   const real_t tmp_qloop_154 = tmp_qloop_152*2.0 + tmp_qloop_153*2.0;
                   const real_t tmp_qloop_155 = tmp_qloop_141 + tmp_qloop_143 + tmp_qloop_154*(tmp_qloop_147 + tmp_qloop_151);
                   const real_t tmp_qloop_160 = tmp_qloop_114 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663;
                   const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_169 = tmp_qloop_136 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_173 = tmp_qloop_114 + tmp_qloop_170*0.66666666666666663 + tmp_qloop_171*0.66666666666666663 + tmp_qloop_172*0.66666666666666663;
                   const real_t tmp_qloop_181 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_182 = tmp_qloop_136 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_186 = tmp_qloop_114 + tmp_qloop_183*0.66666666666666663 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663;
                   const real_t tmp_qloop_194 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_195 = tmp_qloop_136 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_199 = tmp_qloop_114 + tmp_qloop_196*0.66666666666666663 + tmp_qloop_197*0.66666666666666663 + tmp_qloop_198*0.66666666666666663;
                   const real_t tmp_qloop_207 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_208 = tmp_qloop_136 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_212 = tmp_qloop_114 + tmp_qloop_209*0.66666666666666663 + tmp_qloop_210*0.66666666666666663 + tmp_qloop_211*0.66666666666666663;
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_221 = tmp_qloop_136 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_225 = tmp_qloop_114 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663 + tmp_qloop_224*0.66666666666666663;
                   const real_t tmp_qloop_233 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_234 = tmp_qloop_136 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_238 = tmp_qloop_114 + tmp_qloop_235*0.66666666666666663 + tmp_qloop_236*0.66666666666666663 + tmp_qloop_237*0.66666666666666663;
                   const real_t tmp_qloop_246 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_247 = tmp_qloop_136 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_251 = tmp_qloop_114 + tmp_qloop_248*0.66666666666666663 + tmp_qloop_249*0.66666666666666663 + tmp_qloop_250*0.66666666666666663;
                   const real_t tmp_qloop_259 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_260 = tmp_qloop_136 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_264 = tmp_qloop_114 + tmp_qloop_261*0.66666666666666663 + tmp_qloop_262*0.66666666666666663 + tmp_qloop_263*0.66666666666666663;
                   const real_t tmp_qloop_272 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_273 = tmp_qloop_136 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_281 = tmp_qloop_109 + tmp_qloop_280;
                   const real_t tmp_qloop_282 = tmp_qloop_274*0.66666666666666663 + tmp_qloop_275*0.66666666666666663 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_281;
                   const real_t tmp_qloop_295 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_296 = tmp_qloop_293 + tmp_qloop_294 + tmp_qloop_295;
                   const real_t tmp_qloop_297 = tmp_qloop_136 + tmp_qloop_296;
                   const real_t tmp_qloop_298 = tmp_qloop_138*tmp_qloop_297 + tmp_qloop_143 + tmp_qloop_292;
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_303 = tmp_qloop_147 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_304 = tmp_qloop_139*tmp_qloop_299 + tmp_qloop_154*tmp_qloop_303;
                   const real_t tmp_qloop_308 = tmp_qloop_281 + tmp_qloop_305*0.66666666666666663 + tmp_qloop_306*0.66666666666666663 + tmp_qloop_307*0.66666666666666663;
                   const real_t tmp_qloop_316 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_317 = tmp_qloop_147 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_318 = tmp_qloop_139*tmp_qloop_313 + tmp_qloop_154*tmp_qloop_317;
                   const real_t tmp_qloop_322 = tmp_qloop_281 + tmp_qloop_319*0.66666666666666663 + tmp_qloop_320*0.66666666666666663 + tmp_qloop_321*0.66666666666666663;
                   const real_t tmp_qloop_330 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_331 = tmp_qloop_147 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_332 = tmp_qloop_139*tmp_qloop_327 + tmp_qloop_154*tmp_qloop_331;
                   const real_t tmp_qloop_336 = tmp_qloop_281 + tmp_qloop_333*0.66666666666666663 + tmp_qloop_334*0.66666666666666663 + tmp_qloop_335*0.66666666666666663;
                   const real_t tmp_qloop_344 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_345 = tmp_qloop_147 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_346 = tmp_qloop_139*tmp_qloop_341 + tmp_qloop_154*tmp_qloop_345;
                   const real_t tmp_qloop_350 = tmp_qloop_281 + tmp_qloop_347*0.66666666666666663 + tmp_qloop_348*0.66666666666666663 + tmp_qloop_349*0.66666666666666663;
                   const real_t tmp_qloop_358 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_359 = tmp_qloop_147 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_360 = tmp_qloop_139*tmp_qloop_355 + tmp_qloop_154*tmp_qloop_359;
                   const real_t tmp_qloop_364 = tmp_qloop_281 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663 + tmp_qloop_363*0.66666666666666663;
                   const real_t tmp_qloop_372 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_373 = tmp_qloop_147 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_374 = tmp_qloop_139*tmp_qloop_369 + tmp_qloop_154*tmp_qloop_373;
                   const real_t tmp_qloop_378 = tmp_qloop_281 + tmp_qloop_375*0.66666666666666663 + tmp_qloop_376*0.66666666666666663 + tmp_qloop_377*0.66666666666666663;
                   const real_t tmp_qloop_386 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_387 = tmp_qloop_147 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_388 = tmp_qloop_139*tmp_qloop_383 + tmp_qloop_154*tmp_qloop_387;
                   const real_t tmp_qloop_392 = tmp_qloop_281 + tmp_qloop_389*0.66666666666666663 + tmp_qloop_390*0.66666666666666663 + tmp_qloop_391*0.66666666666666663;
                   const real_t tmp_qloop_400 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_401 = tmp_qloop_147 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_402 = tmp_qloop_139*tmp_qloop_397 + tmp_qloop_154*tmp_qloop_401;
                   const real_t tmp_qloop_406 = tmp_qloop_281 + tmp_qloop_403*0.66666666666666663 + tmp_qloop_404*0.66666666666666663 + tmp_qloop_405*0.66666666666666663;
                   const real_t tmp_qloop_414 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_415 = tmp_qloop_147 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_416 = tmp_qloop_139*tmp_qloop_411 + tmp_qloop_154*tmp_qloop_415;
                   const real_t tmp_qloop_420 = tmp_qloop_281 + tmp_qloop_417*0.66666666666666663 + tmp_qloop_418*0.66666666666666663 + tmp_qloop_419*0.66666666666666663;
                   const real_t tmp_qloop_428 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_429 = tmp_qloop_147 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_430 = tmp_qloop_139*tmp_qloop_425 + tmp_qloop_154*tmp_qloop_429;
                   const real_t tmp_qloop_433 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 1];
                   const real_t tmp_qloop_435 = tmp_qloop_431*0.66666666666666663 + tmp_qloop_432*0.66666666666666663 + tmp_qloop_433*0.66666666666666663 + tmp_qloop_434;
                   const real_t tmp_qloop_439 = tmp_qloop_296 + tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438;
                   const real_t tmp_qloop_442 = tmp_qloop_431*2.0 + tmp_qloop_432*2.0 + tmp_qloop_433*2.0;
                   const real_t tmp_qloop_443 = tmp_qloop_142*tmp_qloop_442;
                   const real_t tmp_qloop_447 = tmp_qloop_151 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_448 = tmp_qloop_154*tmp_qloop_447 + tmp_qloop_443;
                   const real_t tmp_qloop_451 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 2];
                   const real_t tmp_qloop_452 = tmp_qloop_434 + tmp_qloop_449*0.66666666666666663 + tmp_qloop_450*0.66666666666666663 + tmp_qloop_451*0.66666666666666663;
                   const real_t tmp_qloop_456 = tmp_qloop_296 + tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455;
                   const real_t tmp_qloop_457 = tmp_qloop_449*2.0 + tmp_qloop_450*2.0 + tmp_qloop_451*2.0;
                   const real_t tmp_qloop_458 = tmp_qloop_142*tmp_qloop_457;
                   const real_t tmp_qloop_462 = tmp_qloop_151 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_463 = tmp_qloop_154*tmp_qloop_462 + tmp_qloop_458;
                   const real_t tmp_qloop_466 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 3];
                   const real_t tmp_qloop_467 = tmp_qloop_434 + tmp_qloop_464*0.66666666666666663 + tmp_qloop_465*0.66666666666666663 + tmp_qloop_466*0.66666666666666663;
                   const real_t tmp_qloop_471 = tmp_qloop_296 + tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470;
                   const real_t tmp_qloop_472 = tmp_qloop_464*2.0 + tmp_qloop_465*2.0 + tmp_qloop_466*2.0;
                   const real_t tmp_qloop_473 = tmp_qloop_142*tmp_qloop_472;
                   const real_t tmp_qloop_477 = tmp_qloop_151 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_478 = tmp_qloop_154*tmp_qloop_477 + tmp_qloop_473;
                   const real_t tmp_qloop_481 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 4];
                   const real_t tmp_qloop_482 = tmp_qloop_434 + tmp_qloop_479*0.66666666666666663 + tmp_qloop_480*0.66666666666666663 + tmp_qloop_481*0.66666666666666663;
                   const real_t tmp_qloop_486 = tmp_qloop_296 + tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485;
                   const real_t tmp_qloop_487 = tmp_qloop_479*2.0 + tmp_qloop_480*2.0 + tmp_qloop_481*2.0;
                   const real_t tmp_qloop_488 = tmp_qloop_142*tmp_qloop_487;
                   const real_t tmp_qloop_492 = tmp_qloop_151 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_493 = tmp_qloop_154*tmp_qloop_492 + tmp_qloop_488;
                   const real_t tmp_qloop_496 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 5];
                   const real_t tmp_qloop_497 = tmp_qloop_434 + tmp_qloop_494*0.66666666666666663 + tmp_qloop_495*0.66666666666666663 + tmp_qloop_496*0.66666666666666663;
                   const real_t tmp_qloop_501 = tmp_qloop_296 + tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500;
                   const real_t tmp_qloop_502 = tmp_qloop_494*2.0 + tmp_qloop_495*2.0 + tmp_qloop_496*2.0;
                   const real_t tmp_qloop_503 = tmp_qloop_142*tmp_qloop_502;
                   const real_t tmp_qloop_507 = tmp_qloop_151 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_508 = tmp_qloop_154*tmp_qloop_507 + tmp_qloop_503;
                   const real_t tmp_qloop_511 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 6];
                   const real_t tmp_qloop_512 = tmp_qloop_434 + tmp_qloop_509*0.66666666666666663 + tmp_qloop_510*0.66666666666666663 + tmp_qloop_511*0.66666666666666663;
                   const real_t tmp_qloop_516 = tmp_qloop_296 + tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515;
                   const real_t tmp_qloop_517 = tmp_qloop_509*2.0 + tmp_qloop_510*2.0 + tmp_qloop_511*2.0;
                   const real_t tmp_qloop_518 = tmp_qloop_142*tmp_qloop_517;
                   const real_t tmp_qloop_522 = tmp_qloop_151 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_523 = tmp_qloop_154*tmp_qloop_522 + tmp_qloop_518;
                   const real_t tmp_qloop_526 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 7];
                   const real_t tmp_qloop_527 = tmp_qloop_434 + tmp_qloop_524*0.66666666666666663 + tmp_qloop_525*0.66666666666666663 + tmp_qloop_526*0.66666666666666663;
                   const real_t tmp_qloop_531 = tmp_qloop_296 + tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530;
                   const real_t tmp_qloop_532 = tmp_qloop_524*2.0 + tmp_qloop_525*2.0 + tmp_qloop_526*2.0;
                   const real_t tmp_qloop_533 = tmp_qloop_142*tmp_qloop_532;
                   const real_t tmp_qloop_537 = tmp_qloop_151 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_538 = tmp_qloop_154*tmp_qloop_537 + tmp_qloop_533;
                   const real_t tmp_qloop_541 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 8];
                   const real_t tmp_qloop_542 = tmp_qloop_434 + tmp_qloop_539*0.66666666666666663 + tmp_qloop_540*0.66666666666666663 + tmp_qloop_541*0.66666666666666663;
                   const real_t tmp_qloop_546 = tmp_qloop_296 + tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545;
                   const real_t tmp_qloop_547 = tmp_qloop_539*2.0 + tmp_qloop_540*2.0 + tmp_qloop_541*2.0;
                   const real_t tmp_qloop_548 = tmp_qloop_142*tmp_qloop_547;
                   const real_t tmp_qloop_552 = tmp_qloop_151 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_553 = tmp_qloop_154*tmp_qloop_552 + tmp_qloop_548;
                   const real_t tmp_qloop_556 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 9];
                   const real_t tmp_qloop_557 = tmp_qloop_434 + tmp_qloop_554*0.66666666666666663 + tmp_qloop_555*0.66666666666666663 + tmp_qloop_556*0.66666666666666663;
                   const real_t tmp_qloop_561 = tmp_qloop_296 + tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560;
                   const real_t tmp_qloop_562 = tmp_qloop_554*2.0 + tmp_qloop_555*2.0 + tmp_qloop_556*2.0;
                   const real_t tmp_qloop_563 = tmp_qloop_142*tmp_qloop_562;
                   const real_t tmp_qloop_567 = tmp_qloop_151 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t tmp_qloop_568 = tmp_qloop_154*tmp_qloop_567 + tmp_qloop_563;
                   const real_t tmp_qloop_571 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[11*q + 10];
                   const real_t tmp_qloop_572 = tmp_qloop_434 + tmp_qloop_569*0.66666666666666663 + tmp_qloop_570*0.66666666666666663 + tmp_qloop_571*0.66666666666666663;
                   const real_t tmp_qloop_576 = tmp_qloop_296 + tmp_qloop_573 + tmp_qloop_574 + tmp_qloop_575;
                   const real_t tmp_qloop_577 = tmp_qloop_569*2.0 + tmp_qloop_570*2.0 + tmp_qloop_571*2.0;
                   const real_t tmp_qloop_578 = tmp_qloop_142*tmp_qloop_577;
                   const real_t tmp_qloop_582 = tmp_qloop_151 + tmp_qloop_579 + tmp_qloop_580 + tmp_qloop_581;
                   const real_t tmp_qloop_583 = tmp_qloop_154*tmp_qloop_582 + tmp_qloop_578;
                   const real_t tmp_qloop_584 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159);
                   const real_t tmp_qloop_587 = tmp_qloop_137*2.0 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_588 = tmp_qloop_143 + tmp_qloop_304;
                   const real_t tmp_qloop_590 = tmp_qloop_297*tmp_qloop_587 + tmp_qloop_589;
                   const real_t tmp_qloop_591 = tmp_qloop_143 + tmp_qloop_590;
                   const real_t tmp_qloop_592 = tmp_qloop_141 + tmp_qloop_448;
                   const real_t tmp_qloop_595 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172);
                   const real_t tmp_qloop_598 = tmp_qloop_137*2.0 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_600 = tmp_qloop_297*tmp_qloop_598 + tmp_qloop_599;
                   const real_t tmp_qloop_601 = tmp_qloop_143 + tmp_qloop_600;
                   const real_t tmp_qloop_604 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_183 + tmp_qloop_184 + tmp_qloop_185);
                   const real_t tmp_qloop_607 = tmp_qloop_137*2.0 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_609 = tmp_qloop_297*tmp_qloop_607 + tmp_qloop_608;
                   const real_t tmp_qloop_610 = tmp_qloop_143 + tmp_qloop_609;
                   const real_t tmp_qloop_613 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198);
                   const real_t tmp_qloop_616 = tmp_qloop_137*2.0 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_618 = tmp_qloop_297*tmp_qloop_616 + tmp_qloop_617;
                   const real_t tmp_qloop_619 = tmp_qloop_143 + tmp_qloop_618;
                   const real_t tmp_qloop_622 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211);
                   const real_t tmp_qloop_625 = tmp_qloop_137*2.0 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_627 = tmp_qloop_297*tmp_qloop_625 + tmp_qloop_626;
                   const real_t tmp_qloop_628 = tmp_qloop_143 + tmp_qloop_627;
                   const real_t tmp_qloop_631 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_222 + tmp_qloop_223 + tmp_qloop_224);
                   const real_t tmp_qloop_634 = tmp_qloop_137*2.0 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_636 = tmp_qloop_297*tmp_qloop_634 + tmp_qloop_635;
                   const real_t tmp_qloop_637 = tmp_qloop_143 + tmp_qloop_636;
                   const real_t tmp_qloop_640 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_235 + tmp_qloop_236 + tmp_qloop_237);
                   const real_t tmp_qloop_643 = tmp_qloop_137*2.0 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_645 = tmp_qloop_297*tmp_qloop_643 + tmp_qloop_644;
                   const real_t tmp_qloop_646 = tmp_qloop_143 + tmp_qloop_645;
                   const real_t tmp_qloop_649 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250);
                   const real_t tmp_qloop_652 = tmp_qloop_137*2.0 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_654 = tmp_qloop_297*tmp_qloop_652 + tmp_qloop_653;
                   const real_t tmp_qloop_655 = tmp_qloop_143 + tmp_qloop_654;
                   const real_t tmp_qloop_658 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263);
                   const real_t tmp_qloop_661 = tmp_qloop_137*2.0 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_663 = tmp_qloop_297*tmp_qloop_661 + tmp_qloop_662;
                   const real_t tmp_qloop_664 = tmp_qloop_143 + tmp_qloop_663;
                   const real_t tmp_qloop_668 = tmp_qloop_115 + tmp_qloop_667;
                   const real_t tmp_qloop_669 = tmp_qloop_118*(tmp_qloop_274 + tmp_qloop_275 + tmp_qloop_276 + tmp_qloop_668);
                   const real_t tmp_qloop_673 = tmp_qloop_152*2.0 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_675 = tmp_qloop_293*0.5 + tmp_qloop_294*0.5 + tmp_qloop_295*0.5;
                   const real_t tmp_qloop_676 = tmp_qloop_137*2.0 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_677 = tmp_qloop_143 + tmp_qloop_297*tmp_qloop_676 + tmp_qloop_674;
                   const real_t tmp_qloop_679 = tmp_qloop_439*tmp_qloop_676 + tmp_qloop_443;
                   const real_t tmp_qloop_680 = tmp_qloop_456*tmp_qloop_676 + tmp_qloop_458;
                   const real_t tmp_qloop_681 = tmp_qloop_471*tmp_qloop_676 + tmp_qloop_473;
                   const real_t tmp_qloop_682 = tmp_qloop_486*tmp_qloop_676 + tmp_qloop_488;
                   const real_t tmp_qloop_683 = tmp_qloop_501*tmp_qloop_676 + tmp_qloop_503;
                   const real_t tmp_qloop_684 = tmp_qloop_516*tmp_qloop_676 + tmp_qloop_518;
                   const real_t tmp_qloop_685 = tmp_qloop_531*tmp_qloop_676 + tmp_qloop_533;
                   const real_t tmp_qloop_686 = tmp_qloop_546*tmp_qloop_676 + tmp_qloop_548;
                   const real_t tmp_qloop_687 = tmp_qloop_561*tmp_qloop_676 + tmp_qloop_563;
                   const real_t tmp_qloop_688 = tmp_qloop_576*tmp_qloop_676 + tmp_qloop_578;
                   const real_t tmp_qloop_689 = tmp_qloop_118*(tmp_qloop_305 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_668);
                   const real_t tmp_qloop_692 = tmp_qloop_152*2.0 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_693 = tmp_qloop_674 + tmp_qloop_679;
                   const real_t tmp_qloop_696 = tmp_qloop_118*(tmp_qloop_319 + tmp_qloop_320 + tmp_qloop_321 + tmp_qloop_668);
                   const real_t tmp_qloop_699 = tmp_qloop_152*2.0 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_702 = tmp_qloop_118*(tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335 + tmp_qloop_668);
                   const real_t tmp_qloop_705 = tmp_qloop_152*2.0 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_708 = tmp_qloop_118*(tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349 + tmp_qloop_668);
                   const real_t tmp_qloop_711 = tmp_qloop_152*2.0 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_714 = tmp_qloop_118*(tmp_qloop_361 + tmp_qloop_362 + tmp_qloop_363 + tmp_qloop_668);
                   const real_t tmp_qloop_717 = tmp_qloop_152*2.0 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_720 = tmp_qloop_118*(tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377 + tmp_qloop_668);
                   const real_t tmp_qloop_723 = tmp_qloop_152*2.0 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_726 = tmp_qloop_118*(tmp_qloop_389 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_668);
                   const real_t tmp_qloop_729 = tmp_qloop_152*2.0 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_732 = tmp_qloop_118*(tmp_qloop_403 + tmp_qloop_404 + tmp_qloop_405 + tmp_qloop_668);
                   const real_t tmp_qloop_735 = tmp_qloop_152*2.0 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_738 = tmp_qloop_118*(tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419 + tmp_qloop_668);
                   const real_t tmp_qloop_741 = tmp_qloop_152*2.0 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_745 = tmp_qloop_118*(tmp_qloop_431 + tmp_qloop_432 + tmp_qloop_433 + tmp_qloop_744);
                   const real_t tmp_qloop_746 = tmp_qloop_431*1.0 + tmp_qloop_432*1.0 + tmp_qloop_433*1.0;
                   const real_t tmp_qloop_747 = tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_748 = tmp_qloop_153*2.0 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_750 = tmp_qloop_118*(tmp_qloop_449 + tmp_qloop_450 + tmp_qloop_451 + tmp_qloop_744);
                   const real_t tmp_qloop_751 = tmp_qloop_449*1.0 + tmp_qloop_450*1.0 + tmp_qloop_451*1.0;
                   const real_t tmp_qloop_752 = tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_753 = tmp_qloop_153*2.0 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_754 = tmp_qloop_118*(tmp_qloop_464 + tmp_qloop_465 + tmp_qloop_466 + tmp_qloop_744);
                   const real_t tmp_qloop_755 = tmp_qloop_464*1.0 + tmp_qloop_465*1.0 + tmp_qloop_466*1.0;
                   const real_t tmp_qloop_756 = tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_757 = tmp_qloop_153*2.0 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_758 = tmp_qloop_118*(tmp_qloop_479 + tmp_qloop_480 + tmp_qloop_481 + tmp_qloop_744);
                   const real_t tmp_qloop_759 = tmp_qloop_479*1.0 + tmp_qloop_480*1.0 + tmp_qloop_481*1.0;
                   const real_t tmp_qloop_760 = tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_761 = tmp_qloop_153*2.0 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_762 = tmp_qloop_118*(tmp_qloop_494 + tmp_qloop_495 + tmp_qloop_496 + tmp_qloop_744);
                   const real_t tmp_qloop_763 = tmp_qloop_494*1.0 + tmp_qloop_495*1.0 + tmp_qloop_496*1.0;
                   const real_t tmp_qloop_764 = tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_765 = tmp_qloop_153*2.0 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_766 = tmp_qloop_118*(tmp_qloop_509 + tmp_qloop_510 + tmp_qloop_511 + tmp_qloop_744);
                   const real_t tmp_qloop_767 = tmp_qloop_509*1.0 + tmp_qloop_510*1.0 + tmp_qloop_511*1.0;
                   const real_t tmp_qloop_768 = tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_769 = tmp_qloop_153*2.0 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_770 = tmp_qloop_118*(tmp_qloop_524 + tmp_qloop_525 + tmp_qloop_526 + tmp_qloop_744);
                   const real_t tmp_qloop_771 = tmp_qloop_524*1.0 + tmp_qloop_525*1.0 + tmp_qloop_526*1.0;
                   const real_t tmp_qloop_772 = tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_773 = tmp_qloop_153*2.0 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_774 = tmp_qloop_118*(tmp_qloop_539 + tmp_qloop_540 + tmp_qloop_541 + tmp_qloop_744);
                   const real_t tmp_qloop_775 = tmp_qloop_539*1.0 + tmp_qloop_540*1.0 + tmp_qloop_541*1.0;
                   const real_t tmp_qloop_776 = tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_777 = tmp_qloop_153*2.0 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_778 = tmp_qloop_118*(tmp_qloop_554 + tmp_qloop_555 + tmp_qloop_556 + tmp_qloop_744);
                   const real_t tmp_qloop_779 = tmp_qloop_554*1.0 + tmp_qloop_555*1.0 + tmp_qloop_556*1.0;
                   const real_t tmp_qloop_780 = tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_781 = tmp_qloop_153*2.0 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + tmp_qloop_129*(tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_127) + tmp_qloop_138*(tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_136) + tmp_qloop_155) - tmp_qloop_119*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_114));
                   const real_t q_tmp_0_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_161 + tmp_qloop_129*tmp_qloop_165 + tmp_qloop_138*tmp_qloop_169 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_160);
                   const real_t q_tmp_0_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_174 + tmp_qloop_129*tmp_qloop_178 + tmp_qloop_138*tmp_qloop_182 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_173);
                   const real_t q_tmp_0_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_187 + tmp_qloop_129*tmp_qloop_191 + tmp_qloop_138*tmp_qloop_195 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_186);
                   const real_t q_tmp_0_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_200 + tmp_qloop_129*tmp_qloop_204 + tmp_qloop_138*tmp_qloop_208 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_199);
                   const real_t q_tmp_0_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_213 + tmp_qloop_129*tmp_qloop_217 + tmp_qloop_138*tmp_qloop_221 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_212);
                   const real_t q_tmp_0_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_226 + tmp_qloop_129*tmp_qloop_230 + tmp_qloop_138*tmp_qloop_234 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_225);
                   const real_t q_tmp_0_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_239 + tmp_qloop_129*tmp_qloop_243 + tmp_qloop_138*tmp_qloop_247 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_238);
                   const real_t q_tmp_0_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_252 + tmp_qloop_129*tmp_qloop_256 + tmp_qloop_138*tmp_qloop_260 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_251);
                   const real_t q_tmp_0_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_265 + tmp_qloop_129*tmp_qloop_269 + tmp_qloop_138*tmp_qloop_273 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_264);
                   const real_t q_tmp_0_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_290 + tmp_qloop_298 + tmp_qloop_304) - tmp_qloop_119*tmp_qloop_282);
                   const real_t q_tmp_0_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_312 + tmp_qloop_298 + tmp_qloop_318) - tmp_qloop_119*tmp_qloop_308);
                   const real_t q_tmp_0_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_326 + tmp_qloop_298 + tmp_qloop_332) - tmp_qloop_119*tmp_qloop_322);
                   const real_t q_tmp_0_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_340 + tmp_qloop_298 + tmp_qloop_346) - tmp_qloop_119*tmp_qloop_336);
                   const real_t q_tmp_0_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_354 + tmp_qloop_298 + tmp_qloop_360) - tmp_qloop_119*tmp_qloop_350);
                   const real_t q_tmp_0_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_368 + tmp_qloop_298 + tmp_qloop_374) - tmp_qloop_119*tmp_qloop_364);
                   const real_t q_tmp_0_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_382 + tmp_qloop_298 + tmp_qloop_388) - tmp_qloop_119*tmp_qloop_378);
                   const real_t q_tmp_0_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_396 + tmp_qloop_298 + tmp_qloop_402) - tmp_qloop_119*tmp_qloop_392);
                   const real_t q_tmp_0_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_410 + tmp_qloop_298 + tmp_qloop_416) - tmp_qloop_119*tmp_qloop_406);
                   const real_t q_tmp_0_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_424 + tmp_qloop_298 + tmp_qloop_430) - tmp_qloop_119*tmp_qloop_420);
                   const real_t q_tmp_0_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_439 + tmp_qloop_441 + tmp_qloop_448) - tmp_qloop_119*tmp_qloop_435);
                   const real_t q_tmp_0_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_456 + tmp_qloop_441 + tmp_qloop_463) - tmp_qloop_119*tmp_qloop_452);
                   const real_t q_tmp_0_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_471 + tmp_qloop_441 + tmp_qloop_478) - tmp_qloop_119*tmp_qloop_467);
                   const real_t q_tmp_0_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_486 + tmp_qloop_441 + tmp_qloop_493) - tmp_qloop_119*tmp_qloop_482);
                   const real_t q_tmp_0_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_501 + tmp_qloop_441 + tmp_qloop_508) - tmp_qloop_119*tmp_qloop_497);
                   const real_t q_tmp_0_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_516 + tmp_qloop_441 + tmp_qloop_523) - tmp_qloop_119*tmp_qloop_512);
                   const real_t q_tmp_0_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_531 + tmp_qloop_441 + tmp_qloop_538) - tmp_qloop_119*tmp_qloop_527);
                   const real_t q_tmp_0_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_546 + tmp_qloop_441 + tmp_qloop_553) - tmp_qloop_119*tmp_qloop_542);
                   const real_t q_tmp_0_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_561 + tmp_qloop_441 + tmp_qloop_568) - tmp_qloop_119*tmp_qloop_557);
                   const real_t q_tmp_0_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_576 + tmp_qloop_441 + tmp_qloop_583) - tmp_qloop_119*tmp_qloop_572);
                   const real_t q_tmp_1_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_161*tmp_qloop_585 + tmp_qloop_165*tmp_qloop_586 + tmp_qloop_169*tmp_qloop_587) - tmp_qloop_160*tmp_qloop_584);
                   const real_t q_tmp_1_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_585 + tmp_qloop_178*tmp_qloop_586 + tmp_qloop_182*tmp_qloop_587) - tmp_qloop_173*tmp_qloop_584);
                   const real_t q_tmp_1_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_585 + tmp_qloop_191*tmp_qloop_586 + tmp_qloop_195*tmp_qloop_587) - tmp_qloop_186*tmp_qloop_584);
                   const real_t q_tmp_1_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_585 + tmp_qloop_204*tmp_qloop_586 + tmp_qloop_208*tmp_qloop_587) - tmp_qloop_199*tmp_qloop_584);
                   const real_t q_tmp_1_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_585 + tmp_qloop_217*tmp_qloop_586 + tmp_qloop_221*tmp_qloop_587) - tmp_qloop_212*tmp_qloop_584);
                   const real_t q_tmp_1_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_585 + tmp_qloop_230*tmp_qloop_586 + tmp_qloop_234*tmp_qloop_587) - tmp_qloop_225*tmp_qloop_584);
                   const real_t q_tmp_1_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_585 + tmp_qloop_243*tmp_qloop_586 + tmp_qloop_247*tmp_qloop_587) - tmp_qloop_238*tmp_qloop_584);
                   const real_t q_tmp_1_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_585 + tmp_qloop_256*tmp_qloop_586 + tmp_qloop_260*tmp_qloop_587) - tmp_qloop_251*tmp_qloop_584);
                   const real_t q_tmp_1_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_585 + tmp_qloop_269*tmp_qloop_586 + tmp_qloop_273*tmp_qloop_587) - tmp_qloop_264*tmp_qloop_584);
                   const real_t q_tmp_1_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_586 + tmp_qloop_588 + tmp_qloop_590) - tmp_qloop_282*tmp_qloop_584);
                   const real_t q_tmp_1_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_586 + tmp_qloop_318 + tmp_qloop_591) - tmp_qloop_308*tmp_qloop_584);
                   const real_t q_tmp_1_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_586 + tmp_qloop_332 + tmp_qloop_591) - tmp_qloop_322*tmp_qloop_584);
                   const real_t q_tmp_1_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_586 + tmp_qloop_346 + tmp_qloop_591) - tmp_qloop_336*tmp_qloop_584);
                   const real_t q_tmp_1_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_586 + tmp_qloop_360 + tmp_qloop_591) - tmp_qloop_350*tmp_qloop_584);
                   const real_t q_tmp_1_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_586 + tmp_qloop_374 + tmp_qloop_591) - tmp_qloop_364*tmp_qloop_584);
                   const real_t q_tmp_1_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_586 + tmp_qloop_388 + tmp_qloop_591) - tmp_qloop_378*tmp_qloop_584);
                   const real_t q_tmp_1_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_586 + tmp_qloop_402 + tmp_qloop_591) - tmp_qloop_392*tmp_qloop_584);
                   const real_t q_tmp_1_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_586 + tmp_qloop_416 + tmp_qloop_591) - tmp_qloop_406*tmp_qloop_584);
                   const real_t q_tmp_1_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_586 + tmp_qloop_430 + tmp_qloop_591) - tmp_qloop_420*tmp_qloop_584);
                   const real_t q_tmp_1_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_587 + tmp_qloop_592 + tmp_qloop_593) - tmp_qloop_435*tmp_qloop_584);
                   const real_t q_tmp_1_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_587 + tmp_qloop_463 + tmp_qloop_594) - tmp_qloop_452*tmp_qloop_584);
                   const real_t q_tmp_1_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_587 + tmp_qloop_478 + tmp_qloop_594) - tmp_qloop_467*tmp_qloop_584);
                   const real_t q_tmp_1_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_587 + tmp_qloop_493 + tmp_qloop_594) - tmp_qloop_482*tmp_qloop_584);
                   const real_t q_tmp_1_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_587 + tmp_qloop_508 + tmp_qloop_594) - tmp_qloop_497*tmp_qloop_584);
                   const real_t q_tmp_1_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_587 + tmp_qloop_523 + tmp_qloop_594) - tmp_qloop_512*tmp_qloop_584);
                   const real_t q_tmp_1_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_587 + tmp_qloop_538 + tmp_qloop_594) - tmp_qloop_527*tmp_qloop_584);
                   const real_t q_tmp_1_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_587 + tmp_qloop_553 + tmp_qloop_594) - tmp_qloop_542*tmp_qloop_584);
                   const real_t q_tmp_1_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_587 + tmp_qloop_568 + tmp_qloop_594) - tmp_qloop_557*tmp_qloop_584);
                   const real_t q_tmp_1_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_587 + tmp_qloop_583 + tmp_qloop_594) - tmp_qloop_572*tmp_qloop_584);
                   const real_t q_tmp_2_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_596 + tmp_qloop_178*tmp_qloop_597 + tmp_qloop_182*tmp_qloop_598) - tmp_qloop_173*tmp_qloop_595);
                   const real_t q_tmp_2_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_596 + tmp_qloop_191*tmp_qloop_597 + tmp_qloop_195*tmp_qloop_598) - tmp_qloop_186*tmp_qloop_595);
                   const real_t q_tmp_2_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_596 + tmp_qloop_204*tmp_qloop_597 + tmp_qloop_208*tmp_qloop_598) - tmp_qloop_199*tmp_qloop_595);
                   const real_t q_tmp_2_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_596 + tmp_qloop_217*tmp_qloop_597 + tmp_qloop_221*tmp_qloop_598) - tmp_qloop_212*tmp_qloop_595);
                   const real_t q_tmp_2_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_596 + tmp_qloop_230*tmp_qloop_597 + tmp_qloop_234*tmp_qloop_598) - tmp_qloop_225*tmp_qloop_595);
                   const real_t q_tmp_2_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_596 + tmp_qloop_243*tmp_qloop_597 + tmp_qloop_247*tmp_qloop_598) - tmp_qloop_238*tmp_qloop_595);
                   const real_t q_tmp_2_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_596 + tmp_qloop_256*tmp_qloop_597 + tmp_qloop_260*tmp_qloop_598) - tmp_qloop_251*tmp_qloop_595);
                   const real_t q_tmp_2_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_596 + tmp_qloop_269*tmp_qloop_597 + tmp_qloop_273*tmp_qloop_598) - tmp_qloop_264*tmp_qloop_595);
                   const real_t q_tmp_2_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_597 + tmp_qloop_588 + tmp_qloop_600) - tmp_qloop_282*tmp_qloop_595);
                   const real_t q_tmp_2_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_597 + tmp_qloop_318 + tmp_qloop_601) - tmp_qloop_308*tmp_qloop_595);
                   const real_t q_tmp_2_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_597 + tmp_qloop_332 + tmp_qloop_601) - tmp_qloop_322*tmp_qloop_595);
                   const real_t q_tmp_2_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_597 + tmp_qloop_346 + tmp_qloop_601) - tmp_qloop_336*tmp_qloop_595);
                   const real_t q_tmp_2_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_597 + tmp_qloop_360 + tmp_qloop_601) - tmp_qloop_350*tmp_qloop_595);
                   const real_t q_tmp_2_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_597 + tmp_qloop_374 + tmp_qloop_601) - tmp_qloop_364*tmp_qloop_595);
                   const real_t q_tmp_2_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_597 + tmp_qloop_388 + tmp_qloop_601) - tmp_qloop_378*tmp_qloop_595);
                   const real_t q_tmp_2_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_597 + tmp_qloop_402 + tmp_qloop_601) - tmp_qloop_392*tmp_qloop_595);
                   const real_t q_tmp_2_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_597 + tmp_qloop_416 + tmp_qloop_601) - tmp_qloop_406*tmp_qloop_595);
                   const real_t q_tmp_2_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_597 + tmp_qloop_430 + tmp_qloop_601) - tmp_qloop_420*tmp_qloop_595);
                   const real_t q_tmp_2_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_598 + tmp_qloop_592 + tmp_qloop_602) - tmp_qloop_435*tmp_qloop_595);
                   const real_t q_tmp_2_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_598 + tmp_qloop_463 + tmp_qloop_603) - tmp_qloop_452*tmp_qloop_595);
                   const real_t q_tmp_2_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_598 + tmp_qloop_478 + tmp_qloop_603) - tmp_qloop_467*tmp_qloop_595);
                   const real_t q_tmp_2_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_598 + tmp_qloop_493 + tmp_qloop_603) - tmp_qloop_482*tmp_qloop_595);
                   const real_t q_tmp_2_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_598 + tmp_qloop_508 + tmp_qloop_603) - tmp_qloop_497*tmp_qloop_595);
                   const real_t q_tmp_2_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_598 + tmp_qloop_523 + tmp_qloop_603) - tmp_qloop_512*tmp_qloop_595);
                   const real_t q_tmp_2_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_598 + tmp_qloop_538 + tmp_qloop_603) - tmp_qloop_527*tmp_qloop_595);
                   const real_t q_tmp_2_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_598 + tmp_qloop_553 + tmp_qloop_603) - tmp_qloop_542*tmp_qloop_595);
                   const real_t q_tmp_2_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_598 + tmp_qloop_568 + tmp_qloop_603) - tmp_qloop_557*tmp_qloop_595);
                   const real_t q_tmp_2_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_598 + tmp_qloop_583 + tmp_qloop_603) - tmp_qloop_572*tmp_qloop_595);
                   const real_t q_tmp_3_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_605 + tmp_qloop_191*tmp_qloop_606 + tmp_qloop_195*tmp_qloop_607) - tmp_qloop_186*tmp_qloop_604);
                   const real_t q_tmp_3_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_605 + tmp_qloop_204*tmp_qloop_606 + tmp_qloop_208*tmp_qloop_607) - tmp_qloop_199*tmp_qloop_604);
                   const real_t q_tmp_3_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_605 + tmp_qloop_217*tmp_qloop_606 + tmp_qloop_221*tmp_qloop_607) - tmp_qloop_212*tmp_qloop_604);
                   const real_t q_tmp_3_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_605 + tmp_qloop_230*tmp_qloop_606 + tmp_qloop_234*tmp_qloop_607) - tmp_qloop_225*tmp_qloop_604);
                   const real_t q_tmp_3_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_605 + tmp_qloop_243*tmp_qloop_606 + tmp_qloop_247*tmp_qloop_607) - tmp_qloop_238*tmp_qloop_604);
                   const real_t q_tmp_3_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_605 + tmp_qloop_256*tmp_qloop_606 + tmp_qloop_260*tmp_qloop_607) - tmp_qloop_251*tmp_qloop_604);
                   const real_t q_tmp_3_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_605 + tmp_qloop_269*tmp_qloop_606 + tmp_qloop_273*tmp_qloop_607) - tmp_qloop_264*tmp_qloop_604);
                   const real_t q_tmp_3_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_606 + tmp_qloop_588 + tmp_qloop_609) - tmp_qloop_282*tmp_qloop_604);
                   const real_t q_tmp_3_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_606 + tmp_qloop_318 + tmp_qloop_610) - tmp_qloop_308*tmp_qloop_604);
                   const real_t q_tmp_3_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_606 + tmp_qloop_332 + tmp_qloop_610) - tmp_qloop_322*tmp_qloop_604);
                   const real_t q_tmp_3_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_606 + tmp_qloop_346 + tmp_qloop_610) - tmp_qloop_336*tmp_qloop_604);
                   const real_t q_tmp_3_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_606 + tmp_qloop_360 + tmp_qloop_610) - tmp_qloop_350*tmp_qloop_604);
                   const real_t q_tmp_3_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_606 + tmp_qloop_374 + tmp_qloop_610) - tmp_qloop_364*tmp_qloop_604);
                   const real_t q_tmp_3_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_606 + tmp_qloop_388 + tmp_qloop_610) - tmp_qloop_378*tmp_qloop_604);
                   const real_t q_tmp_3_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_606 + tmp_qloop_402 + tmp_qloop_610) - tmp_qloop_392*tmp_qloop_604);
                   const real_t q_tmp_3_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_606 + tmp_qloop_416 + tmp_qloop_610) - tmp_qloop_406*tmp_qloop_604);
                   const real_t q_tmp_3_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_606 + tmp_qloop_430 + tmp_qloop_610) - tmp_qloop_420*tmp_qloop_604);
                   const real_t q_tmp_3_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_607 + tmp_qloop_592 + tmp_qloop_611) - tmp_qloop_435*tmp_qloop_604);
                   const real_t q_tmp_3_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_607 + tmp_qloop_463 + tmp_qloop_612) - tmp_qloop_452*tmp_qloop_604);
                   const real_t q_tmp_3_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_607 + tmp_qloop_478 + tmp_qloop_612) - tmp_qloop_467*tmp_qloop_604);
                   const real_t q_tmp_3_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_607 + tmp_qloop_493 + tmp_qloop_612) - tmp_qloop_482*tmp_qloop_604);
                   const real_t q_tmp_3_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_607 + tmp_qloop_508 + tmp_qloop_612) - tmp_qloop_497*tmp_qloop_604);
                   const real_t q_tmp_3_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_607 + tmp_qloop_523 + tmp_qloop_612) - tmp_qloop_512*tmp_qloop_604);
                   const real_t q_tmp_3_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_607 + tmp_qloop_538 + tmp_qloop_612) - tmp_qloop_527*tmp_qloop_604);
                   const real_t q_tmp_3_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_607 + tmp_qloop_553 + tmp_qloop_612) - tmp_qloop_542*tmp_qloop_604);
                   const real_t q_tmp_3_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_607 + tmp_qloop_568 + tmp_qloop_612) - tmp_qloop_557*tmp_qloop_604);
                   const real_t q_tmp_3_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_607 + tmp_qloop_583 + tmp_qloop_612) - tmp_qloop_572*tmp_qloop_604);
                   const real_t q_tmp_4_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_614 + tmp_qloop_204*tmp_qloop_615 + tmp_qloop_208*tmp_qloop_616) - tmp_qloop_199*tmp_qloop_613);
                   const real_t q_tmp_4_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_614 + tmp_qloop_217*tmp_qloop_615 + tmp_qloop_221*tmp_qloop_616) - tmp_qloop_212*tmp_qloop_613);
                   const real_t q_tmp_4_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_614 + tmp_qloop_230*tmp_qloop_615 + tmp_qloop_234*tmp_qloop_616) - tmp_qloop_225*tmp_qloop_613);
                   const real_t q_tmp_4_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_614 + tmp_qloop_243*tmp_qloop_615 + tmp_qloop_247*tmp_qloop_616) - tmp_qloop_238*tmp_qloop_613);
                   const real_t q_tmp_4_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_614 + tmp_qloop_256*tmp_qloop_615 + tmp_qloop_260*tmp_qloop_616) - tmp_qloop_251*tmp_qloop_613);
                   const real_t q_tmp_4_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_614 + tmp_qloop_269*tmp_qloop_615 + tmp_qloop_273*tmp_qloop_616) - tmp_qloop_264*tmp_qloop_613);
                   const real_t q_tmp_4_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_615 + tmp_qloop_588 + tmp_qloop_618) - tmp_qloop_282*tmp_qloop_613);
                   const real_t q_tmp_4_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_615 + tmp_qloop_318 + tmp_qloop_619) - tmp_qloop_308*tmp_qloop_613);
                   const real_t q_tmp_4_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_615 + tmp_qloop_332 + tmp_qloop_619) - tmp_qloop_322*tmp_qloop_613);
                   const real_t q_tmp_4_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_615 + tmp_qloop_346 + tmp_qloop_619) - tmp_qloop_336*tmp_qloop_613);
                   const real_t q_tmp_4_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_615 + tmp_qloop_360 + tmp_qloop_619) - tmp_qloop_350*tmp_qloop_613);
                   const real_t q_tmp_4_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_615 + tmp_qloop_374 + tmp_qloop_619) - tmp_qloop_364*tmp_qloop_613);
                   const real_t q_tmp_4_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_615 + tmp_qloop_388 + tmp_qloop_619) - tmp_qloop_378*tmp_qloop_613);
                   const real_t q_tmp_4_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_615 + tmp_qloop_402 + tmp_qloop_619) - tmp_qloop_392*tmp_qloop_613);
                   const real_t q_tmp_4_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_615 + tmp_qloop_416 + tmp_qloop_619) - tmp_qloop_406*tmp_qloop_613);
                   const real_t q_tmp_4_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_615 + tmp_qloop_430 + tmp_qloop_619) - tmp_qloop_420*tmp_qloop_613);
                   const real_t q_tmp_4_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_616 + tmp_qloop_592 + tmp_qloop_620) - tmp_qloop_435*tmp_qloop_613);
                   const real_t q_tmp_4_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_616 + tmp_qloop_463 + tmp_qloop_621) - tmp_qloop_452*tmp_qloop_613);
                   const real_t q_tmp_4_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_616 + tmp_qloop_478 + tmp_qloop_621) - tmp_qloop_467*tmp_qloop_613);
                   const real_t q_tmp_4_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_616 + tmp_qloop_493 + tmp_qloop_621) - tmp_qloop_482*tmp_qloop_613);
                   const real_t q_tmp_4_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_616 + tmp_qloop_508 + tmp_qloop_621) - tmp_qloop_497*tmp_qloop_613);
                   const real_t q_tmp_4_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_616 + tmp_qloop_523 + tmp_qloop_621) - tmp_qloop_512*tmp_qloop_613);
                   const real_t q_tmp_4_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_616 + tmp_qloop_538 + tmp_qloop_621) - tmp_qloop_527*tmp_qloop_613);
                   const real_t q_tmp_4_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_616 + tmp_qloop_553 + tmp_qloop_621) - tmp_qloop_542*tmp_qloop_613);
                   const real_t q_tmp_4_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_616 + tmp_qloop_568 + tmp_qloop_621) - tmp_qloop_557*tmp_qloop_613);
                   const real_t q_tmp_4_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_616 + tmp_qloop_583 + tmp_qloop_621) - tmp_qloop_572*tmp_qloop_613);
                   const real_t q_tmp_5_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_623 + tmp_qloop_217*tmp_qloop_624 + tmp_qloop_221*tmp_qloop_625) - tmp_qloop_212*tmp_qloop_622);
                   const real_t q_tmp_5_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_623 + tmp_qloop_230*tmp_qloop_624 + tmp_qloop_234*tmp_qloop_625) - tmp_qloop_225*tmp_qloop_622);
                   const real_t q_tmp_5_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_623 + tmp_qloop_243*tmp_qloop_624 + tmp_qloop_247*tmp_qloop_625) - tmp_qloop_238*tmp_qloop_622);
                   const real_t q_tmp_5_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_623 + tmp_qloop_256*tmp_qloop_624 + tmp_qloop_260*tmp_qloop_625) - tmp_qloop_251*tmp_qloop_622);
                   const real_t q_tmp_5_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_623 + tmp_qloop_269*tmp_qloop_624 + tmp_qloop_273*tmp_qloop_625) - tmp_qloop_264*tmp_qloop_622);
                   const real_t q_tmp_5_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_624 + tmp_qloop_588 + tmp_qloop_627) - tmp_qloop_282*tmp_qloop_622);
                   const real_t q_tmp_5_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_624 + tmp_qloop_318 + tmp_qloop_628) - tmp_qloop_308*tmp_qloop_622);
                   const real_t q_tmp_5_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_624 + tmp_qloop_332 + tmp_qloop_628) - tmp_qloop_322*tmp_qloop_622);
                   const real_t q_tmp_5_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_624 + tmp_qloop_346 + tmp_qloop_628) - tmp_qloop_336*tmp_qloop_622);
                   const real_t q_tmp_5_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_624 + tmp_qloop_360 + tmp_qloop_628) - tmp_qloop_350*tmp_qloop_622);
                   const real_t q_tmp_5_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_624 + tmp_qloop_374 + tmp_qloop_628) - tmp_qloop_364*tmp_qloop_622);
                   const real_t q_tmp_5_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_624 + tmp_qloop_388 + tmp_qloop_628) - tmp_qloop_378*tmp_qloop_622);
                   const real_t q_tmp_5_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_624 + tmp_qloop_402 + tmp_qloop_628) - tmp_qloop_392*tmp_qloop_622);
                   const real_t q_tmp_5_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_624 + tmp_qloop_416 + tmp_qloop_628) - tmp_qloop_406*tmp_qloop_622);
                   const real_t q_tmp_5_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_624 + tmp_qloop_430 + tmp_qloop_628) - tmp_qloop_420*tmp_qloop_622);
                   const real_t q_tmp_5_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_625 + tmp_qloop_592 + tmp_qloop_629) - tmp_qloop_435*tmp_qloop_622);
                   const real_t q_tmp_5_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_625 + tmp_qloop_463 + tmp_qloop_630) - tmp_qloop_452*tmp_qloop_622);
                   const real_t q_tmp_5_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_625 + tmp_qloop_478 + tmp_qloop_630) - tmp_qloop_467*tmp_qloop_622);
                   const real_t q_tmp_5_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_625 + tmp_qloop_493 + tmp_qloop_630) - tmp_qloop_482*tmp_qloop_622);
                   const real_t q_tmp_5_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_625 + tmp_qloop_508 + tmp_qloop_630) - tmp_qloop_497*tmp_qloop_622);
                   const real_t q_tmp_5_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_625 + tmp_qloop_523 + tmp_qloop_630) - tmp_qloop_512*tmp_qloop_622);
                   const real_t q_tmp_5_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_625 + tmp_qloop_538 + tmp_qloop_630) - tmp_qloop_527*tmp_qloop_622);
                   const real_t q_tmp_5_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_625 + tmp_qloop_553 + tmp_qloop_630) - tmp_qloop_542*tmp_qloop_622);
                   const real_t q_tmp_5_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_625 + tmp_qloop_568 + tmp_qloop_630) - tmp_qloop_557*tmp_qloop_622);
                   const real_t q_tmp_5_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_625 + tmp_qloop_583 + tmp_qloop_630) - tmp_qloop_572*tmp_qloop_622);
                   const real_t q_tmp_6_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_632 + tmp_qloop_230*tmp_qloop_633 + tmp_qloop_234*tmp_qloop_634) - tmp_qloop_225*tmp_qloop_631);
                   const real_t q_tmp_6_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_632 + tmp_qloop_243*tmp_qloop_633 + tmp_qloop_247*tmp_qloop_634) - tmp_qloop_238*tmp_qloop_631);
                   const real_t q_tmp_6_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_632 + tmp_qloop_256*tmp_qloop_633 + tmp_qloop_260*tmp_qloop_634) - tmp_qloop_251*tmp_qloop_631);
                   const real_t q_tmp_6_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_632 + tmp_qloop_269*tmp_qloop_633 + tmp_qloop_273*tmp_qloop_634) - tmp_qloop_264*tmp_qloop_631);
                   const real_t q_tmp_6_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_633 + tmp_qloop_588 + tmp_qloop_636) - tmp_qloop_282*tmp_qloop_631);
                   const real_t q_tmp_6_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_633 + tmp_qloop_318 + tmp_qloop_637) - tmp_qloop_308*tmp_qloop_631);
                   const real_t q_tmp_6_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_633 + tmp_qloop_332 + tmp_qloop_637) - tmp_qloop_322*tmp_qloop_631);
                   const real_t q_tmp_6_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_633 + tmp_qloop_346 + tmp_qloop_637) - tmp_qloop_336*tmp_qloop_631);
                   const real_t q_tmp_6_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_633 + tmp_qloop_360 + tmp_qloop_637) - tmp_qloop_350*tmp_qloop_631);
                   const real_t q_tmp_6_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_633 + tmp_qloop_374 + tmp_qloop_637) - tmp_qloop_364*tmp_qloop_631);
                   const real_t q_tmp_6_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_633 + tmp_qloop_388 + tmp_qloop_637) - tmp_qloop_378*tmp_qloop_631);
                   const real_t q_tmp_6_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_633 + tmp_qloop_402 + tmp_qloop_637) - tmp_qloop_392*tmp_qloop_631);
                   const real_t q_tmp_6_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_633 + tmp_qloop_416 + tmp_qloop_637) - tmp_qloop_406*tmp_qloop_631);
                   const real_t q_tmp_6_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_633 + tmp_qloop_430 + tmp_qloop_637) - tmp_qloop_420*tmp_qloop_631);
                   const real_t q_tmp_6_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_634 + tmp_qloop_592 + tmp_qloop_638) - tmp_qloop_435*tmp_qloop_631);
                   const real_t q_tmp_6_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_634 + tmp_qloop_463 + tmp_qloop_639) - tmp_qloop_452*tmp_qloop_631);
                   const real_t q_tmp_6_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_634 + tmp_qloop_478 + tmp_qloop_639) - tmp_qloop_467*tmp_qloop_631);
                   const real_t q_tmp_6_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_634 + tmp_qloop_493 + tmp_qloop_639) - tmp_qloop_482*tmp_qloop_631);
                   const real_t q_tmp_6_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_634 + tmp_qloop_508 + tmp_qloop_639) - tmp_qloop_497*tmp_qloop_631);
                   const real_t q_tmp_6_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_634 + tmp_qloop_523 + tmp_qloop_639) - tmp_qloop_512*tmp_qloop_631);
                   const real_t q_tmp_6_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_634 + tmp_qloop_538 + tmp_qloop_639) - tmp_qloop_527*tmp_qloop_631);
                   const real_t q_tmp_6_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_634 + tmp_qloop_553 + tmp_qloop_639) - tmp_qloop_542*tmp_qloop_631);
                   const real_t q_tmp_6_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_634 + tmp_qloop_568 + tmp_qloop_639) - tmp_qloop_557*tmp_qloop_631);
                   const real_t q_tmp_6_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_634 + tmp_qloop_583 + tmp_qloop_639) - tmp_qloop_572*tmp_qloop_631);
                   const real_t q_tmp_7_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_641 + tmp_qloop_243*tmp_qloop_642 + tmp_qloop_247*tmp_qloop_643) - tmp_qloop_238*tmp_qloop_640);
                   const real_t q_tmp_7_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_641 + tmp_qloop_256*tmp_qloop_642 + tmp_qloop_260*tmp_qloop_643) - tmp_qloop_251*tmp_qloop_640);
                   const real_t q_tmp_7_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_641 + tmp_qloop_269*tmp_qloop_642 + tmp_qloop_273*tmp_qloop_643) - tmp_qloop_264*tmp_qloop_640);
                   const real_t q_tmp_7_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_642 + tmp_qloop_588 + tmp_qloop_645) - tmp_qloop_282*tmp_qloop_640);
                   const real_t q_tmp_7_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_642 + tmp_qloop_318 + tmp_qloop_646) - tmp_qloop_308*tmp_qloop_640);
                   const real_t q_tmp_7_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_642 + tmp_qloop_332 + tmp_qloop_646) - tmp_qloop_322*tmp_qloop_640);
                   const real_t q_tmp_7_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_642 + tmp_qloop_346 + tmp_qloop_646) - tmp_qloop_336*tmp_qloop_640);
                   const real_t q_tmp_7_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_642 + tmp_qloop_360 + tmp_qloop_646) - tmp_qloop_350*tmp_qloop_640);
                   const real_t q_tmp_7_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_642 + tmp_qloop_374 + tmp_qloop_646) - tmp_qloop_364*tmp_qloop_640);
                   const real_t q_tmp_7_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_642 + tmp_qloop_388 + tmp_qloop_646) - tmp_qloop_378*tmp_qloop_640);
                   const real_t q_tmp_7_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_642 + tmp_qloop_402 + tmp_qloop_646) - tmp_qloop_392*tmp_qloop_640);
                   const real_t q_tmp_7_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_642 + tmp_qloop_416 + tmp_qloop_646) - tmp_qloop_406*tmp_qloop_640);
                   const real_t q_tmp_7_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_642 + tmp_qloop_430 + tmp_qloop_646) - tmp_qloop_420*tmp_qloop_640);
                   const real_t q_tmp_7_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_643 + tmp_qloop_592 + tmp_qloop_647) - tmp_qloop_435*tmp_qloop_640);
                   const real_t q_tmp_7_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_643 + tmp_qloop_463 + tmp_qloop_648) - tmp_qloop_452*tmp_qloop_640);
                   const real_t q_tmp_7_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_643 + tmp_qloop_478 + tmp_qloop_648) - tmp_qloop_467*tmp_qloop_640);
                   const real_t q_tmp_7_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_643 + tmp_qloop_493 + tmp_qloop_648) - tmp_qloop_482*tmp_qloop_640);
                   const real_t q_tmp_7_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_643 + tmp_qloop_508 + tmp_qloop_648) - tmp_qloop_497*tmp_qloop_640);
                   const real_t q_tmp_7_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_643 + tmp_qloop_523 + tmp_qloop_648) - tmp_qloop_512*tmp_qloop_640);
                   const real_t q_tmp_7_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_643 + tmp_qloop_538 + tmp_qloop_648) - tmp_qloop_527*tmp_qloop_640);
                   const real_t q_tmp_7_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_643 + tmp_qloop_553 + tmp_qloop_648) - tmp_qloop_542*tmp_qloop_640);
                   const real_t q_tmp_7_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_643 + tmp_qloop_568 + tmp_qloop_648) - tmp_qloop_557*tmp_qloop_640);
                   const real_t q_tmp_7_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_643 + tmp_qloop_583 + tmp_qloop_648) - tmp_qloop_572*tmp_qloop_640);
                   const real_t q_tmp_8_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_650 + tmp_qloop_256*tmp_qloop_651 + tmp_qloop_260*tmp_qloop_652) - tmp_qloop_251*tmp_qloop_649);
                   const real_t q_tmp_8_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_650 + tmp_qloop_269*tmp_qloop_651 + tmp_qloop_273*tmp_qloop_652) - tmp_qloop_264*tmp_qloop_649);
                   const real_t q_tmp_8_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_651 + tmp_qloop_588 + tmp_qloop_654) - tmp_qloop_282*tmp_qloop_649);
                   const real_t q_tmp_8_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_651 + tmp_qloop_318 + tmp_qloop_655) - tmp_qloop_308*tmp_qloop_649);
                   const real_t q_tmp_8_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_651 + tmp_qloop_332 + tmp_qloop_655) - tmp_qloop_322*tmp_qloop_649);
                   const real_t q_tmp_8_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_651 + tmp_qloop_346 + tmp_qloop_655) - tmp_qloop_336*tmp_qloop_649);
                   const real_t q_tmp_8_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_651 + tmp_qloop_360 + tmp_qloop_655) - tmp_qloop_350*tmp_qloop_649);
                   const real_t q_tmp_8_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_651 + tmp_qloop_374 + tmp_qloop_655) - tmp_qloop_364*tmp_qloop_649);
                   const real_t q_tmp_8_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_651 + tmp_qloop_388 + tmp_qloop_655) - tmp_qloop_378*tmp_qloop_649);
                   const real_t q_tmp_8_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_651 + tmp_qloop_402 + tmp_qloop_655) - tmp_qloop_392*tmp_qloop_649);
                   const real_t q_tmp_8_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_651 + tmp_qloop_416 + tmp_qloop_655) - tmp_qloop_406*tmp_qloop_649);
                   const real_t q_tmp_8_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_651 + tmp_qloop_430 + tmp_qloop_655) - tmp_qloop_420*tmp_qloop_649);
                   const real_t q_tmp_8_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_652 + tmp_qloop_592 + tmp_qloop_656) - tmp_qloop_435*tmp_qloop_649);
                   const real_t q_tmp_8_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_652 + tmp_qloop_463 + tmp_qloop_657) - tmp_qloop_452*tmp_qloop_649);
                   const real_t q_tmp_8_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_652 + tmp_qloop_478 + tmp_qloop_657) - tmp_qloop_467*tmp_qloop_649);
                   const real_t q_tmp_8_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_652 + tmp_qloop_493 + tmp_qloop_657) - tmp_qloop_482*tmp_qloop_649);
                   const real_t q_tmp_8_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_652 + tmp_qloop_508 + tmp_qloop_657) - tmp_qloop_497*tmp_qloop_649);
                   const real_t q_tmp_8_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_652 + tmp_qloop_523 + tmp_qloop_657) - tmp_qloop_512*tmp_qloop_649);
                   const real_t q_tmp_8_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_652 + tmp_qloop_538 + tmp_qloop_657) - tmp_qloop_527*tmp_qloop_649);
                   const real_t q_tmp_8_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_652 + tmp_qloop_553 + tmp_qloop_657) - tmp_qloop_542*tmp_qloop_649);
                   const real_t q_tmp_8_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_652 + tmp_qloop_568 + tmp_qloop_657) - tmp_qloop_557*tmp_qloop_649);
                   const real_t q_tmp_8_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_652 + tmp_qloop_583 + tmp_qloop_657) - tmp_qloop_572*tmp_qloop_649);
                   const real_t q_tmp_9_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_659 + tmp_qloop_269*tmp_qloop_660 + tmp_qloop_273*tmp_qloop_661) - tmp_qloop_264*tmp_qloop_658);
                   const real_t q_tmp_9_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_660 + tmp_qloop_588 + tmp_qloop_663) - tmp_qloop_282*tmp_qloop_658);
                   const real_t q_tmp_9_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_660 + tmp_qloop_318 + tmp_qloop_664) - tmp_qloop_308*tmp_qloop_658);
                   const real_t q_tmp_9_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_660 + tmp_qloop_332 + tmp_qloop_664) - tmp_qloop_322*tmp_qloop_658);
                   const real_t q_tmp_9_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_660 + tmp_qloop_346 + tmp_qloop_664) - tmp_qloop_336*tmp_qloop_658);
                   const real_t q_tmp_9_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_660 + tmp_qloop_360 + tmp_qloop_664) - tmp_qloop_350*tmp_qloop_658);
                   const real_t q_tmp_9_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_660 + tmp_qloop_374 + tmp_qloop_664) - tmp_qloop_364*tmp_qloop_658);
                   const real_t q_tmp_9_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_660 + tmp_qloop_388 + tmp_qloop_664) - tmp_qloop_378*tmp_qloop_658);
                   const real_t q_tmp_9_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_660 + tmp_qloop_402 + tmp_qloop_664) - tmp_qloop_392*tmp_qloop_658);
                   const real_t q_tmp_9_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_660 + tmp_qloop_416 + tmp_qloop_664) - tmp_qloop_406*tmp_qloop_658);
                   const real_t q_tmp_9_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_660 + tmp_qloop_430 + tmp_qloop_664) - tmp_qloop_420*tmp_qloop_658);
                   const real_t q_tmp_9_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_661 + tmp_qloop_592 + tmp_qloop_665) - tmp_qloop_435*tmp_qloop_658);
                   const real_t q_tmp_9_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_661 + tmp_qloop_463 + tmp_qloop_666) - tmp_qloop_452*tmp_qloop_658);
                   const real_t q_tmp_9_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_661 + tmp_qloop_478 + tmp_qloop_666) - tmp_qloop_467*tmp_qloop_658);
                   const real_t q_tmp_9_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_661 + tmp_qloop_493 + tmp_qloop_666) - tmp_qloop_482*tmp_qloop_658);
                   const real_t q_tmp_9_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_661 + tmp_qloop_508 + tmp_qloop_666) - tmp_qloop_497*tmp_qloop_658);
                   const real_t q_tmp_9_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_661 + tmp_qloop_523 + tmp_qloop_666) - tmp_qloop_512*tmp_qloop_658);
                   const real_t q_tmp_9_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_661 + tmp_qloop_538 + tmp_qloop_666) - tmp_qloop_527*tmp_qloop_658);
                   const real_t q_tmp_9_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_661 + tmp_qloop_553 + tmp_qloop_666) - tmp_qloop_542*tmp_qloop_658);
                   const real_t q_tmp_9_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_661 + tmp_qloop_568 + tmp_qloop_666) - tmp_qloop_557*tmp_qloop_658);
                   const real_t q_tmp_9_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_661 + tmp_qloop_583 + tmp_qloop_666) - tmp_qloop_572*tmp_qloop_658);
                   const real_t q_tmp_10_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_672 + tmp_qloop_299*tmp_qloop_670 + tmp_qloop_303*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_282*tmp_qloop_669);
                   const real_t q_tmp_10_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_672 + tmp_qloop_313*tmp_qloop_670 + tmp_qloop_317*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_669);
                   const real_t q_tmp_10_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_672 + tmp_qloop_327*tmp_qloop_670 + tmp_qloop_331*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_669);
                   const real_t q_tmp_10_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_672 + tmp_qloop_341*tmp_qloop_670 + tmp_qloop_345*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_669);
                   const real_t q_tmp_10_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_672 + tmp_qloop_355*tmp_qloop_670 + tmp_qloop_359*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_669);
                   const real_t q_tmp_10_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_672 + tmp_qloop_369*tmp_qloop_670 + tmp_qloop_373*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_669);
                   const real_t q_tmp_10_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_672 + tmp_qloop_383*tmp_qloop_670 + tmp_qloop_387*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_669);
                   const real_t q_tmp_10_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_672 + tmp_qloop_397*tmp_qloop_670 + tmp_qloop_401*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_669);
                   const real_t q_tmp_10_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_672 + tmp_qloop_411*tmp_qloop_670 + tmp_qloop_415*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_669);
                   const real_t q_tmp_10_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_672 + tmp_qloop_425*tmp_qloop_670 + tmp_qloop_429*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_669);
                   const real_t q_tmp_10_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_679) - tmp_qloop_435*tmp_qloop_669);
                   const real_t q_tmp_10_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_680) - tmp_qloop_452*tmp_qloop_669);
                   const real_t q_tmp_10_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_681) - tmp_qloop_467*tmp_qloop_669);
                   const real_t q_tmp_10_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_682) - tmp_qloop_482*tmp_qloop_669);
                   const real_t q_tmp_10_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_683) - tmp_qloop_497*tmp_qloop_669);
                   const real_t q_tmp_10_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_684) - tmp_qloop_512*tmp_qloop_669);
                   const real_t q_tmp_10_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_685) - tmp_qloop_527*tmp_qloop_669);
                   const real_t q_tmp_10_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_686) - tmp_qloop_542*tmp_qloop_669);
                   const real_t q_tmp_10_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_687) - tmp_qloop_557*tmp_qloop_669);
                   const real_t q_tmp_10_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_688) - tmp_qloop_572*tmp_qloop_669);
                   const real_t q_tmp_11_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_691 + tmp_qloop_313*tmp_qloop_690 + tmp_qloop_317*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_689);
                   const real_t q_tmp_11_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_691 + tmp_qloop_327*tmp_qloop_690 + tmp_qloop_331*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_689);
                   const real_t q_tmp_11_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_691 + tmp_qloop_341*tmp_qloop_690 + tmp_qloop_345*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_689);
                   const real_t q_tmp_11_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_691 + tmp_qloop_355*tmp_qloop_690 + tmp_qloop_359*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_689);
                   const real_t q_tmp_11_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_691 + tmp_qloop_369*tmp_qloop_690 + tmp_qloop_373*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_689);
                   const real_t q_tmp_11_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_691 + tmp_qloop_383*tmp_qloop_690 + tmp_qloop_387*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_689);
                   const real_t q_tmp_11_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_691 + tmp_qloop_397*tmp_qloop_690 + tmp_qloop_401*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_689);
                   const real_t q_tmp_11_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_691 + tmp_qloop_411*tmp_qloop_690 + tmp_qloop_415*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_689);
                   const real_t q_tmp_11_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_691 + tmp_qloop_425*tmp_qloop_690 + tmp_qloop_429*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_689);
                   const real_t q_tmp_11_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_692 + tmp_qloop_693 + tmp_qloop_694) - tmp_qloop_435*tmp_qloop_689);
                   const real_t q_tmp_11_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_692 + tmp_qloop_680 + tmp_qloop_695) - tmp_qloop_452*tmp_qloop_689);
                   const real_t q_tmp_11_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_692 + tmp_qloop_681 + tmp_qloop_695) - tmp_qloop_467*tmp_qloop_689);
                   const real_t q_tmp_11_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_692 + tmp_qloop_682 + tmp_qloop_695) - tmp_qloop_482*tmp_qloop_689);
                   const real_t q_tmp_11_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_692 + tmp_qloop_683 + tmp_qloop_695) - tmp_qloop_497*tmp_qloop_689);
                   const real_t q_tmp_11_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_692 + tmp_qloop_684 + tmp_qloop_695) - tmp_qloop_512*tmp_qloop_689);
                   const real_t q_tmp_11_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_692 + tmp_qloop_685 + tmp_qloop_695) - tmp_qloop_527*tmp_qloop_689);
                   const real_t q_tmp_11_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_692 + tmp_qloop_686 + tmp_qloop_695) - tmp_qloop_542*tmp_qloop_689);
                   const real_t q_tmp_11_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_692 + tmp_qloop_687 + tmp_qloop_695) - tmp_qloop_557*tmp_qloop_689);
                   const real_t q_tmp_11_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_692 + tmp_qloop_688 + tmp_qloop_695) - tmp_qloop_572*tmp_qloop_689);
                   const real_t q_tmp_12_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_698 + tmp_qloop_327*tmp_qloop_697 + tmp_qloop_331*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_696);
                   const real_t q_tmp_12_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_698 + tmp_qloop_341*tmp_qloop_697 + tmp_qloop_345*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_696);
                   const real_t q_tmp_12_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_698 + tmp_qloop_355*tmp_qloop_697 + tmp_qloop_359*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_696);
                   const real_t q_tmp_12_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_698 + tmp_qloop_369*tmp_qloop_697 + tmp_qloop_373*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_696);
                   const real_t q_tmp_12_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_698 + tmp_qloop_383*tmp_qloop_697 + tmp_qloop_387*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_696);
                   const real_t q_tmp_12_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_698 + tmp_qloop_397*tmp_qloop_697 + tmp_qloop_401*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_696);
                   const real_t q_tmp_12_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_698 + tmp_qloop_411*tmp_qloop_697 + tmp_qloop_415*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_696);
                   const real_t q_tmp_12_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_698 + tmp_qloop_425*tmp_qloop_697 + tmp_qloop_429*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_696);
                   const real_t q_tmp_12_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_699 + tmp_qloop_693 + tmp_qloop_700) - tmp_qloop_435*tmp_qloop_696);
                   const real_t q_tmp_12_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_699 + tmp_qloop_680 + tmp_qloop_701) - tmp_qloop_452*tmp_qloop_696);
                   const real_t q_tmp_12_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_699 + tmp_qloop_681 + tmp_qloop_701) - tmp_qloop_467*tmp_qloop_696);
                   const real_t q_tmp_12_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_699 + tmp_qloop_682 + tmp_qloop_701) - tmp_qloop_482*tmp_qloop_696);
                   const real_t q_tmp_12_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_699 + tmp_qloop_683 + tmp_qloop_701) - tmp_qloop_497*tmp_qloop_696);
                   const real_t q_tmp_12_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_699 + tmp_qloop_684 + tmp_qloop_701) - tmp_qloop_512*tmp_qloop_696);
                   const real_t q_tmp_12_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_699 + tmp_qloop_685 + tmp_qloop_701) - tmp_qloop_527*tmp_qloop_696);
                   const real_t q_tmp_12_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_699 + tmp_qloop_686 + tmp_qloop_701) - tmp_qloop_542*tmp_qloop_696);
                   const real_t q_tmp_12_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_699 + tmp_qloop_687 + tmp_qloop_701) - tmp_qloop_557*tmp_qloop_696);
                   const real_t q_tmp_12_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_699 + tmp_qloop_688 + tmp_qloop_701) - tmp_qloop_572*tmp_qloop_696);
                   const real_t q_tmp_13_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_704 + tmp_qloop_341*tmp_qloop_703 + tmp_qloop_345*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_702);
                   const real_t q_tmp_13_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_704 + tmp_qloop_355*tmp_qloop_703 + tmp_qloop_359*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_702);
                   const real_t q_tmp_13_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_704 + tmp_qloop_369*tmp_qloop_703 + tmp_qloop_373*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_702);
                   const real_t q_tmp_13_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_704 + tmp_qloop_383*tmp_qloop_703 + tmp_qloop_387*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_702);
                   const real_t q_tmp_13_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_704 + tmp_qloop_397*tmp_qloop_703 + tmp_qloop_401*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_702);
                   const real_t q_tmp_13_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_704 + tmp_qloop_411*tmp_qloop_703 + tmp_qloop_415*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_702);
                   const real_t q_tmp_13_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_704 + tmp_qloop_425*tmp_qloop_703 + tmp_qloop_429*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_702);
                   const real_t q_tmp_13_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_705 + tmp_qloop_693 + tmp_qloop_706) - tmp_qloop_435*tmp_qloop_702);
                   const real_t q_tmp_13_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_705 + tmp_qloop_680 + tmp_qloop_707) - tmp_qloop_452*tmp_qloop_702);
                   const real_t q_tmp_13_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_705 + tmp_qloop_681 + tmp_qloop_707) - tmp_qloop_467*tmp_qloop_702);
                   const real_t q_tmp_13_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_705 + tmp_qloop_682 + tmp_qloop_707) - tmp_qloop_482*tmp_qloop_702);
                   const real_t q_tmp_13_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_705 + tmp_qloop_683 + tmp_qloop_707) - tmp_qloop_497*tmp_qloop_702);
                   const real_t q_tmp_13_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_705 + tmp_qloop_684 + tmp_qloop_707) - tmp_qloop_512*tmp_qloop_702);
                   const real_t q_tmp_13_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_705 + tmp_qloop_685 + tmp_qloop_707) - tmp_qloop_527*tmp_qloop_702);
                   const real_t q_tmp_13_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_705 + tmp_qloop_686 + tmp_qloop_707) - tmp_qloop_542*tmp_qloop_702);
                   const real_t q_tmp_13_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_705 + tmp_qloop_687 + tmp_qloop_707) - tmp_qloop_557*tmp_qloop_702);
                   const real_t q_tmp_13_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_705 + tmp_qloop_688 + tmp_qloop_707) - tmp_qloop_572*tmp_qloop_702);
                   const real_t q_tmp_14_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_710 + tmp_qloop_355*tmp_qloop_709 + tmp_qloop_359*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_708);
                   const real_t q_tmp_14_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_710 + tmp_qloop_369*tmp_qloop_709 + tmp_qloop_373*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_708);
                   const real_t q_tmp_14_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_710 + tmp_qloop_383*tmp_qloop_709 + tmp_qloop_387*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_708);
                   const real_t q_tmp_14_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_710 + tmp_qloop_397*tmp_qloop_709 + tmp_qloop_401*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_708);
                   const real_t q_tmp_14_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_710 + tmp_qloop_411*tmp_qloop_709 + tmp_qloop_415*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_708);
                   const real_t q_tmp_14_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_710 + tmp_qloop_425*tmp_qloop_709 + tmp_qloop_429*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_708);
                   const real_t q_tmp_14_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_711 + tmp_qloop_693 + tmp_qloop_712) - tmp_qloop_435*tmp_qloop_708);
                   const real_t q_tmp_14_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_711 + tmp_qloop_680 + tmp_qloop_713) - tmp_qloop_452*tmp_qloop_708);
                   const real_t q_tmp_14_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_711 + tmp_qloop_681 + tmp_qloop_713) - tmp_qloop_467*tmp_qloop_708);
                   const real_t q_tmp_14_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_711 + tmp_qloop_682 + tmp_qloop_713) - tmp_qloop_482*tmp_qloop_708);
                   const real_t q_tmp_14_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_711 + tmp_qloop_683 + tmp_qloop_713) - tmp_qloop_497*tmp_qloop_708);
                   const real_t q_tmp_14_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_711 + tmp_qloop_684 + tmp_qloop_713) - tmp_qloop_512*tmp_qloop_708);
                   const real_t q_tmp_14_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_711 + tmp_qloop_685 + tmp_qloop_713) - tmp_qloop_527*tmp_qloop_708);
                   const real_t q_tmp_14_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_711 + tmp_qloop_686 + tmp_qloop_713) - tmp_qloop_542*tmp_qloop_708);
                   const real_t q_tmp_14_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_711 + tmp_qloop_687 + tmp_qloop_713) - tmp_qloop_557*tmp_qloop_708);
                   const real_t q_tmp_14_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_711 + tmp_qloop_688 + tmp_qloop_713) - tmp_qloop_572*tmp_qloop_708);
                   const real_t q_tmp_15_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_716 + tmp_qloop_369*tmp_qloop_715 + tmp_qloop_373*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_714);
                   const real_t q_tmp_15_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_716 + tmp_qloop_383*tmp_qloop_715 + tmp_qloop_387*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_714);
                   const real_t q_tmp_15_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_716 + tmp_qloop_397*tmp_qloop_715 + tmp_qloop_401*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_714);
                   const real_t q_tmp_15_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_716 + tmp_qloop_411*tmp_qloop_715 + tmp_qloop_415*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_714);
                   const real_t q_tmp_15_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_716 + tmp_qloop_425*tmp_qloop_715 + tmp_qloop_429*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_714);
                   const real_t q_tmp_15_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_717 + tmp_qloop_693 + tmp_qloop_718) - tmp_qloop_435*tmp_qloop_714);
                   const real_t q_tmp_15_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_717 + tmp_qloop_680 + tmp_qloop_719) - tmp_qloop_452*tmp_qloop_714);
                   const real_t q_tmp_15_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_717 + tmp_qloop_681 + tmp_qloop_719) - tmp_qloop_467*tmp_qloop_714);
                   const real_t q_tmp_15_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_717 + tmp_qloop_682 + tmp_qloop_719) - tmp_qloop_482*tmp_qloop_714);
                   const real_t q_tmp_15_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_717 + tmp_qloop_683 + tmp_qloop_719) - tmp_qloop_497*tmp_qloop_714);
                   const real_t q_tmp_15_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_717 + tmp_qloop_684 + tmp_qloop_719) - tmp_qloop_512*tmp_qloop_714);
                   const real_t q_tmp_15_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_717 + tmp_qloop_685 + tmp_qloop_719) - tmp_qloop_527*tmp_qloop_714);
                   const real_t q_tmp_15_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_717 + tmp_qloop_686 + tmp_qloop_719) - tmp_qloop_542*tmp_qloop_714);
                   const real_t q_tmp_15_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_717 + tmp_qloop_687 + tmp_qloop_719) - tmp_qloop_557*tmp_qloop_714);
                   const real_t q_tmp_15_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_717 + tmp_qloop_688 + tmp_qloop_719) - tmp_qloop_572*tmp_qloop_714);
                   const real_t q_tmp_16_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_722 + tmp_qloop_383*tmp_qloop_721 + tmp_qloop_387*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_720);
                   const real_t q_tmp_16_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_722 + tmp_qloop_397*tmp_qloop_721 + tmp_qloop_401*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_720);
                   const real_t q_tmp_16_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_722 + tmp_qloop_411*tmp_qloop_721 + tmp_qloop_415*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_720);
                   const real_t q_tmp_16_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_722 + tmp_qloop_425*tmp_qloop_721 + tmp_qloop_429*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_720);
                   const real_t q_tmp_16_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_723 + tmp_qloop_693 + tmp_qloop_724) - tmp_qloop_435*tmp_qloop_720);
                   const real_t q_tmp_16_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_723 + tmp_qloop_680 + tmp_qloop_725) - tmp_qloop_452*tmp_qloop_720);
                   const real_t q_tmp_16_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_723 + tmp_qloop_681 + tmp_qloop_725) - tmp_qloop_467*tmp_qloop_720);
                   const real_t q_tmp_16_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_723 + tmp_qloop_682 + tmp_qloop_725) - tmp_qloop_482*tmp_qloop_720);
                   const real_t q_tmp_16_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_723 + tmp_qloop_683 + tmp_qloop_725) - tmp_qloop_497*tmp_qloop_720);
                   const real_t q_tmp_16_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_723 + tmp_qloop_684 + tmp_qloop_725) - tmp_qloop_512*tmp_qloop_720);
                   const real_t q_tmp_16_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_723 + tmp_qloop_685 + tmp_qloop_725) - tmp_qloop_527*tmp_qloop_720);
                   const real_t q_tmp_16_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_723 + tmp_qloop_686 + tmp_qloop_725) - tmp_qloop_542*tmp_qloop_720);
                   const real_t q_tmp_16_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_723 + tmp_qloop_687 + tmp_qloop_725) - tmp_qloop_557*tmp_qloop_720);
                   const real_t q_tmp_16_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_723 + tmp_qloop_688 + tmp_qloop_725) - tmp_qloop_572*tmp_qloop_720);
                   const real_t q_tmp_17_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_728 + tmp_qloop_397*tmp_qloop_727 + tmp_qloop_401*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_726);
                   const real_t q_tmp_17_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_728 + tmp_qloop_411*tmp_qloop_727 + tmp_qloop_415*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_726);
                   const real_t q_tmp_17_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_728 + tmp_qloop_425*tmp_qloop_727 + tmp_qloop_429*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_726);
                   const real_t q_tmp_17_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_729 + tmp_qloop_693 + tmp_qloop_730) - tmp_qloop_435*tmp_qloop_726);
                   const real_t q_tmp_17_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_729 + tmp_qloop_680 + tmp_qloop_731) - tmp_qloop_452*tmp_qloop_726);
                   const real_t q_tmp_17_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_729 + tmp_qloop_681 + tmp_qloop_731) - tmp_qloop_467*tmp_qloop_726);
                   const real_t q_tmp_17_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_729 + tmp_qloop_682 + tmp_qloop_731) - tmp_qloop_482*tmp_qloop_726);
                   const real_t q_tmp_17_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_729 + tmp_qloop_683 + tmp_qloop_731) - tmp_qloop_497*tmp_qloop_726);
                   const real_t q_tmp_17_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_729 + tmp_qloop_684 + tmp_qloop_731) - tmp_qloop_512*tmp_qloop_726);
                   const real_t q_tmp_17_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_729 + tmp_qloop_685 + tmp_qloop_731) - tmp_qloop_527*tmp_qloop_726);
                   const real_t q_tmp_17_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_729 + tmp_qloop_686 + tmp_qloop_731) - tmp_qloop_542*tmp_qloop_726);
                   const real_t q_tmp_17_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_729 + tmp_qloop_687 + tmp_qloop_731) - tmp_qloop_557*tmp_qloop_726);
                   const real_t q_tmp_17_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_729 + tmp_qloop_688 + tmp_qloop_731) - tmp_qloop_572*tmp_qloop_726);
                   const real_t q_tmp_18_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_734 + tmp_qloop_411*tmp_qloop_733 + tmp_qloop_415*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_732);
                   const real_t q_tmp_18_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_734 + tmp_qloop_425*tmp_qloop_733 + tmp_qloop_429*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_732);
                   const real_t q_tmp_18_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_735 + tmp_qloop_693 + tmp_qloop_736) - tmp_qloop_435*tmp_qloop_732);
                   const real_t q_tmp_18_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_735 + tmp_qloop_680 + tmp_qloop_737) - tmp_qloop_452*tmp_qloop_732);
                   const real_t q_tmp_18_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_735 + tmp_qloop_681 + tmp_qloop_737) - tmp_qloop_467*tmp_qloop_732);
                   const real_t q_tmp_18_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_735 + tmp_qloop_682 + tmp_qloop_737) - tmp_qloop_482*tmp_qloop_732);
                   const real_t q_tmp_18_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_735 + tmp_qloop_683 + tmp_qloop_737) - tmp_qloop_497*tmp_qloop_732);
                   const real_t q_tmp_18_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_735 + tmp_qloop_684 + tmp_qloop_737) - tmp_qloop_512*tmp_qloop_732);
                   const real_t q_tmp_18_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_735 + tmp_qloop_685 + tmp_qloop_737) - tmp_qloop_527*tmp_qloop_732);
                   const real_t q_tmp_18_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_735 + tmp_qloop_686 + tmp_qloop_737) - tmp_qloop_542*tmp_qloop_732);
                   const real_t q_tmp_18_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_735 + tmp_qloop_687 + tmp_qloop_737) - tmp_qloop_557*tmp_qloop_732);
                   const real_t q_tmp_18_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_735 + tmp_qloop_688 + tmp_qloop_737) - tmp_qloop_572*tmp_qloop_732);
                   const real_t q_tmp_19_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_740 + tmp_qloop_425*tmp_qloop_739 + tmp_qloop_429*tmp_qloop_741 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_738);
                   const real_t q_tmp_19_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_741 + tmp_qloop_693 + tmp_qloop_742) - tmp_qloop_435*tmp_qloop_738);
                   const real_t q_tmp_19_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_741 + tmp_qloop_680 + tmp_qloop_743) - tmp_qloop_452*tmp_qloop_738);
                   const real_t q_tmp_19_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_741 + tmp_qloop_681 + tmp_qloop_743) - tmp_qloop_467*tmp_qloop_738);
                   const real_t q_tmp_19_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_741 + tmp_qloop_682 + tmp_qloop_743) - tmp_qloop_482*tmp_qloop_738);
                   const real_t q_tmp_19_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_741 + tmp_qloop_683 + tmp_qloop_743) - tmp_qloop_497*tmp_qloop_738);
                   const real_t q_tmp_19_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_741 + tmp_qloop_684 + tmp_qloop_743) - tmp_qloop_512*tmp_qloop_738);
                   const real_t q_tmp_19_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_741 + tmp_qloop_685 + tmp_qloop_743) - tmp_qloop_527*tmp_qloop_738);
                   const real_t q_tmp_19_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_741 + tmp_qloop_686 + tmp_qloop_743) - tmp_qloop_542*tmp_qloop_738);
                   const real_t q_tmp_19_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_741 + tmp_qloop_687 + tmp_qloop_743) - tmp_qloop_557*tmp_qloop_738);
                   const real_t q_tmp_19_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_741 + tmp_qloop_688 + tmp_qloop_743) - tmp_qloop_572*tmp_qloop_738);
                   const real_t q_tmp_20_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_747 + tmp_qloop_442*tmp_qloop_746 + tmp_qloop_447*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_435*tmp_qloop_745);
                   const real_t q_tmp_20_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_747 + tmp_qloop_457*tmp_qloop_746 + tmp_qloop_462*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_745);
                   const real_t q_tmp_20_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_747 + tmp_qloop_472*tmp_qloop_746 + tmp_qloop_477*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_745);
                   const real_t q_tmp_20_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_747 + tmp_qloop_487*tmp_qloop_746 + tmp_qloop_492*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_745);
                   const real_t q_tmp_20_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_747 + tmp_qloop_502*tmp_qloop_746 + tmp_qloop_507*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_745);
                   const real_t q_tmp_20_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_747 + tmp_qloop_517*tmp_qloop_746 + tmp_qloop_522*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_745);
                   const real_t q_tmp_20_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_747 + tmp_qloop_532*tmp_qloop_746 + tmp_qloop_537*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_745);
                   const real_t q_tmp_20_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_747 + tmp_qloop_547*tmp_qloop_746 + tmp_qloop_552*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_745);
                   const real_t q_tmp_20_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_747 + tmp_qloop_562*tmp_qloop_746 + tmp_qloop_567*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_745);
                   const real_t q_tmp_20_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_747 + tmp_qloop_577*tmp_qloop_746 + tmp_qloop_582*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_745);
                   const real_t q_tmp_21_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_752 + tmp_qloop_457*tmp_qloop_751 + tmp_qloop_462*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_750);
                   const real_t q_tmp_21_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_752 + tmp_qloop_472*tmp_qloop_751 + tmp_qloop_477*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_750);
                   const real_t q_tmp_21_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_752 + tmp_qloop_487*tmp_qloop_751 + tmp_qloop_492*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_750);
                   const real_t q_tmp_21_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_752 + tmp_qloop_502*tmp_qloop_751 + tmp_qloop_507*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_750);
                   const real_t q_tmp_21_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_752 + tmp_qloop_517*tmp_qloop_751 + tmp_qloop_522*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_750);
                   const real_t q_tmp_21_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_752 + tmp_qloop_532*tmp_qloop_751 + tmp_qloop_537*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_750);
                   const real_t q_tmp_21_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_752 + tmp_qloop_547*tmp_qloop_751 + tmp_qloop_552*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_750);
                   const real_t q_tmp_21_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_752 + tmp_qloop_562*tmp_qloop_751 + tmp_qloop_567*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_750);
                   const real_t q_tmp_21_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_752 + tmp_qloop_577*tmp_qloop_751 + tmp_qloop_582*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_750);
                   const real_t q_tmp_22_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_756 + tmp_qloop_472*tmp_qloop_755 + tmp_qloop_477*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_754);
                   const real_t q_tmp_22_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_756 + tmp_qloop_487*tmp_qloop_755 + tmp_qloop_492*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_754);
                   const real_t q_tmp_22_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_756 + tmp_qloop_502*tmp_qloop_755 + tmp_qloop_507*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_754);
                   const real_t q_tmp_22_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_756 + tmp_qloop_517*tmp_qloop_755 + tmp_qloop_522*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_754);
                   const real_t q_tmp_22_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_756 + tmp_qloop_532*tmp_qloop_755 + tmp_qloop_537*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_754);
                   const real_t q_tmp_22_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_756 + tmp_qloop_547*tmp_qloop_755 + tmp_qloop_552*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_754);
                   const real_t q_tmp_22_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_756 + tmp_qloop_562*tmp_qloop_755 + tmp_qloop_567*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_754);
                   const real_t q_tmp_22_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_756 + tmp_qloop_577*tmp_qloop_755 + tmp_qloop_582*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_754);
                   const real_t q_tmp_23_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_760 + tmp_qloop_487*tmp_qloop_759 + tmp_qloop_492*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_758);
                   const real_t q_tmp_23_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_760 + tmp_qloop_502*tmp_qloop_759 + tmp_qloop_507*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_758);
                   const real_t q_tmp_23_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_760 + tmp_qloop_517*tmp_qloop_759 + tmp_qloop_522*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_758);
                   const real_t q_tmp_23_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_760 + tmp_qloop_532*tmp_qloop_759 + tmp_qloop_537*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_758);
                   const real_t q_tmp_23_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_760 + tmp_qloop_547*tmp_qloop_759 + tmp_qloop_552*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_758);
                   const real_t q_tmp_23_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_760 + tmp_qloop_562*tmp_qloop_759 + tmp_qloop_567*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_758);
                   const real_t q_tmp_23_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_760 + tmp_qloop_577*tmp_qloop_759 + tmp_qloop_582*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_758);
                   const real_t q_tmp_24_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_764 + tmp_qloop_502*tmp_qloop_763 + tmp_qloop_507*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_762);
                   const real_t q_tmp_24_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_764 + tmp_qloop_517*tmp_qloop_763 + tmp_qloop_522*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_762);
                   const real_t q_tmp_24_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_764 + tmp_qloop_532*tmp_qloop_763 + tmp_qloop_537*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_762);
                   const real_t q_tmp_24_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_764 + tmp_qloop_547*tmp_qloop_763 + tmp_qloop_552*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_762);
                   const real_t q_tmp_24_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_764 + tmp_qloop_562*tmp_qloop_763 + tmp_qloop_567*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_762);
                   const real_t q_tmp_24_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_764 + tmp_qloop_577*tmp_qloop_763 + tmp_qloop_582*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_762);
                   const real_t q_tmp_25_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_768 + tmp_qloop_517*tmp_qloop_767 + tmp_qloop_522*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_766);
                   const real_t q_tmp_25_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_768 + tmp_qloop_532*tmp_qloop_767 + tmp_qloop_537*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_766);
                   const real_t q_tmp_25_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_768 + tmp_qloop_547*tmp_qloop_767 + tmp_qloop_552*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_766);
                   const real_t q_tmp_25_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_768 + tmp_qloop_562*tmp_qloop_767 + tmp_qloop_567*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_766);
                   const real_t q_tmp_25_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_768 + tmp_qloop_577*tmp_qloop_767 + tmp_qloop_582*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_766);
                   const real_t q_tmp_26_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_772 + tmp_qloop_532*tmp_qloop_771 + tmp_qloop_537*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_770);
                   const real_t q_tmp_26_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_772 + tmp_qloop_547*tmp_qloop_771 + tmp_qloop_552*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_770);
                   const real_t q_tmp_26_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_772 + tmp_qloop_562*tmp_qloop_771 + tmp_qloop_567*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_770);
                   const real_t q_tmp_26_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_772 + tmp_qloop_577*tmp_qloop_771 + tmp_qloop_582*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_770);
                   const real_t q_tmp_27_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_776 + tmp_qloop_547*tmp_qloop_775 + tmp_qloop_552*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_774);
                   const real_t q_tmp_27_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_776 + tmp_qloop_562*tmp_qloop_775 + tmp_qloop_567*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_774);
                   const real_t q_tmp_27_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_776 + tmp_qloop_577*tmp_qloop_775 + tmp_qloop_582*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_774);
                   const real_t q_tmp_28_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_780 + tmp_qloop_562*tmp_qloop_779 + tmp_qloop_567*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_778);
                   const real_t q_tmp_28_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_780 + tmp_qloop_577*tmp_qloop_779 + tmp_qloop_582*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_778);
                   const real_t q_tmp_29_29 = tmp_qloop_156*(-tmp_qloop_118*tmp_qloop_572*(tmp_qloop_569 + tmp_qloop_570 + tmp_qloop_571 + tmp_qloop_744) + tmp_qloop_118*(tmp_qloop_576*(tmp_qloop_573*0.5 + tmp_qloop_574*0.5 + tmp_qloop_575*0.5 + tmp_qloop_675)*2.0 + tmp_qloop_577*(tmp_qloop_569*1.0 + tmp_qloop_570*1.0 + tmp_qloop_571*1.0) + tmp_qloop_582*(tmp_qloop_153 + tmp_qloop_579*0.5 + tmp_qloop_580*0.5 + tmp_qloop_581*0.5)*2.0 + tmp_qloop_749));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                   q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                   q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                   q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                   q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                   q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                   q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                   q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                   q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                   q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                   q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                   q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                   q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                   q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                   q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                   q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                   q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                   q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                   q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                   q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                   q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                   q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                   q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                   q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                   q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                   q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                   q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                   q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                   q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                   q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                   q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                   q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                   q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                   q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                   q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                   q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                   q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                   q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                   q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                   q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                   q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                   q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                   q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                   q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                   q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                   q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                   q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                   q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                   q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                   q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                   q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                   q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                   q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                   q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                   q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                   q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                   q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                   q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                   q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                   q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                   q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                   q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                   q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                   q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                   q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                   q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                   q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                   q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                   q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                   q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                   q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                   q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                   q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                   q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                   q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                   q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                   q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                   q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                   q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                   q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                   q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                   q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                   q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                   q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                   q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                   q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                   q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                   q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                   q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                   q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                   q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                   q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                   q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                   q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                   q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                   q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                   q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                   q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                   q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                   q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                   q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                   q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                   q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                   q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                   q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                   q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                   q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                   q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                   q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                   q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                   q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                   q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                   q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                   q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                   q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                   q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                   q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                   q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                   q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                   q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                   q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                   q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                   q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                   q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                   q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                   q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                   q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                   q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                   q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                   q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                   q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                   q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                   q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                   q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                   q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                   q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                   q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                   q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                   q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                   q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                   q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                   q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                   q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                   q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                   q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                   q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                   q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                   q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                   q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                   q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                   q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                   q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                   q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                   q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                   q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                   q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                   q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                   q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                   q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                   q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                   q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                   q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                   q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                   q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                   q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                   q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                   q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                   q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                   q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                   q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                   q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                   q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                   q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                   q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                   q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                   q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                   q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                   q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                   q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                   q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                   q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                   q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                   q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                   q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                   q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                   q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                   q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                   q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                   q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                   q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                   q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                   q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                   q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                   q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                   q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                   q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                   q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                   q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                   q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                   q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                   q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                   q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                   q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                   q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                   q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                   q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                   q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                   q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                   q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                   q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                   q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                   q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                   q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                   q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                   q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                   q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                   q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                   q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                   q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                   q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                   q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                   q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                   q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                   q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                   q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                   q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                   q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                   q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                   q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                   q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                   q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                   q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                   q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                   q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                   q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                   q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                   q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                   q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                   q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                   q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                   q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                   q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                   q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                   q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                   q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                   q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                   q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                   q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                   q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                   q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                   q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                   q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                   q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                   q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                   q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                   q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                   q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                   q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                   q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                   q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                   q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                   q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                   q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                   q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                   q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                   q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                   q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                   q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                   q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                   q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                   q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                   q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                   q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                   q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                   q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                   q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                   q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                   q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                   q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                   q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                   q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                   q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                   q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                   q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                   q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                   q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                   q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                   q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                   q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                   q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                   q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                   q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                   q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                   q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                   q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                   q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                   q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                   q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                   q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                   q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                   q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                   q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                   q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                   q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                   q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                   q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                   q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                   q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                   q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                   q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                   q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                   q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                   q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                   q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                   q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                   q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                   q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                   q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                   q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                   q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                   q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                   q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                   q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                   q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                   q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                   q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                   q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                   q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                   q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                   q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                   q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                   q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                   q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                   q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                   q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                   q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                   q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                   q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                   q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                   q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                   q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
                const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
                const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
                const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
                const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
                const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
                const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
                const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
                const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
                const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
                const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
                const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
                const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
                const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
                const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
                const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
                const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
                const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_17 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_27 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {0.25, 0.25, 0.25, 0.25, 0.16666666666666674, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666671, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666671, 0.5, 0.16666666666666666, 0.16666666666666666, 0.50000000000000011, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_UP [] = {0.0, ((real_t)(abs_det_jac_affine_BLUE_UP)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(abs_det_jac_affine_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(abs_det_jac_affine_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(abs_det_jac_affine_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_12 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_13 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_14 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_15 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_16 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_17 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_18 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_19 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_20 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_21 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_22 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_23 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_24 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_25 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_26 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_27 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_28 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_29 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_BLUE_UP[4*q],_data_phi_0_0_BLUE_UP[4*q],_data_phi_0_0_BLUE_UP[4*q],_data_phi_0_0_BLUE_UP[4*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_BLUE_UP[4*q + 1],_data_phi_0_0_BLUE_UP[4*q + 1],_data_phi_0_0_BLUE_UP[4*q + 1],_data_phi_0_0_BLUE_UP[4*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_BLUE_UP[4*q + 2],_data_phi_0_0_BLUE_UP[4*q + 2],_data_phi_0_0_BLUE_UP[4*q + 2],_data_phi_0_0_BLUE_UP[4*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_BLUE_UP[4*q + 3],_data_phi_0_0_BLUE_UP[4*q + 3],_data_phi_0_0_BLUE_UP[4*q + 3],_data_phi_0_0_BLUE_UP[4*q + 3]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_436 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_453 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_468 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_483 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_498 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_513 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_528 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_543 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_558 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_573 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q]));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9]));
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_444 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_459 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_474 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_489 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_504 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_519 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_534 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_549 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_564 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_579 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q]));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8]));
                   const __m256d tmp_qloop_257 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_342 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_449 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_464 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_479 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_494 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_509 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_524 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_539 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_554 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_569 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_134 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_236 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_437 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_454 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_469 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_484 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_499 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_514 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_529 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_544 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_559 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_574 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_445 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_460 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_475 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_490 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_505 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_520 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_535 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_550 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_565 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_580 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_343 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_432 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_450 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_465 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_480 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_495 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_510 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_525 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_540 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_555 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_570 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_126 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_124,tmp_qloop_125),tmp_qloop_126);
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_125,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_126,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_134),tmp_qloop_135);
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_134,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_135,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_187 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_213 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_226 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_237 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_239 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_265 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_280 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_291 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(tmp_qloop_120,tmp_qloop_291);
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_438 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_455 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_470 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_485 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_500 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_515 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_530 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_545 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_560 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_575 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_585 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_589 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_585);
                   const __m256d tmp_qloop_596 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_599 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_596);
                   const __m256d tmp_qloop_605 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_608 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_605);
                   const __m256d tmp_qloop_614 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_617 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_614);
                   const __m256d tmp_qloop_623 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_626 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_623);
                   const __m256d tmp_qloop_632 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_635 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_632);
                   const __m256d tmp_qloop_641 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_644 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_641);
                   const __m256d tmp_qloop_650 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_653 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_650);
                   const __m256d tmp_qloop_659 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_662 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_659);
                   const __m256d tmp_qloop_667 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_277,tmp_qloop_278),tmp_qloop_279);
                   const __m256d tmp_qloop_674 = _mm256_mul_pd(tmp_qloop_291,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(1.0,1.0,1.0,1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_121),tmp_qloop_122),tmp_qloop_123);
                   const __m256d tmp_qloop_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_139,tmp_qloop_140);
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_145),tmp_qloop_146);
                   const __m256d tmp_qloop_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_144,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_145,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_146,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_178 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_191 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_204 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_217 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_230 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_243 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_255 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_269 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_289 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_286,tmp_qloop_287),tmp_qloop_288);
                   const __m256d tmp_qloop_290 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_283,tmp_qloop_284),tmp_qloop_285),tmp_qloop_289);
                   const __m256d tmp_qloop_299 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_312 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_313 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_326 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_327 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_340 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_341 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_354 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_355 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_368 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_369 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_382 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_383 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_396 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_410 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_424 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_434 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_280);
                   const __m256d tmp_qloop_440 = _mm256_add_pd(tmp_qloop_127,tmp_qloop_289);
                   const __m256d tmp_qloop_441 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_440),tmp_qloop_141),tmp_qloop_292);
                   const __m256d tmp_qloop_446 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_461 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_476 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_491 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_506 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_521 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_536 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_551 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_566 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_581 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_586 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_593 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_586),tmp_qloop_589);
                   const __m256d tmp_qloop_594 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_593);
                   const __m256d tmp_qloop_597 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_602 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_597),tmp_qloop_599);
                   const __m256d tmp_qloop_603 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_602);
                   const __m256d tmp_qloop_606 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_611 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_606),tmp_qloop_608);
                   const __m256d tmp_qloop_612 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_611);
                   const __m256d tmp_qloop_615 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_620 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_615),tmp_qloop_617);
                   const __m256d tmp_qloop_621 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_620);
                   const __m256d tmp_qloop_624 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_629 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_624),tmp_qloop_626);
                   const __m256d tmp_qloop_630 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_629);
                   const __m256d tmp_qloop_633 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_638 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_633),tmp_qloop_635);
                   const __m256d tmp_qloop_639 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_638);
                   const __m256d tmp_qloop_642 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_647 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_642),tmp_qloop_644);
                   const __m256d tmp_qloop_648 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_647);
                   const __m256d tmp_qloop_651 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_656 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_651),tmp_qloop_653);
                   const __m256d tmp_qloop_657 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_656);
                   const __m256d tmp_qloop_660 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_665 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_660),tmp_qloop_662);
                   const __m256d tmp_qloop_666 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_665);
                   const __m256d tmp_qloop_670 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_671 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_672 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_283),tmp_qloop_284),tmp_qloop_285);
                   const __m256d tmp_qloop_678 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_670),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_672)),tmp_qloop_674);
                   const __m256d tmp_qloop_690 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_691 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_694 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_690),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_691));
                   const __m256d tmp_qloop_695 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_694);
                   const __m256d tmp_qloop_697 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_698 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_700 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_697),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_698));
                   const __m256d tmp_qloop_701 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_700);
                   const __m256d tmp_qloop_703 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_704 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_706 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_703),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_704));
                   const __m256d tmp_qloop_707 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_706);
                   const __m256d tmp_qloop_709 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_710 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_712 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_709),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_710));
                   const __m256d tmp_qloop_713 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_712);
                   const __m256d tmp_qloop_715 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_716 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_718 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_715),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_716));
                   const __m256d tmp_qloop_719 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_718);
                   const __m256d tmp_qloop_721 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_722 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_724 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_721),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_722));
                   const __m256d tmp_qloop_725 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_724);
                   const __m256d tmp_qloop_727 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_728 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_730 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_727),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_728));
                   const __m256d tmp_qloop_731 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_730);
                   const __m256d tmp_qloop_733 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_734 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_736 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_733),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_734));
                   const __m256d tmp_qloop_737 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_736);
                   const __m256d tmp_qloop_739 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_740 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_742 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_739),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_740));
                   const __m256d tmp_qloop_743 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_742);
                   const __m256d tmp_qloop_744 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_667);
                   const __m256d tmp_qloop_749 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_440,_mm256_add_pd(tmp_qloop_128,tmp_qloop_671)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_141),tmp_qloop_674);
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_117));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_130),tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_142,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q]));
                   const __m256d tmp_qloop_151 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_148,tmp_qloop_149),tmp_qloop_150);
                   const __m256d tmp_qloop_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,_mm256_add_pd(tmp_qloop_147,tmp_qloop_151)),tmp_qloop_141),tmp_qloop_143);
                   const __m256d tmp_qloop_160 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_169 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_199 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_208 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_212 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_221 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_225 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_234 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_246 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_251 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_260 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_264 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_273 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_281 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_280);
                   const __m256d tmp_qloop_282 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_296 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_293,tmp_qloop_294),tmp_qloop_295);
                   const __m256d tmp_qloop_297 = _mm256_add_pd(tmp_qloop_136,tmp_qloop_296);
                   const __m256d tmp_qloop_298 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_297),tmp_qloop_143),tmp_qloop_292);
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_303 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_304 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_299),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_303));
                   const __m256d tmp_qloop_308 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_317 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_318 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_313),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_317));
                   const __m256d tmp_qloop_322 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_331 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_332 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_327),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_331));
                   const __m256d tmp_qloop_336 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_345 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_346 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_341),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_345));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_359 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_360 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_355),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_359));
                   const __m256d tmp_qloop_364 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_373 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_374 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_369),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_373));
                   const __m256d tmp_qloop_378 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_387 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_388 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_383),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_387));
                   const __m256d tmp_qloop_392 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_401 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_402 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_397),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_401));
                   const __m256d tmp_qloop_406 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_416 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_411),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_415));
                   const __m256d tmp_qloop_420 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_429 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_430 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_425),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_429));
                   const __m256d tmp_qloop_433 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1]));
                   const __m256d tmp_qloop_435 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_439 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_442 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_443 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_442);
                   const __m256d tmp_qloop_447 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_448 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_447),tmp_qloop_443);
                   const __m256d tmp_qloop_451 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2]));
                   const __m256d tmp_qloop_452 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_457 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_458 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_457);
                   const __m256d tmp_qloop_462 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_463 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_462),tmp_qloop_458);
                   const __m256d tmp_qloop_466 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3]));
                   const __m256d tmp_qloop_467 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_472 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_473 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_472);
                   const __m256d tmp_qloop_477 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_478 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_477),tmp_qloop_473);
                   const __m256d tmp_qloop_481 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4]));
                   const __m256d tmp_qloop_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_486 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_487 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_488 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_487);
                   const __m256d tmp_qloop_492 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_493 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_492),tmp_qloop_488);
                   const __m256d tmp_qloop_496 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5]));
                   const __m256d tmp_qloop_497 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_501 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_502 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_503 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_502);
                   const __m256d tmp_qloop_507 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_508 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_507),tmp_qloop_503);
                   const __m256d tmp_qloop_511 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6]));
                   const __m256d tmp_qloop_512 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_516 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_517 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_518 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_517);
                   const __m256d tmp_qloop_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_523 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_522),tmp_qloop_518);
                   const __m256d tmp_qloop_526 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7]));
                   const __m256d tmp_qloop_527 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_531 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_532 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_533 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_532);
                   const __m256d tmp_qloop_537 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_538 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_537),tmp_qloop_533);
                   const __m256d tmp_qloop_541 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8]));
                   const __m256d tmp_qloop_542 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_546 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_547 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_548 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_547);
                   const __m256d tmp_qloop_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_553 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_552),tmp_qloop_548);
                   const __m256d tmp_qloop_556 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9]));
                   const __m256d tmp_qloop_557 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_561 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_562 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_563 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_562);
                   const __m256d tmp_qloop_567 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d tmp_qloop_568 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_567),tmp_qloop_563);
                   const __m256d tmp_qloop_571 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10]));
                   const __m256d tmp_qloop_572 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_576 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_573),tmp_qloop_574),tmp_qloop_575);
                   const __m256d tmp_qloop_577 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_578 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_577);
                   const __m256d tmp_qloop_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_579),tmp_qloop_580),tmp_qloop_581);
                   const __m256d tmp_qloop_583 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_582),tmp_qloop_578);
                   const __m256d tmp_qloop_584 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_157),tmp_qloop_158),tmp_qloop_159));
                   const __m256d tmp_qloop_587 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_588 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_304);
                   const __m256d tmp_qloop_590 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_587),tmp_qloop_589);
                   const __m256d tmp_qloop_591 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_590);
                   const __m256d tmp_qloop_592 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_448);
                   const __m256d tmp_qloop_595 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172));
                   const __m256d tmp_qloop_598 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_600 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_598),tmp_qloop_599);
                   const __m256d tmp_qloop_601 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_600);
                   const __m256d tmp_qloop_604 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_183),tmp_qloop_184),tmp_qloop_185));
                   const __m256d tmp_qloop_607 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_609 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_607),tmp_qloop_608);
                   const __m256d tmp_qloop_610 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_609);
                   const __m256d tmp_qloop_613 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_196),tmp_qloop_197),tmp_qloop_198));
                   const __m256d tmp_qloop_616 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_618 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_616),tmp_qloop_617);
                   const __m256d tmp_qloop_619 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_618);
                   const __m256d tmp_qloop_622 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211));
                   const __m256d tmp_qloop_625 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_627 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_625),tmp_qloop_626);
                   const __m256d tmp_qloop_628 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_627);
                   const __m256d tmp_qloop_631 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_222),tmp_qloop_223),tmp_qloop_224));
                   const __m256d tmp_qloop_634 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_636 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_634),tmp_qloop_635);
                   const __m256d tmp_qloop_637 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_636);
                   const __m256d tmp_qloop_640 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_235),tmp_qloop_236),tmp_qloop_237));
                   const __m256d tmp_qloop_643 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_645 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_643),tmp_qloop_644);
                   const __m256d tmp_qloop_646 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_645);
                   const __m256d tmp_qloop_649 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250));
                   const __m256d tmp_qloop_652 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_654 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_652),tmp_qloop_653);
                   const __m256d tmp_qloop_655 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_654);
                   const __m256d tmp_qloop_658 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263));
                   const __m256d tmp_qloop_661 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_663 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_661),tmp_qloop_662);
                   const __m256d tmp_qloop_664 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_663);
                   const __m256d tmp_qloop_668 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_667);
                   const __m256d tmp_qloop_669 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_274,tmp_qloop_275),tmp_qloop_276),tmp_qloop_668));
                   const __m256d tmp_qloop_673 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_675 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_676 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_677 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_676),tmp_qloop_143),tmp_qloop_674);
                   const __m256d tmp_qloop_679 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_676),tmp_qloop_443);
                   const __m256d tmp_qloop_680 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_676),tmp_qloop_458);
                   const __m256d tmp_qloop_681 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_676),tmp_qloop_473);
                   const __m256d tmp_qloop_682 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_676),tmp_qloop_488);
                   const __m256d tmp_qloop_683 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_676),tmp_qloop_503);
                   const __m256d tmp_qloop_684 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_676),tmp_qloop_518);
                   const __m256d tmp_qloop_685 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_676),tmp_qloop_533);
                   const __m256d tmp_qloop_686 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_676),tmp_qloop_548);
                   const __m256d tmp_qloop_687 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_676),tmp_qloop_563);
                   const __m256d tmp_qloop_688 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_676),tmp_qloop_578);
                   const __m256d tmp_qloop_689 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_305,tmp_qloop_306),tmp_qloop_307),tmp_qloop_668));
                   const __m256d tmp_qloop_692 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_693 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_679);
                   const __m256d tmp_qloop_696 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_319,tmp_qloop_320),tmp_qloop_321),tmp_qloop_668));
                   const __m256d tmp_qloop_699 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_702 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_333,tmp_qloop_334),tmp_qloop_335),tmp_qloop_668));
                   const __m256d tmp_qloop_705 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_708 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_347,tmp_qloop_348),tmp_qloop_349),tmp_qloop_668));
                   const __m256d tmp_qloop_711 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_714 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_361,tmp_qloop_362),tmp_qloop_363),tmp_qloop_668));
                   const __m256d tmp_qloop_717 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_720 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_375,tmp_qloop_376),tmp_qloop_377),tmp_qloop_668));
                   const __m256d tmp_qloop_723 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_726 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_389,tmp_qloop_390),tmp_qloop_391),tmp_qloop_668));
                   const __m256d tmp_qloop_729 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_732 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_403,tmp_qloop_404),tmp_qloop_405),tmp_qloop_668));
                   const __m256d tmp_qloop_735 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_738 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_417,tmp_qloop_418),tmp_qloop_419),tmp_qloop_668));
                   const __m256d tmp_qloop_741 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_745 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_431,tmp_qloop_432),tmp_qloop_433),tmp_qloop_744));
                   const __m256d tmp_qloop_746 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_747 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_748 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_750 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_449,tmp_qloop_450),tmp_qloop_451),tmp_qloop_744));
                   const __m256d tmp_qloop_751 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_752 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_753 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_754 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_464,tmp_qloop_465),tmp_qloop_466),tmp_qloop_744));
                   const __m256d tmp_qloop_755 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_756 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_757 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_758 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_479,tmp_qloop_480),tmp_qloop_481),tmp_qloop_744));
                   const __m256d tmp_qloop_759 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_760 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_761 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_762 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_494,tmp_qloop_495),tmp_qloop_496),tmp_qloop_744));
                   const __m256d tmp_qloop_763 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_764 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_765 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_766 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_509,tmp_qloop_510),tmp_qloop_511),tmp_qloop_744));
                   const __m256d tmp_qloop_767 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_768 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_769 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_770 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_524,tmp_qloop_525),tmp_qloop_526),tmp_qloop_744));
                   const __m256d tmp_qloop_771 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_772 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_773 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_774 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_539,tmp_qloop_540),tmp_qloop_541),tmp_qloop_744));
                   const __m256d tmp_qloop_775 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_776 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_777 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_778 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_554,tmp_qloop_555),tmp_qloop_556),tmp_qloop_744));
                   const __m256d tmp_qloop_779 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_780 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_781 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(tmp_qloop_129,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_121,tmp_qloop_122),tmp_qloop_123),tmp_qloop_127))),_mm256_mul_pd(tmp_qloop_138,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132),tmp_qloop_136))),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_161),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_165)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_169)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_160),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_178)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_182)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_187),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_191)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_195)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_186),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_200),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_204)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_208)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_213),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_217)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_221)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_212),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_226),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_230)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_234)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_225),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_239),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_243)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_247)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_238),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_252),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_256)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_260)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_251),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_265),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_269)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_273)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_264),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_290),tmp_qloop_298),tmp_qloop_304)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_312),tmp_qloop_298),tmp_qloop_318)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_308),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_326),tmp_qloop_298),tmp_qloop_332)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_322),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_340),tmp_qloop_298),tmp_qloop_346)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_336),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_354),tmp_qloop_298),tmp_qloop_360)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_350),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_368),tmp_qloop_298),tmp_qloop_374)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_364),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_382),tmp_qloop_298),tmp_qloop_388)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_378),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_396),tmp_qloop_298),tmp_qloop_402)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_392),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_410),tmp_qloop_298),tmp_qloop_416)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_406),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_424),tmp_qloop_298),tmp_qloop_430)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_420),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_439),tmp_qloop_441),tmp_qloop_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_435),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_456),tmp_qloop_441),tmp_qloop_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_452),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_471),tmp_qloop_441),tmp_qloop_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_467),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_486),tmp_qloop_441),tmp_qloop_493)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_482),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_501),tmp_qloop_441),tmp_qloop_508)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_497),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_516),tmp_qloop_441),tmp_qloop_523)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_512),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_531),tmp_qloop_441),tmp_qloop_538)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_527),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_546),tmp_qloop_441),tmp_qloop_553)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_542),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_561),tmp_qloop_441),tmp_qloop_568)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_557),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_576),tmp_qloop_441),tmp_qloop_583)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_572),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_165,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_169,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_586),tmp_qloop_588),tmp_qloop_590)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_586),tmp_qloop_318),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_586),tmp_qloop_332),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_586),tmp_qloop_346),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_586),tmp_qloop_360),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_586),tmp_qloop_374),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_586),tmp_qloop_388),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_586),tmp_qloop_402),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_586),tmp_qloop_416),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_586),tmp_qloop_430),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_587),tmp_qloop_592),tmp_qloop_593)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_587),tmp_qloop_463),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_587),tmp_qloop_478),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_587),tmp_qloop_493),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_587),tmp_qloop_508),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_587),tmp_qloop_523),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_587),tmp_qloop_538),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_587),tmp_qloop_553),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_587),tmp_qloop_568),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_587),tmp_qloop_583),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_597),tmp_qloop_588),tmp_qloop_600)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_597),tmp_qloop_318),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_597),tmp_qloop_332),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_597),tmp_qloop_346),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_597),tmp_qloop_360),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_597),tmp_qloop_374),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_597),tmp_qloop_388),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_597),tmp_qloop_402),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_597),tmp_qloop_416),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_597),tmp_qloop_430),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_598),tmp_qloop_592),tmp_qloop_602)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_598),tmp_qloop_463),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_598),tmp_qloop_478),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_598),tmp_qloop_493),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_598),tmp_qloop_508),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_598),tmp_qloop_523),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_598),tmp_qloop_538),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_598),tmp_qloop_553),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_598),tmp_qloop_568),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_598),tmp_qloop_583),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_606),tmp_qloop_588),tmp_qloop_609)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_606),tmp_qloop_318),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_606),tmp_qloop_332),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_606),tmp_qloop_346),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_606),tmp_qloop_360),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_606),tmp_qloop_374),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_606),tmp_qloop_388),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_606),tmp_qloop_402),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_606),tmp_qloop_416),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_606),tmp_qloop_430),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_607),tmp_qloop_592),tmp_qloop_611)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_607),tmp_qloop_463),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_607),tmp_qloop_478),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_607),tmp_qloop_493),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_607),tmp_qloop_508),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_607),tmp_qloop_523),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_607),tmp_qloop_538),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_607),tmp_qloop_553),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_607),tmp_qloop_568),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_607),tmp_qloop_583),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_615),tmp_qloop_588),tmp_qloop_618)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_615),tmp_qloop_318),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_615),tmp_qloop_332),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_615),tmp_qloop_346),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_615),tmp_qloop_360),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_615),tmp_qloop_374),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_615),tmp_qloop_388),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_615),tmp_qloop_402),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_615),tmp_qloop_416),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_615),tmp_qloop_430),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_616),tmp_qloop_592),tmp_qloop_620)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_616),tmp_qloop_463),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_616),tmp_qloop_478),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_616),tmp_qloop_493),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_616),tmp_qloop_508),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_616),tmp_qloop_523),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_616),tmp_qloop_538),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_616),tmp_qloop_553),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_616),tmp_qloop_568),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_616),tmp_qloop_583),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_624),tmp_qloop_588),tmp_qloop_627)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_624),tmp_qloop_318),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_624),tmp_qloop_332),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_624),tmp_qloop_346),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_624),tmp_qloop_360),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_624),tmp_qloop_374),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_624),tmp_qloop_388),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_624),tmp_qloop_402),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_624),tmp_qloop_416),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_624),tmp_qloop_430),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_625),tmp_qloop_592),tmp_qloop_629)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_625),tmp_qloop_463),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_625),tmp_qloop_478),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_625),tmp_qloop_493),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_625),tmp_qloop_508),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_625),tmp_qloop_523),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_625),tmp_qloop_538),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_625),tmp_qloop_553),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_625),tmp_qloop_568),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_625),tmp_qloop_583),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_633),tmp_qloop_588),tmp_qloop_636)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_633),tmp_qloop_318),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_633),tmp_qloop_332),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_633),tmp_qloop_346),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_633),tmp_qloop_360),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_633),tmp_qloop_374),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_633),tmp_qloop_388),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_633),tmp_qloop_402),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_633),tmp_qloop_416),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_633),tmp_qloop_430),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_634),tmp_qloop_592),tmp_qloop_638)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_634),tmp_qloop_463),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_634),tmp_qloop_478),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_634),tmp_qloop_493),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_634),tmp_qloop_508),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_634),tmp_qloop_523),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_634),tmp_qloop_538),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_634),tmp_qloop_553),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_634),tmp_qloop_568),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_634),tmp_qloop_583),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_642),tmp_qloop_588),tmp_qloop_645)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_642),tmp_qloop_318),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_642),tmp_qloop_332),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_642),tmp_qloop_346),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_642),tmp_qloop_360),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_642),tmp_qloop_374),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_642),tmp_qloop_388),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_642),tmp_qloop_402),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_642),tmp_qloop_416),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_642),tmp_qloop_430),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_643),tmp_qloop_592),tmp_qloop_647)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_643),tmp_qloop_463),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_643),tmp_qloop_478),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_643),tmp_qloop_493),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_643),tmp_qloop_508),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_643),tmp_qloop_523),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_643),tmp_qloop_538),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_643),tmp_qloop_553),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_643),tmp_qloop_568),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_643),tmp_qloop_583),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_651),tmp_qloop_588),tmp_qloop_654)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_651),tmp_qloop_318),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_651),tmp_qloop_332),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_651),tmp_qloop_346),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_651),tmp_qloop_360),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_651),tmp_qloop_374),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_651),tmp_qloop_388),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_651),tmp_qloop_402),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_651),tmp_qloop_416),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_651),tmp_qloop_430),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_652),tmp_qloop_592),tmp_qloop_656)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_652),tmp_qloop_463),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_652),tmp_qloop_478),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_652),tmp_qloop_493),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_652),tmp_qloop_508),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_652),tmp_qloop_523),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_652),tmp_qloop_538),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_652),tmp_qloop_553),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_652),tmp_qloop_568),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_652),tmp_qloop_583),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_659),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_660)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_661)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_660),tmp_qloop_588),tmp_qloop_663)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_660),tmp_qloop_318),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_660),tmp_qloop_332),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_660),tmp_qloop_346),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_660),tmp_qloop_360),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_660),tmp_qloop_374),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_660),tmp_qloop_388),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_660),tmp_qloop_402),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_660),tmp_qloop_416),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_660),tmp_qloop_430),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_661),tmp_qloop_592),tmp_qloop_665)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_661),tmp_qloop_463),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_661),tmp_qloop_478),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_661),tmp_qloop_493),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_661),tmp_qloop_508),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_661),tmp_qloop_523),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_661),tmp_qloop_538),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_661),tmp_qloop_553),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_661),tmp_qloop_568),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_661),tmp_qloop_583),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_299,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_303,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_673),tmp_qloop_678),tmp_qloop_679)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_673),tmp_qloop_678),tmp_qloop_680)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_673),tmp_qloop_678),tmp_qloop_681)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_673),tmp_qloop_678),tmp_qloop_682)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_673),tmp_qloop_678),tmp_qloop_683)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_673),tmp_qloop_678),tmp_qloop_684)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_673),tmp_qloop_678),tmp_qloop_685)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_673),tmp_qloop_678),tmp_qloop_686)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_673),tmp_qloop_678),tmp_qloop_687)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_673),tmp_qloop_678),tmp_qloop_688)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_692),tmp_qloop_693),tmp_qloop_694)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_692),tmp_qloop_680),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_692),tmp_qloop_681),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_692),tmp_qloop_682),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_692),tmp_qloop_683),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_692),tmp_qloop_684),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_692),tmp_qloop_685),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_692),tmp_qloop_686),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_692),tmp_qloop_687),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_692),tmp_qloop_688),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_699),tmp_qloop_693),tmp_qloop_700)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_699),tmp_qloop_680),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_699),tmp_qloop_681),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_699),tmp_qloop_682),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_699),tmp_qloop_683),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_699),tmp_qloop_684),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_699),tmp_qloop_685),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_699),tmp_qloop_686),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_699),tmp_qloop_687),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_699),tmp_qloop_688),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_705),tmp_qloop_693),tmp_qloop_706)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_705),tmp_qloop_680),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_705),tmp_qloop_681),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_705),tmp_qloop_682),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_705),tmp_qloop_683),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_705),tmp_qloop_684),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_705),tmp_qloop_685),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_705),tmp_qloop_686),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_705),tmp_qloop_687),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_705),tmp_qloop_688),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_711),tmp_qloop_693),tmp_qloop_712)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_711),tmp_qloop_680),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_711),tmp_qloop_681),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_711),tmp_qloop_682),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_711),tmp_qloop_683),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_711),tmp_qloop_684),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_711),tmp_qloop_685),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_711),tmp_qloop_686),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_711),tmp_qloop_687),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_711),tmp_qloop_688),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_717),tmp_qloop_693),tmp_qloop_718)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_717),tmp_qloop_680),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_717),tmp_qloop_681),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_717),tmp_qloop_682),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_717),tmp_qloop_683),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_717),tmp_qloop_684),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_717),tmp_qloop_685),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_717),tmp_qloop_686),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_717),tmp_qloop_687),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_717),tmp_qloop_688),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_723),tmp_qloop_693),tmp_qloop_724)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_723),tmp_qloop_680),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_723),tmp_qloop_681),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_723),tmp_qloop_682),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_723),tmp_qloop_683),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_723),tmp_qloop_684),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_723),tmp_qloop_685),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_723),tmp_qloop_686),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_723),tmp_qloop_687),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_723),tmp_qloop_688),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_729),tmp_qloop_693),tmp_qloop_730)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_729),tmp_qloop_680),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_729),tmp_qloop_681),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_729),tmp_qloop_682),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_729),tmp_qloop_683),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_729),tmp_qloop_684),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_729),tmp_qloop_685),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_729),tmp_qloop_686),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_729),tmp_qloop_687),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_729),tmp_qloop_688),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_735),tmp_qloop_693),tmp_qloop_736)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_735),tmp_qloop_680),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_735),tmp_qloop_681),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_735),tmp_qloop_682),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_735),tmp_qloop_683),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_735),tmp_qloop_684),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_735),tmp_qloop_685),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_735),tmp_qloop_686),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_735),tmp_qloop_687),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_735),tmp_qloop_688),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_740),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_739)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_741)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_741),tmp_qloop_693),tmp_qloop_742)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_741),tmp_qloop_680),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_741),tmp_qloop_681),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_741),tmp_qloop_682),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_741),tmp_qloop_683),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_741),tmp_qloop_684),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_741),tmp_qloop_685),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_741),tmp_qloop_686),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_741),tmp_qloop_687),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_741),tmp_qloop_688),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_442,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_447,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_577,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(1.0,1.0,1.0,1.0)))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_576,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_573,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_574,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_575,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_675)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_582,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_579,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_580,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_581,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_153)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_572),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_569,tmp_qloop_570),tmp_qloop_571),tmp_qloop_744)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_0_12 = _mm256_add_pd(q_acc_0_12,q_tmp_0_12);
                   q_acc_0_13 = _mm256_add_pd(q_acc_0_13,q_tmp_0_13);
                   q_acc_0_14 = _mm256_add_pd(q_acc_0_14,q_tmp_0_14);
                   q_acc_0_15 = _mm256_add_pd(q_acc_0_15,q_tmp_0_15);
                   q_acc_0_16 = _mm256_add_pd(q_acc_0_16,q_tmp_0_16);
                   q_acc_0_17 = _mm256_add_pd(q_acc_0_17,q_tmp_0_17);
                   q_acc_0_18 = _mm256_add_pd(q_acc_0_18,q_tmp_0_18);
                   q_acc_0_19 = _mm256_add_pd(q_acc_0_19,q_tmp_0_19);
                   q_acc_0_20 = _mm256_add_pd(q_acc_0_20,q_tmp_0_20);
                   q_acc_0_21 = _mm256_add_pd(q_acc_0_21,q_tmp_0_21);
                   q_acc_0_22 = _mm256_add_pd(q_acc_0_22,q_tmp_0_22);
                   q_acc_0_23 = _mm256_add_pd(q_acc_0_23,q_tmp_0_23);
                   q_acc_0_24 = _mm256_add_pd(q_acc_0_24,q_tmp_0_24);
                   q_acc_0_25 = _mm256_add_pd(q_acc_0_25,q_tmp_0_25);
                   q_acc_0_26 = _mm256_add_pd(q_acc_0_26,q_tmp_0_26);
                   q_acc_0_27 = _mm256_add_pd(q_acc_0_27,q_tmp_0_27);
                   q_acc_0_28 = _mm256_add_pd(q_acc_0_28,q_tmp_0_28);
                   q_acc_0_29 = _mm256_add_pd(q_acc_0_29,q_tmp_0_29);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_1_12 = _mm256_add_pd(q_acc_1_12,q_tmp_1_12);
                   q_acc_1_13 = _mm256_add_pd(q_acc_1_13,q_tmp_1_13);
                   q_acc_1_14 = _mm256_add_pd(q_acc_1_14,q_tmp_1_14);
                   q_acc_1_15 = _mm256_add_pd(q_acc_1_15,q_tmp_1_15);
                   q_acc_1_16 = _mm256_add_pd(q_acc_1_16,q_tmp_1_16);
                   q_acc_1_17 = _mm256_add_pd(q_acc_1_17,q_tmp_1_17);
                   q_acc_1_18 = _mm256_add_pd(q_acc_1_18,q_tmp_1_18);
                   q_acc_1_19 = _mm256_add_pd(q_acc_1_19,q_tmp_1_19);
                   q_acc_1_20 = _mm256_add_pd(q_acc_1_20,q_tmp_1_20);
                   q_acc_1_21 = _mm256_add_pd(q_acc_1_21,q_tmp_1_21);
                   q_acc_1_22 = _mm256_add_pd(q_acc_1_22,q_tmp_1_22);
                   q_acc_1_23 = _mm256_add_pd(q_acc_1_23,q_tmp_1_23);
                   q_acc_1_24 = _mm256_add_pd(q_acc_1_24,q_tmp_1_24);
                   q_acc_1_25 = _mm256_add_pd(q_acc_1_25,q_tmp_1_25);
                   q_acc_1_26 = _mm256_add_pd(q_acc_1_26,q_tmp_1_26);
                   q_acc_1_27 = _mm256_add_pd(q_acc_1_27,q_tmp_1_27);
                   q_acc_1_28 = _mm256_add_pd(q_acc_1_28,q_tmp_1_28);
                   q_acc_1_29 = _mm256_add_pd(q_acc_1_29,q_tmp_1_29);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_2_12 = _mm256_add_pd(q_acc_2_12,q_tmp_2_12);
                   q_acc_2_13 = _mm256_add_pd(q_acc_2_13,q_tmp_2_13);
                   q_acc_2_14 = _mm256_add_pd(q_acc_2_14,q_tmp_2_14);
                   q_acc_2_15 = _mm256_add_pd(q_acc_2_15,q_tmp_2_15);
                   q_acc_2_16 = _mm256_add_pd(q_acc_2_16,q_tmp_2_16);
                   q_acc_2_17 = _mm256_add_pd(q_acc_2_17,q_tmp_2_17);
                   q_acc_2_18 = _mm256_add_pd(q_acc_2_18,q_tmp_2_18);
                   q_acc_2_19 = _mm256_add_pd(q_acc_2_19,q_tmp_2_19);
                   q_acc_2_20 = _mm256_add_pd(q_acc_2_20,q_tmp_2_20);
                   q_acc_2_21 = _mm256_add_pd(q_acc_2_21,q_tmp_2_21);
                   q_acc_2_22 = _mm256_add_pd(q_acc_2_22,q_tmp_2_22);
                   q_acc_2_23 = _mm256_add_pd(q_acc_2_23,q_tmp_2_23);
                   q_acc_2_24 = _mm256_add_pd(q_acc_2_24,q_tmp_2_24);
                   q_acc_2_25 = _mm256_add_pd(q_acc_2_25,q_tmp_2_25);
                   q_acc_2_26 = _mm256_add_pd(q_acc_2_26,q_tmp_2_26);
                   q_acc_2_27 = _mm256_add_pd(q_acc_2_27,q_tmp_2_27);
                   q_acc_2_28 = _mm256_add_pd(q_acc_2_28,q_tmp_2_28);
                   q_acc_2_29 = _mm256_add_pd(q_acc_2_29,q_tmp_2_29);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_3_12 = _mm256_add_pd(q_acc_3_12,q_tmp_3_12);
                   q_acc_3_13 = _mm256_add_pd(q_acc_3_13,q_tmp_3_13);
                   q_acc_3_14 = _mm256_add_pd(q_acc_3_14,q_tmp_3_14);
                   q_acc_3_15 = _mm256_add_pd(q_acc_3_15,q_tmp_3_15);
                   q_acc_3_16 = _mm256_add_pd(q_acc_3_16,q_tmp_3_16);
                   q_acc_3_17 = _mm256_add_pd(q_acc_3_17,q_tmp_3_17);
                   q_acc_3_18 = _mm256_add_pd(q_acc_3_18,q_tmp_3_18);
                   q_acc_3_19 = _mm256_add_pd(q_acc_3_19,q_tmp_3_19);
                   q_acc_3_20 = _mm256_add_pd(q_acc_3_20,q_tmp_3_20);
                   q_acc_3_21 = _mm256_add_pd(q_acc_3_21,q_tmp_3_21);
                   q_acc_3_22 = _mm256_add_pd(q_acc_3_22,q_tmp_3_22);
                   q_acc_3_23 = _mm256_add_pd(q_acc_3_23,q_tmp_3_23);
                   q_acc_3_24 = _mm256_add_pd(q_acc_3_24,q_tmp_3_24);
                   q_acc_3_25 = _mm256_add_pd(q_acc_3_25,q_tmp_3_25);
                   q_acc_3_26 = _mm256_add_pd(q_acc_3_26,q_tmp_3_26);
                   q_acc_3_27 = _mm256_add_pd(q_acc_3_27,q_tmp_3_27);
                   q_acc_3_28 = _mm256_add_pd(q_acc_3_28,q_tmp_3_28);
                   q_acc_3_29 = _mm256_add_pd(q_acc_3_29,q_tmp_3_29);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_4_12 = _mm256_add_pd(q_acc_4_12,q_tmp_4_12);
                   q_acc_4_13 = _mm256_add_pd(q_acc_4_13,q_tmp_4_13);
                   q_acc_4_14 = _mm256_add_pd(q_acc_4_14,q_tmp_4_14);
                   q_acc_4_15 = _mm256_add_pd(q_acc_4_15,q_tmp_4_15);
                   q_acc_4_16 = _mm256_add_pd(q_acc_4_16,q_tmp_4_16);
                   q_acc_4_17 = _mm256_add_pd(q_acc_4_17,q_tmp_4_17);
                   q_acc_4_18 = _mm256_add_pd(q_acc_4_18,q_tmp_4_18);
                   q_acc_4_19 = _mm256_add_pd(q_acc_4_19,q_tmp_4_19);
                   q_acc_4_20 = _mm256_add_pd(q_acc_4_20,q_tmp_4_20);
                   q_acc_4_21 = _mm256_add_pd(q_acc_4_21,q_tmp_4_21);
                   q_acc_4_22 = _mm256_add_pd(q_acc_4_22,q_tmp_4_22);
                   q_acc_4_23 = _mm256_add_pd(q_acc_4_23,q_tmp_4_23);
                   q_acc_4_24 = _mm256_add_pd(q_acc_4_24,q_tmp_4_24);
                   q_acc_4_25 = _mm256_add_pd(q_acc_4_25,q_tmp_4_25);
                   q_acc_4_26 = _mm256_add_pd(q_acc_4_26,q_tmp_4_26);
                   q_acc_4_27 = _mm256_add_pd(q_acc_4_27,q_tmp_4_27);
                   q_acc_4_28 = _mm256_add_pd(q_acc_4_28,q_tmp_4_28);
                   q_acc_4_29 = _mm256_add_pd(q_acc_4_29,q_tmp_4_29);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_5_12 = _mm256_add_pd(q_acc_5_12,q_tmp_5_12);
                   q_acc_5_13 = _mm256_add_pd(q_acc_5_13,q_tmp_5_13);
                   q_acc_5_14 = _mm256_add_pd(q_acc_5_14,q_tmp_5_14);
                   q_acc_5_15 = _mm256_add_pd(q_acc_5_15,q_tmp_5_15);
                   q_acc_5_16 = _mm256_add_pd(q_acc_5_16,q_tmp_5_16);
                   q_acc_5_17 = _mm256_add_pd(q_acc_5_17,q_tmp_5_17);
                   q_acc_5_18 = _mm256_add_pd(q_acc_5_18,q_tmp_5_18);
                   q_acc_5_19 = _mm256_add_pd(q_acc_5_19,q_tmp_5_19);
                   q_acc_5_20 = _mm256_add_pd(q_acc_5_20,q_tmp_5_20);
                   q_acc_5_21 = _mm256_add_pd(q_acc_5_21,q_tmp_5_21);
                   q_acc_5_22 = _mm256_add_pd(q_acc_5_22,q_tmp_5_22);
                   q_acc_5_23 = _mm256_add_pd(q_acc_5_23,q_tmp_5_23);
                   q_acc_5_24 = _mm256_add_pd(q_acc_5_24,q_tmp_5_24);
                   q_acc_5_25 = _mm256_add_pd(q_acc_5_25,q_tmp_5_25);
                   q_acc_5_26 = _mm256_add_pd(q_acc_5_26,q_tmp_5_26);
                   q_acc_5_27 = _mm256_add_pd(q_acc_5_27,q_tmp_5_27);
                   q_acc_5_28 = _mm256_add_pd(q_acc_5_28,q_tmp_5_28);
                   q_acc_5_29 = _mm256_add_pd(q_acc_5_29,q_tmp_5_29);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_6_12 = _mm256_add_pd(q_acc_6_12,q_tmp_6_12);
                   q_acc_6_13 = _mm256_add_pd(q_acc_6_13,q_tmp_6_13);
                   q_acc_6_14 = _mm256_add_pd(q_acc_6_14,q_tmp_6_14);
                   q_acc_6_15 = _mm256_add_pd(q_acc_6_15,q_tmp_6_15);
                   q_acc_6_16 = _mm256_add_pd(q_acc_6_16,q_tmp_6_16);
                   q_acc_6_17 = _mm256_add_pd(q_acc_6_17,q_tmp_6_17);
                   q_acc_6_18 = _mm256_add_pd(q_acc_6_18,q_tmp_6_18);
                   q_acc_6_19 = _mm256_add_pd(q_acc_6_19,q_tmp_6_19);
                   q_acc_6_20 = _mm256_add_pd(q_acc_6_20,q_tmp_6_20);
                   q_acc_6_21 = _mm256_add_pd(q_acc_6_21,q_tmp_6_21);
                   q_acc_6_22 = _mm256_add_pd(q_acc_6_22,q_tmp_6_22);
                   q_acc_6_23 = _mm256_add_pd(q_acc_6_23,q_tmp_6_23);
                   q_acc_6_24 = _mm256_add_pd(q_acc_6_24,q_tmp_6_24);
                   q_acc_6_25 = _mm256_add_pd(q_acc_6_25,q_tmp_6_25);
                   q_acc_6_26 = _mm256_add_pd(q_acc_6_26,q_tmp_6_26);
                   q_acc_6_27 = _mm256_add_pd(q_acc_6_27,q_tmp_6_27);
                   q_acc_6_28 = _mm256_add_pd(q_acc_6_28,q_tmp_6_28);
                   q_acc_6_29 = _mm256_add_pd(q_acc_6_29,q_tmp_6_29);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_7_12 = _mm256_add_pd(q_acc_7_12,q_tmp_7_12);
                   q_acc_7_13 = _mm256_add_pd(q_acc_7_13,q_tmp_7_13);
                   q_acc_7_14 = _mm256_add_pd(q_acc_7_14,q_tmp_7_14);
                   q_acc_7_15 = _mm256_add_pd(q_acc_7_15,q_tmp_7_15);
                   q_acc_7_16 = _mm256_add_pd(q_acc_7_16,q_tmp_7_16);
                   q_acc_7_17 = _mm256_add_pd(q_acc_7_17,q_tmp_7_17);
                   q_acc_7_18 = _mm256_add_pd(q_acc_7_18,q_tmp_7_18);
                   q_acc_7_19 = _mm256_add_pd(q_acc_7_19,q_tmp_7_19);
                   q_acc_7_20 = _mm256_add_pd(q_acc_7_20,q_tmp_7_20);
                   q_acc_7_21 = _mm256_add_pd(q_acc_7_21,q_tmp_7_21);
                   q_acc_7_22 = _mm256_add_pd(q_acc_7_22,q_tmp_7_22);
                   q_acc_7_23 = _mm256_add_pd(q_acc_7_23,q_tmp_7_23);
                   q_acc_7_24 = _mm256_add_pd(q_acc_7_24,q_tmp_7_24);
                   q_acc_7_25 = _mm256_add_pd(q_acc_7_25,q_tmp_7_25);
                   q_acc_7_26 = _mm256_add_pd(q_acc_7_26,q_tmp_7_26);
                   q_acc_7_27 = _mm256_add_pd(q_acc_7_27,q_tmp_7_27);
                   q_acc_7_28 = _mm256_add_pd(q_acc_7_28,q_tmp_7_28);
                   q_acc_7_29 = _mm256_add_pd(q_acc_7_29,q_tmp_7_29);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_8_12 = _mm256_add_pd(q_acc_8_12,q_tmp_8_12);
                   q_acc_8_13 = _mm256_add_pd(q_acc_8_13,q_tmp_8_13);
                   q_acc_8_14 = _mm256_add_pd(q_acc_8_14,q_tmp_8_14);
                   q_acc_8_15 = _mm256_add_pd(q_acc_8_15,q_tmp_8_15);
                   q_acc_8_16 = _mm256_add_pd(q_acc_8_16,q_tmp_8_16);
                   q_acc_8_17 = _mm256_add_pd(q_acc_8_17,q_tmp_8_17);
                   q_acc_8_18 = _mm256_add_pd(q_acc_8_18,q_tmp_8_18);
                   q_acc_8_19 = _mm256_add_pd(q_acc_8_19,q_tmp_8_19);
                   q_acc_8_20 = _mm256_add_pd(q_acc_8_20,q_tmp_8_20);
                   q_acc_8_21 = _mm256_add_pd(q_acc_8_21,q_tmp_8_21);
                   q_acc_8_22 = _mm256_add_pd(q_acc_8_22,q_tmp_8_22);
                   q_acc_8_23 = _mm256_add_pd(q_acc_8_23,q_tmp_8_23);
                   q_acc_8_24 = _mm256_add_pd(q_acc_8_24,q_tmp_8_24);
                   q_acc_8_25 = _mm256_add_pd(q_acc_8_25,q_tmp_8_25);
                   q_acc_8_26 = _mm256_add_pd(q_acc_8_26,q_tmp_8_26);
                   q_acc_8_27 = _mm256_add_pd(q_acc_8_27,q_tmp_8_27);
                   q_acc_8_28 = _mm256_add_pd(q_acc_8_28,q_tmp_8_28);
                   q_acc_8_29 = _mm256_add_pd(q_acc_8_29,q_tmp_8_29);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_9_12 = _mm256_add_pd(q_acc_9_12,q_tmp_9_12);
                   q_acc_9_13 = _mm256_add_pd(q_acc_9_13,q_tmp_9_13);
                   q_acc_9_14 = _mm256_add_pd(q_acc_9_14,q_tmp_9_14);
                   q_acc_9_15 = _mm256_add_pd(q_acc_9_15,q_tmp_9_15);
                   q_acc_9_16 = _mm256_add_pd(q_acc_9_16,q_tmp_9_16);
                   q_acc_9_17 = _mm256_add_pd(q_acc_9_17,q_tmp_9_17);
                   q_acc_9_18 = _mm256_add_pd(q_acc_9_18,q_tmp_9_18);
                   q_acc_9_19 = _mm256_add_pd(q_acc_9_19,q_tmp_9_19);
                   q_acc_9_20 = _mm256_add_pd(q_acc_9_20,q_tmp_9_20);
                   q_acc_9_21 = _mm256_add_pd(q_acc_9_21,q_tmp_9_21);
                   q_acc_9_22 = _mm256_add_pd(q_acc_9_22,q_tmp_9_22);
                   q_acc_9_23 = _mm256_add_pd(q_acc_9_23,q_tmp_9_23);
                   q_acc_9_24 = _mm256_add_pd(q_acc_9_24,q_tmp_9_24);
                   q_acc_9_25 = _mm256_add_pd(q_acc_9_25,q_tmp_9_25);
                   q_acc_9_26 = _mm256_add_pd(q_acc_9_26,q_tmp_9_26);
                   q_acc_9_27 = _mm256_add_pd(q_acc_9_27,q_tmp_9_27);
                   q_acc_9_28 = _mm256_add_pd(q_acc_9_28,q_tmp_9_28);
                   q_acc_9_29 = _mm256_add_pd(q_acc_9_29,q_tmp_9_29);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_10_12 = _mm256_add_pd(q_acc_10_12,q_tmp_10_12);
                   q_acc_10_13 = _mm256_add_pd(q_acc_10_13,q_tmp_10_13);
                   q_acc_10_14 = _mm256_add_pd(q_acc_10_14,q_tmp_10_14);
                   q_acc_10_15 = _mm256_add_pd(q_acc_10_15,q_tmp_10_15);
                   q_acc_10_16 = _mm256_add_pd(q_acc_10_16,q_tmp_10_16);
                   q_acc_10_17 = _mm256_add_pd(q_acc_10_17,q_tmp_10_17);
                   q_acc_10_18 = _mm256_add_pd(q_acc_10_18,q_tmp_10_18);
                   q_acc_10_19 = _mm256_add_pd(q_acc_10_19,q_tmp_10_19);
                   q_acc_10_20 = _mm256_add_pd(q_acc_10_20,q_tmp_10_20);
                   q_acc_10_21 = _mm256_add_pd(q_acc_10_21,q_tmp_10_21);
                   q_acc_10_22 = _mm256_add_pd(q_acc_10_22,q_tmp_10_22);
                   q_acc_10_23 = _mm256_add_pd(q_acc_10_23,q_tmp_10_23);
                   q_acc_10_24 = _mm256_add_pd(q_acc_10_24,q_tmp_10_24);
                   q_acc_10_25 = _mm256_add_pd(q_acc_10_25,q_tmp_10_25);
                   q_acc_10_26 = _mm256_add_pd(q_acc_10_26,q_tmp_10_26);
                   q_acc_10_27 = _mm256_add_pd(q_acc_10_27,q_tmp_10_27);
                   q_acc_10_28 = _mm256_add_pd(q_acc_10_28,q_tmp_10_28);
                   q_acc_10_29 = _mm256_add_pd(q_acc_10_29,q_tmp_10_29);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_11_12 = _mm256_add_pd(q_acc_11_12,q_tmp_11_12);
                   q_acc_11_13 = _mm256_add_pd(q_acc_11_13,q_tmp_11_13);
                   q_acc_11_14 = _mm256_add_pd(q_acc_11_14,q_tmp_11_14);
                   q_acc_11_15 = _mm256_add_pd(q_acc_11_15,q_tmp_11_15);
                   q_acc_11_16 = _mm256_add_pd(q_acc_11_16,q_tmp_11_16);
                   q_acc_11_17 = _mm256_add_pd(q_acc_11_17,q_tmp_11_17);
                   q_acc_11_18 = _mm256_add_pd(q_acc_11_18,q_tmp_11_18);
                   q_acc_11_19 = _mm256_add_pd(q_acc_11_19,q_tmp_11_19);
                   q_acc_11_20 = _mm256_add_pd(q_acc_11_20,q_tmp_11_20);
                   q_acc_11_21 = _mm256_add_pd(q_acc_11_21,q_tmp_11_21);
                   q_acc_11_22 = _mm256_add_pd(q_acc_11_22,q_tmp_11_22);
                   q_acc_11_23 = _mm256_add_pd(q_acc_11_23,q_tmp_11_23);
                   q_acc_11_24 = _mm256_add_pd(q_acc_11_24,q_tmp_11_24);
                   q_acc_11_25 = _mm256_add_pd(q_acc_11_25,q_tmp_11_25);
                   q_acc_11_26 = _mm256_add_pd(q_acc_11_26,q_tmp_11_26);
                   q_acc_11_27 = _mm256_add_pd(q_acc_11_27,q_tmp_11_27);
                   q_acc_11_28 = _mm256_add_pd(q_acc_11_28,q_tmp_11_28);
                   q_acc_11_29 = _mm256_add_pd(q_acc_11_29,q_tmp_11_29);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_12_13 = _mm256_add_pd(q_acc_12_13,q_tmp_12_13);
                   q_acc_12_14 = _mm256_add_pd(q_acc_12_14,q_tmp_12_14);
                   q_acc_12_15 = _mm256_add_pd(q_acc_12_15,q_tmp_12_15);
                   q_acc_12_16 = _mm256_add_pd(q_acc_12_16,q_tmp_12_16);
                   q_acc_12_17 = _mm256_add_pd(q_acc_12_17,q_tmp_12_17);
                   q_acc_12_18 = _mm256_add_pd(q_acc_12_18,q_tmp_12_18);
                   q_acc_12_19 = _mm256_add_pd(q_acc_12_19,q_tmp_12_19);
                   q_acc_12_20 = _mm256_add_pd(q_acc_12_20,q_tmp_12_20);
                   q_acc_12_21 = _mm256_add_pd(q_acc_12_21,q_tmp_12_21);
                   q_acc_12_22 = _mm256_add_pd(q_acc_12_22,q_tmp_12_22);
                   q_acc_12_23 = _mm256_add_pd(q_acc_12_23,q_tmp_12_23);
                   q_acc_12_24 = _mm256_add_pd(q_acc_12_24,q_tmp_12_24);
                   q_acc_12_25 = _mm256_add_pd(q_acc_12_25,q_tmp_12_25);
                   q_acc_12_26 = _mm256_add_pd(q_acc_12_26,q_tmp_12_26);
                   q_acc_12_27 = _mm256_add_pd(q_acc_12_27,q_tmp_12_27);
                   q_acc_12_28 = _mm256_add_pd(q_acc_12_28,q_tmp_12_28);
                   q_acc_12_29 = _mm256_add_pd(q_acc_12_29,q_tmp_12_29);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_13_14 = _mm256_add_pd(q_acc_13_14,q_tmp_13_14);
                   q_acc_13_15 = _mm256_add_pd(q_acc_13_15,q_tmp_13_15);
                   q_acc_13_16 = _mm256_add_pd(q_acc_13_16,q_tmp_13_16);
                   q_acc_13_17 = _mm256_add_pd(q_acc_13_17,q_tmp_13_17);
                   q_acc_13_18 = _mm256_add_pd(q_acc_13_18,q_tmp_13_18);
                   q_acc_13_19 = _mm256_add_pd(q_acc_13_19,q_tmp_13_19);
                   q_acc_13_20 = _mm256_add_pd(q_acc_13_20,q_tmp_13_20);
                   q_acc_13_21 = _mm256_add_pd(q_acc_13_21,q_tmp_13_21);
                   q_acc_13_22 = _mm256_add_pd(q_acc_13_22,q_tmp_13_22);
                   q_acc_13_23 = _mm256_add_pd(q_acc_13_23,q_tmp_13_23);
                   q_acc_13_24 = _mm256_add_pd(q_acc_13_24,q_tmp_13_24);
                   q_acc_13_25 = _mm256_add_pd(q_acc_13_25,q_tmp_13_25);
                   q_acc_13_26 = _mm256_add_pd(q_acc_13_26,q_tmp_13_26);
                   q_acc_13_27 = _mm256_add_pd(q_acc_13_27,q_tmp_13_27);
                   q_acc_13_28 = _mm256_add_pd(q_acc_13_28,q_tmp_13_28);
                   q_acc_13_29 = _mm256_add_pd(q_acc_13_29,q_tmp_13_29);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_14_15 = _mm256_add_pd(q_acc_14_15,q_tmp_14_15);
                   q_acc_14_16 = _mm256_add_pd(q_acc_14_16,q_tmp_14_16);
                   q_acc_14_17 = _mm256_add_pd(q_acc_14_17,q_tmp_14_17);
                   q_acc_14_18 = _mm256_add_pd(q_acc_14_18,q_tmp_14_18);
                   q_acc_14_19 = _mm256_add_pd(q_acc_14_19,q_tmp_14_19);
                   q_acc_14_20 = _mm256_add_pd(q_acc_14_20,q_tmp_14_20);
                   q_acc_14_21 = _mm256_add_pd(q_acc_14_21,q_tmp_14_21);
                   q_acc_14_22 = _mm256_add_pd(q_acc_14_22,q_tmp_14_22);
                   q_acc_14_23 = _mm256_add_pd(q_acc_14_23,q_tmp_14_23);
                   q_acc_14_24 = _mm256_add_pd(q_acc_14_24,q_tmp_14_24);
                   q_acc_14_25 = _mm256_add_pd(q_acc_14_25,q_tmp_14_25);
                   q_acc_14_26 = _mm256_add_pd(q_acc_14_26,q_tmp_14_26);
                   q_acc_14_27 = _mm256_add_pd(q_acc_14_27,q_tmp_14_27);
                   q_acc_14_28 = _mm256_add_pd(q_acc_14_28,q_tmp_14_28);
                   q_acc_14_29 = _mm256_add_pd(q_acc_14_29,q_tmp_14_29);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_15_16 = _mm256_add_pd(q_acc_15_16,q_tmp_15_16);
                   q_acc_15_17 = _mm256_add_pd(q_acc_15_17,q_tmp_15_17);
                   q_acc_15_18 = _mm256_add_pd(q_acc_15_18,q_tmp_15_18);
                   q_acc_15_19 = _mm256_add_pd(q_acc_15_19,q_tmp_15_19);
                   q_acc_15_20 = _mm256_add_pd(q_acc_15_20,q_tmp_15_20);
                   q_acc_15_21 = _mm256_add_pd(q_acc_15_21,q_tmp_15_21);
                   q_acc_15_22 = _mm256_add_pd(q_acc_15_22,q_tmp_15_22);
                   q_acc_15_23 = _mm256_add_pd(q_acc_15_23,q_tmp_15_23);
                   q_acc_15_24 = _mm256_add_pd(q_acc_15_24,q_tmp_15_24);
                   q_acc_15_25 = _mm256_add_pd(q_acc_15_25,q_tmp_15_25);
                   q_acc_15_26 = _mm256_add_pd(q_acc_15_26,q_tmp_15_26);
                   q_acc_15_27 = _mm256_add_pd(q_acc_15_27,q_tmp_15_27);
                   q_acc_15_28 = _mm256_add_pd(q_acc_15_28,q_tmp_15_28);
                   q_acc_15_29 = _mm256_add_pd(q_acc_15_29,q_tmp_15_29);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_16_17 = _mm256_add_pd(q_acc_16_17,q_tmp_16_17);
                   q_acc_16_18 = _mm256_add_pd(q_acc_16_18,q_tmp_16_18);
                   q_acc_16_19 = _mm256_add_pd(q_acc_16_19,q_tmp_16_19);
                   q_acc_16_20 = _mm256_add_pd(q_acc_16_20,q_tmp_16_20);
                   q_acc_16_21 = _mm256_add_pd(q_acc_16_21,q_tmp_16_21);
                   q_acc_16_22 = _mm256_add_pd(q_acc_16_22,q_tmp_16_22);
                   q_acc_16_23 = _mm256_add_pd(q_acc_16_23,q_tmp_16_23);
                   q_acc_16_24 = _mm256_add_pd(q_acc_16_24,q_tmp_16_24);
                   q_acc_16_25 = _mm256_add_pd(q_acc_16_25,q_tmp_16_25);
                   q_acc_16_26 = _mm256_add_pd(q_acc_16_26,q_tmp_16_26);
                   q_acc_16_27 = _mm256_add_pd(q_acc_16_27,q_tmp_16_27);
                   q_acc_16_28 = _mm256_add_pd(q_acc_16_28,q_tmp_16_28);
                   q_acc_16_29 = _mm256_add_pd(q_acc_16_29,q_tmp_16_29);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_17_18 = _mm256_add_pd(q_acc_17_18,q_tmp_17_18);
                   q_acc_17_19 = _mm256_add_pd(q_acc_17_19,q_tmp_17_19);
                   q_acc_17_20 = _mm256_add_pd(q_acc_17_20,q_tmp_17_20);
                   q_acc_17_21 = _mm256_add_pd(q_acc_17_21,q_tmp_17_21);
                   q_acc_17_22 = _mm256_add_pd(q_acc_17_22,q_tmp_17_22);
                   q_acc_17_23 = _mm256_add_pd(q_acc_17_23,q_tmp_17_23);
                   q_acc_17_24 = _mm256_add_pd(q_acc_17_24,q_tmp_17_24);
                   q_acc_17_25 = _mm256_add_pd(q_acc_17_25,q_tmp_17_25);
                   q_acc_17_26 = _mm256_add_pd(q_acc_17_26,q_tmp_17_26);
                   q_acc_17_27 = _mm256_add_pd(q_acc_17_27,q_tmp_17_27);
                   q_acc_17_28 = _mm256_add_pd(q_acc_17_28,q_tmp_17_28);
                   q_acc_17_29 = _mm256_add_pd(q_acc_17_29,q_tmp_17_29);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_18_19 = _mm256_add_pd(q_acc_18_19,q_tmp_18_19);
                   q_acc_18_20 = _mm256_add_pd(q_acc_18_20,q_tmp_18_20);
                   q_acc_18_21 = _mm256_add_pd(q_acc_18_21,q_tmp_18_21);
                   q_acc_18_22 = _mm256_add_pd(q_acc_18_22,q_tmp_18_22);
                   q_acc_18_23 = _mm256_add_pd(q_acc_18_23,q_tmp_18_23);
                   q_acc_18_24 = _mm256_add_pd(q_acc_18_24,q_tmp_18_24);
                   q_acc_18_25 = _mm256_add_pd(q_acc_18_25,q_tmp_18_25);
                   q_acc_18_26 = _mm256_add_pd(q_acc_18_26,q_tmp_18_26);
                   q_acc_18_27 = _mm256_add_pd(q_acc_18_27,q_tmp_18_27);
                   q_acc_18_28 = _mm256_add_pd(q_acc_18_28,q_tmp_18_28);
                   q_acc_18_29 = _mm256_add_pd(q_acc_18_29,q_tmp_18_29);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_19_20 = _mm256_add_pd(q_acc_19_20,q_tmp_19_20);
                   q_acc_19_21 = _mm256_add_pd(q_acc_19_21,q_tmp_19_21);
                   q_acc_19_22 = _mm256_add_pd(q_acc_19_22,q_tmp_19_22);
                   q_acc_19_23 = _mm256_add_pd(q_acc_19_23,q_tmp_19_23);
                   q_acc_19_24 = _mm256_add_pd(q_acc_19_24,q_tmp_19_24);
                   q_acc_19_25 = _mm256_add_pd(q_acc_19_25,q_tmp_19_25);
                   q_acc_19_26 = _mm256_add_pd(q_acc_19_26,q_tmp_19_26);
                   q_acc_19_27 = _mm256_add_pd(q_acc_19_27,q_tmp_19_27);
                   q_acc_19_28 = _mm256_add_pd(q_acc_19_28,q_tmp_19_28);
                   q_acc_19_29 = _mm256_add_pd(q_acc_19_29,q_tmp_19_29);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_20_21 = _mm256_add_pd(q_acc_20_21,q_tmp_20_21);
                   q_acc_20_22 = _mm256_add_pd(q_acc_20_22,q_tmp_20_22);
                   q_acc_20_23 = _mm256_add_pd(q_acc_20_23,q_tmp_20_23);
                   q_acc_20_24 = _mm256_add_pd(q_acc_20_24,q_tmp_20_24);
                   q_acc_20_25 = _mm256_add_pd(q_acc_20_25,q_tmp_20_25);
                   q_acc_20_26 = _mm256_add_pd(q_acc_20_26,q_tmp_20_26);
                   q_acc_20_27 = _mm256_add_pd(q_acc_20_27,q_tmp_20_27);
                   q_acc_20_28 = _mm256_add_pd(q_acc_20_28,q_tmp_20_28);
                   q_acc_20_29 = _mm256_add_pd(q_acc_20_29,q_tmp_20_29);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_21_22 = _mm256_add_pd(q_acc_21_22,q_tmp_21_22);
                   q_acc_21_23 = _mm256_add_pd(q_acc_21_23,q_tmp_21_23);
                   q_acc_21_24 = _mm256_add_pd(q_acc_21_24,q_tmp_21_24);
                   q_acc_21_25 = _mm256_add_pd(q_acc_21_25,q_tmp_21_25);
                   q_acc_21_26 = _mm256_add_pd(q_acc_21_26,q_tmp_21_26);
                   q_acc_21_27 = _mm256_add_pd(q_acc_21_27,q_tmp_21_27);
                   q_acc_21_28 = _mm256_add_pd(q_acc_21_28,q_tmp_21_28);
                   q_acc_21_29 = _mm256_add_pd(q_acc_21_29,q_tmp_21_29);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_22_23 = _mm256_add_pd(q_acc_22_23,q_tmp_22_23);
                   q_acc_22_24 = _mm256_add_pd(q_acc_22_24,q_tmp_22_24);
                   q_acc_22_25 = _mm256_add_pd(q_acc_22_25,q_tmp_22_25);
                   q_acc_22_26 = _mm256_add_pd(q_acc_22_26,q_tmp_22_26);
                   q_acc_22_27 = _mm256_add_pd(q_acc_22_27,q_tmp_22_27);
                   q_acc_22_28 = _mm256_add_pd(q_acc_22_28,q_tmp_22_28);
                   q_acc_22_29 = _mm256_add_pd(q_acc_22_29,q_tmp_22_29);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_23_24 = _mm256_add_pd(q_acc_23_24,q_tmp_23_24);
                   q_acc_23_25 = _mm256_add_pd(q_acc_23_25,q_tmp_23_25);
                   q_acc_23_26 = _mm256_add_pd(q_acc_23_26,q_tmp_23_26);
                   q_acc_23_27 = _mm256_add_pd(q_acc_23_27,q_tmp_23_27);
                   q_acc_23_28 = _mm256_add_pd(q_acc_23_28,q_tmp_23_28);
                   q_acc_23_29 = _mm256_add_pd(q_acc_23_29,q_tmp_23_29);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_24_25 = _mm256_add_pd(q_acc_24_25,q_tmp_24_25);
                   q_acc_24_26 = _mm256_add_pd(q_acc_24_26,q_tmp_24_26);
                   q_acc_24_27 = _mm256_add_pd(q_acc_24_27,q_tmp_24_27);
                   q_acc_24_28 = _mm256_add_pd(q_acc_24_28,q_tmp_24_28);
                   q_acc_24_29 = _mm256_add_pd(q_acc_24_29,q_tmp_24_29);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_25_26 = _mm256_add_pd(q_acc_25_26,q_tmp_25_26);
                   q_acc_25_27 = _mm256_add_pd(q_acc_25_27,q_tmp_25_27);
                   q_acc_25_28 = _mm256_add_pd(q_acc_25_28,q_tmp_25_28);
                   q_acc_25_29 = _mm256_add_pd(q_acc_25_29,q_tmp_25_29);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_26_27 = _mm256_add_pd(q_acc_26_27,q_tmp_26_27);
                   q_acc_26_28 = _mm256_add_pd(q_acc_26_28,q_tmp_26_28);
                   q_acc_26_29 = _mm256_add_pd(q_acc_26_29,q_tmp_26_29);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_27_28 = _mm256_add_pd(q_acc_27_28,q_tmp_27_28);
                   q_acc_27_29 = _mm256_add_pd(q_acc_27_29,q_tmp_27_29);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_28_29 = _mm256_add_pd(q_acc_28_29,q_tmp_28_29);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_12,src_dof_12)),_mm256_mul_pd(q_acc_0_13,src_dof_13)),_mm256_mul_pd(q_acc_0_14,src_dof_14)),_mm256_mul_pd(q_acc_0_15,src_dof_15)),_mm256_mul_pd(q_acc_0_16,src_dof_16)),_mm256_mul_pd(q_acc_0_17,src_dof_17)),_mm256_mul_pd(q_acc_0_18,src_dof_18)),_mm256_mul_pd(q_acc_0_19,src_dof_19)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_20,src_dof_20)),_mm256_mul_pd(q_acc_0_21,src_dof_21)),_mm256_mul_pd(q_acc_0_22,src_dof_22)),_mm256_mul_pd(q_acc_0_23,src_dof_23)),_mm256_mul_pd(q_acc_0_24,src_dof_24)),_mm256_mul_pd(q_acc_0_25,src_dof_25)),_mm256_mul_pd(q_acc_0_26,src_dof_26)),_mm256_mul_pd(q_acc_0_27,src_dof_27)),_mm256_mul_pd(q_acc_0_28,src_dof_28)),_mm256_mul_pd(q_acc_0_29,src_dof_29)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_12,src_dof_12)),_mm256_mul_pd(q_acc_1_13,src_dof_13)),_mm256_mul_pd(q_acc_1_14,src_dof_14)),_mm256_mul_pd(q_acc_1_15,src_dof_15)),_mm256_mul_pd(q_acc_1_16,src_dof_16)),_mm256_mul_pd(q_acc_1_17,src_dof_17)),_mm256_mul_pd(q_acc_1_18,src_dof_18)),_mm256_mul_pd(q_acc_1_19,src_dof_19)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_20,src_dof_20)),_mm256_mul_pd(q_acc_1_21,src_dof_21)),_mm256_mul_pd(q_acc_1_22,src_dof_22)),_mm256_mul_pd(q_acc_1_23,src_dof_23)),_mm256_mul_pd(q_acc_1_24,src_dof_24)),_mm256_mul_pd(q_acc_1_25,src_dof_25)),_mm256_mul_pd(q_acc_1_26,src_dof_26)),_mm256_mul_pd(q_acc_1_27,src_dof_27)),_mm256_mul_pd(q_acc_1_28,src_dof_28)),_mm256_mul_pd(q_acc_1_29,src_dof_29)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_12,src_dof_12)),_mm256_mul_pd(q_acc_2_13,src_dof_13)),_mm256_mul_pd(q_acc_2_14,src_dof_14)),_mm256_mul_pd(q_acc_2_15,src_dof_15)),_mm256_mul_pd(q_acc_2_16,src_dof_16)),_mm256_mul_pd(q_acc_2_17,src_dof_17)),_mm256_mul_pd(q_acc_2_18,src_dof_18)),_mm256_mul_pd(q_acc_2_19,src_dof_19)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_20,src_dof_20)),_mm256_mul_pd(q_acc_2_21,src_dof_21)),_mm256_mul_pd(q_acc_2_22,src_dof_22)),_mm256_mul_pd(q_acc_2_23,src_dof_23)),_mm256_mul_pd(q_acc_2_24,src_dof_24)),_mm256_mul_pd(q_acc_2_25,src_dof_25)),_mm256_mul_pd(q_acc_2_26,src_dof_26)),_mm256_mul_pd(q_acc_2_27,src_dof_27)),_mm256_mul_pd(q_acc_2_28,src_dof_28)),_mm256_mul_pd(q_acc_2_29,src_dof_29)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_12,src_dof_12)),_mm256_mul_pd(q_acc_3_13,src_dof_13)),_mm256_mul_pd(q_acc_3_14,src_dof_14)),_mm256_mul_pd(q_acc_3_15,src_dof_15)),_mm256_mul_pd(q_acc_3_16,src_dof_16)),_mm256_mul_pd(q_acc_3_17,src_dof_17)),_mm256_mul_pd(q_acc_3_18,src_dof_18)),_mm256_mul_pd(q_acc_3_19,src_dof_19)),_mm256_mul_pd(q_acc_3_20,src_dof_20)),_mm256_mul_pd(q_acc_3_21,src_dof_21)),_mm256_mul_pd(q_acc_3_22,src_dof_22)),_mm256_mul_pd(q_acc_3_23,src_dof_23)),_mm256_mul_pd(q_acc_3_24,src_dof_24)),_mm256_mul_pd(q_acc_3_25,src_dof_25)),_mm256_mul_pd(q_acc_3_26,src_dof_26)),_mm256_mul_pd(q_acc_3_27,src_dof_27)),_mm256_mul_pd(q_acc_3_28,src_dof_28)),_mm256_mul_pd(q_acc_3_29,src_dof_29)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_12,src_dof_12)),_mm256_mul_pd(q_acc_4_13,src_dof_13)),_mm256_mul_pd(q_acc_4_14,src_dof_14)),_mm256_mul_pd(q_acc_4_15,src_dof_15)),_mm256_mul_pd(q_acc_4_16,src_dof_16)),_mm256_mul_pd(q_acc_4_17,src_dof_17)),_mm256_mul_pd(q_acc_4_18,src_dof_18)),_mm256_mul_pd(q_acc_4_19,src_dof_19)),_mm256_mul_pd(q_acc_4_20,src_dof_20)),_mm256_mul_pd(q_acc_4_21,src_dof_21)),_mm256_mul_pd(q_acc_4_22,src_dof_22)),_mm256_mul_pd(q_acc_4_23,src_dof_23)),_mm256_mul_pd(q_acc_4_24,src_dof_24)),_mm256_mul_pd(q_acc_4_25,src_dof_25)),_mm256_mul_pd(q_acc_4_26,src_dof_26)),_mm256_mul_pd(q_acc_4_27,src_dof_27)),_mm256_mul_pd(q_acc_4_28,src_dof_28)),_mm256_mul_pd(q_acc_4_29,src_dof_29)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_12,src_dof_12)),_mm256_mul_pd(q_acc_5_13,src_dof_13)),_mm256_mul_pd(q_acc_5_14,src_dof_14)),_mm256_mul_pd(q_acc_5_15,src_dof_15)),_mm256_mul_pd(q_acc_5_16,src_dof_16)),_mm256_mul_pd(q_acc_5_17,src_dof_17)),_mm256_mul_pd(q_acc_5_18,src_dof_18)),_mm256_mul_pd(q_acc_5_19,src_dof_19)),_mm256_mul_pd(q_acc_5_20,src_dof_20)),_mm256_mul_pd(q_acc_5_21,src_dof_21)),_mm256_mul_pd(q_acc_5_22,src_dof_22)),_mm256_mul_pd(q_acc_5_23,src_dof_23)),_mm256_mul_pd(q_acc_5_24,src_dof_24)),_mm256_mul_pd(q_acc_5_25,src_dof_25)),_mm256_mul_pd(q_acc_5_26,src_dof_26)),_mm256_mul_pd(q_acc_5_27,src_dof_27)),_mm256_mul_pd(q_acc_5_28,src_dof_28)),_mm256_mul_pd(q_acc_5_29,src_dof_29)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_12,src_dof_12)),_mm256_mul_pd(q_acc_6_13,src_dof_13)),_mm256_mul_pd(q_acc_6_14,src_dof_14)),_mm256_mul_pd(q_acc_6_15,src_dof_15)),_mm256_mul_pd(q_acc_6_16,src_dof_16)),_mm256_mul_pd(q_acc_6_17,src_dof_17)),_mm256_mul_pd(q_acc_6_18,src_dof_18)),_mm256_mul_pd(q_acc_6_19,src_dof_19)),_mm256_mul_pd(q_acc_6_20,src_dof_20)),_mm256_mul_pd(q_acc_6_21,src_dof_21)),_mm256_mul_pd(q_acc_6_22,src_dof_22)),_mm256_mul_pd(q_acc_6_23,src_dof_23)),_mm256_mul_pd(q_acc_6_24,src_dof_24)),_mm256_mul_pd(q_acc_6_25,src_dof_25)),_mm256_mul_pd(q_acc_6_26,src_dof_26)),_mm256_mul_pd(q_acc_6_27,src_dof_27)),_mm256_mul_pd(q_acc_6_28,src_dof_28)),_mm256_mul_pd(q_acc_6_29,src_dof_29)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_12,src_dof_12)),_mm256_mul_pd(q_acc_7_13,src_dof_13)),_mm256_mul_pd(q_acc_7_14,src_dof_14)),_mm256_mul_pd(q_acc_7_15,src_dof_15)),_mm256_mul_pd(q_acc_7_16,src_dof_16)),_mm256_mul_pd(q_acc_7_17,src_dof_17)),_mm256_mul_pd(q_acc_7_18,src_dof_18)),_mm256_mul_pd(q_acc_7_19,src_dof_19)),_mm256_mul_pd(q_acc_7_20,src_dof_20)),_mm256_mul_pd(q_acc_7_21,src_dof_21)),_mm256_mul_pd(q_acc_7_22,src_dof_22)),_mm256_mul_pd(q_acc_7_23,src_dof_23)),_mm256_mul_pd(q_acc_7_24,src_dof_24)),_mm256_mul_pd(q_acc_7_25,src_dof_25)),_mm256_mul_pd(q_acc_7_26,src_dof_26)),_mm256_mul_pd(q_acc_7_27,src_dof_27)),_mm256_mul_pd(q_acc_7_28,src_dof_28)),_mm256_mul_pd(q_acc_7_29,src_dof_29)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_12,src_dof_12)),_mm256_mul_pd(q_acc_8_13,src_dof_13)),_mm256_mul_pd(q_acc_8_14,src_dof_14)),_mm256_mul_pd(q_acc_8_15,src_dof_15)),_mm256_mul_pd(q_acc_8_16,src_dof_16)),_mm256_mul_pd(q_acc_8_17,src_dof_17)),_mm256_mul_pd(q_acc_8_18,src_dof_18)),_mm256_mul_pd(q_acc_8_19,src_dof_19)),_mm256_mul_pd(q_acc_8_20,src_dof_20)),_mm256_mul_pd(q_acc_8_21,src_dof_21)),_mm256_mul_pd(q_acc_8_22,src_dof_22)),_mm256_mul_pd(q_acc_8_23,src_dof_23)),_mm256_mul_pd(q_acc_8_24,src_dof_24)),_mm256_mul_pd(q_acc_8_25,src_dof_25)),_mm256_mul_pd(q_acc_8_26,src_dof_26)),_mm256_mul_pd(q_acc_8_27,src_dof_27)),_mm256_mul_pd(q_acc_8_28,src_dof_28)),_mm256_mul_pd(q_acc_8_29,src_dof_29)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_12,src_dof_12)),_mm256_mul_pd(q_acc_9_13,src_dof_13)),_mm256_mul_pd(q_acc_9_14,src_dof_14)),_mm256_mul_pd(q_acc_9_15,src_dof_15)),_mm256_mul_pd(q_acc_9_16,src_dof_16)),_mm256_mul_pd(q_acc_9_17,src_dof_17)),_mm256_mul_pd(q_acc_9_18,src_dof_18)),_mm256_mul_pd(q_acc_9_19,src_dof_19)),_mm256_mul_pd(q_acc_9_20,src_dof_20)),_mm256_mul_pd(q_acc_9_21,src_dof_21)),_mm256_mul_pd(q_acc_9_22,src_dof_22)),_mm256_mul_pd(q_acc_9_23,src_dof_23)),_mm256_mul_pd(q_acc_9_24,src_dof_24)),_mm256_mul_pd(q_acc_9_25,src_dof_25)),_mm256_mul_pd(q_acc_9_26,src_dof_26)),_mm256_mul_pd(q_acc_9_27,src_dof_27)),_mm256_mul_pd(q_acc_9_28,src_dof_28)),_mm256_mul_pd(q_acc_9_29,src_dof_29)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_10_12,src_dof_12)),_mm256_mul_pd(q_acc_10_13,src_dof_13)),_mm256_mul_pd(q_acc_10_14,src_dof_14)),_mm256_mul_pd(q_acc_10_15,src_dof_15)),_mm256_mul_pd(q_acc_10_16,src_dof_16)),_mm256_mul_pd(q_acc_10_17,src_dof_17)),_mm256_mul_pd(q_acc_10_18,src_dof_18)),_mm256_mul_pd(q_acc_10_19,src_dof_19)),_mm256_mul_pd(q_acc_10_20,src_dof_20)),_mm256_mul_pd(q_acc_10_21,src_dof_21)),_mm256_mul_pd(q_acc_10_22,src_dof_22)),_mm256_mul_pd(q_acc_10_23,src_dof_23)),_mm256_mul_pd(q_acc_10_24,src_dof_24)),_mm256_mul_pd(q_acc_10_25,src_dof_25)),_mm256_mul_pd(q_acc_10_26,src_dof_26)),_mm256_mul_pd(q_acc_10_27,src_dof_27)),_mm256_mul_pd(q_acc_10_28,src_dof_28)),_mm256_mul_pd(q_acc_10_29,src_dof_29)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_11_12,src_dof_12)),_mm256_mul_pd(q_acc_11_13,src_dof_13)),_mm256_mul_pd(q_acc_11_14,src_dof_14)),_mm256_mul_pd(q_acc_11_15,src_dof_15)),_mm256_mul_pd(q_acc_11_16,src_dof_16)),_mm256_mul_pd(q_acc_11_17,src_dof_17)),_mm256_mul_pd(q_acc_11_18,src_dof_18)),_mm256_mul_pd(q_acc_11_19,src_dof_19)),_mm256_mul_pd(q_acc_11_20,src_dof_20)),_mm256_mul_pd(q_acc_11_21,src_dof_21)),_mm256_mul_pd(q_acc_11_22,src_dof_22)),_mm256_mul_pd(q_acc_11_23,src_dof_23)),_mm256_mul_pd(q_acc_11_24,src_dof_24)),_mm256_mul_pd(q_acc_11_25,src_dof_25)),_mm256_mul_pd(q_acc_11_26,src_dof_26)),_mm256_mul_pd(q_acc_11_27,src_dof_27)),_mm256_mul_pd(q_acc_11_28,src_dof_28)),_mm256_mul_pd(q_acc_11_29,src_dof_29)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                const __m256d elMatVec_12 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_12,src_dof_0),_mm256_mul_pd(q_acc_10_12,src_dof_10)),_mm256_mul_pd(q_acc_11_12,src_dof_11)),_mm256_mul_pd(q_acc_12_12,src_dof_12)),_mm256_mul_pd(q_acc_12_13,src_dof_13)),_mm256_mul_pd(q_acc_12_14,src_dof_14)),_mm256_mul_pd(q_acc_12_15,src_dof_15)),_mm256_mul_pd(q_acc_12_16,src_dof_16)),_mm256_mul_pd(q_acc_12_17,src_dof_17)),_mm256_mul_pd(q_acc_12_18,src_dof_18)),_mm256_mul_pd(q_acc_12_19,src_dof_19)),_mm256_mul_pd(q_acc_12_20,src_dof_20)),_mm256_mul_pd(q_acc_12_21,src_dof_21)),_mm256_mul_pd(q_acc_12_22,src_dof_22)),_mm256_mul_pd(q_acc_12_23,src_dof_23)),_mm256_mul_pd(q_acc_12_24,src_dof_24)),_mm256_mul_pd(q_acc_12_25,src_dof_25)),_mm256_mul_pd(q_acc_12_26,src_dof_26)),_mm256_mul_pd(q_acc_12_27,src_dof_27)),_mm256_mul_pd(q_acc_12_28,src_dof_28)),_mm256_mul_pd(q_acc_12_29,src_dof_29)),_mm256_mul_pd(q_acc_1_12,src_dof_1)),_mm256_mul_pd(q_acc_2_12,src_dof_2)),_mm256_mul_pd(q_acc_3_12,src_dof_3)),_mm256_mul_pd(q_acc_4_12,src_dof_4)),_mm256_mul_pd(q_acc_5_12,src_dof_5)),_mm256_mul_pd(q_acc_6_12,src_dof_6)),_mm256_mul_pd(q_acc_7_12,src_dof_7)),_mm256_mul_pd(q_acc_8_12,src_dof_8)),_mm256_mul_pd(q_acc_9_12,src_dof_9));
                const __m256d elMatVec_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_13,src_dof_0),_mm256_mul_pd(q_acc_10_13,src_dof_10)),_mm256_mul_pd(q_acc_11_13,src_dof_11)),_mm256_mul_pd(q_acc_12_13,src_dof_12)),_mm256_mul_pd(q_acc_13_13,src_dof_13)),_mm256_mul_pd(q_acc_13_14,src_dof_14)),_mm256_mul_pd(q_acc_13_15,src_dof_15)),_mm256_mul_pd(q_acc_13_16,src_dof_16)),_mm256_mul_pd(q_acc_13_17,src_dof_17)),_mm256_mul_pd(q_acc_13_18,src_dof_18)),_mm256_mul_pd(q_acc_13_19,src_dof_19)),_mm256_mul_pd(q_acc_13_20,src_dof_20)),_mm256_mul_pd(q_acc_13_21,src_dof_21)),_mm256_mul_pd(q_acc_13_22,src_dof_22)),_mm256_mul_pd(q_acc_13_23,src_dof_23)),_mm256_mul_pd(q_acc_13_24,src_dof_24)),_mm256_mul_pd(q_acc_13_25,src_dof_25)),_mm256_mul_pd(q_acc_13_26,src_dof_26)),_mm256_mul_pd(q_acc_13_27,src_dof_27)),_mm256_mul_pd(q_acc_13_28,src_dof_28)),_mm256_mul_pd(q_acc_13_29,src_dof_29)),_mm256_mul_pd(q_acc_1_13,src_dof_1)),_mm256_mul_pd(q_acc_2_13,src_dof_2)),_mm256_mul_pd(q_acc_3_13,src_dof_3)),_mm256_mul_pd(q_acc_4_13,src_dof_4)),_mm256_mul_pd(q_acc_5_13,src_dof_5)),_mm256_mul_pd(q_acc_6_13,src_dof_6)),_mm256_mul_pd(q_acc_7_13,src_dof_7)),_mm256_mul_pd(q_acc_8_13,src_dof_8)),_mm256_mul_pd(q_acc_9_13,src_dof_9));
                const __m256d elMatVec_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_14,src_dof_0),_mm256_mul_pd(q_acc_10_14,src_dof_10)),_mm256_mul_pd(q_acc_11_14,src_dof_11)),_mm256_mul_pd(q_acc_12_14,src_dof_12)),_mm256_mul_pd(q_acc_13_14,src_dof_13)),_mm256_mul_pd(q_acc_14_14,src_dof_14)),_mm256_mul_pd(q_acc_14_15,src_dof_15)),_mm256_mul_pd(q_acc_14_16,src_dof_16)),_mm256_mul_pd(q_acc_14_17,src_dof_17)),_mm256_mul_pd(q_acc_14_18,src_dof_18)),_mm256_mul_pd(q_acc_14_19,src_dof_19)),_mm256_mul_pd(q_acc_14_20,src_dof_20)),_mm256_mul_pd(q_acc_14_21,src_dof_21)),_mm256_mul_pd(q_acc_14_22,src_dof_22)),_mm256_mul_pd(q_acc_14_23,src_dof_23)),_mm256_mul_pd(q_acc_14_24,src_dof_24)),_mm256_mul_pd(q_acc_14_25,src_dof_25)),_mm256_mul_pd(q_acc_14_26,src_dof_26)),_mm256_mul_pd(q_acc_14_27,src_dof_27)),_mm256_mul_pd(q_acc_14_28,src_dof_28)),_mm256_mul_pd(q_acc_14_29,src_dof_29)),_mm256_mul_pd(q_acc_1_14,src_dof_1)),_mm256_mul_pd(q_acc_2_14,src_dof_2)),_mm256_mul_pd(q_acc_3_14,src_dof_3)),_mm256_mul_pd(q_acc_4_14,src_dof_4)),_mm256_mul_pd(q_acc_5_14,src_dof_5)),_mm256_mul_pd(q_acc_6_14,src_dof_6)),_mm256_mul_pd(q_acc_7_14,src_dof_7)),_mm256_mul_pd(q_acc_8_14,src_dof_8)),_mm256_mul_pd(q_acc_9_14,src_dof_9));
                const __m256d elMatVec_15 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_15,src_dof_0),_mm256_mul_pd(q_acc_10_15,src_dof_10)),_mm256_mul_pd(q_acc_11_15,src_dof_11)),_mm256_mul_pd(q_acc_12_15,src_dof_12)),_mm256_mul_pd(q_acc_13_15,src_dof_13)),_mm256_mul_pd(q_acc_14_15,src_dof_14)),_mm256_mul_pd(q_acc_15_15,src_dof_15)),_mm256_mul_pd(q_acc_15_16,src_dof_16)),_mm256_mul_pd(q_acc_15_17,src_dof_17)),_mm256_mul_pd(q_acc_15_18,src_dof_18)),_mm256_mul_pd(q_acc_15_19,src_dof_19)),_mm256_mul_pd(q_acc_15_20,src_dof_20)),_mm256_mul_pd(q_acc_15_21,src_dof_21)),_mm256_mul_pd(q_acc_15_22,src_dof_22)),_mm256_mul_pd(q_acc_15_23,src_dof_23)),_mm256_mul_pd(q_acc_15_24,src_dof_24)),_mm256_mul_pd(q_acc_15_25,src_dof_25)),_mm256_mul_pd(q_acc_15_26,src_dof_26)),_mm256_mul_pd(q_acc_15_27,src_dof_27)),_mm256_mul_pd(q_acc_15_28,src_dof_28)),_mm256_mul_pd(q_acc_15_29,src_dof_29)),_mm256_mul_pd(q_acc_1_15,src_dof_1)),_mm256_mul_pd(q_acc_2_15,src_dof_2)),_mm256_mul_pd(q_acc_3_15,src_dof_3)),_mm256_mul_pd(q_acc_4_15,src_dof_4)),_mm256_mul_pd(q_acc_5_15,src_dof_5)),_mm256_mul_pd(q_acc_6_15,src_dof_6)),_mm256_mul_pd(q_acc_7_15,src_dof_7)),_mm256_mul_pd(q_acc_8_15,src_dof_8)),_mm256_mul_pd(q_acc_9_15,src_dof_9));
                const __m256d elMatVec_16 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_16,src_dof_0),_mm256_mul_pd(q_acc_10_16,src_dof_10)),_mm256_mul_pd(q_acc_11_16,src_dof_11)),_mm256_mul_pd(q_acc_12_16,src_dof_12)),_mm256_mul_pd(q_acc_13_16,src_dof_13)),_mm256_mul_pd(q_acc_14_16,src_dof_14)),_mm256_mul_pd(q_acc_15_16,src_dof_15)),_mm256_mul_pd(q_acc_16_16,src_dof_16)),_mm256_mul_pd(q_acc_16_17,src_dof_17)),_mm256_mul_pd(q_acc_16_18,src_dof_18)),_mm256_mul_pd(q_acc_16_19,src_dof_19)),_mm256_mul_pd(q_acc_16_20,src_dof_20)),_mm256_mul_pd(q_acc_16_21,src_dof_21)),_mm256_mul_pd(q_acc_16_22,src_dof_22)),_mm256_mul_pd(q_acc_16_23,src_dof_23)),_mm256_mul_pd(q_acc_16_24,src_dof_24)),_mm256_mul_pd(q_acc_16_25,src_dof_25)),_mm256_mul_pd(q_acc_16_26,src_dof_26)),_mm256_mul_pd(q_acc_16_27,src_dof_27)),_mm256_mul_pd(q_acc_16_28,src_dof_28)),_mm256_mul_pd(q_acc_16_29,src_dof_29)),_mm256_mul_pd(q_acc_1_16,src_dof_1)),_mm256_mul_pd(q_acc_2_16,src_dof_2)),_mm256_mul_pd(q_acc_3_16,src_dof_3)),_mm256_mul_pd(q_acc_4_16,src_dof_4)),_mm256_mul_pd(q_acc_5_16,src_dof_5)),_mm256_mul_pd(q_acc_6_16,src_dof_6)),_mm256_mul_pd(q_acc_7_16,src_dof_7)),_mm256_mul_pd(q_acc_8_16,src_dof_8)),_mm256_mul_pd(q_acc_9_16,src_dof_9));
                const __m256d elMatVec_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_17,src_dof_0),_mm256_mul_pd(q_acc_10_17,src_dof_10)),_mm256_mul_pd(q_acc_11_17,src_dof_11)),_mm256_mul_pd(q_acc_12_17,src_dof_12)),_mm256_mul_pd(q_acc_13_17,src_dof_13)),_mm256_mul_pd(q_acc_14_17,src_dof_14)),_mm256_mul_pd(q_acc_15_17,src_dof_15)),_mm256_mul_pd(q_acc_16_17,src_dof_16)),_mm256_mul_pd(q_acc_17_17,src_dof_17)),_mm256_mul_pd(q_acc_17_18,src_dof_18)),_mm256_mul_pd(q_acc_17_19,src_dof_19)),_mm256_mul_pd(q_acc_17_20,src_dof_20)),_mm256_mul_pd(q_acc_17_21,src_dof_21)),_mm256_mul_pd(q_acc_17_22,src_dof_22)),_mm256_mul_pd(q_acc_17_23,src_dof_23)),_mm256_mul_pd(q_acc_17_24,src_dof_24)),_mm256_mul_pd(q_acc_17_25,src_dof_25)),_mm256_mul_pd(q_acc_17_26,src_dof_26)),_mm256_mul_pd(q_acc_17_27,src_dof_27)),_mm256_mul_pd(q_acc_17_28,src_dof_28)),_mm256_mul_pd(q_acc_17_29,src_dof_29)),_mm256_mul_pd(q_acc_1_17,src_dof_1)),_mm256_mul_pd(q_acc_2_17,src_dof_2)),_mm256_mul_pd(q_acc_3_17,src_dof_3)),_mm256_mul_pd(q_acc_4_17,src_dof_4)),_mm256_mul_pd(q_acc_5_17,src_dof_5)),_mm256_mul_pd(q_acc_6_17,src_dof_6)),_mm256_mul_pd(q_acc_7_17,src_dof_7)),_mm256_mul_pd(q_acc_8_17,src_dof_8)),_mm256_mul_pd(q_acc_9_17,src_dof_9));
                const __m256d elMatVec_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_18,src_dof_0),_mm256_mul_pd(q_acc_10_18,src_dof_10)),_mm256_mul_pd(q_acc_11_18,src_dof_11)),_mm256_mul_pd(q_acc_12_18,src_dof_12)),_mm256_mul_pd(q_acc_13_18,src_dof_13)),_mm256_mul_pd(q_acc_14_18,src_dof_14)),_mm256_mul_pd(q_acc_15_18,src_dof_15)),_mm256_mul_pd(q_acc_16_18,src_dof_16)),_mm256_mul_pd(q_acc_17_18,src_dof_17)),_mm256_mul_pd(q_acc_18_18,src_dof_18)),_mm256_mul_pd(q_acc_18_19,src_dof_19)),_mm256_mul_pd(q_acc_18_20,src_dof_20)),_mm256_mul_pd(q_acc_18_21,src_dof_21)),_mm256_mul_pd(q_acc_18_22,src_dof_22)),_mm256_mul_pd(q_acc_18_23,src_dof_23)),_mm256_mul_pd(q_acc_18_24,src_dof_24)),_mm256_mul_pd(q_acc_18_25,src_dof_25)),_mm256_mul_pd(q_acc_18_26,src_dof_26)),_mm256_mul_pd(q_acc_18_27,src_dof_27)),_mm256_mul_pd(q_acc_18_28,src_dof_28)),_mm256_mul_pd(q_acc_18_29,src_dof_29)),_mm256_mul_pd(q_acc_1_18,src_dof_1)),_mm256_mul_pd(q_acc_2_18,src_dof_2)),_mm256_mul_pd(q_acc_3_18,src_dof_3)),_mm256_mul_pd(q_acc_4_18,src_dof_4)),_mm256_mul_pd(q_acc_5_18,src_dof_5)),_mm256_mul_pd(q_acc_6_18,src_dof_6)),_mm256_mul_pd(q_acc_7_18,src_dof_7)),_mm256_mul_pd(q_acc_8_18,src_dof_8)),_mm256_mul_pd(q_acc_9_18,src_dof_9));
                const __m256d elMatVec_19 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_19,src_dof_0),_mm256_mul_pd(q_acc_10_19,src_dof_10)),_mm256_mul_pd(q_acc_11_19,src_dof_11)),_mm256_mul_pd(q_acc_12_19,src_dof_12)),_mm256_mul_pd(q_acc_13_19,src_dof_13)),_mm256_mul_pd(q_acc_14_19,src_dof_14)),_mm256_mul_pd(q_acc_15_19,src_dof_15)),_mm256_mul_pd(q_acc_16_19,src_dof_16)),_mm256_mul_pd(q_acc_17_19,src_dof_17)),_mm256_mul_pd(q_acc_18_19,src_dof_18)),_mm256_mul_pd(q_acc_19_19,src_dof_19)),_mm256_mul_pd(q_acc_19_20,src_dof_20)),_mm256_mul_pd(q_acc_19_21,src_dof_21)),_mm256_mul_pd(q_acc_19_22,src_dof_22)),_mm256_mul_pd(q_acc_19_23,src_dof_23)),_mm256_mul_pd(q_acc_19_24,src_dof_24)),_mm256_mul_pd(q_acc_19_25,src_dof_25)),_mm256_mul_pd(q_acc_19_26,src_dof_26)),_mm256_mul_pd(q_acc_19_27,src_dof_27)),_mm256_mul_pd(q_acc_19_28,src_dof_28)),_mm256_mul_pd(q_acc_19_29,src_dof_29)),_mm256_mul_pd(q_acc_1_19,src_dof_1)),_mm256_mul_pd(q_acc_2_19,src_dof_2)),_mm256_mul_pd(q_acc_3_19,src_dof_3)),_mm256_mul_pd(q_acc_4_19,src_dof_4)),_mm256_mul_pd(q_acc_5_19,src_dof_5)),_mm256_mul_pd(q_acc_6_19,src_dof_6)),_mm256_mul_pd(q_acc_7_19,src_dof_7)),_mm256_mul_pd(q_acc_8_19,src_dof_8)),_mm256_mul_pd(q_acc_9_19,src_dof_9));
                const __m256d elMatVec_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_20,src_dof_0),_mm256_mul_pd(q_acc_10_20,src_dof_10)),_mm256_mul_pd(q_acc_11_20,src_dof_11)),_mm256_mul_pd(q_acc_12_20,src_dof_12)),_mm256_mul_pd(q_acc_13_20,src_dof_13)),_mm256_mul_pd(q_acc_14_20,src_dof_14)),_mm256_mul_pd(q_acc_15_20,src_dof_15)),_mm256_mul_pd(q_acc_16_20,src_dof_16)),_mm256_mul_pd(q_acc_17_20,src_dof_17)),_mm256_mul_pd(q_acc_18_20,src_dof_18)),_mm256_mul_pd(q_acc_19_20,src_dof_19)),_mm256_mul_pd(q_acc_1_20,src_dof_1)),_mm256_mul_pd(q_acc_20_20,src_dof_20)),_mm256_mul_pd(q_acc_20_21,src_dof_21)),_mm256_mul_pd(q_acc_20_22,src_dof_22)),_mm256_mul_pd(q_acc_20_23,src_dof_23)),_mm256_mul_pd(q_acc_20_24,src_dof_24)),_mm256_mul_pd(q_acc_20_25,src_dof_25)),_mm256_mul_pd(q_acc_20_26,src_dof_26)),_mm256_mul_pd(q_acc_20_27,src_dof_27)),_mm256_mul_pd(q_acc_20_28,src_dof_28)),_mm256_mul_pd(q_acc_20_29,src_dof_29)),_mm256_mul_pd(q_acc_2_20,src_dof_2)),_mm256_mul_pd(q_acc_3_20,src_dof_3)),_mm256_mul_pd(q_acc_4_20,src_dof_4)),_mm256_mul_pd(q_acc_5_20,src_dof_5)),_mm256_mul_pd(q_acc_6_20,src_dof_6)),_mm256_mul_pd(q_acc_7_20,src_dof_7)),_mm256_mul_pd(q_acc_8_20,src_dof_8)),_mm256_mul_pd(q_acc_9_20,src_dof_9));
                const __m256d elMatVec_21 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_21,src_dof_0),_mm256_mul_pd(q_acc_10_21,src_dof_10)),_mm256_mul_pd(q_acc_11_21,src_dof_11)),_mm256_mul_pd(q_acc_12_21,src_dof_12)),_mm256_mul_pd(q_acc_13_21,src_dof_13)),_mm256_mul_pd(q_acc_14_21,src_dof_14)),_mm256_mul_pd(q_acc_15_21,src_dof_15)),_mm256_mul_pd(q_acc_16_21,src_dof_16)),_mm256_mul_pd(q_acc_17_21,src_dof_17)),_mm256_mul_pd(q_acc_18_21,src_dof_18)),_mm256_mul_pd(q_acc_19_21,src_dof_19)),_mm256_mul_pd(q_acc_1_21,src_dof_1)),_mm256_mul_pd(q_acc_20_21,src_dof_20)),_mm256_mul_pd(q_acc_21_21,src_dof_21)),_mm256_mul_pd(q_acc_21_22,src_dof_22)),_mm256_mul_pd(q_acc_21_23,src_dof_23)),_mm256_mul_pd(q_acc_21_24,src_dof_24)),_mm256_mul_pd(q_acc_21_25,src_dof_25)),_mm256_mul_pd(q_acc_21_26,src_dof_26)),_mm256_mul_pd(q_acc_21_27,src_dof_27)),_mm256_mul_pd(q_acc_21_28,src_dof_28)),_mm256_mul_pd(q_acc_21_29,src_dof_29)),_mm256_mul_pd(q_acc_2_21,src_dof_2)),_mm256_mul_pd(q_acc_3_21,src_dof_3)),_mm256_mul_pd(q_acc_4_21,src_dof_4)),_mm256_mul_pd(q_acc_5_21,src_dof_5)),_mm256_mul_pd(q_acc_6_21,src_dof_6)),_mm256_mul_pd(q_acc_7_21,src_dof_7)),_mm256_mul_pd(q_acc_8_21,src_dof_8)),_mm256_mul_pd(q_acc_9_21,src_dof_9));
                const __m256d elMatVec_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_22,src_dof_0),_mm256_mul_pd(q_acc_10_22,src_dof_10)),_mm256_mul_pd(q_acc_11_22,src_dof_11)),_mm256_mul_pd(q_acc_12_22,src_dof_12)),_mm256_mul_pd(q_acc_13_22,src_dof_13)),_mm256_mul_pd(q_acc_14_22,src_dof_14)),_mm256_mul_pd(q_acc_15_22,src_dof_15)),_mm256_mul_pd(q_acc_16_22,src_dof_16)),_mm256_mul_pd(q_acc_17_22,src_dof_17)),_mm256_mul_pd(q_acc_18_22,src_dof_18)),_mm256_mul_pd(q_acc_19_22,src_dof_19)),_mm256_mul_pd(q_acc_1_22,src_dof_1)),_mm256_mul_pd(q_acc_20_22,src_dof_20)),_mm256_mul_pd(q_acc_21_22,src_dof_21)),_mm256_mul_pd(q_acc_22_22,src_dof_22)),_mm256_mul_pd(q_acc_22_23,src_dof_23)),_mm256_mul_pd(q_acc_22_24,src_dof_24)),_mm256_mul_pd(q_acc_22_25,src_dof_25)),_mm256_mul_pd(q_acc_22_26,src_dof_26)),_mm256_mul_pd(q_acc_22_27,src_dof_27)),_mm256_mul_pd(q_acc_22_28,src_dof_28)),_mm256_mul_pd(q_acc_22_29,src_dof_29)),_mm256_mul_pd(q_acc_2_22,src_dof_2)),_mm256_mul_pd(q_acc_3_22,src_dof_3)),_mm256_mul_pd(q_acc_4_22,src_dof_4)),_mm256_mul_pd(q_acc_5_22,src_dof_5)),_mm256_mul_pd(q_acc_6_22,src_dof_6)),_mm256_mul_pd(q_acc_7_22,src_dof_7)),_mm256_mul_pd(q_acc_8_22,src_dof_8)),_mm256_mul_pd(q_acc_9_22,src_dof_9));
                const __m256d elMatVec_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_23,src_dof_0),_mm256_mul_pd(q_acc_10_23,src_dof_10)),_mm256_mul_pd(q_acc_11_23,src_dof_11)),_mm256_mul_pd(q_acc_12_23,src_dof_12)),_mm256_mul_pd(q_acc_13_23,src_dof_13)),_mm256_mul_pd(q_acc_14_23,src_dof_14)),_mm256_mul_pd(q_acc_15_23,src_dof_15)),_mm256_mul_pd(q_acc_16_23,src_dof_16)),_mm256_mul_pd(q_acc_17_23,src_dof_17)),_mm256_mul_pd(q_acc_18_23,src_dof_18)),_mm256_mul_pd(q_acc_19_23,src_dof_19)),_mm256_mul_pd(q_acc_1_23,src_dof_1)),_mm256_mul_pd(q_acc_20_23,src_dof_20)),_mm256_mul_pd(q_acc_21_23,src_dof_21)),_mm256_mul_pd(q_acc_22_23,src_dof_22)),_mm256_mul_pd(q_acc_23_23,src_dof_23)),_mm256_mul_pd(q_acc_23_24,src_dof_24)),_mm256_mul_pd(q_acc_23_25,src_dof_25)),_mm256_mul_pd(q_acc_23_26,src_dof_26)),_mm256_mul_pd(q_acc_23_27,src_dof_27)),_mm256_mul_pd(q_acc_23_28,src_dof_28)),_mm256_mul_pd(q_acc_23_29,src_dof_29)),_mm256_mul_pd(q_acc_2_23,src_dof_2)),_mm256_mul_pd(q_acc_3_23,src_dof_3)),_mm256_mul_pd(q_acc_4_23,src_dof_4)),_mm256_mul_pd(q_acc_5_23,src_dof_5)),_mm256_mul_pd(q_acc_6_23,src_dof_6)),_mm256_mul_pd(q_acc_7_23,src_dof_7)),_mm256_mul_pd(q_acc_8_23,src_dof_8)),_mm256_mul_pd(q_acc_9_23,src_dof_9));
                const __m256d elMatVec_24 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_24,src_dof_0),_mm256_mul_pd(q_acc_10_24,src_dof_10)),_mm256_mul_pd(q_acc_11_24,src_dof_11)),_mm256_mul_pd(q_acc_12_24,src_dof_12)),_mm256_mul_pd(q_acc_13_24,src_dof_13)),_mm256_mul_pd(q_acc_14_24,src_dof_14)),_mm256_mul_pd(q_acc_15_24,src_dof_15)),_mm256_mul_pd(q_acc_16_24,src_dof_16)),_mm256_mul_pd(q_acc_17_24,src_dof_17)),_mm256_mul_pd(q_acc_18_24,src_dof_18)),_mm256_mul_pd(q_acc_19_24,src_dof_19)),_mm256_mul_pd(q_acc_1_24,src_dof_1)),_mm256_mul_pd(q_acc_20_24,src_dof_20)),_mm256_mul_pd(q_acc_21_24,src_dof_21)),_mm256_mul_pd(q_acc_22_24,src_dof_22)),_mm256_mul_pd(q_acc_23_24,src_dof_23)),_mm256_mul_pd(q_acc_24_24,src_dof_24)),_mm256_mul_pd(q_acc_24_25,src_dof_25)),_mm256_mul_pd(q_acc_24_26,src_dof_26)),_mm256_mul_pd(q_acc_24_27,src_dof_27)),_mm256_mul_pd(q_acc_24_28,src_dof_28)),_mm256_mul_pd(q_acc_24_29,src_dof_29)),_mm256_mul_pd(q_acc_2_24,src_dof_2)),_mm256_mul_pd(q_acc_3_24,src_dof_3)),_mm256_mul_pd(q_acc_4_24,src_dof_4)),_mm256_mul_pd(q_acc_5_24,src_dof_5)),_mm256_mul_pd(q_acc_6_24,src_dof_6)),_mm256_mul_pd(q_acc_7_24,src_dof_7)),_mm256_mul_pd(q_acc_8_24,src_dof_8)),_mm256_mul_pd(q_acc_9_24,src_dof_9));
                const __m256d elMatVec_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_25,src_dof_0),_mm256_mul_pd(q_acc_10_25,src_dof_10)),_mm256_mul_pd(q_acc_11_25,src_dof_11)),_mm256_mul_pd(q_acc_12_25,src_dof_12)),_mm256_mul_pd(q_acc_13_25,src_dof_13)),_mm256_mul_pd(q_acc_14_25,src_dof_14)),_mm256_mul_pd(q_acc_15_25,src_dof_15)),_mm256_mul_pd(q_acc_16_25,src_dof_16)),_mm256_mul_pd(q_acc_17_25,src_dof_17)),_mm256_mul_pd(q_acc_18_25,src_dof_18)),_mm256_mul_pd(q_acc_19_25,src_dof_19)),_mm256_mul_pd(q_acc_1_25,src_dof_1)),_mm256_mul_pd(q_acc_20_25,src_dof_20)),_mm256_mul_pd(q_acc_21_25,src_dof_21)),_mm256_mul_pd(q_acc_22_25,src_dof_22)),_mm256_mul_pd(q_acc_23_25,src_dof_23)),_mm256_mul_pd(q_acc_24_25,src_dof_24)),_mm256_mul_pd(q_acc_25_25,src_dof_25)),_mm256_mul_pd(q_acc_25_26,src_dof_26)),_mm256_mul_pd(q_acc_25_27,src_dof_27)),_mm256_mul_pd(q_acc_25_28,src_dof_28)),_mm256_mul_pd(q_acc_25_29,src_dof_29)),_mm256_mul_pd(q_acc_2_25,src_dof_2)),_mm256_mul_pd(q_acc_3_25,src_dof_3)),_mm256_mul_pd(q_acc_4_25,src_dof_4)),_mm256_mul_pd(q_acc_5_25,src_dof_5)),_mm256_mul_pd(q_acc_6_25,src_dof_6)),_mm256_mul_pd(q_acc_7_25,src_dof_7)),_mm256_mul_pd(q_acc_8_25,src_dof_8)),_mm256_mul_pd(q_acc_9_25,src_dof_9));
                const __m256d elMatVec_26 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_26,src_dof_0),_mm256_mul_pd(q_acc_10_26,src_dof_10)),_mm256_mul_pd(q_acc_11_26,src_dof_11)),_mm256_mul_pd(q_acc_12_26,src_dof_12)),_mm256_mul_pd(q_acc_13_26,src_dof_13)),_mm256_mul_pd(q_acc_14_26,src_dof_14)),_mm256_mul_pd(q_acc_15_26,src_dof_15)),_mm256_mul_pd(q_acc_16_26,src_dof_16)),_mm256_mul_pd(q_acc_17_26,src_dof_17)),_mm256_mul_pd(q_acc_18_26,src_dof_18)),_mm256_mul_pd(q_acc_19_26,src_dof_19)),_mm256_mul_pd(q_acc_1_26,src_dof_1)),_mm256_mul_pd(q_acc_20_26,src_dof_20)),_mm256_mul_pd(q_acc_21_26,src_dof_21)),_mm256_mul_pd(q_acc_22_26,src_dof_22)),_mm256_mul_pd(q_acc_23_26,src_dof_23)),_mm256_mul_pd(q_acc_24_26,src_dof_24)),_mm256_mul_pd(q_acc_25_26,src_dof_25)),_mm256_mul_pd(q_acc_26_26,src_dof_26)),_mm256_mul_pd(q_acc_26_27,src_dof_27)),_mm256_mul_pd(q_acc_26_28,src_dof_28)),_mm256_mul_pd(q_acc_26_29,src_dof_29)),_mm256_mul_pd(q_acc_2_26,src_dof_2)),_mm256_mul_pd(q_acc_3_26,src_dof_3)),_mm256_mul_pd(q_acc_4_26,src_dof_4)),_mm256_mul_pd(q_acc_5_26,src_dof_5)),_mm256_mul_pd(q_acc_6_26,src_dof_6)),_mm256_mul_pd(q_acc_7_26,src_dof_7)),_mm256_mul_pd(q_acc_8_26,src_dof_8)),_mm256_mul_pd(q_acc_9_26,src_dof_9));
                const __m256d elMatVec_27 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_27,src_dof_0),_mm256_mul_pd(q_acc_10_27,src_dof_10)),_mm256_mul_pd(q_acc_11_27,src_dof_11)),_mm256_mul_pd(q_acc_12_27,src_dof_12)),_mm256_mul_pd(q_acc_13_27,src_dof_13)),_mm256_mul_pd(q_acc_14_27,src_dof_14)),_mm256_mul_pd(q_acc_15_27,src_dof_15)),_mm256_mul_pd(q_acc_16_27,src_dof_16)),_mm256_mul_pd(q_acc_17_27,src_dof_17)),_mm256_mul_pd(q_acc_18_27,src_dof_18)),_mm256_mul_pd(q_acc_19_27,src_dof_19)),_mm256_mul_pd(q_acc_1_27,src_dof_1)),_mm256_mul_pd(q_acc_20_27,src_dof_20)),_mm256_mul_pd(q_acc_21_27,src_dof_21)),_mm256_mul_pd(q_acc_22_27,src_dof_22)),_mm256_mul_pd(q_acc_23_27,src_dof_23)),_mm256_mul_pd(q_acc_24_27,src_dof_24)),_mm256_mul_pd(q_acc_25_27,src_dof_25)),_mm256_mul_pd(q_acc_26_27,src_dof_26)),_mm256_mul_pd(q_acc_27_27,src_dof_27)),_mm256_mul_pd(q_acc_27_28,src_dof_28)),_mm256_mul_pd(q_acc_27_29,src_dof_29)),_mm256_mul_pd(q_acc_2_27,src_dof_2)),_mm256_mul_pd(q_acc_3_27,src_dof_3)),_mm256_mul_pd(q_acc_4_27,src_dof_4)),_mm256_mul_pd(q_acc_5_27,src_dof_5)),_mm256_mul_pd(q_acc_6_27,src_dof_6)),_mm256_mul_pd(q_acc_7_27,src_dof_7)),_mm256_mul_pd(q_acc_8_27,src_dof_8)),_mm256_mul_pd(q_acc_9_27,src_dof_9));
                const __m256d elMatVec_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_28,src_dof_0),_mm256_mul_pd(q_acc_10_28,src_dof_10)),_mm256_mul_pd(q_acc_11_28,src_dof_11)),_mm256_mul_pd(q_acc_12_28,src_dof_12)),_mm256_mul_pd(q_acc_13_28,src_dof_13)),_mm256_mul_pd(q_acc_14_28,src_dof_14)),_mm256_mul_pd(q_acc_15_28,src_dof_15)),_mm256_mul_pd(q_acc_16_28,src_dof_16)),_mm256_mul_pd(q_acc_17_28,src_dof_17)),_mm256_mul_pd(q_acc_18_28,src_dof_18)),_mm256_mul_pd(q_acc_19_28,src_dof_19)),_mm256_mul_pd(q_acc_1_28,src_dof_1)),_mm256_mul_pd(q_acc_20_28,src_dof_20)),_mm256_mul_pd(q_acc_21_28,src_dof_21)),_mm256_mul_pd(q_acc_22_28,src_dof_22)),_mm256_mul_pd(q_acc_23_28,src_dof_23)),_mm256_mul_pd(q_acc_24_28,src_dof_24)),_mm256_mul_pd(q_acc_25_28,src_dof_25)),_mm256_mul_pd(q_acc_26_28,src_dof_26)),_mm256_mul_pd(q_acc_27_28,src_dof_27)),_mm256_mul_pd(q_acc_28_28,src_dof_28)),_mm256_mul_pd(q_acc_28_29,src_dof_29)),_mm256_mul_pd(q_acc_2_28,src_dof_2)),_mm256_mul_pd(q_acc_3_28,src_dof_3)),_mm256_mul_pd(q_acc_4_28,src_dof_4)),_mm256_mul_pd(q_acc_5_28,src_dof_5)),_mm256_mul_pd(q_acc_6_28,src_dof_6)),_mm256_mul_pd(q_acc_7_28,src_dof_7)),_mm256_mul_pd(q_acc_8_28,src_dof_8)),_mm256_mul_pd(q_acc_9_28,src_dof_9));
                const __m256d elMatVec_29 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_29,src_dof_0),_mm256_mul_pd(q_acc_10_29,src_dof_10)),_mm256_mul_pd(q_acc_11_29,src_dof_11)),_mm256_mul_pd(q_acc_12_29,src_dof_12)),_mm256_mul_pd(q_acc_13_29,src_dof_13)),_mm256_mul_pd(q_acc_14_29,src_dof_14)),_mm256_mul_pd(q_acc_15_29,src_dof_15)),_mm256_mul_pd(q_acc_16_29,src_dof_16)),_mm256_mul_pd(q_acc_17_29,src_dof_17)),_mm256_mul_pd(q_acc_18_29,src_dof_18)),_mm256_mul_pd(q_acc_19_29,src_dof_19)),_mm256_mul_pd(q_acc_1_29,src_dof_1)),_mm256_mul_pd(q_acc_20_29,src_dof_20)),_mm256_mul_pd(q_acc_21_29,src_dof_21)),_mm256_mul_pd(q_acc_22_29,src_dof_22)),_mm256_mul_pd(q_acc_23_29,src_dof_23)),_mm256_mul_pd(q_acc_24_29,src_dof_24)),_mm256_mul_pd(q_acc_25_29,src_dof_25)),_mm256_mul_pd(q_acc_26_29,src_dof_26)),_mm256_mul_pd(q_acc_27_29,src_dof_27)),_mm256_mul_pd(q_acc_28_29,src_dof_28)),_mm256_mul_pd(q_acc_29_29,src_dof_29)),_mm256_mul_pd(q_acc_2_29,src_dof_2)),_mm256_mul_pd(q_acc_3_29,src_dof_3)),_mm256_mul_pd(q_acc_4_29,src_dof_4)),_mm256_mul_pd(q_acc_5_29,src_dof_5)),_mm256_mul_pd(q_acc_6_29,src_dof_6)),_mm256_mul_pd(q_acc_7_29,src_dof_7)),_mm256_mul_pd(q_acc_8_29,src_dof_8)),_mm256_mul_pd(q_acc_9_29,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_12,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_13,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_14,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_15,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_16,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_17,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_18,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_19,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_20,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_21,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_22,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_23,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_24,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_25,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_26,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_27,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_28,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_29,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_16 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_26 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_0_12 = 0.0;
                real_t q_acc_0_13 = 0.0;
                real_t q_acc_0_14 = 0.0;
                real_t q_acc_0_15 = 0.0;
                real_t q_acc_0_16 = 0.0;
                real_t q_acc_0_17 = 0.0;
                real_t q_acc_0_18 = 0.0;
                real_t q_acc_0_19 = 0.0;
                real_t q_acc_0_20 = 0.0;
                real_t q_acc_0_21 = 0.0;
                real_t q_acc_0_22 = 0.0;
                real_t q_acc_0_23 = 0.0;
                real_t q_acc_0_24 = 0.0;
                real_t q_acc_0_25 = 0.0;
                real_t q_acc_0_26 = 0.0;
                real_t q_acc_0_27 = 0.0;
                real_t q_acc_0_28 = 0.0;
                real_t q_acc_0_29 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_1_12 = 0.0;
                real_t q_acc_1_13 = 0.0;
                real_t q_acc_1_14 = 0.0;
                real_t q_acc_1_15 = 0.0;
                real_t q_acc_1_16 = 0.0;
                real_t q_acc_1_17 = 0.0;
                real_t q_acc_1_18 = 0.0;
                real_t q_acc_1_19 = 0.0;
                real_t q_acc_1_20 = 0.0;
                real_t q_acc_1_21 = 0.0;
                real_t q_acc_1_22 = 0.0;
                real_t q_acc_1_23 = 0.0;
                real_t q_acc_1_24 = 0.0;
                real_t q_acc_1_25 = 0.0;
                real_t q_acc_1_26 = 0.0;
                real_t q_acc_1_27 = 0.0;
                real_t q_acc_1_28 = 0.0;
                real_t q_acc_1_29 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_2_12 = 0.0;
                real_t q_acc_2_13 = 0.0;
                real_t q_acc_2_14 = 0.0;
                real_t q_acc_2_15 = 0.0;
                real_t q_acc_2_16 = 0.0;
                real_t q_acc_2_17 = 0.0;
                real_t q_acc_2_18 = 0.0;
                real_t q_acc_2_19 = 0.0;
                real_t q_acc_2_20 = 0.0;
                real_t q_acc_2_21 = 0.0;
                real_t q_acc_2_22 = 0.0;
                real_t q_acc_2_23 = 0.0;
                real_t q_acc_2_24 = 0.0;
                real_t q_acc_2_25 = 0.0;
                real_t q_acc_2_26 = 0.0;
                real_t q_acc_2_27 = 0.0;
                real_t q_acc_2_28 = 0.0;
                real_t q_acc_2_29 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_3_12 = 0.0;
                real_t q_acc_3_13 = 0.0;
                real_t q_acc_3_14 = 0.0;
                real_t q_acc_3_15 = 0.0;
                real_t q_acc_3_16 = 0.0;
                real_t q_acc_3_17 = 0.0;
                real_t q_acc_3_18 = 0.0;
                real_t q_acc_3_19 = 0.0;
                real_t q_acc_3_20 = 0.0;
                real_t q_acc_3_21 = 0.0;
                real_t q_acc_3_22 = 0.0;
                real_t q_acc_3_23 = 0.0;
                real_t q_acc_3_24 = 0.0;
                real_t q_acc_3_25 = 0.0;
                real_t q_acc_3_26 = 0.0;
                real_t q_acc_3_27 = 0.0;
                real_t q_acc_3_28 = 0.0;
                real_t q_acc_3_29 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_4_12 = 0.0;
                real_t q_acc_4_13 = 0.0;
                real_t q_acc_4_14 = 0.0;
                real_t q_acc_4_15 = 0.0;
                real_t q_acc_4_16 = 0.0;
                real_t q_acc_4_17 = 0.0;
                real_t q_acc_4_18 = 0.0;
                real_t q_acc_4_19 = 0.0;
                real_t q_acc_4_20 = 0.0;
                real_t q_acc_4_21 = 0.0;
                real_t q_acc_4_22 = 0.0;
                real_t q_acc_4_23 = 0.0;
                real_t q_acc_4_24 = 0.0;
                real_t q_acc_4_25 = 0.0;
                real_t q_acc_4_26 = 0.0;
                real_t q_acc_4_27 = 0.0;
                real_t q_acc_4_28 = 0.0;
                real_t q_acc_4_29 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_5_12 = 0.0;
                real_t q_acc_5_13 = 0.0;
                real_t q_acc_5_14 = 0.0;
                real_t q_acc_5_15 = 0.0;
                real_t q_acc_5_16 = 0.0;
                real_t q_acc_5_17 = 0.0;
                real_t q_acc_5_18 = 0.0;
                real_t q_acc_5_19 = 0.0;
                real_t q_acc_5_20 = 0.0;
                real_t q_acc_5_21 = 0.0;
                real_t q_acc_5_22 = 0.0;
                real_t q_acc_5_23 = 0.0;
                real_t q_acc_5_24 = 0.0;
                real_t q_acc_5_25 = 0.0;
                real_t q_acc_5_26 = 0.0;
                real_t q_acc_5_27 = 0.0;
                real_t q_acc_5_28 = 0.0;
                real_t q_acc_5_29 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_6_12 = 0.0;
                real_t q_acc_6_13 = 0.0;
                real_t q_acc_6_14 = 0.0;
                real_t q_acc_6_15 = 0.0;
                real_t q_acc_6_16 = 0.0;
                real_t q_acc_6_17 = 0.0;
                real_t q_acc_6_18 = 0.0;
                real_t q_acc_6_19 = 0.0;
                real_t q_acc_6_20 = 0.0;
                real_t q_acc_6_21 = 0.0;
                real_t q_acc_6_22 = 0.0;
                real_t q_acc_6_23 = 0.0;
                real_t q_acc_6_24 = 0.0;
                real_t q_acc_6_25 = 0.0;
                real_t q_acc_6_26 = 0.0;
                real_t q_acc_6_27 = 0.0;
                real_t q_acc_6_28 = 0.0;
                real_t q_acc_6_29 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_7_12 = 0.0;
                real_t q_acc_7_13 = 0.0;
                real_t q_acc_7_14 = 0.0;
                real_t q_acc_7_15 = 0.0;
                real_t q_acc_7_16 = 0.0;
                real_t q_acc_7_17 = 0.0;
                real_t q_acc_7_18 = 0.0;
                real_t q_acc_7_19 = 0.0;
                real_t q_acc_7_20 = 0.0;
                real_t q_acc_7_21 = 0.0;
                real_t q_acc_7_22 = 0.0;
                real_t q_acc_7_23 = 0.0;
                real_t q_acc_7_24 = 0.0;
                real_t q_acc_7_25 = 0.0;
                real_t q_acc_7_26 = 0.0;
                real_t q_acc_7_27 = 0.0;
                real_t q_acc_7_28 = 0.0;
                real_t q_acc_7_29 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_8_12 = 0.0;
                real_t q_acc_8_13 = 0.0;
                real_t q_acc_8_14 = 0.0;
                real_t q_acc_8_15 = 0.0;
                real_t q_acc_8_16 = 0.0;
                real_t q_acc_8_17 = 0.0;
                real_t q_acc_8_18 = 0.0;
                real_t q_acc_8_19 = 0.0;
                real_t q_acc_8_20 = 0.0;
                real_t q_acc_8_21 = 0.0;
                real_t q_acc_8_22 = 0.0;
                real_t q_acc_8_23 = 0.0;
                real_t q_acc_8_24 = 0.0;
                real_t q_acc_8_25 = 0.0;
                real_t q_acc_8_26 = 0.0;
                real_t q_acc_8_27 = 0.0;
                real_t q_acc_8_28 = 0.0;
                real_t q_acc_8_29 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_9_12 = 0.0;
                real_t q_acc_9_13 = 0.0;
                real_t q_acc_9_14 = 0.0;
                real_t q_acc_9_15 = 0.0;
                real_t q_acc_9_16 = 0.0;
                real_t q_acc_9_17 = 0.0;
                real_t q_acc_9_18 = 0.0;
                real_t q_acc_9_19 = 0.0;
                real_t q_acc_9_20 = 0.0;
                real_t q_acc_9_21 = 0.0;
                real_t q_acc_9_22 = 0.0;
                real_t q_acc_9_23 = 0.0;
                real_t q_acc_9_24 = 0.0;
                real_t q_acc_9_25 = 0.0;
                real_t q_acc_9_26 = 0.0;
                real_t q_acc_9_27 = 0.0;
                real_t q_acc_9_28 = 0.0;
                real_t q_acc_9_29 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_10_12 = 0.0;
                real_t q_acc_10_13 = 0.0;
                real_t q_acc_10_14 = 0.0;
                real_t q_acc_10_15 = 0.0;
                real_t q_acc_10_16 = 0.0;
                real_t q_acc_10_17 = 0.0;
                real_t q_acc_10_18 = 0.0;
                real_t q_acc_10_19 = 0.0;
                real_t q_acc_10_20 = 0.0;
                real_t q_acc_10_21 = 0.0;
                real_t q_acc_10_22 = 0.0;
                real_t q_acc_10_23 = 0.0;
                real_t q_acc_10_24 = 0.0;
                real_t q_acc_10_25 = 0.0;
                real_t q_acc_10_26 = 0.0;
                real_t q_acc_10_27 = 0.0;
                real_t q_acc_10_28 = 0.0;
                real_t q_acc_10_29 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_11_12 = 0.0;
                real_t q_acc_11_13 = 0.0;
                real_t q_acc_11_14 = 0.0;
                real_t q_acc_11_15 = 0.0;
                real_t q_acc_11_16 = 0.0;
                real_t q_acc_11_17 = 0.0;
                real_t q_acc_11_18 = 0.0;
                real_t q_acc_11_19 = 0.0;
                real_t q_acc_11_20 = 0.0;
                real_t q_acc_11_21 = 0.0;
                real_t q_acc_11_22 = 0.0;
                real_t q_acc_11_23 = 0.0;
                real_t q_acc_11_24 = 0.0;
                real_t q_acc_11_25 = 0.0;
                real_t q_acc_11_26 = 0.0;
                real_t q_acc_11_27 = 0.0;
                real_t q_acc_11_28 = 0.0;
                real_t q_acc_11_29 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_12_13 = 0.0;
                real_t q_acc_12_14 = 0.0;
                real_t q_acc_12_15 = 0.0;
                real_t q_acc_12_16 = 0.0;
                real_t q_acc_12_17 = 0.0;
                real_t q_acc_12_18 = 0.0;
                real_t q_acc_12_19 = 0.0;
                real_t q_acc_12_20 = 0.0;
                real_t q_acc_12_21 = 0.0;
                real_t q_acc_12_22 = 0.0;
                real_t q_acc_12_23 = 0.0;
                real_t q_acc_12_24 = 0.0;
                real_t q_acc_12_25 = 0.0;
                real_t q_acc_12_26 = 0.0;
                real_t q_acc_12_27 = 0.0;
                real_t q_acc_12_28 = 0.0;
                real_t q_acc_12_29 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_13_14 = 0.0;
                real_t q_acc_13_15 = 0.0;
                real_t q_acc_13_16 = 0.0;
                real_t q_acc_13_17 = 0.0;
                real_t q_acc_13_18 = 0.0;
                real_t q_acc_13_19 = 0.0;
                real_t q_acc_13_20 = 0.0;
                real_t q_acc_13_21 = 0.0;
                real_t q_acc_13_22 = 0.0;
                real_t q_acc_13_23 = 0.0;
                real_t q_acc_13_24 = 0.0;
                real_t q_acc_13_25 = 0.0;
                real_t q_acc_13_26 = 0.0;
                real_t q_acc_13_27 = 0.0;
                real_t q_acc_13_28 = 0.0;
                real_t q_acc_13_29 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_14_15 = 0.0;
                real_t q_acc_14_16 = 0.0;
                real_t q_acc_14_17 = 0.0;
                real_t q_acc_14_18 = 0.0;
                real_t q_acc_14_19 = 0.0;
                real_t q_acc_14_20 = 0.0;
                real_t q_acc_14_21 = 0.0;
                real_t q_acc_14_22 = 0.0;
                real_t q_acc_14_23 = 0.0;
                real_t q_acc_14_24 = 0.0;
                real_t q_acc_14_25 = 0.0;
                real_t q_acc_14_26 = 0.0;
                real_t q_acc_14_27 = 0.0;
                real_t q_acc_14_28 = 0.0;
                real_t q_acc_14_29 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_15_16 = 0.0;
                real_t q_acc_15_17 = 0.0;
                real_t q_acc_15_18 = 0.0;
                real_t q_acc_15_19 = 0.0;
                real_t q_acc_15_20 = 0.0;
                real_t q_acc_15_21 = 0.0;
                real_t q_acc_15_22 = 0.0;
                real_t q_acc_15_23 = 0.0;
                real_t q_acc_15_24 = 0.0;
                real_t q_acc_15_25 = 0.0;
                real_t q_acc_15_26 = 0.0;
                real_t q_acc_15_27 = 0.0;
                real_t q_acc_15_28 = 0.0;
                real_t q_acc_15_29 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_16_17 = 0.0;
                real_t q_acc_16_18 = 0.0;
                real_t q_acc_16_19 = 0.0;
                real_t q_acc_16_20 = 0.0;
                real_t q_acc_16_21 = 0.0;
                real_t q_acc_16_22 = 0.0;
                real_t q_acc_16_23 = 0.0;
                real_t q_acc_16_24 = 0.0;
                real_t q_acc_16_25 = 0.0;
                real_t q_acc_16_26 = 0.0;
                real_t q_acc_16_27 = 0.0;
                real_t q_acc_16_28 = 0.0;
                real_t q_acc_16_29 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_17_18 = 0.0;
                real_t q_acc_17_19 = 0.0;
                real_t q_acc_17_20 = 0.0;
                real_t q_acc_17_21 = 0.0;
                real_t q_acc_17_22 = 0.0;
                real_t q_acc_17_23 = 0.0;
                real_t q_acc_17_24 = 0.0;
                real_t q_acc_17_25 = 0.0;
                real_t q_acc_17_26 = 0.0;
                real_t q_acc_17_27 = 0.0;
                real_t q_acc_17_28 = 0.0;
                real_t q_acc_17_29 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_18_19 = 0.0;
                real_t q_acc_18_20 = 0.0;
                real_t q_acc_18_21 = 0.0;
                real_t q_acc_18_22 = 0.0;
                real_t q_acc_18_23 = 0.0;
                real_t q_acc_18_24 = 0.0;
                real_t q_acc_18_25 = 0.0;
                real_t q_acc_18_26 = 0.0;
                real_t q_acc_18_27 = 0.0;
                real_t q_acc_18_28 = 0.0;
                real_t q_acc_18_29 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_19_20 = 0.0;
                real_t q_acc_19_21 = 0.0;
                real_t q_acc_19_22 = 0.0;
                real_t q_acc_19_23 = 0.0;
                real_t q_acc_19_24 = 0.0;
                real_t q_acc_19_25 = 0.0;
                real_t q_acc_19_26 = 0.0;
                real_t q_acc_19_27 = 0.0;
                real_t q_acc_19_28 = 0.0;
                real_t q_acc_19_29 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_20_21 = 0.0;
                real_t q_acc_20_22 = 0.0;
                real_t q_acc_20_23 = 0.0;
                real_t q_acc_20_24 = 0.0;
                real_t q_acc_20_25 = 0.0;
                real_t q_acc_20_26 = 0.0;
                real_t q_acc_20_27 = 0.0;
                real_t q_acc_20_28 = 0.0;
                real_t q_acc_20_29 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_21_22 = 0.0;
                real_t q_acc_21_23 = 0.0;
                real_t q_acc_21_24 = 0.0;
                real_t q_acc_21_25 = 0.0;
                real_t q_acc_21_26 = 0.0;
                real_t q_acc_21_27 = 0.0;
                real_t q_acc_21_28 = 0.0;
                real_t q_acc_21_29 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_22_23 = 0.0;
                real_t q_acc_22_24 = 0.0;
                real_t q_acc_22_25 = 0.0;
                real_t q_acc_22_26 = 0.0;
                real_t q_acc_22_27 = 0.0;
                real_t q_acc_22_28 = 0.0;
                real_t q_acc_22_29 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_23_24 = 0.0;
                real_t q_acc_23_25 = 0.0;
                real_t q_acc_23_26 = 0.0;
                real_t q_acc_23_27 = 0.0;
                real_t q_acc_23_28 = 0.0;
                real_t q_acc_23_29 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_24_25 = 0.0;
                real_t q_acc_24_26 = 0.0;
                real_t q_acc_24_27 = 0.0;
                real_t q_acc_24_28 = 0.0;
                real_t q_acc_24_29 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_25_26 = 0.0;
                real_t q_acc_25_27 = 0.0;
                real_t q_acc_25_28 = 0.0;
                real_t q_acc_25_29 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_26_27 = 0.0;
                real_t q_acc_26_28 = 0.0;
                real_t q_acc_26_29 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_27_28 = 0.0;
                real_t q_acc_27_29 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_28_29 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_156 = (mu_dof_0*_data_phi_0_0_BLUE_UP[4*q] + mu_dof_1*_data_phi_0_0_BLUE_UP[4*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_UP[4*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_UP[4*q + 3])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_133 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_157 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4];
                   const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6];
                   const real_t tmp_qloop_222 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7];
                   const real_t tmp_qloop_235 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10];
                   const real_t tmp_qloop_277 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11];
                   const real_t tmp_qloop_283 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_323 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_337 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_365 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_379 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_407 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_421 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_436 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_453 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_468 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_483 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_498 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_513 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_528 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_543 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_558 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_573 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_121 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q];
                   const real_t tmp_qloop_144 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_162 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4];
                   const real_t tmp_qloop_201 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5];
                   const real_t tmp_qloop_214 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8];
                   const real_t tmp_qloop_253 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9];
                   const real_t tmp_qloop_266 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10];
                   const real_t tmp_qloop_274 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_286 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11];
                   const real_t tmp_qloop_305 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_319 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_361 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_389 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_403 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_444 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_459 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_474 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_489 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_504 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_519 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_534 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_549 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_564 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_579 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q];
                   const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 2];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 3];
                   const real_t tmp_qloop_192 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 4];
                   const real_t tmp_qloop_205 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 5];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 6];
                   const real_t tmp_qloop_231 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 7];
                   const real_t tmp_qloop_244 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 8];
                   const real_t tmp_qloop_257 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 9];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 10];
                   const real_t tmp_qloop_293 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[12*q + 11];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_314 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_328 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_342 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_356 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_370 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_398 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_412 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_431 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_449 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_464 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_479 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_494 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_509 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_524 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_539 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_554 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_569 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_125 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_158 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_184 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_223 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_236 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_278 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_284 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_324 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_338 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_366 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_380 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_408 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_422 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_437 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_454 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_469 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_484 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_499 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_514 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_529 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_544 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_559 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_574 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_145 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_163 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_176 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_202 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_215 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_254 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_267 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_275 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_287 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_306 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_320 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_362 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_390 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_404 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_445 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_460 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_475 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_490 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_505 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_520 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_535 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_550 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_565 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_580 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_193 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_206 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_232 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_245 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_258 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_294 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_315 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_329 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_343 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_357 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_371 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_399 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_413 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_432 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_450 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_465 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_480 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_495 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_510 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_525 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_540 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_555 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_570 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_120 = tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0;
                   const real_t tmp_qloop_126 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_127 = tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_126;
                   const real_t tmp_qloop_128 = tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_126*0.5;
                   const real_t tmp_qloop_135 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_136 = tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135;
                   const real_t tmp_qloop_137 = tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5;
                   const real_t tmp_qloop_159 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_161 = tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0;
                   const real_t tmp_qloop_172 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_174 = tmp_qloop_170*2.0 + tmp_qloop_171*2.0 + tmp_qloop_172*2.0;
                   const real_t tmp_qloop_185 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_187 = tmp_qloop_183*2.0 + tmp_qloop_184*2.0 + tmp_qloop_185*2.0;
                   const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_200 = tmp_qloop_196*2.0 + tmp_qloop_197*2.0 + tmp_qloop_198*2.0;
                   const real_t tmp_qloop_211 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_213 = tmp_qloop_209*2.0 + tmp_qloop_210*2.0 + tmp_qloop_211*2.0;
                   const real_t tmp_qloop_224 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_226 = tmp_qloop_222*2.0 + tmp_qloop_223*2.0 + tmp_qloop_224*2.0;
                   const real_t tmp_qloop_237 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_239 = tmp_qloop_235*2.0 + tmp_qloop_236*2.0 + tmp_qloop_237*2.0;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_252 = tmp_qloop_248*2.0 + tmp_qloop_249*2.0 + tmp_qloop_250*2.0;
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_265 = tmp_qloop_261*2.0 + tmp_qloop_262*2.0 + tmp_qloop_263*2.0;
                   const real_t tmp_qloop_279 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_280 = tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663 + tmp_qloop_279*0.66666666666666663;
                   const real_t tmp_qloop_285 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_291 = tmp_qloop_277*2.0 + tmp_qloop_278*2.0 + tmp_qloop_279*2.0;
                   const real_t tmp_qloop_292 = tmp_qloop_120*tmp_qloop_291;
                   const real_t tmp_qloop_311 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_325 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_339 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_367 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_381 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_409 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_438 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_455 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_470 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_485 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_500 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_515 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_530 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_545 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_560 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_575 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_585 = tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0;
                   const real_t tmp_qloop_589 = tmp_qloop_291*tmp_qloop_585;
                   const real_t tmp_qloop_596 = tmp_qloop_170*1.0 + tmp_qloop_171*1.0 + tmp_qloop_172*1.0;
                   const real_t tmp_qloop_599 = tmp_qloop_291*tmp_qloop_596;
                   const real_t tmp_qloop_605 = tmp_qloop_183*1.0 + tmp_qloop_184*1.0 + tmp_qloop_185*1.0;
                   const real_t tmp_qloop_608 = tmp_qloop_291*tmp_qloop_605;
                   const real_t tmp_qloop_614 = tmp_qloop_196*1.0 + tmp_qloop_197*1.0 + tmp_qloop_198*1.0;
                   const real_t tmp_qloop_617 = tmp_qloop_291*tmp_qloop_614;
                   const real_t tmp_qloop_623 = tmp_qloop_209*1.0 + tmp_qloop_210*1.0 + tmp_qloop_211*1.0;
                   const real_t tmp_qloop_626 = tmp_qloop_291*tmp_qloop_623;
                   const real_t tmp_qloop_632 = tmp_qloop_222*1.0 + tmp_qloop_223*1.0 + tmp_qloop_224*1.0;
                   const real_t tmp_qloop_635 = tmp_qloop_291*tmp_qloop_632;
                   const real_t tmp_qloop_641 = tmp_qloop_235*1.0 + tmp_qloop_236*1.0 + tmp_qloop_237*1.0;
                   const real_t tmp_qloop_644 = tmp_qloop_291*tmp_qloop_641;
                   const real_t tmp_qloop_650 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                   const real_t tmp_qloop_653 = tmp_qloop_291*tmp_qloop_650;
                   const real_t tmp_qloop_659 = tmp_qloop_261*1.0 + tmp_qloop_262*1.0 + tmp_qloop_263*1.0;
                   const real_t tmp_qloop_662 = tmp_qloop_291*tmp_qloop_659;
                   const real_t tmp_qloop_667 = tmp_qloop_277 + tmp_qloop_278 + tmp_qloop_279;
                   const real_t tmp_qloop_674 = tmp_qloop_291*(tmp_qloop_277*1.0 + tmp_qloop_278*1.0 + tmp_qloop_279*1.0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_116 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_123 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_129 = tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_128*2.0;
                   const real_t tmp_qloop_139 = tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0;
                   const real_t tmp_qloop_140 = tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0;
                   const real_t tmp_qloop_141 = tmp_qloop_139*tmp_qloop_140;
                   const real_t tmp_qloop_146 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_147 = tmp_qloop_144 + tmp_qloop_145 + tmp_qloop_146;
                   const real_t tmp_qloop_152 = tmp_qloop_144*0.5 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5;
                   const real_t tmp_qloop_164 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_165 = tmp_qloop_127 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_177 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_178 = tmp_qloop_127 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_191 = tmp_qloop_127 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_203 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_204 = tmp_qloop_127 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_216 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_217 = tmp_qloop_127 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_229 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_230 = tmp_qloop_127 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_243 = tmp_qloop_127 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_255 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_256 = tmp_qloop_127 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_268 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_269 = tmp_qloop_127 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_276 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_288 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_289 = tmp_qloop_286 + tmp_qloop_287 + tmp_qloop_288;
                   const real_t tmp_qloop_290 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_289;
                   const real_t tmp_qloop_299 = tmp_qloop_274*2.0 + tmp_qloop_275*2.0 + tmp_qloop_276*2.0;
                   const real_t tmp_qloop_307 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_312 = tmp_qloop_289 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311;
                   const real_t tmp_qloop_313 = tmp_qloop_305*2.0 + tmp_qloop_306*2.0 + tmp_qloop_307*2.0;
                   const real_t tmp_qloop_321 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_326 = tmp_qloop_289 + tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325;
                   const real_t tmp_qloop_327 = tmp_qloop_319*2.0 + tmp_qloop_320*2.0 + tmp_qloop_321*2.0;
                   const real_t tmp_qloop_335 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_340 = tmp_qloop_289 + tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339;
                   const real_t tmp_qloop_341 = tmp_qloop_333*2.0 + tmp_qloop_334*2.0 + tmp_qloop_335*2.0;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_354 = tmp_qloop_289 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353;
                   const real_t tmp_qloop_355 = tmp_qloop_347*2.0 + tmp_qloop_348*2.0 + tmp_qloop_349*2.0;
                   const real_t tmp_qloop_363 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_368 = tmp_qloop_289 + tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367;
                   const real_t tmp_qloop_369 = tmp_qloop_361*2.0 + tmp_qloop_362*2.0 + tmp_qloop_363*2.0;
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_382 = tmp_qloop_289 + tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381;
                   const real_t tmp_qloop_383 = tmp_qloop_375*2.0 + tmp_qloop_376*2.0 + tmp_qloop_377*2.0;
                   const real_t tmp_qloop_391 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_396 = tmp_qloop_289 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395;
                   const real_t tmp_qloop_397 = tmp_qloop_389*2.0 + tmp_qloop_390*2.0 + tmp_qloop_391*2.0;
                   const real_t tmp_qloop_405 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_410 = tmp_qloop_289 + tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409;
                   const real_t tmp_qloop_411 = tmp_qloop_403*2.0 + tmp_qloop_404*2.0 + tmp_qloop_405*2.0;
                   const real_t tmp_qloop_419 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_424 = tmp_qloop_289 + tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423;
                   const real_t tmp_qloop_425 = tmp_qloop_417*2.0 + tmp_qloop_418*2.0 + tmp_qloop_419*2.0;
                   const real_t tmp_qloop_434 = tmp_qloop_113 + tmp_qloop_280;
                   const real_t tmp_qloop_440 = tmp_qloop_127 + tmp_qloop_289;
                   const real_t tmp_qloop_441 = tmp_qloop_129*tmp_qloop_440 + tmp_qloop_141 + tmp_qloop_292;
                   const real_t tmp_qloop_446 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_461 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_476 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_491 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_506 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_521 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_536 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_551 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_566 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_581 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_586 = tmp_qloop_128*2.0 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_593 = tmp_qloop_440*tmp_qloop_586 + tmp_qloop_589;
                   const real_t tmp_qloop_594 = tmp_qloop_141 + tmp_qloop_593;
                   const real_t tmp_qloop_597 = tmp_qloop_128*2.0 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_602 = tmp_qloop_440*tmp_qloop_597 + tmp_qloop_599;
                   const real_t tmp_qloop_603 = tmp_qloop_141 + tmp_qloop_602;
                   const real_t tmp_qloop_606 = tmp_qloop_128*2.0 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_611 = tmp_qloop_440*tmp_qloop_606 + tmp_qloop_608;
                   const real_t tmp_qloop_612 = tmp_qloop_141 + tmp_qloop_611;
                   const real_t tmp_qloop_615 = tmp_qloop_128*2.0 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_620 = tmp_qloop_440*tmp_qloop_615 + tmp_qloop_617;
                   const real_t tmp_qloop_621 = tmp_qloop_141 + tmp_qloop_620;
                   const real_t tmp_qloop_624 = tmp_qloop_128*2.0 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_629 = tmp_qloop_440*tmp_qloop_624 + tmp_qloop_626;
                   const real_t tmp_qloop_630 = tmp_qloop_141 + tmp_qloop_629;
                   const real_t tmp_qloop_633 = tmp_qloop_128*2.0 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_638 = tmp_qloop_440*tmp_qloop_633 + tmp_qloop_635;
                   const real_t tmp_qloop_639 = tmp_qloop_141 + tmp_qloop_638;
                   const real_t tmp_qloop_642 = tmp_qloop_128*2.0 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_647 = tmp_qloop_440*tmp_qloop_642 + tmp_qloop_644;
                   const real_t tmp_qloop_648 = tmp_qloop_141 + tmp_qloop_647;
                   const real_t tmp_qloop_651 = tmp_qloop_128*2.0 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_656 = tmp_qloop_440*tmp_qloop_651 + tmp_qloop_653;
                   const real_t tmp_qloop_657 = tmp_qloop_141 + tmp_qloop_656;
                   const real_t tmp_qloop_660 = tmp_qloop_128*2.0 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_665 = tmp_qloop_440*tmp_qloop_660 + tmp_qloop_662;
                   const real_t tmp_qloop_666 = tmp_qloop_141 + tmp_qloop_665;
                   const real_t tmp_qloop_670 = tmp_qloop_274*1.0 + tmp_qloop_275*1.0 + tmp_qloop_276*1.0;
                   const real_t tmp_qloop_671 = tmp_qloop_286*0.5 + tmp_qloop_287*0.5 + tmp_qloop_288*0.5;
                   const real_t tmp_qloop_672 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_678 = tmp_qloop_140*tmp_qloop_670 + tmp_qloop_440*tmp_qloop_672 + tmp_qloop_674;
                   const real_t tmp_qloop_690 = tmp_qloop_305*1.0 + tmp_qloop_306*1.0 + tmp_qloop_307*1.0;
                   const real_t tmp_qloop_691 = tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_694 = tmp_qloop_140*tmp_qloop_690 + tmp_qloop_440*tmp_qloop_691;
                   const real_t tmp_qloop_695 = tmp_qloop_674 + tmp_qloop_694;
                   const real_t tmp_qloop_697 = tmp_qloop_319*1.0 + tmp_qloop_320*1.0 + tmp_qloop_321*1.0;
                   const real_t tmp_qloop_698 = tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_700 = tmp_qloop_140*tmp_qloop_697 + tmp_qloop_440*tmp_qloop_698;
                   const real_t tmp_qloop_701 = tmp_qloop_674 + tmp_qloop_700;
                   const real_t tmp_qloop_703 = tmp_qloop_333*1.0 + tmp_qloop_334*1.0 + tmp_qloop_335*1.0;
                   const real_t tmp_qloop_704 = tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_706 = tmp_qloop_140*tmp_qloop_703 + tmp_qloop_440*tmp_qloop_704;
                   const real_t tmp_qloop_707 = tmp_qloop_674 + tmp_qloop_706;
                   const real_t tmp_qloop_709 = tmp_qloop_347*1.0 + tmp_qloop_348*1.0 + tmp_qloop_349*1.0;
                   const real_t tmp_qloop_710 = tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_712 = tmp_qloop_140*tmp_qloop_709 + tmp_qloop_440*tmp_qloop_710;
                   const real_t tmp_qloop_713 = tmp_qloop_674 + tmp_qloop_712;
                   const real_t tmp_qloop_715 = tmp_qloop_361*1.0 + tmp_qloop_362*1.0 + tmp_qloop_363*1.0;
                   const real_t tmp_qloop_716 = tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_718 = tmp_qloop_140*tmp_qloop_715 + tmp_qloop_440*tmp_qloop_716;
                   const real_t tmp_qloop_719 = tmp_qloop_674 + tmp_qloop_718;
                   const real_t tmp_qloop_721 = tmp_qloop_375*1.0 + tmp_qloop_376*1.0 + tmp_qloop_377*1.0;
                   const real_t tmp_qloop_722 = tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_724 = tmp_qloop_140*tmp_qloop_721 + tmp_qloop_440*tmp_qloop_722;
                   const real_t tmp_qloop_725 = tmp_qloop_674 + tmp_qloop_724;
                   const real_t tmp_qloop_727 = tmp_qloop_389*1.0 + tmp_qloop_390*1.0 + tmp_qloop_391*1.0;
                   const real_t tmp_qloop_728 = tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_730 = tmp_qloop_140*tmp_qloop_727 + tmp_qloop_440*tmp_qloop_728;
                   const real_t tmp_qloop_731 = tmp_qloop_674 + tmp_qloop_730;
                   const real_t tmp_qloop_733 = tmp_qloop_403*1.0 + tmp_qloop_404*1.0 + tmp_qloop_405*1.0;
                   const real_t tmp_qloop_734 = tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_736 = tmp_qloop_140*tmp_qloop_733 + tmp_qloop_440*tmp_qloop_734;
                   const real_t tmp_qloop_737 = tmp_qloop_674 + tmp_qloop_736;
                   const real_t tmp_qloop_739 = tmp_qloop_417*1.0 + tmp_qloop_418*1.0 + tmp_qloop_419*1.0;
                   const real_t tmp_qloop_740 = tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_742 = tmp_qloop_140*tmp_qloop_739 + tmp_qloop_440*tmp_qloop_740;
                   const real_t tmp_qloop_743 = tmp_qloop_674 + tmp_qloop_742;
                   const real_t tmp_qloop_744 = tmp_qloop_116 + tmp_qloop_667;
                   const real_t tmp_qloop_749 = tmp_qloop_141 + tmp_qloop_440*(tmp_qloop_128 + tmp_qloop_671)*2.0 + tmp_qloop_674;
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_119 = tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_117);
                   const real_t tmp_qloop_132 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q];
                   const real_t tmp_qloop_138 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_137*2.0;
                   const real_t tmp_qloop_142 = tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0;
                   const real_t tmp_qloop_143 = tmp_qloop_142*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q];
                   const real_t tmp_qloop_151 = tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150;
                   const real_t tmp_qloop_153 = tmp_qloop_148*0.5 + tmp_qloop_149*0.5 + tmp_qloop_150*0.5;
                   const real_t tmp_qloop_154 = tmp_qloop_152*2.0 + tmp_qloop_153*2.0;
                   const real_t tmp_qloop_155 = tmp_qloop_141 + tmp_qloop_143 + tmp_qloop_154*(tmp_qloop_147 + tmp_qloop_151);
                   const real_t tmp_qloop_160 = tmp_qloop_114 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663;
                   const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_169 = tmp_qloop_136 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_173 = tmp_qloop_114 + tmp_qloop_170*0.66666666666666663 + tmp_qloop_171*0.66666666666666663 + tmp_qloop_172*0.66666666666666663;
                   const real_t tmp_qloop_181 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_182 = tmp_qloop_136 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_186 = tmp_qloop_114 + tmp_qloop_183*0.66666666666666663 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663;
                   const real_t tmp_qloop_194 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_195 = tmp_qloop_136 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_199 = tmp_qloop_114 + tmp_qloop_196*0.66666666666666663 + tmp_qloop_197*0.66666666666666663 + tmp_qloop_198*0.66666666666666663;
                   const real_t tmp_qloop_207 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_208 = tmp_qloop_136 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_212 = tmp_qloop_114 + tmp_qloop_209*0.66666666666666663 + tmp_qloop_210*0.66666666666666663 + tmp_qloop_211*0.66666666666666663;
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_221 = tmp_qloop_136 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_225 = tmp_qloop_114 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663 + tmp_qloop_224*0.66666666666666663;
                   const real_t tmp_qloop_233 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_234 = tmp_qloop_136 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_238 = tmp_qloop_114 + tmp_qloop_235*0.66666666666666663 + tmp_qloop_236*0.66666666666666663 + tmp_qloop_237*0.66666666666666663;
                   const real_t tmp_qloop_246 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_247 = tmp_qloop_136 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_251 = tmp_qloop_114 + tmp_qloop_248*0.66666666666666663 + tmp_qloop_249*0.66666666666666663 + tmp_qloop_250*0.66666666666666663;
                   const real_t tmp_qloop_259 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_260 = tmp_qloop_136 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_264 = tmp_qloop_114 + tmp_qloop_261*0.66666666666666663 + tmp_qloop_262*0.66666666666666663 + tmp_qloop_263*0.66666666666666663;
                   const real_t tmp_qloop_272 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_273 = tmp_qloop_136 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_281 = tmp_qloop_109 + tmp_qloop_280;
                   const real_t tmp_qloop_282 = tmp_qloop_274*0.66666666666666663 + tmp_qloop_275*0.66666666666666663 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_281;
                   const real_t tmp_qloop_295 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_296 = tmp_qloop_293 + tmp_qloop_294 + tmp_qloop_295;
                   const real_t tmp_qloop_297 = tmp_qloop_136 + tmp_qloop_296;
                   const real_t tmp_qloop_298 = tmp_qloop_138*tmp_qloop_297 + tmp_qloop_143 + tmp_qloop_292;
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_303 = tmp_qloop_147 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_304 = tmp_qloop_139*tmp_qloop_299 + tmp_qloop_154*tmp_qloop_303;
                   const real_t tmp_qloop_308 = tmp_qloop_281 + tmp_qloop_305*0.66666666666666663 + tmp_qloop_306*0.66666666666666663 + tmp_qloop_307*0.66666666666666663;
                   const real_t tmp_qloop_316 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_317 = tmp_qloop_147 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_318 = tmp_qloop_139*tmp_qloop_313 + tmp_qloop_154*tmp_qloop_317;
                   const real_t tmp_qloop_322 = tmp_qloop_281 + tmp_qloop_319*0.66666666666666663 + tmp_qloop_320*0.66666666666666663 + tmp_qloop_321*0.66666666666666663;
                   const real_t tmp_qloop_330 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_331 = tmp_qloop_147 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_332 = tmp_qloop_139*tmp_qloop_327 + tmp_qloop_154*tmp_qloop_331;
                   const real_t tmp_qloop_336 = tmp_qloop_281 + tmp_qloop_333*0.66666666666666663 + tmp_qloop_334*0.66666666666666663 + tmp_qloop_335*0.66666666666666663;
                   const real_t tmp_qloop_344 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_345 = tmp_qloop_147 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_346 = tmp_qloop_139*tmp_qloop_341 + tmp_qloop_154*tmp_qloop_345;
                   const real_t tmp_qloop_350 = tmp_qloop_281 + tmp_qloop_347*0.66666666666666663 + tmp_qloop_348*0.66666666666666663 + tmp_qloop_349*0.66666666666666663;
                   const real_t tmp_qloop_358 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_359 = tmp_qloop_147 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_360 = tmp_qloop_139*tmp_qloop_355 + tmp_qloop_154*tmp_qloop_359;
                   const real_t tmp_qloop_364 = tmp_qloop_281 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663 + tmp_qloop_363*0.66666666666666663;
                   const real_t tmp_qloop_372 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_373 = tmp_qloop_147 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_374 = tmp_qloop_139*tmp_qloop_369 + tmp_qloop_154*tmp_qloop_373;
                   const real_t tmp_qloop_378 = tmp_qloop_281 + tmp_qloop_375*0.66666666666666663 + tmp_qloop_376*0.66666666666666663 + tmp_qloop_377*0.66666666666666663;
                   const real_t tmp_qloop_386 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_387 = tmp_qloop_147 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_388 = tmp_qloop_139*tmp_qloop_383 + tmp_qloop_154*tmp_qloop_387;
                   const real_t tmp_qloop_392 = tmp_qloop_281 + tmp_qloop_389*0.66666666666666663 + tmp_qloop_390*0.66666666666666663 + tmp_qloop_391*0.66666666666666663;
                   const real_t tmp_qloop_400 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_401 = tmp_qloop_147 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_402 = tmp_qloop_139*tmp_qloop_397 + tmp_qloop_154*tmp_qloop_401;
                   const real_t tmp_qloop_406 = tmp_qloop_281 + tmp_qloop_403*0.66666666666666663 + tmp_qloop_404*0.66666666666666663 + tmp_qloop_405*0.66666666666666663;
                   const real_t tmp_qloop_414 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_415 = tmp_qloop_147 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_416 = tmp_qloop_139*tmp_qloop_411 + tmp_qloop_154*tmp_qloop_415;
                   const real_t tmp_qloop_420 = tmp_qloop_281 + tmp_qloop_417*0.66666666666666663 + tmp_qloop_418*0.66666666666666663 + tmp_qloop_419*0.66666666666666663;
                   const real_t tmp_qloop_428 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_429 = tmp_qloop_147 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_430 = tmp_qloop_139*tmp_qloop_425 + tmp_qloop_154*tmp_qloop_429;
                   const real_t tmp_qloop_433 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 1];
                   const real_t tmp_qloop_435 = tmp_qloop_431*0.66666666666666663 + tmp_qloop_432*0.66666666666666663 + tmp_qloop_433*0.66666666666666663 + tmp_qloop_434;
                   const real_t tmp_qloop_439 = tmp_qloop_296 + tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438;
                   const real_t tmp_qloop_442 = tmp_qloop_431*2.0 + tmp_qloop_432*2.0 + tmp_qloop_433*2.0;
                   const real_t tmp_qloop_443 = tmp_qloop_142*tmp_qloop_442;
                   const real_t tmp_qloop_447 = tmp_qloop_151 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_448 = tmp_qloop_154*tmp_qloop_447 + tmp_qloop_443;
                   const real_t tmp_qloop_451 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 2];
                   const real_t tmp_qloop_452 = tmp_qloop_434 + tmp_qloop_449*0.66666666666666663 + tmp_qloop_450*0.66666666666666663 + tmp_qloop_451*0.66666666666666663;
                   const real_t tmp_qloop_456 = tmp_qloop_296 + tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455;
                   const real_t tmp_qloop_457 = tmp_qloop_449*2.0 + tmp_qloop_450*2.0 + tmp_qloop_451*2.0;
                   const real_t tmp_qloop_458 = tmp_qloop_142*tmp_qloop_457;
                   const real_t tmp_qloop_462 = tmp_qloop_151 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_463 = tmp_qloop_154*tmp_qloop_462 + tmp_qloop_458;
                   const real_t tmp_qloop_466 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 3];
                   const real_t tmp_qloop_467 = tmp_qloop_434 + tmp_qloop_464*0.66666666666666663 + tmp_qloop_465*0.66666666666666663 + tmp_qloop_466*0.66666666666666663;
                   const real_t tmp_qloop_471 = tmp_qloop_296 + tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470;
                   const real_t tmp_qloop_472 = tmp_qloop_464*2.0 + tmp_qloop_465*2.0 + tmp_qloop_466*2.0;
                   const real_t tmp_qloop_473 = tmp_qloop_142*tmp_qloop_472;
                   const real_t tmp_qloop_477 = tmp_qloop_151 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_478 = tmp_qloop_154*tmp_qloop_477 + tmp_qloop_473;
                   const real_t tmp_qloop_481 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 4];
                   const real_t tmp_qloop_482 = tmp_qloop_434 + tmp_qloop_479*0.66666666666666663 + tmp_qloop_480*0.66666666666666663 + tmp_qloop_481*0.66666666666666663;
                   const real_t tmp_qloop_486 = tmp_qloop_296 + tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485;
                   const real_t tmp_qloop_487 = tmp_qloop_479*2.0 + tmp_qloop_480*2.0 + tmp_qloop_481*2.0;
                   const real_t tmp_qloop_488 = tmp_qloop_142*tmp_qloop_487;
                   const real_t tmp_qloop_492 = tmp_qloop_151 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_493 = tmp_qloop_154*tmp_qloop_492 + tmp_qloop_488;
                   const real_t tmp_qloop_496 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 5];
                   const real_t tmp_qloop_497 = tmp_qloop_434 + tmp_qloop_494*0.66666666666666663 + tmp_qloop_495*0.66666666666666663 + tmp_qloop_496*0.66666666666666663;
                   const real_t tmp_qloop_501 = tmp_qloop_296 + tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500;
                   const real_t tmp_qloop_502 = tmp_qloop_494*2.0 + tmp_qloop_495*2.0 + tmp_qloop_496*2.0;
                   const real_t tmp_qloop_503 = tmp_qloop_142*tmp_qloop_502;
                   const real_t tmp_qloop_507 = tmp_qloop_151 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_508 = tmp_qloop_154*tmp_qloop_507 + tmp_qloop_503;
                   const real_t tmp_qloop_511 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 6];
                   const real_t tmp_qloop_512 = tmp_qloop_434 + tmp_qloop_509*0.66666666666666663 + tmp_qloop_510*0.66666666666666663 + tmp_qloop_511*0.66666666666666663;
                   const real_t tmp_qloop_516 = tmp_qloop_296 + tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515;
                   const real_t tmp_qloop_517 = tmp_qloop_509*2.0 + tmp_qloop_510*2.0 + tmp_qloop_511*2.0;
                   const real_t tmp_qloop_518 = tmp_qloop_142*tmp_qloop_517;
                   const real_t tmp_qloop_522 = tmp_qloop_151 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_523 = tmp_qloop_154*tmp_qloop_522 + tmp_qloop_518;
                   const real_t tmp_qloop_526 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 7];
                   const real_t tmp_qloop_527 = tmp_qloop_434 + tmp_qloop_524*0.66666666666666663 + tmp_qloop_525*0.66666666666666663 + tmp_qloop_526*0.66666666666666663;
                   const real_t tmp_qloop_531 = tmp_qloop_296 + tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530;
                   const real_t tmp_qloop_532 = tmp_qloop_524*2.0 + tmp_qloop_525*2.0 + tmp_qloop_526*2.0;
                   const real_t tmp_qloop_533 = tmp_qloop_142*tmp_qloop_532;
                   const real_t tmp_qloop_537 = tmp_qloop_151 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_538 = tmp_qloop_154*tmp_qloop_537 + tmp_qloop_533;
                   const real_t tmp_qloop_541 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 8];
                   const real_t tmp_qloop_542 = tmp_qloop_434 + tmp_qloop_539*0.66666666666666663 + tmp_qloop_540*0.66666666666666663 + tmp_qloop_541*0.66666666666666663;
                   const real_t tmp_qloop_546 = tmp_qloop_296 + tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545;
                   const real_t tmp_qloop_547 = tmp_qloop_539*2.0 + tmp_qloop_540*2.0 + tmp_qloop_541*2.0;
                   const real_t tmp_qloop_548 = tmp_qloop_142*tmp_qloop_547;
                   const real_t tmp_qloop_552 = tmp_qloop_151 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_553 = tmp_qloop_154*tmp_qloop_552 + tmp_qloop_548;
                   const real_t tmp_qloop_556 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 9];
                   const real_t tmp_qloop_557 = tmp_qloop_434 + tmp_qloop_554*0.66666666666666663 + tmp_qloop_555*0.66666666666666663 + tmp_qloop_556*0.66666666666666663;
                   const real_t tmp_qloop_561 = tmp_qloop_296 + tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560;
                   const real_t tmp_qloop_562 = tmp_qloop_554*2.0 + tmp_qloop_555*2.0 + tmp_qloop_556*2.0;
                   const real_t tmp_qloop_563 = tmp_qloop_142*tmp_qloop_562;
                   const real_t tmp_qloop_567 = tmp_qloop_151 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t tmp_qloop_568 = tmp_qloop_154*tmp_qloop_567 + tmp_qloop_563;
                   const real_t tmp_qloop_571 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[11*q + 10];
                   const real_t tmp_qloop_572 = tmp_qloop_434 + tmp_qloop_569*0.66666666666666663 + tmp_qloop_570*0.66666666666666663 + tmp_qloop_571*0.66666666666666663;
                   const real_t tmp_qloop_576 = tmp_qloop_296 + tmp_qloop_573 + tmp_qloop_574 + tmp_qloop_575;
                   const real_t tmp_qloop_577 = tmp_qloop_569*2.0 + tmp_qloop_570*2.0 + tmp_qloop_571*2.0;
                   const real_t tmp_qloop_578 = tmp_qloop_142*tmp_qloop_577;
                   const real_t tmp_qloop_582 = tmp_qloop_151 + tmp_qloop_579 + tmp_qloop_580 + tmp_qloop_581;
                   const real_t tmp_qloop_583 = tmp_qloop_154*tmp_qloop_582 + tmp_qloop_578;
                   const real_t tmp_qloop_584 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159);
                   const real_t tmp_qloop_587 = tmp_qloop_137*2.0 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_588 = tmp_qloop_143 + tmp_qloop_304;
                   const real_t tmp_qloop_590 = tmp_qloop_297*tmp_qloop_587 + tmp_qloop_589;
                   const real_t tmp_qloop_591 = tmp_qloop_143 + tmp_qloop_590;
                   const real_t tmp_qloop_592 = tmp_qloop_141 + tmp_qloop_448;
                   const real_t tmp_qloop_595 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172);
                   const real_t tmp_qloop_598 = tmp_qloop_137*2.0 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_600 = tmp_qloop_297*tmp_qloop_598 + tmp_qloop_599;
                   const real_t tmp_qloop_601 = tmp_qloop_143 + tmp_qloop_600;
                   const real_t tmp_qloop_604 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_183 + tmp_qloop_184 + tmp_qloop_185);
                   const real_t tmp_qloop_607 = tmp_qloop_137*2.0 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_609 = tmp_qloop_297*tmp_qloop_607 + tmp_qloop_608;
                   const real_t tmp_qloop_610 = tmp_qloop_143 + tmp_qloop_609;
                   const real_t tmp_qloop_613 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198);
                   const real_t tmp_qloop_616 = tmp_qloop_137*2.0 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_618 = tmp_qloop_297*tmp_qloop_616 + tmp_qloop_617;
                   const real_t tmp_qloop_619 = tmp_qloop_143 + tmp_qloop_618;
                   const real_t tmp_qloop_622 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211);
                   const real_t tmp_qloop_625 = tmp_qloop_137*2.0 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_627 = tmp_qloop_297*tmp_qloop_625 + tmp_qloop_626;
                   const real_t tmp_qloop_628 = tmp_qloop_143 + tmp_qloop_627;
                   const real_t tmp_qloop_631 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_222 + tmp_qloop_223 + tmp_qloop_224);
                   const real_t tmp_qloop_634 = tmp_qloop_137*2.0 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_636 = tmp_qloop_297*tmp_qloop_634 + tmp_qloop_635;
                   const real_t tmp_qloop_637 = tmp_qloop_143 + tmp_qloop_636;
                   const real_t tmp_qloop_640 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_235 + tmp_qloop_236 + tmp_qloop_237);
                   const real_t tmp_qloop_643 = tmp_qloop_137*2.0 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_645 = tmp_qloop_297*tmp_qloop_643 + tmp_qloop_644;
                   const real_t tmp_qloop_646 = tmp_qloop_143 + tmp_qloop_645;
                   const real_t tmp_qloop_649 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250);
                   const real_t tmp_qloop_652 = tmp_qloop_137*2.0 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_654 = tmp_qloop_297*tmp_qloop_652 + tmp_qloop_653;
                   const real_t tmp_qloop_655 = tmp_qloop_143 + tmp_qloop_654;
                   const real_t tmp_qloop_658 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263);
                   const real_t tmp_qloop_661 = tmp_qloop_137*2.0 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_663 = tmp_qloop_297*tmp_qloop_661 + tmp_qloop_662;
                   const real_t tmp_qloop_664 = tmp_qloop_143 + tmp_qloop_663;
                   const real_t tmp_qloop_668 = tmp_qloop_115 + tmp_qloop_667;
                   const real_t tmp_qloop_669 = tmp_qloop_118*(tmp_qloop_274 + tmp_qloop_275 + tmp_qloop_276 + tmp_qloop_668);
                   const real_t tmp_qloop_673 = tmp_qloop_152*2.0 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_675 = tmp_qloop_293*0.5 + tmp_qloop_294*0.5 + tmp_qloop_295*0.5;
                   const real_t tmp_qloop_676 = tmp_qloop_137*2.0 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_677 = tmp_qloop_143 + tmp_qloop_297*tmp_qloop_676 + tmp_qloop_674;
                   const real_t tmp_qloop_679 = tmp_qloop_439*tmp_qloop_676 + tmp_qloop_443;
                   const real_t tmp_qloop_680 = tmp_qloop_456*tmp_qloop_676 + tmp_qloop_458;
                   const real_t tmp_qloop_681 = tmp_qloop_471*tmp_qloop_676 + tmp_qloop_473;
                   const real_t tmp_qloop_682 = tmp_qloop_486*tmp_qloop_676 + tmp_qloop_488;
                   const real_t tmp_qloop_683 = tmp_qloop_501*tmp_qloop_676 + tmp_qloop_503;
                   const real_t tmp_qloop_684 = tmp_qloop_516*tmp_qloop_676 + tmp_qloop_518;
                   const real_t tmp_qloop_685 = tmp_qloop_531*tmp_qloop_676 + tmp_qloop_533;
                   const real_t tmp_qloop_686 = tmp_qloop_546*tmp_qloop_676 + tmp_qloop_548;
                   const real_t tmp_qloop_687 = tmp_qloop_561*tmp_qloop_676 + tmp_qloop_563;
                   const real_t tmp_qloop_688 = tmp_qloop_576*tmp_qloop_676 + tmp_qloop_578;
                   const real_t tmp_qloop_689 = tmp_qloop_118*(tmp_qloop_305 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_668);
                   const real_t tmp_qloop_692 = tmp_qloop_152*2.0 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_693 = tmp_qloop_674 + tmp_qloop_679;
                   const real_t tmp_qloop_696 = tmp_qloop_118*(tmp_qloop_319 + tmp_qloop_320 + tmp_qloop_321 + tmp_qloop_668);
                   const real_t tmp_qloop_699 = tmp_qloop_152*2.0 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_702 = tmp_qloop_118*(tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335 + tmp_qloop_668);
                   const real_t tmp_qloop_705 = tmp_qloop_152*2.0 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_708 = tmp_qloop_118*(tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349 + tmp_qloop_668);
                   const real_t tmp_qloop_711 = tmp_qloop_152*2.0 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_714 = tmp_qloop_118*(tmp_qloop_361 + tmp_qloop_362 + tmp_qloop_363 + tmp_qloop_668);
                   const real_t tmp_qloop_717 = tmp_qloop_152*2.0 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_720 = tmp_qloop_118*(tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377 + tmp_qloop_668);
                   const real_t tmp_qloop_723 = tmp_qloop_152*2.0 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_726 = tmp_qloop_118*(tmp_qloop_389 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_668);
                   const real_t tmp_qloop_729 = tmp_qloop_152*2.0 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_732 = tmp_qloop_118*(tmp_qloop_403 + tmp_qloop_404 + tmp_qloop_405 + tmp_qloop_668);
                   const real_t tmp_qloop_735 = tmp_qloop_152*2.0 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_738 = tmp_qloop_118*(tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419 + tmp_qloop_668);
                   const real_t tmp_qloop_741 = tmp_qloop_152*2.0 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_745 = tmp_qloop_118*(tmp_qloop_431 + tmp_qloop_432 + tmp_qloop_433 + tmp_qloop_744);
                   const real_t tmp_qloop_746 = tmp_qloop_431*1.0 + tmp_qloop_432*1.0 + tmp_qloop_433*1.0;
                   const real_t tmp_qloop_747 = tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_748 = tmp_qloop_153*2.0 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_750 = tmp_qloop_118*(tmp_qloop_449 + tmp_qloop_450 + tmp_qloop_451 + tmp_qloop_744);
                   const real_t tmp_qloop_751 = tmp_qloop_449*1.0 + tmp_qloop_450*1.0 + tmp_qloop_451*1.0;
                   const real_t tmp_qloop_752 = tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_753 = tmp_qloop_153*2.0 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_754 = tmp_qloop_118*(tmp_qloop_464 + tmp_qloop_465 + tmp_qloop_466 + tmp_qloop_744);
                   const real_t tmp_qloop_755 = tmp_qloop_464*1.0 + tmp_qloop_465*1.0 + tmp_qloop_466*1.0;
                   const real_t tmp_qloop_756 = tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_757 = tmp_qloop_153*2.0 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_758 = tmp_qloop_118*(tmp_qloop_479 + tmp_qloop_480 + tmp_qloop_481 + tmp_qloop_744);
                   const real_t tmp_qloop_759 = tmp_qloop_479*1.0 + tmp_qloop_480*1.0 + tmp_qloop_481*1.0;
                   const real_t tmp_qloop_760 = tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_761 = tmp_qloop_153*2.0 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_762 = tmp_qloop_118*(tmp_qloop_494 + tmp_qloop_495 + tmp_qloop_496 + tmp_qloop_744);
                   const real_t tmp_qloop_763 = tmp_qloop_494*1.0 + tmp_qloop_495*1.0 + tmp_qloop_496*1.0;
                   const real_t tmp_qloop_764 = tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_765 = tmp_qloop_153*2.0 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_766 = tmp_qloop_118*(tmp_qloop_509 + tmp_qloop_510 + tmp_qloop_511 + tmp_qloop_744);
                   const real_t tmp_qloop_767 = tmp_qloop_509*1.0 + tmp_qloop_510*1.0 + tmp_qloop_511*1.0;
                   const real_t tmp_qloop_768 = tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_769 = tmp_qloop_153*2.0 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_770 = tmp_qloop_118*(tmp_qloop_524 + tmp_qloop_525 + tmp_qloop_526 + tmp_qloop_744);
                   const real_t tmp_qloop_771 = tmp_qloop_524*1.0 + tmp_qloop_525*1.0 + tmp_qloop_526*1.0;
                   const real_t tmp_qloop_772 = tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_773 = tmp_qloop_153*2.0 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_774 = tmp_qloop_118*(tmp_qloop_539 + tmp_qloop_540 + tmp_qloop_541 + tmp_qloop_744);
                   const real_t tmp_qloop_775 = tmp_qloop_539*1.0 + tmp_qloop_540*1.0 + tmp_qloop_541*1.0;
                   const real_t tmp_qloop_776 = tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_777 = tmp_qloop_153*2.0 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_778 = tmp_qloop_118*(tmp_qloop_554 + tmp_qloop_555 + tmp_qloop_556 + tmp_qloop_744);
                   const real_t tmp_qloop_779 = tmp_qloop_554*1.0 + tmp_qloop_555*1.0 + tmp_qloop_556*1.0;
                   const real_t tmp_qloop_780 = tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_781 = tmp_qloop_153*2.0 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + tmp_qloop_129*(tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_127) + tmp_qloop_138*(tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_136) + tmp_qloop_155) - tmp_qloop_119*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_114));
                   const real_t q_tmp_0_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_161 + tmp_qloop_129*tmp_qloop_165 + tmp_qloop_138*tmp_qloop_169 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_160);
                   const real_t q_tmp_0_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_174 + tmp_qloop_129*tmp_qloop_178 + tmp_qloop_138*tmp_qloop_182 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_173);
                   const real_t q_tmp_0_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_187 + tmp_qloop_129*tmp_qloop_191 + tmp_qloop_138*tmp_qloop_195 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_186);
                   const real_t q_tmp_0_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_200 + tmp_qloop_129*tmp_qloop_204 + tmp_qloop_138*tmp_qloop_208 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_199);
                   const real_t q_tmp_0_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_213 + tmp_qloop_129*tmp_qloop_217 + tmp_qloop_138*tmp_qloop_221 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_212);
                   const real_t q_tmp_0_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_226 + tmp_qloop_129*tmp_qloop_230 + tmp_qloop_138*tmp_qloop_234 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_225);
                   const real_t q_tmp_0_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_239 + tmp_qloop_129*tmp_qloop_243 + tmp_qloop_138*tmp_qloop_247 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_238);
                   const real_t q_tmp_0_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_252 + tmp_qloop_129*tmp_qloop_256 + tmp_qloop_138*tmp_qloop_260 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_251);
                   const real_t q_tmp_0_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_265 + tmp_qloop_129*tmp_qloop_269 + tmp_qloop_138*tmp_qloop_273 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_264);
                   const real_t q_tmp_0_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_290 + tmp_qloop_298 + tmp_qloop_304) - tmp_qloop_119*tmp_qloop_282);
                   const real_t q_tmp_0_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_312 + tmp_qloop_298 + tmp_qloop_318) - tmp_qloop_119*tmp_qloop_308);
                   const real_t q_tmp_0_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_326 + tmp_qloop_298 + tmp_qloop_332) - tmp_qloop_119*tmp_qloop_322);
                   const real_t q_tmp_0_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_340 + tmp_qloop_298 + tmp_qloop_346) - tmp_qloop_119*tmp_qloop_336);
                   const real_t q_tmp_0_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_354 + tmp_qloop_298 + tmp_qloop_360) - tmp_qloop_119*tmp_qloop_350);
                   const real_t q_tmp_0_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_368 + tmp_qloop_298 + tmp_qloop_374) - tmp_qloop_119*tmp_qloop_364);
                   const real_t q_tmp_0_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_382 + tmp_qloop_298 + tmp_qloop_388) - tmp_qloop_119*tmp_qloop_378);
                   const real_t q_tmp_0_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_396 + tmp_qloop_298 + tmp_qloop_402) - tmp_qloop_119*tmp_qloop_392);
                   const real_t q_tmp_0_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_410 + tmp_qloop_298 + tmp_qloop_416) - tmp_qloop_119*tmp_qloop_406);
                   const real_t q_tmp_0_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_424 + tmp_qloop_298 + tmp_qloop_430) - tmp_qloop_119*tmp_qloop_420);
                   const real_t q_tmp_0_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_439 + tmp_qloop_441 + tmp_qloop_448) - tmp_qloop_119*tmp_qloop_435);
                   const real_t q_tmp_0_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_456 + tmp_qloop_441 + tmp_qloop_463) - tmp_qloop_119*tmp_qloop_452);
                   const real_t q_tmp_0_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_471 + tmp_qloop_441 + tmp_qloop_478) - tmp_qloop_119*tmp_qloop_467);
                   const real_t q_tmp_0_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_486 + tmp_qloop_441 + tmp_qloop_493) - tmp_qloop_119*tmp_qloop_482);
                   const real_t q_tmp_0_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_501 + tmp_qloop_441 + tmp_qloop_508) - tmp_qloop_119*tmp_qloop_497);
                   const real_t q_tmp_0_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_516 + tmp_qloop_441 + tmp_qloop_523) - tmp_qloop_119*tmp_qloop_512);
                   const real_t q_tmp_0_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_531 + tmp_qloop_441 + tmp_qloop_538) - tmp_qloop_119*tmp_qloop_527);
                   const real_t q_tmp_0_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_546 + tmp_qloop_441 + tmp_qloop_553) - tmp_qloop_119*tmp_qloop_542);
                   const real_t q_tmp_0_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_561 + tmp_qloop_441 + tmp_qloop_568) - tmp_qloop_119*tmp_qloop_557);
                   const real_t q_tmp_0_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_576 + tmp_qloop_441 + tmp_qloop_583) - tmp_qloop_119*tmp_qloop_572);
                   const real_t q_tmp_1_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_161*tmp_qloop_585 + tmp_qloop_165*tmp_qloop_586 + tmp_qloop_169*tmp_qloop_587) - tmp_qloop_160*tmp_qloop_584);
                   const real_t q_tmp_1_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_585 + tmp_qloop_178*tmp_qloop_586 + tmp_qloop_182*tmp_qloop_587) - tmp_qloop_173*tmp_qloop_584);
                   const real_t q_tmp_1_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_585 + tmp_qloop_191*tmp_qloop_586 + tmp_qloop_195*tmp_qloop_587) - tmp_qloop_186*tmp_qloop_584);
                   const real_t q_tmp_1_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_585 + tmp_qloop_204*tmp_qloop_586 + tmp_qloop_208*tmp_qloop_587) - tmp_qloop_199*tmp_qloop_584);
                   const real_t q_tmp_1_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_585 + tmp_qloop_217*tmp_qloop_586 + tmp_qloop_221*tmp_qloop_587) - tmp_qloop_212*tmp_qloop_584);
                   const real_t q_tmp_1_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_585 + tmp_qloop_230*tmp_qloop_586 + tmp_qloop_234*tmp_qloop_587) - tmp_qloop_225*tmp_qloop_584);
                   const real_t q_tmp_1_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_585 + tmp_qloop_243*tmp_qloop_586 + tmp_qloop_247*tmp_qloop_587) - tmp_qloop_238*tmp_qloop_584);
                   const real_t q_tmp_1_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_585 + tmp_qloop_256*tmp_qloop_586 + tmp_qloop_260*tmp_qloop_587) - tmp_qloop_251*tmp_qloop_584);
                   const real_t q_tmp_1_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_585 + tmp_qloop_269*tmp_qloop_586 + tmp_qloop_273*tmp_qloop_587) - tmp_qloop_264*tmp_qloop_584);
                   const real_t q_tmp_1_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_586 + tmp_qloop_588 + tmp_qloop_590) - tmp_qloop_282*tmp_qloop_584);
                   const real_t q_tmp_1_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_586 + tmp_qloop_318 + tmp_qloop_591) - tmp_qloop_308*tmp_qloop_584);
                   const real_t q_tmp_1_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_586 + tmp_qloop_332 + tmp_qloop_591) - tmp_qloop_322*tmp_qloop_584);
                   const real_t q_tmp_1_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_586 + tmp_qloop_346 + tmp_qloop_591) - tmp_qloop_336*tmp_qloop_584);
                   const real_t q_tmp_1_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_586 + tmp_qloop_360 + tmp_qloop_591) - tmp_qloop_350*tmp_qloop_584);
                   const real_t q_tmp_1_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_586 + tmp_qloop_374 + tmp_qloop_591) - tmp_qloop_364*tmp_qloop_584);
                   const real_t q_tmp_1_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_586 + tmp_qloop_388 + tmp_qloop_591) - tmp_qloop_378*tmp_qloop_584);
                   const real_t q_tmp_1_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_586 + tmp_qloop_402 + tmp_qloop_591) - tmp_qloop_392*tmp_qloop_584);
                   const real_t q_tmp_1_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_586 + tmp_qloop_416 + tmp_qloop_591) - tmp_qloop_406*tmp_qloop_584);
                   const real_t q_tmp_1_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_586 + tmp_qloop_430 + tmp_qloop_591) - tmp_qloop_420*tmp_qloop_584);
                   const real_t q_tmp_1_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_587 + tmp_qloop_592 + tmp_qloop_593) - tmp_qloop_435*tmp_qloop_584);
                   const real_t q_tmp_1_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_587 + tmp_qloop_463 + tmp_qloop_594) - tmp_qloop_452*tmp_qloop_584);
                   const real_t q_tmp_1_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_587 + tmp_qloop_478 + tmp_qloop_594) - tmp_qloop_467*tmp_qloop_584);
                   const real_t q_tmp_1_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_587 + tmp_qloop_493 + tmp_qloop_594) - tmp_qloop_482*tmp_qloop_584);
                   const real_t q_tmp_1_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_587 + tmp_qloop_508 + tmp_qloop_594) - tmp_qloop_497*tmp_qloop_584);
                   const real_t q_tmp_1_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_587 + tmp_qloop_523 + tmp_qloop_594) - tmp_qloop_512*tmp_qloop_584);
                   const real_t q_tmp_1_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_587 + tmp_qloop_538 + tmp_qloop_594) - tmp_qloop_527*tmp_qloop_584);
                   const real_t q_tmp_1_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_587 + tmp_qloop_553 + tmp_qloop_594) - tmp_qloop_542*tmp_qloop_584);
                   const real_t q_tmp_1_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_587 + tmp_qloop_568 + tmp_qloop_594) - tmp_qloop_557*tmp_qloop_584);
                   const real_t q_tmp_1_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_587 + tmp_qloop_583 + tmp_qloop_594) - tmp_qloop_572*tmp_qloop_584);
                   const real_t q_tmp_2_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_596 + tmp_qloop_178*tmp_qloop_597 + tmp_qloop_182*tmp_qloop_598) - tmp_qloop_173*tmp_qloop_595);
                   const real_t q_tmp_2_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_596 + tmp_qloop_191*tmp_qloop_597 + tmp_qloop_195*tmp_qloop_598) - tmp_qloop_186*tmp_qloop_595);
                   const real_t q_tmp_2_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_596 + tmp_qloop_204*tmp_qloop_597 + tmp_qloop_208*tmp_qloop_598) - tmp_qloop_199*tmp_qloop_595);
                   const real_t q_tmp_2_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_596 + tmp_qloop_217*tmp_qloop_597 + tmp_qloop_221*tmp_qloop_598) - tmp_qloop_212*tmp_qloop_595);
                   const real_t q_tmp_2_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_596 + tmp_qloop_230*tmp_qloop_597 + tmp_qloop_234*tmp_qloop_598) - tmp_qloop_225*tmp_qloop_595);
                   const real_t q_tmp_2_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_596 + tmp_qloop_243*tmp_qloop_597 + tmp_qloop_247*tmp_qloop_598) - tmp_qloop_238*tmp_qloop_595);
                   const real_t q_tmp_2_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_596 + tmp_qloop_256*tmp_qloop_597 + tmp_qloop_260*tmp_qloop_598) - tmp_qloop_251*tmp_qloop_595);
                   const real_t q_tmp_2_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_596 + tmp_qloop_269*tmp_qloop_597 + tmp_qloop_273*tmp_qloop_598) - tmp_qloop_264*tmp_qloop_595);
                   const real_t q_tmp_2_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_597 + tmp_qloop_588 + tmp_qloop_600) - tmp_qloop_282*tmp_qloop_595);
                   const real_t q_tmp_2_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_597 + tmp_qloop_318 + tmp_qloop_601) - tmp_qloop_308*tmp_qloop_595);
                   const real_t q_tmp_2_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_597 + tmp_qloop_332 + tmp_qloop_601) - tmp_qloop_322*tmp_qloop_595);
                   const real_t q_tmp_2_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_597 + tmp_qloop_346 + tmp_qloop_601) - tmp_qloop_336*tmp_qloop_595);
                   const real_t q_tmp_2_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_597 + tmp_qloop_360 + tmp_qloop_601) - tmp_qloop_350*tmp_qloop_595);
                   const real_t q_tmp_2_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_597 + tmp_qloop_374 + tmp_qloop_601) - tmp_qloop_364*tmp_qloop_595);
                   const real_t q_tmp_2_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_597 + tmp_qloop_388 + tmp_qloop_601) - tmp_qloop_378*tmp_qloop_595);
                   const real_t q_tmp_2_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_597 + tmp_qloop_402 + tmp_qloop_601) - tmp_qloop_392*tmp_qloop_595);
                   const real_t q_tmp_2_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_597 + tmp_qloop_416 + tmp_qloop_601) - tmp_qloop_406*tmp_qloop_595);
                   const real_t q_tmp_2_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_597 + tmp_qloop_430 + tmp_qloop_601) - tmp_qloop_420*tmp_qloop_595);
                   const real_t q_tmp_2_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_598 + tmp_qloop_592 + tmp_qloop_602) - tmp_qloop_435*tmp_qloop_595);
                   const real_t q_tmp_2_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_598 + tmp_qloop_463 + tmp_qloop_603) - tmp_qloop_452*tmp_qloop_595);
                   const real_t q_tmp_2_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_598 + tmp_qloop_478 + tmp_qloop_603) - tmp_qloop_467*tmp_qloop_595);
                   const real_t q_tmp_2_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_598 + tmp_qloop_493 + tmp_qloop_603) - tmp_qloop_482*tmp_qloop_595);
                   const real_t q_tmp_2_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_598 + tmp_qloop_508 + tmp_qloop_603) - tmp_qloop_497*tmp_qloop_595);
                   const real_t q_tmp_2_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_598 + tmp_qloop_523 + tmp_qloop_603) - tmp_qloop_512*tmp_qloop_595);
                   const real_t q_tmp_2_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_598 + tmp_qloop_538 + tmp_qloop_603) - tmp_qloop_527*tmp_qloop_595);
                   const real_t q_tmp_2_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_598 + tmp_qloop_553 + tmp_qloop_603) - tmp_qloop_542*tmp_qloop_595);
                   const real_t q_tmp_2_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_598 + tmp_qloop_568 + tmp_qloop_603) - tmp_qloop_557*tmp_qloop_595);
                   const real_t q_tmp_2_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_598 + tmp_qloop_583 + tmp_qloop_603) - tmp_qloop_572*tmp_qloop_595);
                   const real_t q_tmp_3_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_605 + tmp_qloop_191*tmp_qloop_606 + tmp_qloop_195*tmp_qloop_607) - tmp_qloop_186*tmp_qloop_604);
                   const real_t q_tmp_3_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_605 + tmp_qloop_204*tmp_qloop_606 + tmp_qloop_208*tmp_qloop_607) - tmp_qloop_199*tmp_qloop_604);
                   const real_t q_tmp_3_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_605 + tmp_qloop_217*tmp_qloop_606 + tmp_qloop_221*tmp_qloop_607) - tmp_qloop_212*tmp_qloop_604);
                   const real_t q_tmp_3_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_605 + tmp_qloop_230*tmp_qloop_606 + tmp_qloop_234*tmp_qloop_607) - tmp_qloop_225*tmp_qloop_604);
                   const real_t q_tmp_3_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_605 + tmp_qloop_243*tmp_qloop_606 + tmp_qloop_247*tmp_qloop_607) - tmp_qloop_238*tmp_qloop_604);
                   const real_t q_tmp_3_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_605 + tmp_qloop_256*tmp_qloop_606 + tmp_qloop_260*tmp_qloop_607) - tmp_qloop_251*tmp_qloop_604);
                   const real_t q_tmp_3_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_605 + tmp_qloop_269*tmp_qloop_606 + tmp_qloop_273*tmp_qloop_607) - tmp_qloop_264*tmp_qloop_604);
                   const real_t q_tmp_3_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_606 + tmp_qloop_588 + tmp_qloop_609) - tmp_qloop_282*tmp_qloop_604);
                   const real_t q_tmp_3_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_606 + tmp_qloop_318 + tmp_qloop_610) - tmp_qloop_308*tmp_qloop_604);
                   const real_t q_tmp_3_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_606 + tmp_qloop_332 + tmp_qloop_610) - tmp_qloop_322*tmp_qloop_604);
                   const real_t q_tmp_3_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_606 + tmp_qloop_346 + tmp_qloop_610) - tmp_qloop_336*tmp_qloop_604);
                   const real_t q_tmp_3_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_606 + tmp_qloop_360 + tmp_qloop_610) - tmp_qloop_350*tmp_qloop_604);
                   const real_t q_tmp_3_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_606 + tmp_qloop_374 + tmp_qloop_610) - tmp_qloop_364*tmp_qloop_604);
                   const real_t q_tmp_3_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_606 + tmp_qloop_388 + tmp_qloop_610) - tmp_qloop_378*tmp_qloop_604);
                   const real_t q_tmp_3_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_606 + tmp_qloop_402 + tmp_qloop_610) - tmp_qloop_392*tmp_qloop_604);
                   const real_t q_tmp_3_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_606 + tmp_qloop_416 + tmp_qloop_610) - tmp_qloop_406*tmp_qloop_604);
                   const real_t q_tmp_3_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_606 + tmp_qloop_430 + tmp_qloop_610) - tmp_qloop_420*tmp_qloop_604);
                   const real_t q_tmp_3_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_607 + tmp_qloop_592 + tmp_qloop_611) - tmp_qloop_435*tmp_qloop_604);
                   const real_t q_tmp_3_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_607 + tmp_qloop_463 + tmp_qloop_612) - tmp_qloop_452*tmp_qloop_604);
                   const real_t q_tmp_3_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_607 + tmp_qloop_478 + tmp_qloop_612) - tmp_qloop_467*tmp_qloop_604);
                   const real_t q_tmp_3_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_607 + tmp_qloop_493 + tmp_qloop_612) - tmp_qloop_482*tmp_qloop_604);
                   const real_t q_tmp_3_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_607 + tmp_qloop_508 + tmp_qloop_612) - tmp_qloop_497*tmp_qloop_604);
                   const real_t q_tmp_3_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_607 + tmp_qloop_523 + tmp_qloop_612) - tmp_qloop_512*tmp_qloop_604);
                   const real_t q_tmp_3_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_607 + tmp_qloop_538 + tmp_qloop_612) - tmp_qloop_527*tmp_qloop_604);
                   const real_t q_tmp_3_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_607 + tmp_qloop_553 + tmp_qloop_612) - tmp_qloop_542*tmp_qloop_604);
                   const real_t q_tmp_3_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_607 + tmp_qloop_568 + tmp_qloop_612) - tmp_qloop_557*tmp_qloop_604);
                   const real_t q_tmp_3_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_607 + tmp_qloop_583 + tmp_qloop_612) - tmp_qloop_572*tmp_qloop_604);
                   const real_t q_tmp_4_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_614 + tmp_qloop_204*tmp_qloop_615 + tmp_qloop_208*tmp_qloop_616) - tmp_qloop_199*tmp_qloop_613);
                   const real_t q_tmp_4_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_614 + tmp_qloop_217*tmp_qloop_615 + tmp_qloop_221*tmp_qloop_616) - tmp_qloop_212*tmp_qloop_613);
                   const real_t q_tmp_4_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_614 + tmp_qloop_230*tmp_qloop_615 + tmp_qloop_234*tmp_qloop_616) - tmp_qloop_225*tmp_qloop_613);
                   const real_t q_tmp_4_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_614 + tmp_qloop_243*tmp_qloop_615 + tmp_qloop_247*tmp_qloop_616) - tmp_qloop_238*tmp_qloop_613);
                   const real_t q_tmp_4_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_614 + tmp_qloop_256*tmp_qloop_615 + tmp_qloop_260*tmp_qloop_616) - tmp_qloop_251*tmp_qloop_613);
                   const real_t q_tmp_4_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_614 + tmp_qloop_269*tmp_qloop_615 + tmp_qloop_273*tmp_qloop_616) - tmp_qloop_264*tmp_qloop_613);
                   const real_t q_tmp_4_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_615 + tmp_qloop_588 + tmp_qloop_618) - tmp_qloop_282*tmp_qloop_613);
                   const real_t q_tmp_4_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_615 + tmp_qloop_318 + tmp_qloop_619) - tmp_qloop_308*tmp_qloop_613);
                   const real_t q_tmp_4_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_615 + tmp_qloop_332 + tmp_qloop_619) - tmp_qloop_322*tmp_qloop_613);
                   const real_t q_tmp_4_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_615 + tmp_qloop_346 + tmp_qloop_619) - tmp_qloop_336*tmp_qloop_613);
                   const real_t q_tmp_4_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_615 + tmp_qloop_360 + tmp_qloop_619) - tmp_qloop_350*tmp_qloop_613);
                   const real_t q_tmp_4_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_615 + tmp_qloop_374 + tmp_qloop_619) - tmp_qloop_364*tmp_qloop_613);
                   const real_t q_tmp_4_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_615 + tmp_qloop_388 + tmp_qloop_619) - tmp_qloop_378*tmp_qloop_613);
                   const real_t q_tmp_4_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_615 + tmp_qloop_402 + tmp_qloop_619) - tmp_qloop_392*tmp_qloop_613);
                   const real_t q_tmp_4_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_615 + tmp_qloop_416 + tmp_qloop_619) - tmp_qloop_406*tmp_qloop_613);
                   const real_t q_tmp_4_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_615 + tmp_qloop_430 + tmp_qloop_619) - tmp_qloop_420*tmp_qloop_613);
                   const real_t q_tmp_4_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_616 + tmp_qloop_592 + tmp_qloop_620) - tmp_qloop_435*tmp_qloop_613);
                   const real_t q_tmp_4_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_616 + tmp_qloop_463 + tmp_qloop_621) - tmp_qloop_452*tmp_qloop_613);
                   const real_t q_tmp_4_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_616 + tmp_qloop_478 + tmp_qloop_621) - tmp_qloop_467*tmp_qloop_613);
                   const real_t q_tmp_4_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_616 + tmp_qloop_493 + tmp_qloop_621) - tmp_qloop_482*tmp_qloop_613);
                   const real_t q_tmp_4_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_616 + tmp_qloop_508 + tmp_qloop_621) - tmp_qloop_497*tmp_qloop_613);
                   const real_t q_tmp_4_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_616 + tmp_qloop_523 + tmp_qloop_621) - tmp_qloop_512*tmp_qloop_613);
                   const real_t q_tmp_4_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_616 + tmp_qloop_538 + tmp_qloop_621) - tmp_qloop_527*tmp_qloop_613);
                   const real_t q_tmp_4_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_616 + tmp_qloop_553 + tmp_qloop_621) - tmp_qloop_542*tmp_qloop_613);
                   const real_t q_tmp_4_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_616 + tmp_qloop_568 + tmp_qloop_621) - tmp_qloop_557*tmp_qloop_613);
                   const real_t q_tmp_4_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_616 + tmp_qloop_583 + tmp_qloop_621) - tmp_qloop_572*tmp_qloop_613);
                   const real_t q_tmp_5_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_623 + tmp_qloop_217*tmp_qloop_624 + tmp_qloop_221*tmp_qloop_625) - tmp_qloop_212*tmp_qloop_622);
                   const real_t q_tmp_5_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_623 + tmp_qloop_230*tmp_qloop_624 + tmp_qloop_234*tmp_qloop_625) - tmp_qloop_225*tmp_qloop_622);
                   const real_t q_tmp_5_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_623 + tmp_qloop_243*tmp_qloop_624 + tmp_qloop_247*tmp_qloop_625) - tmp_qloop_238*tmp_qloop_622);
                   const real_t q_tmp_5_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_623 + tmp_qloop_256*tmp_qloop_624 + tmp_qloop_260*tmp_qloop_625) - tmp_qloop_251*tmp_qloop_622);
                   const real_t q_tmp_5_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_623 + tmp_qloop_269*tmp_qloop_624 + tmp_qloop_273*tmp_qloop_625) - tmp_qloop_264*tmp_qloop_622);
                   const real_t q_tmp_5_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_624 + tmp_qloop_588 + tmp_qloop_627) - tmp_qloop_282*tmp_qloop_622);
                   const real_t q_tmp_5_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_624 + tmp_qloop_318 + tmp_qloop_628) - tmp_qloop_308*tmp_qloop_622);
                   const real_t q_tmp_5_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_624 + tmp_qloop_332 + tmp_qloop_628) - tmp_qloop_322*tmp_qloop_622);
                   const real_t q_tmp_5_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_624 + tmp_qloop_346 + tmp_qloop_628) - tmp_qloop_336*tmp_qloop_622);
                   const real_t q_tmp_5_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_624 + tmp_qloop_360 + tmp_qloop_628) - tmp_qloop_350*tmp_qloop_622);
                   const real_t q_tmp_5_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_624 + tmp_qloop_374 + tmp_qloop_628) - tmp_qloop_364*tmp_qloop_622);
                   const real_t q_tmp_5_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_624 + tmp_qloop_388 + tmp_qloop_628) - tmp_qloop_378*tmp_qloop_622);
                   const real_t q_tmp_5_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_624 + tmp_qloop_402 + tmp_qloop_628) - tmp_qloop_392*tmp_qloop_622);
                   const real_t q_tmp_5_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_624 + tmp_qloop_416 + tmp_qloop_628) - tmp_qloop_406*tmp_qloop_622);
                   const real_t q_tmp_5_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_624 + tmp_qloop_430 + tmp_qloop_628) - tmp_qloop_420*tmp_qloop_622);
                   const real_t q_tmp_5_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_625 + tmp_qloop_592 + tmp_qloop_629) - tmp_qloop_435*tmp_qloop_622);
                   const real_t q_tmp_5_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_625 + tmp_qloop_463 + tmp_qloop_630) - tmp_qloop_452*tmp_qloop_622);
                   const real_t q_tmp_5_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_625 + tmp_qloop_478 + tmp_qloop_630) - tmp_qloop_467*tmp_qloop_622);
                   const real_t q_tmp_5_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_625 + tmp_qloop_493 + tmp_qloop_630) - tmp_qloop_482*tmp_qloop_622);
                   const real_t q_tmp_5_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_625 + tmp_qloop_508 + tmp_qloop_630) - tmp_qloop_497*tmp_qloop_622);
                   const real_t q_tmp_5_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_625 + tmp_qloop_523 + tmp_qloop_630) - tmp_qloop_512*tmp_qloop_622);
                   const real_t q_tmp_5_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_625 + tmp_qloop_538 + tmp_qloop_630) - tmp_qloop_527*tmp_qloop_622);
                   const real_t q_tmp_5_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_625 + tmp_qloop_553 + tmp_qloop_630) - tmp_qloop_542*tmp_qloop_622);
                   const real_t q_tmp_5_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_625 + tmp_qloop_568 + tmp_qloop_630) - tmp_qloop_557*tmp_qloop_622);
                   const real_t q_tmp_5_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_625 + tmp_qloop_583 + tmp_qloop_630) - tmp_qloop_572*tmp_qloop_622);
                   const real_t q_tmp_6_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_632 + tmp_qloop_230*tmp_qloop_633 + tmp_qloop_234*tmp_qloop_634) - tmp_qloop_225*tmp_qloop_631);
                   const real_t q_tmp_6_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_632 + tmp_qloop_243*tmp_qloop_633 + tmp_qloop_247*tmp_qloop_634) - tmp_qloop_238*tmp_qloop_631);
                   const real_t q_tmp_6_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_632 + tmp_qloop_256*tmp_qloop_633 + tmp_qloop_260*tmp_qloop_634) - tmp_qloop_251*tmp_qloop_631);
                   const real_t q_tmp_6_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_632 + tmp_qloop_269*tmp_qloop_633 + tmp_qloop_273*tmp_qloop_634) - tmp_qloop_264*tmp_qloop_631);
                   const real_t q_tmp_6_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_633 + tmp_qloop_588 + tmp_qloop_636) - tmp_qloop_282*tmp_qloop_631);
                   const real_t q_tmp_6_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_633 + tmp_qloop_318 + tmp_qloop_637) - tmp_qloop_308*tmp_qloop_631);
                   const real_t q_tmp_6_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_633 + tmp_qloop_332 + tmp_qloop_637) - tmp_qloop_322*tmp_qloop_631);
                   const real_t q_tmp_6_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_633 + tmp_qloop_346 + tmp_qloop_637) - tmp_qloop_336*tmp_qloop_631);
                   const real_t q_tmp_6_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_633 + tmp_qloop_360 + tmp_qloop_637) - tmp_qloop_350*tmp_qloop_631);
                   const real_t q_tmp_6_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_633 + tmp_qloop_374 + tmp_qloop_637) - tmp_qloop_364*tmp_qloop_631);
                   const real_t q_tmp_6_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_633 + tmp_qloop_388 + tmp_qloop_637) - tmp_qloop_378*tmp_qloop_631);
                   const real_t q_tmp_6_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_633 + tmp_qloop_402 + tmp_qloop_637) - tmp_qloop_392*tmp_qloop_631);
                   const real_t q_tmp_6_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_633 + tmp_qloop_416 + tmp_qloop_637) - tmp_qloop_406*tmp_qloop_631);
                   const real_t q_tmp_6_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_633 + tmp_qloop_430 + tmp_qloop_637) - tmp_qloop_420*tmp_qloop_631);
                   const real_t q_tmp_6_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_634 + tmp_qloop_592 + tmp_qloop_638) - tmp_qloop_435*tmp_qloop_631);
                   const real_t q_tmp_6_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_634 + tmp_qloop_463 + tmp_qloop_639) - tmp_qloop_452*tmp_qloop_631);
                   const real_t q_tmp_6_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_634 + tmp_qloop_478 + tmp_qloop_639) - tmp_qloop_467*tmp_qloop_631);
                   const real_t q_tmp_6_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_634 + tmp_qloop_493 + tmp_qloop_639) - tmp_qloop_482*tmp_qloop_631);
                   const real_t q_tmp_6_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_634 + tmp_qloop_508 + tmp_qloop_639) - tmp_qloop_497*tmp_qloop_631);
                   const real_t q_tmp_6_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_634 + tmp_qloop_523 + tmp_qloop_639) - tmp_qloop_512*tmp_qloop_631);
                   const real_t q_tmp_6_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_634 + tmp_qloop_538 + tmp_qloop_639) - tmp_qloop_527*tmp_qloop_631);
                   const real_t q_tmp_6_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_634 + tmp_qloop_553 + tmp_qloop_639) - tmp_qloop_542*tmp_qloop_631);
                   const real_t q_tmp_6_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_634 + tmp_qloop_568 + tmp_qloop_639) - tmp_qloop_557*tmp_qloop_631);
                   const real_t q_tmp_6_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_634 + tmp_qloop_583 + tmp_qloop_639) - tmp_qloop_572*tmp_qloop_631);
                   const real_t q_tmp_7_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_641 + tmp_qloop_243*tmp_qloop_642 + tmp_qloop_247*tmp_qloop_643) - tmp_qloop_238*tmp_qloop_640);
                   const real_t q_tmp_7_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_641 + tmp_qloop_256*tmp_qloop_642 + tmp_qloop_260*tmp_qloop_643) - tmp_qloop_251*tmp_qloop_640);
                   const real_t q_tmp_7_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_641 + tmp_qloop_269*tmp_qloop_642 + tmp_qloop_273*tmp_qloop_643) - tmp_qloop_264*tmp_qloop_640);
                   const real_t q_tmp_7_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_642 + tmp_qloop_588 + tmp_qloop_645) - tmp_qloop_282*tmp_qloop_640);
                   const real_t q_tmp_7_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_642 + tmp_qloop_318 + tmp_qloop_646) - tmp_qloop_308*tmp_qloop_640);
                   const real_t q_tmp_7_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_642 + tmp_qloop_332 + tmp_qloop_646) - tmp_qloop_322*tmp_qloop_640);
                   const real_t q_tmp_7_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_642 + tmp_qloop_346 + tmp_qloop_646) - tmp_qloop_336*tmp_qloop_640);
                   const real_t q_tmp_7_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_642 + tmp_qloop_360 + tmp_qloop_646) - tmp_qloop_350*tmp_qloop_640);
                   const real_t q_tmp_7_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_642 + tmp_qloop_374 + tmp_qloop_646) - tmp_qloop_364*tmp_qloop_640);
                   const real_t q_tmp_7_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_642 + tmp_qloop_388 + tmp_qloop_646) - tmp_qloop_378*tmp_qloop_640);
                   const real_t q_tmp_7_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_642 + tmp_qloop_402 + tmp_qloop_646) - tmp_qloop_392*tmp_qloop_640);
                   const real_t q_tmp_7_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_642 + tmp_qloop_416 + tmp_qloop_646) - tmp_qloop_406*tmp_qloop_640);
                   const real_t q_tmp_7_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_642 + tmp_qloop_430 + tmp_qloop_646) - tmp_qloop_420*tmp_qloop_640);
                   const real_t q_tmp_7_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_643 + tmp_qloop_592 + tmp_qloop_647) - tmp_qloop_435*tmp_qloop_640);
                   const real_t q_tmp_7_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_643 + tmp_qloop_463 + tmp_qloop_648) - tmp_qloop_452*tmp_qloop_640);
                   const real_t q_tmp_7_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_643 + tmp_qloop_478 + tmp_qloop_648) - tmp_qloop_467*tmp_qloop_640);
                   const real_t q_tmp_7_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_643 + tmp_qloop_493 + tmp_qloop_648) - tmp_qloop_482*tmp_qloop_640);
                   const real_t q_tmp_7_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_643 + tmp_qloop_508 + tmp_qloop_648) - tmp_qloop_497*tmp_qloop_640);
                   const real_t q_tmp_7_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_643 + tmp_qloop_523 + tmp_qloop_648) - tmp_qloop_512*tmp_qloop_640);
                   const real_t q_tmp_7_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_643 + tmp_qloop_538 + tmp_qloop_648) - tmp_qloop_527*tmp_qloop_640);
                   const real_t q_tmp_7_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_643 + tmp_qloop_553 + tmp_qloop_648) - tmp_qloop_542*tmp_qloop_640);
                   const real_t q_tmp_7_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_643 + tmp_qloop_568 + tmp_qloop_648) - tmp_qloop_557*tmp_qloop_640);
                   const real_t q_tmp_7_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_643 + tmp_qloop_583 + tmp_qloop_648) - tmp_qloop_572*tmp_qloop_640);
                   const real_t q_tmp_8_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_650 + tmp_qloop_256*tmp_qloop_651 + tmp_qloop_260*tmp_qloop_652) - tmp_qloop_251*tmp_qloop_649);
                   const real_t q_tmp_8_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_650 + tmp_qloop_269*tmp_qloop_651 + tmp_qloop_273*tmp_qloop_652) - tmp_qloop_264*tmp_qloop_649);
                   const real_t q_tmp_8_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_651 + tmp_qloop_588 + tmp_qloop_654) - tmp_qloop_282*tmp_qloop_649);
                   const real_t q_tmp_8_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_651 + tmp_qloop_318 + tmp_qloop_655) - tmp_qloop_308*tmp_qloop_649);
                   const real_t q_tmp_8_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_651 + tmp_qloop_332 + tmp_qloop_655) - tmp_qloop_322*tmp_qloop_649);
                   const real_t q_tmp_8_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_651 + tmp_qloop_346 + tmp_qloop_655) - tmp_qloop_336*tmp_qloop_649);
                   const real_t q_tmp_8_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_651 + tmp_qloop_360 + tmp_qloop_655) - tmp_qloop_350*tmp_qloop_649);
                   const real_t q_tmp_8_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_651 + tmp_qloop_374 + tmp_qloop_655) - tmp_qloop_364*tmp_qloop_649);
                   const real_t q_tmp_8_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_651 + tmp_qloop_388 + tmp_qloop_655) - tmp_qloop_378*tmp_qloop_649);
                   const real_t q_tmp_8_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_651 + tmp_qloop_402 + tmp_qloop_655) - tmp_qloop_392*tmp_qloop_649);
                   const real_t q_tmp_8_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_651 + tmp_qloop_416 + tmp_qloop_655) - tmp_qloop_406*tmp_qloop_649);
                   const real_t q_tmp_8_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_651 + tmp_qloop_430 + tmp_qloop_655) - tmp_qloop_420*tmp_qloop_649);
                   const real_t q_tmp_8_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_652 + tmp_qloop_592 + tmp_qloop_656) - tmp_qloop_435*tmp_qloop_649);
                   const real_t q_tmp_8_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_652 + tmp_qloop_463 + tmp_qloop_657) - tmp_qloop_452*tmp_qloop_649);
                   const real_t q_tmp_8_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_652 + tmp_qloop_478 + tmp_qloop_657) - tmp_qloop_467*tmp_qloop_649);
                   const real_t q_tmp_8_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_652 + tmp_qloop_493 + tmp_qloop_657) - tmp_qloop_482*tmp_qloop_649);
                   const real_t q_tmp_8_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_652 + tmp_qloop_508 + tmp_qloop_657) - tmp_qloop_497*tmp_qloop_649);
                   const real_t q_tmp_8_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_652 + tmp_qloop_523 + tmp_qloop_657) - tmp_qloop_512*tmp_qloop_649);
                   const real_t q_tmp_8_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_652 + tmp_qloop_538 + tmp_qloop_657) - tmp_qloop_527*tmp_qloop_649);
                   const real_t q_tmp_8_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_652 + tmp_qloop_553 + tmp_qloop_657) - tmp_qloop_542*tmp_qloop_649);
                   const real_t q_tmp_8_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_652 + tmp_qloop_568 + tmp_qloop_657) - tmp_qloop_557*tmp_qloop_649);
                   const real_t q_tmp_8_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_652 + tmp_qloop_583 + tmp_qloop_657) - tmp_qloop_572*tmp_qloop_649);
                   const real_t q_tmp_9_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_659 + tmp_qloop_269*tmp_qloop_660 + tmp_qloop_273*tmp_qloop_661) - tmp_qloop_264*tmp_qloop_658);
                   const real_t q_tmp_9_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_660 + tmp_qloop_588 + tmp_qloop_663) - tmp_qloop_282*tmp_qloop_658);
                   const real_t q_tmp_9_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_660 + tmp_qloop_318 + tmp_qloop_664) - tmp_qloop_308*tmp_qloop_658);
                   const real_t q_tmp_9_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_660 + tmp_qloop_332 + tmp_qloop_664) - tmp_qloop_322*tmp_qloop_658);
                   const real_t q_tmp_9_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_660 + tmp_qloop_346 + tmp_qloop_664) - tmp_qloop_336*tmp_qloop_658);
                   const real_t q_tmp_9_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_660 + tmp_qloop_360 + tmp_qloop_664) - tmp_qloop_350*tmp_qloop_658);
                   const real_t q_tmp_9_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_660 + tmp_qloop_374 + tmp_qloop_664) - tmp_qloop_364*tmp_qloop_658);
                   const real_t q_tmp_9_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_660 + tmp_qloop_388 + tmp_qloop_664) - tmp_qloop_378*tmp_qloop_658);
                   const real_t q_tmp_9_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_660 + tmp_qloop_402 + tmp_qloop_664) - tmp_qloop_392*tmp_qloop_658);
                   const real_t q_tmp_9_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_660 + tmp_qloop_416 + tmp_qloop_664) - tmp_qloop_406*tmp_qloop_658);
                   const real_t q_tmp_9_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_660 + tmp_qloop_430 + tmp_qloop_664) - tmp_qloop_420*tmp_qloop_658);
                   const real_t q_tmp_9_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_661 + tmp_qloop_592 + tmp_qloop_665) - tmp_qloop_435*tmp_qloop_658);
                   const real_t q_tmp_9_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_661 + tmp_qloop_463 + tmp_qloop_666) - tmp_qloop_452*tmp_qloop_658);
                   const real_t q_tmp_9_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_661 + tmp_qloop_478 + tmp_qloop_666) - tmp_qloop_467*tmp_qloop_658);
                   const real_t q_tmp_9_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_661 + tmp_qloop_493 + tmp_qloop_666) - tmp_qloop_482*tmp_qloop_658);
                   const real_t q_tmp_9_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_661 + tmp_qloop_508 + tmp_qloop_666) - tmp_qloop_497*tmp_qloop_658);
                   const real_t q_tmp_9_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_661 + tmp_qloop_523 + tmp_qloop_666) - tmp_qloop_512*tmp_qloop_658);
                   const real_t q_tmp_9_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_661 + tmp_qloop_538 + tmp_qloop_666) - tmp_qloop_527*tmp_qloop_658);
                   const real_t q_tmp_9_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_661 + tmp_qloop_553 + tmp_qloop_666) - tmp_qloop_542*tmp_qloop_658);
                   const real_t q_tmp_9_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_661 + tmp_qloop_568 + tmp_qloop_666) - tmp_qloop_557*tmp_qloop_658);
                   const real_t q_tmp_9_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_661 + tmp_qloop_583 + tmp_qloop_666) - tmp_qloop_572*tmp_qloop_658);
                   const real_t q_tmp_10_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_672 + tmp_qloop_299*tmp_qloop_670 + tmp_qloop_303*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_282*tmp_qloop_669);
                   const real_t q_tmp_10_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_672 + tmp_qloop_313*tmp_qloop_670 + tmp_qloop_317*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_669);
                   const real_t q_tmp_10_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_672 + tmp_qloop_327*tmp_qloop_670 + tmp_qloop_331*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_669);
                   const real_t q_tmp_10_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_672 + tmp_qloop_341*tmp_qloop_670 + tmp_qloop_345*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_669);
                   const real_t q_tmp_10_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_672 + tmp_qloop_355*tmp_qloop_670 + tmp_qloop_359*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_669);
                   const real_t q_tmp_10_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_672 + tmp_qloop_369*tmp_qloop_670 + tmp_qloop_373*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_669);
                   const real_t q_tmp_10_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_672 + tmp_qloop_383*tmp_qloop_670 + tmp_qloop_387*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_669);
                   const real_t q_tmp_10_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_672 + tmp_qloop_397*tmp_qloop_670 + tmp_qloop_401*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_669);
                   const real_t q_tmp_10_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_672 + tmp_qloop_411*tmp_qloop_670 + tmp_qloop_415*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_669);
                   const real_t q_tmp_10_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_672 + tmp_qloop_425*tmp_qloop_670 + tmp_qloop_429*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_669);
                   const real_t q_tmp_10_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_679) - tmp_qloop_435*tmp_qloop_669);
                   const real_t q_tmp_10_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_680) - tmp_qloop_452*tmp_qloop_669);
                   const real_t q_tmp_10_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_681) - tmp_qloop_467*tmp_qloop_669);
                   const real_t q_tmp_10_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_682) - tmp_qloop_482*tmp_qloop_669);
                   const real_t q_tmp_10_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_683) - tmp_qloop_497*tmp_qloop_669);
                   const real_t q_tmp_10_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_684) - tmp_qloop_512*tmp_qloop_669);
                   const real_t q_tmp_10_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_685) - tmp_qloop_527*tmp_qloop_669);
                   const real_t q_tmp_10_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_686) - tmp_qloop_542*tmp_qloop_669);
                   const real_t q_tmp_10_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_687) - tmp_qloop_557*tmp_qloop_669);
                   const real_t q_tmp_10_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_688) - tmp_qloop_572*tmp_qloop_669);
                   const real_t q_tmp_11_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_691 + tmp_qloop_313*tmp_qloop_690 + tmp_qloop_317*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_689);
                   const real_t q_tmp_11_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_691 + tmp_qloop_327*tmp_qloop_690 + tmp_qloop_331*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_689);
                   const real_t q_tmp_11_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_691 + tmp_qloop_341*tmp_qloop_690 + tmp_qloop_345*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_689);
                   const real_t q_tmp_11_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_691 + tmp_qloop_355*tmp_qloop_690 + tmp_qloop_359*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_689);
                   const real_t q_tmp_11_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_691 + tmp_qloop_369*tmp_qloop_690 + tmp_qloop_373*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_689);
                   const real_t q_tmp_11_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_691 + tmp_qloop_383*tmp_qloop_690 + tmp_qloop_387*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_689);
                   const real_t q_tmp_11_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_691 + tmp_qloop_397*tmp_qloop_690 + tmp_qloop_401*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_689);
                   const real_t q_tmp_11_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_691 + tmp_qloop_411*tmp_qloop_690 + tmp_qloop_415*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_689);
                   const real_t q_tmp_11_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_691 + tmp_qloop_425*tmp_qloop_690 + tmp_qloop_429*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_689);
                   const real_t q_tmp_11_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_692 + tmp_qloop_693 + tmp_qloop_694) - tmp_qloop_435*tmp_qloop_689);
                   const real_t q_tmp_11_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_692 + tmp_qloop_680 + tmp_qloop_695) - tmp_qloop_452*tmp_qloop_689);
                   const real_t q_tmp_11_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_692 + tmp_qloop_681 + tmp_qloop_695) - tmp_qloop_467*tmp_qloop_689);
                   const real_t q_tmp_11_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_692 + tmp_qloop_682 + tmp_qloop_695) - tmp_qloop_482*tmp_qloop_689);
                   const real_t q_tmp_11_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_692 + tmp_qloop_683 + tmp_qloop_695) - tmp_qloop_497*tmp_qloop_689);
                   const real_t q_tmp_11_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_692 + tmp_qloop_684 + tmp_qloop_695) - tmp_qloop_512*tmp_qloop_689);
                   const real_t q_tmp_11_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_692 + tmp_qloop_685 + tmp_qloop_695) - tmp_qloop_527*tmp_qloop_689);
                   const real_t q_tmp_11_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_692 + tmp_qloop_686 + tmp_qloop_695) - tmp_qloop_542*tmp_qloop_689);
                   const real_t q_tmp_11_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_692 + tmp_qloop_687 + tmp_qloop_695) - tmp_qloop_557*tmp_qloop_689);
                   const real_t q_tmp_11_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_692 + tmp_qloop_688 + tmp_qloop_695) - tmp_qloop_572*tmp_qloop_689);
                   const real_t q_tmp_12_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_698 + tmp_qloop_327*tmp_qloop_697 + tmp_qloop_331*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_696);
                   const real_t q_tmp_12_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_698 + tmp_qloop_341*tmp_qloop_697 + tmp_qloop_345*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_696);
                   const real_t q_tmp_12_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_698 + tmp_qloop_355*tmp_qloop_697 + tmp_qloop_359*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_696);
                   const real_t q_tmp_12_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_698 + tmp_qloop_369*tmp_qloop_697 + tmp_qloop_373*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_696);
                   const real_t q_tmp_12_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_698 + tmp_qloop_383*tmp_qloop_697 + tmp_qloop_387*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_696);
                   const real_t q_tmp_12_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_698 + tmp_qloop_397*tmp_qloop_697 + tmp_qloop_401*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_696);
                   const real_t q_tmp_12_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_698 + tmp_qloop_411*tmp_qloop_697 + tmp_qloop_415*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_696);
                   const real_t q_tmp_12_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_698 + tmp_qloop_425*tmp_qloop_697 + tmp_qloop_429*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_696);
                   const real_t q_tmp_12_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_699 + tmp_qloop_693 + tmp_qloop_700) - tmp_qloop_435*tmp_qloop_696);
                   const real_t q_tmp_12_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_699 + tmp_qloop_680 + tmp_qloop_701) - tmp_qloop_452*tmp_qloop_696);
                   const real_t q_tmp_12_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_699 + tmp_qloop_681 + tmp_qloop_701) - tmp_qloop_467*tmp_qloop_696);
                   const real_t q_tmp_12_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_699 + tmp_qloop_682 + tmp_qloop_701) - tmp_qloop_482*tmp_qloop_696);
                   const real_t q_tmp_12_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_699 + tmp_qloop_683 + tmp_qloop_701) - tmp_qloop_497*tmp_qloop_696);
                   const real_t q_tmp_12_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_699 + tmp_qloop_684 + tmp_qloop_701) - tmp_qloop_512*tmp_qloop_696);
                   const real_t q_tmp_12_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_699 + tmp_qloop_685 + tmp_qloop_701) - tmp_qloop_527*tmp_qloop_696);
                   const real_t q_tmp_12_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_699 + tmp_qloop_686 + tmp_qloop_701) - tmp_qloop_542*tmp_qloop_696);
                   const real_t q_tmp_12_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_699 + tmp_qloop_687 + tmp_qloop_701) - tmp_qloop_557*tmp_qloop_696);
                   const real_t q_tmp_12_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_699 + tmp_qloop_688 + tmp_qloop_701) - tmp_qloop_572*tmp_qloop_696);
                   const real_t q_tmp_13_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_704 + tmp_qloop_341*tmp_qloop_703 + tmp_qloop_345*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_702);
                   const real_t q_tmp_13_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_704 + tmp_qloop_355*tmp_qloop_703 + tmp_qloop_359*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_702);
                   const real_t q_tmp_13_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_704 + tmp_qloop_369*tmp_qloop_703 + tmp_qloop_373*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_702);
                   const real_t q_tmp_13_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_704 + tmp_qloop_383*tmp_qloop_703 + tmp_qloop_387*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_702);
                   const real_t q_tmp_13_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_704 + tmp_qloop_397*tmp_qloop_703 + tmp_qloop_401*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_702);
                   const real_t q_tmp_13_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_704 + tmp_qloop_411*tmp_qloop_703 + tmp_qloop_415*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_702);
                   const real_t q_tmp_13_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_704 + tmp_qloop_425*tmp_qloop_703 + tmp_qloop_429*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_702);
                   const real_t q_tmp_13_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_705 + tmp_qloop_693 + tmp_qloop_706) - tmp_qloop_435*tmp_qloop_702);
                   const real_t q_tmp_13_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_705 + tmp_qloop_680 + tmp_qloop_707) - tmp_qloop_452*tmp_qloop_702);
                   const real_t q_tmp_13_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_705 + tmp_qloop_681 + tmp_qloop_707) - tmp_qloop_467*tmp_qloop_702);
                   const real_t q_tmp_13_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_705 + tmp_qloop_682 + tmp_qloop_707) - tmp_qloop_482*tmp_qloop_702);
                   const real_t q_tmp_13_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_705 + tmp_qloop_683 + tmp_qloop_707) - tmp_qloop_497*tmp_qloop_702);
                   const real_t q_tmp_13_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_705 + tmp_qloop_684 + tmp_qloop_707) - tmp_qloop_512*tmp_qloop_702);
                   const real_t q_tmp_13_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_705 + tmp_qloop_685 + tmp_qloop_707) - tmp_qloop_527*tmp_qloop_702);
                   const real_t q_tmp_13_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_705 + tmp_qloop_686 + tmp_qloop_707) - tmp_qloop_542*tmp_qloop_702);
                   const real_t q_tmp_13_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_705 + tmp_qloop_687 + tmp_qloop_707) - tmp_qloop_557*tmp_qloop_702);
                   const real_t q_tmp_13_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_705 + tmp_qloop_688 + tmp_qloop_707) - tmp_qloop_572*tmp_qloop_702);
                   const real_t q_tmp_14_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_710 + tmp_qloop_355*tmp_qloop_709 + tmp_qloop_359*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_708);
                   const real_t q_tmp_14_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_710 + tmp_qloop_369*tmp_qloop_709 + tmp_qloop_373*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_708);
                   const real_t q_tmp_14_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_710 + tmp_qloop_383*tmp_qloop_709 + tmp_qloop_387*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_708);
                   const real_t q_tmp_14_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_710 + tmp_qloop_397*tmp_qloop_709 + tmp_qloop_401*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_708);
                   const real_t q_tmp_14_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_710 + tmp_qloop_411*tmp_qloop_709 + tmp_qloop_415*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_708);
                   const real_t q_tmp_14_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_710 + tmp_qloop_425*tmp_qloop_709 + tmp_qloop_429*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_708);
                   const real_t q_tmp_14_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_711 + tmp_qloop_693 + tmp_qloop_712) - tmp_qloop_435*tmp_qloop_708);
                   const real_t q_tmp_14_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_711 + tmp_qloop_680 + tmp_qloop_713) - tmp_qloop_452*tmp_qloop_708);
                   const real_t q_tmp_14_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_711 + tmp_qloop_681 + tmp_qloop_713) - tmp_qloop_467*tmp_qloop_708);
                   const real_t q_tmp_14_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_711 + tmp_qloop_682 + tmp_qloop_713) - tmp_qloop_482*tmp_qloop_708);
                   const real_t q_tmp_14_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_711 + tmp_qloop_683 + tmp_qloop_713) - tmp_qloop_497*tmp_qloop_708);
                   const real_t q_tmp_14_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_711 + tmp_qloop_684 + tmp_qloop_713) - tmp_qloop_512*tmp_qloop_708);
                   const real_t q_tmp_14_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_711 + tmp_qloop_685 + tmp_qloop_713) - tmp_qloop_527*tmp_qloop_708);
                   const real_t q_tmp_14_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_711 + tmp_qloop_686 + tmp_qloop_713) - tmp_qloop_542*tmp_qloop_708);
                   const real_t q_tmp_14_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_711 + tmp_qloop_687 + tmp_qloop_713) - tmp_qloop_557*tmp_qloop_708);
                   const real_t q_tmp_14_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_711 + tmp_qloop_688 + tmp_qloop_713) - tmp_qloop_572*tmp_qloop_708);
                   const real_t q_tmp_15_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_716 + tmp_qloop_369*tmp_qloop_715 + tmp_qloop_373*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_714);
                   const real_t q_tmp_15_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_716 + tmp_qloop_383*tmp_qloop_715 + tmp_qloop_387*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_714);
                   const real_t q_tmp_15_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_716 + tmp_qloop_397*tmp_qloop_715 + tmp_qloop_401*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_714);
                   const real_t q_tmp_15_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_716 + tmp_qloop_411*tmp_qloop_715 + tmp_qloop_415*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_714);
                   const real_t q_tmp_15_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_716 + tmp_qloop_425*tmp_qloop_715 + tmp_qloop_429*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_714);
                   const real_t q_tmp_15_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_717 + tmp_qloop_693 + tmp_qloop_718) - tmp_qloop_435*tmp_qloop_714);
                   const real_t q_tmp_15_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_717 + tmp_qloop_680 + tmp_qloop_719) - tmp_qloop_452*tmp_qloop_714);
                   const real_t q_tmp_15_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_717 + tmp_qloop_681 + tmp_qloop_719) - tmp_qloop_467*tmp_qloop_714);
                   const real_t q_tmp_15_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_717 + tmp_qloop_682 + tmp_qloop_719) - tmp_qloop_482*tmp_qloop_714);
                   const real_t q_tmp_15_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_717 + tmp_qloop_683 + tmp_qloop_719) - tmp_qloop_497*tmp_qloop_714);
                   const real_t q_tmp_15_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_717 + tmp_qloop_684 + tmp_qloop_719) - tmp_qloop_512*tmp_qloop_714);
                   const real_t q_tmp_15_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_717 + tmp_qloop_685 + tmp_qloop_719) - tmp_qloop_527*tmp_qloop_714);
                   const real_t q_tmp_15_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_717 + tmp_qloop_686 + tmp_qloop_719) - tmp_qloop_542*tmp_qloop_714);
                   const real_t q_tmp_15_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_717 + tmp_qloop_687 + tmp_qloop_719) - tmp_qloop_557*tmp_qloop_714);
                   const real_t q_tmp_15_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_717 + tmp_qloop_688 + tmp_qloop_719) - tmp_qloop_572*tmp_qloop_714);
                   const real_t q_tmp_16_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_722 + tmp_qloop_383*tmp_qloop_721 + tmp_qloop_387*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_720);
                   const real_t q_tmp_16_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_722 + tmp_qloop_397*tmp_qloop_721 + tmp_qloop_401*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_720);
                   const real_t q_tmp_16_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_722 + tmp_qloop_411*tmp_qloop_721 + tmp_qloop_415*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_720);
                   const real_t q_tmp_16_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_722 + tmp_qloop_425*tmp_qloop_721 + tmp_qloop_429*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_720);
                   const real_t q_tmp_16_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_723 + tmp_qloop_693 + tmp_qloop_724) - tmp_qloop_435*tmp_qloop_720);
                   const real_t q_tmp_16_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_723 + tmp_qloop_680 + tmp_qloop_725) - tmp_qloop_452*tmp_qloop_720);
                   const real_t q_tmp_16_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_723 + tmp_qloop_681 + tmp_qloop_725) - tmp_qloop_467*tmp_qloop_720);
                   const real_t q_tmp_16_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_723 + tmp_qloop_682 + tmp_qloop_725) - tmp_qloop_482*tmp_qloop_720);
                   const real_t q_tmp_16_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_723 + tmp_qloop_683 + tmp_qloop_725) - tmp_qloop_497*tmp_qloop_720);
                   const real_t q_tmp_16_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_723 + tmp_qloop_684 + tmp_qloop_725) - tmp_qloop_512*tmp_qloop_720);
                   const real_t q_tmp_16_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_723 + tmp_qloop_685 + tmp_qloop_725) - tmp_qloop_527*tmp_qloop_720);
                   const real_t q_tmp_16_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_723 + tmp_qloop_686 + tmp_qloop_725) - tmp_qloop_542*tmp_qloop_720);
                   const real_t q_tmp_16_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_723 + tmp_qloop_687 + tmp_qloop_725) - tmp_qloop_557*tmp_qloop_720);
                   const real_t q_tmp_16_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_723 + tmp_qloop_688 + tmp_qloop_725) - tmp_qloop_572*tmp_qloop_720);
                   const real_t q_tmp_17_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_728 + tmp_qloop_397*tmp_qloop_727 + tmp_qloop_401*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_726);
                   const real_t q_tmp_17_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_728 + tmp_qloop_411*tmp_qloop_727 + tmp_qloop_415*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_726);
                   const real_t q_tmp_17_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_728 + tmp_qloop_425*tmp_qloop_727 + tmp_qloop_429*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_726);
                   const real_t q_tmp_17_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_729 + tmp_qloop_693 + tmp_qloop_730) - tmp_qloop_435*tmp_qloop_726);
                   const real_t q_tmp_17_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_729 + tmp_qloop_680 + tmp_qloop_731) - tmp_qloop_452*tmp_qloop_726);
                   const real_t q_tmp_17_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_729 + tmp_qloop_681 + tmp_qloop_731) - tmp_qloop_467*tmp_qloop_726);
                   const real_t q_tmp_17_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_729 + tmp_qloop_682 + tmp_qloop_731) - tmp_qloop_482*tmp_qloop_726);
                   const real_t q_tmp_17_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_729 + tmp_qloop_683 + tmp_qloop_731) - tmp_qloop_497*tmp_qloop_726);
                   const real_t q_tmp_17_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_729 + tmp_qloop_684 + tmp_qloop_731) - tmp_qloop_512*tmp_qloop_726);
                   const real_t q_tmp_17_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_729 + tmp_qloop_685 + tmp_qloop_731) - tmp_qloop_527*tmp_qloop_726);
                   const real_t q_tmp_17_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_729 + tmp_qloop_686 + tmp_qloop_731) - tmp_qloop_542*tmp_qloop_726);
                   const real_t q_tmp_17_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_729 + tmp_qloop_687 + tmp_qloop_731) - tmp_qloop_557*tmp_qloop_726);
                   const real_t q_tmp_17_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_729 + tmp_qloop_688 + tmp_qloop_731) - tmp_qloop_572*tmp_qloop_726);
                   const real_t q_tmp_18_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_734 + tmp_qloop_411*tmp_qloop_733 + tmp_qloop_415*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_732);
                   const real_t q_tmp_18_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_734 + tmp_qloop_425*tmp_qloop_733 + tmp_qloop_429*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_732);
                   const real_t q_tmp_18_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_735 + tmp_qloop_693 + tmp_qloop_736) - tmp_qloop_435*tmp_qloop_732);
                   const real_t q_tmp_18_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_735 + tmp_qloop_680 + tmp_qloop_737) - tmp_qloop_452*tmp_qloop_732);
                   const real_t q_tmp_18_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_735 + tmp_qloop_681 + tmp_qloop_737) - tmp_qloop_467*tmp_qloop_732);
                   const real_t q_tmp_18_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_735 + tmp_qloop_682 + tmp_qloop_737) - tmp_qloop_482*tmp_qloop_732);
                   const real_t q_tmp_18_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_735 + tmp_qloop_683 + tmp_qloop_737) - tmp_qloop_497*tmp_qloop_732);
                   const real_t q_tmp_18_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_735 + tmp_qloop_684 + tmp_qloop_737) - tmp_qloop_512*tmp_qloop_732);
                   const real_t q_tmp_18_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_735 + tmp_qloop_685 + tmp_qloop_737) - tmp_qloop_527*tmp_qloop_732);
                   const real_t q_tmp_18_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_735 + tmp_qloop_686 + tmp_qloop_737) - tmp_qloop_542*tmp_qloop_732);
                   const real_t q_tmp_18_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_735 + tmp_qloop_687 + tmp_qloop_737) - tmp_qloop_557*tmp_qloop_732);
                   const real_t q_tmp_18_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_735 + tmp_qloop_688 + tmp_qloop_737) - tmp_qloop_572*tmp_qloop_732);
                   const real_t q_tmp_19_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_740 + tmp_qloop_425*tmp_qloop_739 + tmp_qloop_429*tmp_qloop_741 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_738);
                   const real_t q_tmp_19_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_741 + tmp_qloop_693 + tmp_qloop_742) - tmp_qloop_435*tmp_qloop_738);
                   const real_t q_tmp_19_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_741 + tmp_qloop_680 + tmp_qloop_743) - tmp_qloop_452*tmp_qloop_738);
                   const real_t q_tmp_19_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_741 + tmp_qloop_681 + tmp_qloop_743) - tmp_qloop_467*tmp_qloop_738);
                   const real_t q_tmp_19_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_741 + tmp_qloop_682 + tmp_qloop_743) - tmp_qloop_482*tmp_qloop_738);
                   const real_t q_tmp_19_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_741 + tmp_qloop_683 + tmp_qloop_743) - tmp_qloop_497*tmp_qloop_738);
                   const real_t q_tmp_19_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_741 + tmp_qloop_684 + tmp_qloop_743) - tmp_qloop_512*tmp_qloop_738);
                   const real_t q_tmp_19_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_741 + tmp_qloop_685 + tmp_qloop_743) - tmp_qloop_527*tmp_qloop_738);
                   const real_t q_tmp_19_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_741 + tmp_qloop_686 + tmp_qloop_743) - tmp_qloop_542*tmp_qloop_738);
                   const real_t q_tmp_19_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_741 + tmp_qloop_687 + tmp_qloop_743) - tmp_qloop_557*tmp_qloop_738);
                   const real_t q_tmp_19_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_741 + tmp_qloop_688 + tmp_qloop_743) - tmp_qloop_572*tmp_qloop_738);
                   const real_t q_tmp_20_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_747 + tmp_qloop_442*tmp_qloop_746 + tmp_qloop_447*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_435*tmp_qloop_745);
                   const real_t q_tmp_20_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_747 + tmp_qloop_457*tmp_qloop_746 + tmp_qloop_462*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_745);
                   const real_t q_tmp_20_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_747 + tmp_qloop_472*tmp_qloop_746 + tmp_qloop_477*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_745);
                   const real_t q_tmp_20_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_747 + tmp_qloop_487*tmp_qloop_746 + tmp_qloop_492*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_745);
                   const real_t q_tmp_20_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_747 + tmp_qloop_502*tmp_qloop_746 + tmp_qloop_507*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_745);
                   const real_t q_tmp_20_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_747 + tmp_qloop_517*tmp_qloop_746 + tmp_qloop_522*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_745);
                   const real_t q_tmp_20_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_747 + tmp_qloop_532*tmp_qloop_746 + tmp_qloop_537*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_745);
                   const real_t q_tmp_20_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_747 + tmp_qloop_547*tmp_qloop_746 + tmp_qloop_552*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_745);
                   const real_t q_tmp_20_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_747 + tmp_qloop_562*tmp_qloop_746 + tmp_qloop_567*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_745);
                   const real_t q_tmp_20_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_747 + tmp_qloop_577*tmp_qloop_746 + tmp_qloop_582*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_745);
                   const real_t q_tmp_21_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_752 + tmp_qloop_457*tmp_qloop_751 + tmp_qloop_462*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_750);
                   const real_t q_tmp_21_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_752 + tmp_qloop_472*tmp_qloop_751 + tmp_qloop_477*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_750);
                   const real_t q_tmp_21_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_752 + tmp_qloop_487*tmp_qloop_751 + tmp_qloop_492*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_750);
                   const real_t q_tmp_21_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_752 + tmp_qloop_502*tmp_qloop_751 + tmp_qloop_507*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_750);
                   const real_t q_tmp_21_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_752 + tmp_qloop_517*tmp_qloop_751 + tmp_qloop_522*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_750);
                   const real_t q_tmp_21_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_752 + tmp_qloop_532*tmp_qloop_751 + tmp_qloop_537*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_750);
                   const real_t q_tmp_21_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_752 + tmp_qloop_547*tmp_qloop_751 + tmp_qloop_552*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_750);
                   const real_t q_tmp_21_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_752 + tmp_qloop_562*tmp_qloop_751 + tmp_qloop_567*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_750);
                   const real_t q_tmp_21_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_752 + tmp_qloop_577*tmp_qloop_751 + tmp_qloop_582*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_750);
                   const real_t q_tmp_22_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_756 + tmp_qloop_472*tmp_qloop_755 + tmp_qloop_477*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_754);
                   const real_t q_tmp_22_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_756 + tmp_qloop_487*tmp_qloop_755 + tmp_qloop_492*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_754);
                   const real_t q_tmp_22_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_756 + tmp_qloop_502*tmp_qloop_755 + tmp_qloop_507*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_754);
                   const real_t q_tmp_22_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_756 + tmp_qloop_517*tmp_qloop_755 + tmp_qloop_522*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_754);
                   const real_t q_tmp_22_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_756 + tmp_qloop_532*tmp_qloop_755 + tmp_qloop_537*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_754);
                   const real_t q_tmp_22_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_756 + tmp_qloop_547*tmp_qloop_755 + tmp_qloop_552*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_754);
                   const real_t q_tmp_22_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_756 + tmp_qloop_562*tmp_qloop_755 + tmp_qloop_567*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_754);
                   const real_t q_tmp_22_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_756 + tmp_qloop_577*tmp_qloop_755 + tmp_qloop_582*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_754);
                   const real_t q_tmp_23_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_760 + tmp_qloop_487*tmp_qloop_759 + tmp_qloop_492*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_758);
                   const real_t q_tmp_23_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_760 + tmp_qloop_502*tmp_qloop_759 + tmp_qloop_507*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_758);
                   const real_t q_tmp_23_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_760 + tmp_qloop_517*tmp_qloop_759 + tmp_qloop_522*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_758);
                   const real_t q_tmp_23_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_760 + tmp_qloop_532*tmp_qloop_759 + tmp_qloop_537*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_758);
                   const real_t q_tmp_23_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_760 + tmp_qloop_547*tmp_qloop_759 + tmp_qloop_552*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_758);
                   const real_t q_tmp_23_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_760 + tmp_qloop_562*tmp_qloop_759 + tmp_qloop_567*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_758);
                   const real_t q_tmp_23_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_760 + tmp_qloop_577*tmp_qloop_759 + tmp_qloop_582*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_758);
                   const real_t q_tmp_24_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_764 + tmp_qloop_502*tmp_qloop_763 + tmp_qloop_507*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_762);
                   const real_t q_tmp_24_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_764 + tmp_qloop_517*tmp_qloop_763 + tmp_qloop_522*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_762);
                   const real_t q_tmp_24_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_764 + tmp_qloop_532*tmp_qloop_763 + tmp_qloop_537*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_762);
                   const real_t q_tmp_24_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_764 + tmp_qloop_547*tmp_qloop_763 + tmp_qloop_552*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_762);
                   const real_t q_tmp_24_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_764 + tmp_qloop_562*tmp_qloop_763 + tmp_qloop_567*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_762);
                   const real_t q_tmp_24_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_764 + tmp_qloop_577*tmp_qloop_763 + tmp_qloop_582*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_762);
                   const real_t q_tmp_25_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_768 + tmp_qloop_517*tmp_qloop_767 + tmp_qloop_522*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_766);
                   const real_t q_tmp_25_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_768 + tmp_qloop_532*tmp_qloop_767 + tmp_qloop_537*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_766);
                   const real_t q_tmp_25_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_768 + tmp_qloop_547*tmp_qloop_767 + tmp_qloop_552*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_766);
                   const real_t q_tmp_25_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_768 + tmp_qloop_562*tmp_qloop_767 + tmp_qloop_567*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_766);
                   const real_t q_tmp_25_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_768 + tmp_qloop_577*tmp_qloop_767 + tmp_qloop_582*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_766);
                   const real_t q_tmp_26_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_772 + tmp_qloop_532*tmp_qloop_771 + tmp_qloop_537*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_770);
                   const real_t q_tmp_26_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_772 + tmp_qloop_547*tmp_qloop_771 + tmp_qloop_552*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_770);
                   const real_t q_tmp_26_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_772 + tmp_qloop_562*tmp_qloop_771 + tmp_qloop_567*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_770);
                   const real_t q_tmp_26_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_772 + tmp_qloop_577*tmp_qloop_771 + tmp_qloop_582*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_770);
                   const real_t q_tmp_27_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_776 + tmp_qloop_547*tmp_qloop_775 + tmp_qloop_552*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_774);
                   const real_t q_tmp_27_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_776 + tmp_qloop_562*tmp_qloop_775 + tmp_qloop_567*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_774);
                   const real_t q_tmp_27_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_776 + tmp_qloop_577*tmp_qloop_775 + tmp_qloop_582*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_774);
                   const real_t q_tmp_28_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_780 + tmp_qloop_562*tmp_qloop_779 + tmp_qloop_567*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_778);
                   const real_t q_tmp_28_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_780 + tmp_qloop_577*tmp_qloop_779 + tmp_qloop_582*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_778);
                   const real_t q_tmp_29_29 = tmp_qloop_156*(-tmp_qloop_118*tmp_qloop_572*(tmp_qloop_569 + tmp_qloop_570 + tmp_qloop_571 + tmp_qloop_744) + tmp_qloop_118*(tmp_qloop_576*(tmp_qloop_573*0.5 + tmp_qloop_574*0.5 + tmp_qloop_575*0.5 + tmp_qloop_675)*2.0 + tmp_qloop_577*(tmp_qloop_569*1.0 + tmp_qloop_570*1.0 + tmp_qloop_571*1.0) + tmp_qloop_582*(tmp_qloop_153 + tmp_qloop_579*0.5 + tmp_qloop_580*0.5 + tmp_qloop_581*0.5)*2.0 + tmp_qloop_749));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                   q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                   q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                   q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                   q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                   q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                   q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                   q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                   q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                   q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                   q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                   q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                   q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                   q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                   q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                   q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                   q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                   q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                   q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                   q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                   q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                   q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                   q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                   q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                   q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                   q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                   q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                   q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                   q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                   q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                   q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                   q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                   q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                   q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                   q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                   q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                   q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                   q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                   q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                   q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                   q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                   q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                   q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                   q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                   q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                   q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                   q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                   q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                   q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                   q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                   q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                   q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                   q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                   q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                   q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                   q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                   q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                   q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                   q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                   q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                   q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                   q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                   q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                   q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                   q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                   q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                   q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                   q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                   q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                   q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                   q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                   q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                   q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                   q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                   q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                   q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                   q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                   q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                   q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                   q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                   q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                   q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                   q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                   q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                   q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                   q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                   q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                   q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                   q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                   q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                   q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                   q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                   q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                   q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                   q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                   q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                   q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                   q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                   q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                   q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                   q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                   q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                   q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                   q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                   q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                   q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                   q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                   q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                   q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                   q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                   q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                   q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                   q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                   q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                   q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                   q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                   q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                   q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                   q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                   q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                   q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                   q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                   q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                   q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                   q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                   q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                   q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                   q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                   q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                   q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                   q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                   q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                   q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                   q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                   q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                   q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                   q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                   q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                   q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                   q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                   q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                   q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                   q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                   q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                   q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                   q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                   q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                   q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                   q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                   q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                   q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                   q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                   q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                   q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                   q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                   q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                   q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                   q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                   q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                   q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                   q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                   q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                   q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                   q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                   q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                   q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                   q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                   q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                   q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                   q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                   q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                   q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                   q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                   q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                   q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                   q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                   q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                   q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                   q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                   q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                   q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                   q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                   q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                   q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                   q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                   q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                   q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                   q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                   q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                   q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                   q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                   q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                   q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                   q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                   q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                   q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                   q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                   q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                   q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                   q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                   q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                   q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                   q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                   q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                   q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                   q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                   q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                   q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                   q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                   q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                   q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                   q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                   q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                   q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                   q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                   q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                   q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                   q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                   q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                   q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                   q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                   q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                   q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                   q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                   q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                   q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                   q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                   q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                   q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                   q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                   q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                   q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                   q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                   q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                   q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                   q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                   q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                   q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                   q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                   q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                   q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                   q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                   q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                   q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                   q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                   q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                   q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                   q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                   q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                   q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                   q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                   q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                   q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                   q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                   q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                   q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                   q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                   q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                   q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                   q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                   q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                   q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                   q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                   q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                   q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                   q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                   q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                   q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                   q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                   q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                   q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                   q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                   q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                   q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                   q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                   q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                   q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                   q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                   q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                   q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                   q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                   q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                   q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                   q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                   q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                   q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                   q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                   q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                   q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                   q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                   q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                   q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                   q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                   q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                   q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                   q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                   q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                   q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                   q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                   q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                   q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                   q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                   q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                   q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                   q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                   q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                   q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                   q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                   q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                   q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                   q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                   q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                   q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                   q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                   q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                   q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                   q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                   q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                   q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                   q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                   q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                   q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                   q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                   q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                   q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                   q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                   q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                   q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                   q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                   q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                   q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                   q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                   q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                   q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                   q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                   q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                   q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                   q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                   q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                   q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                   q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
                const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
                const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
                const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
                const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
                const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
                const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
                const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
                const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
                const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
                const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
                const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
                const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
                const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
                const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
                const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
                const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
                const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_17 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_27 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {0.25, 0.25, 0.25, 0.25, 0.16666666666666674, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666671, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666671, 0.5, 0.16666666666666666, 0.16666666666666666, 0.50000000000000011, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(abs_det_jac_affine_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(abs_det_jac_affine_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(abs_det_jac_affine_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_12 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_13 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_14 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_15 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_16 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_17 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_18 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_19 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_20 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_21 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_22 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_23 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_24 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_25 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_26 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_27 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_28 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_29 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[4*q],_data_phi_0_0_BLUE_DOWN[4*q],_data_phi_0_0_BLUE_DOWN[4*q],_data_phi_0_0_BLUE_DOWN[4*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[4*q + 1],_data_phi_0_0_BLUE_DOWN[4*q + 1],_data_phi_0_0_BLUE_DOWN[4*q + 1],_data_phi_0_0_BLUE_DOWN[4*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[4*q + 2],_data_phi_0_0_BLUE_DOWN[4*q + 2],_data_phi_0_0_BLUE_DOWN[4*q + 2],_data_phi_0_0_BLUE_DOWN[4*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_BLUE_DOWN[4*q + 3],_data_phi_0_0_BLUE_DOWN[4*q + 3],_data_phi_0_0_BLUE_DOWN[4*q + 3],_data_phi_0_0_BLUE_DOWN[4*q + 3]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_436 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_453 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_468 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_483 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_498 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_513 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_528 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_543 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_558 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_573 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q]));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_444 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_459 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_474 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_489 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_504 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_519 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_534 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_549 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_564 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_579 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q]));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_257 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_342 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_449 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_464 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_479 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_494 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_509 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_524 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_539 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_554 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_569 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_134 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_236 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_437 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_454 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_469 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_484 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_499 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_514 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_529 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_544 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_559 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_574 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_445 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_460 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_475 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_490 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_505 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_520 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_535 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_550 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_565 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_580 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_343 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_432 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_450 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_465 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_480 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_495 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_510 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_525 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_540 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_555 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_570 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_126 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_124,tmp_qloop_125),tmp_qloop_126);
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_125,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_126,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_134),tmp_qloop_135);
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_134,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_135,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_187 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_213 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_226 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_237 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_239 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_265 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_280 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_291 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(tmp_qloop_120,tmp_qloop_291);
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_438 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_455 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_470 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_485 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_500 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_515 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_530 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_545 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_560 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_575 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_585 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_589 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_585);
                   const __m256d tmp_qloop_596 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_599 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_596);
                   const __m256d tmp_qloop_605 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_608 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_605);
                   const __m256d tmp_qloop_614 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_617 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_614);
                   const __m256d tmp_qloop_623 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_626 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_623);
                   const __m256d tmp_qloop_632 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_635 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_632);
                   const __m256d tmp_qloop_641 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_644 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_641);
                   const __m256d tmp_qloop_650 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_653 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_650);
                   const __m256d tmp_qloop_659 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_662 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_659);
                   const __m256d tmp_qloop_667 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_277,tmp_qloop_278),tmp_qloop_279);
                   const __m256d tmp_qloop_674 = _mm256_mul_pd(tmp_qloop_291,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(1.0,1.0,1.0,1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_121),tmp_qloop_122),tmp_qloop_123);
                   const __m256d tmp_qloop_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_139,tmp_qloop_140);
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_145),tmp_qloop_146);
                   const __m256d tmp_qloop_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_144,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_145,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_146,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_178 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_191 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_204 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_217 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_230 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_243 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_255 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_269 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_289 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_286,tmp_qloop_287),tmp_qloop_288);
                   const __m256d tmp_qloop_290 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_283,tmp_qloop_284),tmp_qloop_285),tmp_qloop_289);
                   const __m256d tmp_qloop_299 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_312 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_313 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_326 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_327 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_340 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_341 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_354 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_355 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_368 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_369 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_382 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_383 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_396 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_410 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_424 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_434 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_280);
                   const __m256d tmp_qloop_440 = _mm256_add_pd(tmp_qloop_127,tmp_qloop_289);
                   const __m256d tmp_qloop_441 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_440),tmp_qloop_141),tmp_qloop_292);
                   const __m256d tmp_qloop_446 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_461 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_476 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_491 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_506 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_521 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_536 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_551 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_566 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_581 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_586 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_593 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_586),tmp_qloop_589);
                   const __m256d tmp_qloop_594 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_593);
                   const __m256d tmp_qloop_597 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_602 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_597),tmp_qloop_599);
                   const __m256d tmp_qloop_603 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_602);
                   const __m256d tmp_qloop_606 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_611 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_606),tmp_qloop_608);
                   const __m256d tmp_qloop_612 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_611);
                   const __m256d tmp_qloop_615 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_620 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_615),tmp_qloop_617);
                   const __m256d tmp_qloop_621 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_620);
                   const __m256d tmp_qloop_624 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_629 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_624),tmp_qloop_626);
                   const __m256d tmp_qloop_630 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_629);
                   const __m256d tmp_qloop_633 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_638 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_633),tmp_qloop_635);
                   const __m256d tmp_qloop_639 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_638);
                   const __m256d tmp_qloop_642 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_647 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_642),tmp_qloop_644);
                   const __m256d tmp_qloop_648 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_647);
                   const __m256d tmp_qloop_651 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_656 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_651),tmp_qloop_653);
                   const __m256d tmp_qloop_657 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_656);
                   const __m256d tmp_qloop_660 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_665 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_660),tmp_qloop_662);
                   const __m256d tmp_qloop_666 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_665);
                   const __m256d tmp_qloop_670 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_671 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_672 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_283),tmp_qloop_284),tmp_qloop_285);
                   const __m256d tmp_qloop_678 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_670),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_672)),tmp_qloop_674);
                   const __m256d tmp_qloop_690 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_691 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_694 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_690),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_691));
                   const __m256d tmp_qloop_695 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_694);
                   const __m256d tmp_qloop_697 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_698 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_700 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_697),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_698));
                   const __m256d tmp_qloop_701 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_700);
                   const __m256d tmp_qloop_703 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_704 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_706 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_703),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_704));
                   const __m256d tmp_qloop_707 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_706);
                   const __m256d tmp_qloop_709 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_710 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_712 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_709),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_710));
                   const __m256d tmp_qloop_713 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_712);
                   const __m256d tmp_qloop_715 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_716 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_718 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_715),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_716));
                   const __m256d tmp_qloop_719 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_718);
                   const __m256d tmp_qloop_721 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_722 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_724 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_721),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_722));
                   const __m256d tmp_qloop_725 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_724);
                   const __m256d tmp_qloop_727 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_728 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_730 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_727),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_728));
                   const __m256d tmp_qloop_731 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_730);
                   const __m256d tmp_qloop_733 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_734 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_736 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_733),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_734));
                   const __m256d tmp_qloop_737 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_736);
                   const __m256d tmp_qloop_739 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_740 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_742 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_739),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_740));
                   const __m256d tmp_qloop_743 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_742);
                   const __m256d tmp_qloop_744 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_667);
                   const __m256d tmp_qloop_749 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_440,_mm256_add_pd(tmp_qloop_128,tmp_qloop_671)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_141),tmp_qloop_674);
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_117));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_130),tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_142,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q]));
                   const __m256d tmp_qloop_151 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_148,tmp_qloop_149),tmp_qloop_150);
                   const __m256d tmp_qloop_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,_mm256_add_pd(tmp_qloop_147,tmp_qloop_151)),tmp_qloop_141),tmp_qloop_143);
                   const __m256d tmp_qloop_160 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_169 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_199 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_208 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_212 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_221 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_225 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_234 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_246 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_251 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_260 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_264 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_273 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_281 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_280);
                   const __m256d tmp_qloop_282 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_296 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_293,tmp_qloop_294),tmp_qloop_295);
                   const __m256d tmp_qloop_297 = _mm256_add_pd(tmp_qloop_136,tmp_qloop_296);
                   const __m256d tmp_qloop_298 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_297),tmp_qloop_143),tmp_qloop_292);
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_303 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_304 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_299),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_303));
                   const __m256d tmp_qloop_308 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_317 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_318 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_313),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_317));
                   const __m256d tmp_qloop_322 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_331 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_332 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_327),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_331));
                   const __m256d tmp_qloop_336 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_345 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_346 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_341),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_345));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_359 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_360 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_355),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_359));
                   const __m256d tmp_qloop_364 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_373 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_374 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_369),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_373));
                   const __m256d tmp_qloop_378 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_387 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_388 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_383),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_387));
                   const __m256d tmp_qloop_392 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_401 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_402 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_397),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_401));
                   const __m256d tmp_qloop_406 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_416 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_411),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_415));
                   const __m256d tmp_qloop_420 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_429 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_430 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_425),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_429));
                   const __m256d tmp_qloop_433 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_435 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_439 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_442 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_443 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_442);
                   const __m256d tmp_qloop_447 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_448 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_447),tmp_qloop_443);
                   const __m256d tmp_qloop_451 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_452 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_457 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_458 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_457);
                   const __m256d tmp_qloop_462 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_463 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_462),tmp_qloop_458);
                   const __m256d tmp_qloop_466 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_467 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_472 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_473 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_472);
                   const __m256d tmp_qloop_477 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_478 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_477),tmp_qloop_473);
                   const __m256d tmp_qloop_481 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_486 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_487 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_488 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_487);
                   const __m256d tmp_qloop_492 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_493 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_492),tmp_qloop_488);
                   const __m256d tmp_qloop_496 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_497 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_501 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_502 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_503 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_502);
                   const __m256d tmp_qloop_507 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_508 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_507),tmp_qloop_503);
                   const __m256d tmp_qloop_511 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_512 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_516 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_517 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_518 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_517);
                   const __m256d tmp_qloop_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_523 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_522),tmp_qloop_518);
                   const __m256d tmp_qloop_526 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_527 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_531 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_532 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_533 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_532);
                   const __m256d tmp_qloop_537 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_538 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_537),tmp_qloop_533);
                   const __m256d tmp_qloop_541 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_542 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_546 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_547 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_548 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_547);
                   const __m256d tmp_qloop_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_553 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_552),tmp_qloop_548);
                   const __m256d tmp_qloop_556 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_557 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_561 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_562 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_563 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_562);
                   const __m256d tmp_qloop_567 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d tmp_qloop_568 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_567),tmp_qloop_563);
                   const __m256d tmp_qloop_571 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_572 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_576 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_573),tmp_qloop_574),tmp_qloop_575);
                   const __m256d tmp_qloop_577 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_578 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_577);
                   const __m256d tmp_qloop_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_579),tmp_qloop_580),tmp_qloop_581);
                   const __m256d tmp_qloop_583 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_582),tmp_qloop_578);
                   const __m256d tmp_qloop_584 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_157),tmp_qloop_158),tmp_qloop_159));
                   const __m256d tmp_qloop_587 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_588 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_304);
                   const __m256d tmp_qloop_590 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_587),tmp_qloop_589);
                   const __m256d tmp_qloop_591 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_590);
                   const __m256d tmp_qloop_592 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_448);
                   const __m256d tmp_qloop_595 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172));
                   const __m256d tmp_qloop_598 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_600 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_598),tmp_qloop_599);
                   const __m256d tmp_qloop_601 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_600);
                   const __m256d tmp_qloop_604 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_183),tmp_qloop_184),tmp_qloop_185));
                   const __m256d tmp_qloop_607 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_609 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_607),tmp_qloop_608);
                   const __m256d tmp_qloop_610 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_609);
                   const __m256d tmp_qloop_613 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_196),tmp_qloop_197),tmp_qloop_198));
                   const __m256d tmp_qloop_616 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_618 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_616),tmp_qloop_617);
                   const __m256d tmp_qloop_619 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_618);
                   const __m256d tmp_qloop_622 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211));
                   const __m256d tmp_qloop_625 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_627 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_625),tmp_qloop_626);
                   const __m256d tmp_qloop_628 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_627);
                   const __m256d tmp_qloop_631 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_222),tmp_qloop_223),tmp_qloop_224));
                   const __m256d tmp_qloop_634 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_636 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_634),tmp_qloop_635);
                   const __m256d tmp_qloop_637 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_636);
                   const __m256d tmp_qloop_640 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_235),tmp_qloop_236),tmp_qloop_237));
                   const __m256d tmp_qloop_643 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_645 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_643),tmp_qloop_644);
                   const __m256d tmp_qloop_646 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_645);
                   const __m256d tmp_qloop_649 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250));
                   const __m256d tmp_qloop_652 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_654 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_652),tmp_qloop_653);
                   const __m256d tmp_qloop_655 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_654);
                   const __m256d tmp_qloop_658 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263));
                   const __m256d tmp_qloop_661 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_663 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_661),tmp_qloop_662);
                   const __m256d tmp_qloop_664 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_663);
                   const __m256d tmp_qloop_668 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_667);
                   const __m256d tmp_qloop_669 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_274,tmp_qloop_275),tmp_qloop_276),tmp_qloop_668));
                   const __m256d tmp_qloop_673 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_675 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_676 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_677 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_676),tmp_qloop_143),tmp_qloop_674);
                   const __m256d tmp_qloop_679 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_676),tmp_qloop_443);
                   const __m256d tmp_qloop_680 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_676),tmp_qloop_458);
                   const __m256d tmp_qloop_681 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_676),tmp_qloop_473);
                   const __m256d tmp_qloop_682 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_676),tmp_qloop_488);
                   const __m256d tmp_qloop_683 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_676),tmp_qloop_503);
                   const __m256d tmp_qloop_684 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_676),tmp_qloop_518);
                   const __m256d tmp_qloop_685 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_676),tmp_qloop_533);
                   const __m256d tmp_qloop_686 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_676),tmp_qloop_548);
                   const __m256d tmp_qloop_687 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_676),tmp_qloop_563);
                   const __m256d tmp_qloop_688 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_676),tmp_qloop_578);
                   const __m256d tmp_qloop_689 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_305,tmp_qloop_306),tmp_qloop_307),tmp_qloop_668));
                   const __m256d tmp_qloop_692 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_693 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_679);
                   const __m256d tmp_qloop_696 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_319,tmp_qloop_320),tmp_qloop_321),tmp_qloop_668));
                   const __m256d tmp_qloop_699 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_702 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_333,tmp_qloop_334),tmp_qloop_335),tmp_qloop_668));
                   const __m256d tmp_qloop_705 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_708 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_347,tmp_qloop_348),tmp_qloop_349),tmp_qloop_668));
                   const __m256d tmp_qloop_711 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_714 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_361,tmp_qloop_362),tmp_qloop_363),tmp_qloop_668));
                   const __m256d tmp_qloop_717 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_720 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_375,tmp_qloop_376),tmp_qloop_377),tmp_qloop_668));
                   const __m256d tmp_qloop_723 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_726 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_389,tmp_qloop_390),tmp_qloop_391),tmp_qloop_668));
                   const __m256d tmp_qloop_729 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_732 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_403,tmp_qloop_404),tmp_qloop_405),tmp_qloop_668));
                   const __m256d tmp_qloop_735 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_738 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_417,tmp_qloop_418),tmp_qloop_419),tmp_qloop_668));
                   const __m256d tmp_qloop_741 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_745 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_431,tmp_qloop_432),tmp_qloop_433),tmp_qloop_744));
                   const __m256d tmp_qloop_746 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_747 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_748 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_750 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_449,tmp_qloop_450),tmp_qloop_451),tmp_qloop_744));
                   const __m256d tmp_qloop_751 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_752 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_753 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_754 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_464,tmp_qloop_465),tmp_qloop_466),tmp_qloop_744));
                   const __m256d tmp_qloop_755 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_756 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_757 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_758 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_479,tmp_qloop_480),tmp_qloop_481),tmp_qloop_744));
                   const __m256d tmp_qloop_759 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_760 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_761 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_762 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_494,tmp_qloop_495),tmp_qloop_496),tmp_qloop_744));
                   const __m256d tmp_qloop_763 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_764 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_765 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_766 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_509,tmp_qloop_510),tmp_qloop_511),tmp_qloop_744));
                   const __m256d tmp_qloop_767 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_768 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_769 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_770 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_524,tmp_qloop_525),tmp_qloop_526),tmp_qloop_744));
                   const __m256d tmp_qloop_771 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_772 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_773 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_774 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_539,tmp_qloop_540),tmp_qloop_541),tmp_qloop_744));
                   const __m256d tmp_qloop_775 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_776 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_777 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_778 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_554,tmp_qloop_555),tmp_qloop_556),tmp_qloop_744));
                   const __m256d tmp_qloop_779 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_780 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_781 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(tmp_qloop_129,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_121,tmp_qloop_122),tmp_qloop_123),tmp_qloop_127))),_mm256_mul_pd(tmp_qloop_138,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132),tmp_qloop_136))),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_161),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_165)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_169)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_160),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_178)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_182)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_187),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_191)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_195)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_186),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_200),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_204)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_208)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_213),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_217)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_221)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_212),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_226),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_230)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_234)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_225),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_239),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_243)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_247)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_238),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_252),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_256)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_260)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_251),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_265),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_269)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_273)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_264),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_290),tmp_qloop_298),tmp_qloop_304)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_312),tmp_qloop_298),tmp_qloop_318)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_308),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_326),tmp_qloop_298),tmp_qloop_332)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_322),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_340),tmp_qloop_298),tmp_qloop_346)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_336),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_354),tmp_qloop_298),tmp_qloop_360)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_350),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_368),tmp_qloop_298),tmp_qloop_374)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_364),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_382),tmp_qloop_298),tmp_qloop_388)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_378),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_396),tmp_qloop_298),tmp_qloop_402)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_392),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_410),tmp_qloop_298),tmp_qloop_416)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_406),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_424),tmp_qloop_298),tmp_qloop_430)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_420),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_439),tmp_qloop_441),tmp_qloop_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_435),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_456),tmp_qloop_441),tmp_qloop_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_452),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_471),tmp_qloop_441),tmp_qloop_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_467),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_486),tmp_qloop_441),tmp_qloop_493)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_482),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_501),tmp_qloop_441),tmp_qloop_508)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_497),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_516),tmp_qloop_441),tmp_qloop_523)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_512),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_531),tmp_qloop_441),tmp_qloop_538)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_527),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_546),tmp_qloop_441),tmp_qloop_553)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_542),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_561),tmp_qloop_441),tmp_qloop_568)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_557),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_576),tmp_qloop_441),tmp_qloop_583)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_572),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_165,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_169,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_586),tmp_qloop_588),tmp_qloop_590)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_586),tmp_qloop_318),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_586),tmp_qloop_332),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_586),tmp_qloop_346),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_586),tmp_qloop_360),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_586),tmp_qloop_374),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_586),tmp_qloop_388),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_586),tmp_qloop_402),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_586),tmp_qloop_416),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_586),tmp_qloop_430),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_587),tmp_qloop_592),tmp_qloop_593)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_587),tmp_qloop_463),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_587),tmp_qloop_478),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_587),tmp_qloop_493),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_587),tmp_qloop_508),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_587),tmp_qloop_523),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_587),tmp_qloop_538),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_587),tmp_qloop_553),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_587),tmp_qloop_568),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_587),tmp_qloop_583),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_597),tmp_qloop_588),tmp_qloop_600)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_597),tmp_qloop_318),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_597),tmp_qloop_332),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_597),tmp_qloop_346),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_597),tmp_qloop_360),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_597),tmp_qloop_374),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_597),tmp_qloop_388),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_597),tmp_qloop_402),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_597),tmp_qloop_416),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_597),tmp_qloop_430),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_598),tmp_qloop_592),tmp_qloop_602)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_598),tmp_qloop_463),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_598),tmp_qloop_478),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_598),tmp_qloop_493),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_598),tmp_qloop_508),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_598),tmp_qloop_523),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_598),tmp_qloop_538),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_598),tmp_qloop_553),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_598),tmp_qloop_568),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_598),tmp_qloop_583),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_606),tmp_qloop_588),tmp_qloop_609)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_606),tmp_qloop_318),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_606),tmp_qloop_332),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_606),tmp_qloop_346),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_606),tmp_qloop_360),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_606),tmp_qloop_374),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_606),tmp_qloop_388),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_606),tmp_qloop_402),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_606),tmp_qloop_416),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_606),tmp_qloop_430),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_607),tmp_qloop_592),tmp_qloop_611)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_607),tmp_qloop_463),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_607),tmp_qloop_478),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_607),tmp_qloop_493),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_607),tmp_qloop_508),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_607),tmp_qloop_523),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_607),tmp_qloop_538),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_607),tmp_qloop_553),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_607),tmp_qloop_568),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_607),tmp_qloop_583),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_615),tmp_qloop_588),tmp_qloop_618)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_615),tmp_qloop_318),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_615),tmp_qloop_332),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_615),tmp_qloop_346),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_615),tmp_qloop_360),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_615),tmp_qloop_374),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_615),tmp_qloop_388),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_615),tmp_qloop_402),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_615),tmp_qloop_416),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_615),tmp_qloop_430),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_616),tmp_qloop_592),tmp_qloop_620)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_616),tmp_qloop_463),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_616),tmp_qloop_478),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_616),tmp_qloop_493),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_616),tmp_qloop_508),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_616),tmp_qloop_523),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_616),tmp_qloop_538),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_616),tmp_qloop_553),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_616),tmp_qloop_568),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_616),tmp_qloop_583),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_624),tmp_qloop_588),tmp_qloop_627)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_624),tmp_qloop_318),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_624),tmp_qloop_332),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_624),tmp_qloop_346),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_624),tmp_qloop_360),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_624),tmp_qloop_374),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_624),tmp_qloop_388),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_624),tmp_qloop_402),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_624),tmp_qloop_416),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_624),tmp_qloop_430),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_625),tmp_qloop_592),tmp_qloop_629)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_625),tmp_qloop_463),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_625),tmp_qloop_478),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_625),tmp_qloop_493),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_625),tmp_qloop_508),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_625),tmp_qloop_523),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_625),tmp_qloop_538),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_625),tmp_qloop_553),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_625),tmp_qloop_568),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_625),tmp_qloop_583),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_633),tmp_qloop_588),tmp_qloop_636)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_633),tmp_qloop_318),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_633),tmp_qloop_332),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_633),tmp_qloop_346),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_633),tmp_qloop_360),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_633),tmp_qloop_374),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_633),tmp_qloop_388),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_633),tmp_qloop_402),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_633),tmp_qloop_416),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_633),tmp_qloop_430),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_634),tmp_qloop_592),tmp_qloop_638)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_634),tmp_qloop_463),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_634),tmp_qloop_478),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_634),tmp_qloop_493),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_634),tmp_qloop_508),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_634),tmp_qloop_523),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_634),tmp_qloop_538),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_634),tmp_qloop_553),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_634),tmp_qloop_568),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_634),tmp_qloop_583),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_642),tmp_qloop_588),tmp_qloop_645)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_642),tmp_qloop_318),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_642),tmp_qloop_332),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_642),tmp_qloop_346),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_642),tmp_qloop_360),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_642),tmp_qloop_374),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_642),tmp_qloop_388),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_642),tmp_qloop_402),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_642),tmp_qloop_416),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_642),tmp_qloop_430),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_643),tmp_qloop_592),tmp_qloop_647)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_643),tmp_qloop_463),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_643),tmp_qloop_478),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_643),tmp_qloop_493),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_643),tmp_qloop_508),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_643),tmp_qloop_523),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_643),tmp_qloop_538),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_643),tmp_qloop_553),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_643),tmp_qloop_568),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_643),tmp_qloop_583),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_651),tmp_qloop_588),tmp_qloop_654)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_651),tmp_qloop_318),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_651),tmp_qloop_332),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_651),tmp_qloop_346),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_651),tmp_qloop_360),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_651),tmp_qloop_374),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_651),tmp_qloop_388),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_651),tmp_qloop_402),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_651),tmp_qloop_416),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_651),tmp_qloop_430),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_652),tmp_qloop_592),tmp_qloop_656)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_652),tmp_qloop_463),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_652),tmp_qloop_478),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_652),tmp_qloop_493),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_652),tmp_qloop_508),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_652),tmp_qloop_523),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_652),tmp_qloop_538),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_652),tmp_qloop_553),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_652),tmp_qloop_568),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_652),tmp_qloop_583),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_659),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_660)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_661)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_660),tmp_qloop_588),tmp_qloop_663)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_660),tmp_qloop_318),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_660),tmp_qloop_332),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_660),tmp_qloop_346),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_660),tmp_qloop_360),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_660),tmp_qloop_374),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_660),tmp_qloop_388),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_660),tmp_qloop_402),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_660),tmp_qloop_416),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_660),tmp_qloop_430),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_661),tmp_qloop_592),tmp_qloop_665)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_661),tmp_qloop_463),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_661),tmp_qloop_478),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_661),tmp_qloop_493),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_661),tmp_qloop_508),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_661),tmp_qloop_523),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_661),tmp_qloop_538),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_661),tmp_qloop_553),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_661),tmp_qloop_568),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_661),tmp_qloop_583),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_299,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_303,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_673),tmp_qloop_678),tmp_qloop_679)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_673),tmp_qloop_678),tmp_qloop_680)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_673),tmp_qloop_678),tmp_qloop_681)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_673),tmp_qloop_678),tmp_qloop_682)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_673),tmp_qloop_678),tmp_qloop_683)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_673),tmp_qloop_678),tmp_qloop_684)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_673),tmp_qloop_678),tmp_qloop_685)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_673),tmp_qloop_678),tmp_qloop_686)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_673),tmp_qloop_678),tmp_qloop_687)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_673),tmp_qloop_678),tmp_qloop_688)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_692),tmp_qloop_693),tmp_qloop_694)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_692),tmp_qloop_680),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_692),tmp_qloop_681),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_692),tmp_qloop_682),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_692),tmp_qloop_683),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_692),tmp_qloop_684),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_692),tmp_qloop_685),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_692),tmp_qloop_686),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_692),tmp_qloop_687),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_692),tmp_qloop_688),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_699),tmp_qloop_693),tmp_qloop_700)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_699),tmp_qloop_680),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_699),tmp_qloop_681),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_699),tmp_qloop_682),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_699),tmp_qloop_683),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_699),tmp_qloop_684),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_699),tmp_qloop_685),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_699),tmp_qloop_686),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_699),tmp_qloop_687),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_699),tmp_qloop_688),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_705),tmp_qloop_693),tmp_qloop_706)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_705),tmp_qloop_680),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_705),tmp_qloop_681),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_705),tmp_qloop_682),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_705),tmp_qloop_683),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_705),tmp_qloop_684),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_705),tmp_qloop_685),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_705),tmp_qloop_686),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_705),tmp_qloop_687),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_705),tmp_qloop_688),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_711),tmp_qloop_693),tmp_qloop_712)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_711),tmp_qloop_680),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_711),tmp_qloop_681),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_711),tmp_qloop_682),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_711),tmp_qloop_683),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_711),tmp_qloop_684),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_711),tmp_qloop_685),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_711),tmp_qloop_686),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_711),tmp_qloop_687),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_711),tmp_qloop_688),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_717),tmp_qloop_693),tmp_qloop_718)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_717),tmp_qloop_680),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_717),tmp_qloop_681),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_717),tmp_qloop_682),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_717),tmp_qloop_683),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_717),tmp_qloop_684),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_717),tmp_qloop_685),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_717),tmp_qloop_686),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_717),tmp_qloop_687),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_717),tmp_qloop_688),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_723),tmp_qloop_693),tmp_qloop_724)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_723),tmp_qloop_680),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_723),tmp_qloop_681),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_723),tmp_qloop_682),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_723),tmp_qloop_683),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_723),tmp_qloop_684),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_723),tmp_qloop_685),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_723),tmp_qloop_686),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_723),tmp_qloop_687),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_723),tmp_qloop_688),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_729),tmp_qloop_693),tmp_qloop_730)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_729),tmp_qloop_680),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_729),tmp_qloop_681),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_729),tmp_qloop_682),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_729),tmp_qloop_683),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_729),tmp_qloop_684),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_729),tmp_qloop_685),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_729),tmp_qloop_686),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_729),tmp_qloop_687),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_729),tmp_qloop_688),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_735),tmp_qloop_693),tmp_qloop_736)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_735),tmp_qloop_680),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_735),tmp_qloop_681),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_735),tmp_qloop_682),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_735),tmp_qloop_683),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_735),tmp_qloop_684),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_735),tmp_qloop_685),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_735),tmp_qloop_686),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_735),tmp_qloop_687),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_735),tmp_qloop_688),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_740),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_739)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_741)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_741),tmp_qloop_693),tmp_qloop_742)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_741),tmp_qloop_680),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_741),tmp_qloop_681),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_741),tmp_qloop_682),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_741),tmp_qloop_683),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_741),tmp_qloop_684),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_741),tmp_qloop_685),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_741),tmp_qloop_686),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_741),tmp_qloop_687),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_741),tmp_qloop_688),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_442,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_447,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_577,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(1.0,1.0,1.0,1.0)))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_576,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_573,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_574,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_575,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_675)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_582,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_579,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_580,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_581,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_153)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_572),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_569,tmp_qloop_570),tmp_qloop_571),tmp_qloop_744)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_0_12 = _mm256_add_pd(q_acc_0_12,q_tmp_0_12);
                   q_acc_0_13 = _mm256_add_pd(q_acc_0_13,q_tmp_0_13);
                   q_acc_0_14 = _mm256_add_pd(q_acc_0_14,q_tmp_0_14);
                   q_acc_0_15 = _mm256_add_pd(q_acc_0_15,q_tmp_0_15);
                   q_acc_0_16 = _mm256_add_pd(q_acc_0_16,q_tmp_0_16);
                   q_acc_0_17 = _mm256_add_pd(q_acc_0_17,q_tmp_0_17);
                   q_acc_0_18 = _mm256_add_pd(q_acc_0_18,q_tmp_0_18);
                   q_acc_0_19 = _mm256_add_pd(q_acc_0_19,q_tmp_0_19);
                   q_acc_0_20 = _mm256_add_pd(q_acc_0_20,q_tmp_0_20);
                   q_acc_0_21 = _mm256_add_pd(q_acc_0_21,q_tmp_0_21);
                   q_acc_0_22 = _mm256_add_pd(q_acc_0_22,q_tmp_0_22);
                   q_acc_0_23 = _mm256_add_pd(q_acc_0_23,q_tmp_0_23);
                   q_acc_0_24 = _mm256_add_pd(q_acc_0_24,q_tmp_0_24);
                   q_acc_0_25 = _mm256_add_pd(q_acc_0_25,q_tmp_0_25);
                   q_acc_0_26 = _mm256_add_pd(q_acc_0_26,q_tmp_0_26);
                   q_acc_0_27 = _mm256_add_pd(q_acc_0_27,q_tmp_0_27);
                   q_acc_0_28 = _mm256_add_pd(q_acc_0_28,q_tmp_0_28);
                   q_acc_0_29 = _mm256_add_pd(q_acc_0_29,q_tmp_0_29);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_1_12 = _mm256_add_pd(q_acc_1_12,q_tmp_1_12);
                   q_acc_1_13 = _mm256_add_pd(q_acc_1_13,q_tmp_1_13);
                   q_acc_1_14 = _mm256_add_pd(q_acc_1_14,q_tmp_1_14);
                   q_acc_1_15 = _mm256_add_pd(q_acc_1_15,q_tmp_1_15);
                   q_acc_1_16 = _mm256_add_pd(q_acc_1_16,q_tmp_1_16);
                   q_acc_1_17 = _mm256_add_pd(q_acc_1_17,q_tmp_1_17);
                   q_acc_1_18 = _mm256_add_pd(q_acc_1_18,q_tmp_1_18);
                   q_acc_1_19 = _mm256_add_pd(q_acc_1_19,q_tmp_1_19);
                   q_acc_1_20 = _mm256_add_pd(q_acc_1_20,q_tmp_1_20);
                   q_acc_1_21 = _mm256_add_pd(q_acc_1_21,q_tmp_1_21);
                   q_acc_1_22 = _mm256_add_pd(q_acc_1_22,q_tmp_1_22);
                   q_acc_1_23 = _mm256_add_pd(q_acc_1_23,q_tmp_1_23);
                   q_acc_1_24 = _mm256_add_pd(q_acc_1_24,q_tmp_1_24);
                   q_acc_1_25 = _mm256_add_pd(q_acc_1_25,q_tmp_1_25);
                   q_acc_1_26 = _mm256_add_pd(q_acc_1_26,q_tmp_1_26);
                   q_acc_1_27 = _mm256_add_pd(q_acc_1_27,q_tmp_1_27);
                   q_acc_1_28 = _mm256_add_pd(q_acc_1_28,q_tmp_1_28);
                   q_acc_1_29 = _mm256_add_pd(q_acc_1_29,q_tmp_1_29);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_2_12 = _mm256_add_pd(q_acc_2_12,q_tmp_2_12);
                   q_acc_2_13 = _mm256_add_pd(q_acc_2_13,q_tmp_2_13);
                   q_acc_2_14 = _mm256_add_pd(q_acc_2_14,q_tmp_2_14);
                   q_acc_2_15 = _mm256_add_pd(q_acc_2_15,q_tmp_2_15);
                   q_acc_2_16 = _mm256_add_pd(q_acc_2_16,q_tmp_2_16);
                   q_acc_2_17 = _mm256_add_pd(q_acc_2_17,q_tmp_2_17);
                   q_acc_2_18 = _mm256_add_pd(q_acc_2_18,q_tmp_2_18);
                   q_acc_2_19 = _mm256_add_pd(q_acc_2_19,q_tmp_2_19);
                   q_acc_2_20 = _mm256_add_pd(q_acc_2_20,q_tmp_2_20);
                   q_acc_2_21 = _mm256_add_pd(q_acc_2_21,q_tmp_2_21);
                   q_acc_2_22 = _mm256_add_pd(q_acc_2_22,q_tmp_2_22);
                   q_acc_2_23 = _mm256_add_pd(q_acc_2_23,q_tmp_2_23);
                   q_acc_2_24 = _mm256_add_pd(q_acc_2_24,q_tmp_2_24);
                   q_acc_2_25 = _mm256_add_pd(q_acc_2_25,q_tmp_2_25);
                   q_acc_2_26 = _mm256_add_pd(q_acc_2_26,q_tmp_2_26);
                   q_acc_2_27 = _mm256_add_pd(q_acc_2_27,q_tmp_2_27);
                   q_acc_2_28 = _mm256_add_pd(q_acc_2_28,q_tmp_2_28);
                   q_acc_2_29 = _mm256_add_pd(q_acc_2_29,q_tmp_2_29);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_3_12 = _mm256_add_pd(q_acc_3_12,q_tmp_3_12);
                   q_acc_3_13 = _mm256_add_pd(q_acc_3_13,q_tmp_3_13);
                   q_acc_3_14 = _mm256_add_pd(q_acc_3_14,q_tmp_3_14);
                   q_acc_3_15 = _mm256_add_pd(q_acc_3_15,q_tmp_3_15);
                   q_acc_3_16 = _mm256_add_pd(q_acc_3_16,q_tmp_3_16);
                   q_acc_3_17 = _mm256_add_pd(q_acc_3_17,q_tmp_3_17);
                   q_acc_3_18 = _mm256_add_pd(q_acc_3_18,q_tmp_3_18);
                   q_acc_3_19 = _mm256_add_pd(q_acc_3_19,q_tmp_3_19);
                   q_acc_3_20 = _mm256_add_pd(q_acc_3_20,q_tmp_3_20);
                   q_acc_3_21 = _mm256_add_pd(q_acc_3_21,q_tmp_3_21);
                   q_acc_3_22 = _mm256_add_pd(q_acc_3_22,q_tmp_3_22);
                   q_acc_3_23 = _mm256_add_pd(q_acc_3_23,q_tmp_3_23);
                   q_acc_3_24 = _mm256_add_pd(q_acc_3_24,q_tmp_3_24);
                   q_acc_3_25 = _mm256_add_pd(q_acc_3_25,q_tmp_3_25);
                   q_acc_3_26 = _mm256_add_pd(q_acc_3_26,q_tmp_3_26);
                   q_acc_3_27 = _mm256_add_pd(q_acc_3_27,q_tmp_3_27);
                   q_acc_3_28 = _mm256_add_pd(q_acc_3_28,q_tmp_3_28);
                   q_acc_3_29 = _mm256_add_pd(q_acc_3_29,q_tmp_3_29);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_4_12 = _mm256_add_pd(q_acc_4_12,q_tmp_4_12);
                   q_acc_4_13 = _mm256_add_pd(q_acc_4_13,q_tmp_4_13);
                   q_acc_4_14 = _mm256_add_pd(q_acc_4_14,q_tmp_4_14);
                   q_acc_4_15 = _mm256_add_pd(q_acc_4_15,q_tmp_4_15);
                   q_acc_4_16 = _mm256_add_pd(q_acc_4_16,q_tmp_4_16);
                   q_acc_4_17 = _mm256_add_pd(q_acc_4_17,q_tmp_4_17);
                   q_acc_4_18 = _mm256_add_pd(q_acc_4_18,q_tmp_4_18);
                   q_acc_4_19 = _mm256_add_pd(q_acc_4_19,q_tmp_4_19);
                   q_acc_4_20 = _mm256_add_pd(q_acc_4_20,q_tmp_4_20);
                   q_acc_4_21 = _mm256_add_pd(q_acc_4_21,q_tmp_4_21);
                   q_acc_4_22 = _mm256_add_pd(q_acc_4_22,q_tmp_4_22);
                   q_acc_4_23 = _mm256_add_pd(q_acc_4_23,q_tmp_4_23);
                   q_acc_4_24 = _mm256_add_pd(q_acc_4_24,q_tmp_4_24);
                   q_acc_4_25 = _mm256_add_pd(q_acc_4_25,q_tmp_4_25);
                   q_acc_4_26 = _mm256_add_pd(q_acc_4_26,q_tmp_4_26);
                   q_acc_4_27 = _mm256_add_pd(q_acc_4_27,q_tmp_4_27);
                   q_acc_4_28 = _mm256_add_pd(q_acc_4_28,q_tmp_4_28);
                   q_acc_4_29 = _mm256_add_pd(q_acc_4_29,q_tmp_4_29);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_5_12 = _mm256_add_pd(q_acc_5_12,q_tmp_5_12);
                   q_acc_5_13 = _mm256_add_pd(q_acc_5_13,q_tmp_5_13);
                   q_acc_5_14 = _mm256_add_pd(q_acc_5_14,q_tmp_5_14);
                   q_acc_5_15 = _mm256_add_pd(q_acc_5_15,q_tmp_5_15);
                   q_acc_5_16 = _mm256_add_pd(q_acc_5_16,q_tmp_5_16);
                   q_acc_5_17 = _mm256_add_pd(q_acc_5_17,q_tmp_5_17);
                   q_acc_5_18 = _mm256_add_pd(q_acc_5_18,q_tmp_5_18);
                   q_acc_5_19 = _mm256_add_pd(q_acc_5_19,q_tmp_5_19);
                   q_acc_5_20 = _mm256_add_pd(q_acc_5_20,q_tmp_5_20);
                   q_acc_5_21 = _mm256_add_pd(q_acc_5_21,q_tmp_5_21);
                   q_acc_5_22 = _mm256_add_pd(q_acc_5_22,q_tmp_5_22);
                   q_acc_5_23 = _mm256_add_pd(q_acc_5_23,q_tmp_5_23);
                   q_acc_5_24 = _mm256_add_pd(q_acc_5_24,q_tmp_5_24);
                   q_acc_5_25 = _mm256_add_pd(q_acc_5_25,q_tmp_5_25);
                   q_acc_5_26 = _mm256_add_pd(q_acc_5_26,q_tmp_5_26);
                   q_acc_5_27 = _mm256_add_pd(q_acc_5_27,q_tmp_5_27);
                   q_acc_5_28 = _mm256_add_pd(q_acc_5_28,q_tmp_5_28);
                   q_acc_5_29 = _mm256_add_pd(q_acc_5_29,q_tmp_5_29);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_6_12 = _mm256_add_pd(q_acc_6_12,q_tmp_6_12);
                   q_acc_6_13 = _mm256_add_pd(q_acc_6_13,q_tmp_6_13);
                   q_acc_6_14 = _mm256_add_pd(q_acc_6_14,q_tmp_6_14);
                   q_acc_6_15 = _mm256_add_pd(q_acc_6_15,q_tmp_6_15);
                   q_acc_6_16 = _mm256_add_pd(q_acc_6_16,q_tmp_6_16);
                   q_acc_6_17 = _mm256_add_pd(q_acc_6_17,q_tmp_6_17);
                   q_acc_6_18 = _mm256_add_pd(q_acc_6_18,q_tmp_6_18);
                   q_acc_6_19 = _mm256_add_pd(q_acc_6_19,q_tmp_6_19);
                   q_acc_6_20 = _mm256_add_pd(q_acc_6_20,q_tmp_6_20);
                   q_acc_6_21 = _mm256_add_pd(q_acc_6_21,q_tmp_6_21);
                   q_acc_6_22 = _mm256_add_pd(q_acc_6_22,q_tmp_6_22);
                   q_acc_6_23 = _mm256_add_pd(q_acc_6_23,q_tmp_6_23);
                   q_acc_6_24 = _mm256_add_pd(q_acc_6_24,q_tmp_6_24);
                   q_acc_6_25 = _mm256_add_pd(q_acc_6_25,q_tmp_6_25);
                   q_acc_6_26 = _mm256_add_pd(q_acc_6_26,q_tmp_6_26);
                   q_acc_6_27 = _mm256_add_pd(q_acc_6_27,q_tmp_6_27);
                   q_acc_6_28 = _mm256_add_pd(q_acc_6_28,q_tmp_6_28);
                   q_acc_6_29 = _mm256_add_pd(q_acc_6_29,q_tmp_6_29);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_7_12 = _mm256_add_pd(q_acc_7_12,q_tmp_7_12);
                   q_acc_7_13 = _mm256_add_pd(q_acc_7_13,q_tmp_7_13);
                   q_acc_7_14 = _mm256_add_pd(q_acc_7_14,q_tmp_7_14);
                   q_acc_7_15 = _mm256_add_pd(q_acc_7_15,q_tmp_7_15);
                   q_acc_7_16 = _mm256_add_pd(q_acc_7_16,q_tmp_7_16);
                   q_acc_7_17 = _mm256_add_pd(q_acc_7_17,q_tmp_7_17);
                   q_acc_7_18 = _mm256_add_pd(q_acc_7_18,q_tmp_7_18);
                   q_acc_7_19 = _mm256_add_pd(q_acc_7_19,q_tmp_7_19);
                   q_acc_7_20 = _mm256_add_pd(q_acc_7_20,q_tmp_7_20);
                   q_acc_7_21 = _mm256_add_pd(q_acc_7_21,q_tmp_7_21);
                   q_acc_7_22 = _mm256_add_pd(q_acc_7_22,q_tmp_7_22);
                   q_acc_7_23 = _mm256_add_pd(q_acc_7_23,q_tmp_7_23);
                   q_acc_7_24 = _mm256_add_pd(q_acc_7_24,q_tmp_7_24);
                   q_acc_7_25 = _mm256_add_pd(q_acc_7_25,q_tmp_7_25);
                   q_acc_7_26 = _mm256_add_pd(q_acc_7_26,q_tmp_7_26);
                   q_acc_7_27 = _mm256_add_pd(q_acc_7_27,q_tmp_7_27);
                   q_acc_7_28 = _mm256_add_pd(q_acc_7_28,q_tmp_7_28);
                   q_acc_7_29 = _mm256_add_pd(q_acc_7_29,q_tmp_7_29);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_8_12 = _mm256_add_pd(q_acc_8_12,q_tmp_8_12);
                   q_acc_8_13 = _mm256_add_pd(q_acc_8_13,q_tmp_8_13);
                   q_acc_8_14 = _mm256_add_pd(q_acc_8_14,q_tmp_8_14);
                   q_acc_8_15 = _mm256_add_pd(q_acc_8_15,q_tmp_8_15);
                   q_acc_8_16 = _mm256_add_pd(q_acc_8_16,q_tmp_8_16);
                   q_acc_8_17 = _mm256_add_pd(q_acc_8_17,q_tmp_8_17);
                   q_acc_8_18 = _mm256_add_pd(q_acc_8_18,q_tmp_8_18);
                   q_acc_8_19 = _mm256_add_pd(q_acc_8_19,q_tmp_8_19);
                   q_acc_8_20 = _mm256_add_pd(q_acc_8_20,q_tmp_8_20);
                   q_acc_8_21 = _mm256_add_pd(q_acc_8_21,q_tmp_8_21);
                   q_acc_8_22 = _mm256_add_pd(q_acc_8_22,q_tmp_8_22);
                   q_acc_8_23 = _mm256_add_pd(q_acc_8_23,q_tmp_8_23);
                   q_acc_8_24 = _mm256_add_pd(q_acc_8_24,q_tmp_8_24);
                   q_acc_8_25 = _mm256_add_pd(q_acc_8_25,q_tmp_8_25);
                   q_acc_8_26 = _mm256_add_pd(q_acc_8_26,q_tmp_8_26);
                   q_acc_8_27 = _mm256_add_pd(q_acc_8_27,q_tmp_8_27);
                   q_acc_8_28 = _mm256_add_pd(q_acc_8_28,q_tmp_8_28);
                   q_acc_8_29 = _mm256_add_pd(q_acc_8_29,q_tmp_8_29);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_9_12 = _mm256_add_pd(q_acc_9_12,q_tmp_9_12);
                   q_acc_9_13 = _mm256_add_pd(q_acc_9_13,q_tmp_9_13);
                   q_acc_9_14 = _mm256_add_pd(q_acc_9_14,q_tmp_9_14);
                   q_acc_9_15 = _mm256_add_pd(q_acc_9_15,q_tmp_9_15);
                   q_acc_9_16 = _mm256_add_pd(q_acc_9_16,q_tmp_9_16);
                   q_acc_9_17 = _mm256_add_pd(q_acc_9_17,q_tmp_9_17);
                   q_acc_9_18 = _mm256_add_pd(q_acc_9_18,q_tmp_9_18);
                   q_acc_9_19 = _mm256_add_pd(q_acc_9_19,q_tmp_9_19);
                   q_acc_9_20 = _mm256_add_pd(q_acc_9_20,q_tmp_9_20);
                   q_acc_9_21 = _mm256_add_pd(q_acc_9_21,q_tmp_9_21);
                   q_acc_9_22 = _mm256_add_pd(q_acc_9_22,q_tmp_9_22);
                   q_acc_9_23 = _mm256_add_pd(q_acc_9_23,q_tmp_9_23);
                   q_acc_9_24 = _mm256_add_pd(q_acc_9_24,q_tmp_9_24);
                   q_acc_9_25 = _mm256_add_pd(q_acc_9_25,q_tmp_9_25);
                   q_acc_9_26 = _mm256_add_pd(q_acc_9_26,q_tmp_9_26);
                   q_acc_9_27 = _mm256_add_pd(q_acc_9_27,q_tmp_9_27);
                   q_acc_9_28 = _mm256_add_pd(q_acc_9_28,q_tmp_9_28);
                   q_acc_9_29 = _mm256_add_pd(q_acc_9_29,q_tmp_9_29);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_10_12 = _mm256_add_pd(q_acc_10_12,q_tmp_10_12);
                   q_acc_10_13 = _mm256_add_pd(q_acc_10_13,q_tmp_10_13);
                   q_acc_10_14 = _mm256_add_pd(q_acc_10_14,q_tmp_10_14);
                   q_acc_10_15 = _mm256_add_pd(q_acc_10_15,q_tmp_10_15);
                   q_acc_10_16 = _mm256_add_pd(q_acc_10_16,q_tmp_10_16);
                   q_acc_10_17 = _mm256_add_pd(q_acc_10_17,q_tmp_10_17);
                   q_acc_10_18 = _mm256_add_pd(q_acc_10_18,q_tmp_10_18);
                   q_acc_10_19 = _mm256_add_pd(q_acc_10_19,q_tmp_10_19);
                   q_acc_10_20 = _mm256_add_pd(q_acc_10_20,q_tmp_10_20);
                   q_acc_10_21 = _mm256_add_pd(q_acc_10_21,q_tmp_10_21);
                   q_acc_10_22 = _mm256_add_pd(q_acc_10_22,q_tmp_10_22);
                   q_acc_10_23 = _mm256_add_pd(q_acc_10_23,q_tmp_10_23);
                   q_acc_10_24 = _mm256_add_pd(q_acc_10_24,q_tmp_10_24);
                   q_acc_10_25 = _mm256_add_pd(q_acc_10_25,q_tmp_10_25);
                   q_acc_10_26 = _mm256_add_pd(q_acc_10_26,q_tmp_10_26);
                   q_acc_10_27 = _mm256_add_pd(q_acc_10_27,q_tmp_10_27);
                   q_acc_10_28 = _mm256_add_pd(q_acc_10_28,q_tmp_10_28);
                   q_acc_10_29 = _mm256_add_pd(q_acc_10_29,q_tmp_10_29);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_11_12 = _mm256_add_pd(q_acc_11_12,q_tmp_11_12);
                   q_acc_11_13 = _mm256_add_pd(q_acc_11_13,q_tmp_11_13);
                   q_acc_11_14 = _mm256_add_pd(q_acc_11_14,q_tmp_11_14);
                   q_acc_11_15 = _mm256_add_pd(q_acc_11_15,q_tmp_11_15);
                   q_acc_11_16 = _mm256_add_pd(q_acc_11_16,q_tmp_11_16);
                   q_acc_11_17 = _mm256_add_pd(q_acc_11_17,q_tmp_11_17);
                   q_acc_11_18 = _mm256_add_pd(q_acc_11_18,q_tmp_11_18);
                   q_acc_11_19 = _mm256_add_pd(q_acc_11_19,q_tmp_11_19);
                   q_acc_11_20 = _mm256_add_pd(q_acc_11_20,q_tmp_11_20);
                   q_acc_11_21 = _mm256_add_pd(q_acc_11_21,q_tmp_11_21);
                   q_acc_11_22 = _mm256_add_pd(q_acc_11_22,q_tmp_11_22);
                   q_acc_11_23 = _mm256_add_pd(q_acc_11_23,q_tmp_11_23);
                   q_acc_11_24 = _mm256_add_pd(q_acc_11_24,q_tmp_11_24);
                   q_acc_11_25 = _mm256_add_pd(q_acc_11_25,q_tmp_11_25);
                   q_acc_11_26 = _mm256_add_pd(q_acc_11_26,q_tmp_11_26);
                   q_acc_11_27 = _mm256_add_pd(q_acc_11_27,q_tmp_11_27);
                   q_acc_11_28 = _mm256_add_pd(q_acc_11_28,q_tmp_11_28);
                   q_acc_11_29 = _mm256_add_pd(q_acc_11_29,q_tmp_11_29);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_12_13 = _mm256_add_pd(q_acc_12_13,q_tmp_12_13);
                   q_acc_12_14 = _mm256_add_pd(q_acc_12_14,q_tmp_12_14);
                   q_acc_12_15 = _mm256_add_pd(q_acc_12_15,q_tmp_12_15);
                   q_acc_12_16 = _mm256_add_pd(q_acc_12_16,q_tmp_12_16);
                   q_acc_12_17 = _mm256_add_pd(q_acc_12_17,q_tmp_12_17);
                   q_acc_12_18 = _mm256_add_pd(q_acc_12_18,q_tmp_12_18);
                   q_acc_12_19 = _mm256_add_pd(q_acc_12_19,q_tmp_12_19);
                   q_acc_12_20 = _mm256_add_pd(q_acc_12_20,q_tmp_12_20);
                   q_acc_12_21 = _mm256_add_pd(q_acc_12_21,q_tmp_12_21);
                   q_acc_12_22 = _mm256_add_pd(q_acc_12_22,q_tmp_12_22);
                   q_acc_12_23 = _mm256_add_pd(q_acc_12_23,q_tmp_12_23);
                   q_acc_12_24 = _mm256_add_pd(q_acc_12_24,q_tmp_12_24);
                   q_acc_12_25 = _mm256_add_pd(q_acc_12_25,q_tmp_12_25);
                   q_acc_12_26 = _mm256_add_pd(q_acc_12_26,q_tmp_12_26);
                   q_acc_12_27 = _mm256_add_pd(q_acc_12_27,q_tmp_12_27);
                   q_acc_12_28 = _mm256_add_pd(q_acc_12_28,q_tmp_12_28);
                   q_acc_12_29 = _mm256_add_pd(q_acc_12_29,q_tmp_12_29);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_13_14 = _mm256_add_pd(q_acc_13_14,q_tmp_13_14);
                   q_acc_13_15 = _mm256_add_pd(q_acc_13_15,q_tmp_13_15);
                   q_acc_13_16 = _mm256_add_pd(q_acc_13_16,q_tmp_13_16);
                   q_acc_13_17 = _mm256_add_pd(q_acc_13_17,q_tmp_13_17);
                   q_acc_13_18 = _mm256_add_pd(q_acc_13_18,q_tmp_13_18);
                   q_acc_13_19 = _mm256_add_pd(q_acc_13_19,q_tmp_13_19);
                   q_acc_13_20 = _mm256_add_pd(q_acc_13_20,q_tmp_13_20);
                   q_acc_13_21 = _mm256_add_pd(q_acc_13_21,q_tmp_13_21);
                   q_acc_13_22 = _mm256_add_pd(q_acc_13_22,q_tmp_13_22);
                   q_acc_13_23 = _mm256_add_pd(q_acc_13_23,q_tmp_13_23);
                   q_acc_13_24 = _mm256_add_pd(q_acc_13_24,q_tmp_13_24);
                   q_acc_13_25 = _mm256_add_pd(q_acc_13_25,q_tmp_13_25);
                   q_acc_13_26 = _mm256_add_pd(q_acc_13_26,q_tmp_13_26);
                   q_acc_13_27 = _mm256_add_pd(q_acc_13_27,q_tmp_13_27);
                   q_acc_13_28 = _mm256_add_pd(q_acc_13_28,q_tmp_13_28);
                   q_acc_13_29 = _mm256_add_pd(q_acc_13_29,q_tmp_13_29);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_14_15 = _mm256_add_pd(q_acc_14_15,q_tmp_14_15);
                   q_acc_14_16 = _mm256_add_pd(q_acc_14_16,q_tmp_14_16);
                   q_acc_14_17 = _mm256_add_pd(q_acc_14_17,q_tmp_14_17);
                   q_acc_14_18 = _mm256_add_pd(q_acc_14_18,q_tmp_14_18);
                   q_acc_14_19 = _mm256_add_pd(q_acc_14_19,q_tmp_14_19);
                   q_acc_14_20 = _mm256_add_pd(q_acc_14_20,q_tmp_14_20);
                   q_acc_14_21 = _mm256_add_pd(q_acc_14_21,q_tmp_14_21);
                   q_acc_14_22 = _mm256_add_pd(q_acc_14_22,q_tmp_14_22);
                   q_acc_14_23 = _mm256_add_pd(q_acc_14_23,q_tmp_14_23);
                   q_acc_14_24 = _mm256_add_pd(q_acc_14_24,q_tmp_14_24);
                   q_acc_14_25 = _mm256_add_pd(q_acc_14_25,q_tmp_14_25);
                   q_acc_14_26 = _mm256_add_pd(q_acc_14_26,q_tmp_14_26);
                   q_acc_14_27 = _mm256_add_pd(q_acc_14_27,q_tmp_14_27);
                   q_acc_14_28 = _mm256_add_pd(q_acc_14_28,q_tmp_14_28);
                   q_acc_14_29 = _mm256_add_pd(q_acc_14_29,q_tmp_14_29);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_15_16 = _mm256_add_pd(q_acc_15_16,q_tmp_15_16);
                   q_acc_15_17 = _mm256_add_pd(q_acc_15_17,q_tmp_15_17);
                   q_acc_15_18 = _mm256_add_pd(q_acc_15_18,q_tmp_15_18);
                   q_acc_15_19 = _mm256_add_pd(q_acc_15_19,q_tmp_15_19);
                   q_acc_15_20 = _mm256_add_pd(q_acc_15_20,q_tmp_15_20);
                   q_acc_15_21 = _mm256_add_pd(q_acc_15_21,q_tmp_15_21);
                   q_acc_15_22 = _mm256_add_pd(q_acc_15_22,q_tmp_15_22);
                   q_acc_15_23 = _mm256_add_pd(q_acc_15_23,q_tmp_15_23);
                   q_acc_15_24 = _mm256_add_pd(q_acc_15_24,q_tmp_15_24);
                   q_acc_15_25 = _mm256_add_pd(q_acc_15_25,q_tmp_15_25);
                   q_acc_15_26 = _mm256_add_pd(q_acc_15_26,q_tmp_15_26);
                   q_acc_15_27 = _mm256_add_pd(q_acc_15_27,q_tmp_15_27);
                   q_acc_15_28 = _mm256_add_pd(q_acc_15_28,q_tmp_15_28);
                   q_acc_15_29 = _mm256_add_pd(q_acc_15_29,q_tmp_15_29);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_16_17 = _mm256_add_pd(q_acc_16_17,q_tmp_16_17);
                   q_acc_16_18 = _mm256_add_pd(q_acc_16_18,q_tmp_16_18);
                   q_acc_16_19 = _mm256_add_pd(q_acc_16_19,q_tmp_16_19);
                   q_acc_16_20 = _mm256_add_pd(q_acc_16_20,q_tmp_16_20);
                   q_acc_16_21 = _mm256_add_pd(q_acc_16_21,q_tmp_16_21);
                   q_acc_16_22 = _mm256_add_pd(q_acc_16_22,q_tmp_16_22);
                   q_acc_16_23 = _mm256_add_pd(q_acc_16_23,q_tmp_16_23);
                   q_acc_16_24 = _mm256_add_pd(q_acc_16_24,q_tmp_16_24);
                   q_acc_16_25 = _mm256_add_pd(q_acc_16_25,q_tmp_16_25);
                   q_acc_16_26 = _mm256_add_pd(q_acc_16_26,q_tmp_16_26);
                   q_acc_16_27 = _mm256_add_pd(q_acc_16_27,q_tmp_16_27);
                   q_acc_16_28 = _mm256_add_pd(q_acc_16_28,q_tmp_16_28);
                   q_acc_16_29 = _mm256_add_pd(q_acc_16_29,q_tmp_16_29);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_17_18 = _mm256_add_pd(q_acc_17_18,q_tmp_17_18);
                   q_acc_17_19 = _mm256_add_pd(q_acc_17_19,q_tmp_17_19);
                   q_acc_17_20 = _mm256_add_pd(q_acc_17_20,q_tmp_17_20);
                   q_acc_17_21 = _mm256_add_pd(q_acc_17_21,q_tmp_17_21);
                   q_acc_17_22 = _mm256_add_pd(q_acc_17_22,q_tmp_17_22);
                   q_acc_17_23 = _mm256_add_pd(q_acc_17_23,q_tmp_17_23);
                   q_acc_17_24 = _mm256_add_pd(q_acc_17_24,q_tmp_17_24);
                   q_acc_17_25 = _mm256_add_pd(q_acc_17_25,q_tmp_17_25);
                   q_acc_17_26 = _mm256_add_pd(q_acc_17_26,q_tmp_17_26);
                   q_acc_17_27 = _mm256_add_pd(q_acc_17_27,q_tmp_17_27);
                   q_acc_17_28 = _mm256_add_pd(q_acc_17_28,q_tmp_17_28);
                   q_acc_17_29 = _mm256_add_pd(q_acc_17_29,q_tmp_17_29);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_18_19 = _mm256_add_pd(q_acc_18_19,q_tmp_18_19);
                   q_acc_18_20 = _mm256_add_pd(q_acc_18_20,q_tmp_18_20);
                   q_acc_18_21 = _mm256_add_pd(q_acc_18_21,q_tmp_18_21);
                   q_acc_18_22 = _mm256_add_pd(q_acc_18_22,q_tmp_18_22);
                   q_acc_18_23 = _mm256_add_pd(q_acc_18_23,q_tmp_18_23);
                   q_acc_18_24 = _mm256_add_pd(q_acc_18_24,q_tmp_18_24);
                   q_acc_18_25 = _mm256_add_pd(q_acc_18_25,q_tmp_18_25);
                   q_acc_18_26 = _mm256_add_pd(q_acc_18_26,q_tmp_18_26);
                   q_acc_18_27 = _mm256_add_pd(q_acc_18_27,q_tmp_18_27);
                   q_acc_18_28 = _mm256_add_pd(q_acc_18_28,q_tmp_18_28);
                   q_acc_18_29 = _mm256_add_pd(q_acc_18_29,q_tmp_18_29);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_19_20 = _mm256_add_pd(q_acc_19_20,q_tmp_19_20);
                   q_acc_19_21 = _mm256_add_pd(q_acc_19_21,q_tmp_19_21);
                   q_acc_19_22 = _mm256_add_pd(q_acc_19_22,q_tmp_19_22);
                   q_acc_19_23 = _mm256_add_pd(q_acc_19_23,q_tmp_19_23);
                   q_acc_19_24 = _mm256_add_pd(q_acc_19_24,q_tmp_19_24);
                   q_acc_19_25 = _mm256_add_pd(q_acc_19_25,q_tmp_19_25);
                   q_acc_19_26 = _mm256_add_pd(q_acc_19_26,q_tmp_19_26);
                   q_acc_19_27 = _mm256_add_pd(q_acc_19_27,q_tmp_19_27);
                   q_acc_19_28 = _mm256_add_pd(q_acc_19_28,q_tmp_19_28);
                   q_acc_19_29 = _mm256_add_pd(q_acc_19_29,q_tmp_19_29);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_20_21 = _mm256_add_pd(q_acc_20_21,q_tmp_20_21);
                   q_acc_20_22 = _mm256_add_pd(q_acc_20_22,q_tmp_20_22);
                   q_acc_20_23 = _mm256_add_pd(q_acc_20_23,q_tmp_20_23);
                   q_acc_20_24 = _mm256_add_pd(q_acc_20_24,q_tmp_20_24);
                   q_acc_20_25 = _mm256_add_pd(q_acc_20_25,q_tmp_20_25);
                   q_acc_20_26 = _mm256_add_pd(q_acc_20_26,q_tmp_20_26);
                   q_acc_20_27 = _mm256_add_pd(q_acc_20_27,q_tmp_20_27);
                   q_acc_20_28 = _mm256_add_pd(q_acc_20_28,q_tmp_20_28);
                   q_acc_20_29 = _mm256_add_pd(q_acc_20_29,q_tmp_20_29);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_21_22 = _mm256_add_pd(q_acc_21_22,q_tmp_21_22);
                   q_acc_21_23 = _mm256_add_pd(q_acc_21_23,q_tmp_21_23);
                   q_acc_21_24 = _mm256_add_pd(q_acc_21_24,q_tmp_21_24);
                   q_acc_21_25 = _mm256_add_pd(q_acc_21_25,q_tmp_21_25);
                   q_acc_21_26 = _mm256_add_pd(q_acc_21_26,q_tmp_21_26);
                   q_acc_21_27 = _mm256_add_pd(q_acc_21_27,q_tmp_21_27);
                   q_acc_21_28 = _mm256_add_pd(q_acc_21_28,q_tmp_21_28);
                   q_acc_21_29 = _mm256_add_pd(q_acc_21_29,q_tmp_21_29);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_22_23 = _mm256_add_pd(q_acc_22_23,q_tmp_22_23);
                   q_acc_22_24 = _mm256_add_pd(q_acc_22_24,q_tmp_22_24);
                   q_acc_22_25 = _mm256_add_pd(q_acc_22_25,q_tmp_22_25);
                   q_acc_22_26 = _mm256_add_pd(q_acc_22_26,q_tmp_22_26);
                   q_acc_22_27 = _mm256_add_pd(q_acc_22_27,q_tmp_22_27);
                   q_acc_22_28 = _mm256_add_pd(q_acc_22_28,q_tmp_22_28);
                   q_acc_22_29 = _mm256_add_pd(q_acc_22_29,q_tmp_22_29);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_23_24 = _mm256_add_pd(q_acc_23_24,q_tmp_23_24);
                   q_acc_23_25 = _mm256_add_pd(q_acc_23_25,q_tmp_23_25);
                   q_acc_23_26 = _mm256_add_pd(q_acc_23_26,q_tmp_23_26);
                   q_acc_23_27 = _mm256_add_pd(q_acc_23_27,q_tmp_23_27);
                   q_acc_23_28 = _mm256_add_pd(q_acc_23_28,q_tmp_23_28);
                   q_acc_23_29 = _mm256_add_pd(q_acc_23_29,q_tmp_23_29);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_24_25 = _mm256_add_pd(q_acc_24_25,q_tmp_24_25);
                   q_acc_24_26 = _mm256_add_pd(q_acc_24_26,q_tmp_24_26);
                   q_acc_24_27 = _mm256_add_pd(q_acc_24_27,q_tmp_24_27);
                   q_acc_24_28 = _mm256_add_pd(q_acc_24_28,q_tmp_24_28);
                   q_acc_24_29 = _mm256_add_pd(q_acc_24_29,q_tmp_24_29);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_25_26 = _mm256_add_pd(q_acc_25_26,q_tmp_25_26);
                   q_acc_25_27 = _mm256_add_pd(q_acc_25_27,q_tmp_25_27);
                   q_acc_25_28 = _mm256_add_pd(q_acc_25_28,q_tmp_25_28);
                   q_acc_25_29 = _mm256_add_pd(q_acc_25_29,q_tmp_25_29);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_26_27 = _mm256_add_pd(q_acc_26_27,q_tmp_26_27);
                   q_acc_26_28 = _mm256_add_pd(q_acc_26_28,q_tmp_26_28);
                   q_acc_26_29 = _mm256_add_pd(q_acc_26_29,q_tmp_26_29);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_27_28 = _mm256_add_pd(q_acc_27_28,q_tmp_27_28);
                   q_acc_27_29 = _mm256_add_pd(q_acc_27_29,q_tmp_27_29);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_28_29 = _mm256_add_pd(q_acc_28_29,q_tmp_28_29);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_12,src_dof_12)),_mm256_mul_pd(q_acc_0_13,src_dof_13)),_mm256_mul_pd(q_acc_0_14,src_dof_14)),_mm256_mul_pd(q_acc_0_15,src_dof_15)),_mm256_mul_pd(q_acc_0_16,src_dof_16)),_mm256_mul_pd(q_acc_0_17,src_dof_17)),_mm256_mul_pd(q_acc_0_18,src_dof_18)),_mm256_mul_pd(q_acc_0_19,src_dof_19)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_20,src_dof_20)),_mm256_mul_pd(q_acc_0_21,src_dof_21)),_mm256_mul_pd(q_acc_0_22,src_dof_22)),_mm256_mul_pd(q_acc_0_23,src_dof_23)),_mm256_mul_pd(q_acc_0_24,src_dof_24)),_mm256_mul_pd(q_acc_0_25,src_dof_25)),_mm256_mul_pd(q_acc_0_26,src_dof_26)),_mm256_mul_pd(q_acc_0_27,src_dof_27)),_mm256_mul_pd(q_acc_0_28,src_dof_28)),_mm256_mul_pd(q_acc_0_29,src_dof_29)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_12,src_dof_12)),_mm256_mul_pd(q_acc_1_13,src_dof_13)),_mm256_mul_pd(q_acc_1_14,src_dof_14)),_mm256_mul_pd(q_acc_1_15,src_dof_15)),_mm256_mul_pd(q_acc_1_16,src_dof_16)),_mm256_mul_pd(q_acc_1_17,src_dof_17)),_mm256_mul_pd(q_acc_1_18,src_dof_18)),_mm256_mul_pd(q_acc_1_19,src_dof_19)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_20,src_dof_20)),_mm256_mul_pd(q_acc_1_21,src_dof_21)),_mm256_mul_pd(q_acc_1_22,src_dof_22)),_mm256_mul_pd(q_acc_1_23,src_dof_23)),_mm256_mul_pd(q_acc_1_24,src_dof_24)),_mm256_mul_pd(q_acc_1_25,src_dof_25)),_mm256_mul_pd(q_acc_1_26,src_dof_26)),_mm256_mul_pd(q_acc_1_27,src_dof_27)),_mm256_mul_pd(q_acc_1_28,src_dof_28)),_mm256_mul_pd(q_acc_1_29,src_dof_29)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_12,src_dof_12)),_mm256_mul_pd(q_acc_2_13,src_dof_13)),_mm256_mul_pd(q_acc_2_14,src_dof_14)),_mm256_mul_pd(q_acc_2_15,src_dof_15)),_mm256_mul_pd(q_acc_2_16,src_dof_16)),_mm256_mul_pd(q_acc_2_17,src_dof_17)),_mm256_mul_pd(q_acc_2_18,src_dof_18)),_mm256_mul_pd(q_acc_2_19,src_dof_19)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_20,src_dof_20)),_mm256_mul_pd(q_acc_2_21,src_dof_21)),_mm256_mul_pd(q_acc_2_22,src_dof_22)),_mm256_mul_pd(q_acc_2_23,src_dof_23)),_mm256_mul_pd(q_acc_2_24,src_dof_24)),_mm256_mul_pd(q_acc_2_25,src_dof_25)),_mm256_mul_pd(q_acc_2_26,src_dof_26)),_mm256_mul_pd(q_acc_2_27,src_dof_27)),_mm256_mul_pd(q_acc_2_28,src_dof_28)),_mm256_mul_pd(q_acc_2_29,src_dof_29)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_12,src_dof_12)),_mm256_mul_pd(q_acc_3_13,src_dof_13)),_mm256_mul_pd(q_acc_3_14,src_dof_14)),_mm256_mul_pd(q_acc_3_15,src_dof_15)),_mm256_mul_pd(q_acc_3_16,src_dof_16)),_mm256_mul_pd(q_acc_3_17,src_dof_17)),_mm256_mul_pd(q_acc_3_18,src_dof_18)),_mm256_mul_pd(q_acc_3_19,src_dof_19)),_mm256_mul_pd(q_acc_3_20,src_dof_20)),_mm256_mul_pd(q_acc_3_21,src_dof_21)),_mm256_mul_pd(q_acc_3_22,src_dof_22)),_mm256_mul_pd(q_acc_3_23,src_dof_23)),_mm256_mul_pd(q_acc_3_24,src_dof_24)),_mm256_mul_pd(q_acc_3_25,src_dof_25)),_mm256_mul_pd(q_acc_3_26,src_dof_26)),_mm256_mul_pd(q_acc_3_27,src_dof_27)),_mm256_mul_pd(q_acc_3_28,src_dof_28)),_mm256_mul_pd(q_acc_3_29,src_dof_29)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_12,src_dof_12)),_mm256_mul_pd(q_acc_4_13,src_dof_13)),_mm256_mul_pd(q_acc_4_14,src_dof_14)),_mm256_mul_pd(q_acc_4_15,src_dof_15)),_mm256_mul_pd(q_acc_4_16,src_dof_16)),_mm256_mul_pd(q_acc_4_17,src_dof_17)),_mm256_mul_pd(q_acc_4_18,src_dof_18)),_mm256_mul_pd(q_acc_4_19,src_dof_19)),_mm256_mul_pd(q_acc_4_20,src_dof_20)),_mm256_mul_pd(q_acc_4_21,src_dof_21)),_mm256_mul_pd(q_acc_4_22,src_dof_22)),_mm256_mul_pd(q_acc_4_23,src_dof_23)),_mm256_mul_pd(q_acc_4_24,src_dof_24)),_mm256_mul_pd(q_acc_4_25,src_dof_25)),_mm256_mul_pd(q_acc_4_26,src_dof_26)),_mm256_mul_pd(q_acc_4_27,src_dof_27)),_mm256_mul_pd(q_acc_4_28,src_dof_28)),_mm256_mul_pd(q_acc_4_29,src_dof_29)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_12,src_dof_12)),_mm256_mul_pd(q_acc_5_13,src_dof_13)),_mm256_mul_pd(q_acc_5_14,src_dof_14)),_mm256_mul_pd(q_acc_5_15,src_dof_15)),_mm256_mul_pd(q_acc_5_16,src_dof_16)),_mm256_mul_pd(q_acc_5_17,src_dof_17)),_mm256_mul_pd(q_acc_5_18,src_dof_18)),_mm256_mul_pd(q_acc_5_19,src_dof_19)),_mm256_mul_pd(q_acc_5_20,src_dof_20)),_mm256_mul_pd(q_acc_5_21,src_dof_21)),_mm256_mul_pd(q_acc_5_22,src_dof_22)),_mm256_mul_pd(q_acc_5_23,src_dof_23)),_mm256_mul_pd(q_acc_5_24,src_dof_24)),_mm256_mul_pd(q_acc_5_25,src_dof_25)),_mm256_mul_pd(q_acc_5_26,src_dof_26)),_mm256_mul_pd(q_acc_5_27,src_dof_27)),_mm256_mul_pd(q_acc_5_28,src_dof_28)),_mm256_mul_pd(q_acc_5_29,src_dof_29)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_12,src_dof_12)),_mm256_mul_pd(q_acc_6_13,src_dof_13)),_mm256_mul_pd(q_acc_6_14,src_dof_14)),_mm256_mul_pd(q_acc_6_15,src_dof_15)),_mm256_mul_pd(q_acc_6_16,src_dof_16)),_mm256_mul_pd(q_acc_6_17,src_dof_17)),_mm256_mul_pd(q_acc_6_18,src_dof_18)),_mm256_mul_pd(q_acc_6_19,src_dof_19)),_mm256_mul_pd(q_acc_6_20,src_dof_20)),_mm256_mul_pd(q_acc_6_21,src_dof_21)),_mm256_mul_pd(q_acc_6_22,src_dof_22)),_mm256_mul_pd(q_acc_6_23,src_dof_23)),_mm256_mul_pd(q_acc_6_24,src_dof_24)),_mm256_mul_pd(q_acc_6_25,src_dof_25)),_mm256_mul_pd(q_acc_6_26,src_dof_26)),_mm256_mul_pd(q_acc_6_27,src_dof_27)),_mm256_mul_pd(q_acc_6_28,src_dof_28)),_mm256_mul_pd(q_acc_6_29,src_dof_29)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_12,src_dof_12)),_mm256_mul_pd(q_acc_7_13,src_dof_13)),_mm256_mul_pd(q_acc_7_14,src_dof_14)),_mm256_mul_pd(q_acc_7_15,src_dof_15)),_mm256_mul_pd(q_acc_7_16,src_dof_16)),_mm256_mul_pd(q_acc_7_17,src_dof_17)),_mm256_mul_pd(q_acc_7_18,src_dof_18)),_mm256_mul_pd(q_acc_7_19,src_dof_19)),_mm256_mul_pd(q_acc_7_20,src_dof_20)),_mm256_mul_pd(q_acc_7_21,src_dof_21)),_mm256_mul_pd(q_acc_7_22,src_dof_22)),_mm256_mul_pd(q_acc_7_23,src_dof_23)),_mm256_mul_pd(q_acc_7_24,src_dof_24)),_mm256_mul_pd(q_acc_7_25,src_dof_25)),_mm256_mul_pd(q_acc_7_26,src_dof_26)),_mm256_mul_pd(q_acc_7_27,src_dof_27)),_mm256_mul_pd(q_acc_7_28,src_dof_28)),_mm256_mul_pd(q_acc_7_29,src_dof_29)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_12,src_dof_12)),_mm256_mul_pd(q_acc_8_13,src_dof_13)),_mm256_mul_pd(q_acc_8_14,src_dof_14)),_mm256_mul_pd(q_acc_8_15,src_dof_15)),_mm256_mul_pd(q_acc_8_16,src_dof_16)),_mm256_mul_pd(q_acc_8_17,src_dof_17)),_mm256_mul_pd(q_acc_8_18,src_dof_18)),_mm256_mul_pd(q_acc_8_19,src_dof_19)),_mm256_mul_pd(q_acc_8_20,src_dof_20)),_mm256_mul_pd(q_acc_8_21,src_dof_21)),_mm256_mul_pd(q_acc_8_22,src_dof_22)),_mm256_mul_pd(q_acc_8_23,src_dof_23)),_mm256_mul_pd(q_acc_8_24,src_dof_24)),_mm256_mul_pd(q_acc_8_25,src_dof_25)),_mm256_mul_pd(q_acc_8_26,src_dof_26)),_mm256_mul_pd(q_acc_8_27,src_dof_27)),_mm256_mul_pd(q_acc_8_28,src_dof_28)),_mm256_mul_pd(q_acc_8_29,src_dof_29)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_12,src_dof_12)),_mm256_mul_pd(q_acc_9_13,src_dof_13)),_mm256_mul_pd(q_acc_9_14,src_dof_14)),_mm256_mul_pd(q_acc_9_15,src_dof_15)),_mm256_mul_pd(q_acc_9_16,src_dof_16)),_mm256_mul_pd(q_acc_9_17,src_dof_17)),_mm256_mul_pd(q_acc_9_18,src_dof_18)),_mm256_mul_pd(q_acc_9_19,src_dof_19)),_mm256_mul_pd(q_acc_9_20,src_dof_20)),_mm256_mul_pd(q_acc_9_21,src_dof_21)),_mm256_mul_pd(q_acc_9_22,src_dof_22)),_mm256_mul_pd(q_acc_9_23,src_dof_23)),_mm256_mul_pd(q_acc_9_24,src_dof_24)),_mm256_mul_pd(q_acc_9_25,src_dof_25)),_mm256_mul_pd(q_acc_9_26,src_dof_26)),_mm256_mul_pd(q_acc_9_27,src_dof_27)),_mm256_mul_pd(q_acc_9_28,src_dof_28)),_mm256_mul_pd(q_acc_9_29,src_dof_29)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_10_12,src_dof_12)),_mm256_mul_pd(q_acc_10_13,src_dof_13)),_mm256_mul_pd(q_acc_10_14,src_dof_14)),_mm256_mul_pd(q_acc_10_15,src_dof_15)),_mm256_mul_pd(q_acc_10_16,src_dof_16)),_mm256_mul_pd(q_acc_10_17,src_dof_17)),_mm256_mul_pd(q_acc_10_18,src_dof_18)),_mm256_mul_pd(q_acc_10_19,src_dof_19)),_mm256_mul_pd(q_acc_10_20,src_dof_20)),_mm256_mul_pd(q_acc_10_21,src_dof_21)),_mm256_mul_pd(q_acc_10_22,src_dof_22)),_mm256_mul_pd(q_acc_10_23,src_dof_23)),_mm256_mul_pd(q_acc_10_24,src_dof_24)),_mm256_mul_pd(q_acc_10_25,src_dof_25)),_mm256_mul_pd(q_acc_10_26,src_dof_26)),_mm256_mul_pd(q_acc_10_27,src_dof_27)),_mm256_mul_pd(q_acc_10_28,src_dof_28)),_mm256_mul_pd(q_acc_10_29,src_dof_29)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_11_12,src_dof_12)),_mm256_mul_pd(q_acc_11_13,src_dof_13)),_mm256_mul_pd(q_acc_11_14,src_dof_14)),_mm256_mul_pd(q_acc_11_15,src_dof_15)),_mm256_mul_pd(q_acc_11_16,src_dof_16)),_mm256_mul_pd(q_acc_11_17,src_dof_17)),_mm256_mul_pd(q_acc_11_18,src_dof_18)),_mm256_mul_pd(q_acc_11_19,src_dof_19)),_mm256_mul_pd(q_acc_11_20,src_dof_20)),_mm256_mul_pd(q_acc_11_21,src_dof_21)),_mm256_mul_pd(q_acc_11_22,src_dof_22)),_mm256_mul_pd(q_acc_11_23,src_dof_23)),_mm256_mul_pd(q_acc_11_24,src_dof_24)),_mm256_mul_pd(q_acc_11_25,src_dof_25)),_mm256_mul_pd(q_acc_11_26,src_dof_26)),_mm256_mul_pd(q_acc_11_27,src_dof_27)),_mm256_mul_pd(q_acc_11_28,src_dof_28)),_mm256_mul_pd(q_acc_11_29,src_dof_29)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                const __m256d elMatVec_12 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_12,src_dof_0),_mm256_mul_pd(q_acc_10_12,src_dof_10)),_mm256_mul_pd(q_acc_11_12,src_dof_11)),_mm256_mul_pd(q_acc_12_12,src_dof_12)),_mm256_mul_pd(q_acc_12_13,src_dof_13)),_mm256_mul_pd(q_acc_12_14,src_dof_14)),_mm256_mul_pd(q_acc_12_15,src_dof_15)),_mm256_mul_pd(q_acc_12_16,src_dof_16)),_mm256_mul_pd(q_acc_12_17,src_dof_17)),_mm256_mul_pd(q_acc_12_18,src_dof_18)),_mm256_mul_pd(q_acc_12_19,src_dof_19)),_mm256_mul_pd(q_acc_12_20,src_dof_20)),_mm256_mul_pd(q_acc_12_21,src_dof_21)),_mm256_mul_pd(q_acc_12_22,src_dof_22)),_mm256_mul_pd(q_acc_12_23,src_dof_23)),_mm256_mul_pd(q_acc_12_24,src_dof_24)),_mm256_mul_pd(q_acc_12_25,src_dof_25)),_mm256_mul_pd(q_acc_12_26,src_dof_26)),_mm256_mul_pd(q_acc_12_27,src_dof_27)),_mm256_mul_pd(q_acc_12_28,src_dof_28)),_mm256_mul_pd(q_acc_12_29,src_dof_29)),_mm256_mul_pd(q_acc_1_12,src_dof_1)),_mm256_mul_pd(q_acc_2_12,src_dof_2)),_mm256_mul_pd(q_acc_3_12,src_dof_3)),_mm256_mul_pd(q_acc_4_12,src_dof_4)),_mm256_mul_pd(q_acc_5_12,src_dof_5)),_mm256_mul_pd(q_acc_6_12,src_dof_6)),_mm256_mul_pd(q_acc_7_12,src_dof_7)),_mm256_mul_pd(q_acc_8_12,src_dof_8)),_mm256_mul_pd(q_acc_9_12,src_dof_9));
                const __m256d elMatVec_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_13,src_dof_0),_mm256_mul_pd(q_acc_10_13,src_dof_10)),_mm256_mul_pd(q_acc_11_13,src_dof_11)),_mm256_mul_pd(q_acc_12_13,src_dof_12)),_mm256_mul_pd(q_acc_13_13,src_dof_13)),_mm256_mul_pd(q_acc_13_14,src_dof_14)),_mm256_mul_pd(q_acc_13_15,src_dof_15)),_mm256_mul_pd(q_acc_13_16,src_dof_16)),_mm256_mul_pd(q_acc_13_17,src_dof_17)),_mm256_mul_pd(q_acc_13_18,src_dof_18)),_mm256_mul_pd(q_acc_13_19,src_dof_19)),_mm256_mul_pd(q_acc_13_20,src_dof_20)),_mm256_mul_pd(q_acc_13_21,src_dof_21)),_mm256_mul_pd(q_acc_13_22,src_dof_22)),_mm256_mul_pd(q_acc_13_23,src_dof_23)),_mm256_mul_pd(q_acc_13_24,src_dof_24)),_mm256_mul_pd(q_acc_13_25,src_dof_25)),_mm256_mul_pd(q_acc_13_26,src_dof_26)),_mm256_mul_pd(q_acc_13_27,src_dof_27)),_mm256_mul_pd(q_acc_13_28,src_dof_28)),_mm256_mul_pd(q_acc_13_29,src_dof_29)),_mm256_mul_pd(q_acc_1_13,src_dof_1)),_mm256_mul_pd(q_acc_2_13,src_dof_2)),_mm256_mul_pd(q_acc_3_13,src_dof_3)),_mm256_mul_pd(q_acc_4_13,src_dof_4)),_mm256_mul_pd(q_acc_5_13,src_dof_5)),_mm256_mul_pd(q_acc_6_13,src_dof_6)),_mm256_mul_pd(q_acc_7_13,src_dof_7)),_mm256_mul_pd(q_acc_8_13,src_dof_8)),_mm256_mul_pd(q_acc_9_13,src_dof_9));
                const __m256d elMatVec_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_14,src_dof_0),_mm256_mul_pd(q_acc_10_14,src_dof_10)),_mm256_mul_pd(q_acc_11_14,src_dof_11)),_mm256_mul_pd(q_acc_12_14,src_dof_12)),_mm256_mul_pd(q_acc_13_14,src_dof_13)),_mm256_mul_pd(q_acc_14_14,src_dof_14)),_mm256_mul_pd(q_acc_14_15,src_dof_15)),_mm256_mul_pd(q_acc_14_16,src_dof_16)),_mm256_mul_pd(q_acc_14_17,src_dof_17)),_mm256_mul_pd(q_acc_14_18,src_dof_18)),_mm256_mul_pd(q_acc_14_19,src_dof_19)),_mm256_mul_pd(q_acc_14_20,src_dof_20)),_mm256_mul_pd(q_acc_14_21,src_dof_21)),_mm256_mul_pd(q_acc_14_22,src_dof_22)),_mm256_mul_pd(q_acc_14_23,src_dof_23)),_mm256_mul_pd(q_acc_14_24,src_dof_24)),_mm256_mul_pd(q_acc_14_25,src_dof_25)),_mm256_mul_pd(q_acc_14_26,src_dof_26)),_mm256_mul_pd(q_acc_14_27,src_dof_27)),_mm256_mul_pd(q_acc_14_28,src_dof_28)),_mm256_mul_pd(q_acc_14_29,src_dof_29)),_mm256_mul_pd(q_acc_1_14,src_dof_1)),_mm256_mul_pd(q_acc_2_14,src_dof_2)),_mm256_mul_pd(q_acc_3_14,src_dof_3)),_mm256_mul_pd(q_acc_4_14,src_dof_4)),_mm256_mul_pd(q_acc_5_14,src_dof_5)),_mm256_mul_pd(q_acc_6_14,src_dof_6)),_mm256_mul_pd(q_acc_7_14,src_dof_7)),_mm256_mul_pd(q_acc_8_14,src_dof_8)),_mm256_mul_pd(q_acc_9_14,src_dof_9));
                const __m256d elMatVec_15 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_15,src_dof_0),_mm256_mul_pd(q_acc_10_15,src_dof_10)),_mm256_mul_pd(q_acc_11_15,src_dof_11)),_mm256_mul_pd(q_acc_12_15,src_dof_12)),_mm256_mul_pd(q_acc_13_15,src_dof_13)),_mm256_mul_pd(q_acc_14_15,src_dof_14)),_mm256_mul_pd(q_acc_15_15,src_dof_15)),_mm256_mul_pd(q_acc_15_16,src_dof_16)),_mm256_mul_pd(q_acc_15_17,src_dof_17)),_mm256_mul_pd(q_acc_15_18,src_dof_18)),_mm256_mul_pd(q_acc_15_19,src_dof_19)),_mm256_mul_pd(q_acc_15_20,src_dof_20)),_mm256_mul_pd(q_acc_15_21,src_dof_21)),_mm256_mul_pd(q_acc_15_22,src_dof_22)),_mm256_mul_pd(q_acc_15_23,src_dof_23)),_mm256_mul_pd(q_acc_15_24,src_dof_24)),_mm256_mul_pd(q_acc_15_25,src_dof_25)),_mm256_mul_pd(q_acc_15_26,src_dof_26)),_mm256_mul_pd(q_acc_15_27,src_dof_27)),_mm256_mul_pd(q_acc_15_28,src_dof_28)),_mm256_mul_pd(q_acc_15_29,src_dof_29)),_mm256_mul_pd(q_acc_1_15,src_dof_1)),_mm256_mul_pd(q_acc_2_15,src_dof_2)),_mm256_mul_pd(q_acc_3_15,src_dof_3)),_mm256_mul_pd(q_acc_4_15,src_dof_4)),_mm256_mul_pd(q_acc_5_15,src_dof_5)),_mm256_mul_pd(q_acc_6_15,src_dof_6)),_mm256_mul_pd(q_acc_7_15,src_dof_7)),_mm256_mul_pd(q_acc_8_15,src_dof_8)),_mm256_mul_pd(q_acc_9_15,src_dof_9));
                const __m256d elMatVec_16 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_16,src_dof_0),_mm256_mul_pd(q_acc_10_16,src_dof_10)),_mm256_mul_pd(q_acc_11_16,src_dof_11)),_mm256_mul_pd(q_acc_12_16,src_dof_12)),_mm256_mul_pd(q_acc_13_16,src_dof_13)),_mm256_mul_pd(q_acc_14_16,src_dof_14)),_mm256_mul_pd(q_acc_15_16,src_dof_15)),_mm256_mul_pd(q_acc_16_16,src_dof_16)),_mm256_mul_pd(q_acc_16_17,src_dof_17)),_mm256_mul_pd(q_acc_16_18,src_dof_18)),_mm256_mul_pd(q_acc_16_19,src_dof_19)),_mm256_mul_pd(q_acc_16_20,src_dof_20)),_mm256_mul_pd(q_acc_16_21,src_dof_21)),_mm256_mul_pd(q_acc_16_22,src_dof_22)),_mm256_mul_pd(q_acc_16_23,src_dof_23)),_mm256_mul_pd(q_acc_16_24,src_dof_24)),_mm256_mul_pd(q_acc_16_25,src_dof_25)),_mm256_mul_pd(q_acc_16_26,src_dof_26)),_mm256_mul_pd(q_acc_16_27,src_dof_27)),_mm256_mul_pd(q_acc_16_28,src_dof_28)),_mm256_mul_pd(q_acc_16_29,src_dof_29)),_mm256_mul_pd(q_acc_1_16,src_dof_1)),_mm256_mul_pd(q_acc_2_16,src_dof_2)),_mm256_mul_pd(q_acc_3_16,src_dof_3)),_mm256_mul_pd(q_acc_4_16,src_dof_4)),_mm256_mul_pd(q_acc_5_16,src_dof_5)),_mm256_mul_pd(q_acc_6_16,src_dof_6)),_mm256_mul_pd(q_acc_7_16,src_dof_7)),_mm256_mul_pd(q_acc_8_16,src_dof_8)),_mm256_mul_pd(q_acc_9_16,src_dof_9));
                const __m256d elMatVec_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_17,src_dof_0),_mm256_mul_pd(q_acc_10_17,src_dof_10)),_mm256_mul_pd(q_acc_11_17,src_dof_11)),_mm256_mul_pd(q_acc_12_17,src_dof_12)),_mm256_mul_pd(q_acc_13_17,src_dof_13)),_mm256_mul_pd(q_acc_14_17,src_dof_14)),_mm256_mul_pd(q_acc_15_17,src_dof_15)),_mm256_mul_pd(q_acc_16_17,src_dof_16)),_mm256_mul_pd(q_acc_17_17,src_dof_17)),_mm256_mul_pd(q_acc_17_18,src_dof_18)),_mm256_mul_pd(q_acc_17_19,src_dof_19)),_mm256_mul_pd(q_acc_17_20,src_dof_20)),_mm256_mul_pd(q_acc_17_21,src_dof_21)),_mm256_mul_pd(q_acc_17_22,src_dof_22)),_mm256_mul_pd(q_acc_17_23,src_dof_23)),_mm256_mul_pd(q_acc_17_24,src_dof_24)),_mm256_mul_pd(q_acc_17_25,src_dof_25)),_mm256_mul_pd(q_acc_17_26,src_dof_26)),_mm256_mul_pd(q_acc_17_27,src_dof_27)),_mm256_mul_pd(q_acc_17_28,src_dof_28)),_mm256_mul_pd(q_acc_17_29,src_dof_29)),_mm256_mul_pd(q_acc_1_17,src_dof_1)),_mm256_mul_pd(q_acc_2_17,src_dof_2)),_mm256_mul_pd(q_acc_3_17,src_dof_3)),_mm256_mul_pd(q_acc_4_17,src_dof_4)),_mm256_mul_pd(q_acc_5_17,src_dof_5)),_mm256_mul_pd(q_acc_6_17,src_dof_6)),_mm256_mul_pd(q_acc_7_17,src_dof_7)),_mm256_mul_pd(q_acc_8_17,src_dof_8)),_mm256_mul_pd(q_acc_9_17,src_dof_9));
                const __m256d elMatVec_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_18,src_dof_0),_mm256_mul_pd(q_acc_10_18,src_dof_10)),_mm256_mul_pd(q_acc_11_18,src_dof_11)),_mm256_mul_pd(q_acc_12_18,src_dof_12)),_mm256_mul_pd(q_acc_13_18,src_dof_13)),_mm256_mul_pd(q_acc_14_18,src_dof_14)),_mm256_mul_pd(q_acc_15_18,src_dof_15)),_mm256_mul_pd(q_acc_16_18,src_dof_16)),_mm256_mul_pd(q_acc_17_18,src_dof_17)),_mm256_mul_pd(q_acc_18_18,src_dof_18)),_mm256_mul_pd(q_acc_18_19,src_dof_19)),_mm256_mul_pd(q_acc_18_20,src_dof_20)),_mm256_mul_pd(q_acc_18_21,src_dof_21)),_mm256_mul_pd(q_acc_18_22,src_dof_22)),_mm256_mul_pd(q_acc_18_23,src_dof_23)),_mm256_mul_pd(q_acc_18_24,src_dof_24)),_mm256_mul_pd(q_acc_18_25,src_dof_25)),_mm256_mul_pd(q_acc_18_26,src_dof_26)),_mm256_mul_pd(q_acc_18_27,src_dof_27)),_mm256_mul_pd(q_acc_18_28,src_dof_28)),_mm256_mul_pd(q_acc_18_29,src_dof_29)),_mm256_mul_pd(q_acc_1_18,src_dof_1)),_mm256_mul_pd(q_acc_2_18,src_dof_2)),_mm256_mul_pd(q_acc_3_18,src_dof_3)),_mm256_mul_pd(q_acc_4_18,src_dof_4)),_mm256_mul_pd(q_acc_5_18,src_dof_5)),_mm256_mul_pd(q_acc_6_18,src_dof_6)),_mm256_mul_pd(q_acc_7_18,src_dof_7)),_mm256_mul_pd(q_acc_8_18,src_dof_8)),_mm256_mul_pd(q_acc_9_18,src_dof_9));
                const __m256d elMatVec_19 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_19,src_dof_0),_mm256_mul_pd(q_acc_10_19,src_dof_10)),_mm256_mul_pd(q_acc_11_19,src_dof_11)),_mm256_mul_pd(q_acc_12_19,src_dof_12)),_mm256_mul_pd(q_acc_13_19,src_dof_13)),_mm256_mul_pd(q_acc_14_19,src_dof_14)),_mm256_mul_pd(q_acc_15_19,src_dof_15)),_mm256_mul_pd(q_acc_16_19,src_dof_16)),_mm256_mul_pd(q_acc_17_19,src_dof_17)),_mm256_mul_pd(q_acc_18_19,src_dof_18)),_mm256_mul_pd(q_acc_19_19,src_dof_19)),_mm256_mul_pd(q_acc_19_20,src_dof_20)),_mm256_mul_pd(q_acc_19_21,src_dof_21)),_mm256_mul_pd(q_acc_19_22,src_dof_22)),_mm256_mul_pd(q_acc_19_23,src_dof_23)),_mm256_mul_pd(q_acc_19_24,src_dof_24)),_mm256_mul_pd(q_acc_19_25,src_dof_25)),_mm256_mul_pd(q_acc_19_26,src_dof_26)),_mm256_mul_pd(q_acc_19_27,src_dof_27)),_mm256_mul_pd(q_acc_19_28,src_dof_28)),_mm256_mul_pd(q_acc_19_29,src_dof_29)),_mm256_mul_pd(q_acc_1_19,src_dof_1)),_mm256_mul_pd(q_acc_2_19,src_dof_2)),_mm256_mul_pd(q_acc_3_19,src_dof_3)),_mm256_mul_pd(q_acc_4_19,src_dof_4)),_mm256_mul_pd(q_acc_5_19,src_dof_5)),_mm256_mul_pd(q_acc_6_19,src_dof_6)),_mm256_mul_pd(q_acc_7_19,src_dof_7)),_mm256_mul_pd(q_acc_8_19,src_dof_8)),_mm256_mul_pd(q_acc_9_19,src_dof_9));
                const __m256d elMatVec_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_20,src_dof_0),_mm256_mul_pd(q_acc_10_20,src_dof_10)),_mm256_mul_pd(q_acc_11_20,src_dof_11)),_mm256_mul_pd(q_acc_12_20,src_dof_12)),_mm256_mul_pd(q_acc_13_20,src_dof_13)),_mm256_mul_pd(q_acc_14_20,src_dof_14)),_mm256_mul_pd(q_acc_15_20,src_dof_15)),_mm256_mul_pd(q_acc_16_20,src_dof_16)),_mm256_mul_pd(q_acc_17_20,src_dof_17)),_mm256_mul_pd(q_acc_18_20,src_dof_18)),_mm256_mul_pd(q_acc_19_20,src_dof_19)),_mm256_mul_pd(q_acc_1_20,src_dof_1)),_mm256_mul_pd(q_acc_20_20,src_dof_20)),_mm256_mul_pd(q_acc_20_21,src_dof_21)),_mm256_mul_pd(q_acc_20_22,src_dof_22)),_mm256_mul_pd(q_acc_20_23,src_dof_23)),_mm256_mul_pd(q_acc_20_24,src_dof_24)),_mm256_mul_pd(q_acc_20_25,src_dof_25)),_mm256_mul_pd(q_acc_20_26,src_dof_26)),_mm256_mul_pd(q_acc_20_27,src_dof_27)),_mm256_mul_pd(q_acc_20_28,src_dof_28)),_mm256_mul_pd(q_acc_20_29,src_dof_29)),_mm256_mul_pd(q_acc_2_20,src_dof_2)),_mm256_mul_pd(q_acc_3_20,src_dof_3)),_mm256_mul_pd(q_acc_4_20,src_dof_4)),_mm256_mul_pd(q_acc_5_20,src_dof_5)),_mm256_mul_pd(q_acc_6_20,src_dof_6)),_mm256_mul_pd(q_acc_7_20,src_dof_7)),_mm256_mul_pd(q_acc_8_20,src_dof_8)),_mm256_mul_pd(q_acc_9_20,src_dof_9));
                const __m256d elMatVec_21 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_21,src_dof_0),_mm256_mul_pd(q_acc_10_21,src_dof_10)),_mm256_mul_pd(q_acc_11_21,src_dof_11)),_mm256_mul_pd(q_acc_12_21,src_dof_12)),_mm256_mul_pd(q_acc_13_21,src_dof_13)),_mm256_mul_pd(q_acc_14_21,src_dof_14)),_mm256_mul_pd(q_acc_15_21,src_dof_15)),_mm256_mul_pd(q_acc_16_21,src_dof_16)),_mm256_mul_pd(q_acc_17_21,src_dof_17)),_mm256_mul_pd(q_acc_18_21,src_dof_18)),_mm256_mul_pd(q_acc_19_21,src_dof_19)),_mm256_mul_pd(q_acc_1_21,src_dof_1)),_mm256_mul_pd(q_acc_20_21,src_dof_20)),_mm256_mul_pd(q_acc_21_21,src_dof_21)),_mm256_mul_pd(q_acc_21_22,src_dof_22)),_mm256_mul_pd(q_acc_21_23,src_dof_23)),_mm256_mul_pd(q_acc_21_24,src_dof_24)),_mm256_mul_pd(q_acc_21_25,src_dof_25)),_mm256_mul_pd(q_acc_21_26,src_dof_26)),_mm256_mul_pd(q_acc_21_27,src_dof_27)),_mm256_mul_pd(q_acc_21_28,src_dof_28)),_mm256_mul_pd(q_acc_21_29,src_dof_29)),_mm256_mul_pd(q_acc_2_21,src_dof_2)),_mm256_mul_pd(q_acc_3_21,src_dof_3)),_mm256_mul_pd(q_acc_4_21,src_dof_4)),_mm256_mul_pd(q_acc_5_21,src_dof_5)),_mm256_mul_pd(q_acc_6_21,src_dof_6)),_mm256_mul_pd(q_acc_7_21,src_dof_7)),_mm256_mul_pd(q_acc_8_21,src_dof_8)),_mm256_mul_pd(q_acc_9_21,src_dof_9));
                const __m256d elMatVec_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_22,src_dof_0),_mm256_mul_pd(q_acc_10_22,src_dof_10)),_mm256_mul_pd(q_acc_11_22,src_dof_11)),_mm256_mul_pd(q_acc_12_22,src_dof_12)),_mm256_mul_pd(q_acc_13_22,src_dof_13)),_mm256_mul_pd(q_acc_14_22,src_dof_14)),_mm256_mul_pd(q_acc_15_22,src_dof_15)),_mm256_mul_pd(q_acc_16_22,src_dof_16)),_mm256_mul_pd(q_acc_17_22,src_dof_17)),_mm256_mul_pd(q_acc_18_22,src_dof_18)),_mm256_mul_pd(q_acc_19_22,src_dof_19)),_mm256_mul_pd(q_acc_1_22,src_dof_1)),_mm256_mul_pd(q_acc_20_22,src_dof_20)),_mm256_mul_pd(q_acc_21_22,src_dof_21)),_mm256_mul_pd(q_acc_22_22,src_dof_22)),_mm256_mul_pd(q_acc_22_23,src_dof_23)),_mm256_mul_pd(q_acc_22_24,src_dof_24)),_mm256_mul_pd(q_acc_22_25,src_dof_25)),_mm256_mul_pd(q_acc_22_26,src_dof_26)),_mm256_mul_pd(q_acc_22_27,src_dof_27)),_mm256_mul_pd(q_acc_22_28,src_dof_28)),_mm256_mul_pd(q_acc_22_29,src_dof_29)),_mm256_mul_pd(q_acc_2_22,src_dof_2)),_mm256_mul_pd(q_acc_3_22,src_dof_3)),_mm256_mul_pd(q_acc_4_22,src_dof_4)),_mm256_mul_pd(q_acc_5_22,src_dof_5)),_mm256_mul_pd(q_acc_6_22,src_dof_6)),_mm256_mul_pd(q_acc_7_22,src_dof_7)),_mm256_mul_pd(q_acc_8_22,src_dof_8)),_mm256_mul_pd(q_acc_9_22,src_dof_9));
                const __m256d elMatVec_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_23,src_dof_0),_mm256_mul_pd(q_acc_10_23,src_dof_10)),_mm256_mul_pd(q_acc_11_23,src_dof_11)),_mm256_mul_pd(q_acc_12_23,src_dof_12)),_mm256_mul_pd(q_acc_13_23,src_dof_13)),_mm256_mul_pd(q_acc_14_23,src_dof_14)),_mm256_mul_pd(q_acc_15_23,src_dof_15)),_mm256_mul_pd(q_acc_16_23,src_dof_16)),_mm256_mul_pd(q_acc_17_23,src_dof_17)),_mm256_mul_pd(q_acc_18_23,src_dof_18)),_mm256_mul_pd(q_acc_19_23,src_dof_19)),_mm256_mul_pd(q_acc_1_23,src_dof_1)),_mm256_mul_pd(q_acc_20_23,src_dof_20)),_mm256_mul_pd(q_acc_21_23,src_dof_21)),_mm256_mul_pd(q_acc_22_23,src_dof_22)),_mm256_mul_pd(q_acc_23_23,src_dof_23)),_mm256_mul_pd(q_acc_23_24,src_dof_24)),_mm256_mul_pd(q_acc_23_25,src_dof_25)),_mm256_mul_pd(q_acc_23_26,src_dof_26)),_mm256_mul_pd(q_acc_23_27,src_dof_27)),_mm256_mul_pd(q_acc_23_28,src_dof_28)),_mm256_mul_pd(q_acc_23_29,src_dof_29)),_mm256_mul_pd(q_acc_2_23,src_dof_2)),_mm256_mul_pd(q_acc_3_23,src_dof_3)),_mm256_mul_pd(q_acc_4_23,src_dof_4)),_mm256_mul_pd(q_acc_5_23,src_dof_5)),_mm256_mul_pd(q_acc_6_23,src_dof_6)),_mm256_mul_pd(q_acc_7_23,src_dof_7)),_mm256_mul_pd(q_acc_8_23,src_dof_8)),_mm256_mul_pd(q_acc_9_23,src_dof_9));
                const __m256d elMatVec_24 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_24,src_dof_0),_mm256_mul_pd(q_acc_10_24,src_dof_10)),_mm256_mul_pd(q_acc_11_24,src_dof_11)),_mm256_mul_pd(q_acc_12_24,src_dof_12)),_mm256_mul_pd(q_acc_13_24,src_dof_13)),_mm256_mul_pd(q_acc_14_24,src_dof_14)),_mm256_mul_pd(q_acc_15_24,src_dof_15)),_mm256_mul_pd(q_acc_16_24,src_dof_16)),_mm256_mul_pd(q_acc_17_24,src_dof_17)),_mm256_mul_pd(q_acc_18_24,src_dof_18)),_mm256_mul_pd(q_acc_19_24,src_dof_19)),_mm256_mul_pd(q_acc_1_24,src_dof_1)),_mm256_mul_pd(q_acc_20_24,src_dof_20)),_mm256_mul_pd(q_acc_21_24,src_dof_21)),_mm256_mul_pd(q_acc_22_24,src_dof_22)),_mm256_mul_pd(q_acc_23_24,src_dof_23)),_mm256_mul_pd(q_acc_24_24,src_dof_24)),_mm256_mul_pd(q_acc_24_25,src_dof_25)),_mm256_mul_pd(q_acc_24_26,src_dof_26)),_mm256_mul_pd(q_acc_24_27,src_dof_27)),_mm256_mul_pd(q_acc_24_28,src_dof_28)),_mm256_mul_pd(q_acc_24_29,src_dof_29)),_mm256_mul_pd(q_acc_2_24,src_dof_2)),_mm256_mul_pd(q_acc_3_24,src_dof_3)),_mm256_mul_pd(q_acc_4_24,src_dof_4)),_mm256_mul_pd(q_acc_5_24,src_dof_5)),_mm256_mul_pd(q_acc_6_24,src_dof_6)),_mm256_mul_pd(q_acc_7_24,src_dof_7)),_mm256_mul_pd(q_acc_8_24,src_dof_8)),_mm256_mul_pd(q_acc_9_24,src_dof_9));
                const __m256d elMatVec_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_25,src_dof_0),_mm256_mul_pd(q_acc_10_25,src_dof_10)),_mm256_mul_pd(q_acc_11_25,src_dof_11)),_mm256_mul_pd(q_acc_12_25,src_dof_12)),_mm256_mul_pd(q_acc_13_25,src_dof_13)),_mm256_mul_pd(q_acc_14_25,src_dof_14)),_mm256_mul_pd(q_acc_15_25,src_dof_15)),_mm256_mul_pd(q_acc_16_25,src_dof_16)),_mm256_mul_pd(q_acc_17_25,src_dof_17)),_mm256_mul_pd(q_acc_18_25,src_dof_18)),_mm256_mul_pd(q_acc_19_25,src_dof_19)),_mm256_mul_pd(q_acc_1_25,src_dof_1)),_mm256_mul_pd(q_acc_20_25,src_dof_20)),_mm256_mul_pd(q_acc_21_25,src_dof_21)),_mm256_mul_pd(q_acc_22_25,src_dof_22)),_mm256_mul_pd(q_acc_23_25,src_dof_23)),_mm256_mul_pd(q_acc_24_25,src_dof_24)),_mm256_mul_pd(q_acc_25_25,src_dof_25)),_mm256_mul_pd(q_acc_25_26,src_dof_26)),_mm256_mul_pd(q_acc_25_27,src_dof_27)),_mm256_mul_pd(q_acc_25_28,src_dof_28)),_mm256_mul_pd(q_acc_25_29,src_dof_29)),_mm256_mul_pd(q_acc_2_25,src_dof_2)),_mm256_mul_pd(q_acc_3_25,src_dof_3)),_mm256_mul_pd(q_acc_4_25,src_dof_4)),_mm256_mul_pd(q_acc_5_25,src_dof_5)),_mm256_mul_pd(q_acc_6_25,src_dof_6)),_mm256_mul_pd(q_acc_7_25,src_dof_7)),_mm256_mul_pd(q_acc_8_25,src_dof_8)),_mm256_mul_pd(q_acc_9_25,src_dof_9));
                const __m256d elMatVec_26 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_26,src_dof_0),_mm256_mul_pd(q_acc_10_26,src_dof_10)),_mm256_mul_pd(q_acc_11_26,src_dof_11)),_mm256_mul_pd(q_acc_12_26,src_dof_12)),_mm256_mul_pd(q_acc_13_26,src_dof_13)),_mm256_mul_pd(q_acc_14_26,src_dof_14)),_mm256_mul_pd(q_acc_15_26,src_dof_15)),_mm256_mul_pd(q_acc_16_26,src_dof_16)),_mm256_mul_pd(q_acc_17_26,src_dof_17)),_mm256_mul_pd(q_acc_18_26,src_dof_18)),_mm256_mul_pd(q_acc_19_26,src_dof_19)),_mm256_mul_pd(q_acc_1_26,src_dof_1)),_mm256_mul_pd(q_acc_20_26,src_dof_20)),_mm256_mul_pd(q_acc_21_26,src_dof_21)),_mm256_mul_pd(q_acc_22_26,src_dof_22)),_mm256_mul_pd(q_acc_23_26,src_dof_23)),_mm256_mul_pd(q_acc_24_26,src_dof_24)),_mm256_mul_pd(q_acc_25_26,src_dof_25)),_mm256_mul_pd(q_acc_26_26,src_dof_26)),_mm256_mul_pd(q_acc_26_27,src_dof_27)),_mm256_mul_pd(q_acc_26_28,src_dof_28)),_mm256_mul_pd(q_acc_26_29,src_dof_29)),_mm256_mul_pd(q_acc_2_26,src_dof_2)),_mm256_mul_pd(q_acc_3_26,src_dof_3)),_mm256_mul_pd(q_acc_4_26,src_dof_4)),_mm256_mul_pd(q_acc_5_26,src_dof_5)),_mm256_mul_pd(q_acc_6_26,src_dof_6)),_mm256_mul_pd(q_acc_7_26,src_dof_7)),_mm256_mul_pd(q_acc_8_26,src_dof_8)),_mm256_mul_pd(q_acc_9_26,src_dof_9));
                const __m256d elMatVec_27 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_27,src_dof_0),_mm256_mul_pd(q_acc_10_27,src_dof_10)),_mm256_mul_pd(q_acc_11_27,src_dof_11)),_mm256_mul_pd(q_acc_12_27,src_dof_12)),_mm256_mul_pd(q_acc_13_27,src_dof_13)),_mm256_mul_pd(q_acc_14_27,src_dof_14)),_mm256_mul_pd(q_acc_15_27,src_dof_15)),_mm256_mul_pd(q_acc_16_27,src_dof_16)),_mm256_mul_pd(q_acc_17_27,src_dof_17)),_mm256_mul_pd(q_acc_18_27,src_dof_18)),_mm256_mul_pd(q_acc_19_27,src_dof_19)),_mm256_mul_pd(q_acc_1_27,src_dof_1)),_mm256_mul_pd(q_acc_20_27,src_dof_20)),_mm256_mul_pd(q_acc_21_27,src_dof_21)),_mm256_mul_pd(q_acc_22_27,src_dof_22)),_mm256_mul_pd(q_acc_23_27,src_dof_23)),_mm256_mul_pd(q_acc_24_27,src_dof_24)),_mm256_mul_pd(q_acc_25_27,src_dof_25)),_mm256_mul_pd(q_acc_26_27,src_dof_26)),_mm256_mul_pd(q_acc_27_27,src_dof_27)),_mm256_mul_pd(q_acc_27_28,src_dof_28)),_mm256_mul_pd(q_acc_27_29,src_dof_29)),_mm256_mul_pd(q_acc_2_27,src_dof_2)),_mm256_mul_pd(q_acc_3_27,src_dof_3)),_mm256_mul_pd(q_acc_4_27,src_dof_4)),_mm256_mul_pd(q_acc_5_27,src_dof_5)),_mm256_mul_pd(q_acc_6_27,src_dof_6)),_mm256_mul_pd(q_acc_7_27,src_dof_7)),_mm256_mul_pd(q_acc_8_27,src_dof_8)),_mm256_mul_pd(q_acc_9_27,src_dof_9));
                const __m256d elMatVec_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_28,src_dof_0),_mm256_mul_pd(q_acc_10_28,src_dof_10)),_mm256_mul_pd(q_acc_11_28,src_dof_11)),_mm256_mul_pd(q_acc_12_28,src_dof_12)),_mm256_mul_pd(q_acc_13_28,src_dof_13)),_mm256_mul_pd(q_acc_14_28,src_dof_14)),_mm256_mul_pd(q_acc_15_28,src_dof_15)),_mm256_mul_pd(q_acc_16_28,src_dof_16)),_mm256_mul_pd(q_acc_17_28,src_dof_17)),_mm256_mul_pd(q_acc_18_28,src_dof_18)),_mm256_mul_pd(q_acc_19_28,src_dof_19)),_mm256_mul_pd(q_acc_1_28,src_dof_1)),_mm256_mul_pd(q_acc_20_28,src_dof_20)),_mm256_mul_pd(q_acc_21_28,src_dof_21)),_mm256_mul_pd(q_acc_22_28,src_dof_22)),_mm256_mul_pd(q_acc_23_28,src_dof_23)),_mm256_mul_pd(q_acc_24_28,src_dof_24)),_mm256_mul_pd(q_acc_25_28,src_dof_25)),_mm256_mul_pd(q_acc_26_28,src_dof_26)),_mm256_mul_pd(q_acc_27_28,src_dof_27)),_mm256_mul_pd(q_acc_28_28,src_dof_28)),_mm256_mul_pd(q_acc_28_29,src_dof_29)),_mm256_mul_pd(q_acc_2_28,src_dof_2)),_mm256_mul_pd(q_acc_3_28,src_dof_3)),_mm256_mul_pd(q_acc_4_28,src_dof_4)),_mm256_mul_pd(q_acc_5_28,src_dof_5)),_mm256_mul_pd(q_acc_6_28,src_dof_6)),_mm256_mul_pd(q_acc_7_28,src_dof_7)),_mm256_mul_pd(q_acc_8_28,src_dof_8)),_mm256_mul_pd(q_acc_9_28,src_dof_9));
                const __m256d elMatVec_29 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_29,src_dof_0),_mm256_mul_pd(q_acc_10_29,src_dof_10)),_mm256_mul_pd(q_acc_11_29,src_dof_11)),_mm256_mul_pd(q_acc_12_29,src_dof_12)),_mm256_mul_pd(q_acc_13_29,src_dof_13)),_mm256_mul_pd(q_acc_14_29,src_dof_14)),_mm256_mul_pd(q_acc_15_29,src_dof_15)),_mm256_mul_pd(q_acc_16_29,src_dof_16)),_mm256_mul_pd(q_acc_17_29,src_dof_17)),_mm256_mul_pd(q_acc_18_29,src_dof_18)),_mm256_mul_pd(q_acc_19_29,src_dof_19)),_mm256_mul_pd(q_acc_1_29,src_dof_1)),_mm256_mul_pd(q_acc_20_29,src_dof_20)),_mm256_mul_pd(q_acc_21_29,src_dof_21)),_mm256_mul_pd(q_acc_22_29,src_dof_22)),_mm256_mul_pd(q_acc_23_29,src_dof_23)),_mm256_mul_pd(q_acc_24_29,src_dof_24)),_mm256_mul_pd(q_acc_25_29,src_dof_25)),_mm256_mul_pd(q_acc_26_29,src_dof_26)),_mm256_mul_pd(q_acc_27_29,src_dof_27)),_mm256_mul_pd(q_acc_28_29,src_dof_28)),_mm256_mul_pd(q_acc_29_29,src_dof_29)),_mm256_mul_pd(q_acc_2_29,src_dof_2)),_mm256_mul_pd(q_acc_3_29,src_dof_3)),_mm256_mul_pd(q_acc_4_29,src_dof_4)),_mm256_mul_pd(q_acc_5_29,src_dof_5)),_mm256_mul_pd(q_acc_6_29,src_dof_6)),_mm256_mul_pd(q_acc_7_29,src_dof_7)),_mm256_mul_pd(q_acc_8_29,src_dof_8)),_mm256_mul_pd(q_acc_9_29,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_12,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_13,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_14,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_15,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_16,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_17,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_18,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_19,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_20,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_21,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_22,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_23,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_24,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_25,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_26,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_27,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_28,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_29,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_0_12 = 0.0;
                real_t q_acc_0_13 = 0.0;
                real_t q_acc_0_14 = 0.0;
                real_t q_acc_0_15 = 0.0;
                real_t q_acc_0_16 = 0.0;
                real_t q_acc_0_17 = 0.0;
                real_t q_acc_0_18 = 0.0;
                real_t q_acc_0_19 = 0.0;
                real_t q_acc_0_20 = 0.0;
                real_t q_acc_0_21 = 0.0;
                real_t q_acc_0_22 = 0.0;
                real_t q_acc_0_23 = 0.0;
                real_t q_acc_0_24 = 0.0;
                real_t q_acc_0_25 = 0.0;
                real_t q_acc_0_26 = 0.0;
                real_t q_acc_0_27 = 0.0;
                real_t q_acc_0_28 = 0.0;
                real_t q_acc_0_29 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_1_12 = 0.0;
                real_t q_acc_1_13 = 0.0;
                real_t q_acc_1_14 = 0.0;
                real_t q_acc_1_15 = 0.0;
                real_t q_acc_1_16 = 0.0;
                real_t q_acc_1_17 = 0.0;
                real_t q_acc_1_18 = 0.0;
                real_t q_acc_1_19 = 0.0;
                real_t q_acc_1_20 = 0.0;
                real_t q_acc_1_21 = 0.0;
                real_t q_acc_1_22 = 0.0;
                real_t q_acc_1_23 = 0.0;
                real_t q_acc_1_24 = 0.0;
                real_t q_acc_1_25 = 0.0;
                real_t q_acc_1_26 = 0.0;
                real_t q_acc_1_27 = 0.0;
                real_t q_acc_1_28 = 0.0;
                real_t q_acc_1_29 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_2_12 = 0.0;
                real_t q_acc_2_13 = 0.0;
                real_t q_acc_2_14 = 0.0;
                real_t q_acc_2_15 = 0.0;
                real_t q_acc_2_16 = 0.0;
                real_t q_acc_2_17 = 0.0;
                real_t q_acc_2_18 = 0.0;
                real_t q_acc_2_19 = 0.0;
                real_t q_acc_2_20 = 0.0;
                real_t q_acc_2_21 = 0.0;
                real_t q_acc_2_22 = 0.0;
                real_t q_acc_2_23 = 0.0;
                real_t q_acc_2_24 = 0.0;
                real_t q_acc_2_25 = 0.0;
                real_t q_acc_2_26 = 0.0;
                real_t q_acc_2_27 = 0.0;
                real_t q_acc_2_28 = 0.0;
                real_t q_acc_2_29 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_3_12 = 0.0;
                real_t q_acc_3_13 = 0.0;
                real_t q_acc_3_14 = 0.0;
                real_t q_acc_3_15 = 0.0;
                real_t q_acc_3_16 = 0.0;
                real_t q_acc_3_17 = 0.0;
                real_t q_acc_3_18 = 0.0;
                real_t q_acc_3_19 = 0.0;
                real_t q_acc_3_20 = 0.0;
                real_t q_acc_3_21 = 0.0;
                real_t q_acc_3_22 = 0.0;
                real_t q_acc_3_23 = 0.0;
                real_t q_acc_3_24 = 0.0;
                real_t q_acc_3_25 = 0.0;
                real_t q_acc_3_26 = 0.0;
                real_t q_acc_3_27 = 0.0;
                real_t q_acc_3_28 = 0.0;
                real_t q_acc_3_29 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_4_12 = 0.0;
                real_t q_acc_4_13 = 0.0;
                real_t q_acc_4_14 = 0.0;
                real_t q_acc_4_15 = 0.0;
                real_t q_acc_4_16 = 0.0;
                real_t q_acc_4_17 = 0.0;
                real_t q_acc_4_18 = 0.0;
                real_t q_acc_4_19 = 0.0;
                real_t q_acc_4_20 = 0.0;
                real_t q_acc_4_21 = 0.0;
                real_t q_acc_4_22 = 0.0;
                real_t q_acc_4_23 = 0.0;
                real_t q_acc_4_24 = 0.0;
                real_t q_acc_4_25 = 0.0;
                real_t q_acc_4_26 = 0.0;
                real_t q_acc_4_27 = 0.0;
                real_t q_acc_4_28 = 0.0;
                real_t q_acc_4_29 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_5_12 = 0.0;
                real_t q_acc_5_13 = 0.0;
                real_t q_acc_5_14 = 0.0;
                real_t q_acc_5_15 = 0.0;
                real_t q_acc_5_16 = 0.0;
                real_t q_acc_5_17 = 0.0;
                real_t q_acc_5_18 = 0.0;
                real_t q_acc_5_19 = 0.0;
                real_t q_acc_5_20 = 0.0;
                real_t q_acc_5_21 = 0.0;
                real_t q_acc_5_22 = 0.0;
                real_t q_acc_5_23 = 0.0;
                real_t q_acc_5_24 = 0.0;
                real_t q_acc_5_25 = 0.0;
                real_t q_acc_5_26 = 0.0;
                real_t q_acc_5_27 = 0.0;
                real_t q_acc_5_28 = 0.0;
                real_t q_acc_5_29 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_6_12 = 0.0;
                real_t q_acc_6_13 = 0.0;
                real_t q_acc_6_14 = 0.0;
                real_t q_acc_6_15 = 0.0;
                real_t q_acc_6_16 = 0.0;
                real_t q_acc_6_17 = 0.0;
                real_t q_acc_6_18 = 0.0;
                real_t q_acc_6_19 = 0.0;
                real_t q_acc_6_20 = 0.0;
                real_t q_acc_6_21 = 0.0;
                real_t q_acc_6_22 = 0.0;
                real_t q_acc_6_23 = 0.0;
                real_t q_acc_6_24 = 0.0;
                real_t q_acc_6_25 = 0.0;
                real_t q_acc_6_26 = 0.0;
                real_t q_acc_6_27 = 0.0;
                real_t q_acc_6_28 = 0.0;
                real_t q_acc_6_29 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_7_12 = 0.0;
                real_t q_acc_7_13 = 0.0;
                real_t q_acc_7_14 = 0.0;
                real_t q_acc_7_15 = 0.0;
                real_t q_acc_7_16 = 0.0;
                real_t q_acc_7_17 = 0.0;
                real_t q_acc_7_18 = 0.0;
                real_t q_acc_7_19 = 0.0;
                real_t q_acc_7_20 = 0.0;
                real_t q_acc_7_21 = 0.0;
                real_t q_acc_7_22 = 0.0;
                real_t q_acc_7_23 = 0.0;
                real_t q_acc_7_24 = 0.0;
                real_t q_acc_7_25 = 0.0;
                real_t q_acc_7_26 = 0.0;
                real_t q_acc_7_27 = 0.0;
                real_t q_acc_7_28 = 0.0;
                real_t q_acc_7_29 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_8_12 = 0.0;
                real_t q_acc_8_13 = 0.0;
                real_t q_acc_8_14 = 0.0;
                real_t q_acc_8_15 = 0.0;
                real_t q_acc_8_16 = 0.0;
                real_t q_acc_8_17 = 0.0;
                real_t q_acc_8_18 = 0.0;
                real_t q_acc_8_19 = 0.0;
                real_t q_acc_8_20 = 0.0;
                real_t q_acc_8_21 = 0.0;
                real_t q_acc_8_22 = 0.0;
                real_t q_acc_8_23 = 0.0;
                real_t q_acc_8_24 = 0.0;
                real_t q_acc_8_25 = 0.0;
                real_t q_acc_8_26 = 0.0;
                real_t q_acc_8_27 = 0.0;
                real_t q_acc_8_28 = 0.0;
                real_t q_acc_8_29 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_9_12 = 0.0;
                real_t q_acc_9_13 = 0.0;
                real_t q_acc_9_14 = 0.0;
                real_t q_acc_9_15 = 0.0;
                real_t q_acc_9_16 = 0.0;
                real_t q_acc_9_17 = 0.0;
                real_t q_acc_9_18 = 0.0;
                real_t q_acc_9_19 = 0.0;
                real_t q_acc_9_20 = 0.0;
                real_t q_acc_9_21 = 0.0;
                real_t q_acc_9_22 = 0.0;
                real_t q_acc_9_23 = 0.0;
                real_t q_acc_9_24 = 0.0;
                real_t q_acc_9_25 = 0.0;
                real_t q_acc_9_26 = 0.0;
                real_t q_acc_9_27 = 0.0;
                real_t q_acc_9_28 = 0.0;
                real_t q_acc_9_29 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_10_12 = 0.0;
                real_t q_acc_10_13 = 0.0;
                real_t q_acc_10_14 = 0.0;
                real_t q_acc_10_15 = 0.0;
                real_t q_acc_10_16 = 0.0;
                real_t q_acc_10_17 = 0.0;
                real_t q_acc_10_18 = 0.0;
                real_t q_acc_10_19 = 0.0;
                real_t q_acc_10_20 = 0.0;
                real_t q_acc_10_21 = 0.0;
                real_t q_acc_10_22 = 0.0;
                real_t q_acc_10_23 = 0.0;
                real_t q_acc_10_24 = 0.0;
                real_t q_acc_10_25 = 0.0;
                real_t q_acc_10_26 = 0.0;
                real_t q_acc_10_27 = 0.0;
                real_t q_acc_10_28 = 0.0;
                real_t q_acc_10_29 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_11_12 = 0.0;
                real_t q_acc_11_13 = 0.0;
                real_t q_acc_11_14 = 0.0;
                real_t q_acc_11_15 = 0.0;
                real_t q_acc_11_16 = 0.0;
                real_t q_acc_11_17 = 0.0;
                real_t q_acc_11_18 = 0.0;
                real_t q_acc_11_19 = 0.0;
                real_t q_acc_11_20 = 0.0;
                real_t q_acc_11_21 = 0.0;
                real_t q_acc_11_22 = 0.0;
                real_t q_acc_11_23 = 0.0;
                real_t q_acc_11_24 = 0.0;
                real_t q_acc_11_25 = 0.0;
                real_t q_acc_11_26 = 0.0;
                real_t q_acc_11_27 = 0.0;
                real_t q_acc_11_28 = 0.0;
                real_t q_acc_11_29 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_12_13 = 0.0;
                real_t q_acc_12_14 = 0.0;
                real_t q_acc_12_15 = 0.0;
                real_t q_acc_12_16 = 0.0;
                real_t q_acc_12_17 = 0.0;
                real_t q_acc_12_18 = 0.0;
                real_t q_acc_12_19 = 0.0;
                real_t q_acc_12_20 = 0.0;
                real_t q_acc_12_21 = 0.0;
                real_t q_acc_12_22 = 0.0;
                real_t q_acc_12_23 = 0.0;
                real_t q_acc_12_24 = 0.0;
                real_t q_acc_12_25 = 0.0;
                real_t q_acc_12_26 = 0.0;
                real_t q_acc_12_27 = 0.0;
                real_t q_acc_12_28 = 0.0;
                real_t q_acc_12_29 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_13_14 = 0.0;
                real_t q_acc_13_15 = 0.0;
                real_t q_acc_13_16 = 0.0;
                real_t q_acc_13_17 = 0.0;
                real_t q_acc_13_18 = 0.0;
                real_t q_acc_13_19 = 0.0;
                real_t q_acc_13_20 = 0.0;
                real_t q_acc_13_21 = 0.0;
                real_t q_acc_13_22 = 0.0;
                real_t q_acc_13_23 = 0.0;
                real_t q_acc_13_24 = 0.0;
                real_t q_acc_13_25 = 0.0;
                real_t q_acc_13_26 = 0.0;
                real_t q_acc_13_27 = 0.0;
                real_t q_acc_13_28 = 0.0;
                real_t q_acc_13_29 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_14_15 = 0.0;
                real_t q_acc_14_16 = 0.0;
                real_t q_acc_14_17 = 0.0;
                real_t q_acc_14_18 = 0.0;
                real_t q_acc_14_19 = 0.0;
                real_t q_acc_14_20 = 0.0;
                real_t q_acc_14_21 = 0.0;
                real_t q_acc_14_22 = 0.0;
                real_t q_acc_14_23 = 0.0;
                real_t q_acc_14_24 = 0.0;
                real_t q_acc_14_25 = 0.0;
                real_t q_acc_14_26 = 0.0;
                real_t q_acc_14_27 = 0.0;
                real_t q_acc_14_28 = 0.0;
                real_t q_acc_14_29 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_15_16 = 0.0;
                real_t q_acc_15_17 = 0.0;
                real_t q_acc_15_18 = 0.0;
                real_t q_acc_15_19 = 0.0;
                real_t q_acc_15_20 = 0.0;
                real_t q_acc_15_21 = 0.0;
                real_t q_acc_15_22 = 0.0;
                real_t q_acc_15_23 = 0.0;
                real_t q_acc_15_24 = 0.0;
                real_t q_acc_15_25 = 0.0;
                real_t q_acc_15_26 = 0.0;
                real_t q_acc_15_27 = 0.0;
                real_t q_acc_15_28 = 0.0;
                real_t q_acc_15_29 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_16_17 = 0.0;
                real_t q_acc_16_18 = 0.0;
                real_t q_acc_16_19 = 0.0;
                real_t q_acc_16_20 = 0.0;
                real_t q_acc_16_21 = 0.0;
                real_t q_acc_16_22 = 0.0;
                real_t q_acc_16_23 = 0.0;
                real_t q_acc_16_24 = 0.0;
                real_t q_acc_16_25 = 0.0;
                real_t q_acc_16_26 = 0.0;
                real_t q_acc_16_27 = 0.0;
                real_t q_acc_16_28 = 0.0;
                real_t q_acc_16_29 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_17_18 = 0.0;
                real_t q_acc_17_19 = 0.0;
                real_t q_acc_17_20 = 0.0;
                real_t q_acc_17_21 = 0.0;
                real_t q_acc_17_22 = 0.0;
                real_t q_acc_17_23 = 0.0;
                real_t q_acc_17_24 = 0.0;
                real_t q_acc_17_25 = 0.0;
                real_t q_acc_17_26 = 0.0;
                real_t q_acc_17_27 = 0.0;
                real_t q_acc_17_28 = 0.0;
                real_t q_acc_17_29 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_18_19 = 0.0;
                real_t q_acc_18_20 = 0.0;
                real_t q_acc_18_21 = 0.0;
                real_t q_acc_18_22 = 0.0;
                real_t q_acc_18_23 = 0.0;
                real_t q_acc_18_24 = 0.0;
                real_t q_acc_18_25 = 0.0;
                real_t q_acc_18_26 = 0.0;
                real_t q_acc_18_27 = 0.0;
                real_t q_acc_18_28 = 0.0;
                real_t q_acc_18_29 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_19_20 = 0.0;
                real_t q_acc_19_21 = 0.0;
                real_t q_acc_19_22 = 0.0;
                real_t q_acc_19_23 = 0.0;
                real_t q_acc_19_24 = 0.0;
                real_t q_acc_19_25 = 0.0;
                real_t q_acc_19_26 = 0.0;
                real_t q_acc_19_27 = 0.0;
                real_t q_acc_19_28 = 0.0;
                real_t q_acc_19_29 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_20_21 = 0.0;
                real_t q_acc_20_22 = 0.0;
                real_t q_acc_20_23 = 0.0;
                real_t q_acc_20_24 = 0.0;
                real_t q_acc_20_25 = 0.0;
                real_t q_acc_20_26 = 0.0;
                real_t q_acc_20_27 = 0.0;
                real_t q_acc_20_28 = 0.0;
                real_t q_acc_20_29 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_21_22 = 0.0;
                real_t q_acc_21_23 = 0.0;
                real_t q_acc_21_24 = 0.0;
                real_t q_acc_21_25 = 0.0;
                real_t q_acc_21_26 = 0.0;
                real_t q_acc_21_27 = 0.0;
                real_t q_acc_21_28 = 0.0;
                real_t q_acc_21_29 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_22_23 = 0.0;
                real_t q_acc_22_24 = 0.0;
                real_t q_acc_22_25 = 0.0;
                real_t q_acc_22_26 = 0.0;
                real_t q_acc_22_27 = 0.0;
                real_t q_acc_22_28 = 0.0;
                real_t q_acc_22_29 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_23_24 = 0.0;
                real_t q_acc_23_25 = 0.0;
                real_t q_acc_23_26 = 0.0;
                real_t q_acc_23_27 = 0.0;
                real_t q_acc_23_28 = 0.0;
                real_t q_acc_23_29 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_24_25 = 0.0;
                real_t q_acc_24_26 = 0.0;
                real_t q_acc_24_27 = 0.0;
                real_t q_acc_24_28 = 0.0;
                real_t q_acc_24_29 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_25_26 = 0.0;
                real_t q_acc_25_27 = 0.0;
                real_t q_acc_25_28 = 0.0;
                real_t q_acc_25_29 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_26_27 = 0.0;
                real_t q_acc_26_28 = 0.0;
                real_t q_acc_26_29 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_27_28 = 0.0;
                real_t q_acc_27_29 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_28_29 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_156 = (mu_dof_0*_data_phi_0_0_BLUE_DOWN[4*q] + mu_dof_1*_data_phi_0_0_BLUE_DOWN[4*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_DOWN[4*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_DOWN[4*q + 3])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_133 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_157 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4];
                   const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6];
                   const real_t tmp_qloop_222 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7];
                   const real_t tmp_qloop_235 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10];
                   const real_t tmp_qloop_277 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11];
                   const real_t tmp_qloop_283 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_323 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_337 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_365 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_379 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_407 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_421 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_436 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_453 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_468 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_483 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_498 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_513 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_528 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_543 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_558 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_573 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_121 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q];
                   const real_t tmp_qloop_144 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_162 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4];
                   const real_t tmp_qloop_201 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5];
                   const real_t tmp_qloop_214 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8];
                   const real_t tmp_qloop_253 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9];
                   const real_t tmp_qloop_266 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10];
                   const real_t tmp_qloop_274 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_286 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11];
                   const real_t tmp_qloop_305 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_319 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_361 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_389 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_403 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_444 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_459 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_474 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_489 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_504 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_519 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_534 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_549 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_564 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_579 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q];
                   const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 2];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 3];
                   const real_t tmp_qloop_192 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 4];
                   const real_t tmp_qloop_205 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 5];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 6];
                   const real_t tmp_qloop_231 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 7];
                   const real_t tmp_qloop_244 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 8];
                   const real_t tmp_qloop_257 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 9];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 10];
                   const real_t tmp_qloop_293 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[12*q + 11];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_314 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_328 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_342 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_356 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_370 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_398 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_412 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_431 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_449 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_464 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_479 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_494 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_509 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_524 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_539 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_554 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_569 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_125 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_158 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_184 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_223 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_236 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_278 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_284 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_324 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_338 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_366 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_380 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_408 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_422 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_437 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_454 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_469 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_484 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_499 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_514 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_529 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_544 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_559 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_574 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_145 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_163 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_176 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_202 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_215 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_254 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_267 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_275 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_287 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_306 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_320 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_362 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_390 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_404 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_445 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_460 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_475 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_490 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_505 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_520 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_535 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_550 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_565 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_580 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_193 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_206 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_232 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_245 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_258 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_294 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_315 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_329 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_343 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_357 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_371 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_399 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_413 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_432 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_450 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_465 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_480 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_495 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_510 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_525 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_540 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_555 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_570 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_120 = tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0;
                   const real_t tmp_qloop_126 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_127 = tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_126;
                   const real_t tmp_qloop_128 = tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_126*0.5;
                   const real_t tmp_qloop_135 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_136 = tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135;
                   const real_t tmp_qloop_137 = tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5;
                   const real_t tmp_qloop_159 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_161 = tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0;
                   const real_t tmp_qloop_172 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_174 = tmp_qloop_170*2.0 + tmp_qloop_171*2.0 + tmp_qloop_172*2.0;
                   const real_t tmp_qloop_185 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_187 = tmp_qloop_183*2.0 + tmp_qloop_184*2.0 + tmp_qloop_185*2.0;
                   const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_200 = tmp_qloop_196*2.0 + tmp_qloop_197*2.0 + tmp_qloop_198*2.0;
                   const real_t tmp_qloop_211 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_213 = tmp_qloop_209*2.0 + tmp_qloop_210*2.0 + tmp_qloop_211*2.0;
                   const real_t tmp_qloop_224 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_226 = tmp_qloop_222*2.0 + tmp_qloop_223*2.0 + tmp_qloop_224*2.0;
                   const real_t tmp_qloop_237 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_239 = tmp_qloop_235*2.0 + tmp_qloop_236*2.0 + tmp_qloop_237*2.0;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_252 = tmp_qloop_248*2.0 + tmp_qloop_249*2.0 + tmp_qloop_250*2.0;
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_265 = tmp_qloop_261*2.0 + tmp_qloop_262*2.0 + tmp_qloop_263*2.0;
                   const real_t tmp_qloop_279 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_280 = tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663 + tmp_qloop_279*0.66666666666666663;
                   const real_t tmp_qloop_285 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_291 = tmp_qloop_277*2.0 + tmp_qloop_278*2.0 + tmp_qloop_279*2.0;
                   const real_t tmp_qloop_292 = tmp_qloop_120*tmp_qloop_291;
                   const real_t tmp_qloop_311 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_325 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_339 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_367 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_381 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_409 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_438 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_455 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_470 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_485 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_500 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_515 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_530 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_545 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_560 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_575 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_585 = tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0;
                   const real_t tmp_qloop_589 = tmp_qloop_291*tmp_qloop_585;
                   const real_t tmp_qloop_596 = tmp_qloop_170*1.0 + tmp_qloop_171*1.0 + tmp_qloop_172*1.0;
                   const real_t tmp_qloop_599 = tmp_qloop_291*tmp_qloop_596;
                   const real_t tmp_qloop_605 = tmp_qloop_183*1.0 + tmp_qloop_184*1.0 + tmp_qloop_185*1.0;
                   const real_t tmp_qloop_608 = tmp_qloop_291*tmp_qloop_605;
                   const real_t tmp_qloop_614 = tmp_qloop_196*1.0 + tmp_qloop_197*1.0 + tmp_qloop_198*1.0;
                   const real_t tmp_qloop_617 = tmp_qloop_291*tmp_qloop_614;
                   const real_t tmp_qloop_623 = tmp_qloop_209*1.0 + tmp_qloop_210*1.0 + tmp_qloop_211*1.0;
                   const real_t tmp_qloop_626 = tmp_qloop_291*tmp_qloop_623;
                   const real_t tmp_qloop_632 = tmp_qloop_222*1.0 + tmp_qloop_223*1.0 + tmp_qloop_224*1.0;
                   const real_t tmp_qloop_635 = tmp_qloop_291*tmp_qloop_632;
                   const real_t tmp_qloop_641 = tmp_qloop_235*1.0 + tmp_qloop_236*1.0 + tmp_qloop_237*1.0;
                   const real_t tmp_qloop_644 = tmp_qloop_291*tmp_qloop_641;
                   const real_t tmp_qloop_650 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                   const real_t tmp_qloop_653 = tmp_qloop_291*tmp_qloop_650;
                   const real_t tmp_qloop_659 = tmp_qloop_261*1.0 + tmp_qloop_262*1.0 + tmp_qloop_263*1.0;
                   const real_t tmp_qloop_662 = tmp_qloop_291*tmp_qloop_659;
                   const real_t tmp_qloop_667 = tmp_qloop_277 + tmp_qloop_278 + tmp_qloop_279;
                   const real_t tmp_qloop_674 = tmp_qloop_291*(tmp_qloop_277*1.0 + tmp_qloop_278*1.0 + tmp_qloop_279*1.0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_116 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_123 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_129 = tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_128*2.0;
                   const real_t tmp_qloop_139 = tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0;
                   const real_t tmp_qloop_140 = tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0;
                   const real_t tmp_qloop_141 = tmp_qloop_139*tmp_qloop_140;
                   const real_t tmp_qloop_146 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_147 = tmp_qloop_144 + tmp_qloop_145 + tmp_qloop_146;
                   const real_t tmp_qloop_152 = tmp_qloop_144*0.5 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5;
                   const real_t tmp_qloop_164 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_165 = tmp_qloop_127 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_177 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_178 = tmp_qloop_127 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_191 = tmp_qloop_127 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_203 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_204 = tmp_qloop_127 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_216 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_217 = tmp_qloop_127 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_229 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_230 = tmp_qloop_127 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_243 = tmp_qloop_127 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_255 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_256 = tmp_qloop_127 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_268 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_269 = tmp_qloop_127 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_276 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_288 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_289 = tmp_qloop_286 + tmp_qloop_287 + tmp_qloop_288;
                   const real_t tmp_qloop_290 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_289;
                   const real_t tmp_qloop_299 = tmp_qloop_274*2.0 + tmp_qloop_275*2.0 + tmp_qloop_276*2.0;
                   const real_t tmp_qloop_307 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_312 = tmp_qloop_289 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311;
                   const real_t tmp_qloop_313 = tmp_qloop_305*2.0 + tmp_qloop_306*2.0 + tmp_qloop_307*2.0;
                   const real_t tmp_qloop_321 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_326 = tmp_qloop_289 + tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325;
                   const real_t tmp_qloop_327 = tmp_qloop_319*2.0 + tmp_qloop_320*2.0 + tmp_qloop_321*2.0;
                   const real_t tmp_qloop_335 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_340 = tmp_qloop_289 + tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339;
                   const real_t tmp_qloop_341 = tmp_qloop_333*2.0 + tmp_qloop_334*2.0 + tmp_qloop_335*2.0;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_354 = tmp_qloop_289 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353;
                   const real_t tmp_qloop_355 = tmp_qloop_347*2.0 + tmp_qloop_348*2.0 + tmp_qloop_349*2.0;
                   const real_t tmp_qloop_363 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_368 = tmp_qloop_289 + tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367;
                   const real_t tmp_qloop_369 = tmp_qloop_361*2.0 + tmp_qloop_362*2.0 + tmp_qloop_363*2.0;
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_382 = tmp_qloop_289 + tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381;
                   const real_t tmp_qloop_383 = tmp_qloop_375*2.0 + tmp_qloop_376*2.0 + tmp_qloop_377*2.0;
                   const real_t tmp_qloop_391 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_396 = tmp_qloop_289 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395;
                   const real_t tmp_qloop_397 = tmp_qloop_389*2.0 + tmp_qloop_390*2.0 + tmp_qloop_391*2.0;
                   const real_t tmp_qloop_405 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_410 = tmp_qloop_289 + tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409;
                   const real_t tmp_qloop_411 = tmp_qloop_403*2.0 + tmp_qloop_404*2.0 + tmp_qloop_405*2.0;
                   const real_t tmp_qloop_419 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_424 = tmp_qloop_289 + tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423;
                   const real_t tmp_qloop_425 = tmp_qloop_417*2.0 + tmp_qloop_418*2.0 + tmp_qloop_419*2.0;
                   const real_t tmp_qloop_434 = tmp_qloop_113 + tmp_qloop_280;
                   const real_t tmp_qloop_440 = tmp_qloop_127 + tmp_qloop_289;
                   const real_t tmp_qloop_441 = tmp_qloop_129*tmp_qloop_440 + tmp_qloop_141 + tmp_qloop_292;
                   const real_t tmp_qloop_446 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_461 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_476 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_491 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_506 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_521 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_536 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_551 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_566 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_581 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_586 = tmp_qloop_128*2.0 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_593 = tmp_qloop_440*tmp_qloop_586 + tmp_qloop_589;
                   const real_t tmp_qloop_594 = tmp_qloop_141 + tmp_qloop_593;
                   const real_t tmp_qloop_597 = tmp_qloop_128*2.0 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_602 = tmp_qloop_440*tmp_qloop_597 + tmp_qloop_599;
                   const real_t tmp_qloop_603 = tmp_qloop_141 + tmp_qloop_602;
                   const real_t tmp_qloop_606 = tmp_qloop_128*2.0 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_611 = tmp_qloop_440*tmp_qloop_606 + tmp_qloop_608;
                   const real_t tmp_qloop_612 = tmp_qloop_141 + tmp_qloop_611;
                   const real_t tmp_qloop_615 = tmp_qloop_128*2.0 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_620 = tmp_qloop_440*tmp_qloop_615 + tmp_qloop_617;
                   const real_t tmp_qloop_621 = tmp_qloop_141 + tmp_qloop_620;
                   const real_t tmp_qloop_624 = tmp_qloop_128*2.0 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_629 = tmp_qloop_440*tmp_qloop_624 + tmp_qloop_626;
                   const real_t tmp_qloop_630 = tmp_qloop_141 + tmp_qloop_629;
                   const real_t tmp_qloop_633 = tmp_qloop_128*2.0 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_638 = tmp_qloop_440*tmp_qloop_633 + tmp_qloop_635;
                   const real_t tmp_qloop_639 = tmp_qloop_141 + tmp_qloop_638;
                   const real_t tmp_qloop_642 = tmp_qloop_128*2.0 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_647 = tmp_qloop_440*tmp_qloop_642 + tmp_qloop_644;
                   const real_t tmp_qloop_648 = tmp_qloop_141 + tmp_qloop_647;
                   const real_t tmp_qloop_651 = tmp_qloop_128*2.0 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_656 = tmp_qloop_440*tmp_qloop_651 + tmp_qloop_653;
                   const real_t tmp_qloop_657 = tmp_qloop_141 + tmp_qloop_656;
                   const real_t tmp_qloop_660 = tmp_qloop_128*2.0 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_665 = tmp_qloop_440*tmp_qloop_660 + tmp_qloop_662;
                   const real_t tmp_qloop_666 = tmp_qloop_141 + tmp_qloop_665;
                   const real_t tmp_qloop_670 = tmp_qloop_274*1.0 + tmp_qloop_275*1.0 + tmp_qloop_276*1.0;
                   const real_t tmp_qloop_671 = tmp_qloop_286*0.5 + tmp_qloop_287*0.5 + tmp_qloop_288*0.5;
                   const real_t tmp_qloop_672 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_678 = tmp_qloop_140*tmp_qloop_670 + tmp_qloop_440*tmp_qloop_672 + tmp_qloop_674;
                   const real_t tmp_qloop_690 = tmp_qloop_305*1.0 + tmp_qloop_306*1.0 + tmp_qloop_307*1.0;
                   const real_t tmp_qloop_691 = tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_694 = tmp_qloop_140*tmp_qloop_690 + tmp_qloop_440*tmp_qloop_691;
                   const real_t tmp_qloop_695 = tmp_qloop_674 + tmp_qloop_694;
                   const real_t tmp_qloop_697 = tmp_qloop_319*1.0 + tmp_qloop_320*1.0 + tmp_qloop_321*1.0;
                   const real_t tmp_qloop_698 = tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_700 = tmp_qloop_140*tmp_qloop_697 + tmp_qloop_440*tmp_qloop_698;
                   const real_t tmp_qloop_701 = tmp_qloop_674 + tmp_qloop_700;
                   const real_t tmp_qloop_703 = tmp_qloop_333*1.0 + tmp_qloop_334*1.0 + tmp_qloop_335*1.0;
                   const real_t tmp_qloop_704 = tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_706 = tmp_qloop_140*tmp_qloop_703 + tmp_qloop_440*tmp_qloop_704;
                   const real_t tmp_qloop_707 = tmp_qloop_674 + tmp_qloop_706;
                   const real_t tmp_qloop_709 = tmp_qloop_347*1.0 + tmp_qloop_348*1.0 + tmp_qloop_349*1.0;
                   const real_t tmp_qloop_710 = tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_712 = tmp_qloop_140*tmp_qloop_709 + tmp_qloop_440*tmp_qloop_710;
                   const real_t tmp_qloop_713 = tmp_qloop_674 + tmp_qloop_712;
                   const real_t tmp_qloop_715 = tmp_qloop_361*1.0 + tmp_qloop_362*1.0 + tmp_qloop_363*1.0;
                   const real_t tmp_qloop_716 = tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_718 = tmp_qloop_140*tmp_qloop_715 + tmp_qloop_440*tmp_qloop_716;
                   const real_t tmp_qloop_719 = tmp_qloop_674 + tmp_qloop_718;
                   const real_t tmp_qloop_721 = tmp_qloop_375*1.0 + tmp_qloop_376*1.0 + tmp_qloop_377*1.0;
                   const real_t tmp_qloop_722 = tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_724 = tmp_qloop_140*tmp_qloop_721 + tmp_qloop_440*tmp_qloop_722;
                   const real_t tmp_qloop_725 = tmp_qloop_674 + tmp_qloop_724;
                   const real_t tmp_qloop_727 = tmp_qloop_389*1.0 + tmp_qloop_390*1.0 + tmp_qloop_391*1.0;
                   const real_t tmp_qloop_728 = tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_730 = tmp_qloop_140*tmp_qloop_727 + tmp_qloop_440*tmp_qloop_728;
                   const real_t tmp_qloop_731 = tmp_qloop_674 + tmp_qloop_730;
                   const real_t tmp_qloop_733 = tmp_qloop_403*1.0 + tmp_qloop_404*1.0 + tmp_qloop_405*1.0;
                   const real_t tmp_qloop_734 = tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_736 = tmp_qloop_140*tmp_qloop_733 + tmp_qloop_440*tmp_qloop_734;
                   const real_t tmp_qloop_737 = tmp_qloop_674 + tmp_qloop_736;
                   const real_t tmp_qloop_739 = tmp_qloop_417*1.0 + tmp_qloop_418*1.0 + tmp_qloop_419*1.0;
                   const real_t tmp_qloop_740 = tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_742 = tmp_qloop_140*tmp_qloop_739 + tmp_qloop_440*tmp_qloop_740;
                   const real_t tmp_qloop_743 = tmp_qloop_674 + tmp_qloop_742;
                   const real_t tmp_qloop_744 = tmp_qloop_116 + tmp_qloop_667;
                   const real_t tmp_qloop_749 = tmp_qloop_141 + tmp_qloop_440*(tmp_qloop_128 + tmp_qloop_671)*2.0 + tmp_qloop_674;
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_119 = tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_117);
                   const real_t tmp_qloop_132 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_138 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_137*2.0;
                   const real_t tmp_qloop_142 = tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0;
                   const real_t tmp_qloop_143 = tmp_qloop_142*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q];
                   const real_t tmp_qloop_151 = tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150;
                   const real_t tmp_qloop_153 = tmp_qloop_148*0.5 + tmp_qloop_149*0.5 + tmp_qloop_150*0.5;
                   const real_t tmp_qloop_154 = tmp_qloop_152*2.0 + tmp_qloop_153*2.0;
                   const real_t tmp_qloop_155 = tmp_qloop_141 + tmp_qloop_143 + tmp_qloop_154*(tmp_qloop_147 + tmp_qloop_151);
                   const real_t tmp_qloop_160 = tmp_qloop_114 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663;
                   const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_169 = tmp_qloop_136 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_173 = tmp_qloop_114 + tmp_qloop_170*0.66666666666666663 + tmp_qloop_171*0.66666666666666663 + tmp_qloop_172*0.66666666666666663;
                   const real_t tmp_qloop_181 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_182 = tmp_qloop_136 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_186 = tmp_qloop_114 + tmp_qloop_183*0.66666666666666663 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663;
                   const real_t tmp_qloop_194 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_195 = tmp_qloop_136 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_199 = tmp_qloop_114 + tmp_qloop_196*0.66666666666666663 + tmp_qloop_197*0.66666666666666663 + tmp_qloop_198*0.66666666666666663;
                   const real_t tmp_qloop_207 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_208 = tmp_qloop_136 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_212 = tmp_qloop_114 + tmp_qloop_209*0.66666666666666663 + tmp_qloop_210*0.66666666666666663 + tmp_qloop_211*0.66666666666666663;
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_221 = tmp_qloop_136 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_225 = tmp_qloop_114 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663 + tmp_qloop_224*0.66666666666666663;
                   const real_t tmp_qloop_233 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_234 = tmp_qloop_136 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_238 = tmp_qloop_114 + tmp_qloop_235*0.66666666666666663 + tmp_qloop_236*0.66666666666666663 + tmp_qloop_237*0.66666666666666663;
                   const real_t tmp_qloop_246 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_247 = tmp_qloop_136 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_251 = tmp_qloop_114 + tmp_qloop_248*0.66666666666666663 + tmp_qloop_249*0.66666666666666663 + tmp_qloop_250*0.66666666666666663;
                   const real_t tmp_qloop_259 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_260 = tmp_qloop_136 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_264 = tmp_qloop_114 + tmp_qloop_261*0.66666666666666663 + tmp_qloop_262*0.66666666666666663 + tmp_qloop_263*0.66666666666666663;
                   const real_t tmp_qloop_272 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_273 = tmp_qloop_136 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_281 = tmp_qloop_109 + tmp_qloop_280;
                   const real_t tmp_qloop_282 = tmp_qloop_274*0.66666666666666663 + tmp_qloop_275*0.66666666666666663 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_281;
                   const real_t tmp_qloop_295 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_296 = tmp_qloop_293 + tmp_qloop_294 + tmp_qloop_295;
                   const real_t tmp_qloop_297 = tmp_qloop_136 + tmp_qloop_296;
                   const real_t tmp_qloop_298 = tmp_qloop_138*tmp_qloop_297 + tmp_qloop_143 + tmp_qloop_292;
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_303 = tmp_qloop_147 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_304 = tmp_qloop_139*tmp_qloop_299 + tmp_qloop_154*tmp_qloop_303;
                   const real_t tmp_qloop_308 = tmp_qloop_281 + tmp_qloop_305*0.66666666666666663 + tmp_qloop_306*0.66666666666666663 + tmp_qloop_307*0.66666666666666663;
                   const real_t tmp_qloop_316 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_317 = tmp_qloop_147 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_318 = tmp_qloop_139*tmp_qloop_313 + tmp_qloop_154*tmp_qloop_317;
                   const real_t tmp_qloop_322 = tmp_qloop_281 + tmp_qloop_319*0.66666666666666663 + tmp_qloop_320*0.66666666666666663 + tmp_qloop_321*0.66666666666666663;
                   const real_t tmp_qloop_330 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_331 = tmp_qloop_147 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_332 = tmp_qloop_139*tmp_qloop_327 + tmp_qloop_154*tmp_qloop_331;
                   const real_t tmp_qloop_336 = tmp_qloop_281 + tmp_qloop_333*0.66666666666666663 + tmp_qloop_334*0.66666666666666663 + tmp_qloop_335*0.66666666666666663;
                   const real_t tmp_qloop_344 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_345 = tmp_qloop_147 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_346 = tmp_qloop_139*tmp_qloop_341 + tmp_qloop_154*tmp_qloop_345;
                   const real_t tmp_qloop_350 = tmp_qloop_281 + tmp_qloop_347*0.66666666666666663 + tmp_qloop_348*0.66666666666666663 + tmp_qloop_349*0.66666666666666663;
                   const real_t tmp_qloop_358 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_359 = tmp_qloop_147 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_360 = tmp_qloop_139*tmp_qloop_355 + tmp_qloop_154*tmp_qloop_359;
                   const real_t tmp_qloop_364 = tmp_qloop_281 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663 + tmp_qloop_363*0.66666666666666663;
                   const real_t tmp_qloop_372 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_373 = tmp_qloop_147 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_374 = tmp_qloop_139*tmp_qloop_369 + tmp_qloop_154*tmp_qloop_373;
                   const real_t tmp_qloop_378 = tmp_qloop_281 + tmp_qloop_375*0.66666666666666663 + tmp_qloop_376*0.66666666666666663 + tmp_qloop_377*0.66666666666666663;
                   const real_t tmp_qloop_386 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_387 = tmp_qloop_147 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_388 = tmp_qloop_139*tmp_qloop_383 + tmp_qloop_154*tmp_qloop_387;
                   const real_t tmp_qloop_392 = tmp_qloop_281 + tmp_qloop_389*0.66666666666666663 + tmp_qloop_390*0.66666666666666663 + tmp_qloop_391*0.66666666666666663;
                   const real_t tmp_qloop_400 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_401 = tmp_qloop_147 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_402 = tmp_qloop_139*tmp_qloop_397 + tmp_qloop_154*tmp_qloop_401;
                   const real_t tmp_qloop_406 = tmp_qloop_281 + tmp_qloop_403*0.66666666666666663 + tmp_qloop_404*0.66666666666666663 + tmp_qloop_405*0.66666666666666663;
                   const real_t tmp_qloop_414 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_415 = tmp_qloop_147 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_416 = tmp_qloop_139*tmp_qloop_411 + tmp_qloop_154*tmp_qloop_415;
                   const real_t tmp_qloop_420 = tmp_qloop_281 + tmp_qloop_417*0.66666666666666663 + tmp_qloop_418*0.66666666666666663 + tmp_qloop_419*0.66666666666666663;
                   const real_t tmp_qloop_428 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_429 = tmp_qloop_147 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_430 = tmp_qloop_139*tmp_qloop_425 + tmp_qloop_154*tmp_qloop_429;
                   const real_t tmp_qloop_433 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 1];
                   const real_t tmp_qloop_435 = tmp_qloop_431*0.66666666666666663 + tmp_qloop_432*0.66666666666666663 + tmp_qloop_433*0.66666666666666663 + tmp_qloop_434;
                   const real_t tmp_qloop_439 = tmp_qloop_296 + tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438;
                   const real_t tmp_qloop_442 = tmp_qloop_431*2.0 + tmp_qloop_432*2.0 + tmp_qloop_433*2.0;
                   const real_t tmp_qloop_443 = tmp_qloop_142*tmp_qloop_442;
                   const real_t tmp_qloop_447 = tmp_qloop_151 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_448 = tmp_qloop_154*tmp_qloop_447 + tmp_qloop_443;
                   const real_t tmp_qloop_451 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 2];
                   const real_t tmp_qloop_452 = tmp_qloop_434 + tmp_qloop_449*0.66666666666666663 + tmp_qloop_450*0.66666666666666663 + tmp_qloop_451*0.66666666666666663;
                   const real_t tmp_qloop_456 = tmp_qloop_296 + tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455;
                   const real_t tmp_qloop_457 = tmp_qloop_449*2.0 + tmp_qloop_450*2.0 + tmp_qloop_451*2.0;
                   const real_t tmp_qloop_458 = tmp_qloop_142*tmp_qloop_457;
                   const real_t tmp_qloop_462 = tmp_qloop_151 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_463 = tmp_qloop_154*tmp_qloop_462 + tmp_qloop_458;
                   const real_t tmp_qloop_466 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 3];
                   const real_t tmp_qloop_467 = tmp_qloop_434 + tmp_qloop_464*0.66666666666666663 + tmp_qloop_465*0.66666666666666663 + tmp_qloop_466*0.66666666666666663;
                   const real_t tmp_qloop_471 = tmp_qloop_296 + tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470;
                   const real_t tmp_qloop_472 = tmp_qloop_464*2.0 + tmp_qloop_465*2.0 + tmp_qloop_466*2.0;
                   const real_t tmp_qloop_473 = tmp_qloop_142*tmp_qloop_472;
                   const real_t tmp_qloop_477 = tmp_qloop_151 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_478 = tmp_qloop_154*tmp_qloop_477 + tmp_qloop_473;
                   const real_t tmp_qloop_481 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 4];
                   const real_t tmp_qloop_482 = tmp_qloop_434 + tmp_qloop_479*0.66666666666666663 + tmp_qloop_480*0.66666666666666663 + tmp_qloop_481*0.66666666666666663;
                   const real_t tmp_qloop_486 = tmp_qloop_296 + tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485;
                   const real_t tmp_qloop_487 = tmp_qloop_479*2.0 + tmp_qloop_480*2.0 + tmp_qloop_481*2.0;
                   const real_t tmp_qloop_488 = tmp_qloop_142*tmp_qloop_487;
                   const real_t tmp_qloop_492 = tmp_qloop_151 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_493 = tmp_qloop_154*tmp_qloop_492 + tmp_qloop_488;
                   const real_t tmp_qloop_496 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 5];
                   const real_t tmp_qloop_497 = tmp_qloop_434 + tmp_qloop_494*0.66666666666666663 + tmp_qloop_495*0.66666666666666663 + tmp_qloop_496*0.66666666666666663;
                   const real_t tmp_qloop_501 = tmp_qloop_296 + tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500;
                   const real_t tmp_qloop_502 = tmp_qloop_494*2.0 + tmp_qloop_495*2.0 + tmp_qloop_496*2.0;
                   const real_t tmp_qloop_503 = tmp_qloop_142*tmp_qloop_502;
                   const real_t tmp_qloop_507 = tmp_qloop_151 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_508 = tmp_qloop_154*tmp_qloop_507 + tmp_qloop_503;
                   const real_t tmp_qloop_511 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 6];
                   const real_t tmp_qloop_512 = tmp_qloop_434 + tmp_qloop_509*0.66666666666666663 + tmp_qloop_510*0.66666666666666663 + tmp_qloop_511*0.66666666666666663;
                   const real_t tmp_qloop_516 = tmp_qloop_296 + tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515;
                   const real_t tmp_qloop_517 = tmp_qloop_509*2.0 + tmp_qloop_510*2.0 + tmp_qloop_511*2.0;
                   const real_t tmp_qloop_518 = tmp_qloop_142*tmp_qloop_517;
                   const real_t tmp_qloop_522 = tmp_qloop_151 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_523 = tmp_qloop_154*tmp_qloop_522 + tmp_qloop_518;
                   const real_t tmp_qloop_526 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 7];
                   const real_t tmp_qloop_527 = tmp_qloop_434 + tmp_qloop_524*0.66666666666666663 + tmp_qloop_525*0.66666666666666663 + tmp_qloop_526*0.66666666666666663;
                   const real_t tmp_qloop_531 = tmp_qloop_296 + tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530;
                   const real_t tmp_qloop_532 = tmp_qloop_524*2.0 + tmp_qloop_525*2.0 + tmp_qloop_526*2.0;
                   const real_t tmp_qloop_533 = tmp_qloop_142*tmp_qloop_532;
                   const real_t tmp_qloop_537 = tmp_qloop_151 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_538 = tmp_qloop_154*tmp_qloop_537 + tmp_qloop_533;
                   const real_t tmp_qloop_541 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 8];
                   const real_t tmp_qloop_542 = tmp_qloop_434 + tmp_qloop_539*0.66666666666666663 + tmp_qloop_540*0.66666666666666663 + tmp_qloop_541*0.66666666666666663;
                   const real_t tmp_qloop_546 = tmp_qloop_296 + tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545;
                   const real_t tmp_qloop_547 = tmp_qloop_539*2.0 + tmp_qloop_540*2.0 + tmp_qloop_541*2.0;
                   const real_t tmp_qloop_548 = tmp_qloop_142*tmp_qloop_547;
                   const real_t tmp_qloop_552 = tmp_qloop_151 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_553 = tmp_qloop_154*tmp_qloop_552 + tmp_qloop_548;
                   const real_t tmp_qloop_556 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 9];
                   const real_t tmp_qloop_557 = tmp_qloop_434 + tmp_qloop_554*0.66666666666666663 + tmp_qloop_555*0.66666666666666663 + tmp_qloop_556*0.66666666666666663;
                   const real_t tmp_qloop_561 = tmp_qloop_296 + tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560;
                   const real_t tmp_qloop_562 = tmp_qloop_554*2.0 + tmp_qloop_555*2.0 + tmp_qloop_556*2.0;
                   const real_t tmp_qloop_563 = tmp_qloop_142*tmp_qloop_562;
                   const real_t tmp_qloop_567 = tmp_qloop_151 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t tmp_qloop_568 = tmp_qloop_154*tmp_qloop_567 + tmp_qloop_563;
                   const real_t tmp_qloop_571 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[11*q + 10];
                   const real_t tmp_qloop_572 = tmp_qloop_434 + tmp_qloop_569*0.66666666666666663 + tmp_qloop_570*0.66666666666666663 + tmp_qloop_571*0.66666666666666663;
                   const real_t tmp_qloop_576 = tmp_qloop_296 + tmp_qloop_573 + tmp_qloop_574 + tmp_qloop_575;
                   const real_t tmp_qloop_577 = tmp_qloop_569*2.0 + tmp_qloop_570*2.0 + tmp_qloop_571*2.0;
                   const real_t tmp_qloop_578 = tmp_qloop_142*tmp_qloop_577;
                   const real_t tmp_qloop_582 = tmp_qloop_151 + tmp_qloop_579 + tmp_qloop_580 + tmp_qloop_581;
                   const real_t tmp_qloop_583 = tmp_qloop_154*tmp_qloop_582 + tmp_qloop_578;
                   const real_t tmp_qloop_584 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159);
                   const real_t tmp_qloop_587 = tmp_qloop_137*2.0 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_588 = tmp_qloop_143 + tmp_qloop_304;
                   const real_t tmp_qloop_590 = tmp_qloop_297*tmp_qloop_587 + tmp_qloop_589;
                   const real_t tmp_qloop_591 = tmp_qloop_143 + tmp_qloop_590;
                   const real_t tmp_qloop_592 = tmp_qloop_141 + tmp_qloop_448;
                   const real_t tmp_qloop_595 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172);
                   const real_t tmp_qloop_598 = tmp_qloop_137*2.0 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_600 = tmp_qloop_297*tmp_qloop_598 + tmp_qloop_599;
                   const real_t tmp_qloop_601 = tmp_qloop_143 + tmp_qloop_600;
                   const real_t tmp_qloop_604 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_183 + tmp_qloop_184 + tmp_qloop_185);
                   const real_t tmp_qloop_607 = tmp_qloop_137*2.0 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_609 = tmp_qloop_297*tmp_qloop_607 + tmp_qloop_608;
                   const real_t tmp_qloop_610 = tmp_qloop_143 + tmp_qloop_609;
                   const real_t tmp_qloop_613 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198);
                   const real_t tmp_qloop_616 = tmp_qloop_137*2.0 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_618 = tmp_qloop_297*tmp_qloop_616 + tmp_qloop_617;
                   const real_t tmp_qloop_619 = tmp_qloop_143 + tmp_qloop_618;
                   const real_t tmp_qloop_622 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211);
                   const real_t tmp_qloop_625 = tmp_qloop_137*2.0 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_627 = tmp_qloop_297*tmp_qloop_625 + tmp_qloop_626;
                   const real_t tmp_qloop_628 = tmp_qloop_143 + tmp_qloop_627;
                   const real_t tmp_qloop_631 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_222 + tmp_qloop_223 + tmp_qloop_224);
                   const real_t tmp_qloop_634 = tmp_qloop_137*2.0 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_636 = tmp_qloop_297*tmp_qloop_634 + tmp_qloop_635;
                   const real_t tmp_qloop_637 = tmp_qloop_143 + tmp_qloop_636;
                   const real_t tmp_qloop_640 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_235 + tmp_qloop_236 + tmp_qloop_237);
                   const real_t tmp_qloop_643 = tmp_qloop_137*2.0 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_645 = tmp_qloop_297*tmp_qloop_643 + tmp_qloop_644;
                   const real_t tmp_qloop_646 = tmp_qloop_143 + tmp_qloop_645;
                   const real_t tmp_qloop_649 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250);
                   const real_t tmp_qloop_652 = tmp_qloop_137*2.0 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_654 = tmp_qloop_297*tmp_qloop_652 + tmp_qloop_653;
                   const real_t tmp_qloop_655 = tmp_qloop_143 + tmp_qloop_654;
                   const real_t tmp_qloop_658 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263);
                   const real_t tmp_qloop_661 = tmp_qloop_137*2.0 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_663 = tmp_qloop_297*tmp_qloop_661 + tmp_qloop_662;
                   const real_t tmp_qloop_664 = tmp_qloop_143 + tmp_qloop_663;
                   const real_t tmp_qloop_668 = tmp_qloop_115 + tmp_qloop_667;
                   const real_t tmp_qloop_669 = tmp_qloop_118*(tmp_qloop_274 + tmp_qloop_275 + tmp_qloop_276 + tmp_qloop_668);
                   const real_t tmp_qloop_673 = tmp_qloop_152*2.0 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_675 = tmp_qloop_293*0.5 + tmp_qloop_294*0.5 + tmp_qloop_295*0.5;
                   const real_t tmp_qloop_676 = tmp_qloop_137*2.0 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_677 = tmp_qloop_143 + tmp_qloop_297*tmp_qloop_676 + tmp_qloop_674;
                   const real_t tmp_qloop_679 = tmp_qloop_439*tmp_qloop_676 + tmp_qloop_443;
                   const real_t tmp_qloop_680 = tmp_qloop_456*tmp_qloop_676 + tmp_qloop_458;
                   const real_t tmp_qloop_681 = tmp_qloop_471*tmp_qloop_676 + tmp_qloop_473;
                   const real_t tmp_qloop_682 = tmp_qloop_486*tmp_qloop_676 + tmp_qloop_488;
                   const real_t tmp_qloop_683 = tmp_qloop_501*tmp_qloop_676 + tmp_qloop_503;
                   const real_t tmp_qloop_684 = tmp_qloop_516*tmp_qloop_676 + tmp_qloop_518;
                   const real_t tmp_qloop_685 = tmp_qloop_531*tmp_qloop_676 + tmp_qloop_533;
                   const real_t tmp_qloop_686 = tmp_qloop_546*tmp_qloop_676 + tmp_qloop_548;
                   const real_t tmp_qloop_687 = tmp_qloop_561*tmp_qloop_676 + tmp_qloop_563;
                   const real_t tmp_qloop_688 = tmp_qloop_576*tmp_qloop_676 + tmp_qloop_578;
                   const real_t tmp_qloop_689 = tmp_qloop_118*(tmp_qloop_305 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_668);
                   const real_t tmp_qloop_692 = tmp_qloop_152*2.0 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_693 = tmp_qloop_674 + tmp_qloop_679;
                   const real_t tmp_qloop_696 = tmp_qloop_118*(tmp_qloop_319 + tmp_qloop_320 + tmp_qloop_321 + tmp_qloop_668);
                   const real_t tmp_qloop_699 = tmp_qloop_152*2.0 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_702 = tmp_qloop_118*(tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335 + tmp_qloop_668);
                   const real_t tmp_qloop_705 = tmp_qloop_152*2.0 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_708 = tmp_qloop_118*(tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349 + tmp_qloop_668);
                   const real_t tmp_qloop_711 = tmp_qloop_152*2.0 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_714 = tmp_qloop_118*(tmp_qloop_361 + tmp_qloop_362 + tmp_qloop_363 + tmp_qloop_668);
                   const real_t tmp_qloop_717 = tmp_qloop_152*2.0 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_720 = tmp_qloop_118*(tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377 + tmp_qloop_668);
                   const real_t tmp_qloop_723 = tmp_qloop_152*2.0 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_726 = tmp_qloop_118*(tmp_qloop_389 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_668);
                   const real_t tmp_qloop_729 = tmp_qloop_152*2.0 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_732 = tmp_qloop_118*(tmp_qloop_403 + tmp_qloop_404 + tmp_qloop_405 + tmp_qloop_668);
                   const real_t tmp_qloop_735 = tmp_qloop_152*2.0 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_738 = tmp_qloop_118*(tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419 + tmp_qloop_668);
                   const real_t tmp_qloop_741 = tmp_qloop_152*2.0 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_745 = tmp_qloop_118*(tmp_qloop_431 + tmp_qloop_432 + tmp_qloop_433 + tmp_qloop_744);
                   const real_t tmp_qloop_746 = tmp_qloop_431*1.0 + tmp_qloop_432*1.0 + tmp_qloop_433*1.0;
                   const real_t tmp_qloop_747 = tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_748 = tmp_qloop_153*2.0 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_750 = tmp_qloop_118*(tmp_qloop_449 + tmp_qloop_450 + tmp_qloop_451 + tmp_qloop_744);
                   const real_t tmp_qloop_751 = tmp_qloop_449*1.0 + tmp_qloop_450*1.0 + tmp_qloop_451*1.0;
                   const real_t tmp_qloop_752 = tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_753 = tmp_qloop_153*2.0 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_754 = tmp_qloop_118*(tmp_qloop_464 + tmp_qloop_465 + tmp_qloop_466 + tmp_qloop_744);
                   const real_t tmp_qloop_755 = tmp_qloop_464*1.0 + tmp_qloop_465*1.0 + tmp_qloop_466*1.0;
                   const real_t tmp_qloop_756 = tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_757 = tmp_qloop_153*2.0 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_758 = tmp_qloop_118*(tmp_qloop_479 + tmp_qloop_480 + tmp_qloop_481 + tmp_qloop_744);
                   const real_t tmp_qloop_759 = tmp_qloop_479*1.0 + tmp_qloop_480*1.0 + tmp_qloop_481*1.0;
                   const real_t tmp_qloop_760 = tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_761 = tmp_qloop_153*2.0 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_762 = tmp_qloop_118*(tmp_qloop_494 + tmp_qloop_495 + tmp_qloop_496 + tmp_qloop_744);
                   const real_t tmp_qloop_763 = tmp_qloop_494*1.0 + tmp_qloop_495*1.0 + tmp_qloop_496*1.0;
                   const real_t tmp_qloop_764 = tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_765 = tmp_qloop_153*2.0 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_766 = tmp_qloop_118*(tmp_qloop_509 + tmp_qloop_510 + tmp_qloop_511 + tmp_qloop_744);
                   const real_t tmp_qloop_767 = tmp_qloop_509*1.0 + tmp_qloop_510*1.0 + tmp_qloop_511*1.0;
                   const real_t tmp_qloop_768 = tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_769 = tmp_qloop_153*2.0 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_770 = tmp_qloop_118*(tmp_qloop_524 + tmp_qloop_525 + tmp_qloop_526 + tmp_qloop_744);
                   const real_t tmp_qloop_771 = tmp_qloop_524*1.0 + tmp_qloop_525*1.0 + tmp_qloop_526*1.0;
                   const real_t tmp_qloop_772 = tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_773 = tmp_qloop_153*2.0 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_774 = tmp_qloop_118*(tmp_qloop_539 + tmp_qloop_540 + tmp_qloop_541 + tmp_qloop_744);
                   const real_t tmp_qloop_775 = tmp_qloop_539*1.0 + tmp_qloop_540*1.0 + tmp_qloop_541*1.0;
                   const real_t tmp_qloop_776 = tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_777 = tmp_qloop_153*2.0 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_778 = tmp_qloop_118*(tmp_qloop_554 + tmp_qloop_555 + tmp_qloop_556 + tmp_qloop_744);
                   const real_t tmp_qloop_779 = tmp_qloop_554*1.0 + tmp_qloop_555*1.0 + tmp_qloop_556*1.0;
                   const real_t tmp_qloop_780 = tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_781 = tmp_qloop_153*2.0 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + tmp_qloop_129*(tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_127) + tmp_qloop_138*(tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_136) + tmp_qloop_155) - tmp_qloop_119*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_114));
                   const real_t q_tmp_0_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_161 + tmp_qloop_129*tmp_qloop_165 + tmp_qloop_138*tmp_qloop_169 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_160);
                   const real_t q_tmp_0_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_174 + tmp_qloop_129*tmp_qloop_178 + tmp_qloop_138*tmp_qloop_182 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_173);
                   const real_t q_tmp_0_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_187 + tmp_qloop_129*tmp_qloop_191 + tmp_qloop_138*tmp_qloop_195 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_186);
                   const real_t q_tmp_0_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_200 + tmp_qloop_129*tmp_qloop_204 + tmp_qloop_138*tmp_qloop_208 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_199);
                   const real_t q_tmp_0_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_213 + tmp_qloop_129*tmp_qloop_217 + tmp_qloop_138*tmp_qloop_221 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_212);
                   const real_t q_tmp_0_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_226 + tmp_qloop_129*tmp_qloop_230 + tmp_qloop_138*tmp_qloop_234 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_225);
                   const real_t q_tmp_0_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_239 + tmp_qloop_129*tmp_qloop_243 + tmp_qloop_138*tmp_qloop_247 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_238);
                   const real_t q_tmp_0_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_252 + tmp_qloop_129*tmp_qloop_256 + tmp_qloop_138*tmp_qloop_260 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_251);
                   const real_t q_tmp_0_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_265 + tmp_qloop_129*tmp_qloop_269 + tmp_qloop_138*tmp_qloop_273 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_264);
                   const real_t q_tmp_0_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_290 + tmp_qloop_298 + tmp_qloop_304) - tmp_qloop_119*tmp_qloop_282);
                   const real_t q_tmp_0_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_312 + tmp_qloop_298 + tmp_qloop_318) - tmp_qloop_119*tmp_qloop_308);
                   const real_t q_tmp_0_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_326 + tmp_qloop_298 + tmp_qloop_332) - tmp_qloop_119*tmp_qloop_322);
                   const real_t q_tmp_0_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_340 + tmp_qloop_298 + tmp_qloop_346) - tmp_qloop_119*tmp_qloop_336);
                   const real_t q_tmp_0_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_354 + tmp_qloop_298 + tmp_qloop_360) - tmp_qloop_119*tmp_qloop_350);
                   const real_t q_tmp_0_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_368 + tmp_qloop_298 + tmp_qloop_374) - tmp_qloop_119*tmp_qloop_364);
                   const real_t q_tmp_0_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_382 + tmp_qloop_298 + tmp_qloop_388) - tmp_qloop_119*tmp_qloop_378);
                   const real_t q_tmp_0_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_396 + tmp_qloop_298 + tmp_qloop_402) - tmp_qloop_119*tmp_qloop_392);
                   const real_t q_tmp_0_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_410 + tmp_qloop_298 + tmp_qloop_416) - tmp_qloop_119*tmp_qloop_406);
                   const real_t q_tmp_0_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_424 + tmp_qloop_298 + tmp_qloop_430) - tmp_qloop_119*tmp_qloop_420);
                   const real_t q_tmp_0_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_439 + tmp_qloop_441 + tmp_qloop_448) - tmp_qloop_119*tmp_qloop_435);
                   const real_t q_tmp_0_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_456 + tmp_qloop_441 + tmp_qloop_463) - tmp_qloop_119*tmp_qloop_452);
                   const real_t q_tmp_0_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_471 + tmp_qloop_441 + tmp_qloop_478) - tmp_qloop_119*tmp_qloop_467);
                   const real_t q_tmp_0_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_486 + tmp_qloop_441 + tmp_qloop_493) - tmp_qloop_119*tmp_qloop_482);
                   const real_t q_tmp_0_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_501 + tmp_qloop_441 + tmp_qloop_508) - tmp_qloop_119*tmp_qloop_497);
                   const real_t q_tmp_0_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_516 + tmp_qloop_441 + tmp_qloop_523) - tmp_qloop_119*tmp_qloop_512);
                   const real_t q_tmp_0_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_531 + tmp_qloop_441 + tmp_qloop_538) - tmp_qloop_119*tmp_qloop_527);
                   const real_t q_tmp_0_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_546 + tmp_qloop_441 + tmp_qloop_553) - tmp_qloop_119*tmp_qloop_542);
                   const real_t q_tmp_0_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_561 + tmp_qloop_441 + tmp_qloop_568) - tmp_qloop_119*tmp_qloop_557);
                   const real_t q_tmp_0_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_576 + tmp_qloop_441 + tmp_qloop_583) - tmp_qloop_119*tmp_qloop_572);
                   const real_t q_tmp_1_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_161*tmp_qloop_585 + tmp_qloop_165*tmp_qloop_586 + tmp_qloop_169*tmp_qloop_587) - tmp_qloop_160*tmp_qloop_584);
                   const real_t q_tmp_1_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_585 + tmp_qloop_178*tmp_qloop_586 + tmp_qloop_182*tmp_qloop_587) - tmp_qloop_173*tmp_qloop_584);
                   const real_t q_tmp_1_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_585 + tmp_qloop_191*tmp_qloop_586 + tmp_qloop_195*tmp_qloop_587) - tmp_qloop_186*tmp_qloop_584);
                   const real_t q_tmp_1_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_585 + tmp_qloop_204*tmp_qloop_586 + tmp_qloop_208*tmp_qloop_587) - tmp_qloop_199*tmp_qloop_584);
                   const real_t q_tmp_1_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_585 + tmp_qloop_217*tmp_qloop_586 + tmp_qloop_221*tmp_qloop_587) - tmp_qloop_212*tmp_qloop_584);
                   const real_t q_tmp_1_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_585 + tmp_qloop_230*tmp_qloop_586 + tmp_qloop_234*tmp_qloop_587) - tmp_qloop_225*tmp_qloop_584);
                   const real_t q_tmp_1_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_585 + tmp_qloop_243*tmp_qloop_586 + tmp_qloop_247*tmp_qloop_587) - tmp_qloop_238*tmp_qloop_584);
                   const real_t q_tmp_1_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_585 + tmp_qloop_256*tmp_qloop_586 + tmp_qloop_260*tmp_qloop_587) - tmp_qloop_251*tmp_qloop_584);
                   const real_t q_tmp_1_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_585 + tmp_qloop_269*tmp_qloop_586 + tmp_qloop_273*tmp_qloop_587) - tmp_qloop_264*tmp_qloop_584);
                   const real_t q_tmp_1_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_586 + tmp_qloop_588 + tmp_qloop_590) - tmp_qloop_282*tmp_qloop_584);
                   const real_t q_tmp_1_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_586 + tmp_qloop_318 + tmp_qloop_591) - tmp_qloop_308*tmp_qloop_584);
                   const real_t q_tmp_1_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_586 + tmp_qloop_332 + tmp_qloop_591) - tmp_qloop_322*tmp_qloop_584);
                   const real_t q_tmp_1_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_586 + tmp_qloop_346 + tmp_qloop_591) - tmp_qloop_336*tmp_qloop_584);
                   const real_t q_tmp_1_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_586 + tmp_qloop_360 + tmp_qloop_591) - tmp_qloop_350*tmp_qloop_584);
                   const real_t q_tmp_1_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_586 + tmp_qloop_374 + tmp_qloop_591) - tmp_qloop_364*tmp_qloop_584);
                   const real_t q_tmp_1_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_586 + tmp_qloop_388 + tmp_qloop_591) - tmp_qloop_378*tmp_qloop_584);
                   const real_t q_tmp_1_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_586 + tmp_qloop_402 + tmp_qloop_591) - tmp_qloop_392*tmp_qloop_584);
                   const real_t q_tmp_1_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_586 + tmp_qloop_416 + tmp_qloop_591) - tmp_qloop_406*tmp_qloop_584);
                   const real_t q_tmp_1_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_586 + tmp_qloop_430 + tmp_qloop_591) - tmp_qloop_420*tmp_qloop_584);
                   const real_t q_tmp_1_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_587 + tmp_qloop_592 + tmp_qloop_593) - tmp_qloop_435*tmp_qloop_584);
                   const real_t q_tmp_1_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_587 + tmp_qloop_463 + tmp_qloop_594) - tmp_qloop_452*tmp_qloop_584);
                   const real_t q_tmp_1_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_587 + tmp_qloop_478 + tmp_qloop_594) - tmp_qloop_467*tmp_qloop_584);
                   const real_t q_tmp_1_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_587 + tmp_qloop_493 + tmp_qloop_594) - tmp_qloop_482*tmp_qloop_584);
                   const real_t q_tmp_1_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_587 + tmp_qloop_508 + tmp_qloop_594) - tmp_qloop_497*tmp_qloop_584);
                   const real_t q_tmp_1_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_587 + tmp_qloop_523 + tmp_qloop_594) - tmp_qloop_512*tmp_qloop_584);
                   const real_t q_tmp_1_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_587 + tmp_qloop_538 + tmp_qloop_594) - tmp_qloop_527*tmp_qloop_584);
                   const real_t q_tmp_1_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_587 + tmp_qloop_553 + tmp_qloop_594) - tmp_qloop_542*tmp_qloop_584);
                   const real_t q_tmp_1_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_587 + tmp_qloop_568 + tmp_qloop_594) - tmp_qloop_557*tmp_qloop_584);
                   const real_t q_tmp_1_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_587 + tmp_qloop_583 + tmp_qloop_594) - tmp_qloop_572*tmp_qloop_584);
                   const real_t q_tmp_2_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_596 + tmp_qloop_178*tmp_qloop_597 + tmp_qloop_182*tmp_qloop_598) - tmp_qloop_173*tmp_qloop_595);
                   const real_t q_tmp_2_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_596 + tmp_qloop_191*tmp_qloop_597 + tmp_qloop_195*tmp_qloop_598) - tmp_qloop_186*tmp_qloop_595);
                   const real_t q_tmp_2_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_596 + tmp_qloop_204*tmp_qloop_597 + tmp_qloop_208*tmp_qloop_598) - tmp_qloop_199*tmp_qloop_595);
                   const real_t q_tmp_2_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_596 + tmp_qloop_217*tmp_qloop_597 + tmp_qloop_221*tmp_qloop_598) - tmp_qloop_212*tmp_qloop_595);
                   const real_t q_tmp_2_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_596 + tmp_qloop_230*tmp_qloop_597 + tmp_qloop_234*tmp_qloop_598) - tmp_qloop_225*tmp_qloop_595);
                   const real_t q_tmp_2_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_596 + tmp_qloop_243*tmp_qloop_597 + tmp_qloop_247*tmp_qloop_598) - tmp_qloop_238*tmp_qloop_595);
                   const real_t q_tmp_2_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_596 + tmp_qloop_256*tmp_qloop_597 + tmp_qloop_260*tmp_qloop_598) - tmp_qloop_251*tmp_qloop_595);
                   const real_t q_tmp_2_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_596 + tmp_qloop_269*tmp_qloop_597 + tmp_qloop_273*tmp_qloop_598) - tmp_qloop_264*tmp_qloop_595);
                   const real_t q_tmp_2_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_597 + tmp_qloop_588 + tmp_qloop_600) - tmp_qloop_282*tmp_qloop_595);
                   const real_t q_tmp_2_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_597 + tmp_qloop_318 + tmp_qloop_601) - tmp_qloop_308*tmp_qloop_595);
                   const real_t q_tmp_2_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_597 + tmp_qloop_332 + tmp_qloop_601) - tmp_qloop_322*tmp_qloop_595);
                   const real_t q_tmp_2_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_597 + tmp_qloop_346 + tmp_qloop_601) - tmp_qloop_336*tmp_qloop_595);
                   const real_t q_tmp_2_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_597 + tmp_qloop_360 + tmp_qloop_601) - tmp_qloop_350*tmp_qloop_595);
                   const real_t q_tmp_2_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_597 + tmp_qloop_374 + tmp_qloop_601) - tmp_qloop_364*tmp_qloop_595);
                   const real_t q_tmp_2_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_597 + tmp_qloop_388 + tmp_qloop_601) - tmp_qloop_378*tmp_qloop_595);
                   const real_t q_tmp_2_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_597 + tmp_qloop_402 + tmp_qloop_601) - tmp_qloop_392*tmp_qloop_595);
                   const real_t q_tmp_2_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_597 + tmp_qloop_416 + tmp_qloop_601) - tmp_qloop_406*tmp_qloop_595);
                   const real_t q_tmp_2_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_597 + tmp_qloop_430 + tmp_qloop_601) - tmp_qloop_420*tmp_qloop_595);
                   const real_t q_tmp_2_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_598 + tmp_qloop_592 + tmp_qloop_602) - tmp_qloop_435*tmp_qloop_595);
                   const real_t q_tmp_2_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_598 + tmp_qloop_463 + tmp_qloop_603) - tmp_qloop_452*tmp_qloop_595);
                   const real_t q_tmp_2_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_598 + tmp_qloop_478 + tmp_qloop_603) - tmp_qloop_467*tmp_qloop_595);
                   const real_t q_tmp_2_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_598 + tmp_qloop_493 + tmp_qloop_603) - tmp_qloop_482*tmp_qloop_595);
                   const real_t q_tmp_2_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_598 + tmp_qloop_508 + tmp_qloop_603) - tmp_qloop_497*tmp_qloop_595);
                   const real_t q_tmp_2_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_598 + tmp_qloop_523 + tmp_qloop_603) - tmp_qloop_512*tmp_qloop_595);
                   const real_t q_tmp_2_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_598 + tmp_qloop_538 + tmp_qloop_603) - tmp_qloop_527*tmp_qloop_595);
                   const real_t q_tmp_2_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_598 + tmp_qloop_553 + tmp_qloop_603) - tmp_qloop_542*tmp_qloop_595);
                   const real_t q_tmp_2_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_598 + tmp_qloop_568 + tmp_qloop_603) - tmp_qloop_557*tmp_qloop_595);
                   const real_t q_tmp_2_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_598 + tmp_qloop_583 + tmp_qloop_603) - tmp_qloop_572*tmp_qloop_595);
                   const real_t q_tmp_3_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_605 + tmp_qloop_191*tmp_qloop_606 + tmp_qloop_195*tmp_qloop_607) - tmp_qloop_186*tmp_qloop_604);
                   const real_t q_tmp_3_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_605 + tmp_qloop_204*tmp_qloop_606 + tmp_qloop_208*tmp_qloop_607) - tmp_qloop_199*tmp_qloop_604);
                   const real_t q_tmp_3_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_605 + tmp_qloop_217*tmp_qloop_606 + tmp_qloop_221*tmp_qloop_607) - tmp_qloop_212*tmp_qloop_604);
                   const real_t q_tmp_3_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_605 + tmp_qloop_230*tmp_qloop_606 + tmp_qloop_234*tmp_qloop_607) - tmp_qloop_225*tmp_qloop_604);
                   const real_t q_tmp_3_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_605 + tmp_qloop_243*tmp_qloop_606 + tmp_qloop_247*tmp_qloop_607) - tmp_qloop_238*tmp_qloop_604);
                   const real_t q_tmp_3_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_605 + tmp_qloop_256*tmp_qloop_606 + tmp_qloop_260*tmp_qloop_607) - tmp_qloop_251*tmp_qloop_604);
                   const real_t q_tmp_3_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_605 + tmp_qloop_269*tmp_qloop_606 + tmp_qloop_273*tmp_qloop_607) - tmp_qloop_264*tmp_qloop_604);
                   const real_t q_tmp_3_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_606 + tmp_qloop_588 + tmp_qloop_609) - tmp_qloop_282*tmp_qloop_604);
                   const real_t q_tmp_3_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_606 + tmp_qloop_318 + tmp_qloop_610) - tmp_qloop_308*tmp_qloop_604);
                   const real_t q_tmp_3_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_606 + tmp_qloop_332 + tmp_qloop_610) - tmp_qloop_322*tmp_qloop_604);
                   const real_t q_tmp_3_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_606 + tmp_qloop_346 + tmp_qloop_610) - tmp_qloop_336*tmp_qloop_604);
                   const real_t q_tmp_3_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_606 + tmp_qloop_360 + tmp_qloop_610) - tmp_qloop_350*tmp_qloop_604);
                   const real_t q_tmp_3_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_606 + tmp_qloop_374 + tmp_qloop_610) - tmp_qloop_364*tmp_qloop_604);
                   const real_t q_tmp_3_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_606 + tmp_qloop_388 + tmp_qloop_610) - tmp_qloop_378*tmp_qloop_604);
                   const real_t q_tmp_3_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_606 + tmp_qloop_402 + tmp_qloop_610) - tmp_qloop_392*tmp_qloop_604);
                   const real_t q_tmp_3_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_606 + tmp_qloop_416 + tmp_qloop_610) - tmp_qloop_406*tmp_qloop_604);
                   const real_t q_tmp_3_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_606 + tmp_qloop_430 + tmp_qloop_610) - tmp_qloop_420*tmp_qloop_604);
                   const real_t q_tmp_3_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_607 + tmp_qloop_592 + tmp_qloop_611) - tmp_qloop_435*tmp_qloop_604);
                   const real_t q_tmp_3_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_607 + tmp_qloop_463 + tmp_qloop_612) - tmp_qloop_452*tmp_qloop_604);
                   const real_t q_tmp_3_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_607 + tmp_qloop_478 + tmp_qloop_612) - tmp_qloop_467*tmp_qloop_604);
                   const real_t q_tmp_3_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_607 + tmp_qloop_493 + tmp_qloop_612) - tmp_qloop_482*tmp_qloop_604);
                   const real_t q_tmp_3_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_607 + tmp_qloop_508 + tmp_qloop_612) - tmp_qloop_497*tmp_qloop_604);
                   const real_t q_tmp_3_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_607 + tmp_qloop_523 + tmp_qloop_612) - tmp_qloop_512*tmp_qloop_604);
                   const real_t q_tmp_3_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_607 + tmp_qloop_538 + tmp_qloop_612) - tmp_qloop_527*tmp_qloop_604);
                   const real_t q_tmp_3_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_607 + tmp_qloop_553 + tmp_qloop_612) - tmp_qloop_542*tmp_qloop_604);
                   const real_t q_tmp_3_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_607 + tmp_qloop_568 + tmp_qloop_612) - tmp_qloop_557*tmp_qloop_604);
                   const real_t q_tmp_3_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_607 + tmp_qloop_583 + tmp_qloop_612) - tmp_qloop_572*tmp_qloop_604);
                   const real_t q_tmp_4_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_614 + tmp_qloop_204*tmp_qloop_615 + tmp_qloop_208*tmp_qloop_616) - tmp_qloop_199*tmp_qloop_613);
                   const real_t q_tmp_4_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_614 + tmp_qloop_217*tmp_qloop_615 + tmp_qloop_221*tmp_qloop_616) - tmp_qloop_212*tmp_qloop_613);
                   const real_t q_tmp_4_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_614 + tmp_qloop_230*tmp_qloop_615 + tmp_qloop_234*tmp_qloop_616) - tmp_qloop_225*tmp_qloop_613);
                   const real_t q_tmp_4_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_614 + tmp_qloop_243*tmp_qloop_615 + tmp_qloop_247*tmp_qloop_616) - tmp_qloop_238*tmp_qloop_613);
                   const real_t q_tmp_4_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_614 + tmp_qloop_256*tmp_qloop_615 + tmp_qloop_260*tmp_qloop_616) - tmp_qloop_251*tmp_qloop_613);
                   const real_t q_tmp_4_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_614 + tmp_qloop_269*tmp_qloop_615 + tmp_qloop_273*tmp_qloop_616) - tmp_qloop_264*tmp_qloop_613);
                   const real_t q_tmp_4_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_615 + tmp_qloop_588 + tmp_qloop_618) - tmp_qloop_282*tmp_qloop_613);
                   const real_t q_tmp_4_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_615 + tmp_qloop_318 + tmp_qloop_619) - tmp_qloop_308*tmp_qloop_613);
                   const real_t q_tmp_4_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_615 + tmp_qloop_332 + tmp_qloop_619) - tmp_qloop_322*tmp_qloop_613);
                   const real_t q_tmp_4_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_615 + tmp_qloop_346 + tmp_qloop_619) - tmp_qloop_336*tmp_qloop_613);
                   const real_t q_tmp_4_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_615 + tmp_qloop_360 + tmp_qloop_619) - tmp_qloop_350*tmp_qloop_613);
                   const real_t q_tmp_4_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_615 + tmp_qloop_374 + tmp_qloop_619) - tmp_qloop_364*tmp_qloop_613);
                   const real_t q_tmp_4_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_615 + tmp_qloop_388 + tmp_qloop_619) - tmp_qloop_378*tmp_qloop_613);
                   const real_t q_tmp_4_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_615 + tmp_qloop_402 + tmp_qloop_619) - tmp_qloop_392*tmp_qloop_613);
                   const real_t q_tmp_4_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_615 + tmp_qloop_416 + tmp_qloop_619) - tmp_qloop_406*tmp_qloop_613);
                   const real_t q_tmp_4_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_615 + tmp_qloop_430 + tmp_qloop_619) - tmp_qloop_420*tmp_qloop_613);
                   const real_t q_tmp_4_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_616 + tmp_qloop_592 + tmp_qloop_620) - tmp_qloop_435*tmp_qloop_613);
                   const real_t q_tmp_4_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_616 + tmp_qloop_463 + tmp_qloop_621) - tmp_qloop_452*tmp_qloop_613);
                   const real_t q_tmp_4_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_616 + tmp_qloop_478 + tmp_qloop_621) - tmp_qloop_467*tmp_qloop_613);
                   const real_t q_tmp_4_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_616 + tmp_qloop_493 + tmp_qloop_621) - tmp_qloop_482*tmp_qloop_613);
                   const real_t q_tmp_4_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_616 + tmp_qloop_508 + tmp_qloop_621) - tmp_qloop_497*tmp_qloop_613);
                   const real_t q_tmp_4_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_616 + tmp_qloop_523 + tmp_qloop_621) - tmp_qloop_512*tmp_qloop_613);
                   const real_t q_tmp_4_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_616 + tmp_qloop_538 + tmp_qloop_621) - tmp_qloop_527*tmp_qloop_613);
                   const real_t q_tmp_4_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_616 + tmp_qloop_553 + tmp_qloop_621) - tmp_qloop_542*tmp_qloop_613);
                   const real_t q_tmp_4_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_616 + tmp_qloop_568 + tmp_qloop_621) - tmp_qloop_557*tmp_qloop_613);
                   const real_t q_tmp_4_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_616 + tmp_qloop_583 + tmp_qloop_621) - tmp_qloop_572*tmp_qloop_613);
                   const real_t q_tmp_5_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_623 + tmp_qloop_217*tmp_qloop_624 + tmp_qloop_221*tmp_qloop_625) - tmp_qloop_212*tmp_qloop_622);
                   const real_t q_tmp_5_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_623 + tmp_qloop_230*tmp_qloop_624 + tmp_qloop_234*tmp_qloop_625) - tmp_qloop_225*tmp_qloop_622);
                   const real_t q_tmp_5_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_623 + tmp_qloop_243*tmp_qloop_624 + tmp_qloop_247*tmp_qloop_625) - tmp_qloop_238*tmp_qloop_622);
                   const real_t q_tmp_5_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_623 + tmp_qloop_256*tmp_qloop_624 + tmp_qloop_260*tmp_qloop_625) - tmp_qloop_251*tmp_qloop_622);
                   const real_t q_tmp_5_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_623 + tmp_qloop_269*tmp_qloop_624 + tmp_qloop_273*tmp_qloop_625) - tmp_qloop_264*tmp_qloop_622);
                   const real_t q_tmp_5_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_624 + tmp_qloop_588 + tmp_qloop_627) - tmp_qloop_282*tmp_qloop_622);
                   const real_t q_tmp_5_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_624 + tmp_qloop_318 + tmp_qloop_628) - tmp_qloop_308*tmp_qloop_622);
                   const real_t q_tmp_5_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_624 + tmp_qloop_332 + tmp_qloop_628) - tmp_qloop_322*tmp_qloop_622);
                   const real_t q_tmp_5_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_624 + tmp_qloop_346 + tmp_qloop_628) - tmp_qloop_336*tmp_qloop_622);
                   const real_t q_tmp_5_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_624 + tmp_qloop_360 + tmp_qloop_628) - tmp_qloop_350*tmp_qloop_622);
                   const real_t q_tmp_5_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_624 + tmp_qloop_374 + tmp_qloop_628) - tmp_qloop_364*tmp_qloop_622);
                   const real_t q_tmp_5_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_624 + tmp_qloop_388 + tmp_qloop_628) - tmp_qloop_378*tmp_qloop_622);
                   const real_t q_tmp_5_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_624 + tmp_qloop_402 + tmp_qloop_628) - tmp_qloop_392*tmp_qloop_622);
                   const real_t q_tmp_5_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_624 + tmp_qloop_416 + tmp_qloop_628) - tmp_qloop_406*tmp_qloop_622);
                   const real_t q_tmp_5_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_624 + tmp_qloop_430 + tmp_qloop_628) - tmp_qloop_420*tmp_qloop_622);
                   const real_t q_tmp_5_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_625 + tmp_qloop_592 + tmp_qloop_629) - tmp_qloop_435*tmp_qloop_622);
                   const real_t q_tmp_5_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_625 + tmp_qloop_463 + tmp_qloop_630) - tmp_qloop_452*tmp_qloop_622);
                   const real_t q_tmp_5_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_625 + tmp_qloop_478 + tmp_qloop_630) - tmp_qloop_467*tmp_qloop_622);
                   const real_t q_tmp_5_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_625 + tmp_qloop_493 + tmp_qloop_630) - tmp_qloop_482*tmp_qloop_622);
                   const real_t q_tmp_5_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_625 + tmp_qloop_508 + tmp_qloop_630) - tmp_qloop_497*tmp_qloop_622);
                   const real_t q_tmp_5_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_625 + tmp_qloop_523 + tmp_qloop_630) - tmp_qloop_512*tmp_qloop_622);
                   const real_t q_tmp_5_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_625 + tmp_qloop_538 + tmp_qloop_630) - tmp_qloop_527*tmp_qloop_622);
                   const real_t q_tmp_5_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_625 + tmp_qloop_553 + tmp_qloop_630) - tmp_qloop_542*tmp_qloop_622);
                   const real_t q_tmp_5_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_625 + tmp_qloop_568 + tmp_qloop_630) - tmp_qloop_557*tmp_qloop_622);
                   const real_t q_tmp_5_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_625 + tmp_qloop_583 + tmp_qloop_630) - tmp_qloop_572*tmp_qloop_622);
                   const real_t q_tmp_6_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_632 + tmp_qloop_230*tmp_qloop_633 + tmp_qloop_234*tmp_qloop_634) - tmp_qloop_225*tmp_qloop_631);
                   const real_t q_tmp_6_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_632 + tmp_qloop_243*tmp_qloop_633 + tmp_qloop_247*tmp_qloop_634) - tmp_qloop_238*tmp_qloop_631);
                   const real_t q_tmp_6_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_632 + tmp_qloop_256*tmp_qloop_633 + tmp_qloop_260*tmp_qloop_634) - tmp_qloop_251*tmp_qloop_631);
                   const real_t q_tmp_6_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_632 + tmp_qloop_269*tmp_qloop_633 + tmp_qloop_273*tmp_qloop_634) - tmp_qloop_264*tmp_qloop_631);
                   const real_t q_tmp_6_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_633 + tmp_qloop_588 + tmp_qloop_636) - tmp_qloop_282*tmp_qloop_631);
                   const real_t q_tmp_6_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_633 + tmp_qloop_318 + tmp_qloop_637) - tmp_qloop_308*tmp_qloop_631);
                   const real_t q_tmp_6_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_633 + tmp_qloop_332 + tmp_qloop_637) - tmp_qloop_322*tmp_qloop_631);
                   const real_t q_tmp_6_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_633 + tmp_qloop_346 + tmp_qloop_637) - tmp_qloop_336*tmp_qloop_631);
                   const real_t q_tmp_6_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_633 + tmp_qloop_360 + tmp_qloop_637) - tmp_qloop_350*tmp_qloop_631);
                   const real_t q_tmp_6_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_633 + tmp_qloop_374 + tmp_qloop_637) - tmp_qloop_364*tmp_qloop_631);
                   const real_t q_tmp_6_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_633 + tmp_qloop_388 + tmp_qloop_637) - tmp_qloop_378*tmp_qloop_631);
                   const real_t q_tmp_6_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_633 + tmp_qloop_402 + tmp_qloop_637) - tmp_qloop_392*tmp_qloop_631);
                   const real_t q_tmp_6_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_633 + tmp_qloop_416 + tmp_qloop_637) - tmp_qloop_406*tmp_qloop_631);
                   const real_t q_tmp_6_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_633 + tmp_qloop_430 + tmp_qloop_637) - tmp_qloop_420*tmp_qloop_631);
                   const real_t q_tmp_6_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_634 + tmp_qloop_592 + tmp_qloop_638) - tmp_qloop_435*tmp_qloop_631);
                   const real_t q_tmp_6_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_634 + tmp_qloop_463 + tmp_qloop_639) - tmp_qloop_452*tmp_qloop_631);
                   const real_t q_tmp_6_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_634 + tmp_qloop_478 + tmp_qloop_639) - tmp_qloop_467*tmp_qloop_631);
                   const real_t q_tmp_6_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_634 + tmp_qloop_493 + tmp_qloop_639) - tmp_qloop_482*tmp_qloop_631);
                   const real_t q_tmp_6_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_634 + tmp_qloop_508 + tmp_qloop_639) - tmp_qloop_497*tmp_qloop_631);
                   const real_t q_tmp_6_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_634 + tmp_qloop_523 + tmp_qloop_639) - tmp_qloop_512*tmp_qloop_631);
                   const real_t q_tmp_6_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_634 + tmp_qloop_538 + tmp_qloop_639) - tmp_qloop_527*tmp_qloop_631);
                   const real_t q_tmp_6_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_634 + tmp_qloop_553 + tmp_qloop_639) - tmp_qloop_542*tmp_qloop_631);
                   const real_t q_tmp_6_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_634 + tmp_qloop_568 + tmp_qloop_639) - tmp_qloop_557*tmp_qloop_631);
                   const real_t q_tmp_6_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_634 + tmp_qloop_583 + tmp_qloop_639) - tmp_qloop_572*tmp_qloop_631);
                   const real_t q_tmp_7_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_641 + tmp_qloop_243*tmp_qloop_642 + tmp_qloop_247*tmp_qloop_643) - tmp_qloop_238*tmp_qloop_640);
                   const real_t q_tmp_7_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_641 + tmp_qloop_256*tmp_qloop_642 + tmp_qloop_260*tmp_qloop_643) - tmp_qloop_251*tmp_qloop_640);
                   const real_t q_tmp_7_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_641 + tmp_qloop_269*tmp_qloop_642 + tmp_qloop_273*tmp_qloop_643) - tmp_qloop_264*tmp_qloop_640);
                   const real_t q_tmp_7_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_642 + tmp_qloop_588 + tmp_qloop_645) - tmp_qloop_282*tmp_qloop_640);
                   const real_t q_tmp_7_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_642 + tmp_qloop_318 + tmp_qloop_646) - tmp_qloop_308*tmp_qloop_640);
                   const real_t q_tmp_7_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_642 + tmp_qloop_332 + tmp_qloop_646) - tmp_qloop_322*tmp_qloop_640);
                   const real_t q_tmp_7_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_642 + tmp_qloop_346 + tmp_qloop_646) - tmp_qloop_336*tmp_qloop_640);
                   const real_t q_tmp_7_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_642 + tmp_qloop_360 + tmp_qloop_646) - tmp_qloop_350*tmp_qloop_640);
                   const real_t q_tmp_7_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_642 + tmp_qloop_374 + tmp_qloop_646) - tmp_qloop_364*tmp_qloop_640);
                   const real_t q_tmp_7_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_642 + tmp_qloop_388 + tmp_qloop_646) - tmp_qloop_378*tmp_qloop_640);
                   const real_t q_tmp_7_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_642 + tmp_qloop_402 + tmp_qloop_646) - tmp_qloop_392*tmp_qloop_640);
                   const real_t q_tmp_7_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_642 + tmp_qloop_416 + tmp_qloop_646) - tmp_qloop_406*tmp_qloop_640);
                   const real_t q_tmp_7_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_642 + tmp_qloop_430 + tmp_qloop_646) - tmp_qloop_420*tmp_qloop_640);
                   const real_t q_tmp_7_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_643 + tmp_qloop_592 + tmp_qloop_647) - tmp_qloop_435*tmp_qloop_640);
                   const real_t q_tmp_7_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_643 + tmp_qloop_463 + tmp_qloop_648) - tmp_qloop_452*tmp_qloop_640);
                   const real_t q_tmp_7_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_643 + tmp_qloop_478 + tmp_qloop_648) - tmp_qloop_467*tmp_qloop_640);
                   const real_t q_tmp_7_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_643 + tmp_qloop_493 + tmp_qloop_648) - tmp_qloop_482*tmp_qloop_640);
                   const real_t q_tmp_7_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_643 + tmp_qloop_508 + tmp_qloop_648) - tmp_qloop_497*tmp_qloop_640);
                   const real_t q_tmp_7_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_643 + tmp_qloop_523 + tmp_qloop_648) - tmp_qloop_512*tmp_qloop_640);
                   const real_t q_tmp_7_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_643 + tmp_qloop_538 + tmp_qloop_648) - tmp_qloop_527*tmp_qloop_640);
                   const real_t q_tmp_7_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_643 + tmp_qloop_553 + tmp_qloop_648) - tmp_qloop_542*tmp_qloop_640);
                   const real_t q_tmp_7_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_643 + tmp_qloop_568 + tmp_qloop_648) - tmp_qloop_557*tmp_qloop_640);
                   const real_t q_tmp_7_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_643 + tmp_qloop_583 + tmp_qloop_648) - tmp_qloop_572*tmp_qloop_640);
                   const real_t q_tmp_8_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_650 + tmp_qloop_256*tmp_qloop_651 + tmp_qloop_260*tmp_qloop_652) - tmp_qloop_251*tmp_qloop_649);
                   const real_t q_tmp_8_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_650 + tmp_qloop_269*tmp_qloop_651 + tmp_qloop_273*tmp_qloop_652) - tmp_qloop_264*tmp_qloop_649);
                   const real_t q_tmp_8_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_651 + tmp_qloop_588 + tmp_qloop_654) - tmp_qloop_282*tmp_qloop_649);
                   const real_t q_tmp_8_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_651 + tmp_qloop_318 + tmp_qloop_655) - tmp_qloop_308*tmp_qloop_649);
                   const real_t q_tmp_8_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_651 + tmp_qloop_332 + tmp_qloop_655) - tmp_qloop_322*tmp_qloop_649);
                   const real_t q_tmp_8_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_651 + tmp_qloop_346 + tmp_qloop_655) - tmp_qloop_336*tmp_qloop_649);
                   const real_t q_tmp_8_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_651 + tmp_qloop_360 + tmp_qloop_655) - tmp_qloop_350*tmp_qloop_649);
                   const real_t q_tmp_8_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_651 + tmp_qloop_374 + tmp_qloop_655) - tmp_qloop_364*tmp_qloop_649);
                   const real_t q_tmp_8_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_651 + tmp_qloop_388 + tmp_qloop_655) - tmp_qloop_378*tmp_qloop_649);
                   const real_t q_tmp_8_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_651 + tmp_qloop_402 + tmp_qloop_655) - tmp_qloop_392*tmp_qloop_649);
                   const real_t q_tmp_8_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_651 + tmp_qloop_416 + tmp_qloop_655) - tmp_qloop_406*tmp_qloop_649);
                   const real_t q_tmp_8_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_651 + tmp_qloop_430 + tmp_qloop_655) - tmp_qloop_420*tmp_qloop_649);
                   const real_t q_tmp_8_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_652 + tmp_qloop_592 + tmp_qloop_656) - tmp_qloop_435*tmp_qloop_649);
                   const real_t q_tmp_8_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_652 + tmp_qloop_463 + tmp_qloop_657) - tmp_qloop_452*tmp_qloop_649);
                   const real_t q_tmp_8_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_652 + tmp_qloop_478 + tmp_qloop_657) - tmp_qloop_467*tmp_qloop_649);
                   const real_t q_tmp_8_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_652 + tmp_qloop_493 + tmp_qloop_657) - tmp_qloop_482*tmp_qloop_649);
                   const real_t q_tmp_8_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_652 + tmp_qloop_508 + tmp_qloop_657) - tmp_qloop_497*tmp_qloop_649);
                   const real_t q_tmp_8_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_652 + tmp_qloop_523 + tmp_qloop_657) - tmp_qloop_512*tmp_qloop_649);
                   const real_t q_tmp_8_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_652 + tmp_qloop_538 + tmp_qloop_657) - tmp_qloop_527*tmp_qloop_649);
                   const real_t q_tmp_8_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_652 + tmp_qloop_553 + tmp_qloop_657) - tmp_qloop_542*tmp_qloop_649);
                   const real_t q_tmp_8_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_652 + tmp_qloop_568 + tmp_qloop_657) - tmp_qloop_557*tmp_qloop_649);
                   const real_t q_tmp_8_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_652 + tmp_qloop_583 + tmp_qloop_657) - tmp_qloop_572*tmp_qloop_649);
                   const real_t q_tmp_9_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_659 + tmp_qloop_269*tmp_qloop_660 + tmp_qloop_273*tmp_qloop_661) - tmp_qloop_264*tmp_qloop_658);
                   const real_t q_tmp_9_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_660 + tmp_qloop_588 + tmp_qloop_663) - tmp_qloop_282*tmp_qloop_658);
                   const real_t q_tmp_9_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_660 + tmp_qloop_318 + tmp_qloop_664) - tmp_qloop_308*tmp_qloop_658);
                   const real_t q_tmp_9_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_660 + tmp_qloop_332 + tmp_qloop_664) - tmp_qloop_322*tmp_qloop_658);
                   const real_t q_tmp_9_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_660 + tmp_qloop_346 + tmp_qloop_664) - tmp_qloop_336*tmp_qloop_658);
                   const real_t q_tmp_9_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_660 + tmp_qloop_360 + tmp_qloop_664) - tmp_qloop_350*tmp_qloop_658);
                   const real_t q_tmp_9_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_660 + tmp_qloop_374 + tmp_qloop_664) - tmp_qloop_364*tmp_qloop_658);
                   const real_t q_tmp_9_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_660 + tmp_qloop_388 + tmp_qloop_664) - tmp_qloop_378*tmp_qloop_658);
                   const real_t q_tmp_9_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_660 + tmp_qloop_402 + tmp_qloop_664) - tmp_qloop_392*tmp_qloop_658);
                   const real_t q_tmp_9_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_660 + tmp_qloop_416 + tmp_qloop_664) - tmp_qloop_406*tmp_qloop_658);
                   const real_t q_tmp_9_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_660 + tmp_qloop_430 + tmp_qloop_664) - tmp_qloop_420*tmp_qloop_658);
                   const real_t q_tmp_9_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_661 + tmp_qloop_592 + tmp_qloop_665) - tmp_qloop_435*tmp_qloop_658);
                   const real_t q_tmp_9_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_661 + tmp_qloop_463 + tmp_qloop_666) - tmp_qloop_452*tmp_qloop_658);
                   const real_t q_tmp_9_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_661 + tmp_qloop_478 + tmp_qloop_666) - tmp_qloop_467*tmp_qloop_658);
                   const real_t q_tmp_9_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_661 + tmp_qloop_493 + tmp_qloop_666) - tmp_qloop_482*tmp_qloop_658);
                   const real_t q_tmp_9_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_661 + tmp_qloop_508 + tmp_qloop_666) - tmp_qloop_497*tmp_qloop_658);
                   const real_t q_tmp_9_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_661 + tmp_qloop_523 + tmp_qloop_666) - tmp_qloop_512*tmp_qloop_658);
                   const real_t q_tmp_9_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_661 + tmp_qloop_538 + tmp_qloop_666) - tmp_qloop_527*tmp_qloop_658);
                   const real_t q_tmp_9_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_661 + tmp_qloop_553 + tmp_qloop_666) - tmp_qloop_542*tmp_qloop_658);
                   const real_t q_tmp_9_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_661 + tmp_qloop_568 + tmp_qloop_666) - tmp_qloop_557*tmp_qloop_658);
                   const real_t q_tmp_9_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_661 + tmp_qloop_583 + tmp_qloop_666) - tmp_qloop_572*tmp_qloop_658);
                   const real_t q_tmp_10_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_672 + tmp_qloop_299*tmp_qloop_670 + tmp_qloop_303*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_282*tmp_qloop_669);
                   const real_t q_tmp_10_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_672 + tmp_qloop_313*tmp_qloop_670 + tmp_qloop_317*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_669);
                   const real_t q_tmp_10_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_672 + tmp_qloop_327*tmp_qloop_670 + tmp_qloop_331*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_669);
                   const real_t q_tmp_10_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_672 + tmp_qloop_341*tmp_qloop_670 + tmp_qloop_345*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_669);
                   const real_t q_tmp_10_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_672 + tmp_qloop_355*tmp_qloop_670 + tmp_qloop_359*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_669);
                   const real_t q_tmp_10_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_672 + tmp_qloop_369*tmp_qloop_670 + tmp_qloop_373*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_669);
                   const real_t q_tmp_10_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_672 + tmp_qloop_383*tmp_qloop_670 + tmp_qloop_387*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_669);
                   const real_t q_tmp_10_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_672 + tmp_qloop_397*tmp_qloop_670 + tmp_qloop_401*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_669);
                   const real_t q_tmp_10_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_672 + tmp_qloop_411*tmp_qloop_670 + tmp_qloop_415*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_669);
                   const real_t q_tmp_10_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_672 + tmp_qloop_425*tmp_qloop_670 + tmp_qloop_429*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_669);
                   const real_t q_tmp_10_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_679) - tmp_qloop_435*tmp_qloop_669);
                   const real_t q_tmp_10_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_680) - tmp_qloop_452*tmp_qloop_669);
                   const real_t q_tmp_10_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_681) - tmp_qloop_467*tmp_qloop_669);
                   const real_t q_tmp_10_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_682) - tmp_qloop_482*tmp_qloop_669);
                   const real_t q_tmp_10_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_683) - tmp_qloop_497*tmp_qloop_669);
                   const real_t q_tmp_10_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_684) - tmp_qloop_512*tmp_qloop_669);
                   const real_t q_tmp_10_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_685) - tmp_qloop_527*tmp_qloop_669);
                   const real_t q_tmp_10_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_686) - tmp_qloop_542*tmp_qloop_669);
                   const real_t q_tmp_10_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_687) - tmp_qloop_557*tmp_qloop_669);
                   const real_t q_tmp_10_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_688) - tmp_qloop_572*tmp_qloop_669);
                   const real_t q_tmp_11_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_691 + tmp_qloop_313*tmp_qloop_690 + tmp_qloop_317*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_689);
                   const real_t q_tmp_11_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_691 + tmp_qloop_327*tmp_qloop_690 + tmp_qloop_331*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_689);
                   const real_t q_tmp_11_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_691 + tmp_qloop_341*tmp_qloop_690 + tmp_qloop_345*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_689);
                   const real_t q_tmp_11_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_691 + tmp_qloop_355*tmp_qloop_690 + tmp_qloop_359*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_689);
                   const real_t q_tmp_11_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_691 + tmp_qloop_369*tmp_qloop_690 + tmp_qloop_373*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_689);
                   const real_t q_tmp_11_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_691 + tmp_qloop_383*tmp_qloop_690 + tmp_qloop_387*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_689);
                   const real_t q_tmp_11_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_691 + tmp_qloop_397*tmp_qloop_690 + tmp_qloop_401*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_689);
                   const real_t q_tmp_11_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_691 + tmp_qloop_411*tmp_qloop_690 + tmp_qloop_415*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_689);
                   const real_t q_tmp_11_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_691 + tmp_qloop_425*tmp_qloop_690 + tmp_qloop_429*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_689);
                   const real_t q_tmp_11_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_692 + tmp_qloop_693 + tmp_qloop_694) - tmp_qloop_435*tmp_qloop_689);
                   const real_t q_tmp_11_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_692 + tmp_qloop_680 + tmp_qloop_695) - tmp_qloop_452*tmp_qloop_689);
                   const real_t q_tmp_11_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_692 + tmp_qloop_681 + tmp_qloop_695) - tmp_qloop_467*tmp_qloop_689);
                   const real_t q_tmp_11_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_692 + tmp_qloop_682 + tmp_qloop_695) - tmp_qloop_482*tmp_qloop_689);
                   const real_t q_tmp_11_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_692 + tmp_qloop_683 + tmp_qloop_695) - tmp_qloop_497*tmp_qloop_689);
                   const real_t q_tmp_11_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_692 + tmp_qloop_684 + tmp_qloop_695) - tmp_qloop_512*tmp_qloop_689);
                   const real_t q_tmp_11_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_692 + tmp_qloop_685 + tmp_qloop_695) - tmp_qloop_527*tmp_qloop_689);
                   const real_t q_tmp_11_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_692 + tmp_qloop_686 + tmp_qloop_695) - tmp_qloop_542*tmp_qloop_689);
                   const real_t q_tmp_11_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_692 + tmp_qloop_687 + tmp_qloop_695) - tmp_qloop_557*tmp_qloop_689);
                   const real_t q_tmp_11_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_692 + tmp_qloop_688 + tmp_qloop_695) - tmp_qloop_572*tmp_qloop_689);
                   const real_t q_tmp_12_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_698 + tmp_qloop_327*tmp_qloop_697 + tmp_qloop_331*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_696);
                   const real_t q_tmp_12_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_698 + tmp_qloop_341*tmp_qloop_697 + tmp_qloop_345*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_696);
                   const real_t q_tmp_12_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_698 + tmp_qloop_355*tmp_qloop_697 + tmp_qloop_359*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_696);
                   const real_t q_tmp_12_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_698 + tmp_qloop_369*tmp_qloop_697 + tmp_qloop_373*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_696);
                   const real_t q_tmp_12_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_698 + tmp_qloop_383*tmp_qloop_697 + tmp_qloop_387*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_696);
                   const real_t q_tmp_12_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_698 + tmp_qloop_397*tmp_qloop_697 + tmp_qloop_401*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_696);
                   const real_t q_tmp_12_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_698 + tmp_qloop_411*tmp_qloop_697 + tmp_qloop_415*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_696);
                   const real_t q_tmp_12_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_698 + tmp_qloop_425*tmp_qloop_697 + tmp_qloop_429*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_696);
                   const real_t q_tmp_12_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_699 + tmp_qloop_693 + tmp_qloop_700) - tmp_qloop_435*tmp_qloop_696);
                   const real_t q_tmp_12_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_699 + tmp_qloop_680 + tmp_qloop_701) - tmp_qloop_452*tmp_qloop_696);
                   const real_t q_tmp_12_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_699 + tmp_qloop_681 + tmp_qloop_701) - tmp_qloop_467*tmp_qloop_696);
                   const real_t q_tmp_12_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_699 + tmp_qloop_682 + tmp_qloop_701) - tmp_qloop_482*tmp_qloop_696);
                   const real_t q_tmp_12_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_699 + tmp_qloop_683 + tmp_qloop_701) - tmp_qloop_497*tmp_qloop_696);
                   const real_t q_tmp_12_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_699 + tmp_qloop_684 + tmp_qloop_701) - tmp_qloop_512*tmp_qloop_696);
                   const real_t q_tmp_12_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_699 + tmp_qloop_685 + tmp_qloop_701) - tmp_qloop_527*tmp_qloop_696);
                   const real_t q_tmp_12_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_699 + tmp_qloop_686 + tmp_qloop_701) - tmp_qloop_542*tmp_qloop_696);
                   const real_t q_tmp_12_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_699 + tmp_qloop_687 + tmp_qloop_701) - tmp_qloop_557*tmp_qloop_696);
                   const real_t q_tmp_12_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_699 + tmp_qloop_688 + tmp_qloop_701) - tmp_qloop_572*tmp_qloop_696);
                   const real_t q_tmp_13_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_704 + tmp_qloop_341*tmp_qloop_703 + tmp_qloop_345*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_702);
                   const real_t q_tmp_13_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_704 + tmp_qloop_355*tmp_qloop_703 + tmp_qloop_359*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_702);
                   const real_t q_tmp_13_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_704 + tmp_qloop_369*tmp_qloop_703 + tmp_qloop_373*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_702);
                   const real_t q_tmp_13_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_704 + tmp_qloop_383*tmp_qloop_703 + tmp_qloop_387*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_702);
                   const real_t q_tmp_13_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_704 + tmp_qloop_397*tmp_qloop_703 + tmp_qloop_401*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_702);
                   const real_t q_tmp_13_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_704 + tmp_qloop_411*tmp_qloop_703 + tmp_qloop_415*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_702);
                   const real_t q_tmp_13_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_704 + tmp_qloop_425*tmp_qloop_703 + tmp_qloop_429*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_702);
                   const real_t q_tmp_13_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_705 + tmp_qloop_693 + tmp_qloop_706) - tmp_qloop_435*tmp_qloop_702);
                   const real_t q_tmp_13_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_705 + tmp_qloop_680 + tmp_qloop_707) - tmp_qloop_452*tmp_qloop_702);
                   const real_t q_tmp_13_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_705 + tmp_qloop_681 + tmp_qloop_707) - tmp_qloop_467*tmp_qloop_702);
                   const real_t q_tmp_13_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_705 + tmp_qloop_682 + tmp_qloop_707) - tmp_qloop_482*tmp_qloop_702);
                   const real_t q_tmp_13_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_705 + tmp_qloop_683 + tmp_qloop_707) - tmp_qloop_497*tmp_qloop_702);
                   const real_t q_tmp_13_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_705 + tmp_qloop_684 + tmp_qloop_707) - tmp_qloop_512*tmp_qloop_702);
                   const real_t q_tmp_13_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_705 + tmp_qloop_685 + tmp_qloop_707) - tmp_qloop_527*tmp_qloop_702);
                   const real_t q_tmp_13_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_705 + tmp_qloop_686 + tmp_qloop_707) - tmp_qloop_542*tmp_qloop_702);
                   const real_t q_tmp_13_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_705 + tmp_qloop_687 + tmp_qloop_707) - tmp_qloop_557*tmp_qloop_702);
                   const real_t q_tmp_13_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_705 + tmp_qloop_688 + tmp_qloop_707) - tmp_qloop_572*tmp_qloop_702);
                   const real_t q_tmp_14_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_710 + tmp_qloop_355*tmp_qloop_709 + tmp_qloop_359*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_708);
                   const real_t q_tmp_14_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_710 + tmp_qloop_369*tmp_qloop_709 + tmp_qloop_373*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_708);
                   const real_t q_tmp_14_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_710 + tmp_qloop_383*tmp_qloop_709 + tmp_qloop_387*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_708);
                   const real_t q_tmp_14_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_710 + tmp_qloop_397*tmp_qloop_709 + tmp_qloop_401*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_708);
                   const real_t q_tmp_14_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_710 + tmp_qloop_411*tmp_qloop_709 + tmp_qloop_415*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_708);
                   const real_t q_tmp_14_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_710 + tmp_qloop_425*tmp_qloop_709 + tmp_qloop_429*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_708);
                   const real_t q_tmp_14_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_711 + tmp_qloop_693 + tmp_qloop_712) - tmp_qloop_435*tmp_qloop_708);
                   const real_t q_tmp_14_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_711 + tmp_qloop_680 + tmp_qloop_713) - tmp_qloop_452*tmp_qloop_708);
                   const real_t q_tmp_14_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_711 + tmp_qloop_681 + tmp_qloop_713) - tmp_qloop_467*tmp_qloop_708);
                   const real_t q_tmp_14_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_711 + tmp_qloop_682 + tmp_qloop_713) - tmp_qloop_482*tmp_qloop_708);
                   const real_t q_tmp_14_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_711 + tmp_qloop_683 + tmp_qloop_713) - tmp_qloop_497*tmp_qloop_708);
                   const real_t q_tmp_14_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_711 + tmp_qloop_684 + tmp_qloop_713) - tmp_qloop_512*tmp_qloop_708);
                   const real_t q_tmp_14_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_711 + tmp_qloop_685 + tmp_qloop_713) - tmp_qloop_527*tmp_qloop_708);
                   const real_t q_tmp_14_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_711 + tmp_qloop_686 + tmp_qloop_713) - tmp_qloop_542*tmp_qloop_708);
                   const real_t q_tmp_14_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_711 + tmp_qloop_687 + tmp_qloop_713) - tmp_qloop_557*tmp_qloop_708);
                   const real_t q_tmp_14_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_711 + tmp_qloop_688 + tmp_qloop_713) - tmp_qloop_572*tmp_qloop_708);
                   const real_t q_tmp_15_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_716 + tmp_qloop_369*tmp_qloop_715 + tmp_qloop_373*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_714);
                   const real_t q_tmp_15_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_716 + tmp_qloop_383*tmp_qloop_715 + tmp_qloop_387*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_714);
                   const real_t q_tmp_15_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_716 + tmp_qloop_397*tmp_qloop_715 + tmp_qloop_401*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_714);
                   const real_t q_tmp_15_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_716 + tmp_qloop_411*tmp_qloop_715 + tmp_qloop_415*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_714);
                   const real_t q_tmp_15_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_716 + tmp_qloop_425*tmp_qloop_715 + tmp_qloop_429*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_714);
                   const real_t q_tmp_15_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_717 + tmp_qloop_693 + tmp_qloop_718) - tmp_qloop_435*tmp_qloop_714);
                   const real_t q_tmp_15_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_717 + tmp_qloop_680 + tmp_qloop_719) - tmp_qloop_452*tmp_qloop_714);
                   const real_t q_tmp_15_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_717 + tmp_qloop_681 + tmp_qloop_719) - tmp_qloop_467*tmp_qloop_714);
                   const real_t q_tmp_15_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_717 + tmp_qloop_682 + tmp_qloop_719) - tmp_qloop_482*tmp_qloop_714);
                   const real_t q_tmp_15_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_717 + tmp_qloop_683 + tmp_qloop_719) - tmp_qloop_497*tmp_qloop_714);
                   const real_t q_tmp_15_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_717 + tmp_qloop_684 + tmp_qloop_719) - tmp_qloop_512*tmp_qloop_714);
                   const real_t q_tmp_15_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_717 + tmp_qloop_685 + tmp_qloop_719) - tmp_qloop_527*tmp_qloop_714);
                   const real_t q_tmp_15_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_717 + tmp_qloop_686 + tmp_qloop_719) - tmp_qloop_542*tmp_qloop_714);
                   const real_t q_tmp_15_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_717 + tmp_qloop_687 + tmp_qloop_719) - tmp_qloop_557*tmp_qloop_714);
                   const real_t q_tmp_15_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_717 + tmp_qloop_688 + tmp_qloop_719) - tmp_qloop_572*tmp_qloop_714);
                   const real_t q_tmp_16_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_722 + tmp_qloop_383*tmp_qloop_721 + tmp_qloop_387*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_720);
                   const real_t q_tmp_16_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_722 + tmp_qloop_397*tmp_qloop_721 + tmp_qloop_401*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_720);
                   const real_t q_tmp_16_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_722 + tmp_qloop_411*tmp_qloop_721 + tmp_qloop_415*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_720);
                   const real_t q_tmp_16_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_722 + tmp_qloop_425*tmp_qloop_721 + tmp_qloop_429*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_720);
                   const real_t q_tmp_16_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_723 + tmp_qloop_693 + tmp_qloop_724) - tmp_qloop_435*tmp_qloop_720);
                   const real_t q_tmp_16_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_723 + tmp_qloop_680 + tmp_qloop_725) - tmp_qloop_452*tmp_qloop_720);
                   const real_t q_tmp_16_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_723 + tmp_qloop_681 + tmp_qloop_725) - tmp_qloop_467*tmp_qloop_720);
                   const real_t q_tmp_16_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_723 + tmp_qloop_682 + tmp_qloop_725) - tmp_qloop_482*tmp_qloop_720);
                   const real_t q_tmp_16_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_723 + tmp_qloop_683 + tmp_qloop_725) - tmp_qloop_497*tmp_qloop_720);
                   const real_t q_tmp_16_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_723 + tmp_qloop_684 + tmp_qloop_725) - tmp_qloop_512*tmp_qloop_720);
                   const real_t q_tmp_16_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_723 + tmp_qloop_685 + tmp_qloop_725) - tmp_qloop_527*tmp_qloop_720);
                   const real_t q_tmp_16_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_723 + tmp_qloop_686 + tmp_qloop_725) - tmp_qloop_542*tmp_qloop_720);
                   const real_t q_tmp_16_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_723 + tmp_qloop_687 + tmp_qloop_725) - tmp_qloop_557*tmp_qloop_720);
                   const real_t q_tmp_16_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_723 + tmp_qloop_688 + tmp_qloop_725) - tmp_qloop_572*tmp_qloop_720);
                   const real_t q_tmp_17_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_728 + tmp_qloop_397*tmp_qloop_727 + tmp_qloop_401*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_726);
                   const real_t q_tmp_17_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_728 + tmp_qloop_411*tmp_qloop_727 + tmp_qloop_415*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_726);
                   const real_t q_tmp_17_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_728 + tmp_qloop_425*tmp_qloop_727 + tmp_qloop_429*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_726);
                   const real_t q_tmp_17_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_729 + tmp_qloop_693 + tmp_qloop_730) - tmp_qloop_435*tmp_qloop_726);
                   const real_t q_tmp_17_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_729 + tmp_qloop_680 + tmp_qloop_731) - tmp_qloop_452*tmp_qloop_726);
                   const real_t q_tmp_17_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_729 + tmp_qloop_681 + tmp_qloop_731) - tmp_qloop_467*tmp_qloop_726);
                   const real_t q_tmp_17_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_729 + tmp_qloop_682 + tmp_qloop_731) - tmp_qloop_482*tmp_qloop_726);
                   const real_t q_tmp_17_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_729 + tmp_qloop_683 + tmp_qloop_731) - tmp_qloop_497*tmp_qloop_726);
                   const real_t q_tmp_17_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_729 + tmp_qloop_684 + tmp_qloop_731) - tmp_qloop_512*tmp_qloop_726);
                   const real_t q_tmp_17_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_729 + tmp_qloop_685 + tmp_qloop_731) - tmp_qloop_527*tmp_qloop_726);
                   const real_t q_tmp_17_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_729 + tmp_qloop_686 + tmp_qloop_731) - tmp_qloop_542*tmp_qloop_726);
                   const real_t q_tmp_17_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_729 + tmp_qloop_687 + tmp_qloop_731) - tmp_qloop_557*tmp_qloop_726);
                   const real_t q_tmp_17_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_729 + tmp_qloop_688 + tmp_qloop_731) - tmp_qloop_572*tmp_qloop_726);
                   const real_t q_tmp_18_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_734 + tmp_qloop_411*tmp_qloop_733 + tmp_qloop_415*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_732);
                   const real_t q_tmp_18_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_734 + tmp_qloop_425*tmp_qloop_733 + tmp_qloop_429*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_732);
                   const real_t q_tmp_18_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_735 + tmp_qloop_693 + tmp_qloop_736) - tmp_qloop_435*tmp_qloop_732);
                   const real_t q_tmp_18_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_735 + tmp_qloop_680 + tmp_qloop_737) - tmp_qloop_452*tmp_qloop_732);
                   const real_t q_tmp_18_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_735 + tmp_qloop_681 + tmp_qloop_737) - tmp_qloop_467*tmp_qloop_732);
                   const real_t q_tmp_18_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_735 + tmp_qloop_682 + tmp_qloop_737) - tmp_qloop_482*tmp_qloop_732);
                   const real_t q_tmp_18_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_735 + tmp_qloop_683 + tmp_qloop_737) - tmp_qloop_497*tmp_qloop_732);
                   const real_t q_tmp_18_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_735 + tmp_qloop_684 + tmp_qloop_737) - tmp_qloop_512*tmp_qloop_732);
                   const real_t q_tmp_18_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_735 + tmp_qloop_685 + tmp_qloop_737) - tmp_qloop_527*tmp_qloop_732);
                   const real_t q_tmp_18_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_735 + tmp_qloop_686 + tmp_qloop_737) - tmp_qloop_542*tmp_qloop_732);
                   const real_t q_tmp_18_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_735 + tmp_qloop_687 + tmp_qloop_737) - tmp_qloop_557*tmp_qloop_732);
                   const real_t q_tmp_18_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_735 + tmp_qloop_688 + tmp_qloop_737) - tmp_qloop_572*tmp_qloop_732);
                   const real_t q_tmp_19_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_740 + tmp_qloop_425*tmp_qloop_739 + tmp_qloop_429*tmp_qloop_741 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_738);
                   const real_t q_tmp_19_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_741 + tmp_qloop_693 + tmp_qloop_742) - tmp_qloop_435*tmp_qloop_738);
                   const real_t q_tmp_19_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_741 + tmp_qloop_680 + tmp_qloop_743) - tmp_qloop_452*tmp_qloop_738);
                   const real_t q_tmp_19_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_741 + tmp_qloop_681 + tmp_qloop_743) - tmp_qloop_467*tmp_qloop_738);
                   const real_t q_tmp_19_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_741 + tmp_qloop_682 + tmp_qloop_743) - tmp_qloop_482*tmp_qloop_738);
                   const real_t q_tmp_19_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_741 + tmp_qloop_683 + tmp_qloop_743) - tmp_qloop_497*tmp_qloop_738);
                   const real_t q_tmp_19_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_741 + tmp_qloop_684 + tmp_qloop_743) - tmp_qloop_512*tmp_qloop_738);
                   const real_t q_tmp_19_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_741 + tmp_qloop_685 + tmp_qloop_743) - tmp_qloop_527*tmp_qloop_738);
                   const real_t q_tmp_19_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_741 + tmp_qloop_686 + tmp_qloop_743) - tmp_qloop_542*tmp_qloop_738);
                   const real_t q_tmp_19_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_741 + tmp_qloop_687 + tmp_qloop_743) - tmp_qloop_557*tmp_qloop_738);
                   const real_t q_tmp_19_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_741 + tmp_qloop_688 + tmp_qloop_743) - tmp_qloop_572*tmp_qloop_738);
                   const real_t q_tmp_20_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_747 + tmp_qloop_442*tmp_qloop_746 + tmp_qloop_447*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_435*tmp_qloop_745);
                   const real_t q_tmp_20_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_747 + tmp_qloop_457*tmp_qloop_746 + tmp_qloop_462*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_745);
                   const real_t q_tmp_20_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_747 + tmp_qloop_472*tmp_qloop_746 + tmp_qloop_477*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_745);
                   const real_t q_tmp_20_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_747 + tmp_qloop_487*tmp_qloop_746 + tmp_qloop_492*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_745);
                   const real_t q_tmp_20_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_747 + tmp_qloop_502*tmp_qloop_746 + tmp_qloop_507*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_745);
                   const real_t q_tmp_20_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_747 + tmp_qloop_517*tmp_qloop_746 + tmp_qloop_522*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_745);
                   const real_t q_tmp_20_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_747 + tmp_qloop_532*tmp_qloop_746 + tmp_qloop_537*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_745);
                   const real_t q_tmp_20_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_747 + tmp_qloop_547*tmp_qloop_746 + tmp_qloop_552*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_745);
                   const real_t q_tmp_20_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_747 + tmp_qloop_562*tmp_qloop_746 + tmp_qloop_567*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_745);
                   const real_t q_tmp_20_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_747 + tmp_qloop_577*tmp_qloop_746 + tmp_qloop_582*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_745);
                   const real_t q_tmp_21_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_752 + tmp_qloop_457*tmp_qloop_751 + tmp_qloop_462*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_750);
                   const real_t q_tmp_21_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_752 + tmp_qloop_472*tmp_qloop_751 + tmp_qloop_477*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_750);
                   const real_t q_tmp_21_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_752 + tmp_qloop_487*tmp_qloop_751 + tmp_qloop_492*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_750);
                   const real_t q_tmp_21_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_752 + tmp_qloop_502*tmp_qloop_751 + tmp_qloop_507*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_750);
                   const real_t q_tmp_21_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_752 + tmp_qloop_517*tmp_qloop_751 + tmp_qloop_522*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_750);
                   const real_t q_tmp_21_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_752 + tmp_qloop_532*tmp_qloop_751 + tmp_qloop_537*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_750);
                   const real_t q_tmp_21_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_752 + tmp_qloop_547*tmp_qloop_751 + tmp_qloop_552*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_750);
                   const real_t q_tmp_21_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_752 + tmp_qloop_562*tmp_qloop_751 + tmp_qloop_567*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_750);
                   const real_t q_tmp_21_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_752 + tmp_qloop_577*tmp_qloop_751 + tmp_qloop_582*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_750);
                   const real_t q_tmp_22_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_756 + tmp_qloop_472*tmp_qloop_755 + tmp_qloop_477*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_754);
                   const real_t q_tmp_22_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_756 + tmp_qloop_487*tmp_qloop_755 + tmp_qloop_492*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_754);
                   const real_t q_tmp_22_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_756 + tmp_qloop_502*tmp_qloop_755 + tmp_qloop_507*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_754);
                   const real_t q_tmp_22_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_756 + tmp_qloop_517*tmp_qloop_755 + tmp_qloop_522*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_754);
                   const real_t q_tmp_22_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_756 + tmp_qloop_532*tmp_qloop_755 + tmp_qloop_537*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_754);
                   const real_t q_tmp_22_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_756 + tmp_qloop_547*tmp_qloop_755 + tmp_qloop_552*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_754);
                   const real_t q_tmp_22_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_756 + tmp_qloop_562*tmp_qloop_755 + tmp_qloop_567*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_754);
                   const real_t q_tmp_22_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_756 + tmp_qloop_577*tmp_qloop_755 + tmp_qloop_582*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_754);
                   const real_t q_tmp_23_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_760 + tmp_qloop_487*tmp_qloop_759 + tmp_qloop_492*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_758);
                   const real_t q_tmp_23_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_760 + tmp_qloop_502*tmp_qloop_759 + tmp_qloop_507*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_758);
                   const real_t q_tmp_23_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_760 + tmp_qloop_517*tmp_qloop_759 + tmp_qloop_522*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_758);
                   const real_t q_tmp_23_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_760 + tmp_qloop_532*tmp_qloop_759 + tmp_qloop_537*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_758);
                   const real_t q_tmp_23_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_760 + tmp_qloop_547*tmp_qloop_759 + tmp_qloop_552*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_758);
                   const real_t q_tmp_23_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_760 + tmp_qloop_562*tmp_qloop_759 + tmp_qloop_567*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_758);
                   const real_t q_tmp_23_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_760 + tmp_qloop_577*tmp_qloop_759 + tmp_qloop_582*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_758);
                   const real_t q_tmp_24_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_764 + tmp_qloop_502*tmp_qloop_763 + tmp_qloop_507*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_762);
                   const real_t q_tmp_24_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_764 + tmp_qloop_517*tmp_qloop_763 + tmp_qloop_522*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_762);
                   const real_t q_tmp_24_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_764 + tmp_qloop_532*tmp_qloop_763 + tmp_qloop_537*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_762);
                   const real_t q_tmp_24_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_764 + tmp_qloop_547*tmp_qloop_763 + tmp_qloop_552*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_762);
                   const real_t q_tmp_24_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_764 + tmp_qloop_562*tmp_qloop_763 + tmp_qloop_567*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_762);
                   const real_t q_tmp_24_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_764 + tmp_qloop_577*tmp_qloop_763 + tmp_qloop_582*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_762);
                   const real_t q_tmp_25_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_768 + tmp_qloop_517*tmp_qloop_767 + tmp_qloop_522*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_766);
                   const real_t q_tmp_25_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_768 + tmp_qloop_532*tmp_qloop_767 + tmp_qloop_537*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_766);
                   const real_t q_tmp_25_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_768 + tmp_qloop_547*tmp_qloop_767 + tmp_qloop_552*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_766);
                   const real_t q_tmp_25_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_768 + tmp_qloop_562*tmp_qloop_767 + tmp_qloop_567*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_766);
                   const real_t q_tmp_25_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_768 + tmp_qloop_577*tmp_qloop_767 + tmp_qloop_582*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_766);
                   const real_t q_tmp_26_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_772 + tmp_qloop_532*tmp_qloop_771 + tmp_qloop_537*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_770);
                   const real_t q_tmp_26_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_772 + tmp_qloop_547*tmp_qloop_771 + tmp_qloop_552*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_770);
                   const real_t q_tmp_26_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_772 + tmp_qloop_562*tmp_qloop_771 + tmp_qloop_567*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_770);
                   const real_t q_tmp_26_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_772 + tmp_qloop_577*tmp_qloop_771 + tmp_qloop_582*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_770);
                   const real_t q_tmp_27_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_776 + tmp_qloop_547*tmp_qloop_775 + tmp_qloop_552*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_774);
                   const real_t q_tmp_27_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_776 + tmp_qloop_562*tmp_qloop_775 + tmp_qloop_567*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_774);
                   const real_t q_tmp_27_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_776 + tmp_qloop_577*tmp_qloop_775 + tmp_qloop_582*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_774);
                   const real_t q_tmp_28_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_780 + tmp_qloop_562*tmp_qloop_779 + tmp_qloop_567*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_778);
                   const real_t q_tmp_28_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_780 + tmp_qloop_577*tmp_qloop_779 + tmp_qloop_582*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_778);
                   const real_t q_tmp_29_29 = tmp_qloop_156*(-tmp_qloop_118*tmp_qloop_572*(tmp_qloop_569 + tmp_qloop_570 + tmp_qloop_571 + tmp_qloop_744) + tmp_qloop_118*(tmp_qloop_576*(tmp_qloop_573*0.5 + tmp_qloop_574*0.5 + tmp_qloop_575*0.5 + tmp_qloop_675)*2.0 + tmp_qloop_577*(tmp_qloop_569*1.0 + tmp_qloop_570*1.0 + tmp_qloop_571*1.0) + tmp_qloop_582*(tmp_qloop_153 + tmp_qloop_579*0.5 + tmp_qloop_580*0.5 + tmp_qloop_581*0.5)*2.0 + tmp_qloop_749));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                   q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                   q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                   q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                   q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                   q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                   q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                   q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                   q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                   q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                   q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                   q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                   q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                   q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                   q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                   q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                   q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                   q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                   q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                   q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                   q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                   q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                   q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                   q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                   q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                   q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                   q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                   q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                   q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                   q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                   q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                   q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                   q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                   q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                   q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                   q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                   q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                   q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                   q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                   q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                   q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                   q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                   q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                   q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                   q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                   q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                   q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                   q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                   q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                   q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                   q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                   q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                   q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                   q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                   q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                   q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                   q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                   q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                   q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                   q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                   q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                   q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                   q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                   q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                   q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                   q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                   q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                   q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                   q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                   q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                   q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                   q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                   q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                   q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                   q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                   q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                   q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                   q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                   q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                   q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                   q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                   q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                   q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                   q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                   q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                   q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                   q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                   q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                   q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                   q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                   q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                   q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                   q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                   q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                   q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                   q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                   q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                   q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                   q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                   q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                   q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                   q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                   q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                   q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                   q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                   q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                   q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                   q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                   q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                   q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                   q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                   q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                   q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                   q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                   q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                   q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                   q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                   q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                   q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                   q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                   q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                   q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                   q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                   q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                   q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                   q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                   q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                   q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                   q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                   q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                   q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                   q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                   q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                   q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                   q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                   q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                   q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                   q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                   q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                   q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                   q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                   q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                   q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                   q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                   q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                   q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                   q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                   q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                   q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                   q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                   q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                   q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                   q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                   q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                   q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                   q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                   q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                   q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                   q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                   q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                   q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                   q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                   q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                   q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                   q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                   q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                   q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                   q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                   q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                   q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                   q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                   q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                   q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                   q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                   q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                   q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                   q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                   q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                   q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                   q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                   q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                   q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                   q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                   q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                   q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                   q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                   q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                   q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                   q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                   q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                   q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                   q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                   q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                   q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                   q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                   q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                   q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                   q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                   q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                   q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                   q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                   q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                   q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                   q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                   q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                   q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                   q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                   q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                   q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                   q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                   q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                   q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                   q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                   q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                   q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                   q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                   q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                   q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                   q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                   q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                   q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                   q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                   q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                   q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                   q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                   q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                   q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                   q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                   q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                   q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                   q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                   q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                   q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                   q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                   q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                   q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                   q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                   q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                   q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                   q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                   q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                   q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                   q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                   q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                   q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                   q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                   q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                   q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                   q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                   q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                   q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                   q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                   q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                   q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                   q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                   q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                   q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                   q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                   q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                   q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                   q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                   q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                   q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                   q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                   q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                   q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                   q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                   q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                   q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                   q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                   q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                   q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                   q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                   q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                   q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                   q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                   q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                   q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                   q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                   q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                   q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                   q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                   q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                   q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                   q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                   q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                   q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                   q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                   q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                   q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                   q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                   q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                   q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                   q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                   q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                   q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                   q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                   q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                   q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                   q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                   q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                   q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                   q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                   q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                   q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                   q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                   q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                   q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                   q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                   q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                   q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                   q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                   q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                   q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                   q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                   q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                   q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                   q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                   q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                   q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                   q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                   q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                   q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                   q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                   q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                   q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                   q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                   q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                   q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                   q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                   q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                   q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                   q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                   q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                   q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                   q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                   q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                   q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                   q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                   q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                   q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
                const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
                const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
                const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
                const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
                const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
                const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
                const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
                const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
                const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
                const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
                const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
                const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
                const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
                const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
                const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
                const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
                const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_17 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_27 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {0.25, 0.25, 0.25, 0.25, 0.16666666666666674, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666671, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666671, 0.5, 0.16666666666666666, 0.16666666666666666, 0.50000000000000011, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_UP [] = {0.0, ((real_t)(abs_det_jac_affine_GREEN_UP)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(abs_det_jac_affine_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(abs_det_jac_affine_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(abs_det_jac_affine_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_12 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_13 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_14 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_15 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_16 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_17 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_18 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_19 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_20 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_21 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_22 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_23 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_24 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_25 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_26 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_27 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_28 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_29 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_GREEN_UP[4*q],_data_phi_0_0_GREEN_UP[4*q],_data_phi_0_0_GREEN_UP[4*q],_data_phi_0_0_GREEN_UP[4*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_GREEN_UP[4*q + 1],_data_phi_0_0_GREEN_UP[4*q + 1],_data_phi_0_0_GREEN_UP[4*q + 1],_data_phi_0_0_GREEN_UP[4*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_GREEN_UP[4*q + 2],_data_phi_0_0_GREEN_UP[4*q + 2],_data_phi_0_0_GREEN_UP[4*q + 2],_data_phi_0_0_GREEN_UP[4*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_GREEN_UP[4*q + 3],_data_phi_0_0_GREEN_UP[4*q + 3],_data_phi_0_0_GREEN_UP[4*q + 3],_data_phi_0_0_GREEN_UP[4*q + 3]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_436 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_453 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_468 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_483 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_498 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_513 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_528 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_543 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_558 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_573 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q]));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9]));
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_444 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_459 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_474 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_489 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_504 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_519 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_534 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_549 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_564 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_579 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q]));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8]));
                   const __m256d tmp_qloop_257 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_342 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_449 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_464 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_479 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_494 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_509 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_524 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_539 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_554 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_569 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_134 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_236 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_437 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_454 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_469 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_484 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_499 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_514 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_529 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_544 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_559 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_574 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_445 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_460 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_475 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_490 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_505 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_520 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_535 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_550 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_565 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_580 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_343 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_432 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_450 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_465 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_480 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_495 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_510 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_525 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_540 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_555 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_570 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_126 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_124,tmp_qloop_125),tmp_qloop_126);
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_125,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_126,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_134),tmp_qloop_135);
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_134,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_135,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_187 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_213 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_226 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_237 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_239 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_265 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_280 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_291 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(tmp_qloop_120,tmp_qloop_291);
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_438 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_455 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_470 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_485 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_500 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_515 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_530 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_545 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_560 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_575 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_585 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_589 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_585);
                   const __m256d tmp_qloop_596 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_599 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_596);
                   const __m256d tmp_qloop_605 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_608 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_605);
                   const __m256d tmp_qloop_614 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_617 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_614);
                   const __m256d tmp_qloop_623 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_626 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_623);
                   const __m256d tmp_qloop_632 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_635 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_632);
                   const __m256d tmp_qloop_641 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_644 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_641);
                   const __m256d tmp_qloop_650 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_653 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_650);
                   const __m256d tmp_qloop_659 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_662 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_659);
                   const __m256d tmp_qloop_667 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_277,tmp_qloop_278),tmp_qloop_279);
                   const __m256d tmp_qloop_674 = _mm256_mul_pd(tmp_qloop_291,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(1.0,1.0,1.0,1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_121),tmp_qloop_122),tmp_qloop_123);
                   const __m256d tmp_qloop_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_139,tmp_qloop_140);
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_145),tmp_qloop_146);
                   const __m256d tmp_qloop_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_144,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_145,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_146,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_178 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_191 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_204 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_217 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_230 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_243 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_255 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_269 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_289 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_286,tmp_qloop_287),tmp_qloop_288);
                   const __m256d tmp_qloop_290 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_283,tmp_qloop_284),tmp_qloop_285),tmp_qloop_289);
                   const __m256d tmp_qloop_299 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_312 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_313 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_326 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_327 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_340 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_341 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_354 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_355 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_368 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_369 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_382 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_383 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_396 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_410 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_424 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_434 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_280);
                   const __m256d tmp_qloop_440 = _mm256_add_pd(tmp_qloop_127,tmp_qloop_289);
                   const __m256d tmp_qloop_441 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_440),tmp_qloop_141),tmp_qloop_292);
                   const __m256d tmp_qloop_446 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_461 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_476 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_491 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_506 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_521 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_536 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_551 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_566 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_581 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_586 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_593 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_586),tmp_qloop_589);
                   const __m256d tmp_qloop_594 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_593);
                   const __m256d tmp_qloop_597 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_602 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_597),tmp_qloop_599);
                   const __m256d tmp_qloop_603 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_602);
                   const __m256d tmp_qloop_606 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_611 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_606),tmp_qloop_608);
                   const __m256d tmp_qloop_612 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_611);
                   const __m256d tmp_qloop_615 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_620 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_615),tmp_qloop_617);
                   const __m256d tmp_qloop_621 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_620);
                   const __m256d tmp_qloop_624 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_629 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_624),tmp_qloop_626);
                   const __m256d tmp_qloop_630 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_629);
                   const __m256d tmp_qloop_633 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_638 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_633),tmp_qloop_635);
                   const __m256d tmp_qloop_639 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_638);
                   const __m256d tmp_qloop_642 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_647 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_642),tmp_qloop_644);
                   const __m256d tmp_qloop_648 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_647);
                   const __m256d tmp_qloop_651 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_656 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_651),tmp_qloop_653);
                   const __m256d tmp_qloop_657 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_656);
                   const __m256d tmp_qloop_660 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_665 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_660),tmp_qloop_662);
                   const __m256d tmp_qloop_666 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_665);
                   const __m256d tmp_qloop_670 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_671 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_672 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_283),tmp_qloop_284),tmp_qloop_285);
                   const __m256d tmp_qloop_678 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_670),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_672)),tmp_qloop_674);
                   const __m256d tmp_qloop_690 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_691 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_694 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_690),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_691));
                   const __m256d tmp_qloop_695 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_694);
                   const __m256d tmp_qloop_697 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_698 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_700 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_697),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_698));
                   const __m256d tmp_qloop_701 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_700);
                   const __m256d tmp_qloop_703 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_704 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_706 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_703),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_704));
                   const __m256d tmp_qloop_707 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_706);
                   const __m256d tmp_qloop_709 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_710 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_712 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_709),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_710));
                   const __m256d tmp_qloop_713 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_712);
                   const __m256d tmp_qloop_715 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_716 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_718 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_715),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_716));
                   const __m256d tmp_qloop_719 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_718);
                   const __m256d tmp_qloop_721 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_722 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_724 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_721),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_722));
                   const __m256d tmp_qloop_725 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_724);
                   const __m256d tmp_qloop_727 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_728 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_730 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_727),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_728));
                   const __m256d tmp_qloop_731 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_730);
                   const __m256d tmp_qloop_733 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_734 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_736 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_733),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_734));
                   const __m256d tmp_qloop_737 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_736);
                   const __m256d tmp_qloop_739 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_740 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_742 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_739),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_740));
                   const __m256d tmp_qloop_743 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_742);
                   const __m256d tmp_qloop_744 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_667);
                   const __m256d tmp_qloop_749 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_440,_mm256_add_pd(tmp_qloop_128,tmp_qloop_671)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_141),tmp_qloop_674);
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_117));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_130),tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_142,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q]));
                   const __m256d tmp_qloop_151 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_148,tmp_qloop_149),tmp_qloop_150);
                   const __m256d tmp_qloop_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,_mm256_add_pd(tmp_qloop_147,tmp_qloop_151)),tmp_qloop_141),tmp_qloop_143);
                   const __m256d tmp_qloop_160 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_169 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_199 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_208 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_212 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_221 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_225 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_234 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_246 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_251 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_260 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_264 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_273 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_281 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_280);
                   const __m256d tmp_qloop_282 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_296 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_293,tmp_qloop_294),tmp_qloop_295);
                   const __m256d tmp_qloop_297 = _mm256_add_pd(tmp_qloop_136,tmp_qloop_296);
                   const __m256d tmp_qloop_298 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_297),tmp_qloop_143),tmp_qloop_292);
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_303 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_304 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_299),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_303));
                   const __m256d tmp_qloop_308 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_317 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_318 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_313),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_317));
                   const __m256d tmp_qloop_322 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_331 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_332 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_327),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_331));
                   const __m256d tmp_qloop_336 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_345 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_346 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_341),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_345));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_359 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_360 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_355),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_359));
                   const __m256d tmp_qloop_364 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_373 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_374 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_369),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_373));
                   const __m256d tmp_qloop_378 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_387 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_388 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_383),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_387));
                   const __m256d tmp_qloop_392 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_401 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_402 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_397),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_401));
                   const __m256d tmp_qloop_406 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_416 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_411),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_415));
                   const __m256d tmp_qloop_420 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_429 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_430 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_425),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_429));
                   const __m256d tmp_qloop_433 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1]));
                   const __m256d tmp_qloop_435 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_439 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_442 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_443 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_442);
                   const __m256d tmp_qloop_447 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_448 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_447),tmp_qloop_443);
                   const __m256d tmp_qloop_451 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2]));
                   const __m256d tmp_qloop_452 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_457 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_458 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_457);
                   const __m256d tmp_qloop_462 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_463 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_462),tmp_qloop_458);
                   const __m256d tmp_qloop_466 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3]));
                   const __m256d tmp_qloop_467 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_472 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_473 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_472);
                   const __m256d tmp_qloop_477 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_478 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_477),tmp_qloop_473);
                   const __m256d tmp_qloop_481 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4]));
                   const __m256d tmp_qloop_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_486 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_487 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_488 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_487);
                   const __m256d tmp_qloop_492 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_493 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_492),tmp_qloop_488);
                   const __m256d tmp_qloop_496 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5]));
                   const __m256d tmp_qloop_497 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_501 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_502 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_503 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_502);
                   const __m256d tmp_qloop_507 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_508 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_507),tmp_qloop_503);
                   const __m256d tmp_qloop_511 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6]));
                   const __m256d tmp_qloop_512 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_516 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_517 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_518 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_517);
                   const __m256d tmp_qloop_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_523 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_522),tmp_qloop_518);
                   const __m256d tmp_qloop_526 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7]));
                   const __m256d tmp_qloop_527 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_531 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_532 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_533 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_532);
                   const __m256d tmp_qloop_537 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_538 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_537),tmp_qloop_533);
                   const __m256d tmp_qloop_541 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8]));
                   const __m256d tmp_qloop_542 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_546 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_547 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_548 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_547);
                   const __m256d tmp_qloop_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_553 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_552),tmp_qloop_548);
                   const __m256d tmp_qloop_556 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9]));
                   const __m256d tmp_qloop_557 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_561 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_562 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_563 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_562);
                   const __m256d tmp_qloop_567 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d tmp_qloop_568 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_567),tmp_qloop_563);
                   const __m256d tmp_qloop_571 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10]));
                   const __m256d tmp_qloop_572 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_576 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_573),tmp_qloop_574),tmp_qloop_575);
                   const __m256d tmp_qloop_577 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_578 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_577);
                   const __m256d tmp_qloop_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_579),tmp_qloop_580),tmp_qloop_581);
                   const __m256d tmp_qloop_583 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_582),tmp_qloop_578);
                   const __m256d tmp_qloop_584 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_157),tmp_qloop_158),tmp_qloop_159));
                   const __m256d tmp_qloop_587 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_588 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_304);
                   const __m256d tmp_qloop_590 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_587),tmp_qloop_589);
                   const __m256d tmp_qloop_591 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_590);
                   const __m256d tmp_qloop_592 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_448);
                   const __m256d tmp_qloop_595 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172));
                   const __m256d tmp_qloop_598 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_600 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_598),tmp_qloop_599);
                   const __m256d tmp_qloop_601 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_600);
                   const __m256d tmp_qloop_604 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_183),tmp_qloop_184),tmp_qloop_185));
                   const __m256d tmp_qloop_607 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_609 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_607),tmp_qloop_608);
                   const __m256d tmp_qloop_610 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_609);
                   const __m256d tmp_qloop_613 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_196),tmp_qloop_197),tmp_qloop_198));
                   const __m256d tmp_qloop_616 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_618 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_616),tmp_qloop_617);
                   const __m256d tmp_qloop_619 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_618);
                   const __m256d tmp_qloop_622 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211));
                   const __m256d tmp_qloop_625 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_627 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_625),tmp_qloop_626);
                   const __m256d tmp_qloop_628 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_627);
                   const __m256d tmp_qloop_631 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_222),tmp_qloop_223),tmp_qloop_224));
                   const __m256d tmp_qloop_634 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_636 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_634),tmp_qloop_635);
                   const __m256d tmp_qloop_637 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_636);
                   const __m256d tmp_qloop_640 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_235),tmp_qloop_236),tmp_qloop_237));
                   const __m256d tmp_qloop_643 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_645 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_643),tmp_qloop_644);
                   const __m256d tmp_qloop_646 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_645);
                   const __m256d tmp_qloop_649 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250));
                   const __m256d tmp_qloop_652 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_654 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_652),tmp_qloop_653);
                   const __m256d tmp_qloop_655 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_654);
                   const __m256d tmp_qloop_658 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263));
                   const __m256d tmp_qloop_661 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_663 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_661),tmp_qloop_662);
                   const __m256d tmp_qloop_664 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_663);
                   const __m256d tmp_qloop_668 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_667);
                   const __m256d tmp_qloop_669 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_274,tmp_qloop_275),tmp_qloop_276),tmp_qloop_668));
                   const __m256d tmp_qloop_673 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_675 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_676 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_677 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_676),tmp_qloop_143),tmp_qloop_674);
                   const __m256d tmp_qloop_679 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_676),tmp_qloop_443);
                   const __m256d tmp_qloop_680 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_676),tmp_qloop_458);
                   const __m256d tmp_qloop_681 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_676),tmp_qloop_473);
                   const __m256d tmp_qloop_682 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_676),tmp_qloop_488);
                   const __m256d tmp_qloop_683 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_676),tmp_qloop_503);
                   const __m256d tmp_qloop_684 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_676),tmp_qloop_518);
                   const __m256d tmp_qloop_685 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_676),tmp_qloop_533);
                   const __m256d tmp_qloop_686 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_676),tmp_qloop_548);
                   const __m256d tmp_qloop_687 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_676),tmp_qloop_563);
                   const __m256d tmp_qloop_688 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_676),tmp_qloop_578);
                   const __m256d tmp_qloop_689 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_305,tmp_qloop_306),tmp_qloop_307),tmp_qloop_668));
                   const __m256d tmp_qloop_692 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_693 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_679);
                   const __m256d tmp_qloop_696 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_319,tmp_qloop_320),tmp_qloop_321),tmp_qloop_668));
                   const __m256d tmp_qloop_699 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_702 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_333,tmp_qloop_334),tmp_qloop_335),tmp_qloop_668));
                   const __m256d tmp_qloop_705 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_708 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_347,tmp_qloop_348),tmp_qloop_349),tmp_qloop_668));
                   const __m256d tmp_qloop_711 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_714 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_361,tmp_qloop_362),tmp_qloop_363),tmp_qloop_668));
                   const __m256d tmp_qloop_717 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_720 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_375,tmp_qloop_376),tmp_qloop_377),tmp_qloop_668));
                   const __m256d tmp_qloop_723 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_726 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_389,tmp_qloop_390),tmp_qloop_391),tmp_qloop_668));
                   const __m256d tmp_qloop_729 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_732 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_403,tmp_qloop_404),tmp_qloop_405),tmp_qloop_668));
                   const __m256d tmp_qloop_735 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_738 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_417,tmp_qloop_418),tmp_qloop_419),tmp_qloop_668));
                   const __m256d tmp_qloop_741 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_745 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_431,tmp_qloop_432),tmp_qloop_433),tmp_qloop_744));
                   const __m256d tmp_qloop_746 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_747 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_748 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_750 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_449,tmp_qloop_450),tmp_qloop_451),tmp_qloop_744));
                   const __m256d tmp_qloop_751 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_752 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_753 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_754 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_464,tmp_qloop_465),tmp_qloop_466),tmp_qloop_744));
                   const __m256d tmp_qloop_755 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_756 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_757 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_758 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_479,tmp_qloop_480),tmp_qloop_481),tmp_qloop_744));
                   const __m256d tmp_qloop_759 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_760 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_761 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_762 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_494,tmp_qloop_495),tmp_qloop_496),tmp_qloop_744));
                   const __m256d tmp_qloop_763 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_764 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_765 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_766 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_509,tmp_qloop_510),tmp_qloop_511),tmp_qloop_744));
                   const __m256d tmp_qloop_767 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_768 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_769 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_770 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_524,tmp_qloop_525),tmp_qloop_526),tmp_qloop_744));
                   const __m256d tmp_qloop_771 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_772 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_773 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_774 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_539,tmp_qloop_540),tmp_qloop_541),tmp_qloop_744));
                   const __m256d tmp_qloop_775 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_776 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_777 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_778 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_554,tmp_qloop_555),tmp_qloop_556),tmp_qloop_744));
                   const __m256d tmp_qloop_779 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_780 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_781 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(tmp_qloop_129,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_121,tmp_qloop_122),tmp_qloop_123),tmp_qloop_127))),_mm256_mul_pd(tmp_qloop_138,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132),tmp_qloop_136))),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_161),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_165)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_169)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_160),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_178)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_182)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_187),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_191)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_195)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_186),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_200),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_204)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_208)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_213),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_217)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_221)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_212),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_226),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_230)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_234)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_225),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_239),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_243)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_247)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_238),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_252),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_256)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_260)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_251),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_265),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_269)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_273)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_264),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_290),tmp_qloop_298),tmp_qloop_304)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_312),tmp_qloop_298),tmp_qloop_318)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_308),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_326),tmp_qloop_298),tmp_qloop_332)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_322),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_340),tmp_qloop_298),tmp_qloop_346)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_336),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_354),tmp_qloop_298),tmp_qloop_360)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_350),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_368),tmp_qloop_298),tmp_qloop_374)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_364),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_382),tmp_qloop_298),tmp_qloop_388)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_378),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_396),tmp_qloop_298),tmp_qloop_402)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_392),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_410),tmp_qloop_298),tmp_qloop_416)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_406),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_424),tmp_qloop_298),tmp_qloop_430)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_420),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_439),tmp_qloop_441),tmp_qloop_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_435),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_456),tmp_qloop_441),tmp_qloop_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_452),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_471),tmp_qloop_441),tmp_qloop_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_467),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_486),tmp_qloop_441),tmp_qloop_493)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_482),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_501),tmp_qloop_441),tmp_qloop_508)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_497),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_516),tmp_qloop_441),tmp_qloop_523)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_512),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_531),tmp_qloop_441),tmp_qloop_538)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_527),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_546),tmp_qloop_441),tmp_qloop_553)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_542),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_561),tmp_qloop_441),tmp_qloop_568)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_557),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_576),tmp_qloop_441),tmp_qloop_583)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_572),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_165,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_169,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_586),tmp_qloop_588),tmp_qloop_590)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_586),tmp_qloop_318),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_586),tmp_qloop_332),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_586),tmp_qloop_346),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_586),tmp_qloop_360),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_586),tmp_qloop_374),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_586),tmp_qloop_388),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_586),tmp_qloop_402),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_586),tmp_qloop_416),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_586),tmp_qloop_430),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_587),tmp_qloop_592),tmp_qloop_593)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_587),tmp_qloop_463),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_587),tmp_qloop_478),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_587),tmp_qloop_493),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_587),tmp_qloop_508),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_587),tmp_qloop_523),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_587),tmp_qloop_538),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_587),tmp_qloop_553),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_587),tmp_qloop_568),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_587),tmp_qloop_583),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_597),tmp_qloop_588),tmp_qloop_600)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_597),tmp_qloop_318),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_597),tmp_qloop_332),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_597),tmp_qloop_346),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_597),tmp_qloop_360),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_597),tmp_qloop_374),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_597),tmp_qloop_388),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_597),tmp_qloop_402),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_597),tmp_qloop_416),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_597),tmp_qloop_430),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_598),tmp_qloop_592),tmp_qloop_602)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_598),tmp_qloop_463),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_598),tmp_qloop_478),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_598),tmp_qloop_493),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_598),tmp_qloop_508),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_598),tmp_qloop_523),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_598),tmp_qloop_538),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_598),tmp_qloop_553),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_598),tmp_qloop_568),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_598),tmp_qloop_583),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_606),tmp_qloop_588),tmp_qloop_609)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_606),tmp_qloop_318),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_606),tmp_qloop_332),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_606),tmp_qloop_346),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_606),tmp_qloop_360),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_606),tmp_qloop_374),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_606),tmp_qloop_388),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_606),tmp_qloop_402),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_606),tmp_qloop_416),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_606),tmp_qloop_430),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_607),tmp_qloop_592),tmp_qloop_611)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_607),tmp_qloop_463),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_607),tmp_qloop_478),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_607),tmp_qloop_493),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_607),tmp_qloop_508),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_607),tmp_qloop_523),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_607),tmp_qloop_538),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_607),tmp_qloop_553),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_607),tmp_qloop_568),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_607),tmp_qloop_583),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_615),tmp_qloop_588),tmp_qloop_618)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_615),tmp_qloop_318),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_615),tmp_qloop_332),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_615),tmp_qloop_346),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_615),tmp_qloop_360),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_615),tmp_qloop_374),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_615),tmp_qloop_388),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_615),tmp_qloop_402),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_615),tmp_qloop_416),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_615),tmp_qloop_430),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_616),tmp_qloop_592),tmp_qloop_620)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_616),tmp_qloop_463),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_616),tmp_qloop_478),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_616),tmp_qloop_493),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_616),tmp_qloop_508),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_616),tmp_qloop_523),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_616),tmp_qloop_538),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_616),tmp_qloop_553),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_616),tmp_qloop_568),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_616),tmp_qloop_583),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_624),tmp_qloop_588),tmp_qloop_627)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_624),tmp_qloop_318),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_624),tmp_qloop_332),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_624),tmp_qloop_346),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_624),tmp_qloop_360),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_624),tmp_qloop_374),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_624),tmp_qloop_388),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_624),tmp_qloop_402),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_624),tmp_qloop_416),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_624),tmp_qloop_430),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_625),tmp_qloop_592),tmp_qloop_629)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_625),tmp_qloop_463),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_625),tmp_qloop_478),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_625),tmp_qloop_493),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_625),tmp_qloop_508),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_625),tmp_qloop_523),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_625),tmp_qloop_538),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_625),tmp_qloop_553),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_625),tmp_qloop_568),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_625),tmp_qloop_583),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_633),tmp_qloop_588),tmp_qloop_636)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_633),tmp_qloop_318),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_633),tmp_qloop_332),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_633),tmp_qloop_346),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_633),tmp_qloop_360),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_633),tmp_qloop_374),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_633),tmp_qloop_388),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_633),tmp_qloop_402),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_633),tmp_qloop_416),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_633),tmp_qloop_430),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_634),tmp_qloop_592),tmp_qloop_638)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_634),tmp_qloop_463),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_634),tmp_qloop_478),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_634),tmp_qloop_493),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_634),tmp_qloop_508),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_634),tmp_qloop_523),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_634),tmp_qloop_538),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_634),tmp_qloop_553),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_634),tmp_qloop_568),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_634),tmp_qloop_583),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_642),tmp_qloop_588),tmp_qloop_645)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_642),tmp_qloop_318),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_642),tmp_qloop_332),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_642),tmp_qloop_346),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_642),tmp_qloop_360),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_642),tmp_qloop_374),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_642),tmp_qloop_388),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_642),tmp_qloop_402),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_642),tmp_qloop_416),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_642),tmp_qloop_430),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_643),tmp_qloop_592),tmp_qloop_647)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_643),tmp_qloop_463),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_643),tmp_qloop_478),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_643),tmp_qloop_493),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_643),tmp_qloop_508),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_643),tmp_qloop_523),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_643),tmp_qloop_538),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_643),tmp_qloop_553),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_643),tmp_qloop_568),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_643),tmp_qloop_583),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_651),tmp_qloop_588),tmp_qloop_654)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_651),tmp_qloop_318),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_651),tmp_qloop_332),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_651),tmp_qloop_346),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_651),tmp_qloop_360),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_651),tmp_qloop_374),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_651),tmp_qloop_388),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_651),tmp_qloop_402),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_651),tmp_qloop_416),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_651),tmp_qloop_430),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_652),tmp_qloop_592),tmp_qloop_656)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_652),tmp_qloop_463),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_652),tmp_qloop_478),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_652),tmp_qloop_493),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_652),tmp_qloop_508),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_652),tmp_qloop_523),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_652),tmp_qloop_538),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_652),tmp_qloop_553),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_652),tmp_qloop_568),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_652),tmp_qloop_583),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_659),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_660)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_661)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_660),tmp_qloop_588),tmp_qloop_663)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_660),tmp_qloop_318),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_660),tmp_qloop_332),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_660),tmp_qloop_346),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_660),tmp_qloop_360),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_660),tmp_qloop_374),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_660),tmp_qloop_388),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_660),tmp_qloop_402),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_660),tmp_qloop_416),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_660),tmp_qloop_430),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_661),tmp_qloop_592),tmp_qloop_665)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_661),tmp_qloop_463),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_661),tmp_qloop_478),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_661),tmp_qloop_493),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_661),tmp_qloop_508),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_661),tmp_qloop_523),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_661),tmp_qloop_538),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_661),tmp_qloop_553),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_661),tmp_qloop_568),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_661),tmp_qloop_583),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_299,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_303,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_673),tmp_qloop_678),tmp_qloop_679)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_673),tmp_qloop_678),tmp_qloop_680)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_673),tmp_qloop_678),tmp_qloop_681)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_673),tmp_qloop_678),tmp_qloop_682)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_673),tmp_qloop_678),tmp_qloop_683)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_673),tmp_qloop_678),tmp_qloop_684)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_673),tmp_qloop_678),tmp_qloop_685)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_673),tmp_qloop_678),tmp_qloop_686)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_673),tmp_qloop_678),tmp_qloop_687)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_673),tmp_qloop_678),tmp_qloop_688)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_692),tmp_qloop_693),tmp_qloop_694)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_692),tmp_qloop_680),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_692),tmp_qloop_681),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_692),tmp_qloop_682),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_692),tmp_qloop_683),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_692),tmp_qloop_684),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_692),tmp_qloop_685),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_692),tmp_qloop_686),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_692),tmp_qloop_687),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_692),tmp_qloop_688),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_699),tmp_qloop_693),tmp_qloop_700)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_699),tmp_qloop_680),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_699),tmp_qloop_681),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_699),tmp_qloop_682),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_699),tmp_qloop_683),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_699),tmp_qloop_684),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_699),tmp_qloop_685),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_699),tmp_qloop_686),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_699),tmp_qloop_687),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_699),tmp_qloop_688),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_705),tmp_qloop_693),tmp_qloop_706)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_705),tmp_qloop_680),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_705),tmp_qloop_681),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_705),tmp_qloop_682),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_705),tmp_qloop_683),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_705),tmp_qloop_684),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_705),tmp_qloop_685),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_705),tmp_qloop_686),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_705),tmp_qloop_687),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_705),tmp_qloop_688),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_711),tmp_qloop_693),tmp_qloop_712)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_711),tmp_qloop_680),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_711),tmp_qloop_681),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_711),tmp_qloop_682),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_711),tmp_qloop_683),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_711),tmp_qloop_684),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_711),tmp_qloop_685),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_711),tmp_qloop_686),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_711),tmp_qloop_687),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_711),tmp_qloop_688),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_717),tmp_qloop_693),tmp_qloop_718)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_717),tmp_qloop_680),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_717),tmp_qloop_681),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_717),tmp_qloop_682),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_717),tmp_qloop_683),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_717),tmp_qloop_684),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_717),tmp_qloop_685),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_717),tmp_qloop_686),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_717),tmp_qloop_687),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_717),tmp_qloop_688),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_723),tmp_qloop_693),tmp_qloop_724)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_723),tmp_qloop_680),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_723),tmp_qloop_681),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_723),tmp_qloop_682),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_723),tmp_qloop_683),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_723),tmp_qloop_684),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_723),tmp_qloop_685),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_723),tmp_qloop_686),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_723),tmp_qloop_687),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_723),tmp_qloop_688),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_729),tmp_qloop_693),tmp_qloop_730)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_729),tmp_qloop_680),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_729),tmp_qloop_681),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_729),tmp_qloop_682),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_729),tmp_qloop_683),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_729),tmp_qloop_684),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_729),tmp_qloop_685),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_729),tmp_qloop_686),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_729),tmp_qloop_687),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_729),tmp_qloop_688),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_735),tmp_qloop_693),tmp_qloop_736)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_735),tmp_qloop_680),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_735),tmp_qloop_681),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_735),tmp_qloop_682),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_735),tmp_qloop_683),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_735),tmp_qloop_684),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_735),tmp_qloop_685),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_735),tmp_qloop_686),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_735),tmp_qloop_687),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_735),tmp_qloop_688),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_740),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_739)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_741)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_741),tmp_qloop_693),tmp_qloop_742)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_741),tmp_qloop_680),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_741),tmp_qloop_681),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_741),tmp_qloop_682),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_741),tmp_qloop_683),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_741),tmp_qloop_684),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_741),tmp_qloop_685),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_741),tmp_qloop_686),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_741),tmp_qloop_687),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_741),tmp_qloop_688),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_442,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_447,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_577,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(1.0,1.0,1.0,1.0)))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_576,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_573,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_574,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_575,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_675)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_582,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_579,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_580,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_581,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_153)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_572),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_569,tmp_qloop_570),tmp_qloop_571),tmp_qloop_744)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_0_12 = _mm256_add_pd(q_acc_0_12,q_tmp_0_12);
                   q_acc_0_13 = _mm256_add_pd(q_acc_0_13,q_tmp_0_13);
                   q_acc_0_14 = _mm256_add_pd(q_acc_0_14,q_tmp_0_14);
                   q_acc_0_15 = _mm256_add_pd(q_acc_0_15,q_tmp_0_15);
                   q_acc_0_16 = _mm256_add_pd(q_acc_0_16,q_tmp_0_16);
                   q_acc_0_17 = _mm256_add_pd(q_acc_0_17,q_tmp_0_17);
                   q_acc_0_18 = _mm256_add_pd(q_acc_0_18,q_tmp_0_18);
                   q_acc_0_19 = _mm256_add_pd(q_acc_0_19,q_tmp_0_19);
                   q_acc_0_20 = _mm256_add_pd(q_acc_0_20,q_tmp_0_20);
                   q_acc_0_21 = _mm256_add_pd(q_acc_0_21,q_tmp_0_21);
                   q_acc_0_22 = _mm256_add_pd(q_acc_0_22,q_tmp_0_22);
                   q_acc_0_23 = _mm256_add_pd(q_acc_0_23,q_tmp_0_23);
                   q_acc_0_24 = _mm256_add_pd(q_acc_0_24,q_tmp_0_24);
                   q_acc_0_25 = _mm256_add_pd(q_acc_0_25,q_tmp_0_25);
                   q_acc_0_26 = _mm256_add_pd(q_acc_0_26,q_tmp_0_26);
                   q_acc_0_27 = _mm256_add_pd(q_acc_0_27,q_tmp_0_27);
                   q_acc_0_28 = _mm256_add_pd(q_acc_0_28,q_tmp_0_28);
                   q_acc_0_29 = _mm256_add_pd(q_acc_0_29,q_tmp_0_29);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_1_12 = _mm256_add_pd(q_acc_1_12,q_tmp_1_12);
                   q_acc_1_13 = _mm256_add_pd(q_acc_1_13,q_tmp_1_13);
                   q_acc_1_14 = _mm256_add_pd(q_acc_1_14,q_tmp_1_14);
                   q_acc_1_15 = _mm256_add_pd(q_acc_1_15,q_tmp_1_15);
                   q_acc_1_16 = _mm256_add_pd(q_acc_1_16,q_tmp_1_16);
                   q_acc_1_17 = _mm256_add_pd(q_acc_1_17,q_tmp_1_17);
                   q_acc_1_18 = _mm256_add_pd(q_acc_1_18,q_tmp_1_18);
                   q_acc_1_19 = _mm256_add_pd(q_acc_1_19,q_tmp_1_19);
                   q_acc_1_20 = _mm256_add_pd(q_acc_1_20,q_tmp_1_20);
                   q_acc_1_21 = _mm256_add_pd(q_acc_1_21,q_tmp_1_21);
                   q_acc_1_22 = _mm256_add_pd(q_acc_1_22,q_tmp_1_22);
                   q_acc_1_23 = _mm256_add_pd(q_acc_1_23,q_tmp_1_23);
                   q_acc_1_24 = _mm256_add_pd(q_acc_1_24,q_tmp_1_24);
                   q_acc_1_25 = _mm256_add_pd(q_acc_1_25,q_tmp_1_25);
                   q_acc_1_26 = _mm256_add_pd(q_acc_1_26,q_tmp_1_26);
                   q_acc_1_27 = _mm256_add_pd(q_acc_1_27,q_tmp_1_27);
                   q_acc_1_28 = _mm256_add_pd(q_acc_1_28,q_tmp_1_28);
                   q_acc_1_29 = _mm256_add_pd(q_acc_1_29,q_tmp_1_29);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_2_12 = _mm256_add_pd(q_acc_2_12,q_tmp_2_12);
                   q_acc_2_13 = _mm256_add_pd(q_acc_2_13,q_tmp_2_13);
                   q_acc_2_14 = _mm256_add_pd(q_acc_2_14,q_tmp_2_14);
                   q_acc_2_15 = _mm256_add_pd(q_acc_2_15,q_tmp_2_15);
                   q_acc_2_16 = _mm256_add_pd(q_acc_2_16,q_tmp_2_16);
                   q_acc_2_17 = _mm256_add_pd(q_acc_2_17,q_tmp_2_17);
                   q_acc_2_18 = _mm256_add_pd(q_acc_2_18,q_tmp_2_18);
                   q_acc_2_19 = _mm256_add_pd(q_acc_2_19,q_tmp_2_19);
                   q_acc_2_20 = _mm256_add_pd(q_acc_2_20,q_tmp_2_20);
                   q_acc_2_21 = _mm256_add_pd(q_acc_2_21,q_tmp_2_21);
                   q_acc_2_22 = _mm256_add_pd(q_acc_2_22,q_tmp_2_22);
                   q_acc_2_23 = _mm256_add_pd(q_acc_2_23,q_tmp_2_23);
                   q_acc_2_24 = _mm256_add_pd(q_acc_2_24,q_tmp_2_24);
                   q_acc_2_25 = _mm256_add_pd(q_acc_2_25,q_tmp_2_25);
                   q_acc_2_26 = _mm256_add_pd(q_acc_2_26,q_tmp_2_26);
                   q_acc_2_27 = _mm256_add_pd(q_acc_2_27,q_tmp_2_27);
                   q_acc_2_28 = _mm256_add_pd(q_acc_2_28,q_tmp_2_28);
                   q_acc_2_29 = _mm256_add_pd(q_acc_2_29,q_tmp_2_29);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_3_12 = _mm256_add_pd(q_acc_3_12,q_tmp_3_12);
                   q_acc_3_13 = _mm256_add_pd(q_acc_3_13,q_tmp_3_13);
                   q_acc_3_14 = _mm256_add_pd(q_acc_3_14,q_tmp_3_14);
                   q_acc_3_15 = _mm256_add_pd(q_acc_3_15,q_tmp_3_15);
                   q_acc_3_16 = _mm256_add_pd(q_acc_3_16,q_tmp_3_16);
                   q_acc_3_17 = _mm256_add_pd(q_acc_3_17,q_tmp_3_17);
                   q_acc_3_18 = _mm256_add_pd(q_acc_3_18,q_tmp_3_18);
                   q_acc_3_19 = _mm256_add_pd(q_acc_3_19,q_tmp_3_19);
                   q_acc_3_20 = _mm256_add_pd(q_acc_3_20,q_tmp_3_20);
                   q_acc_3_21 = _mm256_add_pd(q_acc_3_21,q_tmp_3_21);
                   q_acc_3_22 = _mm256_add_pd(q_acc_3_22,q_tmp_3_22);
                   q_acc_3_23 = _mm256_add_pd(q_acc_3_23,q_tmp_3_23);
                   q_acc_3_24 = _mm256_add_pd(q_acc_3_24,q_tmp_3_24);
                   q_acc_3_25 = _mm256_add_pd(q_acc_3_25,q_tmp_3_25);
                   q_acc_3_26 = _mm256_add_pd(q_acc_3_26,q_tmp_3_26);
                   q_acc_3_27 = _mm256_add_pd(q_acc_3_27,q_tmp_3_27);
                   q_acc_3_28 = _mm256_add_pd(q_acc_3_28,q_tmp_3_28);
                   q_acc_3_29 = _mm256_add_pd(q_acc_3_29,q_tmp_3_29);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_4_12 = _mm256_add_pd(q_acc_4_12,q_tmp_4_12);
                   q_acc_4_13 = _mm256_add_pd(q_acc_4_13,q_tmp_4_13);
                   q_acc_4_14 = _mm256_add_pd(q_acc_4_14,q_tmp_4_14);
                   q_acc_4_15 = _mm256_add_pd(q_acc_4_15,q_tmp_4_15);
                   q_acc_4_16 = _mm256_add_pd(q_acc_4_16,q_tmp_4_16);
                   q_acc_4_17 = _mm256_add_pd(q_acc_4_17,q_tmp_4_17);
                   q_acc_4_18 = _mm256_add_pd(q_acc_4_18,q_tmp_4_18);
                   q_acc_4_19 = _mm256_add_pd(q_acc_4_19,q_tmp_4_19);
                   q_acc_4_20 = _mm256_add_pd(q_acc_4_20,q_tmp_4_20);
                   q_acc_4_21 = _mm256_add_pd(q_acc_4_21,q_tmp_4_21);
                   q_acc_4_22 = _mm256_add_pd(q_acc_4_22,q_tmp_4_22);
                   q_acc_4_23 = _mm256_add_pd(q_acc_4_23,q_tmp_4_23);
                   q_acc_4_24 = _mm256_add_pd(q_acc_4_24,q_tmp_4_24);
                   q_acc_4_25 = _mm256_add_pd(q_acc_4_25,q_tmp_4_25);
                   q_acc_4_26 = _mm256_add_pd(q_acc_4_26,q_tmp_4_26);
                   q_acc_4_27 = _mm256_add_pd(q_acc_4_27,q_tmp_4_27);
                   q_acc_4_28 = _mm256_add_pd(q_acc_4_28,q_tmp_4_28);
                   q_acc_4_29 = _mm256_add_pd(q_acc_4_29,q_tmp_4_29);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_5_12 = _mm256_add_pd(q_acc_5_12,q_tmp_5_12);
                   q_acc_5_13 = _mm256_add_pd(q_acc_5_13,q_tmp_5_13);
                   q_acc_5_14 = _mm256_add_pd(q_acc_5_14,q_tmp_5_14);
                   q_acc_5_15 = _mm256_add_pd(q_acc_5_15,q_tmp_5_15);
                   q_acc_5_16 = _mm256_add_pd(q_acc_5_16,q_tmp_5_16);
                   q_acc_5_17 = _mm256_add_pd(q_acc_5_17,q_tmp_5_17);
                   q_acc_5_18 = _mm256_add_pd(q_acc_5_18,q_tmp_5_18);
                   q_acc_5_19 = _mm256_add_pd(q_acc_5_19,q_tmp_5_19);
                   q_acc_5_20 = _mm256_add_pd(q_acc_5_20,q_tmp_5_20);
                   q_acc_5_21 = _mm256_add_pd(q_acc_5_21,q_tmp_5_21);
                   q_acc_5_22 = _mm256_add_pd(q_acc_5_22,q_tmp_5_22);
                   q_acc_5_23 = _mm256_add_pd(q_acc_5_23,q_tmp_5_23);
                   q_acc_5_24 = _mm256_add_pd(q_acc_5_24,q_tmp_5_24);
                   q_acc_5_25 = _mm256_add_pd(q_acc_5_25,q_tmp_5_25);
                   q_acc_5_26 = _mm256_add_pd(q_acc_5_26,q_tmp_5_26);
                   q_acc_5_27 = _mm256_add_pd(q_acc_5_27,q_tmp_5_27);
                   q_acc_5_28 = _mm256_add_pd(q_acc_5_28,q_tmp_5_28);
                   q_acc_5_29 = _mm256_add_pd(q_acc_5_29,q_tmp_5_29);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_6_12 = _mm256_add_pd(q_acc_6_12,q_tmp_6_12);
                   q_acc_6_13 = _mm256_add_pd(q_acc_6_13,q_tmp_6_13);
                   q_acc_6_14 = _mm256_add_pd(q_acc_6_14,q_tmp_6_14);
                   q_acc_6_15 = _mm256_add_pd(q_acc_6_15,q_tmp_6_15);
                   q_acc_6_16 = _mm256_add_pd(q_acc_6_16,q_tmp_6_16);
                   q_acc_6_17 = _mm256_add_pd(q_acc_6_17,q_tmp_6_17);
                   q_acc_6_18 = _mm256_add_pd(q_acc_6_18,q_tmp_6_18);
                   q_acc_6_19 = _mm256_add_pd(q_acc_6_19,q_tmp_6_19);
                   q_acc_6_20 = _mm256_add_pd(q_acc_6_20,q_tmp_6_20);
                   q_acc_6_21 = _mm256_add_pd(q_acc_6_21,q_tmp_6_21);
                   q_acc_6_22 = _mm256_add_pd(q_acc_6_22,q_tmp_6_22);
                   q_acc_6_23 = _mm256_add_pd(q_acc_6_23,q_tmp_6_23);
                   q_acc_6_24 = _mm256_add_pd(q_acc_6_24,q_tmp_6_24);
                   q_acc_6_25 = _mm256_add_pd(q_acc_6_25,q_tmp_6_25);
                   q_acc_6_26 = _mm256_add_pd(q_acc_6_26,q_tmp_6_26);
                   q_acc_6_27 = _mm256_add_pd(q_acc_6_27,q_tmp_6_27);
                   q_acc_6_28 = _mm256_add_pd(q_acc_6_28,q_tmp_6_28);
                   q_acc_6_29 = _mm256_add_pd(q_acc_6_29,q_tmp_6_29);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_7_12 = _mm256_add_pd(q_acc_7_12,q_tmp_7_12);
                   q_acc_7_13 = _mm256_add_pd(q_acc_7_13,q_tmp_7_13);
                   q_acc_7_14 = _mm256_add_pd(q_acc_7_14,q_tmp_7_14);
                   q_acc_7_15 = _mm256_add_pd(q_acc_7_15,q_tmp_7_15);
                   q_acc_7_16 = _mm256_add_pd(q_acc_7_16,q_tmp_7_16);
                   q_acc_7_17 = _mm256_add_pd(q_acc_7_17,q_tmp_7_17);
                   q_acc_7_18 = _mm256_add_pd(q_acc_7_18,q_tmp_7_18);
                   q_acc_7_19 = _mm256_add_pd(q_acc_7_19,q_tmp_7_19);
                   q_acc_7_20 = _mm256_add_pd(q_acc_7_20,q_tmp_7_20);
                   q_acc_7_21 = _mm256_add_pd(q_acc_7_21,q_tmp_7_21);
                   q_acc_7_22 = _mm256_add_pd(q_acc_7_22,q_tmp_7_22);
                   q_acc_7_23 = _mm256_add_pd(q_acc_7_23,q_tmp_7_23);
                   q_acc_7_24 = _mm256_add_pd(q_acc_7_24,q_tmp_7_24);
                   q_acc_7_25 = _mm256_add_pd(q_acc_7_25,q_tmp_7_25);
                   q_acc_7_26 = _mm256_add_pd(q_acc_7_26,q_tmp_7_26);
                   q_acc_7_27 = _mm256_add_pd(q_acc_7_27,q_tmp_7_27);
                   q_acc_7_28 = _mm256_add_pd(q_acc_7_28,q_tmp_7_28);
                   q_acc_7_29 = _mm256_add_pd(q_acc_7_29,q_tmp_7_29);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_8_12 = _mm256_add_pd(q_acc_8_12,q_tmp_8_12);
                   q_acc_8_13 = _mm256_add_pd(q_acc_8_13,q_tmp_8_13);
                   q_acc_8_14 = _mm256_add_pd(q_acc_8_14,q_tmp_8_14);
                   q_acc_8_15 = _mm256_add_pd(q_acc_8_15,q_tmp_8_15);
                   q_acc_8_16 = _mm256_add_pd(q_acc_8_16,q_tmp_8_16);
                   q_acc_8_17 = _mm256_add_pd(q_acc_8_17,q_tmp_8_17);
                   q_acc_8_18 = _mm256_add_pd(q_acc_8_18,q_tmp_8_18);
                   q_acc_8_19 = _mm256_add_pd(q_acc_8_19,q_tmp_8_19);
                   q_acc_8_20 = _mm256_add_pd(q_acc_8_20,q_tmp_8_20);
                   q_acc_8_21 = _mm256_add_pd(q_acc_8_21,q_tmp_8_21);
                   q_acc_8_22 = _mm256_add_pd(q_acc_8_22,q_tmp_8_22);
                   q_acc_8_23 = _mm256_add_pd(q_acc_8_23,q_tmp_8_23);
                   q_acc_8_24 = _mm256_add_pd(q_acc_8_24,q_tmp_8_24);
                   q_acc_8_25 = _mm256_add_pd(q_acc_8_25,q_tmp_8_25);
                   q_acc_8_26 = _mm256_add_pd(q_acc_8_26,q_tmp_8_26);
                   q_acc_8_27 = _mm256_add_pd(q_acc_8_27,q_tmp_8_27);
                   q_acc_8_28 = _mm256_add_pd(q_acc_8_28,q_tmp_8_28);
                   q_acc_8_29 = _mm256_add_pd(q_acc_8_29,q_tmp_8_29);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_9_12 = _mm256_add_pd(q_acc_9_12,q_tmp_9_12);
                   q_acc_9_13 = _mm256_add_pd(q_acc_9_13,q_tmp_9_13);
                   q_acc_9_14 = _mm256_add_pd(q_acc_9_14,q_tmp_9_14);
                   q_acc_9_15 = _mm256_add_pd(q_acc_9_15,q_tmp_9_15);
                   q_acc_9_16 = _mm256_add_pd(q_acc_9_16,q_tmp_9_16);
                   q_acc_9_17 = _mm256_add_pd(q_acc_9_17,q_tmp_9_17);
                   q_acc_9_18 = _mm256_add_pd(q_acc_9_18,q_tmp_9_18);
                   q_acc_9_19 = _mm256_add_pd(q_acc_9_19,q_tmp_9_19);
                   q_acc_9_20 = _mm256_add_pd(q_acc_9_20,q_tmp_9_20);
                   q_acc_9_21 = _mm256_add_pd(q_acc_9_21,q_tmp_9_21);
                   q_acc_9_22 = _mm256_add_pd(q_acc_9_22,q_tmp_9_22);
                   q_acc_9_23 = _mm256_add_pd(q_acc_9_23,q_tmp_9_23);
                   q_acc_9_24 = _mm256_add_pd(q_acc_9_24,q_tmp_9_24);
                   q_acc_9_25 = _mm256_add_pd(q_acc_9_25,q_tmp_9_25);
                   q_acc_9_26 = _mm256_add_pd(q_acc_9_26,q_tmp_9_26);
                   q_acc_9_27 = _mm256_add_pd(q_acc_9_27,q_tmp_9_27);
                   q_acc_9_28 = _mm256_add_pd(q_acc_9_28,q_tmp_9_28);
                   q_acc_9_29 = _mm256_add_pd(q_acc_9_29,q_tmp_9_29);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_10_12 = _mm256_add_pd(q_acc_10_12,q_tmp_10_12);
                   q_acc_10_13 = _mm256_add_pd(q_acc_10_13,q_tmp_10_13);
                   q_acc_10_14 = _mm256_add_pd(q_acc_10_14,q_tmp_10_14);
                   q_acc_10_15 = _mm256_add_pd(q_acc_10_15,q_tmp_10_15);
                   q_acc_10_16 = _mm256_add_pd(q_acc_10_16,q_tmp_10_16);
                   q_acc_10_17 = _mm256_add_pd(q_acc_10_17,q_tmp_10_17);
                   q_acc_10_18 = _mm256_add_pd(q_acc_10_18,q_tmp_10_18);
                   q_acc_10_19 = _mm256_add_pd(q_acc_10_19,q_tmp_10_19);
                   q_acc_10_20 = _mm256_add_pd(q_acc_10_20,q_tmp_10_20);
                   q_acc_10_21 = _mm256_add_pd(q_acc_10_21,q_tmp_10_21);
                   q_acc_10_22 = _mm256_add_pd(q_acc_10_22,q_tmp_10_22);
                   q_acc_10_23 = _mm256_add_pd(q_acc_10_23,q_tmp_10_23);
                   q_acc_10_24 = _mm256_add_pd(q_acc_10_24,q_tmp_10_24);
                   q_acc_10_25 = _mm256_add_pd(q_acc_10_25,q_tmp_10_25);
                   q_acc_10_26 = _mm256_add_pd(q_acc_10_26,q_tmp_10_26);
                   q_acc_10_27 = _mm256_add_pd(q_acc_10_27,q_tmp_10_27);
                   q_acc_10_28 = _mm256_add_pd(q_acc_10_28,q_tmp_10_28);
                   q_acc_10_29 = _mm256_add_pd(q_acc_10_29,q_tmp_10_29);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_11_12 = _mm256_add_pd(q_acc_11_12,q_tmp_11_12);
                   q_acc_11_13 = _mm256_add_pd(q_acc_11_13,q_tmp_11_13);
                   q_acc_11_14 = _mm256_add_pd(q_acc_11_14,q_tmp_11_14);
                   q_acc_11_15 = _mm256_add_pd(q_acc_11_15,q_tmp_11_15);
                   q_acc_11_16 = _mm256_add_pd(q_acc_11_16,q_tmp_11_16);
                   q_acc_11_17 = _mm256_add_pd(q_acc_11_17,q_tmp_11_17);
                   q_acc_11_18 = _mm256_add_pd(q_acc_11_18,q_tmp_11_18);
                   q_acc_11_19 = _mm256_add_pd(q_acc_11_19,q_tmp_11_19);
                   q_acc_11_20 = _mm256_add_pd(q_acc_11_20,q_tmp_11_20);
                   q_acc_11_21 = _mm256_add_pd(q_acc_11_21,q_tmp_11_21);
                   q_acc_11_22 = _mm256_add_pd(q_acc_11_22,q_tmp_11_22);
                   q_acc_11_23 = _mm256_add_pd(q_acc_11_23,q_tmp_11_23);
                   q_acc_11_24 = _mm256_add_pd(q_acc_11_24,q_tmp_11_24);
                   q_acc_11_25 = _mm256_add_pd(q_acc_11_25,q_tmp_11_25);
                   q_acc_11_26 = _mm256_add_pd(q_acc_11_26,q_tmp_11_26);
                   q_acc_11_27 = _mm256_add_pd(q_acc_11_27,q_tmp_11_27);
                   q_acc_11_28 = _mm256_add_pd(q_acc_11_28,q_tmp_11_28);
                   q_acc_11_29 = _mm256_add_pd(q_acc_11_29,q_tmp_11_29);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_12_13 = _mm256_add_pd(q_acc_12_13,q_tmp_12_13);
                   q_acc_12_14 = _mm256_add_pd(q_acc_12_14,q_tmp_12_14);
                   q_acc_12_15 = _mm256_add_pd(q_acc_12_15,q_tmp_12_15);
                   q_acc_12_16 = _mm256_add_pd(q_acc_12_16,q_tmp_12_16);
                   q_acc_12_17 = _mm256_add_pd(q_acc_12_17,q_tmp_12_17);
                   q_acc_12_18 = _mm256_add_pd(q_acc_12_18,q_tmp_12_18);
                   q_acc_12_19 = _mm256_add_pd(q_acc_12_19,q_tmp_12_19);
                   q_acc_12_20 = _mm256_add_pd(q_acc_12_20,q_tmp_12_20);
                   q_acc_12_21 = _mm256_add_pd(q_acc_12_21,q_tmp_12_21);
                   q_acc_12_22 = _mm256_add_pd(q_acc_12_22,q_tmp_12_22);
                   q_acc_12_23 = _mm256_add_pd(q_acc_12_23,q_tmp_12_23);
                   q_acc_12_24 = _mm256_add_pd(q_acc_12_24,q_tmp_12_24);
                   q_acc_12_25 = _mm256_add_pd(q_acc_12_25,q_tmp_12_25);
                   q_acc_12_26 = _mm256_add_pd(q_acc_12_26,q_tmp_12_26);
                   q_acc_12_27 = _mm256_add_pd(q_acc_12_27,q_tmp_12_27);
                   q_acc_12_28 = _mm256_add_pd(q_acc_12_28,q_tmp_12_28);
                   q_acc_12_29 = _mm256_add_pd(q_acc_12_29,q_tmp_12_29);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_13_14 = _mm256_add_pd(q_acc_13_14,q_tmp_13_14);
                   q_acc_13_15 = _mm256_add_pd(q_acc_13_15,q_tmp_13_15);
                   q_acc_13_16 = _mm256_add_pd(q_acc_13_16,q_tmp_13_16);
                   q_acc_13_17 = _mm256_add_pd(q_acc_13_17,q_tmp_13_17);
                   q_acc_13_18 = _mm256_add_pd(q_acc_13_18,q_tmp_13_18);
                   q_acc_13_19 = _mm256_add_pd(q_acc_13_19,q_tmp_13_19);
                   q_acc_13_20 = _mm256_add_pd(q_acc_13_20,q_tmp_13_20);
                   q_acc_13_21 = _mm256_add_pd(q_acc_13_21,q_tmp_13_21);
                   q_acc_13_22 = _mm256_add_pd(q_acc_13_22,q_tmp_13_22);
                   q_acc_13_23 = _mm256_add_pd(q_acc_13_23,q_tmp_13_23);
                   q_acc_13_24 = _mm256_add_pd(q_acc_13_24,q_tmp_13_24);
                   q_acc_13_25 = _mm256_add_pd(q_acc_13_25,q_tmp_13_25);
                   q_acc_13_26 = _mm256_add_pd(q_acc_13_26,q_tmp_13_26);
                   q_acc_13_27 = _mm256_add_pd(q_acc_13_27,q_tmp_13_27);
                   q_acc_13_28 = _mm256_add_pd(q_acc_13_28,q_tmp_13_28);
                   q_acc_13_29 = _mm256_add_pd(q_acc_13_29,q_tmp_13_29);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_14_15 = _mm256_add_pd(q_acc_14_15,q_tmp_14_15);
                   q_acc_14_16 = _mm256_add_pd(q_acc_14_16,q_tmp_14_16);
                   q_acc_14_17 = _mm256_add_pd(q_acc_14_17,q_tmp_14_17);
                   q_acc_14_18 = _mm256_add_pd(q_acc_14_18,q_tmp_14_18);
                   q_acc_14_19 = _mm256_add_pd(q_acc_14_19,q_tmp_14_19);
                   q_acc_14_20 = _mm256_add_pd(q_acc_14_20,q_tmp_14_20);
                   q_acc_14_21 = _mm256_add_pd(q_acc_14_21,q_tmp_14_21);
                   q_acc_14_22 = _mm256_add_pd(q_acc_14_22,q_tmp_14_22);
                   q_acc_14_23 = _mm256_add_pd(q_acc_14_23,q_tmp_14_23);
                   q_acc_14_24 = _mm256_add_pd(q_acc_14_24,q_tmp_14_24);
                   q_acc_14_25 = _mm256_add_pd(q_acc_14_25,q_tmp_14_25);
                   q_acc_14_26 = _mm256_add_pd(q_acc_14_26,q_tmp_14_26);
                   q_acc_14_27 = _mm256_add_pd(q_acc_14_27,q_tmp_14_27);
                   q_acc_14_28 = _mm256_add_pd(q_acc_14_28,q_tmp_14_28);
                   q_acc_14_29 = _mm256_add_pd(q_acc_14_29,q_tmp_14_29);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_15_16 = _mm256_add_pd(q_acc_15_16,q_tmp_15_16);
                   q_acc_15_17 = _mm256_add_pd(q_acc_15_17,q_tmp_15_17);
                   q_acc_15_18 = _mm256_add_pd(q_acc_15_18,q_tmp_15_18);
                   q_acc_15_19 = _mm256_add_pd(q_acc_15_19,q_tmp_15_19);
                   q_acc_15_20 = _mm256_add_pd(q_acc_15_20,q_tmp_15_20);
                   q_acc_15_21 = _mm256_add_pd(q_acc_15_21,q_tmp_15_21);
                   q_acc_15_22 = _mm256_add_pd(q_acc_15_22,q_tmp_15_22);
                   q_acc_15_23 = _mm256_add_pd(q_acc_15_23,q_tmp_15_23);
                   q_acc_15_24 = _mm256_add_pd(q_acc_15_24,q_tmp_15_24);
                   q_acc_15_25 = _mm256_add_pd(q_acc_15_25,q_tmp_15_25);
                   q_acc_15_26 = _mm256_add_pd(q_acc_15_26,q_tmp_15_26);
                   q_acc_15_27 = _mm256_add_pd(q_acc_15_27,q_tmp_15_27);
                   q_acc_15_28 = _mm256_add_pd(q_acc_15_28,q_tmp_15_28);
                   q_acc_15_29 = _mm256_add_pd(q_acc_15_29,q_tmp_15_29);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_16_17 = _mm256_add_pd(q_acc_16_17,q_tmp_16_17);
                   q_acc_16_18 = _mm256_add_pd(q_acc_16_18,q_tmp_16_18);
                   q_acc_16_19 = _mm256_add_pd(q_acc_16_19,q_tmp_16_19);
                   q_acc_16_20 = _mm256_add_pd(q_acc_16_20,q_tmp_16_20);
                   q_acc_16_21 = _mm256_add_pd(q_acc_16_21,q_tmp_16_21);
                   q_acc_16_22 = _mm256_add_pd(q_acc_16_22,q_tmp_16_22);
                   q_acc_16_23 = _mm256_add_pd(q_acc_16_23,q_tmp_16_23);
                   q_acc_16_24 = _mm256_add_pd(q_acc_16_24,q_tmp_16_24);
                   q_acc_16_25 = _mm256_add_pd(q_acc_16_25,q_tmp_16_25);
                   q_acc_16_26 = _mm256_add_pd(q_acc_16_26,q_tmp_16_26);
                   q_acc_16_27 = _mm256_add_pd(q_acc_16_27,q_tmp_16_27);
                   q_acc_16_28 = _mm256_add_pd(q_acc_16_28,q_tmp_16_28);
                   q_acc_16_29 = _mm256_add_pd(q_acc_16_29,q_tmp_16_29);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_17_18 = _mm256_add_pd(q_acc_17_18,q_tmp_17_18);
                   q_acc_17_19 = _mm256_add_pd(q_acc_17_19,q_tmp_17_19);
                   q_acc_17_20 = _mm256_add_pd(q_acc_17_20,q_tmp_17_20);
                   q_acc_17_21 = _mm256_add_pd(q_acc_17_21,q_tmp_17_21);
                   q_acc_17_22 = _mm256_add_pd(q_acc_17_22,q_tmp_17_22);
                   q_acc_17_23 = _mm256_add_pd(q_acc_17_23,q_tmp_17_23);
                   q_acc_17_24 = _mm256_add_pd(q_acc_17_24,q_tmp_17_24);
                   q_acc_17_25 = _mm256_add_pd(q_acc_17_25,q_tmp_17_25);
                   q_acc_17_26 = _mm256_add_pd(q_acc_17_26,q_tmp_17_26);
                   q_acc_17_27 = _mm256_add_pd(q_acc_17_27,q_tmp_17_27);
                   q_acc_17_28 = _mm256_add_pd(q_acc_17_28,q_tmp_17_28);
                   q_acc_17_29 = _mm256_add_pd(q_acc_17_29,q_tmp_17_29);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_18_19 = _mm256_add_pd(q_acc_18_19,q_tmp_18_19);
                   q_acc_18_20 = _mm256_add_pd(q_acc_18_20,q_tmp_18_20);
                   q_acc_18_21 = _mm256_add_pd(q_acc_18_21,q_tmp_18_21);
                   q_acc_18_22 = _mm256_add_pd(q_acc_18_22,q_tmp_18_22);
                   q_acc_18_23 = _mm256_add_pd(q_acc_18_23,q_tmp_18_23);
                   q_acc_18_24 = _mm256_add_pd(q_acc_18_24,q_tmp_18_24);
                   q_acc_18_25 = _mm256_add_pd(q_acc_18_25,q_tmp_18_25);
                   q_acc_18_26 = _mm256_add_pd(q_acc_18_26,q_tmp_18_26);
                   q_acc_18_27 = _mm256_add_pd(q_acc_18_27,q_tmp_18_27);
                   q_acc_18_28 = _mm256_add_pd(q_acc_18_28,q_tmp_18_28);
                   q_acc_18_29 = _mm256_add_pd(q_acc_18_29,q_tmp_18_29);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_19_20 = _mm256_add_pd(q_acc_19_20,q_tmp_19_20);
                   q_acc_19_21 = _mm256_add_pd(q_acc_19_21,q_tmp_19_21);
                   q_acc_19_22 = _mm256_add_pd(q_acc_19_22,q_tmp_19_22);
                   q_acc_19_23 = _mm256_add_pd(q_acc_19_23,q_tmp_19_23);
                   q_acc_19_24 = _mm256_add_pd(q_acc_19_24,q_tmp_19_24);
                   q_acc_19_25 = _mm256_add_pd(q_acc_19_25,q_tmp_19_25);
                   q_acc_19_26 = _mm256_add_pd(q_acc_19_26,q_tmp_19_26);
                   q_acc_19_27 = _mm256_add_pd(q_acc_19_27,q_tmp_19_27);
                   q_acc_19_28 = _mm256_add_pd(q_acc_19_28,q_tmp_19_28);
                   q_acc_19_29 = _mm256_add_pd(q_acc_19_29,q_tmp_19_29);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_20_21 = _mm256_add_pd(q_acc_20_21,q_tmp_20_21);
                   q_acc_20_22 = _mm256_add_pd(q_acc_20_22,q_tmp_20_22);
                   q_acc_20_23 = _mm256_add_pd(q_acc_20_23,q_tmp_20_23);
                   q_acc_20_24 = _mm256_add_pd(q_acc_20_24,q_tmp_20_24);
                   q_acc_20_25 = _mm256_add_pd(q_acc_20_25,q_tmp_20_25);
                   q_acc_20_26 = _mm256_add_pd(q_acc_20_26,q_tmp_20_26);
                   q_acc_20_27 = _mm256_add_pd(q_acc_20_27,q_tmp_20_27);
                   q_acc_20_28 = _mm256_add_pd(q_acc_20_28,q_tmp_20_28);
                   q_acc_20_29 = _mm256_add_pd(q_acc_20_29,q_tmp_20_29);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_21_22 = _mm256_add_pd(q_acc_21_22,q_tmp_21_22);
                   q_acc_21_23 = _mm256_add_pd(q_acc_21_23,q_tmp_21_23);
                   q_acc_21_24 = _mm256_add_pd(q_acc_21_24,q_tmp_21_24);
                   q_acc_21_25 = _mm256_add_pd(q_acc_21_25,q_tmp_21_25);
                   q_acc_21_26 = _mm256_add_pd(q_acc_21_26,q_tmp_21_26);
                   q_acc_21_27 = _mm256_add_pd(q_acc_21_27,q_tmp_21_27);
                   q_acc_21_28 = _mm256_add_pd(q_acc_21_28,q_tmp_21_28);
                   q_acc_21_29 = _mm256_add_pd(q_acc_21_29,q_tmp_21_29);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_22_23 = _mm256_add_pd(q_acc_22_23,q_tmp_22_23);
                   q_acc_22_24 = _mm256_add_pd(q_acc_22_24,q_tmp_22_24);
                   q_acc_22_25 = _mm256_add_pd(q_acc_22_25,q_tmp_22_25);
                   q_acc_22_26 = _mm256_add_pd(q_acc_22_26,q_tmp_22_26);
                   q_acc_22_27 = _mm256_add_pd(q_acc_22_27,q_tmp_22_27);
                   q_acc_22_28 = _mm256_add_pd(q_acc_22_28,q_tmp_22_28);
                   q_acc_22_29 = _mm256_add_pd(q_acc_22_29,q_tmp_22_29);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_23_24 = _mm256_add_pd(q_acc_23_24,q_tmp_23_24);
                   q_acc_23_25 = _mm256_add_pd(q_acc_23_25,q_tmp_23_25);
                   q_acc_23_26 = _mm256_add_pd(q_acc_23_26,q_tmp_23_26);
                   q_acc_23_27 = _mm256_add_pd(q_acc_23_27,q_tmp_23_27);
                   q_acc_23_28 = _mm256_add_pd(q_acc_23_28,q_tmp_23_28);
                   q_acc_23_29 = _mm256_add_pd(q_acc_23_29,q_tmp_23_29);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_24_25 = _mm256_add_pd(q_acc_24_25,q_tmp_24_25);
                   q_acc_24_26 = _mm256_add_pd(q_acc_24_26,q_tmp_24_26);
                   q_acc_24_27 = _mm256_add_pd(q_acc_24_27,q_tmp_24_27);
                   q_acc_24_28 = _mm256_add_pd(q_acc_24_28,q_tmp_24_28);
                   q_acc_24_29 = _mm256_add_pd(q_acc_24_29,q_tmp_24_29);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_25_26 = _mm256_add_pd(q_acc_25_26,q_tmp_25_26);
                   q_acc_25_27 = _mm256_add_pd(q_acc_25_27,q_tmp_25_27);
                   q_acc_25_28 = _mm256_add_pd(q_acc_25_28,q_tmp_25_28);
                   q_acc_25_29 = _mm256_add_pd(q_acc_25_29,q_tmp_25_29);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_26_27 = _mm256_add_pd(q_acc_26_27,q_tmp_26_27);
                   q_acc_26_28 = _mm256_add_pd(q_acc_26_28,q_tmp_26_28);
                   q_acc_26_29 = _mm256_add_pd(q_acc_26_29,q_tmp_26_29);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_27_28 = _mm256_add_pd(q_acc_27_28,q_tmp_27_28);
                   q_acc_27_29 = _mm256_add_pd(q_acc_27_29,q_tmp_27_29);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_28_29 = _mm256_add_pd(q_acc_28_29,q_tmp_28_29);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_12,src_dof_12)),_mm256_mul_pd(q_acc_0_13,src_dof_13)),_mm256_mul_pd(q_acc_0_14,src_dof_14)),_mm256_mul_pd(q_acc_0_15,src_dof_15)),_mm256_mul_pd(q_acc_0_16,src_dof_16)),_mm256_mul_pd(q_acc_0_17,src_dof_17)),_mm256_mul_pd(q_acc_0_18,src_dof_18)),_mm256_mul_pd(q_acc_0_19,src_dof_19)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_20,src_dof_20)),_mm256_mul_pd(q_acc_0_21,src_dof_21)),_mm256_mul_pd(q_acc_0_22,src_dof_22)),_mm256_mul_pd(q_acc_0_23,src_dof_23)),_mm256_mul_pd(q_acc_0_24,src_dof_24)),_mm256_mul_pd(q_acc_0_25,src_dof_25)),_mm256_mul_pd(q_acc_0_26,src_dof_26)),_mm256_mul_pd(q_acc_0_27,src_dof_27)),_mm256_mul_pd(q_acc_0_28,src_dof_28)),_mm256_mul_pd(q_acc_0_29,src_dof_29)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_12,src_dof_12)),_mm256_mul_pd(q_acc_1_13,src_dof_13)),_mm256_mul_pd(q_acc_1_14,src_dof_14)),_mm256_mul_pd(q_acc_1_15,src_dof_15)),_mm256_mul_pd(q_acc_1_16,src_dof_16)),_mm256_mul_pd(q_acc_1_17,src_dof_17)),_mm256_mul_pd(q_acc_1_18,src_dof_18)),_mm256_mul_pd(q_acc_1_19,src_dof_19)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_20,src_dof_20)),_mm256_mul_pd(q_acc_1_21,src_dof_21)),_mm256_mul_pd(q_acc_1_22,src_dof_22)),_mm256_mul_pd(q_acc_1_23,src_dof_23)),_mm256_mul_pd(q_acc_1_24,src_dof_24)),_mm256_mul_pd(q_acc_1_25,src_dof_25)),_mm256_mul_pd(q_acc_1_26,src_dof_26)),_mm256_mul_pd(q_acc_1_27,src_dof_27)),_mm256_mul_pd(q_acc_1_28,src_dof_28)),_mm256_mul_pd(q_acc_1_29,src_dof_29)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_12,src_dof_12)),_mm256_mul_pd(q_acc_2_13,src_dof_13)),_mm256_mul_pd(q_acc_2_14,src_dof_14)),_mm256_mul_pd(q_acc_2_15,src_dof_15)),_mm256_mul_pd(q_acc_2_16,src_dof_16)),_mm256_mul_pd(q_acc_2_17,src_dof_17)),_mm256_mul_pd(q_acc_2_18,src_dof_18)),_mm256_mul_pd(q_acc_2_19,src_dof_19)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_20,src_dof_20)),_mm256_mul_pd(q_acc_2_21,src_dof_21)),_mm256_mul_pd(q_acc_2_22,src_dof_22)),_mm256_mul_pd(q_acc_2_23,src_dof_23)),_mm256_mul_pd(q_acc_2_24,src_dof_24)),_mm256_mul_pd(q_acc_2_25,src_dof_25)),_mm256_mul_pd(q_acc_2_26,src_dof_26)),_mm256_mul_pd(q_acc_2_27,src_dof_27)),_mm256_mul_pd(q_acc_2_28,src_dof_28)),_mm256_mul_pd(q_acc_2_29,src_dof_29)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_12,src_dof_12)),_mm256_mul_pd(q_acc_3_13,src_dof_13)),_mm256_mul_pd(q_acc_3_14,src_dof_14)),_mm256_mul_pd(q_acc_3_15,src_dof_15)),_mm256_mul_pd(q_acc_3_16,src_dof_16)),_mm256_mul_pd(q_acc_3_17,src_dof_17)),_mm256_mul_pd(q_acc_3_18,src_dof_18)),_mm256_mul_pd(q_acc_3_19,src_dof_19)),_mm256_mul_pd(q_acc_3_20,src_dof_20)),_mm256_mul_pd(q_acc_3_21,src_dof_21)),_mm256_mul_pd(q_acc_3_22,src_dof_22)),_mm256_mul_pd(q_acc_3_23,src_dof_23)),_mm256_mul_pd(q_acc_3_24,src_dof_24)),_mm256_mul_pd(q_acc_3_25,src_dof_25)),_mm256_mul_pd(q_acc_3_26,src_dof_26)),_mm256_mul_pd(q_acc_3_27,src_dof_27)),_mm256_mul_pd(q_acc_3_28,src_dof_28)),_mm256_mul_pd(q_acc_3_29,src_dof_29)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_12,src_dof_12)),_mm256_mul_pd(q_acc_4_13,src_dof_13)),_mm256_mul_pd(q_acc_4_14,src_dof_14)),_mm256_mul_pd(q_acc_4_15,src_dof_15)),_mm256_mul_pd(q_acc_4_16,src_dof_16)),_mm256_mul_pd(q_acc_4_17,src_dof_17)),_mm256_mul_pd(q_acc_4_18,src_dof_18)),_mm256_mul_pd(q_acc_4_19,src_dof_19)),_mm256_mul_pd(q_acc_4_20,src_dof_20)),_mm256_mul_pd(q_acc_4_21,src_dof_21)),_mm256_mul_pd(q_acc_4_22,src_dof_22)),_mm256_mul_pd(q_acc_4_23,src_dof_23)),_mm256_mul_pd(q_acc_4_24,src_dof_24)),_mm256_mul_pd(q_acc_4_25,src_dof_25)),_mm256_mul_pd(q_acc_4_26,src_dof_26)),_mm256_mul_pd(q_acc_4_27,src_dof_27)),_mm256_mul_pd(q_acc_4_28,src_dof_28)),_mm256_mul_pd(q_acc_4_29,src_dof_29)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_12,src_dof_12)),_mm256_mul_pd(q_acc_5_13,src_dof_13)),_mm256_mul_pd(q_acc_5_14,src_dof_14)),_mm256_mul_pd(q_acc_5_15,src_dof_15)),_mm256_mul_pd(q_acc_5_16,src_dof_16)),_mm256_mul_pd(q_acc_5_17,src_dof_17)),_mm256_mul_pd(q_acc_5_18,src_dof_18)),_mm256_mul_pd(q_acc_5_19,src_dof_19)),_mm256_mul_pd(q_acc_5_20,src_dof_20)),_mm256_mul_pd(q_acc_5_21,src_dof_21)),_mm256_mul_pd(q_acc_5_22,src_dof_22)),_mm256_mul_pd(q_acc_5_23,src_dof_23)),_mm256_mul_pd(q_acc_5_24,src_dof_24)),_mm256_mul_pd(q_acc_5_25,src_dof_25)),_mm256_mul_pd(q_acc_5_26,src_dof_26)),_mm256_mul_pd(q_acc_5_27,src_dof_27)),_mm256_mul_pd(q_acc_5_28,src_dof_28)),_mm256_mul_pd(q_acc_5_29,src_dof_29)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_12,src_dof_12)),_mm256_mul_pd(q_acc_6_13,src_dof_13)),_mm256_mul_pd(q_acc_6_14,src_dof_14)),_mm256_mul_pd(q_acc_6_15,src_dof_15)),_mm256_mul_pd(q_acc_6_16,src_dof_16)),_mm256_mul_pd(q_acc_6_17,src_dof_17)),_mm256_mul_pd(q_acc_6_18,src_dof_18)),_mm256_mul_pd(q_acc_6_19,src_dof_19)),_mm256_mul_pd(q_acc_6_20,src_dof_20)),_mm256_mul_pd(q_acc_6_21,src_dof_21)),_mm256_mul_pd(q_acc_6_22,src_dof_22)),_mm256_mul_pd(q_acc_6_23,src_dof_23)),_mm256_mul_pd(q_acc_6_24,src_dof_24)),_mm256_mul_pd(q_acc_6_25,src_dof_25)),_mm256_mul_pd(q_acc_6_26,src_dof_26)),_mm256_mul_pd(q_acc_6_27,src_dof_27)),_mm256_mul_pd(q_acc_6_28,src_dof_28)),_mm256_mul_pd(q_acc_6_29,src_dof_29)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_12,src_dof_12)),_mm256_mul_pd(q_acc_7_13,src_dof_13)),_mm256_mul_pd(q_acc_7_14,src_dof_14)),_mm256_mul_pd(q_acc_7_15,src_dof_15)),_mm256_mul_pd(q_acc_7_16,src_dof_16)),_mm256_mul_pd(q_acc_7_17,src_dof_17)),_mm256_mul_pd(q_acc_7_18,src_dof_18)),_mm256_mul_pd(q_acc_7_19,src_dof_19)),_mm256_mul_pd(q_acc_7_20,src_dof_20)),_mm256_mul_pd(q_acc_7_21,src_dof_21)),_mm256_mul_pd(q_acc_7_22,src_dof_22)),_mm256_mul_pd(q_acc_7_23,src_dof_23)),_mm256_mul_pd(q_acc_7_24,src_dof_24)),_mm256_mul_pd(q_acc_7_25,src_dof_25)),_mm256_mul_pd(q_acc_7_26,src_dof_26)),_mm256_mul_pd(q_acc_7_27,src_dof_27)),_mm256_mul_pd(q_acc_7_28,src_dof_28)),_mm256_mul_pd(q_acc_7_29,src_dof_29)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_12,src_dof_12)),_mm256_mul_pd(q_acc_8_13,src_dof_13)),_mm256_mul_pd(q_acc_8_14,src_dof_14)),_mm256_mul_pd(q_acc_8_15,src_dof_15)),_mm256_mul_pd(q_acc_8_16,src_dof_16)),_mm256_mul_pd(q_acc_8_17,src_dof_17)),_mm256_mul_pd(q_acc_8_18,src_dof_18)),_mm256_mul_pd(q_acc_8_19,src_dof_19)),_mm256_mul_pd(q_acc_8_20,src_dof_20)),_mm256_mul_pd(q_acc_8_21,src_dof_21)),_mm256_mul_pd(q_acc_8_22,src_dof_22)),_mm256_mul_pd(q_acc_8_23,src_dof_23)),_mm256_mul_pd(q_acc_8_24,src_dof_24)),_mm256_mul_pd(q_acc_8_25,src_dof_25)),_mm256_mul_pd(q_acc_8_26,src_dof_26)),_mm256_mul_pd(q_acc_8_27,src_dof_27)),_mm256_mul_pd(q_acc_8_28,src_dof_28)),_mm256_mul_pd(q_acc_8_29,src_dof_29)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_12,src_dof_12)),_mm256_mul_pd(q_acc_9_13,src_dof_13)),_mm256_mul_pd(q_acc_9_14,src_dof_14)),_mm256_mul_pd(q_acc_9_15,src_dof_15)),_mm256_mul_pd(q_acc_9_16,src_dof_16)),_mm256_mul_pd(q_acc_9_17,src_dof_17)),_mm256_mul_pd(q_acc_9_18,src_dof_18)),_mm256_mul_pd(q_acc_9_19,src_dof_19)),_mm256_mul_pd(q_acc_9_20,src_dof_20)),_mm256_mul_pd(q_acc_9_21,src_dof_21)),_mm256_mul_pd(q_acc_9_22,src_dof_22)),_mm256_mul_pd(q_acc_9_23,src_dof_23)),_mm256_mul_pd(q_acc_9_24,src_dof_24)),_mm256_mul_pd(q_acc_9_25,src_dof_25)),_mm256_mul_pd(q_acc_9_26,src_dof_26)),_mm256_mul_pd(q_acc_9_27,src_dof_27)),_mm256_mul_pd(q_acc_9_28,src_dof_28)),_mm256_mul_pd(q_acc_9_29,src_dof_29)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_10_12,src_dof_12)),_mm256_mul_pd(q_acc_10_13,src_dof_13)),_mm256_mul_pd(q_acc_10_14,src_dof_14)),_mm256_mul_pd(q_acc_10_15,src_dof_15)),_mm256_mul_pd(q_acc_10_16,src_dof_16)),_mm256_mul_pd(q_acc_10_17,src_dof_17)),_mm256_mul_pd(q_acc_10_18,src_dof_18)),_mm256_mul_pd(q_acc_10_19,src_dof_19)),_mm256_mul_pd(q_acc_10_20,src_dof_20)),_mm256_mul_pd(q_acc_10_21,src_dof_21)),_mm256_mul_pd(q_acc_10_22,src_dof_22)),_mm256_mul_pd(q_acc_10_23,src_dof_23)),_mm256_mul_pd(q_acc_10_24,src_dof_24)),_mm256_mul_pd(q_acc_10_25,src_dof_25)),_mm256_mul_pd(q_acc_10_26,src_dof_26)),_mm256_mul_pd(q_acc_10_27,src_dof_27)),_mm256_mul_pd(q_acc_10_28,src_dof_28)),_mm256_mul_pd(q_acc_10_29,src_dof_29)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_11_12,src_dof_12)),_mm256_mul_pd(q_acc_11_13,src_dof_13)),_mm256_mul_pd(q_acc_11_14,src_dof_14)),_mm256_mul_pd(q_acc_11_15,src_dof_15)),_mm256_mul_pd(q_acc_11_16,src_dof_16)),_mm256_mul_pd(q_acc_11_17,src_dof_17)),_mm256_mul_pd(q_acc_11_18,src_dof_18)),_mm256_mul_pd(q_acc_11_19,src_dof_19)),_mm256_mul_pd(q_acc_11_20,src_dof_20)),_mm256_mul_pd(q_acc_11_21,src_dof_21)),_mm256_mul_pd(q_acc_11_22,src_dof_22)),_mm256_mul_pd(q_acc_11_23,src_dof_23)),_mm256_mul_pd(q_acc_11_24,src_dof_24)),_mm256_mul_pd(q_acc_11_25,src_dof_25)),_mm256_mul_pd(q_acc_11_26,src_dof_26)),_mm256_mul_pd(q_acc_11_27,src_dof_27)),_mm256_mul_pd(q_acc_11_28,src_dof_28)),_mm256_mul_pd(q_acc_11_29,src_dof_29)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                const __m256d elMatVec_12 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_12,src_dof_0),_mm256_mul_pd(q_acc_10_12,src_dof_10)),_mm256_mul_pd(q_acc_11_12,src_dof_11)),_mm256_mul_pd(q_acc_12_12,src_dof_12)),_mm256_mul_pd(q_acc_12_13,src_dof_13)),_mm256_mul_pd(q_acc_12_14,src_dof_14)),_mm256_mul_pd(q_acc_12_15,src_dof_15)),_mm256_mul_pd(q_acc_12_16,src_dof_16)),_mm256_mul_pd(q_acc_12_17,src_dof_17)),_mm256_mul_pd(q_acc_12_18,src_dof_18)),_mm256_mul_pd(q_acc_12_19,src_dof_19)),_mm256_mul_pd(q_acc_12_20,src_dof_20)),_mm256_mul_pd(q_acc_12_21,src_dof_21)),_mm256_mul_pd(q_acc_12_22,src_dof_22)),_mm256_mul_pd(q_acc_12_23,src_dof_23)),_mm256_mul_pd(q_acc_12_24,src_dof_24)),_mm256_mul_pd(q_acc_12_25,src_dof_25)),_mm256_mul_pd(q_acc_12_26,src_dof_26)),_mm256_mul_pd(q_acc_12_27,src_dof_27)),_mm256_mul_pd(q_acc_12_28,src_dof_28)),_mm256_mul_pd(q_acc_12_29,src_dof_29)),_mm256_mul_pd(q_acc_1_12,src_dof_1)),_mm256_mul_pd(q_acc_2_12,src_dof_2)),_mm256_mul_pd(q_acc_3_12,src_dof_3)),_mm256_mul_pd(q_acc_4_12,src_dof_4)),_mm256_mul_pd(q_acc_5_12,src_dof_5)),_mm256_mul_pd(q_acc_6_12,src_dof_6)),_mm256_mul_pd(q_acc_7_12,src_dof_7)),_mm256_mul_pd(q_acc_8_12,src_dof_8)),_mm256_mul_pd(q_acc_9_12,src_dof_9));
                const __m256d elMatVec_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_13,src_dof_0),_mm256_mul_pd(q_acc_10_13,src_dof_10)),_mm256_mul_pd(q_acc_11_13,src_dof_11)),_mm256_mul_pd(q_acc_12_13,src_dof_12)),_mm256_mul_pd(q_acc_13_13,src_dof_13)),_mm256_mul_pd(q_acc_13_14,src_dof_14)),_mm256_mul_pd(q_acc_13_15,src_dof_15)),_mm256_mul_pd(q_acc_13_16,src_dof_16)),_mm256_mul_pd(q_acc_13_17,src_dof_17)),_mm256_mul_pd(q_acc_13_18,src_dof_18)),_mm256_mul_pd(q_acc_13_19,src_dof_19)),_mm256_mul_pd(q_acc_13_20,src_dof_20)),_mm256_mul_pd(q_acc_13_21,src_dof_21)),_mm256_mul_pd(q_acc_13_22,src_dof_22)),_mm256_mul_pd(q_acc_13_23,src_dof_23)),_mm256_mul_pd(q_acc_13_24,src_dof_24)),_mm256_mul_pd(q_acc_13_25,src_dof_25)),_mm256_mul_pd(q_acc_13_26,src_dof_26)),_mm256_mul_pd(q_acc_13_27,src_dof_27)),_mm256_mul_pd(q_acc_13_28,src_dof_28)),_mm256_mul_pd(q_acc_13_29,src_dof_29)),_mm256_mul_pd(q_acc_1_13,src_dof_1)),_mm256_mul_pd(q_acc_2_13,src_dof_2)),_mm256_mul_pd(q_acc_3_13,src_dof_3)),_mm256_mul_pd(q_acc_4_13,src_dof_4)),_mm256_mul_pd(q_acc_5_13,src_dof_5)),_mm256_mul_pd(q_acc_6_13,src_dof_6)),_mm256_mul_pd(q_acc_7_13,src_dof_7)),_mm256_mul_pd(q_acc_8_13,src_dof_8)),_mm256_mul_pd(q_acc_9_13,src_dof_9));
                const __m256d elMatVec_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_14,src_dof_0),_mm256_mul_pd(q_acc_10_14,src_dof_10)),_mm256_mul_pd(q_acc_11_14,src_dof_11)),_mm256_mul_pd(q_acc_12_14,src_dof_12)),_mm256_mul_pd(q_acc_13_14,src_dof_13)),_mm256_mul_pd(q_acc_14_14,src_dof_14)),_mm256_mul_pd(q_acc_14_15,src_dof_15)),_mm256_mul_pd(q_acc_14_16,src_dof_16)),_mm256_mul_pd(q_acc_14_17,src_dof_17)),_mm256_mul_pd(q_acc_14_18,src_dof_18)),_mm256_mul_pd(q_acc_14_19,src_dof_19)),_mm256_mul_pd(q_acc_14_20,src_dof_20)),_mm256_mul_pd(q_acc_14_21,src_dof_21)),_mm256_mul_pd(q_acc_14_22,src_dof_22)),_mm256_mul_pd(q_acc_14_23,src_dof_23)),_mm256_mul_pd(q_acc_14_24,src_dof_24)),_mm256_mul_pd(q_acc_14_25,src_dof_25)),_mm256_mul_pd(q_acc_14_26,src_dof_26)),_mm256_mul_pd(q_acc_14_27,src_dof_27)),_mm256_mul_pd(q_acc_14_28,src_dof_28)),_mm256_mul_pd(q_acc_14_29,src_dof_29)),_mm256_mul_pd(q_acc_1_14,src_dof_1)),_mm256_mul_pd(q_acc_2_14,src_dof_2)),_mm256_mul_pd(q_acc_3_14,src_dof_3)),_mm256_mul_pd(q_acc_4_14,src_dof_4)),_mm256_mul_pd(q_acc_5_14,src_dof_5)),_mm256_mul_pd(q_acc_6_14,src_dof_6)),_mm256_mul_pd(q_acc_7_14,src_dof_7)),_mm256_mul_pd(q_acc_8_14,src_dof_8)),_mm256_mul_pd(q_acc_9_14,src_dof_9));
                const __m256d elMatVec_15 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_15,src_dof_0),_mm256_mul_pd(q_acc_10_15,src_dof_10)),_mm256_mul_pd(q_acc_11_15,src_dof_11)),_mm256_mul_pd(q_acc_12_15,src_dof_12)),_mm256_mul_pd(q_acc_13_15,src_dof_13)),_mm256_mul_pd(q_acc_14_15,src_dof_14)),_mm256_mul_pd(q_acc_15_15,src_dof_15)),_mm256_mul_pd(q_acc_15_16,src_dof_16)),_mm256_mul_pd(q_acc_15_17,src_dof_17)),_mm256_mul_pd(q_acc_15_18,src_dof_18)),_mm256_mul_pd(q_acc_15_19,src_dof_19)),_mm256_mul_pd(q_acc_15_20,src_dof_20)),_mm256_mul_pd(q_acc_15_21,src_dof_21)),_mm256_mul_pd(q_acc_15_22,src_dof_22)),_mm256_mul_pd(q_acc_15_23,src_dof_23)),_mm256_mul_pd(q_acc_15_24,src_dof_24)),_mm256_mul_pd(q_acc_15_25,src_dof_25)),_mm256_mul_pd(q_acc_15_26,src_dof_26)),_mm256_mul_pd(q_acc_15_27,src_dof_27)),_mm256_mul_pd(q_acc_15_28,src_dof_28)),_mm256_mul_pd(q_acc_15_29,src_dof_29)),_mm256_mul_pd(q_acc_1_15,src_dof_1)),_mm256_mul_pd(q_acc_2_15,src_dof_2)),_mm256_mul_pd(q_acc_3_15,src_dof_3)),_mm256_mul_pd(q_acc_4_15,src_dof_4)),_mm256_mul_pd(q_acc_5_15,src_dof_5)),_mm256_mul_pd(q_acc_6_15,src_dof_6)),_mm256_mul_pd(q_acc_7_15,src_dof_7)),_mm256_mul_pd(q_acc_8_15,src_dof_8)),_mm256_mul_pd(q_acc_9_15,src_dof_9));
                const __m256d elMatVec_16 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_16,src_dof_0),_mm256_mul_pd(q_acc_10_16,src_dof_10)),_mm256_mul_pd(q_acc_11_16,src_dof_11)),_mm256_mul_pd(q_acc_12_16,src_dof_12)),_mm256_mul_pd(q_acc_13_16,src_dof_13)),_mm256_mul_pd(q_acc_14_16,src_dof_14)),_mm256_mul_pd(q_acc_15_16,src_dof_15)),_mm256_mul_pd(q_acc_16_16,src_dof_16)),_mm256_mul_pd(q_acc_16_17,src_dof_17)),_mm256_mul_pd(q_acc_16_18,src_dof_18)),_mm256_mul_pd(q_acc_16_19,src_dof_19)),_mm256_mul_pd(q_acc_16_20,src_dof_20)),_mm256_mul_pd(q_acc_16_21,src_dof_21)),_mm256_mul_pd(q_acc_16_22,src_dof_22)),_mm256_mul_pd(q_acc_16_23,src_dof_23)),_mm256_mul_pd(q_acc_16_24,src_dof_24)),_mm256_mul_pd(q_acc_16_25,src_dof_25)),_mm256_mul_pd(q_acc_16_26,src_dof_26)),_mm256_mul_pd(q_acc_16_27,src_dof_27)),_mm256_mul_pd(q_acc_16_28,src_dof_28)),_mm256_mul_pd(q_acc_16_29,src_dof_29)),_mm256_mul_pd(q_acc_1_16,src_dof_1)),_mm256_mul_pd(q_acc_2_16,src_dof_2)),_mm256_mul_pd(q_acc_3_16,src_dof_3)),_mm256_mul_pd(q_acc_4_16,src_dof_4)),_mm256_mul_pd(q_acc_5_16,src_dof_5)),_mm256_mul_pd(q_acc_6_16,src_dof_6)),_mm256_mul_pd(q_acc_7_16,src_dof_7)),_mm256_mul_pd(q_acc_8_16,src_dof_8)),_mm256_mul_pd(q_acc_9_16,src_dof_9));
                const __m256d elMatVec_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_17,src_dof_0),_mm256_mul_pd(q_acc_10_17,src_dof_10)),_mm256_mul_pd(q_acc_11_17,src_dof_11)),_mm256_mul_pd(q_acc_12_17,src_dof_12)),_mm256_mul_pd(q_acc_13_17,src_dof_13)),_mm256_mul_pd(q_acc_14_17,src_dof_14)),_mm256_mul_pd(q_acc_15_17,src_dof_15)),_mm256_mul_pd(q_acc_16_17,src_dof_16)),_mm256_mul_pd(q_acc_17_17,src_dof_17)),_mm256_mul_pd(q_acc_17_18,src_dof_18)),_mm256_mul_pd(q_acc_17_19,src_dof_19)),_mm256_mul_pd(q_acc_17_20,src_dof_20)),_mm256_mul_pd(q_acc_17_21,src_dof_21)),_mm256_mul_pd(q_acc_17_22,src_dof_22)),_mm256_mul_pd(q_acc_17_23,src_dof_23)),_mm256_mul_pd(q_acc_17_24,src_dof_24)),_mm256_mul_pd(q_acc_17_25,src_dof_25)),_mm256_mul_pd(q_acc_17_26,src_dof_26)),_mm256_mul_pd(q_acc_17_27,src_dof_27)),_mm256_mul_pd(q_acc_17_28,src_dof_28)),_mm256_mul_pd(q_acc_17_29,src_dof_29)),_mm256_mul_pd(q_acc_1_17,src_dof_1)),_mm256_mul_pd(q_acc_2_17,src_dof_2)),_mm256_mul_pd(q_acc_3_17,src_dof_3)),_mm256_mul_pd(q_acc_4_17,src_dof_4)),_mm256_mul_pd(q_acc_5_17,src_dof_5)),_mm256_mul_pd(q_acc_6_17,src_dof_6)),_mm256_mul_pd(q_acc_7_17,src_dof_7)),_mm256_mul_pd(q_acc_8_17,src_dof_8)),_mm256_mul_pd(q_acc_9_17,src_dof_9));
                const __m256d elMatVec_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_18,src_dof_0),_mm256_mul_pd(q_acc_10_18,src_dof_10)),_mm256_mul_pd(q_acc_11_18,src_dof_11)),_mm256_mul_pd(q_acc_12_18,src_dof_12)),_mm256_mul_pd(q_acc_13_18,src_dof_13)),_mm256_mul_pd(q_acc_14_18,src_dof_14)),_mm256_mul_pd(q_acc_15_18,src_dof_15)),_mm256_mul_pd(q_acc_16_18,src_dof_16)),_mm256_mul_pd(q_acc_17_18,src_dof_17)),_mm256_mul_pd(q_acc_18_18,src_dof_18)),_mm256_mul_pd(q_acc_18_19,src_dof_19)),_mm256_mul_pd(q_acc_18_20,src_dof_20)),_mm256_mul_pd(q_acc_18_21,src_dof_21)),_mm256_mul_pd(q_acc_18_22,src_dof_22)),_mm256_mul_pd(q_acc_18_23,src_dof_23)),_mm256_mul_pd(q_acc_18_24,src_dof_24)),_mm256_mul_pd(q_acc_18_25,src_dof_25)),_mm256_mul_pd(q_acc_18_26,src_dof_26)),_mm256_mul_pd(q_acc_18_27,src_dof_27)),_mm256_mul_pd(q_acc_18_28,src_dof_28)),_mm256_mul_pd(q_acc_18_29,src_dof_29)),_mm256_mul_pd(q_acc_1_18,src_dof_1)),_mm256_mul_pd(q_acc_2_18,src_dof_2)),_mm256_mul_pd(q_acc_3_18,src_dof_3)),_mm256_mul_pd(q_acc_4_18,src_dof_4)),_mm256_mul_pd(q_acc_5_18,src_dof_5)),_mm256_mul_pd(q_acc_6_18,src_dof_6)),_mm256_mul_pd(q_acc_7_18,src_dof_7)),_mm256_mul_pd(q_acc_8_18,src_dof_8)),_mm256_mul_pd(q_acc_9_18,src_dof_9));
                const __m256d elMatVec_19 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_19,src_dof_0),_mm256_mul_pd(q_acc_10_19,src_dof_10)),_mm256_mul_pd(q_acc_11_19,src_dof_11)),_mm256_mul_pd(q_acc_12_19,src_dof_12)),_mm256_mul_pd(q_acc_13_19,src_dof_13)),_mm256_mul_pd(q_acc_14_19,src_dof_14)),_mm256_mul_pd(q_acc_15_19,src_dof_15)),_mm256_mul_pd(q_acc_16_19,src_dof_16)),_mm256_mul_pd(q_acc_17_19,src_dof_17)),_mm256_mul_pd(q_acc_18_19,src_dof_18)),_mm256_mul_pd(q_acc_19_19,src_dof_19)),_mm256_mul_pd(q_acc_19_20,src_dof_20)),_mm256_mul_pd(q_acc_19_21,src_dof_21)),_mm256_mul_pd(q_acc_19_22,src_dof_22)),_mm256_mul_pd(q_acc_19_23,src_dof_23)),_mm256_mul_pd(q_acc_19_24,src_dof_24)),_mm256_mul_pd(q_acc_19_25,src_dof_25)),_mm256_mul_pd(q_acc_19_26,src_dof_26)),_mm256_mul_pd(q_acc_19_27,src_dof_27)),_mm256_mul_pd(q_acc_19_28,src_dof_28)),_mm256_mul_pd(q_acc_19_29,src_dof_29)),_mm256_mul_pd(q_acc_1_19,src_dof_1)),_mm256_mul_pd(q_acc_2_19,src_dof_2)),_mm256_mul_pd(q_acc_3_19,src_dof_3)),_mm256_mul_pd(q_acc_4_19,src_dof_4)),_mm256_mul_pd(q_acc_5_19,src_dof_5)),_mm256_mul_pd(q_acc_6_19,src_dof_6)),_mm256_mul_pd(q_acc_7_19,src_dof_7)),_mm256_mul_pd(q_acc_8_19,src_dof_8)),_mm256_mul_pd(q_acc_9_19,src_dof_9));
                const __m256d elMatVec_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_20,src_dof_0),_mm256_mul_pd(q_acc_10_20,src_dof_10)),_mm256_mul_pd(q_acc_11_20,src_dof_11)),_mm256_mul_pd(q_acc_12_20,src_dof_12)),_mm256_mul_pd(q_acc_13_20,src_dof_13)),_mm256_mul_pd(q_acc_14_20,src_dof_14)),_mm256_mul_pd(q_acc_15_20,src_dof_15)),_mm256_mul_pd(q_acc_16_20,src_dof_16)),_mm256_mul_pd(q_acc_17_20,src_dof_17)),_mm256_mul_pd(q_acc_18_20,src_dof_18)),_mm256_mul_pd(q_acc_19_20,src_dof_19)),_mm256_mul_pd(q_acc_1_20,src_dof_1)),_mm256_mul_pd(q_acc_20_20,src_dof_20)),_mm256_mul_pd(q_acc_20_21,src_dof_21)),_mm256_mul_pd(q_acc_20_22,src_dof_22)),_mm256_mul_pd(q_acc_20_23,src_dof_23)),_mm256_mul_pd(q_acc_20_24,src_dof_24)),_mm256_mul_pd(q_acc_20_25,src_dof_25)),_mm256_mul_pd(q_acc_20_26,src_dof_26)),_mm256_mul_pd(q_acc_20_27,src_dof_27)),_mm256_mul_pd(q_acc_20_28,src_dof_28)),_mm256_mul_pd(q_acc_20_29,src_dof_29)),_mm256_mul_pd(q_acc_2_20,src_dof_2)),_mm256_mul_pd(q_acc_3_20,src_dof_3)),_mm256_mul_pd(q_acc_4_20,src_dof_4)),_mm256_mul_pd(q_acc_5_20,src_dof_5)),_mm256_mul_pd(q_acc_6_20,src_dof_6)),_mm256_mul_pd(q_acc_7_20,src_dof_7)),_mm256_mul_pd(q_acc_8_20,src_dof_8)),_mm256_mul_pd(q_acc_9_20,src_dof_9));
                const __m256d elMatVec_21 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_21,src_dof_0),_mm256_mul_pd(q_acc_10_21,src_dof_10)),_mm256_mul_pd(q_acc_11_21,src_dof_11)),_mm256_mul_pd(q_acc_12_21,src_dof_12)),_mm256_mul_pd(q_acc_13_21,src_dof_13)),_mm256_mul_pd(q_acc_14_21,src_dof_14)),_mm256_mul_pd(q_acc_15_21,src_dof_15)),_mm256_mul_pd(q_acc_16_21,src_dof_16)),_mm256_mul_pd(q_acc_17_21,src_dof_17)),_mm256_mul_pd(q_acc_18_21,src_dof_18)),_mm256_mul_pd(q_acc_19_21,src_dof_19)),_mm256_mul_pd(q_acc_1_21,src_dof_1)),_mm256_mul_pd(q_acc_20_21,src_dof_20)),_mm256_mul_pd(q_acc_21_21,src_dof_21)),_mm256_mul_pd(q_acc_21_22,src_dof_22)),_mm256_mul_pd(q_acc_21_23,src_dof_23)),_mm256_mul_pd(q_acc_21_24,src_dof_24)),_mm256_mul_pd(q_acc_21_25,src_dof_25)),_mm256_mul_pd(q_acc_21_26,src_dof_26)),_mm256_mul_pd(q_acc_21_27,src_dof_27)),_mm256_mul_pd(q_acc_21_28,src_dof_28)),_mm256_mul_pd(q_acc_21_29,src_dof_29)),_mm256_mul_pd(q_acc_2_21,src_dof_2)),_mm256_mul_pd(q_acc_3_21,src_dof_3)),_mm256_mul_pd(q_acc_4_21,src_dof_4)),_mm256_mul_pd(q_acc_5_21,src_dof_5)),_mm256_mul_pd(q_acc_6_21,src_dof_6)),_mm256_mul_pd(q_acc_7_21,src_dof_7)),_mm256_mul_pd(q_acc_8_21,src_dof_8)),_mm256_mul_pd(q_acc_9_21,src_dof_9));
                const __m256d elMatVec_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_22,src_dof_0),_mm256_mul_pd(q_acc_10_22,src_dof_10)),_mm256_mul_pd(q_acc_11_22,src_dof_11)),_mm256_mul_pd(q_acc_12_22,src_dof_12)),_mm256_mul_pd(q_acc_13_22,src_dof_13)),_mm256_mul_pd(q_acc_14_22,src_dof_14)),_mm256_mul_pd(q_acc_15_22,src_dof_15)),_mm256_mul_pd(q_acc_16_22,src_dof_16)),_mm256_mul_pd(q_acc_17_22,src_dof_17)),_mm256_mul_pd(q_acc_18_22,src_dof_18)),_mm256_mul_pd(q_acc_19_22,src_dof_19)),_mm256_mul_pd(q_acc_1_22,src_dof_1)),_mm256_mul_pd(q_acc_20_22,src_dof_20)),_mm256_mul_pd(q_acc_21_22,src_dof_21)),_mm256_mul_pd(q_acc_22_22,src_dof_22)),_mm256_mul_pd(q_acc_22_23,src_dof_23)),_mm256_mul_pd(q_acc_22_24,src_dof_24)),_mm256_mul_pd(q_acc_22_25,src_dof_25)),_mm256_mul_pd(q_acc_22_26,src_dof_26)),_mm256_mul_pd(q_acc_22_27,src_dof_27)),_mm256_mul_pd(q_acc_22_28,src_dof_28)),_mm256_mul_pd(q_acc_22_29,src_dof_29)),_mm256_mul_pd(q_acc_2_22,src_dof_2)),_mm256_mul_pd(q_acc_3_22,src_dof_3)),_mm256_mul_pd(q_acc_4_22,src_dof_4)),_mm256_mul_pd(q_acc_5_22,src_dof_5)),_mm256_mul_pd(q_acc_6_22,src_dof_6)),_mm256_mul_pd(q_acc_7_22,src_dof_7)),_mm256_mul_pd(q_acc_8_22,src_dof_8)),_mm256_mul_pd(q_acc_9_22,src_dof_9));
                const __m256d elMatVec_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_23,src_dof_0),_mm256_mul_pd(q_acc_10_23,src_dof_10)),_mm256_mul_pd(q_acc_11_23,src_dof_11)),_mm256_mul_pd(q_acc_12_23,src_dof_12)),_mm256_mul_pd(q_acc_13_23,src_dof_13)),_mm256_mul_pd(q_acc_14_23,src_dof_14)),_mm256_mul_pd(q_acc_15_23,src_dof_15)),_mm256_mul_pd(q_acc_16_23,src_dof_16)),_mm256_mul_pd(q_acc_17_23,src_dof_17)),_mm256_mul_pd(q_acc_18_23,src_dof_18)),_mm256_mul_pd(q_acc_19_23,src_dof_19)),_mm256_mul_pd(q_acc_1_23,src_dof_1)),_mm256_mul_pd(q_acc_20_23,src_dof_20)),_mm256_mul_pd(q_acc_21_23,src_dof_21)),_mm256_mul_pd(q_acc_22_23,src_dof_22)),_mm256_mul_pd(q_acc_23_23,src_dof_23)),_mm256_mul_pd(q_acc_23_24,src_dof_24)),_mm256_mul_pd(q_acc_23_25,src_dof_25)),_mm256_mul_pd(q_acc_23_26,src_dof_26)),_mm256_mul_pd(q_acc_23_27,src_dof_27)),_mm256_mul_pd(q_acc_23_28,src_dof_28)),_mm256_mul_pd(q_acc_23_29,src_dof_29)),_mm256_mul_pd(q_acc_2_23,src_dof_2)),_mm256_mul_pd(q_acc_3_23,src_dof_3)),_mm256_mul_pd(q_acc_4_23,src_dof_4)),_mm256_mul_pd(q_acc_5_23,src_dof_5)),_mm256_mul_pd(q_acc_6_23,src_dof_6)),_mm256_mul_pd(q_acc_7_23,src_dof_7)),_mm256_mul_pd(q_acc_8_23,src_dof_8)),_mm256_mul_pd(q_acc_9_23,src_dof_9));
                const __m256d elMatVec_24 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_24,src_dof_0),_mm256_mul_pd(q_acc_10_24,src_dof_10)),_mm256_mul_pd(q_acc_11_24,src_dof_11)),_mm256_mul_pd(q_acc_12_24,src_dof_12)),_mm256_mul_pd(q_acc_13_24,src_dof_13)),_mm256_mul_pd(q_acc_14_24,src_dof_14)),_mm256_mul_pd(q_acc_15_24,src_dof_15)),_mm256_mul_pd(q_acc_16_24,src_dof_16)),_mm256_mul_pd(q_acc_17_24,src_dof_17)),_mm256_mul_pd(q_acc_18_24,src_dof_18)),_mm256_mul_pd(q_acc_19_24,src_dof_19)),_mm256_mul_pd(q_acc_1_24,src_dof_1)),_mm256_mul_pd(q_acc_20_24,src_dof_20)),_mm256_mul_pd(q_acc_21_24,src_dof_21)),_mm256_mul_pd(q_acc_22_24,src_dof_22)),_mm256_mul_pd(q_acc_23_24,src_dof_23)),_mm256_mul_pd(q_acc_24_24,src_dof_24)),_mm256_mul_pd(q_acc_24_25,src_dof_25)),_mm256_mul_pd(q_acc_24_26,src_dof_26)),_mm256_mul_pd(q_acc_24_27,src_dof_27)),_mm256_mul_pd(q_acc_24_28,src_dof_28)),_mm256_mul_pd(q_acc_24_29,src_dof_29)),_mm256_mul_pd(q_acc_2_24,src_dof_2)),_mm256_mul_pd(q_acc_3_24,src_dof_3)),_mm256_mul_pd(q_acc_4_24,src_dof_4)),_mm256_mul_pd(q_acc_5_24,src_dof_5)),_mm256_mul_pd(q_acc_6_24,src_dof_6)),_mm256_mul_pd(q_acc_7_24,src_dof_7)),_mm256_mul_pd(q_acc_8_24,src_dof_8)),_mm256_mul_pd(q_acc_9_24,src_dof_9));
                const __m256d elMatVec_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_25,src_dof_0),_mm256_mul_pd(q_acc_10_25,src_dof_10)),_mm256_mul_pd(q_acc_11_25,src_dof_11)),_mm256_mul_pd(q_acc_12_25,src_dof_12)),_mm256_mul_pd(q_acc_13_25,src_dof_13)),_mm256_mul_pd(q_acc_14_25,src_dof_14)),_mm256_mul_pd(q_acc_15_25,src_dof_15)),_mm256_mul_pd(q_acc_16_25,src_dof_16)),_mm256_mul_pd(q_acc_17_25,src_dof_17)),_mm256_mul_pd(q_acc_18_25,src_dof_18)),_mm256_mul_pd(q_acc_19_25,src_dof_19)),_mm256_mul_pd(q_acc_1_25,src_dof_1)),_mm256_mul_pd(q_acc_20_25,src_dof_20)),_mm256_mul_pd(q_acc_21_25,src_dof_21)),_mm256_mul_pd(q_acc_22_25,src_dof_22)),_mm256_mul_pd(q_acc_23_25,src_dof_23)),_mm256_mul_pd(q_acc_24_25,src_dof_24)),_mm256_mul_pd(q_acc_25_25,src_dof_25)),_mm256_mul_pd(q_acc_25_26,src_dof_26)),_mm256_mul_pd(q_acc_25_27,src_dof_27)),_mm256_mul_pd(q_acc_25_28,src_dof_28)),_mm256_mul_pd(q_acc_25_29,src_dof_29)),_mm256_mul_pd(q_acc_2_25,src_dof_2)),_mm256_mul_pd(q_acc_3_25,src_dof_3)),_mm256_mul_pd(q_acc_4_25,src_dof_4)),_mm256_mul_pd(q_acc_5_25,src_dof_5)),_mm256_mul_pd(q_acc_6_25,src_dof_6)),_mm256_mul_pd(q_acc_7_25,src_dof_7)),_mm256_mul_pd(q_acc_8_25,src_dof_8)),_mm256_mul_pd(q_acc_9_25,src_dof_9));
                const __m256d elMatVec_26 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_26,src_dof_0),_mm256_mul_pd(q_acc_10_26,src_dof_10)),_mm256_mul_pd(q_acc_11_26,src_dof_11)),_mm256_mul_pd(q_acc_12_26,src_dof_12)),_mm256_mul_pd(q_acc_13_26,src_dof_13)),_mm256_mul_pd(q_acc_14_26,src_dof_14)),_mm256_mul_pd(q_acc_15_26,src_dof_15)),_mm256_mul_pd(q_acc_16_26,src_dof_16)),_mm256_mul_pd(q_acc_17_26,src_dof_17)),_mm256_mul_pd(q_acc_18_26,src_dof_18)),_mm256_mul_pd(q_acc_19_26,src_dof_19)),_mm256_mul_pd(q_acc_1_26,src_dof_1)),_mm256_mul_pd(q_acc_20_26,src_dof_20)),_mm256_mul_pd(q_acc_21_26,src_dof_21)),_mm256_mul_pd(q_acc_22_26,src_dof_22)),_mm256_mul_pd(q_acc_23_26,src_dof_23)),_mm256_mul_pd(q_acc_24_26,src_dof_24)),_mm256_mul_pd(q_acc_25_26,src_dof_25)),_mm256_mul_pd(q_acc_26_26,src_dof_26)),_mm256_mul_pd(q_acc_26_27,src_dof_27)),_mm256_mul_pd(q_acc_26_28,src_dof_28)),_mm256_mul_pd(q_acc_26_29,src_dof_29)),_mm256_mul_pd(q_acc_2_26,src_dof_2)),_mm256_mul_pd(q_acc_3_26,src_dof_3)),_mm256_mul_pd(q_acc_4_26,src_dof_4)),_mm256_mul_pd(q_acc_5_26,src_dof_5)),_mm256_mul_pd(q_acc_6_26,src_dof_6)),_mm256_mul_pd(q_acc_7_26,src_dof_7)),_mm256_mul_pd(q_acc_8_26,src_dof_8)),_mm256_mul_pd(q_acc_9_26,src_dof_9));
                const __m256d elMatVec_27 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_27,src_dof_0),_mm256_mul_pd(q_acc_10_27,src_dof_10)),_mm256_mul_pd(q_acc_11_27,src_dof_11)),_mm256_mul_pd(q_acc_12_27,src_dof_12)),_mm256_mul_pd(q_acc_13_27,src_dof_13)),_mm256_mul_pd(q_acc_14_27,src_dof_14)),_mm256_mul_pd(q_acc_15_27,src_dof_15)),_mm256_mul_pd(q_acc_16_27,src_dof_16)),_mm256_mul_pd(q_acc_17_27,src_dof_17)),_mm256_mul_pd(q_acc_18_27,src_dof_18)),_mm256_mul_pd(q_acc_19_27,src_dof_19)),_mm256_mul_pd(q_acc_1_27,src_dof_1)),_mm256_mul_pd(q_acc_20_27,src_dof_20)),_mm256_mul_pd(q_acc_21_27,src_dof_21)),_mm256_mul_pd(q_acc_22_27,src_dof_22)),_mm256_mul_pd(q_acc_23_27,src_dof_23)),_mm256_mul_pd(q_acc_24_27,src_dof_24)),_mm256_mul_pd(q_acc_25_27,src_dof_25)),_mm256_mul_pd(q_acc_26_27,src_dof_26)),_mm256_mul_pd(q_acc_27_27,src_dof_27)),_mm256_mul_pd(q_acc_27_28,src_dof_28)),_mm256_mul_pd(q_acc_27_29,src_dof_29)),_mm256_mul_pd(q_acc_2_27,src_dof_2)),_mm256_mul_pd(q_acc_3_27,src_dof_3)),_mm256_mul_pd(q_acc_4_27,src_dof_4)),_mm256_mul_pd(q_acc_5_27,src_dof_5)),_mm256_mul_pd(q_acc_6_27,src_dof_6)),_mm256_mul_pd(q_acc_7_27,src_dof_7)),_mm256_mul_pd(q_acc_8_27,src_dof_8)),_mm256_mul_pd(q_acc_9_27,src_dof_9));
                const __m256d elMatVec_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_28,src_dof_0),_mm256_mul_pd(q_acc_10_28,src_dof_10)),_mm256_mul_pd(q_acc_11_28,src_dof_11)),_mm256_mul_pd(q_acc_12_28,src_dof_12)),_mm256_mul_pd(q_acc_13_28,src_dof_13)),_mm256_mul_pd(q_acc_14_28,src_dof_14)),_mm256_mul_pd(q_acc_15_28,src_dof_15)),_mm256_mul_pd(q_acc_16_28,src_dof_16)),_mm256_mul_pd(q_acc_17_28,src_dof_17)),_mm256_mul_pd(q_acc_18_28,src_dof_18)),_mm256_mul_pd(q_acc_19_28,src_dof_19)),_mm256_mul_pd(q_acc_1_28,src_dof_1)),_mm256_mul_pd(q_acc_20_28,src_dof_20)),_mm256_mul_pd(q_acc_21_28,src_dof_21)),_mm256_mul_pd(q_acc_22_28,src_dof_22)),_mm256_mul_pd(q_acc_23_28,src_dof_23)),_mm256_mul_pd(q_acc_24_28,src_dof_24)),_mm256_mul_pd(q_acc_25_28,src_dof_25)),_mm256_mul_pd(q_acc_26_28,src_dof_26)),_mm256_mul_pd(q_acc_27_28,src_dof_27)),_mm256_mul_pd(q_acc_28_28,src_dof_28)),_mm256_mul_pd(q_acc_28_29,src_dof_29)),_mm256_mul_pd(q_acc_2_28,src_dof_2)),_mm256_mul_pd(q_acc_3_28,src_dof_3)),_mm256_mul_pd(q_acc_4_28,src_dof_4)),_mm256_mul_pd(q_acc_5_28,src_dof_5)),_mm256_mul_pd(q_acc_6_28,src_dof_6)),_mm256_mul_pd(q_acc_7_28,src_dof_7)),_mm256_mul_pd(q_acc_8_28,src_dof_8)),_mm256_mul_pd(q_acc_9_28,src_dof_9));
                const __m256d elMatVec_29 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_29,src_dof_0),_mm256_mul_pd(q_acc_10_29,src_dof_10)),_mm256_mul_pd(q_acc_11_29,src_dof_11)),_mm256_mul_pd(q_acc_12_29,src_dof_12)),_mm256_mul_pd(q_acc_13_29,src_dof_13)),_mm256_mul_pd(q_acc_14_29,src_dof_14)),_mm256_mul_pd(q_acc_15_29,src_dof_15)),_mm256_mul_pd(q_acc_16_29,src_dof_16)),_mm256_mul_pd(q_acc_17_29,src_dof_17)),_mm256_mul_pd(q_acc_18_29,src_dof_18)),_mm256_mul_pd(q_acc_19_29,src_dof_19)),_mm256_mul_pd(q_acc_1_29,src_dof_1)),_mm256_mul_pd(q_acc_20_29,src_dof_20)),_mm256_mul_pd(q_acc_21_29,src_dof_21)),_mm256_mul_pd(q_acc_22_29,src_dof_22)),_mm256_mul_pd(q_acc_23_29,src_dof_23)),_mm256_mul_pd(q_acc_24_29,src_dof_24)),_mm256_mul_pd(q_acc_25_29,src_dof_25)),_mm256_mul_pd(q_acc_26_29,src_dof_26)),_mm256_mul_pd(q_acc_27_29,src_dof_27)),_mm256_mul_pd(q_acc_28_29,src_dof_28)),_mm256_mul_pd(q_acc_29_29,src_dof_29)),_mm256_mul_pd(q_acc_2_29,src_dof_2)),_mm256_mul_pd(q_acc_3_29,src_dof_3)),_mm256_mul_pd(q_acc_4_29,src_dof_4)),_mm256_mul_pd(q_acc_5_29,src_dof_5)),_mm256_mul_pd(q_acc_6_29,src_dof_6)),_mm256_mul_pd(q_acc_7_29,src_dof_7)),_mm256_mul_pd(q_acc_8_29,src_dof_8)),_mm256_mul_pd(q_acc_9_29,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_12,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_13,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_14,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_15,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_16,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_17,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_18,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_19,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_20,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_21,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_22,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_23,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_24,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_25,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_26,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_27,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_28,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_29,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_15 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_17 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_19 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_25 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_27 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_29 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_1 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_2 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_3 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_0_12 = 0.0;
                real_t q_acc_0_13 = 0.0;
                real_t q_acc_0_14 = 0.0;
                real_t q_acc_0_15 = 0.0;
                real_t q_acc_0_16 = 0.0;
                real_t q_acc_0_17 = 0.0;
                real_t q_acc_0_18 = 0.0;
                real_t q_acc_0_19 = 0.0;
                real_t q_acc_0_20 = 0.0;
                real_t q_acc_0_21 = 0.0;
                real_t q_acc_0_22 = 0.0;
                real_t q_acc_0_23 = 0.0;
                real_t q_acc_0_24 = 0.0;
                real_t q_acc_0_25 = 0.0;
                real_t q_acc_0_26 = 0.0;
                real_t q_acc_0_27 = 0.0;
                real_t q_acc_0_28 = 0.0;
                real_t q_acc_0_29 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_1_12 = 0.0;
                real_t q_acc_1_13 = 0.0;
                real_t q_acc_1_14 = 0.0;
                real_t q_acc_1_15 = 0.0;
                real_t q_acc_1_16 = 0.0;
                real_t q_acc_1_17 = 0.0;
                real_t q_acc_1_18 = 0.0;
                real_t q_acc_1_19 = 0.0;
                real_t q_acc_1_20 = 0.0;
                real_t q_acc_1_21 = 0.0;
                real_t q_acc_1_22 = 0.0;
                real_t q_acc_1_23 = 0.0;
                real_t q_acc_1_24 = 0.0;
                real_t q_acc_1_25 = 0.0;
                real_t q_acc_1_26 = 0.0;
                real_t q_acc_1_27 = 0.0;
                real_t q_acc_1_28 = 0.0;
                real_t q_acc_1_29 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_2_12 = 0.0;
                real_t q_acc_2_13 = 0.0;
                real_t q_acc_2_14 = 0.0;
                real_t q_acc_2_15 = 0.0;
                real_t q_acc_2_16 = 0.0;
                real_t q_acc_2_17 = 0.0;
                real_t q_acc_2_18 = 0.0;
                real_t q_acc_2_19 = 0.0;
                real_t q_acc_2_20 = 0.0;
                real_t q_acc_2_21 = 0.0;
                real_t q_acc_2_22 = 0.0;
                real_t q_acc_2_23 = 0.0;
                real_t q_acc_2_24 = 0.0;
                real_t q_acc_2_25 = 0.0;
                real_t q_acc_2_26 = 0.0;
                real_t q_acc_2_27 = 0.0;
                real_t q_acc_2_28 = 0.0;
                real_t q_acc_2_29 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_3_12 = 0.0;
                real_t q_acc_3_13 = 0.0;
                real_t q_acc_3_14 = 0.0;
                real_t q_acc_3_15 = 0.0;
                real_t q_acc_3_16 = 0.0;
                real_t q_acc_3_17 = 0.0;
                real_t q_acc_3_18 = 0.0;
                real_t q_acc_3_19 = 0.0;
                real_t q_acc_3_20 = 0.0;
                real_t q_acc_3_21 = 0.0;
                real_t q_acc_3_22 = 0.0;
                real_t q_acc_3_23 = 0.0;
                real_t q_acc_3_24 = 0.0;
                real_t q_acc_3_25 = 0.0;
                real_t q_acc_3_26 = 0.0;
                real_t q_acc_3_27 = 0.0;
                real_t q_acc_3_28 = 0.0;
                real_t q_acc_3_29 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_4_12 = 0.0;
                real_t q_acc_4_13 = 0.0;
                real_t q_acc_4_14 = 0.0;
                real_t q_acc_4_15 = 0.0;
                real_t q_acc_4_16 = 0.0;
                real_t q_acc_4_17 = 0.0;
                real_t q_acc_4_18 = 0.0;
                real_t q_acc_4_19 = 0.0;
                real_t q_acc_4_20 = 0.0;
                real_t q_acc_4_21 = 0.0;
                real_t q_acc_4_22 = 0.0;
                real_t q_acc_4_23 = 0.0;
                real_t q_acc_4_24 = 0.0;
                real_t q_acc_4_25 = 0.0;
                real_t q_acc_4_26 = 0.0;
                real_t q_acc_4_27 = 0.0;
                real_t q_acc_4_28 = 0.0;
                real_t q_acc_4_29 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_5_12 = 0.0;
                real_t q_acc_5_13 = 0.0;
                real_t q_acc_5_14 = 0.0;
                real_t q_acc_5_15 = 0.0;
                real_t q_acc_5_16 = 0.0;
                real_t q_acc_5_17 = 0.0;
                real_t q_acc_5_18 = 0.0;
                real_t q_acc_5_19 = 0.0;
                real_t q_acc_5_20 = 0.0;
                real_t q_acc_5_21 = 0.0;
                real_t q_acc_5_22 = 0.0;
                real_t q_acc_5_23 = 0.0;
                real_t q_acc_5_24 = 0.0;
                real_t q_acc_5_25 = 0.0;
                real_t q_acc_5_26 = 0.0;
                real_t q_acc_5_27 = 0.0;
                real_t q_acc_5_28 = 0.0;
                real_t q_acc_5_29 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_6_12 = 0.0;
                real_t q_acc_6_13 = 0.0;
                real_t q_acc_6_14 = 0.0;
                real_t q_acc_6_15 = 0.0;
                real_t q_acc_6_16 = 0.0;
                real_t q_acc_6_17 = 0.0;
                real_t q_acc_6_18 = 0.0;
                real_t q_acc_6_19 = 0.0;
                real_t q_acc_6_20 = 0.0;
                real_t q_acc_6_21 = 0.0;
                real_t q_acc_6_22 = 0.0;
                real_t q_acc_6_23 = 0.0;
                real_t q_acc_6_24 = 0.0;
                real_t q_acc_6_25 = 0.0;
                real_t q_acc_6_26 = 0.0;
                real_t q_acc_6_27 = 0.0;
                real_t q_acc_6_28 = 0.0;
                real_t q_acc_6_29 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_7_12 = 0.0;
                real_t q_acc_7_13 = 0.0;
                real_t q_acc_7_14 = 0.0;
                real_t q_acc_7_15 = 0.0;
                real_t q_acc_7_16 = 0.0;
                real_t q_acc_7_17 = 0.0;
                real_t q_acc_7_18 = 0.0;
                real_t q_acc_7_19 = 0.0;
                real_t q_acc_7_20 = 0.0;
                real_t q_acc_7_21 = 0.0;
                real_t q_acc_7_22 = 0.0;
                real_t q_acc_7_23 = 0.0;
                real_t q_acc_7_24 = 0.0;
                real_t q_acc_7_25 = 0.0;
                real_t q_acc_7_26 = 0.0;
                real_t q_acc_7_27 = 0.0;
                real_t q_acc_7_28 = 0.0;
                real_t q_acc_7_29 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_8_12 = 0.0;
                real_t q_acc_8_13 = 0.0;
                real_t q_acc_8_14 = 0.0;
                real_t q_acc_8_15 = 0.0;
                real_t q_acc_8_16 = 0.0;
                real_t q_acc_8_17 = 0.0;
                real_t q_acc_8_18 = 0.0;
                real_t q_acc_8_19 = 0.0;
                real_t q_acc_8_20 = 0.0;
                real_t q_acc_8_21 = 0.0;
                real_t q_acc_8_22 = 0.0;
                real_t q_acc_8_23 = 0.0;
                real_t q_acc_8_24 = 0.0;
                real_t q_acc_8_25 = 0.0;
                real_t q_acc_8_26 = 0.0;
                real_t q_acc_8_27 = 0.0;
                real_t q_acc_8_28 = 0.0;
                real_t q_acc_8_29 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_9_12 = 0.0;
                real_t q_acc_9_13 = 0.0;
                real_t q_acc_9_14 = 0.0;
                real_t q_acc_9_15 = 0.0;
                real_t q_acc_9_16 = 0.0;
                real_t q_acc_9_17 = 0.0;
                real_t q_acc_9_18 = 0.0;
                real_t q_acc_9_19 = 0.0;
                real_t q_acc_9_20 = 0.0;
                real_t q_acc_9_21 = 0.0;
                real_t q_acc_9_22 = 0.0;
                real_t q_acc_9_23 = 0.0;
                real_t q_acc_9_24 = 0.0;
                real_t q_acc_9_25 = 0.0;
                real_t q_acc_9_26 = 0.0;
                real_t q_acc_9_27 = 0.0;
                real_t q_acc_9_28 = 0.0;
                real_t q_acc_9_29 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_10_12 = 0.0;
                real_t q_acc_10_13 = 0.0;
                real_t q_acc_10_14 = 0.0;
                real_t q_acc_10_15 = 0.0;
                real_t q_acc_10_16 = 0.0;
                real_t q_acc_10_17 = 0.0;
                real_t q_acc_10_18 = 0.0;
                real_t q_acc_10_19 = 0.0;
                real_t q_acc_10_20 = 0.0;
                real_t q_acc_10_21 = 0.0;
                real_t q_acc_10_22 = 0.0;
                real_t q_acc_10_23 = 0.0;
                real_t q_acc_10_24 = 0.0;
                real_t q_acc_10_25 = 0.0;
                real_t q_acc_10_26 = 0.0;
                real_t q_acc_10_27 = 0.0;
                real_t q_acc_10_28 = 0.0;
                real_t q_acc_10_29 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_11_12 = 0.0;
                real_t q_acc_11_13 = 0.0;
                real_t q_acc_11_14 = 0.0;
                real_t q_acc_11_15 = 0.0;
                real_t q_acc_11_16 = 0.0;
                real_t q_acc_11_17 = 0.0;
                real_t q_acc_11_18 = 0.0;
                real_t q_acc_11_19 = 0.0;
                real_t q_acc_11_20 = 0.0;
                real_t q_acc_11_21 = 0.0;
                real_t q_acc_11_22 = 0.0;
                real_t q_acc_11_23 = 0.0;
                real_t q_acc_11_24 = 0.0;
                real_t q_acc_11_25 = 0.0;
                real_t q_acc_11_26 = 0.0;
                real_t q_acc_11_27 = 0.0;
                real_t q_acc_11_28 = 0.0;
                real_t q_acc_11_29 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_12_13 = 0.0;
                real_t q_acc_12_14 = 0.0;
                real_t q_acc_12_15 = 0.0;
                real_t q_acc_12_16 = 0.0;
                real_t q_acc_12_17 = 0.0;
                real_t q_acc_12_18 = 0.0;
                real_t q_acc_12_19 = 0.0;
                real_t q_acc_12_20 = 0.0;
                real_t q_acc_12_21 = 0.0;
                real_t q_acc_12_22 = 0.0;
                real_t q_acc_12_23 = 0.0;
                real_t q_acc_12_24 = 0.0;
                real_t q_acc_12_25 = 0.0;
                real_t q_acc_12_26 = 0.0;
                real_t q_acc_12_27 = 0.0;
                real_t q_acc_12_28 = 0.0;
                real_t q_acc_12_29 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_13_14 = 0.0;
                real_t q_acc_13_15 = 0.0;
                real_t q_acc_13_16 = 0.0;
                real_t q_acc_13_17 = 0.0;
                real_t q_acc_13_18 = 0.0;
                real_t q_acc_13_19 = 0.0;
                real_t q_acc_13_20 = 0.0;
                real_t q_acc_13_21 = 0.0;
                real_t q_acc_13_22 = 0.0;
                real_t q_acc_13_23 = 0.0;
                real_t q_acc_13_24 = 0.0;
                real_t q_acc_13_25 = 0.0;
                real_t q_acc_13_26 = 0.0;
                real_t q_acc_13_27 = 0.0;
                real_t q_acc_13_28 = 0.0;
                real_t q_acc_13_29 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_14_15 = 0.0;
                real_t q_acc_14_16 = 0.0;
                real_t q_acc_14_17 = 0.0;
                real_t q_acc_14_18 = 0.0;
                real_t q_acc_14_19 = 0.0;
                real_t q_acc_14_20 = 0.0;
                real_t q_acc_14_21 = 0.0;
                real_t q_acc_14_22 = 0.0;
                real_t q_acc_14_23 = 0.0;
                real_t q_acc_14_24 = 0.0;
                real_t q_acc_14_25 = 0.0;
                real_t q_acc_14_26 = 0.0;
                real_t q_acc_14_27 = 0.0;
                real_t q_acc_14_28 = 0.0;
                real_t q_acc_14_29 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_15_16 = 0.0;
                real_t q_acc_15_17 = 0.0;
                real_t q_acc_15_18 = 0.0;
                real_t q_acc_15_19 = 0.0;
                real_t q_acc_15_20 = 0.0;
                real_t q_acc_15_21 = 0.0;
                real_t q_acc_15_22 = 0.0;
                real_t q_acc_15_23 = 0.0;
                real_t q_acc_15_24 = 0.0;
                real_t q_acc_15_25 = 0.0;
                real_t q_acc_15_26 = 0.0;
                real_t q_acc_15_27 = 0.0;
                real_t q_acc_15_28 = 0.0;
                real_t q_acc_15_29 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_16_17 = 0.0;
                real_t q_acc_16_18 = 0.0;
                real_t q_acc_16_19 = 0.0;
                real_t q_acc_16_20 = 0.0;
                real_t q_acc_16_21 = 0.0;
                real_t q_acc_16_22 = 0.0;
                real_t q_acc_16_23 = 0.0;
                real_t q_acc_16_24 = 0.0;
                real_t q_acc_16_25 = 0.0;
                real_t q_acc_16_26 = 0.0;
                real_t q_acc_16_27 = 0.0;
                real_t q_acc_16_28 = 0.0;
                real_t q_acc_16_29 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_17_18 = 0.0;
                real_t q_acc_17_19 = 0.0;
                real_t q_acc_17_20 = 0.0;
                real_t q_acc_17_21 = 0.0;
                real_t q_acc_17_22 = 0.0;
                real_t q_acc_17_23 = 0.0;
                real_t q_acc_17_24 = 0.0;
                real_t q_acc_17_25 = 0.0;
                real_t q_acc_17_26 = 0.0;
                real_t q_acc_17_27 = 0.0;
                real_t q_acc_17_28 = 0.0;
                real_t q_acc_17_29 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_18_19 = 0.0;
                real_t q_acc_18_20 = 0.0;
                real_t q_acc_18_21 = 0.0;
                real_t q_acc_18_22 = 0.0;
                real_t q_acc_18_23 = 0.0;
                real_t q_acc_18_24 = 0.0;
                real_t q_acc_18_25 = 0.0;
                real_t q_acc_18_26 = 0.0;
                real_t q_acc_18_27 = 0.0;
                real_t q_acc_18_28 = 0.0;
                real_t q_acc_18_29 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_19_20 = 0.0;
                real_t q_acc_19_21 = 0.0;
                real_t q_acc_19_22 = 0.0;
                real_t q_acc_19_23 = 0.0;
                real_t q_acc_19_24 = 0.0;
                real_t q_acc_19_25 = 0.0;
                real_t q_acc_19_26 = 0.0;
                real_t q_acc_19_27 = 0.0;
                real_t q_acc_19_28 = 0.0;
                real_t q_acc_19_29 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_20_21 = 0.0;
                real_t q_acc_20_22 = 0.0;
                real_t q_acc_20_23 = 0.0;
                real_t q_acc_20_24 = 0.0;
                real_t q_acc_20_25 = 0.0;
                real_t q_acc_20_26 = 0.0;
                real_t q_acc_20_27 = 0.0;
                real_t q_acc_20_28 = 0.0;
                real_t q_acc_20_29 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_21_22 = 0.0;
                real_t q_acc_21_23 = 0.0;
                real_t q_acc_21_24 = 0.0;
                real_t q_acc_21_25 = 0.0;
                real_t q_acc_21_26 = 0.0;
                real_t q_acc_21_27 = 0.0;
                real_t q_acc_21_28 = 0.0;
                real_t q_acc_21_29 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_22_23 = 0.0;
                real_t q_acc_22_24 = 0.0;
                real_t q_acc_22_25 = 0.0;
                real_t q_acc_22_26 = 0.0;
                real_t q_acc_22_27 = 0.0;
                real_t q_acc_22_28 = 0.0;
                real_t q_acc_22_29 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_23_24 = 0.0;
                real_t q_acc_23_25 = 0.0;
                real_t q_acc_23_26 = 0.0;
                real_t q_acc_23_27 = 0.0;
                real_t q_acc_23_28 = 0.0;
                real_t q_acc_23_29 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_24_25 = 0.0;
                real_t q_acc_24_26 = 0.0;
                real_t q_acc_24_27 = 0.0;
                real_t q_acc_24_28 = 0.0;
                real_t q_acc_24_29 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_25_26 = 0.0;
                real_t q_acc_25_27 = 0.0;
                real_t q_acc_25_28 = 0.0;
                real_t q_acc_25_29 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_26_27 = 0.0;
                real_t q_acc_26_28 = 0.0;
                real_t q_acc_26_29 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_27_28 = 0.0;
                real_t q_acc_27_29 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_28_29 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_156 = (mu_dof_0*_data_phi_0_0_GREEN_UP[4*q] + mu_dof_1*_data_phi_0_0_GREEN_UP[4*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_UP[4*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_UP[4*q + 3])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_133 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_157 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4];
                   const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6];
                   const real_t tmp_qloop_222 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7];
                   const real_t tmp_qloop_235 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10];
                   const real_t tmp_qloop_277 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11];
                   const real_t tmp_qloop_283 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_323 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_337 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_365 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_379 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_407 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_421 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_436 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_453 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_468 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_483 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_498 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_513 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_528 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_543 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_558 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_573 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_121 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q];
                   const real_t tmp_qloop_144 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_162 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4];
                   const real_t tmp_qloop_201 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5];
                   const real_t tmp_qloop_214 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8];
                   const real_t tmp_qloop_253 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9];
                   const real_t tmp_qloop_266 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10];
                   const real_t tmp_qloop_274 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_286 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11];
                   const real_t tmp_qloop_305 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_319 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_361 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_389 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_403 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_444 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_459 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_474 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_489 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_504 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_519 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_534 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_549 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_564 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_579 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q];
                   const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 2];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 3];
                   const real_t tmp_qloop_192 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 4];
                   const real_t tmp_qloop_205 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 5];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 6];
                   const real_t tmp_qloop_231 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 7];
                   const real_t tmp_qloop_244 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 8];
                   const real_t tmp_qloop_257 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 9];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 10];
                   const real_t tmp_qloop_293 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[12*q + 11];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_314 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_328 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_342 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_356 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_370 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_398 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_412 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_431 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_449 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_464 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_479 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_494 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_509 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_524 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_539 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_554 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_569 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_125 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_158 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_184 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_223 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_236 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_278 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_284 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_324 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_338 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_366 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_380 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_408 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_422 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_437 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_454 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_469 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_484 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_499 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_514 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_529 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_544 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_559 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_574 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_145 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_163 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_176 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_202 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_215 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_254 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_267 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_275 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_287 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_306 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_320 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_362 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_390 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_404 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_445 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_460 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_475 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_490 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_505 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_520 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_535 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_550 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_565 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_580 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_193 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_206 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_232 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_245 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_258 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_294 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_315 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_329 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_343 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_357 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_371 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_399 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_413 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_432 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_450 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_465 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_480 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_495 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_510 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_525 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_540 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_555 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_570 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_120 = tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0;
                   const real_t tmp_qloop_126 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_127 = tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_126;
                   const real_t tmp_qloop_128 = tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_126*0.5;
                   const real_t tmp_qloop_135 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_136 = tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135;
                   const real_t tmp_qloop_137 = tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5;
                   const real_t tmp_qloop_159 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_161 = tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0;
                   const real_t tmp_qloop_172 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_174 = tmp_qloop_170*2.0 + tmp_qloop_171*2.0 + tmp_qloop_172*2.0;
                   const real_t tmp_qloop_185 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_187 = tmp_qloop_183*2.0 + tmp_qloop_184*2.0 + tmp_qloop_185*2.0;
                   const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_200 = tmp_qloop_196*2.0 + tmp_qloop_197*2.0 + tmp_qloop_198*2.0;
                   const real_t tmp_qloop_211 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_213 = tmp_qloop_209*2.0 + tmp_qloop_210*2.0 + tmp_qloop_211*2.0;
                   const real_t tmp_qloop_224 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_226 = tmp_qloop_222*2.0 + tmp_qloop_223*2.0 + tmp_qloop_224*2.0;
                   const real_t tmp_qloop_237 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_239 = tmp_qloop_235*2.0 + tmp_qloop_236*2.0 + tmp_qloop_237*2.0;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_252 = tmp_qloop_248*2.0 + tmp_qloop_249*2.0 + tmp_qloop_250*2.0;
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_265 = tmp_qloop_261*2.0 + tmp_qloop_262*2.0 + tmp_qloop_263*2.0;
                   const real_t tmp_qloop_279 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_280 = tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663 + tmp_qloop_279*0.66666666666666663;
                   const real_t tmp_qloop_285 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_291 = tmp_qloop_277*2.0 + tmp_qloop_278*2.0 + tmp_qloop_279*2.0;
                   const real_t tmp_qloop_292 = tmp_qloop_120*tmp_qloop_291;
                   const real_t tmp_qloop_311 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_325 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_339 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_367 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_381 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_409 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_438 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_455 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_470 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_485 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_500 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_515 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_530 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_545 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_560 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_575 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_585 = tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0;
                   const real_t tmp_qloop_589 = tmp_qloop_291*tmp_qloop_585;
                   const real_t tmp_qloop_596 = tmp_qloop_170*1.0 + tmp_qloop_171*1.0 + tmp_qloop_172*1.0;
                   const real_t tmp_qloop_599 = tmp_qloop_291*tmp_qloop_596;
                   const real_t tmp_qloop_605 = tmp_qloop_183*1.0 + tmp_qloop_184*1.0 + tmp_qloop_185*1.0;
                   const real_t tmp_qloop_608 = tmp_qloop_291*tmp_qloop_605;
                   const real_t tmp_qloop_614 = tmp_qloop_196*1.0 + tmp_qloop_197*1.0 + tmp_qloop_198*1.0;
                   const real_t tmp_qloop_617 = tmp_qloop_291*tmp_qloop_614;
                   const real_t tmp_qloop_623 = tmp_qloop_209*1.0 + tmp_qloop_210*1.0 + tmp_qloop_211*1.0;
                   const real_t tmp_qloop_626 = tmp_qloop_291*tmp_qloop_623;
                   const real_t tmp_qloop_632 = tmp_qloop_222*1.0 + tmp_qloop_223*1.0 + tmp_qloop_224*1.0;
                   const real_t tmp_qloop_635 = tmp_qloop_291*tmp_qloop_632;
                   const real_t tmp_qloop_641 = tmp_qloop_235*1.0 + tmp_qloop_236*1.0 + tmp_qloop_237*1.0;
                   const real_t tmp_qloop_644 = tmp_qloop_291*tmp_qloop_641;
                   const real_t tmp_qloop_650 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                   const real_t tmp_qloop_653 = tmp_qloop_291*tmp_qloop_650;
                   const real_t tmp_qloop_659 = tmp_qloop_261*1.0 + tmp_qloop_262*1.0 + tmp_qloop_263*1.0;
                   const real_t tmp_qloop_662 = tmp_qloop_291*tmp_qloop_659;
                   const real_t tmp_qloop_667 = tmp_qloop_277 + tmp_qloop_278 + tmp_qloop_279;
                   const real_t tmp_qloop_674 = tmp_qloop_291*(tmp_qloop_277*1.0 + tmp_qloop_278*1.0 + tmp_qloop_279*1.0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_116 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_123 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_129 = tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_128*2.0;
                   const real_t tmp_qloop_139 = tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0;
                   const real_t tmp_qloop_140 = tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0;
                   const real_t tmp_qloop_141 = tmp_qloop_139*tmp_qloop_140;
                   const real_t tmp_qloop_146 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_147 = tmp_qloop_144 + tmp_qloop_145 + tmp_qloop_146;
                   const real_t tmp_qloop_152 = tmp_qloop_144*0.5 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5;
                   const real_t tmp_qloop_164 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_165 = tmp_qloop_127 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_177 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_178 = tmp_qloop_127 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_191 = tmp_qloop_127 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_203 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_204 = tmp_qloop_127 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_216 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_217 = tmp_qloop_127 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_229 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_230 = tmp_qloop_127 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_243 = tmp_qloop_127 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_255 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_256 = tmp_qloop_127 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_268 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_269 = tmp_qloop_127 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_276 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_288 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_289 = tmp_qloop_286 + tmp_qloop_287 + tmp_qloop_288;
                   const real_t tmp_qloop_290 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_289;
                   const real_t tmp_qloop_299 = tmp_qloop_274*2.0 + tmp_qloop_275*2.0 + tmp_qloop_276*2.0;
                   const real_t tmp_qloop_307 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_312 = tmp_qloop_289 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311;
                   const real_t tmp_qloop_313 = tmp_qloop_305*2.0 + tmp_qloop_306*2.0 + tmp_qloop_307*2.0;
                   const real_t tmp_qloop_321 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_326 = tmp_qloop_289 + tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325;
                   const real_t tmp_qloop_327 = tmp_qloop_319*2.0 + tmp_qloop_320*2.0 + tmp_qloop_321*2.0;
                   const real_t tmp_qloop_335 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_340 = tmp_qloop_289 + tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339;
                   const real_t tmp_qloop_341 = tmp_qloop_333*2.0 + tmp_qloop_334*2.0 + tmp_qloop_335*2.0;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_354 = tmp_qloop_289 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353;
                   const real_t tmp_qloop_355 = tmp_qloop_347*2.0 + tmp_qloop_348*2.0 + tmp_qloop_349*2.0;
                   const real_t tmp_qloop_363 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_368 = tmp_qloop_289 + tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367;
                   const real_t tmp_qloop_369 = tmp_qloop_361*2.0 + tmp_qloop_362*2.0 + tmp_qloop_363*2.0;
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_382 = tmp_qloop_289 + tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381;
                   const real_t tmp_qloop_383 = tmp_qloop_375*2.0 + tmp_qloop_376*2.0 + tmp_qloop_377*2.0;
                   const real_t tmp_qloop_391 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_396 = tmp_qloop_289 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395;
                   const real_t tmp_qloop_397 = tmp_qloop_389*2.0 + tmp_qloop_390*2.0 + tmp_qloop_391*2.0;
                   const real_t tmp_qloop_405 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_410 = tmp_qloop_289 + tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409;
                   const real_t tmp_qloop_411 = tmp_qloop_403*2.0 + tmp_qloop_404*2.0 + tmp_qloop_405*2.0;
                   const real_t tmp_qloop_419 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_424 = tmp_qloop_289 + tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423;
                   const real_t tmp_qloop_425 = tmp_qloop_417*2.0 + tmp_qloop_418*2.0 + tmp_qloop_419*2.0;
                   const real_t tmp_qloop_434 = tmp_qloop_113 + tmp_qloop_280;
                   const real_t tmp_qloop_440 = tmp_qloop_127 + tmp_qloop_289;
                   const real_t tmp_qloop_441 = tmp_qloop_129*tmp_qloop_440 + tmp_qloop_141 + tmp_qloop_292;
                   const real_t tmp_qloop_446 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_461 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_476 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_491 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_506 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_521 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_536 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_551 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_566 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_581 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_586 = tmp_qloop_128*2.0 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_593 = tmp_qloop_440*tmp_qloop_586 + tmp_qloop_589;
                   const real_t tmp_qloop_594 = tmp_qloop_141 + tmp_qloop_593;
                   const real_t tmp_qloop_597 = tmp_qloop_128*2.0 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_602 = tmp_qloop_440*tmp_qloop_597 + tmp_qloop_599;
                   const real_t tmp_qloop_603 = tmp_qloop_141 + tmp_qloop_602;
                   const real_t tmp_qloop_606 = tmp_qloop_128*2.0 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_611 = tmp_qloop_440*tmp_qloop_606 + tmp_qloop_608;
                   const real_t tmp_qloop_612 = tmp_qloop_141 + tmp_qloop_611;
                   const real_t tmp_qloop_615 = tmp_qloop_128*2.0 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_620 = tmp_qloop_440*tmp_qloop_615 + tmp_qloop_617;
                   const real_t tmp_qloop_621 = tmp_qloop_141 + tmp_qloop_620;
                   const real_t tmp_qloop_624 = tmp_qloop_128*2.0 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_629 = tmp_qloop_440*tmp_qloop_624 + tmp_qloop_626;
                   const real_t tmp_qloop_630 = tmp_qloop_141 + tmp_qloop_629;
                   const real_t tmp_qloop_633 = tmp_qloop_128*2.0 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_638 = tmp_qloop_440*tmp_qloop_633 + tmp_qloop_635;
                   const real_t tmp_qloop_639 = tmp_qloop_141 + tmp_qloop_638;
                   const real_t tmp_qloop_642 = tmp_qloop_128*2.0 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_647 = tmp_qloop_440*tmp_qloop_642 + tmp_qloop_644;
                   const real_t tmp_qloop_648 = tmp_qloop_141 + tmp_qloop_647;
                   const real_t tmp_qloop_651 = tmp_qloop_128*2.0 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_656 = tmp_qloop_440*tmp_qloop_651 + tmp_qloop_653;
                   const real_t tmp_qloop_657 = tmp_qloop_141 + tmp_qloop_656;
                   const real_t tmp_qloop_660 = tmp_qloop_128*2.0 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_665 = tmp_qloop_440*tmp_qloop_660 + tmp_qloop_662;
                   const real_t tmp_qloop_666 = tmp_qloop_141 + tmp_qloop_665;
                   const real_t tmp_qloop_670 = tmp_qloop_274*1.0 + tmp_qloop_275*1.0 + tmp_qloop_276*1.0;
                   const real_t tmp_qloop_671 = tmp_qloop_286*0.5 + tmp_qloop_287*0.5 + tmp_qloop_288*0.5;
                   const real_t tmp_qloop_672 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_678 = tmp_qloop_140*tmp_qloop_670 + tmp_qloop_440*tmp_qloop_672 + tmp_qloop_674;
                   const real_t tmp_qloop_690 = tmp_qloop_305*1.0 + tmp_qloop_306*1.0 + tmp_qloop_307*1.0;
                   const real_t tmp_qloop_691 = tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_694 = tmp_qloop_140*tmp_qloop_690 + tmp_qloop_440*tmp_qloop_691;
                   const real_t tmp_qloop_695 = tmp_qloop_674 + tmp_qloop_694;
                   const real_t tmp_qloop_697 = tmp_qloop_319*1.0 + tmp_qloop_320*1.0 + tmp_qloop_321*1.0;
                   const real_t tmp_qloop_698 = tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_700 = tmp_qloop_140*tmp_qloop_697 + tmp_qloop_440*tmp_qloop_698;
                   const real_t tmp_qloop_701 = tmp_qloop_674 + tmp_qloop_700;
                   const real_t tmp_qloop_703 = tmp_qloop_333*1.0 + tmp_qloop_334*1.0 + tmp_qloop_335*1.0;
                   const real_t tmp_qloop_704 = tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_706 = tmp_qloop_140*tmp_qloop_703 + tmp_qloop_440*tmp_qloop_704;
                   const real_t tmp_qloop_707 = tmp_qloop_674 + tmp_qloop_706;
                   const real_t tmp_qloop_709 = tmp_qloop_347*1.0 + tmp_qloop_348*1.0 + tmp_qloop_349*1.0;
                   const real_t tmp_qloop_710 = tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_712 = tmp_qloop_140*tmp_qloop_709 + tmp_qloop_440*tmp_qloop_710;
                   const real_t tmp_qloop_713 = tmp_qloop_674 + tmp_qloop_712;
                   const real_t tmp_qloop_715 = tmp_qloop_361*1.0 + tmp_qloop_362*1.0 + tmp_qloop_363*1.0;
                   const real_t tmp_qloop_716 = tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_718 = tmp_qloop_140*tmp_qloop_715 + tmp_qloop_440*tmp_qloop_716;
                   const real_t tmp_qloop_719 = tmp_qloop_674 + tmp_qloop_718;
                   const real_t tmp_qloop_721 = tmp_qloop_375*1.0 + tmp_qloop_376*1.0 + tmp_qloop_377*1.0;
                   const real_t tmp_qloop_722 = tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_724 = tmp_qloop_140*tmp_qloop_721 + tmp_qloop_440*tmp_qloop_722;
                   const real_t tmp_qloop_725 = tmp_qloop_674 + tmp_qloop_724;
                   const real_t tmp_qloop_727 = tmp_qloop_389*1.0 + tmp_qloop_390*1.0 + tmp_qloop_391*1.0;
                   const real_t tmp_qloop_728 = tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_730 = tmp_qloop_140*tmp_qloop_727 + tmp_qloop_440*tmp_qloop_728;
                   const real_t tmp_qloop_731 = tmp_qloop_674 + tmp_qloop_730;
                   const real_t tmp_qloop_733 = tmp_qloop_403*1.0 + tmp_qloop_404*1.0 + tmp_qloop_405*1.0;
                   const real_t tmp_qloop_734 = tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_736 = tmp_qloop_140*tmp_qloop_733 + tmp_qloop_440*tmp_qloop_734;
                   const real_t tmp_qloop_737 = tmp_qloop_674 + tmp_qloop_736;
                   const real_t tmp_qloop_739 = tmp_qloop_417*1.0 + tmp_qloop_418*1.0 + tmp_qloop_419*1.0;
                   const real_t tmp_qloop_740 = tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_742 = tmp_qloop_140*tmp_qloop_739 + tmp_qloop_440*tmp_qloop_740;
                   const real_t tmp_qloop_743 = tmp_qloop_674 + tmp_qloop_742;
                   const real_t tmp_qloop_744 = tmp_qloop_116 + tmp_qloop_667;
                   const real_t tmp_qloop_749 = tmp_qloop_141 + tmp_qloop_440*(tmp_qloop_128 + tmp_qloop_671)*2.0 + tmp_qloop_674;
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_119 = tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_117);
                   const real_t tmp_qloop_132 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q];
                   const real_t tmp_qloop_138 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_137*2.0;
                   const real_t tmp_qloop_142 = tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0;
                   const real_t tmp_qloop_143 = tmp_qloop_142*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q];
                   const real_t tmp_qloop_151 = tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150;
                   const real_t tmp_qloop_153 = tmp_qloop_148*0.5 + tmp_qloop_149*0.5 + tmp_qloop_150*0.5;
                   const real_t tmp_qloop_154 = tmp_qloop_152*2.0 + tmp_qloop_153*2.0;
                   const real_t tmp_qloop_155 = tmp_qloop_141 + tmp_qloop_143 + tmp_qloop_154*(tmp_qloop_147 + tmp_qloop_151);
                   const real_t tmp_qloop_160 = tmp_qloop_114 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663;
                   const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_169 = tmp_qloop_136 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_173 = tmp_qloop_114 + tmp_qloop_170*0.66666666666666663 + tmp_qloop_171*0.66666666666666663 + tmp_qloop_172*0.66666666666666663;
                   const real_t tmp_qloop_181 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_182 = tmp_qloop_136 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_186 = tmp_qloop_114 + tmp_qloop_183*0.66666666666666663 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663;
                   const real_t tmp_qloop_194 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_195 = tmp_qloop_136 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_199 = tmp_qloop_114 + tmp_qloop_196*0.66666666666666663 + tmp_qloop_197*0.66666666666666663 + tmp_qloop_198*0.66666666666666663;
                   const real_t tmp_qloop_207 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_208 = tmp_qloop_136 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_212 = tmp_qloop_114 + tmp_qloop_209*0.66666666666666663 + tmp_qloop_210*0.66666666666666663 + tmp_qloop_211*0.66666666666666663;
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_221 = tmp_qloop_136 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_225 = tmp_qloop_114 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663 + tmp_qloop_224*0.66666666666666663;
                   const real_t tmp_qloop_233 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_234 = tmp_qloop_136 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_238 = tmp_qloop_114 + tmp_qloop_235*0.66666666666666663 + tmp_qloop_236*0.66666666666666663 + tmp_qloop_237*0.66666666666666663;
                   const real_t tmp_qloop_246 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_247 = tmp_qloop_136 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_251 = tmp_qloop_114 + tmp_qloop_248*0.66666666666666663 + tmp_qloop_249*0.66666666666666663 + tmp_qloop_250*0.66666666666666663;
                   const real_t tmp_qloop_259 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_260 = tmp_qloop_136 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_264 = tmp_qloop_114 + tmp_qloop_261*0.66666666666666663 + tmp_qloop_262*0.66666666666666663 + tmp_qloop_263*0.66666666666666663;
                   const real_t tmp_qloop_272 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_273 = tmp_qloop_136 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_281 = tmp_qloop_109 + tmp_qloop_280;
                   const real_t tmp_qloop_282 = tmp_qloop_274*0.66666666666666663 + tmp_qloop_275*0.66666666666666663 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_281;
                   const real_t tmp_qloop_295 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_296 = tmp_qloop_293 + tmp_qloop_294 + tmp_qloop_295;
                   const real_t tmp_qloop_297 = tmp_qloop_136 + tmp_qloop_296;
                   const real_t tmp_qloop_298 = tmp_qloop_138*tmp_qloop_297 + tmp_qloop_143 + tmp_qloop_292;
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_303 = tmp_qloop_147 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_304 = tmp_qloop_139*tmp_qloop_299 + tmp_qloop_154*tmp_qloop_303;
                   const real_t tmp_qloop_308 = tmp_qloop_281 + tmp_qloop_305*0.66666666666666663 + tmp_qloop_306*0.66666666666666663 + tmp_qloop_307*0.66666666666666663;
                   const real_t tmp_qloop_316 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_317 = tmp_qloop_147 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_318 = tmp_qloop_139*tmp_qloop_313 + tmp_qloop_154*tmp_qloop_317;
                   const real_t tmp_qloop_322 = tmp_qloop_281 + tmp_qloop_319*0.66666666666666663 + tmp_qloop_320*0.66666666666666663 + tmp_qloop_321*0.66666666666666663;
                   const real_t tmp_qloop_330 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_331 = tmp_qloop_147 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_332 = tmp_qloop_139*tmp_qloop_327 + tmp_qloop_154*tmp_qloop_331;
                   const real_t tmp_qloop_336 = tmp_qloop_281 + tmp_qloop_333*0.66666666666666663 + tmp_qloop_334*0.66666666666666663 + tmp_qloop_335*0.66666666666666663;
                   const real_t tmp_qloop_344 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_345 = tmp_qloop_147 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_346 = tmp_qloop_139*tmp_qloop_341 + tmp_qloop_154*tmp_qloop_345;
                   const real_t tmp_qloop_350 = tmp_qloop_281 + tmp_qloop_347*0.66666666666666663 + tmp_qloop_348*0.66666666666666663 + tmp_qloop_349*0.66666666666666663;
                   const real_t tmp_qloop_358 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_359 = tmp_qloop_147 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_360 = tmp_qloop_139*tmp_qloop_355 + tmp_qloop_154*tmp_qloop_359;
                   const real_t tmp_qloop_364 = tmp_qloop_281 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663 + tmp_qloop_363*0.66666666666666663;
                   const real_t tmp_qloop_372 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_373 = tmp_qloop_147 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_374 = tmp_qloop_139*tmp_qloop_369 + tmp_qloop_154*tmp_qloop_373;
                   const real_t tmp_qloop_378 = tmp_qloop_281 + tmp_qloop_375*0.66666666666666663 + tmp_qloop_376*0.66666666666666663 + tmp_qloop_377*0.66666666666666663;
                   const real_t tmp_qloop_386 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_387 = tmp_qloop_147 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_388 = tmp_qloop_139*tmp_qloop_383 + tmp_qloop_154*tmp_qloop_387;
                   const real_t tmp_qloop_392 = tmp_qloop_281 + tmp_qloop_389*0.66666666666666663 + tmp_qloop_390*0.66666666666666663 + tmp_qloop_391*0.66666666666666663;
                   const real_t tmp_qloop_400 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_401 = tmp_qloop_147 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_402 = tmp_qloop_139*tmp_qloop_397 + tmp_qloop_154*tmp_qloop_401;
                   const real_t tmp_qloop_406 = tmp_qloop_281 + tmp_qloop_403*0.66666666666666663 + tmp_qloop_404*0.66666666666666663 + tmp_qloop_405*0.66666666666666663;
                   const real_t tmp_qloop_414 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_415 = tmp_qloop_147 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_416 = tmp_qloop_139*tmp_qloop_411 + tmp_qloop_154*tmp_qloop_415;
                   const real_t tmp_qloop_420 = tmp_qloop_281 + tmp_qloop_417*0.66666666666666663 + tmp_qloop_418*0.66666666666666663 + tmp_qloop_419*0.66666666666666663;
                   const real_t tmp_qloop_428 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_429 = tmp_qloop_147 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_430 = tmp_qloop_139*tmp_qloop_425 + tmp_qloop_154*tmp_qloop_429;
                   const real_t tmp_qloop_433 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 1];
                   const real_t tmp_qloop_435 = tmp_qloop_431*0.66666666666666663 + tmp_qloop_432*0.66666666666666663 + tmp_qloop_433*0.66666666666666663 + tmp_qloop_434;
                   const real_t tmp_qloop_439 = tmp_qloop_296 + tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438;
                   const real_t tmp_qloop_442 = tmp_qloop_431*2.0 + tmp_qloop_432*2.0 + tmp_qloop_433*2.0;
                   const real_t tmp_qloop_443 = tmp_qloop_142*tmp_qloop_442;
                   const real_t tmp_qloop_447 = tmp_qloop_151 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_448 = tmp_qloop_154*tmp_qloop_447 + tmp_qloop_443;
                   const real_t tmp_qloop_451 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 2];
                   const real_t tmp_qloop_452 = tmp_qloop_434 + tmp_qloop_449*0.66666666666666663 + tmp_qloop_450*0.66666666666666663 + tmp_qloop_451*0.66666666666666663;
                   const real_t tmp_qloop_456 = tmp_qloop_296 + tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455;
                   const real_t tmp_qloop_457 = tmp_qloop_449*2.0 + tmp_qloop_450*2.0 + tmp_qloop_451*2.0;
                   const real_t tmp_qloop_458 = tmp_qloop_142*tmp_qloop_457;
                   const real_t tmp_qloop_462 = tmp_qloop_151 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_463 = tmp_qloop_154*tmp_qloop_462 + tmp_qloop_458;
                   const real_t tmp_qloop_466 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 3];
                   const real_t tmp_qloop_467 = tmp_qloop_434 + tmp_qloop_464*0.66666666666666663 + tmp_qloop_465*0.66666666666666663 + tmp_qloop_466*0.66666666666666663;
                   const real_t tmp_qloop_471 = tmp_qloop_296 + tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470;
                   const real_t tmp_qloop_472 = tmp_qloop_464*2.0 + tmp_qloop_465*2.0 + tmp_qloop_466*2.0;
                   const real_t tmp_qloop_473 = tmp_qloop_142*tmp_qloop_472;
                   const real_t tmp_qloop_477 = tmp_qloop_151 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_478 = tmp_qloop_154*tmp_qloop_477 + tmp_qloop_473;
                   const real_t tmp_qloop_481 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 4];
                   const real_t tmp_qloop_482 = tmp_qloop_434 + tmp_qloop_479*0.66666666666666663 + tmp_qloop_480*0.66666666666666663 + tmp_qloop_481*0.66666666666666663;
                   const real_t tmp_qloop_486 = tmp_qloop_296 + tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485;
                   const real_t tmp_qloop_487 = tmp_qloop_479*2.0 + tmp_qloop_480*2.0 + tmp_qloop_481*2.0;
                   const real_t tmp_qloop_488 = tmp_qloop_142*tmp_qloop_487;
                   const real_t tmp_qloop_492 = tmp_qloop_151 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_493 = tmp_qloop_154*tmp_qloop_492 + tmp_qloop_488;
                   const real_t tmp_qloop_496 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 5];
                   const real_t tmp_qloop_497 = tmp_qloop_434 + tmp_qloop_494*0.66666666666666663 + tmp_qloop_495*0.66666666666666663 + tmp_qloop_496*0.66666666666666663;
                   const real_t tmp_qloop_501 = tmp_qloop_296 + tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500;
                   const real_t tmp_qloop_502 = tmp_qloop_494*2.0 + tmp_qloop_495*2.0 + tmp_qloop_496*2.0;
                   const real_t tmp_qloop_503 = tmp_qloop_142*tmp_qloop_502;
                   const real_t tmp_qloop_507 = tmp_qloop_151 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_508 = tmp_qloop_154*tmp_qloop_507 + tmp_qloop_503;
                   const real_t tmp_qloop_511 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 6];
                   const real_t tmp_qloop_512 = tmp_qloop_434 + tmp_qloop_509*0.66666666666666663 + tmp_qloop_510*0.66666666666666663 + tmp_qloop_511*0.66666666666666663;
                   const real_t tmp_qloop_516 = tmp_qloop_296 + tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515;
                   const real_t tmp_qloop_517 = tmp_qloop_509*2.0 + tmp_qloop_510*2.0 + tmp_qloop_511*2.0;
                   const real_t tmp_qloop_518 = tmp_qloop_142*tmp_qloop_517;
                   const real_t tmp_qloop_522 = tmp_qloop_151 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_523 = tmp_qloop_154*tmp_qloop_522 + tmp_qloop_518;
                   const real_t tmp_qloop_526 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 7];
                   const real_t tmp_qloop_527 = tmp_qloop_434 + tmp_qloop_524*0.66666666666666663 + tmp_qloop_525*0.66666666666666663 + tmp_qloop_526*0.66666666666666663;
                   const real_t tmp_qloop_531 = tmp_qloop_296 + tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530;
                   const real_t tmp_qloop_532 = tmp_qloop_524*2.0 + tmp_qloop_525*2.0 + tmp_qloop_526*2.0;
                   const real_t tmp_qloop_533 = tmp_qloop_142*tmp_qloop_532;
                   const real_t tmp_qloop_537 = tmp_qloop_151 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_538 = tmp_qloop_154*tmp_qloop_537 + tmp_qloop_533;
                   const real_t tmp_qloop_541 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 8];
                   const real_t tmp_qloop_542 = tmp_qloop_434 + tmp_qloop_539*0.66666666666666663 + tmp_qloop_540*0.66666666666666663 + tmp_qloop_541*0.66666666666666663;
                   const real_t tmp_qloop_546 = tmp_qloop_296 + tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545;
                   const real_t tmp_qloop_547 = tmp_qloop_539*2.0 + tmp_qloop_540*2.0 + tmp_qloop_541*2.0;
                   const real_t tmp_qloop_548 = tmp_qloop_142*tmp_qloop_547;
                   const real_t tmp_qloop_552 = tmp_qloop_151 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_553 = tmp_qloop_154*tmp_qloop_552 + tmp_qloop_548;
                   const real_t tmp_qloop_556 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 9];
                   const real_t tmp_qloop_557 = tmp_qloop_434 + tmp_qloop_554*0.66666666666666663 + tmp_qloop_555*0.66666666666666663 + tmp_qloop_556*0.66666666666666663;
                   const real_t tmp_qloop_561 = tmp_qloop_296 + tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560;
                   const real_t tmp_qloop_562 = tmp_qloop_554*2.0 + tmp_qloop_555*2.0 + tmp_qloop_556*2.0;
                   const real_t tmp_qloop_563 = tmp_qloop_142*tmp_qloop_562;
                   const real_t tmp_qloop_567 = tmp_qloop_151 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t tmp_qloop_568 = tmp_qloop_154*tmp_qloop_567 + tmp_qloop_563;
                   const real_t tmp_qloop_571 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[11*q + 10];
                   const real_t tmp_qloop_572 = tmp_qloop_434 + tmp_qloop_569*0.66666666666666663 + tmp_qloop_570*0.66666666666666663 + tmp_qloop_571*0.66666666666666663;
                   const real_t tmp_qloop_576 = tmp_qloop_296 + tmp_qloop_573 + tmp_qloop_574 + tmp_qloop_575;
                   const real_t tmp_qloop_577 = tmp_qloop_569*2.0 + tmp_qloop_570*2.0 + tmp_qloop_571*2.0;
                   const real_t tmp_qloop_578 = tmp_qloop_142*tmp_qloop_577;
                   const real_t tmp_qloop_582 = tmp_qloop_151 + tmp_qloop_579 + tmp_qloop_580 + tmp_qloop_581;
                   const real_t tmp_qloop_583 = tmp_qloop_154*tmp_qloop_582 + tmp_qloop_578;
                   const real_t tmp_qloop_584 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159);
                   const real_t tmp_qloop_587 = tmp_qloop_137*2.0 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_588 = tmp_qloop_143 + tmp_qloop_304;
                   const real_t tmp_qloop_590 = tmp_qloop_297*tmp_qloop_587 + tmp_qloop_589;
                   const real_t tmp_qloop_591 = tmp_qloop_143 + tmp_qloop_590;
                   const real_t tmp_qloop_592 = tmp_qloop_141 + tmp_qloop_448;
                   const real_t tmp_qloop_595 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172);
                   const real_t tmp_qloop_598 = tmp_qloop_137*2.0 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_600 = tmp_qloop_297*tmp_qloop_598 + tmp_qloop_599;
                   const real_t tmp_qloop_601 = tmp_qloop_143 + tmp_qloop_600;
                   const real_t tmp_qloop_604 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_183 + tmp_qloop_184 + tmp_qloop_185);
                   const real_t tmp_qloop_607 = tmp_qloop_137*2.0 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_609 = tmp_qloop_297*tmp_qloop_607 + tmp_qloop_608;
                   const real_t tmp_qloop_610 = tmp_qloop_143 + tmp_qloop_609;
                   const real_t tmp_qloop_613 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198);
                   const real_t tmp_qloop_616 = tmp_qloop_137*2.0 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_618 = tmp_qloop_297*tmp_qloop_616 + tmp_qloop_617;
                   const real_t tmp_qloop_619 = tmp_qloop_143 + tmp_qloop_618;
                   const real_t tmp_qloop_622 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211);
                   const real_t tmp_qloop_625 = tmp_qloop_137*2.0 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_627 = tmp_qloop_297*tmp_qloop_625 + tmp_qloop_626;
                   const real_t tmp_qloop_628 = tmp_qloop_143 + tmp_qloop_627;
                   const real_t tmp_qloop_631 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_222 + tmp_qloop_223 + tmp_qloop_224);
                   const real_t tmp_qloop_634 = tmp_qloop_137*2.0 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_636 = tmp_qloop_297*tmp_qloop_634 + tmp_qloop_635;
                   const real_t tmp_qloop_637 = tmp_qloop_143 + tmp_qloop_636;
                   const real_t tmp_qloop_640 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_235 + tmp_qloop_236 + tmp_qloop_237);
                   const real_t tmp_qloop_643 = tmp_qloop_137*2.0 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_645 = tmp_qloop_297*tmp_qloop_643 + tmp_qloop_644;
                   const real_t tmp_qloop_646 = tmp_qloop_143 + tmp_qloop_645;
                   const real_t tmp_qloop_649 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250);
                   const real_t tmp_qloop_652 = tmp_qloop_137*2.0 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_654 = tmp_qloop_297*tmp_qloop_652 + tmp_qloop_653;
                   const real_t tmp_qloop_655 = tmp_qloop_143 + tmp_qloop_654;
                   const real_t tmp_qloop_658 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263);
                   const real_t tmp_qloop_661 = tmp_qloop_137*2.0 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_663 = tmp_qloop_297*tmp_qloop_661 + tmp_qloop_662;
                   const real_t tmp_qloop_664 = tmp_qloop_143 + tmp_qloop_663;
                   const real_t tmp_qloop_668 = tmp_qloop_115 + tmp_qloop_667;
                   const real_t tmp_qloop_669 = tmp_qloop_118*(tmp_qloop_274 + tmp_qloop_275 + tmp_qloop_276 + tmp_qloop_668);
                   const real_t tmp_qloop_673 = tmp_qloop_152*2.0 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_675 = tmp_qloop_293*0.5 + tmp_qloop_294*0.5 + tmp_qloop_295*0.5;
                   const real_t tmp_qloop_676 = tmp_qloop_137*2.0 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_677 = tmp_qloop_143 + tmp_qloop_297*tmp_qloop_676 + tmp_qloop_674;
                   const real_t tmp_qloop_679 = tmp_qloop_439*tmp_qloop_676 + tmp_qloop_443;
                   const real_t tmp_qloop_680 = tmp_qloop_456*tmp_qloop_676 + tmp_qloop_458;
                   const real_t tmp_qloop_681 = tmp_qloop_471*tmp_qloop_676 + tmp_qloop_473;
                   const real_t tmp_qloop_682 = tmp_qloop_486*tmp_qloop_676 + tmp_qloop_488;
                   const real_t tmp_qloop_683 = tmp_qloop_501*tmp_qloop_676 + tmp_qloop_503;
                   const real_t tmp_qloop_684 = tmp_qloop_516*tmp_qloop_676 + tmp_qloop_518;
                   const real_t tmp_qloop_685 = tmp_qloop_531*tmp_qloop_676 + tmp_qloop_533;
                   const real_t tmp_qloop_686 = tmp_qloop_546*tmp_qloop_676 + tmp_qloop_548;
                   const real_t tmp_qloop_687 = tmp_qloop_561*tmp_qloop_676 + tmp_qloop_563;
                   const real_t tmp_qloop_688 = tmp_qloop_576*tmp_qloop_676 + tmp_qloop_578;
                   const real_t tmp_qloop_689 = tmp_qloop_118*(tmp_qloop_305 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_668);
                   const real_t tmp_qloop_692 = tmp_qloop_152*2.0 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_693 = tmp_qloop_674 + tmp_qloop_679;
                   const real_t tmp_qloop_696 = tmp_qloop_118*(tmp_qloop_319 + tmp_qloop_320 + tmp_qloop_321 + tmp_qloop_668);
                   const real_t tmp_qloop_699 = tmp_qloop_152*2.0 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_702 = tmp_qloop_118*(tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335 + tmp_qloop_668);
                   const real_t tmp_qloop_705 = tmp_qloop_152*2.0 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_708 = tmp_qloop_118*(tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349 + tmp_qloop_668);
                   const real_t tmp_qloop_711 = tmp_qloop_152*2.0 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_714 = tmp_qloop_118*(tmp_qloop_361 + tmp_qloop_362 + tmp_qloop_363 + tmp_qloop_668);
                   const real_t tmp_qloop_717 = tmp_qloop_152*2.0 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_720 = tmp_qloop_118*(tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377 + tmp_qloop_668);
                   const real_t tmp_qloop_723 = tmp_qloop_152*2.0 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_726 = tmp_qloop_118*(tmp_qloop_389 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_668);
                   const real_t tmp_qloop_729 = tmp_qloop_152*2.0 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_732 = tmp_qloop_118*(tmp_qloop_403 + tmp_qloop_404 + tmp_qloop_405 + tmp_qloop_668);
                   const real_t tmp_qloop_735 = tmp_qloop_152*2.0 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_738 = tmp_qloop_118*(tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419 + tmp_qloop_668);
                   const real_t tmp_qloop_741 = tmp_qloop_152*2.0 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_745 = tmp_qloop_118*(tmp_qloop_431 + tmp_qloop_432 + tmp_qloop_433 + tmp_qloop_744);
                   const real_t tmp_qloop_746 = tmp_qloop_431*1.0 + tmp_qloop_432*1.0 + tmp_qloop_433*1.0;
                   const real_t tmp_qloop_747 = tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_748 = tmp_qloop_153*2.0 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_750 = tmp_qloop_118*(tmp_qloop_449 + tmp_qloop_450 + tmp_qloop_451 + tmp_qloop_744);
                   const real_t tmp_qloop_751 = tmp_qloop_449*1.0 + tmp_qloop_450*1.0 + tmp_qloop_451*1.0;
                   const real_t tmp_qloop_752 = tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_753 = tmp_qloop_153*2.0 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_754 = tmp_qloop_118*(tmp_qloop_464 + tmp_qloop_465 + tmp_qloop_466 + tmp_qloop_744);
                   const real_t tmp_qloop_755 = tmp_qloop_464*1.0 + tmp_qloop_465*1.0 + tmp_qloop_466*1.0;
                   const real_t tmp_qloop_756 = tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_757 = tmp_qloop_153*2.0 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_758 = tmp_qloop_118*(tmp_qloop_479 + tmp_qloop_480 + tmp_qloop_481 + tmp_qloop_744);
                   const real_t tmp_qloop_759 = tmp_qloop_479*1.0 + tmp_qloop_480*1.0 + tmp_qloop_481*1.0;
                   const real_t tmp_qloop_760 = tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_761 = tmp_qloop_153*2.0 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_762 = tmp_qloop_118*(tmp_qloop_494 + tmp_qloop_495 + tmp_qloop_496 + tmp_qloop_744);
                   const real_t tmp_qloop_763 = tmp_qloop_494*1.0 + tmp_qloop_495*1.0 + tmp_qloop_496*1.0;
                   const real_t tmp_qloop_764 = tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_765 = tmp_qloop_153*2.0 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_766 = tmp_qloop_118*(tmp_qloop_509 + tmp_qloop_510 + tmp_qloop_511 + tmp_qloop_744);
                   const real_t tmp_qloop_767 = tmp_qloop_509*1.0 + tmp_qloop_510*1.0 + tmp_qloop_511*1.0;
                   const real_t tmp_qloop_768 = tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_769 = tmp_qloop_153*2.0 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_770 = tmp_qloop_118*(tmp_qloop_524 + tmp_qloop_525 + tmp_qloop_526 + tmp_qloop_744);
                   const real_t tmp_qloop_771 = tmp_qloop_524*1.0 + tmp_qloop_525*1.0 + tmp_qloop_526*1.0;
                   const real_t tmp_qloop_772 = tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_773 = tmp_qloop_153*2.0 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_774 = tmp_qloop_118*(tmp_qloop_539 + tmp_qloop_540 + tmp_qloop_541 + tmp_qloop_744);
                   const real_t tmp_qloop_775 = tmp_qloop_539*1.0 + tmp_qloop_540*1.0 + tmp_qloop_541*1.0;
                   const real_t tmp_qloop_776 = tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_777 = tmp_qloop_153*2.0 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_778 = tmp_qloop_118*(tmp_qloop_554 + tmp_qloop_555 + tmp_qloop_556 + tmp_qloop_744);
                   const real_t tmp_qloop_779 = tmp_qloop_554*1.0 + tmp_qloop_555*1.0 + tmp_qloop_556*1.0;
                   const real_t tmp_qloop_780 = tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_781 = tmp_qloop_153*2.0 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + tmp_qloop_129*(tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_127) + tmp_qloop_138*(tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_136) + tmp_qloop_155) - tmp_qloop_119*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_114));
                   const real_t q_tmp_0_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_161 + tmp_qloop_129*tmp_qloop_165 + tmp_qloop_138*tmp_qloop_169 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_160);
                   const real_t q_tmp_0_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_174 + tmp_qloop_129*tmp_qloop_178 + tmp_qloop_138*tmp_qloop_182 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_173);
                   const real_t q_tmp_0_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_187 + tmp_qloop_129*tmp_qloop_191 + tmp_qloop_138*tmp_qloop_195 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_186);
                   const real_t q_tmp_0_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_200 + tmp_qloop_129*tmp_qloop_204 + tmp_qloop_138*tmp_qloop_208 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_199);
                   const real_t q_tmp_0_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_213 + tmp_qloop_129*tmp_qloop_217 + tmp_qloop_138*tmp_qloop_221 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_212);
                   const real_t q_tmp_0_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_226 + tmp_qloop_129*tmp_qloop_230 + tmp_qloop_138*tmp_qloop_234 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_225);
                   const real_t q_tmp_0_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_239 + tmp_qloop_129*tmp_qloop_243 + tmp_qloop_138*tmp_qloop_247 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_238);
                   const real_t q_tmp_0_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_252 + tmp_qloop_129*tmp_qloop_256 + tmp_qloop_138*tmp_qloop_260 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_251);
                   const real_t q_tmp_0_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_265 + tmp_qloop_129*tmp_qloop_269 + tmp_qloop_138*tmp_qloop_273 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_264);
                   const real_t q_tmp_0_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_290 + tmp_qloop_298 + tmp_qloop_304) - tmp_qloop_119*tmp_qloop_282);
                   const real_t q_tmp_0_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_312 + tmp_qloop_298 + tmp_qloop_318) - tmp_qloop_119*tmp_qloop_308);
                   const real_t q_tmp_0_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_326 + tmp_qloop_298 + tmp_qloop_332) - tmp_qloop_119*tmp_qloop_322);
                   const real_t q_tmp_0_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_340 + tmp_qloop_298 + tmp_qloop_346) - tmp_qloop_119*tmp_qloop_336);
                   const real_t q_tmp_0_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_354 + tmp_qloop_298 + tmp_qloop_360) - tmp_qloop_119*tmp_qloop_350);
                   const real_t q_tmp_0_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_368 + tmp_qloop_298 + tmp_qloop_374) - tmp_qloop_119*tmp_qloop_364);
                   const real_t q_tmp_0_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_382 + tmp_qloop_298 + tmp_qloop_388) - tmp_qloop_119*tmp_qloop_378);
                   const real_t q_tmp_0_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_396 + tmp_qloop_298 + tmp_qloop_402) - tmp_qloop_119*tmp_qloop_392);
                   const real_t q_tmp_0_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_410 + tmp_qloop_298 + tmp_qloop_416) - tmp_qloop_119*tmp_qloop_406);
                   const real_t q_tmp_0_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_424 + tmp_qloop_298 + tmp_qloop_430) - tmp_qloop_119*tmp_qloop_420);
                   const real_t q_tmp_0_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_439 + tmp_qloop_441 + tmp_qloop_448) - tmp_qloop_119*tmp_qloop_435);
                   const real_t q_tmp_0_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_456 + tmp_qloop_441 + tmp_qloop_463) - tmp_qloop_119*tmp_qloop_452);
                   const real_t q_tmp_0_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_471 + tmp_qloop_441 + tmp_qloop_478) - tmp_qloop_119*tmp_qloop_467);
                   const real_t q_tmp_0_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_486 + tmp_qloop_441 + tmp_qloop_493) - tmp_qloop_119*tmp_qloop_482);
                   const real_t q_tmp_0_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_501 + tmp_qloop_441 + tmp_qloop_508) - tmp_qloop_119*tmp_qloop_497);
                   const real_t q_tmp_0_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_516 + tmp_qloop_441 + tmp_qloop_523) - tmp_qloop_119*tmp_qloop_512);
                   const real_t q_tmp_0_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_531 + tmp_qloop_441 + tmp_qloop_538) - tmp_qloop_119*tmp_qloop_527);
                   const real_t q_tmp_0_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_546 + tmp_qloop_441 + tmp_qloop_553) - tmp_qloop_119*tmp_qloop_542);
                   const real_t q_tmp_0_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_561 + tmp_qloop_441 + tmp_qloop_568) - tmp_qloop_119*tmp_qloop_557);
                   const real_t q_tmp_0_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_576 + tmp_qloop_441 + tmp_qloop_583) - tmp_qloop_119*tmp_qloop_572);
                   const real_t q_tmp_1_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_161*tmp_qloop_585 + tmp_qloop_165*tmp_qloop_586 + tmp_qloop_169*tmp_qloop_587) - tmp_qloop_160*tmp_qloop_584);
                   const real_t q_tmp_1_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_585 + tmp_qloop_178*tmp_qloop_586 + tmp_qloop_182*tmp_qloop_587) - tmp_qloop_173*tmp_qloop_584);
                   const real_t q_tmp_1_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_585 + tmp_qloop_191*tmp_qloop_586 + tmp_qloop_195*tmp_qloop_587) - tmp_qloop_186*tmp_qloop_584);
                   const real_t q_tmp_1_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_585 + tmp_qloop_204*tmp_qloop_586 + tmp_qloop_208*tmp_qloop_587) - tmp_qloop_199*tmp_qloop_584);
                   const real_t q_tmp_1_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_585 + tmp_qloop_217*tmp_qloop_586 + tmp_qloop_221*tmp_qloop_587) - tmp_qloop_212*tmp_qloop_584);
                   const real_t q_tmp_1_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_585 + tmp_qloop_230*tmp_qloop_586 + tmp_qloop_234*tmp_qloop_587) - tmp_qloop_225*tmp_qloop_584);
                   const real_t q_tmp_1_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_585 + tmp_qloop_243*tmp_qloop_586 + tmp_qloop_247*tmp_qloop_587) - tmp_qloop_238*tmp_qloop_584);
                   const real_t q_tmp_1_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_585 + tmp_qloop_256*tmp_qloop_586 + tmp_qloop_260*tmp_qloop_587) - tmp_qloop_251*tmp_qloop_584);
                   const real_t q_tmp_1_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_585 + tmp_qloop_269*tmp_qloop_586 + tmp_qloop_273*tmp_qloop_587) - tmp_qloop_264*tmp_qloop_584);
                   const real_t q_tmp_1_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_586 + tmp_qloop_588 + tmp_qloop_590) - tmp_qloop_282*tmp_qloop_584);
                   const real_t q_tmp_1_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_586 + tmp_qloop_318 + tmp_qloop_591) - tmp_qloop_308*tmp_qloop_584);
                   const real_t q_tmp_1_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_586 + tmp_qloop_332 + tmp_qloop_591) - tmp_qloop_322*tmp_qloop_584);
                   const real_t q_tmp_1_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_586 + tmp_qloop_346 + tmp_qloop_591) - tmp_qloop_336*tmp_qloop_584);
                   const real_t q_tmp_1_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_586 + tmp_qloop_360 + tmp_qloop_591) - tmp_qloop_350*tmp_qloop_584);
                   const real_t q_tmp_1_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_586 + tmp_qloop_374 + tmp_qloop_591) - tmp_qloop_364*tmp_qloop_584);
                   const real_t q_tmp_1_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_586 + tmp_qloop_388 + tmp_qloop_591) - tmp_qloop_378*tmp_qloop_584);
                   const real_t q_tmp_1_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_586 + tmp_qloop_402 + tmp_qloop_591) - tmp_qloop_392*tmp_qloop_584);
                   const real_t q_tmp_1_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_586 + tmp_qloop_416 + tmp_qloop_591) - tmp_qloop_406*tmp_qloop_584);
                   const real_t q_tmp_1_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_586 + tmp_qloop_430 + tmp_qloop_591) - tmp_qloop_420*tmp_qloop_584);
                   const real_t q_tmp_1_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_587 + tmp_qloop_592 + tmp_qloop_593) - tmp_qloop_435*tmp_qloop_584);
                   const real_t q_tmp_1_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_587 + tmp_qloop_463 + tmp_qloop_594) - tmp_qloop_452*tmp_qloop_584);
                   const real_t q_tmp_1_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_587 + tmp_qloop_478 + tmp_qloop_594) - tmp_qloop_467*tmp_qloop_584);
                   const real_t q_tmp_1_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_587 + tmp_qloop_493 + tmp_qloop_594) - tmp_qloop_482*tmp_qloop_584);
                   const real_t q_tmp_1_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_587 + tmp_qloop_508 + tmp_qloop_594) - tmp_qloop_497*tmp_qloop_584);
                   const real_t q_tmp_1_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_587 + tmp_qloop_523 + tmp_qloop_594) - tmp_qloop_512*tmp_qloop_584);
                   const real_t q_tmp_1_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_587 + tmp_qloop_538 + tmp_qloop_594) - tmp_qloop_527*tmp_qloop_584);
                   const real_t q_tmp_1_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_587 + tmp_qloop_553 + tmp_qloop_594) - tmp_qloop_542*tmp_qloop_584);
                   const real_t q_tmp_1_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_587 + tmp_qloop_568 + tmp_qloop_594) - tmp_qloop_557*tmp_qloop_584);
                   const real_t q_tmp_1_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_587 + tmp_qloop_583 + tmp_qloop_594) - tmp_qloop_572*tmp_qloop_584);
                   const real_t q_tmp_2_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_596 + tmp_qloop_178*tmp_qloop_597 + tmp_qloop_182*tmp_qloop_598) - tmp_qloop_173*tmp_qloop_595);
                   const real_t q_tmp_2_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_596 + tmp_qloop_191*tmp_qloop_597 + tmp_qloop_195*tmp_qloop_598) - tmp_qloop_186*tmp_qloop_595);
                   const real_t q_tmp_2_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_596 + tmp_qloop_204*tmp_qloop_597 + tmp_qloop_208*tmp_qloop_598) - tmp_qloop_199*tmp_qloop_595);
                   const real_t q_tmp_2_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_596 + tmp_qloop_217*tmp_qloop_597 + tmp_qloop_221*tmp_qloop_598) - tmp_qloop_212*tmp_qloop_595);
                   const real_t q_tmp_2_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_596 + tmp_qloop_230*tmp_qloop_597 + tmp_qloop_234*tmp_qloop_598) - tmp_qloop_225*tmp_qloop_595);
                   const real_t q_tmp_2_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_596 + tmp_qloop_243*tmp_qloop_597 + tmp_qloop_247*tmp_qloop_598) - tmp_qloop_238*tmp_qloop_595);
                   const real_t q_tmp_2_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_596 + tmp_qloop_256*tmp_qloop_597 + tmp_qloop_260*tmp_qloop_598) - tmp_qloop_251*tmp_qloop_595);
                   const real_t q_tmp_2_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_596 + tmp_qloop_269*tmp_qloop_597 + tmp_qloop_273*tmp_qloop_598) - tmp_qloop_264*tmp_qloop_595);
                   const real_t q_tmp_2_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_597 + tmp_qloop_588 + tmp_qloop_600) - tmp_qloop_282*tmp_qloop_595);
                   const real_t q_tmp_2_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_597 + tmp_qloop_318 + tmp_qloop_601) - tmp_qloop_308*tmp_qloop_595);
                   const real_t q_tmp_2_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_597 + tmp_qloop_332 + tmp_qloop_601) - tmp_qloop_322*tmp_qloop_595);
                   const real_t q_tmp_2_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_597 + tmp_qloop_346 + tmp_qloop_601) - tmp_qloop_336*tmp_qloop_595);
                   const real_t q_tmp_2_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_597 + tmp_qloop_360 + tmp_qloop_601) - tmp_qloop_350*tmp_qloop_595);
                   const real_t q_tmp_2_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_597 + tmp_qloop_374 + tmp_qloop_601) - tmp_qloop_364*tmp_qloop_595);
                   const real_t q_tmp_2_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_597 + tmp_qloop_388 + tmp_qloop_601) - tmp_qloop_378*tmp_qloop_595);
                   const real_t q_tmp_2_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_597 + tmp_qloop_402 + tmp_qloop_601) - tmp_qloop_392*tmp_qloop_595);
                   const real_t q_tmp_2_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_597 + tmp_qloop_416 + tmp_qloop_601) - tmp_qloop_406*tmp_qloop_595);
                   const real_t q_tmp_2_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_597 + tmp_qloop_430 + tmp_qloop_601) - tmp_qloop_420*tmp_qloop_595);
                   const real_t q_tmp_2_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_598 + tmp_qloop_592 + tmp_qloop_602) - tmp_qloop_435*tmp_qloop_595);
                   const real_t q_tmp_2_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_598 + tmp_qloop_463 + tmp_qloop_603) - tmp_qloop_452*tmp_qloop_595);
                   const real_t q_tmp_2_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_598 + tmp_qloop_478 + tmp_qloop_603) - tmp_qloop_467*tmp_qloop_595);
                   const real_t q_tmp_2_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_598 + tmp_qloop_493 + tmp_qloop_603) - tmp_qloop_482*tmp_qloop_595);
                   const real_t q_tmp_2_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_598 + tmp_qloop_508 + tmp_qloop_603) - tmp_qloop_497*tmp_qloop_595);
                   const real_t q_tmp_2_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_598 + tmp_qloop_523 + tmp_qloop_603) - tmp_qloop_512*tmp_qloop_595);
                   const real_t q_tmp_2_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_598 + tmp_qloop_538 + tmp_qloop_603) - tmp_qloop_527*tmp_qloop_595);
                   const real_t q_tmp_2_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_598 + tmp_qloop_553 + tmp_qloop_603) - tmp_qloop_542*tmp_qloop_595);
                   const real_t q_tmp_2_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_598 + tmp_qloop_568 + tmp_qloop_603) - tmp_qloop_557*tmp_qloop_595);
                   const real_t q_tmp_2_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_598 + tmp_qloop_583 + tmp_qloop_603) - tmp_qloop_572*tmp_qloop_595);
                   const real_t q_tmp_3_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_605 + tmp_qloop_191*tmp_qloop_606 + tmp_qloop_195*tmp_qloop_607) - tmp_qloop_186*tmp_qloop_604);
                   const real_t q_tmp_3_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_605 + tmp_qloop_204*tmp_qloop_606 + tmp_qloop_208*tmp_qloop_607) - tmp_qloop_199*tmp_qloop_604);
                   const real_t q_tmp_3_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_605 + tmp_qloop_217*tmp_qloop_606 + tmp_qloop_221*tmp_qloop_607) - tmp_qloop_212*tmp_qloop_604);
                   const real_t q_tmp_3_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_605 + tmp_qloop_230*tmp_qloop_606 + tmp_qloop_234*tmp_qloop_607) - tmp_qloop_225*tmp_qloop_604);
                   const real_t q_tmp_3_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_605 + tmp_qloop_243*tmp_qloop_606 + tmp_qloop_247*tmp_qloop_607) - tmp_qloop_238*tmp_qloop_604);
                   const real_t q_tmp_3_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_605 + tmp_qloop_256*tmp_qloop_606 + tmp_qloop_260*tmp_qloop_607) - tmp_qloop_251*tmp_qloop_604);
                   const real_t q_tmp_3_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_605 + tmp_qloop_269*tmp_qloop_606 + tmp_qloop_273*tmp_qloop_607) - tmp_qloop_264*tmp_qloop_604);
                   const real_t q_tmp_3_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_606 + tmp_qloop_588 + tmp_qloop_609) - tmp_qloop_282*tmp_qloop_604);
                   const real_t q_tmp_3_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_606 + tmp_qloop_318 + tmp_qloop_610) - tmp_qloop_308*tmp_qloop_604);
                   const real_t q_tmp_3_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_606 + tmp_qloop_332 + tmp_qloop_610) - tmp_qloop_322*tmp_qloop_604);
                   const real_t q_tmp_3_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_606 + tmp_qloop_346 + tmp_qloop_610) - tmp_qloop_336*tmp_qloop_604);
                   const real_t q_tmp_3_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_606 + tmp_qloop_360 + tmp_qloop_610) - tmp_qloop_350*tmp_qloop_604);
                   const real_t q_tmp_3_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_606 + tmp_qloop_374 + tmp_qloop_610) - tmp_qloop_364*tmp_qloop_604);
                   const real_t q_tmp_3_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_606 + tmp_qloop_388 + tmp_qloop_610) - tmp_qloop_378*tmp_qloop_604);
                   const real_t q_tmp_3_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_606 + tmp_qloop_402 + tmp_qloop_610) - tmp_qloop_392*tmp_qloop_604);
                   const real_t q_tmp_3_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_606 + tmp_qloop_416 + tmp_qloop_610) - tmp_qloop_406*tmp_qloop_604);
                   const real_t q_tmp_3_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_606 + tmp_qloop_430 + tmp_qloop_610) - tmp_qloop_420*tmp_qloop_604);
                   const real_t q_tmp_3_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_607 + tmp_qloop_592 + tmp_qloop_611) - tmp_qloop_435*tmp_qloop_604);
                   const real_t q_tmp_3_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_607 + tmp_qloop_463 + tmp_qloop_612) - tmp_qloop_452*tmp_qloop_604);
                   const real_t q_tmp_3_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_607 + tmp_qloop_478 + tmp_qloop_612) - tmp_qloop_467*tmp_qloop_604);
                   const real_t q_tmp_3_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_607 + tmp_qloop_493 + tmp_qloop_612) - tmp_qloop_482*tmp_qloop_604);
                   const real_t q_tmp_3_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_607 + tmp_qloop_508 + tmp_qloop_612) - tmp_qloop_497*tmp_qloop_604);
                   const real_t q_tmp_3_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_607 + tmp_qloop_523 + tmp_qloop_612) - tmp_qloop_512*tmp_qloop_604);
                   const real_t q_tmp_3_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_607 + tmp_qloop_538 + tmp_qloop_612) - tmp_qloop_527*tmp_qloop_604);
                   const real_t q_tmp_3_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_607 + tmp_qloop_553 + tmp_qloop_612) - tmp_qloop_542*tmp_qloop_604);
                   const real_t q_tmp_3_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_607 + tmp_qloop_568 + tmp_qloop_612) - tmp_qloop_557*tmp_qloop_604);
                   const real_t q_tmp_3_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_607 + tmp_qloop_583 + tmp_qloop_612) - tmp_qloop_572*tmp_qloop_604);
                   const real_t q_tmp_4_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_614 + tmp_qloop_204*tmp_qloop_615 + tmp_qloop_208*tmp_qloop_616) - tmp_qloop_199*tmp_qloop_613);
                   const real_t q_tmp_4_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_614 + tmp_qloop_217*tmp_qloop_615 + tmp_qloop_221*tmp_qloop_616) - tmp_qloop_212*tmp_qloop_613);
                   const real_t q_tmp_4_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_614 + tmp_qloop_230*tmp_qloop_615 + tmp_qloop_234*tmp_qloop_616) - tmp_qloop_225*tmp_qloop_613);
                   const real_t q_tmp_4_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_614 + tmp_qloop_243*tmp_qloop_615 + tmp_qloop_247*tmp_qloop_616) - tmp_qloop_238*tmp_qloop_613);
                   const real_t q_tmp_4_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_614 + tmp_qloop_256*tmp_qloop_615 + tmp_qloop_260*tmp_qloop_616) - tmp_qloop_251*tmp_qloop_613);
                   const real_t q_tmp_4_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_614 + tmp_qloop_269*tmp_qloop_615 + tmp_qloop_273*tmp_qloop_616) - tmp_qloop_264*tmp_qloop_613);
                   const real_t q_tmp_4_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_615 + tmp_qloop_588 + tmp_qloop_618) - tmp_qloop_282*tmp_qloop_613);
                   const real_t q_tmp_4_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_615 + tmp_qloop_318 + tmp_qloop_619) - tmp_qloop_308*tmp_qloop_613);
                   const real_t q_tmp_4_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_615 + tmp_qloop_332 + tmp_qloop_619) - tmp_qloop_322*tmp_qloop_613);
                   const real_t q_tmp_4_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_615 + tmp_qloop_346 + tmp_qloop_619) - tmp_qloop_336*tmp_qloop_613);
                   const real_t q_tmp_4_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_615 + tmp_qloop_360 + tmp_qloop_619) - tmp_qloop_350*tmp_qloop_613);
                   const real_t q_tmp_4_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_615 + tmp_qloop_374 + tmp_qloop_619) - tmp_qloop_364*tmp_qloop_613);
                   const real_t q_tmp_4_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_615 + tmp_qloop_388 + tmp_qloop_619) - tmp_qloop_378*tmp_qloop_613);
                   const real_t q_tmp_4_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_615 + tmp_qloop_402 + tmp_qloop_619) - tmp_qloop_392*tmp_qloop_613);
                   const real_t q_tmp_4_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_615 + tmp_qloop_416 + tmp_qloop_619) - tmp_qloop_406*tmp_qloop_613);
                   const real_t q_tmp_4_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_615 + tmp_qloop_430 + tmp_qloop_619) - tmp_qloop_420*tmp_qloop_613);
                   const real_t q_tmp_4_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_616 + tmp_qloop_592 + tmp_qloop_620) - tmp_qloop_435*tmp_qloop_613);
                   const real_t q_tmp_4_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_616 + tmp_qloop_463 + tmp_qloop_621) - tmp_qloop_452*tmp_qloop_613);
                   const real_t q_tmp_4_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_616 + tmp_qloop_478 + tmp_qloop_621) - tmp_qloop_467*tmp_qloop_613);
                   const real_t q_tmp_4_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_616 + tmp_qloop_493 + tmp_qloop_621) - tmp_qloop_482*tmp_qloop_613);
                   const real_t q_tmp_4_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_616 + tmp_qloop_508 + tmp_qloop_621) - tmp_qloop_497*tmp_qloop_613);
                   const real_t q_tmp_4_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_616 + tmp_qloop_523 + tmp_qloop_621) - tmp_qloop_512*tmp_qloop_613);
                   const real_t q_tmp_4_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_616 + tmp_qloop_538 + tmp_qloop_621) - tmp_qloop_527*tmp_qloop_613);
                   const real_t q_tmp_4_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_616 + tmp_qloop_553 + tmp_qloop_621) - tmp_qloop_542*tmp_qloop_613);
                   const real_t q_tmp_4_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_616 + tmp_qloop_568 + tmp_qloop_621) - tmp_qloop_557*tmp_qloop_613);
                   const real_t q_tmp_4_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_616 + tmp_qloop_583 + tmp_qloop_621) - tmp_qloop_572*tmp_qloop_613);
                   const real_t q_tmp_5_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_623 + tmp_qloop_217*tmp_qloop_624 + tmp_qloop_221*tmp_qloop_625) - tmp_qloop_212*tmp_qloop_622);
                   const real_t q_tmp_5_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_623 + tmp_qloop_230*tmp_qloop_624 + tmp_qloop_234*tmp_qloop_625) - tmp_qloop_225*tmp_qloop_622);
                   const real_t q_tmp_5_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_623 + tmp_qloop_243*tmp_qloop_624 + tmp_qloop_247*tmp_qloop_625) - tmp_qloop_238*tmp_qloop_622);
                   const real_t q_tmp_5_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_623 + tmp_qloop_256*tmp_qloop_624 + tmp_qloop_260*tmp_qloop_625) - tmp_qloop_251*tmp_qloop_622);
                   const real_t q_tmp_5_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_623 + tmp_qloop_269*tmp_qloop_624 + tmp_qloop_273*tmp_qloop_625) - tmp_qloop_264*tmp_qloop_622);
                   const real_t q_tmp_5_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_624 + tmp_qloop_588 + tmp_qloop_627) - tmp_qloop_282*tmp_qloop_622);
                   const real_t q_tmp_5_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_624 + tmp_qloop_318 + tmp_qloop_628) - tmp_qloop_308*tmp_qloop_622);
                   const real_t q_tmp_5_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_624 + tmp_qloop_332 + tmp_qloop_628) - tmp_qloop_322*tmp_qloop_622);
                   const real_t q_tmp_5_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_624 + tmp_qloop_346 + tmp_qloop_628) - tmp_qloop_336*tmp_qloop_622);
                   const real_t q_tmp_5_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_624 + tmp_qloop_360 + tmp_qloop_628) - tmp_qloop_350*tmp_qloop_622);
                   const real_t q_tmp_5_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_624 + tmp_qloop_374 + tmp_qloop_628) - tmp_qloop_364*tmp_qloop_622);
                   const real_t q_tmp_5_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_624 + tmp_qloop_388 + tmp_qloop_628) - tmp_qloop_378*tmp_qloop_622);
                   const real_t q_tmp_5_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_624 + tmp_qloop_402 + tmp_qloop_628) - tmp_qloop_392*tmp_qloop_622);
                   const real_t q_tmp_5_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_624 + tmp_qloop_416 + tmp_qloop_628) - tmp_qloop_406*tmp_qloop_622);
                   const real_t q_tmp_5_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_624 + tmp_qloop_430 + tmp_qloop_628) - tmp_qloop_420*tmp_qloop_622);
                   const real_t q_tmp_5_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_625 + tmp_qloop_592 + tmp_qloop_629) - tmp_qloop_435*tmp_qloop_622);
                   const real_t q_tmp_5_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_625 + tmp_qloop_463 + tmp_qloop_630) - tmp_qloop_452*tmp_qloop_622);
                   const real_t q_tmp_5_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_625 + tmp_qloop_478 + tmp_qloop_630) - tmp_qloop_467*tmp_qloop_622);
                   const real_t q_tmp_5_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_625 + tmp_qloop_493 + tmp_qloop_630) - tmp_qloop_482*tmp_qloop_622);
                   const real_t q_tmp_5_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_625 + tmp_qloop_508 + tmp_qloop_630) - tmp_qloop_497*tmp_qloop_622);
                   const real_t q_tmp_5_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_625 + tmp_qloop_523 + tmp_qloop_630) - tmp_qloop_512*tmp_qloop_622);
                   const real_t q_tmp_5_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_625 + tmp_qloop_538 + tmp_qloop_630) - tmp_qloop_527*tmp_qloop_622);
                   const real_t q_tmp_5_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_625 + tmp_qloop_553 + tmp_qloop_630) - tmp_qloop_542*tmp_qloop_622);
                   const real_t q_tmp_5_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_625 + tmp_qloop_568 + tmp_qloop_630) - tmp_qloop_557*tmp_qloop_622);
                   const real_t q_tmp_5_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_625 + tmp_qloop_583 + tmp_qloop_630) - tmp_qloop_572*tmp_qloop_622);
                   const real_t q_tmp_6_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_632 + tmp_qloop_230*tmp_qloop_633 + tmp_qloop_234*tmp_qloop_634) - tmp_qloop_225*tmp_qloop_631);
                   const real_t q_tmp_6_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_632 + tmp_qloop_243*tmp_qloop_633 + tmp_qloop_247*tmp_qloop_634) - tmp_qloop_238*tmp_qloop_631);
                   const real_t q_tmp_6_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_632 + tmp_qloop_256*tmp_qloop_633 + tmp_qloop_260*tmp_qloop_634) - tmp_qloop_251*tmp_qloop_631);
                   const real_t q_tmp_6_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_632 + tmp_qloop_269*tmp_qloop_633 + tmp_qloop_273*tmp_qloop_634) - tmp_qloop_264*tmp_qloop_631);
                   const real_t q_tmp_6_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_633 + tmp_qloop_588 + tmp_qloop_636) - tmp_qloop_282*tmp_qloop_631);
                   const real_t q_tmp_6_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_633 + tmp_qloop_318 + tmp_qloop_637) - tmp_qloop_308*tmp_qloop_631);
                   const real_t q_tmp_6_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_633 + tmp_qloop_332 + tmp_qloop_637) - tmp_qloop_322*tmp_qloop_631);
                   const real_t q_tmp_6_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_633 + tmp_qloop_346 + tmp_qloop_637) - tmp_qloop_336*tmp_qloop_631);
                   const real_t q_tmp_6_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_633 + tmp_qloop_360 + tmp_qloop_637) - tmp_qloop_350*tmp_qloop_631);
                   const real_t q_tmp_6_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_633 + tmp_qloop_374 + tmp_qloop_637) - tmp_qloop_364*tmp_qloop_631);
                   const real_t q_tmp_6_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_633 + tmp_qloop_388 + tmp_qloop_637) - tmp_qloop_378*tmp_qloop_631);
                   const real_t q_tmp_6_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_633 + tmp_qloop_402 + tmp_qloop_637) - tmp_qloop_392*tmp_qloop_631);
                   const real_t q_tmp_6_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_633 + tmp_qloop_416 + tmp_qloop_637) - tmp_qloop_406*tmp_qloop_631);
                   const real_t q_tmp_6_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_633 + tmp_qloop_430 + tmp_qloop_637) - tmp_qloop_420*tmp_qloop_631);
                   const real_t q_tmp_6_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_634 + tmp_qloop_592 + tmp_qloop_638) - tmp_qloop_435*tmp_qloop_631);
                   const real_t q_tmp_6_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_634 + tmp_qloop_463 + tmp_qloop_639) - tmp_qloop_452*tmp_qloop_631);
                   const real_t q_tmp_6_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_634 + tmp_qloop_478 + tmp_qloop_639) - tmp_qloop_467*tmp_qloop_631);
                   const real_t q_tmp_6_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_634 + tmp_qloop_493 + tmp_qloop_639) - tmp_qloop_482*tmp_qloop_631);
                   const real_t q_tmp_6_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_634 + tmp_qloop_508 + tmp_qloop_639) - tmp_qloop_497*tmp_qloop_631);
                   const real_t q_tmp_6_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_634 + tmp_qloop_523 + tmp_qloop_639) - tmp_qloop_512*tmp_qloop_631);
                   const real_t q_tmp_6_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_634 + tmp_qloop_538 + tmp_qloop_639) - tmp_qloop_527*tmp_qloop_631);
                   const real_t q_tmp_6_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_634 + tmp_qloop_553 + tmp_qloop_639) - tmp_qloop_542*tmp_qloop_631);
                   const real_t q_tmp_6_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_634 + tmp_qloop_568 + tmp_qloop_639) - tmp_qloop_557*tmp_qloop_631);
                   const real_t q_tmp_6_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_634 + tmp_qloop_583 + tmp_qloop_639) - tmp_qloop_572*tmp_qloop_631);
                   const real_t q_tmp_7_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_641 + tmp_qloop_243*tmp_qloop_642 + tmp_qloop_247*tmp_qloop_643) - tmp_qloop_238*tmp_qloop_640);
                   const real_t q_tmp_7_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_641 + tmp_qloop_256*tmp_qloop_642 + tmp_qloop_260*tmp_qloop_643) - tmp_qloop_251*tmp_qloop_640);
                   const real_t q_tmp_7_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_641 + tmp_qloop_269*tmp_qloop_642 + tmp_qloop_273*tmp_qloop_643) - tmp_qloop_264*tmp_qloop_640);
                   const real_t q_tmp_7_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_642 + tmp_qloop_588 + tmp_qloop_645) - tmp_qloop_282*tmp_qloop_640);
                   const real_t q_tmp_7_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_642 + tmp_qloop_318 + tmp_qloop_646) - tmp_qloop_308*tmp_qloop_640);
                   const real_t q_tmp_7_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_642 + tmp_qloop_332 + tmp_qloop_646) - tmp_qloop_322*tmp_qloop_640);
                   const real_t q_tmp_7_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_642 + tmp_qloop_346 + tmp_qloop_646) - tmp_qloop_336*tmp_qloop_640);
                   const real_t q_tmp_7_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_642 + tmp_qloop_360 + tmp_qloop_646) - tmp_qloop_350*tmp_qloop_640);
                   const real_t q_tmp_7_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_642 + tmp_qloop_374 + tmp_qloop_646) - tmp_qloop_364*tmp_qloop_640);
                   const real_t q_tmp_7_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_642 + tmp_qloop_388 + tmp_qloop_646) - tmp_qloop_378*tmp_qloop_640);
                   const real_t q_tmp_7_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_642 + tmp_qloop_402 + tmp_qloop_646) - tmp_qloop_392*tmp_qloop_640);
                   const real_t q_tmp_7_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_642 + tmp_qloop_416 + tmp_qloop_646) - tmp_qloop_406*tmp_qloop_640);
                   const real_t q_tmp_7_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_642 + tmp_qloop_430 + tmp_qloop_646) - tmp_qloop_420*tmp_qloop_640);
                   const real_t q_tmp_7_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_643 + tmp_qloop_592 + tmp_qloop_647) - tmp_qloop_435*tmp_qloop_640);
                   const real_t q_tmp_7_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_643 + tmp_qloop_463 + tmp_qloop_648) - tmp_qloop_452*tmp_qloop_640);
                   const real_t q_tmp_7_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_643 + tmp_qloop_478 + tmp_qloop_648) - tmp_qloop_467*tmp_qloop_640);
                   const real_t q_tmp_7_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_643 + tmp_qloop_493 + tmp_qloop_648) - tmp_qloop_482*tmp_qloop_640);
                   const real_t q_tmp_7_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_643 + tmp_qloop_508 + tmp_qloop_648) - tmp_qloop_497*tmp_qloop_640);
                   const real_t q_tmp_7_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_643 + tmp_qloop_523 + tmp_qloop_648) - tmp_qloop_512*tmp_qloop_640);
                   const real_t q_tmp_7_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_643 + tmp_qloop_538 + tmp_qloop_648) - tmp_qloop_527*tmp_qloop_640);
                   const real_t q_tmp_7_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_643 + tmp_qloop_553 + tmp_qloop_648) - tmp_qloop_542*tmp_qloop_640);
                   const real_t q_tmp_7_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_643 + tmp_qloop_568 + tmp_qloop_648) - tmp_qloop_557*tmp_qloop_640);
                   const real_t q_tmp_7_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_643 + tmp_qloop_583 + tmp_qloop_648) - tmp_qloop_572*tmp_qloop_640);
                   const real_t q_tmp_8_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_650 + tmp_qloop_256*tmp_qloop_651 + tmp_qloop_260*tmp_qloop_652) - tmp_qloop_251*tmp_qloop_649);
                   const real_t q_tmp_8_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_650 + tmp_qloop_269*tmp_qloop_651 + tmp_qloop_273*tmp_qloop_652) - tmp_qloop_264*tmp_qloop_649);
                   const real_t q_tmp_8_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_651 + tmp_qloop_588 + tmp_qloop_654) - tmp_qloop_282*tmp_qloop_649);
                   const real_t q_tmp_8_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_651 + tmp_qloop_318 + tmp_qloop_655) - tmp_qloop_308*tmp_qloop_649);
                   const real_t q_tmp_8_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_651 + tmp_qloop_332 + tmp_qloop_655) - tmp_qloop_322*tmp_qloop_649);
                   const real_t q_tmp_8_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_651 + tmp_qloop_346 + tmp_qloop_655) - tmp_qloop_336*tmp_qloop_649);
                   const real_t q_tmp_8_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_651 + tmp_qloop_360 + tmp_qloop_655) - tmp_qloop_350*tmp_qloop_649);
                   const real_t q_tmp_8_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_651 + tmp_qloop_374 + tmp_qloop_655) - tmp_qloop_364*tmp_qloop_649);
                   const real_t q_tmp_8_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_651 + tmp_qloop_388 + tmp_qloop_655) - tmp_qloop_378*tmp_qloop_649);
                   const real_t q_tmp_8_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_651 + tmp_qloop_402 + tmp_qloop_655) - tmp_qloop_392*tmp_qloop_649);
                   const real_t q_tmp_8_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_651 + tmp_qloop_416 + tmp_qloop_655) - tmp_qloop_406*tmp_qloop_649);
                   const real_t q_tmp_8_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_651 + tmp_qloop_430 + tmp_qloop_655) - tmp_qloop_420*tmp_qloop_649);
                   const real_t q_tmp_8_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_652 + tmp_qloop_592 + tmp_qloop_656) - tmp_qloop_435*tmp_qloop_649);
                   const real_t q_tmp_8_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_652 + tmp_qloop_463 + tmp_qloop_657) - tmp_qloop_452*tmp_qloop_649);
                   const real_t q_tmp_8_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_652 + tmp_qloop_478 + tmp_qloop_657) - tmp_qloop_467*tmp_qloop_649);
                   const real_t q_tmp_8_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_652 + tmp_qloop_493 + tmp_qloop_657) - tmp_qloop_482*tmp_qloop_649);
                   const real_t q_tmp_8_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_652 + tmp_qloop_508 + tmp_qloop_657) - tmp_qloop_497*tmp_qloop_649);
                   const real_t q_tmp_8_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_652 + tmp_qloop_523 + tmp_qloop_657) - tmp_qloop_512*tmp_qloop_649);
                   const real_t q_tmp_8_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_652 + tmp_qloop_538 + tmp_qloop_657) - tmp_qloop_527*tmp_qloop_649);
                   const real_t q_tmp_8_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_652 + tmp_qloop_553 + tmp_qloop_657) - tmp_qloop_542*tmp_qloop_649);
                   const real_t q_tmp_8_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_652 + tmp_qloop_568 + tmp_qloop_657) - tmp_qloop_557*tmp_qloop_649);
                   const real_t q_tmp_8_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_652 + tmp_qloop_583 + tmp_qloop_657) - tmp_qloop_572*tmp_qloop_649);
                   const real_t q_tmp_9_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_659 + tmp_qloop_269*tmp_qloop_660 + tmp_qloop_273*tmp_qloop_661) - tmp_qloop_264*tmp_qloop_658);
                   const real_t q_tmp_9_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_660 + tmp_qloop_588 + tmp_qloop_663) - tmp_qloop_282*tmp_qloop_658);
                   const real_t q_tmp_9_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_660 + tmp_qloop_318 + tmp_qloop_664) - tmp_qloop_308*tmp_qloop_658);
                   const real_t q_tmp_9_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_660 + tmp_qloop_332 + tmp_qloop_664) - tmp_qloop_322*tmp_qloop_658);
                   const real_t q_tmp_9_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_660 + tmp_qloop_346 + tmp_qloop_664) - tmp_qloop_336*tmp_qloop_658);
                   const real_t q_tmp_9_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_660 + tmp_qloop_360 + tmp_qloop_664) - tmp_qloop_350*tmp_qloop_658);
                   const real_t q_tmp_9_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_660 + tmp_qloop_374 + tmp_qloop_664) - tmp_qloop_364*tmp_qloop_658);
                   const real_t q_tmp_9_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_660 + tmp_qloop_388 + tmp_qloop_664) - tmp_qloop_378*tmp_qloop_658);
                   const real_t q_tmp_9_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_660 + tmp_qloop_402 + tmp_qloop_664) - tmp_qloop_392*tmp_qloop_658);
                   const real_t q_tmp_9_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_660 + tmp_qloop_416 + tmp_qloop_664) - tmp_qloop_406*tmp_qloop_658);
                   const real_t q_tmp_9_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_660 + tmp_qloop_430 + tmp_qloop_664) - tmp_qloop_420*tmp_qloop_658);
                   const real_t q_tmp_9_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_661 + tmp_qloop_592 + tmp_qloop_665) - tmp_qloop_435*tmp_qloop_658);
                   const real_t q_tmp_9_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_661 + tmp_qloop_463 + tmp_qloop_666) - tmp_qloop_452*tmp_qloop_658);
                   const real_t q_tmp_9_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_661 + tmp_qloop_478 + tmp_qloop_666) - tmp_qloop_467*tmp_qloop_658);
                   const real_t q_tmp_9_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_661 + tmp_qloop_493 + tmp_qloop_666) - tmp_qloop_482*tmp_qloop_658);
                   const real_t q_tmp_9_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_661 + tmp_qloop_508 + tmp_qloop_666) - tmp_qloop_497*tmp_qloop_658);
                   const real_t q_tmp_9_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_661 + tmp_qloop_523 + tmp_qloop_666) - tmp_qloop_512*tmp_qloop_658);
                   const real_t q_tmp_9_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_661 + tmp_qloop_538 + tmp_qloop_666) - tmp_qloop_527*tmp_qloop_658);
                   const real_t q_tmp_9_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_661 + tmp_qloop_553 + tmp_qloop_666) - tmp_qloop_542*tmp_qloop_658);
                   const real_t q_tmp_9_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_661 + tmp_qloop_568 + tmp_qloop_666) - tmp_qloop_557*tmp_qloop_658);
                   const real_t q_tmp_9_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_661 + tmp_qloop_583 + tmp_qloop_666) - tmp_qloop_572*tmp_qloop_658);
                   const real_t q_tmp_10_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_672 + tmp_qloop_299*tmp_qloop_670 + tmp_qloop_303*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_282*tmp_qloop_669);
                   const real_t q_tmp_10_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_672 + tmp_qloop_313*tmp_qloop_670 + tmp_qloop_317*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_669);
                   const real_t q_tmp_10_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_672 + tmp_qloop_327*tmp_qloop_670 + tmp_qloop_331*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_669);
                   const real_t q_tmp_10_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_672 + tmp_qloop_341*tmp_qloop_670 + tmp_qloop_345*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_669);
                   const real_t q_tmp_10_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_672 + tmp_qloop_355*tmp_qloop_670 + tmp_qloop_359*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_669);
                   const real_t q_tmp_10_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_672 + tmp_qloop_369*tmp_qloop_670 + tmp_qloop_373*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_669);
                   const real_t q_tmp_10_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_672 + tmp_qloop_383*tmp_qloop_670 + tmp_qloop_387*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_669);
                   const real_t q_tmp_10_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_672 + tmp_qloop_397*tmp_qloop_670 + tmp_qloop_401*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_669);
                   const real_t q_tmp_10_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_672 + tmp_qloop_411*tmp_qloop_670 + tmp_qloop_415*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_669);
                   const real_t q_tmp_10_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_672 + tmp_qloop_425*tmp_qloop_670 + tmp_qloop_429*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_669);
                   const real_t q_tmp_10_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_679) - tmp_qloop_435*tmp_qloop_669);
                   const real_t q_tmp_10_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_680) - tmp_qloop_452*tmp_qloop_669);
                   const real_t q_tmp_10_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_681) - tmp_qloop_467*tmp_qloop_669);
                   const real_t q_tmp_10_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_682) - tmp_qloop_482*tmp_qloop_669);
                   const real_t q_tmp_10_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_683) - tmp_qloop_497*tmp_qloop_669);
                   const real_t q_tmp_10_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_684) - tmp_qloop_512*tmp_qloop_669);
                   const real_t q_tmp_10_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_685) - tmp_qloop_527*tmp_qloop_669);
                   const real_t q_tmp_10_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_686) - tmp_qloop_542*tmp_qloop_669);
                   const real_t q_tmp_10_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_687) - tmp_qloop_557*tmp_qloop_669);
                   const real_t q_tmp_10_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_688) - tmp_qloop_572*tmp_qloop_669);
                   const real_t q_tmp_11_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_691 + tmp_qloop_313*tmp_qloop_690 + tmp_qloop_317*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_689);
                   const real_t q_tmp_11_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_691 + tmp_qloop_327*tmp_qloop_690 + tmp_qloop_331*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_689);
                   const real_t q_tmp_11_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_691 + tmp_qloop_341*tmp_qloop_690 + tmp_qloop_345*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_689);
                   const real_t q_tmp_11_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_691 + tmp_qloop_355*tmp_qloop_690 + tmp_qloop_359*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_689);
                   const real_t q_tmp_11_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_691 + tmp_qloop_369*tmp_qloop_690 + tmp_qloop_373*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_689);
                   const real_t q_tmp_11_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_691 + tmp_qloop_383*tmp_qloop_690 + tmp_qloop_387*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_689);
                   const real_t q_tmp_11_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_691 + tmp_qloop_397*tmp_qloop_690 + tmp_qloop_401*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_689);
                   const real_t q_tmp_11_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_691 + tmp_qloop_411*tmp_qloop_690 + tmp_qloop_415*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_689);
                   const real_t q_tmp_11_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_691 + tmp_qloop_425*tmp_qloop_690 + tmp_qloop_429*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_689);
                   const real_t q_tmp_11_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_692 + tmp_qloop_693 + tmp_qloop_694) - tmp_qloop_435*tmp_qloop_689);
                   const real_t q_tmp_11_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_692 + tmp_qloop_680 + tmp_qloop_695) - tmp_qloop_452*tmp_qloop_689);
                   const real_t q_tmp_11_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_692 + tmp_qloop_681 + tmp_qloop_695) - tmp_qloop_467*tmp_qloop_689);
                   const real_t q_tmp_11_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_692 + tmp_qloop_682 + tmp_qloop_695) - tmp_qloop_482*tmp_qloop_689);
                   const real_t q_tmp_11_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_692 + tmp_qloop_683 + tmp_qloop_695) - tmp_qloop_497*tmp_qloop_689);
                   const real_t q_tmp_11_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_692 + tmp_qloop_684 + tmp_qloop_695) - tmp_qloop_512*tmp_qloop_689);
                   const real_t q_tmp_11_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_692 + tmp_qloop_685 + tmp_qloop_695) - tmp_qloop_527*tmp_qloop_689);
                   const real_t q_tmp_11_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_692 + tmp_qloop_686 + tmp_qloop_695) - tmp_qloop_542*tmp_qloop_689);
                   const real_t q_tmp_11_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_692 + tmp_qloop_687 + tmp_qloop_695) - tmp_qloop_557*tmp_qloop_689);
                   const real_t q_tmp_11_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_692 + tmp_qloop_688 + tmp_qloop_695) - tmp_qloop_572*tmp_qloop_689);
                   const real_t q_tmp_12_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_698 + tmp_qloop_327*tmp_qloop_697 + tmp_qloop_331*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_696);
                   const real_t q_tmp_12_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_698 + tmp_qloop_341*tmp_qloop_697 + tmp_qloop_345*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_696);
                   const real_t q_tmp_12_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_698 + tmp_qloop_355*tmp_qloop_697 + tmp_qloop_359*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_696);
                   const real_t q_tmp_12_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_698 + tmp_qloop_369*tmp_qloop_697 + tmp_qloop_373*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_696);
                   const real_t q_tmp_12_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_698 + tmp_qloop_383*tmp_qloop_697 + tmp_qloop_387*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_696);
                   const real_t q_tmp_12_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_698 + tmp_qloop_397*tmp_qloop_697 + tmp_qloop_401*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_696);
                   const real_t q_tmp_12_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_698 + tmp_qloop_411*tmp_qloop_697 + tmp_qloop_415*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_696);
                   const real_t q_tmp_12_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_698 + tmp_qloop_425*tmp_qloop_697 + tmp_qloop_429*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_696);
                   const real_t q_tmp_12_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_699 + tmp_qloop_693 + tmp_qloop_700) - tmp_qloop_435*tmp_qloop_696);
                   const real_t q_tmp_12_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_699 + tmp_qloop_680 + tmp_qloop_701) - tmp_qloop_452*tmp_qloop_696);
                   const real_t q_tmp_12_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_699 + tmp_qloop_681 + tmp_qloop_701) - tmp_qloop_467*tmp_qloop_696);
                   const real_t q_tmp_12_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_699 + tmp_qloop_682 + tmp_qloop_701) - tmp_qloop_482*tmp_qloop_696);
                   const real_t q_tmp_12_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_699 + tmp_qloop_683 + tmp_qloop_701) - tmp_qloop_497*tmp_qloop_696);
                   const real_t q_tmp_12_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_699 + tmp_qloop_684 + tmp_qloop_701) - tmp_qloop_512*tmp_qloop_696);
                   const real_t q_tmp_12_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_699 + tmp_qloop_685 + tmp_qloop_701) - tmp_qloop_527*tmp_qloop_696);
                   const real_t q_tmp_12_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_699 + tmp_qloop_686 + tmp_qloop_701) - tmp_qloop_542*tmp_qloop_696);
                   const real_t q_tmp_12_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_699 + tmp_qloop_687 + tmp_qloop_701) - tmp_qloop_557*tmp_qloop_696);
                   const real_t q_tmp_12_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_699 + tmp_qloop_688 + tmp_qloop_701) - tmp_qloop_572*tmp_qloop_696);
                   const real_t q_tmp_13_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_704 + tmp_qloop_341*tmp_qloop_703 + tmp_qloop_345*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_702);
                   const real_t q_tmp_13_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_704 + tmp_qloop_355*tmp_qloop_703 + tmp_qloop_359*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_702);
                   const real_t q_tmp_13_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_704 + tmp_qloop_369*tmp_qloop_703 + tmp_qloop_373*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_702);
                   const real_t q_tmp_13_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_704 + tmp_qloop_383*tmp_qloop_703 + tmp_qloop_387*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_702);
                   const real_t q_tmp_13_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_704 + tmp_qloop_397*tmp_qloop_703 + tmp_qloop_401*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_702);
                   const real_t q_tmp_13_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_704 + tmp_qloop_411*tmp_qloop_703 + tmp_qloop_415*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_702);
                   const real_t q_tmp_13_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_704 + tmp_qloop_425*tmp_qloop_703 + tmp_qloop_429*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_702);
                   const real_t q_tmp_13_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_705 + tmp_qloop_693 + tmp_qloop_706) - tmp_qloop_435*tmp_qloop_702);
                   const real_t q_tmp_13_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_705 + tmp_qloop_680 + tmp_qloop_707) - tmp_qloop_452*tmp_qloop_702);
                   const real_t q_tmp_13_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_705 + tmp_qloop_681 + tmp_qloop_707) - tmp_qloop_467*tmp_qloop_702);
                   const real_t q_tmp_13_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_705 + tmp_qloop_682 + tmp_qloop_707) - tmp_qloop_482*tmp_qloop_702);
                   const real_t q_tmp_13_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_705 + tmp_qloop_683 + tmp_qloop_707) - tmp_qloop_497*tmp_qloop_702);
                   const real_t q_tmp_13_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_705 + tmp_qloop_684 + tmp_qloop_707) - tmp_qloop_512*tmp_qloop_702);
                   const real_t q_tmp_13_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_705 + tmp_qloop_685 + tmp_qloop_707) - tmp_qloop_527*tmp_qloop_702);
                   const real_t q_tmp_13_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_705 + tmp_qloop_686 + tmp_qloop_707) - tmp_qloop_542*tmp_qloop_702);
                   const real_t q_tmp_13_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_705 + tmp_qloop_687 + tmp_qloop_707) - tmp_qloop_557*tmp_qloop_702);
                   const real_t q_tmp_13_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_705 + tmp_qloop_688 + tmp_qloop_707) - tmp_qloop_572*tmp_qloop_702);
                   const real_t q_tmp_14_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_710 + tmp_qloop_355*tmp_qloop_709 + tmp_qloop_359*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_708);
                   const real_t q_tmp_14_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_710 + tmp_qloop_369*tmp_qloop_709 + tmp_qloop_373*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_708);
                   const real_t q_tmp_14_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_710 + tmp_qloop_383*tmp_qloop_709 + tmp_qloop_387*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_708);
                   const real_t q_tmp_14_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_710 + tmp_qloop_397*tmp_qloop_709 + tmp_qloop_401*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_708);
                   const real_t q_tmp_14_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_710 + tmp_qloop_411*tmp_qloop_709 + tmp_qloop_415*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_708);
                   const real_t q_tmp_14_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_710 + tmp_qloop_425*tmp_qloop_709 + tmp_qloop_429*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_708);
                   const real_t q_tmp_14_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_711 + tmp_qloop_693 + tmp_qloop_712) - tmp_qloop_435*tmp_qloop_708);
                   const real_t q_tmp_14_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_711 + tmp_qloop_680 + tmp_qloop_713) - tmp_qloop_452*tmp_qloop_708);
                   const real_t q_tmp_14_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_711 + tmp_qloop_681 + tmp_qloop_713) - tmp_qloop_467*tmp_qloop_708);
                   const real_t q_tmp_14_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_711 + tmp_qloop_682 + tmp_qloop_713) - tmp_qloop_482*tmp_qloop_708);
                   const real_t q_tmp_14_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_711 + tmp_qloop_683 + tmp_qloop_713) - tmp_qloop_497*tmp_qloop_708);
                   const real_t q_tmp_14_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_711 + tmp_qloop_684 + tmp_qloop_713) - tmp_qloop_512*tmp_qloop_708);
                   const real_t q_tmp_14_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_711 + tmp_qloop_685 + tmp_qloop_713) - tmp_qloop_527*tmp_qloop_708);
                   const real_t q_tmp_14_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_711 + tmp_qloop_686 + tmp_qloop_713) - tmp_qloop_542*tmp_qloop_708);
                   const real_t q_tmp_14_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_711 + tmp_qloop_687 + tmp_qloop_713) - tmp_qloop_557*tmp_qloop_708);
                   const real_t q_tmp_14_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_711 + tmp_qloop_688 + tmp_qloop_713) - tmp_qloop_572*tmp_qloop_708);
                   const real_t q_tmp_15_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_716 + tmp_qloop_369*tmp_qloop_715 + tmp_qloop_373*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_714);
                   const real_t q_tmp_15_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_716 + tmp_qloop_383*tmp_qloop_715 + tmp_qloop_387*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_714);
                   const real_t q_tmp_15_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_716 + tmp_qloop_397*tmp_qloop_715 + tmp_qloop_401*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_714);
                   const real_t q_tmp_15_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_716 + tmp_qloop_411*tmp_qloop_715 + tmp_qloop_415*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_714);
                   const real_t q_tmp_15_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_716 + tmp_qloop_425*tmp_qloop_715 + tmp_qloop_429*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_714);
                   const real_t q_tmp_15_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_717 + tmp_qloop_693 + tmp_qloop_718) - tmp_qloop_435*tmp_qloop_714);
                   const real_t q_tmp_15_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_717 + tmp_qloop_680 + tmp_qloop_719) - tmp_qloop_452*tmp_qloop_714);
                   const real_t q_tmp_15_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_717 + tmp_qloop_681 + tmp_qloop_719) - tmp_qloop_467*tmp_qloop_714);
                   const real_t q_tmp_15_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_717 + tmp_qloop_682 + tmp_qloop_719) - tmp_qloop_482*tmp_qloop_714);
                   const real_t q_tmp_15_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_717 + tmp_qloop_683 + tmp_qloop_719) - tmp_qloop_497*tmp_qloop_714);
                   const real_t q_tmp_15_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_717 + tmp_qloop_684 + tmp_qloop_719) - tmp_qloop_512*tmp_qloop_714);
                   const real_t q_tmp_15_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_717 + tmp_qloop_685 + tmp_qloop_719) - tmp_qloop_527*tmp_qloop_714);
                   const real_t q_tmp_15_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_717 + tmp_qloop_686 + tmp_qloop_719) - tmp_qloop_542*tmp_qloop_714);
                   const real_t q_tmp_15_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_717 + tmp_qloop_687 + tmp_qloop_719) - tmp_qloop_557*tmp_qloop_714);
                   const real_t q_tmp_15_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_717 + tmp_qloop_688 + tmp_qloop_719) - tmp_qloop_572*tmp_qloop_714);
                   const real_t q_tmp_16_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_722 + tmp_qloop_383*tmp_qloop_721 + tmp_qloop_387*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_720);
                   const real_t q_tmp_16_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_722 + tmp_qloop_397*tmp_qloop_721 + tmp_qloop_401*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_720);
                   const real_t q_tmp_16_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_722 + tmp_qloop_411*tmp_qloop_721 + tmp_qloop_415*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_720);
                   const real_t q_tmp_16_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_722 + tmp_qloop_425*tmp_qloop_721 + tmp_qloop_429*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_720);
                   const real_t q_tmp_16_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_723 + tmp_qloop_693 + tmp_qloop_724) - tmp_qloop_435*tmp_qloop_720);
                   const real_t q_tmp_16_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_723 + tmp_qloop_680 + tmp_qloop_725) - tmp_qloop_452*tmp_qloop_720);
                   const real_t q_tmp_16_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_723 + tmp_qloop_681 + tmp_qloop_725) - tmp_qloop_467*tmp_qloop_720);
                   const real_t q_tmp_16_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_723 + tmp_qloop_682 + tmp_qloop_725) - tmp_qloop_482*tmp_qloop_720);
                   const real_t q_tmp_16_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_723 + tmp_qloop_683 + tmp_qloop_725) - tmp_qloop_497*tmp_qloop_720);
                   const real_t q_tmp_16_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_723 + tmp_qloop_684 + tmp_qloop_725) - tmp_qloop_512*tmp_qloop_720);
                   const real_t q_tmp_16_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_723 + tmp_qloop_685 + tmp_qloop_725) - tmp_qloop_527*tmp_qloop_720);
                   const real_t q_tmp_16_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_723 + tmp_qloop_686 + tmp_qloop_725) - tmp_qloop_542*tmp_qloop_720);
                   const real_t q_tmp_16_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_723 + tmp_qloop_687 + tmp_qloop_725) - tmp_qloop_557*tmp_qloop_720);
                   const real_t q_tmp_16_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_723 + tmp_qloop_688 + tmp_qloop_725) - tmp_qloop_572*tmp_qloop_720);
                   const real_t q_tmp_17_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_728 + tmp_qloop_397*tmp_qloop_727 + tmp_qloop_401*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_726);
                   const real_t q_tmp_17_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_728 + tmp_qloop_411*tmp_qloop_727 + tmp_qloop_415*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_726);
                   const real_t q_tmp_17_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_728 + tmp_qloop_425*tmp_qloop_727 + tmp_qloop_429*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_726);
                   const real_t q_tmp_17_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_729 + tmp_qloop_693 + tmp_qloop_730) - tmp_qloop_435*tmp_qloop_726);
                   const real_t q_tmp_17_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_729 + tmp_qloop_680 + tmp_qloop_731) - tmp_qloop_452*tmp_qloop_726);
                   const real_t q_tmp_17_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_729 + tmp_qloop_681 + tmp_qloop_731) - tmp_qloop_467*tmp_qloop_726);
                   const real_t q_tmp_17_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_729 + tmp_qloop_682 + tmp_qloop_731) - tmp_qloop_482*tmp_qloop_726);
                   const real_t q_tmp_17_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_729 + tmp_qloop_683 + tmp_qloop_731) - tmp_qloop_497*tmp_qloop_726);
                   const real_t q_tmp_17_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_729 + tmp_qloop_684 + tmp_qloop_731) - tmp_qloop_512*tmp_qloop_726);
                   const real_t q_tmp_17_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_729 + tmp_qloop_685 + tmp_qloop_731) - tmp_qloop_527*tmp_qloop_726);
                   const real_t q_tmp_17_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_729 + tmp_qloop_686 + tmp_qloop_731) - tmp_qloop_542*tmp_qloop_726);
                   const real_t q_tmp_17_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_729 + tmp_qloop_687 + tmp_qloop_731) - tmp_qloop_557*tmp_qloop_726);
                   const real_t q_tmp_17_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_729 + tmp_qloop_688 + tmp_qloop_731) - tmp_qloop_572*tmp_qloop_726);
                   const real_t q_tmp_18_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_734 + tmp_qloop_411*tmp_qloop_733 + tmp_qloop_415*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_732);
                   const real_t q_tmp_18_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_734 + tmp_qloop_425*tmp_qloop_733 + tmp_qloop_429*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_732);
                   const real_t q_tmp_18_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_735 + tmp_qloop_693 + tmp_qloop_736) - tmp_qloop_435*tmp_qloop_732);
                   const real_t q_tmp_18_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_735 + tmp_qloop_680 + tmp_qloop_737) - tmp_qloop_452*tmp_qloop_732);
                   const real_t q_tmp_18_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_735 + tmp_qloop_681 + tmp_qloop_737) - tmp_qloop_467*tmp_qloop_732);
                   const real_t q_tmp_18_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_735 + tmp_qloop_682 + tmp_qloop_737) - tmp_qloop_482*tmp_qloop_732);
                   const real_t q_tmp_18_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_735 + tmp_qloop_683 + tmp_qloop_737) - tmp_qloop_497*tmp_qloop_732);
                   const real_t q_tmp_18_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_735 + tmp_qloop_684 + tmp_qloop_737) - tmp_qloop_512*tmp_qloop_732);
                   const real_t q_tmp_18_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_735 + tmp_qloop_685 + tmp_qloop_737) - tmp_qloop_527*tmp_qloop_732);
                   const real_t q_tmp_18_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_735 + tmp_qloop_686 + tmp_qloop_737) - tmp_qloop_542*tmp_qloop_732);
                   const real_t q_tmp_18_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_735 + tmp_qloop_687 + tmp_qloop_737) - tmp_qloop_557*tmp_qloop_732);
                   const real_t q_tmp_18_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_735 + tmp_qloop_688 + tmp_qloop_737) - tmp_qloop_572*tmp_qloop_732);
                   const real_t q_tmp_19_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_740 + tmp_qloop_425*tmp_qloop_739 + tmp_qloop_429*tmp_qloop_741 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_738);
                   const real_t q_tmp_19_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_741 + tmp_qloop_693 + tmp_qloop_742) - tmp_qloop_435*tmp_qloop_738);
                   const real_t q_tmp_19_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_741 + tmp_qloop_680 + tmp_qloop_743) - tmp_qloop_452*tmp_qloop_738);
                   const real_t q_tmp_19_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_741 + tmp_qloop_681 + tmp_qloop_743) - tmp_qloop_467*tmp_qloop_738);
                   const real_t q_tmp_19_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_741 + tmp_qloop_682 + tmp_qloop_743) - tmp_qloop_482*tmp_qloop_738);
                   const real_t q_tmp_19_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_741 + tmp_qloop_683 + tmp_qloop_743) - tmp_qloop_497*tmp_qloop_738);
                   const real_t q_tmp_19_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_741 + tmp_qloop_684 + tmp_qloop_743) - tmp_qloop_512*tmp_qloop_738);
                   const real_t q_tmp_19_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_741 + tmp_qloop_685 + tmp_qloop_743) - tmp_qloop_527*tmp_qloop_738);
                   const real_t q_tmp_19_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_741 + tmp_qloop_686 + tmp_qloop_743) - tmp_qloop_542*tmp_qloop_738);
                   const real_t q_tmp_19_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_741 + tmp_qloop_687 + tmp_qloop_743) - tmp_qloop_557*tmp_qloop_738);
                   const real_t q_tmp_19_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_741 + tmp_qloop_688 + tmp_qloop_743) - tmp_qloop_572*tmp_qloop_738);
                   const real_t q_tmp_20_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_747 + tmp_qloop_442*tmp_qloop_746 + tmp_qloop_447*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_435*tmp_qloop_745);
                   const real_t q_tmp_20_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_747 + tmp_qloop_457*tmp_qloop_746 + tmp_qloop_462*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_745);
                   const real_t q_tmp_20_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_747 + tmp_qloop_472*tmp_qloop_746 + tmp_qloop_477*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_745);
                   const real_t q_tmp_20_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_747 + tmp_qloop_487*tmp_qloop_746 + tmp_qloop_492*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_745);
                   const real_t q_tmp_20_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_747 + tmp_qloop_502*tmp_qloop_746 + tmp_qloop_507*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_745);
                   const real_t q_tmp_20_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_747 + tmp_qloop_517*tmp_qloop_746 + tmp_qloop_522*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_745);
                   const real_t q_tmp_20_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_747 + tmp_qloop_532*tmp_qloop_746 + tmp_qloop_537*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_745);
                   const real_t q_tmp_20_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_747 + tmp_qloop_547*tmp_qloop_746 + tmp_qloop_552*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_745);
                   const real_t q_tmp_20_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_747 + tmp_qloop_562*tmp_qloop_746 + tmp_qloop_567*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_745);
                   const real_t q_tmp_20_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_747 + tmp_qloop_577*tmp_qloop_746 + tmp_qloop_582*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_745);
                   const real_t q_tmp_21_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_752 + tmp_qloop_457*tmp_qloop_751 + tmp_qloop_462*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_750);
                   const real_t q_tmp_21_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_752 + tmp_qloop_472*tmp_qloop_751 + tmp_qloop_477*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_750);
                   const real_t q_tmp_21_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_752 + tmp_qloop_487*tmp_qloop_751 + tmp_qloop_492*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_750);
                   const real_t q_tmp_21_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_752 + tmp_qloop_502*tmp_qloop_751 + tmp_qloop_507*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_750);
                   const real_t q_tmp_21_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_752 + tmp_qloop_517*tmp_qloop_751 + tmp_qloop_522*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_750);
                   const real_t q_tmp_21_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_752 + tmp_qloop_532*tmp_qloop_751 + tmp_qloop_537*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_750);
                   const real_t q_tmp_21_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_752 + tmp_qloop_547*tmp_qloop_751 + tmp_qloop_552*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_750);
                   const real_t q_tmp_21_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_752 + tmp_qloop_562*tmp_qloop_751 + tmp_qloop_567*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_750);
                   const real_t q_tmp_21_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_752 + tmp_qloop_577*tmp_qloop_751 + tmp_qloop_582*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_750);
                   const real_t q_tmp_22_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_756 + tmp_qloop_472*tmp_qloop_755 + tmp_qloop_477*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_754);
                   const real_t q_tmp_22_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_756 + tmp_qloop_487*tmp_qloop_755 + tmp_qloop_492*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_754);
                   const real_t q_tmp_22_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_756 + tmp_qloop_502*tmp_qloop_755 + tmp_qloop_507*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_754);
                   const real_t q_tmp_22_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_756 + tmp_qloop_517*tmp_qloop_755 + tmp_qloop_522*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_754);
                   const real_t q_tmp_22_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_756 + tmp_qloop_532*tmp_qloop_755 + tmp_qloop_537*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_754);
                   const real_t q_tmp_22_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_756 + tmp_qloop_547*tmp_qloop_755 + tmp_qloop_552*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_754);
                   const real_t q_tmp_22_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_756 + tmp_qloop_562*tmp_qloop_755 + tmp_qloop_567*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_754);
                   const real_t q_tmp_22_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_756 + tmp_qloop_577*tmp_qloop_755 + tmp_qloop_582*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_754);
                   const real_t q_tmp_23_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_760 + tmp_qloop_487*tmp_qloop_759 + tmp_qloop_492*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_758);
                   const real_t q_tmp_23_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_760 + tmp_qloop_502*tmp_qloop_759 + tmp_qloop_507*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_758);
                   const real_t q_tmp_23_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_760 + tmp_qloop_517*tmp_qloop_759 + tmp_qloop_522*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_758);
                   const real_t q_tmp_23_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_760 + tmp_qloop_532*tmp_qloop_759 + tmp_qloop_537*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_758);
                   const real_t q_tmp_23_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_760 + tmp_qloop_547*tmp_qloop_759 + tmp_qloop_552*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_758);
                   const real_t q_tmp_23_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_760 + tmp_qloop_562*tmp_qloop_759 + tmp_qloop_567*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_758);
                   const real_t q_tmp_23_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_760 + tmp_qloop_577*tmp_qloop_759 + tmp_qloop_582*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_758);
                   const real_t q_tmp_24_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_764 + tmp_qloop_502*tmp_qloop_763 + tmp_qloop_507*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_762);
                   const real_t q_tmp_24_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_764 + tmp_qloop_517*tmp_qloop_763 + tmp_qloop_522*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_762);
                   const real_t q_tmp_24_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_764 + tmp_qloop_532*tmp_qloop_763 + tmp_qloop_537*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_762);
                   const real_t q_tmp_24_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_764 + tmp_qloop_547*tmp_qloop_763 + tmp_qloop_552*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_762);
                   const real_t q_tmp_24_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_764 + tmp_qloop_562*tmp_qloop_763 + tmp_qloop_567*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_762);
                   const real_t q_tmp_24_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_764 + tmp_qloop_577*tmp_qloop_763 + tmp_qloop_582*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_762);
                   const real_t q_tmp_25_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_768 + tmp_qloop_517*tmp_qloop_767 + tmp_qloop_522*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_766);
                   const real_t q_tmp_25_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_768 + tmp_qloop_532*tmp_qloop_767 + tmp_qloop_537*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_766);
                   const real_t q_tmp_25_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_768 + tmp_qloop_547*tmp_qloop_767 + tmp_qloop_552*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_766);
                   const real_t q_tmp_25_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_768 + tmp_qloop_562*tmp_qloop_767 + tmp_qloop_567*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_766);
                   const real_t q_tmp_25_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_768 + tmp_qloop_577*tmp_qloop_767 + tmp_qloop_582*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_766);
                   const real_t q_tmp_26_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_772 + tmp_qloop_532*tmp_qloop_771 + tmp_qloop_537*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_770);
                   const real_t q_tmp_26_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_772 + tmp_qloop_547*tmp_qloop_771 + tmp_qloop_552*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_770);
                   const real_t q_tmp_26_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_772 + tmp_qloop_562*tmp_qloop_771 + tmp_qloop_567*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_770);
                   const real_t q_tmp_26_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_772 + tmp_qloop_577*tmp_qloop_771 + tmp_qloop_582*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_770);
                   const real_t q_tmp_27_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_776 + tmp_qloop_547*tmp_qloop_775 + tmp_qloop_552*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_774);
                   const real_t q_tmp_27_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_776 + tmp_qloop_562*tmp_qloop_775 + tmp_qloop_567*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_774);
                   const real_t q_tmp_27_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_776 + tmp_qloop_577*tmp_qloop_775 + tmp_qloop_582*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_774);
                   const real_t q_tmp_28_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_780 + tmp_qloop_562*tmp_qloop_779 + tmp_qloop_567*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_778);
                   const real_t q_tmp_28_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_780 + tmp_qloop_577*tmp_qloop_779 + tmp_qloop_582*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_778);
                   const real_t q_tmp_29_29 = tmp_qloop_156*(-tmp_qloop_118*tmp_qloop_572*(tmp_qloop_569 + tmp_qloop_570 + tmp_qloop_571 + tmp_qloop_744) + tmp_qloop_118*(tmp_qloop_576*(tmp_qloop_573*0.5 + tmp_qloop_574*0.5 + tmp_qloop_575*0.5 + tmp_qloop_675)*2.0 + tmp_qloop_577*(tmp_qloop_569*1.0 + tmp_qloop_570*1.0 + tmp_qloop_571*1.0) + tmp_qloop_582*(tmp_qloop_153 + tmp_qloop_579*0.5 + tmp_qloop_580*0.5 + tmp_qloop_581*0.5)*2.0 + tmp_qloop_749));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                   q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                   q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                   q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                   q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                   q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                   q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                   q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                   q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                   q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                   q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                   q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                   q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                   q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                   q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                   q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                   q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                   q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                   q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                   q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                   q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                   q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                   q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                   q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                   q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                   q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                   q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                   q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                   q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                   q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                   q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                   q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                   q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                   q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                   q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                   q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                   q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                   q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                   q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                   q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                   q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                   q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                   q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                   q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                   q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                   q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                   q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                   q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                   q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                   q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                   q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                   q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                   q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                   q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                   q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                   q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                   q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                   q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                   q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                   q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                   q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                   q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                   q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                   q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                   q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                   q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                   q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                   q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                   q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                   q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                   q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                   q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                   q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                   q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                   q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                   q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                   q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                   q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                   q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                   q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                   q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                   q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                   q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                   q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                   q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                   q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                   q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                   q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                   q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                   q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                   q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                   q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                   q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                   q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                   q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                   q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                   q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                   q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                   q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                   q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                   q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                   q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                   q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                   q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                   q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                   q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                   q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                   q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                   q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                   q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                   q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                   q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                   q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                   q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                   q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                   q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                   q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                   q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                   q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                   q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                   q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                   q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                   q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                   q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                   q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                   q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                   q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                   q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                   q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                   q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                   q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                   q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                   q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                   q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                   q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                   q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                   q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                   q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                   q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                   q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                   q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                   q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                   q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                   q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                   q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                   q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                   q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                   q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                   q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                   q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                   q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                   q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                   q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                   q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                   q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                   q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                   q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                   q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                   q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                   q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                   q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                   q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                   q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                   q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                   q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                   q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                   q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                   q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                   q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                   q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                   q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                   q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                   q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                   q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                   q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                   q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                   q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                   q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                   q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                   q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                   q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                   q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                   q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                   q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                   q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                   q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                   q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                   q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                   q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                   q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                   q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                   q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                   q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                   q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                   q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                   q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                   q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                   q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                   q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                   q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                   q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                   q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                   q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                   q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                   q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                   q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                   q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                   q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                   q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                   q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                   q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                   q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                   q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                   q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                   q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                   q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                   q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                   q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                   q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                   q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                   q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                   q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                   q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                   q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                   q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                   q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                   q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                   q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                   q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                   q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                   q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                   q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                   q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                   q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                   q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                   q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                   q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                   q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                   q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                   q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                   q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                   q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                   q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                   q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                   q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                   q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                   q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                   q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                   q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                   q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                   q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                   q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                   q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                   q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                   q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                   q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                   q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                   q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                   q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                   q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                   q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                   q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                   q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                   q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                   q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                   q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                   q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                   q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                   q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                   q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                   q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                   q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                   q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                   q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                   q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                   q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                   q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                   q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                   q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                   q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                   q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                   q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                   q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                   q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                   q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                   q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                   q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                   q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                   q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                   q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                   q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                   q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                   q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                   q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                   q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                   q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                   q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                   q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                   q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                   q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                   q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                   q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                   q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                   q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                   q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                   q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                   q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                   q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                   q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                   q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                   q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                   q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                   q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                   q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                   q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                   q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                   q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                   q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                   q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                   q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                   q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                   q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                   q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                   q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                   q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                   q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                   q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                   q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                   q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                   q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                   q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                   q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                   q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                   q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                   q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                   q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                   q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                   q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                   q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                   q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                   q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
                const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
                const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
                const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
                const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
                const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
                const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
                const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
                const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
                const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
                const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
                const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
                const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
                const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
                const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
                const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
                const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
                const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_17 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_27 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {0.25, 0.25, 0.25, 0.25, 0.16666666666666674, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666671, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666671, 0.5, 0.16666666666666666, 0.16666666666666666, 0.50000000000000011, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN)), 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(abs_det_jac_affine_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(abs_det_jac_affine_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(abs_det_jac_affine_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_0_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_0_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), 0.0, ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_10 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_11 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_12 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_13 = _mm256_loadu_pd(& _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_14 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_15 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_16 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_17 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_18 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_19 = _mm256_loadu_pd(& _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_20 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_21 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_22 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_23 = _mm256_loadu_pd(& _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_24 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_25 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_26 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_27 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_28 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_29 = _mm256_loadu_pd(& _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d mu_dof_0 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d mu_dof_1 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_2 = _mm256_loadu_pd(& _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d mu_dof_3 = _mm256_loadu_pd(& _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                __m256d q_acc_0_0 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_0_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_1 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_1_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_2 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_2_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_3 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_3_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_4 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_4_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_5 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_5_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_6 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_6_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_7 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_7_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_8 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_8_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_9 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_9_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_10 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_10_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_11 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_11_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_12 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_12_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_13 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_13_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_14 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_14_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_15 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_15_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_16 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_16_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_17 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_17_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_18 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_18_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_19 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_19_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_20 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_20_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_21 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_21_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_22 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_22_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_23 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_23_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_24 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_24_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_25 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_25_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_26 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_26_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_27 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_27_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_28 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_28_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                __m256d q_acc_29_29 = _mm256_set_pd(0.0,0.0,0.0,0.0);
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const __m256d tmp_qloop_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_0);
                   const __m256d tmp_qloop_19 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_18);
                   const __m256d tmp_qloop_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_2);
                   const __m256d tmp_qloop_23 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_12,tmp_qloop_12,tmp_qloop_12,tmp_qloop_12)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_1,tmp_qloop_1,tmp_qloop_1,tmp_qloop_1)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1),_mm256_set_pd(_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q],_data_q_p_0[q])),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1),_mm256_set_pd(_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q],_data_q_p_1[q]))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1),_mm256_set_pd(_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q],_data_q_p_2[q]))),p_affine_0_1);
                   const __m256d tmp_qloop_26 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_8,tmp_qloop_8,tmp_qloop_8,tmp_qloop_8)),_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_27 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_14,tmp_qloop_14,tmp_qloop_14,tmp_qloop_14)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_15,tmp_qloop_15,tmp_qloop_15,tmp_qloop_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_7,tmp_qloop_7,tmp_qloop_7,tmp_qloop_7))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_23,_mm256_set_pd(tmp_qloop_10,tmp_qloop_10,tmp_qloop_10,tmp_qloop_10)),_mm256_set_pd(tmp_qloop_9,tmp_qloop_9,tmp_qloop_9,tmp_qloop_9))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_24,_mm256_set_pd(tmp_qloop_13,tmp_qloop_13,tmp_qloop_13,tmp_qloop_13)),_mm256_set_pd(tmp_qloop_6,tmp_qloop_6,tmp_qloop_6,tmp_qloop_6))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_26,_mm256_set_pd(tmp_qloop_2,tmp_qloop_2,tmp_qloop_2,tmp_qloop_2)),_mm256_set_pd(tmp_qloop_3,tmp_qloop_3,tmp_qloop_3,tmp_qloop_3))),_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21));
                   const __m256d tmp_qloop_28 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20));
                   const __m256d tmp_qloop_29 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_25);
                   const __m256d tmp_qloop_30 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_22);
                   const __m256d tmp_qloop_31 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_19,tmp_qloop_29),tmp_qloop_30);
                   const __m256d tmp_qloop_34 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33));
                   const __m256d tmp_qloop_35 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_34);
                   const __m256d tmp_qloop_36 = _mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_35),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_37 = _mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31));
                   const __m256d tmp_qloop_38 = _mm256_mul_pd(tmp_qloop_37,_mm256_set_pd(1.0,1.0,1.0,1.0));
                   const __m256d tmp_qloop_41 = _mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40));
                   const __m256d tmp_qloop_42 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_28),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                   const __m256d tmp_qloop_43 = _mm256_mul_pd(tmp_qloop_38,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_44 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_43);
                   const __m256d tmp_qloop_47 = _mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_48 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_47);
                   const __m256d tmp_qloop_49 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),tmp_qloop_48);
                   const __m256d tmp_qloop_50 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_49);
                   const __m256d tmp_qloop_51 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,tmp_qloop_47));
                   const __m256d tmp_qloop_52 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_51);
                   const __m256d tmp_qloop_54 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53)),tmp_qloop_28);
                   const __m256d tmp_qloop_55 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_54));
                   const __m256d tmp_qloop_56 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46));
                   const __m256d tmp_qloop_57 = _mm256_add_pd(tmp_qloop_28,tmp_qloop_56);
                   const __m256d tmp_qloop_58 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_47),_mm256_mul_pd(tmp_qloop_31,tmp_qloop_57));
                   const __m256d tmp_qloop_66 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_qloop_31),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,tmp_qloop_31),tmp_qloop_31)),_mm256_set_pd(3.0,3.0,3.0,3.0));
                   const __m256d tmp_qloop_67 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_66);
                   const __m256d tmp_qloop_69 = _mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_70 = _mm256_mul_pd(tmp_qloop_41,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_71 = _mm256_mul_pd(tmp_qloop_35,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_73 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72));
                   const __m256d tmp_qloop_74 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_20,tmp_qloop_20,tmp_qloop_20,tmp_qloop_20)),tmp_qloop_27);
                   const __m256d tmp_qloop_75 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_34,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),tmp_qloop_74);
                   const __m256d tmp_qloop_76 = _mm256_mul_pd(tmp_qloop_66,_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17));
                   const __m256d tmp_qloop_77 = _mm256_mul_pd(tmp_qloop_51,tmp_qloop_76);
                   const __m256d tmp_qloop_78 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_77);
                   const __m256d tmp_qloop_79 = _mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_80 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_81 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_43);
                   const __m256d tmp_qloop_82 = _mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(2.0,2.0,2.0,2.0));
                   const __m256d tmp_qloop_83 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33)),_mm256_mul_pd(tmp_qloop_18,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)));
                   const __m256d tmp_qloop_84 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                   const __m256d tmp_qloop_85 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_22);
                   const __m256d tmp_qloop_86 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_43);
                   const __m256d tmp_qloop_87 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_21,tmp_qloop_21,tmp_qloop_21,tmp_qloop_21)),_mm256_set_pd(tmp_qloop_32,tmp_qloop_32,tmp_qloop_32,tmp_qloop_32)));
                   const __m256d tmp_qloop_88 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_43);
                   const __m256d tmp_qloop_89 = _mm256_mul_pd(tmp_qloop_42,tmp_qloop_76);
                   const __m256d tmp_qloop_90 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_91 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_89);
                   const __m256d tmp_qloop_92 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_25,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_82,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)));
                   const __m256d tmp_qloop_93 = _mm256_mul_pd(tmp_qloop_85,tmp_qloop_89);
                   const __m256d tmp_qloop_94 = _mm256_mul_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68));
                   const __m256d tmp_qloop_95 = _mm256_mul_pd(tmp_qloop_55,tmp_qloop_76);
                   const __m256d tmp_qloop_96 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_69,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)));
                   const __m256d tmp_qloop_97 = _mm256_mul_pd(tmp_qloop_49,tmp_qloop_76);
                   const __m256d tmp_qloop_98 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_79,_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46)));
                   const __m256d tmp_qloop_99 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_97);
                   const __m256d tmp_qloop_100 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_99);
                   const __m256d tmp_qloop_101 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_56,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_22,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),tmp_qloop_74);
                   const __m256d tmp_qloop_102 = _mm256_mul_pd(tmp_qloop_58,tmp_qloop_76);
                   const __m256d tmp_qloop_156 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(mu_dof_0,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[4*q],_data_phi_0_0_GREEN_DOWN[4*q],_data_phi_0_0_GREEN_DOWN[4*q],_data_phi_0_0_GREEN_DOWN[4*q])),_mm256_mul_pd(mu_dof_1,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[4*q + 1],_data_phi_0_0_GREEN_DOWN[4*q + 1],_data_phi_0_0_GREEN_DOWN[4*q + 1],_data_phi_0_0_GREEN_DOWN[4*q + 1]))),_mm256_mul_pd(mu_dof_2,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[4*q + 2],_data_phi_0_0_GREEN_DOWN[4*q + 2],_data_phi_0_0_GREEN_DOWN[4*q + 2],_data_phi_0_0_GREEN_DOWN[4*q + 2]))),_mm256_mul_pd(mu_dof_3,_mm256_set_pd(_data_phi_0_0_GREEN_DOWN[4*q + 3],_data_phi_0_0_GREEN_DOWN[4*q + 3],_data_phi_0_0_GREEN_DOWN[4*q + 3],_data_phi_0_0_GREEN_DOWN[4*q + 3]))),_mm256_set_pd(_data_q_w[q],_data_q_w[q],_data_q_w[q],_data_q_w[q]));
                   const __m256d jac_blending_0_0 = _mm256_mul_pd(tmp_qloop_36,tmp_qloop_38);
                   const __m256d jac_blending_0_1 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_44);
                   const __m256d jac_blending_0_2 = _mm256_mul_pd(tmp_qloop_18,tmp_qloop_50);
                   const __m256d jac_blending_1_0 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_52);
                   const __m256d jac_blending_1_1 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_55);
                   const __m256d tmp_qloop_63 = _mm256_mul_pd(jac_blending_0_2,jac_blending_1_1);
                   const __m256d jac_blending_1_2 = _mm256_mul_pd(tmp_qloop_25,tmp_qloop_50);
                   const __m256d tmp_qloop_60 = _mm256_mul_pd(jac_blending_0_1,jac_blending_1_2);
                   const __m256d jac_blending_2_0 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_52);
                   const __m256d jac_blending_2_1 = _mm256_mul_pd(tmp_qloop_22,tmp_qloop_44);
                   const __m256d tmp_qloop_61 = _mm256_mul_pd(jac_blending_1_2,jac_blending_2_1);
                   const __m256d jac_blending_2_2 = _mm256_mul_pd(tmp_qloop_43,tmp_qloop_58);
                   const __m256d tmp_qloop_59 = _mm256_mul_pd(jac_blending_1_1,jac_blending_2_2);
                   const __m256d tmp_qloop_62 = _mm256_mul_pd(jac_blending_0_1,jac_blending_2_2);
                   const __m256d tmp_qloop_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_59),_mm256_mul_pd(jac_blending_2_0,tmp_qloop_60)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,tmp_qloop_61),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,tmp_qloop_62),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_0,tmp_qloop_63),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),jac_blending_2_1));
                   const __m256d tmp_qloop_65 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_qloop_64);
                   const __m256d abs_det_jac_blending = tmp_qloop_64;
                   const __m256d tmp_qloop_118 = _mm256_mul_pd(abs_det_jac_blending,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1]));
                   const __m256d jac_blending_inv_0_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_59));
                   const __m256d tmp_qloop_103 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q]));
                   const __m256d tmp_qloop_124 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_133 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_157 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_170 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_183 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_196 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_209 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_222 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_235 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_248 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_261 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_277 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_283 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_309 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_323 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_337 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_351 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_365 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_379 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_393 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_407 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_421 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_436 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_453 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_468 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_483 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_498 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_513 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_528 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_543 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_558 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_573 = _mm256_mul_pd(jac_blending_inv_0_0,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_62,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_2,jac_blending_2_1)));
                   const __m256d tmp_qloop_110 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_121 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q]));
                   const __m256d tmp_qloop_144 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_162 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_175 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_188 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_201 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_214 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_227 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_240 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_253 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_266 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_274 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_286 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_305 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_319 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_333 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_347 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_361 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_375 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_389 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_403 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_417 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_444 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_459 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_474 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_489 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_504 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_519 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_534 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_549 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_564 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_579 = _mm256_mul_pd(jac_blending_inv_0_1,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_0_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_qloop_60));
                   const __m256d tmp_qloop_106 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_130 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q]));
                   const __m256d tmp_qloop_148 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_166 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2]));
                   const __m256d tmp_qloop_179 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3]));
                   const __m256d tmp_qloop_192 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4]));
                   const __m256d tmp_qloop_205 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5]));
                   const __m256d tmp_qloop_218 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6]));
                   const __m256d tmp_qloop_231 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7]));
                   const __m256d tmp_qloop_244 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8]));
                   const __m256d tmp_qloop_257 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9]));
                   const __m256d tmp_qloop_270 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10]));
                   const __m256d tmp_qloop_293 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11],_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11]));
                   const __m256d tmp_qloop_300 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_314 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_328 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_342 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_356 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_370 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_384 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_398 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_412 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_426 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_431 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_449 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_464 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_479 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_494 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_509 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_524 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_539 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_554 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_569 = _mm256_mul_pd(jac_blending_inv_0_2,_mm256_set_pd(_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_104 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_125 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_134 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_158 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_171 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_184 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_197 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_210 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_223 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_236 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_249 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_262 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_278 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_284 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_310 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_324 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_338 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_352 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_366 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_380 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_394 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_408 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_422 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_437 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_454 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_469 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_484 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_499 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_514 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_529 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_544 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_559 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_574 = _mm256_mul_pd(jac_blending_inv_1_0,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_111 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_122 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_145 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_163 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_176 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_189 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_202 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_215 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_228 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_241 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_254 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_267 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_275 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_287 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_306 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_320 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_334 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_348 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_362 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_376 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_390 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_404 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_418 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_445 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_460 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_475 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_490 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_505 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_520 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_535 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_550 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_565 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_580 = _mm256_mul_pd(jac_blending_inv_1_1,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_1_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2,jac_blending_1_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_107 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_131 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_149 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_167 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_180 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_193 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_206 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_219 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_232 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_245 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_258 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_271 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_294 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_301 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_315 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_329 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_343 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_357 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_371 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_385 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_399 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_413 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_427 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_432 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_450 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_465 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_480 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_495 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_510 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_525 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_540 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_555 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_570 = _mm256_mul_pd(jac_blending_inv_1_2,_mm256_set_pd(_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10]));
                   const __m256d jac_blending_inv_2_0 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_0,jac_blending_2_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_1,jac_blending_2_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_105 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_120 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_126 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_127 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_124,tmp_qloop_125),tmp_qloop_126);
                   const __m256d tmp_qloop_128 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_124,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_125,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_126,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_135 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_136 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_133,tmp_qloop_134),tmp_qloop_135);
                   const __m256d tmp_qloop_137 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_133,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_134,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_135,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_159 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_161 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_172 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_174 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_185 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_187 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_198 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_200 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_211 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_213 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_224 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_226 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_237 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_239 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_250 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_252 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_263 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_265 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_279 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_280 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_285 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_291 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_292 = _mm256_mul_pd(tmp_qloop_120,tmp_qloop_291);
                   const __m256d tmp_qloop_311 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_325 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_339 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_353 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_367 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_381 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_395 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_409 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_423 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_438 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_455 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_470 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_485 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_500 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_515 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_530 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_545 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_560 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_575 = _mm256_mul_pd(jac_blending_inv_2_0,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_585 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_589 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_585);
                   const __m256d tmp_qloop_596 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_599 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_596);
                   const __m256d tmp_qloop_605 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_608 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_605);
                   const __m256d tmp_qloop_614 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_617 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_614);
                   const __m256d tmp_qloop_623 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_626 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_623);
                   const __m256d tmp_qloop_632 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_635 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_632);
                   const __m256d tmp_qloop_641 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_644 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_641);
                   const __m256d tmp_qloop_650 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_653 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_650);
                   const __m256d tmp_qloop_659 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_662 = _mm256_mul_pd(tmp_qloop_291,tmp_qloop_659);
                   const __m256d tmp_qloop_667 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_277,tmp_qloop_278),tmp_qloop_279);
                   const __m256d tmp_qloop_674 = _mm256_mul_pd(tmp_qloop_291,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_277,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_278,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_279,_mm256_set_pd(1.0,1.0,1.0,1.0))));
                   const __m256d jac_blending_inv_2_1 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_2_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_2_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_112 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_113 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_116 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_110,tmp_qloop_111),tmp_qloop_112);
                   const __m256d tmp_qloop_123 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_129 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_121),tmp_qloop_122),tmp_qloop_123);
                   const __m256d tmp_qloop_139 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_140 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_110,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_111,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_112,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_141 = _mm256_mul_pd(tmp_qloop_139,tmp_qloop_140);
                   const __m256d tmp_qloop_146 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_147 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_144,tmp_qloop_145),tmp_qloop_146);
                   const __m256d tmp_qloop_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_144,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_145,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_146,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_164 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_165 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_177 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_178 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_190 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_191 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_203 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_204 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_216 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_217 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_229 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_230 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_242 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_243 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_255 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_256 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_268 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_269 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_127,tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_276 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_288 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_289 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_286,tmp_qloop_287),tmp_qloop_288);
                   const __m256d tmp_qloop_290 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_283,tmp_qloop_284),tmp_qloop_285),tmp_qloop_289);
                   const __m256d tmp_qloop_299 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_307 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_312 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_313 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_321 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_326 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_327 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_335 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_340 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_341 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_349 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_354 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_355 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_363 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_368 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_369 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_377 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_382 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_383 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_391 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_396 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_405 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_410 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_419 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_424 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_289,tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_434 = _mm256_add_pd(tmp_qloop_113,tmp_qloop_280);
                   const __m256d tmp_qloop_440 = _mm256_add_pd(tmp_qloop_127,tmp_qloop_289);
                   const __m256d tmp_qloop_441 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_440),tmp_qloop_141),tmp_qloop_292);
                   const __m256d tmp_qloop_446 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_461 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_476 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_491 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_506 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_521 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_536 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_551 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_566 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_581 = _mm256_mul_pd(jac_blending_inv_2_1,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_586 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_162),tmp_qloop_163),tmp_qloop_164);
                   const __m256d tmp_qloop_593 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_586),tmp_qloop_589);
                   const __m256d tmp_qloop_594 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_593);
                   const __m256d tmp_qloop_597 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_175),tmp_qloop_176),tmp_qloop_177);
                   const __m256d tmp_qloop_602 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_597),tmp_qloop_599);
                   const __m256d tmp_qloop_603 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_602);
                   const __m256d tmp_qloop_606 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_188),tmp_qloop_189),tmp_qloop_190);
                   const __m256d tmp_qloop_611 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_606),tmp_qloop_608);
                   const __m256d tmp_qloop_612 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_611);
                   const __m256d tmp_qloop_615 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_201),tmp_qloop_202),tmp_qloop_203);
                   const __m256d tmp_qloop_620 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_615),tmp_qloop_617);
                   const __m256d tmp_qloop_621 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_620);
                   const __m256d tmp_qloop_624 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_214),tmp_qloop_215),tmp_qloop_216);
                   const __m256d tmp_qloop_629 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_624),tmp_qloop_626);
                   const __m256d tmp_qloop_630 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_629);
                   const __m256d tmp_qloop_633 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_227),tmp_qloop_228),tmp_qloop_229);
                   const __m256d tmp_qloop_638 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_633),tmp_qloop_635);
                   const __m256d tmp_qloop_639 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_638);
                   const __m256d tmp_qloop_642 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_240),tmp_qloop_241),tmp_qloop_242);
                   const __m256d tmp_qloop_647 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_642),tmp_qloop_644);
                   const __m256d tmp_qloop_648 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_647);
                   const __m256d tmp_qloop_651 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_253),tmp_qloop_254),tmp_qloop_255);
                   const __m256d tmp_qloop_656 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_651),tmp_qloop_653);
                   const __m256d tmp_qloop_657 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_656);
                   const __m256d tmp_qloop_660 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_128,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_266),tmp_qloop_267),tmp_qloop_268);
                   const __m256d tmp_qloop_665 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_440,tmp_qloop_660),tmp_qloop_662);
                   const __m256d tmp_qloop_666 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_665);
                   const __m256d tmp_qloop_670 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_671 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_286,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_287,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_288,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_672 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_283),tmp_qloop_284),tmp_qloop_285);
                   const __m256d tmp_qloop_678 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_670),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_672)),tmp_qloop_674);
                   const __m256d tmp_qloop_690 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_691 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_309),tmp_qloop_310),tmp_qloop_311);
                   const __m256d tmp_qloop_694 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_690),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_691));
                   const __m256d tmp_qloop_695 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_694);
                   const __m256d tmp_qloop_697 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_698 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_323),tmp_qloop_324),tmp_qloop_325);
                   const __m256d tmp_qloop_700 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_697),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_698));
                   const __m256d tmp_qloop_701 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_700);
                   const __m256d tmp_qloop_703 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_704 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_337),tmp_qloop_338),tmp_qloop_339);
                   const __m256d tmp_qloop_706 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_703),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_704));
                   const __m256d tmp_qloop_707 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_706);
                   const __m256d tmp_qloop_709 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_710 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_351),tmp_qloop_352),tmp_qloop_353);
                   const __m256d tmp_qloop_712 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_709),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_710));
                   const __m256d tmp_qloop_713 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_712);
                   const __m256d tmp_qloop_715 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_716 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_365),tmp_qloop_366),tmp_qloop_367);
                   const __m256d tmp_qloop_718 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_715),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_716));
                   const __m256d tmp_qloop_719 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_718);
                   const __m256d tmp_qloop_721 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_722 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_379),tmp_qloop_380),tmp_qloop_381);
                   const __m256d tmp_qloop_724 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_721),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_722));
                   const __m256d tmp_qloop_725 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_724);
                   const __m256d tmp_qloop_727 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_728 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_393),tmp_qloop_394),tmp_qloop_395);
                   const __m256d tmp_qloop_730 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_727),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_728));
                   const __m256d tmp_qloop_731 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_730);
                   const __m256d tmp_qloop_733 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_734 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_407),tmp_qloop_408),tmp_qloop_409);
                   const __m256d tmp_qloop_736 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_733),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_734));
                   const __m256d tmp_qloop_737 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_736);
                   const __m256d tmp_qloop_739 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_740 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_671,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_421),tmp_qloop_422),tmp_qloop_423);
                   const __m256d tmp_qloop_742 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_140,tmp_qloop_739),_mm256_mul_pd(tmp_qloop_440,tmp_qloop_740));
                   const __m256d tmp_qloop_743 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_742);
                   const __m256d tmp_qloop_744 = _mm256_add_pd(tmp_qloop_116,tmp_qloop_667);
                   const __m256d tmp_qloop_749 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_440,_mm256_add_pd(tmp_qloop_128,tmp_qloop_671)),_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_141),tmp_qloop_674);
                   const __m256d jac_blending_inv_2_2 = _mm256_mul_pd(tmp_qloop_65,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0,jac_blending_1_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1,jac_blending_1_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d tmp_qloop_108 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_109 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)));
                   const __m256d tmp_qloop_114 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_113);
                   const __m256d tmp_qloop_115 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_106,tmp_qloop_107),tmp_qloop_108);
                   const __m256d tmp_qloop_117 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_116);
                   const __m256d tmp_qloop_119 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_103,tmp_qloop_104),tmp_qloop_105),tmp_qloop_117));
                   const __m256d tmp_qloop_132 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_130),tmp_qloop_131),tmp_qloop_132);
                   const __m256d tmp_qloop_142 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_143 = _mm256_mul_pd(tmp_qloop_142,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_106,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_107,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_108,_mm256_set_pd(2.0,2.0,2.0,2.0))));
                   const __m256d tmp_qloop_150 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q]));
                   const __m256d tmp_qloop_151 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_148,tmp_qloop_149),tmp_qloop_150);
                   const __m256d tmp_qloop_153 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_148,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_149,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_150,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_154 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_155 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,_mm256_add_pd(tmp_qloop_147,tmp_qloop_151)),tmp_qloop_141),tmp_qloop_143);
                   const __m256d tmp_qloop_160 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_157,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_158,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_159,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_168 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_169 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_173 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_170,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_171,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_172,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_181 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_186 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_183,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_184,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_185,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_194 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_199 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_196,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_197,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_198,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_207 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_208 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_212 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_209,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_210,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_211,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_220 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_221 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_225 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_222,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_223,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_224,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_233 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_234 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_238 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_235,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_236,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_237,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_246 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_247 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_251 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_248,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_249,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_250,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_259 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_260 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_264 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_261,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_262,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_263,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114);
                   const __m256d tmp_qloop_272 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_273 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_136,tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_281 = _mm256_add_pd(tmp_qloop_109,tmp_qloop_280);
                   const __m256d tmp_qloop_282 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_274,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_275,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_276,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_295 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_296 = _mm256_add_pd(_mm256_add_pd(tmp_qloop_293,tmp_qloop_294),tmp_qloop_295);
                   const __m256d tmp_qloop_297 = _mm256_add_pd(tmp_qloop_136,tmp_qloop_296);
                   const __m256d tmp_qloop_298 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_297),tmp_qloop_143),tmp_qloop_292);
                   const __m256d tmp_qloop_302 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_303 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_304 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_299),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_303));
                   const __m256d tmp_qloop_308 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_305,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_306,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_307,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_316 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_317 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_318 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_313),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_317));
                   const __m256d tmp_qloop_322 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_319,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_320,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_321,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_330 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_331 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_332 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_327),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_331));
                   const __m256d tmp_qloop_336 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_333,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_334,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_335,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_344 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_345 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_346 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_341),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_345));
                   const __m256d tmp_qloop_350 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_347,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_348,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_349,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_358 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_359 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_360 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_355),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_359));
                   const __m256d tmp_qloop_364 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_361,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_362,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_363,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_372 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_373 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_374 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_369),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_373));
                   const __m256d tmp_qloop_378 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_375,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_376,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_377,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_386 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_387 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_388 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_383),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_387));
                   const __m256d tmp_qloop_392 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_389,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_390,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_391,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_400 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_401 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_402 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_397),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_401));
                   const __m256d tmp_qloop_406 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_403,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_404,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_405,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_414 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_416 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_411),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_415));
                   const __m256d tmp_qloop_420 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_417,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_418,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_419,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_281);
                   const __m256d tmp_qloop_428 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_429 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_147,tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_430 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_139,tmp_qloop_425),_mm256_mul_pd(tmp_qloop_154,tmp_qloop_429));
                   const __m256d tmp_qloop_433 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1]));
                   const __m256d tmp_qloop_435 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_439 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_442 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_443 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_442);
                   const __m256d tmp_qloop_447 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_448 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_447),tmp_qloop_443);
                   const __m256d tmp_qloop_451 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2]));
                   const __m256d tmp_qloop_452 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_457 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_458 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_457);
                   const __m256d tmp_qloop_462 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_463 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_462),tmp_qloop_458);
                   const __m256d tmp_qloop_466 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3]));
                   const __m256d tmp_qloop_467 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_472 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_473 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_472);
                   const __m256d tmp_qloop_477 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_478 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_477),tmp_qloop_473);
                   const __m256d tmp_qloop_481 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4]));
                   const __m256d tmp_qloop_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_486 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_487 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_488 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_487);
                   const __m256d tmp_qloop_492 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_493 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_492),tmp_qloop_488);
                   const __m256d tmp_qloop_496 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5]));
                   const __m256d tmp_qloop_497 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_501 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_502 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_503 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_502);
                   const __m256d tmp_qloop_507 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_508 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_507),tmp_qloop_503);
                   const __m256d tmp_qloop_511 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6]));
                   const __m256d tmp_qloop_512 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_516 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_517 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_518 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_517);
                   const __m256d tmp_qloop_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_523 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_522),tmp_qloop_518);
                   const __m256d tmp_qloop_526 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7]));
                   const __m256d tmp_qloop_527 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_531 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_532 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_533 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_532);
                   const __m256d tmp_qloop_537 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_538 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_537),tmp_qloop_533);
                   const __m256d tmp_qloop_541 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8]));
                   const __m256d tmp_qloop_542 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_546 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_547 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_548 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_547);
                   const __m256d tmp_qloop_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_553 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_552),tmp_qloop_548);
                   const __m256d tmp_qloop_556 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9]));
                   const __m256d tmp_qloop_557 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_561 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_562 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_563 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_562);
                   const __m256d tmp_qloop_567 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d tmp_qloop_568 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_567),tmp_qloop_563);
                   const __m256d tmp_qloop_571 = _mm256_mul_pd(jac_blending_inv_2_2,_mm256_set_pd(_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10],_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10]));
                   const __m256d tmp_qloop_572 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_434);
                   const __m256d tmp_qloop_576 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_296,tmp_qloop_573),tmp_qloop_574),tmp_qloop_575);
                   const __m256d tmp_qloop_577 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_578 = _mm256_mul_pd(tmp_qloop_142,tmp_qloop_577);
                   const __m256d tmp_qloop_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_151,tmp_qloop_579),tmp_qloop_580),tmp_qloop_581);
                   const __m256d tmp_qloop_583 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_154,tmp_qloop_582),tmp_qloop_578);
                   const __m256d tmp_qloop_584 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_157),tmp_qloop_158),tmp_qloop_159));
                   const __m256d tmp_qloop_587 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_166),tmp_qloop_167),tmp_qloop_168);
                   const __m256d tmp_qloop_588 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_304);
                   const __m256d tmp_qloop_590 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_587),tmp_qloop_589);
                   const __m256d tmp_qloop_591 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_590);
                   const __m256d tmp_qloop_592 = _mm256_add_pd(tmp_qloop_141,tmp_qloop_448);
                   const __m256d tmp_qloop_595 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_170),tmp_qloop_171),tmp_qloop_172));
                   const __m256d tmp_qloop_598 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_179),tmp_qloop_180),tmp_qloop_181);
                   const __m256d tmp_qloop_600 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_598),tmp_qloop_599);
                   const __m256d tmp_qloop_601 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_600);
                   const __m256d tmp_qloop_604 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_183),tmp_qloop_184),tmp_qloop_185));
                   const __m256d tmp_qloop_607 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_192),tmp_qloop_193),tmp_qloop_194);
                   const __m256d tmp_qloop_609 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_607),tmp_qloop_608);
                   const __m256d tmp_qloop_610 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_609);
                   const __m256d tmp_qloop_613 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_196),tmp_qloop_197),tmp_qloop_198));
                   const __m256d tmp_qloop_616 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_205),tmp_qloop_206),tmp_qloop_207);
                   const __m256d tmp_qloop_618 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_616),tmp_qloop_617);
                   const __m256d tmp_qloop_619 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_618);
                   const __m256d tmp_qloop_622 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_209),tmp_qloop_210),tmp_qloop_211));
                   const __m256d tmp_qloop_625 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_218),tmp_qloop_219),tmp_qloop_220);
                   const __m256d tmp_qloop_627 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_625),tmp_qloop_626);
                   const __m256d tmp_qloop_628 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_627);
                   const __m256d tmp_qloop_631 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_222),tmp_qloop_223),tmp_qloop_224));
                   const __m256d tmp_qloop_634 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_231),tmp_qloop_232),tmp_qloop_233);
                   const __m256d tmp_qloop_636 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_634),tmp_qloop_635);
                   const __m256d tmp_qloop_637 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_636);
                   const __m256d tmp_qloop_640 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_235),tmp_qloop_236),tmp_qloop_237));
                   const __m256d tmp_qloop_643 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_244),tmp_qloop_245),tmp_qloop_246);
                   const __m256d tmp_qloop_645 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_643),tmp_qloop_644);
                   const __m256d tmp_qloop_646 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_645);
                   const __m256d tmp_qloop_649 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_248),tmp_qloop_249),tmp_qloop_250));
                   const __m256d tmp_qloop_652 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_257),tmp_qloop_258),tmp_qloop_259);
                   const __m256d tmp_qloop_654 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_652),tmp_qloop_653);
                   const __m256d tmp_qloop_655 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_654);
                   const __m256d tmp_qloop_658 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_117,tmp_qloop_261),tmp_qloop_262),tmp_qloop_263));
                   const __m256d tmp_qloop_661 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_270),tmp_qloop_271),tmp_qloop_272);
                   const __m256d tmp_qloop_663 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_661),tmp_qloop_662);
                   const __m256d tmp_qloop_664 = _mm256_add_pd(tmp_qloop_143,tmp_qloop_663);
                   const __m256d tmp_qloop_668 = _mm256_add_pd(tmp_qloop_115,tmp_qloop_667);
                   const __m256d tmp_qloop_669 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_274,tmp_qloop_275),tmp_qloop_276),tmp_qloop_668));
                   const __m256d tmp_qloop_673 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_300),tmp_qloop_301),tmp_qloop_302);
                   const __m256d tmp_qloop_675 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_293,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_294,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_295,_mm256_set_pd(0.5,0.5,0.5,0.5)));
                   const __m256d tmp_qloop_676 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_137,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)));
                   const __m256d tmp_qloop_677 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_297,tmp_qloop_676),tmp_qloop_143),tmp_qloop_674);
                   const __m256d tmp_qloop_679 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_676),tmp_qloop_443);
                   const __m256d tmp_qloop_680 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_676),tmp_qloop_458);
                   const __m256d tmp_qloop_681 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_676),tmp_qloop_473);
                   const __m256d tmp_qloop_682 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_676),tmp_qloop_488);
                   const __m256d tmp_qloop_683 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_676),tmp_qloop_503);
                   const __m256d tmp_qloop_684 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_676),tmp_qloop_518);
                   const __m256d tmp_qloop_685 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_676),tmp_qloop_533);
                   const __m256d tmp_qloop_686 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_676),tmp_qloop_548);
                   const __m256d tmp_qloop_687 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_676),tmp_qloop_563);
                   const __m256d tmp_qloop_688 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_676),tmp_qloop_578);
                   const __m256d tmp_qloop_689 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_305,tmp_qloop_306),tmp_qloop_307),tmp_qloop_668));
                   const __m256d tmp_qloop_692 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_314),tmp_qloop_315),tmp_qloop_316);
                   const __m256d tmp_qloop_693 = _mm256_add_pd(tmp_qloop_674,tmp_qloop_679);
                   const __m256d tmp_qloop_696 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_319,tmp_qloop_320),tmp_qloop_321),tmp_qloop_668));
                   const __m256d tmp_qloop_699 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_328),tmp_qloop_329),tmp_qloop_330);
                   const __m256d tmp_qloop_702 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_333,tmp_qloop_334),tmp_qloop_335),tmp_qloop_668));
                   const __m256d tmp_qloop_705 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_342),tmp_qloop_343),tmp_qloop_344);
                   const __m256d tmp_qloop_708 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_347,tmp_qloop_348),tmp_qloop_349),tmp_qloop_668));
                   const __m256d tmp_qloop_711 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_356),tmp_qloop_357),tmp_qloop_358);
                   const __m256d tmp_qloop_714 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_361,tmp_qloop_362),tmp_qloop_363),tmp_qloop_668));
                   const __m256d tmp_qloop_717 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_370),tmp_qloop_371),tmp_qloop_372);
                   const __m256d tmp_qloop_720 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_375,tmp_qloop_376),tmp_qloop_377),tmp_qloop_668));
                   const __m256d tmp_qloop_723 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_384),tmp_qloop_385),tmp_qloop_386);
                   const __m256d tmp_qloop_726 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_389,tmp_qloop_390),tmp_qloop_391),tmp_qloop_668));
                   const __m256d tmp_qloop_729 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_398),tmp_qloop_399),tmp_qloop_400);
                   const __m256d tmp_qloop_732 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_403,tmp_qloop_404),tmp_qloop_405),tmp_qloop_668));
                   const __m256d tmp_qloop_735 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_412),tmp_qloop_413),tmp_qloop_414);
                   const __m256d tmp_qloop_738 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_417,tmp_qloop_418),tmp_qloop_419),tmp_qloop_668));
                   const __m256d tmp_qloop_741 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_152,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_426),tmp_qloop_427),tmp_qloop_428);
                   const __m256d tmp_qloop_745 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_431,tmp_qloop_432),tmp_qloop_433),tmp_qloop_744));
                   const __m256d tmp_qloop_746 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_431,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_432,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_433,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_747 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_436),tmp_qloop_437),tmp_qloop_438);
                   const __m256d tmp_qloop_748 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_444),tmp_qloop_445),tmp_qloop_446);
                   const __m256d tmp_qloop_750 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_449,tmp_qloop_450),tmp_qloop_451),tmp_qloop_744));
                   const __m256d tmp_qloop_751 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_449,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_450,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_451,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_752 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_453),tmp_qloop_454),tmp_qloop_455);
                   const __m256d tmp_qloop_753 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_459),tmp_qloop_460),tmp_qloop_461);
                   const __m256d tmp_qloop_754 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_464,tmp_qloop_465),tmp_qloop_466),tmp_qloop_744));
                   const __m256d tmp_qloop_755 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_464,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_465,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_466,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_756 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_468),tmp_qloop_469),tmp_qloop_470);
                   const __m256d tmp_qloop_757 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_474),tmp_qloop_475),tmp_qloop_476);
                   const __m256d tmp_qloop_758 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_479,tmp_qloop_480),tmp_qloop_481),tmp_qloop_744));
                   const __m256d tmp_qloop_759 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_479,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_480,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_481,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_760 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_483),tmp_qloop_484),tmp_qloop_485);
                   const __m256d tmp_qloop_761 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_489),tmp_qloop_490),tmp_qloop_491);
                   const __m256d tmp_qloop_762 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_494,tmp_qloop_495),tmp_qloop_496),tmp_qloop_744));
                   const __m256d tmp_qloop_763 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_494,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_495,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_496,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_764 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_498),tmp_qloop_499),tmp_qloop_500);
                   const __m256d tmp_qloop_765 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_504),tmp_qloop_505),tmp_qloop_506);
                   const __m256d tmp_qloop_766 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_509,tmp_qloop_510),tmp_qloop_511),tmp_qloop_744));
                   const __m256d tmp_qloop_767 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_509,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_510,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_511,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_768 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_513),tmp_qloop_514),tmp_qloop_515);
                   const __m256d tmp_qloop_769 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_519),tmp_qloop_520),tmp_qloop_521);
                   const __m256d tmp_qloop_770 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_524,tmp_qloop_525),tmp_qloop_526),tmp_qloop_744));
                   const __m256d tmp_qloop_771 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_524,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_525,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_526,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_772 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_528),tmp_qloop_529),tmp_qloop_530);
                   const __m256d tmp_qloop_773 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_534),tmp_qloop_535),tmp_qloop_536);
                   const __m256d tmp_qloop_774 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_539,tmp_qloop_540),tmp_qloop_541),tmp_qloop_744));
                   const __m256d tmp_qloop_775 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_539,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_540,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_541,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_776 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_543),tmp_qloop_544),tmp_qloop_545);
                   const __m256d tmp_qloop_777 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_549),tmp_qloop_550),tmp_qloop_551);
                   const __m256d tmp_qloop_778 = _mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_554,tmp_qloop_555),tmp_qloop_556),tmp_qloop_744));
                   const __m256d tmp_qloop_779 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_554,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_555,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_556,_mm256_set_pd(1.0,1.0,1.0,1.0)));
                   const __m256d tmp_qloop_780 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_675,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_558),tmp_qloop_559),tmp_qloop_560);
                   const __m256d tmp_qloop_781 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_153,_mm256_set_pd(2.0,2.0,2.0,2.0)),tmp_qloop_564),tmp_qloop_565),tmp_qloop_566);
                   const __m256d hessian_blending_0_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_set_pd(tmp_qloop_33,tmp_qloop_33,tmp_qloop_33,tmp_qloop_33))),_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68))),_mm256_mul_pd(tmp_qloop_35,tmp_qloop_69)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_28,tmp_qloop_69),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_25,tmp_qloop_71)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_0_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_67),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_19,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_22,tmp_qloop_71)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_0_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_78),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_81),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_2_0_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_83),tmp_qloop_84);
                   const __m256d hessian_blending_0_0_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_77,tmp_qloop_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_75),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_0_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_80,tmp_qloop_86),tmp_qloop_84);
                   const __m256d hessian_blending_2_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_83,tmp_qloop_86),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_77),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_52);
                   const __m256d hessian_blending_0_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_87,tmp_qloop_88),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_1_1_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_qloop_88,tmp_qloop_92));
                   const __m256d hessian_blending_0_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_set_pd(tmp_qloop_53,tmp_qloop_53,tmp_qloop_53,tmp_qloop_53))),_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40))),_mm256_mul_pd(tmp_qloop_47,tmp_qloop_79)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_79))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_29,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_mul_pd(tmp_qloop_54,tmp_qloop_82)),tmp_qloop_73)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_1_2 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_87),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_1_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_37),tmp_qloop_90),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_86,tmp_qloop_92),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_30,tmp_qloop_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_44);
                   const __m256d hessian_blending_0_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_88,tmp_qloop_96),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_19,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_1_2_0 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_18,tmp_qloop_37),tmp_qloop_98),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_0 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_85,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_18),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_1 = _mm256_add_pd(_mm256_mul_pd(tmp_qloop_100,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_25,tmp_qloop_37),tmp_qloop_96),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_81,tmp_qloop_98),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_29,tmp_qloop_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),tmp_qloop_50);
                   const __m256d hessian_blending_2_2_1 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_22,tmp_qloop_99),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_101,tmp_qloop_25),tmp_qloop_37),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_0_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_18),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_68,tmp_qloop_68,tmp_qloop_68,tmp_qloop_68)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_69)),tmp_qloop_94)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_1_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_25),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_40,tmp_qloop_40,tmp_qloop_40,tmp_qloop_40)),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_79)),tmp_qloop_70)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d hessian_blending_2_2_2 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_102,tmp_qloop_22),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_37,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_31,_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72)),_mm256_set_pd(tmp_qloop_46,tmp_qloop_46,tmp_qloop_46,tmp_qloop_46))),_mm256_mul_pd(tmp_qloop_48,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_30,_mm256_set_pd(tmp_qloop_72,tmp_qloop_72,tmp_qloop_72,tmp_qloop_72))),_mm256_mul_pd(tmp_qloop_57,tmp_qloop_82))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_set_pd(tmp_qloop_17,tmp_qloop_17,tmp_qloop_17,tmp_qloop_17)));
                   const __m256d q_tmp_0_0 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(2.0,2.0,2.0,2.0)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(2.0,2.0,2.0,2.0)))),_mm256_mul_pd(tmp_qloop_129,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_121,tmp_qloop_122),tmp_qloop_123),tmp_qloop_127))),_mm256_mul_pd(tmp_qloop_138,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_130,tmp_qloop_131),tmp_qloop_132),tmp_qloop_136))),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_103,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663)),_mm256_mul_pd(tmp_qloop_104,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),_mm256_mul_pd(tmp_qloop_105,_mm256_set_pd(0.66666666666666663,0.66666666666666663,0.66666666666666663,0.66666666666666663))),tmp_qloop_114)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_161),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_165)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_169)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_160),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_174),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_178)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_182)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_173),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_187),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_191)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_195)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_186),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_200),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_204)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_208)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_213),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_217)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_221)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_212),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_226),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_230)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_234)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_225),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_239),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_243)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_247)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_238),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_252),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_256)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_260)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_251),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_120,tmp_qloop_265),_mm256_mul_pd(tmp_qloop_129,tmp_qloop_269)),_mm256_mul_pd(tmp_qloop_138,tmp_qloop_273)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_264),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_290),tmp_qloop_298),tmp_qloop_304)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_282),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_312),tmp_qloop_298),tmp_qloop_318)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_308),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_326),tmp_qloop_298),tmp_qloop_332)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_322),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_340),tmp_qloop_298),tmp_qloop_346)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_336),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_354),tmp_qloop_298),tmp_qloop_360)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_350),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_368),tmp_qloop_298),tmp_qloop_374)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_364),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_382),tmp_qloop_298),tmp_qloop_388)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_378),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_396),tmp_qloop_298),tmp_qloop_402)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_392),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_410),tmp_qloop_298),tmp_qloop_416)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_406),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_129,tmp_qloop_424),tmp_qloop_298),tmp_qloop_430)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_420),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_439),tmp_qloop_441),tmp_qloop_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_435),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_456),tmp_qloop_441),tmp_qloop_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_452),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_471),tmp_qloop_441),tmp_qloop_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_467),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_486),tmp_qloop_441),tmp_qloop_493)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_482),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_501),tmp_qloop_441),tmp_qloop_508)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_497),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_516),tmp_qloop_441),tmp_qloop_523)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_512),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_531),tmp_qloop_441),tmp_qloop_538)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_527),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_546),tmp_qloop_441),tmp_qloop_553)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_542),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_561),tmp_qloop_441),tmp_qloop_568)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_557),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_0_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_138,tmp_qloop_576),tmp_qloop_441),tmp_qloop_583)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_119,tmp_qloop_572),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_1 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_161,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_165,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_169,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_160,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_585),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_586)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_587)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_586),tmp_qloop_588),tmp_qloop_590)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_586),tmp_qloop_318),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_586),tmp_qloop_332),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_586),tmp_qloop_346),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_586),tmp_qloop_360),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_586),tmp_qloop_374),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_586),tmp_qloop_388),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_586),tmp_qloop_402),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_586),tmp_qloop_416),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_586),tmp_qloop_430),tmp_qloop_591)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_587),tmp_qloop_592),tmp_qloop_593)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_587),tmp_qloop_463),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_587),tmp_qloop_478),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_587),tmp_qloop_493),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_587),tmp_qloop_508),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_587),tmp_qloop_523),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_587),tmp_qloop_538),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_587),tmp_qloop_553),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_587),tmp_qloop_568),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_1_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_587),tmp_qloop_583),tmp_qloop_594)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_584),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_2 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_174,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_178,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_182,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_173,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_596),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_597)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_598)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_597),tmp_qloop_588),tmp_qloop_600)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_597),tmp_qloop_318),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_597),tmp_qloop_332),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_597),tmp_qloop_346),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_597),tmp_qloop_360),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_597),tmp_qloop_374),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_597),tmp_qloop_388),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_597),tmp_qloop_402),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_597),tmp_qloop_416),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_597),tmp_qloop_430),tmp_qloop_601)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_598),tmp_qloop_592),tmp_qloop_602)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_598),tmp_qloop_463),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_598),tmp_qloop_478),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_598),tmp_qloop_493),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_598),tmp_qloop_508),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_598),tmp_qloop_523),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_598),tmp_qloop_538),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_598),tmp_qloop_553),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_598),tmp_qloop_568),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_2_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_598),tmp_qloop_583),tmp_qloop_603)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_595),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_3 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_187,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_191,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_195,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_186,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_605),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_606)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_607)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_606),tmp_qloop_588),tmp_qloop_609)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_606),tmp_qloop_318),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_606),tmp_qloop_332),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_606),tmp_qloop_346),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_606),tmp_qloop_360),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_606),tmp_qloop_374),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_606),tmp_qloop_388),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_606),tmp_qloop_402),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_606),tmp_qloop_416),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_606),tmp_qloop_430),tmp_qloop_610)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_607),tmp_qloop_592),tmp_qloop_611)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_607),tmp_qloop_463),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_607),tmp_qloop_478),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_607),tmp_qloop_493),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_607),tmp_qloop_508),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_607),tmp_qloop_523),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_607),tmp_qloop_538),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_607),tmp_qloop_553),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_607),tmp_qloop_568),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_3_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_607),tmp_qloop_583),tmp_qloop_612)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_604),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_4 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_200,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_204,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_208,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_199,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_614),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_615)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_616)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_615),tmp_qloop_588),tmp_qloop_618)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_615),tmp_qloop_318),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_615),tmp_qloop_332),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_615),tmp_qloop_346),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_615),tmp_qloop_360),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_615),tmp_qloop_374),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_615),tmp_qloop_388),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_615),tmp_qloop_402),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_615),tmp_qloop_416),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_615),tmp_qloop_430),tmp_qloop_619)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_616),tmp_qloop_592),tmp_qloop_620)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_616),tmp_qloop_463),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_616),tmp_qloop_478),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_616),tmp_qloop_493),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_616),tmp_qloop_508),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_616),tmp_qloop_523),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_616),tmp_qloop_538),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_616),tmp_qloop_553),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_616),tmp_qloop_568),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_4_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_616),tmp_qloop_583),tmp_qloop_621)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_613),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_5 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_213,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_217,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_221,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_212,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_623),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_624)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_625)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_624),tmp_qloop_588),tmp_qloop_627)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_624),tmp_qloop_318),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_624),tmp_qloop_332),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_624),tmp_qloop_346),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_624),tmp_qloop_360),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_624),tmp_qloop_374),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_624),tmp_qloop_388),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_624),tmp_qloop_402),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_624),tmp_qloop_416),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_624),tmp_qloop_430),tmp_qloop_628)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_625),tmp_qloop_592),tmp_qloop_629)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_625),tmp_qloop_463),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_625),tmp_qloop_478),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_625),tmp_qloop_493),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_625),tmp_qloop_508),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_625),tmp_qloop_523),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_625),tmp_qloop_538),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_625),tmp_qloop_553),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_625),tmp_qloop_568),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_5_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_625),tmp_qloop_583),tmp_qloop_630)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_622),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_6 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_226,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_230,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_234,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_225,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_632),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_633)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_634)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_633),tmp_qloop_588),tmp_qloop_636)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_633),tmp_qloop_318),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_633),tmp_qloop_332),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_633),tmp_qloop_346),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_633),tmp_qloop_360),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_633),tmp_qloop_374),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_633),tmp_qloop_388),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_633),tmp_qloop_402),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_633),tmp_qloop_416),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_633),tmp_qloop_430),tmp_qloop_637)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_634),tmp_qloop_592),tmp_qloop_638)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_634),tmp_qloop_463),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_634),tmp_qloop_478),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_634),tmp_qloop_493),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_634),tmp_qloop_508),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_634),tmp_qloop_523),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_634),tmp_qloop_538),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_634),tmp_qloop_553),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_634),tmp_qloop_568),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_6_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_634),tmp_qloop_583),tmp_qloop_639)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_631),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_7 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_239,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_243,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_247,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_238,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_641),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_642)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_643)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_642),tmp_qloop_588),tmp_qloop_645)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_642),tmp_qloop_318),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_642),tmp_qloop_332),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_642),tmp_qloop_346),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_642),tmp_qloop_360),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_642),tmp_qloop_374),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_642),tmp_qloop_388),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_642),tmp_qloop_402),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_642),tmp_qloop_416),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_642),tmp_qloop_430),tmp_qloop_646)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_643),tmp_qloop_592),tmp_qloop_647)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_643),tmp_qloop_463),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_643),tmp_qloop_478),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_643),tmp_qloop_493),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_643),tmp_qloop_508),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_643),tmp_qloop_523),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_643),tmp_qloop_538),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_643),tmp_qloop_553),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_643),tmp_qloop_568),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_7_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_643),tmp_qloop_583),tmp_qloop_648)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_640),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_8 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_252,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_256,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_260,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_251,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_650),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_651)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_652)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_651),tmp_qloop_588),tmp_qloop_654)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_651),tmp_qloop_318),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_651),tmp_qloop_332),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_651),tmp_qloop_346),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_651),tmp_qloop_360),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_651),tmp_qloop_374),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_651),tmp_qloop_388),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_651),tmp_qloop_402),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_651),tmp_qloop_416),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_651),tmp_qloop_430),tmp_qloop_655)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_652),tmp_qloop_592),tmp_qloop_656)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_652),tmp_qloop_463),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_652),tmp_qloop_478),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_652),tmp_qloop_493),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_652),tmp_qloop_508),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_652),tmp_qloop_523),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_652),tmp_qloop_538),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_652),tmp_qloop_553),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_652),tmp_qloop_568),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_8_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_652),tmp_qloop_583),tmp_qloop_657)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_649),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_9 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_265,tmp_qloop_659),_mm256_mul_pd(tmp_qloop_269,tmp_qloop_660)),_mm256_mul_pd(tmp_qloop_273,tmp_qloop_661)),tmp_qloop_155)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_264,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_660),tmp_qloop_588),tmp_qloop_663)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_660),tmp_qloop_318),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_660),tmp_qloop_332),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_660),tmp_qloop_346),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_660),tmp_qloop_360),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_660),tmp_qloop_374),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_660),tmp_qloop_388),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_660),tmp_qloop_402),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_660),tmp_qloop_416),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_660),tmp_qloop_430),tmp_qloop_664)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_661),tmp_qloop_592),tmp_qloop_665)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_661),tmp_qloop_463),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_661),tmp_qloop_478),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_661),tmp_qloop_493),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_661),tmp_qloop_508),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_661),tmp_qloop_523),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_661),tmp_qloop_538),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_661),tmp_qloop_553),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_661),tmp_qloop_568),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_9_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_661),tmp_qloop_583),tmp_qloop_666)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_658),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_10 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_290,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_299,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_303,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_282,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_672),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_670)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_673)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_673),tmp_qloop_678),tmp_qloop_679)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_673),tmp_qloop_678),tmp_qloop_680)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_673),tmp_qloop_678),tmp_qloop_681)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_673),tmp_qloop_678),tmp_qloop_682)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_673),tmp_qloop_678),tmp_qloop_683)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_673),tmp_qloop_678),tmp_qloop_684)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_673),tmp_qloop_678),tmp_qloop_685)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_673),tmp_qloop_678),tmp_qloop_686)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_673),tmp_qloop_678),tmp_qloop_687)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_10_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_673),tmp_qloop_678),tmp_qloop_688)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_669),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_11 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_312,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_313,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_317,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_308,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_691),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_690)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_692)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_692),tmp_qloop_693),tmp_qloop_694)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_692),tmp_qloop_680),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_692),tmp_qloop_681),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_692),tmp_qloop_682),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_692),tmp_qloop_683),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_692),tmp_qloop_684),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_692),tmp_qloop_685),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_692),tmp_qloop_686),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_692),tmp_qloop_687),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_11_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_692),tmp_qloop_688),tmp_qloop_695)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_689),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_12 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_326,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_327,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_331,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_322,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_698),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_697)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_699)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_699),tmp_qloop_693),tmp_qloop_700)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_699),tmp_qloop_680),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_699),tmp_qloop_681),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_699),tmp_qloop_682),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_699),tmp_qloop_683),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_699),tmp_qloop_684),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_699),tmp_qloop_685),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_699),tmp_qloop_686),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_699),tmp_qloop_687),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_12_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_699),tmp_qloop_688),tmp_qloop_701)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_696),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_13 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_340,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_341,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_345,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_336,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_704),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_703)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_705)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_705),tmp_qloop_693),tmp_qloop_706)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_705),tmp_qloop_680),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_705),tmp_qloop_681),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_705),tmp_qloop_682),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_705),tmp_qloop_683),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_705),tmp_qloop_684),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_705),tmp_qloop_685),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_705),tmp_qloop_686),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_705),tmp_qloop_687),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_13_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_705),tmp_qloop_688),tmp_qloop_707)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_702),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_14 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_354,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_355,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_359,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_350,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_710),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_709)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_711)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_711),tmp_qloop_693),tmp_qloop_712)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_711),tmp_qloop_680),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_711),tmp_qloop_681),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_711),tmp_qloop_682),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_711),tmp_qloop_683),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_711),tmp_qloop_684),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_711),tmp_qloop_685),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_711),tmp_qloop_686),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_711),tmp_qloop_687),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_14_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_711),tmp_qloop_688),tmp_qloop_713)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_708),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_15 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_368,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_369,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_373,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_364,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_716),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_715)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_717)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_717),tmp_qloop_693),tmp_qloop_718)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_717),tmp_qloop_680),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_717),tmp_qloop_681),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_717),tmp_qloop_682),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_717),tmp_qloop_683),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_717),tmp_qloop_684),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_717),tmp_qloop_685),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_717),tmp_qloop_686),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_717),tmp_qloop_687),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_15_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_717),tmp_qloop_688),tmp_qloop_719)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_714),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_16 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_382,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_383,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_387,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_378,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_722),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_721)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_723)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_723),tmp_qloop_693),tmp_qloop_724)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_723),tmp_qloop_680),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_723),tmp_qloop_681),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_723),tmp_qloop_682),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_723),tmp_qloop_683),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_723),tmp_qloop_684),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_723),tmp_qloop_685),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_723),tmp_qloop_686),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_723),tmp_qloop_687),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_16_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_723),tmp_qloop_688),tmp_qloop_725)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_720),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_17 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_396,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_397,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_401,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_392,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_728),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_727)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_729)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_729),tmp_qloop_693),tmp_qloop_730)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_729),tmp_qloop_680),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_729),tmp_qloop_681),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_729),tmp_qloop_682),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_729),tmp_qloop_683),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_729),tmp_qloop_684),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_729),tmp_qloop_685),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_729),tmp_qloop_686),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_729),tmp_qloop_687),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_17_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_729),tmp_qloop_688),tmp_qloop_731)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_726),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_18 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_410,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_411,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_415,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_406,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_734),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_733)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_735)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_735),tmp_qloop_693),tmp_qloop_736)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_735),tmp_qloop_680),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_735),tmp_qloop_681),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_735),tmp_qloop_682),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_735),tmp_qloop_683),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_735),tmp_qloop_684),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_735),tmp_qloop_685),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_735),tmp_qloop_686),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_735),tmp_qloop_687),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_18_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_735),tmp_qloop_688),tmp_qloop_737)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_732),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_19 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_424,tmp_qloop_740),_mm256_mul_pd(tmp_qloop_425,tmp_qloop_739)),_mm256_mul_pd(tmp_qloop_429,tmp_qloop_741)),tmp_qloop_677)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_420,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_447,tmp_qloop_741),tmp_qloop_693),tmp_qloop_742)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_462,tmp_qloop_741),tmp_qloop_680),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_477,tmp_qloop_741),tmp_qloop_681),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_492,tmp_qloop_741),tmp_qloop_682),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_507,tmp_qloop_741),tmp_qloop_683),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_522,tmp_qloop_741),tmp_qloop_684),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_537,tmp_qloop_741),tmp_qloop_685),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_552,tmp_qloop_741),tmp_qloop_686),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_567,tmp_qloop_741),tmp_qloop_687),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_19_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_582,tmp_qloop_741),tmp_qloop_688),tmp_qloop_743)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_738),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_20 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_439,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_442,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_447,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_435,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_20_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_747),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_746)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_748)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_745),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_21 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_456,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_457,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_462,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_452,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_21_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_752),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_751)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_753)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_750),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_22 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_471,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_472,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_477,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_467,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_22_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_756),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_755)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_757)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_754),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_23 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_486,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_487,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_492,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_482,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_23_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_760),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_759)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_761)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_758),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_24 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_501,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_502,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_507,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_497,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_24_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_764),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_763)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_765)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_762),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_25 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_516,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_517,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_522,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_512,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_25_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_768),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_767)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_769)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_766),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_26 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_531,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_532,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_537,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_527,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_26_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_772),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_771)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_773)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_770),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_27 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_546,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_547,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_552,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_542,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_27_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_776),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_775)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_777)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_774),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_28 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_561,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_562,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_567,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_557,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_28_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_576,tmp_qloop_780),_mm256_mul_pd(tmp_qloop_577,tmp_qloop_779)),_mm256_mul_pd(tmp_qloop_582,tmp_qloop_781)),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_572,tmp_qloop_778),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   const __m256d q_tmp_29_29 = _mm256_mul_pd(tmp_qloop_156,_mm256_add_pd(_mm256_mul_pd(tmp_qloop_118,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_577,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_569,_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_mul_pd(tmp_qloop_570,_mm256_set_pd(1.0,1.0,1.0,1.0))),_mm256_mul_pd(tmp_qloop_571,_mm256_set_pd(1.0,1.0,1.0,1.0)))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_576,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_573,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_574,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_575,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_675)),_mm256_set_pd(2.0,2.0,2.0,2.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_582,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_qloop_579,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_qloop_580,_mm256_set_pd(0.5,0.5,0.5,0.5))),_mm256_mul_pd(tmp_qloop_581,_mm256_set_pd(0.5,0.5,0.5,0.5))),tmp_qloop_153)),_mm256_set_pd(2.0,2.0,2.0,2.0))),tmp_qloop_749)),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_qloop_118,tmp_qloop_572),_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(tmp_qloop_569,tmp_qloop_570),tmp_qloop_571),tmp_qloop_744)),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                   q_acc_0_0 = _mm256_add_pd(q_acc_0_0,q_tmp_0_0);
                   q_acc_0_1 = _mm256_add_pd(q_acc_0_1,q_tmp_0_1);
                   q_acc_0_2 = _mm256_add_pd(q_acc_0_2,q_tmp_0_2);
                   q_acc_0_3 = _mm256_add_pd(q_acc_0_3,q_tmp_0_3);
                   q_acc_0_4 = _mm256_add_pd(q_acc_0_4,q_tmp_0_4);
                   q_acc_0_5 = _mm256_add_pd(q_acc_0_5,q_tmp_0_5);
                   q_acc_0_6 = _mm256_add_pd(q_acc_0_6,q_tmp_0_6);
                   q_acc_0_7 = _mm256_add_pd(q_acc_0_7,q_tmp_0_7);
                   q_acc_0_8 = _mm256_add_pd(q_acc_0_8,q_tmp_0_8);
                   q_acc_0_9 = _mm256_add_pd(q_acc_0_9,q_tmp_0_9);
                   q_acc_0_10 = _mm256_add_pd(q_acc_0_10,q_tmp_0_10);
                   q_acc_0_11 = _mm256_add_pd(q_acc_0_11,q_tmp_0_11);
                   q_acc_0_12 = _mm256_add_pd(q_acc_0_12,q_tmp_0_12);
                   q_acc_0_13 = _mm256_add_pd(q_acc_0_13,q_tmp_0_13);
                   q_acc_0_14 = _mm256_add_pd(q_acc_0_14,q_tmp_0_14);
                   q_acc_0_15 = _mm256_add_pd(q_acc_0_15,q_tmp_0_15);
                   q_acc_0_16 = _mm256_add_pd(q_acc_0_16,q_tmp_0_16);
                   q_acc_0_17 = _mm256_add_pd(q_acc_0_17,q_tmp_0_17);
                   q_acc_0_18 = _mm256_add_pd(q_acc_0_18,q_tmp_0_18);
                   q_acc_0_19 = _mm256_add_pd(q_acc_0_19,q_tmp_0_19);
                   q_acc_0_20 = _mm256_add_pd(q_acc_0_20,q_tmp_0_20);
                   q_acc_0_21 = _mm256_add_pd(q_acc_0_21,q_tmp_0_21);
                   q_acc_0_22 = _mm256_add_pd(q_acc_0_22,q_tmp_0_22);
                   q_acc_0_23 = _mm256_add_pd(q_acc_0_23,q_tmp_0_23);
                   q_acc_0_24 = _mm256_add_pd(q_acc_0_24,q_tmp_0_24);
                   q_acc_0_25 = _mm256_add_pd(q_acc_0_25,q_tmp_0_25);
                   q_acc_0_26 = _mm256_add_pd(q_acc_0_26,q_tmp_0_26);
                   q_acc_0_27 = _mm256_add_pd(q_acc_0_27,q_tmp_0_27);
                   q_acc_0_28 = _mm256_add_pd(q_acc_0_28,q_tmp_0_28);
                   q_acc_0_29 = _mm256_add_pd(q_acc_0_29,q_tmp_0_29);
                   q_acc_1_1 = _mm256_add_pd(q_acc_1_1,q_tmp_1_1);
                   q_acc_1_2 = _mm256_add_pd(q_acc_1_2,q_tmp_1_2);
                   q_acc_1_3 = _mm256_add_pd(q_acc_1_3,q_tmp_1_3);
                   q_acc_1_4 = _mm256_add_pd(q_acc_1_4,q_tmp_1_4);
                   q_acc_1_5 = _mm256_add_pd(q_acc_1_5,q_tmp_1_5);
                   q_acc_1_6 = _mm256_add_pd(q_acc_1_6,q_tmp_1_6);
                   q_acc_1_7 = _mm256_add_pd(q_acc_1_7,q_tmp_1_7);
                   q_acc_1_8 = _mm256_add_pd(q_acc_1_8,q_tmp_1_8);
                   q_acc_1_9 = _mm256_add_pd(q_acc_1_9,q_tmp_1_9);
                   q_acc_1_10 = _mm256_add_pd(q_acc_1_10,q_tmp_1_10);
                   q_acc_1_11 = _mm256_add_pd(q_acc_1_11,q_tmp_1_11);
                   q_acc_1_12 = _mm256_add_pd(q_acc_1_12,q_tmp_1_12);
                   q_acc_1_13 = _mm256_add_pd(q_acc_1_13,q_tmp_1_13);
                   q_acc_1_14 = _mm256_add_pd(q_acc_1_14,q_tmp_1_14);
                   q_acc_1_15 = _mm256_add_pd(q_acc_1_15,q_tmp_1_15);
                   q_acc_1_16 = _mm256_add_pd(q_acc_1_16,q_tmp_1_16);
                   q_acc_1_17 = _mm256_add_pd(q_acc_1_17,q_tmp_1_17);
                   q_acc_1_18 = _mm256_add_pd(q_acc_1_18,q_tmp_1_18);
                   q_acc_1_19 = _mm256_add_pd(q_acc_1_19,q_tmp_1_19);
                   q_acc_1_20 = _mm256_add_pd(q_acc_1_20,q_tmp_1_20);
                   q_acc_1_21 = _mm256_add_pd(q_acc_1_21,q_tmp_1_21);
                   q_acc_1_22 = _mm256_add_pd(q_acc_1_22,q_tmp_1_22);
                   q_acc_1_23 = _mm256_add_pd(q_acc_1_23,q_tmp_1_23);
                   q_acc_1_24 = _mm256_add_pd(q_acc_1_24,q_tmp_1_24);
                   q_acc_1_25 = _mm256_add_pd(q_acc_1_25,q_tmp_1_25);
                   q_acc_1_26 = _mm256_add_pd(q_acc_1_26,q_tmp_1_26);
                   q_acc_1_27 = _mm256_add_pd(q_acc_1_27,q_tmp_1_27);
                   q_acc_1_28 = _mm256_add_pd(q_acc_1_28,q_tmp_1_28);
                   q_acc_1_29 = _mm256_add_pd(q_acc_1_29,q_tmp_1_29);
                   q_acc_2_2 = _mm256_add_pd(q_acc_2_2,q_tmp_2_2);
                   q_acc_2_3 = _mm256_add_pd(q_acc_2_3,q_tmp_2_3);
                   q_acc_2_4 = _mm256_add_pd(q_acc_2_4,q_tmp_2_4);
                   q_acc_2_5 = _mm256_add_pd(q_acc_2_5,q_tmp_2_5);
                   q_acc_2_6 = _mm256_add_pd(q_acc_2_6,q_tmp_2_6);
                   q_acc_2_7 = _mm256_add_pd(q_acc_2_7,q_tmp_2_7);
                   q_acc_2_8 = _mm256_add_pd(q_acc_2_8,q_tmp_2_8);
                   q_acc_2_9 = _mm256_add_pd(q_acc_2_9,q_tmp_2_9);
                   q_acc_2_10 = _mm256_add_pd(q_acc_2_10,q_tmp_2_10);
                   q_acc_2_11 = _mm256_add_pd(q_acc_2_11,q_tmp_2_11);
                   q_acc_2_12 = _mm256_add_pd(q_acc_2_12,q_tmp_2_12);
                   q_acc_2_13 = _mm256_add_pd(q_acc_2_13,q_tmp_2_13);
                   q_acc_2_14 = _mm256_add_pd(q_acc_2_14,q_tmp_2_14);
                   q_acc_2_15 = _mm256_add_pd(q_acc_2_15,q_tmp_2_15);
                   q_acc_2_16 = _mm256_add_pd(q_acc_2_16,q_tmp_2_16);
                   q_acc_2_17 = _mm256_add_pd(q_acc_2_17,q_tmp_2_17);
                   q_acc_2_18 = _mm256_add_pd(q_acc_2_18,q_tmp_2_18);
                   q_acc_2_19 = _mm256_add_pd(q_acc_2_19,q_tmp_2_19);
                   q_acc_2_20 = _mm256_add_pd(q_acc_2_20,q_tmp_2_20);
                   q_acc_2_21 = _mm256_add_pd(q_acc_2_21,q_tmp_2_21);
                   q_acc_2_22 = _mm256_add_pd(q_acc_2_22,q_tmp_2_22);
                   q_acc_2_23 = _mm256_add_pd(q_acc_2_23,q_tmp_2_23);
                   q_acc_2_24 = _mm256_add_pd(q_acc_2_24,q_tmp_2_24);
                   q_acc_2_25 = _mm256_add_pd(q_acc_2_25,q_tmp_2_25);
                   q_acc_2_26 = _mm256_add_pd(q_acc_2_26,q_tmp_2_26);
                   q_acc_2_27 = _mm256_add_pd(q_acc_2_27,q_tmp_2_27);
                   q_acc_2_28 = _mm256_add_pd(q_acc_2_28,q_tmp_2_28);
                   q_acc_2_29 = _mm256_add_pd(q_acc_2_29,q_tmp_2_29);
                   q_acc_3_3 = _mm256_add_pd(q_acc_3_3,q_tmp_3_3);
                   q_acc_3_4 = _mm256_add_pd(q_acc_3_4,q_tmp_3_4);
                   q_acc_3_5 = _mm256_add_pd(q_acc_3_5,q_tmp_3_5);
                   q_acc_3_6 = _mm256_add_pd(q_acc_3_6,q_tmp_3_6);
                   q_acc_3_7 = _mm256_add_pd(q_acc_3_7,q_tmp_3_7);
                   q_acc_3_8 = _mm256_add_pd(q_acc_3_8,q_tmp_3_8);
                   q_acc_3_9 = _mm256_add_pd(q_acc_3_9,q_tmp_3_9);
                   q_acc_3_10 = _mm256_add_pd(q_acc_3_10,q_tmp_3_10);
                   q_acc_3_11 = _mm256_add_pd(q_acc_3_11,q_tmp_3_11);
                   q_acc_3_12 = _mm256_add_pd(q_acc_3_12,q_tmp_3_12);
                   q_acc_3_13 = _mm256_add_pd(q_acc_3_13,q_tmp_3_13);
                   q_acc_3_14 = _mm256_add_pd(q_acc_3_14,q_tmp_3_14);
                   q_acc_3_15 = _mm256_add_pd(q_acc_3_15,q_tmp_3_15);
                   q_acc_3_16 = _mm256_add_pd(q_acc_3_16,q_tmp_3_16);
                   q_acc_3_17 = _mm256_add_pd(q_acc_3_17,q_tmp_3_17);
                   q_acc_3_18 = _mm256_add_pd(q_acc_3_18,q_tmp_3_18);
                   q_acc_3_19 = _mm256_add_pd(q_acc_3_19,q_tmp_3_19);
                   q_acc_3_20 = _mm256_add_pd(q_acc_3_20,q_tmp_3_20);
                   q_acc_3_21 = _mm256_add_pd(q_acc_3_21,q_tmp_3_21);
                   q_acc_3_22 = _mm256_add_pd(q_acc_3_22,q_tmp_3_22);
                   q_acc_3_23 = _mm256_add_pd(q_acc_3_23,q_tmp_3_23);
                   q_acc_3_24 = _mm256_add_pd(q_acc_3_24,q_tmp_3_24);
                   q_acc_3_25 = _mm256_add_pd(q_acc_3_25,q_tmp_3_25);
                   q_acc_3_26 = _mm256_add_pd(q_acc_3_26,q_tmp_3_26);
                   q_acc_3_27 = _mm256_add_pd(q_acc_3_27,q_tmp_3_27);
                   q_acc_3_28 = _mm256_add_pd(q_acc_3_28,q_tmp_3_28);
                   q_acc_3_29 = _mm256_add_pd(q_acc_3_29,q_tmp_3_29);
                   q_acc_4_4 = _mm256_add_pd(q_acc_4_4,q_tmp_4_4);
                   q_acc_4_5 = _mm256_add_pd(q_acc_4_5,q_tmp_4_5);
                   q_acc_4_6 = _mm256_add_pd(q_acc_4_6,q_tmp_4_6);
                   q_acc_4_7 = _mm256_add_pd(q_acc_4_7,q_tmp_4_7);
                   q_acc_4_8 = _mm256_add_pd(q_acc_4_8,q_tmp_4_8);
                   q_acc_4_9 = _mm256_add_pd(q_acc_4_9,q_tmp_4_9);
                   q_acc_4_10 = _mm256_add_pd(q_acc_4_10,q_tmp_4_10);
                   q_acc_4_11 = _mm256_add_pd(q_acc_4_11,q_tmp_4_11);
                   q_acc_4_12 = _mm256_add_pd(q_acc_4_12,q_tmp_4_12);
                   q_acc_4_13 = _mm256_add_pd(q_acc_4_13,q_tmp_4_13);
                   q_acc_4_14 = _mm256_add_pd(q_acc_4_14,q_tmp_4_14);
                   q_acc_4_15 = _mm256_add_pd(q_acc_4_15,q_tmp_4_15);
                   q_acc_4_16 = _mm256_add_pd(q_acc_4_16,q_tmp_4_16);
                   q_acc_4_17 = _mm256_add_pd(q_acc_4_17,q_tmp_4_17);
                   q_acc_4_18 = _mm256_add_pd(q_acc_4_18,q_tmp_4_18);
                   q_acc_4_19 = _mm256_add_pd(q_acc_4_19,q_tmp_4_19);
                   q_acc_4_20 = _mm256_add_pd(q_acc_4_20,q_tmp_4_20);
                   q_acc_4_21 = _mm256_add_pd(q_acc_4_21,q_tmp_4_21);
                   q_acc_4_22 = _mm256_add_pd(q_acc_4_22,q_tmp_4_22);
                   q_acc_4_23 = _mm256_add_pd(q_acc_4_23,q_tmp_4_23);
                   q_acc_4_24 = _mm256_add_pd(q_acc_4_24,q_tmp_4_24);
                   q_acc_4_25 = _mm256_add_pd(q_acc_4_25,q_tmp_4_25);
                   q_acc_4_26 = _mm256_add_pd(q_acc_4_26,q_tmp_4_26);
                   q_acc_4_27 = _mm256_add_pd(q_acc_4_27,q_tmp_4_27);
                   q_acc_4_28 = _mm256_add_pd(q_acc_4_28,q_tmp_4_28);
                   q_acc_4_29 = _mm256_add_pd(q_acc_4_29,q_tmp_4_29);
                   q_acc_5_5 = _mm256_add_pd(q_acc_5_5,q_tmp_5_5);
                   q_acc_5_6 = _mm256_add_pd(q_acc_5_6,q_tmp_5_6);
                   q_acc_5_7 = _mm256_add_pd(q_acc_5_7,q_tmp_5_7);
                   q_acc_5_8 = _mm256_add_pd(q_acc_5_8,q_tmp_5_8);
                   q_acc_5_9 = _mm256_add_pd(q_acc_5_9,q_tmp_5_9);
                   q_acc_5_10 = _mm256_add_pd(q_acc_5_10,q_tmp_5_10);
                   q_acc_5_11 = _mm256_add_pd(q_acc_5_11,q_tmp_5_11);
                   q_acc_5_12 = _mm256_add_pd(q_acc_5_12,q_tmp_5_12);
                   q_acc_5_13 = _mm256_add_pd(q_acc_5_13,q_tmp_5_13);
                   q_acc_5_14 = _mm256_add_pd(q_acc_5_14,q_tmp_5_14);
                   q_acc_5_15 = _mm256_add_pd(q_acc_5_15,q_tmp_5_15);
                   q_acc_5_16 = _mm256_add_pd(q_acc_5_16,q_tmp_5_16);
                   q_acc_5_17 = _mm256_add_pd(q_acc_5_17,q_tmp_5_17);
                   q_acc_5_18 = _mm256_add_pd(q_acc_5_18,q_tmp_5_18);
                   q_acc_5_19 = _mm256_add_pd(q_acc_5_19,q_tmp_5_19);
                   q_acc_5_20 = _mm256_add_pd(q_acc_5_20,q_tmp_5_20);
                   q_acc_5_21 = _mm256_add_pd(q_acc_5_21,q_tmp_5_21);
                   q_acc_5_22 = _mm256_add_pd(q_acc_5_22,q_tmp_5_22);
                   q_acc_5_23 = _mm256_add_pd(q_acc_5_23,q_tmp_5_23);
                   q_acc_5_24 = _mm256_add_pd(q_acc_5_24,q_tmp_5_24);
                   q_acc_5_25 = _mm256_add_pd(q_acc_5_25,q_tmp_5_25);
                   q_acc_5_26 = _mm256_add_pd(q_acc_5_26,q_tmp_5_26);
                   q_acc_5_27 = _mm256_add_pd(q_acc_5_27,q_tmp_5_27);
                   q_acc_5_28 = _mm256_add_pd(q_acc_5_28,q_tmp_5_28);
                   q_acc_5_29 = _mm256_add_pd(q_acc_5_29,q_tmp_5_29);
                   q_acc_6_6 = _mm256_add_pd(q_acc_6_6,q_tmp_6_6);
                   q_acc_6_7 = _mm256_add_pd(q_acc_6_7,q_tmp_6_7);
                   q_acc_6_8 = _mm256_add_pd(q_acc_6_8,q_tmp_6_8);
                   q_acc_6_9 = _mm256_add_pd(q_acc_6_9,q_tmp_6_9);
                   q_acc_6_10 = _mm256_add_pd(q_acc_6_10,q_tmp_6_10);
                   q_acc_6_11 = _mm256_add_pd(q_acc_6_11,q_tmp_6_11);
                   q_acc_6_12 = _mm256_add_pd(q_acc_6_12,q_tmp_6_12);
                   q_acc_6_13 = _mm256_add_pd(q_acc_6_13,q_tmp_6_13);
                   q_acc_6_14 = _mm256_add_pd(q_acc_6_14,q_tmp_6_14);
                   q_acc_6_15 = _mm256_add_pd(q_acc_6_15,q_tmp_6_15);
                   q_acc_6_16 = _mm256_add_pd(q_acc_6_16,q_tmp_6_16);
                   q_acc_6_17 = _mm256_add_pd(q_acc_6_17,q_tmp_6_17);
                   q_acc_6_18 = _mm256_add_pd(q_acc_6_18,q_tmp_6_18);
                   q_acc_6_19 = _mm256_add_pd(q_acc_6_19,q_tmp_6_19);
                   q_acc_6_20 = _mm256_add_pd(q_acc_6_20,q_tmp_6_20);
                   q_acc_6_21 = _mm256_add_pd(q_acc_6_21,q_tmp_6_21);
                   q_acc_6_22 = _mm256_add_pd(q_acc_6_22,q_tmp_6_22);
                   q_acc_6_23 = _mm256_add_pd(q_acc_6_23,q_tmp_6_23);
                   q_acc_6_24 = _mm256_add_pd(q_acc_6_24,q_tmp_6_24);
                   q_acc_6_25 = _mm256_add_pd(q_acc_6_25,q_tmp_6_25);
                   q_acc_6_26 = _mm256_add_pd(q_acc_6_26,q_tmp_6_26);
                   q_acc_6_27 = _mm256_add_pd(q_acc_6_27,q_tmp_6_27);
                   q_acc_6_28 = _mm256_add_pd(q_acc_6_28,q_tmp_6_28);
                   q_acc_6_29 = _mm256_add_pd(q_acc_6_29,q_tmp_6_29);
                   q_acc_7_7 = _mm256_add_pd(q_acc_7_7,q_tmp_7_7);
                   q_acc_7_8 = _mm256_add_pd(q_acc_7_8,q_tmp_7_8);
                   q_acc_7_9 = _mm256_add_pd(q_acc_7_9,q_tmp_7_9);
                   q_acc_7_10 = _mm256_add_pd(q_acc_7_10,q_tmp_7_10);
                   q_acc_7_11 = _mm256_add_pd(q_acc_7_11,q_tmp_7_11);
                   q_acc_7_12 = _mm256_add_pd(q_acc_7_12,q_tmp_7_12);
                   q_acc_7_13 = _mm256_add_pd(q_acc_7_13,q_tmp_7_13);
                   q_acc_7_14 = _mm256_add_pd(q_acc_7_14,q_tmp_7_14);
                   q_acc_7_15 = _mm256_add_pd(q_acc_7_15,q_tmp_7_15);
                   q_acc_7_16 = _mm256_add_pd(q_acc_7_16,q_tmp_7_16);
                   q_acc_7_17 = _mm256_add_pd(q_acc_7_17,q_tmp_7_17);
                   q_acc_7_18 = _mm256_add_pd(q_acc_7_18,q_tmp_7_18);
                   q_acc_7_19 = _mm256_add_pd(q_acc_7_19,q_tmp_7_19);
                   q_acc_7_20 = _mm256_add_pd(q_acc_7_20,q_tmp_7_20);
                   q_acc_7_21 = _mm256_add_pd(q_acc_7_21,q_tmp_7_21);
                   q_acc_7_22 = _mm256_add_pd(q_acc_7_22,q_tmp_7_22);
                   q_acc_7_23 = _mm256_add_pd(q_acc_7_23,q_tmp_7_23);
                   q_acc_7_24 = _mm256_add_pd(q_acc_7_24,q_tmp_7_24);
                   q_acc_7_25 = _mm256_add_pd(q_acc_7_25,q_tmp_7_25);
                   q_acc_7_26 = _mm256_add_pd(q_acc_7_26,q_tmp_7_26);
                   q_acc_7_27 = _mm256_add_pd(q_acc_7_27,q_tmp_7_27);
                   q_acc_7_28 = _mm256_add_pd(q_acc_7_28,q_tmp_7_28);
                   q_acc_7_29 = _mm256_add_pd(q_acc_7_29,q_tmp_7_29);
                   q_acc_8_8 = _mm256_add_pd(q_acc_8_8,q_tmp_8_8);
                   q_acc_8_9 = _mm256_add_pd(q_acc_8_9,q_tmp_8_9);
                   q_acc_8_10 = _mm256_add_pd(q_acc_8_10,q_tmp_8_10);
                   q_acc_8_11 = _mm256_add_pd(q_acc_8_11,q_tmp_8_11);
                   q_acc_8_12 = _mm256_add_pd(q_acc_8_12,q_tmp_8_12);
                   q_acc_8_13 = _mm256_add_pd(q_acc_8_13,q_tmp_8_13);
                   q_acc_8_14 = _mm256_add_pd(q_acc_8_14,q_tmp_8_14);
                   q_acc_8_15 = _mm256_add_pd(q_acc_8_15,q_tmp_8_15);
                   q_acc_8_16 = _mm256_add_pd(q_acc_8_16,q_tmp_8_16);
                   q_acc_8_17 = _mm256_add_pd(q_acc_8_17,q_tmp_8_17);
                   q_acc_8_18 = _mm256_add_pd(q_acc_8_18,q_tmp_8_18);
                   q_acc_8_19 = _mm256_add_pd(q_acc_8_19,q_tmp_8_19);
                   q_acc_8_20 = _mm256_add_pd(q_acc_8_20,q_tmp_8_20);
                   q_acc_8_21 = _mm256_add_pd(q_acc_8_21,q_tmp_8_21);
                   q_acc_8_22 = _mm256_add_pd(q_acc_8_22,q_tmp_8_22);
                   q_acc_8_23 = _mm256_add_pd(q_acc_8_23,q_tmp_8_23);
                   q_acc_8_24 = _mm256_add_pd(q_acc_8_24,q_tmp_8_24);
                   q_acc_8_25 = _mm256_add_pd(q_acc_8_25,q_tmp_8_25);
                   q_acc_8_26 = _mm256_add_pd(q_acc_8_26,q_tmp_8_26);
                   q_acc_8_27 = _mm256_add_pd(q_acc_8_27,q_tmp_8_27);
                   q_acc_8_28 = _mm256_add_pd(q_acc_8_28,q_tmp_8_28);
                   q_acc_8_29 = _mm256_add_pd(q_acc_8_29,q_tmp_8_29);
                   q_acc_9_9 = _mm256_add_pd(q_acc_9_9,q_tmp_9_9);
                   q_acc_9_10 = _mm256_add_pd(q_acc_9_10,q_tmp_9_10);
                   q_acc_9_11 = _mm256_add_pd(q_acc_9_11,q_tmp_9_11);
                   q_acc_9_12 = _mm256_add_pd(q_acc_9_12,q_tmp_9_12);
                   q_acc_9_13 = _mm256_add_pd(q_acc_9_13,q_tmp_9_13);
                   q_acc_9_14 = _mm256_add_pd(q_acc_9_14,q_tmp_9_14);
                   q_acc_9_15 = _mm256_add_pd(q_acc_9_15,q_tmp_9_15);
                   q_acc_9_16 = _mm256_add_pd(q_acc_9_16,q_tmp_9_16);
                   q_acc_9_17 = _mm256_add_pd(q_acc_9_17,q_tmp_9_17);
                   q_acc_9_18 = _mm256_add_pd(q_acc_9_18,q_tmp_9_18);
                   q_acc_9_19 = _mm256_add_pd(q_acc_9_19,q_tmp_9_19);
                   q_acc_9_20 = _mm256_add_pd(q_acc_9_20,q_tmp_9_20);
                   q_acc_9_21 = _mm256_add_pd(q_acc_9_21,q_tmp_9_21);
                   q_acc_9_22 = _mm256_add_pd(q_acc_9_22,q_tmp_9_22);
                   q_acc_9_23 = _mm256_add_pd(q_acc_9_23,q_tmp_9_23);
                   q_acc_9_24 = _mm256_add_pd(q_acc_9_24,q_tmp_9_24);
                   q_acc_9_25 = _mm256_add_pd(q_acc_9_25,q_tmp_9_25);
                   q_acc_9_26 = _mm256_add_pd(q_acc_9_26,q_tmp_9_26);
                   q_acc_9_27 = _mm256_add_pd(q_acc_9_27,q_tmp_9_27);
                   q_acc_9_28 = _mm256_add_pd(q_acc_9_28,q_tmp_9_28);
                   q_acc_9_29 = _mm256_add_pd(q_acc_9_29,q_tmp_9_29);
                   q_acc_10_10 = _mm256_add_pd(q_acc_10_10,q_tmp_10_10);
                   q_acc_10_11 = _mm256_add_pd(q_acc_10_11,q_tmp_10_11);
                   q_acc_10_12 = _mm256_add_pd(q_acc_10_12,q_tmp_10_12);
                   q_acc_10_13 = _mm256_add_pd(q_acc_10_13,q_tmp_10_13);
                   q_acc_10_14 = _mm256_add_pd(q_acc_10_14,q_tmp_10_14);
                   q_acc_10_15 = _mm256_add_pd(q_acc_10_15,q_tmp_10_15);
                   q_acc_10_16 = _mm256_add_pd(q_acc_10_16,q_tmp_10_16);
                   q_acc_10_17 = _mm256_add_pd(q_acc_10_17,q_tmp_10_17);
                   q_acc_10_18 = _mm256_add_pd(q_acc_10_18,q_tmp_10_18);
                   q_acc_10_19 = _mm256_add_pd(q_acc_10_19,q_tmp_10_19);
                   q_acc_10_20 = _mm256_add_pd(q_acc_10_20,q_tmp_10_20);
                   q_acc_10_21 = _mm256_add_pd(q_acc_10_21,q_tmp_10_21);
                   q_acc_10_22 = _mm256_add_pd(q_acc_10_22,q_tmp_10_22);
                   q_acc_10_23 = _mm256_add_pd(q_acc_10_23,q_tmp_10_23);
                   q_acc_10_24 = _mm256_add_pd(q_acc_10_24,q_tmp_10_24);
                   q_acc_10_25 = _mm256_add_pd(q_acc_10_25,q_tmp_10_25);
                   q_acc_10_26 = _mm256_add_pd(q_acc_10_26,q_tmp_10_26);
                   q_acc_10_27 = _mm256_add_pd(q_acc_10_27,q_tmp_10_27);
                   q_acc_10_28 = _mm256_add_pd(q_acc_10_28,q_tmp_10_28);
                   q_acc_10_29 = _mm256_add_pd(q_acc_10_29,q_tmp_10_29);
                   q_acc_11_11 = _mm256_add_pd(q_acc_11_11,q_tmp_11_11);
                   q_acc_11_12 = _mm256_add_pd(q_acc_11_12,q_tmp_11_12);
                   q_acc_11_13 = _mm256_add_pd(q_acc_11_13,q_tmp_11_13);
                   q_acc_11_14 = _mm256_add_pd(q_acc_11_14,q_tmp_11_14);
                   q_acc_11_15 = _mm256_add_pd(q_acc_11_15,q_tmp_11_15);
                   q_acc_11_16 = _mm256_add_pd(q_acc_11_16,q_tmp_11_16);
                   q_acc_11_17 = _mm256_add_pd(q_acc_11_17,q_tmp_11_17);
                   q_acc_11_18 = _mm256_add_pd(q_acc_11_18,q_tmp_11_18);
                   q_acc_11_19 = _mm256_add_pd(q_acc_11_19,q_tmp_11_19);
                   q_acc_11_20 = _mm256_add_pd(q_acc_11_20,q_tmp_11_20);
                   q_acc_11_21 = _mm256_add_pd(q_acc_11_21,q_tmp_11_21);
                   q_acc_11_22 = _mm256_add_pd(q_acc_11_22,q_tmp_11_22);
                   q_acc_11_23 = _mm256_add_pd(q_acc_11_23,q_tmp_11_23);
                   q_acc_11_24 = _mm256_add_pd(q_acc_11_24,q_tmp_11_24);
                   q_acc_11_25 = _mm256_add_pd(q_acc_11_25,q_tmp_11_25);
                   q_acc_11_26 = _mm256_add_pd(q_acc_11_26,q_tmp_11_26);
                   q_acc_11_27 = _mm256_add_pd(q_acc_11_27,q_tmp_11_27);
                   q_acc_11_28 = _mm256_add_pd(q_acc_11_28,q_tmp_11_28);
                   q_acc_11_29 = _mm256_add_pd(q_acc_11_29,q_tmp_11_29);
                   q_acc_12_12 = _mm256_add_pd(q_acc_12_12,q_tmp_12_12);
                   q_acc_12_13 = _mm256_add_pd(q_acc_12_13,q_tmp_12_13);
                   q_acc_12_14 = _mm256_add_pd(q_acc_12_14,q_tmp_12_14);
                   q_acc_12_15 = _mm256_add_pd(q_acc_12_15,q_tmp_12_15);
                   q_acc_12_16 = _mm256_add_pd(q_acc_12_16,q_tmp_12_16);
                   q_acc_12_17 = _mm256_add_pd(q_acc_12_17,q_tmp_12_17);
                   q_acc_12_18 = _mm256_add_pd(q_acc_12_18,q_tmp_12_18);
                   q_acc_12_19 = _mm256_add_pd(q_acc_12_19,q_tmp_12_19);
                   q_acc_12_20 = _mm256_add_pd(q_acc_12_20,q_tmp_12_20);
                   q_acc_12_21 = _mm256_add_pd(q_acc_12_21,q_tmp_12_21);
                   q_acc_12_22 = _mm256_add_pd(q_acc_12_22,q_tmp_12_22);
                   q_acc_12_23 = _mm256_add_pd(q_acc_12_23,q_tmp_12_23);
                   q_acc_12_24 = _mm256_add_pd(q_acc_12_24,q_tmp_12_24);
                   q_acc_12_25 = _mm256_add_pd(q_acc_12_25,q_tmp_12_25);
                   q_acc_12_26 = _mm256_add_pd(q_acc_12_26,q_tmp_12_26);
                   q_acc_12_27 = _mm256_add_pd(q_acc_12_27,q_tmp_12_27);
                   q_acc_12_28 = _mm256_add_pd(q_acc_12_28,q_tmp_12_28);
                   q_acc_12_29 = _mm256_add_pd(q_acc_12_29,q_tmp_12_29);
                   q_acc_13_13 = _mm256_add_pd(q_acc_13_13,q_tmp_13_13);
                   q_acc_13_14 = _mm256_add_pd(q_acc_13_14,q_tmp_13_14);
                   q_acc_13_15 = _mm256_add_pd(q_acc_13_15,q_tmp_13_15);
                   q_acc_13_16 = _mm256_add_pd(q_acc_13_16,q_tmp_13_16);
                   q_acc_13_17 = _mm256_add_pd(q_acc_13_17,q_tmp_13_17);
                   q_acc_13_18 = _mm256_add_pd(q_acc_13_18,q_tmp_13_18);
                   q_acc_13_19 = _mm256_add_pd(q_acc_13_19,q_tmp_13_19);
                   q_acc_13_20 = _mm256_add_pd(q_acc_13_20,q_tmp_13_20);
                   q_acc_13_21 = _mm256_add_pd(q_acc_13_21,q_tmp_13_21);
                   q_acc_13_22 = _mm256_add_pd(q_acc_13_22,q_tmp_13_22);
                   q_acc_13_23 = _mm256_add_pd(q_acc_13_23,q_tmp_13_23);
                   q_acc_13_24 = _mm256_add_pd(q_acc_13_24,q_tmp_13_24);
                   q_acc_13_25 = _mm256_add_pd(q_acc_13_25,q_tmp_13_25);
                   q_acc_13_26 = _mm256_add_pd(q_acc_13_26,q_tmp_13_26);
                   q_acc_13_27 = _mm256_add_pd(q_acc_13_27,q_tmp_13_27);
                   q_acc_13_28 = _mm256_add_pd(q_acc_13_28,q_tmp_13_28);
                   q_acc_13_29 = _mm256_add_pd(q_acc_13_29,q_tmp_13_29);
                   q_acc_14_14 = _mm256_add_pd(q_acc_14_14,q_tmp_14_14);
                   q_acc_14_15 = _mm256_add_pd(q_acc_14_15,q_tmp_14_15);
                   q_acc_14_16 = _mm256_add_pd(q_acc_14_16,q_tmp_14_16);
                   q_acc_14_17 = _mm256_add_pd(q_acc_14_17,q_tmp_14_17);
                   q_acc_14_18 = _mm256_add_pd(q_acc_14_18,q_tmp_14_18);
                   q_acc_14_19 = _mm256_add_pd(q_acc_14_19,q_tmp_14_19);
                   q_acc_14_20 = _mm256_add_pd(q_acc_14_20,q_tmp_14_20);
                   q_acc_14_21 = _mm256_add_pd(q_acc_14_21,q_tmp_14_21);
                   q_acc_14_22 = _mm256_add_pd(q_acc_14_22,q_tmp_14_22);
                   q_acc_14_23 = _mm256_add_pd(q_acc_14_23,q_tmp_14_23);
                   q_acc_14_24 = _mm256_add_pd(q_acc_14_24,q_tmp_14_24);
                   q_acc_14_25 = _mm256_add_pd(q_acc_14_25,q_tmp_14_25);
                   q_acc_14_26 = _mm256_add_pd(q_acc_14_26,q_tmp_14_26);
                   q_acc_14_27 = _mm256_add_pd(q_acc_14_27,q_tmp_14_27);
                   q_acc_14_28 = _mm256_add_pd(q_acc_14_28,q_tmp_14_28);
                   q_acc_14_29 = _mm256_add_pd(q_acc_14_29,q_tmp_14_29);
                   q_acc_15_15 = _mm256_add_pd(q_acc_15_15,q_tmp_15_15);
                   q_acc_15_16 = _mm256_add_pd(q_acc_15_16,q_tmp_15_16);
                   q_acc_15_17 = _mm256_add_pd(q_acc_15_17,q_tmp_15_17);
                   q_acc_15_18 = _mm256_add_pd(q_acc_15_18,q_tmp_15_18);
                   q_acc_15_19 = _mm256_add_pd(q_acc_15_19,q_tmp_15_19);
                   q_acc_15_20 = _mm256_add_pd(q_acc_15_20,q_tmp_15_20);
                   q_acc_15_21 = _mm256_add_pd(q_acc_15_21,q_tmp_15_21);
                   q_acc_15_22 = _mm256_add_pd(q_acc_15_22,q_tmp_15_22);
                   q_acc_15_23 = _mm256_add_pd(q_acc_15_23,q_tmp_15_23);
                   q_acc_15_24 = _mm256_add_pd(q_acc_15_24,q_tmp_15_24);
                   q_acc_15_25 = _mm256_add_pd(q_acc_15_25,q_tmp_15_25);
                   q_acc_15_26 = _mm256_add_pd(q_acc_15_26,q_tmp_15_26);
                   q_acc_15_27 = _mm256_add_pd(q_acc_15_27,q_tmp_15_27);
                   q_acc_15_28 = _mm256_add_pd(q_acc_15_28,q_tmp_15_28);
                   q_acc_15_29 = _mm256_add_pd(q_acc_15_29,q_tmp_15_29);
                   q_acc_16_16 = _mm256_add_pd(q_acc_16_16,q_tmp_16_16);
                   q_acc_16_17 = _mm256_add_pd(q_acc_16_17,q_tmp_16_17);
                   q_acc_16_18 = _mm256_add_pd(q_acc_16_18,q_tmp_16_18);
                   q_acc_16_19 = _mm256_add_pd(q_acc_16_19,q_tmp_16_19);
                   q_acc_16_20 = _mm256_add_pd(q_acc_16_20,q_tmp_16_20);
                   q_acc_16_21 = _mm256_add_pd(q_acc_16_21,q_tmp_16_21);
                   q_acc_16_22 = _mm256_add_pd(q_acc_16_22,q_tmp_16_22);
                   q_acc_16_23 = _mm256_add_pd(q_acc_16_23,q_tmp_16_23);
                   q_acc_16_24 = _mm256_add_pd(q_acc_16_24,q_tmp_16_24);
                   q_acc_16_25 = _mm256_add_pd(q_acc_16_25,q_tmp_16_25);
                   q_acc_16_26 = _mm256_add_pd(q_acc_16_26,q_tmp_16_26);
                   q_acc_16_27 = _mm256_add_pd(q_acc_16_27,q_tmp_16_27);
                   q_acc_16_28 = _mm256_add_pd(q_acc_16_28,q_tmp_16_28);
                   q_acc_16_29 = _mm256_add_pd(q_acc_16_29,q_tmp_16_29);
                   q_acc_17_17 = _mm256_add_pd(q_acc_17_17,q_tmp_17_17);
                   q_acc_17_18 = _mm256_add_pd(q_acc_17_18,q_tmp_17_18);
                   q_acc_17_19 = _mm256_add_pd(q_acc_17_19,q_tmp_17_19);
                   q_acc_17_20 = _mm256_add_pd(q_acc_17_20,q_tmp_17_20);
                   q_acc_17_21 = _mm256_add_pd(q_acc_17_21,q_tmp_17_21);
                   q_acc_17_22 = _mm256_add_pd(q_acc_17_22,q_tmp_17_22);
                   q_acc_17_23 = _mm256_add_pd(q_acc_17_23,q_tmp_17_23);
                   q_acc_17_24 = _mm256_add_pd(q_acc_17_24,q_tmp_17_24);
                   q_acc_17_25 = _mm256_add_pd(q_acc_17_25,q_tmp_17_25);
                   q_acc_17_26 = _mm256_add_pd(q_acc_17_26,q_tmp_17_26);
                   q_acc_17_27 = _mm256_add_pd(q_acc_17_27,q_tmp_17_27);
                   q_acc_17_28 = _mm256_add_pd(q_acc_17_28,q_tmp_17_28);
                   q_acc_17_29 = _mm256_add_pd(q_acc_17_29,q_tmp_17_29);
                   q_acc_18_18 = _mm256_add_pd(q_acc_18_18,q_tmp_18_18);
                   q_acc_18_19 = _mm256_add_pd(q_acc_18_19,q_tmp_18_19);
                   q_acc_18_20 = _mm256_add_pd(q_acc_18_20,q_tmp_18_20);
                   q_acc_18_21 = _mm256_add_pd(q_acc_18_21,q_tmp_18_21);
                   q_acc_18_22 = _mm256_add_pd(q_acc_18_22,q_tmp_18_22);
                   q_acc_18_23 = _mm256_add_pd(q_acc_18_23,q_tmp_18_23);
                   q_acc_18_24 = _mm256_add_pd(q_acc_18_24,q_tmp_18_24);
                   q_acc_18_25 = _mm256_add_pd(q_acc_18_25,q_tmp_18_25);
                   q_acc_18_26 = _mm256_add_pd(q_acc_18_26,q_tmp_18_26);
                   q_acc_18_27 = _mm256_add_pd(q_acc_18_27,q_tmp_18_27);
                   q_acc_18_28 = _mm256_add_pd(q_acc_18_28,q_tmp_18_28);
                   q_acc_18_29 = _mm256_add_pd(q_acc_18_29,q_tmp_18_29);
                   q_acc_19_19 = _mm256_add_pd(q_acc_19_19,q_tmp_19_19);
                   q_acc_19_20 = _mm256_add_pd(q_acc_19_20,q_tmp_19_20);
                   q_acc_19_21 = _mm256_add_pd(q_acc_19_21,q_tmp_19_21);
                   q_acc_19_22 = _mm256_add_pd(q_acc_19_22,q_tmp_19_22);
                   q_acc_19_23 = _mm256_add_pd(q_acc_19_23,q_tmp_19_23);
                   q_acc_19_24 = _mm256_add_pd(q_acc_19_24,q_tmp_19_24);
                   q_acc_19_25 = _mm256_add_pd(q_acc_19_25,q_tmp_19_25);
                   q_acc_19_26 = _mm256_add_pd(q_acc_19_26,q_tmp_19_26);
                   q_acc_19_27 = _mm256_add_pd(q_acc_19_27,q_tmp_19_27);
                   q_acc_19_28 = _mm256_add_pd(q_acc_19_28,q_tmp_19_28);
                   q_acc_19_29 = _mm256_add_pd(q_acc_19_29,q_tmp_19_29);
                   q_acc_20_20 = _mm256_add_pd(q_acc_20_20,q_tmp_20_20);
                   q_acc_20_21 = _mm256_add_pd(q_acc_20_21,q_tmp_20_21);
                   q_acc_20_22 = _mm256_add_pd(q_acc_20_22,q_tmp_20_22);
                   q_acc_20_23 = _mm256_add_pd(q_acc_20_23,q_tmp_20_23);
                   q_acc_20_24 = _mm256_add_pd(q_acc_20_24,q_tmp_20_24);
                   q_acc_20_25 = _mm256_add_pd(q_acc_20_25,q_tmp_20_25);
                   q_acc_20_26 = _mm256_add_pd(q_acc_20_26,q_tmp_20_26);
                   q_acc_20_27 = _mm256_add_pd(q_acc_20_27,q_tmp_20_27);
                   q_acc_20_28 = _mm256_add_pd(q_acc_20_28,q_tmp_20_28);
                   q_acc_20_29 = _mm256_add_pd(q_acc_20_29,q_tmp_20_29);
                   q_acc_21_21 = _mm256_add_pd(q_acc_21_21,q_tmp_21_21);
                   q_acc_21_22 = _mm256_add_pd(q_acc_21_22,q_tmp_21_22);
                   q_acc_21_23 = _mm256_add_pd(q_acc_21_23,q_tmp_21_23);
                   q_acc_21_24 = _mm256_add_pd(q_acc_21_24,q_tmp_21_24);
                   q_acc_21_25 = _mm256_add_pd(q_acc_21_25,q_tmp_21_25);
                   q_acc_21_26 = _mm256_add_pd(q_acc_21_26,q_tmp_21_26);
                   q_acc_21_27 = _mm256_add_pd(q_acc_21_27,q_tmp_21_27);
                   q_acc_21_28 = _mm256_add_pd(q_acc_21_28,q_tmp_21_28);
                   q_acc_21_29 = _mm256_add_pd(q_acc_21_29,q_tmp_21_29);
                   q_acc_22_22 = _mm256_add_pd(q_acc_22_22,q_tmp_22_22);
                   q_acc_22_23 = _mm256_add_pd(q_acc_22_23,q_tmp_22_23);
                   q_acc_22_24 = _mm256_add_pd(q_acc_22_24,q_tmp_22_24);
                   q_acc_22_25 = _mm256_add_pd(q_acc_22_25,q_tmp_22_25);
                   q_acc_22_26 = _mm256_add_pd(q_acc_22_26,q_tmp_22_26);
                   q_acc_22_27 = _mm256_add_pd(q_acc_22_27,q_tmp_22_27);
                   q_acc_22_28 = _mm256_add_pd(q_acc_22_28,q_tmp_22_28);
                   q_acc_22_29 = _mm256_add_pd(q_acc_22_29,q_tmp_22_29);
                   q_acc_23_23 = _mm256_add_pd(q_acc_23_23,q_tmp_23_23);
                   q_acc_23_24 = _mm256_add_pd(q_acc_23_24,q_tmp_23_24);
                   q_acc_23_25 = _mm256_add_pd(q_acc_23_25,q_tmp_23_25);
                   q_acc_23_26 = _mm256_add_pd(q_acc_23_26,q_tmp_23_26);
                   q_acc_23_27 = _mm256_add_pd(q_acc_23_27,q_tmp_23_27);
                   q_acc_23_28 = _mm256_add_pd(q_acc_23_28,q_tmp_23_28);
                   q_acc_23_29 = _mm256_add_pd(q_acc_23_29,q_tmp_23_29);
                   q_acc_24_24 = _mm256_add_pd(q_acc_24_24,q_tmp_24_24);
                   q_acc_24_25 = _mm256_add_pd(q_acc_24_25,q_tmp_24_25);
                   q_acc_24_26 = _mm256_add_pd(q_acc_24_26,q_tmp_24_26);
                   q_acc_24_27 = _mm256_add_pd(q_acc_24_27,q_tmp_24_27);
                   q_acc_24_28 = _mm256_add_pd(q_acc_24_28,q_tmp_24_28);
                   q_acc_24_29 = _mm256_add_pd(q_acc_24_29,q_tmp_24_29);
                   q_acc_25_25 = _mm256_add_pd(q_acc_25_25,q_tmp_25_25);
                   q_acc_25_26 = _mm256_add_pd(q_acc_25_26,q_tmp_25_26);
                   q_acc_25_27 = _mm256_add_pd(q_acc_25_27,q_tmp_25_27);
                   q_acc_25_28 = _mm256_add_pd(q_acc_25_28,q_tmp_25_28);
                   q_acc_25_29 = _mm256_add_pd(q_acc_25_29,q_tmp_25_29);
                   q_acc_26_26 = _mm256_add_pd(q_acc_26_26,q_tmp_26_26);
                   q_acc_26_27 = _mm256_add_pd(q_acc_26_27,q_tmp_26_27);
                   q_acc_26_28 = _mm256_add_pd(q_acc_26_28,q_tmp_26_28);
                   q_acc_26_29 = _mm256_add_pd(q_acc_26_29,q_tmp_26_29);
                   q_acc_27_27 = _mm256_add_pd(q_acc_27_27,q_tmp_27_27);
                   q_acc_27_28 = _mm256_add_pd(q_acc_27_28,q_tmp_27_28);
                   q_acc_27_29 = _mm256_add_pd(q_acc_27_29,q_tmp_27_29);
                   q_acc_28_28 = _mm256_add_pd(q_acc_28_28,q_tmp_28_28);
                   q_acc_28_29 = _mm256_add_pd(q_acc_28_29,q_tmp_28_29);
                   q_acc_29_29 = _mm256_add_pd(q_acc_29_29,q_tmp_29_29);
                }
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_0,src_dof_0),_mm256_mul_pd(q_acc_0_1,src_dof_1)),_mm256_mul_pd(q_acc_0_10,src_dof_10)),_mm256_mul_pd(q_acc_0_11,src_dof_11)),_mm256_mul_pd(q_acc_0_12,src_dof_12)),_mm256_mul_pd(q_acc_0_13,src_dof_13)),_mm256_mul_pd(q_acc_0_14,src_dof_14)),_mm256_mul_pd(q_acc_0_15,src_dof_15)),_mm256_mul_pd(q_acc_0_16,src_dof_16)),_mm256_mul_pd(q_acc_0_17,src_dof_17)),_mm256_mul_pd(q_acc_0_18,src_dof_18)),_mm256_mul_pd(q_acc_0_19,src_dof_19)),_mm256_mul_pd(q_acc_0_2,src_dof_2)),_mm256_mul_pd(q_acc_0_20,src_dof_20)),_mm256_mul_pd(q_acc_0_21,src_dof_21)),_mm256_mul_pd(q_acc_0_22,src_dof_22)),_mm256_mul_pd(q_acc_0_23,src_dof_23)),_mm256_mul_pd(q_acc_0_24,src_dof_24)),_mm256_mul_pd(q_acc_0_25,src_dof_25)),_mm256_mul_pd(q_acc_0_26,src_dof_26)),_mm256_mul_pd(q_acc_0_27,src_dof_27)),_mm256_mul_pd(q_acc_0_28,src_dof_28)),_mm256_mul_pd(q_acc_0_29,src_dof_29)),_mm256_mul_pd(q_acc_0_3,src_dof_3)),_mm256_mul_pd(q_acc_0_4,src_dof_4)),_mm256_mul_pd(q_acc_0_5,src_dof_5)),_mm256_mul_pd(q_acc_0_6,src_dof_6)),_mm256_mul_pd(q_acc_0_7,src_dof_7)),_mm256_mul_pd(q_acc_0_8,src_dof_8)),_mm256_mul_pd(q_acc_0_9,src_dof_9));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_1,src_dof_0),_mm256_mul_pd(q_acc_1_1,src_dof_1)),_mm256_mul_pd(q_acc_1_10,src_dof_10)),_mm256_mul_pd(q_acc_1_11,src_dof_11)),_mm256_mul_pd(q_acc_1_12,src_dof_12)),_mm256_mul_pd(q_acc_1_13,src_dof_13)),_mm256_mul_pd(q_acc_1_14,src_dof_14)),_mm256_mul_pd(q_acc_1_15,src_dof_15)),_mm256_mul_pd(q_acc_1_16,src_dof_16)),_mm256_mul_pd(q_acc_1_17,src_dof_17)),_mm256_mul_pd(q_acc_1_18,src_dof_18)),_mm256_mul_pd(q_acc_1_19,src_dof_19)),_mm256_mul_pd(q_acc_1_2,src_dof_2)),_mm256_mul_pd(q_acc_1_20,src_dof_20)),_mm256_mul_pd(q_acc_1_21,src_dof_21)),_mm256_mul_pd(q_acc_1_22,src_dof_22)),_mm256_mul_pd(q_acc_1_23,src_dof_23)),_mm256_mul_pd(q_acc_1_24,src_dof_24)),_mm256_mul_pd(q_acc_1_25,src_dof_25)),_mm256_mul_pd(q_acc_1_26,src_dof_26)),_mm256_mul_pd(q_acc_1_27,src_dof_27)),_mm256_mul_pd(q_acc_1_28,src_dof_28)),_mm256_mul_pd(q_acc_1_29,src_dof_29)),_mm256_mul_pd(q_acc_1_3,src_dof_3)),_mm256_mul_pd(q_acc_1_4,src_dof_4)),_mm256_mul_pd(q_acc_1_5,src_dof_5)),_mm256_mul_pd(q_acc_1_6,src_dof_6)),_mm256_mul_pd(q_acc_1_7,src_dof_7)),_mm256_mul_pd(q_acc_1_8,src_dof_8)),_mm256_mul_pd(q_acc_1_9,src_dof_9));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_2,src_dof_0),_mm256_mul_pd(q_acc_1_2,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_10)),_mm256_mul_pd(q_acc_2_11,src_dof_11)),_mm256_mul_pd(q_acc_2_12,src_dof_12)),_mm256_mul_pd(q_acc_2_13,src_dof_13)),_mm256_mul_pd(q_acc_2_14,src_dof_14)),_mm256_mul_pd(q_acc_2_15,src_dof_15)),_mm256_mul_pd(q_acc_2_16,src_dof_16)),_mm256_mul_pd(q_acc_2_17,src_dof_17)),_mm256_mul_pd(q_acc_2_18,src_dof_18)),_mm256_mul_pd(q_acc_2_19,src_dof_19)),_mm256_mul_pd(q_acc_2_2,src_dof_2)),_mm256_mul_pd(q_acc_2_20,src_dof_20)),_mm256_mul_pd(q_acc_2_21,src_dof_21)),_mm256_mul_pd(q_acc_2_22,src_dof_22)),_mm256_mul_pd(q_acc_2_23,src_dof_23)),_mm256_mul_pd(q_acc_2_24,src_dof_24)),_mm256_mul_pd(q_acc_2_25,src_dof_25)),_mm256_mul_pd(q_acc_2_26,src_dof_26)),_mm256_mul_pd(q_acc_2_27,src_dof_27)),_mm256_mul_pd(q_acc_2_28,src_dof_28)),_mm256_mul_pd(q_acc_2_29,src_dof_29)),_mm256_mul_pd(q_acc_2_3,src_dof_3)),_mm256_mul_pd(q_acc_2_4,src_dof_4)),_mm256_mul_pd(q_acc_2_5,src_dof_5)),_mm256_mul_pd(q_acc_2_6,src_dof_6)),_mm256_mul_pd(q_acc_2_7,src_dof_7)),_mm256_mul_pd(q_acc_2_8,src_dof_8)),_mm256_mul_pd(q_acc_2_9,src_dof_9));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_3,src_dof_0),_mm256_mul_pd(q_acc_1_3,src_dof_1)),_mm256_mul_pd(q_acc_2_3,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_10)),_mm256_mul_pd(q_acc_3_11,src_dof_11)),_mm256_mul_pd(q_acc_3_12,src_dof_12)),_mm256_mul_pd(q_acc_3_13,src_dof_13)),_mm256_mul_pd(q_acc_3_14,src_dof_14)),_mm256_mul_pd(q_acc_3_15,src_dof_15)),_mm256_mul_pd(q_acc_3_16,src_dof_16)),_mm256_mul_pd(q_acc_3_17,src_dof_17)),_mm256_mul_pd(q_acc_3_18,src_dof_18)),_mm256_mul_pd(q_acc_3_19,src_dof_19)),_mm256_mul_pd(q_acc_3_20,src_dof_20)),_mm256_mul_pd(q_acc_3_21,src_dof_21)),_mm256_mul_pd(q_acc_3_22,src_dof_22)),_mm256_mul_pd(q_acc_3_23,src_dof_23)),_mm256_mul_pd(q_acc_3_24,src_dof_24)),_mm256_mul_pd(q_acc_3_25,src_dof_25)),_mm256_mul_pd(q_acc_3_26,src_dof_26)),_mm256_mul_pd(q_acc_3_27,src_dof_27)),_mm256_mul_pd(q_acc_3_28,src_dof_28)),_mm256_mul_pd(q_acc_3_29,src_dof_29)),_mm256_mul_pd(q_acc_3_3,src_dof_3)),_mm256_mul_pd(q_acc_3_4,src_dof_4)),_mm256_mul_pd(q_acc_3_5,src_dof_5)),_mm256_mul_pd(q_acc_3_6,src_dof_6)),_mm256_mul_pd(q_acc_3_7,src_dof_7)),_mm256_mul_pd(q_acc_3_8,src_dof_8)),_mm256_mul_pd(q_acc_3_9,src_dof_9));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_4,src_dof_0),_mm256_mul_pd(q_acc_1_4,src_dof_1)),_mm256_mul_pd(q_acc_2_4,src_dof_2)),_mm256_mul_pd(q_acc_3_4,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_10)),_mm256_mul_pd(q_acc_4_11,src_dof_11)),_mm256_mul_pd(q_acc_4_12,src_dof_12)),_mm256_mul_pd(q_acc_4_13,src_dof_13)),_mm256_mul_pd(q_acc_4_14,src_dof_14)),_mm256_mul_pd(q_acc_4_15,src_dof_15)),_mm256_mul_pd(q_acc_4_16,src_dof_16)),_mm256_mul_pd(q_acc_4_17,src_dof_17)),_mm256_mul_pd(q_acc_4_18,src_dof_18)),_mm256_mul_pd(q_acc_4_19,src_dof_19)),_mm256_mul_pd(q_acc_4_20,src_dof_20)),_mm256_mul_pd(q_acc_4_21,src_dof_21)),_mm256_mul_pd(q_acc_4_22,src_dof_22)),_mm256_mul_pd(q_acc_4_23,src_dof_23)),_mm256_mul_pd(q_acc_4_24,src_dof_24)),_mm256_mul_pd(q_acc_4_25,src_dof_25)),_mm256_mul_pd(q_acc_4_26,src_dof_26)),_mm256_mul_pd(q_acc_4_27,src_dof_27)),_mm256_mul_pd(q_acc_4_28,src_dof_28)),_mm256_mul_pd(q_acc_4_29,src_dof_29)),_mm256_mul_pd(q_acc_4_4,src_dof_4)),_mm256_mul_pd(q_acc_4_5,src_dof_5)),_mm256_mul_pd(q_acc_4_6,src_dof_6)),_mm256_mul_pd(q_acc_4_7,src_dof_7)),_mm256_mul_pd(q_acc_4_8,src_dof_8)),_mm256_mul_pd(q_acc_4_9,src_dof_9));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_5,src_dof_0),_mm256_mul_pd(q_acc_1_5,src_dof_1)),_mm256_mul_pd(q_acc_2_5,src_dof_2)),_mm256_mul_pd(q_acc_3_5,src_dof_3)),_mm256_mul_pd(q_acc_4_5,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_10)),_mm256_mul_pd(q_acc_5_11,src_dof_11)),_mm256_mul_pd(q_acc_5_12,src_dof_12)),_mm256_mul_pd(q_acc_5_13,src_dof_13)),_mm256_mul_pd(q_acc_5_14,src_dof_14)),_mm256_mul_pd(q_acc_5_15,src_dof_15)),_mm256_mul_pd(q_acc_5_16,src_dof_16)),_mm256_mul_pd(q_acc_5_17,src_dof_17)),_mm256_mul_pd(q_acc_5_18,src_dof_18)),_mm256_mul_pd(q_acc_5_19,src_dof_19)),_mm256_mul_pd(q_acc_5_20,src_dof_20)),_mm256_mul_pd(q_acc_5_21,src_dof_21)),_mm256_mul_pd(q_acc_5_22,src_dof_22)),_mm256_mul_pd(q_acc_5_23,src_dof_23)),_mm256_mul_pd(q_acc_5_24,src_dof_24)),_mm256_mul_pd(q_acc_5_25,src_dof_25)),_mm256_mul_pd(q_acc_5_26,src_dof_26)),_mm256_mul_pd(q_acc_5_27,src_dof_27)),_mm256_mul_pd(q_acc_5_28,src_dof_28)),_mm256_mul_pd(q_acc_5_29,src_dof_29)),_mm256_mul_pd(q_acc_5_5,src_dof_5)),_mm256_mul_pd(q_acc_5_6,src_dof_6)),_mm256_mul_pd(q_acc_5_7,src_dof_7)),_mm256_mul_pd(q_acc_5_8,src_dof_8)),_mm256_mul_pd(q_acc_5_9,src_dof_9));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_6,src_dof_0),_mm256_mul_pd(q_acc_1_6,src_dof_1)),_mm256_mul_pd(q_acc_2_6,src_dof_2)),_mm256_mul_pd(q_acc_3_6,src_dof_3)),_mm256_mul_pd(q_acc_4_6,src_dof_4)),_mm256_mul_pd(q_acc_5_6,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_10)),_mm256_mul_pd(q_acc_6_11,src_dof_11)),_mm256_mul_pd(q_acc_6_12,src_dof_12)),_mm256_mul_pd(q_acc_6_13,src_dof_13)),_mm256_mul_pd(q_acc_6_14,src_dof_14)),_mm256_mul_pd(q_acc_6_15,src_dof_15)),_mm256_mul_pd(q_acc_6_16,src_dof_16)),_mm256_mul_pd(q_acc_6_17,src_dof_17)),_mm256_mul_pd(q_acc_6_18,src_dof_18)),_mm256_mul_pd(q_acc_6_19,src_dof_19)),_mm256_mul_pd(q_acc_6_20,src_dof_20)),_mm256_mul_pd(q_acc_6_21,src_dof_21)),_mm256_mul_pd(q_acc_6_22,src_dof_22)),_mm256_mul_pd(q_acc_6_23,src_dof_23)),_mm256_mul_pd(q_acc_6_24,src_dof_24)),_mm256_mul_pd(q_acc_6_25,src_dof_25)),_mm256_mul_pd(q_acc_6_26,src_dof_26)),_mm256_mul_pd(q_acc_6_27,src_dof_27)),_mm256_mul_pd(q_acc_6_28,src_dof_28)),_mm256_mul_pd(q_acc_6_29,src_dof_29)),_mm256_mul_pd(q_acc_6_6,src_dof_6)),_mm256_mul_pd(q_acc_6_7,src_dof_7)),_mm256_mul_pd(q_acc_6_8,src_dof_8)),_mm256_mul_pd(q_acc_6_9,src_dof_9));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_7,src_dof_0),_mm256_mul_pd(q_acc_1_7,src_dof_1)),_mm256_mul_pd(q_acc_2_7,src_dof_2)),_mm256_mul_pd(q_acc_3_7,src_dof_3)),_mm256_mul_pd(q_acc_4_7,src_dof_4)),_mm256_mul_pd(q_acc_5_7,src_dof_5)),_mm256_mul_pd(q_acc_6_7,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_10)),_mm256_mul_pd(q_acc_7_11,src_dof_11)),_mm256_mul_pd(q_acc_7_12,src_dof_12)),_mm256_mul_pd(q_acc_7_13,src_dof_13)),_mm256_mul_pd(q_acc_7_14,src_dof_14)),_mm256_mul_pd(q_acc_7_15,src_dof_15)),_mm256_mul_pd(q_acc_7_16,src_dof_16)),_mm256_mul_pd(q_acc_7_17,src_dof_17)),_mm256_mul_pd(q_acc_7_18,src_dof_18)),_mm256_mul_pd(q_acc_7_19,src_dof_19)),_mm256_mul_pd(q_acc_7_20,src_dof_20)),_mm256_mul_pd(q_acc_7_21,src_dof_21)),_mm256_mul_pd(q_acc_7_22,src_dof_22)),_mm256_mul_pd(q_acc_7_23,src_dof_23)),_mm256_mul_pd(q_acc_7_24,src_dof_24)),_mm256_mul_pd(q_acc_7_25,src_dof_25)),_mm256_mul_pd(q_acc_7_26,src_dof_26)),_mm256_mul_pd(q_acc_7_27,src_dof_27)),_mm256_mul_pd(q_acc_7_28,src_dof_28)),_mm256_mul_pd(q_acc_7_29,src_dof_29)),_mm256_mul_pd(q_acc_7_7,src_dof_7)),_mm256_mul_pd(q_acc_7_8,src_dof_8)),_mm256_mul_pd(q_acc_7_9,src_dof_9));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_8,src_dof_0),_mm256_mul_pd(q_acc_1_8,src_dof_1)),_mm256_mul_pd(q_acc_2_8,src_dof_2)),_mm256_mul_pd(q_acc_3_8,src_dof_3)),_mm256_mul_pd(q_acc_4_8,src_dof_4)),_mm256_mul_pd(q_acc_5_8,src_dof_5)),_mm256_mul_pd(q_acc_6_8,src_dof_6)),_mm256_mul_pd(q_acc_7_8,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_10)),_mm256_mul_pd(q_acc_8_11,src_dof_11)),_mm256_mul_pd(q_acc_8_12,src_dof_12)),_mm256_mul_pd(q_acc_8_13,src_dof_13)),_mm256_mul_pd(q_acc_8_14,src_dof_14)),_mm256_mul_pd(q_acc_8_15,src_dof_15)),_mm256_mul_pd(q_acc_8_16,src_dof_16)),_mm256_mul_pd(q_acc_8_17,src_dof_17)),_mm256_mul_pd(q_acc_8_18,src_dof_18)),_mm256_mul_pd(q_acc_8_19,src_dof_19)),_mm256_mul_pd(q_acc_8_20,src_dof_20)),_mm256_mul_pd(q_acc_8_21,src_dof_21)),_mm256_mul_pd(q_acc_8_22,src_dof_22)),_mm256_mul_pd(q_acc_8_23,src_dof_23)),_mm256_mul_pd(q_acc_8_24,src_dof_24)),_mm256_mul_pd(q_acc_8_25,src_dof_25)),_mm256_mul_pd(q_acc_8_26,src_dof_26)),_mm256_mul_pd(q_acc_8_27,src_dof_27)),_mm256_mul_pd(q_acc_8_28,src_dof_28)),_mm256_mul_pd(q_acc_8_29,src_dof_29)),_mm256_mul_pd(q_acc_8_8,src_dof_8)),_mm256_mul_pd(q_acc_8_9,src_dof_9));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_9,src_dof_0),_mm256_mul_pd(q_acc_1_9,src_dof_1)),_mm256_mul_pd(q_acc_2_9,src_dof_2)),_mm256_mul_pd(q_acc_3_9,src_dof_3)),_mm256_mul_pd(q_acc_4_9,src_dof_4)),_mm256_mul_pd(q_acc_5_9,src_dof_5)),_mm256_mul_pd(q_acc_6_9,src_dof_6)),_mm256_mul_pd(q_acc_7_9,src_dof_7)),_mm256_mul_pd(q_acc_8_9,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_10)),_mm256_mul_pd(q_acc_9_11,src_dof_11)),_mm256_mul_pd(q_acc_9_12,src_dof_12)),_mm256_mul_pd(q_acc_9_13,src_dof_13)),_mm256_mul_pd(q_acc_9_14,src_dof_14)),_mm256_mul_pd(q_acc_9_15,src_dof_15)),_mm256_mul_pd(q_acc_9_16,src_dof_16)),_mm256_mul_pd(q_acc_9_17,src_dof_17)),_mm256_mul_pd(q_acc_9_18,src_dof_18)),_mm256_mul_pd(q_acc_9_19,src_dof_19)),_mm256_mul_pd(q_acc_9_20,src_dof_20)),_mm256_mul_pd(q_acc_9_21,src_dof_21)),_mm256_mul_pd(q_acc_9_22,src_dof_22)),_mm256_mul_pd(q_acc_9_23,src_dof_23)),_mm256_mul_pd(q_acc_9_24,src_dof_24)),_mm256_mul_pd(q_acc_9_25,src_dof_25)),_mm256_mul_pd(q_acc_9_26,src_dof_26)),_mm256_mul_pd(q_acc_9_27,src_dof_27)),_mm256_mul_pd(q_acc_9_28,src_dof_28)),_mm256_mul_pd(q_acc_9_29,src_dof_29)),_mm256_mul_pd(q_acc_9_9,src_dof_9));
                const __m256d elMatVec_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_10,src_dof_0),_mm256_mul_pd(q_acc_10_10,src_dof_10)),_mm256_mul_pd(q_acc_10_11,src_dof_11)),_mm256_mul_pd(q_acc_10_12,src_dof_12)),_mm256_mul_pd(q_acc_10_13,src_dof_13)),_mm256_mul_pd(q_acc_10_14,src_dof_14)),_mm256_mul_pd(q_acc_10_15,src_dof_15)),_mm256_mul_pd(q_acc_10_16,src_dof_16)),_mm256_mul_pd(q_acc_10_17,src_dof_17)),_mm256_mul_pd(q_acc_10_18,src_dof_18)),_mm256_mul_pd(q_acc_10_19,src_dof_19)),_mm256_mul_pd(q_acc_10_20,src_dof_20)),_mm256_mul_pd(q_acc_10_21,src_dof_21)),_mm256_mul_pd(q_acc_10_22,src_dof_22)),_mm256_mul_pd(q_acc_10_23,src_dof_23)),_mm256_mul_pd(q_acc_10_24,src_dof_24)),_mm256_mul_pd(q_acc_10_25,src_dof_25)),_mm256_mul_pd(q_acc_10_26,src_dof_26)),_mm256_mul_pd(q_acc_10_27,src_dof_27)),_mm256_mul_pd(q_acc_10_28,src_dof_28)),_mm256_mul_pd(q_acc_10_29,src_dof_29)),_mm256_mul_pd(q_acc_1_10,src_dof_1)),_mm256_mul_pd(q_acc_2_10,src_dof_2)),_mm256_mul_pd(q_acc_3_10,src_dof_3)),_mm256_mul_pd(q_acc_4_10,src_dof_4)),_mm256_mul_pd(q_acc_5_10,src_dof_5)),_mm256_mul_pd(q_acc_6_10,src_dof_6)),_mm256_mul_pd(q_acc_7_10,src_dof_7)),_mm256_mul_pd(q_acc_8_10,src_dof_8)),_mm256_mul_pd(q_acc_9_10,src_dof_9));
                const __m256d elMatVec_11 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_11,src_dof_0),_mm256_mul_pd(q_acc_10_11,src_dof_10)),_mm256_mul_pd(q_acc_11_11,src_dof_11)),_mm256_mul_pd(q_acc_11_12,src_dof_12)),_mm256_mul_pd(q_acc_11_13,src_dof_13)),_mm256_mul_pd(q_acc_11_14,src_dof_14)),_mm256_mul_pd(q_acc_11_15,src_dof_15)),_mm256_mul_pd(q_acc_11_16,src_dof_16)),_mm256_mul_pd(q_acc_11_17,src_dof_17)),_mm256_mul_pd(q_acc_11_18,src_dof_18)),_mm256_mul_pd(q_acc_11_19,src_dof_19)),_mm256_mul_pd(q_acc_11_20,src_dof_20)),_mm256_mul_pd(q_acc_11_21,src_dof_21)),_mm256_mul_pd(q_acc_11_22,src_dof_22)),_mm256_mul_pd(q_acc_11_23,src_dof_23)),_mm256_mul_pd(q_acc_11_24,src_dof_24)),_mm256_mul_pd(q_acc_11_25,src_dof_25)),_mm256_mul_pd(q_acc_11_26,src_dof_26)),_mm256_mul_pd(q_acc_11_27,src_dof_27)),_mm256_mul_pd(q_acc_11_28,src_dof_28)),_mm256_mul_pd(q_acc_11_29,src_dof_29)),_mm256_mul_pd(q_acc_1_11,src_dof_1)),_mm256_mul_pd(q_acc_2_11,src_dof_2)),_mm256_mul_pd(q_acc_3_11,src_dof_3)),_mm256_mul_pd(q_acc_4_11,src_dof_4)),_mm256_mul_pd(q_acc_5_11,src_dof_5)),_mm256_mul_pd(q_acc_6_11,src_dof_6)),_mm256_mul_pd(q_acc_7_11,src_dof_7)),_mm256_mul_pd(q_acc_8_11,src_dof_8)),_mm256_mul_pd(q_acc_9_11,src_dof_9));
                const __m256d elMatVec_12 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_12,src_dof_0),_mm256_mul_pd(q_acc_10_12,src_dof_10)),_mm256_mul_pd(q_acc_11_12,src_dof_11)),_mm256_mul_pd(q_acc_12_12,src_dof_12)),_mm256_mul_pd(q_acc_12_13,src_dof_13)),_mm256_mul_pd(q_acc_12_14,src_dof_14)),_mm256_mul_pd(q_acc_12_15,src_dof_15)),_mm256_mul_pd(q_acc_12_16,src_dof_16)),_mm256_mul_pd(q_acc_12_17,src_dof_17)),_mm256_mul_pd(q_acc_12_18,src_dof_18)),_mm256_mul_pd(q_acc_12_19,src_dof_19)),_mm256_mul_pd(q_acc_12_20,src_dof_20)),_mm256_mul_pd(q_acc_12_21,src_dof_21)),_mm256_mul_pd(q_acc_12_22,src_dof_22)),_mm256_mul_pd(q_acc_12_23,src_dof_23)),_mm256_mul_pd(q_acc_12_24,src_dof_24)),_mm256_mul_pd(q_acc_12_25,src_dof_25)),_mm256_mul_pd(q_acc_12_26,src_dof_26)),_mm256_mul_pd(q_acc_12_27,src_dof_27)),_mm256_mul_pd(q_acc_12_28,src_dof_28)),_mm256_mul_pd(q_acc_12_29,src_dof_29)),_mm256_mul_pd(q_acc_1_12,src_dof_1)),_mm256_mul_pd(q_acc_2_12,src_dof_2)),_mm256_mul_pd(q_acc_3_12,src_dof_3)),_mm256_mul_pd(q_acc_4_12,src_dof_4)),_mm256_mul_pd(q_acc_5_12,src_dof_5)),_mm256_mul_pd(q_acc_6_12,src_dof_6)),_mm256_mul_pd(q_acc_7_12,src_dof_7)),_mm256_mul_pd(q_acc_8_12,src_dof_8)),_mm256_mul_pd(q_acc_9_12,src_dof_9));
                const __m256d elMatVec_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_13,src_dof_0),_mm256_mul_pd(q_acc_10_13,src_dof_10)),_mm256_mul_pd(q_acc_11_13,src_dof_11)),_mm256_mul_pd(q_acc_12_13,src_dof_12)),_mm256_mul_pd(q_acc_13_13,src_dof_13)),_mm256_mul_pd(q_acc_13_14,src_dof_14)),_mm256_mul_pd(q_acc_13_15,src_dof_15)),_mm256_mul_pd(q_acc_13_16,src_dof_16)),_mm256_mul_pd(q_acc_13_17,src_dof_17)),_mm256_mul_pd(q_acc_13_18,src_dof_18)),_mm256_mul_pd(q_acc_13_19,src_dof_19)),_mm256_mul_pd(q_acc_13_20,src_dof_20)),_mm256_mul_pd(q_acc_13_21,src_dof_21)),_mm256_mul_pd(q_acc_13_22,src_dof_22)),_mm256_mul_pd(q_acc_13_23,src_dof_23)),_mm256_mul_pd(q_acc_13_24,src_dof_24)),_mm256_mul_pd(q_acc_13_25,src_dof_25)),_mm256_mul_pd(q_acc_13_26,src_dof_26)),_mm256_mul_pd(q_acc_13_27,src_dof_27)),_mm256_mul_pd(q_acc_13_28,src_dof_28)),_mm256_mul_pd(q_acc_13_29,src_dof_29)),_mm256_mul_pd(q_acc_1_13,src_dof_1)),_mm256_mul_pd(q_acc_2_13,src_dof_2)),_mm256_mul_pd(q_acc_3_13,src_dof_3)),_mm256_mul_pd(q_acc_4_13,src_dof_4)),_mm256_mul_pd(q_acc_5_13,src_dof_5)),_mm256_mul_pd(q_acc_6_13,src_dof_6)),_mm256_mul_pd(q_acc_7_13,src_dof_7)),_mm256_mul_pd(q_acc_8_13,src_dof_8)),_mm256_mul_pd(q_acc_9_13,src_dof_9));
                const __m256d elMatVec_14 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_14,src_dof_0),_mm256_mul_pd(q_acc_10_14,src_dof_10)),_mm256_mul_pd(q_acc_11_14,src_dof_11)),_mm256_mul_pd(q_acc_12_14,src_dof_12)),_mm256_mul_pd(q_acc_13_14,src_dof_13)),_mm256_mul_pd(q_acc_14_14,src_dof_14)),_mm256_mul_pd(q_acc_14_15,src_dof_15)),_mm256_mul_pd(q_acc_14_16,src_dof_16)),_mm256_mul_pd(q_acc_14_17,src_dof_17)),_mm256_mul_pd(q_acc_14_18,src_dof_18)),_mm256_mul_pd(q_acc_14_19,src_dof_19)),_mm256_mul_pd(q_acc_14_20,src_dof_20)),_mm256_mul_pd(q_acc_14_21,src_dof_21)),_mm256_mul_pd(q_acc_14_22,src_dof_22)),_mm256_mul_pd(q_acc_14_23,src_dof_23)),_mm256_mul_pd(q_acc_14_24,src_dof_24)),_mm256_mul_pd(q_acc_14_25,src_dof_25)),_mm256_mul_pd(q_acc_14_26,src_dof_26)),_mm256_mul_pd(q_acc_14_27,src_dof_27)),_mm256_mul_pd(q_acc_14_28,src_dof_28)),_mm256_mul_pd(q_acc_14_29,src_dof_29)),_mm256_mul_pd(q_acc_1_14,src_dof_1)),_mm256_mul_pd(q_acc_2_14,src_dof_2)),_mm256_mul_pd(q_acc_3_14,src_dof_3)),_mm256_mul_pd(q_acc_4_14,src_dof_4)),_mm256_mul_pd(q_acc_5_14,src_dof_5)),_mm256_mul_pd(q_acc_6_14,src_dof_6)),_mm256_mul_pd(q_acc_7_14,src_dof_7)),_mm256_mul_pd(q_acc_8_14,src_dof_8)),_mm256_mul_pd(q_acc_9_14,src_dof_9));
                const __m256d elMatVec_15 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_15,src_dof_0),_mm256_mul_pd(q_acc_10_15,src_dof_10)),_mm256_mul_pd(q_acc_11_15,src_dof_11)),_mm256_mul_pd(q_acc_12_15,src_dof_12)),_mm256_mul_pd(q_acc_13_15,src_dof_13)),_mm256_mul_pd(q_acc_14_15,src_dof_14)),_mm256_mul_pd(q_acc_15_15,src_dof_15)),_mm256_mul_pd(q_acc_15_16,src_dof_16)),_mm256_mul_pd(q_acc_15_17,src_dof_17)),_mm256_mul_pd(q_acc_15_18,src_dof_18)),_mm256_mul_pd(q_acc_15_19,src_dof_19)),_mm256_mul_pd(q_acc_15_20,src_dof_20)),_mm256_mul_pd(q_acc_15_21,src_dof_21)),_mm256_mul_pd(q_acc_15_22,src_dof_22)),_mm256_mul_pd(q_acc_15_23,src_dof_23)),_mm256_mul_pd(q_acc_15_24,src_dof_24)),_mm256_mul_pd(q_acc_15_25,src_dof_25)),_mm256_mul_pd(q_acc_15_26,src_dof_26)),_mm256_mul_pd(q_acc_15_27,src_dof_27)),_mm256_mul_pd(q_acc_15_28,src_dof_28)),_mm256_mul_pd(q_acc_15_29,src_dof_29)),_mm256_mul_pd(q_acc_1_15,src_dof_1)),_mm256_mul_pd(q_acc_2_15,src_dof_2)),_mm256_mul_pd(q_acc_3_15,src_dof_3)),_mm256_mul_pd(q_acc_4_15,src_dof_4)),_mm256_mul_pd(q_acc_5_15,src_dof_5)),_mm256_mul_pd(q_acc_6_15,src_dof_6)),_mm256_mul_pd(q_acc_7_15,src_dof_7)),_mm256_mul_pd(q_acc_8_15,src_dof_8)),_mm256_mul_pd(q_acc_9_15,src_dof_9));
                const __m256d elMatVec_16 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_16,src_dof_0),_mm256_mul_pd(q_acc_10_16,src_dof_10)),_mm256_mul_pd(q_acc_11_16,src_dof_11)),_mm256_mul_pd(q_acc_12_16,src_dof_12)),_mm256_mul_pd(q_acc_13_16,src_dof_13)),_mm256_mul_pd(q_acc_14_16,src_dof_14)),_mm256_mul_pd(q_acc_15_16,src_dof_15)),_mm256_mul_pd(q_acc_16_16,src_dof_16)),_mm256_mul_pd(q_acc_16_17,src_dof_17)),_mm256_mul_pd(q_acc_16_18,src_dof_18)),_mm256_mul_pd(q_acc_16_19,src_dof_19)),_mm256_mul_pd(q_acc_16_20,src_dof_20)),_mm256_mul_pd(q_acc_16_21,src_dof_21)),_mm256_mul_pd(q_acc_16_22,src_dof_22)),_mm256_mul_pd(q_acc_16_23,src_dof_23)),_mm256_mul_pd(q_acc_16_24,src_dof_24)),_mm256_mul_pd(q_acc_16_25,src_dof_25)),_mm256_mul_pd(q_acc_16_26,src_dof_26)),_mm256_mul_pd(q_acc_16_27,src_dof_27)),_mm256_mul_pd(q_acc_16_28,src_dof_28)),_mm256_mul_pd(q_acc_16_29,src_dof_29)),_mm256_mul_pd(q_acc_1_16,src_dof_1)),_mm256_mul_pd(q_acc_2_16,src_dof_2)),_mm256_mul_pd(q_acc_3_16,src_dof_3)),_mm256_mul_pd(q_acc_4_16,src_dof_4)),_mm256_mul_pd(q_acc_5_16,src_dof_5)),_mm256_mul_pd(q_acc_6_16,src_dof_6)),_mm256_mul_pd(q_acc_7_16,src_dof_7)),_mm256_mul_pd(q_acc_8_16,src_dof_8)),_mm256_mul_pd(q_acc_9_16,src_dof_9));
                const __m256d elMatVec_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_17,src_dof_0),_mm256_mul_pd(q_acc_10_17,src_dof_10)),_mm256_mul_pd(q_acc_11_17,src_dof_11)),_mm256_mul_pd(q_acc_12_17,src_dof_12)),_mm256_mul_pd(q_acc_13_17,src_dof_13)),_mm256_mul_pd(q_acc_14_17,src_dof_14)),_mm256_mul_pd(q_acc_15_17,src_dof_15)),_mm256_mul_pd(q_acc_16_17,src_dof_16)),_mm256_mul_pd(q_acc_17_17,src_dof_17)),_mm256_mul_pd(q_acc_17_18,src_dof_18)),_mm256_mul_pd(q_acc_17_19,src_dof_19)),_mm256_mul_pd(q_acc_17_20,src_dof_20)),_mm256_mul_pd(q_acc_17_21,src_dof_21)),_mm256_mul_pd(q_acc_17_22,src_dof_22)),_mm256_mul_pd(q_acc_17_23,src_dof_23)),_mm256_mul_pd(q_acc_17_24,src_dof_24)),_mm256_mul_pd(q_acc_17_25,src_dof_25)),_mm256_mul_pd(q_acc_17_26,src_dof_26)),_mm256_mul_pd(q_acc_17_27,src_dof_27)),_mm256_mul_pd(q_acc_17_28,src_dof_28)),_mm256_mul_pd(q_acc_17_29,src_dof_29)),_mm256_mul_pd(q_acc_1_17,src_dof_1)),_mm256_mul_pd(q_acc_2_17,src_dof_2)),_mm256_mul_pd(q_acc_3_17,src_dof_3)),_mm256_mul_pd(q_acc_4_17,src_dof_4)),_mm256_mul_pd(q_acc_5_17,src_dof_5)),_mm256_mul_pd(q_acc_6_17,src_dof_6)),_mm256_mul_pd(q_acc_7_17,src_dof_7)),_mm256_mul_pd(q_acc_8_17,src_dof_8)),_mm256_mul_pd(q_acc_9_17,src_dof_9));
                const __m256d elMatVec_18 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_18,src_dof_0),_mm256_mul_pd(q_acc_10_18,src_dof_10)),_mm256_mul_pd(q_acc_11_18,src_dof_11)),_mm256_mul_pd(q_acc_12_18,src_dof_12)),_mm256_mul_pd(q_acc_13_18,src_dof_13)),_mm256_mul_pd(q_acc_14_18,src_dof_14)),_mm256_mul_pd(q_acc_15_18,src_dof_15)),_mm256_mul_pd(q_acc_16_18,src_dof_16)),_mm256_mul_pd(q_acc_17_18,src_dof_17)),_mm256_mul_pd(q_acc_18_18,src_dof_18)),_mm256_mul_pd(q_acc_18_19,src_dof_19)),_mm256_mul_pd(q_acc_18_20,src_dof_20)),_mm256_mul_pd(q_acc_18_21,src_dof_21)),_mm256_mul_pd(q_acc_18_22,src_dof_22)),_mm256_mul_pd(q_acc_18_23,src_dof_23)),_mm256_mul_pd(q_acc_18_24,src_dof_24)),_mm256_mul_pd(q_acc_18_25,src_dof_25)),_mm256_mul_pd(q_acc_18_26,src_dof_26)),_mm256_mul_pd(q_acc_18_27,src_dof_27)),_mm256_mul_pd(q_acc_18_28,src_dof_28)),_mm256_mul_pd(q_acc_18_29,src_dof_29)),_mm256_mul_pd(q_acc_1_18,src_dof_1)),_mm256_mul_pd(q_acc_2_18,src_dof_2)),_mm256_mul_pd(q_acc_3_18,src_dof_3)),_mm256_mul_pd(q_acc_4_18,src_dof_4)),_mm256_mul_pd(q_acc_5_18,src_dof_5)),_mm256_mul_pd(q_acc_6_18,src_dof_6)),_mm256_mul_pd(q_acc_7_18,src_dof_7)),_mm256_mul_pd(q_acc_8_18,src_dof_8)),_mm256_mul_pd(q_acc_9_18,src_dof_9));
                const __m256d elMatVec_19 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_19,src_dof_0),_mm256_mul_pd(q_acc_10_19,src_dof_10)),_mm256_mul_pd(q_acc_11_19,src_dof_11)),_mm256_mul_pd(q_acc_12_19,src_dof_12)),_mm256_mul_pd(q_acc_13_19,src_dof_13)),_mm256_mul_pd(q_acc_14_19,src_dof_14)),_mm256_mul_pd(q_acc_15_19,src_dof_15)),_mm256_mul_pd(q_acc_16_19,src_dof_16)),_mm256_mul_pd(q_acc_17_19,src_dof_17)),_mm256_mul_pd(q_acc_18_19,src_dof_18)),_mm256_mul_pd(q_acc_19_19,src_dof_19)),_mm256_mul_pd(q_acc_19_20,src_dof_20)),_mm256_mul_pd(q_acc_19_21,src_dof_21)),_mm256_mul_pd(q_acc_19_22,src_dof_22)),_mm256_mul_pd(q_acc_19_23,src_dof_23)),_mm256_mul_pd(q_acc_19_24,src_dof_24)),_mm256_mul_pd(q_acc_19_25,src_dof_25)),_mm256_mul_pd(q_acc_19_26,src_dof_26)),_mm256_mul_pd(q_acc_19_27,src_dof_27)),_mm256_mul_pd(q_acc_19_28,src_dof_28)),_mm256_mul_pd(q_acc_19_29,src_dof_29)),_mm256_mul_pd(q_acc_1_19,src_dof_1)),_mm256_mul_pd(q_acc_2_19,src_dof_2)),_mm256_mul_pd(q_acc_3_19,src_dof_3)),_mm256_mul_pd(q_acc_4_19,src_dof_4)),_mm256_mul_pd(q_acc_5_19,src_dof_5)),_mm256_mul_pd(q_acc_6_19,src_dof_6)),_mm256_mul_pd(q_acc_7_19,src_dof_7)),_mm256_mul_pd(q_acc_8_19,src_dof_8)),_mm256_mul_pd(q_acc_9_19,src_dof_9));
                const __m256d elMatVec_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_20,src_dof_0),_mm256_mul_pd(q_acc_10_20,src_dof_10)),_mm256_mul_pd(q_acc_11_20,src_dof_11)),_mm256_mul_pd(q_acc_12_20,src_dof_12)),_mm256_mul_pd(q_acc_13_20,src_dof_13)),_mm256_mul_pd(q_acc_14_20,src_dof_14)),_mm256_mul_pd(q_acc_15_20,src_dof_15)),_mm256_mul_pd(q_acc_16_20,src_dof_16)),_mm256_mul_pd(q_acc_17_20,src_dof_17)),_mm256_mul_pd(q_acc_18_20,src_dof_18)),_mm256_mul_pd(q_acc_19_20,src_dof_19)),_mm256_mul_pd(q_acc_1_20,src_dof_1)),_mm256_mul_pd(q_acc_20_20,src_dof_20)),_mm256_mul_pd(q_acc_20_21,src_dof_21)),_mm256_mul_pd(q_acc_20_22,src_dof_22)),_mm256_mul_pd(q_acc_20_23,src_dof_23)),_mm256_mul_pd(q_acc_20_24,src_dof_24)),_mm256_mul_pd(q_acc_20_25,src_dof_25)),_mm256_mul_pd(q_acc_20_26,src_dof_26)),_mm256_mul_pd(q_acc_20_27,src_dof_27)),_mm256_mul_pd(q_acc_20_28,src_dof_28)),_mm256_mul_pd(q_acc_20_29,src_dof_29)),_mm256_mul_pd(q_acc_2_20,src_dof_2)),_mm256_mul_pd(q_acc_3_20,src_dof_3)),_mm256_mul_pd(q_acc_4_20,src_dof_4)),_mm256_mul_pd(q_acc_5_20,src_dof_5)),_mm256_mul_pd(q_acc_6_20,src_dof_6)),_mm256_mul_pd(q_acc_7_20,src_dof_7)),_mm256_mul_pd(q_acc_8_20,src_dof_8)),_mm256_mul_pd(q_acc_9_20,src_dof_9));
                const __m256d elMatVec_21 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_21,src_dof_0),_mm256_mul_pd(q_acc_10_21,src_dof_10)),_mm256_mul_pd(q_acc_11_21,src_dof_11)),_mm256_mul_pd(q_acc_12_21,src_dof_12)),_mm256_mul_pd(q_acc_13_21,src_dof_13)),_mm256_mul_pd(q_acc_14_21,src_dof_14)),_mm256_mul_pd(q_acc_15_21,src_dof_15)),_mm256_mul_pd(q_acc_16_21,src_dof_16)),_mm256_mul_pd(q_acc_17_21,src_dof_17)),_mm256_mul_pd(q_acc_18_21,src_dof_18)),_mm256_mul_pd(q_acc_19_21,src_dof_19)),_mm256_mul_pd(q_acc_1_21,src_dof_1)),_mm256_mul_pd(q_acc_20_21,src_dof_20)),_mm256_mul_pd(q_acc_21_21,src_dof_21)),_mm256_mul_pd(q_acc_21_22,src_dof_22)),_mm256_mul_pd(q_acc_21_23,src_dof_23)),_mm256_mul_pd(q_acc_21_24,src_dof_24)),_mm256_mul_pd(q_acc_21_25,src_dof_25)),_mm256_mul_pd(q_acc_21_26,src_dof_26)),_mm256_mul_pd(q_acc_21_27,src_dof_27)),_mm256_mul_pd(q_acc_21_28,src_dof_28)),_mm256_mul_pd(q_acc_21_29,src_dof_29)),_mm256_mul_pd(q_acc_2_21,src_dof_2)),_mm256_mul_pd(q_acc_3_21,src_dof_3)),_mm256_mul_pd(q_acc_4_21,src_dof_4)),_mm256_mul_pd(q_acc_5_21,src_dof_5)),_mm256_mul_pd(q_acc_6_21,src_dof_6)),_mm256_mul_pd(q_acc_7_21,src_dof_7)),_mm256_mul_pd(q_acc_8_21,src_dof_8)),_mm256_mul_pd(q_acc_9_21,src_dof_9));
                const __m256d elMatVec_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_22,src_dof_0),_mm256_mul_pd(q_acc_10_22,src_dof_10)),_mm256_mul_pd(q_acc_11_22,src_dof_11)),_mm256_mul_pd(q_acc_12_22,src_dof_12)),_mm256_mul_pd(q_acc_13_22,src_dof_13)),_mm256_mul_pd(q_acc_14_22,src_dof_14)),_mm256_mul_pd(q_acc_15_22,src_dof_15)),_mm256_mul_pd(q_acc_16_22,src_dof_16)),_mm256_mul_pd(q_acc_17_22,src_dof_17)),_mm256_mul_pd(q_acc_18_22,src_dof_18)),_mm256_mul_pd(q_acc_19_22,src_dof_19)),_mm256_mul_pd(q_acc_1_22,src_dof_1)),_mm256_mul_pd(q_acc_20_22,src_dof_20)),_mm256_mul_pd(q_acc_21_22,src_dof_21)),_mm256_mul_pd(q_acc_22_22,src_dof_22)),_mm256_mul_pd(q_acc_22_23,src_dof_23)),_mm256_mul_pd(q_acc_22_24,src_dof_24)),_mm256_mul_pd(q_acc_22_25,src_dof_25)),_mm256_mul_pd(q_acc_22_26,src_dof_26)),_mm256_mul_pd(q_acc_22_27,src_dof_27)),_mm256_mul_pd(q_acc_22_28,src_dof_28)),_mm256_mul_pd(q_acc_22_29,src_dof_29)),_mm256_mul_pd(q_acc_2_22,src_dof_2)),_mm256_mul_pd(q_acc_3_22,src_dof_3)),_mm256_mul_pd(q_acc_4_22,src_dof_4)),_mm256_mul_pd(q_acc_5_22,src_dof_5)),_mm256_mul_pd(q_acc_6_22,src_dof_6)),_mm256_mul_pd(q_acc_7_22,src_dof_7)),_mm256_mul_pd(q_acc_8_22,src_dof_8)),_mm256_mul_pd(q_acc_9_22,src_dof_9));
                const __m256d elMatVec_23 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_23,src_dof_0),_mm256_mul_pd(q_acc_10_23,src_dof_10)),_mm256_mul_pd(q_acc_11_23,src_dof_11)),_mm256_mul_pd(q_acc_12_23,src_dof_12)),_mm256_mul_pd(q_acc_13_23,src_dof_13)),_mm256_mul_pd(q_acc_14_23,src_dof_14)),_mm256_mul_pd(q_acc_15_23,src_dof_15)),_mm256_mul_pd(q_acc_16_23,src_dof_16)),_mm256_mul_pd(q_acc_17_23,src_dof_17)),_mm256_mul_pd(q_acc_18_23,src_dof_18)),_mm256_mul_pd(q_acc_19_23,src_dof_19)),_mm256_mul_pd(q_acc_1_23,src_dof_1)),_mm256_mul_pd(q_acc_20_23,src_dof_20)),_mm256_mul_pd(q_acc_21_23,src_dof_21)),_mm256_mul_pd(q_acc_22_23,src_dof_22)),_mm256_mul_pd(q_acc_23_23,src_dof_23)),_mm256_mul_pd(q_acc_23_24,src_dof_24)),_mm256_mul_pd(q_acc_23_25,src_dof_25)),_mm256_mul_pd(q_acc_23_26,src_dof_26)),_mm256_mul_pd(q_acc_23_27,src_dof_27)),_mm256_mul_pd(q_acc_23_28,src_dof_28)),_mm256_mul_pd(q_acc_23_29,src_dof_29)),_mm256_mul_pd(q_acc_2_23,src_dof_2)),_mm256_mul_pd(q_acc_3_23,src_dof_3)),_mm256_mul_pd(q_acc_4_23,src_dof_4)),_mm256_mul_pd(q_acc_5_23,src_dof_5)),_mm256_mul_pd(q_acc_6_23,src_dof_6)),_mm256_mul_pd(q_acc_7_23,src_dof_7)),_mm256_mul_pd(q_acc_8_23,src_dof_8)),_mm256_mul_pd(q_acc_9_23,src_dof_9));
                const __m256d elMatVec_24 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_24,src_dof_0),_mm256_mul_pd(q_acc_10_24,src_dof_10)),_mm256_mul_pd(q_acc_11_24,src_dof_11)),_mm256_mul_pd(q_acc_12_24,src_dof_12)),_mm256_mul_pd(q_acc_13_24,src_dof_13)),_mm256_mul_pd(q_acc_14_24,src_dof_14)),_mm256_mul_pd(q_acc_15_24,src_dof_15)),_mm256_mul_pd(q_acc_16_24,src_dof_16)),_mm256_mul_pd(q_acc_17_24,src_dof_17)),_mm256_mul_pd(q_acc_18_24,src_dof_18)),_mm256_mul_pd(q_acc_19_24,src_dof_19)),_mm256_mul_pd(q_acc_1_24,src_dof_1)),_mm256_mul_pd(q_acc_20_24,src_dof_20)),_mm256_mul_pd(q_acc_21_24,src_dof_21)),_mm256_mul_pd(q_acc_22_24,src_dof_22)),_mm256_mul_pd(q_acc_23_24,src_dof_23)),_mm256_mul_pd(q_acc_24_24,src_dof_24)),_mm256_mul_pd(q_acc_24_25,src_dof_25)),_mm256_mul_pd(q_acc_24_26,src_dof_26)),_mm256_mul_pd(q_acc_24_27,src_dof_27)),_mm256_mul_pd(q_acc_24_28,src_dof_28)),_mm256_mul_pd(q_acc_24_29,src_dof_29)),_mm256_mul_pd(q_acc_2_24,src_dof_2)),_mm256_mul_pd(q_acc_3_24,src_dof_3)),_mm256_mul_pd(q_acc_4_24,src_dof_4)),_mm256_mul_pd(q_acc_5_24,src_dof_5)),_mm256_mul_pd(q_acc_6_24,src_dof_6)),_mm256_mul_pd(q_acc_7_24,src_dof_7)),_mm256_mul_pd(q_acc_8_24,src_dof_8)),_mm256_mul_pd(q_acc_9_24,src_dof_9));
                const __m256d elMatVec_25 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_25,src_dof_0),_mm256_mul_pd(q_acc_10_25,src_dof_10)),_mm256_mul_pd(q_acc_11_25,src_dof_11)),_mm256_mul_pd(q_acc_12_25,src_dof_12)),_mm256_mul_pd(q_acc_13_25,src_dof_13)),_mm256_mul_pd(q_acc_14_25,src_dof_14)),_mm256_mul_pd(q_acc_15_25,src_dof_15)),_mm256_mul_pd(q_acc_16_25,src_dof_16)),_mm256_mul_pd(q_acc_17_25,src_dof_17)),_mm256_mul_pd(q_acc_18_25,src_dof_18)),_mm256_mul_pd(q_acc_19_25,src_dof_19)),_mm256_mul_pd(q_acc_1_25,src_dof_1)),_mm256_mul_pd(q_acc_20_25,src_dof_20)),_mm256_mul_pd(q_acc_21_25,src_dof_21)),_mm256_mul_pd(q_acc_22_25,src_dof_22)),_mm256_mul_pd(q_acc_23_25,src_dof_23)),_mm256_mul_pd(q_acc_24_25,src_dof_24)),_mm256_mul_pd(q_acc_25_25,src_dof_25)),_mm256_mul_pd(q_acc_25_26,src_dof_26)),_mm256_mul_pd(q_acc_25_27,src_dof_27)),_mm256_mul_pd(q_acc_25_28,src_dof_28)),_mm256_mul_pd(q_acc_25_29,src_dof_29)),_mm256_mul_pd(q_acc_2_25,src_dof_2)),_mm256_mul_pd(q_acc_3_25,src_dof_3)),_mm256_mul_pd(q_acc_4_25,src_dof_4)),_mm256_mul_pd(q_acc_5_25,src_dof_5)),_mm256_mul_pd(q_acc_6_25,src_dof_6)),_mm256_mul_pd(q_acc_7_25,src_dof_7)),_mm256_mul_pd(q_acc_8_25,src_dof_8)),_mm256_mul_pd(q_acc_9_25,src_dof_9));
                const __m256d elMatVec_26 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_26,src_dof_0),_mm256_mul_pd(q_acc_10_26,src_dof_10)),_mm256_mul_pd(q_acc_11_26,src_dof_11)),_mm256_mul_pd(q_acc_12_26,src_dof_12)),_mm256_mul_pd(q_acc_13_26,src_dof_13)),_mm256_mul_pd(q_acc_14_26,src_dof_14)),_mm256_mul_pd(q_acc_15_26,src_dof_15)),_mm256_mul_pd(q_acc_16_26,src_dof_16)),_mm256_mul_pd(q_acc_17_26,src_dof_17)),_mm256_mul_pd(q_acc_18_26,src_dof_18)),_mm256_mul_pd(q_acc_19_26,src_dof_19)),_mm256_mul_pd(q_acc_1_26,src_dof_1)),_mm256_mul_pd(q_acc_20_26,src_dof_20)),_mm256_mul_pd(q_acc_21_26,src_dof_21)),_mm256_mul_pd(q_acc_22_26,src_dof_22)),_mm256_mul_pd(q_acc_23_26,src_dof_23)),_mm256_mul_pd(q_acc_24_26,src_dof_24)),_mm256_mul_pd(q_acc_25_26,src_dof_25)),_mm256_mul_pd(q_acc_26_26,src_dof_26)),_mm256_mul_pd(q_acc_26_27,src_dof_27)),_mm256_mul_pd(q_acc_26_28,src_dof_28)),_mm256_mul_pd(q_acc_26_29,src_dof_29)),_mm256_mul_pd(q_acc_2_26,src_dof_2)),_mm256_mul_pd(q_acc_3_26,src_dof_3)),_mm256_mul_pd(q_acc_4_26,src_dof_4)),_mm256_mul_pd(q_acc_5_26,src_dof_5)),_mm256_mul_pd(q_acc_6_26,src_dof_6)),_mm256_mul_pd(q_acc_7_26,src_dof_7)),_mm256_mul_pd(q_acc_8_26,src_dof_8)),_mm256_mul_pd(q_acc_9_26,src_dof_9));
                const __m256d elMatVec_27 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_27,src_dof_0),_mm256_mul_pd(q_acc_10_27,src_dof_10)),_mm256_mul_pd(q_acc_11_27,src_dof_11)),_mm256_mul_pd(q_acc_12_27,src_dof_12)),_mm256_mul_pd(q_acc_13_27,src_dof_13)),_mm256_mul_pd(q_acc_14_27,src_dof_14)),_mm256_mul_pd(q_acc_15_27,src_dof_15)),_mm256_mul_pd(q_acc_16_27,src_dof_16)),_mm256_mul_pd(q_acc_17_27,src_dof_17)),_mm256_mul_pd(q_acc_18_27,src_dof_18)),_mm256_mul_pd(q_acc_19_27,src_dof_19)),_mm256_mul_pd(q_acc_1_27,src_dof_1)),_mm256_mul_pd(q_acc_20_27,src_dof_20)),_mm256_mul_pd(q_acc_21_27,src_dof_21)),_mm256_mul_pd(q_acc_22_27,src_dof_22)),_mm256_mul_pd(q_acc_23_27,src_dof_23)),_mm256_mul_pd(q_acc_24_27,src_dof_24)),_mm256_mul_pd(q_acc_25_27,src_dof_25)),_mm256_mul_pd(q_acc_26_27,src_dof_26)),_mm256_mul_pd(q_acc_27_27,src_dof_27)),_mm256_mul_pd(q_acc_27_28,src_dof_28)),_mm256_mul_pd(q_acc_27_29,src_dof_29)),_mm256_mul_pd(q_acc_2_27,src_dof_2)),_mm256_mul_pd(q_acc_3_27,src_dof_3)),_mm256_mul_pd(q_acc_4_27,src_dof_4)),_mm256_mul_pd(q_acc_5_27,src_dof_5)),_mm256_mul_pd(q_acc_6_27,src_dof_6)),_mm256_mul_pd(q_acc_7_27,src_dof_7)),_mm256_mul_pd(q_acc_8_27,src_dof_8)),_mm256_mul_pd(q_acc_9_27,src_dof_9));
                const __m256d elMatVec_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_28,src_dof_0),_mm256_mul_pd(q_acc_10_28,src_dof_10)),_mm256_mul_pd(q_acc_11_28,src_dof_11)),_mm256_mul_pd(q_acc_12_28,src_dof_12)),_mm256_mul_pd(q_acc_13_28,src_dof_13)),_mm256_mul_pd(q_acc_14_28,src_dof_14)),_mm256_mul_pd(q_acc_15_28,src_dof_15)),_mm256_mul_pd(q_acc_16_28,src_dof_16)),_mm256_mul_pd(q_acc_17_28,src_dof_17)),_mm256_mul_pd(q_acc_18_28,src_dof_18)),_mm256_mul_pd(q_acc_19_28,src_dof_19)),_mm256_mul_pd(q_acc_1_28,src_dof_1)),_mm256_mul_pd(q_acc_20_28,src_dof_20)),_mm256_mul_pd(q_acc_21_28,src_dof_21)),_mm256_mul_pd(q_acc_22_28,src_dof_22)),_mm256_mul_pd(q_acc_23_28,src_dof_23)),_mm256_mul_pd(q_acc_24_28,src_dof_24)),_mm256_mul_pd(q_acc_25_28,src_dof_25)),_mm256_mul_pd(q_acc_26_28,src_dof_26)),_mm256_mul_pd(q_acc_27_28,src_dof_27)),_mm256_mul_pd(q_acc_28_28,src_dof_28)),_mm256_mul_pd(q_acc_28_29,src_dof_29)),_mm256_mul_pd(q_acc_2_28,src_dof_2)),_mm256_mul_pd(q_acc_3_28,src_dof_3)),_mm256_mul_pd(q_acc_4_28,src_dof_4)),_mm256_mul_pd(q_acc_5_28,src_dof_5)),_mm256_mul_pd(q_acc_6_28,src_dof_6)),_mm256_mul_pd(q_acc_7_28,src_dof_7)),_mm256_mul_pd(q_acc_8_28,src_dof_8)),_mm256_mul_pd(q_acc_9_28,src_dof_9));
                const __m256d elMatVec_29 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(q_acc_0_29,src_dof_0),_mm256_mul_pd(q_acc_10_29,src_dof_10)),_mm256_mul_pd(q_acc_11_29,src_dof_11)),_mm256_mul_pd(q_acc_12_29,src_dof_12)),_mm256_mul_pd(q_acc_13_29,src_dof_13)),_mm256_mul_pd(q_acc_14_29,src_dof_14)),_mm256_mul_pd(q_acc_15_29,src_dof_15)),_mm256_mul_pd(q_acc_16_29,src_dof_16)),_mm256_mul_pd(q_acc_17_29,src_dof_17)),_mm256_mul_pd(q_acc_18_29,src_dof_18)),_mm256_mul_pd(q_acc_19_29,src_dof_19)),_mm256_mul_pd(q_acc_1_29,src_dof_1)),_mm256_mul_pd(q_acc_20_29,src_dof_20)),_mm256_mul_pd(q_acc_21_29,src_dof_21)),_mm256_mul_pd(q_acc_22_29,src_dof_22)),_mm256_mul_pd(q_acc_23_29,src_dof_23)),_mm256_mul_pd(q_acc_24_29,src_dof_24)),_mm256_mul_pd(q_acc_25_29,src_dof_25)),_mm256_mul_pd(q_acc_26_29,src_dof_26)),_mm256_mul_pd(q_acc_27_29,src_dof_27)),_mm256_mul_pd(q_acc_28_29,src_dof_28)),_mm256_mul_pd(q_acc_29_29,src_dof_29)),_mm256_mul_pd(q_acc_2_29,src_dof_2)),_mm256_mul_pd(q_acc_3_29,src_dof_3)),_mm256_mul_pd(q_acc_4_29,src_dof_4)),_mm256_mul_pd(q_acc_5_29,src_dof_5)),_mm256_mul_pd(q_acc_6_29,src_dof_6)),_mm256_mul_pd(q_acc_7_29,src_dof_7)),_mm256_mul_pd(q_acc_8_29,src_dof_8)),_mm256_mul_pd(q_acc_9_29,src_dof_9));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_10,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_11,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_12,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_13,_mm256_loadu_pd(& _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_14,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_15,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_16,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_17,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_18,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_19,_mm256_loadu_pd(& _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_20,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_21,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_22,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_23,_mm256_loadu_pd(& _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_24,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_25,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_26,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_27,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_28,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_29,_mm256_loadu_pd(& _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_src_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_7 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_src_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_src_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_10 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_11 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_12 = _data_src_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_13 = _data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_14 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_15 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_16 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_17 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_18 = _data_src_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_19 = _data_src_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_20 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_21 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_22 = _data_src_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_23 = _data_src_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_24 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_25 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_26 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_27 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_28 = _data_src_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_29 = _data_src_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t mu_dof_0 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t mu_dof_1 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_2 = _data_mu[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t mu_dof_3 = _data_mu[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                real_t q_acc_0_0 = 0.0;
                real_t q_acc_0_1 = 0.0;
                real_t q_acc_0_2 = 0.0;
                real_t q_acc_0_3 = 0.0;
                real_t q_acc_0_4 = 0.0;
                real_t q_acc_0_5 = 0.0;
                real_t q_acc_0_6 = 0.0;
                real_t q_acc_0_7 = 0.0;
                real_t q_acc_0_8 = 0.0;
                real_t q_acc_0_9 = 0.0;
                real_t q_acc_0_10 = 0.0;
                real_t q_acc_0_11 = 0.0;
                real_t q_acc_0_12 = 0.0;
                real_t q_acc_0_13 = 0.0;
                real_t q_acc_0_14 = 0.0;
                real_t q_acc_0_15 = 0.0;
                real_t q_acc_0_16 = 0.0;
                real_t q_acc_0_17 = 0.0;
                real_t q_acc_0_18 = 0.0;
                real_t q_acc_0_19 = 0.0;
                real_t q_acc_0_20 = 0.0;
                real_t q_acc_0_21 = 0.0;
                real_t q_acc_0_22 = 0.0;
                real_t q_acc_0_23 = 0.0;
                real_t q_acc_0_24 = 0.0;
                real_t q_acc_0_25 = 0.0;
                real_t q_acc_0_26 = 0.0;
                real_t q_acc_0_27 = 0.0;
                real_t q_acc_0_28 = 0.0;
                real_t q_acc_0_29 = 0.0;
                real_t q_acc_1_1 = 0.0;
                real_t q_acc_1_2 = 0.0;
                real_t q_acc_1_3 = 0.0;
                real_t q_acc_1_4 = 0.0;
                real_t q_acc_1_5 = 0.0;
                real_t q_acc_1_6 = 0.0;
                real_t q_acc_1_7 = 0.0;
                real_t q_acc_1_8 = 0.0;
                real_t q_acc_1_9 = 0.0;
                real_t q_acc_1_10 = 0.0;
                real_t q_acc_1_11 = 0.0;
                real_t q_acc_1_12 = 0.0;
                real_t q_acc_1_13 = 0.0;
                real_t q_acc_1_14 = 0.0;
                real_t q_acc_1_15 = 0.0;
                real_t q_acc_1_16 = 0.0;
                real_t q_acc_1_17 = 0.0;
                real_t q_acc_1_18 = 0.0;
                real_t q_acc_1_19 = 0.0;
                real_t q_acc_1_20 = 0.0;
                real_t q_acc_1_21 = 0.0;
                real_t q_acc_1_22 = 0.0;
                real_t q_acc_1_23 = 0.0;
                real_t q_acc_1_24 = 0.0;
                real_t q_acc_1_25 = 0.0;
                real_t q_acc_1_26 = 0.0;
                real_t q_acc_1_27 = 0.0;
                real_t q_acc_1_28 = 0.0;
                real_t q_acc_1_29 = 0.0;
                real_t q_acc_2_2 = 0.0;
                real_t q_acc_2_3 = 0.0;
                real_t q_acc_2_4 = 0.0;
                real_t q_acc_2_5 = 0.0;
                real_t q_acc_2_6 = 0.0;
                real_t q_acc_2_7 = 0.0;
                real_t q_acc_2_8 = 0.0;
                real_t q_acc_2_9 = 0.0;
                real_t q_acc_2_10 = 0.0;
                real_t q_acc_2_11 = 0.0;
                real_t q_acc_2_12 = 0.0;
                real_t q_acc_2_13 = 0.0;
                real_t q_acc_2_14 = 0.0;
                real_t q_acc_2_15 = 0.0;
                real_t q_acc_2_16 = 0.0;
                real_t q_acc_2_17 = 0.0;
                real_t q_acc_2_18 = 0.0;
                real_t q_acc_2_19 = 0.0;
                real_t q_acc_2_20 = 0.0;
                real_t q_acc_2_21 = 0.0;
                real_t q_acc_2_22 = 0.0;
                real_t q_acc_2_23 = 0.0;
                real_t q_acc_2_24 = 0.0;
                real_t q_acc_2_25 = 0.0;
                real_t q_acc_2_26 = 0.0;
                real_t q_acc_2_27 = 0.0;
                real_t q_acc_2_28 = 0.0;
                real_t q_acc_2_29 = 0.0;
                real_t q_acc_3_3 = 0.0;
                real_t q_acc_3_4 = 0.0;
                real_t q_acc_3_5 = 0.0;
                real_t q_acc_3_6 = 0.0;
                real_t q_acc_3_7 = 0.0;
                real_t q_acc_3_8 = 0.0;
                real_t q_acc_3_9 = 0.0;
                real_t q_acc_3_10 = 0.0;
                real_t q_acc_3_11 = 0.0;
                real_t q_acc_3_12 = 0.0;
                real_t q_acc_3_13 = 0.0;
                real_t q_acc_3_14 = 0.0;
                real_t q_acc_3_15 = 0.0;
                real_t q_acc_3_16 = 0.0;
                real_t q_acc_3_17 = 0.0;
                real_t q_acc_3_18 = 0.0;
                real_t q_acc_3_19 = 0.0;
                real_t q_acc_3_20 = 0.0;
                real_t q_acc_3_21 = 0.0;
                real_t q_acc_3_22 = 0.0;
                real_t q_acc_3_23 = 0.0;
                real_t q_acc_3_24 = 0.0;
                real_t q_acc_3_25 = 0.0;
                real_t q_acc_3_26 = 0.0;
                real_t q_acc_3_27 = 0.0;
                real_t q_acc_3_28 = 0.0;
                real_t q_acc_3_29 = 0.0;
                real_t q_acc_4_4 = 0.0;
                real_t q_acc_4_5 = 0.0;
                real_t q_acc_4_6 = 0.0;
                real_t q_acc_4_7 = 0.0;
                real_t q_acc_4_8 = 0.0;
                real_t q_acc_4_9 = 0.0;
                real_t q_acc_4_10 = 0.0;
                real_t q_acc_4_11 = 0.0;
                real_t q_acc_4_12 = 0.0;
                real_t q_acc_4_13 = 0.0;
                real_t q_acc_4_14 = 0.0;
                real_t q_acc_4_15 = 0.0;
                real_t q_acc_4_16 = 0.0;
                real_t q_acc_4_17 = 0.0;
                real_t q_acc_4_18 = 0.0;
                real_t q_acc_4_19 = 0.0;
                real_t q_acc_4_20 = 0.0;
                real_t q_acc_4_21 = 0.0;
                real_t q_acc_4_22 = 0.0;
                real_t q_acc_4_23 = 0.0;
                real_t q_acc_4_24 = 0.0;
                real_t q_acc_4_25 = 0.0;
                real_t q_acc_4_26 = 0.0;
                real_t q_acc_4_27 = 0.0;
                real_t q_acc_4_28 = 0.0;
                real_t q_acc_4_29 = 0.0;
                real_t q_acc_5_5 = 0.0;
                real_t q_acc_5_6 = 0.0;
                real_t q_acc_5_7 = 0.0;
                real_t q_acc_5_8 = 0.0;
                real_t q_acc_5_9 = 0.0;
                real_t q_acc_5_10 = 0.0;
                real_t q_acc_5_11 = 0.0;
                real_t q_acc_5_12 = 0.0;
                real_t q_acc_5_13 = 0.0;
                real_t q_acc_5_14 = 0.0;
                real_t q_acc_5_15 = 0.0;
                real_t q_acc_5_16 = 0.0;
                real_t q_acc_5_17 = 0.0;
                real_t q_acc_5_18 = 0.0;
                real_t q_acc_5_19 = 0.0;
                real_t q_acc_5_20 = 0.0;
                real_t q_acc_5_21 = 0.0;
                real_t q_acc_5_22 = 0.0;
                real_t q_acc_5_23 = 0.0;
                real_t q_acc_5_24 = 0.0;
                real_t q_acc_5_25 = 0.0;
                real_t q_acc_5_26 = 0.0;
                real_t q_acc_5_27 = 0.0;
                real_t q_acc_5_28 = 0.0;
                real_t q_acc_5_29 = 0.0;
                real_t q_acc_6_6 = 0.0;
                real_t q_acc_6_7 = 0.0;
                real_t q_acc_6_8 = 0.0;
                real_t q_acc_6_9 = 0.0;
                real_t q_acc_6_10 = 0.0;
                real_t q_acc_6_11 = 0.0;
                real_t q_acc_6_12 = 0.0;
                real_t q_acc_6_13 = 0.0;
                real_t q_acc_6_14 = 0.0;
                real_t q_acc_6_15 = 0.0;
                real_t q_acc_6_16 = 0.0;
                real_t q_acc_6_17 = 0.0;
                real_t q_acc_6_18 = 0.0;
                real_t q_acc_6_19 = 0.0;
                real_t q_acc_6_20 = 0.0;
                real_t q_acc_6_21 = 0.0;
                real_t q_acc_6_22 = 0.0;
                real_t q_acc_6_23 = 0.0;
                real_t q_acc_6_24 = 0.0;
                real_t q_acc_6_25 = 0.0;
                real_t q_acc_6_26 = 0.0;
                real_t q_acc_6_27 = 0.0;
                real_t q_acc_6_28 = 0.0;
                real_t q_acc_6_29 = 0.0;
                real_t q_acc_7_7 = 0.0;
                real_t q_acc_7_8 = 0.0;
                real_t q_acc_7_9 = 0.0;
                real_t q_acc_7_10 = 0.0;
                real_t q_acc_7_11 = 0.0;
                real_t q_acc_7_12 = 0.0;
                real_t q_acc_7_13 = 0.0;
                real_t q_acc_7_14 = 0.0;
                real_t q_acc_7_15 = 0.0;
                real_t q_acc_7_16 = 0.0;
                real_t q_acc_7_17 = 0.0;
                real_t q_acc_7_18 = 0.0;
                real_t q_acc_7_19 = 0.0;
                real_t q_acc_7_20 = 0.0;
                real_t q_acc_7_21 = 0.0;
                real_t q_acc_7_22 = 0.0;
                real_t q_acc_7_23 = 0.0;
                real_t q_acc_7_24 = 0.0;
                real_t q_acc_7_25 = 0.0;
                real_t q_acc_7_26 = 0.0;
                real_t q_acc_7_27 = 0.0;
                real_t q_acc_7_28 = 0.0;
                real_t q_acc_7_29 = 0.0;
                real_t q_acc_8_8 = 0.0;
                real_t q_acc_8_9 = 0.0;
                real_t q_acc_8_10 = 0.0;
                real_t q_acc_8_11 = 0.0;
                real_t q_acc_8_12 = 0.0;
                real_t q_acc_8_13 = 0.0;
                real_t q_acc_8_14 = 0.0;
                real_t q_acc_8_15 = 0.0;
                real_t q_acc_8_16 = 0.0;
                real_t q_acc_8_17 = 0.0;
                real_t q_acc_8_18 = 0.0;
                real_t q_acc_8_19 = 0.0;
                real_t q_acc_8_20 = 0.0;
                real_t q_acc_8_21 = 0.0;
                real_t q_acc_8_22 = 0.0;
                real_t q_acc_8_23 = 0.0;
                real_t q_acc_8_24 = 0.0;
                real_t q_acc_8_25 = 0.0;
                real_t q_acc_8_26 = 0.0;
                real_t q_acc_8_27 = 0.0;
                real_t q_acc_8_28 = 0.0;
                real_t q_acc_8_29 = 0.0;
                real_t q_acc_9_9 = 0.0;
                real_t q_acc_9_10 = 0.0;
                real_t q_acc_9_11 = 0.0;
                real_t q_acc_9_12 = 0.0;
                real_t q_acc_9_13 = 0.0;
                real_t q_acc_9_14 = 0.0;
                real_t q_acc_9_15 = 0.0;
                real_t q_acc_9_16 = 0.0;
                real_t q_acc_9_17 = 0.0;
                real_t q_acc_9_18 = 0.0;
                real_t q_acc_9_19 = 0.0;
                real_t q_acc_9_20 = 0.0;
                real_t q_acc_9_21 = 0.0;
                real_t q_acc_9_22 = 0.0;
                real_t q_acc_9_23 = 0.0;
                real_t q_acc_9_24 = 0.0;
                real_t q_acc_9_25 = 0.0;
                real_t q_acc_9_26 = 0.0;
                real_t q_acc_9_27 = 0.0;
                real_t q_acc_9_28 = 0.0;
                real_t q_acc_9_29 = 0.0;
                real_t q_acc_10_10 = 0.0;
                real_t q_acc_10_11 = 0.0;
                real_t q_acc_10_12 = 0.0;
                real_t q_acc_10_13 = 0.0;
                real_t q_acc_10_14 = 0.0;
                real_t q_acc_10_15 = 0.0;
                real_t q_acc_10_16 = 0.0;
                real_t q_acc_10_17 = 0.0;
                real_t q_acc_10_18 = 0.0;
                real_t q_acc_10_19 = 0.0;
                real_t q_acc_10_20 = 0.0;
                real_t q_acc_10_21 = 0.0;
                real_t q_acc_10_22 = 0.0;
                real_t q_acc_10_23 = 0.0;
                real_t q_acc_10_24 = 0.0;
                real_t q_acc_10_25 = 0.0;
                real_t q_acc_10_26 = 0.0;
                real_t q_acc_10_27 = 0.0;
                real_t q_acc_10_28 = 0.0;
                real_t q_acc_10_29 = 0.0;
                real_t q_acc_11_11 = 0.0;
                real_t q_acc_11_12 = 0.0;
                real_t q_acc_11_13 = 0.0;
                real_t q_acc_11_14 = 0.0;
                real_t q_acc_11_15 = 0.0;
                real_t q_acc_11_16 = 0.0;
                real_t q_acc_11_17 = 0.0;
                real_t q_acc_11_18 = 0.0;
                real_t q_acc_11_19 = 0.0;
                real_t q_acc_11_20 = 0.0;
                real_t q_acc_11_21 = 0.0;
                real_t q_acc_11_22 = 0.0;
                real_t q_acc_11_23 = 0.0;
                real_t q_acc_11_24 = 0.0;
                real_t q_acc_11_25 = 0.0;
                real_t q_acc_11_26 = 0.0;
                real_t q_acc_11_27 = 0.0;
                real_t q_acc_11_28 = 0.0;
                real_t q_acc_11_29 = 0.0;
                real_t q_acc_12_12 = 0.0;
                real_t q_acc_12_13 = 0.0;
                real_t q_acc_12_14 = 0.0;
                real_t q_acc_12_15 = 0.0;
                real_t q_acc_12_16 = 0.0;
                real_t q_acc_12_17 = 0.0;
                real_t q_acc_12_18 = 0.0;
                real_t q_acc_12_19 = 0.0;
                real_t q_acc_12_20 = 0.0;
                real_t q_acc_12_21 = 0.0;
                real_t q_acc_12_22 = 0.0;
                real_t q_acc_12_23 = 0.0;
                real_t q_acc_12_24 = 0.0;
                real_t q_acc_12_25 = 0.0;
                real_t q_acc_12_26 = 0.0;
                real_t q_acc_12_27 = 0.0;
                real_t q_acc_12_28 = 0.0;
                real_t q_acc_12_29 = 0.0;
                real_t q_acc_13_13 = 0.0;
                real_t q_acc_13_14 = 0.0;
                real_t q_acc_13_15 = 0.0;
                real_t q_acc_13_16 = 0.0;
                real_t q_acc_13_17 = 0.0;
                real_t q_acc_13_18 = 0.0;
                real_t q_acc_13_19 = 0.0;
                real_t q_acc_13_20 = 0.0;
                real_t q_acc_13_21 = 0.0;
                real_t q_acc_13_22 = 0.0;
                real_t q_acc_13_23 = 0.0;
                real_t q_acc_13_24 = 0.0;
                real_t q_acc_13_25 = 0.0;
                real_t q_acc_13_26 = 0.0;
                real_t q_acc_13_27 = 0.0;
                real_t q_acc_13_28 = 0.0;
                real_t q_acc_13_29 = 0.0;
                real_t q_acc_14_14 = 0.0;
                real_t q_acc_14_15 = 0.0;
                real_t q_acc_14_16 = 0.0;
                real_t q_acc_14_17 = 0.0;
                real_t q_acc_14_18 = 0.0;
                real_t q_acc_14_19 = 0.0;
                real_t q_acc_14_20 = 0.0;
                real_t q_acc_14_21 = 0.0;
                real_t q_acc_14_22 = 0.0;
                real_t q_acc_14_23 = 0.0;
                real_t q_acc_14_24 = 0.0;
                real_t q_acc_14_25 = 0.0;
                real_t q_acc_14_26 = 0.0;
                real_t q_acc_14_27 = 0.0;
                real_t q_acc_14_28 = 0.0;
                real_t q_acc_14_29 = 0.0;
                real_t q_acc_15_15 = 0.0;
                real_t q_acc_15_16 = 0.0;
                real_t q_acc_15_17 = 0.0;
                real_t q_acc_15_18 = 0.0;
                real_t q_acc_15_19 = 0.0;
                real_t q_acc_15_20 = 0.0;
                real_t q_acc_15_21 = 0.0;
                real_t q_acc_15_22 = 0.0;
                real_t q_acc_15_23 = 0.0;
                real_t q_acc_15_24 = 0.0;
                real_t q_acc_15_25 = 0.0;
                real_t q_acc_15_26 = 0.0;
                real_t q_acc_15_27 = 0.0;
                real_t q_acc_15_28 = 0.0;
                real_t q_acc_15_29 = 0.0;
                real_t q_acc_16_16 = 0.0;
                real_t q_acc_16_17 = 0.0;
                real_t q_acc_16_18 = 0.0;
                real_t q_acc_16_19 = 0.0;
                real_t q_acc_16_20 = 0.0;
                real_t q_acc_16_21 = 0.0;
                real_t q_acc_16_22 = 0.0;
                real_t q_acc_16_23 = 0.0;
                real_t q_acc_16_24 = 0.0;
                real_t q_acc_16_25 = 0.0;
                real_t q_acc_16_26 = 0.0;
                real_t q_acc_16_27 = 0.0;
                real_t q_acc_16_28 = 0.0;
                real_t q_acc_16_29 = 0.0;
                real_t q_acc_17_17 = 0.0;
                real_t q_acc_17_18 = 0.0;
                real_t q_acc_17_19 = 0.0;
                real_t q_acc_17_20 = 0.0;
                real_t q_acc_17_21 = 0.0;
                real_t q_acc_17_22 = 0.0;
                real_t q_acc_17_23 = 0.0;
                real_t q_acc_17_24 = 0.0;
                real_t q_acc_17_25 = 0.0;
                real_t q_acc_17_26 = 0.0;
                real_t q_acc_17_27 = 0.0;
                real_t q_acc_17_28 = 0.0;
                real_t q_acc_17_29 = 0.0;
                real_t q_acc_18_18 = 0.0;
                real_t q_acc_18_19 = 0.0;
                real_t q_acc_18_20 = 0.0;
                real_t q_acc_18_21 = 0.0;
                real_t q_acc_18_22 = 0.0;
                real_t q_acc_18_23 = 0.0;
                real_t q_acc_18_24 = 0.0;
                real_t q_acc_18_25 = 0.0;
                real_t q_acc_18_26 = 0.0;
                real_t q_acc_18_27 = 0.0;
                real_t q_acc_18_28 = 0.0;
                real_t q_acc_18_29 = 0.0;
                real_t q_acc_19_19 = 0.0;
                real_t q_acc_19_20 = 0.0;
                real_t q_acc_19_21 = 0.0;
                real_t q_acc_19_22 = 0.0;
                real_t q_acc_19_23 = 0.0;
                real_t q_acc_19_24 = 0.0;
                real_t q_acc_19_25 = 0.0;
                real_t q_acc_19_26 = 0.0;
                real_t q_acc_19_27 = 0.0;
                real_t q_acc_19_28 = 0.0;
                real_t q_acc_19_29 = 0.0;
                real_t q_acc_20_20 = 0.0;
                real_t q_acc_20_21 = 0.0;
                real_t q_acc_20_22 = 0.0;
                real_t q_acc_20_23 = 0.0;
                real_t q_acc_20_24 = 0.0;
                real_t q_acc_20_25 = 0.0;
                real_t q_acc_20_26 = 0.0;
                real_t q_acc_20_27 = 0.0;
                real_t q_acc_20_28 = 0.0;
                real_t q_acc_20_29 = 0.0;
                real_t q_acc_21_21 = 0.0;
                real_t q_acc_21_22 = 0.0;
                real_t q_acc_21_23 = 0.0;
                real_t q_acc_21_24 = 0.0;
                real_t q_acc_21_25 = 0.0;
                real_t q_acc_21_26 = 0.0;
                real_t q_acc_21_27 = 0.0;
                real_t q_acc_21_28 = 0.0;
                real_t q_acc_21_29 = 0.0;
                real_t q_acc_22_22 = 0.0;
                real_t q_acc_22_23 = 0.0;
                real_t q_acc_22_24 = 0.0;
                real_t q_acc_22_25 = 0.0;
                real_t q_acc_22_26 = 0.0;
                real_t q_acc_22_27 = 0.0;
                real_t q_acc_22_28 = 0.0;
                real_t q_acc_22_29 = 0.0;
                real_t q_acc_23_23 = 0.0;
                real_t q_acc_23_24 = 0.0;
                real_t q_acc_23_25 = 0.0;
                real_t q_acc_23_26 = 0.0;
                real_t q_acc_23_27 = 0.0;
                real_t q_acc_23_28 = 0.0;
                real_t q_acc_23_29 = 0.0;
                real_t q_acc_24_24 = 0.0;
                real_t q_acc_24_25 = 0.0;
                real_t q_acc_24_26 = 0.0;
                real_t q_acc_24_27 = 0.0;
                real_t q_acc_24_28 = 0.0;
                real_t q_acc_24_29 = 0.0;
                real_t q_acc_25_25 = 0.0;
                real_t q_acc_25_26 = 0.0;
                real_t q_acc_25_27 = 0.0;
                real_t q_acc_25_28 = 0.0;
                real_t q_acc_25_29 = 0.0;
                real_t q_acc_26_26 = 0.0;
                real_t q_acc_26_27 = 0.0;
                real_t q_acc_26_28 = 0.0;
                real_t q_acc_26_29 = 0.0;
                real_t q_acc_27_27 = 0.0;
                real_t q_acc_27_28 = 0.0;
                real_t q_acc_27_29 = 0.0;
                real_t q_acc_28_28 = 0.0;
                real_t q_acc_28_29 = 0.0;
                real_t q_acc_29_29 = 0.0;
                for (int64_t q = 0; q < 5; q += 1)
                {
                   const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                   const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                   const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                   const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                   const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                   const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                   const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                   const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                   const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                   const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                   const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                   const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                   const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                   const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                   const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                   const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                   const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                   const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                   const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                   const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                   const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                   const real_t tmp_qloop_47 = -tmp_qloop_28;
                   const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                   const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                   const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                   const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                   const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                   const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                   const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                   const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                   const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                   const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                   const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                   const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                   const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                   const real_t tmp_qloop_70 = -tmp_qloop_41;
                   const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                   const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                   const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                   const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                   const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                   const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                   const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                   const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                   const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                   const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                   const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                   const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                   const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                   const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                   const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                   const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                   const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                   const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                   const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                   const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                   const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                   const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                   const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                   const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                   const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                   const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                   const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                   const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                   const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                   const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                   const real_t tmp_qloop_156 = (mu_dof_0*_data_phi_0_0_GREEN_DOWN[4*q] + mu_dof_1*_data_phi_0_0_GREEN_DOWN[4*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_DOWN[4*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_DOWN[4*q + 3])*_data_q_w[q];
                   const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                   const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                   const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                   const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                   const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                   const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                   const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                   const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                   const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                   const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                   const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                   const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                   const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                   const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                   const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                   const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                   const real_t abs_det_jac_blending = tmp_qloop_64;
                   const real_t tmp_qloop_118 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 1];
                   const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                   const real_t tmp_qloop_103 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q];
                   const real_t tmp_qloop_124 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_133 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_157 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2];
                   const real_t tmp_qloop_170 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3];
                   const real_t tmp_qloop_183 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4];
                   const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5];
                   const real_t tmp_qloop_209 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6];
                   const real_t tmp_qloop_222 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7];
                   const real_t tmp_qloop_235 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8];
                   const real_t tmp_qloop_248 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9];
                   const real_t tmp_qloop_261 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10];
                   const real_t tmp_qloop_277 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11];
                   const real_t tmp_qloop_283 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_309 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_323 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_337 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_351 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_365 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_379 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_393 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_407 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_421 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_436 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_453 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_468 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_483 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_498 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_513 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_528 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_543 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_558 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_573 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                   const real_t tmp_qloop_110 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_121 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q];
                   const real_t tmp_qloop_144 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_162 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2];
                   const real_t tmp_qloop_175 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3];
                   const real_t tmp_qloop_188 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4];
                   const real_t tmp_qloop_201 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5];
                   const real_t tmp_qloop_214 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6];
                   const real_t tmp_qloop_227 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7];
                   const real_t tmp_qloop_240 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8];
                   const real_t tmp_qloop_253 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9];
                   const real_t tmp_qloop_266 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10];
                   const real_t tmp_qloop_274 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_286 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11];
                   const real_t tmp_qloop_305 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_319 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_333 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_347 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_361 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_375 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_389 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_403 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_417 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_444 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_459 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_474 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_489 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_504 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_519 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_534 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_549 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_564 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_579 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                   const real_t tmp_qloop_106 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_130 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q];
                   const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 2];
                   const real_t tmp_qloop_179 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 3];
                   const real_t tmp_qloop_192 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 4];
                   const real_t tmp_qloop_205 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 5];
                   const real_t tmp_qloop_218 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 6];
                   const real_t tmp_qloop_231 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 7];
                   const real_t tmp_qloop_244 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 8];
                   const real_t tmp_qloop_257 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 9];
                   const real_t tmp_qloop_270 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 10];
                   const real_t tmp_qloop_293 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[12*q + 11];
                   const real_t tmp_qloop_300 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_314 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_328 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_342 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_356 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_370 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_384 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_398 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_412 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_426 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_431 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_449 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_464 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_479 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_494 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_509 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_524 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_539 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_554 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_569 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                   const real_t tmp_qloop_104 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_125 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_158 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_171 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_184 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_210 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_223 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_236 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_249 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_262 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_278 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_284 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_310 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_324 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_338 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_352 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_366 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_380 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_394 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_408 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_422 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_437 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_454 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_469 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_484 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_499 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_514 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_529 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_544 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_559 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_574 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                   const real_t tmp_qloop_111 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_122 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_145 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_163 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_176 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_189 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_202 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_215 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_228 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_241 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_254 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_267 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_275 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_287 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_306 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_320 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_334 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_348 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_362 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_376 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_390 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_404 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_418 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_445 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_460 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_475 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_490 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_505 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_520 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_535 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_550 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_565 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_580 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                   const real_t tmp_qloop_107 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_131 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_180 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_193 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_206 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_219 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_232 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_245 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_258 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_271 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_294 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_301 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_315 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_329 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_343 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_357 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_371 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_385 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_399 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_413 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_427 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_432 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_450 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_465 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_480 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_495 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_510 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_525 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_540 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_555 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_570 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[11*q + 10];
                   const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                   const real_t tmp_qloop_105 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_120 = tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0;
                   const real_t tmp_qloop_126 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_127 = tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_126;
                   const real_t tmp_qloop_128 = tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_126*0.5;
                   const real_t tmp_qloop_135 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_136 = tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135;
                   const real_t tmp_qloop_137 = tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5;
                   const real_t tmp_qloop_159 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_161 = tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0;
                   const real_t tmp_qloop_172 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_174 = tmp_qloop_170*2.0 + tmp_qloop_171*2.0 + tmp_qloop_172*2.0;
                   const real_t tmp_qloop_185 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_187 = tmp_qloop_183*2.0 + tmp_qloop_184*2.0 + tmp_qloop_185*2.0;
                   const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_200 = tmp_qloop_196*2.0 + tmp_qloop_197*2.0 + tmp_qloop_198*2.0;
                   const real_t tmp_qloop_211 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_213 = tmp_qloop_209*2.0 + tmp_qloop_210*2.0 + tmp_qloop_211*2.0;
                   const real_t tmp_qloop_224 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_226 = tmp_qloop_222*2.0 + tmp_qloop_223*2.0 + tmp_qloop_224*2.0;
                   const real_t tmp_qloop_237 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_239 = tmp_qloop_235*2.0 + tmp_qloop_236*2.0 + tmp_qloop_237*2.0;
                   const real_t tmp_qloop_250 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_252 = tmp_qloop_248*2.0 + tmp_qloop_249*2.0 + tmp_qloop_250*2.0;
                   const real_t tmp_qloop_263 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_265 = tmp_qloop_261*2.0 + tmp_qloop_262*2.0 + tmp_qloop_263*2.0;
                   const real_t tmp_qloop_279 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_280 = tmp_qloop_277*0.66666666666666663 + tmp_qloop_278*0.66666666666666663 + tmp_qloop_279*0.66666666666666663;
                   const real_t tmp_qloop_285 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_291 = tmp_qloop_277*2.0 + tmp_qloop_278*2.0 + tmp_qloop_279*2.0;
                   const real_t tmp_qloop_292 = tmp_qloop_120*tmp_qloop_291;
                   const real_t tmp_qloop_311 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_325 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_339 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_353 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_367 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_381 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_395 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_409 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_423 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_438 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_455 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_470 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_485 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_500 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_515 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_530 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_545 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_560 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_575 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_585 = tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0;
                   const real_t tmp_qloop_589 = tmp_qloop_291*tmp_qloop_585;
                   const real_t tmp_qloop_596 = tmp_qloop_170*1.0 + tmp_qloop_171*1.0 + tmp_qloop_172*1.0;
                   const real_t tmp_qloop_599 = tmp_qloop_291*tmp_qloop_596;
                   const real_t tmp_qloop_605 = tmp_qloop_183*1.0 + tmp_qloop_184*1.0 + tmp_qloop_185*1.0;
                   const real_t tmp_qloop_608 = tmp_qloop_291*tmp_qloop_605;
                   const real_t tmp_qloop_614 = tmp_qloop_196*1.0 + tmp_qloop_197*1.0 + tmp_qloop_198*1.0;
                   const real_t tmp_qloop_617 = tmp_qloop_291*tmp_qloop_614;
                   const real_t tmp_qloop_623 = tmp_qloop_209*1.0 + tmp_qloop_210*1.0 + tmp_qloop_211*1.0;
                   const real_t tmp_qloop_626 = tmp_qloop_291*tmp_qloop_623;
                   const real_t tmp_qloop_632 = tmp_qloop_222*1.0 + tmp_qloop_223*1.0 + tmp_qloop_224*1.0;
                   const real_t tmp_qloop_635 = tmp_qloop_291*tmp_qloop_632;
                   const real_t tmp_qloop_641 = tmp_qloop_235*1.0 + tmp_qloop_236*1.0 + tmp_qloop_237*1.0;
                   const real_t tmp_qloop_644 = tmp_qloop_291*tmp_qloop_641;
                   const real_t tmp_qloop_650 = tmp_qloop_248*1.0 + tmp_qloop_249*1.0 + tmp_qloop_250*1.0;
                   const real_t tmp_qloop_653 = tmp_qloop_291*tmp_qloop_650;
                   const real_t tmp_qloop_659 = tmp_qloop_261*1.0 + tmp_qloop_262*1.0 + tmp_qloop_263*1.0;
                   const real_t tmp_qloop_662 = tmp_qloop_291*tmp_qloop_659;
                   const real_t tmp_qloop_667 = tmp_qloop_277 + tmp_qloop_278 + tmp_qloop_279;
                   const real_t tmp_qloop_674 = tmp_qloop_291*(tmp_qloop_277*1.0 + tmp_qloop_278*1.0 + tmp_qloop_279*1.0);
                   const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                   const real_t tmp_qloop_112 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_113 = tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663 + tmp_qloop_112*0.66666666666666663;
                   const real_t tmp_qloop_116 = tmp_qloop_110 + tmp_qloop_111 + tmp_qloop_112;
                   const real_t tmp_qloop_123 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_129 = tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_128*2.0;
                   const real_t tmp_qloop_139 = tmp_qloop_110*1.0 + tmp_qloop_111*1.0 + tmp_qloop_112*1.0;
                   const real_t tmp_qloop_140 = tmp_qloop_110*2.0 + tmp_qloop_111*2.0 + tmp_qloop_112*2.0;
                   const real_t tmp_qloop_141 = tmp_qloop_139*tmp_qloop_140;
                   const real_t tmp_qloop_146 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_147 = tmp_qloop_144 + tmp_qloop_145 + tmp_qloop_146;
                   const real_t tmp_qloop_152 = tmp_qloop_144*0.5 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5;
                   const real_t tmp_qloop_164 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_165 = tmp_qloop_127 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_177 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_178 = tmp_qloop_127 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_190 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_191 = tmp_qloop_127 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_203 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_204 = tmp_qloop_127 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_216 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_217 = tmp_qloop_127 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_229 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_230 = tmp_qloop_127 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_242 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_243 = tmp_qloop_127 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_255 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_256 = tmp_qloop_127 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_268 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_269 = tmp_qloop_127 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_276 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_288 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_289 = tmp_qloop_286 + tmp_qloop_287 + tmp_qloop_288;
                   const real_t tmp_qloop_290 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_289;
                   const real_t tmp_qloop_299 = tmp_qloop_274*2.0 + tmp_qloop_275*2.0 + tmp_qloop_276*2.0;
                   const real_t tmp_qloop_307 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_312 = tmp_qloop_289 + tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311;
                   const real_t tmp_qloop_313 = tmp_qloop_305*2.0 + tmp_qloop_306*2.0 + tmp_qloop_307*2.0;
                   const real_t tmp_qloop_321 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_326 = tmp_qloop_289 + tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325;
                   const real_t tmp_qloop_327 = tmp_qloop_319*2.0 + tmp_qloop_320*2.0 + tmp_qloop_321*2.0;
                   const real_t tmp_qloop_335 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_340 = tmp_qloop_289 + tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339;
                   const real_t tmp_qloop_341 = tmp_qloop_333*2.0 + tmp_qloop_334*2.0 + tmp_qloop_335*2.0;
                   const real_t tmp_qloop_349 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_354 = tmp_qloop_289 + tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353;
                   const real_t tmp_qloop_355 = tmp_qloop_347*2.0 + tmp_qloop_348*2.0 + tmp_qloop_349*2.0;
                   const real_t tmp_qloop_363 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_368 = tmp_qloop_289 + tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367;
                   const real_t tmp_qloop_369 = tmp_qloop_361*2.0 + tmp_qloop_362*2.0 + tmp_qloop_363*2.0;
                   const real_t tmp_qloop_377 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_382 = tmp_qloop_289 + tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381;
                   const real_t tmp_qloop_383 = tmp_qloop_375*2.0 + tmp_qloop_376*2.0 + tmp_qloop_377*2.0;
                   const real_t tmp_qloop_391 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_396 = tmp_qloop_289 + tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395;
                   const real_t tmp_qloop_397 = tmp_qloop_389*2.0 + tmp_qloop_390*2.0 + tmp_qloop_391*2.0;
                   const real_t tmp_qloop_405 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_410 = tmp_qloop_289 + tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409;
                   const real_t tmp_qloop_411 = tmp_qloop_403*2.0 + tmp_qloop_404*2.0 + tmp_qloop_405*2.0;
                   const real_t tmp_qloop_419 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_424 = tmp_qloop_289 + tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423;
                   const real_t tmp_qloop_425 = tmp_qloop_417*2.0 + tmp_qloop_418*2.0 + tmp_qloop_419*2.0;
                   const real_t tmp_qloop_434 = tmp_qloop_113 + tmp_qloop_280;
                   const real_t tmp_qloop_440 = tmp_qloop_127 + tmp_qloop_289;
                   const real_t tmp_qloop_441 = tmp_qloop_129*tmp_qloop_440 + tmp_qloop_141 + tmp_qloop_292;
                   const real_t tmp_qloop_446 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_461 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_476 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_491 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_506 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_521 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_536 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_551 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_566 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_581 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_586 = tmp_qloop_128*2.0 + tmp_qloop_162 + tmp_qloop_163 + tmp_qloop_164;
                   const real_t tmp_qloop_593 = tmp_qloop_440*tmp_qloop_586 + tmp_qloop_589;
                   const real_t tmp_qloop_594 = tmp_qloop_141 + tmp_qloop_593;
                   const real_t tmp_qloop_597 = tmp_qloop_128*2.0 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177;
                   const real_t tmp_qloop_602 = tmp_qloop_440*tmp_qloop_597 + tmp_qloop_599;
                   const real_t tmp_qloop_603 = tmp_qloop_141 + tmp_qloop_602;
                   const real_t tmp_qloop_606 = tmp_qloop_128*2.0 + tmp_qloop_188 + tmp_qloop_189 + tmp_qloop_190;
                   const real_t tmp_qloop_611 = tmp_qloop_440*tmp_qloop_606 + tmp_qloop_608;
                   const real_t tmp_qloop_612 = tmp_qloop_141 + tmp_qloop_611;
                   const real_t tmp_qloop_615 = tmp_qloop_128*2.0 + tmp_qloop_201 + tmp_qloop_202 + tmp_qloop_203;
                   const real_t tmp_qloop_620 = tmp_qloop_440*tmp_qloop_615 + tmp_qloop_617;
                   const real_t tmp_qloop_621 = tmp_qloop_141 + tmp_qloop_620;
                   const real_t tmp_qloop_624 = tmp_qloop_128*2.0 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216;
                   const real_t tmp_qloop_629 = tmp_qloop_440*tmp_qloop_624 + tmp_qloop_626;
                   const real_t tmp_qloop_630 = tmp_qloop_141 + tmp_qloop_629;
                   const real_t tmp_qloop_633 = tmp_qloop_128*2.0 + tmp_qloop_227 + tmp_qloop_228 + tmp_qloop_229;
                   const real_t tmp_qloop_638 = tmp_qloop_440*tmp_qloop_633 + tmp_qloop_635;
                   const real_t tmp_qloop_639 = tmp_qloop_141 + tmp_qloop_638;
                   const real_t tmp_qloop_642 = tmp_qloop_128*2.0 + tmp_qloop_240 + tmp_qloop_241 + tmp_qloop_242;
                   const real_t tmp_qloop_647 = tmp_qloop_440*tmp_qloop_642 + tmp_qloop_644;
                   const real_t tmp_qloop_648 = tmp_qloop_141 + tmp_qloop_647;
                   const real_t tmp_qloop_651 = tmp_qloop_128*2.0 + tmp_qloop_253 + tmp_qloop_254 + tmp_qloop_255;
                   const real_t tmp_qloop_656 = tmp_qloop_440*tmp_qloop_651 + tmp_qloop_653;
                   const real_t tmp_qloop_657 = tmp_qloop_141 + tmp_qloop_656;
                   const real_t tmp_qloop_660 = tmp_qloop_128*2.0 + tmp_qloop_266 + tmp_qloop_267 + tmp_qloop_268;
                   const real_t tmp_qloop_665 = tmp_qloop_440*tmp_qloop_660 + tmp_qloop_662;
                   const real_t tmp_qloop_666 = tmp_qloop_141 + tmp_qloop_665;
                   const real_t tmp_qloop_670 = tmp_qloop_274*1.0 + tmp_qloop_275*1.0 + tmp_qloop_276*1.0;
                   const real_t tmp_qloop_671 = tmp_qloop_286*0.5 + tmp_qloop_287*0.5 + tmp_qloop_288*0.5;
                   const real_t tmp_qloop_672 = tmp_qloop_283 + tmp_qloop_284 + tmp_qloop_285 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_678 = tmp_qloop_140*tmp_qloop_670 + tmp_qloop_440*tmp_qloop_672 + tmp_qloop_674;
                   const real_t tmp_qloop_690 = tmp_qloop_305*1.0 + tmp_qloop_306*1.0 + tmp_qloop_307*1.0;
                   const real_t tmp_qloop_691 = tmp_qloop_309 + tmp_qloop_310 + tmp_qloop_311 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_694 = tmp_qloop_140*tmp_qloop_690 + tmp_qloop_440*tmp_qloop_691;
                   const real_t tmp_qloop_695 = tmp_qloop_674 + tmp_qloop_694;
                   const real_t tmp_qloop_697 = tmp_qloop_319*1.0 + tmp_qloop_320*1.0 + tmp_qloop_321*1.0;
                   const real_t tmp_qloop_698 = tmp_qloop_323 + tmp_qloop_324 + tmp_qloop_325 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_700 = tmp_qloop_140*tmp_qloop_697 + tmp_qloop_440*tmp_qloop_698;
                   const real_t tmp_qloop_701 = tmp_qloop_674 + tmp_qloop_700;
                   const real_t tmp_qloop_703 = tmp_qloop_333*1.0 + tmp_qloop_334*1.0 + tmp_qloop_335*1.0;
                   const real_t tmp_qloop_704 = tmp_qloop_337 + tmp_qloop_338 + tmp_qloop_339 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_706 = tmp_qloop_140*tmp_qloop_703 + tmp_qloop_440*tmp_qloop_704;
                   const real_t tmp_qloop_707 = tmp_qloop_674 + tmp_qloop_706;
                   const real_t tmp_qloop_709 = tmp_qloop_347*1.0 + tmp_qloop_348*1.0 + tmp_qloop_349*1.0;
                   const real_t tmp_qloop_710 = tmp_qloop_351 + tmp_qloop_352 + tmp_qloop_353 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_712 = tmp_qloop_140*tmp_qloop_709 + tmp_qloop_440*tmp_qloop_710;
                   const real_t tmp_qloop_713 = tmp_qloop_674 + tmp_qloop_712;
                   const real_t tmp_qloop_715 = tmp_qloop_361*1.0 + tmp_qloop_362*1.0 + tmp_qloop_363*1.0;
                   const real_t tmp_qloop_716 = tmp_qloop_365 + tmp_qloop_366 + tmp_qloop_367 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_718 = tmp_qloop_140*tmp_qloop_715 + tmp_qloop_440*tmp_qloop_716;
                   const real_t tmp_qloop_719 = tmp_qloop_674 + tmp_qloop_718;
                   const real_t tmp_qloop_721 = tmp_qloop_375*1.0 + tmp_qloop_376*1.0 + tmp_qloop_377*1.0;
                   const real_t tmp_qloop_722 = tmp_qloop_379 + tmp_qloop_380 + tmp_qloop_381 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_724 = tmp_qloop_140*tmp_qloop_721 + tmp_qloop_440*tmp_qloop_722;
                   const real_t tmp_qloop_725 = tmp_qloop_674 + tmp_qloop_724;
                   const real_t tmp_qloop_727 = tmp_qloop_389*1.0 + tmp_qloop_390*1.0 + tmp_qloop_391*1.0;
                   const real_t tmp_qloop_728 = tmp_qloop_393 + tmp_qloop_394 + tmp_qloop_395 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_730 = tmp_qloop_140*tmp_qloop_727 + tmp_qloop_440*tmp_qloop_728;
                   const real_t tmp_qloop_731 = tmp_qloop_674 + tmp_qloop_730;
                   const real_t tmp_qloop_733 = tmp_qloop_403*1.0 + tmp_qloop_404*1.0 + tmp_qloop_405*1.0;
                   const real_t tmp_qloop_734 = tmp_qloop_407 + tmp_qloop_408 + tmp_qloop_409 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_736 = tmp_qloop_140*tmp_qloop_733 + tmp_qloop_440*tmp_qloop_734;
                   const real_t tmp_qloop_737 = tmp_qloop_674 + tmp_qloop_736;
                   const real_t tmp_qloop_739 = tmp_qloop_417*1.0 + tmp_qloop_418*1.0 + tmp_qloop_419*1.0;
                   const real_t tmp_qloop_740 = tmp_qloop_421 + tmp_qloop_422 + tmp_qloop_423 + tmp_qloop_671*2.0;
                   const real_t tmp_qloop_742 = tmp_qloop_140*tmp_qloop_739 + tmp_qloop_440*tmp_qloop_740;
                   const real_t tmp_qloop_743 = tmp_qloop_674 + tmp_qloop_742;
                   const real_t tmp_qloop_744 = tmp_qloop_116 + tmp_qloop_667;
                   const real_t tmp_qloop_749 = tmp_qloop_141 + tmp_qloop_440*(tmp_qloop_128 + tmp_qloop_671)*2.0 + tmp_qloop_674;
                   const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                   const real_t tmp_qloop_108 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_109 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663;
                   const real_t tmp_qloop_114 = tmp_qloop_109 + tmp_qloop_113;
                   const real_t tmp_qloop_115 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108;
                   const real_t tmp_qloop_117 = tmp_qloop_115 + tmp_qloop_116;
                   const real_t tmp_qloop_119 = tmp_qloop_118*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_117);
                   const real_t tmp_qloop_132 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_138 = tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_137*2.0;
                   const real_t tmp_qloop_142 = tmp_qloop_106*1.0 + tmp_qloop_107*1.0 + tmp_qloop_108*1.0;
                   const real_t tmp_qloop_143 = tmp_qloop_142*(tmp_qloop_106*2.0 + tmp_qloop_107*2.0 + tmp_qloop_108*2.0);
                   const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q];
                   const real_t tmp_qloop_151 = tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150;
                   const real_t tmp_qloop_153 = tmp_qloop_148*0.5 + tmp_qloop_149*0.5 + tmp_qloop_150*0.5;
                   const real_t tmp_qloop_154 = tmp_qloop_152*2.0 + tmp_qloop_153*2.0;
                   const real_t tmp_qloop_155 = tmp_qloop_141 + tmp_qloop_143 + tmp_qloop_154*(tmp_qloop_147 + tmp_qloop_151);
                   const real_t tmp_qloop_160 = tmp_qloop_114 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663;
                   const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_169 = tmp_qloop_136 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_173 = tmp_qloop_114 + tmp_qloop_170*0.66666666666666663 + tmp_qloop_171*0.66666666666666663 + tmp_qloop_172*0.66666666666666663;
                   const real_t tmp_qloop_181 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_182 = tmp_qloop_136 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_186 = tmp_qloop_114 + tmp_qloop_183*0.66666666666666663 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663;
                   const real_t tmp_qloop_194 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_195 = tmp_qloop_136 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_199 = tmp_qloop_114 + tmp_qloop_196*0.66666666666666663 + tmp_qloop_197*0.66666666666666663 + tmp_qloop_198*0.66666666666666663;
                   const real_t tmp_qloop_207 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_208 = tmp_qloop_136 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_212 = tmp_qloop_114 + tmp_qloop_209*0.66666666666666663 + tmp_qloop_210*0.66666666666666663 + tmp_qloop_211*0.66666666666666663;
                   const real_t tmp_qloop_220 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_221 = tmp_qloop_136 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_225 = tmp_qloop_114 + tmp_qloop_222*0.66666666666666663 + tmp_qloop_223*0.66666666666666663 + tmp_qloop_224*0.66666666666666663;
                   const real_t tmp_qloop_233 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_234 = tmp_qloop_136 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_238 = tmp_qloop_114 + tmp_qloop_235*0.66666666666666663 + tmp_qloop_236*0.66666666666666663 + tmp_qloop_237*0.66666666666666663;
                   const real_t tmp_qloop_246 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_247 = tmp_qloop_136 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_251 = tmp_qloop_114 + tmp_qloop_248*0.66666666666666663 + tmp_qloop_249*0.66666666666666663 + tmp_qloop_250*0.66666666666666663;
                   const real_t tmp_qloop_259 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_260 = tmp_qloop_136 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_264 = tmp_qloop_114 + tmp_qloop_261*0.66666666666666663 + tmp_qloop_262*0.66666666666666663 + tmp_qloop_263*0.66666666666666663;
                   const real_t tmp_qloop_272 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_273 = tmp_qloop_136 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_281 = tmp_qloop_109 + tmp_qloop_280;
                   const real_t tmp_qloop_282 = tmp_qloop_274*0.66666666666666663 + tmp_qloop_275*0.66666666666666663 + tmp_qloop_276*0.66666666666666663 + tmp_qloop_281;
                   const real_t tmp_qloop_295 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_296 = tmp_qloop_293 + tmp_qloop_294 + tmp_qloop_295;
                   const real_t tmp_qloop_297 = tmp_qloop_136 + tmp_qloop_296;
                   const real_t tmp_qloop_298 = tmp_qloop_138*tmp_qloop_297 + tmp_qloop_143 + tmp_qloop_292;
                   const real_t tmp_qloop_302 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_303 = tmp_qloop_147 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_304 = tmp_qloop_139*tmp_qloop_299 + tmp_qloop_154*tmp_qloop_303;
                   const real_t tmp_qloop_308 = tmp_qloop_281 + tmp_qloop_305*0.66666666666666663 + tmp_qloop_306*0.66666666666666663 + tmp_qloop_307*0.66666666666666663;
                   const real_t tmp_qloop_316 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_317 = tmp_qloop_147 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_318 = tmp_qloop_139*tmp_qloop_313 + tmp_qloop_154*tmp_qloop_317;
                   const real_t tmp_qloop_322 = tmp_qloop_281 + tmp_qloop_319*0.66666666666666663 + tmp_qloop_320*0.66666666666666663 + tmp_qloop_321*0.66666666666666663;
                   const real_t tmp_qloop_330 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_331 = tmp_qloop_147 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_332 = tmp_qloop_139*tmp_qloop_327 + tmp_qloop_154*tmp_qloop_331;
                   const real_t tmp_qloop_336 = tmp_qloop_281 + tmp_qloop_333*0.66666666666666663 + tmp_qloop_334*0.66666666666666663 + tmp_qloop_335*0.66666666666666663;
                   const real_t tmp_qloop_344 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_345 = tmp_qloop_147 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_346 = tmp_qloop_139*tmp_qloop_341 + tmp_qloop_154*tmp_qloop_345;
                   const real_t tmp_qloop_350 = tmp_qloop_281 + tmp_qloop_347*0.66666666666666663 + tmp_qloop_348*0.66666666666666663 + tmp_qloop_349*0.66666666666666663;
                   const real_t tmp_qloop_358 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_359 = tmp_qloop_147 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_360 = tmp_qloop_139*tmp_qloop_355 + tmp_qloop_154*tmp_qloop_359;
                   const real_t tmp_qloop_364 = tmp_qloop_281 + tmp_qloop_361*0.66666666666666663 + tmp_qloop_362*0.66666666666666663 + tmp_qloop_363*0.66666666666666663;
                   const real_t tmp_qloop_372 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_373 = tmp_qloop_147 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_374 = tmp_qloop_139*tmp_qloop_369 + tmp_qloop_154*tmp_qloop_373;
                   const real_t tmp_qloop_378 = tmp_qloop_281 + tmp_qloop_375*0.66666666666666663 + tmp_qloop_376*0.66666666666666663 + tmp_qloop_377*0.66666666666666663;
                   const real_t tmp_qloop_386 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_387 = tmp_qloop_147 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_388 = tmp_qloop_139*tmp_qloop_383 + tmp_qloop_154*tmp_qloop_387;
                   const real_t tmp_qloop_392 = tmp_qloop_281 + tmp_qloop_389*0.66666666666666663 + tmp_qloop_390*0.66666666666666663 + tmp_qloop_391*0.66666666666666663;
                   const real_t tmp_qloop_400 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_401 = tmp_qloop_147 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_402 = tmp_qloop_139*tmp_qloop_397 + tmp_qloop_154*tmp_qloop_401;
                   const real_t tmp_qloop_406 = tmp_qloop_281 + tmp_qloop_403*0.66666666666666663 + tmp_qloop_404*0.66666666666666663 + tmp_qloop_405*0.66666666666666663;
                   const real_t tmp_qloop_414 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_415 = tmp_qloop_147 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_416 = tmp_qloop_139*tmp_qloop_411 + tmp_qloop_154*tmp_qloop_415;
                   const real_t tmp_qloop_420 = tmp_qloop_281 + tmp_qloop_417*0.66666666666666663 + tmp_qloop_418*0.66666666666666663 + tmp_qloop_419*0.66666666666666663;
                   const real_t tmp_qloop_428 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_429 = tmp_qloop_147 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_430 = tmp_qloop_139*tmp_qloop_425 + tmp_qloop_154*tmp_qloop_429;
                   const real_t tmp_qloop_433 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 1];
                   const real_t tmp_qloop_435 = tmp_qloop_431*0.66666666666666663 + tmp_qloop_432*0.66666666666666663 + tmp_qloop_433*0.66666666666666663 + tmp_qloop_434;
                   const real_t tmp_qloop_439 = tmp_qloop_296 + tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438;
                   const real_t tmp_qloop_442 = tmp_qloop_431*2.0 + tmp_qloop_432*2.0 + tmp_qloop_433*2.0;
                   const real_t tmp_qloop_443 = tmp_qloop_142*tmp_qloop_442;
                   const real_t tmp_qloop_447 = tmp_qloop_151 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_448 = tmp_qloop_154*tmp_qloop_447 + tmp_qloop_443;
                   const real_t tmp_qloop_451 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 2];
                   const real_t tmp_qloop_452 = tmp_qloop_434 + tmp_qloop_449*0.66666666666666663 + tmp_qloop_450*0.66666666666666663 + tmp_qloop_451*0.66666666666666663;
                   const real_t tmp_qloop_456 = tmp_qloop_296 + tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455;
                   const real_t tmp_qloop_457 = tmp_qloop_449*2.0 + tmp_qloop_450*2.0 + tmp_qloop_451*2.0;
                   const real_t tmp_qloop_458 = tmp_qloop_142*tmp_qloop_457;
                   const real_t tmp_qloop_462 = tmp_qloop_151 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_463 = tmp_qloop_154*tmp_qloop_462 + tmp_qloop_458;
                   const real_t tmp_qloop_466 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 3];
                   const real_t tmp_qloop_467 = tmp_qloop_434 + tmp_qloop_464*0.66666666666666663 + tmp_qloop_465*0.66666666666666663 + tmp_qloop_466*0.66666666666666663;
                   const real_t tmp_qloop_471 = tmp_qloop_296 + tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470;
                   const real_t tmp_qloop_472 = tmp_qloop_464*2.0 + tmp_qloop_465*2.0 + tmp_qloop_466*2.0;
                   const real_t tmp_qloop_473 = tmp_qloop_142*tmp_qloop_472;
                   const real_t tmp_qloop_477 = tmp_qloop_151 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_478 = tmp_qloop_154*tmp_qloop_477 + tmp_qloop_473;
                   const real_t tmp_qloop_481 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 4];
                   const real_t tmp_qloop_482 = tmp_qloop_434 + tmp_qloop_479*0.66666666666666663 + tmp_qloop_480*0.66666666666666663 + tmp_qloop_481*0.66666666666666663;
                   const real_t tmp_qloop_486 = tmp_qloop_296 + tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485;
                   const real_t tmp_qloop_487 = tmp_qloop_479*2.0 + tmp_qloop_480*2.0 + tmp_qloop_481*2.0;
                   const real_t tmp_qloop_488 = tmp_qloop_142*tmp_qloop_487;
                   const real_t tmp_qloop_492 = tmp_qloop_151 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_493 = tmp_qloop_154*tmp_qloop_492 + tmp_qloop_488;
                   const real_t tmp_qloop_496 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 5];
                   const real_t tmp_qloop_497 = tmp_qloop_434 + tmp_qloop_494*0.66666666666666663 + tmp_qloop_495*0.66666666666666663 + tmp_qloop_496*0.66666666666666663;
                   const real_t tmp_qloop_501 = tmp_qloop_296 + tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500;
                   const real_t tmp_qloop_502 = tmp_qloop_494*2.0 + tmp_qloop_495*2.0 + tmp_qloop_496*2.0;
                   const real_t tmp_qloop_503 = tmp_qloop_142*tmp_qloop_502;
                   const real_t tmp_qloop_507 = tmp_qloop_151 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_508 = tmp_qloop_154*tmp_qloop_507 + tmp_qloop_503;
                   const real_t tmp_qloop_511 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 6];
                   const real_t tmp_qloop_512 = tmp_qloop_434 + tmp_qloop_509*0.66666666666666663 + tmp_qloop_510*0.66666666666666663 + tmp_qloop_511*0.66666666666666663;
                   const real_t tmp_qloop_516 = tmp_qloop_296 + tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515;
                   const real_t tmp_qloop_517 = tmp_qloop_509*2.0 + tmp_qloop_510*2.0 + tmp_qloop_511*2.0;
                   const real_t tmp_qloop_518 = tmp_qloop_142*tmp_qloop_517;
                   const real_t tmp_qloop_522 = tmp_qloop_151 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_523 = tmp_qloop_154*tmp_qloop_522 + tmp_qloop_518;
                   const real_t tmp_qloop_526 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 7];
                   const real_t tmp_qloop_527 = tmp_qloop_434 + tmp_qloop_524*0.66666666666666663 + tmp_qloop_525*0.66666666666666663 + tmp_qloop_526*0.66666666666666663;
                   const real_t tmp_qloop_531 = tmp_qloop_296 + tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530;
                   const real_t tmp_qloop_532 = tmp_qloop_524*2.0 + tmp_qloop_525*2.0 + tmp_qloop_526*2.0;
                   const real_t tmp_qloop_533 = tmp_qloop_142*tmp_qloop_532;
                   const real_t tmp_qloop_537 = tmp_qloop_151 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_538 = tmp_qloop_154*tmp_qloop_537 + tmp_qloop_533;
                   const real_t tmp_qloop_541 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 8];
                   const real_t tmp_qloop_542 = tmp_qloop_434 + tmp_qloop_539*0.66666666666666663 + tmp_qloop_540*0.66666666666666663 + tmp_qloop_541*0.66666666666666663;
                   const real_t tmp_qloop_546 = tmp_qloop_296 + tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545;
                   const real_t tmp_qloop_547 = tmp_qloop_539*2.0 + tmp_qloop_540*2.0 + tmp_qloop_541*2.0;
                   const real_t tmp_qloop_548 = tmp_qloop_142*tmp_qloop_547;
                   const real_t tmp_qloop_552 = tmp_qloop_151 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_553 = tmp_qloop_154*tmp_qloop_552 + tmp_qloop_548;
                   const real_t tmp_qloop_556 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 9];
                   const real_t tmp_qloop_557 = tmp_qloop_434 + tmp_qloop_554*0.66666666666666663 + tmp_qloop_555*0.66666666666666663 + tmp_qloop_556*0.66666666666666663;
                   const real_t tmp_qloop_561 = tmp_qloop_296 + tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560;
                   const real_t tmp_qloop_562 = tmp_qloop_554*2.0 + tmp_qloop_555*2.0 + tmp_qloop_556*2.0;
                   const real_t tmp_qloop_563 = tmp_qloop_142*tmp_qloop_562;
                   const real_t tmp_qloop_567 = tmp_qloop_151 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t tmp_qloop_568 = tmp_qloop_154*tmp_qloop_567 + tmp_qloop_563;
                   const real_t tmp_qloop_571 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[11*q + 10];
                   const real_t tmp_qloop_572 = tmp_qloop_434 + tmp_qloop_569*0.66666666666666663 + tmp_qloop_570*0.66666666666666663 + tmp_qloop_571*0.66666666666666663;
                   const real_t tmp_qloop_576 = tmp_qloop_296 + tmp_qloop_573 + tmp_qloop_574 + tmp_qloop_575;
                   const real_t tmp_qloop_577 = tmp_qloop_569*2.0 + tmp_qloop_570*2.0 + tmp_qloop_571*2.0;
                   const real_t tmp_qloop_578 = tmp_qloop_142*tmp_qloop_577;
                   const real_t tmp_qloop_582 = tmp_qloop_151 + tmp_qloop_579 + tmp_qloop_580 + tmp_qloop_581;
                   const real_t tmp_qloop_583 = tmp_qloop_154*tmp_qloop_582 + tmp_qloop_578;
                   const real_t tmp_qloop_584 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159);
                   const real_t tmp_qloop_587 = tmp_qloop_137*2.0 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168;
                   const real_t tmp_qloop_588 = tmp_qloop_143 + tmp_qloop_304;
                   const real_t tmp_qloop_590 = tmp_qloop_297*tmp_qloop_587 + tmp_qloop_589;
                   const real_t tmp_qloop_591 = tmp_qloop_143 + tmp_qloop_590;
                   const real_t tmp_qloop_592 = tmp_qloop_141 + tmp_qloop_448;
                   const real_t tmp_qloop_595 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_170 + tmp_qloop_171 + tmp_qloop_172);
                   const real_t tmp_qloop_598 = tmp_qloop_137*2.0 + tmp_qloop_179 + tmp_qloop_180 + tmp_qloop_181;
                   const real_t tmp_qloop_600 = tmp_qloop_297*tmp_qloop_598 + tmp_qloop_599;
                   const real_t tmp_qloop_601 = tmp_qloop_143 + tmp_qloop_600;
                   const real_t tmp_qloop_604 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_183 + tmp_qloop_184 + tmp_qloop_185);
                   const real_t tmp_qloop_607 = tmp_qloop_137*2.0 + tmp_qloop_192 + tmp_qloop_193 + tmp_qloop_194;
                   const real_t tmp_qloop_609 = tmp_qloop_297*tmp_qloop_607 + tmp_qloop_608;
                   const real_t tmp_qloop_610 = tmp_qloop_143 + tmp_qloop_609;
                   const real_t tmp_qloop_613 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198);
                   const real_t tmp_qloop_616 = tmp_qloop_137*2.0 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207;
                   const real_t tmp_qloop_618 = tmp_qloop_297*tmp_qloop_616 + tmp_qloop_617;
                   const real_t tmp_qloop_619 = tmp_qloop_143 + tmp_qloop_618;
                   const real_t tmp_qloop_622 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_209 + tmp_qloop_210 + tmp_qloop_211);
                   const real_t tmp_qloop_625 = tmp_qloop_137*2.0 + tmp_qloop_218 + tmp_qloop_219 + tmp_qloop_220;
                   const real_t tmp_qloop_627 = tmp_qloop_297*tmp_qloop_625 + tmp_qloop_626;
                   const real_t tmp_qloop_628 = tmp_qloop_143 + tmp_qloop_627;
                   const real_t tmp_qloop_631 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_222 + tmp_qloop_223 + tmp_qloop_224);
                   const real_t tmp_qloop_634 = tmp_qloop_137*2.0 + tmp_qloop_231 + tmp_qloop_232 + tmp_qloop_233;
                   const real_t tmp_qloop_636 = tmp_qloop_297*tmp_qloop_634 + tmp_qloop_635;
                   const real_t tmp_qloop_637 = tmp_qloop_143 + tmp_qloop_636;
                   const real_t tmp_qloop_640 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_235 + tmp_qloop_236 + tmp_qloop_237);
                   const real_t tmp_qloop_643 = tmp_qloop_137*2.0 + tmp_qloop_244 + tmp_qloop_245 + tmp_qloop_246;
                   const real_t tmp_qloop_645 = tmp_qloop_297*tmp_qloop_643 + tmp_qloop_644;
                   const real_t tmp_qloop_646 = tmp_qloop_143 + tmp_qloop_645;
                   const real_t tmp_qloop_649 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_248 + tmp_qloop_249 + tmp_qloop_250);
                   const real_t tmp_qloop_652 = tmp_qloop_137*2.0 + tmp_qloop_257 + tmp_qloop_258 + tmp_qloop_259;
                   const real_t tmp_qloop_654 = tmp_qloop_297*tmp_qloop_652 + tmp_qloop_653;
                   const real_t tmp_qloop_655 = tmp_qloop_143 + tmp_qloop_654;
                   const real_t tmp_qloop_658 = tmp_qloop_118*(tmp_qloop_117 + tmp_qloop_261 + tmp_qloop_262 + tmp_qloop_263);
                   const real_t tmp_qloop_661 = tmp_qloop_137*2.0 + tmp_qloop_270 + tmp_qloop_271 + tmp_qloop_272;
                   const real_t tmp_qloop_663 = tmp_qloop_297*tmp_qloop_661 + tmp_qloop_662;
                   const real_t tmp_qloop_664 = tmp_qloop_143 + tmp_qloop_663;
                   const real_t tmp_qloop_668 = tmp_qloop_115 + tmp_qloop_667;
                   const real_t tmp_qloop_669 = tmp_qloop_118*(tmp_qloop_274 + tmp_qloop_275 + tmp_qloop_276 + tmp_qloop_668);
                   const real_t tmp_qloop_673 = tmp_qloop_152*2.0 + tmp_qloop_300 + tmp_qloop_301 + tmp_qloop_302;
                   const real_t tmp_qloop_675 = tmp_qloop_293*0.5 + tmp_qloop_294*0.5 + tmp_qloop_295*0.5;
                   const real_t tmp_qloop_676 = tmp_qloop_137*2.0 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_677 = tmp_qloop_143 + tmp_qloop_297*tmp_qloop_676 + tmp_qloop_674;
                   const real_t tmp_qloop_679 = tmp_qloop_439*tmp_qloop_676 + tmp_qloop_443;
                   const real_t tmp_qloop_680 = tmp_qloop_456*tmp_qloop_676 + tmp_qloop_458;
                   const real_t tmp_qloop_681 = tmp_qloop_471*tmp_qloop_676 + tmp_qloop_473;
                   const real_t tmp_qloop_682 = tmp_qloop_486*tmp_qloop_676 + tmp_qloop_488;
                   const real_t tmp_qloop_683 = tmp_qloop_501*tmp_qloop_676 + tmp_qloop_503;
                   const real_t tmp_qloop_684 = tmp_qloop_516*tmp_qloop_676 + tmp_qloop_518;
                   const real_t tmp_qloop_685 = tmp_qloop_531*tmp_qloop_676 + tmp_qloop_533;
                   const real_t tmp_qloop_686 = tmp_qloop_546*tmp_qloop_676 + tmp_qloop_548;
                   const real_t tmp_qloop_687 = tmp_qloop_561*tmp_qloop_676 + tmp_qloop_563;
                   const real_t tmp_qloop_688 = tmp_qloop_576*tmp_qloop_676 + tmp_qloop_578;
                   const real_t tmp_qloop_689 = tmp_qloop_118*(tmp_qloop_305 + tmp_qloop_306 + tmp_qloop_307 + tmp_qloop_668);
                   const real_t tmp_qloop_692 = tmp_qloop_152*2.0 + tmp_qloop_314 + tmp_qloop_315 + tmp_qloop_316;
                   const real_t tmp_qloop_693 = tmp_qloop_674 + tmp_qloop_679;
                   const real_t tmp_qloop_696 = tmp_qloop_118*(tmp_qloop_319 + tmp_qloop_320 + tmp_qloop_321 + tmp_qloop_668);
                   const real_t tmp_qloop_699 = tmp_qloop_152*2.0 + tmp_qloop_328 + tmp_qloop_329 + tmp_qloop_330;
                   const real_t tmp_qloop_702 = tmp_qloop_118*(tmp_qloop_333 + tmp_qloop_334 + tmp_qloop_335 + tmp_qloop_668);
                   const real_t tmp_qloop_705 = tmp_qloop_152*2.0 + tmp_qloop_342 + tmp_qloop_343 + tmp_qloop_344;
                   const real_t tmp_qloop_708 = tmp_qloop_118*(tmp_qloop_347 + tmp_qloop_348 + tmp_qloop_349 + tmp_qloop_668);
                   const real_t tmp_qloop_711 = tmp_qloop_152*2.0 + tmp_qloop_356 + tmp_qloop_357 + tmp_qloop_358;
                   const real_t tmp_qloop_714 = tmp_qloop_118*(tmp_qloop_361 + tmp_qloop_362 + tmp_qloop_363 + tmp_qloop_668);
                   const real_t tmp_qloop_717 = tmp_qloop_152*2.0 + tmp_qloop_370 + tmp_qloop_371 + tmp_qloop_372;
                   const real_t tmp_qloop_720 = tmp_qloop_118*(tmp_qloop_375 + tmp_qloop_376 + tmp_qloop_377 + tmp_qloop_668);
                   const real_t tmp_qloop_723 = tmp_qloop_152*2.0 + tmp_qloop_384 + tmp_qloop_385 + tmp_qloop_386;
                   const real_t tmp_qloop_726 = tmp_qloop_118*(tmp_qloop_389 + tmp_qloop_390 + tmp_qloop_391 + tmp_qloop_668);
                   const real_t tmp_qloop_729 = tmp_qloop_152*2.0 + tmp_qloop_398 + tmp_qloop_399 + tmp_qloop_400;
                   const real_t tmp_qloop_732 = tmp_qloop_118*(tmp_qloop_403 + tmp_qloop_404 + tmp_qloop_405 + tmp_qloop_668);
                   const real_t tmp_qloop_735 = tmp_qloop_152*2.0 + tmp_qloop_412 + tmp_qloop_413 + tmp_qloop_414;
                   const real_t tmp_qloop_738 = tmp_qloop_118*(tmp_qloop_417 + tmp_qloop_418 + tmp_qloop_419 + tmp_qloop_668);
                   const real_t tmp_qloop_741 = tmp_qloop_152*2.0 + tmp_qloop_426 + tmp_qloop_427 + tmp_qloop_428;
                   const real_t tmp_qloop_745 = tmp_qloop_118*(tmp_qloop_431 + tmp_qloop_432 + tmp_qloop_433 + tmp_qloop_744);
                   const real_t tmp_qloop_746 = tmp_qloop_431*1.0 + tmp_qloop_432*1.0 + tmp_qloop_433*1.0;
                   const real_t tmp_qloop_747 = tmp_qloop_436 + tmp_qloop_437 + tmp_qloop_438 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_748 = tmp_qloop_153*2.0 + tmp_qloop_444 + tmp_qloop_445 + tmp_qloop_446;
                   const real_t tmp_qloop_750 = tmp_qloop_118*(tmp_qloop_449 + tmp_qloop_450 + tmp_qloop_451 + tmp_qloop_744);
                   const real_t tmp_qloop_751 = tmp_qloop_449*1.0 + tmp_qloop_450*1.0 + tmp_qloop_451*1.0;
                   const real_t tmp_qloop_752 = tmp_qloop_453 + tmp_qloop_454 + tmp_qloop_455 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_753 = tmp_qloop_153*2.0 + tmp_qloop_459 + tmp_qloop_460 + tmp_qloop_461;
                   const real_t tmp_qloop_754 = tmp_qloop_118*(tmp_qloop_464 + tmp_qloop_465 + tmp_qloop_466 + tmp_qloop_744);
                   const real_t tmp_qloop_755 = tmp_qloop_464*1.0 + tmp_qloop_465*1.0 + tmp_qloop_466*1.0;
                   const real_t tmp_qloop_756 = tmp_qloop_468 + tmp_qloop_469 + tmp_qloop_470 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_757 = tmp_qloop_153*2.0 + tmp_qloop_474 + tmp_qloop_475 + tmp_qloop_476;
                   const real_t tmp_qloop_758 = tmp_qloop_118*(tmp_qloop_479 + tmp_qloop_480 + tmp_qloop_481 + tmp_qloop_744);
                   const real_t tmp_qloop_759 = tmp_qloop_479*1.0 + tmp_qloop_480*1.0 + tmp_qloop_481*1.0;
                   const real_t tmp_qloop_760 = tmp_qloop_483 + tmp_qloop_484 + tmp_qloop_485 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_761 = tmp_qloop_153*2.0 + tmp_qloop_489 + tmp_qloop_490 + tmp_qloop_491;
                   const real_t tmp_qloop_762 = tmp_qloop_118*(tmp_qloop_494 + tmp_qloop_495 + tmp_qloop_496 + tmp_qloop_744);
                   const real_t tmp_qloop_763 = tmp_qloop_494*1.0 + tmp_qloop_495*1.0 + tmp_qloop_496*1.0;
                   const real_t tmp_qloop_764 = tmp_qloop_498 + tmp_qloop_499 + tmp_qloop_500 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_765 = tmp_qloop_153*2.0 + tmp_qloop_504 + tmp_qloop_505 + tmp_qloop_506;
                   const real_t tmp_qloop_766 = tmp_qloop_118*(tmp_qloop_509 + tmp_qloop_510 + tmp_qloop_511 + tmp_qloop_744);
                   const real_t tmp_qloop_767 = tmp_qloop_509*1.0 + tmp_qloop_510*1.0 + tmp_qloop_511*1.0;
                   const real_t tmp_qloop_768 = tmp_qloop_513 + tmp_qloop_514 + tmp_qloop_515 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_769 = tmp_qloop_153*2.0 + tmp_qloop_519 + tmp_qloop_520 + tmp_qloop_521;
                   const real_t tmp_qloop_770 = tmp_qloop_118*(tmp_qloop_524 + tmp_qloop_525 + tmp_qloop_526 + tmp_qloop_744);
                   const real_t tmp_qloop_771 = tmp_qloop_524*1.0 + tmp_qloop_525*1.0 + tmp_qloop_526*1.0;
                   const real_t tmp_qloop_772 = tmp_qloop_528 + tmp_qloop_529 + tmp_qloop_530 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_773 = tmp_qloop_153*2.0 + tmp_qloop_534 + tmp_qloop_535 + tmp_qloop_536;
                   const real_t tmp_qloop_774 = tmp_qloop_118*(tmp_qloop_539 + tmp_qloop_540 + tmp_qloop_541 + tmp_qloop_744);
                   const real_t tmp_qloop_775 = tmp_qloop_539*1.0 + tmp_qloop_540*1.0 + tmp_qloop_541*1.0;
                   const real_t tmp_qloop_776 = tmp_qloop_543 + tmp_qloop_544 + tmp_qloop_545 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_777 = tmp_qloop_153*2.0 + tmp_qloop_549 + tmp_qloop_550 + tmp_qloop_551;
                   const real_t tmp_qloop_778 = tmp_qloop_118*(tmp_qloop_554 + tmp_qloop_555 + tmp_qloop_556 + tmp_qloop_744);
                   const real_t tmp_qloop_779 = tmp_qloop_554*1.0 + tmp_qloop_555*1.0 + tmp_qloop_556*1.0;
                   const real_t tmp_qloop_780 = tmp_qloop_558 + tmp_qloop_559 + tmp_qloop_560 + tmp_qloop_675*2.0;
                   const real_t tmp_qloop_781 = tmp_qloop_153*2.0 + tmp_qloop_564 + tmp_qloop_565 + tmp_qloop_566;
                   const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                   const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                   const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                   const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                   const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                   const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                   const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                   const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                   const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                   const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                   const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                   const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                   const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                   const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                   const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                   const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                   const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                   const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                   const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                   const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                   const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                   const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                   const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                   const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                   const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                   const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                   const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                   const real_t q_tmp_0_0 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + tmp_qloop_129*(tmp_qloop_121 + tmp_qloop_122 + tmp_qloop_123 + tmp_qloop_127) + tmp_qloop_138*(tmp_qloop_130 + tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_136) + tmp_qloop_155) - tmp_qloop_119*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_114));
                   const real_t q_tmp_0_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_161 + tmp_qloop_129*tmp_qloop_165 + tmp_qloop_138*tmp_qloop_169 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_160);
                   const real_t q_tmp_0_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_174 + tmp_qloop_129*tmp_qloop_178 + tmp_qloop_138*tmp_qloop_182 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_173);
                   const real_t q_tmp_0_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_187 + tmp_qloop_129*tmp_qloop_191 + tmp_qloop_138*tmp_qloop_195 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_186);
                   const real_t q_tmp_0_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_200 + tmp_qloop_129*tmp_qloop_204 + tmp_qloop_138*tmp_qloop_208 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_199);
                   const real_t q_tmp_0_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_213 + tmp_qloop_129*tmp_qloop_217 + tmp_qloop_138*tmp_qloop_221 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_212);
                   const real_t q_tmp_0_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_226 + tmp_qloop_129*tmp_qloop_230 + tmp_qloop_138*tmp_qloop_234 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_225);
                   const real_t q_tmp_0_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_239 + tmp_qloop_129*tmp_qloop_243 + tmp_qloop_138*tmp_qloop_247 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_238);
                   const real_t q_tmp_0_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_252 + tmp_qloop_129*tmp_qloop_256 + tmp_qloop_138*tmp_qloop_260 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_251);
                   const real_t q_tmp_0_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_120*tmp_qloop_265 + tmp_qloop_129*tmp_qloop_269 + tmp_qloop_138*tmp_qloop_273 + tmp_qloop_155) - tmp_qloop_119*tmp_qloop_264);
                   const real_t q_tmp_0_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_290 + tmp_qloop_298 + tmp_qloop_304) - tmp_qloop_119*tmp_qloop_282);
                   const real_t q_tmp_0_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_312 + tmp_qloop_298 + tmp_qloop_318) - tmp_qloop_119*tmp_qloop_308);
                   const real_t q_tmp_0_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_326 + tmp_qloop_298 + tmp_qloop_332) - tmp_qloop_119*tmp_qloop_322);
                   const real_t q_tmp_0_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_340 + tmp_qloop_298 + tmp_qloop_346) - tmp_qloop_119*tmp_qloop_336);
                   const real_t q_tmp_0_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_354 + tmp_qloop_298 + tmp_qloop_360) - tmp_qloop_119*tmp_qloop_350);
                   const real_t q_tmp_0_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_368 + tmp_qloop_298 + tmp_qloop_374) - tmp_qloop_119*tmp_qloop_364);
                   const real_t q_tmp_0_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_382 + tmp_qloop_298 + tmp_qloop_388) - tmp_qloop_119*tmp_qloop_378);
                   const real_t q_tmp_0_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_396 + tmp_qloop_298 + tmp_qloop_402) - tmp_qloop_119*tmp_qloop_392);
                   const real_t q_tmp_0_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_410 + tmp_qloop_298 + tmp_qloop_416) - tmp_qloop_119*tmp_qloop_406);
                   const real_t q_tmp_0_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_129*tmp_qloop_424 + tmp_qloop_298 + tmp_qloop_430) - tmp_qloop_119*tmp_qloop_420);
                   const real_t q_tmp_0_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_439 + tmp_qloop_441 + tmp_qloop_448) - tmp_qloop_119*tmp_qloop_435);
                   const real_t q_tmp_0_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_456 + tmp_qloop_441 + tmp_qloop_463) - tmp_qloop_119*tmp_qloop_452);
                   const real_t q_tmp_0_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_471 + tmp_qloop_441 + tmp_qloop_478) - tmp_qloop_119*tmp_qloop_467);
                   const real_t q_tmp_0_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_486 + tmp_qloop_441 + tmp_qloop_493) - tmp_qloop_119*tmp_qloop_482);
                   const real_t q_tmp_0_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_501 + tmp_qloop_441 + tmp_qloop_508) - tmp_qloop_119*tmp_qloop_497);
                   const real_t q_tmp_0_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_516 + tmp_qloop_441 + tmp_qloop_523) - tmp_qloop_119*tmp_qloop_512);
                   const real_t q_tmp_0_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_531 + tmp_qloop_441 + tmp_qloop_538) - tmp_qloop_119*tmp_qloop_527);
                   const real_t q_tmp_0_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_546 + tmp_qloop_441 + tmp_qloop_553) - tmp_qloop_119*tmp_qloop_542);
                   const real_t q_tmp_0_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_561 + tmp_qloop_441 + tmp_qloop_568) - tmp_qloop_119*tmp_qloop_557);
                   const real_t q_tmp_0_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_138*tmp_qloop_576 + tmp_qloop_441 + tmp_qloop_583) - tmp_qloop_119*tmp_qloop_572);
                   const real_t q_tmp_1_1 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_161*tmp_qloop_585 + tmp_qloop_165*tmp_qloop_586 + tmp_qloop_169*tmp_qloop_587) - tmp_qloop_160*tmp_qloop_584);
                   const real_t q_tmp_1_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_585 + tmp_qloop_178*tmp_qloop_586 + tmp_qloop_182*tmp_qloop_587) - tmp_qloop_173*tmp_qloop_584);
                   const real_t q_tmp_1_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_585 + tmp_qloop_191*tmp_qloop_586 + tmp_qloop_195*tmp_qloop_587) - tmp_qloop_186*tmp_qloop_584);
                   const real_t q_tmp_1_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_585 + tmp_qloop_204*tmp_qloop_586 + tmp_qloop_208*tmp_qloop_587) - tmp_qloop_199*tmp_qloop_584);
                   const real_t q_tmp_1_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_585 + tmp_qloop_217*tmp_qloop_586 + tmp_qloop_221*tmp_qloop_587) - tmp_qloop_212*tmp_qloop_584);
                   const real_t q_tmp_1_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_585 + tmp_qloop_230*tmp_qloop_586 + tmp_qloop_234*tmp_qloop_587) - tmp_qloop_225*tmp_qloop_584);
                   const real_t q_tmp_1_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_585 + tmp_qloop_243*tmp_qloop_586 + tmp_qloop_247*tmp_qloop_587) - tmp_qloop_238*tmp_qloop_584);
                   const real_t q_tmp_1_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_585 + tmp_qloop_256*tmp_qloop_586 + tmp_qloop_260*tmp_qloop_587) - tmp_qloop_251*tmp_qloop_584);
                   const real_t q_tmp_1_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_585 + tmp_qloop_269*tmp_qloop_586 + tmp_qloop_273*tmp_qloop_587) - tmp_qloop_264*tmp_qloop_584);
                   const real_t q_tmp_1_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_586 + tmp_qloop_588 + tmp_qloop_590) - tmp_qloop_282*tmp_qloop_584);
                   const real_t q_tmp_1_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_586 + tmp_qloop_318 + tmp_qloop_591) - tmp_qloop_308*tmp_qloop_584);
                   const real_t q_tmp_1_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_586 + tmp_qloop_332 + tmp_qloop_591) - tmp_qloop_322*tmp_qloop_584);
                   const real_t q_tmp_1_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_586 + tmp_qloop_346 + tmp_qloop_591) - tmp_qloop_336*tmp_qloop_584);
                   const real_t q_tmp_1_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_586 + tmp_qloop_360 + tmp_qloop_591) - tmp_qloop_350*tmp_qloop_584);
                   const real_t q_tmp_1_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_586 + tmp_qloop_374 + tmp_qloop_591) - tmp_qloop_364*tmp_qloop_584);
                   const real_t q_tmp_1_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_586 + tmp_qloop_388 + tmp_qloop_591) - tmp_qloop_378*tmp_qloop_584);
                   const real_t q_tmp_1_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_586 + tmp_qloop_402 + tmp_qloop_591) - tmp_qloop_392*tmp_qloop_584);
                   const real_t q_tmp_1_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_586 + tmp_qloop_416 + tmp_qloop_591) - tmp_qloop_406*tmp_qloop_584);
                   const real_t q_tmp_1_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_586 + tmp_qloop_430 + tmp_qloop_591) - tmp_qloop_420*tmp_qloop_584);
                   const real_t q_tmp_1_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_587 + tmp_qloop_592 + tmp_qloop_593) - tmp_qloop_435*tmp_qloop_584);
                   const real_t q_tmp_1_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_587 + tmp_qloop_463 + tmp_qloop_594) - tmp_qloop_452*tmp_qloop_584);
                   const real_t q_tmp_1_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_587 + tmp_qloop_478 + tmp_qloop_594) - tmp_qloop_467*tmp_qloop_584);
                   const real_t q_tmp_1_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_587 + tmp_qloop_493 + tmp_qloop_594) - tmp_qloop_482*tmp_qloop_584);
                   const real_t q_tmp_1_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_587 + tmp_qloop_508 + tmp_qloop_594) - tmp_qloop_497*tmp_qloop_584);
                   const real_t q_tmp_1_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_587 + tmp_qloop_523 + tmp_qloop_594) - tmp_qloop_512*tmp_qloop_584);
                   const real_t q_tmp_1_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_587 + tmp_qloop_538 + tmp_qloop_594) - tmp_qloop_527*tmp_qloop_584);
                   const real_t q_tmp_1_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_587 + tmp_qloop_553 + tmp_qloop_594) - tmp_qloop_542*tmp_qloop_584);
                   const real_t q_tmp_1_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_587 + tmp_qloop_568 + tmp_qloop_594) - tmp_qloop_557*tmp_qloop_584);
                   const real_t q_tmp_1_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_587 + tmp_qloop_583 + tmp_qloop_594) - tmp_qloop_572*tmp_qloop_584);
                   const real_t q_tmp_2_2 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_174*tmp_qloop_596 + tmp_qloop_178*tmp_qloop_597 + tmp_qloop_182*tmp_qloop_598) - tmp_qloop_173*tmp_qloop_595);
                   const real_t q_tmp_2_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_596 + tmp_qloop_191*tmp_qloop_597 + tmp_qloop_195*tmp_qloop_598) - tmp_qloop_186*tmp_qloop_595);
                   const real_t q_tmp_2_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_596 + tmp_qloop_204*tmp_qloop_597 + tmp_qloop_208*tmp_qloop_598) - tmp_qloop_199*tmp_qloop_595);
                   const real_t q_tmp_2_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_596 + tmp_qloop_217*tmp_qloop_597 + tmp_qloop_221*tmp_qloop_598) - tmp_qloop_212*tmp_qloop_595);
                   const real_t q_tmp_2_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_596 + tmp_qloop_230*tmp_qloop_597 + tmp_qloop_234*tmp_qloop_598) - tmp_qloop_225*tmp_qloop_595);
                   const real_t q_tmp_2_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_596 + tmp_qloop_243*tmp_qloop_597 + tmp_qloop_247*tmp_qloop_598) - tmp_qloop_238*tmp_qloop_595);
                   const real_t q_tmp_2_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_596 + tmp_qloop_256*tmp_qloop_597 + tmp_qloop_260*tmp_qloop_598) - tmp_qloop_251*tmp_qloop_595);
                   const real_t q_tmp_2_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_596 + tmp_qloop_269*tmp_qloop_597 + tmp_qloop_273*tmp_qloop_598) - tmp_qloop_264*tmp_qloop_595);
                   const real_t q_tmp_2_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_597 + tmp_qloop_588 + tmp_qloop_600) - tmp_qloop_282*tmp_qloop_595);
                   const real_t q_tmp_2_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_597 + tmp_qloop_318 + tmp_qloop_601) - tmp_qloop_308*tmp_qloop_595);
                   const real_t q_tmp_2_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_597 + tmp_qloop_332 + tmp_qloop_601) - tmp_qloop_322*tmp_qloop_595);
                   const real_t q_tmp_2_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_597 + tmp_qloop_346 + tmp_qloop_601) - tmp_qloop_336*tmp_qloop_595);
                   const real_t q_tmp_2_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_597 + tmp_qloop_360 + tmp_qloop_601) - tmp_qloop_350*tmp_qloop_595);
                   const real_t q_tmp_2_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_597 + tmp_qloop_374 + tmp_qloop_601) - tmp_qloop_364*tmp_qloop_595);
                   const real_t q_tmp_2_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_597 + tmp_qloop_388 + tmp_qloop_601) - tmp_qloop_378*tmp_qloop_595);
                   const real_t q_tmp_2_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_597 + tmp_qloop_402 + tmp_qloop_601) - tmp_qloop_392*tmp_qloop_595);
                   const real_t q_tmp_2_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_597 + tmp_qloop_416 + tmp_qloop_601) - tmp_qloop_406*tmp_qloop_595);
                   const real_t q_tmp_2_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_597 + tmp_qloop_430 + tmp_qloop_601) - tmp_qloop_420*tmp_qloop_595);
                   const real_t q_tmp_2_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_598 + tmp_qloop_592 + tmp_qloop_602) - tmp_qloop_435*tmp_qloop_595);
                   const real_t q_tmp_2_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_598 + tmp_qloop_463 + tmp_qloop_603) - tmp_qloop_452*tmp_qloop_595);
                   const real_t q_tmp_2_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_598 + tmp_qloop_478 + tmp_qloop_603) - tmp_qloop_467*tmp_qloop_595);
                   const real_t q_tmp_2_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_598 + tmp_qloop_493 + tmp_qloop_603) - tmp_qloop_482*tmp_qloop_595);
                   const real_t q_tmp_2_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_598 + tmp_qloop_508 + tmp_qloop_603) - tmp_qloop_497*tmp_qloop_595);
                   const real_t q_tmp_2_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_598 + tmp_qloop_523 + tmp_qloop_603) - tmp_qloop_512*tmp_qloop_595);
                   const real_t q_tmp_2_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_598 + tmp_qloop_538 + tmp_qloop_603) - tmp_qloop_527*tmp_qloop_595);
                   const real_t q_tmp_2_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_598 + tmp_qloop_553 + tmp_qloop_603) - tmp_qloop_542*tmp_qloop_595);
                   const real_t q_tmp_2_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_598 + tmp_qloop_568 + tmp_qloop_603) - tmp_qloop_557*tmp_qloop_595);
                   const real_t q_tmp_2_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_598 + tmp_qloop_583 + tmp_qloop_603) - tmp_qloop_572*tmp_qloop_595);
                   const real_t q_tmp_3_3 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_187*tmp_qloop_605 + tmp_qloop_191*tmp_qloop_606 + tmp_qloop_195*tmp_qloop_607) - tmp_qloop_186*tmp_qloop_604);
                   const real_t q_tmp_3_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_605 + tmp_qloop_204*tmp_qloop_606 + tmp_qloop_208*tmp_qloop_607) - tmp_qloop_199*tmp_qloop_604);
                   const real_t q_tmp_3_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_605 + tmp_qloop_217*tmp_qloop_606 + tmp_qloop_221*tmp_qloop_607) - tmp_qloop_212*tmp_qloop_604);
                   const real_t q_tmp_3_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_605 + tmp_qloop_230*tmp_qloop_606 + tmp_qloop_234*tmp_qloop_607) - tmp_qloop_225*tmp_qloop_604);
                   const real_t q_tmp_3_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_605 + tmp_qloop_243*tmp_qloop_606 + tmp_qloop_247*tmp_qloop_607) - tmp_qloop_238*tmp_qloop_604);
                   const real_t q_tmp_3_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_605 + tmp_qloop_256*tmp_qloop_606 + tmp_qloop_260*tmp_qloop_607) - tmp_qloop_251*tmp_qloop_604);
                   const real_t q_tmp_3_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_605 + tmp_qloop_269*tmp_qloop_606 + tmp_qloop_273*tmp_qloop_607) - tmp_qloop_264*tmp_qloop_604);
                   const real_t q_tmp_3_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_606 + tmp_qloop_588 + tmp_qloop_609) - tmp_qloop_282*tmp_qloop_604);
                   const real_t q_tmp_3_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_606 + tmp_qloop_318 + tmp_qloop_610) - tmp_qloop_308*tmp_qloop_604);
                   const real_t q_tmp_3_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_606 + tmp_qloop_332 + tmp_qloop_610) - tmp_qloop_322*tmp_qloop_604);
                   const real_t q_tmp_3_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_606 + tmp_qloop_346 + tmp_qloop_610) - tmp_qloop_336*tmp_qloop_604);
                   const real_t q_tmp_3_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_606 + tmp_qloop_360 + tmp_qloop_610) - tmp_qloop_350*tmp_qloop_604);
                   const real_t q_tmp_3_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_606 + tmp_qloop_374 + tmp_qloop_610) - tmp_qloop_364*tmp_qloop_604);
                   const real_t q_tmp_3_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_606 + tmp_qloop_388 + tmp_qloop_610) - tmp_qloop_378*tmp_qloop_604);
                   const real_t q_tmp_3_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_606 + tmp_qloop_402 + tmp_qloop_610) - tmp_qloop_392*tmp_qloop_604);
                   const real_t q_tmp_3_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_606 + tmp_qloop_416 + tmp_qloop_610) - tmp_qloop_406*tmp_qloop_604);
                   const real_t q_tmp_3_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_606 + tmp_qloop_430 + tmp_qloop_610) - tmp_qloop_420*tmp_qloop_604);
                   const real_t q_tmp_3_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_607 + tmp_qloop_592 + tmp_qloop_611) - tmp_qloop_435*tmp_qloop_604);
                   const real_t q_tmp_3_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_607 + tmp_qloop_463 + tmp_qloop_612) - tmp_qloop_452*tmp_qloop_604);
                   const real_t q_tmp_3_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_607 + tmp_qloop_478 + tmp_qloop_612) - tmp_qloop_467*tmp_qloop_604);
                   const real_t q_tmp_3_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_607 + tmp_qloop_493 + tmp_qloop_612) - tmp_qloop_482*tmp_qloop_604);
                   const real_t q_tmp_3_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_607 + tmp_qloop_508 + tmp_qloop_612) - tmp_qloop_497*tmp_qloop_604);
                   const real_t q_tmp_3_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_607 + tmp_qloop_523 + tmp_qloop_612) - tmp_qloop_512*tmp_qloop_604);
                   const real_t q_tmp_3_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_607 + tmp_qloop_538 + tmp_qloop_612) - tmp_qloop_527*tmp_qloop_604);
                   const real_t q_tmp_3_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_607 + tmp_qloop_553 + tmp_qloop_612) - tmp_qloop_542*tmp_qloop_604);
                   const real_t q_tmp_3_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_607 + tmp_qloop_568 + tmp_qloop_612) - tmp_qloop_557*tmp_qloop_604);
                   const real_t q_tmp_3_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_607 + tmp_qloop_583 + tmp_qloop_612) - tmp_qloop_572*tmp_qloop_604);
                   const real_t q_tmp_4_4 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_200*tmp_qloop_614 + tmp_qloop_204*tmp_qloop_615 + tmp_qloop_208*tmp_qloop_616) - tmp_qloop_199*tmp_qloop_613);
                   const real_t q_tmp_4_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_614 + tmp_qloop_217*tmp_qloop_615 + tmp_qloop_221*tmp_qloop_616) - tmp_qloop_212*tmp_qloop_613);
                   const real_t q_tmp_4_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_614 + tmp_qloop_230*tmp_qloop_615 + tmp_qloop_234*tmp_qloop_616) - tmp_qloop_225*tmp_qloop_613);
                   const real_t q_tmp_4_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_614 + tmp_qloop_243*tmp_qloop_615 + tmp_qloop_247*tmp_qloop_616) - tmp_qloop_238*tmp_qloop_613);
                   const real_t q_tmp_4_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_614 + tmp_qloop_256*tmp_qloop_615 + tmp_qloop_260*tmp_qloop_616) - tmp_qloop_251*tmp_qloop_613);
                   const real_t q_tmp_4_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_614 + tmp_qloop_269*tmp_qloop_615 + tmp_qloop_273*tmp_qloop_616) - tmp_qloop_264*tmp_qloop_613);
                   const real_t q_tmp_4_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_615 + tmp_qloop_588 + tmp_qloop_618) - tmp_qloop_282*tmp_qloop_613);
                   const real_t q_tmp_4_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_615 + tmp_qloop_318 + tmp_qloop_619) - tmp_qloop_308*tmp_qloop_613);
                   const real_t q_tmp_4_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_615 + tmp_qloop_332 + tmp_qloop_619) - tmp_qloop_322*tmp_qloop_613);
                   const real_t q_tmp_4_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_615 + tmp_qloop_346 + tmp_qloop_619) - tmp_qloop_336*tmp_qloop_613);
                   const real_t q_tmp_4_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_615 + tmp_qloop_360 + tmp_qloop_619) - tmp_qloop_350*tmp_qloop_613);
                   const real_t q_tmp_4_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_615 + tmp_qloop_374 + tmp_qloop_619) - tmp_qloop_364*tmp_qloop_613);
                   const real_t q_tmp_4_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_615 + tmp_qloop_388 + tmp_qloop_619) - tmp_qloop_378*tmp_qloop_613);
                   const real_t q_tmp_4_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_615 + tmp_qloop_402 + tmp_qloop_619) - tmp_qloop_392*tmp_qloop_613);
                   const real_t q_tmp_4_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_615 + tmp_qloop_416 + tmp_qloop_619) - tmp_qloop_406*tmp_qloop_613);
                   const real_t q_tmp_4_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_615 + tmp_qloop_430 + tmp_qloop_619) - tmp_qloop_420*tmp_qloop_613);
                   const real_t q_tmp_4_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_616 + tmp_qloop_592 + tmp_qloop_620) - tmp_qloop_435*tmp_qloop_613);
                   const real_t q_tmp_4_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_616 + tmp_qloop_463 + tmp_qloop_621) - tmp_qloop_452*tmp_qloop_613);
                   const real_t q_tmp_4_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_616 + tmp_qloop_478 + tmp_qloop_621) - tmp_qloop_467*tmp_qloop_613);
                   const real_t q_tmp_4_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_616 + tmp_qloop_493 + tmp_qloop_621) - tmp_qloop_482*tmp_qloop_613);
                   const real_t q_tmp_4_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_616 + tmp_qloop_508 + tmp_qloop_621) - tmp_qloop_497*tmp_qloop_613);
                   const real_t q_tmp_4_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_616 + tmp_qloop_523 + tmp_qloop_621) - tmp_qloop_512*tmp_qloop_613);
                   const real_t q_tmp_4_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_616 + tmp_qloop_538 + tmp_qloop_621) - tmp_qloop_527*tmp_qloop_613);
                   const real_t q_tmp_4_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_616 + tmp_qloop_553 + tmp_qloop_621) - tmp_qloop_542*tmp_qloop_613);
                   const real_t q_tmp_4_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_616 + tmp_qloop_568 + tmp_qloop_621) - tmp_qloop_557*tmp_qloop_613);
                   const real_t q_tmp_4_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_616 + tmp_qloop_583 + tmp_qloop_621) - tmp_qloop_572*tmp_qloop_613);
                   const real_t q_tmp_5_5 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_213*tmp_qloop_623 + tmp_qloop_217*tmp_qloop_624 + tmp_qloop_221*tmp_qloop_625) - tmp_qloop_212*tmp_qloop_622);
                   const real_t q_tmp_5_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_623 + tmp_qloop_230*tmp_qloop_624 + tmp_qloop_234*tmp_qloop_625) - tmp_qloop_225*tmp_qloop_622);
                   const real_t q_tmp_5_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_623 + tmp_qloop_243*tmp_qloop_624 + tmp_qloop_247*tmp_qloop_625) - tmp_qloop_238*tmp_qloop_622);
                   const real_t q_tmp_5_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_623 + tmp_qloop_256*tmp_qloop_624 + tmp_qloop_260*tmp_qloop_625) - tmp_qloop_251*tmp_qloop_622);
                   const real_t q_tmp_5_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_623 + tmp_qloop_269*tmp_qloop_624 + tmp_qloop_273*tmp_qloop_625) - tmp_qloop_264*tmp_qloop_622);
                   const real_t q_tmp_5_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_624 + tmp_qloop_588 + tmp_qloop_627) - tmp_qloop_282*tmp_qloop_622);
                   const real_t q_tmp_5_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_624 + tmp_qloop_318 + tmp_qloop_628) - tmp_qloop_308*tmp_qloop_622);
                   const real_t q_tmp_5_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_624 + tmp_qloop_332 + tmp_qloop_628) - tmp_qloop_322*tmp_qloop_622);
                   const real_t q_tmp_5_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_624 + tmp_qloop_346 + tmp_qloop_628) - tmp_qloop_336*tmp_qloop_622);
                   const real_t q_tmp_5_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_624 + tmp_qloop_360 + tmp_qloop_628) - tmp_qloop_350*tmp_qloop_622);
                   const real_t q_tmp_5_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_624 + tmp_qloop_374 + tmp_qloop_628) - tmp_qloop_364*tmp_qloop_622);
                   const real_t q_tmp_5_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_624 + tmp_qloop_388 + tmp_qloop_628) - tmp_qloop_378*tmp_qloop_622);
                   const real_t q_tmp_5_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_624 + tmp_qloop_402 + tmp_qloop_628) - tmp_qloop_392*tmp_qloop_622);
                   const real_t q_tmp_5_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_624 + tmp_qloop_416 + tmp_qloop_628) - tmp_qloop_406*tmp_qloop_622);
                   const real_t q_tmp_5_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_624 + tmp_qloop_430 + tmp_qloop_628) - tmp_qloop_420*tmp_qloop_622);
                   const real_t q_tmp_5_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_625 + tmp_qloop_592 + tmp_qloop_629) - tmp_qloop_435*tmp_qloop_622);
                   const real_t q_tmp_5_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_625 + tmp_qloop_463 + tmp_qloop_630) - tmp_qloop_452*tmp_qloop_622);
                   const real_t q_tmp_5_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_625 + tmp_qloop_478 + tmp_qloop_630) - tmp_qloop_467*tmp_qloop_622);
                   const real_t q_tmp_5_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_625 + tmp_qloop_493 + tmp_qloop_630) - tmp_qloop_482*tmp_qloop_622);
                   const real_t q_tmp_5_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_625 + tmp_qloop_508 + tmp_qloop_630) - tmp_qloop_497*tmp_qloop_622);
                   const real_t q_tmp_5_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_625 + tmp_qloop_523 + tmp_qloop_630) - tmp_qloop_512*tmp_qloop_622);
                   const real_t q_tmp_5_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_625 + tmp_qloop_538 + tmp_qloop_630) - tmp_qloop_527*tmp_qloop_622);
                   const real_t q_tmp_5_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_625 + tmp_qloop_553 + tmp_qloop_630) - tmp_qloop_542*tmp_qloop_622);
                   const real_t q_tmp_5_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_625 + tmp_qloop_568 + tmp_qloop_630) - tmp_qloop_557*tmp_qloop_622);
                   const real_t q_tmp_5_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_625 + tmp_qloop_583 + tmp_qloop_630) - tmp_qloop_572*tmp_qloop_622);
                   const real_t q_tmp_6_6 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_226*tmp_qloop_632 + tmp_qloop_230*tmp_qloop_633 + tmp_qloop_234*tmp_qloop_634) - tmp_qloop_225*tmp_qloop_631);
                   const real_t q_tmp_6_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_632 + tmp_qloop_243*tmp_qloop_633 + tmp_qloop_247*tmp_qloop_634) - tmp_qloop_238*tmp_qloop_631);
                   const real_t q_tmp_6_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_632 + tmp_qloop_256*tmp_qloop_633 + tmp_qloop_260*tmp_qloop_634) - tmp_qloop_251*tmp_qloop_631);
                   const real_t q_tmp_6_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_632 + tmp_qloop_269*tmp_qloop_633 + tmp_qloop_273*tmp_qloop_634) - tmp_qloop_264*tmp_qloop_631);
                   const real_t q_tmp_6_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_633 + tmp_qloop_588 + tmp_qloop_636) - tmp_qloop_282*tmp_qloop_631);
                   const real_t q_tmp_6_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_633 + tmp_qloop_318 + tmp_qloop_637) - tmp_qloop_308*tmp_qloop_631);
                   const real_t q_tmp_6_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_633 + tmp_qloop_332 + tmp_qloop_637) - tmp_qloop_322*tmp_qloop_631);
                   const real_t q_tmp_6_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_633 + tmp_qloop_346 + tmp_qloop_637) - tmp_qloop_336*tmp_qloop_631);
                   const real_t q_tmp_6_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_633 + tmp_qloop_360 + tmp_qloop_637) - tmp_qloop_350*tmp_qloop_631);
                   const real_t q_tmp_6_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_633 + tmp_qloop_374 + tmp_qloop_637) - tmp_qloop_364*tmp_qloop_631);
                   const real_t q_tmp_6_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_633 + tmp_qloop_388 + tmp_qloop_637) - tmp_qloop_378*tmp_qloop_631);
                   const real_t q_tmp_6_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_633 + tmp_qloop_402 + tmp_qloop_637) - tmp_qloop_392*tmp_qloop_631);
                   const real_t q_tmp_6_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_633 + tmp_qloop_416 + tmp_qloop_637) - tmp_qloop_406*tmp_qloop_631);
                   const real_t q_tmp_6_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_633 + tmp_qloop_430 + tmp_qloop_637) - tmp_qloop_420*tmp_qloop_631);
                   const real_t q_tmp_6_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_634 + tmp_qloop_592 + tmp_qloop_638) - tmp_qloop_435*tmp_qloop_631);
                   const real_t q_tmp_6_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_634 + tmp_qloop_463 + tmp_qloop_639) - tmp_qloop_452*tmp_qloop_631);
                   const real_t q_tmp_6_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_634 + tmp_qloop_478 + tmp_qloop_639) - tmp_qloop_467*tmp_qloop_631);
                   const real_t q_tmp_6_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_634 + tmp_qloop_493 + tmp_qloop_639) - tmp_qloop_482*tmp_qloop_631);
                   const real_t q_tmp_6_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_634 + tmp_qloop_508 + tmp_qloop_639) - tmp_qloop_497*tmp_qloop_631);
                   const real_t q_tmp_6_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_634 + tmp_qloop_523 + tmp_qloop_639) - tmp_qloop_512*tmp_qloop_631);
                   const real_t q_tmp_6_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_634 + tmp_qloop_538 + tmp_qloop_639) - tmp_qloop_527*tmp_qloop_631);
                   const real_t q_tmp_6_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_634 + tmp_qloop_553 + tmp_qloop_639) - tmp_qloop_542*tmp_qloop_631);
                   const real_t q_tmp_6_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_634 + tmp_qloop_568 + tmp_qloop_639) - tmp_qloop_557*tmp_qloop_631);
                   const real_t q_tmp_6_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_634 + tmp_qloop_583 + tmp_qloop_639) - tmp_qloop_572*tmp_qloop_631);
                   const real_t q_tmp_7_7 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_239*tmp_qloop_641 + tmp_qloop_243*tmp_qloop_642 + tmp_qloop_247*tmp_qloop_643) - tmp_qloop_238*tmp_qloop_640);
                   const real_t q_tmp_7_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_641 + tmp_qloop_256*tmp_qloop_642 + tmp_qloop_260*tmp_qloop_643) - tmp_qloop_251*tmp_qloop_640);
                   const real_t q_tmp_7_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_641 + tmp_qloop_269*tmp_qloop_642 + tmp_qloop_273*tmp_qloop_643) - tmp_qloop_264*tmp_qloop_640);
                   const real_t q_tmp_7_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_642 + tmp_qloop_588 + tmp_qloop_645) - tmp_qloop_282*tmp_qloop_640);
                   const real_t q_tmp_7_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_642 + tmp_qloop_318 + tmp_qloop_646) - tmp_qloop_308*tmp_qloop_640);
                   const real_t q_tmp_7_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_642 + tmp_qloop_332 + tmp_qloop_646) - tmp_qloop_322*tmp_qloop_640);
                   const real_t q_tmp_7_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_642 + tmp_qloop_346 + tmp_qloop_646) - tmp_qloop_336*tmp_qloop_640);
                   const real_t q_tmp_7_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_642 + tmp_qloop_360 + tmp_qloop_646) - tmp_qloop_350*tmp_qloop_640);
                   const real_t q_tmp_7_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_642 + tmp_qloop_374 + tmp_qloop_646) - tmp_qloop_364*tmp_qloop_640);
                   const real_t q_tmp_7_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_642 + tmp_qloop_388 + tmp_qloop_646) - tmp_qloop_378*tmp_qloop_640);
                   const real_t q_tmp_7_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_642 + tmp_qloop_402 + tmp_qloop_646) - tmp_qloop_392*tmp_qloop_640);
                   const real_t q_tmp_7_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_642 + tmp_qloop_416 + tmp_qloop_646) - tmp_qloop_406*tmp_qloop_640);
                   const real_t q_tmp_7_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_642 + tmp_qloop_430 + tmp_qloop_646) - tmp_qloop_420*tmp_qloop_640);
                   const real_t q_tmp_7_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_643 + tmp_qloop_592 + tmp_qloop_647) - tmp_qloop_435*tmp_qloop_640);
                   const real_t q_tmp_7_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_643 + tmp_qloop_463 + tmp_qloop_648) - tmp_qloop_452*tmp_qloop_640);
                   const real_t q_tmp_7_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_643 + tmp_qloop_478 + tmp_qloop_648) - tmp_qloop_467*tmp_qloop_640);
                   const real_t q_tmp_7_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_643 + tmp_qloop_493 + tmp_qloop_648) - tmp_qloop_482*tmp_qloop_640);
                   const real_t q_tmp_7_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_643 + tmp_qloop_508 + tmp_qloop_648) - tmp_qloop_497*tmp_qloop_640);
                   const real_t q_tmp_7_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_643 + tmp_qloop_523 + tmp_qloop_648) - tmp_qloop_512*tmp_qloop_640);
                   const real_t q_tmp_7_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_643 + tmp_qloop_538 + tmp_qloop_648) - tmp_qloop_527*tmp_qloop_640);
                   const real_t q_tmp_7_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_643 + tmp_qloop_553 + tmp_qloop_648) - tmp_qloop_542*tmp_qloop_640);
                   const real_t q_tmp_7_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_643 + tmp_qloop_568 + tmp_qloop_648) - tmp_qloop_557*tmp_qloop_640);
                   const real_t q_tmp_7_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_643 + tmp_qloop_583 + tmp_qloop_648) - tmp_qloop_572*tmp_qloop_640);
                   const real_t q_tmp_8_8 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_252*tmp_qloop_650 + tmp_qloop_256*tmp_qloop_651 + tmp_qloop_260*tmp_qloop_652) - tmp_qloop_251*tmp_qloop_649);
                   const real_t q_tmp_8_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_650 + tmp_qloop_269*tmp_qloop_651 + tmp_qloop_273*tmp_qloop_652) - tmp_qloop_264*tmp_qloop_649);
                   const real_t q_tmp_8_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_651 + tmp_qloop_588 + tmp_qloop_654) - tmp_qloop_282*tmp_qloop_649);
                   const real_t q_tmp_8_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_651 + tmp_qloop_318 + tmp_qloop_655) - tmp_qloop_308*tmp_qloop_649);
                   const real_t q_tmp_8_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_651 + tmp_qloop_332 + tmp_qloop_655) - tmp_qloop_322*tmp_qloop_649);
                   const real_t q_tmp_8_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_651 + tmp_qloop_346 + tmp_qloop_655) - tmp_qloop_336*tmp_qloop_649);
                   const real_t q_tmp_8_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_651 + tmp_qloop_360 + tmp_qloop_655) - tmp_qloop_350*tmp_qloop_649);
                   const real_t q_tmp_8_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_651 + tmp_qloop_374 + tmp_qloop_655) - tmp_qloop_364*tmp_qloop_649);
                   const real_t q_tmp_8_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_651 + tmp_qloop_388 + tmp_qloop_655) - tmp_qloop_378*tmp_qloop_649);
                   const real_t q_tmp_8_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_651 + tmp_qloop_402 + tmp_qloop_655) - tmp_qloop_392*tmp_qloop_649);
                   const real_t q_tmp_8_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_651 + tmp_qloop_416 + tmp_qloop_655) - tmp_qloop_406*tmp_qloop_649);
                   const real_t q_tmp_8_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_651 + tmp_qloop_430 + tmp_qloop_655) - tmp_qloop_420*tmp_qloop_649);
                   const real_t q_tmp_8_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_652 + tmp_qloop_592 + tmp_qloop_656) - tmp_qloop_435*tmp_qloop_649);
                   const real_t q_tmp_8_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_652 + tmp_qloop_463 + tmp_qloop_657) - tmp_qloop_452*tmp_qloop_649);
                   const real_t q_tmp_8_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_652 + tmp_qloop_478 + tmp_qloop_657) - tmp_qloop_467*tmp_qloop_649);
                   const real_t q_tmp_8_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_652 + tmp_qloop_493 + tmp_qloop_657) - tmp_qloop_482*tmp_qloop_649);
                   const real_t q_tmp_8_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_652 + tmp_qloop_508 + tmp_qloop_657) - tmp_qloop_497*tmp_qloop_649);
                   const real_t q_tmp_8_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_652 + tmp_qloop_523 + tmp_qloop_657) - tmp_qloop_512*tmp_qloop_649);
                   const real_t q_tmp_8_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_652 + tmp_qloop_538 + tmp_qloop_657) - tmp_qloop_527*tmp_qloop_649);
                   const real_t q_tmp_8_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_652 + tmp_qloop_553 + tmp_qloop_657) - tmp_qloop_542*tmp_qloop_649);
                   const real_t q_tmp_8_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_652 + tmp_qloop_568 + tmp_qloop_657) - tmp_qloop_557*tmp_qloop_649);
                   const real_t q_tmp_8_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_652 + tmp_qloop_583 + tmp_qloop_657) - tmp_qloop_572*tmp_qloop_649);
                   const real_t q_tmp_9_9 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_155 + tmp_qloop_265*tmp_qloop_659 + tmp_qloop_269*tmp_qloop_660 + tmp_qloop_273*tmp_qloop_661) - tmp_qloop_264*tmp_qloop_658);
                   const real_t q_tmp_9_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_660 + tmp_qloop_588 + tmp_qloop_663) - tmp_qloop_282*tmp_qloop_658);
                   const real_t q_tmp_9_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_660 + tmp_qloop_318 + tmp_qloop_664) - tmp_qloop_308*tmp_qloop_658);
                   const real_t q_tmp_9_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_660 + tmp_qloop_332 + tmp_qloop_664) - tmp_qloop_322*tmp_qloop_658);
                   const real_t q_tmp_9_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_660 + tmp_qloop_346 + tmp_qloop_664) - tmp_qloop_336*tmp_qloop_658);
                   const real_t q_tmp_9_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_660 + tmp_qloop_360 + tmp_qloop_664) - tmp_qloop_350*tmp_qloop_658);
                   const real_t q_tmp_9_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_660 + tmp_qloop_374 + tmp_qloop_664) - tmp_qloop_364*tmp_qloop_658);
                   const real_t q_tmp_9_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_660 + tmp_qloop_388 + tmp_qloop_664) - tmp_qloop_378*tmp_qloop_658);
                   const real_t q_tmp_9_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_660 + tmp_qloop_402 + tmp_qloop_664) - tmp_qloop_392*tmp_qloop_658);
                   const real_t q_tmp_9_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_660 + tmp_qloop_416 + tmp_qloop_664) - tmp_qloop_406*tmp_qloop_658);
                   const real_t q_tmp_9_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_660 + tmp_qloop_430 + tmp_qloop_664) - tmp_qloop_420*tmp_qloop_658);
                   const real_t q_tmp_9_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_661 + tmp_qloop_592 + tmp_qloop_665) - tmp_qloop_435*tmp_qloop_658);
                   const real_t q_tmp_9_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_661 + tmp_qloop_463 + tmp_qloop_666) - tmp_qloop_452*tmp_qloop_658);
                   const real_t q_tmp_9_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_661 + tmp_qloop_478 + tmp_qloop_666) - tmp_qloop_467*tmp_qloop_658);
                   const real_t q_tmp_9_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_661 + tmp_qloop_493 + tmp_qloop_666) - tmp_qloop_482*tmp_qloop_658);
                   const real_t q_tmp_9_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_661 + tmp_qloop_508 + tmp_qloop_666) - tmp_qloop_497*tmp_qloop_658);
                   const real_t q_tmp_9_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_661 + tmp_qloop_523 + tmp_qloop_666) - tmp_qloop_512*tmp_qloop_658);
                   const real_t q_tmp_9_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_661 + tmp_qloop_538 + tmp_qloop_666) - tmp_qloop_527*tmp_qloop_658);
                   const real_t q_tmp_9_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_661 + tmp_qloop_553 + tmp_qloop_666) - tmp_qloop_542*tmp_qloop_658);
                   const real_t q_tmp_9_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_661 + tmp_qloop_568 + tmp_qloop_666) - tmp_qloop_557*tmp_qloop_658);
                   const real_t q_tmp_9_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_661 + tmp_qloop_583 + tmp_qloop_666) - tmp_qloop_572*tmp_qloop_658);
                   const real_t q_tmp_10_10 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_290*tmp_qloop_672 + tmp_qloop_299*tmp_qloop_670 + tmp_qloop_303*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_282*tmp_qloop_669);
                   const real_t q_tmp_10_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_672 + tmp_qloop_313*tmp_qloop_670 + tmp_qloop_317*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_669);
                   const real_t q_tmp_10_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_672 + tmp_qloop_327*tmp_qloop_670 + tmp_qloop_331*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_669);
                   const real_t q_tmp_10_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_672 + tmp_qloop_341*tmp_qloop_670 + tmp_qloop_345*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_669);
                   const real_t q_tmp_10_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_672 + tmp_qloop_355*tmp_qloop_670 + tmp_qloop_359*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_669);
                   const real_t q_tmp_10_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_672 + tmp_qloop_369*tmp_qloop_670 + tmp_qloop_373*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_669);
                   const real_t q_tmp_10_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_672 + tmp_qloop_383*tmp_qloop_670 + tmp_qloop_387*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_669);
                   const real_t q_tmp_10_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_672 + tmp_qloop_397*tmp_qloop_670 + tmp_qloop_401*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_669);
                   const real_t q_tmp_10_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_672 + tmp_qloop_411*tmp_qloop_670 + tmp_qloop_415*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_669);
                   const real_t q_tmp_10_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_672 + tmp_qloop_425*tmp_qloop_670 + tmp_qloop_429*tmp_qloop_673 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_669);
                   const real_t q_tmp_10_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_679) - tmp_qloop_435*tmp_qloop_669);
                   const real_t q_tmp_10_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_680) - tmp_qloop_452*tmp_qloop_669);
                   const real_t q_tmp_10_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_681) - tmp_qloop_467*tmp_qloop_669);
                   const real_t q_tmp_10_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_682) - tmp_qloop_482*tmp_qloop_669);
                   const real_t q_tmp_10_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_683) - tmp_qloop_497*tmp_qloop_669);
                   const real_t q_tmp_10_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_684) - tmp_qloop_512*tmp_qloop_669);
                   const real_t q_tmp_10_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_685) - tmp_qloop_527*tmp_qloop_669);
                   const real_t q_tmp_10_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_686) - tmp_qloop_542*tmp_qloop_669);
                   const real_t q_tmp_10_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_687) - tmp_qloop_557*tmp_qloop_669);
                   const real_t q_tmp_10_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_673 + tmp_qloop_678 + tmp_qloop_688) - tmp_qloop_572*tmp_qloop_669);
                   const real_t q_tmp_11_11 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_312*tmp_qloop_691 + tmp_qloop_313*tmp_qloop_690 + tmp_qloop_317*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_308*tmp_qloop_689);
                   const real_t q_tmp_11_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_691 + tmp_qloop_327*tmp_qloop_690 + tmp_qloop_331*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_689);
                   const real_t q_tmp_11_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_691 + tmp_qloop_341*tmp_qloop_690 + tmp_qloop_345*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_689);
                   const real_t q_tmp_11_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_691 + tmp_qloop_355*tmp_qloop_690 + tmp_qloop_359*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_689);
                   const real_t q_tmp_11_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_691 + tmp_qloop_369*tmp_qloop_690 + tmp_qloop_373*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_689);
                   const real_t q_tmp_11_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_691 + tmp_qloop_383*tmp_qloop_690 + tmp_qloop_387*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_689);
                   const real_t q_tmp_11_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_691 + tmp_qloop_397*tmp_qloop_690 + tmp_qloop_401*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_689);
                   const real_t q_tmp_11_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_691 + tmp_qloop_411*tmp_qloop_690 + tmp_qloop_415*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_689);
                   const real_t q_tmp_11_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_691 + tmp_qloop_425*tmp_qloop_690 + tmp_qloop_429*tmp_qloop_692 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_689);
                   const real_t q_tmp_11_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_692 + tmp_qloop_693 + tmp_qloop_694) - tmp_qloop_435*tmp_qloop_689);
                   const real_t q_tmp_11_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_692 + tmp_qloop_680 + tmp_qloop_695) - tmp_qloop_452*tmp_qloop_689);
                   const real_t q_tmp_11_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_692 + tmp_qloop_681 + tmp_qloop_695) - tmp_qloop_467*tmp_qloop_689);
                   const real_t q_tmp_11_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_692 + tmp_qloop_682 + tmp_qloop_695) - tmp_qloop_482*tmp_qloop_689);
                   const real_t q_tmp_11_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_692 + tmp_qloop_683 + tmp_qloop_695) - tmp_qloop_497*tmp_qloop_689);
                   const real_t q_tmp_11_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_692 + tmp_qloop_684 + tmp_qloop_695) - tmp_qloop_512*tmp_qloop_689);
                   const real_t q_tmp_11_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_692 + tmp_qloop_685 + tmp_qloop_695) - tmp_qloop_527*tmp_qloop_689);
                   const real_t q_tmp_11_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_692 + tmp_qloop_686 + tmp_qloop_695) - tmp_qloop_542*tmp_qloop_689);
                   const real_t q_tmp_11_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_692 + tmp_qloop_687 + tmp_qloop_695) - tmp_qloop_557*tmp_qloop_689);
                   const real_t q_tmp_11_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_692 + tmp_qloop_688 + tmp_qloop_695) - tmp_qloop_572*tmp_qloop_689);
                   const real_t q_tmp_12_12 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_326*tmp_qloop_698 + tmp_qloop_327*tmp_qloop_697 + tmp_qloop_331*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_322*tmp_qloop_696);
                   const real_t q_tmp_12_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_698 + tmp_qloop_341*tmp_qloop_697 + tmp_qloop_345*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_696);
                   const real_t q_tmp_12_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_698 + tmp_qloop_355*tmp_qloop_697 + tmp_qloop_359*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_696);
                   const real_t q_tmp_12_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_698 + tmp_qloop_369*tmp_qloop_697 + tmp_qloop_373*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_696);
                   const real_t q_tmp_12_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_698 + tmp_qloop_383*tmp_qloop_697 + tmp_qloop_387*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_696);
                   const real_t q_tmp_12_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_698 + tmp_qloop_397*tmp_qloop_697 + tmp_qloop_401*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_696);
                   const real_t q_tmp_12_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_698 + tmp_qloop_411*tmp_qloop_697 + tmp_qloop_415*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_696);
                   const real_t q_tmp_12_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_698 + tmp_qloop_425*tmp_qloop_697 + tmp_qloop_429*tmp_qloop_699 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_696);
                   const real_t q_tmp_12_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_699 + tmp_qloop_693 + tmp_qloop_700) - tmp_qloop_435*tmp_qloop_696);
                   const real_t q_tmp_12_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_699 + tmp_qloop_680 + tmp_qloop_701) - tmp_qloop_452*tmp_qloop_696);
                   const real_t q_tmp_12_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_699 + tmp_qloop_681 + tmp_qloop_701) - tmp_qloop_467*tmp_qloop_696);
                   const real_t q_tmp_12_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_699 + tmp_qloop_682 + tmp_qloop_701) - tmp_qloop_482*tmp_qloop_696);
                   const real_t q_tmp_12_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_699 + tmp_qloop_683 + tmp_qloop_701) - tmp_qloop_497*tmp_qloop_696);
                   const real_t q_tmp_12_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_699 + tmp_qloop_684 + tmp_qloop_701) - tmp_qloop_512*tmp_qloop_696);
                   const real_t q_tmp_12_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_699 + tmp_qloop_685 + tmp_qloop_701) - tmp_qloop_527*tmp_qloop_696);
                   const real_t q_tmp_12_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_699 + tmp_qloop_686 + tmp_qloop_701) - tmp_qloop_542*tmp_qloop_696);
                   const real_t q_tmp_12_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_699 + tmp_qloop_687 + tmp_qloop_701) - tmp_qloop_557*tmp_qloop_696);
                   const real_t q_tmp_12_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_699 + tmp_qloop_688 + tmp_qloop_701) - tmp_qloop_572*tmp_qloop_696);
                   const real_t q_tmp_13_13 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_340*tmp_qloop_704 + tmp_qloop_341*tmp_qloop_703 + tmp_qloop_345*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_336*tmp_qloop_702);
                   const real_t q_tmp_13_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_704 + tmp_qloop_355*tmp_qloop_703 + tmp_qloop_359*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_702);
                   const real_t q_tmp_13_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_704 + tmp_qloop_369*tmp_qloop_703 + tmp_qloop_373*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_702);
                   const real_t q_tmp_13_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_704 + tmp_qloop_383*tmp_qloop_703 + tmp_qloop_387*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_702);
                   const real_t q_tmp_13_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_704 + tmp_qloop_397*tmp_qloop_703 + tmp_qloop_401*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_702);
                   const real_t q_tmp_13_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_704 + tmp_qloop_411*tmp_qloop_703 + tmp_qloop_415*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_702);
                   const real_t q_tmp_13_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_704 + tmp_qloop_425*tmp_qloop_703 + tmp_qloop_429*tmp_qloop_705 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_702);
                   const real_t q_tmp_13_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_705 + tmp_qloop_693 + tmp_qloop_706) - tmp_qloop_435*tmp_qloop_702);
                   const real_t q_tmp_13_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_705 + tmp_qloop_680 + tmp_qloop_707) - tmp_qloop_452*tmp_qloop_702);
                   const real_t q_tmp_13_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_705 + tmp_qloop_681 + tmp_qloop_707) - tmp_qloop_467*tmp_qloop_702);
                   const real_t q_tmp_13_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_705 + tmp_qloop_682 + tmp_qloop_707) - tmp_qloop_482*tmp_qloop_702);
                   const real_t q_tmp_13_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_705 + tmp_qloop_683 + tmp_qloop_707) - tmp_qloop_497*tmp_qloop_702);
                   const real_t q_tmp_13_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_705 + tmp_qloop_684 + tmp_qloop_707) - tmp_qloop_512*tmp_qloop_702);
                   const real_t q_tmp_13_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_705 + tmp_qloop_685 + tmp_qloop_707) - tmp_qloop_527*tmp_qloop_702);
                   const real_t q_tmp_13_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_705 + tmp_qloop_686 + tmp_qloop_707) - tmp_qloop_542*tmp_qloop_702);
                   const real_t q_tmp_13_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_705 + tmp_qloop_687 + tmp_qloop_707) - tmp_qloop_557*tmp_qloop_702);
                   const real_t q_tmp_13_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_705 + tmp_qloop_688 + tmp_qloop_707) - tmp_qloop_572*tmp_qloop_702);
                   const real_t q_tmp_14_14 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_354*tmp_qloop_710 + tmp_qloop_355*tmp_qloop_709 + tmp_qloop_359*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_350*tmp_qloop_708);
                   const real_t q_tmp_14_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_710 + tmp_qloop_369*tmp_qloop_709 + tmp_qloop_373*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_708);
                   const real_t q_tmp_14_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_710 + tmp_qloop_383*tmp_qloop_709 + tmp_qloop_387*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_708);
                   const real_t q_tmp_14_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_710 + tmp_qloop_397*tmp_qloop_709 + tmp_qloop_401*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_708);
                   const real_t q_tmp_14_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_710 + tmp_qloop_411*tmp_qloop_709 + tmp_qloop_415*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_708);
                   const real_t q_tmp_14_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_710 + tmp_qloop_425*tmp_qloop_709 + tmp_qloop_429*tmp_qloop_711 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_708);
                   const real_t q_tmp_14_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_711 + tmp_qloop_693 + tmp_qloop_712) - tmp_qloop_435*tmp_qloop_708);
                   const real_t q_tmp_14_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_711 + tmp_qloop_680 + tmp_qloop_713) - tmp_qloop_452*tmp_qloop_708);
                   const real_t q_tmp_14_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_711 + tmp_qloop_681 + tmp_qloop_713) - tmp_qloop_467*tmp_qloop_708);
                   const real_t q_tmp_14_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_711 + tmp_qloop_682 + tmp_qloop_713) - tmp_qloop_482*tmp_qloop_708);
                   const real_t q_tmp_14_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_711 + tmp_qloop_683 + tmp_qloop_713) - tmp_qloop_497*tmp_qloop_708);
                   const real_t q_tmp_14_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_711 + tmp_qloop_684 + tmp_qloop_713) - tmp_qloop_512*tmp_qloop_708);
                   const real_t q_tmp_14_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_711 + tmp_qloop_685 + tmp_qloop_713) - tmp_qloop_527*tmp_qloop_708);
                   const real_t q_tmp_14_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_711 + tmp_qloop_686 + tmp_qloop_713) - tmp_qloop_542*tmp_qloop_708);
                   const real_t q_tmp_14_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_711 + tmp_qloop_687 + tmp_qloop_713) - tmp_qloop_557*tmp_qloop_708);
                   const real_t q_tmp_14_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_711 + tmp_qloop_688 + tmp_qloop_713) - tmp_qloop_572*tmp_qloop_708);
                   const real_t q_tmp_15_15 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_368*tmp_qloop_716 + tmp_qloop_369*tmp_qloop_715 + tmp_qloop_373*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_364*tmp_qloop_714);
                   const real_t q_tmp_15_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_716 + tmp_qloop_383*tmp_qloop_715 + tmp_qloop_387*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_714);
                   const real_t q_tmp_15_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_716 + tmp_qloop_397*tmp_qloop_715 + tmp_qloop_401*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_714);
                   const real_t q_tmp_15_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_716 + tmp_qloop_411*tmp_qloop_715 + tmp_qloop_415*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_714);
                   const real_t q_tmp_15_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_716 + tmp_qloop_425*tmp_qloop_715 + tmp_qloop_429*tmp_qloop_717 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_714);
                   const real_t q_tmp_15_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_717 + tmp_qloop_693 + tmp_qloop_718) - tmp_qloop_435*tmp_qloop_714);
                   const real_t q_tmp_15_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_717 + tmp_qloop_680 + tmp_qloop_719) - tmp_qloop_452*tmp_qloop_714);
                   const real_t q_tmp_15_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_717 + tmp_qloop_681 + tmp_qloop_719) - tmp_qloop_467*tmp_qloop_714);
                   const real_t q_tmp_15_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_717 + tmp_qloop_682 + tmp_qloop_719) - tmp_qloop_482*tmp_qloop_714);
                   const real_t q_tmp_15_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_717 + tmp_qloop_683 + tmp_qloop_719) - tmp_qloop_497*tmp_qloop_714);
                   const real_t q_tmp_15_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_717 + tmp_qloop_684 + tmp_qloop_719) - tmp_qloop_512*tmp_qloop_714);
                   const real_t q_tmp_15_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_717 + tmp_qloop_685 + tmp_qloop_719) - tmp_qloop_527*tmp_qloop_714);
                   const real_t q_tmp_15_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_717 + tmp_qloop_686 + tmp_qloop_719) - tmp_qloop_542*tmp_qloop_714);
                   const real_t q_tmp_15_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_717 + tmp_qloop_687 + tmp_qloop_719) - tmp_qloop_557*tmp_qloop_714);
                   const real_t q_tmp_15_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_717 + tmp_qloop_688 + tmp_qloop_719) - tmp_qloop_572*tmp_qloop_714);
                   const real_t q_tmp_16_16 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_382*tmp_qloop_722 + tmp_qloop_383*tmp_qloop_721 + tmp_qloop_387*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_378*tmp_qloop_720);
                   const real_t q_tmp_16_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_722 + tmp_qloop_397*tmp_qloop_721 + tmp_qloop_401*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_720);
                   const real_t q_tmp_16_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_722 + tmp_qloop_411*tmp_qloop_721 + tmp_qloop_415*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_720);
                   const real_t q_tmp_16_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_722 + tmp_qloop_425*tmp_qloop_721 + tmp_qloop_429*tmp_qloop_723 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_720);
                   const real_t q_tmp_16_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_723 + tmp_qloop_693 + tmp_qloop_724) - tmp_qloop_435*tmp_qloop_720);
                   const real_t q_tmp_16_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_723 + tmp_qloop_680 + tmp_qloop_725) - tmp_qloop_452*tmp_qloop_720);
                   const real_t q_tmp_16_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_723 + tmp_qloop_681 + tmp_qloop_725) - tmp_qloop_467*tmp_qloop_720);
                   const real_t q_tmp_16_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_723 + tmp_qloop_682 + tmp_qloop_725) - tmp_qloop_482*tmp_qloop_720);
                   const real_t q_tmp_16_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_723 + tmp_qloop_683 + tmp_qloop_725) - tmp_qloop_497*tmp_qloop_720);
                   const real_t q_tmp_16_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_723 + tmp_qloop_684 + tmp_qloop_725) - tmp_qloop_512*tmp_qloop_720);
                   const real_t q_tmp_16_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_723 + tmp_qloop_685 + tmp_qloop_725) - tmp_qloop_527*tmp_qloop_720);
                   const real_t q_tmp_16_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_723 + tmp_qloop_686 + tmp_qloop_725) - tmp_qloop_542*tmp_qloop_720);
                   const real_t q_tmp_16_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_723 + tmp_qloop_687 + tmp_qloop_725) - tmp_qloop_557*tmp_qloop_720);
                   const real_t q_tmp_16_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_723 + tmp_qloop_688 + tmp_qloop_725) - tmp_qloop_572*tmp_qloop_720);
                   const real_t q_tmp_17_17 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_396*tmp_qloop_728 + tmp_qloop_397*tmp_qloop_727 + tmp_qloop_401*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_392*tmp_qloop_726);
                   const real_t q_tmp_17_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_728 + tmp_qloop_411*tmp_qloop_727 + tmp_qloop_415*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_726);
                   const real_t q_tmp_17_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_728 + tmp_qloop_425*tmp_qloop_727 + tmp_qloop_429*tmp_qloop_729 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_726);
                   const real_t q_tmp_17_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_729 + tmp_qloop_693 + tmp_qloop_730) - tmp_qloop_435*tmp_qloop_726);
                   const real_t q_tmp_17_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_729 + tmp_qloop_680 + tmp_qloop_731) - tmp_qloop_452*tmp_qloop_726);
                   const real_t q_tmp_17_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_729 + tmp_qloop_681 + tmp_qloop_731) - tmp_qloop_467*tmp_qloop_726);
                   const real_t q_tmp_17_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_729 + tmp_qloop_682 + tmp_qloop_731) - tmp_qloop_482*tmp_qloop_726);
                   const real_t q_tmp_17_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_729 + tmp_qloop_683 + tmp_qloop_731) - tmp_qloop_497*tmp_qloop_726);
                   const real_t q_tmp_17_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_729 + tmp_qloop_684 + tmp_qloop_731) - tmp_qloop_512*tmp_qloop_726);
                   const real_t q_tmp_17_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_729 + tmp_qloop_685 + tmp_qloop_731) - tmp_qloop_527*tmp_qloop_726);
                   const real_t q_tmp_17_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_729 + tmp_qloop_686 + tmp_qloop_731) - tmp_qloop_542*tmp_qloop_726);
                   const real_t q_tmp_17_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_729 + tmp_qloop_687 + tmp_qloop_731) - tmp_qloop_557*tmp_qloop_726);
                   const real_t q_tmp_17_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_729 + tmp_qloop_688 + tmp_qloop_731) - tmp_qloop_572*tmp_qloop_726);
                   const real_t q_tmp_18_18 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_410*tmp_qloop_734 + tmp_qloop_411*tmp_qloop_733 + tmp_qloop_415*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_406*tmp_qloop_732);
                   const real_t q_tmp_18_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_734 + tmp_qloop_425*tmp_qloop_733 + tmp_qloop_429*tmp_qloop_735 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_732);
                   const real_t q_tmp_18_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_735 + tmp_qloop_693 + tmp_qloop_736) - tmp_qloop_435*tmp_qloop_732);
                   const real_t q_tmp_18_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_735 + tmp_qloop_680 + tmp_qloop_737) - tmp_qloop_452*tmp_qloop_732);
                   const real_t q_tmp_18_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_735 + tmp_qloop_681 + tmp_qloop_737) - tmp_qloop_467*tmp_qloop_732);
                   const real_t q_tmp_18_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_735 + tmp_qloop_682 + tmp_qloop_737) - tmp_qloop_482*tmp_qloop_732);
                   const real_t q_tmp_18_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_735 + tmp_qloop_683 + tmp_qloop_737) - tmp_qloop_497*tmp_qloop_732);
                   const real_t q_tmp_18_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_735 + tmp_qloop_684 + tmp_qloop_737) - tmp_qloop_512*tmp_qloop_732);
                   const real_t q_tmp_18_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_735 + tmp_qloop_685 + tmp_qloop_737) - tmp_qloop_527*tmp_qloop_732);
                   const real_t q_tmp_18_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_735 + tmp_qloop_686 + tmp_qloop_737) - tmp_qloop_542*tmp_qloop_732);
                   const real_t q_tmp_18_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_735 + tmp_qloop_687 + tmp_qloop_737) - tmp_qloop_557*tmp_qloop_732);
                   const real_t q_tmp_18_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_735 + tmp_qloop_688 + tmp_qloop_737) - tmp_qloop_572*tmp_qloop_732);
                   const real_t q_tmp_19_19 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_424*tmp_qloop_740 + tmp_qloop_425*tmp_qloop_739 + tmp_qloop_429*tmp_qloop_741 + tmp_qloop_677) - tmp_qloop_420*tmp_qloop_738);
                   const real_t q_tmp_19_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_447*tmp_qloop_741 + tmp_qloop_693 + tmp_qloop_742) - tmp_qloop_435*tmp_qloop_738);
                   const real_t q_tmp_19_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_462*tmp_qloop_741 + tmp_qloop_680 + tmp_qloop_743) - tmp_qloop_452*tmp_qloop_738);
                   const real_t q_tmp_19_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_477*tmp_qloop_741 + tmp_qloop_681 + tmp_qloop_743) - tmp_qloop_467*tmp_qloop_738);
                   const real_t q_tmp_19_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_492*tmp_qloop_741 + tmp_qloop_682 + tmp_qloop_743) - tmp_qloop_482*tmp_qloop_738);
                   const real_t q_tmp_19_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_507*tmp_qloop_741 + tmp_qloop_683 + tmp_qloop_743) - tmp_qloop_497*tmp_qloop_738);
                   const real_t q_tmp_19_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_522*tmp_qloop_741 + tmp_qloop_684 + tmp_qloop_743) - tmp_qloop_512*tmp_qloop_738);
                   const real_t q_tmp_19_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_537*tmp_qloop_741 + tmp_qloop_685 + tmp_qloop_743) - tmp_qloop_527*tmp_qloop_738);
                   const real_t q_tmp_19_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_552*tmp_qloop_741 + tmp_qloop_686 + tmp_qloop_743) - tmp_qloop_542*tmp_qloop_738);
                   const real_t q_tmp_19_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_567*tmp_qloop_741 + tmp_qloop_687 + tmp_qloop_743) - tmp_qloop_557*tmp_qloop_738);
                   const real_t q_tmp_19_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_582*tmp_qloop_741 + tmp_qloop_688 + tmp_qloop_743) - tmp_qloop_572*tmp_qloop_738);
                   const real_t q_tmp_20_20 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_439*tmp_qloop_747 + tmp_qloop_442*tmp_qloop_746 + tmp_qloop_447*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_435*tmp_qloop_745);
                   const real_t q_tmp_20_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_747 + tmp_qloop_457*tmp_qloop_746 + tmp_qloop_462*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_745);
                   const real_t q_tmp_20_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_747 + tmp_qloop_472*tmp_qloop_746 + tmp_qloop_477*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_745);
                   const real_t q_tmp_20_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_747 + tmp_qloop_487*tmp_qloop_746 + tmp_qloop_492*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_745);
                   const real_t q_tmp_20_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_747 + tmp_qloop_502*tmp_qloop_746 + tmp_qloop_507*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_745);
                   const real_t q_tmp_20_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_747 + tmp_qloop_517*tmp_qloop_746 + tmp_qloop_522*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_745);
                   const real_t q_tmp_20_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_747 + tmp_qloop_532*tmp_qloop_746 + tmp_qloop_537*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_745);
                   const real_t q_tmp_20_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_747 + tmp_qloop_547*tmp_qloop_746 + tmp_qloop_552*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_745);
                   const real_t q_tmp_20_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_747 + tmp_qloop_562*tmp_qloop_746 + tmp_qloop_567*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_745);
                   const real_t q_tmp_20_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_747 + tmp_qloop_577*tmp_qloop_746 + tmp_qloop_582*tmp_qloop_748 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_745);
                   const real_t q_tmp_21_21 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_456*tmp_qloop_752 + tmp_qloop_457*tmp_qloop_751 + tmp_qloop_462*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_452*tmp_qloop_750);
                   const real_t q_tmp_21_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_752 + tmp_qloop_472*tmp_qloop_751 + tmp_qloop_477*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_750);
                   const real_t q_tmp_21_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_752 + tmp_qloop_487*tmp_qloop_751 + tmp_qloop_492*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_750);
                   const real_t q_tmp_21_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_752 + tmp_qloop_502*tmp_qloop_751 + tmp_qloop_507*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_750);
                   const real_t q_tmp_21_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_752 + tmp_qloop_517*tmp_qloop_751 + tmp_qloop_522*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_750);
                   const real_t q_tmp_21_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_752 + tmp_qloop_532*tmp_qloop_751 + tmp_qloop_537*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_750);
                   const real_t q_tmp_21_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_752 + tmp_qloop_547*tmp_qloop_751 + tmp_qloop_552*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_750);
                   const real_t q_tmp_21_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_752 + tmp_qloop_562*tmp_qloop_751 + tmp_qloop_567*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_750);
                   const real_t q_tmp_21_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_752 + tmp_qloop_577*tmp_qloop_751 + tmp_qloop_582*tmp_qloop_753 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_750);
                   const real_t q_tmp_22_22 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_471*tmp_qloop_756 + tmp_qloop_472*tmp_qloop_755 + tmp_qloop_477*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_467*tmp_qloop_754);
                   const real_t q_tmp_22_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_756 + tmp_qloop_487*tmp_qloop_755 + tmp_qloop_492*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_754);
                   const real_t q_tmp_22_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_756 + tmp_qloop_502*tmp_qloop_755 + tmp_qloop_507*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_754);
                   const real_t q_tmp_22_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_756 + tmp_qloop_517*tmp_qloop_755 + tmp_qloop_522*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_754);
                   const real_t q_tmp_22_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_756 + tmp_qloop_532*tmp_qloop_755 + tmp_qloop_537*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_754);
                   const real_t q_tmp_22_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_756 + tmp_qloop_547*tmp_qloop_755 + tmp_qloop_552*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_754);
                   const real_t q_tmp_22_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_756 + tmp_qloop_562*tmp_qloop_755 + tmp_qloop_567*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_754);
                   const real_t q_tmp_22_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_756 + tmp_qloop_577*tmp_qloop_755 + tmp_qloop_582*tmp_qloop_757 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_754);
                   const real_t q_tmp_23_23 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_486*tmp_qloop_760 + tmp_qloop_487*tmp_qloop_759 + tmp_qloop_492*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_482*tmp_qloop_758);
                   const real_t q_tmp_23_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_760 + tmp_qloop_502*tmp_qloop_759 + tmp_qloop_507*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_758);
                   const real_t q_tmp_23_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_760 + tmp_qloop_517*tmp_qloop_759 + tmp_qloop_522*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_758);
                   const real_t q_tmp_23_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_760 + tmp_qloop_532*tmp_qloop_759 + tmp_qloop_537*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_758);
                   const real_t q_tmp_23_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_760 + tmp_qloop_547*tmp_qloop_759 + tmp_qloop_552*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_758);
                   const real_t q_tmp_23_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_760 + tmp_qloop_562*tmp_qloop_759 + tmp_qloop_567*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_758);
                   const real_t q_tmp_23_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_760 + tmp_qloop_577*tmp_qloop_759 + tmp_qloop_582*tmp_qloop_761 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_758);
                   const real_t q_tmp_24_24 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_501*tmp_qloop_764 + tmp_qloop_502*tmp_qloop_763 + tmp_qloop_507*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_497*tmp_qloop_762);
                   const real_t q_tmp_24_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_764 + tmp_qloop_517*tmp_qloop_763 + tmp_qloop_522*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_762);
                   const real_t q_tmp_24_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_764 + tmp_qloop_532*tmp_qloop_763 + tmp_qloop_537*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_762);
                   const real_t q_tmp_24_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_764 + tmp_qloop_547*tmp_qloop_763 + tmp_qloop_552*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_762);
                   const real_t q_tmp_24_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_764 + tmp_qloop_562*tmp_qloop_763 + tmp_qloop_567*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_762);
                   const real_t q_tmp_24_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_764 + tmp_qloop_577*tmp_qloop_763 + tmp_qloop_582*tmp_qloop_765 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_762);
                   const real_t q_tmp_25_25 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_516*tmp_qloop_768 + tmp_qloop_517*tmp_qloop_767 + tmp_qloop_522*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_512*tmp_qloop_766);
                   const real_t q_tmp_25_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_768 + tmp_qloop_532*tmp_qloop_767 + tmp_qloop_537*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_766);
                   const real_t q_tmp_25_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_768 + tmp_qloop_547*tmp_qloop_767 + tmp_qloop_552*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_766);
                   const real_t q_tmp_25_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_768 + tmp_qloop_562*tmp_qloop_767 + tmp_qloop_567*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_766);
                   const real_t q_tmp_25_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_768 + tmp_qloop_577*tmp_qloop_767 + tmp_qloop_582*tmp_qloop_769 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_766);
                   const real_t q_tmp_26_26 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_531*tmp_qloop_772 + tmp_qloop_532*tmp_qloop_771 + tmp_qloop_537*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_527*tmp_qloop_770);
                   const real_t q_tmp_26_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_772 + tmp_qloop_547*tmp_qloop_771 + tmp_qloop_552*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_770);
                   const real_t q_tmp_26_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_772 + tmp_qloop_562*tmp_qloop_771 + tmp_qloop_567*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_770);
                   const real_t q_tmp_26_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_772 + tmp_qloop_577*tmp_qloop_771 + tmp_qloop_582*tmp_qloop_773 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_770);
                   const real_t q_tmp_27_27 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_546*tmp_qloop_776 + tmp_qloop_547*tmp_qloop_775 + tmp_qloop_552*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_542*tmp_qloop_774);
                   const real_t q_tmp_27_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_776 + tmp_qloop_562*tmp_qloop_775 + tmp_qloop_567*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_774);
                   const real_t q_tmp_27_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_776 + tmp_qloop_577*tmp_qloop_775 + tmp_qloop_582*tmp_qloop_777 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_774);
                   const real_t q_tmp_28_28 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_561*tmp_qloop_780 + tmp_qloop_562*tmp_qloop_779 + tmp_qloop_567*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_557*tmp_qloop_778);
                   const real_t q_tmp_28_29 = tmp_qloop_156*(tmp_qloop_118*(tmp_qloop_576*tmp_qloop_780 + tmp_qloop_577*tmp_qloop_779 + tmp_qloop_582*tmp_qloop_781 + tmp_qloop_749) - tmp_qloop_572*tmp_qloop_778);
                   const real_t q_tmp_29_29 = tmp_qloop_156*(-tmp_qloop_118*tmp_qloop_572*(tmp_qloop_569 + tmp_qloop_570 + tmp_qloop_571 + tmp_qloop_744) + tmp_qloop_118*(tmp_qloop_576*(tmp_qloop_573*0.5 + tmp_qloop_574*0.5 + tmp_qloop_575*0.5 + tmp_qloop_675)*2.0 + tmp_qloop_577*(tmp_qloop_569*1.0 + tmp_qloop_570*1.0 + tmp_qloop_571*1.0) + tmp_qloop_582*(tmp_qloop_153 + tmp_qloop_579*0.5 + tmp_qloop_580*0.5 + tmp_qloop_581*0.5)*2.0 + tmp_qloop_749));
                   q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                   q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                   q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                   q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                   q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                   q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                   q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                   q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                   q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                   q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                   q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                   q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                   q_acc_0_12 = q_acc_0_12 + q_tmp_0_12;
                   q_acc_0_13 = q_acc_0_13 + q_tmp_0_13;
                   q_acc_0_14 = q_acc_0_14 + q_tmp_0_14;
                   q_acc_0_15 = q_acc_0_15 + q_tmp_0_15;
                   q_acc_0_16 = q_acc_0_16 + q_tmp_0_16;
                   q_acc_0_17 = q_acc_0_17 + q_tmp_0_17;
                   q_acc_0_18 = q_acc_0_18 + q_tmp_0_18;
                   q_acc_0_19 = q_acc_0_19 + q_tmp_0_19;
                   q_acc_0_20 = q_acc_0_20 + q_tmp_0_20;
                   q_acc_0_21 = q_acc_0_21 + q_tmp_0_21;
                   q_acc_0_22 = q_acc_0_22 + q_tmp_0_22;
                   q_acc_0_23 = q_acc_0_23 + q_tmp_0_23;
                   q_acc_0_24 = q_acc_0_24 + q_tmp_0_24;
                   q_acc_0_25 = q_acc_0_25 + q_tmp_0_25;
                   q_acc_0_26 = q_acc_0_26 + q_tmp_0_26;
                   q_acc_0_27 = q_acc_0_27 + q_tmp_0_27;
                   q_acc_0_28 = q_acc_0_28 + q_tmp_0_28;
                   q_acc_0_29 = q_acc_0_29 + q_tmp_0_29;
                   q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                   q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                   q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                   q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                   q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                   q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                   q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                   q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                   q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                   q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                   q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                   q_acc_1_12 = q_acc_1_12 + q_tmp_1_12;
                   q_acc_1_13 = q_acc_1_13 + q_tmp_1_13;
                   q_acc_1_14 = q_acc_1_14 + q_tmp_1_14;
                   q_acc_1_15 = q_acc_1_15 + q_tmp_1_15;
                   q_acc_1_16 = q_acc_1_16 + q_tmp_1_16;
                   q_acc_1_17 = q_acc_1_17 + q_tmp_1_17;
                   q_acc_1_18 = q_acc_1_18 + q_tmp_1_18;
                   q_acc_1_19 = q_acc_1_19 + q_tmp_1_19;
                   q_acc_1_20 = q_acc_1_20 + q_tmp_1_20;
                   q_acc_1_21 = q_acc_1_21 + q_tmp_1_21;
                   q_acc_1_22 = q_acc_1_22 + q_tmp_1_22;
                   q_acc_1_23 = q_acc_1_23 + q_tmp_1_23;
                   q_acc_1_24 = q_acc_1_24 + q_tmp_1_24;
                   q_acc_1_25 = q_acc_1_25 + q_tmp_1_25;
                   q_acc_1_26 = q_acc_1_26 + q_tmp_1_26;
                   q_acc_1_27 = q_acc_1_27 + q_tmp_1_27;
                   q_acc_1_28 = q_acc_1_28 + q_tmp_1_28;
                   q_acc_1_29 = q_acc_1_29 + q_tmp_1_29;
                   q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                   q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                   q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                   q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                   q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                   q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                   q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                   q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                   q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                   q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                   q_acc_2_12 = q_acc_2_12 + q_tmp_2_12;
                   q_acc_2_13 = q_acc_2_13 + q_tmp_2_13;
                   q_acc_2_14 = q_acc_2_14 + q_tmp_2_14;
                   q_acc_2_15 = q_acc_2_15 + q_tmp_2_15;
                   q_acc_2_16 = q_acc_2_16 + q_tmp_2_16;
                   q_acc_2_17 = q_acc_2_17 + q_tmp_2_17;
                   q_acc_2_18 = q_acc_2_18 + q_tmp_2_18;
                   q_acc_2_19 = q_acc_2_19 + q_tmp_2_19;
                   q_acc_2_20 = q_acc_2_20 + q_tmp_2_20;
                   q_acc_2_21 = q_acc_2_21 + q_tmp_2_21;
                   q_acc_2_22 = q_acc_2_22 + q_tmp_2_22;
                   q_acc_2_23 = q_acc_2_23 + q_tmp_2_23;
                   q_acc_2_24 = q_acc_2_24 + q_tmp_2_24;
                   q_acc_2_25 = q_acc_2_25 + q_tmp_2_25;
                   q_acc_2_26 = q_acc_2_26 + q_tmp_2_26;
                   q_acc_2_27 = q_acc_2_27 + q_tmp_2_27;
                   q_acc_2_28 = q_acc_2_28 + q_tmp_2_28;
                   q_acc_2_29 = q_acc_2_29 + q_tmp_2_29;
                   q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                   q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                   q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                   q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                   q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                   q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                   q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                   q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                   q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                   q_acc_3_12 = q_acc_3_12 + q_tmp_3_12;
                   q_acc_3_13 = q_acc_3_13 + q_tmp_3_13;
                   q_acc_3_14 = q_acc_3_14 + q_tmp_3_14;
                   q_acc_3_15 = q_acc_3_15 + q_tmp_3_15;
                   q_acc_3_16 = q_acc_3_16 + q_tmp_3_16;
                   q_acc_3_17 = q_acc_3_17 + q_tmp_3_17;
                   q_acc_3_18 = q_acc_3_18 + q_tmp_3_18;
                   q_acc_3_19 = q_acc_3_19 + q_tmp_3_19;
                   q_acc_3_20 = q_acc_3_20 + q_tmp_3_20;
                   q_acc_3_21 = q_acc_3_21 + q_tmp_3_21;
                   q_acc_3_22 = q_acc_3_22 + q_tmp_3_22;
                   q_acc_3_23 = q_acc_3_23 + q_tmp_3_23;
                   q_acc_3_24 = q_acc_3_24 + q_tmp_3_24;
                   q_acc_3_25 = q_acc_3_25 + q_tmp_3_25;
                   q_acc_3_26 = q_acc_3_26 + q_tmp_3_26;
                   q_acc_3_27 = q_acc_3_27 + q_tmp_3_27;
                   q_acc_3_28 = q_acc_3_28 + q_tmp_3_28;
                   q_acc_3_29 = q_acc_3_29 + q_tmp_3_29;
                   q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                   q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                   q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                   q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                   q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                   q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                   q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                   q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                   q_acc_4_12 = q_acc_4_12 + q_tmp_4_12;
                   q_acc_4_13 = q_acc_4_13 + q_tmp_4_13;
                   q_acc_4_14 = q_acc_4_14 + q_tmp_4_14;
                   q_acc_4_15 = q_acc_4_15 + q_tmp_4_15;
                   q_acc_4_16 = q_acc_4_16 + q_tmp_4_16;
                   q_acc_4_17 = q_acc_4_17 + q_tmp_4_17;
                   q_acc_4_18 = q_acc_4_18 + q_tmp_4_18;
                   q_acc_4_19 = q_acc_4_19 + q_tmp_4_19;
                   q_acc_4_20 = q_acc_4_20 + q_tmp_4_20;
                   q_acc_4_21 = q_acc_4_21 + q_tmp_4_21;
                   q_acc_4_22 = q_acc_4_22 + q_tmp_4_22;
                   q_acc_4_23 = q_acc_4_23 + q_tmp_4_23;
                   q_acc_4_24 = q_acc_4_24 + q_tmp_4_24;
                   q_acc_4_25 = q_acc_4_25 + q_tmp_4_25;
                   q_acc_4_26 = q_acc_4_26 + q_tmp_4_26;
                   q_acc_4_27 = q_acc_4_27 + q_tmp_4_27;
                   q_acc_4_28 = q_acc_4_28 + q_tmp_4_28;
                   q_acc_4_29 = q_acc_4_29 + q_tmp_4_29;
                   q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                   q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                   q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                   q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                   q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                   q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                   q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                   q_acc_5_12 = q_acc_5_12 + q_tmp_5_12;
                   q_acc_5_13 = q_acc_5_13 + q_tmp_5_13;
                   q_acc_5_14 = q_acc_5_14 + q_tmp_5_14;
                   q_acc_5_15 = q_acc_5_15 + q_tmp_5_15;
                   q_acc_5_16 = q_acc_5_16 + q_tmp_5_16;
                   q_acc_5_17 = q_acc_5_17 + q_tmp_5_17;
                   q_acc_5_18 = q_acc_5_18 + q_tmp_5_18;
                   q_acc_5_19 = q_acc_5_19 + q_tmp_5_19;
                   q_acc_5_20 = q_acc_5_20 + q_tmp_5_20;
                   q_acc_5_21 = q_acc_5_21 + q_tmp_5_21;
                   q_acc_5_22 = q_acc_5_22 + q_tmp_5_22;
                   q_acc_5_23 = q_acc_5_23 + q_tmp_5_23;
                   q_acc_5_24 = q_acc_5_24 + q_tmp_5_24;
                   q_acc_5_25 = q_acc_5_25 + q_tmp_5_25;
                   q_acc_5_26 = q_acc_5_26 + q_tmp_5_26;
                   q_acc_5_27 = q_acc_5_27 + q_tmp_5_27;
                   q_acc_5_28 = q_acc_5_28 + q_tmp_5_28;
                   q_acc_5_29 = q_acc_5_29 + q_tmp_5_29;
                   q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                   q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                   q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                   q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                   q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                   q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                   q_acc_6_12 = q_acc_6_12 + q_tmp_6_12;
                   q_acc_6_13 = q_acc_6_13 + q_tmp_6_13;
                   q_acc_6_14 = q_acc_6_14 + q_tmp_6_14;
                   q_acc_6_15 = q_acc_6_15 + q_tmp_6_15;
                   q_acc_6_16 = q_acc_6_16 + q_tmp_6_16;
                   q_acc_6_17 = q_acc_6_17 + q_tmp_6_17;
                   q_acc_6_18 = q_acc_6_18 + q_tmp_6_18;
                   q_acc_6_19 = q_acc_6_19 + q_tmp_6_19;
                   q_acc_6_20 = q_acc_6_20 + q_tmp_6_20;
                   q_acc_6_21 = q_acc_6_21 + q_tmp_6_21;
                   q_acc_6_22 = q_acc_6_22 + q_tmp_6_22;
                   q_acc_6_23 = q_acc_6_23 + q_tmp_6_23;
                   q_acc_6_24 = q_acc_6_24 + q_tmp_6_24;
                   q_acc_6_25 = q_acc_6_25 + q_tmp_6_25;
                   q_acc_6_26 = q_acc_6_26 + q_tmp_6_26;
                   q_acc_6_27 = q_acc_6_27 + q_tmp_6_27;
                   q_acc_6_28 = q_acc_6_28 + q_tmp_6_28;
                   q_acc_6_29 = q_acc_6_29 + q_tmp_6_29;
                   q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                   q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                   q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                   q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                   q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                   q_acc_7_12 = q_acc_7_12 + q_tmp_7_12;
                   q_acc_7_13 = q_acc_7_13 + q_tmp_7_13;
                   q_acc_7_14 = q_acc_7_14 + q_tmp_7_14;
                   q_acc_7_15 = q_acc_7_15 + q_tmp_7_15;
                   q_acc_7_16 = q_acc_7_16 + q_tmp_7_16;
                   q_acc_7_17 = q_acc_7_17 + q_tmp_7_17;
                   q_acc_7_18 = q_acc_7_18 + q_tmp_7_18;
                   q_acc_7_19 = q_acc_7_19 + q_tmp_7_19;
                   q_acc_7_20 = q_acc_7_20 + q_tmp_7_20;
                   q_acc_7_21 = q_acc_7_21 + q_tmp_7_21;
                   q_acc_7_22 = q_acc_7_22 + q_tmp_7_22;
                   q_acc_7_23 = q_acc_7_23 + q_tmp_7_23;
                   q_acc_7_24 = q_acc_7_24 + q_tmp_7_24;
                   q_acc_7_25 = q_acc_7_25 + q_tmp_7_25;
                   q_acc_7_26 = q_acc_7_26 + q_tmp_7_26;
                   q_acc_7_27 = q_acc_7_27 + q_tmp_7_27;
                   q_acc_7_28 = q_acc_7_28 + q_tmp_7_28;
                   q_acc_7_29 = q_acc_7_29 + q_tmp_7_29;
                   q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                   q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                   q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                   q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                   q_acc_8_12 = q_acc_8_12 + q_tmp_8_12;
                   q_acc_8_13 = q_acc_8_13 + q_tmp_8_13;
                   q_acc_8_14 = q_acc_8_14 + q_tmp_8_14;
                   q_acc_8_15 = q_acc_8_15 + q_tmp_8_15;
                   q_acc_8_16 = q_acc_8_16 + q_tmp_8_16;
                   q_acc_8_17 = q_acc_8_17 + q_tmp_8_17;
                   q_acc_8_18 = q_acc_8_18 + q_tmp_8_18;
                   q_acc_8_19 = q_acc_8_19 + q_tmp_8_19;
                   q_acc_8_20 = q_acc_8_20 + q_tmp_8_20;
                   q_acc_8_21 = q_acc_8_21 + q_tmp_8_21;
                   q_acc_8_22 = q_acc_8_22 + q_tmp_8_22;
                   q_acc_8_23 = q_acc_8_23 + q_tmp_8_23;
                   q_acc_8_24 = q_acc_8_24 + q_tmp_8_24;
                   q_acc_8_25 = q_acc_8_25 + q_tmp_8_25;
                   q_acc_8_26 = q_acc_8_26 + q_tmp_8_26;
                   q_acc_8_27 = q_acc_8_27 + q_tmp_8_27;
                   q_acc_8_28 = q_acc_8_28 + q_tmp_8_28;
                   q_acc_8_29 = q_acc_8_29 + q_tmp_8_29;
                   q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                   q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                   q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                   q_acc_9_12 = q_acc_9_12 + q_tmp_9_12;
                   q_acc_9_13 = q_acc_9_13 + q_tmp_9_13;
                   q_acc_9_14 = q_acc_9_14 + q_tmp_9_14;
                   q_acc_9_15 = q_acc_9_15 + q_tmp_9_15;
                   q_acc_9_16 = q_acc_9_16 + q_tmp_9_16;
                   q_acc_9_17 = q_acc_9_17 + q_tmp_9_17;
                   q_acc_9_18 = q_acc_9_18 + q_tmp_9_18;
                   q_acc_9_19 = q_acc_9_19 + q_tmp_9_19;
                   q_acc_9_20 = q_acc_9_20 + q_tmp_9_20;
                   q_acc_9_21 = q_acc_9_21 + q_tmp_9_21;
                   q_acc_9_22 = q_acc_9_22 + q_tmp_9_22;
                   q_acc_9_23 = q_acc_9_23 + q_tmp_9_23;
                   q_acc_9_24 = q_acc_9_24 + q_tmp_9_24;
                   q_acc_9_25 = q_acc_9_25 + q_tmp_9_25;
                   q_acc_9_26 = q_acc_9_26 + q_tmp_9_26;
                   q_acc_9_27 = q_acc_9_27 + q_tmp_9_27;
                   q_acc_9_28 = q_acc_9_28 + q_tmp_9_28;
                   q_acc_9_29 = q_acc_9_29 + q_tmp_9_29;
                   q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                   q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                   q_acc_10_12 = q_acc_10_12 + q_tmp_10_12;
                   q_acc_10_13 = q_acc_10_13 + q_tmp_10_13;
                   q_acc_10_14 = q_acc_10_14 + q_tmp_10_14;
                   q_acc_10_15 = q_acc_10_15 + q_tmp_10_15;
                   q_acc_10_16 = q_acc_10_16 + q_tmp_10_16;
                   q_acc_10_17 = q_acc_10_17 + q_tmp_10_17;
                   q_acc_10_18 = q_acc_10_18 + q_tmp_10_18;
                   q_acc_10_19 = q_acc_10_19 + q_tmp_10_19;
                   q_acc_10_20 = q_acc_10_20 + q_tmp_10_20;
                   q_acc_10_21 = q_acc_10_21 + q_tmp_10_21;
                   q_acc_10_22 = q_acc_10_22 + q_tmp_10_22;
                   q_acc_10_23 = q_acc_10_23 + q_tmp_10_23;
                   q_acc_10_24 = q_acc_10_24 + q_tmp_10_24;
                   q_acc_10_25 = q_acc_10_25 + q_tmp_10_25;
                   q_acc_10_26 = q_acc_10_26 + q_tmp_10_26;
                   q_acc_10_27 = q_acc_10_27 + q_tmp_10_27;
                   q_acc_10_28 = q_acc_10_28 + q_tmp_10_28;
                   q_acc_10_29 = q_acc_10_29 + q_tmp_10_29;
                   q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
                   q_acc_11_12 = q_acc_11_12 + q_tmp_11_12;
                   q_acc_11_13 = q_acc_11_13 + q_tmp_11_13;
                   q_acc_11_14 = q_acc_11_14 + q_tmp_11_14;
                   q_acc_11_15 = q_acc_11_15 + q_tmp_11_15;
                   q_acc_11_16 = q_acc_11_16 + q_tmp_11_16;
                   q_acc_11_17 = q_acc_11_17 + q_tmp_11_17;
                   q_acc_11_18 = q_acc_11_18 + q_tmp_11_18;
                   q_acc_11_19 = q_acc_11_19 + q_tmp_11_19;
                   q_acc_11_20 = q_acc_11_20 + q_tmp_11_20;
                   q_acc_11_21 = q_acc_11_21 + q_tmp_11_21;
                   q_acc_11_22 = q_acc_11_22 + q_tmp_11_22;
                   q_acc_11_23 = q_acc_11_23 + q_tmp_11_23;
                   q_acc_11_24 = q_acc_11_24 + q_tmp_11_24;
                   q_acc_11_25 = q_acc_11_25 + q_tmp_11_25;
                   q_acc_11_26 = q_acc_11_26 + q_tmp_11_26;
                   q_acc_11_27 = q_acc_11_27 + q_tmp_11_27;
                   q_acc_11_28 = q_acc_11_28 + q_tmp_11_28;
                   q_acc_11_29 = q_acc_11_29 + q_tmp_11_29;
                   q_acc_12_12 = q_acc_12_12 + q_tmp_12_12;
                   q_acc_12_13 = q_acc_12_13 + q_tmp_12_13;
                   q_acc_12_14 = q_acc_12_14 + q_tmp_12_14;
                   q_acc_12_15 = q_acc_12_15 + q_tmp_12_15;
                   q_acc_12_16 = q_acc_12_16 + q_tmp_12_16;
                   q_acc_12_17 = q_acc_12_17 + q_tmp_12_17;
                   q_acc_12_18 = q_acc_12_18 + q_tmp_12_18;
                   q_acc_12_19 = q_acc_12_19 + q_tmp_12_19;
                   q_acc_12_20 = q_acc_12_20 + q_tmp_12_20;
                   q_acc_12_21 = q_acc_12_21 + q_tmp_12_21;
                   q_acc_12_22 = q_acc_12_22 + q_tmp_12_22;
                   q_acc_12_23 = q_acc_12_23 + q_tmp_12_23;
                   q_acc_12_24 = q_acc_12_24 + q_tmp_12_24;
                   q_acc_12_25 = q_acc_12_25 + q_tmp_12_25;
                   q_acc_12_26 = q_acc_12_26 + q_tmp_12_26;
                   q_acc_12_27 = q_acc_12_27 + q_tmp_12_27;
                   q_acc_12_28 = q_acc_12_28 + q_tmp_12_28;
                   q_acc_12_29 = q_acc_12_29 + q_tmp_12_29;
                   q_acc_13_13 = q_acc_13_13 + q_tmp_13_13;
                   q_acc_13_14 = q_acc_13_14 + q_tmp_13_14;
                   q_acc_13_15 = q_acc_13_15 + q_tmp_13_15;
                   q_acc_13_16 = q_acc_13_16 + q_tmp_13_16;
                   q_acc_13_17 = q_acc_13_17 + q_tmp_13_17;
                   q_acc_13_18 = q_acc_13_18 + q_tmp_13_18;
                   q_acc_13_19 = q_acc_13_19 + q_tmp_13_19;
                   q_acc_13_20 = q_acc_13_20 + q_tmp_13_20;
                   q_acc_13_21 = q_acc_13_21 + q_tmp_13_21;
                   q_acc_13_22 = q_acc_13_22 + q_tmp_13_22;
                   q_acc_13_23 = q_acc_13_23 + q_tmp_13_23;
                   q_acc_13_24 = q_acc_13_24 + q_tmp_13_24;
                   q_acc_13_25 = q_acc_13_25 + q_tmp_13_25;
                   q_acc_13_26 = q_acc_13_26 + q_tmp_13_26;
                   q_acc_13_27 = q_acc_13_27 + q_tmp_13_27;
                   q_acc_13_28 = q_acc_13_28 + q_tmp_13_28;
                   q_acc_13_29 = q_acc_13_29 + q_tmp_13_29;
                   q_acc_14_14 = q_acc_14_14 + q_tmp_14_14;
                   q_acc_14_15 = q_acc_14_15 + q_tmp_14_15;
                   q_acc_14_16 = q_acc_14_16 + q_tmp_14_16;
                   q_acc_14_17 = q_acc_14_17 + q_tmp_14_17;
                   q_acc_14_18 = q_acc_14_18 + q_tmp_14_18;
                   q_acc_14_19 = q_acc_14_19 + q_tmp_14_19;
                   q_acc_14_20 = q_acc_14_20 + q_tmp_14_20;
                   q_acc_14_21 = q_acc_14_21 + q_tmp_14_21;
                   q_acc_14_22 = q_acc_14_22 + q_tmp_14_22;
                   q_acc_14_23 = q_acc_14_23 + q_tmp_14_23;
                   q_acc_14_24 = q_acc_14_24 + q_tmp_14_24;
                   q_acc_14_25 = q_acc_14_25 + q_tmp_14_25;
                   q_acc_14_26 = q_acc_14_26 + q_tmp_14_26;
                   q_acc_14_27 = q_acc_14_27 + q_tmp_14_27;
                   q_acc_14_28 = q_acc_14_28 + q_tmp_14_28;
                   q_acc_14_29 = q_acc_14_29 + q_tmp_14_29;
                   q_acc_15_15 = q_acc_15_15 + q_tmp_15_15;
                   q_acc_15_16 = q_acc_15_16 + q_tmp_15_16;
                   q_acc_15_17 = q_acc_15_17 + q_tmp_15_17;
                   q_acc_15_18 = q_acc_15_18 + q_tmp_15_18;
                   q_acc_15_19 = q_acc_15_19 + q_tmp_15_19;
                   q_acc_15_20 = q_acc_15_20 + q_tmp_15_20;
                   q_acc_15_21 = q_acc_15_21 + q_tmp_15_21;
                   q_acc_15_22 = q_acc_15_22 + q_tmp_15_22;
                   q_acc_15_23 = q_acc_15_23 + q_tmp_15_23;
                   q_acc_15_24 = q_acc_15_24 + q_tmp_15_24;
                   q_acc_15_25 = q_acc_15_25 + q_tmp_15_25;
                   q_acc_15_26 = q_acc_15_26 + q_tmp_15_26;
                   q_acc_15_27 = q_acc_15_27 + q_tmp_15_27;
                   q_acc_15_28 = q_acc_15_28 + q_tmp_15_28;
                   q_acc_15_29 = q_acc_15_29 + q_tmp_15_29;
                   q_acc_16_16 = q_acc_16_16 + q_tmp_16_16;
                   q_acc_16_17 = q_acc_16_17 + q_tmp_16_17;
                   q_acc_16_18 = q_acc_16_18 + q_tmp_16_18;
                   q_acc_16_19 = q_acc_16_19 + q_tmp_16_19;
                   q_acc_16_20 = q_acc_16_20 + q_tmp_16_20;
                   q_acc_16_21 = q_acc_16_21 + q_tmp_16_21;
                   q_acc_16_22 = q_acc_16_22 + q_tmp_16_22;
                   q_acc_16_23 = q_acc_16_23 + q_tmp_16_23;
                   q_acc_16_24 = q_acc_16_24 + q_tmp_16_24;
                   q_acc_16_25 = q_acc_16_25 + q_tmp_16_25;
                   q_acc_16_26 = q_acc_16_26 + q_tmp_16_26;
                   q_acc_16_27 = q_acc_16_27 + q_tmp_16_27;
                   q_acc_16_28 = q_acc_16_28 + q_tmp_16_28;
                   q_acc_16_29 = q_acc_16_29 + q_tmp_16_29;
                   q_acc_17_17 = q_acc_17_17 + q_tmp_17_17;
                   q_acc_17_18 = q_acc_17_18 + q_tmp_17_18;
                   q_acc_17_19 = q_acc_17_19 + q_tmp_17_19;
                   q_acc_17_20 = q_acc_17_20 + q_tmp_17_20;
                   q_acc_17_21 = q_acc_17_21 + q_tmp_17_21;
                   q_acc_17_22 = q_acc_17_22 + q_tmp_17_22;
                   q_acc_17_23 = q_acc_17_23 + q_tmp_17_23;
                   q_acc_17_24 = q_acc_17_24 + q_tmp_17_24;
                   q_acc_17_25 = q_acc_17_25 + q_tmp_17_25;
                   q_acc_17_26 = q_acc_17_26 + q_tmp_17_26;
                   q_acc_17_27 = q_acc_17_27 + q_tmp_17_27;
                   q_acc_17_28 = q_acc_17_28 + q_tmp_17_28;
                   q_acc_17_29 = q_acc_17_29 + q_tmp_17_29;
                   q_acc_18_18 = q_acc_18_18 + q_tmp_18_18;
                   q_acc_18_19 = q_acc_18_19 + q_tmp_18_19;
                   q_acc_18_20 = q_acc_18_20 + q_tmp_18_20;
                   q_acc_18_21 = q_acc_18_21 + q_tmp_18_21;
                   q_acc_18_22 = q_acc_18_22 + q_tmp_18_22;
                   q_acc_18_23 = q_acc_18_23 + q_tmp_18_23;
                   q_acc_18_24 = q_acc_18_24 + q_tmp_18_24;
                   q_acc_18_25 = q_acc_18_25 + q_tmp_18_25;
                   q_acc_18_26 = q_acc_18_26 + q_tmp_18_26;
                   q_acc_18_27 = q_acc_18_27 + q_tmp_18_27;
                   q_acc_18_28 = q_acc_18_28 + q_tmp_18_28;
                   q_acc_18_29 = q_acc_18_29 + q_tmp_18_29;
                   q_acc_19_19 = q_acc_19_19 + q_tmp_19_19;
                   q_acc_19_20 = q_acc_19_20 + q_tmp_19_20;
                   q_acc_19_21 = q_acc_19_21 + q_tmp_19_21;
                   q_acc_19_22 = q_acc_19_22 + q_tmp_19_22;
                   q_acc_19_23 = q_acc_19_23 + q_tmp_19_23;
                   q_acc_19_24 = q_acc_19_24 + q_tmp_19_24;
                   q_acc_19_25 = q_acc_19_25 + q_tmp_19_25;
                   q_acc_19_26 = q_acc_19_26 + q_tmp_19_26;
                   q_acc_19_27 = q_acc_19_27 + q_tmp_19_27;
                   q_acc_19_28 = q_acc_19_28 + q_tmp_19_28;
                   q_acc_19_29 = q_acc_19_29 + q_tmp_19_29;
                   q_acc_20_20 = q_acc_20_20 + q_tmp_20_20;
                   q_acc_20_21 = q_acc_20_21 + q_tmp_20_21;
                   q_acc_20_22 = q_acc_20_22 + q_tmp_20_22;
                   q_acc_20_23 = q_acc_20_23 + q_tmp_20_23;
                   q_acc_20_24 = q_acc_20_24 + q_tmp_20_24;
                   q_acc_20_25 = q_acc_20_25 + q_tmp_20_25;
                   q_acc_20_26 = q_acc_20_26 + q_tmp_20_26;
                   q_acc_20_27 = q_acc_20_27 + q_tmp_20_27;
                   q_acc_20_28 = q_acc_20_28 + q_tmp_20_28;
                   q_acc_20_29 = q_acc_20_29 + q_tmp_20_29;
                   q_acc_21_21 = q_acc_21_21 + q_tmp_21_21;
                   q_acc_21_22 = q_acc_21_22 + q_tmp_21_22;
                   q_acc_21_23 = q_acc_21_23 + q_tmp_21_23;
                   q_acc_21_24 = q_acc_21_24 + q_tmp_21_24;
                   q_acc_21_25 = q_acc_21_25 + q_tmp_21_25;
                   q_acc_21_26 = q_acc_21_26 + q_tmp_21_26;
                   q_acc_21_27 = q_acc_21_27 + q_tmp_21_27;
                   q_acc_21_28 = q_acc_21_28 + q_tmp_21_28;
                   q_acc_21_29 = q_acc_21_29 + q_tmp_21_29;
                   q_acc_22_22 = q_acc_22_22 + q_tmp_22_22;
                   q_acc_22_23 = q_acc_22_23 + q_tmp_22_23;
                   q_acc_22_24 = q_acc_22_24 + q_tmp_22_24;
                   q_acc_22_25 = q_acc_22_25 + q_tmp_22_25;
                   q_acc_22_26 = q_acc_22_26 + q_tmp_22_26;
                   q_acc_22_27 = q_acc_22_27 + q_tmp_22_27;
                   q_acc_22_28 = q_acc_22_28 + q_tmp_22_28;
                   q_acc_22_29 = q_acc_22_29 + q_tmp_22_29;
                   q_acc_23_23 = q_acc_23_23 + q_tmp_23_23;
                   q_acc_23_24 = q_acc_23_24 + q_tmp_23_24;
                   q_acc_23_25 = q_acc_23_25 + q_tmp_23_25;
                   q_acc_23_26 = q_acc_23_26 + q_tmp_23_26;
                   q_acc_23_27 = q_acc_23_27 + q_tmp_23_27;
                   q_acc_23_28 = q_acc_23_28 + q_tmp_23_28;
                   q_acc_23_29 = q_acc_23_29 + q_tmp_23_29;
                   q_acc_24_24 = q_acc_24_24 + q_tmp_24_24;
                   q_acc_24_25 = q_acc_24_25 + q_tmp_24_25;
                   q_acc_24_26 = q_acc_24_26 + q_tmp_24_26;
                   q_acc_24_27 = q_acc_24_27 + q_tmp_24_27;
                   q_acc_24_28 = q_acc_24_28 + q_tmp_24_28;
                   q_acc_24_29 = q_acc_24_29 + q_tmp_24_29;
                   q_acc_25_25 = q_acc_25_25 + q_tmp_25_25;
                   q_acc_25_26 = q_acc_25_26 + q_tmp_25_26;
                   q_acc_25_27 = q_acc_25_27 + q_tmp_25_27;
                   q_acc_25_28 = q_acc_25_28 + q_tmp_25_28;
                   q_acc_25_29 = q_acc_25_29 + q_tmp_25_29;
                   q_acc_26_26 = q_acc_26_26 + q_tmp_26_26;
                   q_acc_26_27 = q_acc_26_27 + q_tmp_26_27;
                   q_acc_26_28 = q_acc_26_28 + q_tmp_26_28;
                   q_acc_26_29 = q_acc_26_29 + q_tmp_26_29;
                   q_acc_27_27 = q_acc_27_27 + q_tmp_27_27;
                   q_acc_27_28 = q_acc_27_28 + q_tmp_27_28;
                   q_acc_27_29 = q_acc_27_29 + q_tmp_27_29;
                   q_acc_28_28 = q_acc_28_28 + q_tmp_28_28;
                   q_acc_28_29 = q_acc_28_29 + q_tmp_28_29;
                   q_acc_29_29 = q_acc_29_29 + q_tmp_29_29;
                }
                const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_10*src_dof_10 + q_acc_0_11*src_dof_11 + q_acc_0_12*src_dof_12 + q_acc_0_13*src_dof_13 + q_acc_0_14*src_dof_14 + q_acc_0_15*src_dof_15 + q_acc_0_16*src_dof_16 + q_acc_0_17*src_dof_17 + q_acc_0_18*src_dof_18 + q_acc_0_19*src_dof_19 + q_acc_0_2*src_dof_2 + q_acc_0_20*src_dof_20 + q_acc_0_21*src_dof_21 + q_acc_0_22*src_dof_22 + q_acc_0_23*src_dof_23 + q_acc_0_24*src_dof_24 + q_acc_0_25*src_dof_25 + q_acc_0_26*src_dof_26 + q_acc_0_27*src_dof_27 + q_acc_0_28*src_dof_28 + q_acc_0_29*src_dof_29 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
                const real_t elMatVec_1 = q_acc_0_1*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_10*src_dof_10 + q_acc_1_11*src_dof_11 + q_acc_1_12*src_dof_12 + q_acc_1_13*src_dof_13 + q_acc_1_14*src_dof_14 + q_acc_1_15*src_dof_15 + q_acc_1_16*src_dof_16 + q_acc_1_17*src_dof_17 + q_acc_1_18*src_dof_18 + q_acc_1_19*src_dof_19 + q_acc_1_2*src_dof_2 + q_acc_1_20*src_dof_20 + q_acc_1_21*src_dof_21 + q_acc_1_22*src_dof_22 + q_acc_1_23*src_dof_23 + q_acc_1_24*src_dof_24 + q_acc_1_25*src_dof_25 + q_acc_1_26*src_dof_26 + q_acc_1_27*src_dof_27 + q_acc_1_28*src_dof_28 + q_acc_1_29*src_dof_29 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
                const real_t elMatVec_2 = q_acc_0_2*src_dof_0 + q_acc_1_2*src_dof_1 + q_acc_2_10*src_dof_10 + q_acc_2_11*src_dof_11 + q_acc_2_12*src_dof_12 + q_acc_2_13*src_dof_13 + q_acc_2_14*src_dof_14 + q_acc_2_15*src_dof_15 + q_acc_2_16*src_dof_16 + q_acc_2_17*src_dof_17 + q_acc_2_18*src_dof_18 + q_acc_2_19*src_dof_19 + q_acc_2_2*src_dof_2 + q_acc_2_20*src_dof_20 + q_acc_2_21*src_dof_21 + q_acc_2_22*src_dof_22 + q_acc_2_23*src_dof_23 + q_acc_2_24*src_dof_24 + q_acc_2_25*src_dof_25 + q_acc_2_26*src_dof_26 + q_acc_2_27*src_dof_27 + q_acc_2_28*src_dof_28 + q_acc_2_29*src_dof_29 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
                const real_t elMatVec_3 = q_acc_0_3*src_dof_0 + q_acc_1_3*src_dof_1 + q_acc_2_3*src_dof_2 + q_acc_3_10*src_dof_10 + q_acc_3_11*src_dof_11 + q_acc_3_12*src_dof_12 + q_acc_3_13*src_dof_13 + q_acc_3_14*src_dof_14 + q_acc_3_15*src_dof_15 + q_acc_3_16*src_dof_16 + q_acc_3_17*src_dof_17 + q_acc_3_18*src_dof_18 + q_acc_3_19*src_dof_19 + q_acc_3_20*src_dof_20 + q_acc_3_21*src_dof_21 + q_acc_3_22*src_dof_22 + q_acc_3_23*src_dof_23 + q_acc_3_24*src_dof_24 + q_acc_3_25*src_dof_25 + q_acc_3_26*src_dof_26 + q_acc_3_27*src_dof_27 + q_acc_3_28*src_dof_28 + q_acc_3_29*src_dof_29 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
                const real_t elMatVec_4 = q_acc_0_4*src_dof_0 + q_acc_1_4*src_dof_1 + q_acc_2_4*src_dof_2 + q_acc_3_4*src_dof_3 + q_acc_4_10*src_dof_10 + q_acc_4_11*src_dof_11 + q_acc_4_12*src_dof_12 + q_acc_4_13*src_dof_13 + q_acc_4_14*src_dof_14 + q_acc_4_15*src_dof_15 + q_acc_4_16*src_dof_16 + q_acc_4_17*src_dof_17 + q_acc_4_18*src_dof_18 + q_acc_4_19*src_dof_19 + q_acc_4_20*src_dof_20 + q_acc_4_21*src_dof_21 + q_acc_4_22*src_dof_22 + q_acc_4_23*src_dof_23 + q_acc_4_24*src_dof_24 + q_acc_4_25*src_dof_25 + q_acc_4_26*src_dof_26 + q_acc_4_27*src_dof_27 + q_acc_4_28*src_dof_28 + q_acc_4_29*src_dof_29 + q_acc_4_4*src_dof_4 + q_acc_4_5*src_dof_5 + q_acc_4_6*src_dof_6 + q_acc_4_7*src_dof_7 + q_acc_4_8*src_dof_8 + q_acc_4_9*src_dof_9;
                const real_t elMatVec_5 = q_acc_0_5*src_dof_0 + q_acc_1_5*src_dof_1 + q_acc_2_5*src_dof_2 + q_acc_3_5*src_dof_3 + q_acc_4_5*src_dof_4 + q_acc_5_10*src_dof_10 + q_acc_5_11*src_dof_11 + q_acc_5_12*src_dof_12 + q_acc_5_13*src_dof_13 + q_acc_5_14*src_dof_14 + q_acc_5_15*src_dof_15 + q_acc_5_16*src_dof_16 + q_acc_5_17*src_dof_17 + q_acc_5_18*src_dof_18 + q_acc_5_19*src_dof_19 + q_acc_5_20*src_dof_20 + q_acc_5_21*src_dof_21 + q_acc_5_22*src_dof_22 + q_acc_5_23*src_dof_23 + q_acc_5_24*src_dof_24 + q_acc_5_25*src_dof_25 + q_acc_5_26*src_dof_26 + q_acc_5_27*src_dof_27 + q_acc_5_28*src_dof_28 + q_acc_5_29*src_dof_29 + q_acc_5_5*src_dof_5 + q_acc_5_6*src_dof_6 + q_acc_5_7*src_dof_7 + q_acc_5_8*src_dof_8 + q_acc_5_9*src_dof_9;
                const real_t elMatVec_6 = q_acc_0_6*src_dof_0 + q_acc_1_6*src_dof_1 + q_acc_2_6*src_dof_2 + q_acc_3_6*src_dof_3 + q_acc_4_6*src_dof_4 + q_acc_5_6*src_dof_5 + q_acc_6_10*src_dof_10 + q_acc_6_11*src_dof_11 + q_acc_6_12*src_dof_12 + q_acc_6_13*src_dof_13 + q_acc_6_14*src_dof_14 + q_acc_6_15*src_dof_15 + q_acc_6_16*src_dof_16 + q_acc_6_17*src_dof_17 + q_acc_6_18*src_dof_18 + q_acc_6_19*src_dof_19 + q_acc_6_20*src_dof_20 + q_acc_6_21*src_dof_21 + q_acc_6_22*src_dof_22 + q_acc_6_23*src_dof_23 + q_acc_6_24*src_dof_24 + q_acc_6_25*src_dof_25 + q_acc_6_26*src_dof_26 + q_acc_6_27*src_dof_27 + q_acc_6_28*src_dof_28 + q_acc_6_29*src_dof_29 + q_acc_6_6*src_dof_6 + q_acc_6_7*src_dof_7 + q_acc_6_8*src_dof_8 + q_acc_6_9*src_dof_9;
                const real_t elMatVec_7 = q_acc_0_7*src_dof_0 + q_acc_1_7*src_dof_1 + q_acc_2_7*src_dof_2 + q_acc_3_7*src_dof_3 + q_acc_4_7*src_dof_4 + q_acc_5_7*src_dof_5 + q_acc_6_7*src_dof_6 + q_acc_7_10*src_dof_10 + q_acc_7_11*src_dof_11 + q_acc_7_12*src_dof_12 + q_acc_7_13*src_dof_13 + q_acc_7_14*src_dof_14 + q_acc_7_15*src_dof_15 + q_acc_7_16*src_dof_16 + q_acc_7_17*src_dof_17 + q_acc_7_18*src_dof_18 + q_acc_7_19*src_dof_19 + q_acc_7_20*src_dof_20 + q_acc_7_21*src_dof_21 + q_acc_7_22*src_dof_22 + q_acc_7_23*src_dof_23 + q_acc_7_24*src_dof_24 + q_acc_7_25*src_dof_25 + q_acc_7_26*src_dof_26 + q_acc_7_27*src_dof_27 + q_acc_7_28*src_dof_28 + q_acc_7_29*src_dof_29 + q_acc_7_7*src_dof_7 + q_acc_7_8*src_dof_8 + q_acc_7_9*src_dof_9;
                const real_t elMatVec_8 = q_acc_0_8*src_dof_0 + q_acc_1_8*src_dof_1 + q_acc_2_8*src_dof_2 + q_acc_3_8*src_dof_3 + q_acc_4_8*src_dof_4 + q_acc_5_8*src_dof_5 + q_acc_6_8*src_dof_6 + q_acc_7_8*src_dof_7 + q_acc_8_10*src_dof_10 + q_acc_8_11*src_dof_11 + q_acc_8_12*src_dof_12 + q_acc_8_13*src_dof_13 + q_acc_8_14*src_dof_14 + q_acc_8_15*src_dof_15 + q_acc_8_16*src_dof_16 + q_acc_8_17*src_dof_17 + q_acc_8_18*src_dof_18 + q_acc_8_19*src_dof_19 + q_acc_8_20*src_dof_20 + q_acc_8_21*src_dof_21 + q_acc_8_22*src_dof_22 + q_acc_8_23*src_dof_23 + q_acc_8_24*src_dof_24 + q_acc_8_25*src_dof_25 + q_acc_8_26*src_dof_26 + q_acc_8_27*src_dof_27 + q_acc_8_28*src_dof_28 + q_acc_8_29*src_dof_29 + q_acc_8_8*src_dof_8 + q_acc_8_9*src_dof_9;
                const real_t elMatVec_9 = q_acc_0_9*src_dof_0 + q_acc_1_9*src_dof_1 + q_acc_2_9*src_dof_2 + q_acc_3_9*src_dof_3 + q_acc_4_9*src_dof_4 + q_acc_5_9*src_dof_5 + q_acc_6_9*src_dof_6 + q_acc_7_9*src_dof_7 + q_acc_8_9*src_dof_8 + q_acc_9_10*src_dof_10 + q_acc_9_11*src_dof_11 + q_acc_9_12*src_dof_12 + q_acc_9_13*src_dof_13 + q_acc_9_14*src_dof_14 + q_acc_9_15*src_dof_15 + q_acc_9_16*src_dof_16 + q_acc_9_17*src_dof_17 + q_acc_9_18*src_dof_18 + q_acc_9_19*src_dof_19 + q_acc_9_20*src_dof_20 + q_acc_9_21*src_dof_21 + q_acc_9_22*src_dof_22 + q_acc_9_23*src_dof_23 + q_acc_9_24*src_dof_24 + q_acc_9_25*src_dof_25 + q_acc_9_26*src_dof_26 + q_acc_9_27*src_dof_27 + q_acc_9_28*src_dof_28 + q_acc_9_29*src_dof_29 + q_acc_9_9*src_dof_9;
                const real_t elMatVec_10 = q_acc_0_10*src_dof_0 + q_acc_10_10*src_dof_10 + q_acc_10_11*src_dof_11 + q_acc_10_12*src_dof_12 + q_acc_10_13*src_dof_13 + q_acc_10_14*src_dof_14 + q_acc_10_15*src_dof_15 + q_acc_10_16*src_dof_16 + q_acc_10_17*src_dof_17 + q_acc_10_18*src_dof_18 + q_acc_10_19*src_dof_19 + q_acc_10_20*src_dof_20 + q_acc_10_21*src_dof_21 + q_acc_10_22*src_dof_22 + q_acc_10_23*src_dof_23 + q_acc_10_24*src_dof_24 + q_acc_10_25*src_dof_25 + q_acc_10_26*src_dof_26 + q_acc_10_27*src_dof_27 + q_acc_10_28*src_dof_28 + q_acc_10_29*src_dof_29 + q_acc_1_10*src_dof_1 + q_acc_2_10*src_dof_2 + q_acc_3_10*src_dof_3 + q_acc_4_10*src_dof_4 + q_acc_5_10*src_dof_5 + q_acc_6_10*src_dof_6 + q_acc_7_10*src_dof_7 + q_acc_8_10*src_dof_8 + q_acc_9_10*src_dof_9;
                const real_t elMatVec_11 = q_acc_0_11*src_dof_0 + q_acc_10_11*src_dof_10 + q_acc_11_11*src_dof_11 + q_acc_11_12*src_dof_12 + q_acc_11_13*src_dof_13 + q_acc_11_14*src_dof_14 + q_acc_11_15*src_dof_15 + q_acc_11_16*src_dof_16 + q_acc_11_17*src_dof_17 + q_acc_11_18*src_dof_18 + q_acc_11_19*src_dof_19 + q_acc_11_20*src_dof_20 + q_acc_11_21*src_dof_21 + q_acc_11_22*src_dof_22 + q_acc_11_23*src_dof_23 + q_acc_11_24*src_dof_24 + q_acc_11_25*src_dof_25 + q_acc_11_26*src_dof_26 + q_acc_11_27*src_dof_27 + q_acc_11_28*src_dof_28 + q_acc_11_29*src_dof_29 + q_acc_1_11*src_dof_1 + q_acc_2_11*src_dof_2 + q_acc_3_11*src_dof_3 + q_acc_4_11*src_dof_4 + q_acc_5_11*src_dof_5 + q_acc_6_11*src_dof_6 + q_acc_7_11*src_dof_7 + q_acc_8_11*src_dof_8 + q_acc_9_11*src_dof_9;
                const real_t elMatVec_12 = q_acc_0_12*src_dof_0 + q_acc_10_12*src_dof_10 + q_acc_11_12*src_dof_11 + q_acc_12_12*src_dof_12 + q_acc_12_13*src_dof_13 + q_acc_12_14*src_dof_14 + q_acc_12_15*src_dof_15 + q_acc_12_16*src_dof_16 + q_acc_12_17*src_dof_17 + q_acc_12_18*src_dof_18 + q_acc_12_19*src_dof_19 + q_acc_12_20*src_dof_20 + q_acc_12_21*src_dof_21 + q_acc_12_22*src_dof_22 + q_acc_12_23*src_dof_23 + q_acc_12_24*src_dof_24 + q_acc_12_25*src_dof_25 + q_acc_12_26*src_dof_26 + q_acc_12_27*src_dof_27 + q_acc_12_28*src_dof_28 + q_acc_12_29*src_dof_29 + q_acc_1_12*src_dof_1 + q_acc_2_12*src_dof_2 + q_acc_3_12*src_dof_3 + q_acc_4_12*src_dof_4 + q_acc_5_12*src_dof_5 + q_acc_6_12*src_dof_6 + q_acc_7_12*src_dof_7 + q_acc_8_12*src_dof_8 + q_acc_9_12*src_dof_9;
                const real_t elMatVec_13 = q_acc_0_13*src_dof_0 + q_acc_10_13*src_dof_10 + q_acc_11_13*src_dof_11 + q_acc_12_13*src_dof_12 + q_acc_13_13*src_dof_13 + q_acc_13_14*src_dof_14 + q_acc_13_15*src_dof_15 + q_acc_13_16*src_dof_16 + q_acc_13_17*src_dof_17 + q_acc_13_18*src_dof_18 + q_acc_13_19*src_dof_19 + q_acc_13_20*src_dof_20 + q_acc_13_21*src_dof_21 + q_acc_13_22*src_dof_22 + q_acc_13_23*src_dof_23 + q_acc_13_24*src_dof_24 + q_acc_13_25*src_dof_25 + q_acc_13_26*src_dof_26 + q_acc_13_27*src_dof_27 + q_acc_13_28*src_dof_28 + q_acc_13_29*src_dof_29 + q_acc_1_13*src_dof_1 + q_acc_2_13*src_dof_2 + q_acc_3_13*src_dof_3 + q_acc_4_13*src_dof_4 + q_acc_5_13*src_dof_5 + q_acc_6_13*src_dof_6 + q_acc_7_13*src_dof_7 + q_acc_8_13*src_dof_8 + q_acc_9_13*src_dof_9;
                const real_t elMatVec_14 = q_acc_0_14*src_dof_0 + q_acc_10_14*src_dof_10 + q_acc_11_14*src_dof_11 + q_acc_12_14*src_dof_12 + q_acc_13_14*src_dof_13 + q_acc_14_14*src_dof_14 + q_acc_14_15*src_dof_15 + q_acc_14_16*src_dof_16 + q_acc_14_17*src_dof_17 + q_acc_14_18*src_dof_18 + q_acc_14_19*src_dof_19 + q_acc_14_20*src_dof_20 + q_acc_14_21*src_dof_21 + q_acc_14_22*src_dof_22 + q_acc_14_23*src_dof_23 + q_acc_14_24*src_dof_24 + q_acc_14_25*src_dof_25 + q_acc_14_26*src_dof_26 + q_acc_14_27*src_dof_27 + q_acc_14_28*src_dof_28 + q_acc_14_29*src_dof_29 + q_acc_1_14*src_dof_1 + q_acc_2_14*src_dof_2 + q_acc_3_14*src_dof_3 + q_acc_4_14*src_dof_4 + q_acc_5_14*src_dof_5 + q_acc_6_14*src_dof_6 + q_acc_7_14*src_dof_7 + q_acc_8_14*src_dof_8 + q_acc_9_14*src_dof_9;
                const real_t elMatVec_15 = q_acc_0_15*src_dof_0 + q_acc_10_15*src_dof_10 + q_acc_11_15*src_dof_11 + q_acc_12_15*src_dof_12 + q_acc_13_15*src_dof_13 + q_acc_14_15*src_dof_14 + q_acc_15_15*src_dof_15 + q_acc_15_16*src_dof_16 + q_acc_15_17*src_dof_17 + q_acc_15_18*src_dof_18 + q_acc_15_19*src_dof_19 + q_acc_15_20*src_dof_20 + q_acc_15_21*src_dof_21 + q_acc_15_22*src_dof_22 + q_acc_15_23*src_dof_23 + q_acc_15_24*src_dof_24 + q_acc_15_25*src_dof_25 + q_acc_15_26*src_dof_26 + q_acc_15_27*src_dof_27 + q_acc_15_28*src_dof_28 + q_acc_15_29*src_dof_29 + q_acc_1_15*src_dof_1 + q_acc_2_15*src_dof_2 + q_acc_3_15*src_dof_3 + q_acc_4_15*src_dof_4 + q_acc_5_15*src_dof_5 + q_acc_6_15*src_dof_6 + q_acc_7_15*src_dof_7 + q_acc_8_15*src_dof_8 + q_acc_9_15*src_dof_9;
                const real_t elMatVec_16 = q_acc_0_16*src_dof_0 + q_acc_10_16*src_dof_10 + q_acc_11_16*src_dof_11 + q_acc_12_16*src_dof_12 + q_acc_13_16*src_dof_13 + q_acc_14_16*src_dof_14 + q_acc_15_16*src_dof_15 + q_acc_16_16*src_dof_16 + q_acc_16_17*src_dof_17 + q_acc_16_18*src_dof_18 + q_acc_16_19*src_dof_19 + q_acc_16_20*src_dof_20 + q_acc_16_21*src_dof_21 + q_acc_16_22*src_dof_22 + q_acc_16_23*src_dof_23 + q_acc_16_24*src_dof_24 + q_acc_16_25*src_dof_25 + q_acc_16_26*src_dof_26 + q_acc_16_27*src_dof_27 + q_acc_16_28*src_dof_28 + q_acc_16_29*src_dof_29 + q_acc_1_16*src_dof_1 + q_acc_2_16*src_dof_2 + q_acc_3_16*src_dof_3 + q_acc_4_16*src_dof_4 + q_acc_5_16*src_dof_5 + q_acc_6_16*src_dof_6 + q_acc_7_16*src_dof_7 + q_acc_8_16*src_dof_8 + q_acc_9_16*src_dof_9;
                const real_t elMatVec_17 = q_acc_0_17*src_dof_0 + q_acc_10_17*src_dof_10 + q_acc_11_17*src_dof_11 + q_acc_12_17*src_dof_12 + q_acc_13_17*src_dof_13 + q_acc_14_17*src_dof_14 + q_acc_15_17*src_dof_15 + q_acc_16_17*src_dof_16 + q_acc_17_17*src_dof_17 + q_acc_17_18*src_dof_18 + q_acc_17_19*src_dof_19 + q_acc_17_20*src_dof_20 + q_acc_17_21*src_dof_21 + q_acc_17_22*src_dof_22 + q_acc_17_23*src_dof_23 + q_acc_17_24*src_dof_24 + q_acc_17_25*src_dof_25 + q_acc_17_26*src_dof_26 + q_acc_17_27*src_dof_27 + q_acc_17_28*src_dof_28 + q_acc_17_29*src_dof_29 + q_acc_1_17*src_dof_1 + q_acc_2_17*src_dof_2 + q_acc_3_17*src_dof_3 + q_acc_4_17*src_dof_4 + q_acc_5_17*src_dof_5 + q_acc_6_17*src_dof_6 + q_acc_7_17*src_dof_7 + q_acc_8_17*src_dof_8 + q_acc_9_17*src_dof_9;
                const real_t elMatVec_18 = q_acc_0_18*src_dof_0 + q_acc_10_18*src_dof_10 + q_acc_11_18*src_dof_11 + q_acc_12_18*src_dof_12 + q_acc_13_18*src_dof_13 + q_acc_14_18*src_dof_14 + q_acc_15_18*src_dof_15 + q_acc_16_18*src_dof_16 + q_acc_17_18*src_dof_17 + q_acc_18_18*src_dof_18 + q_acc_18_19*src_dof_19 + q_acc_18_20*src_dof_20 + q_acc_18_21*src_dof_21 + q_acc_18_22*src_dof_22 + q_acc_18_23*src_dof_23 + q_acc_18_24*src_dof_24 + q_acc_18_25*src_dof_25 + q_acc_18_26*src_dof_26 + q_acc_18_27*src_dof_27 + q_acc_18_28*src_dof_28 + q_acc_18_29*src_dof_29 + q_acc_1_18*src_dof_1 + q_acc_2_18*src_dof_2 + q_acc_3_18*src_dof_3 + q_acc_4_18*src_dof_4 + q_acc_5_18*src_dof_5 + q_acc_6_18*src_dof_6 + q_acc_7_18*src_dof_7 + q_acc_8_18*src_dof_8 + q_acc_9_18*src_dof_9;
                const real_t elMatVec_19 = q_acc_0_19*src_dof_0 + q_acc_10_19*src_dof_10 + q_acc_11_19*src_dof_11 + q_acc_12_19*src_dof_12 + q_acc_13_19*src_dof_13 + q_acc_14_19*src_dof_14 + q_acc_15_19*src_dof_15 + q_acc_16_19*src_dof_16 + q_acc_17_19*src_dof_17 + q_acc_18_19*src_dof_18 + q_acc_19_19*src_dof_19 + q_acc_19_20*src_dof_20 + q_acc_19_21*src_dof_21 + q_acc_19_22*src_dof_22 + q_acc_19_23*src_dof_23 + q_acc_19_24*src_dof_24 + q_acc_19_25*src_dof_25 + q_acc_19_26*src_dof_26 + q_acc_19_27*src_dof_27 + q_acc_19_28*src_dof_28 + q_acc_19_29*src_dof_29 + q_acc_1_19*src_dof_1 + q_acc_2_19*src_dof_2 + q_acc_3_19*src_dof_3 + q_acc_4_19*src_dof_4 + q_acc_5_19*src_dof_5 + q_acc_6_19*src_dof_6 + q_acc_7_19*src_dof_7 + q_acc_8_19*src_dof_8 + q_acc_9_19*src_dof_9;
                const real_t elMatVec_20 = q_acc_0_20*src_dof_0 + q_acc_10_20*src_dof_10 + q_acc_11_20*src_dof_11 + q_acc_12_20*src_dof_12 + q_acc_13_20*src_dof_13 + q_acc_14_20*src_dof_14 + q_acc_15_20*src_dof_15 + q_acc_16_20*src_dof_16 + q_acc_17_20*src_dof_17 + q_acc_18_20*src_dof_18 + q_acc_19_20*src_dof_19 + q_acc_1_20*src_dof_1 + q_acc_20_20*src_dof_20 + q_acc_20_21*src_dof_21 + q_acc_20_22*src_dof_22 + q_acc_20_23*src_dof_23 + q_acc_20_24*src_dof_24 + q_acc_20_25*src_dof_25 + q_acc_20_26*src_dof_26 + q_acc_20_27*src_dof_27 + q_acc_20_28*src_dof_28 + q_acc_20_29*src_dof_29 + q_acc_2_20*src_dof_2 + q_acc_3_20*src_dof_3 + q_acc_4_20*src_dof_4 + q_acc_5_20*src_dof_5 + q_acc_6_20*src_dof_6 + q_acc_7_20*src_dof_7 + q_acc_8_20*src_dof_8 + q_acc_9_20*src_dof_9;
                const real_t elMatVec_21 = q_acc_0_21*src_dof_0 + q_acc_10_21*src_dof_10 + q_acc_11_21*src_dof_11 + q_acc_12_21*src_dof_12 + q_acc_13_21*src_dof_13 + q_acc_14_21*src_dof_14 + q_acc_15_21*src_dof_15 + q_acc_16_21*src_dof_16 + q_acc_17_21*src_dof_17 + q_acc_18_21*src_dof_18 + q_acc_19_21*src_dof_19 + q_acc_1_21*src_dof_1 + q_acc_20_21*src_dof_20 + q_acc_21_21*src_dof_21 + q_acc_21_22*src_dof_22 + q_acc_21_23*src_dof_23 + q_acc_21_24*src_dof_24 + q_acc_21_25*src_dof_25 + q_acc_21_26*src_dof_26 + q_acc_21_27*src_dof_27 + q_acc_21_28*src_dof_28 + q_acc_21_29*src_dof_29 + q_acc_2_21*src_dof_2 + q_acc_3_21*src_dof_3 + q_acc_4_21*src_dof_4 + q_acc_5_21*src_dof_5 + q_acc_6_21*src_dof_6 + q_acc_7_21*src_dof_7 + q_acc_8_21*src_dof_8 + q_acc_9_21*src_dof_9;
                const real_t elMatVec_22 = q_acc_0_22*src_dof_0 + q_acc_10_22*src_dof_10 + q_acc_11_22*src_dof_11 + q_acc_12_22*src_dof_12 + q_acc_13_22*src_dof_13 + q_acc_14_22*src_dof_14 + q_acc_15_22*src_dof_15 + q_acc_16_22*src_dof_16 + q_acc_17_22*src_dof_17 + q_acc_18_22*src_dof_18 + q_acc_19_22*src_dof_19 + q_acc_1_22*src_dof_1 + q_acc_20_22*src_dof_20 + q_acc_21_22*src_dof_21 + q_acc_22_22*src_dof_22 + q_acc_22_23*src_dof_23 + q_acc_22_24*src_dof_24 + q_acc_22_25*src_dof_25 + q_acc_22_26*src_dof_26 + q_acc_22_27*src_dof_27 + q_acc_22_28*src_dof_28 + q_acc_22_29*src_dof_29 + q_acc_2_22*src_dof_2 + q_acc_3_22*src_dof_3 + q_acc_4_22*src_dof_4 + q_acc_5_22*src_dof_5 + q_acc_6_22*src_dof_6 + q_acc_7_22*src_dof_7 + q_acc_8_22*src_dof_8 + q_acc_9_22*src_dof_9;
                const real_t elMatVec_23 = q_acc_0_23*src_dof_0 + q_acc_10_23*src_dof_10 + q_acc_11_23*src_dof_11 + q_acc_12_23*src_dof_12 + q_acc_13_23*src_dof_13 + q_acc_14_23*src_dof_14 + q_acc_15_23*src_dof_15 + q_acc_16_23*src_dof_16 + q_acc_17_23*src_dof_17 + q_acc_18_23*src_dof_18 + q_acc_19_23*src_dof_19 + q_acc_1_23*src_dof_1 + q_acc_20_23*src_dof_20 + q_acc_21_23*src_dof_21 + q_acc_22_23*src_dof_22 + q_acc_23_23*src_dof_23 + q_acc_23_24*src_dof_24 + q_acc_23_25*src_dof_25 + q_acc_23_26*src_dof_26 + q_acc_23_27*src_dof_27 + q_acc_23_28*src_dof_28 + q_acc_23_29*src_dof_29 + q_acc_2_23*src_dof_2 + q_acc_3_23*src_dof_3 + q_acc_4_23*src_dof_4 + q_acc_5_23*src_dof_5 + q_acc_6_23*src_dof_6 + q_acc_7_23*src_dof_7 + q_acc_8_23*src_dof_8 + q_acc_9_23*src_dof_9;
                const real_t elMatVec_24 = q_acc_0_24*src_dof_0 + q_acc_10_24*src_dof_10 + q_acc_11_24*src_dof_11 + q_acc_12_24*src_dof_12 + q_acc_13_24*src_dof_13 + q_acc_14_24*src_dof_14 + q_acc_15_24*src_dof_15 + q_acc_16_24*src_dof_16 + q_acc_17_24*src_dof_17 + q_acc_18_24*src_dof_18 + q_acc_19_24*src_dof_19 + q_acc_1_24*src_dof_1 + q_acc_20_24*src_dof_20 + q_acc_21_24*src_dof_21 + q_acc_22_24*src_dof_22 + q_acc_23_24*src_dof_23 + q_acc_24_24*src_dof_24 + q_acc_24_25*src_dof_25 + q_acc_24_26*src_dof_26 + q_acc_24_27*src_dof_27 + q_acc_24_28*src_dof_28 + q_acc_24_29*src_dof_29 + q_acc_2_24*src_dof_2 + q_acc_3_24*src_dof_3 + q_acc_4_24*src_dof_4 + q_acc_5_24*src_dof_5 + q_acc_6_24*src_dof_6 + q_acc_7_24*src_dof_7 + q_acc_8_24*src_dof_8 + q_acc_9_24*src_dof_9;
                const real_t elMatVec_25 = q_acc_0_25*src_dof_0 + q_acc_10_25*src_dof_10 + q_acc_11_25*src_dof_11 + q_acc_12_25*src_dof_12 + q_acc_13_25*src_dof_13 + q_acc_14_25*src_dof_14 + q_acc_15_25*src_dof_15 + q_acc_16_25*src_dof_16 + q_acc_17_25*src_dof_17 + q_acc_18_25*src_dof_18 + q_acc_19_25*src_dof_19 + q_acc_1_25*src_dof_1 + q_acc_20_25*src_dof_20 + q_acc_21_25*src_dof_21 + q_acc_22_25*src_dof_22 + q_acc_23_25*src_dof_23 + q_acc_24_25*src_dof_24 + q_acc_25_25*src_dof_25 + q_acc_25_26*src_dof_26 + q_acc_25_27*src_dof_27 + q_acc_25_28*src_dof_28 + q_acc_25_29*src_dof_29 + q_acc_2_25*src_dof_2 + q_acc_3_25*src_dof_3 + q_acc_4_25*src_dof_4 + q_acc_5_25*src_dof_5 + q_acc_6_25*src_dof_6 + q_acc_7_25*src_dof_7 + q_acc_8_25*src_dof_8 + q_acc_9_25*src_dof_9;
                const real_t elMatVec_26 = q_acc_0_26*src_dof_0 + q_acc_10_26*src_dof_10 + q_acc_11_26*src_dof_11 + q_acc_12_26*src_dof_12 + q_acc_13_26*src_dof_13 + q_acc_14_26*src_dof_14 + q_acc_15_26*src_dof_15 + q_acc_16_26*src_dof_16 + q_acc_17_26*src_dof_17 + q_acc_18_26*src_dof_18 + q_acc_19_26*src_dof_19 + q_acc_1_26*src_dof_1 + q_acc_20_26*src_dof_20 + q_acc_21_26*src_dof_21 + q_acc_22_26*src_dof_22 + q_acc_23_26*src_dof_23 + q_acc_24_26*src_dof_24 + q_acc_25_26*src_dof_25 + q_acc_26_26*src_dof_26 + q_acc_26_27*src_dof_27 + q_acc_26_28*src_dof_28 + q_acc_26_29*src_dof_29 + q_acc_2_26*src_dof_2 + q_acc_3_26*src_dof_3 + q_acc_4_26*src_dof_4 + q_acc_5_26*src_dof_5 + q_acc_6_26*src_dof_6 + q_acc_7_26*src_dof_7 + q_acc_8_26*src_dof_8 + q_acc_9_26*src_dof_9;
                const real_t elMatVec_27 = q_acc_0_27*src_dof_0 + q_acc_10_27*src_dof_10 + q_acc_11_27*src_dof_11 + q_acc_12_27*src_dof_12 + q_acc_13_27*src_dof_13 + q_acc_14_27*src_dof_14 + q_acc_15_27*src_dof_15 + q_acc_16_27*src_dof_16 + q_acc_17_27*src_dof_17 + q_acc_18_27*src_dof_18 + q_acc_19_27*src_dof_19 + q_acc_1_27*src_dof_1 + q_acc_20_27*src_dof_20 + q_acc_21_27*src_dof_21 + q_acc_22_27*src_dof_22 + q_acc_23_27*src_dof_23 + q_acc_24_27*src_dof_24 + q_acc_25_27*src_dof_25 + q_acc_26_27*src_dof_26 + q_acc_27_27*src_dof_27 + q_acc_27_28*src_dof_28 + q_acc_27_29*src_dof_29 + q_acc_2_27*src_dof_2 + q_acc_3_27*src_dof_3 + q_acc_4_27*src_dof_4 + q_acc_5_27*src_dof_5 + q_acc_6_27*src_dof_6 + q_acc_7_27*src_dof_7 + q_acc_8_27*src_dof_8 + q_acc_9_27*src_dof_9;
                const real_t elMatVec_28 = q_acc_0_28*src_dof_0 + q_acc_10_28*src_dof_10 + q_acc_11_28*src_dof_11 + q_acc_12_28*src_dof_12 + q_acc_13_28*src_dof_13 + q_acc_14_28*src_dof_14 + q_acc_15_28*src_dof_15 + q_acc_16_28*src_dof_16 + q_acc_17_28*src_dof_17 + q_acc_18_28*src_dof_18 + q_acc_19_28*src_dof_19 + q_acc_1_28*src_dof_1 + q_acc_20_28*src_dof_20 + q_acc_21_28*src_dof_21 + q_acc_22_28*src_dof_22 + q_acc_23_28*src_dof_23 + q_acc_24_28*src_dof_24 + q_acc_25_28*src_dof_25 + q_acc_26_28*src_dof_26 + q_acc_27_28*src_dof_27 + q_acc_28_28*src_dof_28 + q_acc_28_29*src_dof_29 + q_acc_2_28*src_dof_2 + q_acc_3_28*src_dof_3 + q_acc_4_28*src_dof_4 + q_acc_5_28*src_dof_5 + q_acc_6_28*src_dof_6 + q_acc_7_28*src_dof_7 + q_acc_8_28*src_dof_8 + q_acc_9_28*src_dof_9;
                const real_t elMatVec_29 = q_acc_0_29*src_dof_0 + q_acc_10_29*src_dof_10 + q_acc_11_29*src_dof_11 + q_acc_12_29*src_dof_12 + q_acc_13_29*src_dof_13 + q_acc_14_29*src_dof_14 + q_acc_15_29*src_dof_15 + q_acc_16_29*src_dof_16 + q_acc_17_29*src_dof_17 + q_acc_18_29*src_dof_18 + q_acc_19_29*src_dof_19 + q_acc_1_29*src_dof_1 + q_acc_20_29*src_dof_20 + q_acc_21_29*src_dof_21 + q_acc_22_29*src_dof_22 + q_acc_23_29*src_dof_23 + q_acc_24_29*src_dof_24 + q_acc_25_29*src_dof_25 + q_acc_26_29*src_dof_26 + q_acc_27_29*src_dof_27 + q_acc_28_29*src_dof_28 + q_acc_29_29*src_dof_29 + q_acc_2_29*src_dof_2 + q_acc_3_29*src_dof_3 + q_acc_4_29*src_dof_4 + q_acc_5_29*src_dof_5 + q_acc_6_29*src_dof_6 + q_acc_7_29*src_dof_7 + q_acc_8_29*src_dof_8 + q_acc_9_29*src_dof_9;
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_6 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dst_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_10 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_11 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_12 + _data_dst_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_13 + _data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_14 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_15 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_16 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_17 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_18 + _data_dst_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_19 + _data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_20 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_21 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_22 + _data_dst_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_23 + _data_dst_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_24 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_25 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_26 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_27 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_28 + _data_dst_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_29 + _data_dst_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
