/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ElementwiseFullStokesIcosahedralShellMap_2_2.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseFullStokesIcosahedralShellMap_2_2::computeInverseDiagonalOperatorValues_P2ElementwiseFullStokesIcosahedralShellMap_2_2_macro_3D( real_t * RESTRICT  _data_invDiag_Edge, real_t * RESTRICT  _data_invDiag_Vertex, real_t * RESTRICT  _data_muEdge, real_t * RESTRICT  _data_muVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {-0.1333333333333333, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983, 0.074999999999999983};
   
       const real_t _data_q_p_0 [] = {0.25, 0.16666666666666666, 0.16666666666666666, 0.5, 0.16666666666666666};
   
       const real_t _data_q_p_1 [] = {0.25, 0.16666666666666666, 0.5, 0.16666666666666666, 0.16666666666666666};
   
       const real_t _data_q_p_2 [] = {0.25, 0.5, 0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
       const real_t tmp_qloop_1 = -rayVertex_0;
       const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
       const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
       const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
       const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
       const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
       const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
       const real_t tmp_qloop_8 = -rayVertex_1;
       const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
       const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
       const real_t tmp_qloop_12 = -rayVertex_2;
       const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
       const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
       const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
       const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
       const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
       const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
       const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
       const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
       const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_39 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
       const real_t tmp_qloop_40 = tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_45 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
       const real_t tmp_qloop_46 = -tmp_qloop_21*tmp_qloop_45;
       const real_t tmp_qloop_53 = -tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_68 = tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_72 = tmp_qloop_21*tmp_qloop_45;
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_UP [] = {0.0, ((real_t)(abs_det_jac_affine_WHITE_UP)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_UP)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_UP)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_UP)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_UP))};
      
          const real_t _data_tabulated_and_untitled_0_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_0_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0 + jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_1_0_WHITE_UP)), ((real_t)(-jac_affine_inv_0_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(-jac_affine_inv_1_0_WHITE_UP - jac_affine_inv_2_0_WHITE_UP)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.0 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.0 + jac_affine_inv_1_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_0_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_0_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_0_WHITE_UP*-2.0 + jac_affine_inv_2_0_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_0_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0 + jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_1_1_WHITE_UP)), ((real_t)(-jac_affine_inv_0_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(-jac_affine_inv_1_1_WHITE_UP - jac_affine_inv_2_1_WHITE_UP)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.0 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.0 + jac_affine_inv_1_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_1_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_1_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_1_WHITE_UP*-2.0 + jac_affine_inv_2_1_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_1_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0 + jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_1_2_WHITE_UP)), ((real_t)(-jac_affine_inv_0_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(-jac_affine_inv_1_2_WHITE_UP - jac_affine_inv_2_2_WHITE_UP)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333304 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333315 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.0 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.0 + jac_affine_inv_1_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_1_2_WHITE_UP*0.33333333333333326 + jac_affine_inv_2_2_WHITE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.333333333333333 + jac_affine_inv_1_2_WHITE_UP*-2.0 + jac_affine_inv_2_2_WHITE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_UP*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3333333333333337 + jac_affine_inv_1_2_WHITE_UP*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_138 = (mu_dof_0*_data_phi_0_0_WHITE_UP[10*q] + mu_dof_1*_data_phi_0_0_WHITE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_UP[10*q + 9])*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_114 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t tmp_qloop_106 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q];
                const real_t tmp_qloop_115 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q];
                const real_t tmp_qloop_132 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_UP[q];
                const real_t tmp_qloop_142 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_151 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_160 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_169 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_178 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_187 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_205 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_214 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 9];
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t tmp_qloop_107 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_UP[q];
                const real_t tmp_qloop_123 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q];
                const real_t tmp_qloop_131 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q];
                const real_t tmp_qloop_145 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_154 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_163 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_172 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_181 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_190 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_199 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_208 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_217 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 9];
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t tmp_qloop_103 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q];
                const real_t tmp_qloop_118 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q];
                const real_t tmp_qloop_126 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_UP[q];
                const real_t tmp_qloop_139 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_157 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_175 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_184 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_193 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_202 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_211 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_UP[10*q + 9];
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t tmp_qloop_108 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_UP[q];
                const real_t tmp_qloop_116 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q];
                const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_UP[q];
                const real_t tmp_qloop_143 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_152 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_161 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_170 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_179 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_188 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_206 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_215 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 9];
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t tmp_qloop_109 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_UP[q];
                const real_t tmp_qloop_124 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q];
                const real_t tmp_qloop_133 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_UP[q];
                const real_t tmp_qloop_146 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_155 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_164 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_173 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_182 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_191 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_200 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_209 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_218 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 9];
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t tmp_qloop_104 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q];
                const real_t tmp_qloop_119 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_UP[q];
                const real_t tmp_qloop_127 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_UP[q];
                const real_t tmp_qloop_140 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_158 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_176 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_185 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_194 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_203 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_212 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_UP[10*q + 9];
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t tmp_qloop_110 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_UP[q];
                const real_t tmp_qloop_117 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q];
                const real_t tmp_qloop_136 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_UP[q];
                const real_t tmp_qloop_144 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_153 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_162 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_171 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_180 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_189 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_207 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_216 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 9];
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t tmp_qloop_111 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_UP[q];
                const real_t tmp_qloop_112 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108 + tmp_qloop_109 + tmp_qloop_110 + tmp_qloop_111;
                const real_t tmp_qloop_113 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663 + tmp_qloop_109*0.66666666666666663 + tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663;
                const real_t tmp_qloop_125 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q];
                const real_t tmp_qloop_135 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_UP[q];
                const real_t tmp_qloop_137 = (tmp_qloop_106*1.0 + tmp_qloop_108*1.0 + tmp_qloop_110*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_108*2.0 + tmp_qloop_110*2.0) + (tmp_qloop_107*1.0 + tmp_qloop_109*1.0 + tmp_qloop_111*1.0)*(tmp_qloop_107*2.0 + tmp_qloop_109*2.0 + tmp_qloop_111*2.0) + (tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135 + tmp_qloop_136)*(tmp_qloop_131*0.5 + tmp_qloop_132*0.5 + tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5 + tmp_qloop_136*0.5)*2.0;
                const real_t tmp_qloop_147 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_156 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_165 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_174 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_183 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_192 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_201 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_210 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_219 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 9];
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_105 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q];
                const real_t tmp_qloop_120 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_UP[q];
                const real_t tmp_qloop_121 = tmp_qloop_118 + tmp_qloop_119 + tmp_qloop_120;
                const real_t tmp_qloop_122 = tmp_qloop_118*0.5 + tmp_qloop_119*0.5 + tmp_qloop_120*0.5;
                const real_t tmp_qloop_128 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_UP[q];
                const real_t tmp_qloop_129 = tmp_qloop_126 + tmp_qloop_127 + tmp_qloop_128;
                const real_t tmp_qloop_130 = tmp_qloop_126*0.5 + tmp_qloop_127*0.5 + tmp_qloop_128*0.5;
                const real_t tmp_qloop_141 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 1];
                const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 2];
                const real_t tmp_qloop_159 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 3];
                const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 4];
                const real_t tmp_qloop_177 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 5];
                const real_t tmp_qloop_186 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 6];
                const real_t tmp_qloop_195 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 7];
                const real_t tmp_qloop_204 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 8];
                const real_t tmp_qloop_213 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_UP[10*q + 9];
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_112)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_113) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_115 + tmp_qloop_116 + tmp_qloop_117 + tmp_qloop_121)*(tmp_qloop_115*0.5 + tmp_qloop_116*0.5 + tmp_qloop_117*0.5 + tmp_qloop_122)*2.0 + (tmp_qloop_123 + tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_129)*(tmp_qloop_123*0.5 + tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_130)*2.0));
                const real_t q_tmp_1_1 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_139 + tmp_qloop_140 + tmp_qloop_141)*(tmp_qloop_113 + tmp_qloop_139*0.66666666666666663 + tmp_qloop_140*0.66666666666666663 + tmp_qloop_141*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_139*1.0 + tmp_qloop_140*1.0 + tmp_qloop_141*1.0)*(tmp_qloop_139*2.0 + tmp_qloop_140*2.0 + tmp_qloop_141*2.0) + (tmp_qloop_121 + tmp_qloop_142 + tmp_qloop_143 + tmp_qloop_144)*(tmp_qloop_122 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5 + tmp_qloop_144*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_145 + tmp_qloop_146 + tmp_qloop_147)*(tmp_qloop_130 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5 + tmp_qloop_147*0.5)*2.0));
                const real_t q_tmp_2_2 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150)*(tmp_qloop_113 + tmp_qloop_148*0.66666666666666663 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_148*1.0 + tmp_qloop_149*1.0 + tmp_qloop_150*1.0)*(tmp_qloop_148*2.0 + tmp_qloop_149*2.0 + tmp_qloop_150*2.0) + (tmp_qloop_121 + tmp_qloop_151 + tmp_qloop_152 + tmp_qloop_153)*(tmp_qloop_122 + tmp_qloop_151*0.5 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_154 + tmp_qloop_155 + tmp_qloop_156)*(tmp_qloop_130 + tmp_qloop_154*0.5 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5)*2.0));
                const real_t q_tmp_3_3 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159)*(tmp_qloop_113 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0)*(tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0) + (tmp_qloop_121 + tmp_qloop_160 + tmp_qloop_161 + tmp_qloop_162)*(tmp_qloop_122 + tmp_qloop_160*0.5 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_163 + tmp_qloop_164 + tmp_qloop_165)*(tmp_qloop_130 + tmp_qloop_163*0.5 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5)*2.0));
                const real_t q_tmp_4_4 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168)*(tmp_qloop_113 + tmp_qloop_166*0.66666666666666663 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_166*1.0 + tmp_qloop_167*1.0 + tmp_qloop_168*1.0)*(tmp_qloop_166*2.0 + tmp_qloop_167*2.0 + tmp_qloop_168*2.0) + (tmp_qloop_121 + tmp_qloop_169 + tmp_qloop_170 + tmp_qloop_171)*(tmp_qloop_122 + tmp_qloop_169*0.5 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_172 + tmp_qloop_173 + tmp_qloop_174)*(tmp_qloop_130 + tmp_qloop_172*0.5 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5)*2.0));
                const real_t q_tmp_5_5 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177)*(tmp_qloop_113 + tmp_qloop_175*0.66666666666666663 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_175*1.0 + tmp_qloop_176*1.0 + tmp_qloop_177*1.0)*(tmp_qloop_175*2.0 + tmp_qloop_176*2.0 + tmp_qloop_177*2.0) + (tmp_qloop_121 + tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180)*(tmp_qloop_122 + tmp_qloop_178*0.5 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_181 + tmp_qloop_182 + tmp_qloop_183)*(tmp_qloop_130 + tmp_qloop_181*0.5 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5)*2.0));
                const real_t q_tmp_6_6 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_184 + tmp_qloop_185 + tmp_qloop_186)*(tmp_qloop_113 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_184*1.0 + tmp_qloop_185*1.0 + tmp_qloop_186*1.0)*(tmp_qloop_184*2.0 + tmp_qloop_185*2.0 + tmp_qloop_186*2.0) + (tmp_qloop_121 + tmp_qloop_187 + tmp_qloop_188 + tmp_qloop_189)*(tmp_qloop_122 + tmp_qloop_187*0.5 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_190 + tmp_qloop_191 + tmp_qloop_192)*(tmp_qloop_130 + tmp_qloop_190*0.5 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5)*2.0));
                const real_t q_tmp_7_7 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_193 + tmp_qloop_194 + tmp_qloop_195)*(tmp_qloop_113 + tmp_qloop_193*0.66666666666666663 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_193*1.0 + tmp_qloop_194*1.0 + tmp_qloop_195*1.0)*(tmp_qloop_193*2.0 + tmp_qloop_194*2.0 + tmp_qloop_195*2.0) + (tmp_qloop_121 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198)*(tmp_qloop_122 + tmp_qloop_196*0.5 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201)*(tmp_qloop_130 + tmp_qloop_199*0.5 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5)*2.0));
                const real_t q_tmp_8_8 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_202 + tmp_qloop_203 + tmp_qloop_204)*(tmp_qloop_113 + tmp_qloop_202*0.66666666666666663 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_202*1.0 + tmp_qloop_203*1.0 + tmp_qloop_204*1.0)*(tmp_qloop_202*2.0 + tmp_qloop_203*2.0 + tmp_qloop_204*2.0) + (tmp_qloop_121 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207)*(tmp_qloop_122 + tmp_qloop_205*0.5 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_208 + tmp_qloop_209 + tmp_qloop_210)*(tmp_qloop_130 + tmp_qloop_208*0.5 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5)*2.0));
                const real_t q_tmp_9_9 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_211 + tmp_qloop_212 + tmp_qloop_213)*(tmp_qloop_113 + tmp_qloop_211*0.66666666666666663 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_211*1.0 + tmp_qloop_212*1.0 + tmp_qloop_213*1.0)*(tmp_qloop_211*2.0 + tmp_qloop_212*2.0 + tmp_qloop_213*2.0) + (tmp_qloop_121 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216)*(tmp_qloop_122 + tmp_qloop_214*0.5 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_217 + tmp_qloop_218 + tmp_qloop_219)*(tmp_qloop_130 + tmp_qloop_217*0.5 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5)*2.0));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN))};
      
          const real_t _data_tabulated_and_untitled_0_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_0_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0 + jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_1_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_0_WHITE_DOWN - jac_affine_inv_2_0_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.0 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.0 + jac_affine_inv_1_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_WHITE_DOWN*-2.0 + jac_affine_inv_2_0_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0 + jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_1_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_1_WHITE_DOWN - jac_affine_inv_2_1_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.0 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.0 + jac_affine_inv_1_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_WHITE_DOWN*-2.0 + jac_affine_inv_2_1_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_WHITE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0 + jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_1_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_0_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(-jac_affine_inv_1_2_WHITE_DOWN - jac_affine_inv_2_2_WHITE_DOWN)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.0 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.0 + jac_affine_inv_1_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_WHITE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_WHITE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_WHITE_DOWN*-2.0 + jac_affine_inv_2_2_WHITE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_WHITE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_WHITE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_WHITE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_WHITE_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_138 = (mu_dof_0*_data_phi_0_0_WHITE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_WHITE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_DOWN[10*q + 9])*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_114 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t tmp_qloop_106 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q];
                const real_t tmp_qloop_115 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q];
                const real_t tmp_qloop_132 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_WHITE_DOWN[q];
                const real_t tmp_qloop_142 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_151 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_160 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_169 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_178 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_187 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_205 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_214 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 9];
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t tmp_qloop_107 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_WHITE_DOWN[q];
                const real_t tmp_qloop_123 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q];
                const real_t tmp_qloop_131 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q];
                const real_t tmp_qloop_145 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_154 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_163 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_172 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_181 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_190 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_199 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_208 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_217 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 9];
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t tmp_qloop_103 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q];
                const real_t tmp_qloop_118 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q];
                const real_t tmp_qloop_126 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_WHITE_DOWN[q];
                const real_t tmp_qloop_139 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_157 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_175 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_184 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_193 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_202 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_211 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_WHITE_DOWN[10*q + 9];
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t tmp_qloop_108 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_WHITE_DOWN[q];
                const real_t tmp_qloop_116 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q];
                const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_WHITE_DOWN[q];
                const real_t tmp_qloop_143 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_152 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_161 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_170 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_179 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_188 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_206 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_215 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 9];
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t tmp_qloop_109 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_WHITE_DOWN[q];
                const real_t tmp_qloop_124 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q];
                const real_t tmp_qloop_133 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_WHITE_DOWN[q];
                const real_t tmp_qloop_146 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_155 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_164 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_173 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_182 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_191 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_200 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_209 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_218 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 9];
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t tmp_qloop_104 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q];
                const real_t tmp_qloop_119 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_WHITE_DOWN[q];
                const real_t tmp_qloop_127 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_WHITE_DOWN[q];
                const real_t tmp_qloop_140 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_158 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_176 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_185 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_194 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_203 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_212 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_WHITE_DOWN[10*q + 9];
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t tmp_qloop_110 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_WHITE_DOWN[q];
                const real_t tmp_qloop_117 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q];
                const real_t tmp_qloop_136 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_WHITE_DOWN[q];
                const real_t tmp_qloop_144 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_153 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_162 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_171 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_180 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_189 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_207 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_216 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 9];
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t tmp_qloop_111 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_WHITE_DOWN[q];
                const real_t tmp_qloop_112 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108 + tmp_qloop_109 + tmp_qloop_110 + tmp_qloop_111;
                const real_t tmp_qloop_113 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663 + tmp_qloop_109*0.66666666666666663 + tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663;
                const real_t tmp_qloop_125 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q];
                const real_t tmp_qloop_135 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_WHITE_DOWN[q];
                const real_t tmp_qloop_137 = (tmp_qloop_106*1.0 + tmp_qloop_108*1.0 + tmp_qloop_110*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_108*2.0 + tmp_qloop_110*2.0) + (tmp_qloop_107*1.0 + tmp_qloop_109*1.0 + tmp_qloop_111*1.0)*(tmp_qloop_107*2.0 + tmp_qloop_109*2.0 + tmp_qloop_111*2.0) + (tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135 + tmp_qloop_136)*(tmp_qloop_131*0.5 + tmp_qloop_132*0.5 + tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5 + tmp_qloop_136*0.5)*2.0;
                const real_t tmp_qloop_147 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_156 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_165 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_174 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_183 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_192 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_201 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_210 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_219 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 9];
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_105 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q];
                const real_t tmp_qloop_120 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_WHITE_DOWN[q];
                const real_t tmp_qloop_121 = tmp_qloop_118 + tmp_qloop_119 + tmp_qloop_120;
                const real_t tmp_qloop_122 = tmp_qloop_118*0.5 + tmp_qloop_119*0.5 + tmp_qloop_120*0.5;
                const real_t tmp_qloop_128 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_WHITE_DOWN[q];
                const real_t tmp_qloop_129 = tmp_qloop_126 + tmp_qloop_127 + tmp_qloop_128;
                const real_t tmp_qloop_130 = tmp_qloop_126*0.5 + tmp_qloop_127*0.5 + tmp_qloop_128*0.5;
                const real_t tmp_qloop_141 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 1];
                const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 2];
                const real_t tmp_qloop_159 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 3];
                const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 4];
                const real_t tmp_qloop_177 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 5];
                const real_t tmp_qloop_186 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 6];
                const real_t tmp_qloop_195 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 7];
                const real_t tmp_qloop_204 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 8];
                const real_t tmp_qloop_213 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_WHITE_DOWN[10*q + 9];
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_112)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_113) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_115 + tmp_qloop_116 + tmp_qloop_117 + tmp_qloop_121)*(tmp_qloop_115*0.5 + tmp_qloop_116*0.5 + tmp_qloop_117*0.5 + tmp_qloop_122)*2.0 + (tmp_qloop_123 + tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_129)*(tmp_qloop_123*0.5 + tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_130)*2.0));
                const real_t q_tmp_1_1 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_139 + tmp_qloop_140 + tmp_qloop_141)*(tmp_qloop_113 + tmp_qloop_139*0.66666666666666663 + tmp_qloop_140*0.66666666666666663 + tmp_qloop_141*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_139*1.0 + tmp_qloop_140*1.0 + tmp_qloop_141*1.0)*(tmp_qloop_139*2.0 + tmp_qloop_140*2.0 + tmp_qloop_141*2.0) + (tmp_qloop_121 + tmp_qloop_142 + tmp_qloop_143 + tmp_qloop_144)*(tmp_qloop_122 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5 + tmp_qloop_144*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_145 + tmp_qloop_146 + tmp_qloop_147)*(tmp_qloop_130 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5 + tmp_qloop_147*0.5)*2.0));
                const real_t q_tmp_2_2 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150)*(tmp_qloop_113 + tmp_qloop_148*0.66666666666666663 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_148*1.0 + tmp_qloop_149*1.0 + tmp_qloop_150*1.0)*(tmp_qloop_148*2.0 + tmp_qloop_149*2.0 + tmp_qloop_150*2.0) + (tmp_qloop_121 + tmp_qloop_151 + tmp_qloop_152 + tmp_qloop_153)*(tmp_qloop_122 + tmp_qloop_151*0.5 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_154 + tmp_qloop_155 + tmp_qloop_156)*(tmp_qloop_130 + tmp_qloop_154*0.5 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5)*2.0));
                const real_t q_tmp_3_3 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159)*(tmp_qloop_113 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0)*(tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0) + (tmp_qloop_121 + tmp_qloop_160 + tmp_qloop_161 + tmp_qloop_162)*(tmp_qloop_122 + tmp_qloop_160*0.5 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_163 + tmp_qloop_164 + tmp_qloop_165)*(tmp_qloop_130 + tmp_qloop_163*0.5 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5)*2.0));
                const real_t q_tmp_4_4 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168)*(tmp_qloop_113 + tmp_qloop_166*0.66666666666666663 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_166*1.0 + tmp_qloop_167*1.0 + tmp_qloop_168*1.0)*(tmp_qloop_166*2.0 + tmp_qloop_167*2.0 + tmp_qloop_168*2.0) + (tmp_qloop_121 + tmp_qloop_169 + tmp_qloop_170 + tmp_qloop_171)*(tmp_qloop_122 + tmp_qloop_169*0.5 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_172 + tmp_qloop_173 + tmp_qloop_174)*(tmp_qloop_130 + tmp_qloop_172*0.5 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5)*2.0));
                const real_t q_tmp_5_5 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177)*(tmp_qloop_113 + tmp_qloop_175*0.66666666666666663 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_175*1.0 + tmp_qloop_176*1.0 + tmp_qloop_177*1.0)*(tmp_qloop_175*2.0 + tmp_qloop_176*2.0 + tmp_qloop_177*2.0) + (tmp_qloop_121 + tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180)*(tmp_qloop_122 + tmp_qloop_178*0.5 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_181 + tmp_qloop_182 + tmp_qloop_183)*(tmp_qloop_130 + tmp_qloop_181*0.5 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5)*2.0));
                const real_t q_tmp_6_6 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_184 + tmp_qloop_185 + tmp_qloop_186)*(tmp_qloop_113 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_184*1.0 + tmp_qloop_185*1.0 + tmp_qloop_186*1.0)*(tmp_qloop_184*2.0 + tmp_qloop_185*2.0 + tmp_qloop_186*2.0) + (tmp_qloop_121 + tmp_qloop_187 + tmp_qloop_188 + tmp_qloop_189)*(tmp_qloop_122 + tmp_qloop_187*0.5 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_190 + tmp_qloop_191 + tmp_qloop_192)*(tmp_qloop_130 + tmp_qloop_190*0.5 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5)*2.0));
                const real_t q_tmp_7_7 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_193 + tmp_qloop_194 + tmp_qloop_195)*(tmp_qloop_113 + tmp_qloop_193*0.66666666666666663 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_193*1.0 + tmp_qloop_194*1.0 + tmp_qloop_195*1.0)*(tmp_qloop_193*2.0 + tmp_qloop_194*2.0 + tmp_qloop_195*2.0) + (tmp_qloop_121 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198)*(tmp_qloop_122 + tmp_qloop_196*0.5 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201)*(tmp_qloop_130 + tmp_qloop_199*0.5 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5)*2.0));
                const real_t q_tmp_8_8 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_202 + tmp_qloop_203 + tmp_qloop_204)*(tmp_qloop_113 + tmp_qloop_202*0.66666666666666663 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_202*1.0 + tmp_qloop_203*1.0 + tmp_qloop_204*1.0)*(tmp_qloop_202*2.0 + tmp_qloop_203*2.0 + tmp_qloop_204*2.0) + (tmp_qloop_121 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207)*(tmp_qloop_122 + tmp_qloop_205*0.5 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_208 + tmp_qloop_209 + tmp_qloop_210)*(tmp_qloop_130 + tmp_qloop_208*0.5 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5)*2.0));
                const real_t q_tmp_9_9 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_211 + tmp_qloop_212 + tmp_qloop_213)*(tmp_qloop_113 + tmp_qloop_211*0.66666666666666663 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_211*1.0 + tmp_qloop_212*1.0 + tmp_qloop_213*1.0)*(tmp_qloop_211*2.0 + tmp_qloop_212*2.0 + tmp_qloop_213*2.0) + (tmp_qloop_121 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216)*(tmp_qloop_122 + tmp_qloop_214*0.5 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_217 + tmp_qloop_218 + tmp_qloop_219)*(tmp_qloop_130 + tmp_qloop_217*0.5 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5)*2.0));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_UP [] = {0.0, ((real_t)(abs_det_jac_affine_BLUE_UP)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_UP)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_UP)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_UP)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_UP))};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_0_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0 + jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_1_0_BLUE_UP)), ((real_t)(-jac_affine_inv_0_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(-jac_affine_inv_1_0_BLUE_UP - jac_affine_inv_2_0_BLUE_UP)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.0 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.0 + jac_affine_inv_1_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_0_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_0_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_0_BLUE_UP*-2.0 + jac_affine_inv_2_0_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_0_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0 + jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_1_1_BLUE_UP)), ((real_t)(-jac_affine_inv_0_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(-jac_affine_inv_1_1_BLUE_UP - jac_affine_inv_2_1_BLUE_UP)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.0 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.0 + jac_affine_inv_1_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_1_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_1_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_1_BLUE_UP*-2.0 + jac_affine_inv_2_1_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_1_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0 + jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_1_2_BLUE_UP)), ((real_t)(-jac_affine_inv_0_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(-jac_affine_inv_1_2_BLUE_UP - jac_affine_inv_2_2_BLUE_UP)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333304 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333315 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.0 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.0 + jac_affine_inv_1_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_1_2_BLUE_UP*0.33333333333333326 + jac_affine_inv_2_2_BLUE_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.333333333333333 + jac_affine_inv_1_2_BLUE_UP*-2.0 + jac_affine_inv_2_2_BLUE_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_UP*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3333333333333337 + jac_affine_inv_1_2_BLUE_UP*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_138 = (mu_dof_0*_data_phi_0_0_BLUE_UP[10*q] + mu_dof_1*_data_phi_0_0_BLUE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_UP[10*q + 9])*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_114 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t tmp_qloop_106 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q];
                const real_t tmp_qloop_115 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q];
                const real_t tmp_qloop_132 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_UP[q];
                const real_t tmp_qloop_142 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_151 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_160 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_169 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_178 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_187 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_205 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_214 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 9];
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t tmp_qloop_107 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_UP[q];
                const real_t tmp_qloop_123 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q];
                const real_t tmp_qloop_131 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q];
                const real_t tmp_qloop_145 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_154 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_163 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_172 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_181 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_190 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_199 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_208 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_217 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 9];
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t tmp_qloop_103 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q];
                const real_t tmp_qloop_118 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q];
                const real_t tmp_qloop_126 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_UP[q];
                const real_t tmp_qloop_139 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_157 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_175 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_184 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_193 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_202 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_211 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_UP[10*q + 9];
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t tmp_qloop_108 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_UP[q];
                const real_t tmp_qloop_116 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q];
                const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_UP[q];
                const real_t tmp_qloop_143 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_152 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_161 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_170 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_179 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_188 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_206 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_215 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 9];
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t tmp_qloop_109 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_UP[q];
                const real_t tmp_qloop_124 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q];
                const real_t tmp_qloop_133 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_UP[q];
                const real_t tmp_qloop_146 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_155 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_164 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_173 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_182 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_191 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_200 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_209 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_218 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 9];
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t tmp_qloop_104 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q];
                const real_t tmp_qloop_119 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_UP[q];
                const real_t tmp_qloop_127 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_UP[q];
                const real_t tmp_qloop_140 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_158 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_176 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_185 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_194 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_203 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_212 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_UP[10*q + 9];
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t tmp_qloop_110 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_UP[q];
                const real_t tmp_qloop_117 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q];
                const real_t tmp_qloop_136 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_UP[q];
                const real_t tmp_qloop_144 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_153 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_162 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_171 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_180 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_189 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_207 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_216 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 9];
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t tmp_qloop_111 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_UP[q];
                const real_t tmp_qloop_112 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108 + tmp_qloop_109 + tmp_qloop_110 + tmp_qloop_111;
                const real_t tmp_qloop_113 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663 + tmp_qloop_109*0.66666666666666663 + tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663;
                const real_t tmp_qloop_125 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q];
                const real_t tmp_qloop_135 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_UP[q];
                const real_t tmp_qloop_137 = (tmp_qloop_106*1.0 + tmp_qloop_108*1.0 + tmp_qloop_110*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_108*2.0 + tmp_qloop_110*2.0) + (tmp_qloop_107*1.0 + tmp_qloop_109*1.0 + tmp_qloop_111*1.0)*(tmp_qloop_107*2.0 + tmp_qloop_109*2.0 + tmp_qloop_111*2.0) + (tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135 + tmp_qloop_136)*(tmp_qloop_131*0.5 + tmp_qloop_132*0.5 + tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5 + tmp_qloop_136*0.5)*2.0;
                const real_t tmp_qloop_147 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_156 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_165 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_174 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_183 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_192 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_201 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_210 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_219 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 9];
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_105 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q];
                const real_t tmp_qloop_120 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_UP[q];
                const real_t tmp_qloop_121 = tmp_qloop_118 + tmp_qloop_119 + tmp_qloop_120;
                const real_t tmp_qloop_122 = tmp_qloop_118*0.5 + tmp_qloop_119*0.5 + tmp_qloop_120*0.5;
                const real_t tmp_qloop_128 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_UP[q];
                const real_t tmp_qloop_129 = tmp_qloop_126 + tmp_qloop_127 + tmp_qloop_128;
                const real_t tmp_qloop_130 = tmp_qloop_126*0.5 + tmp_qloop_127*0.5 + tmp_qloop_128*0.5;
                const real_t tmp_qloop_141 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 1];
                const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 2];
                const real_t tmp_qloop_159 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 3];
                const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 4];
                const real_t tmp_qloop_177 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 5];
                const real_t tmp_qloop_186 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 6];
                const real_t tmp_qloop_195 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 7];
                const real_t tmp_qloop_204 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 8];
                const real_t tmp_qloop_213 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_UP[10*q + 9];
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_112)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_113) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_115 + tmp_qloop_116 + tmp_qloop_117 + tmp_qloop_121)*(tmp_qloop_115*0.5 + tmp_qloop_116*0.5 + tmp_qloop_117*0.5 + tmp_qloop_122)*2.0 + (tmp_qloop_123 + tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_129)*(tmp_qloop_123*0.5 + tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_130)*2.0));
                const real_t q_tmp_1_1 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_139 + tmp_qloop_140 + tmp_qloop_141)*(tmp_qloop_113 + tmp_qloop_139*0.66666666666666663 + tmp_qloop_140*0.66666666666666663 + tmp_qloop_141*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_139*1.0 + tmp_qloop_140*1.0 + tmp_qloop_141*1.0)*(tmp_qloop_139*2.0 + tmp_qloop_140*2.0 + tmp_qloop_141*2.0) + (tmp_qloop_121 + tmp_qloop_142 + tmp_qloop_143 + tmp_qloop_144)*(tmp_qloop_122 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5 + tmp_qloop_144*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_145 + tmp_qloop_146 + tmp_qloop_147)*(tmp_qloop_130 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5 + tmp_qloop_147*0.5)*2.0));
                const real_t q_tmp_2_2 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150)*(tmp_qloop_113 + tmp_qloop_148*0.66666666666666663 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_148*1.0 + tmp_qloop_149*1.0 + tmp_qloop_150*1.0)*(tmp_qloop_148*2.0 + tmp_qloop_149*2.0 + tmp_qloop_150*2.0) + (tmp_qloop_121 + tmp_qloop_151 + tmp_qloop_152 + tmp_qloop_153)*(tmp_qloop_122 + tmp_qloop_151*0.5 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_154 + tmp_qloop_155 + tmp_qloop_156)*(tmp_qloop_130 + tmp_qloop_154*0.5 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5)*2.0));
                const real_t q_tmp_3_3 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159)*(tmp_qloop_113 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0)*(tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0) + (tmp_qloop_121 + tmp_qloop_160 + tmp_qloop_161 + tmp_qloop_162)*(tmp_qloop_122 + tmp_qloop_160*0.5 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_163 + tmp_qloop_164 + tmp_qloop_165)*(tmp_qloop_130 + tmp_qloop_163*0.5 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5)*2.0));
                const real_t q_tmp_4_4 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168)*(tmp_qloop_113 + tmp_qloop_166*0.66666666666666663 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_166*1.0 + tmp_qloop_167*1.0 + tmp_qloop_168*1.0)*(tmp_qloop_166*2.0 + tmp_qloop_167*2.0 + tmp_qloop_168*2.0) + (tmp_qloop_121 + tmp_qloop_169 + tmp_qloop_170 + tmp_qloop_171)*(tmp_qloop_122 + tmp_qloop_169*0.5 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_172 + tmp_qloop_173 + tmp_qloop_174)*(tmp_qloop_130 + tmp_qloop_172*0.5 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5)*2.0));
                const real_t q_tmp_5_5 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177)*(tmp_qloop_113 + tmp_qloop_175*0.66666666666666663 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_175*1.0 + tmp_qloop_176*1.0 + tmp_qloop_177*1.0)*(tmp_qloop_175*2.0 + tmp_qloop_176*2.0 + tmp_qloop_177*2.0) + (tmp_qloop_121 + tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180)*(tmp_qloop_122 + tmp_qloop_178*0.5 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_181 + tmp_qloop_182 + tmp_qloop_183)*(tmp_qloop_130 + tmp_qloop_181*0.5 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5)*2.0));
                const real_t q_tmp_6_6 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_184 + tmp_qloop_185 + tmp_qloop_186)*(tmp_qloop_113 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_184*1.0 + tmp_qloop_185*1.0 + tmp_qloop_186*1.0)*(tmp_qloop_184*2.0 + tmp_qloop_185*2.0 + tmp_qloop_186*2.0) + (tmp_qloop_121 + tmp_qloop_187 + tmp_qloop_188 + tmp_qloop_189)*(tmp_qloop_122 + tmp_qloop_187*0.5 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_190 + tmp_qloop_191 + tmp_qloop_192)*(tmp_qloop_130 + tmp_qloop_190*0.5 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5)*2.0));
                const real_t q_tmp_7_7 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_193 + tmp_qloop_194 + tmp_qloop_195)*(tmp_qloop_113 + tmp_qloop_193*0.66666666666666663 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_193*1.0 + tmp_qloop_194*1.0 + tmp_qloop_195*1.0)*(tmp_qloop_193*2.0 + tmp_qloop_194*2.0 + tmp_qloop_195*2.0) + (tmp_qloop_121 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198)*(tmp_qloop_122 + tmp_qloop_196*0.5 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201)*(tmp_qloop_130 + tmp_qloop_199*0.5 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5)*2.0));
                const real_t q_tmp_8_8 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_202 + tmp_qloop_203 + tmp_qloop_204)*(tmp_qloop_113 + tmp_qloop_202*0.66666666666666663 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_202*1.0 + tmp_qloop_203*1.0 + tmp_qloop_204*1.0)*(tmp_qloop_202*2.0 + tmp_qloop_203*2.0 + tmp_qloop_204*2.0) + (tmp_qloop_121 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207)*(tmp_qloop_122 + tmp_qloop_205*0.5 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_208 + tmp_qloop_209 + tmp_qloop_210)*(tmp_qloop_130 + tmp_qloop_208*0.5 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5)*2.0));
                const real_t q_tmp_9_9 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_211 + tmp_qloop_212 + tmp_qloop_213)*(tmp_qloop_113 + tmp_qloop_211*0.66666666666666663 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_211*1.0 + tmp_qloop_212*1.0 + tmp_qloop_213*1.0)*(tmp_qloop_211*2.0 + tmp_qloop_212*2.0 + tmp_qloop_213*2.0) + (tmp_qloop_121 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216)*(tmp_qloop_122 + tmp_qloop_214*0.5 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_217 + tmp_qloop_218 + tmp_qloop_219)*(tmp_qloop_130 + tmp_qloop_217*0.5 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5)*2.0));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN))};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_0_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0 + jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_1_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_0_BLUE_DOWN - jac_affine_inv_2_0_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.0 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.0 + jac_affine_inv_1_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_0_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_0_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_0_BLUE_DOWN*-2.0 + jac_affine_inv_2_0_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_0_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0 + jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_1_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_1_BLUE_DOWN - jac_affine_inv_2_1_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.0 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.0 + jac_affine_inv_1_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_1_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_1_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_1_BLUE_DOWN*-2.0 + jac_affine_inv_2_1_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_1_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_BLUE_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0 + jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_1_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_0_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(-jac_affine_inv_1_2_BLUE_DOWN - jac_affine_inv_2_2_BLUE_DOWN)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333304 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333315 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.0 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.0 + jac_affine_inv_1_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_1_2_BLUE_DOWN*0.33333333333333326 + jac_affine_inv_2_2_BLUE_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.333333333333333 + jac_affine_inv_1_2_BLUE_DOWN*-2.0 + jac_affine_inv_2_2_BLUE_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_BLUE_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_BLUE_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3333333333333337 + jac_affine_inv_1_2_BLUE_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_BLUE_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_138 = (mu_dof_0*_data_phi_0_0_BLUE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_BLUE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_DOWN[10*q + 9])*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_114 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t tmp_qloop_106 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q];
                const real_t tmp_qloop_115 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q];
                const real_t tmp_qloop_132 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_BLUE_DOWN[q];
                const real_t tmp_qloop_142 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_151 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_160 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_169 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_178 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_187 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_205 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_214 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 9];
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t tmp_qloop_107 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_BLUE_DOWN[q];
                const real_t tmp_qloop_123 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q];
                const real_t tmp_qloop_131 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q];
                const real_t tmp_qloop_145 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_154 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_163 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_172 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_181 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_190 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_199 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_208 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_217 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 9];
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t tmp_qloop_103 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q];
                const real_t tmp_qloop_118 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q];
                const real_t tmp_qloop_126 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_BLUE_DOWN[q];
                const real_t tmp_qloop_139 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_157 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_175 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_184 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_193 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_202 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_211 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_BLUE_DOWN[10*q + 9];
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t tmp_qloop_108 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_BLUE_DOWN[q];
                const real_t tmp_qloop_116 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q];
                const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_BLUE_DOWN[q];
                const real_t tmp_qloop_143 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_152 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_161 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_170 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_179 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_188 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_206 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_215 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 9];
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t tmp_qloop_109 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_BLUE_DOWN[q];
                const real_t tmp_qloop_124 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q];
                const real_t tmp_qloop_133 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_BLUE_DOWN[q];
                const real_t tmp_qloop_146 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_155 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_164 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_173 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_182 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_191 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_200 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_209 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_218 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 9];
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t tmp_qloop_104 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q];
                const real_t tmp_qloop_119 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_BLUE_DOWN[q];
                const real_t tmp_qloop_127 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_BLUE_DOWN[q];
                const real_t tmp_qloop_140 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_158 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_176 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_185 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_194 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_203 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_212 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_BLUE_DOWN[10*q + 9];
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t tmp_qloop_110 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_BLUE_DOWN[q];
                const real_t tmp_qloop_117 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q];
                const real_t tmp_qloop_136 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_BLUE_DOWN[q];
                const real_t tmp_qloop_144 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_153 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_162 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_171 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_180 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_189 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_207 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_216 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 9];
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t tmp_qloop_111 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_BLUE_DOWN[q];
                const real_t tmp_qloop_112 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108 + tmp_qloop_109 + tmp_qloop_110 + tmp_qloop_111;
                const real_t tmp_qloop_113 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663 + tmp_qloop_109*0.66666666666666663 + tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663;
                const real_t tmp_qloop_125 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q];
                const real_t tmp_qloop_135 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_BLUE_DOWN[q];
                const real_t tmp_qloop_137 = (tmp_qloop_106*1.0 + tmp_qloop_108*1.0 + tmp_qloop_110*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_108*2.0 + tmp_qloop_110*2.0) + (tmp_qloop_107*1.0 + tmp_qloop_109*1.0 + tmp_qloop_111*1.0)*(tmp_qloop_107*2.0 + tmp_qloop_109*2.0 + tmp_qloop_111*2.0) + (tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135 + tmp_qloop_136)*(tmp_qloop_131*0.5 + tmp_qloop_132*0.5 + tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5 + tmp_qloop_136*0.5)*2.0;
                const real_t tmp_qloop_147 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_156 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_165 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_174 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_183 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_192 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_201 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_210 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_219 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 9];
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_105 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q];
                const real_t tmp_qloop_120 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_BLUE_DOWN[q];
                const real_t tmp_qloop_121 = tmp_qloop_118 + tmp_qloop_119 + tmp_qloop_120;
                const real_t tmp_qloop_122 = tmp_qloop_118*0.5 + tmp_qloop_119*0.5 + tmp_qloop_120*0.5;
                const real_t tmp_qloop_128 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_BLUE_DOWN[q];
                const real_t tmp_qloop_129 = tmp_qloop_126 + tmp_qloop_127 + tmp_qloop_128;
                const real_t tmp_qloop_130 = tmp_qloop_126*0.5 + tmp_qloop_127*0.5 + tmp_qloop_128*0.5;
                const real_t tmp_qloop_141 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 1];
                const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 2];
                const real_t tmp_qloop_159 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 3];
                const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 4];
                const real_t tmp_qloop_177 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 5];
                const real_t tmp_qloop_186 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 6];
                const real_t tmp_qloop_195 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 7];
                const real_t tmp_qloop_204 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 8];
                const real_t tmp_qloop_213 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_BLUE_DOWN[10*q + 9];
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_112)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_113) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_115 + tmp_qloop_116 + tmp_qloop_117 + tmp_qloop_121)*(tmp_qloop_115*0.5 + tmp_qloop_116*0.5 + tmp_qloop_117*0.5 + tmp_qloop_122)*2.0 + (tmp_qloop_123 + tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_129)*(tmp_qloop_123*0.5 + tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_130)*2.0));
                const real_t q_tmp_1_1 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_139 + tmp_qloop_140 + tmp_qloop_141)*(tmp_qloop_113 + tmp_qloop_139*0.66666666666666663 + tmp_qloop_140*0.66666666666666663 + tmp_qloop_141*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_139*1.0 + tmp_qloop_140*1.0 + tmp_qloop_141*1.0)*(tmp_qloop_139*2.0 + tmp_qloop_140*2.0 + tmp_qloop_141*2.0) + (tmp_qloop_121 + tmp_qloop_142 + tmp_qloop_143 + tmp_qloop_144)*(tmp_qloop_122 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5 + tmp_qloop_144*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_145 + tmp_qloop_146 + tmp_qloop_147)*(tmp_qloop_130 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5 + tmp_qloop_147*0.5)*2.0));
                const real_t q_tmp_2_2 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150)*(tmp_qloop_113 + tmp_qloop_148*0.66666666666666663 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_148*1.0 + tmp_qloop_149*1.0 + tmp_qloop_150*1.0)*(tmp_qloop_148*2.0 + tmp_qloop_149*2.0 + tmp_qloop_150*2.0) + (tmp_qloop_121 + tmp_qloop_151 + tmp_qloop_152 + tmp_qloop_153)*(tmp_qloop_122 + tmp_qloop_151*0.5 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_154 + tmp_qloop_155 + tmp_qloop_156)*(tmp_qloop_130 + tmp_qloop_154*0.5 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5)*2.0));
                const real_t q_tmp_3_3 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159)*(tmp_qloop_113 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0)*(tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0) + (tmp_qloop_121 + tmp_qloop_160 + tmp_qloop_161 + tmp_qloop_162)*(tmp_qloop_122 + tmp_qloop_160*0.5 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_163 + tmp_qloop_164 + tmp_qloop_165)*(tmp_qloop_130 + tmp_qloop_163*0.5 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5)*2.0));
                const real_t q_tmp_4_4 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168)*(tmp_qloop_113 + tmp_qloop_166*0.66666666666666663 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_166*1.0 + tmp_qloop_167*1.0 + tmp_qloop_168*1.0)*(tmp_qloop_166*2.0 + tmp_qloop_167*2.0 + tmp_qloop_168*2.0) + (tmp_qloop_121 + tmp_qloop_169 + tmp_qloop_170 + tmp_qloop_171)*(tmp_qloop_122 + tmp_qloop_169*0.5 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_172 + tmp_qloop_173 + tmp_qloop_174)*(tmp_qloop_130 + tmp_qloop_172*0.5 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5)*2.0));
                const real_t q_tmp_5_5 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177)*(tmp_qloop_113 + tmp_qloop_175*0.66666666666666663 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_175*1.0 + tmp_qloop_176*1.0 + tmp_qloop_177*1.0)*(tmp_qloop_175*2.0 + tmp_qloop_176*2.0 + tmp_qloop_177*2.0) + (tmp_qloop_121 + tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180)*(tmp_qloop_122 + tmp_qloop_178*0.5 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_181 + tmp_qloop_182 + tmp_qloop_183)*(tmp_qloop_130 + tmp_qloop_181*0.5 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5)*2.0));
                const real_t q_tmp_6_6 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_184 + tmp_qloop_185 + tmp_qloop_186)*(tmp_qloop_113 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_184*1.0 + tmp_qloop_185*1.0 + tmp_qloop_186*1.0)*(tmp_qloop_184*2.0 + tmp_qloop_185*2.0 + tmp_qloop_186*2.0) + (tmp_qloop_121 + tmp_qloop_187 + tmp_qloop_188 + tmp_qloop_189)*(tmp_qloop_122 + tmp_qloop_187*0.5 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_190 + tmp_qloop_191 + tmp_qloop_192)*(tmp_qloop_130 + tmp_qloop_190*0.5 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5)*2.0));
                const real_t q_tmp_7_7 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_193 + tmp_qloop_194 + tmp_qloop_195)*(tmp_qloop_113 + tmp_qloop_193*0.66666666666666663 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_193*1.0 + tmp_qloop_194*1.0 + tmp_qloop_195*1.0)*(tmp_qloop_193*2.0 + tmp_qloop_194*2.0 + tmp_qloop_195*2.0) + (tmp_qloop_121 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198)*(tmp_qloop_122 + tmp_qloop_196*0.5 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201)*(tmp_qloop_130 + tmp_qloop_199*0.5 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5)*2.0));
                const real_t q_tmp_8_8 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_202 + tmp_qloop_203 + tmp_qloop_204)*(tmp_qloop_113 + tmp_qloop_202*0.66666666666666663 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_202*1.0 + tmp_qloop_203*1.0 + tmp_qloop_204*1.0)*(tmp_qloop_202*2.0 + tmp_qloop_203*2.0 + tmp_qloop_204*2.0) + (tmp_qloop_121 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207)*(tmp_qloop_122 + tmp_qloop_205*0.5 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_208 + tmp_qloop_209 + tmp_qloop_210)*(tmp_qloop_130 + tmp_qloop_208*0.5 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5)*2.0));
                const real_t q_tmp_9_9 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_211 + tmp_qloop_212 + tmp_qloop_213)*(tmp_qloop_113 + tmp_qloop_211*0.66666666666666663 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_211*1.0 + tmp_qloop_212*1.0 + tmp_qloop_213*1.0)*(tmp_qloop_211*2.0 + tmp_qloop_212*2.0 + tmp_qloop_213*2.0) + (tmp_qloop_121 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216)*(tmp_qloop_122 + tmp_qloop_214*0.5 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_217 + tmp_qloop_218 + tmp_qloop_219)*(tmp_qloop_130 + tmp_qloop_217*0.5 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5)*2.0));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_UP [] = {0.0, ((real_t)(abs_det_jac_affine_GREEN_UP)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_UP)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_UP)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_UP)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_UP))};
      
          const real_t _data_tabulated_and_untitled_0_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_0_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0 + jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_1_0_GREEN_UP)), ((real_t)(-jac_affine_inv_0_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(-jac_affine_inv_1_0_GREEN_UP - jac_affine_inv_2_0_GREEN_UP)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.0 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.0 + jac_affine_inv_1_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_0_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_0_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_0_GREEN_UP*-2.0 + jac_affine_inv_2_0_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_0_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0 + jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_1_1_GREEN_UP)), ((real_t)(-jac_affine_inv_0_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(-jac_affine_inv_1_1_GREEN_UP - jac_affine_inv_2_1_GREEN_UP)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.0 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.0 + jac_affine_inv_1_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_1_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_1_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_1_GREEN_UP*-2.0 + jac_affine_inv_2_1_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_1_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_UP*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0 + jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_1_2_GREEN_UP)), ((real_t)(-jac_affine_inv_0_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(-jac_affine_inv_1_2_GREEN_UP - jac_affine_inv_2_2_GREEN_UP)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333304 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333315 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.0 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.0 + jac_affine_inv_1_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_1_2_GREEN_UP*0.33333333333333326 + jac_affine_inv_2_2_GREEN_UP*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.333333333333333 + jac_affine_inv_1_2_GREEN_UP*-2.0 + jac_affine_inv_2_2_GREEN_UP*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_UP*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_UP*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3333333333333337 + jac_affine_inv_1_2_GREEN_UP*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_UP*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_138 = (mu_dof_0*_data_phi_0_0_GREEN_UP[10*q] + mu_dof_1*_data_phi_0_0_GREEN_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_UP[10*q + 9])*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_114 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t tmp_qloop_106 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q];
                const real_t tmp_qloop_115 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q];
                const real_t tmp_qloop_132 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_UP[q];
                const real_t tmp_qloop_142 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_151 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_160 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_169 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_178 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_187 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_205 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_214 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 9];
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t tmp_qloop_107 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_UP[q];
                const real_t tmp_qloop_123 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q];
                const real_t tmp_qloop_131 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q];
                const real_t tmp_qloop_145 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_154 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_163 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_172 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_181 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_190 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_199 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_208 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_217 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 9];
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t tmp_qloop_103 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q];
                const real_t tmp_qloop_118 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q];
                const real_t tmp_qloop_126 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_UP[q];
                const real_t tmp_qloop_139 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_157 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_175 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_184 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_193 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_202 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_211 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_UP[10*q + 9];
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t tmp_qloop_108 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_UP[q];
                const real_t tmp_qloop_116 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q];
                const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_UP[q];
                const real_t tmp_qloop_143 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_152 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_161 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_170 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_179 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_188 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_206 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_215 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 9];
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t tmp_qloop_109 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_UP[q];
                const real_t tmp_qloop_124 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q];
                const real_t tmp_qloop_133 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_UP[q];
                const real_t tmp_qloop_146 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_155 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_164 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_173 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_182 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_191 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_200 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_209 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_218 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 9];
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t tmp_qloop_104 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q];
                const real_t tmp_qloop_119 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_UP[q];
                const real_t tmp_qloop_127 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_UP[q];
                const real_t tmp_qloop_140 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_158 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_176 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_185 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_194 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_203 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_212 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_UP[10*q + 9];
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t tmp_qloop_110 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_UP[q];
                const real_t tmp_qloop_117 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q];
                const real_t tmp_qloop_136 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_UP[q];
                const real_t tmp_qloop_144 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_153 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_162 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_171 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_180 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_189 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_207 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_216 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 9];
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t tmp_qloop_111 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_UP[q];
                const real_t tmp_qloop_112 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108 + tmp_qloop_109 + tmp_qloop_110 + tmp_qloop_111;
                const real_t tmp_qloop_113 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663 + tmp_qloop_109*0.66666666666666663 + tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663;
                const real_t tmp_qloop_125 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q];
                const real_t tmp_qloop_135 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_UP[q];
                const real_t tmp_qloop_137 = (tmp_qloop_106*1.0 + tmp_qloop_108*1.0 + tmp_qloop_110*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_108*2.0 + tmp_qloop_110*2.0) + (tmp_qloop_107*1.0 + tmp_qloop_109*1.0 + tmp_qloop_111*1.0)*(tmp_qloop_107*2.0 + tmp_qloop_109*2.0 + tmp_qloop_111*2.0) + (tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135 + tmp_qloop_136)*(tmp_qloop_131*0.5 + tmp_qloop_132*0.5 + tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5 + tmp_qloop_136*0.5)*2.0;
                const real_t tmp_qloop_147 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_156 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_165 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_174 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_183 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_192 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_201 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_210 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_219 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 9];
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_105 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q];
                const real_t tmp_qloop_120 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_UP[q];
                const real_t tmp_qloop_121 = tmp_qloop_118 + tmp_qloop_119 + tmp_qloop_120;
                const real_t tmp_qloop_122 = tmp_qloop_118*0.5 + tmp_qloop_119*0.5 + tmp_qloop_120*0.5;
                const real_t tmp_qloop_128 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_UP[q];
                const real_t tmp_qloop_129 = tmp_qloop_126 + tmp_qloop_127 + tmp_qloop_128;
                const real_t tmp_qloop_130 = tmp_qloop_126*0.5 + tmp_qloop_127*0.5 + tmp_qloop_128*0.5;
                const real_t tmp_qloop_141 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 1];
                const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 2];
                const real_t tmp_qloop_159 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 3];
                const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 4];
                const real_t tmp_qloop_177 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 5];
                const real_t tmp_qloop_186 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 6];
                const real_t tmp_qloop_195 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 7];
                const real_t tmp_qloop_204 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 8];
                const real_t tmp_qloop_213 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_UP[10*q + 9];
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_112)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_113) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_115 + tmp_qloop_116 + tmp_qloop_117 + tmp_qloop_121)*(tmp_qloop_115*0.5 + tmp_qloop_116*0.5 + tmp_qloop_117*0.5 + tmp_qloop_122)*2.0 + (tmp_qloop_123 + tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_129)*(tmp_qloop_123*0.5 + tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_130)*2.0));
                const real_t q_tmp_1_1 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_139 + tmp_qloop_140 + tmp_qloop_141)*(tmp_qloop_113 + tmp_qloop_139*0.66666666666666663 + tmp_qloop_140*0.66666666666666663 + tmp_qloop_141*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_139*1.0 + tmp_qloop_140*1.0 + tmp_qloop_141*1.0)*(tmp_qloop_139*2.0 + tmp_qloop_140*2.0 + tmp_qloop_141*2.0) + (tmp_qloop_121 + tmp_qloop_142 + tmp_qloop_143 + tmp_qloop_144)*(tmp_qloop_122 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5 + tmp_qloop_144*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_145 + tmp_qloop_146 + tmp_qloop_147)*(tmp_qloop_130 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5 + tmp_qloop_147*0.5)*2.0));
                const real_t q_tmp_2_2 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150)*(tmp_qloop_113 + tmp_qloop_148*0.66666666666666663 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_148*1.0 + tmp_qloop_149*1.0 + tmp_qloop_150*1.0)*(tmp_qloop_148*2.0 + tmp_qloop_149*2.0 + tmp_qloop_150*2.0) + (tmp_qloop_121 + tmp_qloop_151 + tmp_qloop_152 + tmp_qloop_153)*(tmp_qloop_122 + tmp_qloop_151*0.5 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_154 + tmp_qloop_155 + tmp_qloop_156)*(tmp_qloop_130 + tmp_qloop_154*0.5 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5)*2.0));
                const real_t q_tmp_3_3 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159)*(tmp_qloop_113 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0)*(tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0) + (tmp_qloop_121 + tmp_qloop_160 + tmp_qloop_161 + tmp_qloop_162)*(tmp_qloop_122 + tmp_qloop_160*0.5 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_163 + tmp_qloop_164 + tmp_qloop_165)*(tmp_qloop_130 + tmp_qloop_163*0.5 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5)*2.0));
                const real_t q_tmp_4_4 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168)*(tmp_qloop_113 + tmp_qloop_166*0.66666666666666663 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_166*1.0 + tmp_qloop_167*1.0 + tmp_qloop_168*1.0)*(tmp_qloop_166*2.0 + tmp_qloop_167*2.0 + tmp_qloop_168*2.0) + (tmp_qloop_121 + tmp_qloop_169 + tmp_qloop_170 + tmp_qloop_171)*(tmp_qloop_122 + tmp_qloop_169*0.5 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_172 + tmp_qloop_173 + tmp_qloop_174)*(tmp_qloop_130 + tmp_qloop_172*0.5 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5)*2.0));
                const real_t q_tmp_5_5 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177)*(tmp_qloop_113 + tmp_qloop_175*0.66666666666666663 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_175*1.0 + tmp_qloop_176*1.0 + tmp_qloop_177*1.0)*(tmp_qloop_175*2.0 + tmp_qloop_176*2.0 + tmp_qloop_177*2.0) + (tmp_qloop_121 + tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180)*(tmp_qloop_122 + tmp_qloop_178*0.5 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_181 + tmp_qloop_182 + tmp_qloop_183)*(tmp_qloop_130 + tmp_qloop_181*0.5 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5)*2.0));
                const real_t q_tmp_6_6 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_184 + tmp_qloop_185 + tmp_qloop_186)*(tmp_qloop_113 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_184*1.0 + tmp_qloop_185*1.0 + tmp_qloop_186*1.0)*(tmp_qloop_184*2.0 + tmp_qloop_185*2.0 + tmp_qloop_186*2.0) + (tmp_qloop_121 + tmp_qloop_187 + tmp_qloop_188 + tmp_qloop_189)*(tmp_qloop_122 + tmp_qloop_187*0.5 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_190 + tmp_qloop_191 + tmp_qloop_192)*(tmp_qloop_130 + tmp_qloop_190*0.5 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5)*2.0));
                const real_t q_tmp_7_7 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_193 + tmp_qloop_194 + tmp_qloop_195)*(tmp_qloop_113 + tmp_qloop_193*0.66666666666666663 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_193*1.0 + tmp_qloop_194*1.0 + tmp_qloop_195*1.0)*(tmp_qloop_193*2.0 + tmp_qloop_194*2.0 + tmp_qloop_195*2.0) + (tmp_qloop_121 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198)*(tmp_qloop_122 + tmp_qloop_196*0.5 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201)*(tmp_qloop_130 + tmp_qloop_199*0.5 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5)*2.0));
                const real_t q_tmp_8_8 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_202 + tmp_qloop_203 + tmp_qloop_204)*(tmp_qloop_113 + tmp_qloop_202*0.66666666666666663 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_202*1.0 + tmp_qloop_203*1.0 + tmp_qloop_204*1.0)*(tmp_qloop_202*2.0 + tmp_qloop_203*2.0 + tmp_qloop_204*2.0) + (tmp_qloop_121 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207)*(tmp_qloop_122 + tmp_qloop_205*0.5 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_208 + tmp_qloop_209 + tmp_qloop_210)*(tmp_qloop_130 + tmp_qloop_208*0.5 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5)*2.0));
                const real_t q_tmp_9_9 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_211 + tmp_qloop_212 + tmp_qloop_213)*(tmp_qloop_113 + tmp_qloop_211*0.66666666666666663 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_211*1.0 + tmp_qloop_212*1.0 + tmp_qloop_213*1.0)*(tmp_qloop_211*2.0 + tmp_qloop_212*2.0 + tmp_qloop_213*2.0) + (tmp_qloop_121 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216)*(tmp_qloop_122 + tmp_qloop_214*0.5 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_217 + tmp_qloop_218 + tmp_qloop_219)*(tmp_qloop_130 + tmp_qloop_217*0.5 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5)*2.0));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {-0.125, -0.125, -0.125, -0.125, 0.25, 0.25, 0.25, 0.25, 0.25, 0.25, -0.11111111111111105, -0.1111111111111111, -0.1111111111111111, 0.0, 0.33333333333333331, 0.33333333333333331, 0.1111111111111111, 0.33333333333333343, 0.11111111111111116, 0.11111111111111116, -0.11111111111111116, -0.1111111111111111, 0.0, -0.1111111111111111, 0.33333333333333331, 0.1111111111111111, 0.33333333333333331, 0.11111111111111116, 0.33333333333333343, 0.11111111111111116, -0.11111111111111116, 0.0, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.33333333333333331, 0.33333333333333331, 0.11111111111111116, 0.11111111111111116, 0.33333333333333343, 5.5511151231257827e-17, -0.1111111111111111, -0.1111111111111111, -0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.1111111111111111, 0.33333333333333337, 0.33333333333333337, 0.33333333333333337};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN))};
      
          const real_t _data_tabulated_and_untitled_0_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_0_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0 + jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_1_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_0_GREEN_DOWN - jac_affine_inv_2_0_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.0 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.0 + jac_affine_inv_1_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_0_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_0_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_0_GREEN_DOWN*-2.0 + jac_affine_inv_2_0_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_0_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_0_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_0_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_0_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_1_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0 + jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_1_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_1_GREEN_DOWN - jac_affine_inv_2_1_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.0 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.0 + jac_affine_inv_1_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_1_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_1_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_1_GREEN_DOWN*-2.0 + jac_affine_inv_2_1_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_1_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_1_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_1_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_1_GREEN_DOWN*-0.66666666666666663))};
      
          const real_t _data_tabulated_and_untitled_2_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0, ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0 + jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_1_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_0_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(-jac_affine_inv_1_2_GREEN_DOWN - jac_affine_inv_2_2_GREEN_DOWN)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333304 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333304)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-1.333333333333333)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333315 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.0 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.0 + jac_affine_inv_1_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_1_2_GREEN_DOWN*0.33333333333333326 + jac_affine_inv_2_2_GREEN_DOWN*0.33333333333333326)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.0)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.333333333333333 + jac_affine_inv_1_2_GREEN_DOWN*-2.0 + jac_affine_inv_2_2_GREEN_DOWN*-2.0)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_1_2_GREEN_DOWN*-1.0000000000000004 + jac_affine_inv_2_2_GREEN_DOWN*-1.0000000000000004)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.33333333333333337)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*1.3333333333333337)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_1_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3333333333333337 + jac_affine_inv_1_2_GREEN_DOWN*-0.66666666666666663 + jac_affine_inv_2_2_GREEN_DOWN*-0.66666666666666663))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 5; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t tmp_qloop_138 = (mu_dof_0*_data_phi_0_0_GREEN_DOWN[10*q] + mu_dof_1*_data_phi_0_0_GREEN_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_DOWN[10*q + 9])*_data_q_w[q];
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_114 = abs_det_jac_blending*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t tmp_qloop_106 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q];
                const real_t tmp_qloop_115 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q];
                const real_t tmp_qloop_132 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_1_GREEN_DOWN[q];
                const real_t tmp_qloop_142 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_151 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_160 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_169 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_178 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_187 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_196 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_205 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_214 = jac_blending_inv_0_0*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 9];
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t tmp_qloop_107 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_1_GREEN_DOWN[q];
                const real_t tmp_qloop_123 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q];
                const real_t tmp_qloop_131 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q];
                const real_t tmp_qloop_145 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_154 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_163 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_172 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_181 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_190 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_199 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_208 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_217 = jac_blending_inv_0_1*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 9];
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t tmp_qloop_103 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q];
                const real_t tmp_qloop_118 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q];
                const real_t tmp_qloop_126 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_1_GREEN_DOWN[q];
                const real_t tmp_qloop_139 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_148 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_157 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_166 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_175 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_184 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_193 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_202 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_211 = jac_blending_inv_0_2*_data_tabulated_and_untitled_0_2_GREEN_DOWN[10*q + 9];
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t tmp_qloop_108 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_0_GREEN_DOWN[q];
                const real_t tmp_qloop_116 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q];
                const real_t tmp_qloop_134 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_1_GREEN_DOWN[q];
                const real_t tmp_qloop_143 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_152 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_161 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_170 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_179 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_188 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_197 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_206 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_215 = jac_blending_inv_1_0*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 9];
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t tmp_qloop_109 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_1_GREEN_DOWN[q];
                const real_t tmp_qloop_124 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q];
                const real_t tmp_qloop_133 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_0_GREEN_DOWN[q];
                const real_t tmp_qloop_146 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_155 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_164 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_173 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_182 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_191 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_200 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_209 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_218 = jac_blending_inv_1_1*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 9];
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t tmp_qloop_104 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q];
                const real_t tmp_qloop_119 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_0_GREEN_DOWN[q];
                const real_t tmp_qloop_127 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_1_GREEN_DOWN[q];
                const real_t tmp_qloop_140 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_149 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_158 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_167 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_176 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_185 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_194 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_203 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_212 = jac_blending_inv_1_2*_data_tabulated_and_untitled_1_2_GREEN_DOWN[10*q + 9];
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t tmp_qloop_110 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_0_GREEN_DOWN[q];
                const real_t tmp_qloop_117 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q];
                const real_t tmp_qloop_136 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_1_GREEN_DOWN[q];
                const real_t tmp_qloop_144 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_153 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_162 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_171 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_180 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_189 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_198 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_207 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_216 = jac_blending_inv_2_0*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 9];
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t tmp_qloop_111 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_1_GREEN_DOWN[q];
                const real_t tmp_qloop_112 = tmp_qloop_106 + tmp_qloop_107 + tmp_qloop_108 + tmp_qloop_109 + tmp_qloop_110 + tmp_qloop_111;
                const real_t tmp_qloop_113 = tmp_qloop_106*0.66666666666666663 + tmp_qloop_107*0.66666666666666663 + tmp_qloop_108*0.66666666666666663 + tmp_qloop_109*0.66666666666666663 + tmp_qloop_110*0.66666666666666663 + tmp_qloop_111*0.66666666666666663;
                const real_t tmp_qloop_125 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q];
                const real_t tmp_qloop_135 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_0_GREEN_DOWN[q];
                const real_t tmp_qloop_137 = (tmp_qloop_106*1.0 + tmp_qloop_108*1.0 + tmp_qloop_110*1.0)*(tmp_qloop_106*2.0 + tmp_qloop_108*2.0 + tmp_qloop_110*2.0) + (tmp_qloop_107*1.0 + tmp_qloop_109*1.0 + tmp_qloop_111*1.0)*(tmp_qloop_107*2.0 + tmp_qloop_109*2.0 + tmp_qloop_111*2.0) + (tmp_qloop_131 + tmp_qloop_132 + tmp_qloop_133 + tmp_qloop_134 + tmp_qloop_135 + tmp_qloop_136)*(tmp_qloop_131*0.5 + tmp_qloop_132*0.5 + tmp_qloop_133*0.5 + tmp_qloop_134*0.5 + tmp_qloop_135*0.5 + tmp_qloop_136*0.5)*2.0;
                const real_t tmp_qloop_147 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_156 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_165 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_174 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_183 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_192 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_201 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_210 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_219 = jac_blending_inv_2_1*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 9];
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t tmp_qloop_105 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q];
                const real_t tmp_qloop_120 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_0_GREEN_DOWN[q];
                const real_t tmp_qloop_121 = tmp_qloop_118 + tmp_qloop_119 + tmp_qloop_120;
                const real_t tmp_qloop_122 = tmp_qloop_118*0.5 + tmp_qloop_119*0.5 + tmp_qloop_120*0.5;
                const real_t tmp_qloop_128 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_1_GREEN_DOWN[q];
                const real_t tmp_qloop_129 = tmp_qloop_126 + tmp_qloop_127 + tmp_qloop_128;
                const real_t tmp_qloop_130 = tmp_qloop_126*0.5 + tmp_qloop_127*0.5 + tmp_qloop_128*0.5;
                const real_t tmp_qloop_141 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 1];
                const real_t tmp_qloop_150 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 2];
                const real_t tmp_qloop_159 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 3];
                const real_t tmp_qloop_168 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 4];
                const real_t tmp_qloop_177 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 5];
                const real_t tmp_qloop_186 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 6];
                const real_t tmp_qloop_195 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 7];
                const real_t tmp_qloop_204 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 8];
                const real_t tmp_qloop_213 = jac_blending_inv_2_2*_data_tabulated_and_untitled_2_2_GREEN_DOWN[10*q + 9];
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_103 + tmp_qloop_104 + tmp_qloop_105 + tmp_qloop_112)*(tmp_qloop_103*0.66666666666666663 + tmp_qloop_104*0.66666666666666663 + tmp_qloop_105*0.66666666666666663 + tmp_qloop_113) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_103*1.0 + tmp_qloop_104*1.0 + tmp_qloop_105*1.0)*(tmp_qloop_103*2.0 + tmp_qloop_104*2.0 + tmp_qloop_105*2.0) + (tmp_qloop_115 + tmp_qloop_116 + tmp_qloop_117 + tmp_qloop_121)*(tmp_qloop_115*0.5 + tmp_qloop_116*0.5 + tmp_qloop_117*0.5 + tmp_qloop_122)*2.0 + (tmp_qloop_123 + tmp_qloop_124 + tmp_qloop_125 + tmp_qloop_129)*(tmp_qloop_123*0.5 + tmp_qloop_124*0.5 + tmp_qloop_125*0.5 + tmp_qloop_130)*2.0));
                const real_t q_tmp_1_1 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_139 + tmp_qloop_140 + tmp_qloop_141)*(tmp_qloop_113 + tmp_qloop_139*0.66666666666666663 + tmp_qloop_140*0.66666666666666663 + tmp_qloop_141*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_139*1.0 + tmp_qloop_140*1.0 + tmp_qloop_141*1.0)*(tmp_qloop_139*2.0 + tmp_qloop_140*2.0 + tmp_qloop_141*2.0) + (tmp_qloop_121 + tmp_qloop_142 + tmp_qloop_143 + tmp_qloop_144)*(tmp_qloop_122 + tmp_qloop_142*0.5 + tmp_qloop_143*0.5 + tmp_qloop_144*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_145 + tmp_qloop_146 + tmp_qloop_147)*(tmp_qloop_130 + tmp_qloop_145*0.5 + tmp_qloop_146*0.5 + tmp_qloop_147*0.5)*2.0));
                const real_t q_tmp_2_2 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_148 + tmp_qloop_149 + tmp_qloop_150)*(tmp_qloop_113 + tmp_qloop_148*0.66666666666666663 + tmp_qloop_149*0.66666666666666663 + tmp_qloop_150*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_148*1.0 + tmp_qloop_149*1.0 + tmp_qloop_150*1.0)*(tmp_qloop_148*2.0 + tmp_qloop_149*2.0 + tmp_qloop_150*2.0) + (tmp_qloop_121 + tmp_qloop_151 + tmp_qloop_152 + tmp_qloop_153)*(tmp_qloop_122 + tmp_qloop_151*0.5 + tmp_qloop_152*0.5 + tmp_qloop_153*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_154 + tmp_qloop_155 + tmp_qloop_156)*(tmp_qloop_130 + tmp_qloop_154*0.5 + tmp_qloop_155*0.5 + tmp_qloop_156*0.5)*2.0));
                const real_t q_tmp_3_3 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_157 + tmp_qloop_158 + tmp_qloop_159)*(tmp_qloop_113 + tmp_qloop_157*0.66666666666666663 + tmp_qloop_158*0.66666666666666663 + tmp_qloop_159*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_157*1.0 + tmp_qloop_158*1.0 + tmp_qloop_159*1.0)*(tmp_qloop_157*2.0 + tmp_qloop_158*2.0 + tmp_qloop_159*2.0) + (tmp_qloop_121 + tmp_qloop_160 + tmp_qloop_161 + tmp_qloop_162)*(tmp_qloop_122 + tmp_qloop_160*0.5 + tmp_qloop_161*0.5 + tmp_qloop_162*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_163 + tmp_qloop_164 + tmp_qloop_165)*(tmp_qloop_130 + tmp_qloop_163*0.5 + tmp_qloop_164*0.5 + tmp_qloop_165*0.5)*2.0));
                const real_t q_tmp_4_4 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_166 + tmp_qloop_167 + tmp_qloop_168)*(tmp_qloop_113 + tmp_qloop_166*0.66666666666666663 + tmp_qloop_167*0.66666666666666663 + tmp_qloop_168*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_166*1.0 + tmp_qloop_167*1.0 + tmp_qloop_168*1.0)*(tmp_qloop_166*2.0 + tmp_qloop_167*2.0 + tmp_qloop_168*2.0) + (tmp_qloop_121 + tmp_qloop_169 + tmp_qloop_170 + tmp_qloop_171)*(tmp_qloop_122 + tmp_qloop_169*0.5 + tmp_qloop_170*0.5 + tmp_qloop_171*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_172 + tmp_qloop_173 + tmp_qloop_174)*(tmp_qloop_130 + tmp_qloop_172*0.5 + tmp_qloop_173*0.5 + tmp_qloop_174*0.5)*2.0));
                const real_t q_tmp_5_5 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_175 + tmp_qloop_176 + tmp_qloop_177)*(tmp_qloop_113 + tmp_qloop_175*0.66666666666666663 + tmp_qloop_176*0.66666666666666663 + tmp_qloop_177*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_175*1.0 + tmp_qloop_176*1.0 + tmp_qloop_177*1.0)*(tmp_qloop_175*2.0 + tmp_qloop_176*2.0 + tmp_qloop_177*2.0) + (tmp_qloop_121 + tmp_qloop_178 + tmp_qloop_179 + tmp_qloop_180)*(tmp_qloop_122 + tmp_qloop_178*0.5 + tmp_qloop_179*0.5 + tmp_qloop_180*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_181 + tmp_qloop_182 + tmp_qloop_183)*(tmp_qloop_130 + tmp_qloop_181*0.5 + tmp_qloop_182*0.5 + tmp_qloop_183*0.5)*2.0));
                const real_t q_tmp_6_6 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_184 + tmp_qloop_185 + tmp_qloop_186)*(tmp_qloop_113 + tmp_qloop_184*0.66666666666666663 + tmp_qloop_185*0.66666666666666663 + tmp_qloop_186*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_184*1.0 + tmp_qloop_185*1.0 + tmp_qloop_186*1.0)*(tmp_qloop_184*2.0 + tmp_qloop_185*2.0 + tmp_qloop_186*2.0) + (tmp_qloop_121 + tmp_qloop_187 + tmp_qloop_188 + tmp_qloop_189)*(tmp_qloop_122 + tmp_qloop_187*0.5 + tmp_qloop_188*0.5 + tmp_qloop_189*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_190 + tmp_qloop_191 + tmp_qloop_192)*(tmp_qloop_130 + tmp_qloop_190*0.5 + tmp_qloop_191*0.5 + tmp_qloop_192*0.5)*2.0));
                const real_t q_tmp_7_7 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_193 + tmp_qloop_194 + tmp_qloop_195)*(tmp_qloop_113 + tmp_qloop_193*0.66666666666666663 + tmp_qloop_194*0.66666666666666663 + tmp_qloop_195*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_193*1.0 + tmp_qloop_194*1.0 + tmp_qloop_195*1.0)*(tmp_qloop_193*2.0 + tmp_qloop_194*2.0 + tmp_qloop_195*2.0) + (tmp_qloop_121 + tmp_qloop_196 + tmp_qloop_197 + tmp_qloop_198)*(tmp_qloop_122 + tmp_qloop_196*0.5 + tmp_qloop_197*0.5 + tmp_qloop_198*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_199 + tmp_qloop_200 + tmp_qloop_201)*(tmp_qloop_130 + tmp_qloop_199*0.5 + tmp_qloop_200*0.5 + tmp_qloop_201*0.5)*2.0));
                const real_t q_tmp_8_8 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_202 + tmp_qloop_203 + tmp_qloop_204)*(tmp_qloop_113 + tmp_qloop_202*0.66666666666666663 + tmp_qloop_203*0.66666666666666663 + tmp_qloop_204*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_202*1.0 + tmp_qloop_203*1.0 + tmp_qloop_204*1.0)*(tmp_qloop_202*2.0 + tmp_qloop_203*2.0 + tmp_qloop_204*2.0) + (tmp_qloop_121 + tmp_qloop_205 + tmp_qloop_206 + tmp_qloop_207)*(tmp_qloop_122 + tmp_qloop_205*0.5 + tmp_qloop_206*0.5 + tmp_qloop_207*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_208 + tmp_qloop_209 + tmp_qloop_210)*(tmp_qloop_130 + tmp_qloop_208*0.5 + tmp_qloop_209*0.5 + tmp_qloop_210*0.5)*2.0));
                const real_t q_tmp_9_9 = tmp_qloop_138*(-tmp_qloop_114*(tmp_qloop_112 + tmp_qloop_211 + tmp_qloop_212 + tmp_qloop_213)*(tmp_qloop_113 + tmp_qloop_211*0.66666666666666663 + tmp_qloop_212*0.66666666666666663 + tmp_qloop_213*0.66666666666666663) + tmp_qloop_114*(tmp_qloop_137 + (tmp_qloop_211*1.0 + tmp_qloop_212*1.0 + tmp_qloop_213*1.0)*(tmp_qloop_211*2.0 + tmp_qloop_212*2.0 + tmp_qloop_213*2.0) + (tmp_qloop_121 + tmp_qloop_214 + tmp_qloop_215 + tmp_qloop_216)*(tmp_qloop_122 + tmp_qloop_214*0.5 + tmp_qloop_215*0.5 + tmp_qloop_216*0.5)*2.0 + (tmp_qloop_129 + tmp_qloop_217 + tmp_qloop_218 + tmp_qloop_219)*(tmp_qloop_130 + tmp_qloop_217*0.5 + tmp_qloop_218*0.5 + tmp_qloop_219*0.5)*2.0));
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
